/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var re=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/errors","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/base/common/path","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/types","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/resources","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/base/common/network","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/uuid","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagementUtil","os","vs/base/common/json","vs/base/common/process","vs/base/common/map","vs/base/common/errorMessage","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/userDataSync/common/abstractSynchronizer","vs/platform/extensions/common/extensions","vs/base/common/jsonFormatter","vs/base/common/stream","vs/platform/externalServices/common/serviceMachineId","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/extpath","vs/base/common/ternarySearchTree","child_process","vs/platform/telemetry/common/telemetryUtils","vs/base/common/codicons","fs","vs/base/common/semver/semver","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/ipc/electron-sandbox/services","vs/platform/native/electron-sandbox/native","vs/platform/policy/common/policy","vs/platform/userDataSync/common/content","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/date","vs/base/common/hash","vs/base/common/marshalling","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/normalization","net","vs/base/common/processes","vs/base/common/severity","vs/base/common/glob","vs/base/node/powershell","vs/base/node/processes","vs/base/parts/ipc/common/ipc.net","electron","vs/platform/environment/common/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/platform/lifecycle/electron-browser/sharedProcessLifecycleService","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/skipList","vs/base/node/macAddress","vs/base/node/ports","vs/base/parts/request/common/request","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/ipc/node/ipc.net","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/electron-browser/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policyIpc","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/request/common/requestIpc","vs/platform/request/electron-browser/sharedProcessRequestService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/shell/node/shellEnv","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/remoteTunnel/electron-browser/remoteTunnelService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/tunnel/node/tunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/electron-browser/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/storage/electron-sandbox/storageService","vs/platform/userDataProfile/electron-sandbox/userDataProfile","vs/platform/userDataProfile/electron-sandbox/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/electron-browser/sharedProcess/contrib/extensions","util","minimist","assert","path","graceful-fs","https","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain"],ae=function(_){for(var e=[],D=0,i=_.length;D<i;D++)e[D]=re[_[D]];return e};define(re[52],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.Codicon=e.getCodiconAriaLabel=void 0;function D(k){return k?k.replace(/\$\((.*?)\)/g,(L,P)=>` ${P} `).trim():""}e.getCodiconAriaLabel=D;class i{constructor(L,P,I){this.id=L,this.definition=P,this.description=I,i.a.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return i.a}}e.Codicon=i,i.a=[],i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",i.circleFilled.definition),i.closeDirty=new i("close-dirty",i.circleFilled.definition),i.debugBreakpoint=new i("debug-breakpoint",i.circleFilled.definition),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",i.circleFilled.definition),i.debugHint=new i("debug-hint",i.circleFilled.definition),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circle=new i("circle",{fontCharacter:"\\eabc"}),i.circleOutline=new i("circle-outline",i.circle.definition),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",i.circle.definition),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolCustomColor=new i("symbol-customcolor",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.circleSmallFilled=new i("circle-small-filled",{fontCharacter:"\\eb8a"}),i.debugStackframeDot=new i("debug-stackframe-dot",i.circleSmallFilled.definition),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLarge=new i("circle-large",{fontCharacter:"\\ebb5"}),i.circleLargeOutline=new i("circle-large-outline",i.circleLarge.definition),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.layout=new i("layout",{fontCharacter:"\\ebeb"}),i.layoutActivitybarLeft=new i("layout-activitybar-left",{fontCharacter:"\\ebec"}),i.layoutActivitybarRight=new i("layout-activitybar-right",{fontCharacter:"\\ebed"}),i.layoutPanelLeft=new i("layout-panel-left",{fontCharacter:"\\ebee"}),i.layoutPanelCenter=new i("layout-panel-center",{fontCharacter:"\\ebef"}),i.layoutPanelJustify=new i("layout-panel-justify",{fontCharacter:"\\ebf0"}),i.layoutPanelRight=new i("layout-panel-right",{fontCharacter:"\\ebf1"}),i.layoutPanel=new i("layout-panel",{fontCharacter:"\\ebf2"}),i.layoutSidebarLeft=new i("layout-sidebar-left",{fontCharacter:"\\ebf3"}),i.layoutSidebarRight=new i("layout-sidebar-right",{fontCharacter:"\\ebf4"}),i.layoutStatusbar=new i("layout-statusbar",{fontCharacter:"\\ebf5"}),i.layoutMenubar=new i("layout-menubar",{fontCharacter:"\\ebf6"}),i.layoutCentered=new i("layout-centered",{fontCharacter:"\\ebf7"}),i.layoutSidebarRightOff=new i("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),i.layoutPanelOff=new i("layout-panel-off",{fontCharacter:"\\ec01"}),i.layoutSidebarLeftOff=new i("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),i.target=new i("target",{fontCharacter:"\\ebf8"}),i.indent=new i("indent",{fontCharacter:"\\ebf9"}),i.recordSmall=new i("record-small",{fontCharacter:"\\ebfa"}),i.errorSmall=new i("error-small",{fontCharacter:"\\ebfb"}),i.arrowCircleDown=new i("arrow-circle-down",{fontCharacter:"\\ebfc"}),i.arrowCircleLeft=new i("arrow-circle-left",{fontCharacter:"\\ebfd"}),i.arrowCircleRight=new i("arrow-circle-right",{fontCharacter:"\\ebfe"}),i.arrowCircleUp=new i("arrow-circle-up",{fontCharacter:"\\ebff"}),i.heartFilled=new i("heart-filled",{fontCharacter:"\\ec04"}),i.map=new i("map",{fontCharacter:"\\ec05"}),i.mapFilled=new i("map-filled",{fontCharacter:"\\ec06"}),i.circleSmall=new i("circle-small",{fontCharacter:"\\ec07"}),i.bellSlash=new i("bell-slash",{fontCharacter:"\\ec08"}),i.bellSlashDot=new i("bell-slash-dot",{fontCharacter:"\\ec09"}),i.commentUnresolved=new i("comment-unresolved",{fontCharacter:"\\ec0a"}),i.gitPullRequestGoToChanges=new i("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),i.gitPullRequestNewChanges=new i("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),i.searchFuzzy=new i("search-fuzzy",{fontCharacter:"\\ec0d"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);var R;(function(k){k.iconNameSegment="[A-Za-z0-9]+",k.iconNameExpression="[A-Za-z0-9-]+",k.iconModifierExpression="~[A-Za-z]+",k.iconNameCharacter="[A-Za-z0-9~-]";const L=new RegExp(`^(${k.iconNameExpression})(${k.iconModifierExpression})?$`);function P(b){if(b instanceof i)return["codicon","codicon-"+b.id];const C=L.exec(b.id);if(!C)return P(i.error);const[,w,p]=C,d=["codicon","codicon-"+w];return p&&d.push("codicon-modifier-"+p.substring(1)),d}k.asClassNameArray=P;function I(b){return P(b).join(" ")}k.asClassName=I;function S(b){return"."+P(b).join(".")}k.asCSSSelector=S})(R=e.CSSIcon||(e.CSSIcon={}))}),define(re[63],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function D(L){return(P,I,S)=>{let b=null,C=null;if(typeof S.value=="function"?(b="value",C=S.value):typeof S.get=="function"&&(b="get",C=S.get),!C)throw new Error("not supported");S[b]=L(C,I)}}function i(L,P,I){let S=null,b=null;if(typeof I.value=="function"?(S="value",b=I.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof I.get=="function"&&(S="get",b=I.get),!b)throw new Error("not supported");const C=`$memoize$${P}`;I[S]=function(...w){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:b.apply(this,w)}),this[C]}}e.memoize=i;function R(L,P,I){return D((S,b)=>{const C=`$debounce$${b}`,w=`$debounce$result$${b}`;return function(...p){this[w]||(this[w]=I?I():void 0),clearTimeout(this[C]),P&&(this[w]=P(this[w],...p),p=[this[w]]),this[C]=setTimeout(()=>{S.apply(this,p),this[w]=I?I():void 0},L)}})}e.debounce=R;function k(L,P,I){return D((S,b)=>{const C=`$throttle$timer$${b}`,w=`$throttle$result$${b}`,p=`$throttle$lastRun$${b}`,d=`$throttle$pending$${b}`;return function(...g){if(this[w]||(this[w]=I?I():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),P&&(this[w]=P(this[w],...g)),this[d])return;const v=this[p]+L;v<=Date.now()?(this[p]=Date.now(),S.apply(this,[this[w]]),this[w]=I?I():void 0):(this[d]=!0,this[C]=setTimeout(()=>{this[d]=!1,this[p]=Date.now(),S.apply(this,[this[w]]),this[w]=I?I():void 0},v-Date.now()))}})}e.throttle=k}),define(re[9],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class D{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?l.isErrorNoTelemetry(n)?new l(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(r=>{r(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}e.ErrorHandler=D,e.errorHandler=new D;function i(f){e.errorHandler.setUnexpectedErrorHandler(f)}e.setUnexpectedErrorHandler=i;function R(f){I(f)||e.errorHandler.onUnexpectedError(f)}e.onUnexpectedError=R;function k(f){I(f)||e.errorHandler.onUnexpectedExternalError(f)}e.onUnexpectedExternalError=k;function L(f){if(f instanceof Error){const{name:n,message:r}=f,t=f.stacktrace||f.stack;return{$isError:!0,name:n,message:r,stack:t,noTelemetry:l.isErrorNoTelemetry(f)}}return f}e.transformErrorForSerialization=L;const P="Canceled";function I(f){return f instanceof S?!0:f instanceof Error&&f.name===P&&f.message===P}e.isCancellationError=I;class S extends Error{constructor(){super(P),this.name=this.message}}e.CancellationError=S;function b(){const f=new Error(P);return f.name=f.message,f}e.canceled=b;function C(f){return f?new Error(`Illegal argument: ${f}`):new Error("Illegal argument")}e.illegalArgument=C;function w(f){return f?new Error(`Illegal state: ${f}`):new Error("Illegal state")}e.illegalState=w;function p(f){return f?new Error(`readonly property '${f} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function d(f){const n=new Error(`${f} has been disposed`);return n.name="DISPOSED",n}e.disposed=d;function g(f){return f?f.message?f.message:f.stack?f.stack.split(`
`)[0]:String(f):"Error"}e.getErrorMessage=g;class v extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.NotImplementedError=v;class u extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.NotSupportedError=u;class m extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=m;class l extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof l)return n;const r=new l;return r.message=n.message,r.stack=n.stack,r}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.ErrorNoTelemetry=l;class h extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,h.prototype);debugger}}e.BugIndicatingError=h}),define(re[20],ae([0,1,9]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function i(x,ie=0){return x[x.length-(1+ie)]}e.tail=i;function R(x){if(x.length===0)throw new Error("Invalid tail call");return[x.slice(0,x.length-1),x[x.length-1]]}e.tail2=R;function k(x,ie,ne=(le,ue)=>le===ue){if(x===ie)return!0;if(!x||!ie||x.length!==ie.length)return!1;for(let le=0,ue=x.length;le<ue;le++)if(!ne(x[le],ie[le]))return!1;return!0}e.equals=k;function L(x,ie){const ne=x.length-1;ie<ne&&(x[ie]=x[ne]),x.pop()}e.removeFastWithoutKeepingOrder=L;function P(x,ie,ne){return I(x.length,le=>ne(x[le],ie))}e.binarySearch=P;function I(x,ie){let ne=0,le=x-1;for(;ne<=le;){const ue=(ne+le)/2|0,ye=ie(ue);if(ye<0)ne=ue+1;else if(ye>0)le=ue-1;else return ue}return-(ne+1)}e.binarySearch2=I;function S(x,ie){let ne=0,le=x.length;if(le===0)return 0;for(;ne<le;){const ue=Math.floor((ne+le)/2);ie(x[ue])?le=ue:ne=ue+1}return ne}e.findFirstInSorted=S;function b(x,ie,ne){if(x=x|0,x>=ie.length)throw new TypeError("invalid index");const le=ie[Math.floor(ie.length*Math.random())],ue=[],ye=[],Se=[];for(const be of ie){const Ee=ne(be,le);Ee<0?ue.push(be):Ee>0?ye.push(be):Se.push(be)}return x<ue.length?b(x,ue,ne):x<ue.length+Se.length?Se[0]:b(x-(ue.length+Se.length),ye,ne)}e.quickSelect=b;function C(x,ie){const ne=[];let le;for(const ue of x.slice(0).sort(ie))!le||ie(le[0],ue)!==0?(le=[ue],ne.push(le)):le.push(ue);return ne}e.groupBy=C;function w(x,ie,ne){const le=[];function ue(be,Ee,Ne){if(Ee===0&&Ne.length===0)return;const Fe=le[le.length-1];Fe&&Fe.start+Fe.deleteCount===be?(Fe.deleteCount+=Ee,Fe.toInsert.push(...Ne)):le.push({start:be,deleteCount:Ee,toInsert:Ne})}let ye=0,Se=0;for(;;){if(ye===x.length){ue(ye,0,ie.slice(Se));break}if(Se===ie.length){ue(ye,x.length-ye,[]);break}const be=x[ye],Ee=ie[Se],Ne=ne(be,Ee);Ne===0?(ye+=1,Se+=1):Ne<0?(ue(ye,1,[]),ye+=1):Ne>0&&(ue(ye,0,[Ee]),Se+=1)}return le}e.sortedDiff=w;function p(x,ie,ne){const le=w(x,ie,ne),ue=[],ye=[];for(const Se of le)ue.push(...x.slice(Se.start,Se.start+Se.deleteCount)),ye.push(...Se.toInsert);return{removed:ue,added:ye}}e.delta=p;function d(x,ie,ne){if(ne===0)return[];const le=x.slice(0,ne).sort(ie);return v(x,ie,le,ne,x.length),le}e.top=d;function g(x,ie,ne,le,ue){return ne===0?Promise.resolve([]):new Promise((ye,Se)=>{(async()=>{const be=x.length,Ee=x.slice(0,ne).sort(ie);for(let Ne=ne,Fe=Math.min(ne+le,be);Ne<be;Ne=Fe,Fe=Math.min(Fe+le,be)){if(Ne>ne&&await new Promise(Ye=>setTimeout(Ye)),ue&&ue.isCancellationRequested)throw new D.CancellationError;v(x,ie,Ee,Ne,Fe)}return Ee})().then(ye,Se)})}e.topAsync=g;function v(x,ie,ne,le,ue){for(const ye=ne.length;le<ue;le++){const Se=x[le];if(ie(Se,ne[ye-1])<0){ne.pop();const be=S(ne,Ee=>ie(Se,Ee)<0);ne.splice(be,0,Se)}}}function u(x){return x.filter(ie=>!!ie)}e.coalesce=u;function m(x){let ie=0;for(let ne=0;ne<x.length;ne++)x[ne]&&(x[ie]=x[ne],ie+=1);x.length=ie}e.coalesceInPlace=m;function l(x,ie,ne){x.splice(ne,0,x.splice(ie,1)[0])}e.move=l;function h(x){return!Array.isArray(x)||x.length===0}e.isFalsyOrEmpty=h;function f(x){return Array.isArray(x)&&x.length>0}e.isNonEmptyArray=f;function n(x,ie=ne=>ne){const ne=new Set;return x.filter(le=>{const ue=ie(le);return ne.has(ue)?!1:(ne.add(ue),!0)})}e.distinct=n;function r(x){const ie=new Set;return ne=>{const le=x(ne);return ie.has(le)?!1:(ie.add(le),!0)}}e.uniqueFilter=r;function t(x,ie){const ne=a(x,ie);if(ne!==-1)return x[ne]}e.findLast=t;function a(x,ie){for(let ne=x.length-1;ne>=0;ne--){const le=x[ne];if(ie(le))return ne}return-1}e.lastIndex=a;function s(x,ie){return x.length>0?x[0]:ie}e.firstOrDefault=s;function c(x,ie){return x.length>0?x[x.length-1]:ie}e.lastOrDefault=c;function o(x,ie,ne=(le,ue)=>le===ue){let le=0;for(let ue=0,ye=Math.min(x.length,ie.length);ue<ye&&ne(x[ue],ie[ue]);ue++)le++;return le}e.commonPrefixLength=o;function y(x){return[].concat(...x)}e.flatten=y;function E(x,ie){let ne=typeof ie=="number"?x:0;typeof ie=="number"?ne=x:(ne=0,ie=x);const le=[];if(ne<=ie)for(let ue=ne;ue<ie;ue++)le.push(ue);else for(let ue=ne;ue>ie;ue--)le.push(ue);return le}e.range=E;function T(x,ie,ne){return x.reduce((le,ue)=>(le[ie(ue)]=ne?ne(ue):ue,le),Object.create(null))}e.index=T;function q(x,ie){return x.push(ie),()=>N(x,ie)}e.insert=q;function N(x,ie){const ne=x.indexOf(ie);if(ne>-1)return x.splice(ne,1),ie}e.remove=N;function j(x,ie,ne){const le=x.slice(0,ie),ue=x.slice(ie);return le.concat(ne,ue)}e.arrayInsert=j;function F(x,ie){let ne;if(typeof ie=="number"){let le=ie;ne=()=>{const ue=Math.sin(le++)*179426549;return ue-Math.floor(ue)}}else ne=Math.random;for(let le=x.length-1;le>0;le-=1){const ue=Math.floor(ne()*(le+1)),ye=x[le];x[le]=x[ue],x[ue]=ye}}e.shuffle=F;function A(x,ie){const ne=x.indexOf(ie);ne>-1&&(x.splice(ne,1),x.unshift(ie))}e.pushToStart=A;function U(x,ie){const ne=x.indexOf(ie);ne>-1&&(x.splice(ne,1),x.push(ie))}e.pushToEnd=U;function B(x,ie){for(const ne of ie)x.push(ne)}e.pushMany=B;function G(x,ie){return Array.isArray(x)?x.map(ie):ie(x)}e.mapArrayOrNot=G;function W(x){return Array.isArray(x)?x:[x]}e.asArray=W;function Z(x){return x[Math.floor(Math.random()*x.length)]}e.getRandomElement=Z;function $(x,ie){for(const ne of x){const le=ie(ne);if(le!==void 0)return le}}e.mapFind=$;function z(x,ie,ne){const le=ee(x,ie),ue=x.length,ye=ne.length;x.length=ue+ye;for(let Se=ue-1;Se>=le;Se--)x[Se+ye]=x[Se];for(let Se=0;Se<ye;Se++)x[Se+le]=ne[Se]}e.insertInto=z;function Y(x,ie,ne,le){const ue=ee(x,ie),ye=x.splice(ue,ne);return z(x,ue,le),ye}e.splice=Y;function ee(x,ie){return ie<0?Math.max(ie+x.length,0):Math.min(ie,x.length)}var oe;(function(x){function ie(ue){return ue<0}x.isLessThan=ie;function ne(ue){return ue>0}x.isGreaterThan=ne;function le(ue){return ue===0}x.isNeitherLessOrGreaterThan=le,x.greaterThan=1,x.lessThan=-1,x.neitherLessOrGreaterThan=0})(oe=e.CompareResult||(e.CompareResult={}));function J(x,ie){return(ne,le)=>ie(x(ne),x(le))}e.compareBy=J;function Q(...x){return(ie,ne)=>{for(const le of x){const ue=le(ie,ne);if(!oe.isNeitherLessOrGreaterThan(ue))return ue}return oe.neitherLessOrGreaterThan}}e.tieBreakComparators=Q;const O=(x,ie)=>x-ie;e.numberComparator=O;function M(x,ie){if(x.length===0)return;let ne=x[0];for(let le=1;le<x.length;le++){const ue=x[le];ie(ue,ne)>0&&(ne=ue)}return ne}e.findMaxBy=M;function H(x,ie){if(x.length===0)return;let ne=x[0];for(let le=1;le<x.length;le++){const ue=x[le];ie(ue,ne)>=0&&(ne=ue)}return ne}e.findLastMaxBy=H;function V(x,ie){return M(x,(ne,le)=>-ie(ne,le))}e.findMinBy=V;class X{constructor(ie){this.f=ie,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(ie){let ne=this.c;for(;ne<this.f.length&&ie(this.f[ne]);)ne++;const le=ne===this.c?null:this.f.slice(this.c,ne);return this.c=ne,le}takeFromEndWhile(ie){let ne=this.d;for(;ne>=0&&ie(this.f[ne]);)ne--;const le=ne===this.d?null:this.f.slice(ne+1,this.d+1);return this.d=ne,le}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const ie=this.f[this.c];return this.c++,ie}removeLast(){const ie=this.f[this.d];return this.d--,ie}takeCount(ie){const ne=this.f.slice(this.c,this.c+ie);return this.c+=ie,ne}}e.ArrayQueue=X;class se{constructor(ie){this.iterate=ie}forEach(ie){this.iterate(ne=>(ie(ne),!0))}toArray(){const ie=[];return this.iterate(ne=>(ie.push(ne),!0)),ie}filter(ie){return new se(ne=>this.iterate(le=>ie(le)?ne(le):!0))}map(ie){return new se(ne=>this.iterate(le=>ne(ie(le))))}some(ie){let ne=!1;return this.iterate(le=>(ne=ie(le),!ne)),ne}findFirst(ie){let ne;return this.iterate(le=>ie(le)?(ne=le,!1):!0),ne}findLast(ie){let ne;return this.iterate(le=>(ie(le)&&(ne=le),!0)),ne}findLastMaxBy(ie){let ne,le=!0;return this.iterate(ue=>((le||oe.isGreaterThan(ie(ue,ne)))&&(le=!1,ne=ue),!0)),ne}}e.CallbackIterable=se,se.empty=new se(x=>{})}),define(re[126],ae([0,1,9]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function i(I,S){if(!I)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}e.ok=i;function R(I,S="Unreachable"){throw new Error(S)}e.assertNever=R;function k(I){if(!I)throw new D.BugIndicatingError("Assertion Failed")}e.assert=k;function L(I){if(!I()){debugger;I(),(0,D.onUnexpectedError)(new D.BugIndicatingError("Assertion Failed"))}}e.assertFn=L;function P(I,S){let b=0;for(;b<I.length-1;){const C=I[b],w=I[b+1];if(!S(C,w))return!1;b++}return!0}e.checkAdjacentItems=P}),define(re[82],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function D(i){const R=this;let k=!1,L;return function(){return k||(k=!0,L=i.apply(R,arguments)),L}}e.once=D}),define(re[64],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(i){function R(h){return h&&typeof h=="object"&&typeof h[Symbol.iterator]=="function"}i.is=R;const k=Object.freeze([]);function L(){return k}i.empty=L;function*P(h){yield h}i.single=P;function I(h){return R(h)?h:P(h)}i.wrap=I;function S(h){return h||k}i.from=S;function b(h){return!h||h[Symbol.iterator]().next().done===!0}i.isEmpty=b;function C(h){return h[Symbol.iterator]().next().value}i.first=C;function w(h,f){for(const n of h)if(f(n))return!0;return!1}i.some=w;function p(h,f){for(const n of h)if(f(n))return n}i.find=p;function*d(h,f){for(const n of h)f(n)&&(yield n)}i.filter=d;function*g(h,f){let n=0;for(const r of h)yield f(r,n++)}i.map=g;function*v(...h){for(const f of h)for(const n of f)yield n}i.concat=v;function u(h,f,n){let r=n;for(const t of h)r=f(r,t);return r}i.reduce=u;function*m(h,f,n=h.length){for(f<0&&(f+=h.length),n<0?n+=h.length:n>h.length&&(n=h.length);f<n;f++)yield h[f]}i.slice=m;function l(h,f=Number.POSITIVE_INFINITY){const n=[];if(f===0)return[n,h];const r=h[Symbol.iterator]();for(let t=0;t<f;t++){const a=r.next();if(a.done)return[n,i.empty()];n.push(a.value)}return[n,{[Symbol.iterator](){return r}}]}i.consume=l})(D=e.Iterable||(e.Iterable={}))}),define(re[35],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(D=e.ScanError||(e.ScanError={}));var i;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(i=e.SyntaxKind||(e.SyntaxKind={}));var R;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(R=e.ParseErrorCode||(e.ParseErrorCode={}));var k;(function(n){n.DEFAULT={allowTrailingComma:!0}})(k=e.ParseOptions||(e.ParseOptions={}));function L(n,r=!1){let t=0;const a=n.length;let s="",c=0,o=16,y=0;function E(U){let B=0,G=0;for(;B<U;){const W=n.charCodeAt(t);if(W>=48&&W<=57)G=G*16+W-48;else if(W>=65&&W<=70)G=G*16+W-65+10;else if(W>=97&&W<=102)G=G*16+W-97+10;else break;t++,B++}return B<U&&(G=-1),G}function T(U){t=U,s="",c=0,o=16,y=0}function q(){const U=t;if(n.charCodeAt(t)===48)t++;else for(t++;t<n.length&&S(n.charCodeAt(t));)t++;if(t<n.length&&n.charCodeAt(t)===46)if(t++,t<n.length&&S(n.charCodeAt(t)))for(t++;t<n.length&&S(n.charCodeAt(t));)t++;else return y=3,n.substring(U,t);let B=t;if(t<n.length&&(n.charCodeAt(t)===69||n.charCodeAt(t)===101))if(t++,(t<n.length&&n.charCodeAt(t)===43||n.charCodeAt(t)===45)&&t++,t<n.length&&S(n.charCodeAt(t))){for(t++;t<n.length&&S(n.charCodeAt(t));)t++;B=t}else y=3;return n.substring(U,B)}function N(){let U="",B=t;for(;;){if(t>=a){U+=n.substring(B,t),y=2;break}const G=n.charCodeAt(t);if(G===34){U+=n.substring(B,t),t++;break}if(G===92){if(U+=n.substring(B,t),t++,t>=a){y=2;break}switch(n.charCodeAt(t++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const Z=E(4);Z>=0?U+=String.fromCharCode(Z):y=4;break}default:y=5}B=t;continue}if(G>=0&&G<=31)if(I(G)){U+=n.substring(B,t),y=2;break}else y=6;t++}return U}function j(){if(s="",y=0,c=t,t>=a)return c=a,o=17;let U=n.charCodeAt(t);if(P(U)){do t++,s+=String.fromCharCode(U),U=n.charCodeAt(t);while(P(U));return o=15}if(I(U))return t++,s+=String.fromCharCode(U),U===13&&n.charCodeAt(t)===10&&(t++,s+=`
`),o=14;switch(U){case 123:return t++,o=1;case 125:return t++,o=2;case 91:return t++,o=3;case 93:return t++,o=4;case 58:return t++,o=6;case 44:return t++,o=5;case 34:return t++,s=N(),o=10;case 47:{const B=t-1;if(n.charCodeAt(t+1)===47){for(t+=2;t<a&&!I(n.charCodeAt(t));)t++;return s=n.substring(B,t),o=12}if(n.charCodeAt(t+1)===42){t+=2;const G=a-1;let W=!1;for(;t<G;){if(n.charCodeAt(t)===42&&n.charCodeAt(t+1)===47){t+=2,W=!0;break}t++}return W||(t++,y=1),s=n.substring(B,t),o=13}return s+=String.fromCharCode(U),t++,o=16}case 45:if(s+=String.fromCharCode(U),t++,t===a||!S(n.charCodeAt(t)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=q(),o=11;default:for(;t<a&&F(U);)t++,U=n.charCodeAt(t);if(c!==t){switch(s=n.substring(c,t),s){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return s+=String.fromCharCode(U),t++,o=16}}function F(U){if(P(U)||I(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function A(){let U;do U=j();while(U>=12&&U<=15);return U}return{setPosition:T,getPosition:()=>t,scan:r?A:j,getToken:()=>o,getTokenValue:()=>s,getTokenOffset:()=>c,getTokenLength:()=>t-c,getTokenError:()=>y}}e.createScanner=L;function P(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function I(n){return n===10||n===13||n===8232||n===8233}function S(n){return n>=48&&n<=57}var b;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(b||(b={}));function C(n,r){const t=[],a=new Object;let s;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function y(E,T,q,N){c.value=E,c.offset=T,c.length=q,c.type=N,c.colonOffset=void 0,s=c}try{l(n,{onObjectBegin:(E,T)=>{if(r<=E)throw a;s=void 0,o=r>E,t.push("")},onObjectProperty:(E,T,q)=>{if(r<T||(y(E,T,q,"property"),t[t.length-1]=E,r<=T+q))throw a},onObjectEnd:(E,T)=>{if(r<=E)throw a;s=void 0,t.pop()},onArrayBegin:(E,T)=>{if(r<=E)throw a;s=void 0,t.push(0)},onArrayEnd:(E,T)=>{if(r<=E)throw a;s=void 0,t.pop()},onLiteralValue:(E,T,q)=>{if(r<T||(y(E,T,q,f(E)),r<=T+q))throw a},onSeparator:(E,T,q)=>{if(r<=T)throw a;if(E===":"&&s&&s.type==="property")s.colonOffset=T,o=!1,s=void 0;else if(E===","){const N=t[t.length-1];typeof N=="number"?t[t.length-1]=N+1:(o=!0,t[t.length-1]=""),s=void 0}}})}catch(E){if(E!==a)throw E}return{path:t,previousNode:s,isAtPropertyKey:o,matches:E=>{let T=0;for(let q=0;T<E.length&&q<t.length;q++)if(E[T]===t[q]||E[T]==="*")T++;else if(E[T]!=="**")return!1;return T===E.length}}}e.getLocation=C;function w(n,r=[],t=k.DEFAULT){let a=null,s=[];const c=[];function o(E){Array.isArray(s)?s.push(E):a!==null&&(s[a]=E)}return l(n,{onObjectBegin:()=>{const E={};o(E),c.push(s),s=E,a=null},onObjectProperty:E=>{a=E},onObjectEnd:()=>{s=c.pop()},onArrayBegin:()=>{const E=[];o(E),c.push(s),s=E,a=null},onArrayEnd:()=>{s=c.pop()},onLiteralValue:o,onError:(E,T,q)=>{r.push({error:E,offset:T,length:q})}},t),s[0]}e.parse=w;function p(n,r=[],t=k.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(E){a.type==="property"&&(a.length=E-a.offset,a=a.parent)}function c(E){return a.children.push(E),E}l(n,{onObjectBegin:E=>{a=c({type:"object",offset:E,length:-1,parent:a,children:[]})},onObjectProperty:(E,T,q)=>{a=c({type:"property",offset:T,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:E,offset:T,length:q,parent:a})},onObjectEnd:(E,T)=>{a.length=E+T-a.offset,a=a.parent,s(E+T)},onArrayBegin:(E,T)=>{a=c({type:"array",offset:E,length:-1,parent:a,children:[]})},onArrayEnd:(E,T)=>{a.length=E+T-a.offset,a=a.parent,s(E+T)},onLiteralValue:(E,T,q)=>{c({type:f(E),offset:T,length:q,parent:a,value:E}),s(T+q)},onSeparator:(E,T,q)=>{a.type==="property"&&(E===":"?a.colonOffset=T:E===","&&s(T))},onError:(E,T,q)=>{r.push({error:E,offset:T,length:q})}},t);const y=a.children[0];return y&&delete y.parent,y}e.parseTree=p;function d(n,r){if(!n)return;let t=n;for(const a of r)if(typeof a=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let s=!1;for(const c of t.children)if(Array.isArray(c.children)&&c.children[0].value===a){t=c.children[1],s=!0;break}if(!s)return}else{const s=a;if(t.type!=="array"||s<0||!Array.isArray(t.children)||s>=t.children.length)return;t=t.children[s]}return t}e.findNodeAtLocation=d;function g(n){if(!n.parent||!n.parent.children)return[];const r=g(n.parent);if(n.parent.type==="property"){const t=n.parent.children[0].value;r.push(t)}else if(n.parent.type==="array"){const t=n.parent.children.indexOf(n);t!==-1&&r.push(t)}return r}e.getNodePath=g;function v(n){switch(n.type){case"array":return n.children.map(v);case"object":{const r=Object.create(null);for(const t of n.children){const a=t.children[1];a&&(r[t.children[0].value]=v(a))}return r}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=v;function u(n,r,t=!1){return r>=n.offset&&r<n.offset+n.length||t&&r===n.offset+n.length}e.contains=u;function m(n,r,t=!1){if(u(n,r,t)){const a=n.children;if(Array.isArray(a))for(let s=0;s<a.length&&a[s].offset<=r;s++){const c=m(a[s],r,t);if(c)return c}return n}}e.findNodeAtOffset=m;function l(n,r,t=k.DEFAULT){const a=L(n,!1);function s(J){return J?()=>J(a.getTokenOffset(),a.getTokenLength()):()=>!0}function c(J){return J?Q=>J(Q,a.getTokenOffset(),a.getTokenLength()):()=>!0}const o=s(r.onObjectBegin),y=c(r.onObjectProperty),E=s(r.onObjectEnd),T=s(r.onArrayBegin),q=s(r.onArrayEnd),N=c(r.onLiteralValue),j=c(r.onSeparator),F=s(r.onComment),A=c(r.onError),U=t&&t.disallowComments,B=t&&t.allowTrailingComma;function G(){for(;;){const J=a.scan();switch(a.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:U||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(J){case 12:case 13:U?W(10):F();break;case 16:W(1);break;case 15:case 14:break;default:return J}}}function W(J,Q=[],O=[]){if(A(J),Q.length+O.length>0){let M=a.getToken();for(;M!==17;){if(Q.indexOf(M)!==-1){G();break}else if(O.indexOf(M)!==-1)break;M=G()}}}function Z(J){const Q=a.getTokenValue();return J?N(Q):y(Q),G(),!0}function $(){switch(a.getToken()){case 11:{let J=0;try{J=JSON.parse(a.getTokenValue()),typeof J!="number"&&(W(2),J=0)}catch{W(2)}N(J);break}case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return G(),!0}function z(){return a.getToken()!==10?(W(3,[],[2,5]),!1):(Z(!1),a.getToken()===6?(j(":"),G(),oe()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function Y(){o(),G();let J=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(J||W(4,[],[]),j(","),G(),a.getToken()===2&&B)break}else J&&W(6,[],[]);z()||W(4,[],[2,5]),J=!0}return E(),a.getToken()!==2?W(7,[2],[]):G(),!0}function ee(){T(),G();let J=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(J||W(4,[],[]),j(","),G(),a.getToken()===4&&B)break}else J&&W(6,[],[]);oe()||W(4,[],[4,5]),J=!0}return q(),a.getToken()!==4?W(8,[4],[]):G(),!0}function oe(){switch(a.getToken()){case 3:return ee();case 1:return Y();case 10:return Z(!0);default:return $()}}return G(),a.getToken()===17?t.allowEmptyContent?!0:(W(4,[],[]),!1):oe()?(a.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.visit=l;function h(n,r){const t=L(n),a=[];let s,c=0,o;do switch(o=t.getPosition(),s=t.scan(),s){case 12:case 13:case 17:c!==o&&a.push(n.substring(c,o)),r!==void 0&&a.push(t.getTokenValue().replace(/[^\r\n]/g,r)),c=t.getPosition();break}while(s!==17);return a.join("")}e.stripComments=h;function f(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=f}),define(re[43],ae([0,1,35]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function i(S,b,C){let w,p,d,g,v;if(b){for(g=b.offset,v=g+b.length,d=g;d>0&&!I(S,d-1);)d--;let o=v;for(;o<S.length&&!I(S,o);)o++;p=S.substring(d,o),w=L(p,C)}else p=S,w=0,d=0,g=0,v=S.length;const u=P(C,S);let m=!1,l=0,h;C.insertSpaces?h=k(" ",C.tabSize||4):h="	";const f=(0,D.createScanner)(p,!1);let n=!1;function r(){return u+k(h,w+l)}function t(){let o=f.scan();for(m=!1;o===15||o===14;)m=m||o===14,o=f.scan();return n=o===16||f.getTokenError()!==0,o}const a=[];function s(o,y,E){!n&&y<v&&E>g&&S.substring(y,E)!==o&&a.push({offset:y,length:E-y,content:o})}let c=t();if(c!==17){const o=f.getTokenOffset()+d,y=k(h,w);s(y,d,o)}for(;c!==17;){let o=f.getTokenOffset()+f.getTokenLength()+d,y=t(),E="";for(;!m&&(y===12||y===13);){const q=f.getTokenOffset()+d;s(" ",o,q),o=f.getTokenOffset()+f.getTokenLength()+d,E=y===12?r():"",y=t()}if(y===2)c!==1&&(l--,E=r());else if(y===4)c!==3&&(l--,E=r());else{switch(c){case 3:case 1:l++,E=r();break;case 5:case 12:E=r();break;case 13:m?E=r():E=" ";break;case 6:E=" ";break;case 10:if(y===6){E="";break}case 7:case 8:case 9:case 11:case 2:case 4:y===12||y===13?E=" ":y!==5&&y!==17&&(n=!0);break;case 16:n=!0;break}m&&(y===12||y===13)&&(E=r())}const T=f.getTokenOffset()+d;s(E,o,T),c=y}return a}e.format=i;function R(S,b){const C=JSON.stringify(S,void 0,b.insertSpaces?b.tabSize||4:"	");return b.eol!==void 0?C.replace(/\r\n|\r|\n/g,b.eol):C}e.toFormattedString=R;function k(S,b){let C="";for(let w=0;w<b;w++)C+=S;return C}function L(S,b){let C=0,w=0;const p=b.tabSize||4;for(;C<S.length;){const d=S.charAt(C);if(d===" ")w++;else if(d==="	")w+=p;else break;C++}return Math.floor(w/p)}function P(S,b){for(let C=0;C<b.length;C++){const w=b.charAt(C);if(w==="\r")return C+1<b.length&&b.charAt(C+1)===`
`?`\r
`:"\r";if(w===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=P;function I(S,b){return`\r
`.indexOf(S.charAt(b))!==-1}e.isEOL=I}),define(re[83],ae([0,1,35,43]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function R(S,b,C){return k(S,b,void 0,C)}e.removeProperty=R;function k(S,b,C,w,p){const d=b.slice(),g=[],v=(0,D.parseTree)(S,g);let u,m;for(;d.length>0&&(m=d.pop(),u=(0,D.findNodeAtLocation)(v,d),u===void 0&&C!==void 0);)typeof m=="string"?C={[m]:C}:C=[C];if(u)if(u.type==="object"&&typeof m=="string"&&Array.isArray(u.children)){const l=(0,D.findNodeAtLocation)(u,[m]);if(l!==void 0)if(C===void 0){if(!l.parent)throw new Error("Malformed AST");const h=u.children.indexOf(l.parent);let f,n=l.parent.offset+l.parent.length;if(h>0){const r=u.children[h-1];f=r.offset+r.length}else f=u.offset+1,u.children.length>1&&(n=u.children[1].offset);return L(S,{offset:f,length:n-f,content:""},w)}else return L(S,{offset:l.offset,length:l.length,content:JSON.stringify(C)},w);else{if(C===void 0)return[];const h=`${JSON.stringify(m)}: ${JSON.stringify(C)}`,f=p?p(u.children.map(r=>r.children[0].value)):u.children.length;let n;if(f>0){const r=u.children[f-1];n={offset:r.offset+r.length,length:0,content:","+h}}else u.children.length===0?n={offset:u.offset+1,length:0,content:h}:n={offset:u.offset+1,length:0,content:h+","};return L(S,n,w)}}else if(u.type==="array"&&typeof m=="number"&&Array.isArray(u.children))if(C!==void 0){const l=`${JSON.stringify(C)}`;let h;if(u.children.length===0||m===0)h={offset:u.offset+1,length:0,content:u.children.length===0?l:l+","};else{const f=m===-1||m>u.children.length?u.children.length:m,n=u.children[f-1];h={offset:n.offset+n.length,length:0,content:","+l}}return L(S,h,w)}else{const l=m,h=u.children[l];let f;if(u.children.length===1)f={offset:u.offset+1,length:u.length-2,content:""};else if(u.children.length-1===l){const n=u.children[l-1],r=n.offset+n.length,t=u.offset+u.length;f={offset:r,length:t-2-r,content:""}}else f={offset:h.offset,length:u.children[l+1].offset-h.offset,content:""};return L(S,f,w)}else throw new Error(`Can not add ${typeof m!="number"?"index":"property"} to parent of type ${u.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return L(S,{offset:v?v.offset:0,length:v?v.length:0,content:JSON.stringify(C)},w)}}e.setProperty=k;function L(S,b,C){let w=P(S,b),p=b.offset,d=b.offset+b.content.length;if(b.length===0||b.content.length===0){for(;p>0&&!(0,i.isEOL)(w,p-1);)p--;for(;d<w.length&&!(0,i.isEOL)(w,d);)d++}const g=(0,i.format)(w,{offset:p,length:d-p},C);for(let u=g.length-1;u>=0;u--){const m=g[u];w=P(w,m),p=Math.min(p,m.offset),d=Math.max(d,m.offset+m.length),d+=m.content.length-m.length}const v=S.length-(w.length-d)-p;return[{offset:p,length:v,content:w.substring(p,d)}]}e.withFormatting=L;function P(S,b){return S.substring(0,b.offset)+b.content+S.substring(b.offset+b.length)}e.applyEdit=P;function I(S,b){const C=b.slice(0).sort((p,d)=>{const g=p.offset-d.offset;return g===0?p.length-d.length:g});let w=S.length;for(let p=C.length-1;p>=0;p--){const d=C[p];if(d.offset+d.length<=w)S=P(S,d);else throw new Error("Overlapping edit");w=d.offset}return S}e.applyEdits=I}),define(re[127],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class D{constructor(R){this.d=R,this.a=!1}hasValue(){return this.a}getValue(){if(!this.a)try{this.b=this.d()}catch(R){this.c=R}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}map(R){return new D(()=>R(this.getValue()))}}e.Lazy=D}),define(re[2],ae([0,1,82,64]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const R=!1;let k=null;function L(c){k=c}if(e.setDisposableTracker=L,R){const c="__is_disposable_tracked__";L(new class{trackDisposable(o){const y=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[c]||console.log(y)},3e3)}setParent(o,y){if(o&&o!==m.None)try{o[c]=!0}catch{}}markAsDisposed(o){if(o&&o!==m.None)try{o[c]=!0}catch{}}markAsSingleton(o){}})}function P(c){return k?.trackDisposable(c),c}function I(c){k?.markAsDisposed(c)}function S(c,o){k?.setParent(c,o)}function b(c,o){if(!!k)for(const y of c)k.setParent(y,o)}function C(c){return k?.markAsSingleton(c),c}e.markAsSingleton=C;function w(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=w;function p(c){if(i.Iterable.is(c)){const o=[];for(const y of c)if(y)try{y.dispose()}catch(E){o.push(E)}if(o.length===1)throw o[0];if(o.length>1)throw new AggregateError(o,"Encountered errors while disposing of store");return Array.isArray(c)?[]:c}else if(c)return c.dispose(),c}e.dispose=p;function d(c){for(const o of c)w(o)&&o.dispose();return[]}e.disposeIfDisposable=d;function g(...c){const o=v(()=>p(c));return b(c,o),o}e.combinedDisposable=g;function v(c){const o=P({dispose:(0,D.once)(()=>{I(o),c()})});return o}e.toDisposable=v;class u{constructor(){this.c=new Set,this.f=!1,P(this)}dispose(){this.f||(I(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{p(this.c)}finally{this.c.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return S(o,this),this.f?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(o),o}}e.DisposableStore=u,u.DISABLE_DISPOSED_WARNING=!1;class m{constructor(){this.q=new u,P(this),S(this.q,this)}dispose(){I(this),this.q.dispose()}B(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(o)}}e.Disposable=m,m.None=Object.freeze({dispose(){}});class l{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(o){this.b||o===this.a||(this.a?.dispose(),o&&S(o,this),this.a=o)}clear(){this.value=void 0}dispose(){this.b=!0,I(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const o=this.a;return this.a=void 0,o&&S(o,null),o}}e.MutableDisposable=l;class h{constructor(o){this.b=o,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=h;class f{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(o){let y=o;return this.unset=()=>y=void 0,this.isset=()=>y!==void 0,this.dispose=()=>{y&&(y(),y=void 0,I(this))},this}}e.SafeDisposable=f;class n{constructor(){this.a=new Map}acquire(o,...y){let E=this.a.get(o);E||(E={counter:0,object:this.b(o,...y)},this.a.set(o,E));const{object:T}=E,q=(0,D.once)(()=>{--E.counter===0&&(this.c(o,E.object),this.a.delete(o))});return E.counter++,{object:T,dispose:q}}}e.ReferenceCollection=n;class r{constructor(o){this.a=o}async acquire(o,...y){const E=this.a.acquire(o,...y);try{return{object:await E.object,dispose:()=>E.dispose()}}catch(T){throw E.dispose(),T}}}e.AsyncReferenceCollection=r;class t{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=t;function a(c){const o=new u;try{c(o)}finally{o.dispose()}}e.disposeOnReturn=a;class s{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){I(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{p(this.a.values())}finally{this.a.clear()}}has(o){return this.a.has(o)}get(o){return this.a.get(o)}set(o,y,E=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),E||this.a.get(o)?.dispose(),this.a.set(o,y)}deleteAndDispose(o){this.a.get(o)?.dispose(),this.a.delete(o)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=s}),define(re[84],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class D{constructor(k){this.element=k,this.next=D.Undefined,this.prev=D.Undefined}}D.Undefined=new D(void 0);class i{constructor(){this.a=D.Undefined,this.b=D.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===D.Undefined}clear(){let k=this.a;for(;k!==D.Undefined;){const L=k.next;k.prev=D.Undefined,k.next=D.Undefined,k=L}this.a=D.Undefined,this.b=D.Undefined,this.c=0}unshift(k){return this.d(k,!1)}push(k){return this.d(k,!0)}d(k,L){const P=new D(k);if(this.a===D.Undefined)this.a=P,this.b=P;else if(L){const S=this.b;this.b=P,P.prev=S,S.next=P}else{const S=this.a;this.a=P,P.next=S,S.prev=P}this.c+=1;let I=!1;return()=>{I||(I=!0,this.e(P))}}shift(){if(this.a!==D.Undefined){const k=this.a.element;return this.e(this.a),k}}pop(){if(this.b!==D.Undefined){const k=this.b.element;return this.e(this.b),k}}e(k){if(k.prev!==D.Undefined&&k.next!==D.Undefined){const L=k.prev;L.next=k.next,k.next.prev=L}else k.prev===D.Undefined&&k.next===D.Undefined?(this.a=D.Undefined,this.b=D.Undefined):k.next===D.Undefined?(this.b=this.b.prev,this.b.next=D.Undefined):k.prev===D.Undefined&&(this.a=this.a.next,this.a.prev=D.Undefined);this.c-=1}*[Symbol.iterator](){let k=this.a;for(;k!==D.Undefined;)yield k.element,k=k.next}}e.LinkedList=i}),define(re[37],ae([0,1]),function(_,e){"use strict";var D,i,R;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function k(d,g,v){let u=d.get(g);return u===void 0&&(u=v,d.set(g,u)),u}e.getOrSet=k;function L(d){const g=[];return d.forEach((v,u)=>{g.push(`${u} => ${v}`)}),`Map(${d.size}) {${g.join(", ")}}`}e.mapToString=L;function P(d){const g=[];return d.forEach(v=>{g.push(v)}),`Set(${d.size}) {${g.join(", ")}}`}e.setToString=P;class I{constructor(g,v){this.uri=g,this.value=v}}class S{constructor(g,v){this[D]="ResourceMap",g instanceof S?(this.b=new Map(g.b),this.c=v??S.a):(this.b=new Map,this.c=g??S.a)}set(g,v){return this.b.set(this.c(g),new I(g,v)),this}get(g){return this.b.get(this.c(g))?.value}has(g){return this.b.has(this.c(g))}get size(){return this.b.size}clear(){this.b.clear()}delete(g){return this.b.delete(this.c(g))}forEach(g,v){typeof v<"u"&&(g=g.bind(v));for(const[u,m]of this.b)g(m.value,m.uri,this)}*values(){for(const g of this.b.values())yield g.value}*keys(){for(const g of this.b.values())yield g.uri}*entries(){for(const g of this.b.values())yield[g.uri,g.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,g]of this.b)yield[g.uri,g.value]}}e.ResourceMap=S,S.a=d=>d.toString();class b{constructor(g,v){this[i]="ResourceSet",!g||typeof g=="function"?this.a=new S(g):(this.a=new S(v),g.forEach(this.add,this))}get size(){return this.a.size}add(g){return this.a.set(g,g),this}clear(){this.a.clear()}delete(g){return this.a.delete(g)}forEach(g,v){this.a.forEach((u,m)=>g.call(v,m,m,this))}has(g){return this.a.has(g)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=b;var C;(function(d){d[d.None=0]="None",d[d.AsOld=1]="AsOld",d[d.AsNew=2]="AsNew"})(C=e.Touch||(e.Touch={}));class w{constructor(){this[R]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(g){return this.a.has(g)}get(g,v=0){const u=this.a.get(g);if(!!u)return v!==0&&this.j(u,v),u.value}set(g,v,u=0){let m=this.a.get(g);if(m)m.value=v,u!==0&&this.j(m,u);else{switch(m={key:g,value:v,next:void 0,previous:void 0},u){case 0:this.h(m);break;case 1:this.g(m);break;case 2:this.h(m);break;default:this.h(m);break}this.a.set(g,m),this.d++}return this}delete(g){return!!this.remove(g)}remove(g){const v=this.a.get(g);if(!!v)return this.a.delete(g),this.i(v),this.d--,v.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const g=this.b;return this.a.delete(g.key),this.i(g),this.d--,g.value}forEach(g,v){const u=this.e;let m=this.b;for(;m;){if(v?g.bind(v)(m.value,m.key,this):g(m.value,m.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");m=m.next}}keys(){const g=this,v=this.e;let u=this.b;const m={[Symbol.iterator](){return m},next(){if(g.e!==v)throw new Error("LinkedMap got modified during iteration.");if(u){const l={value:u.key,done:!1};return u=u.next,l}else return{value:void 0,done:!0}}};return m}values(){const g=this,v=this.e;let u=this.b;const m={[Symbol.iterator](){return m},next(){if(g.e!==v)throw new Error("LinkedMap got modified during iteration.");if(u){const l={value:u.value,done:!1};return u=u.next,l}else return{value:void 0,done:!0}}};return m}entries(){const g=this,v=this.e;let u=this.b;const m={[Symbol.iterator](){return m},next(){if(g.e!==v)throw new Error("LinkedMap got modified during iteration.");if(u){const l={value:[u.key,u.value],done:!1};return u=u.next,l}else return{value:void 0,done:!0}}};return m}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(g){if(g>=this.size)return;if(g===0){this.clear();return}let v=this.b,u=this.size;for(;v&&u>g;)this.a.delete(v.key),v=v.next,u--;this.b=v,this.d=u,v&&(v.previous=void 0),this.e++}g(g){if(!this.b&&!this.c)this.c=g;else if(this.b)g.next=this.b,this.b.previous=g;else throw new Error("Invalid list");this.b=g,this.e++}h(g){if(!this.b&&!this.c)this.b=g;else if(this.c)g.previous=this.c,this.c.next=g;else throw new Error("Invalid list");this.c=g,this.e++}i(g){if(g===this.b&&g===this.c)this.b=void 0,this.c=void 0;else if(g===this.b){if(!g.next)throw new Error("Invalid list");g.next.previous=void 0,this.b=g.next}else if(g===this.c){if(!g.previous)throw new Error("Invalid list");g.previous.next=void 0,this.c=g.previous}else{const v=g.next,u=g.previous;if(!v||!u)throw new Error("Invalid list");v.previous=u,u.next=v}g.next=void 0,g.previous=void 0,this.e++}j(g,v){if(!this.b||!this.c)throw new Error("Invalid list");if(!(v!==1&&v!==2)){if(v===1){if(g===this.b)return;const u=g.next,m=g.previous;g===this.c?(m.next=void 0,this.c=m):(u.previous=m,m.next=u),g.previous=void 0,g.next=this.b,this.b.previous=g,this.b=g,this.e++}else if(v===2){if(g===this.c)return;const u=g.next,m=g.previous;g===this.b?(u.previous=void 0,this.b=u):(u.previous=m,m.next=u),g.next=void 0,g.previous=this.c,this.c.next=g,this.c=g,this.e++}}}toJSON(){const g=[];return this.forEach((v,u)=>{g.push([u,v])}),g}fromJSON(g){this.clear();for(const[v,u]of g)this.set(v,u)}}e.LinkedMap=w;class p extends w{constructor(g,v=1){super(),this.k=g,this.l=Math.min(Math.max(0,v),1)}get limit(){return this.k}set limit(g){this.k=g,this.m()}get ratio(){return this.l}set ratio(g){this.l=Math.min(Math.max(0,g),1),this.m()}get(g,v=2){return super.get(g,v)}peek(g){return super.get(g,0)}set(g,v){return super.set(g,v,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=p}),define(re[85],ae([0,1,37]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const i=new D.LRUCache(1e4);function R(S){return I(S,"NFC",i)}e.normalizeNFC=R;const k=new D.LRUCache(1e4);function L(S){return I(S,"NFD",k)}e.normalizeNFD=L;const P=/[^\u0000-\u0080]/;function I(S,b,C){if(!S)return S;const w=C.get(S);if(w)return w;let p;return P.test(S)?p=S.normalize(b):p=S,C.set(S,p),p}e.removeAccents=function(){const S=/[\u0300-\u036f]/g;return function(b){return L(b).replace(S,"")}}()}),function(){function _(R){const k=[];typeof R=="number"&&k.push("code/timeOrigin",R);function L(I){k.push(I,Date.now())}function P(){const I=[];for(let S=0;S<k.length;S+=2)I.push({name:k[S],startTime:k[S+1]});return I}return{mark:L,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?_():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const L of performance.getEntriesByType("mark"))k.push({name:L.name,startTime:Math.round(R+L.startTime)});return k}};if(typeof process=="object"){const R=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return _(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),_()}function D(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var i;typeof global=="object"?i=global:typeof self=="object"?i=self:i={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(i)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(i):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),i.perf=D(i))}(),function(_,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var i in D)(typeof exports=="object"?exports:_)[i]=D[i]}}(typeof self<"u"?self:this,function(){return function(_){var e={};function D(i){if(e[i])return e[i].exports;var R=e[i]={i,l:!1,exports:{}};return _[i].call(R.exports,R,R.exports,D),R.l=!0,R.exports}return D.m=_,D.c=e,D.d=function(i,R,k){D.o(i,R)||Object.defineProperty(i,R,{enumerable:!0,get:k})},D.r=function(i){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(i,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(i,"__esModule",{value:!0})},D.t=function(i,R){if(1&R&&(i=D(i)),8&R||4&R&&typeof i=="object"&&i&&i.__esModule)return i;var k=Object.create(null);if(D.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:i}),2&R&&typeof i!="string")for(var L in i)D.d(k,L,function(P){return i[P]}.bind(null,L));return k},D.n=function(i){var R=i&&i.__esModule?function(){return i.default}:function(){return i};return D.d(R,"a",R),R},D.o=function(i,R){return Object.prototype.hasOwnProperty.call(i,R)},D.p="",D(D.s=0)}([function(_,e,D){(function(i){var R;e=_.exports=O,R=typeof i=="object"&&i.env&&i.env.NODE_DEBUG&&/\bsemver\b/i.test(i.env.NODE_DEBUG)?function(){var ce=Array.prototype.slice.call(arguments,0);ce.unshift("SEMVER"),console.log.apply(console,ce)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var k=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],I=e.src=[],S=0,b=S++;I[b]="0|[1-9]\\d*";var C=S++;I[C]="[0-9]+";var w=S++;I[w]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=S++;I[p]="("+I[b]+")\\.("+I[b]+")\\.("+I[b]+")";var d=S++;I[d]="("+I[C]+")\\.("+I[C]+")\\.("+I[C]+")";var g=S++;I[g]="(?:"+I[b]+"|"+I[w]+")";var v=S++;I[v]="(?:"+I[C]+"|"+I[w]+")";var u=S++;I[u]="(?:-("+I[g]+"(?:\\."+I[g]+")*))";var m=S++;I[m]="(?:-?("+I[v]+"(?:\\."+I[v]+")*))";var l=S++;I[l]="[0-9A-Za-z-]+";var h=S++;I[h]="(?:\\+("+I[l]+"(?:\\."+I[l]+")*))";var f=S++,n="v?"+I[p]+I[u]+"?"+I[h]+"?";I[f]="^"+n+"$";var r="[v=\\s]*"+I[d]+I[m]+"?"+I[h]+"?",t=S++;I[t]="^"+r+"$";var a=S++;I[a]="((?:<|>)?=?)";var s=S++;I[s]=I[C]+"|x|X|\\*";var c=S++;I[c]=I[b]+"|x|X|\\*";var o=S++;I[o]="[v=\\s]*("+I[c]+")(?:\\.("+I[c]+")(?:\\.("+I[c]+")(?:"+I[u]+")?"+I[h]+"?)?)?";var y=S++;I[y]="[v=\\s]*("+I[s]+")(?:\\.("+I[s]+")(?:\\.("+I[s]+")(?:"+I[m]+")?"+I[h]+"?)?)?";var E=S++;I[E]="^"+I[a]+"\\s*"+I[o]+"$";var T=S++;I[T]="^"+I[a]+"\\s*"+I[y]+"$";var q=S++;I[q]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var N=S++;I[N]="(?:~>?)";var j=S++;I[j]="(\\s*)"+I[N]+"\\s+",P[j]=new RegExp(I[j],"g");var F=S++;I[F]="^"+I[N]+I[o]+"$";var A=S++;I[A]="^"+I[N]+I[y]+"$";var U=S++;I[U]="(?:\\^)";var B=S++;I[B]="(\\s*)"+I[U]+"\\s+",P[B]=new RegExp(I[B],"g");var G=S++;I[G]="^"+I[U]+I[o]+"$";var W=S++;I[W]="^"+I[U]+I[y]+"$";var Z=S++;I[Z]="^"+I[a]+"\\s*("+r+")$|^$";var $=S++;I[$]="^"+I[a]+"\\s*("+n+")$|^$";var z=S++;I[z]="(\\s*)"+I[a]+"\\s*("+r+"|"+I[o]+")",P[z]=new RegExp(I[z],"g");var Y=S++;I[Y]="^\\s*("+I[o]+")\\s+-\\s+("+I[o]+")\\s*$";var ee=S++;I[ee]="^\\s*("+I[y]+")\\s+-\\s+("+I[y]+")\\s*$";var oe=S++;I[oe]="(<|>)?=?\\s*\\*";for(var J=0;J<35;J++)R(J,I[J]),P[J]||(P[J]=new RegExp(I[J]));function Q(ce,de){if(ce instanceof O)return ce;if(typeof ce!="string"||ce.length>k||!(de?P[t]:P[f]).test(ce))return null;try{return new O(ce,de)}catch{return null}}function O(ce,de){if(ce instanceof O){if(ce.loose===de)return ce;ce=ce.version}else if(typeof ce!="string")throw new TypeError("Invalid Version: "+ce);if(ce.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof O))return new O(ce,de);R("SemVer",ce,de),this.loose=de;var ge=ce.trim().match(de?P[t]:P[f]);if(!ge)throw new TypeError("Invalid Version: "+ce);if(this.raw=ce,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Ce){if(/^[0-9]+$/.test(Ce)){var Pe=+Ce;if(Pe>=0&&Pe<L)return Pe}return Ce}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=Q,e.valid=function(ce,de){var ge=Q(ce,de);return ge?ge.version:null},e.clean=function(ce,de){var ge=Q(ce.trim().replace(/^[=v]+/,""),de);return ge?ge.version:null},e.SemVer=O,O.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},O.prototype.toString=function(){return this.version},O.prototype.compare=function(ce){return R("SemVer.compare",this.version,this.loose,ce),ce instanceof O||(ce=new O(ce,this.loose)),this.compareMain(ce)||this.comparePre(ce)},O.prototype.compareMain=function(ce){return ce instanceof O||(ce=new O(ce,this.loose)),H(this.major,ce.major)||H(this.minor,ce.minor)||H(this.patch,ce.patch)},O.prototype.comparePre=function(ce){if(ce instanceof O||(ce=new O(ce,this.loose)),this.prerelease.length&&!ce.prerelease.length)return-1;if(!this.prerelease.length&&ce.prerelease.length)return 1;if(!this.prerelease.length&&!ce.prerelease.length)return 0;var de=0;do{var ge=this.prerelease[de],Ce=ce.prerelease[de];if(R("prerelease compare",de,ge,Ce),ge===void 0&&Ce===void 0)return 0;if(Ce===void 0)return 1;if(ge===void 0)return-1;if(ge!==Ce)return H(ge,Ce)}while(++de)},O.prototype.inc=function(ce,de){switch(ce){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+ce)}return this.format(),this.raw=this.version,this},e.inc=function(ce,de,ge,Ce){typeof ge=="string"&&(Ce=ge,ge=void 0);try{return new O(ce,ge).inc(de,Ce).version}catch{return null}},e.diff=function(ce,de){if(x(ce,de))return null;var ge=Q(ce),Ce=Q(de);if(ge.prerelease.length||Ce.prerelease.length){for(var Pe in ge)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ge[Pe]!==Ce[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in ge)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ge[Pe]!==Ce[Pe])return Pe},e.compareIdentifiers=H;var M=/^[0-9]+$/;function H(ce,de){var ge=M.test(ce),Ce=M.test(de);return ge&&Ce&&(ce=+ce,de=+de),ge&&!Ce?-1:Ce&&!ge?1:ce<de?-1:ce>de?1:0}function V(ce,de,ge){return new O(ce,ge).compare(new O(de,ge))}function X(ce,de,ge){return V(ce,de,ge)>0}function se(ce,de,ge){return V(ce,de,ge)<0}function x(ce,de,ge){return V(ce,de,ge)===0}function ie(ce,de,ge){return V(ce,de,ge)!==0}function ne(ce,de,ge){return V(ce,de,ge)>=0}function le(ce,de,ge){return V(ce,de,ge)<=0}function ue(ce,de,ge,Ce){var Pe;switch(de){case"===":typeof ce=="object"&&(ce=ce.version),typeof ge=="object"&&(ge=ge.version),Pe=ce===ge;break;case"!==":typeof ce=="object"&&(ce=ce.version),typeof ge=="object"&&(ge=ge.version),Pe=ce!==ge;break;case"":case"=":case"==":Pe=x(ce,ge,Ce);break;case"!=":Pe=ie(ce,ge,Ce);break;case">":Pe=X(ce,ge,Ce);break;case">=":Pe=ne(ce,ge,Ce);break;case"<":Pe=se(ce,ge,Ce);break;case"<=":Pe=le(ce,ge,Ce);break;default:throw new TypeError("Invalid operator: "+de)}return Pe}function ye(ce,de){if(ce instanceof ye){if(ce.loose===de)return ce;ce=ce.value}if(!(this instanceof ye))return new ye(ce,de);R("comparator",ce,de),this.loose=de,this.parse(ce),this.semver===Se?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(ce,de){return H(de,ce)},e.major=function(ce,de){return new O(ce,de).major},e.minor=function(ce,de){return new O(ce,de).minor},e.patch=function(ce,de){return new O(ce,de).patch},e.compare=V,e.compareLoose=function(ce,de){return V(ce,de,!0)},e.rcompare=function(ce,de,ge){return V(de,ce,ge)},e.sort=function(ce,de){return ce.sort(function(ge,Ce){return e.compare(ge,Ce,de)})},e.rsort=function(ce,de){return ce.sort(function(ge,Ce){return e.rcompare(ge,Ce,de)})},e.gt=X,e.lt=se,e.eq=x,e.neq=ie,e.gte=ne,e.lte=le,e.cmp=ue,e.Comparator=ye;var Se={};function be(ce,de){if(ce instanceof be)return ce.loose===de?ce:new be(ce.raw,de);if(ce instanceof ye)return new be(ce.value,de);if(!(this instanceof be))return new be(ce,de);if(this.loose=de,this.raw=ce,this.set=ce.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ce);this.format()}function Ee(ce){return!ce||ce.toLowerCase()==="x"||ce==="*"}function Ne(ce,de,ge,Ce,Pe,Ae,De,je,Te,Me,ze,ke,Oe){return((de=Ee(ge)?"":Ee(Ce)?">="+ge+".0.0":Ee(Pe)?">="+ge+"."+Ce+".0":">="+de)+" "+(je=Ee(Te)?"":Ee(Me)?"<"+(+Te+1)+".0.0":Ee(ze)?"<"+Te+"."+(+Me+1)+".0":ke?"<="+Te+"."+Me+"."+ze+"-"+ke:"<="+je)).trim()}function Fe(ce,de){for(var ge=0;ge<ce.length;ge++)if(!ce[ge].test(de))return!1;if(de.prerelease.length){for(ge=0;ge<ce.length;ge++)if(R(ce[ge].semver),ce[ge].semver!==Se&&ce[ge].semver.prerelease.length>0){var Ce=ce[ge].semver;if(Ce.major===de.major&&Ce.minor===de.minor&&Ce.patch===de.patch)return!0}return!1}return!0}function Ye(ce,de,ge){try{de=new be(de,ge)}catch{return!1}return de.test(ce)}function Be(ce,de,ge,Ce){var Pe,Ae,De,je,Te;switch(ce=new O(ce,Ce),de=new be(de,Ce),ge){case">":Pe=X,Ae=le,De=se,je=">",Te=">=";break;case"<":Pe=se,Ae=ne,De=X,je="<",Te="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ye(ce,de,Ce))return!1;for(var Me=0;Me<de.set.length;++Me){var ze=de.set[Me],ke=null,Oe=null;if(ze.forEach(function(te){te.semver===Se&&(te=new ye(">=0.0.0")),ke=ke||te,Oe=Oe||te,Pe(te.semver,ke.semver,Ce)?ke=te:De(te.semver,Oe.semver,Ce)&&(Oe=te)}),ke.operator===je||ke.operator===Te||(!Oe.operator||Oe.operator===je)&&Ae(ce,Oe.semver)||Oe.operator===Te&&De(ce,Oe.semver))return!1}return!0}ye.prototype.parse=function(ce){var de=this.loose?P[Z]:P[$],ge=ce.match(de);if(!ge)throw new TypeError("Invalid comparator: "+ce);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new O(ge[2],this.loose):this.semver=Se},ye.prototype.toString=function(){return this.value},ye.prototype.test=function(ce){return R("Comparator.test",ce,this.loose),this.semver===Se||(typeof ce=="string"&&(ce=new O(ce,this.loose)),ue(ce,this.operator,this.semver,this.loose))},ye.prototype.intersects=function(ce,de){if(!(ce instanceof ye))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new be(ce.value,de),Ye(this.value,ge,de);if(ce.operator==="")return ge=new be(this.value,de),Ye(ce.semver,ge,de);var Ce=!(this.operator!==">="&&this.operator!==">"||ce.operator!==">="&&ce.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||ce.operator!=="<="&&ce.operator!=="<"),Ae=this.semver.version===ce.semver.version,De=!(this.operator!==">="&&this.operator!=="<="||ce.operator!==">="&&ce.operator!=="<="),je=ue(this.semver,"<",ce.semver,de)&&(this.operator===">="||this.operator===">")&&(ce.operator==="<="||ce.operator==="<"),Te=ue(this.semver,">",ce.semver,de)&&(this.operator==="<="||this.operator==="<")&&(ce.operator===">="||ce.operator===">");return Ce||Pe||Ae&&De||je||Te},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(ce){return ce.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(ce){var de=this.loose;ce=ce.trim(),R("range",ce,de);var ge=de?P[ee]:P[Y];ce=ce.replace(ge,Ne),R("hyphen replace",ce),ce=ce.replace(P[z],"$1$2$3"),R("comparator trim",ce,P[z]),ce=(ce=(ce=ce.replace(P[j],"$1~")).replace(P[B],"$1^")).split(/\s+/).join(" ");var Ce=de?P[Z]:P[$],Pe=ce.split(" ").map(function(Ae){return function(De,je){return R("comp",De),De=function(Te,Me){return Te.trim().split(/\s+/).map(function(ze){return function(ke,Oe){R("caret",ke,Oe);var te=Oe?P[W]:P[G];return ke.replace(te,function(he,fe,me,we,Ie){var Re;return R("caret",ke,he,fe,me,we,Ie),Ee(fe)?Re="":Ee(me)?Re=">="+fe+".0.0 <"+(+fe+1)+".0.0":Ee(we)?Re=fe==="0"?">="+fe+"."+me+".0 <"+fe+"."+(+me+1)+".0":">="+fe+"."+me+".0 <"+(+fe+1)+".0.0":Ie?(R("replaceCaret pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Re=fe==="0"?me==="0"?">="+fe+"."+me+"."+we+Ie+" <"+fe+"."+me+"."+(+we+1):">="+fe+"."+me+"."+we+Ie+" <"+fe+"."+(+me+1)+".0":">="+fe+"."+me+"."+we+Ie+" <"+(+fe+1)+".0.0"):(R("no pr"),Re=fe==="0"?me==="0"?">="+fe+"."+me+"."+we+" <"+fe+"."+me+"."+(+we+1):">="+fe+"."+me+"."+we+" <"+fe+"."+(+me+1)+".0":">="+fe+"."+me+"."+we+" <"+(+fe+1)+".0.0"),R("caret return",Re),Re})}(ze,Me)}).join(" ")}(De,je),R("caret",De),De=function(Te,Me){return Te.trim().split(/\s+/).map(function(ze){return function(ke,Oe){var te=Oe?P[A]:P[F];return ke.replace(te,function(he,fe,me,we,Ie){var Re;return R("tilde",ke,he,fe,me,we,Ie),Ee(fe)?Re="":Ee(me)?Re=">="+fe+".0.0 <"+(+fe+1)+".0.0":Ee(we)?Re=">="+fe+"."+me+".0 <"+fe+"."+(+me+1)+".0":Ie?(R("replaceTilde pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Re=">="+fe+"."+me+"."+we+Ie+" <"+fe+"."+(+me+1)+".0"):Re=">="+fe+"."+me+"."+we+" <"+fe+"."+(+me+1)+".0",R("tilde return",Re),Re})}(ze,Me)}).join(" ")}(De,je),R("tildes",De),De=function(Te,Me){return R("replaceXRanges",Te,Me),Te.split(/\s+/).map(function(ze){return function(ke,Oe){ke=ke.trim();var te=Oe?P[T]:P[E];return ke.replace(te,function(he,fe,me,we,Ie,Re){R("xRange",ke,he,fe,me,we,Ie,Re);var He=Ee(me),$e=He||Ee(we),Le=$e||Ee(Ie);return fe==="="&&Le&&(fe=""),He?he=fe===">"||fe==="<"?"<0.0.0":"*":fe&&Le?($e&&(we=0),Le&&(Ie=0),fe===">"?(fe=">=",$e?(me=+me+1,we=0,Ie=0):Le&&(we=+we+1,Ie=0)):fe==="<="&&(fe="<",$e?me=+me+1:we=+we+1),he=fe+me+"."+we+"."+Ie):$e?he=">="+me+".0.0 <"+(+me+1)+".0.0":Le&&(he=">="+me+"."+we+".0 <"+me+"."+(+we+1)+".0"),R("xRange return",he),he})}(ze,Me)}).join(" ")}(De,je),R("xrange",De),De=function(Te,Me){return R("replaceStars",Te,Me),Te.trim().replace(P[oe],"")}(De,je),R("stars",De),De}(Ae,de)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(Ae){return!!Ae.match(Ce)})),Pe=Pe.map(function(Ae){return new ye(Ae,de)})},be.prototype.intersects=function(ce,de){if(!(ce instanceof be))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Ce){return ce.set.some(function(Pe){return Pe.every(function(Ae){return Ce.intersects(Ae,de)})})})})},e.toComparators=function(ce,de){return new be(ce,de).set.map(function(ge){return ge.map(function(Ce){return Ce.value}).join(" ").trim().split(" ")})},be.prototype.test=function(ce){if(!ce)return!1;typeof ce=="string"&&(ce=new O(ce,this.loose));for(var de=0;de<this.set.length;de++)if(Fe(this.set[de],ce))return!0;return!1},e.satisfies=Ye,e.maxSatisfying=function(ce,de,ge){var Ce=null,Pe=null;try{var Ae=new be(de,ge)}catch{return null}return ce.forEach(function(De){Ae.test(De)&&(Ce&&Pe.compare(De)!==-1||(Pe=new O(Ce=De,ge)))}),Ce},e.minSatisfying=function(ce,de,ge){var Ce=null,Pe=null;try{var Ae=new be(de,ge)}catch{return null}return ce.forEach(function(De){Ae.test(De)&&(Ce&&Pe.compare(De)!==1||(Pe=new O(Ce=De,ge)))}),Ce},e.validRange=function(ce,de){try{return new be(ce,de).range||"*"}catch{return null}},e.ltr=function(ce,de,ge){return Be(ce,de,"<",ge)},e.gtr=function(ce,de,ge){return Be(ce,de,">",ge)},e.outside=Be,e.prerelease=function(ce,de){var ge=Q(ce,de);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(ce,de,ge){return ce=new be(ce,ge),de=new be(de,ge),ce.intersects(de)},e.coerce=function(ce){if(ce instanceof O)return ce;if(typeof ce!="string")return null;var de=ce.match(P[q]);return de==null?null:Q((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,D(1))},function(_,e){var D,i,R=_.exports={};function k(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function P(v){if(D===setTimeout)return setTimeout(v,0);if((D===k||!D)&&setTimeout)return D=setTimeout,setTimeout(v,0);try{return D(v,0)}catch{try{return D.call(null,v,0)}catch{return D.call(this,v,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:k}catch{D=k}try{i=typeof clearTimeout=="function"?clearTimeout:L}catch{i=L}})();var I,S=[],b=!1,C=-1;function w(){b&&I&&(b=!1,I.length?S=I.concat(S):C=-1,S.length&&p())}function p(){if(!b){var v=P(w);b=!0;for(var u=S.length;u;){for(I=S,S=[];++C<u;)I&&I[C].run();C=-1,u=S.length}I=null,b=!1,function(m){if(i===clearTimeout)return clearTimeout(m);if((i===L||!i)&&clearTimeout)return i=clearTimeout,clearTimeout(m);try{i(m)}catch{try{return i.call(null,m)}catch{return i.call(this,m)}}}(v)}}function d(v,u){this.fun=v,this.array=u}function g(){}R.nextTick=function(v){var u=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)u[m-1]=arguments[m];S.push(new d(v,u)),S.length!==1||b||P(p)},d.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=g,R.addListener=g,R.once=g,R.off=g,R.removeListener=g,R.removeAllListeners=g,R.emit=g,R.prependListener=g,R.prependOnceListener=g,R.listeners=function(v){return[]},R.binding=function(v){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function(v){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(re[128],ae([0,1]),function(_,e){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class i{constructor(P,I,S){this.level=P,this.key=I,this.value=S,this.forward=[]}}const R=void 0;class k{constructor(P,I=2**16){this.comparator=P,this[D]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(I)|0),this.e=new i(this.c,R,R)}get size(){return this.f}clear(){this.e=new i(this.c,R,R)}has(P){return Boolean(k.g(this,P,this.comparator))}get(P){return k.g(this,P,this.comparator)?.value}set(P,I){return k.h(this,P,I,this.comparator)&&(this.f+=1),this}delete(P){const I=k.k(this,P,this.comparator);return I&&(this.f-=1),I}forEach(P,I){let S=this.e.forward[0];for(;S;)P.call(I,S.value,S.key,this),S=S.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",I=this.e.forward[0];for(;I;)P+=`node(${I.key}, ${I.value}, lvl:${I.level})`,I=I.forward[0];return P}static g(P,I,S){let b=P.e;for(let C=P.d-1;C>=0;C--)for(;b.forward[C]&&S(b.forward[C].key,I)<0;)b=b.forward[C];if(b=b.forward[0],b&&S(b.key,I)===0)return b}static h(P,I,S,b){const C=[];let w=P.e;for(let p=P.d-1;p>=0;p--){for(;w.forward[p]&&b(w.forward[p].key,I)<0;)w=w.forward[p];C[p]=w}if(w=w.forward[0],w&&b(w.key,I)===0)return w.value=S,!1;{const p=k.j(P);if(p>P.d){for(let d=P.d;d<p;d++)C[d]=P.e;P.d=p}w=new i(p,I,S);for(let d=0;d<p;d++)w.forward[d]=C[d].forward[d],C[d].forward[d]=w;return!0}}static j(P,I=.5){let S=1;for(;Math.random()<I&&S<P.c;)S+=1;return S}static k(P,I,S){const b=[];let C=P.e;for(let w=P.d-1;w>=0;w--){for(;C.forward[w]&&S(C.forward[w].key,I)<0;)C=C.forward[w];b[w]=C}if(C=C.forward[0],!C||S(C.key,I)!==0)return!1;for(let w=0;w<P.d&&b[w].forward[w]===C;w++)b[w].forward[w]=C.forward[w];for(;P.d>0&&P.e.forward[P.d-1]===R;)P.d-=1;return!0}}e.SkipList=k}),define(re[44],ae([0,1,9,2]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function R(h){const f=h;return f?typeof f.read=="function":!1}e.isReadable=R;function k(h){const f=h;return f?[f.on,f.pause,f.resume,f.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=k;function L(h){const f=h;return f?k(f.stream)&&Array.isArray(f.buffer)&&typeof f.ended=="boolean":!1}e.isReadableBufferedStream=L;function P(h,f){return new I(h,f)}e.newWriteableStream=P;class I{constructor(f,n){this.e=f,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(f){if(!this.a.destroyed){if(this.a.flowing)this.g(f);else if(this.b.data.push(f),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(f){this.a.destroyed||(this.a.flowing?this.h(f):this.b.error.push(f))}end(f){this.a.destroyed||(typeof f<"u"&&this.write(f),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(f){this.c.data.slice(0).forEach(n=>n(f))}h(f){this.c.error.length===0?(0,D.onUnexpectedError)(f):this.c.error.slice(0).forEach(n=>n(f))}i(){this.c.end.slice(0).forEach(f=>f())}on(f,n){if(!this.a.destroyed)switch(f){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(f,n){if(this.a.destroyed)return;let r;switch(f){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const t=r.indexOf(n);t>=0&&r.splice(t,1)}}j(){if(this.b.data.length>0){const f=this.e(this.b.data);this.g(f),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const f of this.b.error)this.h(f);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function S(h,f){const n=[];let r;for(;(r=h.read())!==null;)n.push(r);return f(n)}e.consumeReadable=S;function b(h,f,n){const r=[];let t;for(;(t=h.read())!==null&&r.length<n;)r.push(t);return t===null&&r.length>0?f(r):{read:()=>{if(r.length>0)return r.shift();if(typeof t<"u"){const a=t;return t=void 0,a}return h.read()}}}e.peekReadable=b;function C(h,f){return new Promise((n,r)=>{const t=[];w(h,{onData:a=>{f&&t.push(a)},onError:a=>{f?r(a):n(void 0)},onEnd:()=>{n(f?f(t):void 0)}})})}e.consumeStream=C;function w(h,f){let n=!1;return h.on("error",r=>{n||f.onError(r)}),h.on("end",()=>{n||f.onEnd()}),h.on("data",r=>{n||f.onData(r)}),(0,i.toDisposable)(()=>n=!0)}e.listenStream=w;function p(h,f){return new Promise((n,r)=>{const t=new i.DisposableStore,a=[],s=y=>{if(a.push(y),a.length>f)return t.dispose(),h.pause(),n({stream:h,buffer:a,ended:!1})},c=y=>r(y),o=()=>n({stream:h,buffer:a,ended:!0});t.add((0,i.toDisposable)(()=>h.removeListener("error",c))),h.on("error",c),t.add((0,i.toDisposable)(()=>h.removeListener("end",o))),h.on("end",o),t.add((0,i.toDisposable)(()=>h.removeListener("data",s))),h.on("data",s)})}e.peekStream=p;function d(h,f){const n=P(f);return n.end(h),n}e.toStream=d;function g(){const h=P(()=>{throw new Error("not supported")});return h.end(),h}e.emptyStream=g;function v(h){let f=!1;return{read:()=>f?null:(f=!0,h)}}e.toReadable=v;function u(h,f,n){const r=P(n);return w(h,{onData:t=>r.write(f.data(t)),onError:t=>r.error(f.error?f.error(t):t),onEnd:()=>r.end()}),r}e.transform=u;function m(h,f,n){let r=!1;return{read:()=>{const t=f.read();return r?t:(r=!0,t!==null?n([h,t]):h)}}}e.prefixedReadable=m;function l(h,f,n){let r=!1;const t=P(n);return w(f,{onData:a=>r?t.write(a):(r=!0,t.write(n([h,a]))),onError:a=>t.error(a),onEnd:()=>{r||(r=!0,t.write(h)),t.end()}}),t}e.prefixedStream=l}),define(re[17],ae([0,1,44]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const i=typeof Buffer<"u";let R,k;class L{static alloc(y){return i?new L(Buffer.allocUnsafe(y)):new L(new Uint8Array(y))}static wrap(y){return i&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new L(y)}static fromString(y,E){return!(E?.dontUseNodeBuffer||!1)&&i?new L(Buffer.from(y)):(R||(R=new TextEncoder),new L(R.encode(y)))}static fromByteArray(y){const E=L.alloc(y.length);for(let T=0,q=y.length;T<q;T++)E.buffer[T]=y[T];return E}static concat(y,E){if(typeof E>"u"){E=0;for(let N=0,j=y.length;N<j;N++)E+=y[N].byteLength}const T=L.alloc(E);let q=0;for(let N=0,j=y.length;N<j;N++){const F=y[N];T.set(F,q),q+=F.byteLength}return T}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=L.alloc(this.byteLength);return y.set(this),y}toString(){return i?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(y,E){return new L(this.buffer.subarray(y,E))}set(y,E){if(y instanceof L)this.buffer.set(y.buffer,E);else if(y instanceof Uint8Array)this.buffer.set(y,E);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),E);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),E);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return S(this.buffer,y)}writeUInt32BE(y,E){b(this.buffer,y,E)}readUInt32LE(y){return C(this.buffer,y)}writeUInt32LE(y,E){w(this.buffer,y,E)}readUInt8(y){return p(this.buffer,y)}writeUInt8(y,E){d(this.buffer,y,E)}}e.VSBuffer=L;function P(o,y){return o[y+0]<<0>>>0|o[y+1]<<8>>>0}e.readUInt16LE=P;function I(o,y,E){o[E+0]=y&255,y=y>>>8,o[E+1]=y&255}e.writeUInt16LE=I;function S(o,y){return o[y]*2**24+o[y+1]*2**16+o[y+2]*2**8+o[y+3]}e.readUInt32BE=S;function b(o,y,E){o[E+3]=y,y=y>>>8,o[E+2]=y,y=y>>>8,o[E+1]=y,y=y>>>8,o[E]=y}e.writeUInt32BE=b;function C(o,y){return o[y+0]<<0>>>0|o[y+1]<<8>>>0|o[y+2]<<16>>>0|o[y+3]<<24>>>0}e.readUInt32LE=C;function w(o,y,E){o[E+0]=y&255,y=y>>>8,o[E+1]=y&255,y=y>>>8,o[E+2]=y&255,y=y>>>8,o[E+3]=y&255}e.writeUInt32LE=w;function p(o,y){return o[y]}e.readUInt8=p;function d(o,y,E){o[E]=y}e.writeUInt8=d;function g(o){return D.consumeReadable(o,y=>L.concat(y))}e.readableToBuffer=g;function v(o){return D.toReadable(o)}e.bufferToReadable=v;function u(o){return D.consumeStream(o,y=>L.concat(y))}e.streamToBuffer=u;async function m(o){return o.ended?L.concat(o.buffer):L.concat([...o.buffer,await u(o.stream)])}e.bufferedStreamToBuffer=m;function l(o){return D.toStream(o,y=>L.concat(y))}e.bufferToStream=l;function h(o){return D.transform(o,{data:y=>typeof y=="string"?L.fromString(y):L.wrap(y)},y=>L.concat(y))}e.streamToBufferReadableStream=h;function f(o){return D.newWriteableStream(y=>L.concat(y),o)}e.newWriteableBufferStream=f;function n(o,y){return D.prefixedReadable(o,y,E=>L.concat(E))}e.prefixedBufferReadable=n;function r(o,y){return D.prefixedStream(o,y,E=>L.concat(E))}e.prefixedBufferStream=r;function t(o){let y=0,E=0,T=0;const q=new Uint8Array(Math.floor(o.length/4*3)),N=F=>{switch(E){case 3:q[T++]=y|F,E=0;break;case 2:q[T++]=y|F>>>2,y=F<<6,E=3;break;case 1:q[T++]=y|F>>>4,y=F<<4,E=2;break;default:y=F<<2,E=1}};for(let F=0;F<o.length;F++){const A=o.charCodeAt(F);if(A>=65&&A<=90)N(A-65);else if(A>=97&&A<=122)N(A-97+26);else if(A>=48&&A<=57)N(A-48+52);else if(A===43||A===45)N(62);else if(A===47||A===95)N(63);else{if(A===61)break;throw new SyntaxError(`Unexpected base64 character ${o[F]}`)}}const j=T;for(;E>0;)N(0);return L.wrap(q).slice(0,j)}e.decodeBase64=t;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:o},y=!0,E=!1){const T=E?s:a;let q="";const N=o.byteLength%3;let j=0;for(;j<o.byteLength-N;j+=3){const F=o[j+0],A=o[j+1],U=o[j+2];q+=T[F>>>2],q+=T[(F<<4|A>>>4)&63],q+=T[(A<<2|U>>>6)&63],q+=T[U&63]}if(N===1){const F=o[j+0];q+=T[F>>>2],q+=T[F<<4&63],y&&(q+="==")}else if(N===2){const F=o[j+0],A=o[j+1];q+=T[F>>>2],q+=T[(F<<4|A>>>4)&63],q+=T[A<<2&63],y&&(q+="=")}return q}e.encodeBase64=c}),define(re[15],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function D(r){return typeof r=="string"}e.isString=D;function i(r){return Array.isArray(r)&&r.every(t=>D(t))}e.isStringArray=i;function R(r){return typeof r=="object"&&r!==null&&!Array.isArray(r)&&!(r instanceof RegExp)&&!(r instanceof Date)}e.isObject=R;function k(r){const t=Object.getPrototypeOf(Uint8Array);return typeof r=="object"&&r instanceof t}e.isTypedArray=k;function L(r){return typeof r=="number"&&!isNaN(r)}e.isNumber=L;function P(r){return!!r&&typeof r[Symbol.iterator]=="function"}e.isIterable=P;function I(r){return r===!0||r===!1}e.isBoolean=I;function S(r){return typeof r>"u"}e.isUndefined=S;function b(r){return!C(r)}e.isDefined=b;function C(r){return S(r)||r===null}e.isUndefinedOrNull=C;function w(r,t){if(!r)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.assertType=w;function p(r){if(C(r))throw new Error("Assertion Failed: argument is undefined or null");return r}e.assertIsDefined=p;function d(...r){const t=[];for(let a=0;a<r.length;a++){const s=r[a];if(C(s))throw new Error(`Assertion Failed: argument at index ${a} is undefined or null`);t.push(s)}return t}e.assertAllDefined=d;const g=Object.prototype.hasOwnProperty;function v(r){if(!R(r))return!1;for(const t in r)if(g.call(r,t))return!1;return!0}e.isEmptyObject=v;function u(r){return typeof r=="function"}e.isFunction=u;function m(...r){return r.length>0&&r.every(u)}e.areFunctions=m;function l(r,t){const a=Math.min(r.length,t.length);for(let s=0;s<a;s++)h(r[s],t[s])}e.validateConstraints=l;function h(r,t){if(D(t)){if(typeof r!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(u(t)){try{if(r instanceof t)return}catch{}if(!C(r)&&r.constructor===t||t.length===1&&t.call(void 0,r)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=h;function f(r){return r===null?void 0:r}e.withNullAsUndefined=f;function n(r){return typeof r>"u"?null:r}e.withUndefinedAsNull=n}),define(re[32],ae([0,1,15]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function i(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const m=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([l,h])=>{m[l]=h&&typeof h=="object"?i(h):h}),m}e.deepClone=i;function R(u){if(!u||typeof u!="object")return u;const m=[u];for(;m.length>0;){const l=m.shift();Object.freeze(l);for(const h in l)if(k.call(l,h)){const f=l[h];typeof f=="object"&&!Object.isFrozen(f)&&!(0,D.isTypedArray)(f)&&m.push(f)}}return u}e.deepFreeze=R;const k=Object.prototype.hasOwnProperty;function L(u,m){return P(u,m,new Set)}e.cloneAndChange=L;function P(u,m,l){if((0,D.isUndefinedOrNull)(u))return u;const h=m(u);if(typeof h<"u")return h;if(Array.isArray(u)){const f=[];for(const n of u)f.push(P(n,m,l));return f}if((0,D.isObject)(u)){if(l.has(u))throw new Error("Cannot clone recursive data-structure");l.add(u);const f={};for(const n in u)k.call(u,n)&&(f[n]=P(u[n],m,l));return l.delete(u),f}return u}function I(u,m,l=!0){return(0,D.isObject)(u)?((0,D.isObject)(m)&&Object.keys(m).forEach(h=>{h in u?l&&((0,D.isObject)(u[h])&&(0,D.isObject)(m[h])?I(u[h],m[h],l):u[h]=m[h]):u[h]=m[h]}),u):m}e.mixin=I;function S(u,m){if(u===m)return!0;if(u==null||m===null||m===void 0||typeof u!=typeof m||typeof u!="object"||Array.isArray(u)!==Array.isArray(m))return!1;let l,h;if(Array.isArray(u)){if(u.length!==m.length)return!1;for(l=0;l<u.length;l++)if(!S(u[l],m[l]))return!1}else{const f=[];for(h in u)f.push(h);f.sort();const n=[];for(h in m)n.push(h);if(n.sort(),!S(f,n))return!1;for(l=0;l<f.length;l++)if(!S(u[f[l]],m[f[l]]))return!1}return!0}e.equals=S;function b(u){const m=new Set;return JSON.stringify(u,(l,h)=>{if((0,D.isObject)(h)||Array.isArray(h)){if(m.has(h))return"[Circular]";m.add(h)}return h})}e.safeStringify=b;function C(u,m){const l=Object.create(null);return!u||!m||Object.keys(m).forEach(f=>{const n=u[f],r=m[f];S(n,r)||(l[f]=r)}),l}e.distinct=C;function w(u,m){const l=m.toLowerCase(),h=Object.keys(u).find(f=>f.toLowerCase()===l);return h?u[h]:u[m]}e.getCaseInsensitive=w;function p(u,m){const l=Object.create(null);for(const[h,f]of Object.entries(u))m(h,f)&&(l[h]=f);return l}e.filter=p;function d(u){let m=[],l=Object.getPrototypeOf(u);for(;Object.prototype!==l;)m=m.concat(Object.getOwnPropertyNames(l)),l=Object.getPrototypeOf(l);return m}e.getAllPropertyNames=d;function g(u){const m=[];for(const l of d(u))typeof u[l]=="function"&&m.push(l);return m}e.getAllMethodNames=g;function v(u,m){const l=f=>function(){const n=Array.prototype.slice.call(arguments,0);return m(f,n)},h={};for(const f of u)h[f]=l(f);return h}e.createProxyObject=v}),define(re[31],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function i(R){return D.test(R)}e.isUUID=i,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(P){for(let I=0;I<P.length;I++)P[I]=Math.floor(Math.random()*256);return P};const k=new Uint8Array(16),L=[];for(let P=0;P<256;P++)L.push(P.toString(16).padStart(2,"0"));return function(){R(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let I=0,S="";return S+=L[k[I++]],S+=L[k[I++]],S+=L[k[I++]],S+=L[k[I++]],S+="-",S+=L[k[I++]],S+=L[k[I++]],S+="-",S+=L[k[I++]],S+=L[k[I++]],S+="-",S+=L[k[I++]],S+=L[k[I++]],S+="-",S+=L[k[I++]],S+=L[k[I++]],S+=L[k[I++]],S+=L[k[I++]],S+=L[k[I++]],S+=L[k[I++]],S}}()}),define(re[129],ae([0,1,34]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const i=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(L){const P=L.replace(/\-/g,":").toLowerCase();return!i.has(P)}function k(){const L=(0,D.networkInterfaces)();for(const P in L){const I=L[P];if(I){for(const{mac:S}of I)if(R(S))return S}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=k}),define(re[130],ae([0,1,86]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function i(P,I,S,b=1){let C=!1;return new Promise(w=>{const p=setTimeout(()=>{if(!C)return C=!0,w(0)},S);R(P,I,b,d=>{if(!C)return C=!0,clearTimeout(p),w(d)})})}e.findFreePort=i;function R(P,I,S,b){if(I===0)return b(0);const C=new D.Socket;C.once("connect",()=>(L(C),R(P+S,I-1,S,b))),C.once("data",()=>{}),C.once("error",w=>(L(C),w.code!=="ECONNREFUSED"?R(P+S,I-1,S,b):b(P))),C.connect(P,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function k(P,I,S,b="127.0.0.1"){let C=!1,w,p=1;const d=D.createServer({pauseOnConnect:!0});function g(v,u){C||(C=!0,d.removeAllListeners(),d.close(),w&&clearTimeout(w),u(v))}return new Promise(v=>{w=setTimeout(()=>{g(0,v)},S),d.on("listening",()=>{g(P,v)}),d.on("error",u=>{u&&(u.code==="EADDRINUSE"||u.code==="EACCES")&&p<I?(P++,p++,d.listen(P,b)):g(0,v)}),d.on("close",()=>{g(0,v)}),d.listen(P,b)})}e.findFreePortFaster=k;function L(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(I){console.error(I)}}}),define(re[131],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OfflineError=e.isOfflineError=void 0;const D="Offline";function i(k){return k instanceof R?!0:k instanceof Error&&k.name===D&&k.message===D}e.isOfflineError=i;class R extends Error{constructor(){super(D),this.name=this.message}}e.OfflineError=R}),define(re[132],ae([0,1,17,9,131]),function(_,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function k(I,S){if(!navigator.onLine)throw new R.OfflineError;I.proxyAuthorization&&(I.headers={...I.headers||{},"Proxy-Authorization":I.proxyAuthorization});const b=new XMLHttpRequest;return new Promise((C,w)=>{b.open(I.type||"GET",I.url||"",!0,I.user,I.password),L(b,I),b.responseType="arraybuffer",b.onerror=p=>w(new Error(b.statusText&&"XHR failed: "+b.statusText||"XHR failed")),b.onload=p=>{C({res:{statusCode:b.status,headers:P(b)},stream:(0,D.bufferToStream)(D.VSBuffer.wrap(new Uint8Array(b.response)))})},b.ontimeout=p=>w(new Error(`XHR timeout: ${I.timeout}ms`)),I.timeout&&(b.timeout=I.timeout),b.send(I.data),S.onCancellationRequested(()=>{b.abort(),w((0,i.canceled)())})})}e.request=k;function L(I,S){if(S.headers){e:for(const b in S.headers){switch(b){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}I.setRequestHeader(b,S.headers[b])}}}function P(I){const S=Object.create(null);for(const b of I.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(b){const C=b.indexOf(":");S[b.substr(0,C).trim().toLowerCase()]=b.substr(C+1).trim()}return S}}),define(re[133],ae([10,11]),function(_,e){return _.create("vs/base/common/date",e)}),define(re[65],ae([0,1,133]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const i=60,R=i*60,k=R*24,L=k*7,P=k*30,I=k*365;function S(C,w,p){typeof C!="number"&&(C=C.getTime());const d=Math.round((new Date().getTime()-C)/1e3);if(d<-30)return(0,D.localize)(0,null,S(new Date().getTime()+d*1e3,!1));if(d<30)return(0,D.localize)(1,null);let g;return d<i?(g=d,w?g===1?p?(0,D.localize)(2,null,g):(0,D.localize)(3,null,g):p?(0,D.localize)(4,null,g):(0,D.localize)(5,null,g):g===1?p?(0,D.localize)(6,null,g):(0,D.localize)(7,null,g):p?(0,D.localize)(8,null,g):(0,D.localize)(9,null,g)):d<R?(g=Math.floor(d/i),w?g===1?p?(0,D.localize)(10,null,g):(0,D.localize)(11,null,g):p?(0,D.localize)(12,null,g):(0,D.localize)(13,null,g):g===1?p?(0,D.localize)(14,null,g):(0,D.localize)(15,null,g):p?(0,D.localize)(16,null,g):(0,D.localize)(17,null,g)):d<k?(g=Math.floor(d/R),w?g===1?p?(0,D.localize)(18,null,g):(0,D.localize)(19,null,g):p?(0,D.localize)(20,null,g):(0,D.localize)(21,null,g):g===1?p?(0,D.localize)(22,null,g):(0,D.localize)(23,null,g):p?(0,D.localize)(24,null,g):(0,D.localize)(25,null,g)):d<L?(g=Math.floor(d/k),w?g===1?(0,D.localize)(26,null,g):(0,D.localize)(27,null,g):g===1?(0,D.localize)(28,null,g):(0,D.localize)(29,null,g)):d<P?(g=Math.floor(d/L),w?g===1?p?(0,D.localize)(30,null,g):(0,D.localize)(31,null,g):p?(0,D.localize)(32,null,g):(0,D.localize)(33,null,g):g===1?p?(0,D.localize)(34,null,g):(0,D.localize)(35,null,g):p?(0,D.localize)(36,null,g):(0,D.localize)(37,null,g)):d<I?(g=Math.floor(d/P),w?g===1?p?(0,D.localize)(38,null,g):(0,D.localize)(39,null,g):p?(0,D.localize)(40,null,g):(0,D.localize)(41,null,g):g===1?p?(0,D.localize)(42,null,g):(0,D.localize)(43,null,g):p?(0,D.localize)(44,null,g):(0,D.localize)(45,null,g)):(g=Math.floor(d/I),w?g===1?p?(0,D.localize)(46,null,g):(0,D.localize)(47,null,g):p?(0,D.localize)(48,null,g):(0,D.localize)(49,null,g):g===1?p?(0,D.localize)(50,null,g):(0,D.localize)(51,null,g):p?(0,D.localize)(52,null,g):(0,D.localize)(53,null,g))}e.fromNow=S;function b(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=b}),define(re[134],ae([10,11]),function(_,e){return _.create("vs/base/common/errorMessage",e)}),define(re[38],ae([0,1,20,15,134]),function(_,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function k(C,w){return w&&(C.stack||C.stacktrace)?R.localize(0,null,P(C),L(C.stack)||L(C.stacktrace)):P(C)}function L(C){return Array.isArray(C)?C.join(`
`):C}function P(C){return typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?R.localize(1,null,C.message):C.message||R.localize(2,null)}function I(C=null,w=!1){if(!C)return R.localize(3,null);if(Array.isArray(C)){const p=D.coalesce(C),d=I(p[0],w);return p.length>1?R.localize(4,null,d,p.length):d}if(i.isString(C))return C;if(C.detail){const p=C.detail;if(p.error)return k(p.error,w);if(p.exception)return k(p.exception,w)}return C.stack?k(C,w):C.message?C.message:R.localize(5,null)}e.toErrorMessage=I;function S(C){const w=C;return w instanceof Error&&Array.isArray(w.actions)}e.isErrorWithActions=S;function b(C,w){let p;return typeof C=="string"?p=new Error(C):p=C,p.actions=w,p}e.createErrorWithActions=b}),define(re[135],ae([10,11]),function(_,e){return _.create("vs/base/common/jsonErrorMessages",e)}),define(re[136],ae([0,1,135]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function i(R){switch(R){case 1:return(0,D.localize)(0,null);case 2:return(0,D.localize)(1,null);case 3:return(0,D.localize)(2,null);case 4:return(0,D.localize)(3,null);case 5:return(0,D.localize)(4,null);case 6:return(0,D.localize)(5,null);case 7:return(0,D.localize)(6,null);case 8:return(0,D.localize)(7,null);case 9:return(0,D.localize)(8,null);default:return""}}e.getParseErrorMessage=i}),define(re[137],ae([10,11]),function(_,e){return _.create("vs/base/common/platform",e)}),define(re[5],ae([0,1,137]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let i=!1,R=!1,k=!1,L=!1,P=!1,I=!1,S=!1,b=!1,C=!1,w=!1,p,d=e.LANGUAGE_DEFAULT,g,v;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?u=e.globals.vscode.process:typeof process<"u"&&(u=process);const m=typeof u?.versions?.electron=="string",l=m&&u?.type==="renderer";if(typeof navigator=="object"&&!l)v=navigator.userAgent,i=v.indexOf("Windows")>=0,R=v.indexOf("Macintosh")>=0,b=(v.indexOf("Macintosh")>=0||v.indexOf("iPad")>=0||v.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=v.indexOf("Linux")>=0,w=v?.indexOf("Mobi")>=0,I=!0,p=D.getConfiguredDefaultLocale(D.localize(0,null))||e.LANGUAGE_DEFAULT,d=p;else if(typeof u=="object"){i=u.platform==="win32",R=u.platform==="darwin",k=u.platform==="linux",L=k&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,S=m,C=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,p=e.LANGUAGE_DEFAULT,d=e.LANGUAGE_DEFAULT;const o=u.env.VSCODE_NLS_CONFIG;if(o)try{const y=JSON.parse(o),E=y.availableLanguages["*"];p=y.locale,d=E||e.LANGUAGE_DEFAULT,g=y._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var h;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(h=e.Platform||(e.Platform={}));function f(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=f;let n=0;R?n=1:i?n=3:k&&(n=2),e.isWindows=i,e.isMacintosh=R,e.isLinux=k,e.isLinuxSnap=L,e.isNative=P,e.isElectron=S,e.isWeb=I,e.isWebWorker=I&&typeof e.globals.importScripts=="function",e.isIOS=b,e.isMobile=w,e.isCI=C,e.platform=n,e.userAgent=v,e.language=d;var r;(function(o){function y(){return e.language}o.value=y;function E(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=E;function T(){return e.language==="en"}o.isDefault=T})(r=e.Language||(e.Language={})),e.locale=p,e.translationsConfigFile=g,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const o=[];e.globals.addEventListener("message",E=>{if(E.data&&E.data.vscodeScheduleAsyncWork)for(let T=0,q=o.length;T<q;T++){const N=o[T];if(N.id===E.data.vscodeScheduleAsyncWork){o.splice(T,1),N.callback();return}}});let y=0;return E=>{const T=++y;o.push({id:T,callback:E}),e.globals.postMessage({vscodeScheduleAsyncWork:T},"*")}}return o=>setTimeout(o)})();var t;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(t=e.OperatingSystem||(e.OperatingSystem={})),e.OS=R||b?2:i?1:3;let a=!0,s=!1;function c(){if(!s){s=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,a=new Uint16Array(o.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=c,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(re[36],ae([0,1,5]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let i;if(typeof D.globals.vscode<"u"&&typeof D.globals.vscode.process<"u"){const R=D.globals.vscode.process;i={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"?i={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:i={get platform(){return D.isWindows?"win32":D.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=i.cwd,e.env=i.env,e.platform=i.platform,e.arch=i.arch}),define(re[12],ae([0,1,36]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const i=65,R=97,k=90,L=122,P=46,I=47,S=92,b=58,C=63;class w extends Error{constructor(h,f,n){let r;typeof f=="string"&&f.indexOf("not ")===0?(r="must not be",f=f.replace(/^not /,"")):r="must be";const t=h.indexOf(".")!==-1?"property":"argument";let a=`The "${h}" ${t} ${r} of type ${f}`;a+=`. Received type ${typeof n}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function p(l,h){if(typeof l!="string")throw new w(h,"string",l)}function d(l){return l===I||l===S}function g(l){return l===I}function v(l){return l>=i&&l<=k||l>=R&&l<=L}function u(l,h,f,n){let r="",t=0,a=-1,s=0,c=0;for(let o=0;o<=l.length;++o){if(o<l.length)c=l.charCodeAt(o);else{if(n(c))break;c=I}if(n(c)){if(!(a===o-1||s===1))if(s===2){if(r.length<2||t!==2||r.charCodeAt(r.length-1)!==P||r.charCodeAt(r.length-2)!==P){if(r.length>2){const y=r.lastIndexOf(f);y===-1?(r="",t=0):(r=r.slice(0,y),t=r.length-1-r.lastIndexOf(f)),a=o,s=0;continue}else if(r.length!==0){r="",t=0,a=o,s=0;continue}}h&&(r+=r.length>0?`${f}..`:"..",t=2)}else r.length>0?r+=`${f}${l.slice(a+1,o)}`:r=l.slice(a+1,o),t=o-a-1;a=o,s=0}else c===P&&s!==-1?++s:s=-1}return r}function m(l,h){if(h===null||typeof h!="object")throw new w("pathObject","Object",h);const f=h.dir||h.root,n=h.base||`${h.name||""}${h.ext||""}`;return f?f===h.root?`${f}${n}`:`${f}${l}${n}`:n}e.win32={resolve(...l){let h="",f="",n=!1;for(let r=l.length-1;r>=-1;r--){let t;if(r>=0){if(t=l[r],p(t,"path"),t.length===0)continue}else h.length===0?t=D.cwd():(t=D.env[`=${h}`]||D.cwd(),(t===void 0||t.slice(0,2).toLowerCase()!==h.toLowerCase()&&t.charCodeAt(2)===S)&&(t=`${h}\\`));const a=t.length;let s=0,c="",o=!1;const y=t.charCodeAt(0);if(a===1)d(y)&&(s=1,o=!0);else if(d(y))if(o=!0,d(t.charCodeAt(1))){let E=2,T=E;for(;E<a&&!d(t.charCodeAt(E));)E++;if(E<a&&E!==T){const q=t.slice(T,E);for(T=E;E<a&&d(t.charCodeAt(E));)E++;if(E<a&&E!==T){for(T=E;E<a&&!d(t.charCodeAt(E));)E++;(E===a||E!==T)&&(c=`\\\\${q}\\${t.slice(T,E)}`,s=E)}}}else s=1;else v(y)&&t.charCodeAt(1)===b&&(c=t.slice(0,2),s=2,a>2&&d(t.charCodeAt(2))&&(o=!0,s=3));if(c.length>0)if(h.length>0){if(c.toLowerCase()!==h.toLowerCase())continue}else h=c;if(n){if(h.length>0)break}else if(f=`${t.slice(s)}\\${f}`,n=o,o&&h.length>0)break}return f=u(f,!n,"\\",d),n?`${h}\\${f}`:`${h}${f}`||"."},normalize(l){p(l,"path");const h=l.length;if(h===0)return".";let f=0,n,r=!1;const t=l.charCodeAt(0);if(h===1)return g(t)?"\\":l;if(d(t))if(r=!0,d(l.charCodeAt(1))){let s=2,c=s;for(;s<h&&!d(l.charCodeAt(s));)s++;if(s<h&&s!==c){const o=l.slice(c,s);for(c=s;s<h&&d(l.charCodeAt(s));)s++;if(s<h&&s!==c){for(c=s;s<h&&!d(l.charCodeAt(s));)s++;if(s===h)return`\\\\${o}\\${l.slice(c)}\\`;s!==c&&(n=`\\\\${o}\\${l.slice(c,s)}`,f=s)}}}else f=1;else v(t)&&l.charCodeAt(1)===b&&(n=l.slice(0,2),f=2,h>2&&d(l.charCodeAt(2))&&(r=!0,f=3));let a=f<h?u(l.slice(f),!r,"\\",d):"";return a.length===0&&!r&&(a="."),a.length>0&&d(l.charCodeAt(h-1))&&(a+="\\"),n===void 0?r?`\\${a}`:a:r?`${n}\\${a}`:`${n}${a}`},isAbsolute(l){p(l,"path");const h=l.length;if(h===0)return!1;const f=l.charCodeAt(0);return d(f)||h>2&&v(f)&&l.charCodeAt(1)===b&&d(l.charCodeAt(2))},join(...l){if(l.length===0)return".";let h,f;for(let t=0;t<l.length;++t){const a=l[t];p(a,"path"),a.length>0&&(h===void 0?h=f=a:h+=`\\${a}`)}if(h===void 0)return".";let n=!0,r=0;if(typeof f=="string"&&d(f.charCodeAt(0))){++r;const t=f.length;t>1&&d(f.charCodeAt(1))&&(++r,t>2&&(d(f.charCodeAt(2))?++r:n=!1))}if(n){for(;r<h.length&&d(h.charCodeAt(r));)r++;r>=2&&(h=`\\${h.slice(r)}`)}return e.win32.normalize(h)},relative(l,h){if(p(l,"from"),p(h,"to"),l===h)return"";const f=e.win32.resolve(l),n=e.win32.resolve(h);if(f===n||(l=f.toLowerCase(),h=n.toLowerCase(),l===h))return"";let r=0;for(;r<l.length&&l.charCodeAt(r)===S;)r++;let t=l.length;for(;t-1>r&&l.charCodeAt(t-1)===S;)t--;const a=t-r;let s=0;for(;s<h.length&&h.charCodeAt(s)===S;)s++;let c=h.length;for(;c-1>s&&h.charCodeAt(c-1)===S;)c--;const o=c-s,y=a<o?a:o;let E=-1,T=0;for(;T<y;T++){const N=l.charCodeAt(r+T);if(N!==h.charCodeAt(s+T))break;N===S&&(E=T)}if(T!==y){if(E===-1)return n}else{if(o>y){if(h.charCodeAt(s+T)===S)return n.slice(s+T+1);if(T===2)return n.slice(s+T)}a>y&&(l.charCodeAt(r+T)===S?E=T:T===2&&(E=3)),E===-1&&(E=0)}let q="";for(T=r+E+1;T<=t;++T)(T===t||l.charCodeAt(T)===S)&&(q+=q.length===0?"..":"\\..");return s+=E,q.length>0?`${q}${n.slice(s,c)}`:(n.charCodeAt(s)===S&&++s,n.slice(s,c))},toNamespacedPath(l){if(typeof l!="string")return l;if(l.length===0)return"";const h=e.win32.resolve(l);if(h.length<=2)return l;if(h.charCodeAt(0)===S){if(h.charCodeAt(1)===S){const f=h.charCodeAt(2);if(f!==C&&f!==P)return`\\\\?\\UNC\\${h.slice(2)}`}}else if(v(h.charCodeAt(0))&&h.charCodeAt(1)===b&&h.charCodeAt(2)===S)return`\\\\?\\${h}`;return l},dirname(l){p(l,"path");const h=l.length;if(h===0)return".";let f=-1,n=0;const r=l.charCodeAt(0);if(h===1)return d(r)?l:".";if(d(r)){if(f=n=1,d(l.charCodeAt(1))){let s=2,c=s;for(;s<h&&!d(l.charCodeAt(s));)s++;if(s<h&&s!==c){for(c=s;s<h&&d(l.charCodeAt(s));)s++;if(s<h&&s!==c){for(c=s;s<h&&!d(l.charCodeAt(s));)s++;if(s===h)return l;s!==c&&(f=n=s+1)}}}}else v(r)&&l.charCodeAt(1)===b&&(f=h>2&&d(l.charCodeAt(2))?3:2,n=f);let t=-1,a=!0;for(let s=h-1;s>=n;--s)if(d(l.charCodeAt(s))){if(!a){t=s;break}}else a=!1;if(t===-1){if(f===-1)return".";t=f}return l.slice(0,t)},basename(l,h){h!==void 0&&p(h,"ext"),p(l,"path");let f=0,n=-1,r=!0,t;if(l.length>=2&&v(l.charCodeAt(0))&&l.charCodeAt(1)===b&&(f=2),h!==void 0&&h.length>0&&h.length<=l.length){if(h===l)return"";let a=h.length-1,s=-1;for(t=l.length-1;t>=f;--t){const c=l.charCodeAt(t);if(d(c)){if(!r){f=t+1;break}}else s===-1&&(r=!1,s=t+1),a>=0&&(c===h.charCodeAt(a)?--a===-1&&(n=t):(a=-1,n=s))}return f===n?n=s:n===-1&&(n=l.length),l.slice(f,n)}for(t=l.length-1;t>=f;--t)if(d(l.charCodeAt(t))){if(!r){f=t+1;break}}else n===-1&&(r=!1,n=t+1);return n===-1?"":l.slice(f,n)},extname(l){p(l,"path");let h=0,f=-1,n=0,r=-1,t=!0,a=0;l.length>=2&&l.charCodeAt(1)===b&&v(l.charCodeAt(0))&&(h=n=2);for(let s=l.length-1;s>=h;--s){const c=l.charCodeAt(s);if(d(c)){if(!t){n=s+1;break}continue}r===-1&&(t=!1,r=s+1),c===P?f===-1?f=s:a!==1&&(a=1):f!==-1&&(a=-1)}return f===-1||r===-1||a===0||a===1&&f===r-1&&f===n+1?"":l.slice(f,r)},format:m.bind(null,"\\"),parse(l){p(l,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return h;const f=l.length;let n=0,r=l.charCodeAt(0);if(f===1)return d(r)?(h.root=h.dir=l,h):(h.base=h.name=l,h);if(d(r)){if(n=1,d(l.charCodeAt(1))){let E=2,T=E;for(;E<f&&!d(l.charCodeAt(E));)E++;if(E<f&&E!==T){for(T=E;E<f&&d(l.charCodeAt(E));)E++;if(E<f&&E!==T){for(T=E;E<f&&!d(l.charCodeAt(E));)E++;E===f?n=E:E!==T&&(n=E+1)}}}}else if(v(r)&&l.charCodeAt(1)===b){if(f<=2)return h.root=h.dir=l,h;if(n=2,d(l.charCodeAt(2))){if(f===3)return h.root=h.dir=l,h;n=3}}n>0&&(h.root=l.slice(0,n));let t=-1,a=n,s=-1,c=!0,o=l.length-1,y=0;for(;o>=n;--o){if(r=l.charCodeAt(o),d(r)){if(!c){a=o+1;break}continue}s===-1&&(c=!1,s=o+1),r===P?t===-1?t=o:y!==1&&(y=1):t!==-1&&(y=-1)}return s!==-1&&(t===-1||y===0||y===1&&t===s-1&&t===a+1?h.base=h.name=l.slice(a,s):(h.name=l.slice(a,t),h.base=l.slice(a,s),h.ext=l.slice(t,s))),a>0&&a!==n?h.dir=l.slice(0,a-1):h.dir=h.root,h},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...l){let h="",f=!1;for(let n=l.length-1;n>=-1&&!f;n--){const r=n>=0?l[n]:D.cwd();p(r,"path"),r.length!==0&&(h=`${r}/${h}`,f=r.charCodeAt(0)===I)}return h=u(h,!f,"/",g),f?`/${h}`:h.length>0?h:"."},normalize(l){if(p(l,"path"),l.length===0)return".";const h=l.charCodeAt(0)===I,f=l.charCodeAt(l.length-1)===I;return l=u(l,!h,"/",g),l.length===0?h?"/":f?"./":".":(f&&(l+="/"),h?`/${l}`:l)},isAbsolute(l){return p(l,"path"),l.length>0&&l.charCodeAt(0)===I},join(...l){if(l.length===0)return".";let h;for(let f=0;f<l.length;++f){const n=l[f];p(n,"path"),n.length>0&&(h===void 0?h=n:h+=`/${n}`)}return h===void 0?".":e.posix.normalize(h)},relative(l,h){if(p(l,"from"),p(h,"to"),l===h||(l=e.posix.resolve(l),h=e.posix.resolve(h),l===h))return"";const f=1,n=l.length,r=n-f,t=1,a=h.length-t,s=r<a?r:a;let c=-1,o=0;for(;o<s;o++){const E=l.charCodeAt(f+o);if(E!==h.charCodeAt(t+o))break;E===I&&(c=o)}if(o===s)if(a>s){if(h.charCodeAt(t+o)===I)return h.slice(t+o+1);if(o===0)return h.slice(t+o)}else r>s&&(l.charCodeAt(f+o)===I?c=o:o===0&&(c=0));let y="";for(o=f+c+1;o<=n;++o)(o===n||l.charCodeAt(o)===I)&&(y+=y.length===0?"..":"/..");return`${y}${h.slice(t+c)}`},toNamespacedPath(l){return l},dirname(l){if(p(l,"path"),l.length===0)return".";const h=l.charCodeAt(0)===I;let f=-1,n=!0;for(let r=l.length-1;r>=1;--r)if(l.charCodeAt(r)===I){if(!n){f=r;break}}else n=!1;return f===-1?h?"/":".":h&&f===1?"//":l.slice(0,f)},basename(l,h){h!==void 0&&p(h,"ext"),p(l,"path");let f=0,n=-1,r=!0,t;if(h!==void 0&&h.length>0&&h.length<=l.length){if(h===l)return"";let a=h.length-1,s=-1;for(t=l.length-1;t>=0;--t){const c=l.charCodeAt(t);if(c===I){if(!r){f=t+1;break}}else s===-1&&(r=!1,s=t+1),a>=0&&(c===h.charCodeAt(a)?--a===-1&&(n=t):(a=-1,n=s))}return f===n?n=s:n===-1&&(n=l.length),l.slice(f,n)}for(t=l.length-1;t>=0;--t)if(l.charCodeAt(t)===I){if(!r){f=t+1;break}}else n===-1&&(r=!1,n=t+1);return n===-1?"":l.slice(f,n)},extname(l){p(l,"path");let h=-1,f=0,n=-1,r=!0,t=0;for(let a=l.length-1;a>=0;--a){const s=l.charCodeAt(a);if(s===I){if(!r){f=a+1;break}continue}n===-1&&(r=!1,n=a+1),s===P?h===-1?h=a:t!==1&&(t=1):h!==-1&&(t=-1)}return h===-1||n===-1||t===0||t===1&&h===n-1&&h===f+1?"":l.slice(h,n)},format:m.bind(null,"/"),parse(l){p(l,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return h;const f=l.charCodeAt(0)===I;let n;f?(h.root="/",n=1):n=0;let r=-1,t=0,a=-1,s=!0,c=l.length-1,o=0;for(;c>=n;--c){const y=l.charCodeAt(c);if(y===I){if(!s){t=c+1;break}continue}a===-1&&(s=!1,a=c+1),y===P?r===-1?r=c:o!==1&&(o=1):r!==-1&&(o=-1)}if(a!==-1){const y=t===0&&f?1:t;r===-1||o===0||o===1&&r===a-1&&r===t+1?h.base=h.name=l.slice(y,a):(h.name=l.slice(y,r),h.base=l.slice(y,a),h.ext=l.slice(r,a))}return t>0?h.dir=l.slice(0,t-1):f&&(h.dir="/"),h},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=D.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=D.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=D.platform==="win32"?e.win32.join:e.posix.join,e.resolve=D.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=D.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=D.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=D.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=D.platform==="win32"?e.win32.extname:e.posix.extname,e.format=D.platform==="win32"?e.win32.format:e.posix.format,e.parse=D.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=D.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=D.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=D.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(re[138],ae([0,1,12]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const i={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},R={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function k(b){const C=(0,D.extname)(b),w=i[C.toLowerCase()];return w!==void 0?w:L(b)}e.getMediaOrTextMime=k;function L(b){const C=(0,D.extname)(b);return R[C.toLowerCase()]}e.getMediaMime=L;function P(b){for(const C in R)if(R[C]===b)return C}e.getExtensionForMimeType=P;const I=/^(.+)\/(.+?)(;.+)?$/;function S(b,C){const w=I.exec(b);return w?`${w[1].toLowerCase()}/${w[2].toLowerCase()}${w[3]??""}`:C?void 0:b}e.normalizeMimeType=S}),define(re[87],ae([0,1,5]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var i;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(i=e.Source||(e.Source={}));var R;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(R=e.TerminateResponseCode||(e.TerminateResponseCode={}));function k(P,...I){const S=I.reduce((w,p)=>(w[p]=!0,w),{}),b=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(w=>!S[w]).forEach(w=>{for(let p=0;p<b.length;p++)if(w.search(b[p])!==-1){delete P[w];break}})}e.sanitizeProcessEnvironment=k;function L(P){!P||(delete P.DEBUG,D.isMacintosh&&delete P.DYLD_LIBRARY_PATH,D.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=L}),define(re[139],ae([0,1,5]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const i=D.globals.performance&&typeof D.globals.performance.now=="function";class R{static create(L=!0){return new R(L)}constructor(L){this.a=i&&L,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?D.globals.performance.now():Date.now()}}e.StopWatch=R}),define(re[3],ae([0,1,9,82,2,84,139]),function(_,e,D,i,R,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const P=!1,I=!1;var S;(function(c){c.None=()=>R.Disposable.None;function o(V){if(I){const{onDidAddListener:X}=V,se=d.create();let x=0;V.onDidAddListener=()=>{++x===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),se.print()),X?.()}}}function y(V,X){return B(V,()=>{},0,void 0,void 0,X)}c.defer=y;function E(V){return(X,se=null,x)=>{let ie=!1,ne;return ne=V(le=>{if(!ie)return ne?ne.dispose():ie=!0,X.call(se,le)},null,x),ie&&ne.dispose(),ne}}c.once=E;function T(V,X,se){return U((x,ie=null,ne)=>V(le=>x.call(ie,X(le)),null,ne),se)}c.map=T;function q(V,X,se){return U((x,ie=null,ne)=>V(le=>{X(le),x.call(ie,le)},null,ne),se)}c.forEach=q;function N(V,X,se){return U((x,ie=null,ne)=>V(le=>X(le)&&x.call(ie,le),null,ne),se)}c.filter=N;function j(V){return V}c.signal=j;function F(...V){return(X,se=null,x)=>(0,R.combinedDisposable)(...V.map(ie=>ie(ne=>X.call(se,ne),null,x)))}c.any=F;function A(V,X,se,x){let ie=se;return T(V,ne=>(ie=X(ie,ne),ie),x)}c.reduce=A;function U(V,X){let se;const x={onWillAddFirstListener(){se=V(ie.fire,ie)},onDidRemoveLastListener(){se?.dispose()}};X||o(x);const ie=new v(x);return X?.add(ie),ie.event}function B(V,X,se=100,x=!1,ie,ne){let le,ue,ye,Se=0;const be={leakWarningThreshold:ie,onWillAddFirstListener(){le=V(Ne=>{Se++,ue=X(ue,Ne),x&&!ye&&(Ee.fire(ue),ue=void 0),clearTimeout(ye),ye=setTimeout(()=>{const Fe=ue;ue=void 0,ye=void 0,(!x||Se>1)&&Ee.fire(Fe),Se=0},se)})},onDidRemoveLastListener(){le.dispose()}};ne||o(be);const Ee=new v(be);return ne?.add(Ee),Ee.event}c.debounce=B;function G(V,X=0,se){return c.debounce(V,(x,ie)=>x?(x.push(ie),x):[ie],X,void 0,void 0,se)}c.accumulate=G;function W(V,X=(x,ie)=>x===ie,se){let x=!0,ie;return N(V,ne=>{const le=x||!X(ne,ie);return x=!1,ie=ne,le},se)}c.latch=W;function Z(V,X,se){return[c.filter(V,X,se),c.filter(V,x=>!X(x),se)]}c.split=Z;function $(V,X=!1,se=[]){let x=se.slice(),ie=V(ue=>{x?x.push(ue):le.fire(ue)});const ne=()=>{x?.forEach(ue=>le.fire(ue)),x=null},le=new v({onWillAddFirstListener(){ie||(ie=V(ue=>le.fire(ue)))},onDidAddFirstListener(){x&&(X?setTimeout(ne):ne())},onDidRemoveLastListener(){ie&&ie.dispose(),ie=null}});return le.event}c.buffer=$;class z{constructor(X){this.event=X,this.c=new R.DisposableStore}map(X){return new z(T(this.event,X,this.c))}forEach(X){return new z(q(this.event,X,this.c))}filter(X){return new z(N(this.event,X,this.c))}reduce(X,se){return new z(A(this.event,X,se,this.c))}latch(){return new z(W(this.event,void 0,this.c))}debounce(X,se=100,x=!1,ie){return new z(B(this.event,X,se,x,ie,this.c))}on(X,se,x){return this.event(X,se,x)}once(X,se,x){return E(this.event)(X,se,x)}dispose(){this.c.dispose()}}function Y(V){return new z(V)}c.chain=Y;function ee(V,X,se=x=>x){const x=(...ue)=>le.fire(se(...ue)),ie=()=>V.on(X,x),ne=()=>V.removeListener(X,x),le=new v({onWillAddFirstListener:ie,onDidRemoveLastListener:ne});return le.event}c.fromNodeEventEmitter=ee;function oe(V,X,se=x=>x){const x=(...ue)=>le.fire(se(...ue)),ie=()=>V.addEventListener(X,x),ne=()=>V.removeEventListener(X,x),le=new v({onWillAddFirstListener:ie,onDidRemoveLastListener:ne});return le.event}c.fromDOMEventEmitter=oe;function J(V){return new Promise(X=>E(V)(X))}c.toPromise=J;function Q(V,X){return X(void 0),V(se=>X(se))}c.runAndSubscribe=Q;function O(V,X){let se=null;function x(ne){se?.dispose(),se=new R.DisposableStore,X(ne,se)}x(void 0);const ie=V(ne=>x(ne));return(0,R.toDisposable)(()=>{ie.dispose(),se?.dispose()})}c.runAndSubscribeWithStore=O;class M{constructor(X,se){this.obs=X,this.c=0,this.d=!1;const x={onWillAddFirstListener:()=>{X.addObserver(this)},onDidRemoveLastListener:()=>{X.removeObserver(this)}};se||o(x),this.emitter=new v(x),se&&se.add(this.emitter)}beginUpdate(X){this.c++}handleChange(X,se){this.d=!0}endUpdate(X){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function H(V,X){return new M(V,X).emitter.event}c.fromObservable=H})(S=e.Event||(e.Event={}));class b{constructor(o){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${o}_${b.c++}`,b.all.add(this)}start(o){this.d=new L.StopWatch(!0),this.listenerCount=o}stop(){if(this.d){const o=this.d.elapsed();this.durations.push(o),this.elapsedOverall+=o,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=b,b.all=new Set,b.c=0;let C=-1;function w(c){const o=C;return C=c,{dispose(){C=o}}}e.setGlobalLeakWarningThreshold=w;class p{constructor(o,y=Math.random().toString(18).slice(2,5)){this.threshold=o,this.name=y,this.d=0}dispose(){this.c?.clear()}check(o,y){const E=this.threshold;if(E<=0||y<E)return;this.c||(this.c=new Map);const T=this.c.get(o.value)||0;if(this.c.set(o.value,T+1),this.d-=1,this.d<=0){this.d=E*.5;let q,N=0;for(const[j,F]of this.c)(!q||N<F)&&(q=j,N=F);console.warn(`[${this.name}] potential listener LEAK detected, having ${y} listeners already. MOST frequent listener (${N}):`),console.warn(q)}return()=>{const q=this.c.get(o.value)||0;this.c.set(o.value,q-1)}}}class d{static create(){return new d(new Error().stack??"")}constructor(o){this.value=o}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class g{constructor(o,y,E){this.callback=o,this.callbackThis=y,this.stack=E,this.subscription=new R.SafeDisposable}invoke(o){this.callback.call(this.callbackThis,o)}}class v{constructor(o){this.j=!1,this.d=o,this.f=C>0||this.d?.leakWarningThreshold?new p(this.d?.leakWarningThreshold??C):void 0,this.g=this.d?._profName?new b(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(P){const o=Array.from(this.q);queueMicrotask(()=>{for(const y of o)y.subscription.isset()&&(y.subscription.unset(),y.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(o,y,E)=>{if(this.q||(this.q=new k.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),R.Disposable.None;const T=this.q.isEmpty();T&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let q,N;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(N=d.create(),q=this.f.check(N,this.q.size+1)),P&&(N=N??d.create());const j=new g(o,y,N),F=this.q.push(j);T&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,o,y);const A=j.subscription.set(()=>{q?.(),this.j||(F(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return E instanceof R.DisposableStore?E.add(A):Array.isArray(E)&&E.push(A),A}),this.l}fire(o){if(this.q){this.m||(this.m=new m);for(const y of this.q)this.m.push(this,y,o);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=v;class u{constructor(){this.c=new k.LinkedList}get size(){return this.c.size}push(o,y,E){this.c.push(new l(o,y,E))}clear(o){const y=new k.LinkedList;for(const E of this.c)E.emitter!==o&&y.push(E);this.c=y}deliver(){for(;this.c.size>0;){const o=this.c.shift();try{o.listener.invoke(o.event)}catch(y){(0,D.onUnexpectedError)(y)}}}}e.EventDeliveryQueue=u;class m extends u{clear(o){this.c.clear()}}class l{constructor(o,y,E){this.emitter=o,this.listener=y,this.event=E}}class h extends v{async fireAsync(o,y,E){if(!!this.q){this.c||(this.c=new k.LinkedList);for(const T of this.q)this.c.push([T,o]);for(;this.c.size>0&&!y.isCancellationRequested;){const[T,q]=this.c.shift(),N=[],j={...q,token:y,waitUntil:F=>{if(Object.isFrozen(N))throw new Error("waitUntil can NOT be called asynchronous");E&&(F=E(F,T.callback)),N.push(F)}};try{T.invoke(j)}catch(F){(0,D.onUnexpectedError)(F);continue}Object.freeze(N),await Promise.allSettled(N).then(F=>{for(const A of F)A.status==="rejected"&&(0,D.onUnexpectedError)(A.reason)})}}}}e.AsyncEmitter=h;class f extends v{constructor(o){super(o),this.h=0,this.s=new k.LinkedList,this.t=o?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const o=Array.from(this.s);this.s.clear(),super.fire(this.t(o))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(o){this.q&&(this.h!==0?this.s.push(o):super.fire(o))}}e.PauseableEmitter=f;class n extends f{constructor(o){super(o),this.c=o.delay??100}fire(o){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(o)}}e.DebounceEmitter=n;class r extends v{constructor(o){super(o),this.c=[],this.h=o?.merge}fire(o){!this.hasListeners()||(this.c.push(o),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(y=>super.fire(y)),this.c=[]}))}}e.MicrotaskEmitter=r;class t{constructor(){this.d=!1,this.f=[],this.c=new v({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(o){const y={event:o,listener:null};this.f.push(y),this.d&&this.j(y);const E=()=>{this.d&&this.k(y);const T=this.f.indexOf(y);this.f.splice(T,1)};return(0,R.toDisposable)((0,i.once)(E))}g(){this.d=!0,this.f.forEach(o=>this.j(o))}h(){this.d=!1,this.f.forEach(o=>this.k(o))}j(o){o.listener=o.event(y=>this.c.fire(y))}k(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=t;class a{constructor(){this.c=[]}wrapEvent(o){return(y,E,T)=>o(q=>{const N=this.c[this.c.length-1];N?N.push(()=>y.call(E,q)):y.call(E,q)},void 0,T)}bufferEvents(o){const y=[];this.c.push(y);const E=o();return this.c.pop(),y.forEach(T=>T()),E}}e.EventBufferer=a;class s{constructor(){this.c=!1,this.d=S.None,this.f=R.Disposable.None,this.g=new v({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(o){this.d=o,this.c&&(this.f.dispose(),this.f=o(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=s}),define(re[21],ae([0,1,3]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const i=Object.freeze(function(P,I){const S=setTimeout(P.bind(I),0);return{dispose(){clearTimeout(S)}}});var R;(function(P){function I(S){return S===P.None||S===P.Cancelled||S instanceof k?!0:!S||typeof S!="object"?!1:typeof S.isCancellationRequested=="boolean"&&typeof S.onCancellationRequested=="function"}P.isCancellationToken=I,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})})(R=e.CancellationToken||(e.CancellationToken={}));class k{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?i:(this.b||(this.b=new D.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class L{constructor(I){this.a=void 0,this.b=void 0,this.b=I&&I.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new k),this.a}cancel(){this.a?this.a instanceof k&&this.a.cancel():this.a=R.Cancelled}dispose(I=!1){I&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof k&&this.a.dispose():this.a=R.None}}e.CancellationTokenSource=L}),define(re[140],ae([0,1,21]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class i{constructor(P){this.b=P,this.a=null}get(){if(this.a)return this.a;const P=new D.CancellationTokenSource,I=this.b(P.token);return this.a={promise:I,dispose:()=>{this.a=null,P.cancel(),P.dispose()}},this.a}}e.Cache=i;class R{constructor(P){this.c=P,this.a=void 0,this.b=void 0}get(P){const I=JSON.stringify(P);return this.b!==I&&(this.b=I,this.a=this.c(P)),this.a}}e.LRUCachedFunction=R;class k{get cachedValues(){return this.a}constructor(P){this.b=P,this.a=new Map}get(P){if(this.a.has(P))return this.a.get(P);const I=this.b(P);return this.a.set(P,I),I}}e.CachedFunction=k}),define(re[27],ae([0,1,140,127]),function(_,e,D,i){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function k(te){return!te||typeof te!="string"?!0:te.trim().length===0}e.isFalsyOrWhitespace=k;const L=/{(\d+)}/g;function P(te,...he){return he.length===0?te:te.replace(L,function(fe,me){const we=parseInt(me,10);return isNaN(we)||we<0||we>=he.length?fe:he[we]})}e.format=P;const I=/{([^}]+)}/g;function S(te,he){return te.replace(I,(fe,me)=>he[me]??fe)}e.format2=S;function b(te){return te.replace(/[<>&]/g,function(he){switch(he){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return he}})}e.escape=b;function C(te){return te.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=C;function w(te,he){let fe=0;const me=he.charCodeAt(0);for(let we=te.length-1;we>=0;we--)te.charCodeAt(we)===me&&fe++;return fe}e.count=w;function p(te,he,fe="\u2026"){return te.length<=he?te:`${te.substr(0,he)}${fe}`}e.truncate=p;function d(te,he=" "){const fe=g(te,he);return v(fe,he)}e.trim=d;function g(te,he){if(!te||!he)return te;const fe=he.length;if(fe===0||te.length===0)return te;let me=0;for(;te.indexOf(he,me)===me;)me=me+fe;return te.substring(me)}e.ltrim=g;function v(te,he){if(!te||!he)return te;const fe=he.length,me=te.length;if(fe===0||me===0)return te;let we=me,Ie=-1;for(;Ie=te.lastIndexOf(he,we-1),!(Ie===-1||Ie+fe!==we);){if(Ie===0)return"";we=Ie}return te.substring(0,we)}e.rtrim=v;function u(te){return te.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function m(te){return te.replace(/\*/g,"")}e.stripWildcards=m;function l(te,he,fe={}){if(!te)throw new Error("Cannot create regex from empty string");he||(te=C(te)),fe.wholeWord&&(/\B/.test(te.charAt(0))||(te="\\b"+te),/\B/.test(te.charAt(te.length-1))||(te=te+"\\b"));let me="";return fe.global&&(me+="g"),fe.matchCase||(me+="i"),fe.multiline&&(me+="m"),fe.unicode&&(me+="u"),new RegExp(te,me)}e.createRegExp=l;function h(te){return te.source==="^"||te.source==="^$"||te.source==="$"||te.source==="^\\s*$"?!1:!!(te.exec("")&&te.lastIndex===0)}e.regExpLeadsToEndlessLoop=h;function f(te){return!!te.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=f;function n(te){return(te.global?"g":"")+(te.ignoreCase?"i":"")+(te.multiline?"m":"")+(te.unicode?"u":"")}e.regExpFlags=n;function r(te){return te.split(/\r\n|\r|\n/)}e.splitLines=r;function t(te){for(let he=0,fe=te.length;he<fe;he++){const me=te.charCodeAt(he);if(me!==32&&me!==9)return he}return-1}e.firstNonWhitespaceIndex=t;function a(te,he=0,fe=te.length){for(let me=he;me<fe;me++){const we=te.charCodeAt(me);if(we!==32&&we!==9)return te.substring(he,me)}return te.substring(he,fe)}e.getLeadingWhitespace=a;function s(te,he=te.length-1){for(let fe=he;fe>=0;fe--){const me=te.charCodeAt(fe);if(me!==32&&me!==9)return fe}return-1}e.lastNonWhitespaceIndex=s;function c(te,he,fe){const me=[];let we=0;for(const Ie of te.matchAll(he)){if(me.push(te.slice(we,Ie.index)),Ie.index===void 0)throw new Error("match.index should be defined");we=Ie.index+Ie[0].length,me.push(fe(Ie[0],...Ie.slice(1),Ie.index,te,Ie.groups))}return me.push(te.slice(we)),Promise.all(me).then(Ie=>Ie.join(""))}e.replaceAsync=c;function o(te,he){return te<he?-1:te>he?1:0}e.compare=o;function y(te,he,fe=0,me=te.length,we=0,Ie=he.length){for(;fe<me&&we<Ie;fe++,we++){const $e=te.charCodeAt(fe),Le=he.charCodeAt(we);if($e<Le)return-1;if($e>Le)return 1}const Re=me-fe,He=Ie-we;return Re<He?-1:Re>He?1:0}e.compareSubstring=y;function E(te,he){return T(te,he,0,te.length,0,he.length)}e.compareIgnoreCase=E;function T(te,he,fe=0,me=te.length,we=0,Ie=he.length){for(;fe<me&&we<Ie;fe++,we++){let $e=te.charCodeAt(fe),Le=he.charCodeAt(we);if($e===Le)continue;if($e>=128||Le>=128)return y(te.toLowerCase(),he.toLowerCase(),fe,me,we,Ie);N($e)&&($e-=32),N(Le)&&(Le-=32);const qe=$e-Le;if(qe!==0)return qe}const Re=me-fe,He=Ie-we;return Re<He?-1:Re>He?1:0}e.compareSubstringIgnoreCase=T;function q(te){return te>=48&&te<=57}e.isAsciiDigit=q;function N(te){return te>=97&&te<=122}e.isLowerAsciiLetter=N;function j(te){return te>=65&&te<=90}e.isUpperAsciiLetter=j;function F(te,he){return te.length===he.length&&T(te,he)===0}e.equalsIgnoreCase=F;function A(te,he){const fe=he.length;return he.length>te.length?!1:T(te,he,0,fe)===0}e.startsWithIgnoreCase=A;function U(te,he){const fe=Math.min(te.length,he.length);let me;for(me=0;me<fe;me++)if(te.charCodeAt(me)!==he.charCodeAt(me))return me;return fe}e.commonPrefixLength=U;function B(te,he){const fe=Math.min(te.length,he.length);let me;const we=te.length-1,Ie=he.length-1;for(me=0;me<fe;me++)if(te.charCodeAt(we-me)!==he.charCodeAt(Ie-me))return me;return fe}e.commonSuffixLength=B;function G(te){return 55296<=te&&te<=56319}e.isHighSurrogate=G;function W(te){return 56320<=te&&te<=57343}e.isLowSurrogate=W;function Z(te,he){return(te-55296<<10)+(he-56320)+65536}e.computeCodePoint=Z;function $(te,he,fe){const me=te.charCodeAt(fe);if(G(me)&&fe+1<he){const we=te.charCodeAt(fe+1);if(W(we))return Z(me,we)}return me}e.getNextCodePoint=$;function z(te,he){const fe=te.charCodeAt(he-1);if(W(fe)&&he>1){const me=te.charCodeAt(he-2);if(G(me))return Z(me,fe)}return fe}class Y{get offset(){return this.e}constructor(he,fe=0){this.c=he,this.d=he.length,this.e=fe}setOffset(he){this.e=he}prevCodePoint(){const he=z(this.c,this.e);return this.e-=he>=65536?2:1,he}nextCodePoint(){const he=$(this.c,this.d,this.e);return this.e+=he>=65536?2:1,he}eol(){return this.e>=this.d}}e.CodePointIterator=Y;class ee{get offset(){return this.c.offset}constructor(he,fe=0){this.c=new Y(he,fe)}nextGraphemeLength(){const he=Ae.getInstance(),fe=this.c,me=fe.offset;let we=he.getGraphemeBreakType(fe.nextCodePoint());for(;!fe.eol();){const Ie=fe.offset,Re=he.getGraphemeBreakType(fe.nextCodePoint());if(Ce(we,Re)){fe.setOffset(Ie);break}we=Re}return fe.offset-me}prevGraphemeLength(){const he=Ae.getInstance(),fe=this.c,me=fe.offset;let we=he.getGraphemeBreakType(fe.prevCodePoint());for(;fe.offset>0;){const Ie=fe.offset,Re=he.getGraphemeBreakType(fe.prevCodePoint());if(Ce(Re,we)){fe.setOffset(Ie);break}we=Re}return me-fe.offset}eol(){return this.c.eol()}}e.GraphemeIterator=ee;function oe(te,he){return new ee(te,he).nextGraphemeLength()}e.nextCharLength=oe;function J(te,he){return new ee(te,he).prevGraphemeLength()}e.prevCharLength=J;function Q(te,he){he>0&&W(te.charCodeAt(he))&&he--;const fe=he+oe(te,he);return[fe-J(te,fe),fe]}e.getCharContainingOffset=Q;function O(te){const he=new ee(te);let fe=0;for(;!he.eol();)fe++,he.nextGraphemeLength();return fe}e.charCount=O;let M;function H(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function V(te){return M||(M=H()),M.test(te)}e.containsRTL=V;const X=/^[\t\n\r\x20-\x7E]*$/;function se(te){return X.test(te)}e.isBasicASCII=se,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function x(te){return e.UNUSUAL_LINE_TERMINATORS.test(te)}e.containsUnusualLineTerminators=x;function ie(te){return te>=11904&&te<=55215||te>=63744&&te<=64255||te>=65281&&te<=65374}e.isFullWidthCharacter=ie;function ne(te){return te>=127462&&te<=127487||te===8986||te===8987||te===9200||te===9203||te>=9728&&te<=10175||te===11088||te===11093||te>=127744&&te<=128591||te>=128640&&te<=128764||te>=128992&&te<=129008||te>=129280&&te<=129535||te>=129648&&te<=129782}e.isEmojiImprecise=ne;function le(te,he){if(te.length<he)return te;const fe=/\b/g;let me=0;for(;fe.test(te)&&!(te.length-fe.lastIndex<he);)me=fe.lastIndex,fe.lastIndex+=1;return te.substring(me).replace(/^\s/,"")}e.lcut=le;const ue=/\x1B\x5B[12]?K/g,ye=/\x1b\[\d+m/g,Se=/\x1b\[0?m/g;function be(te){return te&&(te=te.replace(ue,""),te=te.replace(ye,""),te=te.replace(Se,"")),te}e.removeAnsiEscapeCodes=be,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ee(te){return!!(te&&te.length>0&&te.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ee;function Ne(te){return Ee(te)?te.substr(1):te}e.stripUTF8BOM=Ne;function Fe(te,he){if(!te||!he||te.length<he.length)return!1;const fe=he.length,me=te.toLowerCase();let we=0,Ie=-1;for(;we<fe;){const Re=me.indexOf(he[we],Ie+1);if(Re<0)return!1;Ie=Re,we++}return!0}e.fuzzyContains=Fe;function Ye(te,he=!1){return te?(he&&(te=te.replace(/\\./g,"")),te.toLowerCase()!==te):!1}e.containsUppercaseCharacter=Ye;function Be(te){return te.charAt(0).toUpperCase()+te.slice(1)}e.uppercaseFirstLetter=Be;function ce(te,he=1){if(he===0)return"";let fe=-1;do fe=te.indexOf(`
`,fe+1),he--;while(he>0&&fe>=0);return fe===-1?te:(te[fe-1]==="\r"&&fe--,te.substr(0,fe))}e.getNLines=ce;function de(te){return te=te%(2*26),te<26?String.fromCharCode(97+te):String.fromCharCode(65+te-26)}e.singleLetterHash=de;function ge(te){return Ae.getInstance().getGraphemeBreakType(te)}e.getGraphemeBreakType=ge;function Ce(te,he){return te===0?he!==5&&he!==7:te===2&&he===3?!1:te===4||te===2||te===3||he===4||he===2||he===3?!0:!(te===8&&(he===8||he===9||he===11||he===12)||(te===11||te===9)&&(he===9||he===10)||(te===12||te===10)&&he===10||he===5||he===13||he===7||te===1||te===13&&he===14||te===6&&he===6)}var Pe;(function(te){te[te.Other=0]="Other",te[te.Prepend=1]="Prepend",te[te.CR=2]="CR",te[te.LF=3]="LF",te[te.Control=4]="Control",te[te.Extend=5]="Extend",te[te.Regional_Indicator=6]="Regional_Indicator",te[te.SpacingMark=7]="SpacingMark",te[te.L=8]="L",te[te.V=9]="V",te[te.T=10]="T",te[te.LV=11]="LV",te[te.LVT=12]="LVT",te[te.ZWJ=13]="ZWJ",te[te.Extended_Pictographic=14]="Extended_Pictographic"})(Pe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ae{static getInstance(){return Ae.c||(Ae.c=new Ae),Ae.c}constructor(){this.d=De()}getGraphemeBreakType(he){if(he<32)return he===10?3:he===13?2:4;if(he<127)return 0;const fe=this.d,me=fe.length/3;let we=1;for(;we<=me;)if(he<fe[3*we])we=2*we;else if(he>fe[3*we+1])we=2*we+1;else return fe[3*we+2];return 0}}Ae.c=null;function De(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function je(te,he){if(te===0)return 0;const fe=Te(te,he);if(fe!==void 0)return fe;const me=new Y(he,te);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=je;function Te(te,he){const fe=new Y(he,te);let me=fe.prevCodePoint();for(;Me(me)||me===65039||me===8419;){if(fe.offset===0)return;me=fe.prevCodePoint()}if(!ne(me))return;let we=fe.offset;return we>0&&fe.prevCodePoint()===8205&&(we=fe.offset),we}function Me(te){return 127995<=te&&te<=127999}var ze;(function(te){te[te.zwj=8205]="zwj",te[te.emojiVariantSelector=65039]="emojiVariantSelector",te[te.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),e.noBreakWhitespace="\xA0";class ke{static getInstance(he){return ke.d.get(Array.from(he))}static getLocales(){return ke.e.getValue()}constructor(he){this.f=he}isAmbiguous(he){return this.f.has(he)}getPrimaryConfusable(he){return this.f.get(he)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=ke,R=ke,ke.c=new i.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ke.d=new D.LRUCachedFunction(te=>{function he(Le){const qe=new Map;for(let Ge=0;Ge<Le.length;Ge+=2)qe.set(Le[Ge],Le[Ge+1]);return qe}function fe(Le,qe){const Ge=new Map(Le);for(const[et,at]of qe)Ge.set(et,at);return Ge}function me(Le,qe){if(!Le)return qe;const Ge=new Map;for(const[et,at]of Le)qe.has(et)&&Ge.set(et,at);return Ge}const we=R.c.getValue();let Ie=te.filter(Le=>!Le.startsWith("_")&&Le in we);Ie.length===0&&(Ie=["_default"]);let Re;for(const Le of Ie){const qe=he(we[Le]);Re=me(Re,qe)}const He=he(we._common),$e=fe(He,Re);return new ke($e)}),ke.e=new i.Lazy(()=>Object.keys(ke.c.getValue()).filter(te=>!te.startsWith("_")));class Oe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Oe.c())),this.d}static isInvisibleCharacter(he){return Oe.e().has(he)}static get codePoints(){return Oe.e()}}e.InvisibleCharacters=Oe,Oe.d=void 0}),define(re[48],ae([0,1,12,5,27,15]),function(_,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function L(s){return s===47||s===92}e.isPathSeparator=L;function P(s){return s.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=P;function I(s){return s.indexOf("/")===-1&&(s=P(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=I;function S(s,c=D.posix.sep){if(!s)return"";const o=s.length,y=s.charCodeAt(0);if(L(y)){if(L(s.charCodeAt(1))&&!L(s.charCodeAt(2))){let T=3;const q=T;for(;T<o&&!L(s.charCodeAt(T));T++);if(q!==T&&!L(s.charCodeAt(T+1))){for(T+=1;T<o;T++)if(L(s.charCodeAt(T)))return s.slice(0,T+1).replace(/[\\/]/g,c)}}return c}else if(u(y)&&s.charCodeAt(1)===58)return L(s.charCodeAt(2))?s.slice(0,2)+c:s.slice(0,2);let E=s.indexOf("://");if(E!==-1){for(E+=3;E<o;E++)if(L(s.charCodeAt(E)))return s.slice(0,E+1)}return""}e.getRoot=S;function b(s){if(!i.isWindows||!s||s.length<5)return!1;let c=s.charCodeAt(0);if(c!==92||(c=s.charCodeAt(1),c!==92))return!1;let o=2;const y=o;for(;o<s.length&&(c=s.charCodeAt(o),c!==92);o++);return!(y===o||(c=s.charCodeAt(o+1),isNaN(c)||c===92))}e.isUNC=b;const C=/[\\/:\*\?"<>\|]/g,w=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(s,c=i.isWindows){const o=c?C:w;return!(!s||s.length===0||/^\s+$/.test(s)||(o.lastIndex=0,o.test(s))||c&&p.test(s)||s==="."||s===".."||c&&s[s.length-1]==="."||c&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=d;function g(s,c,o){const y=s===c;return!o||y?y:!s||!c?!1:(0,R.equalsIgnoreCase)(s,c)}e.isEqual=g;function v(s,c,o,y=D.sep){if(s===c)return!0;if(!s||!c||c.length>s.length)return!1;if(o){if(!(0,R.startsWithIgnoreCase)(s,c))return!1;if(c.length===s.length)return!0;let T=c.length;return c.charAt(c.length-1)===y&&T--,s.charAt(T)===y}return c.charAt(c.length-1)!==y&&(c+=y),s.indexOf(c)===0}e.isEqualOrParent=v;function u(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=u;function m(s,c){return i.isWindows&&s.endsWith(":")&&(s+=D.sep),(0,D.isAbsolute)(s)||(s=(0,D.join)(c,s)),s=(0,D.normalize)(s),i.isWindows?(s=(0,R.rtrim)(s,D.sep),s.endsWith(":")&&(s+=D.sep)):(s=(0,R.rtrim)(s,D.sep),s||(s=D.sep)),s}e.sanitizeFilePath=m;function l(s){const c=(0,D.normalize)(s);return i.isWindows?s.length>3?!1:h(c)&&(s.length===2||c.charCodeAt(2)===92):c===D.posix.sep}e.isRootOrDriveLetter=l;function h(s,c=i.isWindows){return c?u(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=h;function f(s){return h(s)?s[0]:void 0}e.getDriveLetter=f;function n(s,c,o){return c.length>s.length?-1:s===c?0:(o&&(s=s.toLowerCase(),c=c.toLowerCase()),s.indexOf(c))}e.indexOfPath=n;function r(s){const c=s.split(":");let o,y,E;for(const T of c){const q=Number(T);(0,k.isNumber)(q)?y===void 0?y=q:E===void 0&&(E=q):o=o?[o,T].join(":"):T}if(!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:y!==void 0?y:void 0,column:E!==void 0?E:y!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function a(s,c,o=8){let y="";for(let T=0;T<o;T++)y+=t.charAt(Math.floor(Math.random()*t.length));let E;return c?E=`${c}-${y}`:E=y,s?(0,D.join)(s,E):E}e.randomPath=a}),define(re[66],ae([0,1,27]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function i(u){return R(u,0)}e.hash=i;function R(u,m){switch(typeof u){case"object":return u===null?k(349,m):Array.isArray(u)?I(u,m):S(u,m);case"string":return P(u,m);case"boolean":return L(u,m);case"number":return k(u,m);case"undefined":return k(937,m);default:return k(617,m)}}e.doHash=R;function k(u,m){return(m<<5)-m+u|0}e.numberHash=k;function L(u,m){return k(u?433:863,m)}function P(u,m){m=k(149417,m);for(let l=0,h=u.length;l<h;l++)m=k(u.charCodeAt(l),m);return m}e.stringHash=P;function I(u,m){return m=k(104579,m),u.reduce((l,h)=>R(h,l),m)}function S(u,m){return m=k(181387,m),Object.keys(u).sort().reduce((l,h)=>(l=P(h,l),R(u[h],l)),m)}class b{constructor(){this.g=0}get value(){return this.g}hash(m){return this.g=R(m,this.g),this.g}}e.Hasher=b;var C;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function w(u,m,l=32){const h=l-m,f=~((1<<h)-1);return(u<<m|(f&u)>>>h)>>>0}function p(u,m=0,l=u.byteLength,h=0){for(let f=0;f<l;f++)u[m+f]=h}function d(u,m,l="0"){for(;u.length<m;)u=l+u;return u}function g(u,m=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(l=>l.toString(16).padStart(2,"0")).join(""):d((u>>>0).toString(16),m/4)}e.toHexString=g;class v{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(m){const l=m.length;if(l===0)return;const h=this.p;let f=this.r,n=this.u,r,t;for(n!==0?(r=n,t=-1,n=0):(r=m.charCodeAt(0),t=0);;){let a=r;if(D.isHighSurrogate(r))if(t+1<l){const s=m.charCodeAt(t+1);D.isLowSurrogate(s)?(t++,a=D.computeCodePoint(r,s)):a=65533}else{n=r;break}else D.isLowSurrogate(r)&&(a=65533);if(f=this.w(h,f,a),t++,t<l)r=m.charCodeAt(t);else break}this.r=f,this.u=n}w(m,l,h){return h<128?m[l++]=h:h<2048?(m[l++]=192|(h&1984)>>>6,m[l++]=128|(h&63)>>>0):h<65536?(m[l++]=224|(h&61440)>>>12,m[l++]=128|(h&4032)>>>6,m[l++]=128|(h&63)>>>0):(m[l++]=240|(h&1835008)>>>18,m[l++]=128|(h&258048)>>>12,m[l++]=128|(h&4032)>>>6,m[l++]=128|(h&63)>>>0),l>=64&&(this.y(),l-=64,this.t+=64,m[0]=m[64+0],m[1]=m[64+1],m[2]=m[64+2]),l}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),g(this.h)+g(this.l)+g(this.m)+g(this.n)+g(this.o)}x(){this.p[this.r++]=128,p(this.p,this.r),this.r>56&&(this.y(),p(this.p));const m=8*this.t;this.q.setUint32(56,Math.floor(m/4294967296),!1),this.q.setUint32(60,m%4294967296,!1),this.y()}y(){const m=v.g,l=this.q;for(let o=0;o<64;o+=4)m.setUint32(o,l.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)m.setUint32(o,w(m.getUint32(o-12,!1)^m.getUint32(o-32,!1)^m.getUint32(o-56,!1)^m.getUint32(o-64,!1),1),!1);let h=this.h,f=this.l,n=this.m,r=this.n,t=this.o,a,s,c;for(let o=0;o<80;o++)o<20?(a=f&n|~f&r,s=1518500249):o<40?(a=f^n^r,s=1859775393):o<60?(a=f&n|f&r|n&r,s=2400959708):(a=f^n^r,s=3395469782),c=w(h,5)+a+t+s+m.getUint32(o*4,!1)&4294967295,t=r,r=n,n=w(f,30),f=h,h=c;this.h=this.h+h&4294967295,this.l=this.l+f&4294967295,this.m=this.m+n&4294967295,this.n=this.n+r&4294967295,this.o=this.o+t&4294967295}}e.StringSHA1=v,v.g=new DataView(new ArrayBuffer(320))}),define(re[88],ae([0,1,27]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var i;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(i||(i={})),function(R){const k="error",L="warning",P="warn",I="info",S="ignore";function b(w){return w?D.equalsIgnoreCase(k,w)?R.Error:D.equalsIgnoreCase(L,w)||D.equalsIgnoreCase(P,w)?R.Warning:D.equalsIgnoreCase(I,w)?R.Info:R.Ignore:R.Ignore}R.fromValue=b;function C(w){switch(w){case R.Error:return k;case R.Warning:return L;case R.Info:return I;default:return S}}R.toString=C}(i||(i={})),e.default=i}),define(re[49],ae([0,1,20,27]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class R{constructor(){this.b="",this.c=0}reset(p){return this.b=p,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(p){const d=p.charCodeAt(0),g=this.b.charCodeAt(this.c);return d-g}value(){return this.b[this.c]}}e.StringIterator=R;class k{constructor(p=!0){this.e=p}reset(p){return this.b=p,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let p=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(p)this.c++;else break;else p=!1;return this}cmp(p){return this.e?(0,i.compareSubstring)(p,this.b,0,p.length,this.c,this.d):(0,i.compareSubstringIgnoreCase)(p,this.b,0,p.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=k;class L{constructor(p=!0,d=!0){this.f=p,this.g=d}reset(p){this.d=0,this.e=0,this.b=p,this.c=p.length;for(let d=p.length-1;d>=0;d--,this.c--){const g=this.b.charCodeAt(d);if(!(g===47||this.f&&g===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let p=!0;for(;this.e<this.c;this.e++){const d=this.b.charCodeAt(this.e);if(d===47||this.f&&d===92)if(p)this.d++;else break;else p=!1}return this}cmp(p){return this.g?(0,i.compareSubstring)(p,this.b,0,p.length,this.d,this.e):(0,i.compareSubstringIgnoreCase)(p,this.b,0,p.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=L;var P;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})(P||(P={}));class I{constructor(p,d){this.f=p,this.g=d,this.d=[],this.e=0}reset(p){return this.c=p,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new L(!1,!this.f(p)),this.b.reset(p.path),this.b.value()&&this.d.push(3)),this.g(p)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(p){if(this.d[this.e]===1)return(0,i.compareIgnoreCase)(p,this.c.scheme);if(this.d[this.e]===2)return(0,i.compareIgnoreCase)(p,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(p);if(this.d[this.e]===4)return(0,i.compare)(p,this.c.query);if(this.d[this.e]===5)return(0,i.compare)(p,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=I;class S{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const p=this.right;return this.right=p.left,p.left=this,this.updateHeight(),p.updateHeight(),p}rotateRight(){const p=this.left;return this.left=p.right,p.right=this,this.updateHeight(),p.updateHeight(),p}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var b;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(b||(b={}));class C{static forUris(p=()=>!1,d=()=>!1){return new C(new I(p,d))}static forPaths(p=!1){return new C(new L(void 0,!p))}static forStrings(){return new C(new R)}static forConfigKeys(){return new C(new k)}constructor(p){this.b=p}clear(){this.c=void 0}fill(p,d){if(d){const g=d.slice(0);(0,D.shuffle)(g);for(const v of g)this.set(v,p)}else{const g=p.slice(0);(0,D.shuffle)(g);for(const v of g)this.set(v[0],v[1])}}set(p,d){const g=this.b.reset(p);let v;this.c||(this.c=new S,this.c.segment=g.value());const u=[];for(v=this.c;;){const l=g.cmp(v.segment);if(l>0)v.left||(v.left=new S,v.left.segment=g.value()),u.push([-1,v]),v=v.left;else if(l<0)v.right||(v.right=new S,v.right.segment=g.value()),u.push([1,v]),v=v.right;else if(g.hasNext())g.next(),v.mid||(v.mid=new S,v.mid.segment=g.value()),u.push([0,v]),v=v.mid;else break}const m=v.value;v.value=d,v.key=p;for(let l=u.length-1;l>=0;l--){const h=u[l][1];h.updateHeight();const f=h.balanceFactor();if(f<-1||f>1){const n=u[l][0],r=u[l+1][0];if(n===1&&r===1)u[l][1]=h.rotateLeft();else if(n===-1&&r===-1)u[l][1]=h.rotateRight();else if(n===1&&r===-1)h.right=u[l+1][1]=u[l+1][1].rotateRight(),u[l][1]=h.rotateLeft();else if(n===-1&&r===1)h.left=u[l+1][1]=u[l+1][1].rotateLeft(),u[l][1]=h.rotateRight();else throw new Error;if(l>0)switch(u[l-1][0]){case-1:u[l-1][1].left=u[l][1];break;case 1:u[l-1][1].right=u[l][1];break;case 0:u[l-1][1].mid=u[l][1];break}else this.c=u[0][1]}}return m}get(p){return this.d(p)?.value}d(p){const d=this.b.reset(p);let g=this.c;for(;g;){const v=d.cmp(g.segment);if(v>0)g=g.left;else if(v<0)g=g.right;else if(d.hasNext())d.next(),g=g.mid;else break}return g}has(p){const d=this.d(p);return!(d?.value===void 0&&d?.mid===void 0)}delete(p){return this.e(p,!1)}deleteSuperstr(p){return this.e(p,!0)}e(p,d){const g=this.b.reset(p),v=[];let u=this.c;for(;u;){const m=g.cmp(u.segment);if(m>0)v.push([-1,u]),u=u.left;else if(m<0)v.push([1,u]),u=u.right;else if(g.hasNext())g.next(),v.push([0,u]),u=u.mid;else break}if(!!u){if(d?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const m=this.f(u.right);if(m.key){const{key:l,value:h,segment:f}=m;this.e(m.key,!1),u.key=l,u.value=h,u.segment=f}}else{const m=u.left??u.right;if(v.length>0){const[l,h]=v[v.length-1];switch(l){case-1:h.left=m;break;case 0:h.mid=m;break;case 1:h.right=m;break}}else this.c=m}for(let m=v.length-1;m>=0;m--){const l=v[m][1];l.updateHeight();const h=l.balanceFactor();if(h>1?(l.right.balanceFactor()>=0||(l.right=l.right.rotateRight()),v[m][1]=l.rotateLeft()):h<-1&&(l.left.balanceFactor()<=0||(l.left=l.left.rotateLeft()),v[m][1]=l.rotateRight()),m>0)switch(v[m-1][0]){case-1:v[m-1][1].left=v[m][1];break;case 1:v[m-1][1].right=v[m][1];break;case 0:v[m-1][1].mid=v[m][1];break}else this.c=v[0][1]}}}f(p){for(;p.left;)p=p.left;return p}findSubstr(p){const d=this.b.reset(p);let g=this.c,v;for(;g;){const u=d.cmp(g.segment);if(u>0)g=g.left;else if(u<0)g=g.right;else if(d.hasNext())d.next(),v=g.value||v,g=g.mid;else break}return g&&g.value||v}findSuperstr(p){const d=this.b.reset(p);let g=this.c;for(;g;){const v=d.cmp(g.segment);if(v>0)g=g.left;else if(v<0)g=g.right;else if(d.hasNext())d.next(),g=g.mid;else return g.mid?this.g(g.mid):void 0}}forEach(p){for(const[d,g]of this)p(g,d)}*[Symbol.iterator](){yield*this.g(this.c)}g(p){const d=[];return this.h(p,d),d[Symbol.iterator]()}h(p,d){!p||(p.left&&this.h(p.left,d),p.value&&d.push([p.key,p.value]),p.mid&&this.h(p.mid,d),p.right&&this.h(p.right,d))}_isBalanced(){const p=d=>{if(!d)return!0;const g=d.balanceFactor();return g<-1||g>1?!1:p(d.left)&&p(d.right)};return p(this.c)}}e.TernarySearchTree=C}),define(re[8],ae([0,1,12,5]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const R=/^\w[\w\d+.-]*$/,k=/^\//,L=/^\/\//;function P(t,a){if(!t.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!R.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!k.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(L.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function I(t,a){return!t&&!a?"file":t}function S(t,a){switch(t){case"https":case"http":case"file":a?a[0]!==C&&(a=C+a):a=C;break}return a}const b="",C="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{static isUri(a){return a instanceof p?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}constructor(a,s,c,o,y,E=!1){typeof a=="object"?(this.scheme=a.scheme||b,this.authority=a.authority||b,this.path=a.path||b,this.query=a.query||b,this.fragment=a.fragment||b):(this.scheme=I(a,E),this.authority=s||b,this.path=S(this.scheme,c||b),this.query=o||b,this.fragment=y||b,P(this,E))}get fsPath(){return l(this,!1)}with(a){if(!a)return this;let{scheme:s,authority:c,path:o,query:y,fragment:E}=a;return s===void 0?s=this.scheme:s===null&&(s=b),c===void 0?c=this.authority:c===null&&(c=b),o===void 0?o=this.path:o===null&&(o=b),y===void 0?y=this.query:y===null&&(y=b),E===void 0?E=this.fragment:E===null&&(E=b),s===this.scheme&&c===this.authority&&o===this.path&&y===this.query&&E===this.fragment?this:new g(s,c,o,y,E)}static parse(a,s=!1){const c=w.exec(a);return c?new g(c[2]||b,r(c[4]||b),r(c[5]||b),r(c[7]||b),r(c[9]||b),s):new g(b,b,b,b,b)}static file(a){let s=b;if(i.isWindows&&(a=a.replace(/\\/g,C)),a[0]===C&&a[1]===C){const c=a.indexOf(C,2);c===-1?(s=a.substring(2),a=C):(s=a.substring(2,c),a=a.substring(c)||C)}return new g("file",s,a,b,b)}static from(a){const s=new g(a.scheme,a.authority,a.path,a.query,a.fragment);return P(s,!0),s}static joinPath(a,...s){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return i.isWindows&&a.scheme==="file"?c=p.file(D.win32.join(l(a,!0),...s)).path:c=D.posix.join(a.path,...s),a.with({path:c})}toString(a=!1){return h(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof p)return a;{const s=new g(a);return s._formatted=a.external,s._fsPath=a._sep===d?a.fsPath:null,s}}else return a}}e.URI=p;const d=i.isWindows?1:void 0;class g extends p{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=l(this,!1)),this._fsPath}toString(a=!1){return a?h(this,!0):(this._formatted||(this._formatted=h(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=d),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const v={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(t,a){let s,c=-1;for(let o=0;o<t.length;o++){const y=t.charCodeAt(o);if(y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57||y===45||y===46||y===95||y===126||a&&y===47)c!==-1&&(s+=encodeURIComponent(t.substring(c,o)),c=-1),s!==void 0&&(s+=t.charAt(o));else{s===void 0&&(s=t.substr(0,o));const E=v[y];E!==void 0?(c!==-1&&(s+=encodeURIComponent(t.substring(c,o)),c=-1),s+=E):c===-1&&(c=o)}}return c!==-1&&(s+=encodeURIComponent(t.substring(c))),s!==void 0?s:t}function m(t){let a;for(let s=0;s<t.length;s++){const c=t.charCodeAt(s);c===35||c===63?(a===void 0&&(a=t.substr(0,s)),a+=v[c]):a!==void 0&&(a+=t[s])}return a!==void 0?a:t}function l(t,a){let s;return t.authority&&t.path.length>1&&t.scheme==="file"?s=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?a?s=t.path.substr(1):s=t.path[1].toLowerCase()+t.path.substr(2):s=t.path,i.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=l;function h(t,a){const s=a?m:u;let c="",{scheme:o,authority:y,path:E,query:T,fragment:q}=t;if(o&&(c+=o,c+=":"),(y||o==="file")&&(c+=C,c+=C),y){let N=y.indexOf("@");if(N!==-1){const j=y.substr(0,N);y=y.substr(N+1),N=j.indexOf(":"),N===-1?c+=s(j,!1):(c+=s(j.substr(0,N),!1),c+=":",c+=s(j.substr(N+1),!1)),c+="@"}y=y.toLowerCase(),N=y.indexOf(":"),N===-1?c+=s(y,!1):(c+=s(y.substr(0,N),!1),c+=y.substr(N))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const N=E.charCodeAt(1);N>=65&&N<=90&&(E=`/${String.fromCharCode(N+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const N=E.charCodeAt(0);N>=65&&N<=90&&(E=`${String.fromCharCode(N+32)}:${E.substr(2)}`)}c+=s(E,!0)}return T&&(c+="?",c+=s(T,!1)),q&&(c+="#",c+=a?q:u(q,!1)),c}function f(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+f(t.substr(3)):t}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(t){return t.match(n)?t.replace(n,a=>f(a)):t}}),define(re[141],ae([0,1,8]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function i(S){const b=S;return b&&typeof b.type=="string"&&typeof b.severity=="string"}e.isRemoteConsoleLog=i;function R(S){const b=[];let C;try{const w=JSON.parse(S.arguments),p=w[w.length-1];p&&p.__$stack&&(w.pop(),C=p.__$stack),b.push(...w)}catch{b.push("Unable to log remote console arguments",S.arguments)}return{args:b,stack:C}}e.parse=R;function k(S){if(typeof S!="string")return k(R(S).stack);const b=S;if(b){const C=L(b),w=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(w&&w.length===4)return{uri:D.URI.file(w[1]),line:Number(w[2]),column:Number(w[3])}}}e.getFirstFrame=k;function L(S){if(!S)return S;const b=S.indexOf(`
`);return b===-1?S:S.substring(0,b)}function P(S,b){const{args:C,stack:w}=R(S),p=typeof C[0]=="string"&&C.length===1;let d=L(w);d&&(d=`(${d.trim()})`);let g=[];if(typeof C[0]=="string"?d&&p?g=[`%c[${b}] %c${C[0]} %c${d}`,I("blue"),I(""),I("grey")]:g=[`%c[${b}] %c${C[0]}`,I("blue"),I(""),...C.slice(1)]:g=[`%c[${b}]%`,I("blue"),...C],d&&!p&&g.push(d),typeof console[S.severity]!="function")throw new Error("Unknown console method");console[S.severity].apply(console,g)}e.log=P;function I(S){return`color: ${S}`}}),define(re[67],ae([0,1,17,27,8]),function(_,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function k(S){return JSON.stringify(S,P)}e.stringify=k;function L(S){let b=JSON.parse(S);return b=I(b),b}e.parse=L;function P(S,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:(0,i.regExpFlags)(b)}:b}function I(S,b=0){if(!S||b>200)return S;if(typeof S=="object"){switch(S.$mid){case 1:return R.URI.revive(S);case 2:return new RegExp(S.source,S.flags);case 16:return new Date(S.source)}if(S instanceof D.VSBuffer||S instanceof Uint8Array)return S;if(Array.isArray(S))for(let C=0;C<S.length;++C)S[C]=I(S[C],b+1);else for(const C in S)Object.hasOwnProperty.call(S,C)&&(S[C]=I(S[C],b+1))}return S}e.revive=I}),define(re[25],ae([0,1,5,8]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var R;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.vscodeUserData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebook="vscode-notebook",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeNotebookCellOutput="vscode-notebook-cell-output",I.vscodeInteractive="vscode-interactive",I.vscodeInteractiveInput="vscode-interactive-input",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.vscodeTerminal="vscode-terminal",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file",I.tmp="tmp",I.vsls="vsls",I.vscodeSourceControl="vscode-scm"})(R=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class k{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(S){this.d=S}setDelegate(S){this.e=S}setServerRootPath(S){this.f=`${S}/${R.vscodeRemoteResource}`}set(S,b,C){this.a[S]=b,this.b[S]=C}setConnectionToken(S,b){this.c[S]=b}getPreferredWebSchema(){return this.d}rewrite(S){if(this.e)return this.e(S);const b=S.authority;let C=this.a[b];C&&C.indexOf(":")!==-1&&C.indexOf("[")===-1&&(C=`[${C}]`);const w=this.b[b],p=this.c[b];let d=`path=${encodeURIComponent(S.path)}`;return typeof p=="string"&&(d+=`&${e.connectionTokenQueryName}=${encodeURIComponent(p)}`),i.URI.from({scheme:D.isWeb?this.d:R.vscodeRemoteResource,authority:`${C}:${w}`,path:this.f,query:d})}}e.RemoteAuthorities=new k,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class L{asBrowserUri(S){const b=this.b(S,_);return this.uriToBrowserUri(b)}uriToBrowserUri(S){return S.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(S):S.scheme===R.file&&(D.isNative||D.isWebWorker&&D.globals.origin===`${R.vscodeFileResource}://${L.a}`)?S.with({scheme:R.vscodeFileResource,authority:S.authority||L.a,query:null,fragment:null}):S}asFileUri(S){const b=this.b(S,_);return this.uriToFileUri(b)}uriToFileUri(S){return S.scheme===R.vscodeFileResource?S.with({scheme:R.file,authority:S.authority!==L.a?S.authority:null,query:null,fragment:null}):S}b(S,b){return i.URI.isUri(S)?S:i.URI.parse(b.toUrl(S))}}L.a="vscode-app",e.FileAccess=new L;var P;(function(I){const S=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);I.CoopAndCoep=Object.freeze(S.get("3"));const b="vscode-coi";function C(p){let d;typeof p=="string"?d=new URL(p).searchParams:p instanceof URL?d=p.searchParams:i.URI.isUri(p)&&(d=new URL(p.toString(!0)).searchParams);const g=d?.get(b);if(!!g)return S.get(g)}I.getHeadersFromQuery=C;function w(p,d,g){if(!globalThis.crossOriginIsolated)return;const v=d&&g?"3":g?"2":"1";p instanceof URLSearchParams?p.set(b,v):p[b]=v}I.addSearchParam=w})(P=e.COI||(e.COI={}))}),define(re[22],ae([0,1,48,25,12,5,27,8]),function(_,e,D,i,R,k,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function I(p){return(0,P.uriToFsPath)(p,!0)}e.originalFSPath=I;class S{constructor(d){this.a=d}compare(d,g,v=!1){return d===g?0:(0,L.compare)(this.getComparisonKey(d,v),this.getComparisonKey(g,v))}isEqual(d,g,v=!1){return d===g?!0:!d||!g?!1:this.getComparisonKey(d,v)===this.getComparisonKey(g,v)}getComparisonKey(d,g=!1){return d.with({path:this.a(d)?d.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(d){return this.a(d)}isEqualOrParent(d,g,v=!1){if(d.scheme===g.scheme){if(d.scheme===i.Schemas.file)return D.isEqualOrParent(I(d),I(g),this.a(d))&&d.query===g.query&&(v||d.fragment===g.fragment);if((0,e.isEqualAuthority)(d.authority,g.authority))return D.isEqualOrParent(d.path,g.path,this.a(d),"/")&&d.query===g.query&&(v||d.fragment===g.fragment)}return!1}joinPath(d,...g){return P.URI.joinPath(d,...g)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return R.posix.basename(d.path)}extname(d){return R.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let g;return d.scheme===i.Schemas.file?g=P.URI.file(R.dirname(I(d))).path:(g=R.posix.dirname(d.path),d.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),g="/")),d.with({path:g})}normalizePath(d){if(!d.path.length)return d;let g;return d.scheme===i.Schemas.file?g=P.URI.file(R.normalize(I(d))).path:g=R.posix.normalize(d.path),d.with({path:g})}relativePath(d,g){if(d.scheme!==g.scheme||!(0,e.isEqualAuthority)(d.authority,g.authority))return;if(d.scheme===i.Schemas.file){const m=R.relative(I(d),I(g));return k.isWindows?D.toSlashes(m):m}let v=d.path||"/";const u=g.path||"/";if(this.a(d)){let m=0;for(const l=Math.min(v.length,u.length);m<l&&!(v.charCodeAt(m)!==u.charCodeAt(m)&&v.charAt(m).toLowerCase()!==u.charAt(m).toLowerCase());m++);v=u.substr(0,m)+v.substr(m)}return R.posix.relative(v,u)}resolvePath(d,g){if(d.scheme===i.Schemas.file){const v=P.URI.file(R.resolve(I(d),g));return d.with({authority:v.authority,path:v.path})}return g=D.toPosixPath(g),d.with({path:R.posix.resolve(d.path,g)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,g){return d===g||d!==void 0&&g!==void 0&&(0,L.equalsIgnoreCase)(d,g)}hasTrailingPathSeparator(d,g=R.sep){if(d.scheme===i.Schemas.file){const v=I(d);return v.length>D.getRoot(v).length&&v[v.length-1]===g}else{const v=d.path;return v.length>1&&v.charCodeAt(v.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,g=R.sep){return(0,e.hasTrailingPathSeparator)(d,g)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,g=R.sep){let v=!1;if(d.scheme===i.Schemas.file){const u=I(d);v=u!==void 0&&u.length===D.getRoot(u).length&&u[u.length-1]===g}else{g="/";const u=d.path;v=u.length===1&&u.charCodeAt(u.length-1)===47}return!v&&!(0,e.hasTrailingPathSeparator)(d,g)?d.with({path:d.path+"/"}):d}}e.ExtUri=S,e.extUri=new S(()=>!1),e.extUriBiasedIgnorePathCase=new S(p=>p.scheme===i.Schemas.file?!k.isLinux:!0),e.extUriIgnorePathCase=new S(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function b(p,d){const g=[];for(let v=0;v<p.length;v++){const u=d(p[v]);p.some((m,l)=>l===v?!1:(0,e.isEqualOrParent)(u,d(m)))||g.push(p[v])}return g}e.distinctParents=b;var C;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function d(g){const v=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(l=>{const[h,f]=l.split(":");h&&f&&v.set(h,f)});const m=g.path.substring(0,g.path.indexOf(";"));return m&&v.set(p.META_DATA_MIME,m),v}p.parseMetaData=d})(C=e.DataUri||(e.DataUri={}));function w(p,d,g){if(d){let v=p.path;return v&&v[0]!==R.posix.sep&&(v=R.posix.sep+v),p.with({scheme:g,authority:d,path:v})}return p.with({scheme:g})}e.toLocalResource=w}),define(re[6],ae([0,1,21,9,3,2,22,5]),function(_,e,D,i,R,k,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function I(Q){return!!Q&&typeof Q.then=="function"}e.isThenable=I;function S(Q){const O=new D.CancellationTokenSource,M=Q(O.token),H=new Promise((V,X)=>{const se=O.token.onCancellationRequested(()=>{se.dispose(),O.dispose(),X(new i.CancellationError)});Promise.resolve(M).then(x=>{se.dispose(),O.dispose(),V(x)},x=>{se.dispose(),O.dispose(),X(x)})});return new class{cancel(){O.cancel()}then(V,X){return H.then(V,X)}catch(V){return this.then(void 0,V)}finally(V){return H.finally(V)}}}e.createCancelablePromise=S;function b(Q,O,M){return new Promise((H,V)=>{const X=O.onCancellationRequested(()=>{X.dispose(),H(M)});Q.then(H,V).finally(()=>X.dispose())})}e.raceCancellation=b;function C(Q,O){return new Promise((M,H)=>{const V=O.onCancellationRequested(()=>{V.dispose(),H(new i.CancellationError)});Q.then(M,H).finally(()=>V.dispose())})}e.raceCancellationError=C;async function w(Q){let O=-1;const M=Q.map((V,X)=>V.then(se=>(O=X,se))),H=await Promise.race(M);return Q.forEach((V,X)=>{X!==O&&V.cancel()}),H}e.raceCancellablePromises=w;function p(Q,O,M){let H;const V=setTimeout(()=>{H?.(void 0),M?.()},O);return Promise.race([Q.finally(()=>clearTimeout(V)),new Promise(X=>H=X)])}e.raceTimeout=p;function d(Q){return new Promise((O,M)=>{const H=Q();I(H)?H.then(O,M):O(H)})}e.asPromise=d;class g{constructor(){this.a=null,this.b=null,this.d=null}queue(O){if(this.a){if(this.d=O,!this.b){const M=()=>{this.b=null;const H=this.queue(this.d);return this.d=null,H};this.b=new Promise(H=>{this.a.then(M,M).then(H)})}return new Promise((M,H)=>{this.b.then(M,H)})}return this.a=O(),new Promise((M,H)=>{this.a.then(V=>{this.a=null,M(V)},V=>{this.a=null,H(V)})})}}e.Throttler=g;class v{constructor(){this.a=Promise.resolve(null)}queue(O){return this.a=this.a.then(()=>O(),()=>O())}}e.Sequencer=v;class u{constructor(){this.a=new Map}queue(O,M){const V=(this.a.get(O)??Promise.resolve()).catch(()=>{}).then(M).finally(()=>{this.a.get(O)===V&&this.a.delete(O)});return this.a.set(O,V),V}}e.SequencerByKey=u;const m=(Q,O)=>{let M=!0;const H=setTimeout(()=>{M=!1,O()},Q);return{isTriggered:()=>M,dispose:()=>{clearTimeout(H),M=!1}}},l=Q=>{let O=!0;return queueMicrotask(()=>{O&&(O=!1,Q())}),{isTriggered:()=>O,dispose:()=>{O=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class h{constructor(O){this.defaultDelay=O,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(O,M=this.defaultDelay){this.g=O,this.h(),this.b||(this.b=new Promise((V,X)=>{this.d=V,this.f=X}).then(()=>{if(this.b=null,this.d=null,this.g){const V=this.g;return this.g=null,V()}}));const H=()=>{this.a=null,this.d?.(null)};return this.a=M===e.MicrotaskDelay?l(H):m(M,H),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new i.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=h;class f{constructor(O){this.a=new h(O),this.b=new g}trigger(O,M){return this.a.trigger(()=>this.b.queue(O),M)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=f;class n{constructor(){this.a=!1,this.b=new Promise((O,M)=>{this.d=O})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=n;class r extends n{constructor(O){super(),this.f=setTimeout(()=>this.open(),O)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=r;function t(Q,O){return O?new Promise((M,H)=>{const V=setTimeout(()=>{X.dispose(),M()},Q),X=O.onCancellationRequested(()=>{clearTimeout(V),X.dispose(),H(new i.CancellationError)})}):S(M=>t(Q,M))}e.timeout=t;function a(Q,O=0){const M=setTimeout(Q,O);return(0,k.toDisposable)(()=>clearTimeout(M))}e.disposableTimeout=a;function s(Q){const O=[];let M=0;const H=Q.length;function V(){return M<H?Q[M++]():null}function X(se){se!=null&&O.push(se);const x=V();return x?x.then(X):Promise.resolve(O)}return Promise.resolve(null).then(X)}e.sequence=s;function c(Q,O=H=>!!H,M=null){let H=0;const V=Q.length,X=()=>{if(H>=V)return Promise.resolve(M);const se=Q[H++];return Promise.resolve(se()).then(ie=>O(ie)?Promise.resolve(ie):X())};return X()}e.first=c;function o(Q,O=H=>!!H,M=null){if(Q.length===0)return Promise.resolve(M);let H=Q.length;const V=()=>{H=-1;for(const X of Q)X.cancel?.()};return new Promise((X,se)=>{for(const x of Q)x.then(ie=>{--H>=0&&O(ie)?(V(),X(ie)):H===0&&X(M)}).catch(ie=>{--H>=0&&(V(),se(ie))})})}e.firstParallel=o;class y{constructor(O){this.a=0,this.d=O,this.f=[],this.b=0,this.g=new R.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(O){return this.a++,new Promise((M,H)=>{this.f.push({factory:O,c:M,e:H}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const O=this.f.shift();this.b++;const M=O.factory();M.then(O.c,O.e),M.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=y;class E extends y{constructor(){super(1)}}e.Queue=E;class T{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const O=new $;return this.b.add(O),O.p}d(){for(const[,O]of this.a)if(O.size>0)return!1;return!0}queueFor(O,M=L.extUri){const H=M.getComparisonKey(O);let V=this.a.get(H);return V||(V=new E,R.Event.once(V.onDrained)(()=>{V?.dispose(),this.a.delete(H),this.f()}),this.a.set(H,V)),V}f(){!this.d()||this.g()}g(){for(const O of this.b)O.complete();this.b.clear()}dispose(){for(const[,O]of this.a)O.dispose();this.a.clear(),this.g()}}e.ResourceQueue=T;class q{constructor(O,M){this.a=-1,typeof O=="function"&&typeof M=="number"&&this.setIfNotSet(O,M)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(O,M){this.cancel(),this.a=setTimeout(()=>{this.a=-1,O()},M)}setIfNotSet(O,M){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,O()},M))}}e.TimeoutTimer=q;class N{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(O,M){this.cancel(),this.a=setInterval(()=>{O()},M)}}e.IntervalTimer=N;class j{constructor(O,M){this.b=-1,this.a=O,this.d=M,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(O=this.d){this.cancel(),this.b=setTimeout(this.f,O)}get delay(){return this.d}set delay(O){this.d=O}isScheduled(){return this.b!==-1}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=j;class F{constructor(O,M){M%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${M}ms is not a multiple of 1000ms.`),this.a=O,this.b=M,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(O=this.b){O%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(O/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=F;class A extends j{constructor(O,M){super(O,M),this.j=[]}work(O){this.j.push(O),this.isScheduled()||this.schedule()}h(){const O=this.j;this.j=[],this.a?.(O)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=A;class U extends k.Disposable{constructor(O,M){super(),this.g=O,this.h=M,this.a=[],this.b=this.B(new k.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(O){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+O.length>this.g.maxBufferedWork)return!1}else if(this.pending+O.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}return this.a.push(...O),this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new j(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=U,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=Q=>{(0,P.setTimeout0)(()=>{if(O)return;const M=Date.now()+15;Q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,M-Date.now())}}))});let O=!1;return{dispose(){O||(O=!0)}}}:e.runWhenIdle=(Q,O)=>{const M=requestIdleCallback(Q,typeof O=="number"?{timeout:O}:void 0);let H=!1;return{dispose(){H||(H=!0,cancelIdleCallback(M))}}}}();class B{constructor(O){this.d=!1,this.a=()=>{try{this.f=O()}catch(M){this.g=M}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=B;async function G(Q,O,M){let H;for(let V=0;V<M;V++)try{return await Q()}catch(X){H=X,await t(O)}throw H}e.retry=G;class W{hasPending(O){return this.a?typeof O=="number"?this.a.taskId===O:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(O,M,H){return this.a={taskId:O,cancel:()=>H?.(),promise:M},M.then(()=>this.d(O),()=>this.d(O)),M}d(O){this.a&&O===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const O=this.b;this.b=void 0,O.run().then(O.promiseResolve,O.promiseReject)}}setNext(O){if(this.b)this.b.run=O;else{let M,H;const V=new Promise((X,se)=>{M=X,H=se});this.b={run:O,promise:V,promiseResolve:M,promiseReject:H}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=W;class Z{constructor(O,M=()=>Date.now()){this.d=O,this.f=M,this.a=0,this.b=0}increment(){const O=this.f();return O-this.a>this.d&&(this.a=O,this.b=0),this.b++,this.b}}e.IntervalCounter=Z;class ${get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((O,M)=>{this.a=O,this.b=M})}complete(O){return new Promise(M=>{this.a(O),this.f=!0,M()})}error(O){return new Promise(M=>{this.b(O),this.d=!0,M()})}cancel(){new Promise(O=>{this.b(new i.CancellationError),this.d=!0,O()})}}e.DeferredPromise=$;var z;(function(Q){async function O(H){let V;const X=await Promise.all(H.map(se=>se.then(x=>x,x=>{V||(V=x)})));if(typeof V<"u")throw V;return X}Q.settled=O;function M(H){return new Promise(async(V,X)=>{try{await H(V,X)}catch(se){X(se)}})}Q.withAsyncBody=M})(z=e.Promises||(e.Promises={}));var Y;(function(Q){Q[Q.Initial=0]="Initial",Q[Q.DoneOK=1]="DoneOK",Q[Q.DoneError=2]="DoneError"})(Y||(Y={}));class ee{static fromArray(O){return new ee(M=>{M.emitMany(O)})}static fromPromise(O){return new ee(async M=>{M.emitMany(await O)})}static fromPromises(O){return new ee(async M=>{await Promise.all(O.map(async H=>M.emitOne(await H)))})}static merge(O){return new ee(async M=>{await Promise.all(O.map(async H=>{for await(const V of H)M.emitOne(V)}))})}constructor(O){this.a=0,this.b=[],this.d=null,this.f=new R.Emitter,queueMicrotask(async()=>{const M={emitOne:H=>this.g(H),emitMany:H=>this.h(H),reject:H=>this.k(H)};try{await Promise.resolve(O(M)),this.j()}catch(H){this.k(H)}finally{M.emitOne=void 0,M.emitMany=void 0,M.reject=void 0}})}[Symbol.asyncIterator](){let O=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(O<this.b.length)return{done:!1,value:this.b[O++]};if(this.a===1)return{done:!0,value:void 0};await R.Event.toPromise(this.f.event)}while(!0)}}}static map(O,M){return new ee(async H=>{for await(const V of O)H.emitOne(M(V))})}map(O){return ee.map(this,O)}static filter(O,M){return new ee(async H=>{for await(const V of O)M(V)&&H.emitOne(V)})}filter(O){return ee.filter(this,O)}static coalesce(O){return ee.filter(O,M=>!!M)}coalesce(){return ee.coalesce(this)}static async toPromise(O){const M=[];for await(const H of O)M.push(H);return M}toPromise(){return ee.toPromise(this)}g(O){this.a===0&&(this.b.push(O),this.f.fire())}h(O){this.a===0&&(this.b=this.b.concat(O),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(O){this.a===0&&(this.a=2,this.d=O,this.f.fire())}}e.AsyncIterableObject=ee,ee.EMPTY=ee.fromArray([]);class oe extends ee{constructor(O,M){super(M),this.l=O}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=oe;function J(Q){const O=new D.CancellationTokenSource,M=Q(O.token);return new oe(O,async H=>{const V=O.token.onCancellationRequested(()=>{V.dispose(),O.dispose(),H.reject(new i.CancellationError)});try{for await(const X of M){if(O.token.isCancellationRequested)return;H.emitOne(X)}V.dispose(),O.dispose()}catch(X){V.dispose(),O.dispose(),H.reject(X)}})}e.createCancelableAsyncIterable=J}),define(re[89],ae([0,1,20,6,48,37,12,5,27]),function(_,e,D,i,R,k,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function S(){return Object.create(null)}e.getEmptyExpression=S,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const b="[/\\\\]",C="[^/\\\\]",w=/\//g;function p($,z){switch($){case 0:return"";case 1:return`${C}*?`;default:return`(?:${b}|${C}+${b}${z?`|${b}${C}+`:""})*?`}}function d($,z){if(!$)return[];const Y=[];let ee=!1,oe=!1,J="";for(const Q of $){switch(Q){case z:if(!ee&&!oe){Y.push(J),J="";continue}break;case"{":ee=!0;break;case"}":ee=!1;break;case"[":oe=!0;break;case"]":oe=!1;break}J+=Q}return J&&Y.push(J),Y}e.splitGlobAware=d;function g($){if(!$)return"";let z="";const Y=d($,e.GLOB_SPLIT);if(Y.every(ee=>ee===e.GLOBSTAR))z=".*";else{let ee=!1;Y.forEach((oe,J)=>{if(oe===e.GLOBSTAR){if(ee)return;z+=p(2,J===Y.length-1)}else{let Q=!1,O="",M=!1,H="";for(const V of oe){if(V!=="}"&&Q){O+=V;continue}if(M&&(V!=="]"||!H)){let X;V==="-"?X=V:(V==="^"||V==="!")&&!H?X="^":V===e.GLOB_SPLIT?X="":X=(0,I.escapeRegExpCharacters)(V),H+=X;continue}switch(V){case"{":Q=!0;continue;case"[":M=!0;continue;case"}":{z+=`(?:${d(O,",").map(x=>g(x)).join("|")})`,Q=!1,O="";break}case"]":{z+="["+H+"]",M=!1,H="";break}case"?":z+=C;continue;case"*":z+=p(1);continue;default:z+=(0,I.escapeRegExpCharacters)(V)}}J<Y.length-1&&(Y[J+1]!==e.GLOBSTAR||J+2<Y.length)&&(z+=b)}ee=oe===e.GLOBSTAR})}return z}const v=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,m=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,l=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,h=/^\*\*((\/[\w\.-]+)+)\/?$/,f=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new k.LRUCache(1e4),r=function(){return!1},t=function(){return null};function a($,z){if(!$)return t;let Y;typeof $!="string"?Y=$.pattern:Y=$,Y=Y.trim();const ee=`${Y}_${!!z.trimForExclusions}`;let oe=n.get(ee);if(oe)return s(oe,$);let J;return v.test(Y)?oe=o(Y.substr(4),Y):(J=u.exec(c(Y,z)))?oe=y(J[1],Y):(z.trimForExclusions?l:m).test(Y)?oe=E(Y,z):(J=h.exec(c(Y,z)))?oe=T(J[1].substr(1),Y,!0):(J=f.exec(c(Y,z)))?oe=T(J[1],Y,!1):oe=q(Y),n.set(ee,oe),s(oe,$)}function s($,z){if(typeof z=="string")return $;const Y=function(ee,oe){return(0,R.isEqualOrParent)(ee,z.base,!P.isLinux)?$((0,I.ltrim)(ee.substr(z.base.length),L.sep),oe):null};return Y.allBasenames=$.allBasenames,Y.allPaths=$.allPaths,Y.basenames=$.basenames,Y.patterns=$.patterns,Y}function c($,z){return z.trimForExclusions&&$.endsWith("/**")?$.substr(0,$.length-2):$}function o($,z){return function(Y,ee){return typeof Y=="string"&&Y.endsWith($)?z:null}}function y($,z){const Y=`/${$}`,ee=`\\${$}`,oe=function(Q,O){return typeof Q!="string"?null:O?O===$?z:null:Q===$||Q.endsWith(Y)||Q.endsWith(ee)?z:null},J=[$];return oe.basenames=J,oe.patterns=[z],oe.allBasenames=J,oe}function E($,z){const Y=W($.slice(1,-1).split(",").map(O=>a(O,z)).filter(O=>O!==t),$),ee=Y.length;if(!ee)return t;if(ee===1)return Y[0];const oe=function(O,M){for(let H=0,V=Y.length;H<V;H++)if(Y[H](O,M))return $;return null},J=Y.find(O=>!!O.allBasenames);J&&(oe.allBasenames=J.allBasenames);const Q=Y.reduce((O,M)=>M.allPaths?O.concat(M.allPaths):O,[]);return Q.length&&(oe.allPaths=Q),oe}function T($,z,Y){const ee=L.sep===L.posix.sep,oe=ee?$:$.replace(w,L.sep),J=L.sep+oe,Q=L.posix.sep+$;let O;return Y?O=function(M,H){return typeof M=="string"&&(M===oe||M.endsWith(J)||!ee&&(M===$||M.endsWith(Q)))?z:null}:O=function(M,H){return typeof M=="string"&&(M===oe||!ee&&M===$)?z:null},O.allPaths=[(Y?"*/":"./")+$],O}function q($){try{const z=new RegExp(`^${g($)}$`);return function(Y){return z.lastIndex=0,typeof Y=="string"&&z.test(Y)?$:null}}catch{return t}}function N($,z,Y){return!$||typeof z!="string"?!1:j($)(z,void 0,Y)}e.match=N;function j($,z={}){if(!$)return r;if(typeof $=="string"||F($)){const Y=a($,z);if(Y===t)return r;const ee=function(oe,J){return!!Y(oe,J)};return Y.allBasenames&&(ee.allBasenames=Y.allBasenames),Y.allPaths&&(ee.allPaths=Y.allPaths),ee}return B($,z)}e.parse=j;function F($){const z=$;return z?typeof z.base=="string"&&typeof z.pattern=="string":!1}e.isRelativePattern=F;function A($){return $.allBasenames||[]}e.getBasenameTerms=A;function U($){return $.allPaths||[]}e.getPathTerms=U;function B($,z){const Y=W(Object.getOwnPropertyNames($).map(O=>G(O,$[O],z)).filter(O=>O!==t)),ee=Y.length;if(!ee)return t;if(!Y.some(O=>!!O.requiresSiblings)){if(ee===1)return Y[0];const O=function(V,X){let se;for(let x=0,ie=Y.length;x<ie;x++){const ne=Y[x](V,X);if(typeof ne=="string")return ne;(0,i.isThenable)(ne)&&(se||(se=[]),se.push(ne))}return se?(async()=>{for(const x of se){const ie=await x;if(typeof ie=="string")return ie}return null})():null},M=Y.find(V=>!!V.allBasenames);M&&(O.allBasenames=M.allBasenames);const H=Y.reduce((V,X)=>X.allPaths?V.concat(X.allPaths):V,[]);return H.length&&(O.allPaths=H),O}const oe=function(O,M,H){let V,X;for(let se=0,x=Y.length;se<x;se++){const ie=Y[se];ie.requiresSiblings&&H&&(M||(M=(0,L.basename)(O)),V||(V=M.substr(0,M.length-(0,L.extname)(O).length)));const ne=ie(O,M,V,H);if(typeof ne=="string")return ne;(0,i.isThenable)(ne)&&(X||(X=[]),X.push(ne))}return X?(async()=>{for(const se of X){const x=await se;if(typeof x=="string")return x}return null})():null},J=Y.find(O=>!!O.allBasenames);J&&(oe.allBasenames=J.allBasenames);const Q=Y.reduce((O,M)=>M.allPaths?O.concat(M.allPaths):O,[]);return Q.length&&(oe.allPaths=Q),oe}function G($,z,Y){if(z===!1)return t;const ee=a($,Y);if(ee===t)return t;if(typeof z=="boolean")return ee;if(z){const oe=z.when;if(typeof oe=="string"){const J=(Q,O,M,H)=>{if(!H||!ee(Q,O))return null;const V=oe.replace("$(basename)",M),X=H(V);return(0,i.isThenable)(X)?X.then(se=>se?$:null):X?$:null};return J.requiresSiblings=!0,J}}return ee}function W($,z){const Y=$.filter(O=>!!O.basenames);if(Y.length<2)return $;const ee=Y.reduce((O,M)=>{const H=M.basenames;return H?O.concat(H):O},[]);let oe;if(z){oe=[];for(let O=0,M=ee.length;O<M;O++)oe.push(z)}else oe=Y.reduce((O,M)=>{const H=M.patterns;return H?O.concat(H):O},[]);const J=function(O,M){if(typeof O!="string")return null;if(!M){let V;for(V=O.length;V>0;V--){const X=O.charCodeAt(V-1);if(X===47||X===92)break}M=O.substr(V)}const H=ee.indexOf(M);return H!==-1?oe[H]:null};J.basenames=ee,J.patterns=oe,J.allBasenames=ee;const Q=$.filter(O=>!O.basenames);return Q.push(J),Q}function Z($,z){return(0,D.equals)($,z,(Y,ee)=>typeof Y=="string"&&typeof ee=="string"?Y===ee:typeof Y!="string"&&typeof ee!="string"?Y.base===ee.base&&Y.pattern===ee.pattern:!1)}e.patternsEquals=Z}),define(re[142],ae([0,1,8]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function i(b){return b.toJSON()}class R{constructor(C){this.a=C}transformIncoming(C){const w=this.a.transformIncoming(C);return w===C?C:i(D.URI.from(w))}transformOutgoing(C){const w=this.a.transformOutgoing(C);return w===C?C:i(D.URI.from(w))}transformOutgoingURI(C){const w=this.a.transformOutgoing(C);return w===C?C:D.URI.from(w)}transformOutgoingScheme(C){return this.a.transformOutgoingScheme(C)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(b){return b}transformOutgoing(b){return b}transformOutgoingURI(b){return b}transformOutgoingScheme(b){return b}};function k(b,C,w){if(!b||w>200)return null;if(typeof b=="object"){if(b instanceof D.URI)return C.transformOutgoing(b);for(const p in b)if(Object.hasOwnProperty.call(b,p)){const d=k(b[p],C,w+1);d!==null&&(b[p]=d)}}return null}function L(b,C){const w=k(b,C,0);return w===null?b:w}e.transformOutgoingURIs=L;function P(b,C,w,p){if(!b||p>200)return null;if(typeof b=="object"){if(b.$mid===1)return w?D.URI.revive(C.transformIncoming(b)):C.transformIncoming(b);for(const d in b)if(Object.hasOwnProperty.call(b,d)){const g=P(b[d],C,w,p+1);g!==null&&(b[d]=g)}}return null}function I(b,C){const w=P(b,C,!1,0);return w===null?b:w}e.transformIncomingURIs=I;function S(b,C){const w=P(b,C,!0,0);return w===null?b:w}e.transformAndReviveIncomingURIs=S}),define(re[143],ae([0,1,34,9,49,31,129]),function(_,e,D,i,R,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(b){return this.a||(this.a=R.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(b)}value(){if(this.b===void 0){let b=0,C=0;const w=(0,D.networkInterfaces)();for(const p in w){const d=w[p];if(d)for(const{mac:g,internal:v}of d)v||(C+=1,this.c(g.toUpperCase())&&(b+=1))}this.b=C>0?b/C:0}return this.b}};let P;async function I(){return P||(P=(async()=>await S()||k.generateUuid())()),P}e.getMachineId=I;async function S(){try{const b=await new Promise((w,p)=>{_(["crypto"],w,p)}),C=(0,L.getMac)();return b.createHash("sha256").update(C,"utf8").digest("hex")}catch(b){i.onUnexpectedError(b);return}}}),define(re[28],ae([0,1,53,34,282,6,48,85,12,5,22,8]),function(_,e,D,i,R,k,L,P,I,S,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var w;(function(B){B[B.UNLINK=0]="UNLINK",B[B.MOVE=1]="MOVE"})(w=e.RimRafMode||(e.RimRafMode={}));async function p(B,G=w.UNLINK){if((0,L.isRootOrDriveLetter)(B))throw new Error("rimraf - will refuse to recursively delete root");return G===w.UNLINK?g(B):d(B)}async function d(B){try{const G=(0,L.randomPath)((0,i.tmpdir)());try{await D.promises.rename(B,G)}catch(W){return W.code==="ENOENT"?void 0:g(B)}g(G).catch(W=>{})}catch(G){if(G.code!=="ENOENT")throw G}}async function g(B){return(0,R.promisify)(D.rm)(B,{recursive:!0,force:!0,maxRetries:3})}function v(B){if((0,L.isRootOrDriveLetter)(B))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(B,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=v;async function u(B,G){return h(await(G?m(B):(0,R.promisify)(D.readdir)(B)))}async function m(B){try{return await(0,R.promisify)(D.readdir)(B,{withFileTypes:!0})}catch(Z){console.warn("[node.js fs] readdir with filetypes failed with error: ",Z)}const G=[],W=await u(B);for(const Z of W){let $=!1,z=!1,Y=!1;try{const ee=await e.Promises.lstat((0,I.join)(B,Z));$=ee.isFile(),z=ee.isDirectory(),Y=ee.isSymbolicLink()}catch(ee){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ee)}G.push({name:Z,isFile:()=>$,isDirectory:()=>z,isSymbolicLink:()=>Y})}return G}function l(B){return h(D.readdirSync(B))}e.readdirSync=l;function h(B){return B.map(G=>typeof G=="string"?S.isMacintosh?(0,P.normalizeNFC)(G):G:(G.name=S.isMacintosh?(0,P.normalizeNFC)(G.name):G.name,G))}async function f(B){const G=await u(B),W=[];for(const Z of G)await r.existsDirectory((0,I.join)(B,Z))&&W.push(Z);return W}function n(B,G=1e3){return new Promise(W=>{let Z=!1;const $=setInterval(()=>{Z||(Z=!0,D.access(B,z=>{Z=!1,z&&(clearInterval($),W(void 0))}))},G)})}e.whenDeleted=n;var r;(function(B){async function G($){let z;try{if(z=await e.Promises.lstat($),!z.isSymbolicLink())return{stat:z}}catch{}try{return{stat:await e.Promises.stat($),symbolicLink:z?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Y){if(Y.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};if(S.isWindows&&Y.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink($)),symbolicLink:{dangling:!1}}}catch(ee){if(ee.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};throw ee}throw Y}}B.stat=G;async function W($){try{const{stat:z,symbolicLink:Y}=await B.stat($);return z.isFile()&&Y?.dangling!==!0}catch{}return!1}B.existsFile=W;async function Z($){try{const{stat:z,symbolicLink:Y}=await B.stat($);return z.isDirectory()&&Y?.dangling!==!0}catch{}return!1}B.existsDirectory=Z})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new k.ResourceQueue;function a(B,G,W){return t.queueFor(C.URI.file(B),b.extUriBiasedIgnorePathCase).queue(()=>{const Z=E(W);return new Promise(($,z)=>o(B,G,Z,Y=>Y?z(Y):$()))})}let s=!0;function c(B){s=B}e.configureFlushOnWrite=c;function o(B,G,W,Z){if(!s)return D.writeFile(B,G,{mode:W.mode,flag:W.flag},Z);D.open(B,W.flag,W.mode,($,z)=>{if($)return Z($);D.writeFile(z,G,Y=>{if(Y)return D.close(z,()=>Z(Y));D.fdatasync(z,ee=>(ee&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ee),c(!1)),D.close(z,oe=>Z(oe))))})})}function y(B,G,W){const Z=E(W);if(!s)return D.writeFileSync(B,G,{mode:Z.mode,flag:Z.flag});const $=D.openSync(B,Z.flag,Z.mode);try{D.writeFileSync($,G);try{D.fdatasyncSync($)}catch(z){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",z),c(!1)}}finally{D.closeSync($)}}e.writeFileSync=y;function E(B){return B?{mode:typeof B.mode=="number"?B.mode:438,flag:typeof B.flag=="string"?B.flag:"w"}:{mode:438,flag:"w"}}async function T(B,G){if(B!==G)try{await e.Promises.rename(B,G)}catch(W){if(B.toLowerCase()!==G.toLowerCase()&&W.code==="EXDEV"||B.endsWith("."))await q(B,G,{preserveSymlinks:!1}),await p(B,w.MOVE);else throw W}}async function q(B,G,W){return j(B,G,{root:{source:B,target:G},options:W,handledSourcePaths:new Set})}const N=511;async function j(B,G,W){if(W.handledSourcePaths.has(B))return;W.handledSourcePaths.add(B);const{stat:Z,symbolicLink:$}=await r.stat(B);if($){if(W.options.preserveSymlinks)try{return await U(B,G,W)}catch(z){console.warn("[node.js fs] copy of symlink failed: ",z)}if($.dangling)return}return Z.isDirectory()?F(B,G,Z.mode&N,W):A(B,G,Z.mode&N)}async function F(B,G,W,Z){await e.Promises.mkdir(G,{recursive:!0,mode:W});const $=await u(B);for(const z of $)await j((0,I.join)(B,z),(0,I.join)(G,z),Z)}async function A(B,G,W){await e.Promises.copyFile(B,G),await e.Promises.chmod(G,W)}async function U(B,G,W){let Z=await e.Promises.readlink(B);(0,L.isEqualOrParent)(Z,W.root.source,!S.isLinux)&&(Z=(0,I.join)(W.root.target,Z.substr(W.root.source.length+1))),await e.Promises.symlink(Z,G)}e.Promises=new class{get access(){return(0,R.promisify)(D.access)}get stat(){return(0,R.promisify)(D.stat)}get lstat(){return(0,R.promisify)(D.lstat)}get utimes(){return(0,R.promisify)(D.utimes)}get read(){return(B,G,W,Z,$)=>new Promise((z,Y)=>{D.read(B,G,W,Z,$,(ee,oe,J)=>ee?Y(ee):z({bytesRead:oe,buffer:J}))})}get readFile(){return(0,R.promisify)(D.readFile)}get write(){return(B,G,W,Z,$)=>new Promise((z,Y)=>{D.write(B,G,W,Z,$,(ee,oe,J)=>ee?Y(ee):z({bytesWritten:oe,buffer:J}))})}get appendFile(){return(0,R.promisify)(D.appendFile)}get fdatasync(){return(0,R.promisify)(D.fdatasync)}get truncate(){return(0,R.promisify)(D.truncate)}get rename(){return(0,R.promisify)(D.rename)}get copyFile(){return(0,R.promisify)(D.copyFile)}get open(){return(0,R.promisify)(D.open)}get close(){return(0,R.promisify)(D.close)}get symlink(){return(0,R.promisify)(D.symlink)}get readlink(){return(0,R.promisify)(D.readlink)}get chmod(){return(0,R.promisify)(D.chmod)}get mkdir(){return(0,R.promisify)(D.mkdir)}get unlink(){return(0,R.promisify)(D.unlink)}get rmdir(){return(0,R.promisify)(D.rmdir)}get realpath(){return(0,R.promisify)(D.realpath)}async exists(B){try{return await e.Promises.access(B),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return f}get writeFile(){return a}get rm(){return p}get move(){return T}get copy(){return q}}}),define(re[144],ae([0,1,53,12,5,27,28]),function(_,e,D,i,R,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(w){if(R.isLinux)return w;const p=(0,i.dirname)(w);if(w===p)return w;const d=((0,i.basename)(w)||w).toLowerCase();try{const v=(0,L.readdirSync)(p).filter(u=>u.toLowerCase()===d);if(v.length===1){const u=P(p);if(u)return(0,i.join)(u,v[0])}else if(v.length>1){const u=v.indexOf(d);if(u>=0){const m=P(p);if(m)return(0,i.join)(m,v[u])}}}catch{}return null}e.realcaseSync=P;async function I(w){if(R.isLinux)return w;const p=(0,i.dirname)(w);if(w===p)return w;const d=((0,i.basename)(w)||w).toLowerCase();try{const v=(await L.Promises.readdir(p)).filter(u=>u.toLowerCase()===d);if(v.length===1){const u=await I(p);if(u)return(0,i.join)(u,v[0])}else if(v.length>1){const u=v.indexOf(d);if(u>=0){const m=await I(p);if(m)return(0,i.join)(m,v[u])}}}catch{}return null}e.realcase=I;async function S(w){try{return await L.Promises.realpath(w)}catch{const d=C(w);return await L.Promises.access(d,D.constants.R_OK),d}}e.realpath=S;function b(w){try{return D.realpathSync(w)}catch{const d=C(w);return D.accessSync(d,D.constants.R_OK),d}}e.realpathSync=b;function C(w){return(0,k.rtrim)((0,i.normalize)(w),i.sep)}}),define(re[90],ae([0,1,34,12,28]),function(_,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const k=/^\d+$/,L=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var I;(function(h){h[h.x64=0]="x64",h[h.x86=1]="x86",h[h.ARM=2]="ARM"})(I||(I={}));let S;switch(process.arch){case"ia32":case"x32":S=1;break;case"arm":case"arm64":S=2;break;default:S=0;break}let b;process.env.PROCESSOR_ARCHITEW6432?b=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?b=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?b=1:b=0;class C{constructor(f,n,r){this.exePath=f,this.displayName=n,this.a=r}async exists(){return this.a===void 0&&(this.a=await R.SymlinkSupport.existsFile(this.exePath)),this.a}}function w({useAlternateBitness:h=!1}={}){return h?S===0?process.env["ProgramFiles(x86)"]||null:b===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:h=!1,findPreview:f=!1}={}){const n=w({useAlternateBitness:h});if(!n)return null;const r=i.join(n,"PowerShell");if(!await R.SymlinkSupport.existsDirectory(r))return null;let t=-1,a=null;for(const o of await R.Promises.readdir(r)){let y=-1;if(f){const T=o.indexOf("-");if(T<0)continue;const q=o.substring(0,T);if(!k.test(q)||o.substring(T+1)!=="preview")continue;y=parseInt(q,10)}else{if(!k.test(o))continue;y=parseInt(o,10)}if(y<=t)continue;const E=i.join(r,o,"pwsh.exe");!await R.SymlinkSupport.existsFile(E)||(a=E,t=y)}if(!a)return null;const s=n.includes("x86")?" (x86)":"",c=f?" Preview":"";return new C(a,`PowerShell${c}${s}`,!0)}async function d({findPreview:h}={}){if(!process.env.LOCALAPPDATA)return null;const f=i.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await R.SymlinkSupport.existsDirectory(f))return null;const{pwshMsixDirRegex:n,pwshMsixName:r}=h?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:L,pwshMsixName:"PowerShell (Store)"};for(const t of await R.Promises.readdir(f))if(n.test(t)){const a=i.join(f,t,"pwsh.exe");return new C(a,r)}return null}function g(){const h=i.join(D.homedir(),".dotnet","tools","pwsh.exe");return new C(h,".NET Core PowerShell Global Tool")}function v(){const h=i.join(process.env.windir,S===1&&b!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new C(h,"Windows PowerShell",!0)}async function*u(){let h=await p();h&&(yield h),h=await p({useAlternateBitness:!0}),h&&(yield h),h=await d(),h&&(yield h),h=g(),h&&(yield h),h=await p({findPreview:!0}),h&&(yield h),h=await d({findPreview:!0}),h&&(yield h),h=await p({useAlternateBitness:!0,findPreview:!0}),h&&(yield h),h=v(),h&&(yield h)}async function*m(){for await(const h of u())await h.exists()&&(yield h)}e.enumeratePowerShellInstallations=m;async function l(){for await(const h of m())return h;return null}e.getFirstAvailablePowerShellInstallation=l}),define(re[91],ae([0,1,12,5,36,87,15,28]),function(_,e,D,i,R,k,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return k.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return k.TerminateResponseCode}});function I(C=R.env){return C.comspec||"cmd.exe"}e.getWindowsShell=I;function S(C){let w=[],p=!1;const d=function(g){if(p){w.push(g);return}(!C.send(g,u=>{if(u&&console.error(u),p=!1,w.length>0){const m=w.slice(0);w=[],m.forEach(l=>d(l))}})||i.isWindows)&&(p=!0)};return{send:d}}e.createQueuedSender=S;var b;(function(C){async function w(p,d,g){if(D.isAbsolute(p))return p;if(d===void 0&&(d=R.cwd()),D.dirname(p)!=="."||(g===void 0&&L.isString(R.env.PATH)&&(g=R.env.PATH.split(D.delimiter)),g===void 0||g.length===0))return D.join(d,p);async function u(m){if(await P.Promises.exists(m)){let l;try{l=await P.Promises.stat(m)}catch(h){h.message.startsWith("EACCES")&&(l=await P.Promises.lstat(m))}return l?!l.isDirectory():!1}return!1}for(const m of g){let l;if(D.isAbsolute(m)?l=D.join(m,p):l=D.join(d,m,p),await u(l))return l;let h=l+".com";if(await u(h)||(h=l+".exe",await u(h)))return h}return D.join(d,p)}C.findExecutable=w})(b=e.win32||(e.win32={}))}),define(re[145],ae([0,1,50,25]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function R(L){return new Promise((P,I)=>{let S;const b=new Map;function C(p,d,g,v,u){const m=b.get(d);if(p===L||m){const l={name:w(g),cmd:g,pid:p,ppid:d,load:v,mem:u};b.set(p,l),p===L&&(S=l),m&&(m.children||(m.children=[]),m.children.push(l),m.children.length>1&&(m.children=m.children.sort((h,f)=>h.pid-f.pid)))}}function w(p){const d=/--vscode-window-kind=shared-process/,g=/--vscode-window-kind=issue-reporter/,v=/--vscode-window-kind=process-explorer/,u=/--utility-sub-type=network/,m=/--utility-sub-type=node.mojom.NodeService/,l=/--crashes-directory/,h=/\\pipe\\winpty-control/,f=/conhost\.exe/,n=/--type=([a-zA-Z-]+)/;if(l.exec(p))return"electron-crash-reporter";if(h.exec(p))return"winpty-process";if(f.exec(p))return"console-window-host (Windows internal process)";let r=n.exec(p);if(r&&r.length===2){if(r[1]==="renderer")return d.exec(p)?"shared-process":g.exec(p)?"issue-reporter":v.exec(p)?"process-explorer":"window";if(r[1]==="utility"){if(u.exec(p))return"utility-network-service";if(m.exec(p))return"extension-host"}return r[1]}const t=/[a-zA-Z-]+\.js/g;let a="";do r=t.exec(p),r&&(a+=r+" ");while(r);return a&&p.indexOf("node ")<0&&p.indexOf("node.exe")<0?`electron_node ${a}`:p}if(process.platform==="win32"){const p=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,g)=>{_(["windows-process-tree"],d,g)}).then(d=>{d.getProcessList(L,g=>{if(!g){I(new Error(`Root process ${L} not found`));return}d.getProcessCpuUsage(g,v=>{const u=new Map;v.forEach(m=>{const l=p(m.commandLine||"");u.set(m.pid,{name:w(l),cmd:l,pid:m.pid,ppid:m.ppid,load:m.cpu||0,mem:m.memory||0})}),S=u.get(L),S?(u.forEach(m=>{const l=u.get(m.ppid);l&&(l.children||(l.children=[]),l.children.push(m))}),u.forEach(m=>{m.children&&(m.children=m.children.sort((l,h)=>l.pid-h.pid))}),P(S)):I(new Error(`Root process ${L} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let p=function(){let d=[S];const g=[];for(;d.length;){const u=d.shift();u&&(g.push(u.pid),u.children&&(d=d.concat(u.children)))}let v=JSON.stringify(i.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);v+=" "+g.join(" "),(0,D.exec)(v,{},(u,m,l)=>{if(u||l)I(u||new Error(l.toString()));else{const h=m.toString().split(`
`);for(let f=0;f<g.length;f++){const n=b.get(g[f]);n.load=parseFloat(h[f])}if(!S){I(new Error(`Root process ${L} not found`));return}P(S)}})};(0,D.exec)("which ps",{},(d,g,v)=>{if(d||v)if(process.platform!=="linux")I(d||new Error(v.toString()));else{const u=JSON.stringify(i.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,D.exec)(u,{},(m,l,h)=>{m||h?I(m||new Error(h.toString())):(k(l,C),p())})}else{const u=g.toString().trim(),m="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${u} ${m}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(l,h,f)=>{l||f&&!f.includes("screen size is bogus")?I(l||new Error(f.toString())):(k(h,C),process.platform==="linux"?p():S?P(S):I(new Error(`Root process ${L} not found`)))})}})}})}e.listProcesses=R;function k(L,P){const I=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,S=L.toString().split(`
`);for(const b of S){const C=I.exec(b.trim());C&&C.length===6&&P(parseInt(C[1]),parseInt(C[2]),C[5],parseFloat(C[3]),parseFloat(C[4]))}}}),define(re[146],ae([0,1,34,5,90,91]),function(_,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function L(p,d){return p===1?i.isWindows?C():k.getWindowsShell(d):S(p,d)}e.getSystemShell=L;function P(p,d){return p===1?i.isWindows?w(d):k.getWindowsShell(d):S(p,d)}e.getSystemShellSync=P;let I=null;function S(p,d){if(i.isLinux&&p===2||i.isMacintosh&&p===3)return"/bin/bash";if(!I){let g;if(i.isWindows)g="/bin/bash";else{if(g=d.SHELL,!g)try{g=(0,D.userInfo)().shell}catch{}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}I=g}return I}let b=null;async function C(){return b||(b=(await(0,R.getFirstAvailablePowerShellInstallation)()).exePath),b}function w(p){if(b)return b;const d=i.isWindows&&parseFloat((0,D.release)())>=10,g=p.hasOwnProperty("PROCESSOR_ARCHITEW6432"),v=`${p.windir}\\${g?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?v:k.getWindowsShell(p)}});var pe=this&&this.__decorate||function(_,e,D,i){var R=arguments.length,k=R<3?e:i===null?i=Object.getOwnPropertyDescriptor(e,D):i,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(_,e,D,i);else for(var P=_.length-1;P>=0;P--)(L=_[P])&&(k=(R<3?L(k):R>3?L(e,D,k):L(e,D))||k);return R>3&&k&&Object.defineProperty(e,D,k),k};define(re[39],ae([0,1,20,6,17,21,63,9,3,2,67,27,15]),function(_,e,D,i,R,k,L,P,I,S,b,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=void 0;var p;(function($){$[$.Promise=100]="Promise",$[$.PromiseCancel=101]="PromiseCancel",$[$.EventListen=102]="EventListen",$[$.EventDispose=103]="EventDispose"})(p||(p={}));function d($){switch($){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function($){$[$.Initialize=200]="Initialize",$[$.PromiseSuccess=201]="PromiseSuccess",$[$.PromiseError=202]="PromiseError",$[$.PromiseErrorObj=203]="PromiseErrorObj",$[$.EventFire=204]="EventFire"})(g||(g={}));function v($){switch($){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function($){$[$.Uninitialized=0]="Uninitialized",$[$.Idle=1]="Idle"})(u||(u={}));class m{constructor(z){this.b=z,this.a=0}read(z){const Y=this.b.slice(this.a,this.a+z);return this.a+=Y.byteLength,Y}}class l{constructor(){this.a=[]}get buffer(){return R.VSBuffer.concat(this.a)}write(z){this.a.push(z)}}var h;(function($){$[$.Undefined=0]="Undefined",$[$.String=1]="String",$[$.Buffer=2]="Buffer",$[$.VSBuffer=3]="VSBuffer",$[$.Array=4]="Array",$[$.Object=5]="Object"})(h||(h={}));function f($){const z=R.VSBuffer.alloc(4);return z.writeUInt32BE($,0),z}function n($){return $.read(4).readUInt32BE(0)}function r($){const z=R.VSBuffer.alloc(1);return z.writeUInt8($,0),z}const t={Undefined:r(h.Undefined),String:r(h.String),Buffer:r(h.Buffer),VSBuffer:r(h.VSBuffer),Array:r(h.Array),Object:r(h.Object)},a=typeof Buffer<"u";function s($,z){if(typeof z>"u")$.write(t.Undefined);else if(typeof z=="string"){const Y=R.VSBuffer.fromString(z);$.write(t.String),$.write(f(Y.byteLength)),$.write(Y)}else if(a&&Buffer.isBuffer(z)){const Y=R.VSBuffer.wrap(z);$.write(t.Buffer),$.write(f(Y.byteLength)),$.write(Y)}else if(z instanceof R.VSBuffer)$.write(t.VSBuffer),$.write(f(z.byteLength)),$.write(z);else if(Array.isArray(z)){$.write(t.Array),$.write(f(z.length));for(const Y of z)s($,Y)}else{const Y=R.VSBuffer.fromString(JSON.stringify(z));$.write(t.Object),$.write(f(Y.byteLength)),$.write(Y)}}function c($){switch($.read(1).readUInt8(0)){case h.Undefined:return;case h.String:return $.read(n($)).toString();case h.Buffer:return $.read(n($)).buffer;case h.VSBuffer:return $.read(n($));case h.Array:{const Y=n($),ee=[];for(let oe=0;oe<Y;oe++)ee.push(c($));return ee}case h.Object:return JSON.parse($.read(n($)).toString())}}class o{constructor(z,Y,ee=null,oe=1e3){this.h=z,this.j=Y,this.k=ee,this.l=oe,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(J=>this.p(J)),this.m({type:200})}registerChannel(z,Y){this.b.set(z,Y),setTimeout(()=>this.v(z),0)}m(z){switch(z.type){case 200:{const Y=this.n([z.type]);this.k?.logOutgoing(Y,0,1,v(z.type));return}case 201:case 202:case 204:case 203:{const Y=this.n([z.type,z.id],z.data);this.k?.logOutgoing(Y,z.id,1,v(z.type),z.data);return}}}n(z,Y=void 0){const ee=new l;return s(ee,z),s(ee,Y),this.o(ee.buffer)}o(z){try{return this.h.send(z),z.byteLength}catch{return 0}}p(z){const Y=new m(z),ee=c(Y),oe=c(Y),J=ee[0];switch(J){case 100:return this.k?.logIncoming(z.byteLength,ee[1],1,`${d(J)}: ${ee[2]}.${ee[3]}`,oe),this.q({type:J,id:ee[1],channelName:ee[2],name:ee[3],arg:oe});case 102:return this.k?.logIncoming(z.byteLength,ee[1],1,`${d(J)}: ${ee[2]}.${ee[3]}`,oe),this.s({type:J,id:ee[1],channelName:ee[2],name:ee[3],arg:oe});case 101:return this.k?.logIncoming(z.byteLength,ee[1],1,`${d(J)}`),this.t({type:J,id:ee[1]});case 103:return this.k?.logIncoming(z.byteLength,ee[1],1,`${d(J)}`),this.t({type:J,id:ee[1]})}}q(z){const Y=this.b.get(z.channelName);if(!Y){this.u(z);return}const ee=new k.CancellationTokenSource;let oe;try{oe=Y.call(this.j,z.name,z.arg,ee.token)}catch(O){oe=Promise.reject(O)}const J=z.id;oe.then(O=>{this.m({id:J,data:O,type:201}),this.d.delete(z.id)},O=>{O instanceof Error?this.m({id:J,data:{message:O.message,name:O.name,stack:O.stack?O.stack.split?O.stack.split(`
`):O.stack:void 0},type:202}):this.m({id:J,data:O,type:203}),this.d.delete(z.id)});const Q=(0,S.toDisposable)(()=>ee.cancel());this.d.set(z.id,Q)}s(z){const Y=this.b.get(z.channelName);if(!Y){this.u(z);return}const ee=z.id,J=Y.listen(this.j,z.name,z.arg)(Q=>this.m({id:ee,data:Q,type:204}));this.d.set(z.id,J)}t(z){const Y=this.d.get(z.id);Y&&(Y.dispose(),this.d.delete(z.id))}u(z){let Y=this.g.get(z.channelName);Y||(Y=[],this.g.set(z.channelName,Y));const ee=setTimeout(()=>{console.error(`Unknown channel: ${z.channelName}`),z.type===100&&this.m({id:z.id,data:{name:"Unknown channel",message:`Channel name '${z.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Y.push({request:z,timeoutTimer:ee})}v(z){const Y=this.g.get(z);if(Y){for(const ee of Y)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case 100:this.q(ee.request);break;case 102:this.s(ee.request);break}this.g.delete(z)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,S.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=o;var y;(function($){$[$.LocalSide=0]="LocalSide",$[$.OtherSide=1]="OtherSide"})(y=e.RequestInitiator||(e.RequestInitiator={}));class E{constructor(z,Y=null){this.l=z,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new I.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ee=>this.r(ee)),this.j=Y}getChannel(z){const Y=this;return{call(ee,oe,J){return Y.a?Promise.reject(new P.CancellationError):Y.m(z,ee,oe,J)},listen(ee,oe){return Y.a?I.Event.None:Y.n(z,ee,oe)}}}m(z,Y,ee,oe=k.CancellationToken.None){const J=this.g++,O={id:J,type:100,channelName:z,name:Y,arg:ee};if(oe.isCancellationRequested)return Promise.reject(new P.CancellationError);let M;return new Promise((V,X)=>{if(oe.isCancellationRequested)return X(new P.CancellationError);const se=()=>{const le=ue=>{switch(ue.type){case 201:this.f.delete(J),V(ue.data);break;case 202:{this.f.delete(J);const ye=new Error(ue.data.message);ye.stack=Array.isArray(ue.data.stack)?ue.data.stack.join(`
`):ue.data.stack,ye.name=ue.data.name,X(ye);break}case 203:this.f.delete(J),X(ue.data);break}};this.f.set(J,le),this.o(O)};let x=null;this.b===u.Idle?se():(x=(0,i.createCancelablePromise)(le=>this.t()),x.then(()=>{x=null,se()}));const ie=()=>{x?(x.cancel(),x=null):this.o({id:J,type:101}),X(new P.CancellationError)},ne=oe.onCancellationRequested(ie);M=(0,S.combinedDisposable)((0,S.toDisposable)(ie),ne),this.d.add(M)}).finally(()=>{this.d.delete(M)})}n(z,Y,ee){const oe=this.g++,Q={id:oe,type:102,channelName:z,name:Y,arg:ee};let O=null;const M=new I.Emitter({onWillAddFirstListener:()=>{O=(0,i.createCancelablePromise)(V=>this.t()),O.then(()=>{O=null,this.d.add(M),this.o(Q)})},onDidRemoveLastListener:()=>{O?(O.cancel(),O=null):(this.d.delete(M),this.o({id:oe,type:103}))}}),H=V=>M.fire(V.data);return this.f.set(oe,H),M.event}o(z){switch(z.type){case 100:case 102:{const Y=this.p([z.type,z.id,z.channelName,z.name],z.arg);this.j?.logOutgoing(Y,z.id,0,`${d(z.type)}: ${z.channelName}.${z.name}`,z.arg);return}case 101:case 103:{const Y=this.p([z.type,z.id]);this.j?.logOutgoing(Y,z.id,0,d(z.type));return}}}p(z,Y=void 0){const ee=new l;return s(ee,z),s(ee,Y),this.q(ee.buffer)}q(z){try{return this.l.send(z),z.byteLength}catch{return 0}}r(z){const Y=new m(z),ee=c(Y),oe=c(Y),J=ee[0];switch(J){case 200:return this.j?.logIncoming(z.byteLength,0,0,v(J)),this.s({type:ee[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(z.byteLength,ee[1],0,v(J),oe),this.s({type:ee[0],id:ee[1],data:oe})}}s(z){if(z.type===200){this.b=u.Idle,this.k.fire();return}this.f.get(z.id)?.(z)}get onDidInitializePromise(){return I.Event.toPromise(this.onDidInitialize)}t(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,S.dispose)(this.d.values()),this.d.clear()}}pe([L.memoize],E.prototype,"onDidInitializePromise",null),e.ChannelClient=E;class T{get connections(){const z=[];return this.f.forEach(Y=>z.push(Y)),z}constructor(z){this.a=new Map,this.f=new Set,this.g=new I.Emitter,this.onDidAddConnection=this.g.event,this.h=new I.Emitter,this.onDidRemoveConnection=this.h.event,z(({protocol:Y,onDidClientDisconnect:ee})=>{I.Event.once(Y.onMessage)(J=>{const Q=new m(J),O=c(Q),M=new o(Y,O),H=new E(Y);this.a.forEach((X,se)=>M.registerChannel(se,X));const V={channelServer:M,channelClient:H,ctx:O};this.f.add(V),this.g.fire(V),ee(()=>{M.dispose(),H.dispose(),this.f.delete(V),this.h.fire(V)})})})}getChannel(z,Y){const ee=this;return{call(oe,J,Q){let O;if((0,w.isFunction)(Y)){const H=(0,D.getRandomElement)(ee.connections.filter(Y));O=H?Promise.resolve(H):I.Event.toPromise(I.Event.filter(ee.onDidAddConnection,Y))}else O=Y.routeCall(ee,oe,J);const M=O.then(H=>H.channelClient.getChannel(z));return N(M).call(oe,J,Q)},listen(oe,J){if((0,w.isFunction)(Y))return ee.j(z,Y,oe,J);const Q=Y.routeEvent(ee,oe,J).then(O=>O.channelClient.getChannel(z));return N(Q).listen(oe,J)}}}j(z,Y,ee,oe){const J=this;let Q=new S.DisposableStore;const O=new I.Emitter({onWillAddFirstListener:()=>{Q=new S.DisposableStore;const M=new I.EventMultiplexer,H=new Map,V=se=>{const ie=se.channelClient.getChannel(z).listen(ee,oe),ne=M.add(ie);H.set(se,ne)},X=se=>{const x=H.get(se);!x||(x.dispose(),H.delete(se))};J.connections.filter(Y).forEach(V),I.Event.filter(J.onDidAddConnection,Y)(V,void 0,Q),J.onDidRemoveConnection(X,void 0,Q),M.event(O.fire,O,Q),Q.add(M)},onDidRemoveLastListener:()=>{Q.dispose()}});return O.event}registerChannel(z,Y){this.a.set(z,Y),this.f.forEach(ee=>{ee.channelServer.registerChannel(z,Y)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=T;class q{constructor(z,Y,ee=null){const oe=new l;s(oe,Y),z.send(oe.buffer),this.a=new E(z,ee),this.d=new o(z,Y,ee)}getChannel(z){return this.a.getChannel(z)}registerChannel(z,Y){this.d.registerChannel(z,Y)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=q;function N($){return{call(z,Y,ee){return $.then(oe=>oe.call(z,Y,ee))},listen(z,Y){const ee=new I.Relay;return $.then(oe=>ee.input=oe.listen(z,Y)),ee.event}}}e.getDelayedChannel=N;function j($){let z=!1;return{call(Y,ee,oe){return z?$.call(Y,ee,oe):(0,i.timeout)(0).then(()=>z=!0).then(()=>$.call(Y,ee,oe))},listen(Y,ee){if(z)return $.listen(Y,ee);const oe=new I.Relay;return(0,i.timeout)(0).then(()=>z=!0).then(()=>oe.input=$.listen(Y,ee)),oe.event}}}e.getNextTickChannel=j;class F{constructor(z){this.a=z}routeCall(z){return this.b(z)}routeEvent(z){return this.b(z)}async b(z){for(const Y of z.connections)if(await Promise.resolve(this.a(Y.ctx)))return Promise.resolve(Y);return await I.Event.toPromise(z.onDidAddConnection),await this.b(z)}}e.StaticRouter=F;var A;(function($){function z(J,Q){const O=J,M=Q&&Q.disableMarshalling,H=new Map;for(const V in O)ee(V)&&H.set(V,I.Event.buffer(O[V],!0));return new class{listen(V,X,se){const x=H.get(X);if(x)return x;if(oe(X)){const ie=O[X];if(typeof ie=="function")return ie.call(O,se)}throw new Error(`Event not found: ${X}`)}call(V,X,se){const x=O[X];if(typeof x=="function"){if(!M&&Array.isArray(se))for(let ie=0;ie<se.length;ie++)se[ie]=(0,b.revive)(se[ie]);return x.apply(O,se)}throw new Error(`Method not found: ${X}`)}}}$.fromService=z;function Y(J,Q){const O=Q&&Q.disableMarshalling;return new Proxy({},{get(M,H){if(typeof H=="string")return Q?.properties?.has(H)?Q.properties.get(H):oe(H)?function(V){return J.listen(H,V)}:ee(H)?J.listen(H):async function(...V){let X;Q&&!(0,w.isUndefinedOrNull)(Q.context)?X=[Q.context,...V]:X=V;const se=await J.call(H,X);return O?se:(0,b.revive)(se)};throw new Error(`Property not found: ${String(H)}`)}})}$.toService=Y;function ee(J){return J[0]==="o"&&J[1]==="n"&&C.isUpperAsciiLetter(J.charCodeAt(2))}function oe(J){return/^onDynamic/.test(J)&&C.isUpperAsciiLetter(J.charCodeAt(9))}})(A=e.ProxyChannel||(e.ProxyChannel={}));const U=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function B($){if(Array.isArray($))return $;if($&&typeof $=="object"&&typeof $.toString=="function"){const z=$.toString();if(z!=="[object Object]")return z}return $}function G($){return Array.isArray($)?$.map(B):B($)}function W($,z,Y,ee,oe,J,Q){Q=G(Q);const O=U[oe],M=O[ee%O.length];let H=[`%c[${$}]%c[${String(z).padStart(7," ")}]%c[len: ${String(Y).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${J}`,"color: darkgreen","color: grey","color: grey",`color: ${M}`];/\($/.test(J)?(H=H.concat(Q),H.push(")")):H.push(Q),console.log.apply(console,H)}class Z{constructor(z,Y){this.d=z,this.f=Y,this.a=0,this.b=0}logOutgoing(z,Y,ee,oe,J){this.b+=z,W(this.d,this.b,z,Y,ee,oe,J)}logIncoming(z,Y,ee,oe,J){this.a+=z,W(this.f,this.a,z,Y,ee,oe,J)}}e.IPCLogger=Z}),define(re[147],ae([0,1,17,3,39]),function(_,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class k{constructor(I){this.a=I,this.onMessage=i.Event.fromDOMEventEmitter(this.a,"message",S=>D.VSBuffer.wrap(S.data)),I.start()}send(I){this.a.postMessage(I.buffer)}disconnect(){this.a.close()}}e.Protocol=k;class L extends R.IPCClient{constructor(I,S){const b=new k(I);super(b,S),this.b=b}dispose(){this.b.disconnect()}}e.Client=L}),define(re[92],ae([0,1,17,3,2,39]),function(_,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var L;(function(a){a.Created="created",a.Read="read",a.Write="write",a.Open="open",a.Error="error",a.Close="close",a.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",a.NodeEndReceived="nodeEndReceived",a.NodeEndSent="nodeEndSent",a.NodeDrainBegin="nodeDrainBegin",a.NodeDrainEnd="nodeDrainEnd",a.zlibInflateError="zlibInflateError",a.zlibInflateData="zlibInflateData",a.zlibInflateInitialWrite="zlibInflateInitialWrite",a.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",a.zlibInflateWrite="zlibInflateWrite",a.zlibInflateFlushFired="zlibInflateFlushFired",a.zlibDeflateError="zlibDeflateError",a.zlibDeflateData="zlibDeflateData",a.zlibDeflateWrite="zlibDeflateWrite",a.zlibDeflateFlushFired="zlibDeflateFlushFired",a.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",a.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",a.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",a.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",a.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",a.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",a.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",a.ProtocolHeaderRead="protocolHeaderRead",a.ProtocolMessageRead="protocolMessageRead",a.ProtocolHeaderWrite="protocolHeaderWrite",a.ProtocolMessageWrite="protocolMessageWrite",a.ProtocolWrite="protocolWrite"})(L=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var P;(function(a){a.enableDiagnostics=!1,a.records=[];const s=new WeakMap;let c=0;function o(E,T){if(!s.has(E)){const q=String(++c);s.set(E,q)}return s.get(E)}function y(E,T,q,N){if(!a.enableDiagnostics)return;const j=o(E,T);if(N instanceof D.VSBuffer||N instanceof Uint8Array||N instanceof ArrayBuffer||ArrayBuffer.isView(N)){const F=D.VSBuffer.alloc(N.byteLength);F.set(N),a.records.push({timestamp:Date.now(),id:j,label:T,type:q,buff:F})}else a.records.push({timestamp:Date.now(),id:j,label:T,type:q,data:N})}a.traceSocketEvent=y})(P=e.SocketDiagnostics||(e.SocketDiagnostics={}));var I;(function(a){a[a.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",a[a.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(I=e.SocketCloseEventType||(e.SocketCloseEventType={}));let S=null;function b(){return S||(S=D.VSBuffer.alloc(0)),S}class C{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(s){this.a.push(s),this.b+=s.byteLength}read(s){return this.c(s,!0)}peek(s){return this.c(s,!1)}c(s,c){if(s===0)return b();if(s>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===s){const T=this.a[0];return c&&(this.a.shift(),this.b-=s),T}if(this.a[0].byteLength>s){const T=this.a[0].slice(0,s);return c&&(this.a[0]=this.a[0].slice(s),this.b-=s),T}const o=D.VSBuffer.alloc(s);let y=0,E=0;for(;s>0;){const T=this.a[E];if(T.byteLength>s){const q=T.slice(0,s);o.set(q,y),y+=s,c&&(this.a[E]=T.slice(s),this.b-=s),s-=s}else o.set(T,y),y+=T.byteLength,c?(this.a.shift(),this.b-=T.byteLength):E++,s-=T.byteLength}return o}}e.ChunkStream=C;var w;(function(a){a[a.None=0]="None",a[a.Regular=1]="Regular",a[a.Control=2]="Control",a[a.Ack=3]="Ack",a[a.Disconnect=5]="Disconnect",a[a.ReplayRequest=6]="ReplayRequest",a[a.Pause=7]="Pause",a[a.Resume=8]="Resume",a[a.KeepAlive=9]="KeepAlive"})(w||(w={}));function p(a){switch(a){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var d;(function(a){a[a.HeaderLength=13]="HeaderLength",a[a.AcknowledgeTime=2e3]="AcknowledgeTime",a[a.TimeoutTime=2e4]="TimeoutTime",a[a.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",a[a.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(d=e.ProtocolConstants||(e.ProtocolConstants={}));class g{constructor(s,c,o,y){this.type=s,this.id=c,this.ack=o,this.data=y,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends R.Disposable{constructor(s){super(),this.f=this.B(new i.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=s,this.b=!1,this.c=new C,this.B(this.a.onData(c=>this.acceptChunk(c))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(s);this.c.byteLength>=this.g.readLen;){const c=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=c.readUInt32BE(9),this.g.messageType=c.readUInt8(0),this.g.id=c.readUInt32BE(1),this.g.ack=c.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:p(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const o=this.g.messageType,y=this.g.id,E=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",c),this.f.fire(new g(o,y,E,c)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class u{constructor(s){this.k=null,this.a=!1,this.b=!1,this.c=s,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(s){if(this.a)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const c=D.VSBuffer.alloc(13);c.writeUInt8(s.type,0),c.writeUInt32BE(s.id,1),c.writeUInt32BE(s.ack,5),c.writeUInt32BE(s.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:p(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",s.data),this.j(c,s.data)}g(s,c){const o=this.f===0;return this.d.push(s,c),this.f+=s.byteLength+c.byteLength,o}h(){const s=D.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,s}j(s,c){this.g(s,c)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const s=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this.c.write(s)}}class m extends R.Disposable{constructor(s){super(),this.f=new i.Emitter,this.onMessage=this.f.event,this.g=new i.Emitter,this.onDidDispose=this.g.event,this.a=s,this.b=this.B(new u(this.a)),this.c=this.B(new v(this.a)),this.B(this.c.onMessage(c=>{c.type===1&&this.f.fire(c.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(s){this.b.write(new g(1,0,0,s))}}e.Protocol=m;class l extends k.IPCClient{static fromSocket(s,c){return new l(new m(s),c)}get onDidDispose(){return this.b.onDidDispose}constructor(s,c,o=null){super(s,c,o),this.b=s}dispose(){super.dispose();const s=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),s.end()}}e.Client=l;class h{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new i.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(s){this.b?this.d.length>0?this.d.push(s):this.a.fire(s):this.d.push(s)}flushBuffer(){this.d=[]}}e.BufferedEmitter=h;class f{constructor(s){this.data=s,this.next=null}}class n{constructor(){this.a=null,this.b=null}length(){let s=0,c=this.a;for(;c;)c=c.next,s++;return s}peek(){return this.a?this.a.data:null}toArray(){const s=[];let c=0,o=this.a;for(;o;)s[c++]=o.data,o=o.next;return s}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(s){const c=new f(s);if(!this.a){this.a=c,this.b=c;return}this.b.next=c,this.b=c}}class r{static getInstance(){return r.b||(r.b=new r),r.b}constructor(){this.c=[];const s=Date.now();for(let c=0;c<r.a;c++)this.c[c]=s-1e3*c;setInterval(()=>{for(let c=r.a;c>=1;c--)this.c[c]=this.c[c-1];this.c[0]=Date.now()},1e3)}d(){const s=Date.now(),c=(1+r.a)*1e3;let o=0;for(let y=0;y<r.a;y++)s-this.c[y]<=c&&o++;return 1-o/r.a}hasHighLoad(){return this.d()>=.5}}r.a=10,r.b=null;class t{get unacknowledgedCount(){return this.c-this.d}constructor(s,c=null,o=r.getInstance()){this.t=new h,this.onControlMessage=this.t.event,this.u=new h,this.onMessage=this.u.event,this.v=new h,this.onDidDispose=this.v.event,this.w=new h,this.onSocketClose=this.w.event,this.x=new h,this.onSocketTimeout=this.x.event,this.s=o,this.a=!1,this.b=new n,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=[],this.o=s,this.p=new u(this.o),this.r.push(this.p),this.q=new v(this.o),this.r.push(this.q),this.r.push(this.q.onMessage(y=>this.y(y))),this.r.push(this.o.onClose(y=>this.w.fire(y))),c&&this.q.acceptChunk(c),this.l=setInterval(()=>{this.C()},5e3)}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r=(0,R.dispose)(this.r)}drain(){return this.p.drain()}sendDisconnect(){const s=new g(5,0,0,b());this.p.write(s),this.p.flush()}sendPause(){const s=new g(7,0,0,b());this.p.write(s)}sendResume(){const s=new g(8,0,0,b());this.p.write(s)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(s,c){this.a=!0,this.r=(0,R.dispose)(this.r),this.t.flushBuffer(),this.w.flushBuffer(),this.x.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=s,this.p=new u(this.o),this.r.push(this.p),this.q=new v(this.o),this.r.push(this.q),this.r.push(this.q.onMessage(o=>this.y(o))),this.r.push(this.o.onClose(o=>this.w.fire(o))),this.q.acceptChunk(c)}endAcceptReconnection(){this.a=!1,this.h=this.g;const s=new g(3,0,this.h,b());this.p.write(s);const c=this.b.toArray();for(let o=0,y=c.length;o<y;o++)this.p.write(c[o]);this.A()}acceptDisconnect(){this.v.fire()}y(s){if(s.ack>this.d){this.d=s.ack;do{const c=this.b.peek();if(c&&c.id<=s.ack)this.b.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this.g)if(s.id!==this.g+1){const c=Date.now();c-this.m>1e4&&(this.m=c,this.p.write(new g(6,0,0,b())))}else this.g=s.id,this.j=Date.now(),this.z(),this.u.fire(s.data);break}case 2:{this.t.fire(s.data);break}case 3:break;case 5:{this.v.fire();break}case 6:{const c=this.b.toArray();for(let o=0,y=c.length;o<y;o++)this.p.write(c[o]);this.A();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(s){const c=++this.c;this.h=this.g;const o=new g(1,c,this.h,s);this.b.push(o),this.a||(this.p.write(o),this.A())}sendControl(s){const c=new g(2,0,0,s);this.p.write(c)}z(){if(this.g<=this.h||this.k)return;const s=Date.now()-this.j;if(s>=2e3){this.B();return}this.k=setTimeout(()=>{this.k=null,this.z()},2e3-s+5)}A(){if(this.c<=this.d||this.f||this.a)return;const s=this.b.peek(),c=Date.now()-s.writtenTime,o=Date.now()-this.q.lastReadTime,y=Date.now()-this.n;if(c>=2e4&&o>=2e4&&y>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.x.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:c,timeSinceLastReceivedSomeData:o});return}const E=Math.max(2e4-c,2e4-o,2e4-y,500);this.f=setTimeout(()=>{this.f=null,this.A()},E)}B(){if(this.g<=this.h)return;this.h=this.g;const s=new g(3,0,this.h,b());this.p.write(s)}C(){const s=new g(9,0,0,b());this.p.write(s)}}e.PersistentProtocol=t}),define(re[148],ae([0,1,93,3,39,147]),function(_,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class L extends R.IPCServer{static b(){const I=i.Event.fromNodeEventEmitter(D.ipcRenderer,"vscode:createMessageChannel",(S,b)=>b);return i.Event.map(I,S=>{const{port1:b,port2:C}=new MessageChannel,p={protocol:new k.Protocol(b),onDidClientDisconnect:i.Event.fromDOMEventEmitter(b,"close")};return D.ipcRenderer.postMessage("vscode:createMessageChannelResult",S,[C]),p})}constructor(){super(L.b())}}e.Server=L}),define(re[68],ae([0,1,50,6,17,21,141,9,3,2,32,91,87,39]),function(_,e,D,i,R,k,L,P,I,S,b,C,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends p.ChannelServer{constructor(u){super({send:m=>{try{process.send?.(m.buffer.toString("base64"))}catch{}},onMessage:I.Event.fromNodeEventEmitter(process,"message",m=>R.VSBuffer.wrap(Buffer.from(m,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.Server=d;class g{constructor(u,m){this.i=u,this.j=m,this.c=new Set,this.g=new Map,this.h=new I.Emitter,this.onDidProcessExit=this.h.event;const l=m&&m.timeout?m.timeout:6e4;this.b=new i.Delayer(l),this.d=null,this.f=null}getChannel(u){const m=this;return{call(l,h,f){return m.k(u,l,h,f)},listen(l,h){return m.l(u,l,h)}}}k(u,m,l,h=k.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(h.isCancellationRequested)return Promise.reject(P.canceled());this.b.cancel();const f=this.n(u),n=(0,i.createCancelablePromise)(a=>f.call(m,l,a)),r=h.onCancellationRequested(()=>n.cancel()),t=(0,S.toDisposable)(()=>n.cancel());return this.c.add(t),n.finally(()=>{r.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),n}l(u,m,l){if(!this.b)return I.Event.None;this.b.cancel();let h;const f=new I.Emitter({onWillAddFirstListener:()=>{h=this.n(u).listen(m,l)(f.fire,f),this.c.add(h)},onDidRemoveLastListener:()=>{this.c.delete(h),h.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return f.event}get m(){if(!this.f){const u=this.j&&this.j.args?this.j.args:[],m=Object.create(null);m.env={...(0,b.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(m.env={...m.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(m.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s))),(0,w.removeDangerousEnvVariables)(m.env),this.d=(0,D.fork)(this.i,u,m);const l=new I.Emitter;I.Event.fromNodeEventEmitter(this.d,"message",s=>s)(s=>{if((0,L.isRemoteConsoleLog)(s)){(0,L.log)(s,`IPC Library: ${this.j.serverName}`);return}l.fire(R.VSBuffer.wrap(Buffer.from(s,"base64")))});const f=this.j.useQueue?(0,C.createQueuedSender)(this.d):this.d,n=s=>this.d&&this.d.connected&&f.send(s.buffer.toString("base64")),r=l.event,t={send:n,onMessage:r};this.f=new p.ChannelClient(t);const a=()=>this.o();process.once("exit",a),this.d.on("error",s=>console.warn('IPC "'+this.j.serverName+'" errored with '+s)),this.d.on("exit",(s,c)=>{process.removeListener("exit",a),this.c.forEach(o=>(0,S.dispose)(o)),this.c.clear(),s!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+s+" and signal "+c),this.b?.cancel(),this.o(),this.h.fire({code:s,signal:c})})}return this.f}n(u){let m=this.g.get(u);return m||(m=this.m.getChannel(u),this.g.set(u,m)),m}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=g}),define(re[149],ae([0,1,17,9,3,2,12,5,31,39,92]),function(_,e,D,i,R,k,L,P,I,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function C(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class w{traceSocketEvent(o,y){b.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,o,y)}constructor(o,y=""){this.f=!0,this.debugLabel=y,this.socket=o,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=E=>{if(this.traceSocketEvent("error",{code:E?.code,message:E?.message}),E){if(E.code==="EPIPE")return;(0,i.onUnexpectedError)(E)}},this.socket.on("error",this.a),this.b=E=>{this.traceSocketEvent("close",{hadError:E}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(o){const y=E=>{this.traceSocketEvent("read",E),o(D.VSBuffer.wrap(E))};return this.socket.on("data",y),{dispose:()=>this.socket.off("data",y)}}onClose(o){const y=E=>{o({type:0,hadError:E,error:void 0})};return this.socket.on("close",y),{dispose:()=>this.socket.off("close",y)}}onEnd(o){const y=()=>{o()};return this.socket.on("end",y),{dispose:()=>this.socket.off("end",y)}}write(o){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",o),this.socket.write(o.buffer,y=>{if(y){if(y.code==="EPIPE")return;(0,i.onUnexpectedError)(y)}})}catch(y){if(y.code==="EPIPE")return;(0,i.onUnexpectedError)(y)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((o,y)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),o();return}const E=()=>{this.socket.off("close",E),this.socket.off("end",E),this.socket.off("error",E),this.socket.off("timeout",E),this.socket.off("drain",E),this.traceSocketEvent("nodeDrainEnd"),o()};this.socket.on("close",E),this.socket.on("end",E),this.socket.on("error",E),this.socket.on("timeout",E),this.socket.on("drain",E)})}}e.NodeSocket=w;var p;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize"})(p||(p={}));var d;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(d||(d={}));class g extends k.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(o,y){this.socket.traceSocketEvent(o,y)}constructor(o,y,E,T){super(),this.f=this.B(new R.Emitter),this.g=this.B(new R.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=o,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:y,inflateBytesLength:E?.byteLength||0,recordInflateBytes:T}),this.a=this.B(new v(this,y,E,T,this.f,(q,N)=>this.k(q,N))),this.B(this.a.onError(q=>{console.error(q),(0,i.onUnexpectedError)(q),this.g.fire({type:0,hadError:!0,error:q})})),this.b=new b.ChunkStream,this.B(this.socket.onData(q=>this.l(q))),this.B(this.socket.onClose(q=>this.g.fire(q)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(o){return this.f.event(o)}onClose(o){return this.g.event(o)}onEnd(o){return this.socket.onEnd(o)}write(o){this.a.writeMessage(o)}k(o,y){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",o);let E=2;o.byteLength<126?E+=0:o.byteLength<2**16?E+=2:E+=8;const T=D.VSBuffer.alloc(E);if(y?T.writeUInt8(194,0):T.writeUInt8(130,0),o.byteLength<126)T.writeUInt8(o.byteLength,1);else if(o.byteLength<2**16){T.writeUInt8(126,1);let q=1;T.writeUInt8(o.byteLength>>>8&255,++q),T.writeUInt8(o.byteLength>>>0&255,++q)}else{T.writeUInt8(127,1);let q=1;T.writeUInt8(0,++q),T.writeUInt8(0,++q),T.writeUInt8(0,++q),T.writeUInt8(0,++q),T.writeUInt8(o.byteLength>>>24&255,++q),T.writeUInt8(o.byteLength>>>16&255,++q),T.writeUInt8(o.byteLength>>>8&255,++q),T.writeUInt8(o.byteLength>>>0&255,++q)}this.socket.write(D.VSBuffer.concat([T,o]))}end(){this.h=!0,this.socket.end()}l(o){if(o.byteLength!==0){for(this.b.acceptChunk(o);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const y=this.b.peek(this.j.readLen),E=y.readUInt8(0),T=(E&128)>>>7,q=(E&64)>>>6,N=y.readUInt8(1),j=(N&128)>>>7,F=N&127;this.j.state=2,this.j.readLen=2+(j?4:0)+(F===126?2:0)+(F===127?8:0),this.j.fin=T,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(q)),this.j.firstFrameOfMessage=Boolean(T),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const y=this.b.read(this.j.readLen),E=y.readUInt8(1),T=(E&128)>>>7;let q=E&127,N=1;q===126?q=y.readUInt8(++N)*2**8+y.readUInt8(++N):q===127&&(q=y.readUInt8(++N)*0+y.readUInt8(++N)*0+y.readUInt8(++N)*0+y.readUInt8(++N)*0+y.readUInt8(++N)*2**24+y.readUInt8(++N)*2**16+y.readUInt8(++N)*2**8+y.readUInt8(++N));let j=0;T&&(j=y.readUInt8(++N)*2**24+y.readUInt8(++N)*2**16+y.readUInt8(++N)*2**8+y.readUInt8(++N)),this.j.state=3,this.j.readLen=q,this.j.mask=j,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const y=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",y),l(y,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",y),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(y,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await R.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=g;class v extends k.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:D.VSBuffer.alloc(0)}constructor(o,y,E,T,q,N){super(),this.k=o,this.l=q,this.m=N,this.a=this.B(new R.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new R.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,y?(this.b=this.B(new u(this.k,T,E,{windowBits:15})),this.f=this.B(new m(this.k,{windowBits:15})),this.B(this.b.onError(j=>this.a.fire(j))),this.B(this.f.onError(j=>this.a.fire(j)))):(this.b=null,this.f=null)}writeMessage(o){this.g.push(o),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const o=this.g.shift();if(this.f){const y=await this.r(this.f,o);this.m(y,!0)}else this.m(o,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(o,y){return new Promise((E,T)=>{o.write(y),o.flush(q=>E(q))})}acceptFrame(o,y,E){this.h.push({data:o,isCompressed:y,isLastFrameOfMessage:E}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const o=this.h.shift();if(this.b&&o.isCompressed){const y=await this.u(this.b,o.data,o.isLastFrameOfMessage);this.l.fire(y)}else this.l.fire(o.data)}this.s=!1}}u(o,y,E){return new Promise((T,q)=>{o.write(y),E&&o.write(D.VSBuffer.fromByteArray([0,0,255,255])),o.flush(N=>T(N))})}}class u extends k.Disposable{get recordedInflateBytes(){return this.j?D.VSBuffer.concat(this.f):D.VSBuffer.alloc(0)}constructor(o,y,E,T){super(),this.h=o,this.j=y,this.a=this.B(new R.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=C().zlib.createInflateRaw(T),this.b.on("error",q=>{this.h.traceSocketEvent("zlibInflateError",{message:q?.message,code:q?.code}),this.a.fire(q)}),this.b.on("data",q=>{this.h.traceSocketEvent("zlibInflateData",q),this.g.push(D.VSBuffer.wrap(q))}),E&&(this.h.traceSocketEvent("zlibInflateInitialWrite",E.buffer),this.b.write(E.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(o){this.j&&this.f.push(o.clone()),this.h.traceSocketEvent("zlibInflateWrite",o),this.b.write(o.buffer)}flush(o){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const y=D.VSBuffer.concat(this.g);this.g.length=0,o(y)})}}class m extends k.Disposable{constructor(o,y){super(),this.g=o,this.a=this.B(new R.Emitter),this.onError=this.a.event,this.f=[],this.b=C().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",E=>{this.g.traceSocketEvent("zlibDeflateError",{message:E?.message,code:E?.code}),this.a.fire(E)}),this.b.on("data",E=>{this.g.traceSocketEvent("zlibDeflateData",E),this.f.push(D.VSBuffer.wrap(E))})}write(o){this.g.traceSocketEvent("zlibDeflateWrite",o.buffer),this.b.write(o.buffer)}flush(o){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let y=D.VSBuffer.concat(this.f);this.f.length=0,y=y.slice(0,y.byteLength-4),o(y)})}}function l(c,o){if(o===0)return;const y=c.byteLength>>>2;for(let F=0;F<y;F++){const A=c.readUInt32BE(F*4);c.writeUInt32BE(A^o,F*4)}const E=y*4,T=c.byteLength-E,q=o>>>24&255,N=o>>>16&255,j=o>>>8&255;T>=1&&c.writeUInt8(c.readUInt8(E)^q,E),T>=2&&c.writeUInt8(c.readUInt8(E+1)^N,E+1),T>=3&&c.writeUInt8(c.readUInt8(E+2)^j,E+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const h={[2]:107,[1]:103};function f(){const c=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;let o;return e.XDG_RUNTIME_DIR?o=(0,L.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${c}.sock`):o=(0,L.join)(C().os.tmpdir(),`vscode-ipc-${c}.sock`),r(o),o}e.createRandomIPCHandle=f;function n(c,o,y){const E=C().crypto.createHash("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${E}-${y}-${o}-sock`;let T;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?T=(0,L.join)(e.XDG_RUNTIME_DIR,`vscode-${E.substr(0,8)}-${y}-${o}.sock`):T=(0,L.join)(c,`${y}-${o}.sock`),r(T),T}e.createStaticIPCHandle=n;function r(c){const o=h[P.platform];typeof o=="number"&&c.length>=o&&console.warn(`WARNING: IPC handle "${c}" is longer than ${o} chars, try a shorter --user-data-dir`)}class t extends S.IPCServer{static b(o){const y=R.Event.fromNodeEventEmitter(o,"connection");return R.Event.map(y,E=>({protocol:new b.Protocol(new w(E,"ipc-server-connection")),onDidClientDisconnect:R.Event.once(R.Event.fromNodeEventEmitter(E,"close"))}))}constructor(o){super(t.b(o)),this.d=o}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=t;function a(c){return new Promise((o,y)=>{const E=C().net.createServer();E.on("error",y),E.listen(c,()=>{E.removeListener("error",y),o(new t(E))})})}e.serve=a;function s(c,o){return new Promise((y,E)=>{const T=C().net.createConnection(c,()=>{T.removeListener("error",E),y(b.Client.fromSocket(new w(T,`ipc-client${o}`),o))});T.once("error",E)})}e.connect=s}),define(re[69],ae([0,1,6,3,2,15]),function(_,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var L;(function(C){C[C.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(L=e.StorageHint||(e.StorageHint={}));function P(C){const w=C;return w?.changed instanceof Map||w?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var I;(function(C){C[C.None=0]="None",C[C.Initialized=1]="Initialized",C[C.Closed=2]="Closed"})(I=e.StorageState||(e.StorageState={}));class S extends R.Disposable{constructor(w,p=Object.create(null)){super(),this.m=w,this.n=p,this.b=this.B(new i.Emitter),this.onDidChangeStorage=this.b.event,this.c=I.None,this.f=new Map,this.g=new D.ThrottledDelayer(S.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(w=>this.r(w)))}r(w){w.changed?.forEach((p,d)=>this.s(d,p)),w.deleted?.forEach(p=>this.s(p,void 0))}s(w,p){if(this.c===I.Closed)return;let d=!1;(0,k.isUndefinedOrNull)(p)?d=this.f.delete(w):this.f.get(w)!==p&&(this.f.set(w,p),d=!0),d&&this.b.fire(w)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===I.None&&(this.c=I.Initialized,this.n.hint!==L.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(w,p){const d=this.f.get(w);return(0,k.isUndefinedOrNull)(d)?p:d}getBoolean(w,p){const d=this.get(w);return(0,k.isUndefinedOrNull)(d)?p:d==="true"}getNumber(w,p){const d=this.get(w);return(0,k.isUndefinedOrNull)(d)?p:parseInt(d,10)}async set(w,p){if(this.c===I.Closed)return;if((0,k.isUndefinedOrNull)(p))return this.delete(w);const d=String(p);if(this.f.get(w)!==d)return this.f.set(w,d),this.j.set(w,d),this.h.delete(w),this.b.fire(w),this.w()}async delete(w){if(!(this.c===I.Closed||!this.f.delete(w)))return this.h.has(w)||this.h.add(w),this.j.delete(w),this.b.fire(w),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=I.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const w={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(w).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(w){if(!!this.u)return this.w(w)}async w(w){return this.g.trigger(()=>this.v(),w)}async whenFlushed(){if(!!this.u)return new Promise(w=>this.l.push(w))}dispose(){this.g.dispose(),super.dispose()}}e.Storage=S,S.a=100;class b{constructor(){this.onDidChangeItemsExternal=i.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(w){w.insert?.forEach((p,d)=>this.a.set(d,p)),w.delete?.forEach(p=>this.a.delete(p))}async close(){}}e.InMemoryStorageDatabase=b}),define(re[150],ae([10,11]),function(_,e){return _.create("vs/base/node/zip",e)}),define(re[151],ae([10,11]),function(_,e){return _.create("vs/platform/configuration/common/configurationRegistry",e)}),define(re[152],ae([10,11]),function(_,e){return _.create("vs/platform/environment/node/argv",e)}),define(re[153],ae([10,11]),function(_,e){return _.create("vs/platform/environment/node/argvHelper",e)}),define(re[154],ae([10,11]),function(_,e){return _.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(re[155],ae([10,11]),function(_,e){return _.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(re[156],ae([10,11]),function(_,e){return _.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(re[157],ae([10,11]),function(_,e){return _.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(re[158],ae([10,11]),function(_,e){return _.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(re[159],ae([10,11]),function(_,e){return _.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(re[160],ae([10,11]),function(_,e){return _.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(re[161],ae([10,11]),function(_,e){return _.create("vs/platform/extensions/common/extensionValidator",e)}),define(re[162],ae([10,11]),function(_,e){return _.create("vs/platform/files/common/fileService",e)}),define(re[163],ae([10,11]),function(_,e){return _.create("vs/platform/files/common/files",e)}),define(re[164],ae([10,11]),function(_,e){return _.create("vs/platform/files/common/io",e)}),define(re[165],ae([10,11]),function(_,e){return _.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(re[166],ae([10,11]),function(_,e){return _.create("vs/platform/languagePacks/common/languagePacks",e)}),define(re[167],ae([10,11]),function(_,e){return _.create("vs/platform/remoteTunnel/electron-browser/remoteTunnelService",e)}),define(re[168],ae([10,11]),function(_,e){return _.create("vs/platform/request/common/request",e)}),define(re[169],ae([10,11]),function(_,e){return _.create("vs/platform/shell/node/shellEnv",e)}),define(re[170],ae([10,11]),function(_,e){return _.create("vs/platform/telemetry/common/telemetryService",e)}),define(re[171],ae([10,11]),function(_,e){return _.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(re[172],ae([10,11]),function(_,e){return _.create("vs/platform/terminal/common/terminalProfiles",e)}),define(re[173],ae([10,11]),function(_,e){return _.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(re[174],ae([10,11]),function(_,e){return _.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(re[175],ae([10,11]),function(_,e){return _.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(re[176],ae([10,11]),function(_,e){return _.create("vs/platform/userDataSync/common/settingsSync",e)}),define(re[177],ae([10,11]),function(_,e){return _.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(re[178],ae([10,11]),function(_,e){return _.create("vs/platform/userDataSync/common/userDataSync",e)}),define(re[179],ae([10,11]),function(_,e){return _.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(re[180],ae([10,11]),function(_,e){return _.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(re[181],ae([10,11]),function(_,e){return _.create("vs/platform/workspace/common/workspace",e)}),define(re[94],ae([0,1,65,63,25,12,36,22,8]),function(_,e,D,i,R,k,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class S{get appRoot(){return(0,k.dirname)(R.FileAccess.asFileUri("").fsPath)}get userHome(){return I.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return I.URI.file((0,k.join)(this.userDataPath,"User"))}get tmpDir(){return I.URI.file(this.b.tmpDir)}get cacheHome(){return I.URI.file(this.userDataPath)}get stateResource(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const g=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,k.join)(this.userDataPath,"logs",g)}return this.args.logsPath}get userDataSyncLogResource(){return I.URI.file((0,k.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return I.URI.file((0,k.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(I.URI.file((0,k.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=L.env.VSCODE_PORTABLE;return g?I.URI.file((0,k.join)(g,"argv.json")):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return I.URI.file((0,k.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,k.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?(0,k.resolve)(g):(0,k.normalize)((0,k.join)(R.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const g=this.args["extensions-download-dir"];return g?I.URI.file((0,k.resolve)(g)):I.URI.file((0,k.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return(0,k.resolve)(g);const v=L.env.VSCODE_EXTENSIONS;if(v)return v;const u=L.env.VSCODE_PORTABLE;return u?(0,k.join)(u,"extensions"):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(v=>/^[^:/?#]+?:\/\//.test(v)?I.URI.parse(v):I.URI.file((0,k.normalize)(v)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?I.URI.parse(g):I.URI.file((0,k.normalize)(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return b(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!L.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(g=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(g))}get extensionLogLevel(){const g=[];for(const v of this.args.log||[]){const u=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(v);u&&u[1]&&u[2]&&g.push([u[1],u[2]])}return g.length?g:void 0}get serviceMachineIdResource(){return(0,P.joinPath)(I.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return I.URI.file((0,k.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const g=L.env.VSCODE_PORTABLE;return g?I.URI.file((0,k.join)(g,"policy.json")):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(g){this.args.continueOn=g}get args(){return this.a}constructor(g,v,u){this.a=g,this.b=v,this.c=u,this.editSessionId=this.args.editSessionId}}pe([i.memoize],S.prototype,"appRoot",null),pe([i.memoize],S.prototype,"userHome",null),pe([i.memoize],S.prototype,"userDataPath",null),pe([i.memoize],S.prototype,"appSettingsHome",null),pe([i.memoize],S.prototype,"tmpDir",null),pe([i.memoize],S.prototype,"cacheHome",null),pe([i.memoize],S.prototype,"stateResource",null),pe([i.memoize],S.prototype,"userRoamingDataHome",null),pe([i.memoize],S.prototype,"userDataSyncHome",null),pe([i.memoize],S.prototype,"userDataSyncLogResource",null),pe([i.memoize],S.prototype,"editSessionsLogResource",null),pe([i.memoize],S.prototype,"sync",null),pe([i.memoize],S.prototype,"machineSettingsResource",null),pe([i.memoize],S.prototype,"workspaceStorageHome",null),pe([i.memoize],S.prototype,"localHistoryHome",null),pe([i.memoize],S.prototype,"keyboardLayoutResource",null),pe([i.memoize],S.prototype,"argvResource",null),pe([i.memoize],S.prototype,"isExtensionDevelopment",null),pe([i.memoize],S.prototype,"untitledWorkspacesHome",null),pe([i.memoize],S.prototype,"installSourcePath",null),pe([i.memoize],S.prototype,"builtinExtensionsPath",null),pe([i.memoize],S.prototype,"extensionsPath",null),pe([i.memoize],S.prototype,"extensionDevelopmentLocationURI",null),pe([i.memoize],S.prototype,"extensionDevelopmentKind",null),pe([i.memoize],S.prototype,"extensionTestsLocationURI",null),pe([i.memoize],S.prototype,"debugExtensionHost",null),pe([i.memoize],S.prototype,"logLevel",null),pe([i.memoize],S.prototype,"extensionLogLevel",null),pe([i.memoize],S.prototype,"serviceMachineIdResource",null),pe([i.memoize],S.prototype,"telemetryLogResource",null),pe([i.memoize],S.prototype,"disableWorkspaceTrust",null),pe([i.memoize],S.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=S;function b(d,g){return p(d["inspect-extensions"],d["inspect-brk-extensions"],5870,g,d.debugId,d.extensionEnvironment)}e.parseExtensionHostPort=b;function C(d,g){return p(d["inspect-search"],d["inspect-brk-search"],5876,g,d.extensionEnvironment)}e.parseSearchPort=C;function w(d,g){return p(d["inspect-ptyhost"],d["inspect-brk-ptyhost"],5877,g,d.extensionEnvironment)}e.parsePtyHostPort=w;function p(d,g,v,u,m,l){const f=Number(g||d)||(u?null:v),n=f?Boolean(!!g):!1;let r;if(l)try{r=JSON.parse(l)}catch{}return{port:f,break:n,debugId:m,env:r}}}),define(re[182],ae([0,1,283,5,152]),function(_,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const k={o:(0,R.localize)(0,null),e:(0,R.localize)(1,null),t:(0,R.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,R.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,R.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,R.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,R.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,R.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,R.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,R.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,R.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,R.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,R.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,R.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,R.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,R.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,R.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,R.localize)(17,null)},category:{type:"string",cat:"e",description:(0,R.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,R.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,R.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,R.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,R.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,R.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,R.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,R.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,R.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,R.localize)(27,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,R.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,R.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,R.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,R.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,R.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,R.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,R.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,R.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const L={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(g,v,u=L){const m=g.find(c=>c.length>0&&c[0]!=="-"),l={},h=["_"],f=[],n={};let r;for(const c in v){const o=v[c];o.type==="subcommand"?c===m&&(r=o):(o.alias&&(l[c]=o.alias),o.type==="string"||o.type==="string[]"?(h.push(c),o.deprecates&&h.push(...o.deprecates)):o.type==="boolean"&&(f.push(c),o.deprecates&&f.push(...o.deprecates)),o.global&&(n[c]=o))}if(r&&m){const c=n;for(const T in r.options)c[T]=r.options[T];const o=g.filter(T=>T!==m),y=u.getSubcommandReporter?u.getSubcommandReporter(m):void 0,E=P(o,c,y);return{[m]:E,_:[]}}const t=D(g,{string:h,boolean:f,alias:l}),a={},s=t;a._=t._.map(c=>String(c)).filter(c=>c.length>0),delete s._;for(const c in v){const o=v[c];if(o.type==="subcommand")continue;o.alias&&delete s[o.alias];let y=s[c];if(o.deprecates)for(const E of o.deprecates)s.hasOwnProperty(E)&&(y||(y=s[E],y&&u.onDeprecatedOption(E,o.deprecationMessage||(0,R.localize)(36,null,c))),delete s[E]);if(typeof y<"u"){if(o.type==="string[]"){if(Array.isArray(y)||(y=[y]),!o.allowEmptyValue){const E=y.filter(T=>T.length>0);E.length!==y.length&&(u.onEmptyValue(c),y=E.length>0?E:void 0)}}else o.type==="string"&&(Array.isArray(y)?(y=y.pop(),u.onMultipleValues(c,y)):!y&&!o.allowEmptyValue&&(u.onEmptyValue(c),y=void 0));a[c]=y,o.deprecationMessage&&u.onDeprecatedOption(c,o.deprecationMessage)}delete s[c]}for(const c in s)u.onUnknownOption(c);return a}e.parseArgs=P;function I(g,v){let u="";return v.args&&(Array.isArray(v.args)?u=` <${v.args.join("> <")}>`:u=` <${v.args}>`),v.alias?`-${v.alias} --${g}${u}`:`--${g}${u}`}function S(g,v){const u=[];for(const m in g){const l=g[m],h=I(m,l);u.push([h,l.description])}return b(u,v)}e.formatOptions=S;function b(g,v){const m=g.reduce((f,n)=>Math.max(f,n[0].length),12)+2+1;if(v-m<25)return g.reduce((f,n)=>f.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);const l=v-m-1,h=[];for(const f of g){const n=f[0],r=w(f[1],l),t=C(m-n.length-2);h.push("  "+n+t+r[0]);for(let a=1;a<r.length;a++)h.push(C(m)+r[a])}return h}function C(g){return" ".repeat(g)}function w(g,v){const u=[];for(;g.length;){const m=g.length<v?g.length:g.lastIndexOf(" ",v),l=g.slice(0,m).trim();g=g.slice(m),u.push(l)}return u}function p(g,v,u,m,l){const h=process.stdout.isTTY&&process.stdout.columns||80,f=l?.noInputFiles!==!0?`[${(0,R.localize)(37,null)}...]`:"",n=[`${g} ${u}`];n.push(""),n.push(`${(0,R.localize)(38,null)}: ${v} [${(0,R.localize)(39,null)}]${f}`),n.push(""),l?.noPipe!==!0&&(i.isWindows?n.push((0,R.localize)(40,null,v)):n.push((0,R.localize)(41,null,v)),n.push(""));const r={},t=[];for(const a in m){const s=m[a];if(s.type==="subcommand")s.description&&t.push({command:a,description:s.description});else if(s.description&&s.cat){let c=r[s.cat];c||(r[s.cat]=c={}),c[a]=s}}for(const a in r){const s=a,c=r[s];c&&(n.push(k[s]),n.push(...S(c,h)),n.push(""))}return t.length&&(n.push((0,R.localize)(42,null)),n.push(...b(t.map(a=>[a.command,a.description]),h)),n.push("")),n.join(`
`)}e.buildHelpMessage=p;function d(g,v){return`${g||(0,R.localize)(43,null)}
${v||(0,R.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=d}),define(re[183],ae([0,1,284,153,182]),function(_,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const k=2048;function L(w,p){const d=(h,f)=>{console.warn((0,i.localize)(0,null,h,f))},g=h=>{console.warn((0,i.localize)(1,null,h))},v=(h,f)=>{console.warn((0,i.localize)(2,null,h,f))},u=h=>({onUnknownOption:f=>{h!=="tunnel"&&console.warn((0,i.localize)(3,null,f,h))},onMultipleValues:d,onEmptyValue:g,onDeprecatedOption:v,getSubcommandReporter:h!=="tunnel"?u:void 0}),m={onUnknownOption:h=>{console.warn((0,i.localize)(4,null,h))},onMultipleValues:d,onEmptyValue:g,onDeprecatedOption:v,getSubcommandReporter:u},l=(0,R.parseArgs)(w,R.OPTIONS,p?m:void 0);return l.goto&&l._.forEach(h=>D(/^(\w:)?[^:]+(:\d*){0,2}$/.test(h),(0,i.localize)(5,null))),l["max-memory"]&&D(parseInt(l["max-memory"])>=k,`The max-memory argument cannot be specified lower than ${k} MB.`),l}function P(w){const p=w.findIndex(d=>!/^-/.test(d));if(p>-1)return[...w.slice(0,p),...w.slice(p+1)]}function I(w){let[,...p]=w;process.env.VSCODE_DEV&&(p=P(p)||[]);const d=!C(process.env);return L(p,d)}e.parseMainProcessArgv=I;function S(w){let[,,...p]=w;return process.env.VSCODE_DEV&&(p=P(p)||[]),L(p,!0)}e.parseCLIProcessArgv=S;function b(w,...p){const d=w.indexOf("--");return d===-1?w.push(...p):w.splice(d,0,...p),w}e.addArg=b;function C(w){return w.VSCODE_CLI==="1"}e.isLaunchedFromCli=C}),function(){"use strict";function _(e,D,i){function R(L,P){const I=k(L,P),S=[I];return e.isAbsolute(I)||S.unshift(i),e.resolve(...S)}function k(L,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const I=process.env.VSCODE_PORTABLE;if(I)return e.join(I,"user-data");let S=process.env.VSCODE_APPDATA;if(S)return e.join(S,P);const b=L["user-data-dir"];if(b)return b;switch(process.platform){case"win32":if(S=process.env.APPDATA,!S){const C=process.env.USERPROFILE;if(typeof C!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");S=e.join(C,"AppData","Roaming")}break;case"darwin":S=e.join(D.homedir(),"Library","Application Support");break;case"linux":S=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(S,P)}return{getUserDataPath:R}}if(typeof define=="function")define(re[184],ae([285,34,36]),function(e,D,i){return _(e,D,i.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),D=require("os");module.exports=_(e,D,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(re[185],ae([0,1,34,94,184]),function(_,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class k extends i.AbstractNativeEnvironmentService{constructor(P,I){super(P,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,R.getUserDataPath)(P,I.nameShort)},I)}}e.NativeEnvironmentService=k}),define(re[186],ae([0,1,8]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const i=/^([^@:]+@)?([^:]+):/,R=/^([^@:]+@)?([^:]+):(.+)$/,k=/^([^@]+@)?([^:]+)(:\d+)?$/,L=/([^@:.]+\.[^@:.]+)(:\d+)?$/,P=/^\s*url\s*=\s*(.+\S)\s*$/mg,I=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function S(v){const u=v.match(L);return u?u[1]:null}function b(v){if(v.indexOf("://")===-1){const u=v.match(i);return u?S(u[2]):null}try{const u=D.URI.parse(v);if(u.authority)return S(u.authority)}catch{}return null}function C(v,u){const m=new Set;let l;for(;l=P.exec(v);){const f=b(l[1]);f&&m.add(f)}const h=new Set(u);return Array.from(m).map(f=>h.has(f)?f:f.replace(I,"a"))}e.getDomainsOfRemotes=C;function w(v){const u=v.match(k);return u?u[2]:null}function p(v,u,m){return v&&u?(m&&u.endsWith(".git")&&(u=u.substr(0,u.length-4)),u.indexOf("/")===0?`${v}${u}`:`${v}/${u}`):null}function d(v,u){if(v.indexOf("://")===-1){const m=v.match(R);if(m)return p(m[2],m[3],u)}try{const m=D.URI.parse(v);if(m.authority)return p(w(m.authority),m.path,u)}catch{}return null}function g(v,u=!1){const m=[];let l;for(;l=P.exec(v);){const h=d(l[1],u);h&&m.push(h)}return m}e.getRemotes=g}),define(re[187],ae([0,1,15,156]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function R(L,P,I){try{k(L,P,I)}catch(S){console.error(S?.message??S)}return L}e.localizeManifest=R;function k(L,P,I){const S=(b,C,w)=>{const p=b[C];if((0,D.isString)(p)){const d=p,g=d.length;if(g>1&&d[0]==="%"&&d[g-1]==="%"){const v=d.substr(1,g-2);let u=P[v];u===void 0&&I&&(u=I[v]);const m=typeof u=="string"?u:u?.message,l=I?.[v],h=typeof l=="string"?l:l?.message;if(!m){h||console.warn(`[${L.name}]: ${(0,i.localize)(0,null,v)}`);return}if(w&&(C==="title"||C==="category")&&h&&h!==m){const f={value:m,original:h};b[C]=f}else b[C]=m}}else if((0,D.isObject)(p))for(const d in p)p.hasOwnProperty(d)&&(d==="commands"?S(p,d,!0):S(p,d,w));else if(Array.isArray(p))for(let d=0;d<p.length;d++)S(p,d,w)};for(const b in L)L.hasOwnProperty(b)&&S(L,b)}}),define(re[188],ae([0,1,9]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class i{constructor(){this.a=new Map}register(k,L){this.a.set(k,L)}updateManifest(k){if(!(!Array.isArray(k.activationEvents)||!k.contributes)&&!(typeof k.main>"u"&&typeof k.browser>"u"))for(const L in k.contributes){const P=this.a.get(L);if(!P)continue;const I=k.contributes[L],S=Array.isArray(I)?I:[I];try{P(S,k.activationEvents)}catch(b){(0,D.onUnexpectedError)(b)}}}}e.ImplicitActivationEventsImpl=i,e.ImplicitActivationEvents=new i}),define(re[189],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class D{constructor(k){this.a=k}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(k,L,P,I){return this.a.call("promptImportantExtensionsInstallNotification",[k,L,P,I])}promptWorkspaceRecommendations(k){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=D;class i{constructor(k){this.a=k}listen(k,L){throw new Error(`Event not found: ${L}`)}call(k,L,P){switch(L){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(P[0],P[1],P[2],P[3])}throw new Error(`Call not found: ${L}`)}}e.ExtensionRecommendationNotificationServiceChannel=i}),define(re[70],ae([0,1,22,88,161,54]),function(_,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function I(u){return u=u.trim(),u==="*"||L.test(u)}e.isValidVersionStr=I;function S(u){if(!I(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const m=u.match(L);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=S;function b(u){if(!u)return null;const m=u.majorBase,l=u.majorMustEqual,h=u.minorBase;let f=u.minorMustEqual;const n=u.patchBase;let r=u.patchMustEqual;u.hasCaret&&(m===0||(f=!1),r=!1);let t=0;if(u.preRelease){const a=P.exec(u.preRelease);if(a){const[,s,c,o]=a;t=Date.UTC(Number(s),Number(c)-1,Number(o))}}return{majorBase:m,majorMustEqual:l,minorBase:h,minorMustEqual:f,patchBase:n,patchMustEqual:r,isMinimum:u.hasGreaterEquals,notBefore:t}}e.normalizeVersion=b;function C(u,m,l){let h;typeof u=="string"?h=b(S(u)):h=u;let f;m instanceof Date?f=m.getTime():typeof m=="string"&&(f=new Date(m).getTime());let n;if(typeof l=="string"?n=b(S(l)):n=l,!h||!n)return!1;const r=h.majorBase,t=h.minorBase,a=h.patchBase;let s=n.majorBase,c=n.minorBase,o=n.patchBase;const y=n.notBefore;let E=n.majorMustEqual,T=n.minorMustEqual,q=n.patchMustEqual;return n.isMinimum?r>s?!0:r<s?!1:t>c?!0:t<c||f&&f<y?!1:a>=o:(r===1&&s===0&&(!E||!T||!q)&&(s=1,c=0,o=0,E=!0,T=!1,q=!1),r<s?!1:r>s?!E:t<c?!1:t>c?!T:a<o?!1:a>o?!q:!(f&&f<y))}e.isValidVersion=C;function w(u,m,l,h,f){const n=[];if(typeof h.publisher<"u"&&typeof h.publisher!="string")return n.push([i.default.Error,R.localize(0,null)]),n;if(typeof h.name!="string")return n.push([i.default.Error,R.localize(1,null,"name")]),n;if(typeof h.version!="string")return n.push([i.default.Error,R.localize(2,null,"version")]),n;if(!h.engines)return n.push([i.default.Error,R.localize(3,null,"engines")]),n;if(typeof h.engines.vscode!="string")return n.push([i.default.Error,R.localize(4,null,"engines.vscode")]),n;if(typeof h.extensionDependencies<"u"&&!v(h.extensionDependencies))return n.push([i.default.Error,R.localize(5,null,"extensionDependencies")]),n;if(typeof h.activationEvents<"u"){if(!v(h.activationEvents))return n.push([i.default.Error,R.localize(6,null,"activationEvents")]),n;if(typeof h.main>"u"&&typeof h.browser>"u")return n.push([i.default.Error,R.localize(7,null,"activationEvents","main")]),n}if(typeof h.extensionKind<"u"&&typeof h.main>"u"&&n.push([i.default.Warning,R.localize(8,null,"extensionKind")]),typeof h.main<"u"){if(typeof h.main!="string")return n.push([i.default.Error,R.localize(9,null,"main")]),n;{const a=(0,D.joinPath)(l,h.main);(0,D.isEqualOrParent)(a,l)||n.push([i.default.Warning,R.localize(10,null,a.path,l.path)])}if(typeof h.activationEvents>"u")return n.push([i.default.Error,R.localize(11,null,"activationEvents","main")]),n}if(typeof h.browser<"u"){if(typeof h.browser!="string")return n.push([i.default.Error,R.localize(12,null,"browser")]),n;{const a=(0,D.joinPath)(l,h.browser);(0,D.isEqualOrParent)(a,l)||n.push([i.default.Warning,R.localize(13,null,a.path,l.path)])}if(typeof h.activationEvents>"u")return n.push([i.default.Error,R.localize(14,null,"activationEvents","browser")]),n}if(!k.valid(h.version))return n.push([i.default.Error,R.localize(15,null)]),n;const r=[];if(!p(u,m,h,f,r))for(const a of r)n.push([i.default.Error,a]);return n}e.validateExtensionManifest=w;function p(u,m,l,h,f){return h||typeof l.main>"u"&&typeof l.browser>"u"?!0:g(u,m,l.engines.vscode,f)}e.isValidExtensionVersion=p;function d(u,m,l){return u==="*"||g(m,l,u)}e.isEngineValid=d;function g(u,m,l,h=[]){const f=b(S(l));if(!f)return h.push(R.localize(16,null,l)),!1;if(f.majorBase===0){if(!f.majorMustEqual||!f.minorMustEqual)return h.push(R.localize(17,null,l)),!1}else if(!f.majorMustEqual)return h.push(R.localize(18,null,l)),!1;return C(u,m,f)?!0:(h.push(R.localize(19,null,u,l)),!1)}function v(u){if(!Array.isArray(u))return!1;for(let m=0,l=u.length;m<l;m++)if(typeof u[m]!="string")return!1;return!0}}),define(re[45],ae([0,1,17,31]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function R(k,L,P){let I=P&&P.get("storage.serviceMachineId",-1)||null;if(I)return I;try{const b=(await L.readFile(k.serviceMachineIdResource)).value.toString();I=(0,i.isUUID)(b)?b:null}catch{I=null}if(!I){I=(0,i.generateUuid)();try{await L.writeFile(k.serviceMachineIdResource,D.VSBuffer.fromString(I))}catch{}}return P?.store("storage.serviceMachineId",I,-1,1),I}e.getServiceMachineId=R}),define(re[55],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class D{constructor(R,k=[],L=!1){this.ctor=R,this.staticArguments=k,this.supportsDelayedInstantiation=L}}e.SyncDescriptor=D}),define(re[71],ae([0,1,55]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const i=[];var R;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(R=e.InstantiationType||(e.InstantiationType={}));function k(P,I,S){I instanceof D.SyncDescriptor||(I=new D.SyncDescriptor(I,[],Boolean(S))),i.push([P,I])}e.registerSingleton=k;function L(){return i}e.getSingletonServiceDescriptors=L}),define(re[190],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class D{constructor(k,L){this.key=k,this.data=L,this.incoming=new Map,this.outgoing=new Map}}e.Node=D;class i{constructor(k){this.b=k,this.a=new Map}roots(){const k=[];for(const L of this.a.values())L.outgoing.size===0&&k.push(L);return k}insertEdge(k,L){const P=this.lookupOrInsertNode(k),I=this.lookupOrInsertNode(L);P.outgoing.set(I.key,I),I.incoming.set(P.key,P)}removeNode(k){const L=this.b(k);this.a.delete(L);for(const P of this.a.values())P.outgoing.delete(L),P.incoming.delete(L)}lookupOrInsertNode(k){const L=this.b(k);let P=this.a.get(L);return P||(P=new D(L,k),this.a.set(L,P)),P}lookup(k){return this.a.get(this.b(k))}isEmpty(){return this.a.size===0}toString(){const k=[];for(const[L,P]of this.a)k.push(`${L}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return k.join(`
`)}findCycleSlow(){for(const[k,L]of this.a){const P=new Set([k]),I=this.c(L,P);if(I)return I}}c(k,L){for(const[P,I]of k.outgoing){if(L.has(P))return[...L,P].join(" -> ");L.add(P);const S=this.c(I,L);if(S)return S;L.delete(P)}}}e.Graph=i}),define(re[4],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var D;(function(L){L.serviceIds=new Map,L.DI_TARGET="$di$target",L.DI_DEPENDENCIES="$di$dependencies";function P(I){return I[L.DI_DEPENDENCIES]||[]}L.getServiceDependencies=P})(D=e._util||(e._util={})),e.IInstantiationService=R("instantiationService");function i(L,P,I){P[D.DI_TARGET]===P?P[D.DI_DEPENDENCIES].push({id:L,index:I}):(P[D.DI_DEPENDENCIES]=[{id:L,index:I}],P[D.DI_TARGET]=P)}function R(L){if(D.serviceIds.has(L))return D.serviceIds.get(L);const P=function(I,S,b){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");i(P,I,b)};return P.toString=()=>L,D.serviceIds.set(L,P),P}e.createDecorator=R;function k(L){return L}e.refineServiceDecorator=k}),define(re[191],ae([0,1,4]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,D.createDecorator)("checksumService")}),define(re[16],ae([0,1,15,8,4]),function(_,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,R.createDecorator)("configurationService");function k(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof i.URI)}e.isConfigurationOverrides=k;function L(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof i.URI)}e.isConfigurationUpdateOverrides=L;var P;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function I(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=I;function S(u,m){const l=Object.create(null);for(const h in u)b(l,h,u[h],m);return l}e.toValuesTree=S;function b(u,m,l,h){const f=m.split("."),n=f.pop();let r=u;for(let t=0;t<f.length;t++){const a=f[t];let s=r[a];switch(typeof s){case"undefined":s=r[a]=Object.create(null);break;case"object":break;default:h(`Ignoring ${m} as ${f.slice(0,t+1).join(".")} is ${JSON.stringify(s)}`);return}r=s}if(typeof r=="object"&&r!==null)try{r[n]=l}catch{h(`Ignoring ${m} as ${f.join(".")} is ${JSON.stringify(r)}`)}else h(`Ignoring ${m} as ${f.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=b;function C(u,m){const l=m.split(".");w(u,l)}e.removeFromValueTree=C;function w(u,m){const l=m.shift();if(m.length===0){delete u[l];return}if(Object.keys(u).indexOf(l)!==-1){const h=u[l];typeof h=="object"&&!Array.isArray(h)&&(w(h,m),Object.keys(h).length===0&&delete u[l])}}function p(u,m,l){function h(r,t){let a=r;for(const s of t){if(typeof a!="object"||a===null)return;a=a[s]}return a}const f=m.split("."),n=h(u,f);return typeof n>"u"?l:n}e.getConfigurationValue=p;function d(u,m,l){Object.keys(m).forEach(h=>{h!=="__proto__"&&(h in u?D.isObject(u[h])&&D.isObject(m[h])?d(u[h],m[h],l):l&&(u[h]=m[h]):u[h]=m[h])})}e.merge=d;function g(u,m,l){const h=u.inspect(m),f=u.inspect(l);return typeof h.userValue<"u"||typeof h.workspaceValue<"u"||typeof h.workspaceFolderValue<"u"?h.value:typeof f.userValue<"u"||typeof f.workspaceValue<"u"||typeof f.workspaceFolderValue<"u"?f.value:h.defaultValue}e.getMigratedSettingValue=g;function v(u){return u.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=v}),define(re[192],ae([0,1,5,27,4]),function(_,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",D.isMacintosh),k.set("isLinux",D.isLinux),k.set("isWindows",D.isWindows),k.set("isWeb",D.isWeb),k.set("isMacNative",D.isMacintosh&&!D.isWeb),k.set("isEdge",D.isEdge),k.set("isFirefox",D.isFirefox),k.set("isChrome",D.isChrome),k.set("isSafari",D.isSafari);const L=Object.prototype.hasOwnProperty;var P;(function(F){F[F.False=0]="False",F[F.True=1]="True",F[F.Defined=2]="Defined",F[F.Not=3]="Not",F[F.Equals=4]="Equals",F[F.NotEquals=5]="NotEquals",F[F.And=6]="And",F[F.Regex=7]="Regex",F[F.NotRegex=8]="NotRegex",F[F.Or=9]="Or",F[F.In=10]="In",F[F.NotIn=11]="NotIn",F[F.Greater=12]="Greater",F[F.GreaterEquals=13]="GreaterEquals",F[F.Smaller=14]="Smaller",F[F.SmallerEquals=15]="SmallerEquals"})(P=e.ContextKeyExprType||(e.ContextKeyExprType={}));class I{static false(){return C.INSTANCE}static true(){return w.INSTANCE}static has(A){return p.create(A)}static equals(A,U){return d.create(A,U)}static notEquals(A,U){return u.create(A,U)}static regex(A,U){return t.create(A,U)}static in(A,U){return g.create(A,U)}static notIn(A,U){return v.create(A,U)}static not(A){return m.create(A)}static and(...A){return c.create(A,null,!0)}static or(...A){return o.create(A,null,!0)}static greater(A,U){return h.create(A,U)}static greaterEquals(A,U){return f.create(A,U)}static smaller(A,U){return n.create(A,U)}static smallerEquals(A,U){return r.create(A,U)}static deserialize(A,U=!1){if(!!A)return this.c(A,U)}static c(A,U){const B=A.split("||");return o.create(B.map(G=>this.d(G,U)),null,!0)}static d(A,U){const B=A.split("&&");return c.create(B.map(G=>this.f(G,U)),null,!0)}static f(A,U){if(A=A.trim(),A.indexOf("!=")>=0){const B=A.split("!=");return u.create(B[0].trim(),this.g(B[1],U))}if(A.indexOf("==")>=0){const B=A.split("==");return d.create(B[0].trim(),this.g(B[1],U))}if(A.indexOf("=~")>=0){const B=A.split("=~");return t.create(B[0].trim(),this.h(B[1],U))}if(A.indexOf(" not in ")>=0){const B=A.split(" not in ");return v.create(B[0].trim(),this.g(B[1],U))}if(A.indexOf(" in ")>=0){const B=A.split(" in ");return g.create(B[0].trim(),this.g(B[1],U))}if(/^[^<=>]+>=[^<=>]+$/.test(A)){const B=A.split(">=");return f.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(A)){const B=A.split(">");return h.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(A)){const B=A.split("<=");return r.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(A)){const B=A.split("<");return n.create(B[0].trim(),B[1].trim())}return/^\!\s*/.test(A)?m.create(A.substr(1).trim()):p.create(A)}static g(A,U){if(A=A.trim(),A==="true")return!0;if(A==="false")return!1;const B=/^'([^']*)'$/.exec(A);return B?B[1].trim():A}static h(A,U){if((0,i.isFalsyOrWhitespace)(A)){if(U)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const B=A.indexOf("/"),G=A.lastIndexOf("/");if(B===G||B<0){if(U)throw new Error(`bad regexp-value '${A}', missing /-enclosure`);return console.warn(`bad regexp-value '${A}', missing /-enclosure`),null}const W=A.slice(B+1,G),Z=A[G+1]==="i"?"i":"";try{return new RegExp(W,Z)}catch($){if(U)throw new Error(`bad regexp-value '${A}', parse error: ${$}`);return console.warn(`bad regexp-value '${A}', parse error: ${$}`),null}}}e.ContextKeyExpr=I;function S(F,A){const U=F?F.substituteConstants():void 0,B=A?A.substituteConstants():void 0;return!U&&!B?!0:!U||!B?!1:U.equals(B)}e.expressionsAreEqualWithConstantSubstitution=S;function b(F,A){return F.cmp(A)}class C{constructor(){this.type=0}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!1}serialize(){return"false"}keys(){return[]}map(A){return this}negate(){return w.INSTANCE}}e.ContextKeyFalseExpr=C,C.INSTANCE=new C;class w{constructor(){this.type=1}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!0}serialize(){return"true"}keys(){return[]}map(A){return this}negate(){return C.INSTANCE}}e.ContextKeyTrueExpr=w,w.INSTANCE=new w;class p{static create(A,U=null){const B=k.get(A);return typeof B=="boolean"?B?w.INSTANCE:C.INSTANCE:new p(A,U)}constructor(A,U){this.key=A,this.c=U,this.type=2}cmp(A){return A.type!==this.type?this.type-A.type:E(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=k.get(this.key);return typeof A=="boolean"?A?w.INSTANCE:C.INSTANCE:this}evaluate(A){return!!A.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(A){return A.mapDefined(this.key)}negate(){return this.c||(this.c=m.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=p;class d{static create(A,U,B=null){if(typeof U=="boolean")return U?p.create(A,B):m.create(A,B);const G=k.get(A);return typeof G=="boolean"?U===(G?"true":"false")?w.INSTANCE:C.INSTANCE:new d(A,U,B)}constructor(A,U,B){this.c=A,this.d=U,this.f=B,this.type=4}cmp(A){return A.type!==this.type?this.type-A.type:T(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){const A=k.get(this.c);if(typeof A=="boolean"){const U=A?"true":"false";return this.d===U?w.INSTANCE:C.INSTANCE}return this}evaluate(A){return A.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(A){return A.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=u.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=d;class g{static create(A,U){return new g(A,U)}constructor(A,U){this.d=A,this.f=U,this.type=10,this.c=null}cmp(A){return A.type!==this.type?this.type-A.type:T(this.d,this.f,A.d,A.f)}equals(A){return A.type===this.type?this.d===A.d&&this.f===A.f:!1}substituteConstants(){return this}evaluate(A){const U=A.getValue(this.f),B=A.getValue(this.d);return Array.isArray(U)?U.includes(B):typeof B=="string"&&typeof U=="object"&&U!==null?L.call(U,B):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(A){return A.mapIn(this.d,this.f)}negate(){return this.c||(this.c=v.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=g;class v{static create(A,U){return new v(A,U)}constructor(A,U){this.d=A,this.f=U,this.type=11,this.c=g.create(A,U)}cmp(A){return A.type!==this.type?this.type-A.type:this.c.cmp(A.c)}equals(A){return A.type===this.type?this.c.equals(A.c):!1}substituteConstants(){return this}evaluate(A){return!this.c.evaluate(A)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(A){return A.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=v;class u{static create(A,U,B=null){if(typeof U=="boolean")return U?m.create(A,B):p.create(A,B);const G=k.get(A);return typeof G=="boolean"?U===(G?"true":"false")?C.INSTANCE:w.INSTANCE:new u(A,U,B)}constructor(A,U,B){this.c=A,this.d=U,this.f=B,this.type=5}cmp(A){return A.type!==this.type?this.type-A.type:T(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){const A=k.get(this.c);if(typeof A=="boolean"){const U=A?"true":"false";return this.d===U?C.INSTANCE:w.INSTANCE}return this}evaluate(A){return A.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(A){return A.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=d.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=u;class m{static create(A,U=null){const B=k.get(A);return typeof B=="boolean"?B?C.INSTANCE:w.INSTANCE:new m(A,U)}constructor(A,U){this.c=A,this.d=U,this.type=3}cmp(A){return A.type!==this.type?this.type-A.type:E(this.c,A.c)}equals(A){return A.type===this.type?this.c===A.c:!1}substituteConstants(){const A=k.get(this.c);return typeof A=="boolean"?A?C.INSTANCE:w.INSTANCE:this}evaluate(A){return!A.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(A){return A.mapNot(this.c)}negate(){return this.d||(this.d=p.create(this.c,this)),this.d}}e.ContextKeyNotExpr=m;function l(F,A){if(typeof F=="string"){const U=parseFloat(F);isNaN(U)||(F=U)}return typeof F=="string"||typeof F=="number"?A(F):C.INSTANCE}class h{static create(A,U,B=null){return l(U,G=>new h(A,G,B))}constructor(A,U,B){this.c=A,this.d=U,this.f=B,this.type=12}cmp(A){return A.type!==this.type?this.type-A.type:T(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(A){return A.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=r.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=h;class f{static create(A,U,B=null){return l(U,G=>new f(A,G,B))}constructor(A,U,B){this.c=A,this.d=U,this.f=B,this.type=13}cmp(A){return A.type!==this.type?this.type-A.type:T(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(A){return A.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=n.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=f;class n{static create(A,U,B=null){return l(U,G=>new n(A,G,B))}constructor(A,U,B){this.c=A,this.d=U,this.f=B,this.type=14}cmp(A){return A.type!==this.type?this.type-A.type:T(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(A){return A.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=f.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=n;class r{static create(A,U,B=null){return l(U,G=>new r(A,G,B))}constructor(A,U,B){this.c=A,this.d=U,this.f=B,this.type=15}cmp(A){return A.type!==this.type?this.type-A.type:T(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(A){return A.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=h.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=r;class t{static create(A,U){return new t(A,U)}constructor(A,U){this.d=A,this.f=U,this.type=7,this.c=null}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.d<A.d)return-1;if(this.d>A.d)return 1;const U=this.f?this.f.source:"",B=A.f?A.f.source:"";return U<B?-1:U>B?1:0}equals(A){if(A.type===this.type){const U=this.f?this.f.source:"",B=A.f?A.f.source:"";return this.d===A.d&&U===B}return!1}substituteConstants(){return this}evaluate(A){const U=A.getValue(this.d);return this.f?this.f.test(U):!1}serialize(){const A=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${A}`}keys(){return[this.d]}map(A){return A.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=a.create(this)),this.c}}e.ContextKeyRegexExpr=t;class a{static create(A){return new a(A)}constructor(A){this.c=A,this.type=8}cmp(A){return A.type!==this.type?this.type-A.type:this.c.cmp(A.c)}equals(A){return A.type===this.type?this.c.equals(A.c):!1}substituteConstants(){return this}evaluate(A){return!this.c.evaluate(A)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(A){return new a(this.c.map(A))}negate(){return this.c}}e.ContextKeyNotRegexExpr=a;function s(F){let A=null;for(let U=0,B=F.length;U<B;U++){const G=F[U].substituteConstants();if(F[U]!==G&&A===null){A=[];for(let W=0;W<U;W++)A[W]=F[W]}A!==null&&(A[U]=G)}return A===null?F:A}class c{static create(A,U,B){return c.d(A,U,B)}constructor(A,U){this.expr=A,this.c=U,this.type=6}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let U=0,B=this.expr.length;U<B;U++){const G=b(this.expr[U],A.expr[U]);if(G!==0)return G}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let U=0,B=this.expr.length;U<B;U++)if(!this.expr[U].equals(A.expr[U]))return!1;return!0}return!1}substituteConstants(){const A=s(this.expr);return A===this.expr?this:c.create(A,this.c,!1)}evaluate(A){for(let U=0,B=this.expr.length;U<B;U++)if(!this.expr[U].evaluate(A))return!1;return!0}static d(A,U,B){const G=[];let W=!1;for(const Z of A)if(!!Z){if(Z.type===1){W=!0;continue}if(Z.type===0)return C.INSTANCE;if(Z.type===6){G.push(...Z.expr);continue}G.push(Z)}if(G.length===0&&W)return w.INSTANCE;if(G.length!==0){if(G.length===1)return G[0];G.sort(b);for(let Z=1;Z<G.length;Z++)G[Z-1].equals(G[Z])&&(G.splice(Z,1),Z--);if(G.length===1)return G[0];for(;G.length>1;){const Z=G[G.length-1];if(Z.type!==9)break;G.pop();const $=G.pop(),z=G.length===0,Y=o.create(Z.expr.map(ee=>c.create([ee,$],null,B)),null,z);Y&&(G.push(Y),G.sort(b))}if(G.length===1)return G[0];if(B){for(let Z=0;Z<G.length;Z++)for(let $=Z+1;$<G.length;$++)if(G[Z].negate().equals(G[$]))return C.INSTANCE;if(G.length===1)return G[0]}return new c(G,U)}}serialize(){return this.expr.map(A=>A.serialize()).join(" && ")}keys(){const A=[];for(const U of this.expr)A.push(...U.keys());return A}map(A){return new c(this.expr.map(U=>U.map(A)),null)}negate(){if(!this.c){const A=[];for(const U of this.expr)A.push(U.negate());this.c=o.create(A,this,!0)}return this.c}}class o{static create(A,U,B){return o.d(A,U,B)}constructor(A,U){this.expr=A,this.c=U,this.type=9}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let U=0,B=this.expr.length;U<B;U++){const G=b(this.expr[U],A.expr[U]);if(G!==0)return G}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let U=0,B=this.expr.length;U<B;U++)if(!this.expr[U].equals(A.expr[U]))return!1;return!0}return!1}substituteConstants(){const A=s(this.expr);return A===this.expr?this:o.create(A,this.c,!1)}evaluate(A){for(let U=0,B=this.expr.length;U<B;U++)if(this.expr[U].evaluate(A))return!0;return!1}static d(A,U,B){let G=[],W=!1;if(A){for(let Z=0,$=A.length;Z<$;Z++){const z=A[Z];if(!!z){if(z.type===0){W=!0;continue}if(z.type===1)return w.INSTANCE;if(z.type===9){G=G.concat(z.expr);continue}G.push(z)}}if(G.length===0&&W)return C.INSTANCE;G.sort(b)}if(G.length!==0){if(G.length===1)return G[0];for(let Z=1;Z<G.length;Z++)G[Z-1].equals(G[Z])&&(G.splice(Z,1),Z--);if(G.length===1)return G[0];if(B){for(let Z=0;Z<G.length;Z++)for(let $=Z+1;$<G.length;$++)if(G[Z].negate().equals(G[$]))return w.INSTANCE;if(G.length===1)return G[0]}return new o(G,U)}}serialize(){return this.expr.map(A=>A.serialize()).join(" || ")}keys(){const A=[];for(const U of this.expr)A.push(...U.keys());return A}map(A){return new o(this.expr.map(U=>U.map(A)),null)}negate(){if(!this.c){const A=[];for(const U of this.expr)A.push(U.negate());for(;A.length>1;){const U=A.shift(),B=A.shift(),G=[];for(const W of j(U))for(const Z of j(B))G.push(c.create([W,Z],null,!1));A.unshift(o.create(G,null,!1))}this.c=o.create(A,this,!0)}return this.c}}class y extends p{static all(){return y.d.values()}constructor(A,U,B){super(A,null),this.f=U,typeof B=="object"?y.d.push({...B,key:A}):B!==!0&&y.d.push({key:A,description:B,type:U!=null?typeof U:void 0})}bindTo(A){return A.createKey(this.key,this.f)}getValue(A){return A.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(A){return d.create(this.key,A)}notEqualsTo(A){return u.create(this.key,A)}}e.RawContextKey=y,y.d=[],e.IContextKeyService=(0,R.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function E(F,A){return F<A?-1:F>A?1:0}function T(F,A,U,B){return F<U?-1:F>U?1:A<B?-1:A>B?1:0}function q(F,A){if(F.type===0||A.type===1)return!0;if(F.type===9)return A.type===9?N(F.expr,A.expr):!1;if(A.type===9){for(const U of A.expr)if(q(F,U))return!0;return!1}if(F.type===6){if(A.type===6)return N(A.expr,F.expr);for(const U of F.expr)if(q(U,A))return!0;return!1}return F.equals(A)}e.implies=q;function N(F,A){let U=0,B=0;for(;U<F.length&&B<A.length;){const G=F[U].cmp(A[B]);if(G<0)return!1;G===0&&U++,B++}return U===F.length}function j(F){return F.type===9?F.expr:[F]}}),define(re[95],ae([0,1,4]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,D.createDecorator)(e.ID);function i(k){return!!k.hostName&&!!k.errorMessage}e.isRemoteDiagnosticError=i;class R{async getPerformanceInfo(L,P){return{}}async getSystemInfo(L,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(L,P){return""}async getWorkspaceFileExtensions(L){return{extensions:[]}}async reportWorkspaceStats(L){}}e.NullDiagnosticsService=R}),define(re[96],ae([0,1,4]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,D.createDecorator)("downloadService")}),define(re[13],ae([0,1,4]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,D.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,D.refineServiceDecorator)(e.IEnvironmentService)}),define(re[29],ae([0,1,155,4]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function R(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=R;function k(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=k;function L(u,m){switch(u){case 3:return m==="x64"?"win32-x64":m==="ia32"?"win32-ia32":m==="arm64"?"win32-arm64":"unknown";case 2:return m==="x64"?"linux-x64":m==="arm64"?"linux-arm64":m==="arm"?"linux-armhf":"unknown";case"alpine":return m==="x64"?"alpine-x64":m==="arm64"?"alpine-arm64":"unknown";case 1:return m==="x64"?"darwin-x64":m==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=L;function P(u,m){return m==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function I(u,m,l){return P(m,l)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===l?!0:S(l).includes(u)}e.isTargetPlatformCompatible=I;function S(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=S;function b(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=b;var C;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(C=e.SortBy||(e.SortBy={}));var w;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(w=e.SortOrder||(e.SortOrder={}));var p;(function(u){u.Install="install",u.Uninstall="uninstall"})(p=e.StatisticType||(e.StatisticType={}));var d;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(d=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,i.createDecorator)("extensionGalleryService");var g;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal",u.Signature="Signature"})(g=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class v extends Error{constructor(m,l){super(m),this.code=l,this.name=l}}e.ExtensionManagementError=v,e.IExtensionManagementService=(0,i.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,i.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,i.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,D.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,D.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(re[193],ae([0,1,3,2,67,32,8,142,29]),function(_,e,D,i,R,k,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function S(v,u){return L.URI.revive(u?u.transformIncoming(v):v)}function b(v,u){return u?u.transformOutgoingURI(v):v}function C(v,u){u=u||P.DefaultURITransformer;const m=v.manifest;return{...(0,P.transformAndReviveIncomingURIs)({...v,manifest:void 0},u),manifest:m}}function w(v,u){return u?(0,k.cloneAndChange)(v,m=>m instanceof L.URI?u.transformOutgoingURI(m):void 0):v}class p{constructor(u,m){this.a=u,this.b=m,this.onInstallExtension=D.Event.buffer(u.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(u.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(u.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(u.onDidUninstallExtension,!0)}listen(u,m){const l=this.b(u);switch(m){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,h=>h.map(f=>({...f,local:f.local?w(f.local,l):f.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(u,m,l){const h=this.b(u);switch(m){case"zip":return this.a.zip(C(l[0],h)).then(f=>b(f,h));case"unzip":return this.a.unzip(S(l[0],h));case"install":return this.a.install(S(l[0],h),(0,R.revive)(l[1]));case"installFromLocation":return this.a.installFromLocation(S(l[0],h),L.URI.revive(l[1]));case"getManifest":return this.a.getManifest(S(l[0],h));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(l[0]);case"installFromGallery":return this.a.installFromGallery(l[0],(0,R.revive)(l[1]));case"uninstall":return this.a.uninstall(C(l[0],h),(0,R.revive)(l[1]));case"reinstallFromGallery":return this.a.reinstallFromGallery(C(l[0],h));case"getInstalled":return this.a.getInstalled(l[0],L.URI.revive(l[1])).then(f=>f.map(n=>w(n,h)));case"getMetadata":return this.a.getMetadata(C(l[0],h));case"updateMetadata":return this.a.updateMetadata(C(l[0],h),l[1]).then(f=>w(f,h));case"updateExtensionScope":return this.a.updateExtensionScope(C(l[0],h),l[1]).then(f=>w(f,h));case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(l[0],l[1])}throw new Error("Invalid call")}}e.ExtensionManagementChannel=p;class d extends i.Disposable{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}constructor(u){super(),this.j=u,this.c=this.B(new D.Emitter),this.f=this.B(new D.Emitter),this.g=this.B(new D.Emitter),this.h=this.B(new D.Emitter),this.B(this.j.listen("onInstallExtension")(m=>this.c.fire({identifier:m.identifier,source:this.k(m.source)?L.URI.revive(m.source):m.source,profileLocation:L.URI.revive(m.profileLocation)}))),this.B(this.j.listen("onDidInstallExtensions")(m=>this.f.fire(m.map(l=>({...l,local:l.local?C(l.local,null):l.local,source:this.k(l.source)?L.URI.revive(l.source):l.source,profileLocation:L.URI.revive(l.profileLocation)}))))),this.B(this.j.listen("onUninstallExtension")(m=>this.g.fire({identifier:m.identifier,profileLocation:L.URI.revive(m.profileLocation)}))),this.B(this.j.listen("onDidUninstallExtension")(m=>this.h.fire({...m,profileLocation:L.URI.revive(m.profileLocation)})))}k(u){return u?typeof u.path=="string"&&typeof u.scheme=="string":!1}getTargetPlatform(){return this.l||(this.l=this.j.call("getTargetPlatform")),this.l}async canInstall(u){const m=await this.getTargetPlatform();return u.allTargetPlatforms.some(l=>(0,I.isTargetPlatformCompatible)(l,u.allTargetPlatforms,m))}zip(u){return Promise.resolve(this.j.call("zip",[u]).then(m=>L.URI.revive(m)))}unzip(u){return Promise.resolve(this.j.call("unzip",[u]))}install(u,m){return Promise.resolve(this.j.call("install",[u,m])).then(l=>C(l,null))}installFromLocation(u,m){return Promise.resolve(this.j.call("installFromLocation",[u,m])).then(l=>C(l,null))}getManifest(u){return Promise.resolve(this.j.call("getManifest",[u]))}installFromGallery(u,m){return Promise.resolve(this.j.call("installFromGallery",[u,m])).then(l=>C(l,null))}uninstall(u,m){return Promise.resolve(this.j.call("uninstall",[u,m]))}reinstallFromGallery(u){return Promise.resolve(this.j.call("reinstallFromGallery",[u]))}getInstalled(u=null,m){return Promise.resolve(this.j.call("getInstalled",[u,m])).then(l=>l.map(h=>C(h,null)))}getMetadata(u){return Promise.resolve(this.j.call("getMetadata",[u]))}updateMetadata(u,m){return Promise.resolve(this.j.call("updateMetadata",[u,m])).then(l=>C(l,null))}updateExtensionScope(u,m){return Promise.resolve(this.j.call("updateExtensionScope",[u,m])).then(l=>C(l,null))}getExtensionsControlManifest(){return Promise.resolve(this.j.call("getExtensionsControlManifest"))}async download(u,m){const l=await this.j.call("download",[u,m]);return L.URI.revive(l)}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=d;class g{constructor(u){this.a=u}listen(u,m){throw new Error("Invalid listen")}call(u,m,l){switch(m){case"getConfigBasedTips":return this.a.getConfigBasedTips(L.URI.revive(l[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.a.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=g}),define(re[97],ae([0,1,4]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,D.createDecorator)("IExtensionSignatureVerificationService");class i{b(){return this.a||(this.a=new Promise((k,L)=>_(["node-vsce-sign"],async P=>k(P),L))),this.a}async verify(k,L){let P;try{P=await this.b()}catch{return!1}return P.verify(k,L)}}e.ExtensionSignatureVerificationService=i}),define(re[98],ae([0,1,4]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var i;(function(L){L[L.FILE=1]="FILE",L[L.WORKSPACE=2]="WORKSPACE",L[L.EXE=3]="EXE"})(i=e.RecommendationSource||(e.RecommendationSource={}));function R(L){switch(L){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=R;var k;(function(L){L.Ignored="ignored",L.Cancelled="cancelled",L.TooMany="toomany",L.IncompatibleWindow="incompatibleWindow",L.Accepted="reacted"})(k=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,D.createDecorator)("IExtensionRecommendationNotificationService")}),define(re[14],ae([0,1,49,12,27,15,8,163,4]),function(_,e,D,i,R,k,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,I.createDecorator)("fileService");function S(W){return W.create===!0}e.isFileOpenForWriteOptions=S;var b;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(b=e.FileType||(e.FileType={}));var C;(function(W){W[W.Readonly=1]="Readonly"})(C=e.FilePermission||(e.FilePermission={}));var w;(function(W){W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock",W[W.FileAtomicRead=16384]="FileAtomicRead",W[W.FileClone=32768]="FileClone"})(w=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(W){return!!(W.capabilities&2)}e.hasReadWriteCapability=p;function d(W){return!!(W.capabilities&8)}e.hasFileFolderCopyCapability=d;function g(W){return!!(W.capabilities&32768)}e.hasFileCloneCapability=g;function v(W){return!!(W.capabilities&4)}e.hasOpenReadWriteCloseCapability=v;function u(W){return!!(W.capabilities&16)}e.hasFileReadStreamCapability=u;function m(W){return p(W)?!!(W.capabilities&16384):!1}e.hasFileAtomicReadCapability=m;var l;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(l=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class h extends Error{constructor(Z,$){super(Z),this.code=$}}e.FileSystemProviderError=h;function f(W,Z){const $=new h(W.toString(),Z);return r($,Z),$}e.createFileSystemProviderError=f;function n(W){return W||f((0,P.localize)(0,null),l.Unknown)}e.ensureFileSystemProviderError=n;function r(W,Z){return W.name=Z?`${Z} (FileSystemError)`:"FileSystemError",W}e.markAsFileSystemProviderError=r;function t(W){if(!W)return l.Unknown;if(W instanceof h)return W.code;const Z=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!Z)return l.Unknown;switch(Z[1]){case l.FileExists:return l.FileExists;case l.FileIsADirectory:return l.FileIsADirectory;case l.FileNotADirectory:return l.FileNotADirectory;case l.FileNotFound:return l.FileNotFound;case l.FileExceedsMemoryLimit:return l.FileExceedsMemoryLimit;case l.FileTooLarge:return l.FileTooLarge;case l.FileWriteLocked:return l.FileWriteLocked;case l.NoPermissions:return l.NoPermissions;case l.Unavailable:return l.Unavailable}return l.Unknown}e.toFileSystemProviderErrorCode=t;function a(W){if(W instanceof T)return W.fileOperationResult;switch(t(W)){case l.FileNotFound:return 1;case l.FileIsADirectory:return 0;case l.FileNotADirectory:return 10;case l.FileWriteLocked:return 5;case l.NoPermissions:return 6;case l.FileExists:return 4;case l.FileExceedsMemoryLimit:return 9;case l.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=a;var s;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY",W[W.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class c{constructor(Z,$,z){this.resource=Z,this.operation=$,this.target=z}isOperation(Z){return this.operation===Z}}e.FileOperationEvent=c;var o;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class y{constructor(Z,$){this.a=void 0,this.b=void 0,this.c=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=Z;const z=new Map;for(const Y of Z){const ee=z.get(Y.type);switch(ee?ee.push([Y.resource,Y]):z.set(Y.type,[[Y.resource,Y]]),Y.type){case 1:this.rawAdded.push(Y.resource);break;case 0:this.rawUpdated.push(Y.resource);break;case 2:this.rawDeleted.push(Y.resource);break}}for(const[Y,ee]of z)switch(Y){case 1:this.a=D.TernarySearchTree.forUris(()=>$),this.a.fill(ee);break;case 0:this.b=D.TernarySearchTree.forUris(()=>$),this.b.fill(ee);break;case 2:this.c=D.TernarySearchTree.forUris(()=>$),this.c.fill(ee);break}}contains(Z,...$){return this.d(Z,{includeChildren:!1},...$)}affects(Z,...$){return this.d(Z,{includeChildren:!0},...$)}d(Z,$,...z){if(!Z)return!1;const Y=z.length>0;return!!((!Y||z.includes(1))&&(this.a?.get(Z)||$.includeChildren&&this.a?.findSuperstr(Z))||(!Y||z.includes(0))&&(this.b?.get(Z)||$.includeChildren&&this.b?.findSuperstr(Z))||(!Y||z.includes(2))&&(this.c?.findSubstr(Z)||$.includeChildren&&this.c?.findSuperstr(Z)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=y;function E(W,Z,$){return!W||!Z||W===Z||Z.length>W.length?!1:(Z.charAt(Z.length-1)!==i.sep&&(Z+=i.sep),$?(0,R.startsWithIgnoreCase)(W,Z):W.indexOf(Z)===0)}e.isParent=E;class T extends Error{constructor(Z,$,z){super(Z),this.fileOperationResult=$,this.options=z}}e.FileOperationError=T;class q extends T{constructor(Z,$,z){super(Z,2,z),this.stat=$}}e.NotModifiedSinceFileOperationError=q;var N;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",W[W.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(N=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var j;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(j=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function F(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}e.etag=F;async function A(W,Z){if(!Z.hasProvider(L.URI.from({scheme:W.scheme})))return new Promise($=>{const z=Z.onDidChangeFileSystemProviderRegistrations(Y=>{Y.scheme===W.scheme&&Y.added&&(z.dispose(),$())})})}e.whenProviderRegistered=A,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class U{static formatSize(Z){return(0,k.isNumber)(Z)||(Z=0),Z<U.KB?(0,P.localize)(1,null,Z.toFixed(0)):Z<U.MB?(0,P.localize)(2,null,(Z/U.KB).toFixed(2)):Z<U.GB?(0,P.localize)(3,null,(Z/U.MB).toFixed(2)):Z<U.TB?(0,P.localize)(4,null,(Z/U.GB).toFixed(2)):(0,P.localize)(5,null,(Z/U.TB).toFixed(2))}}e.ByteSize=U,U.KB=1024,U.MB=U.KB*U.KB,U.GB=U.MB*U.KB,U.TB=U.GB*U.KB;var B;(function(W){W[W.IA32=0]="IA32",W[W.OTHER=1]="OTHER"})(B=e.Arch||(e.Arch={}));function G(W){return{maxFileSize:W===0?300*U.MB:16*U.GB,maxHeapSize:W===0?700*U.MB:2*700*U.MB}}e.getPlatformLimits=G});var K=this&&this.__param||function(_,e){return function(D,i){e(D,i,_)}};define(re[194],ae([0,1,99,44,14]),function(_,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let k=class{constructor(P){this.a=P}async checksum(P){const I=(await this.a.readFileStream(P)).value;return new Promise((S,b)=>{const C=(0,D.createHash)("md5");(0,i.listenStream)(I,{onData:w=>C.update(w.buffer),onError:w=>b(w),onEnd:()=>S(C.digest("base64").replace(/=+$/,""))})})}};k=pe([K(0,R.IFileService)],k),e.ChecksumService=k}),define(re[195],ae([0,1,17,38,9,3,2,44,8,31,14]),function(_,e,D,i,R,k,L,P,I,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class C extends L.Disposable{constructor(p,d){super(),this.a=p,this.b=d,this.onDidChangeCapabilities=k.Event.None,this.f=this.B(new k.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new k.Emitter),this.onDidWatchError=this.g.event,this.h=(0,S.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(p){return this.a.call("stat",[p])}readdir(p){return this.a.call("readdir",[p])}async readFile(p,d){const{buffer:g}=await this.a.call("readFile",[p,d]);return g}readFileStream(p,d,g){const v=(0,P.newWriteableStream)(m=>D.VSBuffer.concat(m.map(l=>D.VSBuffer.wrap(l))).buffer),u=this.a.listen("readFileStream",[p,d])(m=>{if(m instanceof D.VSBuffer)v.write(m.buffer);else{if(m==="end")v.end();else{let l=m;l instanceof Error||(l=(0,b.createFileSystemProviderError)((0,i.toErrorMessage)(l),b.FileSystemProviderErrorCode.Unknown)),v.error(l),v.end()}u.dispose()}});return g.onCancellationRequested(()=>{v.error((0,R.canceled)()),v.end(),u.dispose()}),v}writeFile(p,d,g){return this.a.call("writeFile",[p,D.VSBuffer.wrap(d),g])}open(p,d){return this.a.call("open",[p,d])}close(p){return this.a.call("close",[p])}async read(p,d,g,v,u){const[m,l]=await this.a.call("read",[p,d,u]);return g.set(m.buffer.slice(0,l),v),l}write(p,d,g,v,u){return this.a.call("write",[p,d,D.VSBuffer.wrap(g),v,u])}mkdir(p){return this.a.call("mkdir",[p])}delete(p,d){return this.a.call("delete",[p,d])}rename(p,d,g){return this.a.call("rename",[p,d,g])}copy(p,d,g){return this.a.call("copy",[p,d,g])}cloneFile(p,d){return this.a.call("cloneFile",[p,d])}i(){this.B(this.a.listen("fileChange",[this.h])(p=>{if(Array.isArray(p)){const d=p;this.f.fire(d.map(g=>({resource:I.URI.revive(g.resource),type:g.type})))}else{const d=p;this.g.fire(d)}}))}watch(p,d){const g=(0,S.generateUuid)();return this.a.call("watch",[this.h,g,p,d]),(0,L.toDisposable)(()=>this.a.call("unwatch",[this.h,g]))}}e.DiskFileSystemProviderClient=C}),define(re[100],ae([0,1,17,9,164,14]),function(_,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function L(b,C,w,p,d,g){let v;try{await P(b,C,w,p,d,g)}catch(u){v=u}finally{v&&d.errorTransformer&&(v=d.errorTransformer(v)),typeof v<"u"&&w.error(v),w.end()}}e.readFileIntoStream=L;async function P(b,C,w,p,d,g){I(g);const v=await b.open(C,{create:!1});try{I(g);let u=0,m=0,l=d&&typeof d.length=="number"?d.length:void 0,h=D.VSBuffer.alloc(Math.min(d.bufferSize,typeof l=="number"?l:d.bufferSize)),f=d&&typeof d.position=="number"?d.position:0,n=0;do m=await b.read(v,f,h.buffer,n,h.byteLength-n),f+=m,n+=m,u+=m,typeof l=="number"&&(l-=m),n===h.byteLength&&(await w.write(p(h)),h=D.VSBuffer.alloc(Math.min(d.bufferSize,typeof l=="number"?l:d.bufferSize)),n=0);while(m>0&&(typeof l!="number"||l>0)&&I(g)&&S(u,d));if(n>0){let r=n;typeof l=="number"&&(r=Math.min(n,l)),w.write(p(h.slice(0,r)))}}catch(u){throw(0,k.ensureFileSystemProviderError)(u)}finally{await b.close(v)}}function I(b){if(b.isCancellationRequested)throw(0,i.canceled)();return!0}function S(b,C){if(C?.limits){if(typeof C.limits.memory=="number"&&b>C.limits.memory)throw(0,k.createFileSystemProviderError)((0,R.localize)(0,null),k.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof C.limits.size=="number"&&b>C.limits.size)throw(0,k.createFileSystemProviderError)((0,R.localize)(1,null),k.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(re[56],ae([0,1,89,2,12,5,8,14]),function(_,e,D,i,R,k,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function I(u){return u.recursive===!0}e.isRecursiveWatchRequest=I;class S extends i.Disposable{constructor(m,l,h,f){super(),this.h=m,this.i=l,this.j=h,this.k=f,this.c=this.B(new i.MutableDisposable),this.f=void 0,this.g=0}m(){const m=new i.DisposableStore;this.c.value=m,this.b=this.l(m),this.b.setVerboseLogging(this.j),m.add(this.b.onDidChangeFile(l=>this.h(l))),m.add(this.b.onDidLogMessage(l=>this.i(l))),m.add(this.b.onDidError(l=>this.n(l)))}n(m){this.k.restartOnError?this.g<S.a&&this.f?(this.r(`restarting watcher after error: ${m}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${m}`):this.r(m)}p(m){this.g++,this.m(),this.watch(m)}async watch(m){this.f=m,await this.b?.watch(m)}async setVerboseLogging(m){this.j=m,await this.b?.setVerboseLogging(m)}r(m){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${m}`})}dispose(){return this.b=void 0,super.dispose()}}e.AbstractWatcherClient=S,S.a=5;class b extends S{constructor(m,l,h){super(m,l,h,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=b;class C extends S{constructor(m,l,h){super(m,l,h,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=C;function w(u){return u.map(m=>({type:m.type,resource:L.URI.file(m.path)}))}e.toFileChanges=w;function p(u){const m=new v;for(const l of u)m.processEvent(l);return m.coalesce()}e.coalesceEvents=p;function d(u,m){return typeof m=="string"&&!m.startsWith(D.GLOBSTAR)&&!(0,R.isAbsolute)(m)?{base:u,pattern:m}:m}e.normalizeWatcherPattern=d;function g(u,m){const l=[];for(const h of m)l.push((0,D.parse)(d(u,h)));return l}e.parseWatcherPatterns=g;class v{constructor(){this.a=new Set,this.b=new Map}c(m){return k.isLinux?m.path:m.path.toLowerCase()}processEvent(m){const l=this.b.get(this.c(m));let h=!1;if(l){const f=l.type,n=m.type;l.path!==m.path&&(m.type===2||m.type===1)?h=!0:f===1&&n===2?(this.b.delete(this.c(m)),this.a.delete(l)):f===2&&n===1?l.type=0:f===1&&n===0||(l.type=n)}else h=!0;h&&(this.a.add(m),this.b.set(this.c(m),m))}coalesce(){const m=[],l=[];return Array.from(this.a).filter(h=>h.type!==2?(m.push(h),!1):!0).sort((h,f)=>h.path.length-f.path.length).filter(h=>l.some(f=>(0,P.isParent)(h.path,f,!k.isLinux))?!1:(l.push(h.path),!0)).concat(m)}}}),define(re[196],ae([0,1,53,6,21,48,2,85,12,5,144,28,56]),function(_,e,D,i,R,k,L,P,I,S,b,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class p extends L.Disposable{constructor(v,u,m,l){super(),this.k=v,this.l=u,this.m=m,this.n=l,this.c=new i.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},h=>this.l(h)),this.f=this.B(new i.ThrottledDelayer(p.b)),this.g=[],this.h=(0,w.parseWatcherPatterns)(this.k.path,this.k.excludes),this.i=this.k.includes?(0,w.parseWatcherPatterns)(this.k.path,this.k.includes):void 0,this.j=new R.CancellationTokenSource,this.ready=this.r()}async r(){try{const v=await this.s(this.k);if(this.j.token.isCancellationRequested)return;const u=await C.Promises.stat(v);this.B(await this.t(v,u.isDirectory()))}catch(v){v.code!=="ENOENT"?this.w(v):this.z(v)}}async s(v){let u=v.path;try{u=await C.Promises.realpath(v.path),v.path===u&&(u=await(0,b.realcase)(v.path)??v.path),v.path!==u&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${v.path}, real: ${u})`)}catch{}return u}async t(v,u){if(S.isMacintosh&&(0,k.isEqualOrParent)(v,"/Volumes/",!0))return this.w(`Refusing to watch ${v} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),L.Disposable.None;const m=new R.CancellationTokenSource(this.j.token),l=new L.DisposableStore;try{const h=(0,I.basename)(v),f=(0,D.watch)(v);l.add((0,L.toDisposable)(()=>{f.removeAllListeners(),f.close()})),this.z(`Started watching: '${v}'`);const n=new Set;if(u)try{for(const t of await C.Promises.readdir(v))n.add(t)}catch(t){this.w(t)}const r=new Map;l.add((0,L.toDisposable)(()=>{for(const[,t]of r)t.dispose();r.clear()})),f.on("error",(t,a)=>{this.w(`Failed to watch ${v} for changes using fs.watch() (${t}, ${a})`),this.dispose()}),f.on("change",(t,a)=>{if(m.token.isCancellationRequested)return;this.z(`[raw] ["${t}"] ${a}`);let s="";if(a&&(s=a.toString(),S.isMacintosh&&(s=(0,P.normalizeNFC)(s))),!(!s||t!=="change"&&t!=="rename"))if(u)if(t==="rename"){r.get(s)?.dispose();const c=setTimeout(async()=>{if(r.delete(s),s===h&&!await C.Promises.exists(v)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const o=await this.v((0,I.join)(v,s));if(m.token.isCancellationRequested)return;let y;o?n.has(s)?y=0:(y=1,n.add(s)):(n.delete(s),y=2),this.u({path:(0,I.join)(this.k.path,s),type:y})},p.a);r.set(s,(0,L.toDisposable)(()=>clearTimeout(c)))}else{let c;n.has(s)?c=0:(c=1,n.add(s)),this.u({path:(0,I.join)(this.k.path,s),type:c})}else if(t==="rename"||s!==h){const c=setTimeout(async()=>{const o=await C.Promises.exists(v);m.token.isCancellationRequested||(o?(this.u({path:this.k.path,type:0},!0),l.add(await this.t(v,!1))):(await this.u({path:this.k.path,type:2},!0),this.dispose()))},p.a);l.clear(),l.add((0,L.toDisposable)(()=>clearTimeout(c)))}else this.u({path:this.k.path,type:0},!0)})}catch(h){await C.Promises.exists(v)&&!m.token.isCancellationRequested&&this.w(`Failed to watch ${v} for changes using fs.watch() (${h.toString()})`)}return(0,L.toDisposable)(()=>{m.dispose(!0),l.dispose()})}async u(v,u=!1){if(!this.j.token.isCancellationRequested){this.n&&this.z(`${v.type===1?"[ADDED]":v.type===2?"[DELETED]":"[CHANGED]"} ${v.path}`),!u&&this.h.some(m=>m(v.path))?this.n&&this.z(` >> ignored (excluded) ${v.path}`):!u&&this.i&&this.i.length>0&&!this.i.some(m=>m(v.path))?this.n&&this.z(` >> ignored (not included) ${v.path}`):this.g.push(v);try{await this.f.trigger(async()=>{const m=this.g;this.g=[];const l=(0,w.coalesceEvents)(m);if(l.length>0){if(this.n)for(const f of l)this.z(`>> normalized ${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.path}`);this.c.work(l)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${l[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${l.length}, most recent change: ${l[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async v(v){if(S.isLinux)return C.Promises.exists(v);try{const u=(0,I.basename)(v);return(await C.Promises.readdir((0,I.dirname)(v))).some(l=>l===u)}catch(u){return this.z(u),!1}}setVerboseLogging(v){this.n=v}w(v){this.j.token.isCancellationRequested||this.m?.({type:"error",message:`[File Watcher (node.js)] ${v}`})}y(v){this.j.token.isCancellationRequested||this.m?.({type:"warn",message:`[File Watcher (node.js)] ${v}`})}z(v){!this.j.token.isCancellationRequested&&this.n&&this.m?.({type:"trace",message:`[File Watcher (node.js)] ${v}`})}dispose(){this.z(`stopping file watcher on ${this.k.path}`),this.j.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=p,p.a=100,p.b=50;async function d(g,v,u,m,l=512){const h=await C.Promises.open(g,"r"),f=Buffer.allocUnsafe(l),n=new R.CancellationTokenSource(m);let r,t=!1;const a={path:g,excludes:[],recursive:!1},s=new p(a,c=>{(async()=>{for(const{type:o}of c)if(o===0){if(t)return;t=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:y}=await C.Promises.read(h,f,0,l,null);if(!y||n.token.isCancellationRequested)break;v(f.slice(0,y))}}catch(y){r=new Error(y),n.dispose(!0)}finally{t=!1}}})()});return await s.ready,u(),new Promise((c,o)=>{n.token.onCancellationRequested(async()=>{s.dispose();try{await C.Promises.close(h)}catch(y){r=new Error(y)}r?o(r):c()})})}e.watchFileContents=d}),define(re[197],ae([0,1,3,89,2,5,196]),function(_,e,D,i,R,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class P extends R.Disposable{constructor(){super(...arguments),this.a=this.B(new D.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new D.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=D.Event.None,this.c=new Map,this.f=!1}async watch(S){const b=this.i(S),C=b.filter(p=>{const d=this.c.get(p.path);return d?!(0,i.patternsEquals)(d.request.excludes,p.excludes)||!(0,i.patternsEquals)(d.request.includes,p.includes):!0}),w=Array.from(this.c.values()).filter(({request:p})=>!b.find(d=>d.path===p.path&&(0,i.patternsEquals)(d.excludes,p.excludes)&&(0,i.patternsEquals)(d.includes,p.includes))).map(({request:p})=>p.path);C.length&&this.j(`Request to start watching: ${C.map(p=>`${p.path} (excludes: ${p.excludes.length>0?p.excludes:"<none>"}, includes: ${p.includes&&p.includes.length>0?JSON.stringify(p.includes):"<all>"})`).join(",")}`),w.length&&this.j(`Request to stop watching: ${w.join(",")}`);for(const p of w)this.h(p);for(const p of C)this.g(p)}g(S){const b=new L.NodeJSFileWatcherLibrary(S,w=>this.a.fire(w),w=>this.b.fire(w),this.f),C={request:S,instance:b};this.c.set(S.path,C)}async stop(){for(const[S]of this.c)this.h(S);this.c.clear()}h(S){const b=this.c.get(S);b&&(this.c.delete(S),b.instance.dispose())}i(S){const b=new Map;for(const C of S){const w=k.isLinux?C.path:C.path.toLowerCase();b.set(w,C)}return Array.from(b.values())}async setVerboseLogging(S){this.f=S;for(const[,b]of this.c)b.instance.setVerboseLogging(S)}j(S){this.f&&this.b.fire({type:"trace",message:this.k(S)})}k(S,b){return b?`[File Watcher (node.js)] ${S} (path: ${b.request.path})`:`[File Watcher (node.js)] ${S}`}}e.NodeJSWatcher=P}),define(re[198],ae([0,1,56,197]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class R extends D.AbstractNonRecursiveWatcherClient{constructor(L,P,I){super(L,P,I),this.m()}l(){return new i.NodeJSWatcher}}e.NodeJSWatcherClient=R}),define(re[199],ae([0,1,25,39,68,56]),function(_,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class L extends k.AbstractUniversalWatcherClient{constructor(I,S,b){super(I,S,b),this.m()}l(I){const S=I.add(new R.Client(D.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return I.add(S.onDidProcessExit(({code:b,signal:C})=>this.n(`terminated by itself with code ${b}, signal: ${C}`))),i.ProxyChannel.toService((0,i.getNextTickChannel)(S.getChannel("watcher")))}}e.UniversalWatcherClient=L}),define(re[72],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class D{constructor(...R){this.a=new Map;for(const[k,L]of R)this.set(k,L)}set(R,k){const L=this.a.get(R);return this.a.set(R,k),L}has(R){return this.a.has(R)}get(R){return this.a.get(R)}}e.ServiceCollection=D}),define(re[200],ae([0,1,6,9,2,55,190,4,72,84]),function(_,e,D,i,R,k,L,P,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const b=!1;class C extends Error{constructor(v){super("cyclic dependency between services"),this.message=v.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${v.toString()}`}}class w{constructor(v=new I.ServiceCollection,u=!1,m,l=b){this.f=v,this.g=u,this.h=m,this.i=l,this.o=new Set,this.f.set(P.IInstantiationService,this),this._globalGraph=l?m?._globalGraph??new L.Graph(h=>h):void 0}createChild(v){return new w(v,this.g,this,this.i)}invokeFunction(v,...u){const m=d.traceInvocation(this.i,v);let l=!1;try{return v({get:f=>{if(l)throw(0,i.illegalState)("service accessor is only valid during the invocation of its target method");const n=this.m(f,m);if(!n)throw new Error(`[invokeFunction] unknown service '${f}'`);return n}},...u)}finally{l=!0,m.stop()}}createInstance(v,...u){let m,l;return v instanceof k.SyncDescriptor?(m=d.traceCreation(this.i,v.ctor),l=this.j(v.ctor,v.staticArguments.concat(u),m)):(m=d.traceCreation(this.i,v),l=this.j(v,u,m)),m.stop(),l}j(v,u=[],m){const l=P._util.getServiceDependencies(v).sort((n,r)=>n.index-r.index),h=[];for(const n of l){const r=this.m(n.id,m);r||this.u(`[createInstance] ${v.name} depends on UNKNOWN service ${n.id}.`,!1),h.push(r)}const f=l.length>0?l[0].index:u.length;if(u.length!==f){console.trace(`[createInstance] First service dependency of ${v.name} at position ${f+1} conflicts with ${u.length} static arguments`);const n=f-u.length;n>0?u=u.concat(new Array(n)):u=u.slice(0,f)}return Reflect.construct(v,u.concat(h))}k(v,u){if(this.f.get(v)instanceof k.SyncDescriptor)this.f.set(v,u);else if(this.h)this.h.k(v,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l(v){const u=this.f.get(v);return!u&&this.h?this.h.l(v):u}m(v,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(v));const m=this.l(v);return m instanceof k.SyncDescriptor?this.q(v,m,u.branch(v,!0)):(u.branch(v,!1),m)}q(v,u,m){if(this.o.has(v))throw new Error(`illegal state - RECURSIVELY instantiating service '${v}'`);this.o.add(v);try{return this.r(v,u,m)}finally{this.o.delete(v)}}r(v,u,m){const l=new L.Graph(n=>n.id.toString());let h=0;const f=[{id:v,desc:u,_trace:m}];for(;f.length;){const n=f.pop();if(l.lookupOrInsertNode(n),h++>1e3)throw new C(l);for(const r of P._util.getServiceDependencies(n.desc.ctor)){const t=this.l(r.id);if(t||this.u(`[createInstance] ${v} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(r.id)),t instanceof k.SyncDescriptor){const a={id:r.id,desc:t,_trace:n._trace.branch(r.id,!0)};l.insertEdge(n,a),f.push(a)}}}for(;;){const n=l.roots();if(n.length===0){if(!l.isEmpty())throw new C(l);break}for(const{data:r}of n){if(this.l(r.id)instanceof k.SyncDescriptor){const a=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,a)}l.removeNode(r)}}return this.l(v)}s(v,u,m=[],l,h){if(this.f.get(v)instanceof k.SyncDescriptor)return this.t(v,u,m,l,h);if(this.h)return this.h.s(v,u,m,l,h);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t(v,u,m=[],l,h){if(l){const f=new w(void 0,this.g,this,this.i);f.c=String(v);const n=new Map,r=new D.IdleValue(()=>{const t=f.j(u,m,h);for(const[a,s]of n){const c=t[a];if(typeof c=="function")for(const o of s)c.apply(t,o)}return n.clear(),t});return new Proxy(Object.create(null),{get(t,a){if(!r.isInitialized&&typeof a=="string"&&(a.startsWith("onDid")||a.startsWith("onWill"))){let o=n.get(a);return o||(o=new S.LinkedList,n.set(a,o)),(E,T,q)=>{const N=o.push([E,T,q]);return(0,R.toDisposable)(N)}}if(a in t)return t[a];const s=r.value;let c=s[a];return typeof c!="function"||(c=c.bind(s),t[a]=c),c},set(t,a,s){return r.value[a]=s,!0}})}else return this.j(u,m,h)}u(v,u){if(u&&console.warn(v),this.g)throw new Error(v)}}e.InstantiationService=w;var p;(function(g){g[g.Creation=0]="Creation",g[g.Invocation=1]="Invocation",g[g.Branch=2]="Branch"})(p||(p={}));class d{static traceInvocation(v,u){return v?new d(1,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d.c}static traceCreation(v,u){return v?new d(0,u.name):d.c}constructor(v,u){this.type=v,this.name=u,this.g=Date.now(),this.h=[]}branch(v,u){const m=new d(2,v.toString());return this.h.push([v,u,m]),m}stop(){const v=Date.now()-this.g;d.f+=v;let u=!1;function m(h,f){const n=[],r=new Array(h+1).join("	");for(const[t,a,s]of f.h)if(a&&s){u=!0,n.push(`${r}CREATES -> ${t}`);const c=m(h+1,s);c&&n.push(c)}else n.push(`${r}uses -> ${t}`);return n.join(`
`)}const l=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${v.toFixed(2)}ms (grand total ${d.f.toFixed(2)}ms)`];(v>2||u)&&d.all.add(l.join(`
`))}}e.Trace=d,d.all=new Set,d.c=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d.f=0}),define(re[201],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class D{constructor(R,k){this.a=R,this.b=k}getChannel(R){return this.a.getChannel(R,this.b)}registerChannel(R,k){this.a.registerChannel(R,k)}}e.MessagePortMainProcessService=D}),define(re[57],ae([0,1,39,55,71,4]),function(_,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class L{constructor(p,d,g,v){const u=g.getChannel(p);return P(d)?v.createInstance(new i.SyncDescriptor(d.channelClientCtor,[u])):D.ProxyChannel.toService(u,d?.proxyOptions)}}function P(w){return!!w?.channelClientCtor}e.IMainProcessService=(0,k.createDecorator)("mainProcessService");let I=class extends L{constructor(p,d,g,v){super(p,d,g,v)}};I=pe([K(2,e.IMainProcessService),K(3,k.IInstantiationService)],I);function S(w,p,d){(0,R.registerSingleton)(w,new i.SyncDescriptor(I,[p,d],!0))}e.registerMainProcessRemoteService=S,e.ISharedProcessService=(0,k.createDecorator)("sharedProcessService");let b=class extends L{constructor(p,d,g,v){super(p,d,g,v)}};b=pe([K(2,e.ISharedProcessService),K(3,k.IInstantiationService)],b);function C(w,p,d){(0,R.registerSingleton)(w,new i.SyncDescriptor(b,[p,d],!0))}e.registerSharedProcessRemoteService=C}),define(re[73],ae([0,1,21,2,5,166,29,4]),function(_,e,D,i,R,k,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.ILanguagePackService=(0,P.createDecorator)("languagePackService");let I=class extends i.Disposable{constructor(b){super(),this.c=b}async getAvailableLanguages(){const b=new D.CancellationTokenSource;setTimeout(()=>b.cancel(),1e3);let C;try{C=await this.c.query({text:'category:"language packs"',pageSize:20},b.token)}catch{return[]}const p=C.firstPage.filter(d=>d.properties.localizedLanguages?.length&&d.tags.some(g=>g.startsWith("lp-"))).map(d=>{const g=d.properties.localizedLanguages?.[0],v=this.getLocale(d);return{...this.f(v,g,d),extensionId:d.identifier.id,galleryExtension:d}});return p.push({...this.f("en","English"),extensionId:"default"}),p}getLocale(b){return b.tags.find(C=>C.startsWith("lp-"))?.split("lp-")[1]}f(b,C,w){const p=C??b;let d;if(p!==b&&(d=`(${b})`),b.toLowerCase()===R.language.toLowerCase()&&(d??="",d+=(0,k.localize)(0,null)),w?.installCount){d??="";const g=w.installCount;let v;g>1e6?v=`${Math.floor(g/1e5)/10}M`:g>1e3?v=`${Math.floor(g/1e3)}K`:v=String(g),d+=` $(cloud-download) ${v}`}return{id:b,label:p,description:d}}};I=pe([K(0,L.IExtensionGalleryService)],I),e.LanguagePackBaseService=I}),define(re[202],ae([0,1,2,73]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let R=class extends D.Disposable{constructor(L){super(),this.a=L,this.b()}b(){this.a.update()}};R=pe([K(0,i.ILanguagePackService)],R),e.LocalizationsUpdater=R}),define(re[7],ae([0,1,38,3,2,37,5,8,4]),function(_,e,D,i,R,k,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,I.createDecorator)("logService"),e.ILoggerService=(0,I.createDecorator)("loggerService");function S(){return new Date().toISOString()}var b;(function(c){c[c.Off=0]="Off",c[c.Trace=1]="Trace",c[c.Debug=2]="Debug",c[c.Info=3]="Info",c[c.Warning=4]="Warning",c[c.Error=5]="Error"})(b=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=b.Info;function C(c,o,y){switch(o){case b.Trace:c.trace(y);break;case b.Debug:c.debug(y);break;case b.Info:c.info(y);break;case b.Warning:c.warn(y);break;case b.Error:c.error(y);break;case b.Off:break;default:throw new Error(`Invalid log level ${o}`)}}e.log=C;function w(c){let o="";for(let y=0;y<c.length;y++){let E=c[y];if(typeof E=="object")try{E=JSON.stringify(E)}catch{}o+=(y>0?" ":"")+E}return o}e.format=w;class p extends R.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new i.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(o){this.b!==o&&(this.b=o,this.c.fire(this.b))}getLevel(){return this.b}f(o){return this.b!==b.Off&&this.b<=o}}e.AbstractLogger=p;class d extends p{constructor(o){super(),this.h=o}f(o){return this.h||super.f(o)}trace(o,...y){this.f(b.Trace)&&this.g(b.Trace,w([o,...y]))}debug(o,...y){this.f(b.Debug)&&this.g(b.Debug,w([o,...y]))}info(o,...y){this.f(b.Info)&&this.g(b.Info,w([o,...y]))}warn(o,...y){this.f(b.Warning)&&this.g(b.Warning,w([o,...y]))}error(o,...y){if(this.f(b.Error))if(o instanceof Error){const E=Array.prototype.slice.call(arguments);E[0]=o.stack,this.g(b.Error,w(E))}else this.g(b.Error,w([o,...y]))}flush(){}}e.AbstractMessageLogger=d;class g extends p{constructor(o=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(o),this.g=!L.isWindows}trace(o,...y){this.f(b.Trace)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,o,...y):console.log(`[main ${S()}]`,o,...y))}debug(o,...y){this.f(b.Debug)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,o,...y):console.log(`[main ${S()}]`,o,...y))}info(o,...y){this.f(b.Info)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,o,...y):console.log(`[main ${S()}]`,o,...y))}warn(o,...y){this.f(b.Warning)&&(this.g?console.warn(`\x1B[93m[main ${S()}]\x1B[0m`,o,...y):console.warn(`[main ${S()}]`,o,...y))}error(o,...y){this.f(b.Error)&&(this.g?console.error(`\x1B[91m[main ${S()}]\x1B[0m`,o,...y):console.error(`[main ${S()}]`,o,...y))}dispose(){}flush(){}}e.ConsoleMainLogger=g;class v extends p{constructor(o=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(o)}trace(o,...y){this.f(b.Trace)&&console.log("%cTRACE","color: #888",o,...y)}debug(o,...y){this.f(b.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",o,...y)}info(o,...y){this.f(b.Info)&&console.log("%c INFO","color: #33f",o,...y)}warn(o,...y){this.f(b.Warning)&&console.log("%c WARN","color: #993",o,...y)}error(o,...y){this.f(b.Error)&&console.log("%c  ERR","color: #f33",o,...y)}dispose(){}flush(){}}e.ConsoleLogger=v;class u extends p{constructor(o,y=e.DEFAULT_LOG_LEVEL){super(),this.g=o,this.setLevel(y)}trace(o,...y){this.f(b.Trace)&&this.g.log(b.Trace,[this.h(o),...y])}debug(o,...y){this.f(b.Debug)&&this.g.log(b.Debug,[this.h(o),...y])}info(o,...y){this.f(b.Info)&&this.g.log(b.Info,[this.h(o),...y])}warn(o,...y){this.f(b.Warning)&&this.g.log(b.Warning,[this.h(o),...y])}error(o,...y){this.f(b.Error)&&this.g.log(b.Error,[this.h(o),...y])}h(o){return typeof o=="string"?o:(0,D.toErrorMessage)(o,this.f(b.Trace))}dispose(){}flush(){}}e.AdapterLogger=u;class m extends p{constructor(o){super(),this.g=o,o.length&&this.setLevel(o[0].getLevel())}setLevel(o){for(const y of this.g)y.setLevel(o);super.setLevel(o)}trace(o,...y){for(const E of this.g)E.trace(o,...y)}debug(o,...y){for(const E of this.g)E.debug(o,...y)}info(o,...y){for(const E of this.g)E.info(o,...y)}warn(o,...y){for(const E of this.g)E.warn(o,...y)}error(o,...y){for(const E of this.g)E.error(o,...y)}flush(){for(const o of this.g)o.flush()}dispose(){for(const o of this.g)o.dispose()}}e.MultiplexLogService=m;class l extends R.Disposable{constructor(o){super(),this.b=o,this.B(o)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(o){this.b.setLevel(o)}getLevel(){return this.b.getLevel()}trace(o,...y){this.b.trace(o,...y)}debug(o,...y){this.b.debug(o,...y)}info(o,...y){this.b.info(o,...y)}warn(o,...y){this.b.warn(o,...y)}error(o,...y){this.b.error(o,...y)}flush(){this.b.flush()}}e.LogService=l;class h extends R.Disposable{constructor(o,y){super(),this.c=o,this.b=new k.ResourceMap,this.B(y(E=>this.setLevel(E)))}getLoggers(){return[...this.b.values()].map(({logger:o})=>o)}getLogger(o){return this.b.get(o)?.logger}createLogger(o,y,E){let T=this.b.get(o)?.logger;return T||(E=y?.always?b.Trace:E,T=this.f(o,E??this.c,y),this.b.set(o,{logger:T,logLevel:E})),T}setLevel(o,y){const E=P.URI.isUri(o)?o:void 0,T=E?y:o;if(E){const q=this.b.get(E);q&&q.logLevel!==T&&(q.logLevel=T,q.logger.setLevel(T))}else this.c=T,this.b.forEach(({logLevel:q,logger:N})=>{q===void 0&&N.setLevel(this.c)})}getLogLevel(o){return this.b.get(o)?.logLevel}dispose(){this.b.forEach(({logger:o})=>o.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=h;class f{constructor(){this.onDidChangeLogLevel=new i.Emitter().event}setLevel(o){}getLevel(){return b.Info}trace(o,...y){}debug(o,...y){}info(o,...y){}warn(o,...y){}error(o,...y){}critical(o,...y){}dispose(){}flush(){}}e.NullLogger=f;class n extends f{}e.NullLogService=n;class r extends h{constructor(){super(b.Info,i.Event.None)}f(o,y,E){return new f}}e.NullLoggerService=r;function t(c){if(c.verbose)return b.Trace;if(typeof c.logLevel=="string"){const o=s(c.logLevel.toLowerCase());if(o!==void 0)return o}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=t;function a(c){switch(c){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Off:return"off"}}e.LogLevelToString=a;function s(c){switch(c){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Error;case"off":return b.Off}}e.parseLogLevel=s}),define(re[203],ae([0,1,6,9,2,12,28,13,7]),function(_,e,D,i,R,k,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let S=class extends R.Disposable{constructor(C,w){super(),this.a=C,this.b=w,this.B(new D.RunOnceScheduler(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const C=(0,k.basename)(this.a.logsPath),w=(0,k.dirname)(this.a.logsPath),g=(await L.Promises.readdir(w)).filter(u=>/^\d{8}T\d{6}$/.test(u)).sort().filter(u=>u!==C),v=g.slice(0,Math.max(0,g.length-9));v.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${v.join(", ")}'`),await Promise.all(v.map(u=>L.Promises.rm((0,k.join)(w,u)))))}catch(C){(0,i.onUnexpectedError)(C)}}};S=pe([K(0,P.IEnvironmentService),K(1,I.ILogService)],S),e.LogsDataCleaner=S}),define(re[204],ae([0,1,20,6,9,3,2,12,56,7]),function(_,e,D,i,R,k,L,P,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class b extends L.Disposable{constructor(w,p){super(),this.a=w,this.b=p,this.c=this.B(new k.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new k.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new i.ThrottledDelayer(0)),this.s=[],this.t=this.B(new i.ThrottledDelayer(0))}watch(w,p){return p.recursive||this.b?.watcher?.forceUniversal?this.l(w,p):this.u(w,p)}l(w,p){const d={path:this.C(w),excludes:p.excludes,includes:p.includes,recursive:p.recursive},g=(0,D.insert)(this.j,d);return this.m(),(0,L.toDisposable)(()=>{g(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(w=>(0,R.onUnexpectedError)(w))}n(){this.h||(this.h=this.B(this.p(p=>this.c.fire((0,I.toFileChanges)(p)),p=>this.z(p),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)})));const w=this.b?.watcher?.recursive?.usePolling;if(w===!0)for(const p of this.j)(0,I.isRecursiveWatchRequest)(p)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const p of this.j)(0,I.isRecursiveWatchRequest)(p)&&w.includes(p.path)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(w,p){const d={path:this.C(w),excludes:p.excludes,includes:p.includes,recursive:!1},g=(0,D.insert)(this.s,d);return this.v(),(0,L.toDisposable)(()=>{g(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(w=>(0,R.onUnexpectedError)(w))}w(){return this.r||(this.r=this.B(this.y(w=>this.c.fire((0,I.toFileChanges)(w)),w=>this.z(w),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)}))),this.r.watch(this.s)}z(w){w.type==="error"&&this.g.fire(w.message),this.a[w.type](w.message)}C(w){return(0,P.normalize)(w.fsPath)}}e.AbstractDiskFileSystemProvider=b}),define(re[205],ae([0,1,20,6,17,21,3,66,64,2,49,25,206,22,44,162,14,100,7]),function(_,e,D,i,R,k,L,P,I,S,b,C,w,p,d,g,v,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let l=class extends S.Disposable{constructor(f){super(),this.b=f,this.a=256*1024,this.c=this.B(new L.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new L.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new L.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new L.Emitter),this.onDidRunOperation=this.m.event,this.Q=this.B(new L.Emitter),this.onDidFilesChange=this.Q.event,this.R=this.B(new L.Emitter),this.onDidWatchError=this.R.event,this.S=new Map,this.W=this.B(new i.ResourceQueue)}registerProvider(f,n){if(this.h.has(f))throw new Error(`A filesystem provider for the scheme '${f}' is already registered.`);(0,w.mark)(`code/registerFilesystem/${f}`);const r=new S.DisposableStore;return this.h.set(f,n),this.c.fire({added:!0,scheme:f,provider:n}),r.add(n.onDidChangeFile(t=>this.Q.fire(new v.FileChangesEvent(t,!this.N(n))))),typeof n.onDidWatchError=="function"&&r.add(n.onDidWatchError(t=>this.R.fire(new Error(t)))),r.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:f}))),(0,S.toDisposable)(()=>{this.c.fire({added:!1,scheme:f,provider:n}),this.h.delete(f),(0,S.dispose)(r)})}getProvider(f){return this.h.get(f)}async activateProvider(f){const n=[];this.f.fire({scheme:f,join(r){n.push(r)}}),!this.h.has(f)&&await i.Promises.settled(n)}async canHandleResource(f){return await this.activateProvider(f.scheme),this.hasProvider(f)}hasProvider(f){return this.h.has(f.scheme)}hasCapability(f,n){const r=this.h.get(f.scheme);return!!(r&&r.capabilities&n)}listCapabilities(){return I.Iterable.map(this.h,([f,n])=>({scheme:f,capabilities:n.capabilities}))}async j(f){if(!(0,p.isAbsolutePath)(f))throw new v.FileOperationError((0,g.localize)(0,null,this.mb(f)),8);await this.activateProvider(f.scheme);const n=this.h.get(f.scheme);if(!n){const r=new Error;throw r.name="ENOPRO",r.message=(0,g.localize)(1,null,f.toString()),r}return n}async k(f){const n=await this.j(f);if((0,v.hasOpenReadWriteCloseCapability)(n)||(0,v.hasReadWriteCapability)(n)||(0,v.hasFileReadStreamCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${f.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(f){const n=await this.j(f);if((0,v.hasOpenReadWriteCloseCapability)(n)||(0,v.hasReadWriteCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${f.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(f,n){try{return await this.n(f,n)}catch(r){throw(0,v.toFileSystemProviderErrorCode)(r)===v.FileSystemProviderErrorCode.FileNotFound?new v.FileOperationError((0,g.localize)(2,null,this.mb(f)),1):(0,v.ensureFileSystemProviderError)(r)}}async n(f,n){const r=await this.j(f),t=this.N(r),a=n?.resolveTo,s=n?.resolveSingleChildDescendants,c=n?.resolveMetadata,o=await r.stat(f);let y;return this.p(r,f,o,void 0,!!c,(E,T)=>(y||(y=b.TernarySearchTree.forUris(()=>!t),y.set(f,!0),a&&y.fill(!0,a)),y.get(E.resource)||y.findSuperstr(E.resource.with({query:null,fragment:null}))?!0:E.isDirectory&&s?T===1:!1))}async p(f,n,r,t,a,s){const{providerExtUri:c}=this.M(f),o={resource:n,name:c.basename(n),isFile:(r.type&v.FileType.File)!==0,isDirectory:(r.type&v.FileType.Directory)!==0,isSymbolicLink:(r.type&v.FileType.SymbolicLink)!==0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&v.FilePermission.Readonly)||Boolean(f.capabilities&2048),etag:(0,v.etag)({mtime:r.mtime,size:r.size}),children:void 0};if(o.isDirectory&&s(o,t)){try{const y=await f.readdir(n),E=await i.Promises.settled(y.map(async([T,q])=>{try{const N=c.joinPath(n,T),j=a?await f.stat(N):{type:q};return await this.p(f,N,j,y.length,a,s)}catch(N){return this.b.trace(N),null}}));o.children=(0,D.coalesce)(E)}catch(y){this.b.trace(y),o.children=[]}return o}return o}async resolveAll(f){return i.Promises.settled(f.map(async n=>{try{return{stat:await this.n(n.resource,n.options),success:!0}}catch(r){return this.b.trace(r),{stat:void 0,success:!1}}}))}async stat(f){const n=await this.j(f),r=await n.stat(f);return this.p(n,f,r,void 0,!0,()=>!1)}async exists(f){const n=await this.j(f);try{return!!await n.stat(f)}catch{return!1}}async canCreateFile(f,n){try{await this.r(f,n)}catch(r){return r}return!0}async r(f,n){if(!n?.overwrite&&await this.exists(f))throw new v.FileOperationError((0,g.localize)(3,null,this.mb(f)),3,n)}async createFile(f,n=R.VSBuffer.fromString(""),r){await this.r(f,r);const t=await this.writeFile(f,n);return this.m.fire(new v.FileOperationEvent(f,0,t)),t}async writeFile(f,n,r){const t=this.kb(await this.l(f),f),{providerExtUri:a}=this.M(t);try{await this.s(t,f,r)||await this.O(t,a.dirname(f));let c;if((0,v.hasReadWriteCapability)(t)&&!(n instanceof R.VSBuffer))if((0,d.isReadableStream)(n)){const o=await(0,d.peekStream)(n,3);o.ended?c=R.VSBuffer.concat(o.buffer):c=o}else c=(0,d.peekReadable)(n,o=>R.VSBuffer.concat(o),3);else c=n;!(0,v.hasOpenReadWriteCloseCapability)(t)||(0,v.hasReadWriteCapability)(t)&&c instanceof R.VSBuffer?await this.bb(t,f,r,c):await this.X(t,f,r,c instanceof R.VSBuffer?(0,R.bufferToReadable)(c):c),this.m.fire(new v.FileOperationEvent(f,4))}catch(s){throw new v.FileOperationError((0,g.localize)(4,null,this.mb(f),(0,v.ensureFileSystemProviderError)(s).toString()),(0,v.toFileOperationResult)(s),r)}return this.resolve(f,{resolveMetadata:!0})}async s(f,n,r){if(!!r?.unlock&&!(f.capabilities&8192))throw new Error((0,g.localize)(5,null,this.mb(n)));let a;try{a=await f.stat(n)}catch{return}if((a.type&v.FileType.Directory)!==0)throw new v.FileOperationError((0,g.localize)(6,null,this.mb(n)),0,r);if(this.lb(n,a),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==v.ETAG_DISABLED&&typeof a.mtime=="number"&&typeof a.size=="number"&&r.mtime<a.mtime&&r.etag!==(0,v.etag)({mtime:r.mtime,size:a.size}))throw new v.FileOperationError((0,g.localize)(7,null),3,r);return a}async readFile(f,n,r){const t=await this.k(f);return n?.atomic?this.t(t,f,n,r):this.u(t,f,n,r)}async t(f,n,r,t){return new Promise((a,s)=>{this.W.queueFor(n,this.M(f).providerExtUri).queue(async()=>{try{const c=await this.u(f,n,r,t);a(c)}catch(c){s(c)}})})}async u(f,n,r,t){const a=await this.v(f,n,{...r,preferUnbuffered:!0},t);return{...a,value:await(0,R.streamToBuffer)(a.value)}}async readFileStream(f,n,r){const t=await this.k(f);return this.v(t,f,n,r)}async v(f,n,r,t){const a=new k.CancellationTokenSource(t),s=this.D(n,r).then(o=>o,o=>{throw a.cancel(),o});let c;try{return typeof r?.etag=="string"&&r.etag!==v.ETAG_DISABLED&&await s,r?.atomic&&(0,v.hasFileAtomicReadCapability)(f)||!((0,v.hasOpenReadWriteCloseCapability)(f)||(0,v.hasFileReadStreamCapability)(f))||(0,v.hasReadWriteCapability)(f)&&r?.preferUnbuffered?c=this.C(f,n,r):(0,v.hasFileReadStreamCapability)(f)?c=this.w(f,n,a.token,r):c=this.z(f,n,a.token,r),{...await s,value:c}}catch(o){c&&await(0,d.consumeStream)(c);const y=(0,g.localize)(8,null,this.mb(n),(0,v.ensureFileSystemProviderError)(o).toString());throw o instanceof v.NotModifiedSinceFileOperationError?new v.NotModifiedSinceFileOperationError(y,o.stat,r):new v.FileOperationError(y,(0,v.toFileOperationResult)(o),r)}}w(f,n,r,t=Object.create(null)){const a=f.readFileStream(n,t,r);return(0,d.transform)(a,{data:s=>s instanceof R.VSBuffer?s:R.VSBuffer.wrap(s),error:s=>new v.FileOperationError((0,g.localize)(9,null,this.mb(n),(0,v.ensureFileSystemProviderError)(s).toString()),(0,v.toFileOperationResult)(s),t)},s=>R.VSBuffer.concat(s))}z(f,n,r,t=Object.create(null)){const a=(0,R.newWriteableBufferStream)();return(0,u.readFileIntoStream)(f,n,a,s=>s,{...t,bufferSize:this.a,errorTransformer:s=>new v.FileOperationError((0,g.localize)(10,null,this.mb(n),(0,v.ensureFileSystemProviderError)(s).toString()),(0,v.toFileOperationResult)(s),t)},r),a}C(f,n,r){const t=(0,d.newWriteableStream)(a=>R.VSBuffer.concat(a));return(async()=>{try{let a;r?.atomic&&(0,v.hasFileAtomicReadCapability)(f)?a=await f.readFile(n,{atomic:!0}):a=await f.readFile(n),typeof r?.position=="number"&&(a=a.slice(r.position)),typeof r?.length=="number"&&(a=a.slice(0,r.length)),this.F(n,a.byteLength,r),t.end(R.VSBuffer.wrap(a))}catch(a){t.error(a),t.end()}})(),t}async D(f,n){const r=await this.resolve(f,{resolveMetadata:!0});if(r.isDirectory)throw new v.FileOperationError((0,g.localize)(11,null,this.mb(f)),0,n);if(typeof n?.etag=="string"&&n.etag!==v.ETAG_DISABLED&&n.etag===r.etag)throw new v.NotModifiedSinceFileOperationError((0,g.localize)(12,null),r,n);return this.F(f,r.size,n),r}F(f,n,r){if(r?.limits){let t;if(typeof r.limits.memory=="number"&&n>r.limits.memory&&(t=9),typeof r.limits.size=="number"&&n>r.limits.size&&(t=7),typeof t=="number")throw new v.FileOperationError((0,g.localize)(13,null,this.mb(f)),t)}}async canMove(f,n,r){return this.G(f,n,"move",r)}async canCopy(f,n,r){return this.G(f,n,"copy",r)}async G(f,n,r,t){if(f.toString()!==n.toString())try{const a=r==="move"?this.kb(await this.l(f),f):await this.k(f),s=this.kb(await this.l(n),n);await this.L(a,f,s,n,r,t)}catch(a){return a}return!0}async move(f,n,r){const t=this.kb(await this.l(f),f),a=this.kb(await this.l(n),n),s=await this.H(t,f,a,n,"move",!!r),c=await this.resolve(n,{resolveMetadata:!0});return this.m.fire(new v.FileOperationEvent(f,s==="move"?2:3,c)),c}async copy(f,n,r){const t=await this.k(f),a=this.kb(await this.l(n),n),s=await this.H(t,f,a,n,"copy",!!r),c=await this.resolve(n,{resolveMetadata:!0});return this.m.fire(new v.FileOperationEvent(f,s==="copy"?3:2,c)),c}async H(f,n,r,t,a,s){if(n.toString()===t.toString())return a;const{exists:c,isSameResourceWithDifferentPathCase:o}=await this.L(f,n,r,t,a,s);if(c&&!o&&s&&await this.del(t,{recursive:!0}),await this.O(r,this.M(r).providerExtUri.dirname(t)),a==="copy"){if(f===r&&(0,v.hasFileFolderCopyCapability)(f))await f.copy(n,t,{overwrite:s});else{const y=await this.resolve(n);y.isDirectory?await this.J(f,y,r,t):await this.I(f,n,r,t)}return a}else return f===r?(await f.rename(n,t,{overwrite:s}),a):(await this.H(f,n,r,t,"copy",s),await this.del(n,{recursive:!0}),"copy")}async I(f,n,r,t){if((0,v.hasOpenReadWriteCloseCapability)(f)&&(0,v.hasOpenReadWriteCloseCapability)(r))return this.db(f,n,r,t);if((0,v.hasOpenReadWriteCloseCapability)(f)&&(0,v.hasReadWriteCapability)(r))return this.jb(f,n,r,t);if((0,v.hasReadWriteCapability)(f)&&(0,v.hasOpenReadWriteCloseCapability)(r))return this.hb(f,n,r,t);if((0,v.hasReadWriteCapability)(f)&&(0,v.hasReadWriteCapability)(r))return this.fb(f,n,r,t)}async J(f,n,r,t){await r.mkdir(t),Array.isArray(n.children)&&await i.Promises.settled(n.children.map(async a=>{const s=this.M(r).providerExtUri.joinPath(t,a.name);return a.isDirectory?this.J(f,await this.resolve(a.resource),r,s):this.I(f,a.resource,r,s)}))}async L(f,n,r,t,a,s){let c=!1;if(f===r){const{providerExtUri:y,isPathCaseSensitive:E}=this.M(f);if(E||(c=y.isEqual(n,t)),c&&a==="copy")throw new Error((0,g.localize)(14,null,this.mb(n),this.mb(t)));if(!c&&y.isEqualOrParent(t,n))throw new Error((0,g.localize)(15,null,this.mb(n),this.mb(t)))}const o=await this.exists(t);if(o&&!c){if(!s)throw new v.FileOperationError((0,g.localize)(16,null,this.mb(n),this.mb(t)),4);if(f===r){const{providerExtUri:y}=this.M(f);if(y.isEqualOrParent(n,t))throw new Error((0,g.localize)(17,null,this.mb(n),this.mb(t)))}}return{exists:o,isSameResourceWithDifferentPathCase:c}}M(f){const n=this.N(f);return{providerExtUri:n?p.extUri:p.extUriIgnorePathCase,isPathCaseSensitive:n}}N(f){return!!(f.capabilities&1024)}async createFolder(f){const n=this.kb(await this.j(f),f);await this.O(n,f);const r=await this.resolve(f,{resolveMetadata:!0});return this.m.fire(new v.FileOperationEvent(f,0,r)),r}async O(f,n){const r=[],{providerExtUri:t}=this.M(f);for(;!t.isEqual(n,t.dirname(n));)try{if(((await f.stat(n)).type&v.FileType.Directory)===0)throw new Error((0,g.localize)(18,null,this.mb(n)));break}catch(a){if((0,v.toFileSystemProviderErrorCode)(a)!==v.FileSystemProviderErrorCode.FileNotFound)throw a;r.push(t.basename(n)),n=t.dirname(n)}for(let a=r.length-1;a>=0;a--){n=t.joinPath(n,r[a]);try{await f.mkdir(n)}catch(s){if((0,v.toFileSystemProviderErrorCode)(s)!==v.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(f,n){try{await this.P(f,n)}catch(r){return r}return!0}async P(f,n){const r=this.kb(await this.j(f),f);if(!!n?.useTrash&&!(r.capabilities&4096))throw new Error((0,g.localize)(19,null,this.mb(f)));let a;try{a=await r.stat(f)}catch{}if(a)this.lb(f,a);else throw new v.FileOperationError((0,g.localize)(20,null,this.mb(f)),1);if(!!!n?.recursive){const c=await this.resolve(f);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error((0,g.localize)(21,null,this.mb(f)))}return r}async del(f,n){const r=await this.P(f,n),t=!!n?.useTrash,a=!!n?.recursive;await r.delete(f,{recursive:a,useTrash:t}),this.m.fire(new v.FileOperationEvent(f,1))}async cloneFile(f,n){const r=await this.j(f),t=this.kb(await this.l(n),n);if(r===t&&this.M(r).providerExtUri.isEqual(f,n))return;if(r===t&&(0,v.hasFileCloneCapability)(r))return r.cloneFile(f,n);await this.O(t,this.M(t).providerExtUri.dirname(n));const a=this.W.queueFor(f,this.M(r).providerExtUri);return r===t&&(0,v.hasFileFolderCopyCapability)(r)?a.queue(()=>r.copy(f,n,{overwrite:!0})):a.queue(()=>this.I(r,f,t,n))}watch(f,n={recursive:!1,excludes:[]}){const r=new S.DisposableStore;let t=!1,a=()=>{t=!0};return r.add((0,S.toDisposable)(()=>a())),(async()=>{try{const s=await this.U(f,n);t?(0,S.dispose)(s):a=()=>(0,S.dispose)(s)}catch(s){this.b.error(s)}})(),r}async U(f,n){const r=await this.j(f),t=(0,P.hash)([this.M(r).providerExtUri.getComparisonKey(f),n]);let a=this.S.get(t);return a||(a={count:0,disposable:r.watch(f,n)},this.S.set(t,a)),a.count+=1,(0,S.toDisposable)(()=>{a&&(a.count--,a.count===0&&((0,S.dispose)(a.disposable),this.S.delete(t)))})}dispose(){super.dispose();for(const[,f]of this.S)(0,S.dispose)(f.disposable);this.S.clear()}async X(f,n,r,t){return this.W.queueFor(n,this.M(f).providerExtUri).queue(async()=>{const a=await f.open(n,{create:!0,unlock:r?.unlock??!1});try{(0,d.isReadableStream)(t)||(0,d.isReadableBufferedStream)(t)?await this.Y(f,a,t):await this.Z(f,a,t)}catch(s){throw(0,v.ensureFileSystemProviderError)(s)}finally{await f.close(a)}})}async Y(f,n,r){let t=0,a;if((0,d.isReadableBufferedStream)(r)){if(r.buffer.length>0){const s=R.VSBuffer.concat(r.buffer);await this.ab(f,n,s,s.byteLength,t,0),t+=s.byteLength}if(r.ended)return;a=r.stream}else a=r;return new Promise((s,c)=>{(0,d.listenStream)(a,{onData:async o=>{a.pause();try{await this.ab(f,n,o,o.byteLength,t,0)}catch(y){return c(y)}t+=o.byteLength,setTimeout(()=>a.resume())},onError:o=>c(o),onEnd:()=>s()})})}async Z(f,n,r){let t=0,a;for(;(a=r.read())!==null;)await this.ab(f,n,a,a.byteLength,t,0),t+=a.byteLength}async ab(f,n,r,t,a,s){let c=0;for(;c<t;)c+=await f.write(n,a+c,r.buffer,s+c,t-c)}async bb(f,n,r,t){return this.W.queueFor(n,this.M(f).providerExtUri).queue(()=>this.cb(f,n,r,t))}async cb(f,n,r,t){let a;t instanceof R.VSBuffer?a=t:(0,d.isReadableStream)(t)?a=await(0,R.streamToBuffer)(t):(0,d.isReadableBufferedStream)(t)?a=await(0,R.bufferedStreamToBuffer)(t):a=(0,R.readableToBuffer)(t),await f.writeFile(n,a.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async db(f,n,r,t){return this.W.queueFor(t,this.M(r).providerExtUri).queue(()=>this.eb(f,n,r,t))}async eb(f,n,r,t){let a,s;try{a=await f.open(n,{create:!1}),s=await r.open(t,{create:!0,unlock:!1});const c=R.VSBuffer.alloc(this.a);let o=0,y=0,E=0;do E=await f.read(a,o,c.buffer,y,c.byteLength-y),await this.ab(r,s,c,E,o,y),o+=E,y+=E,y===c.byteLength&&(y=0);while(E>0)}catch(c){throw(0,v.ensureFileSystemProviderError)(c)}finally{await i.Promises.settled([typeof a=="number"?f.close(a):Promise.resolve(),typeof s=="number"?r.close(s):Promise.resolve()])}}async fb(f,n,r,t){return this.W.queueFor(t,this.M(r).providerExtUri).queue(()=>this.gb(f,n,r,t))}async gb(f,n,r,t){return r.writeFile(t,await f.readFile(n),{create:!0,overwrite:!0,unlock:!1})}async hb(f,n,r,t){return this.W.queueFor(t,this.M(r).providerExtUri).queue(()=>this.ib(f,n,r,t))}async ib(f,n,r,t){const a=await r.open(t,{create:!0,unlock:!1});try{const s=await f.readFile(n);await this.ab(r,a,R.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,v.ensureFileSystemProviderError)(s)}finally{await r.close(a)}}async jb(f,n,r,t){const a=await(0,R.streamToBuffer)(this.z(f,n,k.CancellationToken.None));await this.bb(r,t,void 0,a)}kb(f,n){if(f.capabilities&2048)throw new v.FileOperationError((0,g.localize)(22,null,this.mb(n)),6);return f}lb(f,n){if((n.permissions??0)&v.FilePermission.Readonly)throw new v.FileOperationError((0,g.localize)(23,null,this.mb(f)),6)}mb(f){return f.scheme===C.Schemas.file?f.fsPath:f.toString(!0)}};l=pe([K(0,m.ILogService)],l),e.FileService=l}),define(re[207],ae([0,1,53,286,6,37,17,3,48,2,12,5,22,44,28,165,14,100,204,38,199,198]),function(_,e,D,i,R,k,L,P,I,S,b,C,w,p,d,g,v,u,m,l,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,i.gracefulify)(D)}catch(r){console.error(`Error enabling graceful-fs: ${(0,l.toErrorMessage)(r)}`)}})();class n extends m.AbstractDiskFileSystemProvider{constructor(t,a){super(t,a),this.onDidChangeCapabilities=P.Event.None,this.H=new k.ResourceMap(s=>w.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,C.isLinux&&(this.F|=1024)),this.F}async stat(t){try{const{stat:a,symbolicLink:s}=await d.SymlinkSupport.stat(this.C(t));return{type:this.G(a,s),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.Y(a)}}async readdir(t){try{const a=await d.Promises.readdir(this.C(t),{withFileTypes:!0}),s=[];return await Promise.all(a.map(async c=>{try{let o;c.isSymbolicLink()?o=(await this.stat((0,w.joinPath)(t,c.name))).type:o=this.G(c),s.push([c.name,o])}catch(o){this.a.trace(o)}})),s}catch(a){throw this.Y(a)}}G(t,a){let s;return a?.dangling?s=v.FileType.Unknown:t.isFile()?s=v.FileType.File:t.isDirectory()?s=v.FileType.Directory:s=v.FileType.Unknown,a&&(s|=v.FileType.SymbolicLink),s}async I(t){const a=this.C(t);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${a})`);let s;for(;s=this.H.get(t);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${a})`),await s.wait();const c=new R.Barrier;return this.H.set(t,c),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${a})`),(0,S.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${a})`),this.H.get(t)===c&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${a})`),this.H.delete(t)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${a})`),c.open()})}async readFile(t,a){let s;try{a?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(t)})`),s=await this.I(t));const c=this.C(t);return await d.Promises.readFile(c)}catch(c){throw this.Y(c)}finally{s?.dispose()}}J(t){n.D&&this.a.trace(t)}readFileStream(t,a,s){const c=(0,p.newWriteableStream)(o=>L.VSBuffer.concat(o.map(y=>L.VSBuffer.wrap(y))).buffer);return(0,u.readFileIntoStream)(this,t,c,o=>o.buffer,{...a,bufferSize:256*1024},s),c}async writeFile(t,a,s){let c;try{const o=this.C(t);if(!s.create||!s.overwrite){if(await d.Promises.exists(o)){if(!s.overwrite)throw(0,v.createFileSystemProviderError)((0,g.localize)(0,null),v.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,v.createFileSystemProviderError)((0,g.localize)(1,null),v.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(t,{create:!0,unlock:s.unlock}),await this.write(c,0,a,0,a.byteLength)}catch(o){throw await this.Z(t,o)}finally{typeof c=="number"&&await this.close(c)}}static configureFlushOnWrite(t){n.O=t}async open(t,a){const s=this.C(t);let c;(0,v.isFileOpenForWriteOptions)(a)&&(c=await this.I(t));let o;try{if((0,v.isFileOpenForWriteOptions)(a)&&a.unlock)try{const{stat:E}=await d.SymlinkSupport.stat(s);E.mode&128||await d.Promises.chmod(s,E.mode|128)}catch(E){this.a.trace(E)}let y;if((0,v.isFileOpenForWriteOptions)(a)){if(C.isWindows)try{await d.Promises.truncate(s,0),y="r+"}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}y||(y="w")}else y="r";o=await d.Promises.open(s,y)}catch(y){throw c?.dispose(),(0,v.isFileOpenForWriteOptions)(a)?await this.Z(t,y):this.Y(y)}if(this.L.set(o,0),(0,v.isFileOpenForWriteOptions)(a)&&this.N.set(o,t),c){const y=this.M.get(o);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${o} (${s})`),this.M.set(o,c),y&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${o} (${s})`),y.dispose())}return o}async close(t){const a=this.M.get(t);try{if(this.L.delete(t),this.N.delete(t)&&n.O)try{await d.Promises.fdatasync(t)}catch(s){n.configureFlushOnWrite(!1),this.a.error(s)}return await d.Promises.close(t)}catch(s){throw this.Y(s)}finally{a&&(this.M.get(t)===a&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.M.delete(t)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),a.dispose())}}async read(t,a,s,c,o){const y=this.P(t,a);let E=null;try{E=(await d.Promises.read(t,s,c,o,y)).bytesRead}catch(T){throw this.Y(T)}finally{this.Q(t,y,E)}return E}P(t,a){return a===this.L.get(t)?null:a}Q(t,a,s){const c=this.L.get(t);typeof c=="number"&&(typeof a=="number"||(typeof s=="number"?this.L.set(t,c+s):this.L.delete(t)))}async write(t,a,s,c,o){return(0,R.retry)(()=>this.R(t,a,s,c,o),100,3)}async R(t,a,s,c,o){const y=this.P(t,a);let E=null;try{E=(await d.Promises.write(t,s,c,o,y)).bytesWritten}catch(T){throw await this.Z(this.N.get(t),T)}finally{this.Q(t,y,E)}return E}async mkdir(t){try{await d.Promises.mkdir(this.C(t))}catch(a){throw this.Y(a)}}async delete(t,a){try{const s=this.C(t);a.recursive?await d.Promises.rm(s,d.RimRafMode.MOVE):await d.Promises.unlink(s)}catch(s){throw this.Y(s)}}async rename(t,a,s){const c=this.C(t),o=this.C(a);if(c!==o)try{await this.S(t,a,"move",s.overwrite),await d.Promises.move(c,o)}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,g.localize)(2,null,(0,b.basename)(c),(0,b.basename)((0,b.dirname)(o)),y.toString()))),this.Y(y)}}async copy(t,a,s){const c=this.C(t),o=this.C(a);if(c!==o)try{await this.S(t,a,"copy",s.overwrite),await d.Promises.copy(c,o,{preserveSymlinks:!0})}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,g.localize)(3,null,(0,b.basename)(c),(0,b.basename)((0,b.dirname)(o)),y.toString()))),this.Y(y)}}async S(t,a,s,c){const o=this.C(t),y=this.C(a);let E=!1;if(!!(this.capabilities&1024)||(E=(0,I.isEqual)(o,y,!0)),E&&s==="copy")throw(0,v.createFileSystemProviderError)((0,g.localize)(4,null),v.FileSystemProviderErrorCode.FileExists);if(!E&&await d.Promises.exists(y)){if(!c)throw(0,v.createFileSystemProviderError)((0,g.localize)(5,null),v.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}async cloneFile(t,a){return this.U(t,a,!1)}async U(t,a,s){const c=this.C(t),o=this.C(a),y=!!(this.capabilities&1024);if((0,I.isEqual)(c,o,!y))return;const E=new S.DisposableStore;try{const[T,q]=await Promise.all([this.I(t),this.I(a)]);E.add(T),E.add(q),s&&await d.Promises.mkdir((0,b.dirname)(o),{recursive:!0}),await d.Promises.copyFile(c,o)}catch(T){if(T.code==="ENOENT"&&!s)return this.U(t,a,!0);throw this.Y(T)}finally{E.dispose()}}p(t,a,s){return new h.UniversalWatcherClient(c=>t(c),c=>a(c),s)}y(t,a,s){return new f.NodeJSWatcherClient(c=>t(c),c=>a(c),s)}Y(t){if(t instanceof v.FileSystemProviderError)return t;let a;switch(t.code){case"ENOENT":a=v.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=v.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=v.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=v.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=v.FileSystemProviderErrorCode.NoPermissions;break;default:a=v.FileSystemProviderErrorCode.Unknown}return(0,v.createFileSystemProviderError)(t,a)}async Z(t,a){let s=this.Y(a);if(t&&s.code===v.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await d.SymlinkSupport.stat(this.C(t));c.mode&128||(s=(0,v.createFileSystemProviderError)(a,v.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.a.trace(c)}return s}}e.DiskFileSystemProvider=n,n.D=!1,n.O=!0}),define(re[101],ae([0,1,6,3,2,4,7]),function(_,e,D,i,R,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessLifecycleService=e.ISharedProcessLifecycleService=void 0,e.ISharedProcessLifecycleService=(0,k.createDecorator)("lifecycleSharedProcessService");let P=class extends R.Disposable{constructor(S){super(),this.c=S,this.a=void 0,this.b=this.B(new i.Emitter),this.onWillShutdown=this.b.event}fireOnWillShutdown(){if(this.a)return this.a;this.c.trace("Lifecycle#onWillShutdown.fire()");const S=[];return this.b.fire({join(b){S.push(b)}}),this.a=(async()=>{try{await D.Promises.settled(S)}catch(b){this.c.error(b)}})(),this.a}};P=pe([K(0,L.ILogService)],P),e.SharedProcessLifecycleService=P}),define(re[102],ae([0,1,3,8,7]),function(_,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class k{constructor(w,p){this.a=w,this.b=p,this.onDidChangeLogLevel=D.Event.buffer(w.onDidChangeLogLevel,!0)}listen(w,p){switch(p){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${p}`)}async call(w,p,d){switch(p){case"setLevel":return d[1]?this.b.setLevel(i.URI.revive(d[1]),d[0]):this.a.setLevel(d[0])}throw new Error(`Call not found: ${p}`)}}e.LogLevelChannel=k;class L{constructor(w){this.a=w}get onDidChangeLogLevel(){return this.a.listen("onDidChangeLogLevel")}setLevel(w,p){L.setLevel(this.a,w,p)}static setLevel(w,p,d){return w.call("setLevel",[p,d])}}e.LogLevelChannelClient=L;class P{constructor(w){this.b=w,this.a=new Map}listen(w,p){throw new Error(`Event not found: ${p}`)}async call(w,p,d){switch(p){case"createLogger":this.c(i.URI.revive(d[0]),d[1]);return;case"log":return this.e(i.URI.revive(d[0]),d[1]);case"consoleLog":return this.d(d[0],d[1])}throw new Error(`Call not found: ${p}`)}c(w,p){this.a.set(w.toString(),this.b.createLogger(w,p))}d(w,p){let d=console.log;switch(w){case R.LogLevel.Error:d=console.error;break;case R.LogLevel.Warning:d=console.warn;break;case R.LogLevel.Info:d=console.info;break}d.call(console,...p)}e(w,p){const d=this.a.get(w.toString());if(!d)throw new Error("Create the logger before logging");for(const[g,v]of p)(0,R.log)(d,g,v)}}e.LoggerChannel=P;class I extends R.AbstractLoggerService{constructor(w,p,d){super(w,p),this.g=d}createConsoleMainLogger(){return new R.AdapterLogger({log:(w,p)=>{this.g.call("consoleLog",[w,p])}})}f(w,p,d){return new S(this.g,w,p,d)}}e.LoggerChannelClient=I;class S extends R.AbstractMessageLogger{constructor(w,p,d,g){super(g?.always),this.m=w,this.n=p,this.k=!1,this.l=[],this.setLevel(d),this.m.call("createLogger",[p,g]).then(()=>{this.r(this.l),this.k=!0})}g(w,p){const d=[[w,p]];this.k?this.r(d):this.l.push(...d)}r(w){this.m.call("log",[this.n,w])}}class b extends R.LogService{constructor(w,p){super(p),this.c=w,this.B(w.onDidChangeLogLevel(d=>p.setLevel(d)))}setLevel(w){super.setLevel(w),this.c.setLevel(w)}}e.FollowerLogService=b}),define(re[58],ae([0,1,4]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,D.createDecorator)("nativeHostService")}),define(re[59],ae([0,1,3,64,2,4]),function(_,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,k.createDecorator)("policy");class L extends R.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new D.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(S){const b=Object.keys(this.f).length;return this.f={...S,...this.f},b!==Object.keys(this.f).length&&await this.i(S),i.Iterable.reduce(this.g.entries(),(C,[w,p])=>({...C,[w]:p}),{})}getPolicyValue(S){return this.g.get(S)}serialize(){return i.Iterable.reduce(Object.entries(this.f),(S,[b,C])=>({...S,[b]:{definition:C,value:this.g.get(b)}}),{})}}e.AbstractPolicyService=L;class P{constructor(){this.onDidChange=D.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=P}),define(re[208],ae([0,1,3,2,59]),function(_,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class k{constructor(I){this.b=I,this.a=new i.DisposableStore}listen(I,S){switch(S){case"onDidChange":return D.Event.map(this.b.onDidChange,b=>b.reduce((C,w)=>({...C,[w]:this.b.getPolicyValue(w)??null}),{}),this.a)}throw new Error(`Event not found: ${S}`)}call(I,S,b){switch(S){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(b)}throw new Error(`Call not found: ${S}`)}dispose(){this.a.dispose()}}e.PolicyChannel=k;class L extends R.AbstractPolicyService{constructor(I,S){super(),this.a=S;for(const b in I){const{definition:C,value:w}=I[b];this.f[b]=C,w!==void 0&&this.g.set(b,w)}this.a.listen("onDidChange")(b=>{for(const C in b){const w=b[C];w===null?this.g.delete(C):this.g.set(C,w)}this.h.fire(Object.keys(b))})}async i(I){const S=await this.a.call("updatePolicyDefinitions",I);for(const b in S)this.g.set(b,S[b])}}e.PolicyChannelClient=L}),define(re[103],ae([0,1,5,36]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let R;if(typeof D.globals.vscode<"u"&&typeof D.globals.vscode.context<"u"){const k=D.globals.vscode.context.configuration();if(k)R=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(R=globalThis._VSCODE_PRODUCT_JSON,i.env.VSCODE_DEV&&Object.assign(R,{nameShort:`${R.nameShort} Dev`,nameLong:`${R.nameLong} Dev`,dataFolderName:`${R.dataFolderName}-dev`,serverDataFolderName:R.serverDataFolderName?`${R.serverDataFolderName}-dev`:void 0}),!R.version){const k=globalThis._VSCODE_PACKAGE_JSON;Object.assign(R,{version:k.version})}}else R={},Object.keys(R).length===0&&Object.assign(R,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=R}),define(re[23],ae([0,1,4]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,D.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(re[209],ae([0,1,6,9,2,12,28,7,23]),function(_,e,D,i,R,k,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let S=class extends R.Disposable{constructor(C,w,p){super(),this.b=w,this.c=p,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,C&&this.B(new D.RunOnceScheduler(()=>{this.f(C)},3e4)).schedule()}async f(C){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const w=Date.now(),p=(0,k.dirname)(C),d=(0,k.basename)(C),g=await L.Promises.readdir(p);await Promise.all(g.map(async v=>{if(v===d)return;const u=(0,k.join)(p,v),m=await L.Promises.stat(u);if(m.isDirectory()&&w-m.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${v}.`),L.Promises.rm(u)}))}catch(w){(0,i.onUnexpectedError)(w)}}};S=pe([K(1,I.IProductService),K(2,P.ILogService)],S),e.CodeCacheCleaner=S}),define(re[210],ae([0,1,6,9,2,12,28,13,7,23]),function(_,e,D,i,R,k,L,P,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let b=class extends R.Disposable{constructor(w,p,d){super(),this.b=w,this.c=p,this.f=d,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new D.RunOnceScheduler(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const w=Object.create(null),p=JSON.parse(await L.Promises.readFile((0,k.join)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const m of Object.keys(p)){const l=p[m];w[`${l.hash}.${m}`]=!0}const d=(0,k.join)(this.b.userDataPath,"clp");if(!await L.Promises.exists(d))return;const v=await L.Promises.readdir(d);for(const m of v){if(w[m]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${m}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${m}`),await L.Promises.rm((0,k.join)(d,m))}const u=Date.now();for(const m of Object.keys(w)){const l=(0,k.join)(d,m),h=await L.Promises.readdir(l);for(const f of h){if(f==="tcf.json")continue;const n=(0,k.join)(l,f),r=await L.Promises.stat(n);r.isDirectory()&&u-r.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,k.join)(m,f)}`),await L.Promises.rm(n))}}}catch(w){(0,i.onUnexpectedError)(w)}}};b=pe([K(0,P.INativeEnvironmentService),K(1,I.ILogService),K(2,S.IProductService)],b),e.LanguagePackCachedDataCleaner=b}),define(re[211],ae([0,1,12,4]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,i.createDecorator)("IV8InspectProfilingService");var R;(function(k){function L(I){return Boolean(I.samples&&I.timeDeltas)}k.isValidProfile=L;function P(I,S="noAbsolutePaths"){for(const b of I.nodes)b.callFrame&&b.callFrame.url&&((0,D.isAbsolute)(b.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(b.callFrame.url))&&(b.callFrame.url=(0,D.join)(S,(0,D.basename)(b.callFrame.url)));return I}k.rewriteAbsolutePaths=P})(R=e.Utils||(e.Utils={}))}),define(re[212],ae([0,1,31]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class i{constructor(){this.a=new Map}async startProfiling(k){const P=await(await new Promise((S,b)=>{_(["v8-inspect-profiler"],S,b)})).startProfiling({port:k.port,checkForPaused:!0}),I=(0,D.generateUuid)();return this.a.set(I,P),I}async stopProfiling(k){const L=this.a.get(k);if(!L)throw new Error(`UNKNOWN session '${k}'`);const P=await L.stop();return this.a.delete(k),P.profile}}e.InspectProfilingService=i}),define(re[40],ae([0,1,126,15]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class R{constructor(){this.a=new Map}add(L,P){D.ok(i.isString(L)),D.ok(i.isObject(P)),D.ok(!this.a.has(L),"There is already an extension with this id"),this.a.set(L,P)}knows(L){return this.a.has(L)}as(L){return this.a.get(L)||null}}e.Registry=new R}),define(re[104],ae([0,1,3,40]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function R(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class k{constructor(){this.b=new D.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(I,S){this.a[R(I)]=S,this.b.fire(I)}notifySchemaChanged(I){this.b.fire(I)}getSchemaContributions(){return{schemas:this.a}}}const L=new k;i.Registry.add(e.Extensions.JSONContribution,L)}),define(re[46],ae([0,1,20,3,15,151,16,104,40]),function(_,e,D,i,R,k,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(f){f.Multiline="multilineText",f.Singleline="singlelineText"})(S=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var b;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.MACHINE=2]="MACHINE",f[f.WINDOW=3]="WINDOW",f[f.RESOURCE=4]="RESOURCE",f[f.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",f[f.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(b=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const C=I.Registry.as(P.Extensions.JSONContribution);class w{constructor(){this.h=new Set,this.i=new i.Emitter,this.onDidSchemaChange=this.i.event,this.j=new i.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:k.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},C.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.r()}registerConfiguration(n,r=!0){this.registerConfigurations([n],r)}registerConfigurations(n,r=!0){const t=this.k(n,r);C.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(n){const r=this.l(n);C.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:n,remove:r}){const t=[];t.push(...this.l(r)),t.push(...this.k(n,!1)),C.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:(0,D.distinct)(t)})}registerDefaultConfigurations(n){const r=[],t=[];for(const{overrides:a,source:s}of n)for(const c in a)if(r.push(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){const o=this.a.get(c),y=o?.valuesSources??new Map;if(s)for(const N of Object.keys(a[c]))y.set(N,s);const E={...o?.value||{},...a[c]};this.a.set(c,{source:s,value:E,valuesSources:y});const T=(0,L.getLanguageTagSettingPlainKey)(c),q={type:"object",default:E,description:k.localize(1,null,T),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:E,source:R.isString(s)?void 0:s,defaultValueSource:s};t.push(...g(c)),this.d[c]=q,this.b.properties[c]=q}else{this.a.set(c,{value:a[c],source:s});const o=this.d[c];o&&(this.s(c,o),this.o(c,o))}this.registerOverrideIdentifiers(t),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(n){const r=[];for(const{overrides:t,source:a}of n)for(const s in t){const c=this.a.get(s),o=R.isString(a)?a:a?.id,y=R.isString(c?.source)?c?.source:c?.source?.id;if(o===y)if(r.push(s),this.a.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.d[s],delete this.b.properties[s];else{const E=this.d[s];E&&(this.s(s,E),this.o(s,E))}}this.q(),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){for(const r of n)this.h.add(r);this.q()}k(n,r){const t=[];return n.forEach(a=>{t.push(...this.m(a,r,a.extensionInfo,a.restrictedProperties)),this.c.push(a),this.n(a)}),t}l(n){const r=[],t=a=>{if(a.properties)for(const s in a.properties){r.push(s);const c=this.d[s];c?.policy?.name&&this.e.delete(c.policy.name),delete this.d[s],this.p(s,a.properties[s])}a.allOf?.forEach(s=>t(s))};for(const a of n){t(a);const s=this.c.indexOf(a);s!==-1&&this.c.splice(s,1)}return r}m(n,r=!0,t,a,s=3){s=R.isUndefinedOrNull(n.scope)?s:n.scope;const c=[],o=n.properties;if(o)for(const E in o){const T=o[E];if(r&&l(E,T)){delete o[E];continue}if(T.source=t,T.defaultDefaultValue=o[E].default,this.s(E,T),e.OVERRIDE_PROPERTY_REGEX.test(E)?T.scope=void 0:(T.scope=R.isUndefinedOrNull(T.scope)?s:T.scope,T.restricted=R.isUndefinedOrNull(T.restricted)?!!a?.includes(E):T.restricted),o[E].hasOwnProperty("included")&&!o[E].included){this.f[E]=o[E],delete o[E];continue}else this.d[E]=o[E],o[E].policy?.name&&this.e.set(o[E].policy.name,E);!o[E].deprecationMessage&&o[E].markdownDeprecationMessage&&(o[E].deprecationMessage=o[E].markdownDeprecationMessage),c.push(E)}const y=n.allOf;if(y)for(const E of y)c.push(...this.m(E,r,t,a,s));return c}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}n(n){const r=t=>{const a=t.properties;if(a)for(const c in a)this.o(c,a[c]);t.allOf?.forEach(r)};r(n)}o(n,r){switch(e.allSettings.properties[n]=r,r.scope){case 1:e.applicationSettings.properties[n]=r;break;case 2:e.machineSettings.properties[n]=r;break;case 6:e.machineOverridableSettings.properties[n]=r;break;case 3:e.windowSettings.properties[n]=r;break;case 4:e.resourceSettings.properties[n]=r;break;case 5:e.resourceSettings.properties[n]=r,this.g.properties[n]=r;break}}p(n,r){switch(delete e.allSettings.properties[n],r.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.g.properties[n];break}}q(){for(const n of this.h.values()){const r=`[${n}]`,t={type:"object",description:k.localize(2,null),errorMessage:k.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.s(r,t),e.allSettings.properties[r]=t,e.applicationSettings.properties[r]=t,e.machineSettings.properties[r]=t,e.machineOverridableSettings.properties[r]=t,e.windowSettings.properties[r]=t,e.resourceSettings.properties[r]=t}this.i.fire()}r(){const n={type:"object",description:k.localize(4,null),errorMessage:k.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this.i.fire()}s(n,r){const t=this.a.get(n);let a=t?.value,s=t?.source;R.isUndefined(a)&&(a=r.defaultDefaultValue,s=void 0),R.isUndefined(a)&&(a=u(r.type)),r.default=a,r.defaultValueSource=s}}const p="\\[([^\\]]+)\\]",d=new RegExp(p,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${p})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function g(f){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(f)){let r=d.exec(f);for(;r?.length;){const t=r[1].trim();t&&n.push(t),r=d.exec(f)}}return(0,D.distinct)(n)}e.overrideIdentifiersFromKey=g;function v(f){return f.reduce((n,r)=>`${n}[${r}]`,"")}e.keyFromOverrideIdentifiers=v;function u(f){switch(Array.isArray(f)?f[0]:f){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const m=new w;I.Registry.add(e.Extensions.Configuration,m);function l(f,n){return f.trim()?e.OVERRIDE_PROPERTY_REGEX.test(f)?k.localize(7,null,f):m.getConfigurationProperties()[f]!==void 0?k.localize(8,null,f):n.policy?.name&&m.getPolicyConfigurations().get(n.policy?.name)!==void 0?k.localize(9,null,f,n.policy?.name,m.getPolicyConfigurations().get(n.policy?.name)):null:k.localize(6,null)}e.validateProperty=l;function h(){const f=[],n=m.getConfigurationProperties();for(const r of Object.keys(n))f.push([r,n[r].scope]);return f.push(["launch",4]),f.push(["task",4]),f}e.getScopes=h}),define(re[74],ae([0,1,20,3,35,2,37,32,15,8,16,46,40]),function(_,e,D,i,R,k,L,P,I,S,b,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class p{constructor(r={},t=[],a=[],s){this.c=r,this.d=t,this.f=a,this.raw=s,this.a=!1,this.b=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const r=this.raw.map(t=>{if(t instanceof p)return t;const a=new d("");return a.parseRaw(t),a.configurationModel});this.g=r.reduce((t,a)=>a===t?a:t.merge(a),r[0])}else this.g=this;return this.g}get contents(){return this.k(this.c)}get overrides(){return this.k(this.f)}get keys(){return this.k(this.d)}isEmpty(){return this.d.length===0&&Object.keys(this.c).length===0&&this.f.length===0}isFrozen(){return this.a}getValue(r){return r?(0,b.getConfigurationValue)(this.contents,r):this.contents}inspect(r,t){const a=this.rawConfiguration.getValue(r),s=t?this.rawConfiguration.getOverrideValue(r,t):void 0,c=t?this.rawConfiguration.override(t).getValue(r):a;return{value:a,override:s,merged:c}}getOverrideValue(r,t){const a=this.l(t);return a?r?(0,b.getConfigurationValue)(a,r):a:void 0}getKeysForOverrideIdentifier(r){const t=[];for(const a of this.overrides)a.identifiers.includes(r)&&t.push(...a.keys);return D.distinct(t)}getAllOverrideIdentifiers(){const r=[];for(const t of this.overrides)r.push(...t.identifiers);return D.distinct(r)}override(r){let t=this.b.get(r);return t||(t=this.h(r),this.b.set(r,t)),t}merge(...r){const t=P.deepClone(this.contents),a=P.deepClone(this.overrides),s=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const o of r)if(c.push(...o.raw?.length?o.raw:[o]),!o.isEmpty()){this.j(t,o.contents);for(const y of o.overrides){const[E]=a.filter(T=>D.equals(T.identifiers,y.identifiers));E?(this.j(E.contents,y.contents),E.keys.push(...y.keys),E.keys=D.distinct(E.keys)):a.push(P.deepClone(y))}for(const y of o.keys)s.indexOf(y)===-1&&s.push(y)}return new p(t,s,a,c.every(o=>o instanceof p)?void 0:c)}freeze(){return this.a=!0,this}clone(){return new p(P.deepClone(this.contents),[...this.keys],P.deepClone(this.overrides))}h(r){const t=this.l(r);if(!t||typeof t!="object"||!Object.keys(t).length)return this;const a={};for(const s of D.distinct([...Object.keys(this.contents),...Object.keys(t)])){let c=this.contents[s];const o=t[s];o&&(typeof c=="object"&&typeof o=="object"?(c=P.deepClone(c),this.j(c,o)):c=o),a[s]=c}return new p(a,this.keys,this.overrides)}j(r,t){for(const a of Object.keys(t)){if(a in r&&I.isObject(r[a])&&I.isObject(t[a])){this.j(r[a],t[a]);continue}r[a]=P.deepClone(t[a])}}k(r){return this.a&&!Object.isFrozen(r)?P.deepFreeze(r):r}l(r){let t=null,a=null;const s=c=>{c&&(a?this.j(a,c):a=P.deepClone(c))};for(const c of this.overrides)D.equals(c.identifiers,[r])?t=c.contents:c.identifiers.includes(r)&&s(c.contents);return s(t),a}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,t){this.m(r),(0,b.addToValueTree)(this.contents,r,t,a=>{throw new Error(a)})}removeValue(r){this.n(r)&&(0,b.removeFromValueTree)(this.contents,r)}m(r){let t=this.keys.length;for(let a=0;a<t;a++)r.indexOf(this.keys[a])===0&&(t=a);this.keys.splice(t,1,r)}n(r){const t=this.keys.indexOf(r);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=p;class d{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new p}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,t){if(!I.isUndefinedOrNull(r)){const a=this.g(r);this.parseRaw(a,t)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,t){this.a=r;const{contents:a,keys:s,overrides:c,restricted:o,hasExcludedProperties:y}=this.h(r,t);this.b=new p(a,s,c,y?[r]:void 0),this.c=o||[]}g(r){let t={},a=null,s=[];const c=[],o=[];function y(T){Array.isArray(s)?s.push(T):a!==null&&(s[a]=T)}const E={onObjectBegin:()=>{const T={};y(T),c.push(s),s=T,a=null},onObjectProperty:T=>{a=T},onObjectEnd:()=>{s=c.pop()},onArrayBegin:()=>{const T=[];y(T),c.push(s),s=T,a=null},onArrayEnd:()=>{s=c.pop()},onLiteralValue:y,onError:(T,q,N)=>{o.push({error:T,offset:q,length:N})}};if(r)try{R.visit(r,E),t=s[0]||{}}catch(T){console.error(`Error while parsing settings file ${this.f}: ${T}`),this.d=[T]}return t}h(r,t){const a=w.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),s=this.j(r,a,!0,t);r=s.raw;const c=(0,b.toValuesTree)(r,E=>console.error(`Conflict in settings file ${this.f}: ${E}`)),o=Object.keys(r),y=this.l(r,E=>console.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:c,keys:o,overrides:y,restricted:s.restricted,hasExcludedProperties:s.hasExcludedProperties}}j(r,t,a,s){let c=!1;if(!s?.scopes&&!s?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:c};const o={},y=[];for(const E in r)if(C.OVERRIDE_PROPERTY_REGEX.test(E)&&a){const T=this.j(r[E],t,!1,s);o[E]=T.raw,c=c||T.hasExcludedProperties,y.push(...T.restricted)}else{const T=t[E],q=T?typeof T.scope<"u"?T.scope:3:void 0;T?.restricted&&y.push(E),(q===void 0||s.scopes===void 0||s.scopes.includes(q))&&!(s.skipRestricted&&T?.restricted)?o[E]=r[E]:c=!0}return{raw:o,restricted:y,hasExcludedProperties:c}}l(r,t){const a=[];for(const s of Object.keys(r))if(C.OVERRIDE_PROPERTY_REGEX.test(s)){const c={};for(const o in r[s])c[o]=r[s][o];a.push({identifiers:(0,C.overrideIdentifiersFromKey)(s),keys:Object.keys(c),contents:(0,b.toValuesTree)(c,t)})}return a}}e.ConfigurationModelParser=d;class g extends k.Disposable{constructor(r,t,a,s){super(),this.f=r,this.g=t,this.h=s,this.c=this.B(new i.Emitter),this.onDidChange=this.c.event,this.a=new d(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(a.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(i.Event.any(i.Event.filter(this.h.onDidFilesChange,c=>c.contains(this.f)),i.Event.filter(this.h.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&a.isEqual(c.resource,r)))(()=>this.c.fire()))}async loadConfiguration(){try{const r=await this.h.readFile(this.f);return this.a.parse(r.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new p}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=g;class v{constructor(r,t,a,s,c,o,y,E,T,q,N,j,F){this.a=r,this.b=t,this.value=a,this.overrideIdentifiers=s,this.c=c,this.d=o,this.f=y,this.g=E,this.h=T,this.j=q,this.k=N,this.l=j,this.m=F}get p(){return this.n||(this.n=this.c.inspect(this.a,this.b.overrideIdentifier)),this.n}get defaultValue(){return this.p.merged}get default(){return this.p.value!==void 0||this.p.override!==void 0?{value:this.p.value,override:this.p.override}:void 0}get r(){return this.q===void 0&&(this.q=this.d?this.d.inspect(this.a):null),this.q}get policyValue(){return this.r?.merged}get policy(){return this.r?.value!==void 0?{value:this.r.value}:void 0}get t(){return this.s===void 0&&(this.s=this.f?this.f.inspect(this.a):null),this.s}get applicationValue(){return this.t?.merged}get application(){return this.t?.value!==void 0||this.t?.override!==void 0?{value:this.t.value,override:this.t.override}:void 0}get v(){return this.u||(this.u=this.g.inspect(this.a,this.b.overrideIdentifier)),this.u}get userValue(){return this.v.merged}get user(){return this.v.value!==void 0||this.v.override!==void 0?{value:this.v.value,override:this.v.override}:void 0}get x(){return this.w||(this.w=this.h.inspect(this.a,this.b.overrideIdentifier)),this.w}get userLocalValue(){return this.x.merged}get userLocal(){return this.x.value!==void 0||this.x.override!==void 0?{value:this.x.value,override:this.x.override}:void 0}get z(){return this.y||(this.y=this.j.inspect(this.a,this.b.overrideIdentifier)),this.y}get userRemoteValue(){return this.z.merged}get userRemote(){return this.z.value!==void 0||this.z.override!==void 0?{value:this.z.value,override:this.z.override}:void 0}get B(){return this.A===void 0&&(this.A=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.A}get workspaceValue(){return this.B?.merged}get workspace(){return this.B?.value!==void 0||this.B?.override!==void 0?{value:this.B.value,override:this.B.override}:void 0}get E(){return this.D===void 0&&(this.D=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.D}get workspaceFolderValue(){return this.E?.merged}get workspaceFolder(){return this.E?.value!==void 0||this.E?.override!==void 0?{value:this.E.value,override:this.E.override}:void 0}get memoryValue(){return this.m.merged}get memory(){return this.m.value!==void 0||this.m.override!==void 0?{value:this.m.value,override:this.m.override}:void 0}}class u{constructor(r,t,a,s,c=new p,o=new p,y=new L.ResourceMap,E=new p,T=new L.ResourceMap,q=!0){this.c=r,this.d=t,this.f=a,this.g=s,this.h=c,this.j=o,this.l=y,this.m=E,this.n=T,this.p=q,this.a=null,this.b=new L.ResourceMap,this.q=null}getValue(r,t,a){return this.s(r,t,a).getValue(r)}updateValue(r,t,a={}){let s;a.resource?(s=this.n.get(a.resource),s||(s=new p,this.n.set(a.resource,s))):s=this.m,t===void 0?s.removeValue(r):s.setValue(r,t),a.resource||(this.a=null)}inspect(r,t,a){const s=this.s(r,t,a),c=D.distinct(s.overrides.map(E=>E.identifiers).flat()).filter(E=>s.getOverrideValue(r,E)!==void 0),o=this.w(t.resource,a),y=t.resource?this.n.get(t.resource)||this.m:this.m;return new v(r,t,s.getValue(r),c.length?c:void 0,this.c,this.d.isEmpty()?void 0:this.d.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),a?this.j.freeze():void 0,o?o.freeze():void 0,y.inspect(r,t.overrideIdentifier))}keys(r){const t=this.w(void 0,r);return{default:this.c.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this.j.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.q=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.q=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.j=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,t){this.l.set(r,t),this.b.delete(r)}deleteFolderConfiguration(r){this.r.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,t){const a=[];if(!t){const{added:s,updated:c,removed:o}=h(this.c,r);t=[...s,...c,...o]}for(const s of t)for(const c of(0,C.overrideIdentifiersFromKey)(s)){const o=this.c.getKeysForOverrideIdentifier(c),y=r.getKeysForOverrideIdentifier(c),E=[...y.filter(T=>o.indexOf(T)===-1),...o.filter(T=>y.indexOf(T)===-1),...o.filter(T=>!P.equals(this.c.override(c).getValue(T),r.override(c).getValue(T)))];a.push([c,E])}return this.updateDefaultConfiguration(r),{keys:t,overrides:a}}compareAndUpdatePolicyConfiguration(r){const{added:t,updated:a,removed:s}=h(this.d,r),c=[...t,...a,...s];return c.length&&this.updatePolicyConfiguration(r),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:t,updated:a,removed:s,overrides:c}=h(this.applicationConfiguration,r),o=[...t,...a,...s];return o.length&&this.updateApplicationConfiguration(r),{keys:o,overrides:c}}compareAndUpdateLocalUserConfiguration(r){const{added:t,updated:a,removed:s,overrides:c}=h(this.localUserConfiguration,r),o=[...t,...a,...s];return o.length&&this.updateLocalUserConfiguration(r),{keys:o,overrides:c}}compareAndUpdateRemoteUserConfiguration(r){const{added:t,updated:a,removed:s,overrides:c}=h(this.remoteUserConfiguration,r),o=[...t,...a,...s];return o.length&&this.updateRemoteUserConfiguration(r),{keys:o,overrides:c}}compareAndUpdateWorkspaceConfiguration(r){const{added:t,updated:a,removed:s,overrides:c}=h(this.workspaceConfiguration,r),o=[...t,...a,...s];return o.length&&this.updateWorkspaceConfiguration(r),{keys:o,overrides:c}}compareAndUpdateFolderConfiguration(r,t){const a=this.r.get(r),{added:s,updated:c,removed:o,overrides:y}=h(a,t),E=[...s,...c,...o];return(E.length||!a)&&this.updateFolderConfiguration(r,t),{keys:E,overrides:y}}compareAndDeleteFolderConfiguration(r){const t=this.r.get(r);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:a,updated:s,removed:c,overrides:o}=h(t,void 0);return{keys:[...a,...s,...c],overrides:o}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.q||(this.q=this.h.isEmpty()?this.g:this.g.merge(this.h),this.p&&this.q.freeze()),this.q}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.j}get r(){return this.l}s(r,t,a){let s=this.t(t,a);return t.overrideIdentifier&&(s=s.override(t.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(s=s.merge(this.d)),s}t({resource:r},t){let a=this.u();if(t&&r){const s=t.getFolder(r);s&&(a=this.v(s.uri)||a);const c=this.n.get(r);c&&(a=a.merge(c))}return a}u(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.j,this.m),this.p&&(this.j=this.j.freeze())),this.a}v(r){let t=this.b.get(r);if(!t){const a=this.u(),s=this.l.get(r);s?(t=a.merge(s),this.p&&(t=t.freeze()),this.b.set(r,t)):t=a}return t}w(r,t){if(t&&r){const a=t.getFolder(r);if(a)return this.l.get(a.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},folders:[...this.l.keys()].reduce((r,t)=>{const{contents:a,overrides:s,keys:c}=this.l.get(t);return r.push([t,{contents:a,overrides:s,keys:c}]),r},[])}}allKeys(){const r=new Set;return this.c.freeze().keys.forEach(t=>r.add(t)),this.userConfiguration.freeze().keys.forEach(t=>r.add(t)),this.j.freeze().keys.forEach(t=>r.add(t)),this.l.forEach(t=>t.freeze().keys.forEach(a=>r.add(a))),[...r.values()]}x(){const r=new Set;return this.c.freeze().getAllOverrideIdentifiers().forEach(t=>r.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>r.add(t)),this.j.freeze().getAllOverrideIdentifiers().forEach(t=>r.add(t)),this.l.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(a=>r.add(a))),[...r.values()]}y(r){const t=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(a=>t.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(a=>t.add(a)),this.j.getKeysForOverrideIdentifier(r).forEach(a=>t.add(a)),this.l.forEach(a=>a.getKeysForOverrideIdentifier(r).forEach(s=>t.add(s))),[...t.values()]}static parse(r){const t=this.z(r.defaults),a=this.z(r.policy),s=this.z(r.application),c=this.z(r.user),o=this.z(r.workspace),y=r.folders.reduce((E,T)=>(E.set(S.URI.revive(T[0]),this.z(T[1])),E),new L.ResourceMap);return new u(t,a,s,c,new p,o,y,new p,new L.ResourceMap,!1)}static z(r){return new p(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=u;function m(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const r=new Set,t=new Map;for(const s of n)s.keys.forEach(c=>r.add(c)),s.overrides.forEach(([c,o])=>{const y=(0,L.getOrSet)(t,c,new Set);o.forEach(E=>y.add(E))});const a=[];return t.forEach((s,c)=>a.push([c,[...s.values()]])),{keys:[...r.values()],overrides:a}}e.mergeChanges=m;class l{constructor(r,t,a,s){this.change=r,this.b=t,this.c=a,this.d=s,this.f=void 0;const c=new Set;r.keys.forEach(y=>c.add(y)),r.overrides.forEach(([,y])=>y.forEach(E=>c.add(E))),this.affectedKeys=[...c.values()];const o=new p;this.affectedKeys.forEach(y=>o.setValue(y,{})),this.a=o.contents}get previousConfiguration(){return!this.f&&this.b&&(this.f=u.parse(this.b.data)),this.f}affectsConfiguration(r,t){if(this.g(this.a,r)){if(t){const a=this.previousConfiguration?this.previousConfiguration.getValue(r,t,this.b?.workspace):void 0,s=this.c.getValue(r,t,this.d);return!P.equals(a,s)}return!0}return!1}g(r,t){let a=(0,b.toValuesTree)({[t]:!0},()=>{}),s;for(;typeof a=="object"&&(s=Object.keys(a)[0]);){if(r=r[s],!r)return!1;a=a[s]}return!0}}e.ConfigurationChangeEvent=l;function h(n,r){const{added:t,removed:a,updated:s}=f(r?.rawConfiguration,n?.rawConfiguration),c=[],o=n?.getAllOverrideIdentifiers()||[],y=r?.getAllOverrideIdentifiers()||[];if(r){const E=y.filter(T=>!o.includes(T));for(const T of E)c.push([T,r.getKeysForOverrideIdentifier(T)])}if(n){const E=o.filter(T=>!y.includes(T));for(const T of E)c.push([T,n.getKeysForOverrideIdentifier(T)])}if(r&&n){for(const E of o)if(y.includes(E)){const T=f({contents:n.getOverrideValue(void 0,E)||{},keys:n.getKeysForOverrideIdentifier(E)},{contents:r.getOverrideValue(void 0,E)||{},keys:r.getKeysForOverrideIdentifier(E)});c.push([E,[...T.added,...T.removed,...T.updated]])}}return{added:t,removed:a,updated:s,overrides:c}}function f(n,r){const t=n?r?n.keys.filter(c=>r.keys.indexOf(c)===-1):[...n.keys]:[],a=r?n?r.keys.filter(c=>n.keys.indexOf(c)===-1):[...r.keys]:[],s=[];if(n&&r){for(const c of r.keys)if(n.keys.indexOf(c)!==-1){const o=(0,b.getConfigurationValue)(r.contents,c),y=(0,b.getConfigurationValue)(n.contents,c);P.equals(o,y)||s.push(c)}}return{added:t,removed:a,updated:s}}}),define(re[213],ae([0,1,20,3,2,32,15,16,74,46,7,59,40]),function(_,e,D,i,R,k,L,P,I,S,b,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class p extends R.Disposable{constructor(){super(...arguments),this.a=this.B(new i.Emitter),this.onDidChangeConfiguration=this.a.event}get configurationModel(){return this.b||(this.b=new d(this.f())),this.b}async initialize(){return this.b=void 0,this.B(w.Registry.as(S.Extensions.Configuration).onDidUpdateConfiguration(({properties:m,defaultsOverrides:l})=>this.c(m,l))),this.configurationModel}reload(){return this.b=void 0,this.configurationModel}c(m,l){this.b=void 0,this.a.fire({defaults:this.configurationModel,properties:m})}f(){return{}}}e.DefaultConfiguration=p;class d extends I.ConfigurationModel{constructor(m={}){const l=w.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),h=Object.keys(l),f=Object.create(null),n=[];for(const r in l){const t=m[r],a=t!==void 0?t:l[r].default;(0,P.addToValueTree)(f,r,a,s=>console.error(`Conflict in default settings: ${s}`))}for(const r of Object.keys(f))S.OVERRIDE_PROPERTY_REGEX.test(r)&&n.push({identifiers:(0,S.overrideIdentifiersFromKey)(r),keys:Object.keys(f[r]),contents:(0,P.toValuesTree)(f[r],t=>console.error(`Conflict in default settings file: ${t}`))});super(f,h,n)}}e.DefaultConfigurationModel=d;class g{constructor(){this.onDidChangeConfiguration=i.Event.None,this.configurationModel=new I.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=g;let v=class extends R.Disposable{get configurationModel(){return this.b}constructor(m,l,h){super(),this.c=m,this.f=l,this.g=h,this.a=this.B(new i.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new I.ConfigurationModel}async initialize(){return this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(m=>this.i(m))),this.B(this.c.onDidChangeConfiguration(async({properties:m})=>this.j(await this.h(m),!0))),this.b}async h(m){const l={},h=[],f=w.Registry.as(S.Extensions.Configuration).getConfigurationProperties();for(const n of m){const r=f[n];if(!r){h.push(n);continue}if(r.policy){if(r.type!=="string"&&r.type!=="number"){this.g.warn(`Policy ${r.policy.name} has unsupported type ${r.type}`);continue}h.push(n),l[r.policy.name]={type:r.type}}}return(0,L.isEmptyObject)(l)||await this.f.updatePolicyDefinitions(l),h}i(m){const l=w.Registry.as(S.Extensions.Configuration).getPolicyConfigurations(),h=(0,D.coalesce)(m.map(f=>l.get(f)));this.j(h,!0)}j(m,l){const h=w.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),f=[],n=this.b.isEmpty();for(const r of m){const t=h[r]?.policy?.name;if(t){const a=this.f.getPolicyValue(t);(n?a!==void 0:!(0,k.equals)(this.b.getValue(r),a))&&f.push([r,a])}else this.b.getValue(r)!==void 0&&f.push([r,void 0])}if(f.length){const r=this.b;this.b=new I.ConfigurationModel;for(const t of r.keys)this.b.setValue(t,r.getValue(t));for(const[t,a]of f)a===void 0?this.b.removeValue(t):this.b.setValue(t,a);l&&this.a.fire(this.b)}}};v=pe([K(1,C.IPolicyService),K(2,b.ILogService)],v),e.PolicyConfiguration=v}),define(re[214],ae([0,1,6,3,2,22,16,74,213,59]),function(_,e,D,i,R,k,L,P,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class b extends R.Disposable{constructor(w,p,d,g){super(),this.i=w,this.h=this.B(new i.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new I.DefaultConfiguration),this.c=d instanceof S.NullPolicyService?new I.NullPolicyConfiguration:this.B(new I.PolicyConfiguration(this.b,d,g)),this.f=this.B(new P.UserSettings(this.i,void 0,k.extUriBiasedIgnorePathCase,p)),this.a=new P.Configuration(this.b.configurationModel,this.c.configurationModel,new P.ConfigurationModel,new P.ConfigurationModel),this.g=this.B(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:v,properties:u})=>this.k(v,u))),this.B(this.c.onDidChangeConfiguration(v=>this.l(v))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[w,p,d]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new P.Configuration(w,p,new P.ConfigurationModel,d)}getConfigurationData(){return this.a.toData()}getValue(w,p){const d=typeof w=="string"?w:void 0,g=(0,L.isConfigurationOverrides)(w)?w:(0,L.isConfigurationOverrides)(p)?p:{};return this.a.getValue(d,g,void 0)}updateValue(w,p,d,g){return Promise.reject(new Error("not supported"))}inspect(w){return this.a.inspect(w,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const w=await this.f.loadConfiguration();this.j(w)}j(w){const p=this.a.toData(),d=this.a.compareAndUpdateLocalUserConfiguration(w);this.m(d,p,2)}k(w,p){const d=this.a.toData(),g=this.a.compareAndUpdateDefaultConfiguration(w,p);this.m(g,d,7)}l(w){const p=this.a.toData(),d=this.a.compareAndUpdatePolicyConfiguration(w);this.m(d,p,7)}m(w,p,d){const g=new P.ConfigurationChangeEvent(w,{data:p},this.a);g.source=d,g.sourceConfig=this.n(d),this.h.fire(g)}n(w){switch(w){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=b}),define(re[215],ae([0,1,9,4]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,i.createDecorator)("remoteAuthorityResolverService");var R;(function(L){L.Unknown="Unknown",L.NotAvailable="NotAvailable",L.TemporarilyNotAvailable="TemporarilyNotAvailable",L.NoResolverFound="NoResolverFound"})(R=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class k extends D.ErrorNoTelemetry{static isNotAvailable(P){return P instanceof k&&P._code===R.NotAvailable}static isTemporarilyNotAvailable(P){return P instanceof k&&P._code===R.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof k&&P._code===R.NoResolverFound}static isHandled(P){return P instanceof k&&P.isHandled}constructor(P,I=R.Unknown,S){super(P),this._message=P,this._code=I,this._detail=S,this.isHandled=I===R.NotAvailable&&S===!0,Object.setPrototypeOf(this,k.prototype)}}e.RemoteAuthorityResolverError=k}),define(re[75],ae([0,1,25]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function i(S){return S.scheme===D.Schemas.vscodeRemote?S.authority:void 0}e.getRemoteAuthority=i;function R(S){if(!S)return;const b=S.indexOf("+");return b<0?S:S.substr(0,b)}e.getRemoteName=R;function k(S){return`/${S.quality??"oss"}-${S.commit??"dev"}`}e.getRemoteServerRootPath=k;function L(S){const{host:b,port:C}=I(S);if(typeof C>"u")throw new Error("Remote authority doesn't contain a port!");return{host:b,port:C}}e.parseAuthorityWithPort=L;function P(S,b){let{host:C,port:w}=I(S);return typeof w>"u"&&(w=b),{host:C,port:w}}e.parseAuthorityWithOptionalPort=P;function I(S){const b=S.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(b)return{host:b[1],port:parseInt(b[2],10)};const C=S.match(/^(\[[0-9a-z:]+\])$/);if(C)return{host:C[1],port:void 0};const w=S.match(/(.*):(\d+)$/);return w?{host:w[1],port:parseInt(w[2],10)}:{host:S,port:void 0}}}),define(re[42],ae([0,1,27,4,75]),function(_,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function k(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.getWorkspaceSupportTypeMessage=k;function L(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=L,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));var I;(function(d){d.WIN32_X64="win32-x64",d.WIN32_IA32="win32-ia32",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(I=e.TargetPlatform||(e.TargetPlatform={}));class S{constructor(g){this.value=g,this.c=g.toLowerCase()}static equals(g,v){if(typeof g>"u"||g===null)return typeof v>"u"||v===null;if(typeof v>"u"||v===null)return!1;if(typeof g=="string"||typeof v=="string"){const u=typeof g=="string"?g:g.value,m=typeof v=="string"?v:v.value;return D.equalsIgnoreCase(u,m)}return g.c===v.c}static toKey(g){return typeof g=="string"?g.toLowerCase():g.c}}e.ExtensionIdentifier=S;function b(d){return C(d)}e.isApplicationScopedExtension=b;function C(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.isLanguagePackExtension=C;function w(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=w;function p(d,g){if(g){const v=`onResolveRemoteAuthority:${(0,R.getRemoteName)(g)}`;return d.activationEvents?.indexOf(v)!==-1}return!1}e.isResolverExtension=p,e.IBuiltinExtensionsScannerService=(0,i.createDecorator)("IBuiltinExtensionsScannerService")}),define(re[33],ae([0,1,27,29,42,5,8,9,36]),function(_,e,D,i,R,k,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function S(r,t){return r.uuid&&t.uuid?r.uuid===t.uuid:r.id===t.id?!0:(0,D.compareIgnoreCase)(r.id,t.id)===0}e.areSameExtensions=S;const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class C{static create(t){const a=t.manifest?t.manifest.version:t.version,s=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new C(t.identifier,a,s)}static parse(t){const a=b.exec(t);return a&&a[1]&&a[2]?new C({id:a[1]},a[2],a[4]||void 0):null}constructor(t,a,s="undefined"){this.version=a,this.targetPlatform=s,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof C?S(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.ExtensionKey=C;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(r){const t=w.exec(r);return t&&t[1]?[g(t[1]),t[2]]:[g(r),void 0]}e.getIdAndVersion=p;function d(r,t){return`${r}.${t}`}e.getExtensionId=d;function g(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=g;function v(r,t){return g(d(r,t))}e.getGalleryExtensionId=v;function u(r,t){const a=[],s=c=>{for(const o of a)if(o.some(y=>S(t(y),t(c))))return o;return null};for(const c of r){const o=s(c);o?o.push(c):a.push([c])}return a}e.groupByExtension=u;function m(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=m;function l(r){return{id:r.identifier.id,name:r.name,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.getGalleryExtensionTelemetryData=l,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function h(r,t){const a=[],s=t.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const c=s.shift();if(c&&a.every(o=>!S(o.identifier,{id:c}))){const o=r.filter(y=>S(y.identifier,{id:c}));o.length===1&&(a.push(o[0]),s.push(...o[0].manifest.extensionDependencies?.slice(0)??[]))}}return a}e.getExtensionDependencies=h;async function f(r,t){if(!k.isLinux)return!1;let a;try{a=(await r.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{a=(await r.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){t.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(c))}}return!!a&&(a.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=f;async function n(r,t){const a=await f(r,t),s=(0,i.getTargetPlatform)(a?"alpine":k.platform,I.arch);return t.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=n}),define(re[216],ae([0,1,21,33]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function R(k,L,P,I,S){try{const b=await k.getExtensionsControlManifest();if(!b.deprecated)return;const C=await k.getInstalled(1);for(const[w,p]of Object.entries(b.deprecated)){if(!p?.extension)continue;const{id:d,autoMigrate:g,preRelease:v}=p.extension;if(!g)continue;const u=C.find(l=>(0,i.areSameExtensions)(l.identifier,{id:w}));if(!u)continue;const m=(await L.getExtensions([{id:d,preRelease:v}],{targetPlatform:await k.getTargetPlatform(),compatible:!0},D.CancellationToken.None))[0];if(!m){S.info(`Skipping migrating '${u.identifier.id}' extension because, the comaptible target '${d}' extension is not found`);continue}try{S.info(`Migrating '${u.identifier.id}' extension to '${d}' extension...`);const l=!I.getDisabledExtensions().some(f=>(0,i.areSameExtensions)(f,u.identifier));await k.uninstall(u),S.info(`Uninstalled the unsupported extension '${u.identifier.id}'`);let h=C.find(f=>(0,i.areSameExtensions)(f.identifier,{id:d}));(!h||!h.isPreReleaseVersion&&l)&&(h=await k.installFromGallery(m,{installPreReleaseVersion:!0,isMachineScoped:u.isMachineScoped,operation:4}),S.info(`Installed the pre-release extension '${h.identifier.id}'`),l||(await I.disableExtension(h.identifier),S.info(`Disabled the pre-release extension '${h.identifier.id}' because the unsupported extension '${u.identifier.id}' is disabled`)),g.storage&&(P.addToMigrationList((0,i.getExtensionId)(u.manifest.publisher,u.manifest.name),(0,i.getExtensionId)(h.manifest.publisher,h.manifest.name)),S.info("Added pre-release extension to the storage migration list"))),S.info(`Migrated '${u.identifier.id}' extension to '${d}' extension.`)}catch(l){S.error(l)}}}catch(b){S.error(b)}}e.migrateUnsupportedExtensions=R}),define(re[217],ae([0,1,6,9,2,25,5,22,54,15,31,28,16,13,29,33,97,14,7,23]),function(_,e,D,i,R,k,L,P,I,S,b,C,w,p,d,g,v,u,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let h=class yt extends R.Disposable{constructor(n,r,t,a,s,c,o,y){super(),this.h=n,this.i=t,this.j=a,this.k=s,this.l=c,this.m=o,this.n=y,this.extensionsDownloadDir=r.extensionsDownloadLocation,this.f=20,this.g=this.w()}async download(n,r){await this.g;const t=(0,P.joinPath)(this.extensionsDownloadDir,this.y(n));try{await this.u(n,t,s=>this.j.download(n,s,r))}catch(s){throw new d.ExtensionManagementError(s.message,d.ExtensionManagementErrorCode.Download)}let a=!1;if(await this.r(n)){const s=await this.t(n);try{a=await this.m.verify(t.fsPath,s.fsPath),this.n.info(`Verified extension: ${n.identifier.id}`,a)}catch(c){throw await this.delete(s),await this.delete(t),new d.ExtensionManagementError(c.code,d.ExtensionManagementErrorCode.Signature)}}return{location:t,verified:a}}async r(n){if(!n.isSigned||await this.h==="linux-armhf")return!1;const t=this.k.getValue("extensions.verifySignature");return(0,S.isBoolean)(t)?t:this.l.quality!=="stable"}async t(n){await this.g;const r=(0,P.joinPath)(this.extensionsDownloadDir,`${this.y(n)}${yt.c}`);return await this.u(n,r,t=>this.j.downloadSignatureArchive(n,t)),r}async u(n,r,t){if(await this.i.exists(r))return;if(r.scheme!==k.Schemas.file){await t(r);return}const a=(0,P.joinPath)(this.extensionsDownloadDir,`.${(0,b.generateUuid)()}`);await this.i.exists(a)||await t(a);try{await this.v(a,r,Date.now()+2*60*1e3)}catch(s){try{await this.i.del(a)}catch{}if(s.code==="ENOTEMPTY")this.n.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",n.identifier.id,r.path);else throw this.n.info(`Rename failed because of ${(0,i.getErrorMessage)(s)}. Deleted the file from downloaded location`,a.path),s}}async delete(n){await this.g,await this.i.del(n)}async v(n,r,t){try{await C.Promises.rename(n.fsPath,r.fsPath)}catch(a){if(L.isWindows&&a&&a.code==="EPERM"&&Date.now()<t)return this.n.info(`Failed renaming ${n} to ${r} with 'EPERM' error. Trying again...`),this.v(n,r,t);throw a}}async w(){try{if(!await this.i.exists(this.extensionsDownloadDir)){this.n.trace("Extension VSIX downloads cache dir does not exist");return}const n=await this.i.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(n.children){const r=[],t=[],a=[];for(const o of n.children)if(o.name.endsWith(yt.c))a.push(o.resource);else{const y=g.ExtensionKey.parse(o.name);y&&t.push([y,o])}const s=(0,g.groupByExtension)(t,([o])=>o),c=[];for(const o of s)o.sort((y,E)=>I.rcompare(y[0].version,E[0].version)),r.push(...o.slice(1).map(y=>y[1].resource)),c.push(o[0][1]);c.sort((o,y)=>o.mtime-y.mtime),r.push(...c.slice(0,Math.max(0,c.length-this.f)).map(o=>o.resource)),r.push(...a),await D.Promises.settled(r.map(o=>(this.n.trace("Deleting from cache",o.path),this.i.del(o))))}}catch(n){this.n.error(n)}}y(n){return this.f?g.ExtensionKey.create(n).toString().toLowerCase():(0,b.generateUuid)()}};h.c=".sigzip",h=pe([K(1,p.INativeEnvironmentService),K(2,u.IFileService),K(3,d.IExtensionGalleryService),K(4,w.IConfigurationService),K(5,l.IProductService),K(6,v.IExtensionSignatureVerificationService),K(7,m.ILogService)],h),e.ExtensionsDownloader=h}),define(re[218],ae([0,1,2,12,28,42]),function(_,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class L extends D.Disposable{constructor(I,S){super(),this.b=I,this.a=(0,i.join)(this.b.userDataPath,k.MANIFEST_CACHE_FOLDER,k.USER_MANIFEST_CACHE_FILE),this.B(S.onDidInstallExtensions(b=>this.c(b))),this.B(S.onDidUninstallExtension(b=>this.f(b)))}c(I){I.some(S=>!!S.local)&&this.invalidate()}f(I){I.error||this.invalidate()}invalidate(){R.Promises.rm(this.a,R.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=L}),define(re[219],ae([0,1,3,2,37,33,42]),function(_,e,D,i,R,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class P extends i.Disposable{constructor(S,b,C,w,p,d,g){super(),this.f=S,this.g=b,this.h=C,this.i=w,this.j=p,this.k=d,this.l=g,this.a=this.B(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new i.DisposableMap),this.m().then(null,v=>g.error(v))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.C()}n(){this.B(this.h.onDidChangeProfiles(S=>this.p(S.added,S.removed))),this.B(this.i.onAddExtensions(S=>this.r(S))),this.B(this.i.onDidAddExtensions(S=>this.s(S))),this.B(this.i.onRemoveExtensions(S=>this.t(S))),this.B(this.i.onDidRemoveExtensions(S=>this.u(S))),this.B(this.k.onDidFilesChange(S=>this.v(S)))}async p(S,b){try{await Promise.all(b.map(C=>(this.c.deleteAndDispose(C.id),this.z(C.extensionsResource))))}catch(C){this.l.error(C)}try{S.length&&await Promise.all(S.map(C=>(this.c.set(C.id,(0,i.combinedDisposable)(this.k.watch(this.j.extUri.dirname(C.extensionsResource)),this.k.watch(C.extensionsResource))),this.y(C.extensionsResource))))}catch(C){this.l.error(C)}}async r(S){for(const b of S.extensions)this.D(this.G(b.identifier,b.version),S.profileLocation)}async s(S){for(const b of S.extensions){const C=this.G(b.identifier,b.version);S.error?this.F(C,S.profileLocation):this.D(C,S.profileLocation)}}async t(S){for(const b of S.extensions)this.F(this.G(b.identifier,b.version),S.profileLocation)}async u(S){let b=!1;for(const C of S.extensions){const w=this.G(C.identifier,C.version);S.error?this.D(w,S.profileLocation):(this.F(w,S.profileLocation),b=b||!this.b.has(w))}b&&await this.C()}v(S){for(const b of this.h.profiles)S.contains(b.extensionsResource,0,1)&&this.w(b.extensionsResource)}async w(S){const b=[],C=[],w=await this.i.scanProfileExtensions(S),p=new Set,d=new Set;for(const[g,v]of this.b)v.has(S)&&d.add(g);for(const g of w){const v=this.G(g.identifier,g.version);p.add(v),d.has(v)||(b.push(g.identifier),this.D(v,S))}for(const g of d)if(!p.has(g)){const v=this.H(g);v&&(C.push(v.identifier),this.F(g,S))}(b.length||C.length)&&this.a.fire({added:b.length?{extensions:b,profileLocation:S}:void 0,removed:C.length?{extensions:C,profileLocation:S}:void 0})}async y(S){const b=await this.i.scanProfileExtensions(S);for(const C of b)this.D(this.G(C.identifier,C.version),S)}async z(S){for(const b of[...this.b.keys()])this.F(b,S);await this.C()}async C(){const b=(await this.f.getAllUserInstalled()).filter(C=>!this.b.has(this.G(C.identifier,C.manifest.version)));b.length&&await this.f.markAsUninstalled(...b)}D(S,b){let C=this.b.get(S);C||this.b.set(S,C=new R.ResourceSet(w=>this.j.extUri.getComparisonKey(w))),C.add(b)}F(S,b){const C=this.b.get(S);C&&C.delete(b),C?.size||this.b.delete(S)}G(S,b){return`${L.ExtensionIdentifier.toKey(S.id)}@${b}`}H(S){const[b,C]=(0,k.getIdAndVersion)(S);return C?{identifier:{id:b},version:C}:void 0}}e.ExtensionsWatcher=P}),define(re[220],ae([0,1,99,20,6,2,25,12,28,13,29,33,7,73,5,8]),function(_,e,D,i,R,k,L,P,I,S,b,C,w,p,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let v=class extends p.LanguagePackBaseService{constructor(h,f,n,r){super(n),this.h=h,this.i=r,this.g=this.B(new u(f,r)),this.h.registerParticipant({postInstall:async t=>this.j(t),postUninstall:async t=>this.k(t)})}async getBuiltInExtensionTranslationsUri(h){const n=(await this.g.getLanguagePacks())[d.Language.value()];if(!n){this.i.warn(`No language pack found for ${d.Language.value()}`);return}const r=n.translations[h];return r?g.URI.file(r):void 0}async getInstalledLanguages(){const h=await this.g.getLanguagePacks(),f=Object.keys(h).map(n=>{const r=h[n];return{...this.f(n,r.label),extensionId:r.extensions[0].extensionIdentifier.id}});return f.push({...this.f("en","English"),extensionId:"default"}),f.sort((n,r)=>n.label.localeCompare(r.label)),f}async j(h){h&&h.manifest&&h.manifest.contributes&&h.manifest.contributes.localizations&&h.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",h.identifier.id),await this.update())}async k(h){const f=await this.g.getLanguagePacks();Object.keys(f).some(n=>f[n]&&f[n].extensions.some(r=>(0,C.areSameExtensions)(r.extensionIdentifier,h.identifier)))&&(this.i.info("Removing language packs from the extension",h.identifier.id),await this.update())}async update(){const[h,f]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),n=await this.g.update(f);return!(0,i.equals)(Object.keys(h),Object.keys(n))}};v=pe([K(0,b.IExtensionManagementService),K(1,S.INativeEnvironmentService),K(2,b.IExtensionGalleryService),K(3,w.ILogService)],v),e.NativeLanguagePackService=v;let u=class extends k.Disposable{constructor(h,f){super(),this.i=f,this.c={},this.f=(0,P.join)(h.userDataPath,"languagepacks.json"),this.g=new R.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(h){return this.m(f=>{Object.keys(f).forEach(n=>delete f[n]),this.j(f,...h)}).then(()=>this.c)}j(h,...f){for(const n of f)n&&n.manifest&&n.manifest.contributes&&n.manifest.contributes.localizations&&n.manifest.contributes.localizations.length&&this.k(h,n);Object.keys(h).forEach(n=>this.l(h[n]))}k(h,f){const n=f.identifier,r=f.manifest.contributes&&f.manifest.contributes.localizations?f.manifest.contributes.localizations:[];for(const t of r)if(f.location.scheme===L.Schemas.file&&m(t)){let a=h[t.languageId];a||(a={hash:"",extensions:[],translations:{},label:t.localizedLanguageName??t.languageName},h[t.languageId]=a);const s=a.extensions.filter(c=>(0,C.areSameExtensions)(c.extensionIdentifier,n))[0];s?s.version=f.manifest.version:a.extensions.push({extensionIdentifier:n,version:f.manifest.version});for(const c of t.translations)a.translations[c.id]=(0,P.join)(f.location.fsPath,c.path)}}l(h){if(h){const f=(0,D.createHash)("md5");for(const n of h.extensions)f.update(n.extensionIdentifier.uuid||n.extensionIdentifier.id).update(n.version);h.hash=f.digest("hex")}}m(h=()=>null){return this.g.queue(()=>{let f=null;return I.Promises.readFile(this.f,"utf8").then(void 0,n=>n.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(n)).then(n=>{try{return JSON.parse(n)}catch{return{}}}).then(n=>(f=h(n),n)).then(n=>{for(const t of Object.keys(n))n[t]||delete n[t];this.c=n,this.h=!0;const r=JSON.stringify(this.c);return this.i.debug("Writing language packs",r),I.Promises.writeFile(this.f,r)}).then(()=>f,n=>this.i.error(n))})}};u=pe([K(0,S.INativeEnvironmentService),K(1,w.ILogService)],u);function m(l){if(typeof l.languageId!="string"||!Array.isArray(l.translations)||l.translations.length===0)return!1;for(const h of l.translations)if(typeof h.id!="string"||typeof h.path!="string")return!1;return!(l.languageName&&typeof l.languageName!="string"||l.localizedLanguageName&&typeof l.localizedLanguageName!="string")}}),define(re[221],ae([0,1,6,17,21,9,3,2,31,92,215,75]),function(_,e,D,i,R,k,L,P,I,S,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const w=30*1e3;var p;(function(J){J[J.Management=1]="Management",J[J.ExtensionHost=2]="ExtensionHost",J[J.Tunnel=3]="Tunnel"})(p=e.ConnectionType||(e.ConnectionType={}));function d(J){switch(J){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function g(J){const Q=new R.CancellationTokenSource;return setTimeout(()=>Q.cancel(),J),Q.token}function v(J,Q){if(J.isCancellationRequested||Q.isCancellationRequested)return R.CancellationToken.Cancelled;const O=new R.CancellationTokenSource;return J.onCancellationRequested(()=>O.cancel()),Q.onCancellationRequested(()=>O.cancel()),O.token}class u{get didTimeout(){return this.c==="timedout"}constructor(Q){this.c="pending",this.d=new P.DisposableStore,this.promise=new Promise((O,M)=>{this.f=O,this.g=M}),Q.isCancellationRequested?this.h():this.d.add(Q.onCancellationRequested(()=>this.h()))}registerDisposable(Q){this.c==="pending"?this.d.add(Q):Q.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const Q=new Error("Time limit reached");return Q.code="ETIMEDOUT",Q.syscall="connect",Q}resolve(Q){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(Q))}reject(Q){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(Q))}}function m(J,Q){const O=new u(Q);return O.registerDisposable(J.onControlMessage(M=>{const H=JSON.parse(M.toString()),V=$(H);V?O.reject(V):O.resolve(H)})),O.promise}function l(J,Q,O,M,H,V,X,se){const x=new u(se);return Q.connect(O,M,H,V,X,(ie,ne)=>{x.didTimeout?(ie&&J.error(ie),ne?.dispose()):ie||!ne?x.reject(ie):x.resolve(ne)}),x.promise}function h(J,Q){const O=new u(Q);return J.then(M=>{O.didTimeout||O.resolve(M)},M=>{O.didTimeout||O.reject(M)}),O.promise}async function f(J,Q,O,M){const H=ee(J,Q);J.logService.trace(`${H} 1/6. invoking socketFactory.connect().`);let V;try{V=await l(J.logService,J.socketFactory,J.host,J.port,(0,C.getRemoteServerRootPath)(J),`reconnectionToken=${J.reconnectionToken}&reconnection=${J.reconnectionProtocol?"true":"false"}`,`renderer-${d(Q)}-${J.reconnectionToken}`,M)}catch(ne){throw J.logService.error(`${H} socketFactory.connect() failed or timed out. Error:`),J.logService.error(ne),ne}J.logService.trace(`${H} 2/6. socketFactory.connect() was successful.`);let X,se;J.reconnectionProtocol?(J.reconnectionProtocol.beginAcceptReconnection(V,null),X=J.reconnectionProtocol,se=!1):(X=new S.PersistentProtocol(V,null),se=!0),J.logService.trace(`${H} 3/6. sending AuthRequest control message.`);const x=await h(J.signService.createNewMessage((0,I.generateUuid)()),M),ie={type:"auth",auth:J.connectionToken||"00000000000000000000",data:x.data};X.sendControl(i.VSBuffer.fromString(JSON.stringify(ie)));try{const ne=await m(X,v(M,g(1e4)));if(ne.type!=="sign"||typeof ne.data!="string"){const Se=new Error("Unexpected handshake message");throw Se.code="VSCODE_CONNECTION_ERROR",Se}if(J.logService.trace(`${H} 4/6. received SignRequest control message.`),!await h(J.signService.validate(x,ne.signedData),M)){const Se=new Error("Refused to connect to unsupported server");throw Se.code="VSCODE_CONNECTION_ERROR",Se}const ue=await h(J.signService.sign(ne.data),M),ye={type:"connectionType",commit:J.commit,signedData:ue,desiredConnectionType:Q};return O&&(ye.args=O),J.logService.trace(`${H} 5/6. sending ConnectionTypeRequest control message.`),X.sendControl(i.VSBuffer.fromString(JSON.stringify(ye))),{protocol:X,ownsProtocol:se}}catch(ne){throw ne&&ne.code==="ETIMEDOUT"&&(J.logService.error(`${H} the handshake timed out. Error:`),J.logService.error(ne)),ne&&ne.code==="VSCODE_CONNECTION_ERROR"&&(J.logService.error(`${H} received error control message when negotiating connection. Error:`),J.logService.error(ne)),se&&Z(X),ne}}async function n(J,Q,O,M){const H=Date.now(),V=ee(J,Q),{protocol:X,ownsProtocol:se}=await f(J,Q,O,M),x=new u(M);return x.registerDisposable(X.onControlMessage(ie=>{const ne=JSON.parse(ie.toString()),le=$(ne);le?(J.logService.error(`${V} received error control message when negotiating connection. Error:`),J.logService.error(le),se&&Z(X),x.reject(le)):(J.reconnectionProtocol?.endAcceptReconnection(),J.logService.trace(`${V} 6/6. handshake finished, connection is up and running after ${oe(H)}!`),x.resolve({protocol:X,firstMessage:ne}))})),x.promise}async function r(J,Q){const{protocol:O}=await n(J,1,void 0,Q);return{protocol:O}}async function t(J,Q,O){const{protocol:M,firstMessage:H}=await n(J,2,Q,O),V=H&&H.debugPort;return{protocol:M,debugPort:V}}async function a(J,Q,O){const M=Date.now(),H=ee(J,3),{protocol:V}=await f(J,3,Q,O);return J.logService.trace(`${H} 6/6. handshake finished, connection is up and running after ${oe(M)}!`),V}async function s(J,Q,O){const{host:M,port:H,connectionToken:V}=await J.addressProvider.getAddress();return{commit:J.commit,quality:J.quality,host:M,port:H,connectionToken:V,reconnectionToken:Q,reconnectionProtocol:O,socketFactory:J.socketFactory,signService:J.signService,logService:J.logService}}async function c(J,Q,O){return y(J,async M=>{const{protocol:H}=await r(M,R.CancellationToken.None);return new G(J,Q,O,M.reconnectionToken,H)})}e.connectRemoteAgentManagement=c;async function o(J,Q){return y(J,async O=>{const{protocol:M,debugPort:H}=await t(O,Q,R.CancellationToken.None);return new W(J,Q,O.reconnectionToken,M,H)})}e.connectRemoteAgentExtensionHost=o;async function y(J,Q){for(let M=1;;M++)try{const H=(0,I.generateUuid)(),V=await s(J,H,null);return await Q(V)}catch(H){if(M<5)J.logService.error(`[remote-connection][attempt ${M}] An error occurred in initial connection! Will retry... Error:`),J.logService.error(H);else throw J.logService.error(`[remote-connection][attempt ${M}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),J.logService.error(H),B.triggerPermanentFailure(0,0,b.RemoteAuthorityResolverError.isHandled(H)),H}}async function E(J,Q,O){const M=await s(J,(0,I.generateUuid)(),null);return await a(M,{host:Q,port:O},R.CancellationToken.None)}e.connectRemoteAgentTunnel=E;function T(J){return(0,D.createCancelablePromise)(Q=>new Promise((O,M)=>{const H=setTimeout(O,J*1e3);Q.onCancellationRequested(()=>{clearTimeout(H),O()})}))}var q;(function(J){J[J.ConnectionLost=0]="ConnectionLost",J[J.ReconnectionWait=1]="ReconnectionWait",J[J.ReconnectionRunning=2]="ReconnectionRunning",J[J.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",J[J.ConnectionGain=4]="ConnectionGain"})(q=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class N{constructor(Q,O){this.reconnectionToken=Q,this.millisSinceLastIncomingData=O,this.type=0}}e.ConnectionLostEvent=N;class j{constructor(Q,O,M,H){this.reconnectionToken=Q,this.millisSinceLastIncomingData=O,this.durationSeconds=M,this.c=H,this.type=1}skipWait(){this.c.cancel()}}e.ReconnectionWaitEvent=j;class F{constructor(Q,O,M){this.reconnectionToken=Q,this.millisSinceLastIncomingData=O,this.attempt=M,this.type=2}}e.ReconnectionRunningEvent=F;class A{constructor(Q,O,M){this.reconnectionToken=Q,this.millisSinceLastIncomingData=O,this.attempt=M,this.type=4}}e.ConnectionGainEvent=A;class U{constructor(Q,O,M,H){this.reconnectionToken=Q,this.millisSinceLastIncomingData=O,this.attempt=M,this.handled=H,this.type=3}}e.ReconnectionPermanentFailureEvent=U;class B extends P.Disposable{static triggerPermanentFailure(Q,O,M){this._permanentFailure=!0,this.f=Q,this.g=O,this.h=M,this.i.forEach(H=>H.u(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(Q=>Q.r())}static debugPauseSocketWriting(){this.i.forEach(Q=>Q.v())}get k(){return this.c||B._permanentFailure}constructor(Q,O,M,H,V){super(),this.m=Q,this.n=O,this.reconnectionToken=M,this.protocol=H,this.p=V,this.j=this.B(new L.Emitter),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.j.fire(new A(this.reconnectionToken,0,0)),this.B(H.onSocketClose(X=>{const se=Y(this.m,this.reconnectionToken,!0);X?X.type===0?(this.n.logService.info(`${se} received socket close event (hadError: ${X.hadError}).`),X.error&&this.n.logService.error(X.error)):(this.n.logService.info(`${se} received socket close event (wasClean: ${X.wasClean}, code: ${X.code}, reason: ${X.reason}).`),X.event&&this.n.logService.error(X.event)):this.n.logService.info(`${se} received socket close event.`),this.r()})),this.B(H.onSocketTimeout(X=>{const se=Y(this.m,this.reconnectionToken,!0);this.n.logService.info(`${se} received socket timeout event (unacknowledgedMsgCount: ${X.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${X.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${X.timeSinceLastReceivedSomeData}).`),this.r()})),B.i.push(this),this.B((0,P.toDisposable)(()=>{const X=B.i.indexOf(this);X>=0&&B.i.splice(X,1)})),this.k&&this.u(B.f,B.g,B.h)}async r(){if(!this.l)try{this.l=!0,await this.s()}finally{this.l=!1}}async s(){if(this.k)return;const Q=Y(this.m,this.reconnectionToken,!0);this.n.logService.info(`${Q} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const O=[0,5,5,10,10,10,10,10,30];let M=-1;do{M++;const H=M<O.length?O[M]:O[O.length-1];try{if(H>0){const X=T(H);this.j.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),H,X)),this.n.logService.info(`${Q} waiting for ${H} seconds before reconnecting...`);try{await X}catch{}}if(this.k){this.n.logService.error(`${Q} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),M+1)),this.n.logService.info(`${Q} resolving connection...`);const V=await s(this.n,this.reconnectionToken,this.protocol);this.n.logService.info(`${Q} connecting to ${V.host}:${V.port}...`),await this.w(V,g(w)),this.n.logService.info(`${Q} reconnected!`),this.j.fire(new A(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),M+1));break}catch(V){if(V.code==="VSCODE_CONNECTION_ERROR"){this.n.logService.error(`${Q} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.n.logService.error(V),this.t(this.protocol.getMillisSinceLastIncomingData(),M+1,!1);break}if(M>360){this.n.logService.error(`${Q} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.n.logService.error(V),this.t(this.protocol.getMillisSinceLastIncomingData(),M+1,!1);break}if(b.RemoteAuthorityResolverError.isTemporarilyNotAvailable(V)){this.n.logService.info(`${Q} A temporarily not available error occurred while trying to reconnect, will try again...`),this.n.logService.trace(V);continue}if((V.code==="ETIMEDOUT"||V.code==="ENETUNREACH"||V.code==="ECONNREFUSED"||V.code==="ECONNRESET")&&V.syscall==="connect"){this.n.logService.info(`${Q} A network error occurred while trying to reconnect, will try again...`),this.n.logService.trace(V);continue}if((0,k.isCancellationError)(V)){this.n.logService.info(`${Q} A promise cancelation error occurred while trying to reconnect, will try again...`),this.n.logService.trace(V);continue}if(V instanceof b.RemoteAuthorityResolverError){this.n.logService.error(`${Q} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.n.logService.error(V),this.t(this.protocol.getMillisSinceLastIncomingData(),M+1,b.RemoteAuthorityResolverError.isHandled(V));break}this.n.logService.error(`${Q} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.n.logService.error(V),this.t(this.protocol.getMillisSinceLastIncomingData(),M+1,!1);break}}while(!this.k)}t(Q,O,M){this.p?B.triggerPermanentFailure(Q,O,M):this.u(Q,O,M)}u(Q,O,M){this.j.fire(new U(this.reconnectionToken,Q,O,M)),Z(this.protocol)}v(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=B,B._permanentFailure=!1,B.f=0,B.g=0,B.h=!1,B.i=[];class G extends B{constructor(Q,O,M,H,V){super(1,Q,H,V,!0),this.client=this.B(new S.Client(V,{remoteAuthority:O,clientId:M},Q.ipcLogger))}async w(Q,O){await r(Q,O)}}e.ManagementPersistentConnection=G;class W extends B{constructor(Q,O,M,H,V){super(2,Q,M,H,!1),this.y=O,this.debugPort=V}async w(Q,O){await t(Q,this.y,O)}}e.ExtensionHostPersistentConnection=W;function Z(J){try{J.acceptDisconnect();const Q=J.getSocket();J.dispose(),Q.dispose()}catch(Q){(0,k.onUnexpectedError)(Q)}}function $(J){if(J&&J.type==="error"){const Q=new Error(`Connection error: ${J.reason}`);return Q.code="VSCODE_CONNECTION_ERROR",Q}return null}function z(J,Q){for(;J.length<Q;)J+=" ";return J}function Y(J,Q,O){return`[remote-connection][${z(d(J),13)}][${Q.substr(0,5)}\u2026][${O?"reconnect":"initial"}]`}function ee(J,Q){return`${Y(Q,J.reconnectionToken,!!J.reconnectionProtocol)}[${J.host}:${J.port}]`}function oe(J){return`${Date.now()-J} ms`}}),define(re[222],ae([0,1,4]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,D.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(re[223],ae([0,1,86,149]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(R,k,L,P,I,S){const b=w=>S(w,void 0),C=D.createConnection({host:R,port:k},()=>{C.removeListener("error",b);const w=Buffer.alloc(16);for(let v=0;v<16;v++)w[v]=Math.round(Math.random()*256);const p=w.toString("base64"),d=[`GET ws://${/:/.test(R)?`[${R}]`:R}:${k}${L}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${p}`];C.write(d.join(`\r
`)+`\r
\r
`);const g=v=>{v.toString().indexOf(`\r
\r
`)>=0&&(C.off("data",g),S(void 0,new i.NodeSocket(C,I)))};C.on("data",g)});C.setNoDelay(!0),C.once("error",b)}}}),define(re[105],ae([0,1,4]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LOG_CHANNEL_ID=e.LOGGER_NAME=e.LOG_FILE_NAME=e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX=e.TunnelStates=e.IRemoteTunnelService=void 0,e.IRemoteTunnelService=(0,D.createDecorator)("IRemoteTunnelService");var i;(function(R){R.disconnected={type:"disconnected"},R.uninitialized={type:"uninitialized"},R.connected=k=>({type:"connected",info:k}),R.connecting=k=>({type:"connecting",progress:k})})(i=e.TunnelStates||(e.TunnelStates={})),e.CONFIGURATION_KEY_PREFIX="remote.tunnels.access",e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX+".hostNameOverride",e.LOG_FILE_NAME="remoteTunnelService.log",e.LOGGER_NAME="remoteTunnelService",e.LOG_CHANNEL_ID="remoteTunnelServiceLog"}),define(re[224],ae([0,1,132,16,7]),function(_,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let k=class{constructor(P,I){this.a=P,this.b=I}async request(P,I){this.b.trace("RequestService#request (browser) - begin",P.url),P.proxyAuthorization||(P.proxyAuthorization=this.a.getValue("http.proxyAuthorization"));try{const S=await(0,D.request)(P,I);return this.b.trace("RequestService#request (browser) - success",P.url),S}catch(S){throw this.b.error("RequestService#request (browser) - error",P.url,S),S}}async resolveProxy(P){}};k=pe([K(0,i.IConfigurationService),K(1,R.ILogService)],k),e.RequestService=k}),define(re[47],ae([0,1,17,168,46,4,40]),function(_,e,D,i,R,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,k.createDecorator)("requestService");function P(g){return g.res.statusCode&&g.res.statusCode>=200&&g.res.statusCode<300||g.res.statusCode===1223}e.isSuccess=P;function I(g){return g.res.statusCode===204}async function S(g){return I(g)?null:(await(0,D.streamToBuffer)(g.stream)).toString()}e.asText=S;async function b(g){if(!P(g))throw new Error("Server returned "+g.res.statusCode);return S(g)}e.asTextOrError=b;async function C(g){if(!P(g))throw new Error("Server returned "+g.res.statusCode);if(I(g))return null;const u=(await(0,D.streamToBuffer)(g.stream)).toString();try{return JSON.parse(u)}catch(m){throw m.message+=`:
`+u,m}}e.asJson=C;function w(g){d(g)}e.updateProxyConfigurationsScope=w;let p;function d(g){const v=L.Registry.as(R.Extensions.Configuration),u=p;p={id:"http",order:15,title:(0,i.localize)(0,null),type:"object",scope:g,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,i.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,i.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,i.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,i.localize)(4,null),(0,i.localize)(5,null),(0,i.localize)(6,null),(0,i.localize)(7,null)],default:"override",description:(0,i.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,i.localize)(9,null),restricted:!0}}},v.updateConfigurations({add:[p],remove:u?[u]:[]})}d(2)}),define(re[225],ae([0,1,21,25,14,47]),function(_,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let L=class{constructor(I,S){this.a=I,this.b=S}async download(I,S,b=D.CancellationToken.None){if(I.scheme===i.Schemas.file||I.scheme===i.Schemas.vscodeRemote){await this.b.copy(I,S);return}const C={type:"GET",url:I.toString(!0)},w=await this.a.request(C,b);if(w.res.statusCode===200)await this.b.writeFile(S,w.stream);else{const p=await(0,k.asTextOrError)(w);throw new Error(`Expected 200, got back ${w.res.statusCode} instead.

${p}`)}}};L=pe([K(0,k.IRequestService),K(1,R.IFileService)],L),e.DownloadService=L}),define(re[226],ae([0,1,20,21,2,22,186,14,7,23,47]),function(_,e,D,i,R,k,L,P,I,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let C=class extends R.Disposable{constructor(p,d,g,v){super(),this.b=p,this.c=d,this.f=g,this.g=v,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,u])=>this.a.set(u.configPath,u))}getConfigBasedTips(p){return this.h(p)}getAllWorkspacesTips(){return this.j()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async h(p){const d=[];for(const[g,v]of this.a)if(!(v.configScheme&&v.configScheme!==p.scheme))try{const u=await this.b.readFile((0,k.joinPath)(p,g)),m=new Map;Object.entries(v.recommendations).forEach(([h,f])=>{if((0,D.isNonEmptyArray)(f.remotes))for(const n of f.remotes)m.set(n,{extensionId:h,extensionName:f.name,configName:v.configName,important:!!f.important,isExtensionPack:!!f.isExtensionPack,whenNotInstalled:f.whenNotInstalled});else d.push({extensionId:h,extensionName:f.name,configName:v.configName,important:!!f.important,isExtensionPack:!!f.isExtensionPack,whenNotInstalled:f.whenNotInstalled})});const l=(0,L.getDomainsOfRemotes)(u.value.toString(),[...m.keys()]);for(const h of l){const f=m.get(h);f&&d.push(f)}}catch{}return d}async j(){if(!this.c.extensionsGallery?.recommendationsUrl)return[];try{const p=await this.f.request({type:"GET",url:this.c.extensionsGallery?.recommendationsUrl},i.CancellationToken.None);if(p.res.statusCode!==200)return[];const d=await(0,b.asJson)(p);return d?d.workspaceRecommendations||[]:[]}catch(p){return this.g.error(p),[]}}};C=pe([K(0,P.IFileService),K(1,S.IProductService),K(2,b.IRequestService),K(3,I.ILogService)],C),e.ExtensionTipsService=C}),define(re[227],ae([0,1,17,21]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class R{constructor(P){this.a=P}listen(P,I){throw new Error("Invalid listen")}call(P,I,S,b=i.CancellationToken.None){switch(I){case"request":return this.a.request(S[0],b).then(async({res:C,stream:w})=>{const p=await(0,D.streamToBuffer)(w);return[{statusCode:C.statusCode,headers:C.headers},p]});case"resolveProxy":return this.a.resolveProxy(S[0])}throw new Error("Invalid call")}}e.RequestChannel=R;class k{constructor(P){this.a=P}async request(P,I){const[S,b]=await this.a.call("request",[P],I);return{res:S,stream:(0,D.bufferToStream)(b)}}async resolveProxy(P){return this.a.call("resolveProxy",[P])}}e.RequestChannelClient=k}),define(re[228],ae([0,1,15,224,227]),function(_,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRequestService=void 0;class k{constructor(P,I,S,b){this.c=I,this.d=S,this.e=b,this.a=new i.RequestService(I,b),this.b=new R.RequestChannelClient(P.getChannel("request"))}request(P,I){return this.f().request(P,I)}async resolveProxy(P){return this.f().resolveProxy(P)}f(){return this.g()?(this.e.trace("Using main request service"),this.b):(this.e.trace("Using browser request service"),this.a)}g(){const P=this.c.getValue("developer.sharedProcess.redirectRequestsToMain");return(0,D.isBoolean)(P)?P:this.d.quality!=="stable"}}e.SharedProcessRequestService=k}),define(re[106],ae([0,1,66,4]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function R(k){return(0,D.hash)({moduleId:k.process.moduleId,windowId:k.reply.windowId})}e.hash=R,e.ISharedProcessWorkerService=(0,i.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(re[229],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var D;(function(i){i.Spawn="vscode:shared-process->shared-process-worker=spawn",i.Terminate="vscode:shared-process->shared-process-worker=terminate",i.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",i.Ready="vscode:shared-process-worker->shared-process=ready",i.Ack="vscode:shared-process-worker->shared-process=ack",i.Trace="vscode:shared-process-worker->shared-process=trace",i.Info="vscode:shared-process-worker->shared-process=info",i.Warn="vscode:shared-process-worker->shared-process=warn",i.Error="vscode:shared-process-worker->shared-process=error"})(D=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(re[230],ae([0,1,93,6,21,3,2,25,31,7,106,229]),function(_,e,D,i,R,k,L,P,I,S,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let w=class{constructor(g){this.d=g,this.a=new Map,this.b=new Map,this.c=new Map}async createWorker(g){const v=`window: ${g.reply.windowId}, moduleId: ${g.process.moduleId}`;this.d.trace(`SharedProcess: createWorker (${v})`);const u=(0,b.hash)(g);this.b.has(u)&&(this.d.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${v})`),this.f(g));const m=new R.CancellationTokenSource;let l,h,f;this.b.set(u,a=>{m.dispose(!0),l?.terminate(g,R.CancellationToken.None),h?.close(),f?.close(),this.b.delete(u);const s=this.c.get(u);s&&(this.c.delete(u),s({reason:a}))}),l=await this.e(g);const n=new Promise(a=>{this.c.set(u,a)});if(m.token.isCancellationRequested)return n;const{port1:r,port2:t}=new MessageChannel;return h=r,f=t,await l.spawn(g,f,m.token),m.token.isCancellationRequested||(this.d.trace(`SharedProcess: createWorker sending message port back to window (${v})`),D.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",g,[h])),n}e(g){let v=this.a.get(g.process.moduleId);if(!v){this.d.trace(`SharedProcess: creating new web worker (${g.process.moduleId})`);const u=new p(g.process.type,this.d);v=u.init(),u.onDidProcessSelfTerminate(({configuration:m,reason:l})=>{this.f(m,l)}),this.a.set(g.process.moduleId,v)}return v}async disposeWorker(g){return this.f(g)}f(g,v){const u=this.b.get((0,b.hash)(g));u&&(this.d.trace(`SharedProcess: disposeWorker (window: ${g.reply.windowId}, moduleId: ${g.process.moduleId})`),u(v))}};w=pe([K(0,S.ILogService)],w),e.SharedProcessWorkerService=w;class p extends L.Disposable{constructor(g,v){super(),this.f=g,this.g=v,this.a=this.B(new k.Emitter),this.onDidProcessSelfTerminate=this.a.event,this.b=this.h(),this.c=new Map}async init(){return await this.b,this}h(){const g=new i.DeferredPromise,v=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.f})`});return v.onerror=u=>{this.g.error(`SharedProcess: worker error (${this.f})`,u.message)},v.onmessageerror=u=>{this.g.error(`SharedProcess: worker message error (${this.f})`,u)},v.onmessage=u=>{const{id:m,message:l,configuration:h,nonce:f}=u.data;switch(m){case C.SharedProcessWorkerMessages.Ready:g.complete(v);break;case C.SharedProcessWorkerMessages.Ack:if(f){const n=this.c.get(f);n&&(this.c.delete(f),n())}break;case C.SharedProcessWorkerMessages.SelfTerminated:h&&l&&this.a.fire({configuration:h,reason:JSON.parse(l)});break;case C.SharedProcessWorkerMessages.Trace:this.g.trace(`SharedProcess (worker, ${this.f}):`,l);break;case C.SharedProcessWorkerMessages.Info:l&&this.g.info(l);break;case C.SharedProcessWorkerMessages.Warn:this.g.warn(`SharedProcess (worker, ${this.f}):`,l);break;case C.SharedProcessWorkerMessages.Error:this.g.error(`SharedProcess (worker, ${this.f}):`,l);break;default:this.g.warn(`SharedProcess: unexpected worker message (${this.f})`,u)}},v.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),g.p}async i(g,v,u){const m=await this.b;if(!v.isCancellationRequested)return new Promise(l=>{const h=(0,I.generateUuid)();this.c.set(h,l);const f={...g,nonce:h};u?m.postMessage(f,[u]):m.postMessage(f),v.onCancellationRequested(()=>{this.c.delete(h)&&l()})})}spawn(g,v,u){const m={id:C.SharedProcessWorkerMessages.Spawn,configuration:g,environment:{bootstrapPath:P.FileAccess.asFileUri("bootstrap-fork").fsPath}};return this.i(m,u,v)}terminate(g,v){const u={id:C.SharedProcessWorkerMessages.Terminate,configuration:g};return this.i(u,v)}}}),define(re[231],ae([0,1,63,25,185]),function(_,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class k extends R.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:i.Schemas.vscodeUserData})}}pe([D.memoize],k.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=k}),define(re[232],ae([0,1,50,12,169,21,38,9,5,31,146,183,6]),function(_,e,D,i,R,k,L,P,I,S,b,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const p=1e4;let d;async function g(u,m,l){return m["force-disable-user-env"]?(u.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):I.isWindows?(u.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,C.isLaunchedFromCli)(l)&&!m["force-user-env"]?(u.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,C.isLaunchedFromCli)(l)?u.trace("resolveShellEnv(): running (--force-user-env)"):u.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=w.Promises.withAsyncBody(async(h,f)=>{const n=new k.CancellationTokenSource,r=setTimeout(()=>{n.dispose(!0),f(new Error((0,R.localize)(0,null)))},p);try{h(await v(u,n.token))}catch(t){!(0,P.isCancellationError)(t)&&!n.token.isCancellationRequested?f(new Error((0,R.localize)(1,null,(0,L.toErrorMessage)(t)))):h({})}finally{clearTimeout(r),n.dispose()}})),d)}e.getResolvedShellEnv=g;async function v(u,m){const l=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",l);const h=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",h);const f=(0,S.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(f+"(.*)"+f),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};u.trace("getUnixShellEnvironment#env",r);const t=await(0,b.getSystemShell)(I.OS,r);return u.trace("getUnixShellEnvironment#shell",t),new Promise((a,s)=>{if(m.isCancellationRequested)return s((0,P.canceled)());const c=(0,i.basename)(t);let o,y;const E=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(o=`& '${process.execPath}' ${E} -p '''${f}'' + JSON.stringify(process.env) + ''${f}'''`,y=["-Login","-Command"]):(o=`'${process.execPath}' ${E} -p '"${f}" + JSON.stringify(process.env) + "${f}"'`,c==="tcsh"?y=["-ic"]:y=["-ilc"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(y),o);const T=(0,D.spawn)(t,[...y,o],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});m.onCancellationRequested(()=>(T.kill(),s((0,P.canceled)()))),T.on("error",j=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,L.toErrorMessage)(j)),s(j)});const q=[];T.stdout.on("data",j=>q.push(j));const N=[];T.stderr.on("data",j=>N.push(j)),T.on("close",(j,F)=>{const A=Buffer.concat(q).toString("utf8");u.trace("getUnixShellEnvironment#raw",A);const U=Buffer.concat(N).toString("utf8");if(U.trim()&&u.trace("getUnixShellEnvironment#stderr",U),j||F)return s(new Error((0,R.localize)(2,null,j,F)));const B=n.exec(A),G=B?B[1]:"{}";try{const W=JSON.parse(G);l?W.ELECTRON_RUN_AS_NODE=l:delete W.ELECTRON_RUN_AS_NODE,h?W.ELECTRON_NO_ATTACH_CONSOLE=h:delete W.ELECTRON_NO_ATTACH_CONSOLE,delete W.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",W),a(W)}catch(W){u.error("getUnixShellEnvironment#errorCaught",(0,L.toErrorMessage)(W)),s(W)}})})}}),define(re[107],ae([0,1,4]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,D.createDecorator)(e.SIGN_SERVICE_ID)}),define(re[233],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class D{constructor(){this.b=new Map}c(){return new Promise((R,k)=>_(["vsda"],R,k))}async createNewMessage(R){try{const k=await this.c(),L=new k.validator;if(L){const P=String(D.a++);return this.b.set(P,L),{id:P,data:L.createNewMessage(R)}}}catch{}return{id:"",data:R}}async validate(R,k){if(!R.id)return!0;const L=this.b.get(R.id);if(!L)return!1;this.b.delete(R.id);try{return L.validate(k)==="ok"}catch{return!1}}async sign(R){try{const k=await this.c(),L=new k.signer;if(L)return L.sign(R)}catch{}return R}}e.SignService=D,D.a=1}),define(re[76],ae([0,1,3,2]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class R extends i.Disposable{constructor(C,w,p){super(),this.a=C,this.b=w,this.c=p}async getItems(){const C={profile:this.b,workspace:this.c},w=await this.a.call("getItems",C);return new Map(w)}updateItems(C){const w={profile:this.b,workspace:this.c};return C.insert&&(w.insert=Array.from(C.insert.entries())),C.delete&&(w.delete=Array.from(C.delete.values())),this.a.call("updateItems",w)}}class k extends R{constructor(C,w){super(C,w,void 0),this.f=this.B(new D.Emitter),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(C=>this.h(C)))}h(C){(Array.isArray(C.changed)||Array.isArray(C.deleted))&&this.f.fire({changed:C.changed?new Map(C.changed):void 0,deleted:C.deleted?new Set(C.deleted):void 0})}}class L extends k{constructor(C){super(C,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=L;class P extends k{constructor(C,w){super(C,w)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=P;class I extends R{constructor(C,w){super(C,void 0,w),this.onDidChangeItemsExternal=D.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=I;class S{constructor(C){this.a=C}isUsed(C){const w={payload:C,profile:void 0,workspace:void 0};return this.a.call("isUsed",w)}}e.StorageClient=S}),define(re[108],ae([0,1,5,36,8,31]),function(_,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function L(S){if(D.platform===2&&/^penguin(\.|$)/i.test(S))return"chromebook"}async function P(S,b,C,w,p,d,g,v,u,m){const l=Object.create(null);l["common.machineId"]=g,l.sessionID=(0,k.generateUuid)()+Date.now(),l.commitHash=p,l.version=d,l["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),l["common.platform"]=(0,D.PlatformToString)(D.platform),l["common.nodePlatform"]=i.platform,l["common.nodeArch"]=w,l["common.product"]=m||"desktop",v&&(l["common.msftInternal"]=v);let h=0;const f=Date.now();Object.defineProperties(l,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-f,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),D.isLinuxSnap&&(l["common.snap"]="true");const n=L(C);n&&(l["common.platformDetail"]=n);try{const r=await S.readFile(R.URI.file(u));l["common.source"]=r.value.toString().slice(0,30)}catch{}return l}e.resolveCommonProperties=P;function I(S){const b=i.env.USERDNSDOMAIN;if(!b)return!1;const C=b.toLowerCase();return S.some(w=>C===w)}e.verifyMicrosoftInternalDomain=I}),define(re[24],ae([0,1,4]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,D.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var i;(function(k){k[k.NONE=0]="NONE",k[k.CRASH=1]="CRASH",k[k.ERROR=2]="ERROR",k[k.USAGE=3]="USAGE"})(i=e.TelemetryLevel||(e.TelemetryLevel={}));var R;(function(k){k.OFF="off",k.CRASH="crash",k.ERROR="error",k.ON="all"})(R=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(re[234],ae([0,1,34,6,35,25,12,5,8,143,28,145,95,14,23,24]),function(_,e,D,i,R,k,L,P,I,S,b,C,w,p,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const v=new Map;async function u(n,r){const t=`${n}::${r.join(":")}`,a=v.get(t);if(a)return a;const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],c=new Map,o=new Map,y=2e4;function E(q,N,j,F){const A=N.substring(q.length+1);return i.Promises.withAsyncBody(async U=>{let B;try{B=await b.Promises.readdir(N,{withFileTypes:!0})}catch{U();return}if(F.count>=y){F.count+=B.length,F.maxReached=!0,U();return}let G=B.length;if(G===0){U();return}let W=B;F.count+B.length>y&&(F.maxReached=!0,G=y-F.count,W=B.slice(0,G)),F.count+=B.length;for(const Z of W)if(Z.isDirectory()){if(j.includes(Z.name)||await E(q,(0,L.join)(N,Z.name),j,F),--G===0){U();return}}else{const $=Z.name.lastIndexOf(".");if($>=0){const z=Z.name.substring($+1);z&&c.set(z,(c.get(z)??0)+1)}for(const z of s)z.relativePathPattern?.test(A)!==!1&&z.filePattern.test(Z.name)&&o.set(z.tag,(o.get(z.tag)??0)+1);if(--G===0){U();return}}})}const T=i.Promises.withAsyncBody(async q=>{const N={count:0,maxReached:!1};await E(n,n,r,N);const j=await h(n);q({configFiles:m(o),fileTypes:m(c),fileCount:N.count,maxFilesReached:N.maxReached,launchConfigFiles:j})});return v.set(t,T),T}e.collectWorkspaceStats=u;function m(n){return Array.from(n.entries(),([r,t])=>({name:r,count:t})).sort((r,t)=>t.count-r.count)}function l(){const n={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/p.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/p.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(S.virtualMachineHint.value()*100)}%`},r=D.cpus();return r&&r.length>0&&(n.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),n}e.getMachineInfo=l;async function h(n){try{const r=new Map,t=(0,L.join)(n,".vscode","launch.json"),a=await b.Promises.readFile(t),s=[],c=(0,R.parse)(a.toString(),s);if(s.length)return console.log(`Unable to parse ${t}`),[];if((0,R.getNodeType)(c)==="object"&&c.configurations)for(const o of c.configurations){const y=o.type;y&&(r.has(y)?r.set(y,r.get(y)+1):r.set(y,1))}return m(r)}catch{return[]}}e.collectLaunchConfigs=h;let f=class{constructor(r,t){this.c=r,this.d=t}f(r){const t=[];return t.push(`OS Version:       ${r.os}`),t.push(`CPUs:             ${r.cpus}`),t.push(`Memory (System):  ${r.memory}`),t.push(`VM:               ${r.vmHint}`),t.join(`
`)}g(r){const t=[];t.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),t.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const a=D.cpus();return a&&a.length>0&&t.push(`CPUs:             ${a[0].model} (${a.length} x ${a[0].speed})`),t.push(`Memory (System):  ${(D.totalmem()/p.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/p.ByteSize.GB).toFixed(2)}GB free)`),P.isWindows||t.push(`Load (avg):       ${D.loadavg().map(s=>Math.round(s)).join(", ")}`),t.push(`VM:               ${Math.round(S.virtualMachineHint.value()*100)}%`),t.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),t.push(`Process Argv:     ${r.mainArguments.join(" ")}`),t.push(`GPU Status:       ${this.j(r.gpuFeatureStatus)}`),t.join(`
`)}async getPerformanceInfo(r,t){return Promise.all([(0,C.listProcesses)(r.mainPID),this.k(r)]).then(async a=>{let[s,c]=a,o=this.m(r,s);return t.forEach(y=>{if((0,w.isRemoteDiagnosticError)(y))o+=`
${y.errorMessage}`,c+=`
${y.errorMessage}`;else if(o+=`

Remote: ${y.hostName}`,y.processes&&(o+=`
${this.m(r,y.processes)}`),y.workspaceMetadata){c+=`
|  Remote: ${y.hostName}`;for(const E of Object.keys(y.workspaceMetadata)){const T=y.workspaceMetadata[E];let q=`${T.fileCount} files`;T.maxFilesReached&&(q=`more than ${q}`),c+=`|    Folder (${E}): ${q}`,c+=this.h(T)}}}),{processInfo:o,workspaceInfo:c}})}async getSystemInfo(r,t){const{memory:a,vmHint:s,os:c,cpus:o}=l(),y={os:c,memory:a,cpus:o,vmHint:s,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:t};return P.isWindows||(y.load=`${D.loadavg().map(E=>Math.round(E)).join(", ")}`),P.isLinux&&(y.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(y)}async getDiagnostics(r,t){const a=[];return(0,C.listProcesses)(r.mainPID).then(async s=>(a.push(""),a.push(this.g(r)),a.push(""),a.push(this.m(r,s)),r.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(a.push(""),a.push("Workspace Stats: "),a.push(await this.k(r))),t.forEach(c=>{if((0,w.isRemoteDiagnosticError)(c))a.push(`
${c.errorMessage}`);else if(a.push(`

`),a.push(`Remote:           ${c.hostName}`),a.push(this.f(c.machineInfo)),c.processes&&a.push(this.m(r,c.processes)),c.workspaceMetadata)for(const o of Object.keys(c.workspaceMetadata)){const y=c.workspaceMetadata[o];let E=`${y.fileCount} files`;y.maxFilesReached&&(E=`more than ${E}`),a.push(`Folder (${o}): ${E}`),a.push(this.h(y))}}),a.push(""),a.push(""),a.join(`
`)))}h(r){const t=[];let s=0;const c=(T,q)=>{const N=` ${T}(${q})`;s+N.length>60?(t.push(o),o="|                 ",s=o.length):s+=N.length,o+=N};let o="|      File types:";const y=10,E=r.fileTypes.length>y?y:r.fileTypes.length;for(let T=0;T<E;T++){const q=r.fileTypes[T];c(q.name,q.count)}if(t.push(o),r.configFiles.length>=0&&(o="|      Conf files:",s=0,r.configFiles.forEach(T=>{c(T.name,T.count)}),t.push(o)),r.launchConfigFiles.length>0){let T="|      Launch Configs:";r.launchConfigFiles.forEach(q=>{T+=q.count>1?` ${q.name}(${q.count})`:` ${q.name}`}),t.push(T)}return t.join(`
`)}j(r){const t=Math.max(...Object.keys(r).map(a=>a.length));return Object.keys(r).map(a=>`${a}:  ${" ".repeat(t-a.length)}  ${r[a]}`).join(`
                  `)}k(r){const t=[],a=[];return r.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(t.push(`|  Window (${s.title})`),s.folderURIs.forEach(c=>{const o=I.URI.revive(c);if(o.scheme===k.Schemas.file){const y=o.fsPath;a.push(u(y,["node_modules",".git"]).then(E=>{let T=`${E.fileCount} files`;E.maxFilesReached&&(T=`more than ${T}`),t.push(`|    Folder (${(0,L.basename)(y)}): ${T}`),t.push(this.h(E))}).catch(E=>{t.push(`|      Error: Unable to collect workspace stats for folder ${y} (${E.toString()})`)}))}else t.push(`|    Folder (${o.toString()}): Workspace stats not available.`)}))}),Promise.all(a).then(s=>t.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}m(r,t){const a=new Map;r.windows.forEach(c=>a.set(c.pid,c.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),t&&this.n(r.mainPID,a,s,t,0),s.join(`
`)}n(r,t,a,s,c){const o=c===0;let y;o?y=s.pid===r?`${this.d.applicationName} main`:"remote agent":(y=`${"  ".repeat(c)} ${s.name}`,s.name==="window"&&(y=`${y} (${t.get(s.pid)})`));const E=process.platform==="win32"?s.mem:D.totalmem()*(s.mem/100);a.push(`${s.load.toFixed(0).padStart(5," ")}	${(E/p.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${y}`),Array.isArray(s.children)&&s.children.forEach(T=>this.n(r,t,a,T,c+1))}async getWorkspaceFileExtensions(r){const t=new Set;for(const{uri:a}of r.folders){const s=I.URI.revive(a);if(s.scheme!==k.Schemas.file)continue;const c=s.fsPath;try{(await u(c,["node_modules",".git"])).fileTypes.forEach(y=>t.add(y.name))}catch{}}return{extensions:[...t]}}async reportWorkspaceStats(r){for(const{uri:t}of r.folders){const a=I.URI.revive(t);if(a.scheme!==k.Schemas.file)continue;const s=a.fsPath;try{const c=await u(s,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),c.fileTypes.forEach(o=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:o.name,count:o.count})}),c.launchConfigFiles.forEach(o=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:o.name,count:o.count})}),c.configFiles.forEach(o=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:o.name,count:o.count})})}catch{}}}};f=pe([K(0,g.ITelemetryService),K(1,d.IProductService)],f),e.DiagnosticsService=f}),define(re[235],ae([0,1,105,3,24,13,2,7,12,50,23,5,6,101,16,167,34,8]),function(_,e,D,i,R,k,L,P,I,S,b,C,w,p,d,g,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTunnelService=void 0;let m=class extends L.Disposable{constructor(h,f,n,r,t,a){super(),this.p=h,this.r=f,this.s=n,this.t=a,this.b=new i.Emitter,this.onDidTokenFailed=this.b.event,this.c=new i.Emitter,this.onDidChangeTunnelStatus=this.c.event,this.f=new i.Emitter,this.onDidChangeAccount=this.f.event,this.j=D.TunnelStates.disconnected;const s=u.URI.file((0,I.join)(n.logsPath,D.LOG_FILE_NAME));this.g=this.B(r.createLogger(s,{name:D.LOGGER_NAME})),this.k=new w.Delayer(100),this.B(this.g.onDidChangeLogLevel(c=>this.g.info("Log level changed to "+(0,P.LogLevelToString)(c)))),this.B(t.onWillShutdown(c=>{this.i&&(this.i.cancel(),this.i=void 0),this.dispose()})),this.B(a.onDidChangeConfiguration(c=>{c.affectsConfiguration(D.CONFIGURATION_KEY_HOST_NAME)&&this.k.trigger(()=>this.v())}))}async getAccount(){return this.h}async updateAccount(h){if(h&&this.h?h.token!==this.h.token||h.providerId!==this.h.providerId:h!==this.h){this.h=h,this.f.fire(h),h?this.g.info(`Account updated: ${h.accountLabel} (${h.providerId})`):this.g.info("Account reset"),this.p.publicLog2("remoteTunnel.enablement",{enabled:!!h});try{await this.k.trigger(()=>this.v())}catch(f){this.g.error(f)}}return this.j}u(){if(!this.n){let h;C.isMacintosh?h=this.s.appRoot:h=(0,I.dirname)((0,I.dirname)(this.s.appRoot)),this.n=(0,I.join)(h,"bin",`${this.r.tunnelApplicationName}${C.isWindows?".exe":""}`)}return this.n}async v(){if(this.i&&(this.i.cancel(),this.i=void 0),!this.h){this.w(D.TunnelStates.disconnected);return}const{token:h,providerId:f,accountLabel:n}=this.h;this.w(D.TunnelStates.connecting((0,g.localize)(0,null,n,f)));const r=(o,y)=>{o=o.replaceAll(h,"*".repeat(4)),y?this.g.error(o):this.g.info(o),!this.s.isBuilt&&o.startsWith("   Compiling")&&this.w(D.TunnelStates.connecting((0,g.localize)(1,null)))},t=this.y("login",["user","login","--provider",f,"--access-token",h,"--log",(0,P.LogLevelToString)(this.g.getLevel())],r);this.i=t;try{if(await t,this.i!==t)return}catch(o){this.g.error(o),this.i=void 0,this.b.fire(!0),this.w(D.TunnelStates.disconnected);return}const a=this.z();a?this.w(D.TunnelStates.connecting((0,g.localize)(2,null,a))):this.w(D.TunnelStates.connecting((0,g.localize)(3,null)));const s=["--parent-process-id",String(process.pid),"--accept-server-license-terms","--log",(0,P.LogLevelToString)(this.g.getLevel())];a?s.push("--name",a):s.push("--random-name");const c=this.y("tunnel",s,(o,y)=>{y?this.g.error(o):this.g.info(o);const E=o.match(/^\s*Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(E){const T={link:E[1],domain:E[2],hostName:E[4]};this.w(D.TunnelStates.connected(T))}else o.match(/error refreshing token/)&&(c.cancel(),this.b.fire(!0),this.w(D.TunnelStates.disconnected))});this.i=c,c.finally(()=>{c===this.i&&(this.g.info("tunnel process terminated"),this.i=void 0,this.h=void 0,this.w(D.TunnelStates.disconnected))})}async getTunnelStatus(){return this.j}w(h){this.j=h,this.c.fire(h)}y(h,f,n=()=>{}){return(0,w.createCancelablePromise)(r=>new Promise((t,a)=>{r.isCancellationRequested&&t();let s;if(r.onCancellationRequested(()=>{s&&(this.g.info(`${h} terminating(${s.pid})`),s.kill())}),!this.s.isBuilt)n("Building tunnel CLI from sources and run",!1),n(`${h} Spawning: cargo run -- tunnel ${f.join(" ")}`,!1),s=(0,S.spawn)("cargo",["run","--","tunnel",...f],{cwd:(0,I.join)(this.s.appRoot,"cli")});else{n("Running tunnel CLI",!1);const c=this.u();n(`${h} Spawning: ${c} tunnel ${f.join(" ")}`,!1),s=(0,S.spawn)(c,["tunnel",...f],{cwd:(0,v.homedir)()})}s.stdout.on("data",c=>{if(s){const o=c.toString();n(o,!1)}}),s.stderr.on("data",c=>{if(s){const o=c.toString();n(o,!0)}}),s.on("exit",c=>{s&&(n(`${h} exit(${s.pid}): + ${c} `,!1),s=void 0,c===0?t():a())}),s.on("error",c=>{s&&(n(`${h} error(${s.pid}): + ${c} `,!0),s=void 0,a())})}))}z(){let h=this.t.getValue(D.CONFIGURATION_KEY_HOST_NAME)||(0,v.hostname)();return h=h.replace(/[^\w-]/g,"").substring(0,20),h||void 0}};m=pe([K(0,R.ITelemetryService),K(1,b.IProductService),K(2,k.INativeEnvironmentService),K(3,P.ILoggerService),K(4,p.ISharedProcessLifecycleService),K(5,d.IConfigurationService)],m),e.RemoteTunnelService=m}),define(re[109],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class D{constructor(k){this.b=k}listen(k,L){throw new Error(`Event not found: ${L}`)}call(k,L,{eventName:P,data:I}){return this.b.forEach(S=>S.log(P,I)),Promise.resolve(null)}}e.TelemetryAppenderChannel=D;class i{constructor(k){this.b=k}log(k,L){return this.b.call("log",{eventName:k,data:L}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=i}),define(re[51],ae([0,1,32,15,16,75,108,24]),function(_,e,D,i,R,k,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TrustedTelemetryValue=void 0;class I{constructor(c){this.value=c}}e.TrustedTelemetryValue=I;class S{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(c,o){return Promise.resolve(void 0)}publicLog2(c,o){return this.publicLog(c,o)}publicLogError(c,o){return Promise.resolve(void 0)}publicLogError2(c,o){return this.publicLogError(c,o)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=S,e.NullTelemetryService=new S;class b{async publicLog(c,o,y){}async publicLogError(c,o,y){}}e.NullEndpointTelemetryService=b,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function C(s,c){return c.onDidChangeConfiguration(o=>{o.source!==7&&s.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(o.source),configurationKeys:l(o.sourceConfig)})})}e.configurationTelemetry=C;function w(s,c){return!c.isBuilt&&!c.disableTelemetry?!0:!(c.disableTelemetry||!s.enableTelemetry||c.extensionTestsLocationURI)}e.supportsTelemetry=w;function p(s,c){return!(c.isBuilt||c.disableTelemetry||s.enableTelemetry&&s.aiConfig?.ariaKey)}e.isLoggingOnly=p;function d(s){const c=s.getValue(P.TELEMETRY_SETTING_ID),o=s.getValue("telemetry.enableCrashReporter");if(s.getValue(P.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return 0;switch(c??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=d;function g(s){const c={},o={},y={};m(s,y);for(let E in y){E=E.length>150?E.substr(E.length-149):E;const T=y[E];typeof T=="number"?o[E]=T:typeof T=="boolean"?o[E]=T?1:0:typeof T=="string"?(T.length>8192&&console.warn(`Telemetry property: ${E} has been trimmed to 8192, the original length is ${T.length}`),c[E]=T.substring(0,8191)):typeof T<"u"&&T!==null&&(c[E]=T)}return{properties:c,measurements:o}}e.validateTelemetryData=g;const v=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function u(s){if(!s)return"none";const c=(0,k.getRemoteName)(s);return v.has(c)?c:"other"}e.cleanRemoteAuthority=u;function m(s,c,o=0,y){if(!!s)for(const E of Object.getOwnPropertyNames(s)){const T=s[E],q=y?y+E:E;Array.isArray(T)?c[q]=(0,D.safeStringify)(T):T instanceof Date?c[q]=T.toISOString():(0,i.isObject)(T)?o<2?m(T,c,o+1,q+"."):c[q]=(0,D.safeStringify)(T):c[q]=T}}function l(s){if(!s)return[];const c=[];return h(c,"",s),c}function h(s,c,o){o&&typeof o=="object"&&!Array.isArray(o)?Object.keys(o).forEach(y=>h(s,c?`${c}.${y}`:y,o[y])):s.push(c)}function f(s,c){const o=s.msftInternalDomains||[],y=c.getValue("telemetry.internalTesting");return(0,L.verifyMicrosoftInternalDomain)(o)||y}e.isInternalTelemetry=f;function n(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}e.getPiiPathsFromEnvironment=n;function r(s,c){if(!s||!s.includes("/")&&!s.includes("\\"))return s;let o=s;const y=[];for(const N of c)for(;;){const j=N.exec(s);if(!j)break;y.push([j.index,N.lastIndex])}const E=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,T=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let q=0;for(o="";;){const N=T.exec(s);if(!N)break;const j=y.some(([F,A])=>N.index<A&&F<T.lastIndex);!E.test(N[0])&&!j&&(o+=s.substring(q,N.index)+"<REDACTED: user-file-path>",q=T.lastIndex)}return q<s.length&&(o+=s.substr(q)),o}function t(s){if(!s)return s;const c=s.toLowerCase(),o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const y of o)if(y.regex.test(c))return`<REDACTED: ${y.label}>`;return s}function a(s,c){return(0,D.cloneAndChange)(s,o=>{if(o instanceof I)return o.value;if(typeof o=="string"){let y=o.replaceAll("%20"," ");y=r(y,c);for(const E of c)y=y.replace(E,"");return y=t(y),y}})}e.cleanData=a}),define(re[236],ae([0,1,45,51]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function R(k,L,P,I,S,b,C){const w={"X-Market-Client-Id":`VSCode ${k}`,"User-Agent":`VSCode ${k} (${L.nameShort})`};if((0,i.supportsTelemetry)(L,P)&&(0,i.getTelemetryLevel)(I)===3){const p=await(0,D.getServiceMachineId)(P,S,b),{machineId:d}=await C.getTelemetryInfo();w["X-Market-User-Id"]=p,w["VSCode-SessionId"]=d||p}return w}e.resolveMarketplaceHeaders=R}),define(re[237],ae([0,1,9,32,51]),function(_,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const k="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function L(I,S,b){const C=await new Promise((v,u)=>{_(["@microsoft/1ds-core-js"],v,u)}),w=await new Promise((v,u)=>{_(["@microsoft/1ds-post-js"],v,u)}),p=new C.AppInsightsCore,d=new w.PostChannel,g={instrumentationKey:I,endpointUrl:k,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[d]]};if(b){g.extensionConfig={};const v={alwaysUseXhrOverride:!0,httpXHROverride:b};g.extensionConfig[d.identifier]=v}return p.initialize(g,[]),p.addTelemetryInitializer(v=>{S&&(v.ext=v.ext??{},v.ext.utc=v.ext.utc??{},v.ext.utc.flags=8462029)}),p}class P{constructor(S,b,C,w,p){this.d=S,this.e=b,this.f=C,this.g=p,this.c=k,this.f||(this.f={}),typeof w=="function"?this.a=w():this.a=w,this.b=null}h(S){if(!!this.a){if(typeof this.a!="string"){S(this.a);return}this.b||(this.b=L(this.a,this.d,this.g)),this.b.then(b=>{S(b)},b=>{(0,D.onUnexpectedError)(b),console.error(b)})}}log(S,b){if(!this.a)return;b=(0,i.mixin)(b,this.f),b=(0,R.validateTelemetryData)(b);const C=this.e+"/"+S;try{this.h(w=>{w.pluginVersionString=b?.properties.version??"Unknown",w.track({name:C,baseData:{name:C,properties:b?.properties,measurements:b?.measurements}})})}catch{}}flush(){return this.a?new Promise(S=>{this.h(b=>{b.unload(!0,()=>{this.a=void 0,S(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=P}),define(re[110],ae([0,1,2,13,7,51]),function(_,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let L=class extends D.Disposable{constructor(I,S,b=""){super(),this.b=b;const C=I.getLogger(S.telemetryLogResource);C?this.a=this.B(C):(this.a=this.B(I.createLogger(S.telemetryLogResource)),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(I,S){this.a.trace(`${this.b}telemetry/${I}`,(0,k.validateTelemetryData)(S))}};L=pe([K(0,R.ILoggerService),K(1,i.IEnvironmentService)],L),e.TelemetryLogAppender=L}),define(re[111],ae([0,1,2,32,5,27,170,16,46,103,23,40,24,51]),function(_,e,D,i,R,k,L,P,I,S,b,C,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let d=class{constructor(u,m,l){this.k=m,this.l=l,this.d={},this.i=new D.DisposableStore,this.j=[],this.b=u.appenders,this.c=u.commonProperties||Promise.resolve({}),this.f=u.piiPaths||[],this.g=3,this.h=!!u.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const h of this.f)this.j.push(new RegExp((0,k.escapeRegExpCharacters)(h),"gi")),h.indexOf("\\")>=0&&this.j.push(new RegExp((0,k.escapeRegExpCharacters)(h.replace(/\\/g,"/")),"gi"));this.m(),this.k.onDidChangeConfiguration(this.m,this,this.i)}setExperimentProperty(u,m){this.d[u]=m}m(){let u=(0,p.getTelemetryLevel)(this.k);const m=this.l.enabledTelemetryLevels;if(m){this.h=this.sendErrorTelemetry?m.error:!1;const l=m.usage?3:m.error?2:0;u=Math.min(u,l)}this.g=u}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const u=await this.c,m=u.sessionID,l=u["common.machineId"],h=u["common.firstSessionDate"],f=u["common.msftInternal"];return{sessionId:m,machineId:l,firstSessionDate:h,msftInternal:f}}dispose(){this.i.dispose()}n(u,m,l){return this.g<m?Promise.resolve(void 0):this.c.then(h=>{l=(0,i.mixin)(l,this.d),l=(0,p.cleanData)(l,this.j),l=(0,i.mixin)(l,h),this.b.forEach(f=>f.log(u,l))},h=>{console.error(h)})}publicLog(u,m){return this.n(u,3,m)}publicLog2(u,m){return this.publicLog(u,m)}publicLogError(u,m){return this.h?this.n(u,2,m):Promise.resolve(void 0)}publicLogError2(u,m){return this.publicLogError(u,m)}};d.IDLE_START_EVENT_NAME="UserIdleStart",d.IDLE_STOP_EVENT_NAME="UserIdleStop",d=pe([K(1,P.IConfigurationService),K(2,b.IProductService)],d),e.TelemetryService=d;function g(){const v=(0,L.localize)(0,null,S.default.nameLong),u=S.default.privacyStatementUrl?(0,L.localize)(2,null,"https://aka.ms/vscode-telemetry",S.default.privacyStatementUrl):(0,L.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=R.isWeb?"":(0,L.localize)(3,null),l=(0,L.localize)(4,null),h=(0,L.localize)(5,null),f=(0,L.localize)(6,null),n=(0,L.localize)(7,null),r=`
|       | ${l} | ${h} | ${f} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,L.localize)(8,null);return`
${v} ${u} ${m}

&nbsp;

${n}
${r}

&nbsp;

${t}
`}C.Registry.as(I.Extensions.Configuration).registerConfiguration({id:w.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,L.localize)(9,null),properties:{[w.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,L.localize)(10,null),(0,L.localize)(11,null),(0,L.localize)(12,null),(0,L.localize)(13,null)],markdownDescription:g(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),C.Registry.as(I.Extensions.Configuration).registerConfiguration({id:w.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,L.localize)(14,null),properties:{[w.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:S.default.privacyStatementUrl?(0,L.localize)(16,null,S.default.nameLong,S.default.privacyStatementUrl):(0,L.localize)(15,null,S.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,L.localize)(17,null,`\`#${w.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(re[238],ae([0,1,287,237]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class R extends i.AbstractOneDataSystemAppender{constructor(L,P,I,S){const b={sendPOST:(C,w)=>{const p={method:"POST",headers:{...C.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(C.data)}};try{const d=D.request(C.urlString,p,g=>{g.on("data",function(v){w(g.statusCode??200,g.headers,v.toString())}),g.on("error",function(v){w(0,{})})});d.write(C.data),d.end()}catch{w(0,{})}}};super(L,P,I,S,b)}}e.OneDataSystemAppender=R}),define(re[239],ae([0,1,25,68,16,13,7,23,24,109,110,111]),function(_,e,D,i,R,k,L,P,I,S,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let w=class{constructor(d,g,v,u,m){this.b=d,this.c=g,this.d=v,this.e=u,this.f=m,this.a=new Map}async g(d){if(!this.a.has(d.id)){const{machineId:g,sessionId:v}=await this.c.getTelemetryInfo(),u=Object.create(null);u["common.vscodemachineid"]=g,u["common.vscodesessionid"]=v;const m=[d.id,JSON.stringify(u),d.aiKey],h=new i.Client(D.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:m,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),f=[new S.TelemetryAppenderClient(h),new b.TelemetryLogAppender(this.d,this.e,`[${d.id}] `)];this.a.set(d.id,new C.TelemetryService({appenders:f,sendErrorTelemetry:d.sendErrorTelemetry},this.b,this.f))}return this.a.get(d.id)}async publicLog(d,g,v){await(await this.g(d)).publicLog(g,v)}async publicLogError(d,g,v){await(await this.g(d)).publicLogError(g,v)}};w=pe([K(0,R.IConfigurationService),K(1,I.ITelemetryService),K(2,L.ILoggerService),K(3,k.IEnvironmentService),K(4,P.IProductService)],w),e.CustomEndpointTelemetryService=w}),define(re[240],ae([0,1,6,21,3,2,7]),function(_,e,D,i,R,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends k.Disposable{constructor(S,b){super(),this.h=b,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new R.Emitter),this.onCreateRequest=this.g.event,this.b=S===void 0?15e3:S}createRequest(S){return new Promise((b,C)=>{const w=++this.a;this.c.set(w,b),this.g.fire({requestId:w,...S});const p=new i.CancellationTokenSource;(0,D.timeout)(this.b,p.token).then(()=>C(`Request ${w} timed out (${this.b}ms)`)),this.f.set(w,[(0,k.toDisposable)(()=>p.cancel())])})}acceptReply(S,b){const C=this.c.get(S);C?(this.c.delete(S),(0,k.dispose)(this.f.get(S)||[]),this.f.delete(S),C(b)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${S}`)}};P=pe([K(1,L.ILogService)],P),e.RequestStore=P}),define(re[112],ae([0,1,4]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var i;(function(l){l.Shell="terminal.integrated.shell.",l.ShellArgs="terminal.integrated.shellArgs.",l.DefaultProfile="terminal.integrated.defaultProfile.",l.Profiles="terminal.integrated.profiles."})(i=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var R;(function(l){l.ShellLinux="terminal.integrated.shell.linux",l.ShellMacOs="terminal.integrated.shell.osx",l.ShellWindows="terminal.integrated.shell.windows",l.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",l.AutomationShellLinux="terminal.integrated.automationShell.linux",l.AutomationShellMacOs="terminal.integrated.automationShell.osx",l.AutomationShellWindows="terminal.integrated.automationShell.windows",l.AutomationProfileLinux="terminal.integrated.automationProfile.linux",l.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",l.AutomationProfileWindows="terminal.integrated.automationProfile.windows",l.ShellArgsLinux="terminal.integrated.shellArgs.linux",l.ShellArgsMacOs="terminal.integrated.shellArgs.osx",l.ShellArgsWindows="terminal.integrated.shellArgs.windows",l.ProfilesWindows="terminal.integrated.profiles.windows",l.ProfilesMacOs="terminal.integrated.profiles.osx",l.ProfilesLinux="terminal.integrated.profiles.linux",l.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",l.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",l.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",l.UseWslProfiles="terminal.integrated.useWslProfiles",l.TabsDefaultColor="terminal.integrated.tabs.defaultColor",l.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",l.TabsEnabled="terminal.integrated.tabs.enabled",l.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",l.TabsHideCondition="terminal.integrated.tabs.hideCondition",l.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",l.TabsShowActions="terminal.integrated.tabs.showActions",l.TabsLocation="terminal.integrated.tabs.location",l.TabsFocusMode="terminal.integrated.tabs.focusMode",l.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",l.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",l.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",l.CopyOnSelection="terminal.integrated.copyOnSelection",l.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",l.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",l.FontFamily="terminal.integrated.fontFamily",l.FontSize="terminal.integrated.fontSize",l.LetterSpacing="terminal.integrated.letterSpacing",l.LineHeight="terminal.integrated.lineHeight",l.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",l.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",l.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",l.BellDuration="terminal.integrated.bellDuration",l.FontWeight="terminal.integrated.fontWeight",l.FontWeightBold="terminal.integrated.fontWeightBold",l.CursorBlinking="terminal.integrated.cursorBlinking",l.CursorStyle="terminal.integrated.cursorStyle",l.CursorWidth="terminal.integrated.cursorWidth",l.Scrollback="terminal.integrated.scrollback",l.DetectLocale="terminal.integrated.detectLocale",l.DefaultLocation="terminal.integrated.defaultLocation",l.GpuAcceleration="terminal.integrated.gpuAcceleration",l.TerminalTitleSeparator="terminal.integrated.tabs.separator",l.TerminalTitle="terminal.integrated.tabs.title",l.TerminalDescription="terminal.integrated.tabs.description",l.RightClickBehavior="terminal.integrated.rightClickBehavior",l.Cwd="terminal.integrated.cwd",l.ConfirmOnExit="terminal.integrated.confirmOnExit",l.ConfirmOnKill="terminal.integrated.confirmOnKill",l.EnableBell="terminal.integrated.enableBell",l.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",l.AllowChords="terminal.integrated.allowChords",l.AllowMnemonics="terminal.integrated.allowMnemonics",l.EnvMacOs="terminal.integrated.env.osx",l.EnvLinux="terminal.integrated.env.linux",l.EnvWindows="terminal.integrated.env.windows",l.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",l.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",l.ShowExitAlert="terminal.integrated.showExitAlert",l.SplitCwd="terminal.integrated.splitCwd",l.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",l.WordSeparators="terminal.integrated.wordSeparators",l.EnableFileLinks="terminal.integrated.enableFileLinks",l.UnicodeVersion="terminal.integrated.unicodeVersion",l.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",l.LocalEchoEnabled="terminal.integrated.localEchoEnabled",l.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",l.LocalEchoStyle="terminal.integrated.localEchoStyle",l.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",l.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",l.CustomGlyphs="terminal.integrated.customGlyphs",l.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",l.InheritEnv="terminal.integrated.inheritEnv",l.ShowLinkHover="terminal.integrated.showLinkHover",l.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",l.AutoReplies="terminal.integrated.autoReplies",l.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",l.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",l.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",l.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",l.SmoothScrolling="terminal.integrated.smoothScrolling"})(R=e.TerminalSettingId||(e.TerminalSettingId={}));var k;(function(l){l.FileName="ptyhost"})(k=e.TerminalLogConstants||(e.TerminalLogConstants={}));var L;(function(l){l.PowerShell="pwsh",l.Bash="bash",l.Fish="fish",l.Sh="sh",l.Csh="csh",l.Ksh="ksh",l.Zsh="zsh"})(L=e.PosixShellType||(e.PosixShellType={}));var P;(function(l){l.CommandPrompt="cmd",l.PowerShell="pwsh",l.Wsl="wsl",l.GitBash="gitbash"})(P=e.WindowsShellType||(e.WindowsShellType={}));var I;(function(l){l[l.Api=0]="Api",l[l.Process=1]="Process",l[l.Sequence=2]="Sequence",l[l.Config=3]="Config"})(I=e.TitleEventSource||(e.TitleEventSource={}));var S;(function(l){l.LocalPty="localPty",l.PtyHost="ptyHost",l.Log="log",l.Heartbeat="heartbeat"})(S=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,D.createDecorator)("ptyService");var b;(function(l){l.Cwd="cwd",l.InitialCwd="initialCwd",l.FixedDimensions="fixedDimensions",l.Title="title",l.ShellType="shellType",l.HasChildProcesses="hasChildProcesses",l.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",l.OverrideDimensions="overrideDimensions",l.FailedShellIntegrationActivation="failedShellIntegrationActivation",l.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(b=e.ProcessPropertyType||(e.ProcessPropertyType={}));var C;(function(l){l[l.BeatInterval=5e3]="BeatInterval",l[l.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",l[l.SecondWaitMultiplier=1]="SecondWaitMultiplier",l[l.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(C=e.HeartbeatConstants||(e.HeartbeatConstants={}));var w;(function(l){l[l.Panel=1]="Panel",l[l.Editor=2]="Editor"})(w=e.TerminalLocation||(e.TerminalLocation={}));var p;(function(l){l.TerminalView="view",l.Editor="editor"})(p=e.TerminalLocationString||(e.TerminalLocationString={}));var d;(function(l){l[l.GraceTime=6e4]="GraceTime",l[l.ShortGraceTime=6e3]="ShortGraceTime"})(d=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var g;(function(l){l[l.HighWatermarkChars=1e5]="HighWatermarkChars",l[l.LowWatermarkChars=5e3]="LowWatermarkChars",l[l.CharCountAckSize=5e3]="CharCountAckSize"})(g=e.FlowControlConstants||(e.FlowControlConstants={}));var v;(function(l){l.GitBash="Git Bash",l.Pwsh="PowerShell"})(v=e.ProfileSource||(e.ProfileSource={}));var u;(function(l){l[l.Off=0]="Off",l[l.FinalTerm=1]="FinalTerm",l[l.VSCode=2]="VSCode"})(u=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var m;(function(l){l[l.Unknown=0]="Unknown",l[l.Shutdown=1]="Shutdown",l[l.Process=2]="Process",l[l.User=3]="User",l[l.Extension=4]="Extension"})(m=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(re[241],ae([0,1,4]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,D.createDecorator)("localPtyService")}),define(re[242],ae([0,1,34,25,32,12,5,36,27,15,28]),function(_,e,D,i,R,k,L,P,I,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shellIntegrationArgs=e.ShellIntegrationExecutable=e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function C(){const h=/(\d+)\.(\d+)\.(\d+)/g.exec(D.release());let f=0;return h&&h.length===4&&(f=parseInt(h[3])),f}e.getWindowsBuildNumber=C;async function w(h,f,n,r=P.env,t=b.Promises.exists){if(k.isAbsolute(h))return await t(h)?h:void 0;if(f===void 0&&(f=P.cwd()),k.dirname(h)!=="."){const o=k.join(f,h);return await t(o)?o:void 0}const s=(0,R.getCaseInsensitive)(r,"PATH");if(n===void 0&&(0,S.isString)(s)&&(n=s.split(k.delimiter)),n===void 0||n.length===0){const o=k.join(f,h);return await t(o)?o:void 0}for(const o of n){let y;if(k.isAbsolute(o)?y=k.join(o,h):y=k.join(f,o,h),await t(y))return y;if(L.isWindows){let E=y+".com";if(await t(E)||(E=y+".exe",await t(E)))return E}}const c=k.join(f,h);return await t(c)?c:void 0}e.findExecutable=w;function p(h,f,n,r,t){if(!f.shellIntegration.enabled||!h.executable||h.isFeatureTerminal||h.hideFromUser||h.ignoreShellIntegration||L.isWindows&&!f.windowsEnableConpty)return;const a=h.args,s=P.platform==="win32"?k.basename(h.executable).toLowerCase():k.basename(h.executable),c=k.dirname(i.FileAccess.asFileUri("").fsPath);let o;const y={VSCODE_INJECTION:"1"};if(L.isWindows){if(s==="pwsh.exe"||s==="powershell.exe")return!a||m(a)?o=e.shellIntegrationArgs.get(d.WindowsPwsh):u(a)&&(o=e.shellIntegrationArgs.get(d.WindowsPwshLogin)),o?(o=[...o],o[o.length-1]=(0,I.format)(o[o.length-1],c,""),{newArgs:o,envMixin:y}):void 0;r.warn(`Shell integration cannot be enabled for executable "${h.executable}" and args`,h.args);return}switch(s){case"bash":return!a||a.length===0?o=e.shellIntegrationArgs.get(d.Bash):l(a)&&(y.VSCODE_SHELL_LOGIN="1",o=e.shellIntegrationArgs.get(d.Bash)),o?(o=[...o],o[o.length-1]=(0,I.format)(o[o.length-1],c),{newArgs:o,envMixin:y}):void 0;case"pwsh":return!a||m(a)?o=e.shellIntegrationArgs.get(d.Pwsh):u(a)&&(o=e.shellIntegrationArgs.get(d.PwshLogin)),o?(o=[...o],o[o.length-1]=(0,I.format)(o[o.length-1],c,""),{newArgs:o,envMixin:y}):void 0;case"zsh":{if(!a||a.length===0?o=e.shellIntegrationArgs.get(d.Zsh):l(a)?o=e.shellIntegrationArgs.get(d.ZshLogin):(a===e.shellIntegrationArgs.get(d.Zsh)||a===e.shellIntegrationArgs.get(d.ZshLogin))&&(o=a),!o)return;o=[...o],o[o.length-1]=(0,I.format)(o[o.length-1],c);const E=k.join(D.tmpdir(),`${D.userInfo().username}-${t.applicationName}-zsh`);y.ZDOTDIR=E;const T=n?.ZDOTDIR??D.homedir()??"~";y.USER_ZDOTDIR=T;const q=[];return q.push({source:k.join(c,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:k.join(E,".zshrc")}),q.push({source:k.join(c,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:k.join(E,".zprofile")}),q.push({source:k.join(c,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:k.join(E,".zshenv")}),q.push({source:k.join(c,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:k.join(E,".zlogin")}),{newArgs:o,envMixin:y,filesToCopy:q}}}r.warn(`Shell integration cannot be enabled for executable "${h.executable}" and args`,h.args)}e.getShellIntegrationInjection=p;var d;(function(h){h.WindowsPwsh="windows-pwsh",h.WindowsPwshLogin="windows-pwsh-login",h.Pwsh="pwsh",h.PwshLogin="pwsh-login",h.Zsh="zsh",h.ZshLogin="zsh-login",h.Bash="bash"})(d=e.ShellIntegrationExecutable||(e.ShellIntegrationExecutable={})),e.shellIntegrationArgs=new Map,e.shellIntegrationArgs.set(d.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(d.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(d.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(d.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),e.shellIntegrationArgs.set(d.Zsh,["-i"]),e.shellIntegrationArgs.set(d.ZshLogin,["-il"]),e.shellIntegrationArgs.set(d.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const g=["-login","-l"],v=["-nol","-nologo"];function u(h){return typeof h=="string"?g.includes(h.toLowerCase()):h.length===1&&g.includes(h[0].toLowerCase())||h.length===2&&(g.includes(h[0].toLowerCase())||g.includes(h[1].toLowerCase()))&&(v.includes(h[0].toLowerCase())||v.includes(h[1].toLowerCase()))}function m(h){return typeof h=="string"?v.includes(h.toLowerCase()):h.length===0||h?.length===1&&v.includes(h[0].toLowerCase())}function l(h){return h==="string"&&g.includes(h.toLowerCase())||typeof h!="string"&&h.length===1&&g.includes(h[0].toLowerCase())}}),define(re[243],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var D;(function(k){k.DARK="dark",k.LIGHT="light",k.HIGH_CONTRAST_DARK="hcDark",k.HIGH_CONTRAST_LIGHT="hcLight"})(D=e.ColorScheme||(e.ColorScheme={}));function i(k){return k===D.HIGH_CONTRAST_DARK||k===D.HIGH_CONTRAST_LIGHT}e.isHighContrast=i;function R(k){return k===D.DARK||k===D.HIGH_CONTRAST_DARK}e.isDark=R}),define(re[113],ae([0,1,52,3,2,4,40,243]),function(_,e,D,i,R,k,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,k.createDecorator)("themeService");var I;(function(v){function u(m){return m&&typeof m=="object"&&typeof m.id=="string"}v.isThemeColor=u})(I=e.ThemeColor||(e.ThemeColor={}));function S(v){return{id:v}}e.themeColorFromId=S;var b;(function(v){function u(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color>"u"||I.isThemeColor(a.color))}v.isThemeIcon=u;const m=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function l(a){const s=m.exec(a);if(!s)return;const[,c]=s;return{id:c}}v.fromString=l;function h(a){return{id:a}}v.fromId=h;function f(a,s){let c=a.id;const o=c.lastIndexOf("~");return o!==-1&&(c=c.substring(0,o)),s&&(c=`${c}~${s}`),{id:c}}v.modify=f;function n(a){const s=a.id.lastIndexOf("~");if(s!==-1)return a.id.substring(s+1)}v.getModifier=n;function r(a,s){return a.id===s.id&&a.color?.id===s.color?.id}v.isEqual=r;function t(a,s){return{id:a.id,color:s?S(s):void 0}}v.asThemeIcon=t,v.asClassNameArray=D.CSSIcon.asClassNameArray,v.asClassName=D.CSSIcon.asClassName,v.asCSSSelector=D.CSSIcon.asCSSSelector})(b=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function C(v){switch(v){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case P.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class w{constructor(){this.a=[],this.a=[],this.b=new i.Emitter}onColorThemeChange(u){return this.a.push(u),this.b.fire(u),(0,R.toDisposable)(()=>{const m=this.a.indexOf(u);this.a.splice(m,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const p=new w;L.Registry.add(e.Extensions.ThemingContribution,p);function d(v){return p.onColorThemeChange(v)}e.registerThemingParticipant=d;class g extends R.Disposable{constructor(u){super(),this.k=u,this.h=u.getColorTheme(),this.B(this.k.onDidColorThemeChange(m=>this.n(m)))}n(u){this.h=u,this.updateStyles()}updateStyles(){}w(u,m){let l=this.h.getColor(u);return l&&m&&(l=m(l,this.h)),l?l.toString():null}}e.Themable=g}),define(re[244],ae([0,1,52,8,172,113]),function(_,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function L(w,p){const d=[{name:null,description:(0,R.localize)(0,null)}];return d.push(...w.map(g=>({name:g.profileName,description:P(g)}))),p&&d.push(...p.map(g=>({name:g.title,description:I(g)}))),{values:d.map(g=>g.name),markdownDescriptions:d.map(g=>g.description)}}e.createProfileSchemaEnums=L;function P(w){let p=`$(${k.ThemeIcon.isThemeIcon(w.icon)?w.icon.id:w.icon?w.icon:D.Codicon.terminal.id}) ${w.profileName}
- path: ${w.path}`;return w.args&&(typeof w.args=="string"?p+=`
- args: "${w.args}"`:p+=`
- args: [${w.args.length===0?"":`'${w.args.join("','")}'`}]`),w.overrideName!==void 0&&(p+=`
- overrideName: ${w.overrideName}`),w.color&&(p+=`
- color: ${w.color}`),w.env&&(p+=`
- env: ${JSON.stringify(w.env)}`),p}function I(w){return`$(${k.ThemeIcon.isThemeIcon(w.icon)?w.icon.id:w.icon?w.icon:D.Codicon.terminal.id}) ${w.title}
- extensionIdentifier: ${w.extensionIdentifier}`}function S(w,p){if(!w&&!p)return!0;if(typeof w=="string"&&typeof p=="string")return w===p;if(Array.isArray(w)&&Array.isArray(p)){if(w.length!==p.length)return!1;for(let d=0;d<w.length;d++)if(w[d]!==p[d])return!1;return!0}return!1}e.terminalProfileArgsMatch=S;function b(w,p){if(!w&&!p)return!0;if(!w||!p)return!1;if(k.ThemeIcon.isThemeIcon(w)&&k.ThemeIcon.isThemeIcon(p))return w.id===p.id&&w.color===p.color;if(typeof w=="object"&&"light"in w&&"dark"in w&&typeof p=="object"&&"light"in p&&"dark"in p){const d=w,g=p;if((i.URI.isUri(d.light)||C(d.light))&&(i.URI.isUri(d.dark)||C(d.dark))&&(i.URI.isUri(g.light)||C(g.light))&&(i.URI.isUri(g.dark)||C(g.dark)))return d.light.path===g.light.path&&d.dark.path===g.dark.path}if(i.URI.isUri(w)&&i.URI.isUri(p)||C(w)||C(p)){const d=w,g=p;return d.path===g.path&&d.scheme===g.scheme}return!1}e.terminalIconsEqual=b;function C(w){return w?typeof w.path=="string"&&typeof w.scheme=="string":!1}e.isUriComponents=C}),define(re[245],ae([0,1,52,171,46,40,244]),function(_,e,D,i,R,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from(D.Codicon.getAll(),h=>h.id),markdownEnumDescriptions:Array.from(D.Codicon.getAll(),h=>`$(${h.id})`)};const P={args:{description:(0,i.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,i.localize)(1,null),type:"boolean"},icon:{description:(0,i.localize)(2,null),...e.terminalIconSchema},color:{description:(0,i.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,i.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},I={type:"object",required:["path"],properties:{path:{description:(0,i.localize)(5,null),type:["string","array"],items:{type:"string"}},...P}},S={type:"object",required:["path"],properties:{path:{description:(0,i.localize)(6,null),type:["string"],items:{type:"string"}},...P}},b=(0,i.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),C=(0,i.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),w=(0,i.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),p=(0,i.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),d=(0,i.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),g=(0,i.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),v={id:"terminal",order:100,title:(0,i.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:d},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:g},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},S],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},S],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},S],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:b},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:C},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:w},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:b},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:C},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,i.localize)(26,null)}},{type:"string",markdownDescription:(0,i.localize)(27,null)}],default:[],markdownDeprecationMessage:w},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,i.localize)(29,null),enum:["PowerShell","Git Bash"]},...P}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,i.localize)(30,null),type:"string"},id:{description:(0,i.localize)(31,null),type:"string"},title:{description:(0,i.localize)(32,null),type:"string"},...P}},{type:"null"},I]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,i.localize)(34,null),type:"string"},id:{description:(0,i.localize)(35,null),type:"string"},title:{description:(0,i.localize)(36,null),type:"string"},...P}},{type:"null"},I]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,i.localize)(38,null),type:"string"},id:{description:(0,i.localize)(39,null),type:"string"},title:{description:(0,i.localize)(40,null),type:"string"},...P}},{type:"null"},I]}},["terminal.integrated.useWslProfiles"]:{description:(0,i.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,i.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,i.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,i.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,i.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function u(){k.Registry.as(R.Extensions.Configuration).registerConfiguration(v),l()}e.registerTerminalPlatformConfiguration=u;let m;function l(h,f){const n=k.Registry.as(R.Extensions.Configuration);let r;h&&(r=(0,L.createProfileSchemaEnums)(h?.profiles,f));const t=m;m={id:"terminal",order:100,title:(0,i.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:h?.os===3?r?.values:void 0,markdownEnumDescriptions:h?.os===3?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:h?.os===2?r?.values:void 0,markdownEnumDescriptions:h?.os===2?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:h?.os===1?r?.values:void 0,markdownEnumDescriptions:h?.os===1?r?.markdownDescriptions:void 0}}},n.updateConfigurations({add:[m],remove:t?[t]:[]})}e.registerTerminalDefaultProfileConfiguration=l}),define(re[246],ae([0,1,50,52,12,5,28,90,242,113]),function(_,e,D,i,R,k,L,P,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let b,C=!0;function w(r,t,a,s,c=process.env,o,y,E,T){return o=o||{existsFile:L.SymlinkSupport.existsFile,readFile:L.Promises.readFile},k.isWindows?p(a,o,c,y,s.getValue("terminal.integrated.useWslProfiles")!==!1,r&&typeof r=="object"?{...r}:s.getValue("terminal.integrated.profiles.windows"),typeof t=="string"?t:s.getValue("terminal.integrated.defaultProfile.windows"),T,E):h(o,y,a,r&&typeof r=="object"?{...r}:s.getValue(k.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof t=="string"?t:s.getValue(k.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),T,E,c)}e.detectAvailableProfiles=w;async function p(r,t,a,s,c,o,y,E,T){const q=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),N=`${process.env.windir}\\${q?"Sysnative":"System32"}`;let j=!1;(0,I.getWindowsBuildNumber)()>=16299&&(j=!0),await v(E);const F=new Map;r&&(F.set("PowerShell",{source:"PowerShell",icon:i.Codicon.terminalPowershell,isAutoDetected:!0}),F.set("Windows PowerShell",{path:`${N}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:i.Codicon.terminalPowershell,isAutoDetected:!0}),F.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),F.set("Command Prompt",{path:`${N}\\cmd.exe`,icon:i.Codicon.terminalCmd,isAutoDetected:!0})),f(o,F);const A=await d(F.entries(),y,t,a,s,T);if(r||c)try{const U=await m(`${N}\\${j?"wsl":"bash"}.exe`,y);for(const B of U)(!o||!(B.profileName in o))&&A.push(B)}catch{C&&(s?.info("WSL is not installed, so could not detect WSL profiles"),C=!1)}return A}async function d(r,t,a,s=process.env,c,o){const y=[];for(const[E,T]of r){if(T===null)continue;let q,N,j;if("source"in T){const U=b?.get(T.source);if(!U)continue;q=U.paths,N=T.args||U.args,T.icon?j=g(T.icon):U.icon&&(j=U.icon)}else q=Array.isArray(T.path)?T.path:[T.path],N=k.isWindows||Array.isArray(T.args)?T.args:void 0,j=g(T.icon);const F=await o?.(q)||q.slice(),A=await n(E,t,F,a,s,N,T.env,T.overrideName,T.isAutoDetected,c);A?(A.isAutoDetected=T.isAutoDetected,A.icon=j,A.color=T.color,y.push(A)):c?.debug("Terminal profile not validated",E,q)}return c?.debug("Validated terminal profiles",y),y}function g(r){return typeof r=="string"?{id:r}:r}async function v(r){b&&!r||(b=new Map,b.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login","-i"]}),b.set("PowerShell",{profileName:"PowerShell",paths:r||await u(),icon:S.ThemeIcon.asThemeIcon(i.Codicon.terminalPowershell)}))}async function u(){const r=[];for await(const t of(0,P.enumeratePowerShellInstallations)())r.push(t.exePath);return r}async function m(r,t){const a=[],s=await new Promise((y,E)=>{D.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(T,q)=>{if(T)return E("Problem occurred when getting wsl distros");y(q)})});if(!s)return[];const c=new RegExp(/[\r?\n]/),o=s.split(c).filter(y=>y.trim().length>0&&y!=="");for(const y of o){if(y===""||y.startsWith("docker-desktop"))continue;const E=`${y} (WSL)`,T={profileName:E,path:r,args:["-d",`${y}`],isDefault:E===t,icon:l(y),isAutoDetected:!1};a.push(T)}return a}function l(r){return r.includes("Ubuntu")?S.ThemeIcon.asThemeIcon(i.Codicon.terminalUbuntu):r.includes("Debian")?S.ThemeIcon.asThemeIcon(i.Codicon.terminalDebian):S.ThemeIcon.asThemeIcon(i.Codicon.terminalLinux)}async function h(r,t,a,s,c,o,y,E){const T=new Map;if(a){const q=(await r.readFile("/etc/shells")).toString(),N=o||q.split(`
`).filter(F=>F.trim().indexOf("#")!==0&&F.trim().length>0),j=new Map;for(const F of N){let A=(0,R.basename)(F),U=j.get(A)||0;U++,U>1&&(A=`${A} (${U})`),j.set(A,U),T.set(A,{path:F,isAutoDetected:!0})}}return f(s,T),await d(T.entries(),c,r,E,t,y)}function f(r,t){if(!!r)for(const[a,s]of Object.entries(r))s===null||!("path"in s)&&!("source"in s)?t.delete(a):(s.icon=s.icon||t.get(a)?.icon,t.set(a,s))}async function n(r,t,a,s,c,o,y,E,T,q){if(a.length===0)return Promise.resolve(void 0);const N=a.shift();if(N==="")return n(r,t,a,s,c,o,y,E,T);const j={profileName:r,path:N,args:o,env:y,overrideName:E,isAutoDetected:T,isDefault:r===t};if((0,R.basename)(N)===N){const A=c.PATH?c.PATH.split(R.delimiter):void 0,U=await(0,I.findExecutable)(N,void 0,A,void 0,s.existsFile);return U?(j.path=U,j.isFromPath=!0,j):n(r,t,a,s,c,o)}return await s.existsFile((0,R.normalize)(N))?j:n(r,t,a,s,c,o,y,E,T)}}),define(re[247],ae([0,1,3,2,25,5,39,68,16,13,94,232,7,102,240,112,245,246]),function(_,e,D,i,R,k,L,P,I,S,b,C,w,p,d,g,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var m;(function(f){f[f.MaxRestarts=5]="MaxRestarts"})(m||(m={}));let l=0,h=class extends i.Disposable{constructor(n,r,t,a){super(),this.C=n,this.D=r,this.F=t,this.G=a,this.g=0,this.h=!0,this.i=!1,this.l=this.B(new D.Emitter),this.onPtyHostExit=this.l.event,this.m=this.B(new D.Emitter),this.onPtyHostStart=this.m.event,this.n=this.B(new D.Emitter),this.onPtyHostUnresponsive=this.n.event,this.p=this.B(new D.Emitter),this.onPtyHostResponsive=this.p.event,this.r=this.B(new D.Emitter),this.onPtyHostRequestResolveVariables=this.r.event,this.s=this.B(new D.Emitter),this.onProcessData=this.s.event,this.t=this.B(new D.Emitter),this.onProcessReady=this.t.event,this.u=this.B(new D.Emitter),this.onProcessReplay=this.u.event,this.v=this.B(new D.Emitter),this.onProcessOrphanQuestion=this.v.event,this.w=this.B(new D.Emitter),this.onDidRequestDetach=this.w.event,this.y=this.B(new D.Emitter),this.onDidChangeProperty=this.y.event,this.z=this.B(new D.Emitter),this.onProcessExit=this.z.event,(0,v.registerTerminalPlatformConfiguration)(),this.c=this.J(),this.B((0,i.toDisposable)(()=>this.M())),this.f=this.B(new d.RequestStore(void 0,this.G)),this.f.onCreateRequest(this.r.fire,this.r),[this.a,this.b]=this.L(),this.B(this.D.onDidChangeConfiguration(async s=>{s.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.I()}))}initialize(){this.I()}get H(){return this.D.getValue("terminal.integrated.ignoreProcessNames")}async I(){return this.b.refreshIgnoreProcessNames?.(this.H)}async J(){if(k.isWindows)return process.env;try{return await(0,C.getResolvedShellEnv)(this.G,{_:[]},process.env)}catch(n){return this.G.error("ptyHost was unable to resolve shell environment",n),{}}}L(){const n={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.F.logsPath],env:{VSCODE_LAST_PTY_ID:l,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.C.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.C.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.C.scrollback}},r=(0,b.parsePtyHostPort)(this.F.args,this.F.isBuilt);r&&(r.break&&r.port?n.debugBrk=r.port:!r.break&&r.port&&(n.debug=r.port));const t=new P.Client(R.FileAccess.asFileUri("bootstrap-fork").fsPath,n);this.m.fire(),L.ProxyChannel.toService(t.getChannel(g.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.N()),this.N(),this.B(t.onDidProcessExit(o=>{this.l.fire(o.code),this.i||(this.g<=m.MaxRestarts?(this.G.error(`ptyHost terminated unexpectedly with code ${o.code}`),this.g++,this.restartPtyHost()):this.G.error(`ptyHost terminated unexpectedly with code ${o.code}, giving up`))}));const s=t.getChannel(g.TerminalIpcChannels.Log);p.LogLevelChannelClient.setLevel(s,this.G.getLevel()),this.B(this.G.onDidChangeLogLevel(()=>{p.LogLevelChannelClient.setLevel(s,this.G.getLevel())}));const c=L.ProxyChannel.toService(t.getChannel(g.TerminalIpcChannels.PtyHost));return this.B(c.onProcessData(o=>this.s.fire(o))),this.B(c.onProcessReady(o=>this.t.fire(o))),this.B(c.onProcessExit(o=>this.z.fire(o))),this.B(c.onDidChangeProperty(o=>this.y.fire(o))),this.B(c.onProcessReplay(o=>this.u.fire(o))),this.B(c.onProcessOrphanQuestion(o=>this.v.fire(o))),this.B(c.onDidRequestDetach(o=>this.w.fire(o))),[t,c]}dispose(){this.i=!0,super.dispose()}async createProcess(n,r,t,a,s,c,o,y,E,T,q){const N=setTimeout(()=>this.Q(),g.HeartbeatConstants.CreateProcessTimeout),j=await this.b.createProcess(n,r,t,a,s,c,o,y,E,T,q);return clearTimeout(N),l=Math.max(l,j),j}updateTitle(n,r,t){return this.b.updateTitle(n,r,t)}updateIcon(n,r,t,a){return this.b.updateIcon(n,r,t,a)}attachToProcess(n){return this.b.attachToProcess(n)}detachFromProcess(n,r){return this.b.detachFromProcess(n,r)}listProcesses(){return this.b.listProcesses()}reduceConnectionGraceTime(){return this.b.reduceConnectionGraceTime()}start(n){return this.b.start(n)}shutdown(n,r){return this.b.shutdown(n,r)}input(n,r){return this.b.input(n,r)}processBinary(n,r){return this.b.processBinary(n,r)}resize(n,r,t){return this.b.resize(n,r,t)}acknowledgeDataEvent(n,r){return this.b.acknowledgeDataEvent(n,r)}setUnicodeVersion(n,r){return this.b.setUnicodeVersion(n,r)}getInitialCwd(n){return this.b.getInitialCwd(n)}getCwd(n){return this.b.getCwd(n)}getLatency(n){return this.b.getLatency(n)}orphanQuestionReply(n){return this.b.orphanQuestionReply(n)}installAutoReply(n,r){return this.b.installAutoReply(n,r)}uninstallAllAutoReplies(){return this.b.uninstallAllAutoReplies()}uninstallAutoReply(n){return this.b.uninstallAutoReply(n)}getDefaultSystemShell(n){return this.b.getDefaultSystemShell(n)}async getProfiles(n,r,t,a=!1){const s=await this.c;return(0,u.detectAvailableProfiles)(r,t,a,this.D,s,void 0,this.G,this.S.bind(this,n))}getEnvironment(){return this.b.getEnvironment()}getWslPath(n){return this.b.getWslPath(n)}getRevivedPtyNewId(n){return this.b.getRevivedPtyNewId(n)}setTerminalLayoutInfo(n){return this.b.setTerminalLayoutInfo(n)}async getTerminalLayoutInfo(n){return await this.b.getTerminalLayoutInfo(n)}async requestDetachInstance(n,r){return this.b.requestDetachInstance(n,r)}async acceptDetachInstanceReply(n,r){return this.b.acceptDetachInstanceReply(n,r)}async freePortKillProcess(n){if(!this.b.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.b.freePortKillProcess(n)}async serializeTerminalState(n){return this.b.serializeTerminalState(n)}async reviveTerminalProcesses(n,r){return this.b.reviveTerminalProcesses(n,r)}async refreshProperty(n,r){return this.b.refreshProperty(n,r)}async updateProperty(n,r,t){return this.b.updateProperty(n,r,t)}async restartPtyHost(){this.h=!0,this.M(),[this.a,this.b]=this.L()}M(){this.b.shutdownAll?.(),this.a.dispose()}N(){this.R(),this.j=setTimeout(()=>this.O(),g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier),this.h||(this.h=!0,this.p.fire())}O(){this.G.warn(`No ptyHost heartbeat after ${g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.j=void 0,this.k=setTimeout(()=>this.P(),g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.SecondWaitMultiplier)}P(){this.G.error(`No ptyHost heartbeat after ${(g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier+g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.k=void 0,this.h&&(this.h=!1,this.n.fire())}Q(){this.R(),this.G.error(`No ptyHost response to createProcess after ${g.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.h&&(this.h=!1,this.n.fire())}R(){this.j&&(clearTimeout(this.j),this.j=void 0),this.k&&(clearTimeout(this.k),this.k=void 0)}S(n,r){return this.f.createRequest({workspaceId:n,originalText:r})}async acceptPtyHostResolvedVariables(n,r){this.f.acceptReply(n,r)}};h=pe([K(1,I.IConfigurationService),K(2,S.IEnvironmentService),K(3,w.ILogService)],h),e.PtyHostService=h}),define(re[77],ae([0,1,3,16,4,7]),function(_,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,R.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,R.createDecorator)("sharedTunnelsService");var L;(function(g){g.Http="http",g.Https="https"})(L=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(g){g.ConstantPrivate="constantPrivate",g.Private="private",g.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var I;(function(g){g[g.Notify=1]="Notify",g[g.OpenBrowser=2]="OpenBrowser",g[g.OpenPreview=3]="OpenPreview",g[g.Silent=4]="Silent",g[g.Ignore=5]="Ignore",g[g.OpenBrowserOnce=6]="OpenBrowserOnce"})(I=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function S(g){if(g.scheme!=="http"&&g.scheme!=="https")return;const v=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(g.authority);if(!!v)return{address:v[1],port:+v[2]}}e.extractLocalHostUriMetaDataForPortMapping=S,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function b(g){return e.LOCALHOST_ADDRESSES.indexOf(g)>=0}e.isLocalhost=b,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function C(g){return e.ALL_INTERFACES_ADDRESSES.indexOf(g)>=0}e.isAllInterfaces=C;function w(g,v,u,m){if(u===1)return!1;if(u===2&&C(v)){const l=/(\d+)\.(\d+)\.(\d+)/g.exec(m);if(l?.length===4&&parseInt(l[1])>=18)return!1}return g<1024}e.isPortPrivileged=w;class p{constructor(v,u,m){this.remoteAddress=v,this.localAddress=u,this.b=m,this.a=new D.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=p;let d=class{constructor(v,u){this.i=v,this.j=u,this.a=new D.Emitter,this.onTunnelOpened=this.a.event,this.b=new D.Emitter,this.onTunnelClosed=this.b.event,this.c=new D.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const v=this.j.getValue("remote.localPortHost");return!v||v==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(v){return this.e=v,v?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(v){this.f=v.elevation,this.g=v.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const v=[],u=Array.from(this.d.values());for(const m of u){const l=Array.from(m.values());for(const h of l){const f=await h.value;f&&v.push(f)}}return v}async dispose(){for(const v of this.d.values()){for(const{value:u}of v.values())await u.then(m=>m?.dispose());v.clear()}this.d.clear()}setEnvironmentTunnel(v,u,m,l,h){this.o(v,u,Promise.resolve({tunnelRemoteHost:v,tunnelRemotePort:u,localAddress:m,privacy:l,protocol:h,dispose:()=>Promise.resolve()}))}async getExistingTunnel(v,u){(C(v)||b(v))&&(v=e.LOCALHOST_ADDRESSES[0]);const m=this.q(v,u);if(m)return++m.refcount,m.value}openTunnel(v,u,m,l,h=!1,f,n){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${m} on local port ${l}.`),!v)return;if(u||(u="localhost"),this.e&&this.h.has(m)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.r(v,u,m,l,h,f,n);return r?r.then(t=>{if(!t){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(u,m);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.m(t);return(t.tunnelRemoteHost!==u||t.tunnelRemotePort!==m)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(a),a}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}m(v){return{tunnelRemotePort:v.tunnelRemotePort,tunnelRemoteHost:v.tunnelRemoteHost,tunnelLocalPort:v.tunnelLocalPort,localAddress:v.localAddress,privacy:v.privacy,protocol:v.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${v.tunnelRemoteHost}:${v.tunnelRemotePort} `);const u=this.d.get(v.tunnelRemoteHost);if(u){const m=u.get(v.tunnelRemotePort);m&&(m.refcount--,await this.n(v.tunnelRemoteHost,v.tunnelRemotePort,m))}}}}async n(v,u,m){if(m.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${v}:${u}.`);const l=m.value.then(async h=>{h&&(await h.dispose(!0),this.b.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this.d.has(v)&&this.d.get(v).delete(u),l}}async closeTunnel(v,u){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${v}:${u} `);const m=this.d.get(v);if(m&&m.has(u)){const l=m.get(u);l.refcount=0,await this.n(v,u,l)}}o(v,u,m){this.d.has(v)||this.d.set(v,new Map),this.d.get(v).set(u,{refcount:1,value:m})}async p(v,u){const m=this.d.get(v);m&&(await m.get(u)||m.delete(u),m.size===0&&this.d.delete(v))}q(v,u){const m=[v];b(v)?(m.push(...e.LOCALHOST_ADDRESSES),m.push(...e.ALL_INTERFACES_ADDRESSES)):C(v)&&m.push(...e.ALL_INTERFACES_ADDRESSES);const l=m.map(h=>this.d.get(h));for(const h of l){const f=h?.get(u);if(f)return f}}canTunnel(v){return!!S(v)}s(v,u,m,l,h,f,n){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${m} on local port ${l}.`);const r=m;this.h.add(r);const t=l===void 0?m:l,a={elevationRequired:h?this.isPortPrivileged(t):!1},s={remoteAddress:{host:u,port:m},localAddressPort:l,privacy:f,public:f?f!==P.Private:void 0,protocol:n},c=v.forwardPort(s,a);return c?(this.o(u,m,c),c.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(r)})):this.h.delete(r),c}};d=pe([K(0,k.ILogService),K(1,i.IConfigurationService)],d),e.AbstractTunnelService=d}),define(re[248],ae([0,1,7,77,2,9,6]),function(_,e,D,i,R,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class P extends R.Disposable{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new L.DeferredPromise),this.b.p)}setAddress(b){this.a=b,this.b&&(this.b.complete(b),this.b=null)}setTunnel(b){this.B(b)}}let I=class kt extends R.Disposable{constructor(b,C){super(),this.f=b,this.g=C,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(b=>b.dispose())}async createTunnel(){return{id:String(++kt.a)}}async startTunnel(b,C,w,p,d,g){const v=new P,u=await Promise.resolve(this.f.openTunnel(b,v,w,p,d,g));if(!u)throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${w}:${p} (remote).`),v.dispose(),new Error("Could not create tunnel");if(this.c.has(C))throw this.c.delete(C),v.dispose(),await u.dispose(),(0,k.canceled)();return v.setTunnel(u),this.b.set(C,v),this.g.info(`[SharedProcessTunnelService] Created tunnel ${C}: ${u.localAddress} (local) to ${w}:${p} (remote).`),{tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress}}async setAddress(b,C){const w=this.b.get(b);!w||w.setAddress(C)}async destroyTunnel(b){const C=this.b.get(b);if(C){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${b}.`),this.b.delete(b),await C.dispose();return}this.c.add(b)}};I.a=0,I=pe([K(0,i.ISharedTunnelsService),K(1,D.ILogService)],I),e.SharedProcessTunnelService=I}),define(re[249],ae([0,1,86,34,130,223,6,2,16,7,23,221,77,107,5]),function(_,e,D,i,R,k,L,P,I,S,b,C,w,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function g(h,f,n,r,t){let a;for(let s=3;s&&(a?.dispose(),a=await new v(h,f,n,r,t).waitForReady(),!(t&&R.BROWSER_RESTRICTED_PORTS[t]||!R.BROWSER_RESTRICTED_PORTS[a.tunnelLocalPort]));s--);return a}class v extends P.Disposable{constructor(f,n,r,t,a){super(),this.j=n,this.k=a,this.privacy=w.TunnelPrivacyId.Private,this.i=new Map,this.a=f,this.b=D.createServer(),this.c=new L.Barrier,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=s=>this.l(s),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=t,this.tunnelRemoteHost=r}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(n=>{n()})}async waitForReady(){const f=this.k??this.tunnelRemotePort,n=(0,w.isAllInterfaces)(this.j)?"0.0.0.0":"127.0.0.1";let r=await(0,R.findFreePortFaster)(f,2,1e3,n),t=null;return this.b.listen(r,this.j),await this.c.wait(),t=this.b.address(),t||(r=0,this.b.listen(r,this.j),await this.c.wait(),t=this.b.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async l(f){f.pause();const n=(0,w.isLocalhost)(this.tunnelRemoteHost)||(0,w.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,r=await(0,C.connectRemoteAgentTunnel)(this.a,n,this.tunnelRemotePort),t=r.getSocket().socket,a=r.readEntireBuffer();r.dispose(),a.byteLength>0&&f.write(a.buffer),f.on("end",()=>{f.localAddress&&this.i.delete(f.localAddress),t.end()}),f.on("close",()=>t.end()),f.on("error",()=>{f.localAddress&&this.i.delete(f.localAddress),t.destroy()}),t.on("end",()=>f.end()),t.on("close",()=>f.end()),t.on("error",()=>{f.destroy()}),f.pipe(t),t.pipe(f),f.localAddress&&this.i.set(f.localAddress,()=>{f.end(),t.end()})}}let u=class extends w.AbstractTunnelService{constructor(f,n,r,t,a){super(n,a),this.t=f,this.u=r,this.v=t}isPortPrivileged(f){return(0,w.isPortPrivileged)(f,this.k,d.OS,i.release())}r(f,n,r,t,a,s,c){const o=this.q(n,r);if(o)return++o.refcount,o.value;if(this.e)return this.s(this.e,n,r,t,a,s,c);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${r} on local port ${t}.`);const y={commit:this.v.commit,quality:this.v.quality,socketFactory:this.t,addressProvider:f,signService:this.u,logService:this.i,ipcLogger:null},E=g(y,this.k,n,r,t);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(n,r,E),E}}};u=pe([K(1,S.ILogService),K(2,p.ISignService),K(3,b.IProductService),K(4,I.IConfigurationService)],u),e.BaseTunnelService=u;let m=class extends u{constructor(f,n,r,t){super(k.nodeSocketFactory,f,n,r,t)}};m=pe([K(0,S.ILogService),K(1,p.ISignService),K(2,b.IProductService),K(3,I.IConfigurationService)],m),e.TunnelService=m;let l=class extends P.Disposable{constructor(f,n,r,t){super(),this.b=f,this.c=n,this.f=r,this.g=t,this.a=new Map}async openTunnel(f,n,r,t,a,s,c,o){if(this.b.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${r}:${t} on local port ${a}.`),!this.a.has(f)){const y=new m(this.b,this.f,this.c,this.g);this.B(y),this.a.set(f,y),y.onTunnelClosed(async()=>{(await y.tunnels).length===0&&(y.dispose(),this.a.delete(f))})}return this.a.get(f).openTunnel(n,r,t,a,s,c,o)}};l=pe([K(0,S.ILogService),K(1,b.IProductService),K(2,p.ISignService),K(3,I.IConfigurationService)],l),e.SharedTunnelsService=l}),define(re[30],ae([0,1,4]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,D.createDecorator)("IUriIdentityService")}),define(re[250],ae([0,1,30,71,14,22,128,3,2]),function(_,e,D,i,R,k,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class S{constructor(w){this.uri=w,this.time=S._clock++}touch(){return this.time=S._clock++,this}}S._clock=0;let b=class{constructor(w){this.g=w,this.c=new I.DisposableStore,this.f=2**16;const p=new Map,d=g=>{let v=p.get(g.scheme);return v===void 0&&(v=w.hasProvider(g)&&!this.g.hasCapability(g,1024),p.set(g.scheme,v)),v};this.c.add(P.Event.any(w.onDidChangeFileSystemProviderRegistrations,w.onDidChangeFileSystemProviderCapabilities)(g=>{p.delete(g.scheme)})),this.extUri=new k.ExtUri(d),this.d=new L.SkipList((g,v)=>this.extUri.compare(g,v,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(w){this.g.hasProvider(w)&&(w=(0,k.normalizePath)(w));const p=this.d.get(w);return p?p.touch().uri.with({fragment:w.fragment}):(this.d.set(w,new S(w)),this.h(),w)}h(){if(this.d.size<this.f)return;const w=[...this.d.entries()].sort((d,g)=>d[1].touch<g[1].touch?1:d[1].touch>g[1].touch?-1:0);S._clock=0,this.d.clear();const p=this.f*.5;for(let d=0;d<p;d++)this.d.set(w[d][0],w[d][1].touch())}};b=pe([K(0,R.IFileService)],b),e.UriIdentityService=b,(0,i.registerSingleton)(D.IUriIdentityService,b,1)}),define(re[251],ae([0,1,3,2,14,44,49,17]),function(_,e,D,i,R,k,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class I extends i.Disposable{get capabilities(){return this.f.capabilities&-5}constructor(b,C,w,p){super(),this.c=b,this.f=C,this.g=w,this.h=p,this.onDidChangeCapabilities=this.f.onDidChangeCapabilities,this.a=this.B(new D.Emitter),this.onDidChangeFile=this.a.event,this.b=L.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this.B(this.f.onDidChangeFile(d=>this.i(d)))}watch(b,C){this.b.set(b,b);const w=this.f.watch(this.j(b),C);return(0,i.toDisposable)(()=>{this.b.delete(b),w.dispose()})}stat(b){return this.f.stat(this.j(b))}mkdir(b){return this.f.mkdir(this.j(b))}rename(b,C,w){return this.f.rename(this.j(b),this.j(C),w)}readFile(b){return this.f.readFile(this.j(b),{atomic:!0})}readFileStream(b,C,w){const p=(0,k.newWriteableStream)(d=>P.VSBuffer.concat(d.map(g=>P.VSBuffer.wrap(g))).buffer);return(async()=>{try{const d=await this.readFile(b);p.end(d)}catch(d){p.error(d),p.end()}})(),p}readdir(b){return this.f.readdir(this.j(b))}writeFile(b,C,w){return this.f.writeFile(this.j(b),C,w)}delete(b,C){return this.f.delete(this.j(b),C)}copy(b,C,w){if((0,R.hasFileFolderCopyCapability)(this.f))return this.f.copy(this.j(b),this.j(C),w);throw new Error("copy not supported")}i(b){const C=[];for(const w of b){if(w.resource.scheme!==this.c)continue;const p=this.k(w.resource);this.b.findSubstr(p)&&C.push({resource:p,type:w.type})}C.length&&(this.h.debug("User data changed"),this.a.fire(C))}j(b){return b.with({scheme:this.c})}k(b){return b.with({scheme:this.g})}}e.FileUserDataProvider=I}),define(re[60],ae([0,1,83]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function i(L,P,I,S){const b=(0,D.setProperty)(L,P,I,S)[0];return b&&(L=L.substring(0,b.offset)+b.content+L.substring(b.offset+b.length)),L}e.edit=i;function R(L,P,I){let S=I;for(;S>=0;){if(L.charAt(S)===P.charAt(P.length-1)&&P.length===1)return S+1;if(S--,P.length===2&&S>=0&&L.charAt(S)===P.charAt(0))return S+2}return 0}e.getLineStartOffset=R;function k(L,P,I){let S=I;for(;S>=0;)if(L.charAt(S)===P.charAt(P.length-1)&&P.length===1||(S++,P.length===2&&S>=0&&L.charAt(S)===P.charAt(1)))return S;return L.length-1}e.getLineEndOffset=k}),define(re[252],ae([0,1,32,54,15]),function(_,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function k(p,d,g,v,u,m){const l=[],h=[],f=[];if(!d){const U=p.filter(({identifier:B})=>u.every(G=>G.toLowerCase()!==B.id.toLowerCase()));return{local:{added:l,removed:h,updated:f},remote:U.length>0?{added:U,updated:[],removed:[],all:U}:null}}p=p.map(C),d=d.map(C),g=g?g.map(C):null;const n=new Map,r=U=>{U.uuid&&n.set(U.id.toLowerCase(),U.uuid)};p.forEach(({identifier:U})=>r(U)),d.forEach(({identifier:U})=>r(U)),g?.forEach(({identifier:U})=>r(U));const t=U=>{const B=U.identifier.uuid||n.get(U.identifier.id.toLowerCase());return B?`uuid:${B}`:`id:${U.identifier.id.toLowerCase()}`},a=(U,B)=>(U.set(t(B),B),U),s=p.reduce(a,new Map),c=d.reduce(a,new Map),o=d.reduce((U,B)=>a(U,(0,D.deepClone)(B)),new Map),y=g?g.reduce(a,new Map):null,E=v.reduce(a,new Map),T=u.reduce((U,B)=>{const G=n.get(B.toLowerCase());return U.add(G?`uuid:${G}`:`id:${B.toLowerCase()}`)},new Set),q=m.reduce((U,{id:B,uuid:G})=>(G=G??n.get(B.toLowerCase()),U.add(G?`uuid:${G}`:`id:${B.toLowerCase()}`)),new Set),N=L(s,c,T,!1);if(N.added.size>0||N.removed.size>0||N.updated.size>0){const U=L(y,s,T,!1),B=L(y,c,T,!0),G=(W,Z,$,z)=>({...z,installed:Z.installed||$.installed,version:$.version&&(!Z.installed||i.gt($.version,Z.version))?$.version:Z.version,state:I(Z,$,y?.get(W)),preRelease:(Z.installed?z.preRelease:$.preRelease)??Z.preRelease});for(const W of B.removed.values()){const Z=s.get(W);if(!Z)continue;const $=(0,R.assertIsDefined)(y?.get(W)),z=!q.has(W)&&$.installed;Z.installed&&z?h.push(Z.identifier):o.set(W,Z)}for(const W of B.added.values()){const Z=(0,R.assertIsDefined)(c.get(W)),$=s.get(W);if($){if(N.updated.has(W)){const z=G(W,$,Z,Z);P($,Z,!1,!1)||f.push(w(z,W)),o.set(W,z)}}else Z.installed&&l.push(w(Z,W))}for(const W of B.updated.values()){const Z=(0,R.assertIsDefined)(c.get(W)),$=(0,R.assertIsDefined)(y?.get(W)),z=s.get(W);if(z)if(!q.has(W)&&$.installed&&z.installed&&!Z.installed)h.push(z.identifier);else{const ee=G(W,z,Z,Z);f.push(w(ee,W)),o.set(W,ee)}else Z.installed&&l.push(w(Z,W))}for(const W of U.added.values())B.added.has(W)||o.set(W,(0,R.assertIsDefined)(s.get(W)));for(const W of U.updated.values()){if(B.removed.has(W)||B.updated.has(W))continue;const Z=(0,R.assertIsDefined)(s.get(W)),$=(0,R.assertIsDefined)(c.get(W));o.set(W,G(W,Z,$,Z))}for(const W of U.removed.values())B.updated.has(W)||B.removed.has(W)||E.has(W)||!(0,R.assertIsDefined)(c.get(W)).installed||q.has(W)||!(0,R.assertIsDefined)(y?.get(W)).installed||o.delete(W)}const j=[],F=L(c,o,new Set,!0),A=F.added.size>0||F.updated.size>0||F.removed.size>0;return A&&o.forEach((U,B)=>j.push(w(U,B))),{local:{added:l,removed:h,updated:f},remote:A?{added:[...F.added].map(U=>o.get(U)),updated:[...F.updated].map(U=>o.get(U)),removed:[...F.removed].map(U=>c.get(U)),all:j}:null}}e.merge=k;function L(p,d,g,v){const u=p?[...p.keys()].filter(n=>!g.has(n)):[],m=[...d.keys()].filter(n=>!g.has(n)),l=m.filter(n=>u.indexOf(n)===-1).reduce((n,r)=>(n.add(r),n),new Set),h=u.filter(n=>m.indexOf(n)===-1).reduce((n,r)=>(n.add(r),n),new Set),f=new Set;for(const n of u){if(h.has(n))continue;const r=p.get(n),t=d.get(n);(!t||!P(r,t,v,!0))&&f.add(n)}return{added:l,removed:h,updated:f}}function P(p,d,g,v){return!(p.disabled!==d.disabled||v&&p.installed!==d.installed||p.installed&&d.installed&&p.preRelease!==d.preRelease||!b(p.state,d.state)||g&&p.version!==d.version)}function I(p,d,g){const v=p.state,u=d.state,m=g?.state;if(!d.version||v&&i.gt(p.version,d.version))return v;if(u&&i.gt(d.version,p.version)||!v)return u;if(!u)return v;const l=(0,D.deepClone)(v),h=m?S(m,u):{added:Object.keys(u).reduce((n,r)=>(n.add(r),n),new Set),removed:new Set,updated:new Set},f=m?S(m,v):{added:Object.keys(v).reduce((n,r)=>(n.add(r),n),new Set),removed:new Set,updated:new Set};for(const n of[...h.added.values(),...h.updated.values()])l[n]=u[n];for(const n of h.removed.values())f.updated.has(n)||delete l[n];return l}function S(p,d){const g=Object.keys(p),v=Object.keys(d),u=v.filter(h=>g.indexOf(h)===-1).reduce((h,f)=>(h.add(f),h),new Set),m=g.filter(h=>v.indexOf(h)===-1).reduce((h,f)=>(h.add(f),h),new Set),l=new Set;for(const h of g){if(m.has(h))continue;const f=p[h],n=d[h];(0,D.equals)(f,n)||l.add(h)}return{added:u,removed:m,updated:l}}function b(p={},d={}){const{added:g,removed:v,updated:u}=S(p,d);return g.size===0&&v.size===0&&u.size===0}function C(p){return{...p,disabled:!!p.disabled,installed:!!p.installed}}function w(p,d){const g={identifier:{id:p.identifier.id,uuid:d.startsWith("uuid:")?d.substring(5):void 0},preRelease:!!p.preRelease};return p.version&&(g.version=p.version),p.disabled&&(g.disabled=!0),p.installed&&(g.installed=!0),p.state&&(g.state=p.state),g}}),define(re[114],ae([0,1,20,16,4]),function(_,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,R.createDecorator)("IIgnoredExtensionsManagementService");let k=class{constructor(P){this.a=P}hasToNeverSyncExtension(P){return this.b().includes(P.toLowerCase())}hasToAlwaysSyncExtension(P){return this.b().includes(`-${P.toLowerCase()}`)}updateIgnoredExtensions(P,I){let S=[...this.a.getValue("settingsSync.ignoredExtensions")].map(b=>b.toLowerCase());return S=S.filter(b=>b!==P&&b!==`-${P}`),I&&S.push(P.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",S.length?S:void 0,2)}updateSynchronizedExtensions(P,I){let S=[...this.a.getValue("settingsSync.ignoredExtensions")].map(b=>b.toLowerCase());return S=S.filter(b=>b!==P&&b!==`-${P}`),I&&S.push(`-${P.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",S.length?S:void 0,2)}getIgnoredExtensions(P){const I=P.filter(w=>w.isMachineScoped).map(w=>w.identifier.id.toLowerCase()),S=this.b().map(w=>w.toLowerCase()),b=[],C=[];if(Array.isArray(S))for(const w of S)w.startsWith("-")?C.push(w.substring(1)):b.push(w);return(0,D.distinct)([...I,...b].filter(w=>C.indexOf(w)===-1))}b(){let P=this.a.inspect("settingsSync.ignoredExtensions").userValue;return P!==void 0||(P=this.a.inspect("sync.ignoredExtensions").userValue,P!==void 0)?P:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(I=>I.toLowerCase())}};k=pe([K(0,i.IConfigurationService)],k),e.IgnoredExtensionsManagementService=k}),define(re[253],ae([0,1,20,35,32,192,60]),function(_,e,D,i,R,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function P(h){return(0,i.parse)(h)||[]}e.parseKeybindings=P;async function I(h,f,n,r,t){const a=P(h),s=P(f),c=n?P(n):null,o=[...a,...s,...c||[]].map(G=>G.key),y=await t.resolveUserBindings(o),E=b(a,s,c,y);if(!E.hasLocalForwarded&&!E.hasRemoteForwarded)return{mergeContent:h,hasChanges:!1,hasConflicts:!1};if(!E.hasLocalForwarded&&E.hasRemoteForwarded)return{mergeContent:f,hasChanges:!0,hasConflicts:!1};if(E.hasLocalForwarded&&!E.hasRemoteForwarded)return{mergeContent:h,hasChanges:!0,hasConflicts:!1};const T=w(a),q=w(s),N=c?w(c):null,j=d(T,q,y),F=N?d(N,T,y):{added:[...T.keys()].reduce((G,W)=>(G.add(W),G),new Set),removed:new Set,updated:new Set},A=N?d(N,q,y):{added:[...q.keys()].reduce((G,W)=>(G.add(W),G),new Set),removed:new Set,updated:new Set},U=S(j,F,A);let B=h;for(const G of U.removed.values())U.conflicts.has(G)||(B=m(B,G,r));for(const G of U.added.values()){if(U.conflicts.has(G))continue;const W=q.get(G);if(W.some(Z=>Z.command!==`-${G}`&&E.conflicts.has(y[Z.key]))){U.conflicts.add(G);continue}B=u(B,W,r)}for(const G of U.updated.values()){if(U.conflicts.has(G))continue;const W=q.get(G);if(W.some(Z=>Z.command!==`-${G}`&&E.conflicts.has(y[Z.key]))){U.conflicts.add(G);continue}B=l(B,G,W,r)}return{mergeContent:B,hasChanges:!0,hasConflicts:U.conflicts.size>0}}e.merge=I;function S(h,f,n){const r=new Set,t=new Set,a=new Set,s=new Set;for(const c of f.removed.values())n.updated.has(c)&&s.add(c);for(const c of n.removed.values())s.has(c)||(f.updated.has(c)?s.add(c):t.add(c));for(const c of f.added.values())s.has(c)||n.added.has(c)&&h.updated.has(c)&&s.add(c);for(const c of n.added.values())s.has(c)||(f.added.has(c)?h.updated.has(c)&&s.add(c):r.add(c));for(const c of f.updated.values())s.has(c)||n.updated.has(c)&&h.updated.has(c)&&s.add(c);for(const c of n.updated.values())s.has(c)||(f.updated.has(c)?h.updated.has(c)&&s.add(c):a.add(c));return{added:r,removed:t,updated:a,conflicts:s}}function b(h,f,n,r){const t=new Set,a=C(h,r),s=C(f,r),c=n?C(n,r):null,o=p(a,s);if(o.added.size===0&&o.removed.size===0&&o.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const y=c?p(c,a):{added:[...a.keys()].reduce((F,A)=>(F.add(A),F),new Set),removed:new Set,updated:new Set};if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:t,removed:t,updated:t,conflicts:t};const E=c?p(c,s):{added:[...s.keys()].reduce((F,A)=>(F.add(A),F),new Set),removed:new Set,updated:new Set};if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const{added:T,removed:q,updated:N,conflicts:j}=S(o,y,E);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:T,removed:q,updated:N,conflicts:j}}function C(h,f){const n=new Map;for(const r of h){const t=f[r.key];let a=n.get(t);a||(a=[],n.set(t,a)),a.push(r)}return n}function w(h){const f=new Map;for(const n of h){const r=n.command[0]==="-"?n.command.substring(1):n.command;let t=f.get(r);t||(t=[],f.set(r,t)),t.push(n)}return f}function p(h,f){const n=[...h.keys()],r=[...f.keys()],t=r.filter(c=>n.indexOf(c)===-1).reduce((c,o)=>(c.add(o),c),new Set),a=n.filter(c=>r.indexOf(c)===-1).reduce((c,o)=>(c.add(o),c),new Set),s=new Set;for(const c of n){if(a.has(c))continue;const o=h.get(c).map(E=>({...E,key:c})),y=f.get(c).map(E=>({...E,key:c}));(0,D.equals)(o,y,(E,T)=>v(E,T))||s.add(c)}return{added:t,removed:a,updated:s}}function d(h,f,n){const r=[...h.keys()],t=[...f.keys()],a=t.filter(o=>r.indexOf(o)===-1).reduce((o,y)=>(o.add(y),o),new Set),s=r.filter(o=>t.indexOf(o)===-1).reduce((o,y)=>(o.add(y),o),new Set),c=new Set;for(const o of r){if(s.has(o))continue;const y=h.get(o).map(T=>({...T,key:n[T.key]})),E=f.get(o).map(T=>({...T,key:n[T.key]}));g(y,E)||c.add(o)}return{added:a,removed:s,updated:c}}function g(h,f){return!(!(0,D.equals)(h.filter(({command:n})=>n[0]!=="-"),f.filter(({command:n})=>n[0]!=="-"),(n,r)=>v(n,r))||!(0,D.equals)(h.filter(({command:n})=>n[0]==="-"),f.filter(({command:n})=>n[0]==="-"),(n,r)=>v(n,r)))}function v(h,f){if(h.command!==f.command||h.key!==f.key)return!1;const n=k.ContextKeyExpr.deserialize(h.when),r=k.ContextKeyExpr.deserialize(f.when);return!(n&&!r||!n&&r||n&&r&&!n.equals(r)||!R.equals(h.args,f.args))}function u(h,f,n){for(const r of f)h=L.edit(h,[-1],r,n);return h}function m(h,f,n){const r=P(h);for(let t=r.length-1;t>=0;t--)(r[t].command===f||r[t].command===`-${f}`)&&(h=L.edit(h,[t],void 0,n));return h}function l(h,f,n,r){const t=P(h),a=t.findIndex(s=>s.command===f||s.command===`-${f}`);for(let s=t.length-1;s>=0;s--)(t[s].command===f||t[s].command===`-${f}`)&&(h=L.edit(h,[s],void 0,r));for(let s=n.length-1;s>=0;s--)h=L.edit(h,[a],n[s],r);return h}}),define(re[254],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function D(k,L,P){const I={},S={},b=new Set;if(!L)return{local:{added:I,updated:S,removed:[...b.values()]},remote:{added:k,updated:{},removed:[]},conflicts:[]};const C=i(k,L);if(C.added.size===0&&C.removed.size===0&&C.updated.size===0)return{local:{added:I,updated:S,removed:[...b.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const w=i(P,k),p=i(P,L),d={},g={},v=new Set,u=new Set;for(const m of w.removed.values())p.updated.has(m)?I[m]=L[m]:v.add(m);for(const m of p.removed.values())u.has(m)||(w.updated.has(m)?u.add(m):b.add(m));for(const m of w.updated.values())u.has(m)||(p.updated.has(m)?C.updated.has(m)&&u.add(m):g[m]=k[m]);for(const m of p.updated.values())u.has(m)||(w.updated.has(m)?C.updated.has(m)&&u.add(m):k[m]!==void 0&&(S[m]=L[m]));for(const m of w.added.values())u.has(m)||(p.added.has(m)?C.updated.has(m)&&u.add(m):d[m]=k[m]);for(const m of p.added.values())u.has(m)||(w.added.has(m)?C.updated.has(m)&&u.add(m):I[m]=L[m]);return{local:{added:I,removed:[...b.values()],updated:S},remote:{added:d,removed:[...v.values()],updated:g},conflicts:[...u.values()]}}e.merge=D;function i(k,L){const P=k?Object.keys(k):[],I=L?Object.keys(L):[],S=I.filter(w=>P.indexOf(w)===-1).reduce((w,p)=>(w.add(p),w),new Set),b=P.filter(w=>I.indexOf(w)===-1).reduce((w,p)=>(w.add(p),w),new Set),C=new Set;for(const w of P){if(b.has(w))continue;const p=k[w],d=L[w];p!==d&&C.add(w)}return{added:S,removed:b,updated:C}}function R(k,L){const{added:P,removed:I,updated:S}=i(k,L);return P.size===0&&I.size===0&&S.size===0}e.areSame=R}),define(re[255],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(R,k,L,P){const I={local:{added:[],removed:[],updated:[]},remote:{added:[],removed:[],updated:[]}};if(!k){const b=R.filter(({id:C})=>!P.includes(C));return b.length?I.remote.added=b:I.remote=null,I}const S=i(R,k,P);if(S.added.length>0||S.removed.length>0||S.updated.length>0){const b=i(L,R,P),C=i(L,k,P);for(const w of C.removed){const p=R.find(d=>d.id===w);p&&I.local.removed.push(p)}for(const w of C.added){const p=k.find(d=>d.id===w);b.added.includes(w)?S.updated.includes(w)&&I.local.updated.push(p):I.local.added.push(p)}for(const w of C.updated)I.local.updated.push(k.find(p=>p.id===w));for(const w of b.added)C.added.includes(w)||I.remote.added.push(R.find(p=>p.id===w));for(const w of b.updated)C.removed.includes(w)||C.updated.includes(w)||I.remote.updated.push(R.find(p=>p.id===w));for(const w of b.removed)I.remote.removed.push(k.find(p=>p.id===w))}return I.remote.added.length===0&&I.remote.removed.length===0&&I.remote.updated.length===0&&(I.remote=null),I}e.merge=D;function i(R,k,L){R=R?R.filter(({id:w})=>!L.includes(w)):[],k=k.filter(({id:w})=>!L.includes(w));const P=R.map(({id:w})=>w),I=k.map(({id:w})=>w),S=I.filter(w=>P.indexOf(w)===-1),b=P.filter(w=>I.indexOf(w)===-1),C=[];for(const{id:w,name:p,shortName:d}of R){if(b.includes(w))continue;const g=k.find(v=>v.id===w);(!g||g.name!==p||g.shortName!==d)&&C.push(w)}return{added:S,removed:b,updated:C}}}),define(re[26],ae([0,1,20,15,178,46,29,4,104,40]),function(_,e,D,i,R,k,L,P,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncResourceProviderService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.getPathSegments=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function b(){const s=S.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(s).filter(c=>!!s[c].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=b;function C(){const s=S.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),c=Object.keys(s).filter(E=>!!s[E].ignoreSync),o=Object.keys(s).filter(E=>s[E].scope===2||s[E].scope===6),y=b();return(0,D.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...c,...o,...y])}e.getDefaultIgnoredSettings=C,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync",e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM="settingsSync.keybindingsPerPlatform";function w(){const s="vscode://schemas/ignoredSettings",c=S.Registry.as(k.Extensions.Configuration);c.registerConfiguration({id:"settingsSync",order:30,title:(0,R.localize)(0,null),type:"object",properties:{[e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM]:{type:"boolean",description:(0,R.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,R.localize)(2,null),items:[{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,R.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,R.localize)(4,null),default:[],scope:1,$ref:s,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const o=S.Registry.as(I.Extensions.JSONContribution),y=()=>{const E=b(),T=C().filter(F=>F!==e.CONFIGURATION_SYNC_STORE_KEY),q=Object.keys(k.allSettings.properties).filter(F=>T.indexOf(F)===-1),N=T.filter(F=>E.indexOf(F)===-1),j={items:{type:"string",enum:[...q,...N.map(F=>`-${F}`)]}};o.registerSchema(s,j)};return c.onDidUpdateConfiguration(()=>y())}e.registerConfiguration=w;function p(s){return s&&(0,i.isObject)(s)&&(0,i.isString)(s.id)&&Array.isArray(s.scopes)}e.isAuthenticationProvider=p;var d;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState",s.Profiles="profiles"})(d=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function g(s,...c){return s?[s,...c]:c}e.getPathSegments=g;function v(s,c,o,y){return y.joinPath(o.userDataSyncHome,...g(s,c,`lastSync${c}.json`))}e.getLastSyncResourceUri=v,e.IUserDataSyncStoreManagementService=(0,P.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,P.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,P.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function u(s){const c={};return c[e.HEADER_EXECUTION_ID]=s,c}e.createSyncHeaders=u;var m;(function(s){s.Unauthorized="Unauthorized",s.NotFound="NotFound",s.Conflict="Conflict",s.Gone="Gone",s.PreconditionFailed="PreconditionFailed",s.TooLarge="TooLarge",s.UpgradeRequired="UpgradeRequired",s.PreconditionRequired="PreconditionRequired",s.TooManyRequests="RemoteTooManyRequests",s.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",s.RequestFailed="RequestFailed",s.RequestCanceled="RequestCanceled",s.RequestTimeout="RequestTimeout",s.RequestProtocolNotSupported="RequestProtocolNotSupported",s.RequestPathNotEscaped="RequestPathNotEscaped",s.RequestHeadersNotObject="RequestHeadersNotObject",s.NoCollection="NoCollection",s.NoRef="NoRef",s.EmptyResponse="EmptyResponse",s.TurnedOff="TurnedOff",s.SessionExpired="SessionExpired",s.ServiceChanged="ServiceChanged",s.DefaultServiceChanged="DefaultServiceChanged",s.LocalTooManyRequests="LocalTooManyRequests",s.LocalPreconditionFailed="LocalPreconditionFailed",s.LocalInvalidContent="LocalInvalidContent",s.LocalError="LocalError",s.IncompatibleLocalContent="IncompatibleLocalContent",s.IncompatibleRemoteContent="IncompatibleRemoteContent",s.Unknown="Unknown"})(m=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class l extends Error{constructor(c,o,y,E){super(c),this.code=o,this.resource=y,this.operationId=E,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=l;class h extends l{constructor(c,o,y,E,T){super(c,y,void 0,T),this.url=o,this.serverCode=E}}e.UserDataSyncStoreError=h;class f extends l{constructor(c,o){super(c,o)}}e.UserDataAutoSyncError=f,function(s){function c(o){if(o instanceof s)return o;const y=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(o.name);if(y&&y[1]){const E=y[2]==="unknown"?void 0:y[2],T=y[3]==="unknown"?void 0:y[3];return new s(o.message,y[1],E,T)}return new s(o.message,"Unknown")}s.toUserDataSyncError=c}(l=e.UserDataSyncError||(e.UserDataSyncError={}));var n;(function(s){s.Uninitialized="uninitialized",s.Idle="idle",s.Syncing="syncing",s.HasConflicts="hasConflicts"})(n=e.SyncStatus||(e.SyncStatus={}));var r;(function(s){s[s.None=0]="None",s[s.Added=1]="Added",s[s.Modified=2]="Modified",s[s.Deleted=3]="Deleted"})(r=e.Change||(e.Change={}));var t;(function(s){s.Preview="preview",s.Conflict="conflict",s.Accepted="accepted"})(t=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function a(s){return`sync.enable.${s}`}e.getEnablementKey=a,e.IUserDataSyncEnablementService=(0,P.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,P.createDecorator)("IUserDataSyncService"),e.IUserDataSyncResourceProviderService=(0,P.createDecorator)("IUserDataSyncResourceProviderService"),e.IUserDataAutoSyncService=(0,P.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,P.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,P.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview"}),define(re[256],ae([0,1,32,26]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(L,P,I,S,b){if(!P)return{remote:{added:Object.keys(L),removed:[],updated:[],all:Object.keys(L).length>0?L:null},local:{added:{},removed:[],updated:{}}};const C=k(L,P);if(C.added.size===0&&C.removed.size===0&&C.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const w=I?k(I,P):{added:Object.keys(P).reduce((m,l)=>(m.add(l),m),new Set),removed:new Set,updated:new Set},p=I?k(I,L):{added:Object.keys(L).reduce((m,l)=>(m.add(l),m),new Set),removed:new Set,updated:new Set},d={added:{},removed:[],updated:{}},g=D.deepClone(P),v=!I;for(const m of p.added.values())m!==i.SYNC_SERVICE_URL_TYPE&&v&&w.added.has(m)||(g[m]=L[m]);for(const m of p.updated.values())g[m]=L[m];for(const m of p.removed.values())S.unregistered.includes(m)||delete g[m];for(const m of w.added.values()){const l=P[m];if(S.machine.includes(m)){b.info(`GlobalState: Skipped adding ${m} in local storage because it is declared as machine scoped.`);continue}if(I&&p.added.has(m))continue;const h=L[m];h&&h.value===l.value||m===i.SYNC_SERVICE_URL_TYPE&&v&&p.added.has(m)||(h?d.updated[m]=l:d.added[m]=l)}for(const m of w.updated.values()){const l=P[m];if(S.machine.includes(m)){b.info(`GlobalState: Skipped updating ${m} in local storage because it is declared as machine scoped.`);continue}if(p.updated.has(m)||p.removed.has(m))continue;const h=L[m];h&&h.value===l.value||(d.updated[m]=l)}for(const m of w.removed.values()){if(S.machine.includes(m)){b.trace(`GlobalState: Skipped removing ${m} in local storage because it is declared as machine scoped.`);continue}p.updated.has(m)||p.removed.has(m)||d.removed.push(m)}const u=k(P,g);return{local:d,remote:{added:[...u.added],updated:[...u.updated],removed:[...u.removed],all:u.added.size===0&&u.removed.size===0&&u.updated.size===0?null:g}}}e.merge=R;function k(L,P){const I=Object.keys(L),S=Object.keys(P),b=S.filter(p=>I.indexOf(p)===-1).reduce((p,d)=>(p.add(d),p),new Set),C=I.filter(p=>S.indexOf(p)===-1).reduce((p,d)=>(p.add(d),p),new Set),w=new Set;for(const p of I){if(C.has(p))continue;const d=L[p],g=P[p];D.equals(d,g)||w.add(p)}return{added:b,removed:C,updated:w}}}),define(re[257],ae([0,1,20,35,83,43,32,60,26]),function(_,e,D,i,R,k,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function S(o,y,E){let T=[];E?T=C(E):T=b(y);const q=[],N=[...(0,I.getDisallowedIgnoredSettings)()];if(Array.isArray(T))for(const j of T)j.startsWith("-")?N.push(j.substring(1)):q.push(j);return(0,D.distinct)([...o,...q].filter(j=>N.indexOf(j)===-1))}e.getIgnoredSettings=S;function b(o){let y=o.inspect("settingsSync.ignoredSettings").userValue;return y!==void 0||(y=o.inspect("sync.ignoredSettings").userValue,y!==void 0)?y:o.getValue("settingsSync.ignoredSettings")||[]}function C(o){const y=(0,i.parse)(o);return y?y["settingsSync.ignoredSettings"]||y["sync.ignoredSettings"]||[]:[]}function w(o,y){const E=(0,i.parse)(o)||{};let T="{}";for(const q of Object.keys(E)){const N=(0,R.setProperty)(T,[q],E[q],y);T=(0,R.applyEdits)(T,N)}return T}e.removeComments=w;function p(o,y,E,T){if(E.length){const q=c(y),N=(0,i.parse)(y)||{},j=(0,i.parse)(o);if(!j)return o;const F=[];for(const A of E){const U=N[A],B=j[A];U===void 0?o=P.edit(o,[A],void 0,T):B!==void 0?o=P.edit(o,[A],U,T):F.push(n(A,q))}F.sort((A,U)=>A.startOffset-U.startOffset),F.forEach(A=>o=m(A.setting.key,y,o,T))}return o}e.updateIgnoredSettings=p;function d(o,y,E,T,q,N){const j=p(o,y,T,N),F=E!==j,A=E!==y;if(!F&&!A)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(F&&!A)return{conflictsSettings:[],localContent:null,remoteContent:j,hasConflicts:!1};if(A&&!F)return{conflictsSettings:[],localContent:p(y,o,T,N),remoteContent:null,hasConflicts:!1};if(E===null&&v(o)){const V=g(o,y,T)?null:p(y,o,T,N);return{conflictsSettings:[],localContent:V,remoteContent:null,hasConflicts:!1}}let U=o,B=y;const G=(0,i.parse)(o),W=(0,i.parse)(y),Z=E?(0,i.parse)(E):null,$=T.reduce((V,X)=>(V.add(X),V),new Set),z=u(G,W,$),Y=u(Z,G,$),ee=u(Z,W,$),oe=new Map,J=new Set,Q=V=>{J.add(V);const X=q.filter(({key:se})=>se===V)[0];X?(U=P.edit(U,[V],X.value,N),B=P.edit(B,[V],X.value,N)):oe.set(V,{key:V,localValue:G[V],remoteValue:W[V]})};for(const V of Y.removed.values())ee.updated.has(V)?Q(V):B=P.edit(B,[V],void 0,N);for(const V of ee.removed.values())J.has(V)||(Y.updated.has(V)?Q(V):U=P.edit(U,[V],void 0,N));for(const V of Y.updated.values())J.has(V)||(ee.updated.has(V)?z.updated.has(V)&&Q(V):B=P.edit(B,[V],G[V],N));for(const V of ee.updated.values())J.has(V)||(Y.updated.has(V)?z.updated.has(V)&&Q(V):U=P.edit(U,[V],W[V],N));for(const V of Y.added.values())J.has(V)||(ee.added.has(V)?z.updated.has(V)&&Q(V):B=m(V,U,B,N));for(const V of ee.added.values())J.has(V)||(Y.added.has(V)?z.updated.has(V)&&Q(V):U=m(V,B,U,N));const O=oe.size>0||!g(U,B,T),M=O||!g(U,o,[]),H=O||!g(B,y,[]);return{localContent:M?U:null,remoteContent:H?B:null,conflictsSettings:[...oe.values()],hasConflicts:O}}e.merge=d;function g(o,y,E){if(o===y)return!0;const T=(0,i.parse)(o),q=(0,i.parse)(y),N=E.reduce((A,U)=>(A.add(U),A),new Set),j=c(o).filter(A=>!(A.setting&&N.has(A.setting.key))),F=c(y).filter(A=>!(A.setting&&N.has(A.setting.key)));if(j.length!==F.length)return!1;for(let A=0;A<j.length;A++){const U=j[A],B=F[A];if(U.setting&&B.setting){if(U.setting.key!==B.setting.key||!L.equals(T[U.setting.key],q[U.setting.key]))return!1}else if(!U.setting&&!B.setting){if(U.value!==B.value)return!1}else return!1}return!0}e.areSame=g;function v(o){return o?c(o).length===0:!0}e.isEmpty=v;function u(o,y,E){const T=o?Object.keys(o).filter(A=>!E.has(A)):[],q=Object.keys(y).filter(A=>!E.has(A)),N=q.filter(A=>T.indexOf(A)===-1).reduce((A,U)=>(A.add(U),A),new Set),j=T.filter(A=>q.indexOf(A)===-1).reduce((A,U)=>(A.add(U),A),new Set),F=new Set;if(o)for(const A of T){if(j.has(A))continue;const U=o[A],B=y[A];L.equals(U,B)||F.add(A)}return{added:N,removed:j,updated:F}}function m(o,y,E,T){const q=(0,i.parse)(y),N=c(y),j=c(E),F=l(o,N,j);return h(E,o,q[o],F,j,T)}e.addSetting=m;function l(o,y,E){const T=y.findIndex(N=>N.setting?.key===o),q=y[T-1];if(q){if(q.setting){const j=n(q.setting.key,E);if(j)return{index:E.indexOf(j),insertAfter:!0}}else{const j=r(T,y);if(j){const F=n(j.setting.key,E);if(F){const A=t(E.indexOf(F),E),U=a(y,j,y[T]);if(A){const B=a(E,F,A),G=s(U,B);return G?{index:E.indexOf(G),insertAfter:!0}:{index:E.indexOf(A),insertAfter:!1}}else{const B=a(E,F,E[E.length-1]),G=s(U,B);return G?{index:E.indexOf(G),insertAfter:!0}:{index:E.length-1,insertAfter:!0}}}}}const N=y[T+1];if(N)if(N.setting){const j=n(N.setting.key,E);if(j)return{index:E.indexOf(j),insertAfter:!1}}else{const j=t(T,y);if(j){const F=n(j.setting.key,E);if(F){const A=r(E.indexOf(F),E),U=a(y,y[T],j);if(A){const B=a(E,A,F),G=s(U.reverse(),B.reverse());return G?{index:E.indexOf(G),insertAfter:!1}:{index:E.indexOf(A),insertAfter:!0}}else{const B=a(E,E[0],F),G=s(U.reverse(),B.reverse());return G?{index:E.indexOf(G),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:E.length-1,insertAfter:!0}}function h(o,y,E,T,q,N){let j;return T.index===-1?j=(0,R.setProperty)(o,[y],E,N):j=f(o,y,E,T,q,N).map(F=>(0,R.withFormatting)(o,F,N)[0]),(0,R.applyEdits)(o,j)}function f(o,y,E,T,q,N){const j=`${JSON.stringify(y)}: ${JSON.stringify(E)}`,F=(0,k.getEOL)(N,o),A=q[T.index];if(T.insertAfter){const U=[];if(A.setting)U.push({offset:A.endOffset,length:0,content:","+j});else{const B=t(T.index,q),G=r(T.index,q),W=G?.setting?.commaOffset;G&&W===void 0&&U.push({offset:G.endOffset,length:0,content:","});const Z=W!==void 0&&W>A.endOffset;U.push({offset:Z?W+1:A.endOffset,length:0,content:B?F+j+",":F+j})}return U}else{if(A.setting)return[{offset:A.startOffset,length:0,content:j+","}];const U=(q[T.index-1]&&!q[T.index-1].setting?F:"")+j+(t(T.index,q)?",":"")+F;return[{offset:A.startOffset,length:0,content:U}]}}function n(o,y){return y.filter(E=>E.setting?.key===o)[0]}function r(o,y){for(let E=o-1;E>=0;E--)if(y[E].setting)return y[E]}function t(o,y){for(let E=o+1;E<y.length;E++)if(y[E].setting)return y[E]}function a(o,y,E){const T=o.indexOf(y),q=o.indexOf(E);return o.filter((N,j)=>T<j&&j<q)}function s(o,y){if(o.length&&y.length){let E=0;for(;E<y.length&&E<o.length;E++)if(o[E].value!==y[E].value)return y[E-1];return y[E-1]}}function c(o){const y=[];let E=-1,T,q;const N={onObjectBegin:j=>{E++},onObjectProperty:(j,F,A)=>{E===0&&(T=F,q=j)},onObjectEnd:(j,F)=>{E--,E===0&&y.push({startOffset:T,endOffset:j+F,value:o.substring(T,j+F),setting:{key:q,commaOffset:void 0}})},onArrayBegin:(j,F)=>{E++},onArrayEnd:(j,F)=>{E--,E===0&&y.push({startOffset:T,endOffset:j+F,value:o.substring(T,j+F),setting:{key:q,commaOffset:void 0}})},onLiteralValue:(j,F,A)=>{E===0&&y.push({startOffset:T,endOffset:F+A,value:o.substring(T,F+A),setting:{key:q,commaOffset:void 0}})},onSeparator:(j,F,A)=>{if(E===0&&j===","){let U=y.length-1;for(;U>=0&&!y[U].setting;U--);const B=y[U];B&&y.splice(U,1,{startOffset:B.startOffset,endOffset:B.endOffset,value:B.value,setting:{key:B.setting.key,commaOffset:F}})}},onComment:(j,F)=>{E===0&&y.push({startOffset:j,endOffset:j+F,value:o.substring(j,j+F)})}};return(0,i.visit)(o,N),y}}),define(re[78],ae([0,1,3,2,4,26]),function(_,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,R.createDecorator)("IUserDataSyncAccountService");let L=class extends i.Disposable{get account(){return this.a}constructor(I,S){super(),this.g=I,this.h=S,this.b=this.B(new D.Emitter),this.onDidChangeAccount=this.b.event,this.c=this.B(new D.Emitter),this.onTokenFailed=this.c.event,this.f=!1,this.B(I.onTokenFailed(()=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f),this.updateAccount(void 0),this.c.fire(this.f),this.f=!0})),this.B(I.onTokenSucceed(()=>this.f=!1))}async updateAccount(I){(I&&this.a?I.token!==this.a.token||I.authenticationProviderId!==this.a.authenticationProviderId:I!==this.a)&&(this.a=I,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(I))}};L=pe([K(0,k.IUserDataSyncStoreService),K(1,k.IUserDataSyncLogService)],L),e.UserDataSyncAccountService=L}),define(re[258],ae([0,1,2,8]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class R{constructor(w){this.a=w}listen(w,p){switch(p){case"onError":return this.a.onError}throw new Error(`Event not found: ${p}`)}call(w,p,d){switch(p){case"triggerSync":return this.a.triggerSync(d[0],d[1],d[2]);case"turnOn":return this.a.turnOn();case"turnOff":return this.a.turnOff(d[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=R;class k{constructor(w){this.a=w}listen(w,p){throw new Error(`Event not found: ${p}`)}call(w,p,d){switch(p){case"resolveDefaultIgnoredSettings":return this.a.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.a.resolveUserBindings(d[0]);case"resolveFormattingOptions":return this.a.resolveFormattingOptions(i.URI.revive(d[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=k;class L{constructor(w){this.a=w}async resolveDefaultIgnoredSettings(){return this.a.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(w){return this.a.call("resolveUserKeybindings",[w])}async resolveFormattingOptions(w){return this.a.call("resolveFormattingOptions",[w])}}e.UserDataSyncUtilServiceClient=L;class P{constructor(w){this.a=w}listen(w,p){switch(p){case"onDidChange":return this.a.onDidChange}throw new Error(`Event not found: ${p}`)}async call(w,p,d){switch(p){case"getMachines":return this.a.getMachines();case"addCurrentMachine":return this.a.addCurrentMachine();case"removeCurrentMachine":return this.a.removeCurrentMachine();case"renameMachine":return this.a.renameMachine(d[0],d[1]);case"setEnablements":return this.a.setEnablements(d)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=P;class I{constructor(w){this.a=w}listen(w,p){switch(p){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`Event not found: ${p}`)}call(w,p,d){switch(p){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(d)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=I;class S{constructor(w){this.a=w}listen(w,p){switch(p){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${p}`)}call(w,p,d){switch(p){case"switch":return this.a.switch(d[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=S;class b extends D.Disposable{constructor(w){super(),this.a=w,this.onDidChangeUserDataSyncStore=this.a.listen("onDidChangeUserDataSyncStore")}async switch(w){return this.a.call("switch",[w])}async getPreviousUserDataSyncStore(){const w=await this.a.call("getPreviousUserDataSyncStore");return this.b(w)}b(w){return{url:i.URI.revive(w.url),type:w.type,defaultUrl:i.URI.revive(w.defaultUrl),insidersUrl:i.URI.revive(w.insidersUrl),stableUrl:i.URI.revive(w.stableUrl),canSwitch:w.canSwitch,authenticationProviders:w.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=b}),define(re[259],ae([0,1,13,7]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let R=class extends i.AbstractLogger{constructor(L,P){super(),this.g=this.B(L.createLogger(P.userDataSyncLogResource,{name:"settingssync"}))}trace(L,...P){this.g.trace(L,...P)}debug(L,...P){this.g.debug(L,...P)}info(L,...P){this.g.info(L,...P)}warn(L,...P){this.g.warn(L,...P)}error(L,...P){this.g.error(L,...P)}flush(){this.g.flush()}};R=pe([K(0,i.ILoggerService),K(1,D.IEnvironmentService)],R),e.UserDataSyncLogService=R}),define(re[260],ae([0,1,6,3,2]),function(_,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class k extends R.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:I,getActiveWindowId:S}){super(),this.a=this.B(new R.DisposableStore),i.Event.latch(i.Event.any(P,I))(this.f,this,this.a),this.b=(0,D.createCancelablePromise)(()=>S()),(async()=>{try{const C=await this.b;this.c=typeof this.c=="number"?this.c:C}catch{}finally{this.b=void 0}})()}f(P){this.b&&(this.b.cancel(),this.b=void 0),this.c=P}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.ActiveWindowManager=k}),define(re[115],ae([0,1,181,12,49,22,8,4,25]),function(_,e,D,i,R,k,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function S(r){const t=r;return typeof t?.id=="string"&&L.URI.isUri(t.uri)}e.isSingleFolderWorkspaceIdentifier=S,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function b(r,t){if(typeof r=="string"||typeof r>"u")return typeof r=="string"?{id:(0,i.basename)(r)}:t?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const a=r;if(a.configuration)return{id:a.id,configPath:a.configuration};if(a.folders.length===1)return{id:a.id,uri:a.folders[0].uri}}e.toWorkspaceIdentifier=b;function C(r){const t=r;return typeof t?.id=="string"&&L.URI.isUri(t.configPath)}e.isWorkspaceIdentifier=C;function w(r){const t=r;if(t?.uri)return{id:t.id,uri:L.URI.revive(t.uri)};const a=r;if(a?.configPath)return{id:a.id,configPath:L.URI.revive(a.configPath)};if(r?.id)return{id:r.id}}e.reviveIdentifier=w;var p;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(p=e.WorkbenchState||(e.WorkbenchState={}));function d(r){const t=r;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.isWorkspace=d;function g(r){const t=r;return!!(t&&typeof t=="object"&&L.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.isWorkspaceFolder=g;class v{constructor(t,a,s,c,o){this.h=t,this.j=s,this.k=c,this.l=o,this.c=R.TernarySearchTree.forUris(this.l,()=>!0),this.folders=a}update(t){this.h=t.id,this.k=t.configuration,this.j=t.transient,this.l=t.l,this.folders=t.folders}get folders(){return this.g}set folders(t){this.g=t,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(t){this.k=t}getFolder(t){return t&&this.c.findSubstr(t)||null}n(){this.c=R.TernarySearchTree.forUris(this.l,()=>!0);for(const t of this.folders)this.c.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=v;class u{constructor(t,a){this.raw=a,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,k.joinPath)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=u;function m(r){return new u({uri:r,index:0,name:(0,k.basenameOrAuthority)(r)},{uri:r.toString()})}e.toWorkspaceFolder=m,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,D.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function l(r,t){return k.extUriBiasedIgnorePathCase.isEqualOrParent(r,t.untitledWorkspacesHome)}e.isUntitledWorkspace=l;function h(r){let t;return L.URI.isUri(r)?t=r:t=r.configuration,t?.scheme===I.Schemas.tmp}e.isTemporaryWorkspace=h;function f(r,t){return!l(r,t)&&!h(r)}e.isSavedWorkspace=f;function n(r){return(typeof r=="string"?(0,i.extname)(r):(0,k.extname)(r))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=n}),define(re[18],ae([0,1,66,3,2,22,8,173,13,14,4,7,115,37,30,6,31,27]),function(_,e,D,i,R,k,L,P,I,S,b,C,w,p,d,g,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function m(r){const t=r;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&L.URI.isUri(t.location)&&L.URI.isUri(t.globalStorageHome)&&L.URI.isUri(t.settingsResource)&&L.URI.isUri(t.keybindingsResource)&&L.URI.isUri(t.tasksResource)&&L.URI.isUri(t.snippetsHome)&&L.URI.isUri(t.extensionsResource))}e.isUserDataProfile=m,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,b.createDecorator)("IUserDataProfilesService");function l(r,t){return{id:r.id,isDefault:r.isDefault,name:r.name,shortName:r.shortName,location:L.URI.revive(r.location).with({scheme:t}),globalStorageHome:L.URI.revive(r.globalStorageHome).with({scheme:t}),settingsResource:L.URI.revive(r.settingsResource).with({scheme:t}),keybindingsResource:L.URI.revive(r.keybindingsResource).with({scheme:t}),tasksResource:L.URI.revive(r.tasksResource).with({scheme:t}),snippetsHome:L.URI.revive(r.snippetsHome).with({scheme:t}),extensionsResource:L.URI.revive(r.extensionsResource)?.with({scheme:t}),useDefaultFlags:r.useDefaultFlags,isTransient:r.isTransient}}e.reviveProfile=l;function h(r,t,a,s){return{id:r,name:t,location:a,isDefault:!1,shortName:s?.shortName,globalStorageHome:(0,k.joinPath)(a,"globalStorage"),settingsResource:(0,k.joinPath)(a,"settings.json"),keybindingsResource:(0,k.joinPath)(a,"keybindings.json"),tasksResource:(0,k.joinPath)(a,"tasks.json"),snippetsHome:(0,k.joinPath)(a,"snippets"),extensionsResource:(0,k.joinPath)(a,"extensions.json"),useDefaultFlags:s?.useDefaultFlags,isTransient:s?.transient}}e.toUserDataProfile=h;let f=class extends R.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(t,a,s,c){super(),this.m=t,this.n=a,this.r=s,this.s=c,this.f=!1,this.g=this.B(new i.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new i.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new i.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new i.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new p.ResourceMap},this.profilesHome=(0,k.joinPath)(this.m.userRoamingDataHome,"profiles")}setEnablement(t){this.f!==t&&(this.t=void 0,this.f=t)}isEnabled(){return this.f}get u(){if(!this.t){const t=this.f?this.H().map(o=>h((0,k.basename)(o.location),o.name,o.location,{shortName:o.shortName,useDefaultFlags:o.useDefaultFlags})):[];let a;const s=new p.ResourceMap,c=h((0,D.hash)(this.m.userRoamingDataHome.path).toString(16),(0,P.localize)(0,null),this.m.userRoamingDataHome);if(t.unshift({...c,extensionsResource:this.M()??c.extensionsResource,isDefault:!0}),t.length){const o=this.J();if(o.workspaces)for(const[y,E]of Object.entries(o.workspaces)){const T=L.URI.parse(y),q=L.URI.parse(E),N=t.find(j=>this.r.extUri.isEqual(j.location,q));N&&s.set(T,N)}if(o.emptyWindow){const y=L.URI.parse(o.emptyWindow);a=t.find(E=>this.r.extUri.isEqual(E.location,y))}}this.t={profiles:t,workspaces:s,emptyWindow:a}}return this.t}async createTransientProfile(t){const a="Temp",s=new RegExp(`${(0,u.escapeRegExpCharacters)(a)}\\s(\\d+)`);let c=0;for(const y of this.profiles){const E=s.exec(y.name),T=E?parseInt(E[1]):0;c=T>c?T:c}const o=`${a} ${c+1}`;return this.createProfile((0,D.hash)((0,v.generateUuid)()).toString(16),o,{transient:!0},t)}async createNamedProfile(t,a,s){return this.createProfile((0,D.hash)((0,v.generateUuid)()).toString(16),t,a,s)}async createProfile(t,a,s,c){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const o=await this.v(t,a,s);return c&&await this.setProfileForWorkspace(c,o),o}async v(t,a,s){let c=this.k.get(a);return c||(c=(async()=>{try{const o=this.profiles.find(T=>T.name===a||T.id===t);if(o)return o;const y=h(t,a,(0,k.joinPath)(this.profilesHome,t),s);await this.n.createFolder(y.location);const E=[];return this.h.fire({profile:y,join(T){E.push(T)}}),await g.Promises.settled(E),this.C([y],[],[]),y}finally{this.k.delete(a)}})(),this.k.set(a,c)),c}async updateProfile(t,a){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let s=this.profiles.find(c=>c.id===t.id);if(!s)throw new Error(`Profile '${t.name}' does not exist`);return s=h(s.id,a.name??s.name,s.location,{shortName:a.shortName??s.shortName,transient:a.transient??s.isTransient,useDefaultFlags:a.useDefaultFlags??s.useDefaultFlags}),this.C([],[],[s]),s}async removeProfile(t){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(t.isDefault)throw new Error("Cannot remove default profile");const a=this.profiles.find(c=>c.id===t.id);if(!a)throw new Error(`Profile '${t.name}' does not exist`);const s=[];this.i.fire({profile:a,join(c){s.push(c)}});try{await Promise.allSettled(s)}catch(c){this.s.error(c)}a.id===this.u.emptyWindow?.id&&(this.u.emptyWindow=void 0);for(const c of[...this.u.workspaces.keys()])a.id===this.u.workspaces.get(c)?.id&&this.u.workspaces.delete(c);this.G(),this.C([],[a],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(a.location,{recursive:!0})}catch(c){this.s.error(c)}}getOrSetProfileForWorkspace(t,a=this.defaultProfile){if(!this.f)return this.defaultProfile;let s=this.w(t);return s||(s=a,this.profiles.length>1&&this.setProfileForWorkspaceSync(t,s)),s}async setProfileForWorkspace(t,a){this.setProfileForWorkspaceSync(t,a)}setProfileForWorkspaceSync(t,a){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const s=this.profiles.find(c=>c.id===a.id);if(!s)throw new Error(`Profile '${a.name}' does not exist`);this.F(t,s)}unsetWorkspace(t,a){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.F(t,void 0,a)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindow=void 0,this.u.workspaces.clear(),this.u.emptyWindow=void 0,this.G(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const t=await this.n.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(a=>a.isDirectory&&this.profiles.every(s=>!this.r.extUri.isEqual(s.location,a.resource))).map(a=>this.n.del(a.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const t=this.l.profiles.filter(a=>!this.z(a));await Promise.allSettled(t.map(a=>this.removeProfile(a)))}w(t){const a=this.y(t);return L.URI.isUri(a)?this.l.workspaces.get(a)??this.u.workspaces.get(a):this.l.emptyWindow??this.u.emptyWindow}y(t){return(0,w.isSingleFolderWorkspaceIdentifier)(t)?t.uri:(0,w.isWorkspaceIdentifier)(t)?t.configPath:"empty-window"}z(t){return!!(this.r.extUri.isEqual(this.l.emptyWindow?.location,t.location)||[...this.l.workspaces.values()].some(a=>this.r.extUri.isEqual(a.location,t.location))||this.r.extUri.isEqual(this.u.emptyWindow?.location,t.location)||[...this.u.workspaces.values()].some(a=>this.r.extUri.isEqual(a.location,t.location)))}C(t,a,s){const c=[...this.profiles,...t],o=[];this.l.profiles=[];for(let y of c)y.isDefault||a.some(E=>y.id===E.id)||(y=s.find(E=>y.id===E.id)??y,y.isTransient?this.l.profiles.push(y):o.push({location:y.location,name:y.name,shortName:y.shortName,useDefaultFlags:y.useDefaultFlags}));this.I(o),this.t=void 0,this.D(t,a,s)}D(t,a,s){this.g.fire({added:t,removed:a,updated:s,all:this.profiles})}F(t,a,s){s=a?.isTransient?!0:s,s||this.F(t,void 0,!0);const c=this.y(t),o=s?this.l:this.u;L.URI.isUri(c)?(o.workspaces.delete(c),a&&o.workspaces.set(c,a)):o.emptyWindow=a,s||this.G()}G(){const t={};for(const[s,c]of this.u.workspaces.entries())t[s.toString()]=c.location.toString();const a=this.u.emptyWindow?.location.toString();this.L({workspaces:t,emptyWindow:a}),this.t=void 0}H(){return[]}I(t){throw new Error("not implemented")}J(){return{}}L(t){throw new Error("not implemented")}M(){}};f.b="userDataProfiles",f.c="profileAssociations",f=pe([K(0,I.IEnvironmentService),K(1,S.IFileService),K(2,d.IUriIdentityService),K(3,C.ILogService)],f),e.UserDataProfilesService=f;class n extends f{constructor(){super(...arguments),this.a=[],this.P={}}H(){return this.a}I(t){this.a=t}J(){return this.P}L(t){this.P=t}}e.InMemoryUserDataProfilesService=n}),define(re[261],ae([0,1,6,2,18]),function(_,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let k=class extends i.Disposable{constructor(P){super(),this.B(new D.RunOnceScheduler(()=>{P.cleanUp()},10*1e3)).schedule()}};k=pe([K(0,R.IUserDataProfilesService)],k),e.UserDataProfilesCleaner=k}),define(re[262],ae([0,1,20,6,21,9,3,2,5,8,154,29,33,42,7,23,24,18]),function(_,e,D,i,R,k,L,P,I,S,b,C,w,p,d,g,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let m=class extends P.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(t,a,s,c,o){super(),this.t=t,this.u=a,this.v=s,this.w=c,this.y=o,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new L.Emitter),this.m=this.B(new L.Emitter),this.n=this.B(new L.Emitter),this.p=this.B(new L.Emitter),this.s=[],this.B((0,P.toDisposable)(()=>{this.j.forEach(({task:y})=>y.cancel()),this.k.forEach(y=>y.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(t){const a=await this.getTargetPlatform();return t.allTargetPlatforms.some(s=>(0,C.isTargetPlatformCompatible)(s,t.allTargetPlatforms,a))}async installFromGallery(t,a={}){try{if(!this.t.isEnabled())throw new C.ExtensionManagementError(b.localize(0,null),C.ExtensionManagementErrorCode.Internal);const s=await this.G(t,!!a.installGivenVersion,!!a.installPreReleaseVersion);return await this.z(s.manifest,s.extension,a)}catch(s){throw f(this.u,"extensionGallery:install",{extensionData:(0,w.getGalleryExtensionTelemetryData)(t),error:s}),this.v.error("Failed to install extension.",t.identifier.id),this.v.error(s),h(s)}}async uninstall(t,a={}){return this.v.trace("ExtensionManagementService#uninstall",t.identifier.id),this.I(t,a)}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.g||t-this.h>1e3*60*5)&&(this.g=this.O(),this.h=t),this.g}registerParticipant(t){this.s.push(t)}async z(t,a,s){const c={...s,installOnlyNewlyAddedFromExtensionPack:S.URI.isUri(a)?s.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:(0,p.isApplicationScopedExtension)(t)?this.y.defaultProfile.extensionsResource:s.profileLocation??this.P()},o=j=>`${w.ExtensionKey.create(j).toString()}${c.profileLocation?`-${c.profileLocation.toString()}`:""}`;if(!S.URI.isUri(a)){const j=this.j.get(o(a));if(j){this.v.info("Extensions is already requested to install",a.identifier.id);const{local:F}=await j.task.waitUntilTaskIsFinished();return F}}const y=[],E=[],T=[],q=this.Q(t,a,c);S.URI.isUri(a)||this.j.set(o(a),{task:q,waitingTasks:[]}),this.l.fire({identifier:q.identifier,source:a,profileLocation:c.profileLocation}),this.v.info("Installing extension:",q.identifier.id),y.push({task:q,manifest:t});let N=!1;try{if(c.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",q.identifier.id);else try{const F=await this.F(q.identifier,t,!!c.installOnlyNewlyAddedFromExtensionPack,!!c.installPreReleaseVersion,c.profileLocation),A=await this.getInstalled(void 0,c.profileLocation);for(const{gallery:U,manifest:B}of F){N=N||!!B.extensionDependencies?.some(Z=>(0,w.areSameExtensions)({id:Z},q.identifier));const G=o(U),W=this.j.get(G);if(W){if(this.C(q,W.task)){this.v.info("Waiting for already requested installing extension",U.identifier.id,q.identifier.id),W.waitingTasks.push(q);const Z=W.task.identifier;E.push(L.Event.toPromise(L.Event.filter(this.onDidInstallExtensions,$=>$.some(z=>(0,w.areSameExtensions)(z.identifier,Z)))).then($=>{if(!$.find(Y=>(0,w.areSameExtensions)(Y.identifier,Z))?.local)throw new Error(`Extension ${Z.id} is not installed`)}))}}else if(!A.some(({identifier:Z})=>(0,w.areSameExtensions)(Z,U.identifier))){const Z=this.Q(B,U,{...c,donotIncludePackAndDependencies:!0});this.j.set(G,{task:Z,waitingTasks:[q]}),this.l.fire({identifier:Z.identifier,source:U,profileLocation:c.profileLocation}),this.v.info("Installing extension:",Z.identifier.id,q.identifier.id),y.push({task:Z,manifest:B})}}}catch(F){if(S.URI.isUri(q.source))(0,D.isNonEmptyArray)(t.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",q.identifier.id,F.message),(0,D.isNonEmptyArray)(t.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",q.identifier.id,F.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",q.identifier.id),F}const j=y.reduce((F,{task:A,manifest:U})=>(F.set(A.identifier.id.toLowerCase(),{task:A,manifest:U}),F),new Map);for(;j.size;){let F;const A=[...j.values()].filter(({manifest:U})=>!U.extensionDependencies?.some(B=>j.has(B.toLowerCase())));A.length?F=j.size===1?A:A.filter(({task:U})=>!(U===q&&!N)):(this.v.info("Found extensions with circular dependencies",A.map(({task:U})=>U.identifier.id)),F=[...j.values()]),await this.D(F.map(async({task:U})=>{const B=new Date().getTime();try{const{local:G}=await U.run();if(await this.D(this.s.map(W=>W.postInstall(G,U.source,c,R.CancellationToken.None))),!S.URI.isUri(U.source)){const W=U.operation===3,Z=W?void 0:(new Date().getTime()-U.source.lastUpdated)/1e3;if(f(this.u,W?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,w.getGalleryExtensionTelemetryData)(U.source),wasVerified:U.wasVerified,duration:new Date().getTime()-B,durationSinceUpdate:Z}),I.isWeb&&U.operation!==3)try{await this.t.reportStatistic(G.manifest.publisher,G.manifest.name,G.manifest.version,"install")}catch{}}T.push({local:G,identifier:U.identifier,operation:U.operation,source:U.source,context:c.context,profileLocation:c.profileLocation,applicationScoped:G.isApplicationScoped})}catch(G){throw S.URI.isUri(U.source)||f(this.u,U.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,w.getGalleryExtensionTelemetryData)(U.source),wasVerified:U.wasVerified,duration:new Date().getTime()-B,error:G}),this.v.error("Error while installing the extension:",U.identifier.id),G}finally{j.delete(U.identifier.id.toLowerCase())}}))}return E.length&&await this.D(E),T.forEach(({identifier:F})=>this.v.info("Extension installed successfully:",F.id)),this.m.fire(T),T.filter(({identifier:F})=>(0,w.areSameExtensions)(F,q.identifier))[0].local}catch(j){if(y.forEach(({task:F})=>F.cancel()),T.length)try{const F=await Promise.allSettled(T.map(({local:A})=>this.R(A,{versionOnly:!0,profileLocation:c.profileLocation}).run()));for(let A=0;A<F.length;A++){const U=F[A],{identifier:B}=T[A];U.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",B.id):this.v.warn("Rollback: Error while uninstalling extension",B.id,(0,k.getErrorMessage)(U.reason))}}catch(F){this.v.warn("Error while rolling back extensions",(0,k.getErrorMessage)(F),T.map(({identifier:A})=>A.id))}throw this.m.fire(y.map(({task:F})=>({identifier:F.identifier,operation:2,source:F.source,context:c.context,profileLocation:c.profileLocation}))),j}finally{for(const[j,{task:F,waitingTasks:A}]of this.j.entries()){const U=A.indexOf(q);U!==-1&&A.splice(U,1),A.length===0&&(F===q||U!==-1)&&this.j.delete(j)}}}C(t,a){for(const[,{task:s,waitingTasks:c}]of this.j.entries())if(s===t&&(c.includes(a)||c.some(o=>this.C(o,a)))||s===a&&c[0]&&!this.C(t,c[0]))return!1;return!0}async D(t){const a=[],s=[],c=await Promise.allSettled(t);for(const o of c)o.status==="fulfilled"?a.push(o.value):s.push(o.reason);if(s.length)throw l(s);return a}async F(t,a,s,c,o){if(!this.t.isEnabled())return[];const y=await this.getInstalled(void 0,o),E=[t],T=[],q=async(N,j)=>{const F=j.extensionDependencies||[],A=[...F];if(j.extensionPack){const U=s?y.find(B=>(0,w.areSameExtensions)(B.identifier,N)):void 0;for(const B of j.extensionPack)U&&U.manifest.extensionPack&&U.manifest.extensionPack.some(G=>(0,w.areSameExtensions)({id:G},{id:B}))||A.every(G=>!(0,w.areSameExtensions)({id:G},{id:B}))&&A.push(B)}if(A.length){const U=[...E,...T.map(G=>G.gallery.identifier)],B=A.filter(G=>U.every(W=>!(0,w.areSameExtensions)(W,{id:G})));if(B.length){const G=await this.t.getExtensions(B.map(W=>({id:W,preRelease:c})),R.CancellationToken.None);for(const W of G){if(U.find(z=>(0,w.areSameExtensions)(z,W.identifier)))continue;const Z=F.some(z=>(0,w.areSameExtensions)({id:z},W.identifier));let $;try{$=await this.G(W,!1,c)}catch(z){if(z instanceof C.ExtensionManagementError&&z.code===C.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!Z){this.v.info("Skipping the packed extension as it cannot be installed",W.identifier.id);continue}else throw z}T.push({gallery:$.extension,manifest:$.manifest}),await q($.extension.identifier,$.manifest)}}}};return await q(t,a),T}async G(t,a,s){if((await this.getExtensionsControlManifest()).malicious.some(E=>(0,w.areSameExtensions)(t.identifier,E)))throw new C.ExtensionManagementError(b.localize(1,null,t.identifier.id),C.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(t)){const E=await this.getTargetPlatform();throw new C.ExtensionManagementError(b.localize(2,null,t.identifier.id,this.w.nameLong,(0,C.TargetPlatformToString)(E)),C.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const o=await this.H(t,a,s);if(o){if(s&&!a&&t.hasPreReleaseVersion&&!o.properties.isPreReleaseVersion)throw new C.ExtensionManagementError(b.localize(3,null,t.identifier.id,this.w.nameLong,this.w.version),C.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!s&&t.properties.isPreReleaseVersion&&(await this.t.getExtensions([t.identifier],R.CancellationToken.None))[0]?new C.ExtensionManagementError(b.localize(4,null,t.identifier.id),C.ExtensionManagementErrorCode.ReleaseVersionNotFound):new C.ExtensionManagementError(b.localize(5,null,t.identifier.id,this.w.nameLong,this.w.version),C.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",o.identifier.id);const y=await this.t.getManifest(o,R.CancellationToken.None);if(y===null)throw new C.ExtensionManagementError(`Missing manifest for extension ${t.identifier.id}`,C.ExtensionManagementErrorCode.Invalid);if(y.version!==o.version)throw new C.ExtensionManagementError(`Cannot install '${t.identifier.id}' extension because of version mismatch in Marketplace`,C.ExtensionManagementErrorCode.Invalid);return{extension:o,manifest:y}}async H(t,a,s){const c=await this.getTargetPlatform();let o=null;return!a&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==s&&(o=(await this.t.getExtensions([{...t.identifier,preRelease:s}],{targetPlatform:c,compatible:!0},R.CancellationToken.None))[0]||null),!o&&await this.t.isExtensionCompatible(t,s,c)&&(o=t),o||(a?o=(await this.t.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:c,compatible:!0},R.CancellationToken.None))[0]||null:o=await this.t.getCompatibleExtension(t,s,c)),o}async I(t,a){const s={...a,profileLocation:t.isApplicationScoped?this.y.defaultProfile.extensionsResource:a.profileLocation??this.P()},c=N=>`${N.id.toLowerCase()}${s.versionOnly?`-${t.manifest.version}`:""}${s.profileLocation?`@${s.profileLocation.toString()}`:""}`,o=this.k.get(c(t.identifier));if(o)return this.v.info("Extensions is already requested to uninstall",t.identifier.id),o.waitUntilTaskIsFinished();const y=N=>{const j=this.R(N,s);return this.k.set(c(j.extension.identifier),j),s.profileLocation?this.v.info("Uninstalling extension from the profile:",`${N.identifier.id}@${N.manifest.version}`,s.profileLocation.toString()):this.v.info("Uninstalling extension:",`${N.identifier.id}@${N.manifest.version}`),this.n.fire({identifier:N.identifier,profileLocation:s.profileLocation,applicationScoped:N.isApplicationScoped}),j},E=(N,j)=>{j?s.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${N.identifier.id}@${N.manifest.version}`,s.profileLocation.toString(),j.message):this.v.error("Failed to uninstall extension:",`${N.identifier.id}@${N.manifest.version}`,j.message):s.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${N.identifier.id}@${N.manifest.version}`,s.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${N.identifier.id}@${N.manifest.version}`),f(this.u,"extensionGallery:uninstall",{extensionData:(0,w.getLocalExtensionTelemetryData)(N),error:j}),this.p.fire({identifier:N.identifier,error:j?.code,profileLocation:s.profileLocation,applicationScoped:N.isApplicationScoped})},T=[],q=[];try{T.push(y(t));const N=await this.getInstalled(1,s.profileLocation);if(s.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const j=this.M(t,N);for(const F of j)this.k.has(c(F.identifier))?this.v.info("Extensions is already requested to uninstall",F.identifier.id):T.push(y(F))}s.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.J(T.map(j=>j.extension),N,t),await this.D(T.map(async j=>{try{if(await j.run(),await this.D(this.s.map(F=>F.postUninstall(j.extension,s,R.CancellationToken.None))),j.extension.identifier.uuid)try{await this.t.reportStatistic(j.extension.manifest.publisher,j.extension.manifest.name,j.extension.manifest.version,"uninstall")}catch{}E(j.extension)}catch(F){const A=F instanceof C.ExtensionManagementError?F:new C.ExtensionManagementError((0,k.getErrorMessage)(F),C.ExtensionManagementErrorCode.Internal);throw E(j.extension,A),A}finally{q.push(j)}}))}catch(N){const j=N instanceof C.ExtensionManagementError?N:new C.ExtensionManagementError((0,k.getErrorMessage)(N),C.ExtensionManagementErrorCode.Internal);for(const F of T){try{F.cancel()}catch{}q.includes(F)||E(F.extension,j)}throw j}finally{for(const N of T)this.k.delete(c(N.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",N.extension.identifier.id)}}J(t,a,s){for(const c of t){const o=this.N(c,a);if(o.length){const y=o.filter(E=>!t.some(T=>(0,w.areSameExtensions)(T.identifier,E.identifier)));if(y.length)throw new Error(this.L(c,y,s))}}}L(t,a,s){return s===t?a.length===1?b.localize(6,null,s.manifest.displayName||s.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?b.localize(7,null,s.manifest.displayName||s.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):b.localize(8,null,s.manifest.displayName||s.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):a.length===1?b.localize(9,null,s.manifest.displayName||s.manifest.name,t.manifest.displayName||t.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?b.localize(10,null,s.manifest.displayName||s.manifest.name,t.manifest.displayName||t.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):b.localize(11,null,s.manifest.displayName||s.manifest.name,t.manifest.displayName||t.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name)}M(t,a,s=[]){if(s.indexOf(t)!==-1)return[];s.push(t);const c=t.manifest.extensionPack?t.manifest.extensionPack:[];if(c.length){const o=a.filter(E=>!E.isBuiltin&&c.some(T=>(0,w.areSameExtensions)({id:T},E.identifier))),y=[];for(const E of o)y.push(...this.M(E,a,s));return[...o,...y]}return[]}N(t,a){return a.filter(s=>s.manifest.extensionDependencies&&s.manifest.extensionDependencies.some(c=>(0,w.areSameExtensions)({id:c},t.identifier)))}async O(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const t=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};m=pe([K(0,C.IExtensionGalleryService),K(1,v.ITelemetryService),K(2,d.ILogService),K(3,g.IProductService),K(4,u.IUserDataProfilesService)],m),e.AbstractExtensionManagementService=m;function l(r){const t=Array.isArray(r)?r:[r];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((a,s)=>new Error(`${a.message}${a.message?",":""}${s instanceof Error?s.message:s}`),new Error(""))}e.joinErrors=l;function h(r){if(r instanceof C.ExtensionManagementError)return r;const t=new C.ExtensionManagementError(r.message,C.ExtensionManagementErrorCode.Internal);return t.stack=r.stack,t}function f(r,t,{extensionData:a,wasVerified:s,duration:c,error:o,durationSinceUpdate:y}){let E,T;o&&(o instanceof C.ExtensionManagementError?(E=o.code,o.code===C.ExtensionManagementErrorCode.Signature&&(T=o.message)):E=C.ExtensionManagementErrorCode.Internal),r.publicLog(t,{...a,wasVerified:s,success:!o,duration:c,errorcode:E,errorcodeDetail:T,durationSinceUpdate:y})}e.reportTelemetry=f;class n{constructor(){this.d=new i.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,i.createCancelablePromise)(t=>this.h(t))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,i.createCancelablePromise)(t=>new Promise((a,s)=>{const c=t.onCancellationRequested(()=>{c.dispose(),s(new k.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=n}),define(re[61],ae([0,1,6,17,2,3,37,8,33,42,14,4,7,18,30]),function(_,e,D,i,R,k,L,P,I,S,b,C,w,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,C.createDecorator)("IExtensionsProfileScannerService");let g=class extends R.Disposable{constructor(m,l,h,f){super(),this.h=m,this.i=l,this.j=h,this.k=f,this.a=this.B(new k.Emitter),this.onAddExtensions=this.a.event,this.b=this.B(new k.Emitter),this.onDidAddExtensions=this.b.event,this.c=this.B(new k.Emitter),this.onRemoveExtensions=this.c.event,this.f=this.B(new k.Emitter),this.onDidRemoveExtensions=this.f.event,this.g=new L.ResourceMap}scanProfileExtensions(m){return this.l(m)}async addExtensionsToProfile(m,l){const h=[],f=[];try{return await this.l(l,n=>{const r=[];for(const t of n)m.some(([a])=>(0,I.areSameExtensions)(a.identifier,t.identifier)&&a.manifest.version!==t.version)?h.push(t):r.push(t);for(const[t,a]of m)if(!r.some(s=>(0,I.areSameExtensions)(s.identifier,t.identifier)&&s.version===t.manifest.version)){const s={identifier:t.identifier,version:t.manifest.version,location:t.location,metadata:a};f.push(s),r.push(s)}return f.length&&this.a.fire({extensions:f,profileLocation:l}),h.length&&this.c.fire({extensions:h,profileLocation:l}),r}),f.length&&this.b.fire({extensions:f,profileLocation:l}),h.length&&this.f.fire({extensions:h,profileLocation:l}),f}catch(n){throw f.length&&this.b.fire({extensions:f,error:n,profileLocation:l}),h.length&&this.f.fire({extensions:h,error:n,profileLocation:l}),n}}async removeExtensionFromProfile(m,l){const h=[];this.c.fire({extensions:h,profileLocation:l});try{await this.l(l,f=>{const n=[];for(const r of f)(0,I.areSameExtensions)(r.identifier,m.identifier)?h.push(r):n.push(r);return h.length&&this.c.fire({extensions:h,profileLocation:l}),n}),h.length&&this.f.fire({extensions:h,profileLocation:l})}catch(f){throw h.length&&this.f.fire({extensions:h,error:f,profileLocation:l}),f}}async l(m,l){return this.p(m).queue(async()=>{let h=[],f;try{const n=await this.h.readFile(m);f=JSON.parse(n.value.toString())}catch(n){if((0,b.toFileOperationResult)(n)!==1)throw n;this.j.extUri.isEqual(m,this.i.defaultProfile.extensionsResource)&&(f=await this.n())}if(f)for(const n of f){if(!n.identifier){this.k.info("Ignoring invalid extension while scanning. Identifier does not exist.",n);continue}if(!n.location){this.k.info("Ignoring invalid extension while scanning. Location does not exist.",n);continue}if(!n.version){this.k.info("Ignoring invalid extension while scanning. Version does not exist.",n);continue}h.push({identifier:n.identifier,location:P.URI.revive(n.location),version:n.version,metadata:n.metadata})}if(l){h=l(h);const n=h.map(r=>({identifier:r.identifier,version:r.version,location:r.location.toJSON(),metadata:r.metadata}));await this.h.writeFile(m,i.VSBuffer.fromString(JSON.stringify(n)))}return h})}async n(){return this.m||(this.m=(async()=>{const m=this.j.extUri.joinPath(this.i.defaultProfile.location,"extensions.json");let l;try{l=(await this.h.readFile(m)).value.toString()}catch(f){if((0,b.toFileOperationResult)(f)===1)return;throw f}this.k.info("Migrating extensions from old default profile location",m.toString());let h;try{const f=JSON.parse(l);Array.isArray(f)&&f.every(n=>!!(n&&typeof n=="object"&&(0,S.isIExtensionIdentifier)(n.identifier)&&v(n.location)&&n.version&&typeof n.version=="string"))?h=f:this.k.warn("Skipping migrating from old default profile locaiton: Found invalid data",f)}catch(f){this.k.error(f)}if(h)try{await this.h.createFile(this.i.defaultProfile.extensionsResource,i.VSBuffer.fromString(JSON.stringify(h)),{overwrite:!1}),this.k.info("Migrated extensions from old default profile location to new location",m.toString(),this.i.defaultProfile.extensionsResource.toString())}catch(f){if((0,b.toFileOperationResult)(f)===3)this.k.info("Migration from old default profile location to new location is done by another window",m.toString(),this.i.defaultProfile.extensionsResource.toString());else throw f}try{await this.h.del(m)}catch(f){(0,b.toFileOperationResult)(f)!==1&&this.k.error(f)}return h})()),this.m}p(m){let l=this.g.get(m);return l||(l=new D.Queue,this.g.set(m,l)),l}};g=pe([K(0,b.IFileService),K(1,p.IUserDataProfilesService),K(2,d.IUriIdentityService),K(3,w.ILogService)],g),e.ExtensionsProfileScannerService=g;function v(u){return u?typeof u.path=="string"&&typeof u.scheme=="string":!1}}),define(re[79],ae([0,1,20,6,32,17,9,35,136,2,25,12,5,22,54,88,15,8,157,13,33,42,70,14,4,7,23,3,67,61,18,30,187,188]),function(_,e,D,i,R,k,L,P,I,S,b,C,w,p,d,g,v,u,m,l,h,f,n,r,t,a,s,c,o,y,E,T,q,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var j;(function(Z){function $(z,Y){if(z===Y)return!0;const ee=Object.keys(z),oe=new Set;for(const J of Object.keys(Y))oe.add(J);if(ee.length!==oe.size)return!1;for(const J of ee){if(z[J]!==Y[J])return!1;oe.delete(J)}return oe.size===0}Z.equals=$})(j=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let F=class extends S.Disposable{constructor($,z,Y,ee,oe,J,Q,O,M,H,V,X){super(),this.systemExtensionsLocation=$,this.userExtensionsLocation=z,this.l=Y,this.m=ee,this.n=oe,this.p=J,this.r=Q,this.s=O,this.t=M,this.u=H,this.v=V,this.w=X,this.g=this.B(new c.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,p.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(B,(0,p.joinPath)(this.m,f.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(B,(0,p.joinPath)(this.m,f.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(U,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,h.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions($,z,Y){const[ee,oe]=await Promise.all([this.scanSystemExtensions($),this.scanUserExtensions(z)]),J=Y?await this.scanExtensionsUnderDevelopment($,[...ee,...oe]):[];return this.D(ee,oe,J,await this.getTargetPlatform(),!0)}async scanSystemExtensions($){const z=[];z.push(this.F(!!$.useCache,$.language)),z.push(this.G($.language,!!$.checkControlFile));const[Y,ee]=await Promise.all(z);return this.C([...Y,...ee],0,$,!1)}async scanUserExtensions($){const z=$.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",z);const Y=await this.I(z,!!$.profileLocation,1,!$.includeUninstalled,$.language);let oe=await($.useCache&&!Y.devMode&&Y.excludeObsolete?this.j:this.k).scanExtensions(Y);return oe=await this.C(oe,1,$,!0),this.s.trace("Scanned user extensions:",oe.length),oe}async scanExtensionsUnderDevelopment($,z){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const Y=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(ee=>ee.scheme===b.Schemas.file).map(async ee=>{const oe=await this.I(ee,!1,1,!0,$.language,!1);return(await this.k.scanOneOrMultipleExtensions(oe)).map(Q=>(Q.type=z.find(O=>(0,h.areSameExtensions)(O.identifier,Q.identifier))?.type??Q.type,this.k.validate(Q,oe)))}))).flat();return this.C(Y,"development",$,!0)}return[]}async scanExistingExtension($,z,Y){const ee=await this.I($,!1,z,!0,Y.language),oe=await this.k.scanExtension(ee);return!oe||!Y.includeInvalid&&!oe.isValid?null:oe}async scanOneOrMultipleExtensions($,z,Y){const ee=await this.I($,!1,z,!0,Y.language),oe=await this.k.scanOneOrMultipleExtensions(ee);return this.C(oe,z,Y,!0)}async scanMetadata($){const z=(0,p.joinPath)($,"package.json"),Y=(await this.r.readFile(z)).value.toString();return JSON.parse(Y).__metadata}async updateMetadata($,z){const Y=(0,p.joinPath)($,"package.json"),ee=(await this.r.readFile(Y)).value.toString(),oe=JSON.parse(ee);z.isMachineScoped=z.isMachineScoped||void 0,z.isBuiltin=z.isBuiltin||void 0,z.installedTimestamp=z.installedTimestamp||void 0,oe.__metadata={...oe.__metadata,...z},await this.r.writeFile((0,p.joinPath)($,"package.json"),k.VSBuffer.fromString(JSON.stringify(oe,null,"	")))}initializeDefaultProfileExtensions(){return this.z||(this.z=(async()=>{try{const $=this.v.extUri.joinPath(this.userExtensionsLocation,".init-default-profile-extensions");if(await this.r.exists($))return;if(!await this.r.exists(this.n.defaultProfile.extensionsResource)&&!await this.r.exists(this.v.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"))){this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const z=await this.scanUserExtensions({includeInvalid:!0});await this.p.addExtensionsToProfile(z.map(Y=>[Y,Y.metadata]),this.n.defaultProfile.extensionsResource),this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}try{await this.r.createFile($,k.VSBuffer.fromString(""))}catch(z){(0,r.toFileOperationResult)(z)!==1&&this.s.warn("Failed to create default profile extensions initialize marker in extensions installation folder.",this.userExtensionsLocation.toString(),(0,L.getErrorMessage)(z))}}catch($){throw this.s.error($),$}})()),this.z}async C($,z,Y,ee){return Y.includeAllVersions||($=this.D(z===0?$:void 0,z===1?$:void 0,z==="development"?$:void 0,await this.getTargetPlatform(),ee)),Y.includeInvalid||($=$.filter(oe=>oe.isValid)),$.sort((oe,J)=>{const Q=C.basename(oe.location.fsPath),O=C.basename(J.location.fsPath);return Q<O?-1:Q>O?1:0})}D($,z,Y,ee,oe){const J=(O,M,H)=>{if(O.isValid&&!M.isValid)return!1;if(O.isValid===M.isValid){if(oe&&d.gt(O.manifest.version,M.manifest.version))return this.s.debug(`Skipping extension ${M.location.path} with lower version ${M.manifest.version} in favour of ${O.location.path} with version ${O.manifest.version}`),!1;if(d.eq(O.manifest.version,M.manifest.version)){if(O.type===0)return this.s.debug(`Skipping extension ${M.location.path} in favour of system extension ${O.location.path} with same version`),!1;if(O.targetPlatform===ee)return this.s.debug(`Skipping extension ${M.location.path} from different target platform ${M.targetPlatform}`),!1}}return H?this.s.warn(`Overwriting user extension ${O.location.path} with ${M.location.path}.`):this.s.debug(`Overwriting user extension ${O.location.path} with ${M.location.path}.`),!0},Q=new Map;return $?.forEach(O=>{const M=f.ExtensionIdentifier.toKey(O.identifier.id),H=Q.get(M);(!H||J(H,O,!1))&&Q.set(M,O)}),z?.forEach(O=>{const M=f.ExtensionIdentifier.toKey(O.identifier.id),H=Q.get(M);if(!H&&$&&O.type===0){this.s.debug(`Skipping obsolete system extension ${O.location.path}.`);return}(!H||J(H,O,!1))&&Q.set(M,O)}),Y?.forEach(O=>{const M=f.ExtensionIdentifier.toKey(O.identifier.id),H=Q.get(M);(!H||J(H,O,!0))&&Q.set(M,O),Q.set(M,O)}),[...Q.values()]}async F($,z){this.s.trace("Started scanning system extensions");const Y=await this.I(this.systemExtensionsLocation,!1,0,!0,z),oe=await($&&!Y.devMode?this.i:this.k).scanExtensions(Y);return this.s.trace("Scanned system extensions:",oe.length),oe}async G($,z){const Y=this.t.isBuilt?[]:this.u.builtInExtensions;if(!Y?.length)return[];this.s.trace("Started scanning dev system extensions");const ee=z?await this.H():{},oe=[],J=u.URI.file(C.normalize(C.join(b.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const O of Y){const M=ee[O.name]||"marketplace";switch(M){case"disabled":break;case"marketplace":oe.push((0,p.joinPath)(J,O.name));break;default:oe.push(u.URI.file(M));break}}const Q=await Promise.all(oe.map(async O=>this.k.scanExtension(await this.I(O,!1,0,!0,$))));return this.s.trace("Scanned dev system extensions:",Q.length),(0,D.coalesce)(Q)}async H(){try{const $=await this.r.readFile(this.l);return JSON.parse($.value.toString())}catch{return{}}}async I($,z,Y,ee,oe,J=!0){const Q=await this.f(oe??w.language),O=await this.J($),M=z&&!this.v.extUri.isEqual($,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,H=M?await this.J(M):void 0;return new A($,O,M,H,z,Y,ee,J,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,oe,Q)}async J($){try{const z=await this.r.stat($);if(typeof z.mtime=="number")return z.mtime}catch{}}};F=pe([K(4,E.IUserDataProfilesService),K(5,y.IExtensionsProfileScannerService),K(6,r.IFileService),K(7,a.ILogService),K(8,l.IEnvironmentService),K(9,s.IProductService),K(10,T.IUriIdentityService),K(11,t.IInstantiationService)],F),e.AbstractExtensionsScannerService=F;class A{constructor($,z,Y,ee,oe,J,Q,O,M,H,V,X,se,x){this.location=$,this.mtime=z,this.applicationExtensionslocation=Y,this.applicationExtensionslocationMtime=ee,this.profile=oe,this.type=J,this.excludeObsolete=Q,this.validate=O,this.productVersion=M,this.productDate=H,this.productCommit=V,this.devMode=X,this.language=se,this.translations=x}static createNlsConfiguration($){return{language:$.language,pseudo:$.language==="pseudo",devMode:$.devMode,translations:$.translations}}static equals($,z){return(0,p.isEqual)($.location,z.location)&&$.mtime===z.mtime&&(0,p.isEqual)($.applicationExtensionslocation,z.applicationExtensionslocation)&&$.applicationExtensionslocationMtime===z.applicationExtensionslocationMtime&&$.profile===z.profile&&$.type===z.type&&$.excludeObsolete===z.excludeObsolete&&$.validate===z.validate&&$.productVersion===z.productVersion&&$.productDate===z.productDate&&$.productCommit===z.productCommit&&$.devMode===z.devMode&&$.language===z.language&&j.equals($.translations,z.translations)}}let U=class extends S.Disposable{constructor($,z,Y,ee,oe){super(),this.f=$,this.g=z,this.h=Y,this.i=ee,this.j=oe}async scanExtensions($){const z=$.profile?await this.l($):await this.k($);let Y={};if($.excludeObsolete&&$.type===1)try{const ee=(await this.i.readFile(this.f)).value.toString();Y=JSON.parse(ee)}catch{}return(0,v.isEmptyObject)(Y)?z:z.filter(ee=>!Y[h.ExtensionKey.create(ee).toString()])}async k($){const z=await this.i.resolve($.location);if(!z.children?.length)return[];const Y=await Promise.all(z.children.map(async ee=>{if(!ee.isDirectory||$.type===1&&(0,p.basename)(ee.resource).indexOf(".")===0)return null;const oe=new A(ee.resource,$.mtime,$.applicationExtensionslocation,$.applicationExtensionslocationMtime,$.profile,$.type,$.excludeObsolete,$.validate,$.productVersion,$.productDate,$.productCommit,$.devMode,$.language,$.translations);return this.scanExtension(oe)}));return(0,D.coalesce)(Y).sort((ee,oe)=>ee.location.path<oe.location.path?-1:1)}async l($){let z=await this.m($.location,()=>!0,$);if($.applicationExtensionslocation&&!this.h.extUri.isEqual($.location,$.applicationExtensionslocation)){z=z.filter(ee=>!ee.metadata?.isApplicationScoped);const Y=await this.m($.applicationExtensionslocation,ee=>!!ee.metadata?.isApplicationScoped,$);z.push(...Y)}return z}async m($,z,Y){const ee=await this.g.scanProfileExtensions($);if(!ee.length)return[];const oe=await Promise.all(ee.map(async J=>{if(z(J)){const Q=new A(J.location,Y.mtime,Y.applicationExtensionslocation,Y.applicationExtensionslocationMtime,Y.profile,Y.type,Y.excludeObsolete,Y.validate,Y.productVersion,Y.productDate,Y.productCommit,Y.devMode,Y.language,Y.translations);return this.scanExtension(Q,J.metadata)}return null}));return(0,D.coalesce)(oe)}async scanOneOrMultipleExtensions($){try{if(await this.i.exists((0,p.joinPath)($.location,"package.json"))){const z=await this.scanExtension($);return z?[z]:[]}else return await this.scanExtensions($)}catch(z){return this.j.error(`Error scanning extensions at ${$.location.path}:`,(0,L.getErrorMessage)(z)),[]}}async scanExtension($,z){try{let Y=await this.scanExtensionManifest($.location);if(Y){Y.publisher||(Y.publisher=f.UNDEFINED_PUBLISHER),z=z??Y.__metadata,delete Y.__metadata;const ee=(0,h.getGalleryExtensionId)(Y.publisher,Y.name),oe=z?.id?{id:ee,uuid:z.id}:{id:ee},J=z?.isSystem?0:$.type,Q=J===0||!!z?.isBuiltin;N.ImplicitActivationEvents.updateManifest(Y),Y=await this.n($.location,Y,A.createNlsConfiguration($));const O={type:J,identifier:oe,manifest:Y,location:$.location,isBuiltin:Q,targetPlatform:z?.targetPlatform??"undefined",metadata:z,isValid:!0,validations:[]};return $.validate?this.validate(O,$):O}}catch(Y){$.type!==0&&this.j.error(Y)}return null}validate($,z){let Y=!0;const ee=(0,n.validateExtensionManifest)(z.productVersion,z.productDate,z.location,$.manifest,$.isBuiltin);for(const[oe,J]of ee)oe===g.default.Error&&(Y=!1,this.j.error(this.t(z.location,J)));return $.isValid=Y,$.validations=ee,$}async scanExtensionManifest($){const z=(0,p.joinPath)($,"package.json");let Y;try{Y=(await this.i.readFile(z)).value.toString()}catch(oe){return(0,r.toFileOperationResult)(oe)!==1&&this.j.error(this.t($,(0,m.localize)(0,null,z.path,oe.message))),null}let ee;try{ee=JSON.parse(Y)}catch{const J=[];(0,P.parse)(Y,J);for(const Q of J)this.j.error(this.t($,(0,m.localize)(1,null,z.path,Q.offset,Q.length,(0,I.getParseErrorMessage)(Q.error))));return null}return(0,P.getNodeType)(ee)!=="object"?(this.j.error(this.t($,(0,m.localize)(2,null,z.path))),null):ee}async n($,z,Y){const ee=await this.p($,z,Y);if(ee)try{const oe=[],J=await this.r(ee.default,oe);if(oe.length>0)return oe.forEach(O=>{this.j.error(this.t($,(0,m.localize)(3,null,ee.default?.path,(0,I.getParseErrorMessage)(O.error))))}),z;if((0,P.getNodeType)(ee)!=="object")return this.j.error(this.t($,(0,m.localize)(4,null,ee.default?.path))),z;const Q=ee.values||Object.create(null);return(0,q.localizeManifest)(z,Q,J)}catch{}return z}async p($,z,Y){const ee=(0,p.joinPath)($,"package.nls.json"),oe=(M,H)=>{H.forEach(V=>{this.j.error(this.t($,(0,m.localize)(5,null,M?.path,(0,I.getParseErrorMessage)(V.error))))})},J=M=>{this.j.error(this.t($,(0,m.localize)(6,null,M?.path)))},Q=`${z.publisher}.${z.name}`,O=Y.translations[Q];if(O)try{const M=u.URI.file(O),H=(await this.i.readFile(M)).value.toString(),V=[],X=(0,P.parse)(H,V);return V.length>0?(oe(M,V),{values:void 0,default:ee}):(0,P.getNodeType)(X)!=="object"?(J(M),{values:void 0,default:ee}):{values:X.contents?X.contents.package:void 0,default:ee}}catch{return{values:void 0,default:ee}}else{if(!await this.i.exists(ee))return;let H;try{H=await this.s($,Y)}catch{return}if(!H.localized)return{values:void 0,default:H.original};try{const V=(await this.i.readFile(H.localized)).value.toString(),X=[],se=(0,P.parse)(V,X);return X.length>0?(oe(H.localized,X),{values:void 0,default:H.original}):(0,P.getNodeType)(se)!=="object"?(J(H.localized),{values:void 0,default:H.original}):{values:se,default:H.original}}catch{return{values:void 0,default:H.original}}}}async r($,z){if($)try{const Y=(await this.i.readFile($)).value.toString();return(0,P.parse)(Y,z)}catch{}}s($,z){return new Promise((Y,ee)=>{const oe=J=>{const Q=(0,p.joinPath)($,`package.nls.${J}.json`);this.i.exists(Q).then(O=>{O&&Y({localized:Q,original:(0,p.joinPath)($,"package.nls.json")});const M=J.lastIndexOf("-");M===-1?Y({localized:(0,p.joinPath)($,"package.nls.json"),original:null}):(J=J.substring(0,M),oe(J))})};if(z.devMode||z.pseudo||!z.language)return Y({localized:(0,p.joinPath)($,"package.nls.json"),original:null});oe(z.language)})}t($,z){return`[${$.path}]: ${z}`}};U=pe([K(1,y.IExtensionsProfileScannerService),K(2,T.IUriIdentityService),K(3,r.IFileService),K(4,a.ILogService)],U);let B=class extends U{constructor($,z,Y,ee,oe,J){super(z,Y,ee,oe,J),this.y=$,this.v=this.B(new i.ThrottledDelayer(3e3)),this.w=this.B(new c.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions($){const z=await this.z();if(this.u=$,z&&z.input&&A.equals(z.input,this.u))return this.v.trigger(()=>this.D()),z.result.map(ee=>(ee.location=u.URI.revive(ee.location),ee));const Y=await super.scanExtensions($);return await this.C({input:$,result:Y}),Y}async z(){try{const $=await this.i.readFile(this.y),z=JSON.parse($.value.toString());return{result:z.result,input:(0,o.revive)(z.input)}}catch($){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,L.getErrorMessage)($))}return null}async C($){try{await this.i.writeFile(this.y,k.VSBuffer.fromString(JSON.stringify($)))}catch(z){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,L.getErrorMessage)(z))}}async D(){if(!this.u)return;const $=await this.z();if(!$)return;const z=$.result,Y=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!R.equals(Y,z))try{await this.i.del(this.y),this.w.fire()}catch(ee){this.j.error(ee)}}};B=pe([K(2,y.IExtensionsProfileScannerService),K(3,T.IUriIdentityService),K(4,r.IFileService),K(5,a.ILogService)],B);function G(Z,$){const z=(0,h.getExtensionId)(Z.manifest.publisher,Z.manifest.name);return{id:z,identifier:new f.ExtensionIdentifier(z),isBuiltin:Z.type===0,isUserBuiltin:Z.type===1&&Z.isBuiltin,isUnderDevelopment:$,extensionLocation:Z.location,uuid:Z.identifier.uuid,targetPlatform:Z.targetPlatform,...Z.manifest}}e.toExtensionDescription=G;class W extends F{constructor($,z,Y,ee,oe,J,Q,O,M,H,V,X){super($,z,(0,p.joinPath)(Y,".vscode-oss-dev","extensions","control.json"),(0,p.joinPath)(ee,f.MANIFEST_CACHE_FOLDER),oe,J,Q,O,M,H,V,X),this.L=(async()=>{if(w.translationsConfigFile)try{const se=await this.r.readFile(u.URI.file(w.translationsConfigFile));return JSON.parse(se.value.toString())}catch{}return Object.create(null)})()}f($){return this.L}}e.NativeExtensionsScannerService=W}),define(re[263],ae([0,1,50,6,38,3,2,25,12,28,7,18]),function(_,e,D,i,R,k,L,P,I,S,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let w=class extends L.Disposable{constructor(d,g){super(),this.b=d,this.f=g,this.a=new i.Limiter(5)}async postUninstall(d){const g=this.g(d,"uninstall");return g&&(this.f.info(d.identifier.id,d.manifest.version,"Running post uninstall script"),await this.a.queue(()=>this.h(g.script,"uninstall",g.args,!0,d).then(()=>this.f.info(d.identifier.id,d.manifest.version,"Finished running post uninstall script"),v=>this.f.error(d.identifier.id,d.manifest.version,`Failed to run post uninstall script: ${v}`)))),S.Promises.rm(this.j(d)).then(void 0,v=>this.f.error("Error while removing extension storage path",v))}g(d,g){const v=`vscode:${g}`;if(d.location.scheme===P.Schemas.file&&d.manifest&&d.manifest.scripts&&typeof d.manifest.scripts[v]=="string"){const u=d.manifest.scripts[v].split(" ");return u.length<2||u[0]!=="node"||!u[1]?(this.f.warn(d.identifier.id,d.manifest.version,`${v} should be a node script`),null):{script:(0,I.join)(d.location.fsPath,u[1]),args:u.slice(2)||[]}}return null}h(d,g,v,u,m){return new Promise((l,h)=>{const f=this.i(d,g,v,m);let n;const r=t=>{n&&(clearTimeout(n),n=null),t?h(t):l(void 0)};f.on("error",t=>{r((0,R.toErrorMessage)(t)||"Unknown")}),f.on("exit",(t,a)=>{r(t?`post-${g} process exited with code ${t}`:void 0)}),u&&(n=setTimeout(()=>{n=null,f.kill(),h("timed out")},5e3))})}i(d,g,v,u){const m={silent:!0,execArgv:void 0},l=(0,D.fork)(d,[`--type=extension-post-${g}`,...v],m);l.stdout.setEncoding("utf8"),l.stderr.setEncoding("utf8");const h=k.Event.fromNodeEventEmitter(l.stdout,"data"),f=k.Event.fromNodeEventEmitter(l.stderr,"data");h(t=>this.f.info(u.identifier.id,u.manifest.version,`post-${g}`,t)),f(t=>this.f.error(u.identifier.id,u.manifest.version,`post-${g}`,t));const n=k.Event.any(k.Event.map(h,t=>({data:`%c${t}`,format:[""]})),k.Event.map(f,t=>({data:`%c${t}`,format:["color: red"]})));return k.Event.debounce(n,(t,a)=>t?{data:t.data+a.data,format:[...t.format,...a.format]}:{data:a.data,format:a.format},100)(t=>{console.group(u.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),l}j(d){return(0,I.join)(this.b.defaultProfile.globalStorageHome.fsPath,d.identifier.id.toLowerCase())}};w=pe([K(0,C.IUserDataProfilesService),K(1,b.ILogService)],w),e.ExtensionsLifecycle=w}),define(re[264],ae([0,1,8,13,61,79,14,4,7,23,30,18]),function(_,e,D,i,R,k,L,P,I,S,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let w=class extends k.NativeExtensionsScannerService{constructor(d,g,v,u,m,l,h,f){super(D.URI.file(m.builtinExtensionsPath),D.URI.file(m.extensionsPath),m.userHome,D.URI.file(m.userDataPath),d,g,v,u,m,l,h,f)}};w=pe([K(0,C.IUserDataProfilesService),K(1,R.IExtensionsProfileScannerService),K(2,L.IFileService),K(3,I.ILogService),K(4,i.INativeEnvironmentService),K(5,S.IProductService),K(6,b.IUriIdentityService),K(7,P.IInstantiationService)],w),e.ExtensionsScannerService=w}),define(re[19],ae([0,1,6,3,2,206,15,69,4,18]),function(_,e,D,i,R,k,L,P,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,I.createDecorator)("storageService");var b;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(b=e.WillSaveStateReason||(e.WillSaveStateReason={}));var C;(function(m){m[m.APPLICATION=-1]="APPLICATION",m[m.PROFILE=0]="PROFILE",m[m.WORKSPACE=1]="WORKSPACE"})(C=e.StorageScope||(e.StorageScope={}));var w;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(w=e.StorageTarget||(e.StorageTarget={}));function p(m){const l=m.get(e.TARGET_KEY);if(l)try{return JSON.parse(l)}catch{}return Object.create(null)}e.loadKeyTargets=p;class d extends R.Disposable{constructor(l={flushInterval:d.a}){super(),this.j=l,this.b=this.B(new i.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new i.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new i.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new D.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new R.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,D.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,R.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,k.mark)("code/willInitStorage");try{await this.J()}finally{(0,k.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(l,h){if(h===e.TARGET_KEY){switch(l){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:l})}else this.b.fire({scope:l,key:h,target:this.F(l)[h]})}r(l){this.f.fire({reason:l})}get(l,h,f){return this.L(h)?.get(l,f)}getBoolean(l,h,f){return this.L(h)?.getBoolean(l,f)}getNumber(l,h,f){return this.L(h)?.getNumber(l,f)}store(l,h,f,n){if((0,L.isUndefinedOrNull)(h)){this.remove(l,f);return}this.t(()=>{this.u(l,f,n),this.L(f)?.set(l,h)})}remove(l,h){this.t(()=>{this.u(l,h,void 0),this.L(h)?.delete(l)})}t(l){this.b.pause(),this.c.pause();try{l()}finally{this.b.resume(),this.c.resume()}}keys(l,h){const f=[],n=this.F(l);for(const r of Object.keys(n))n[r]===h&&f.push(r);return f}u(l,h,f){const n=this.F(h);typeof f=="number"?n[l]!==f&&(n[l]=f,this.L(h)?.set(e.TARGET_KEY,JSON.stringify(n))):typeof n[l]=="number"&&(delete n[l],this.L(h)?.set(e.TARGET_KEY,JSON.stringify(n)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(l){switch(l){case-1:return this.D;case 0:return this.z;default:return this.w}}G(l){const h=this.L(l);return h?p(h):Object.create(null)}isNew(l){return this.getBoolean(e.IS_NEW_KEY,l)===!0}async flush(l=b.NONE){this.f.fire({reason:l});const h=this.L(-1),f=this.L(0),n=this.L(1);switch(l){case b.NONE:await D.Promises.settled([h?.whenFlushed()??Promise.resolve(),f?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve()]);break;case b.SHUTDOWN:await D.Promises.settled([h?.flush(0)??Promise.resolve(),f?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve()]);break}}async log(){const l=this.L(-1)?.items??new Map,h=this.L(0)?.items??new Map,f=this.L(1)?.items??new Map;return u(l,h,f,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(l,h){return this.r(b.NONE),(0,S.isUserDataProfile)(l)?this.N(l,h):this.O(l,h)}H(l,h){return!(l.id===h.id||g(h)&&g(l))}I(l,h,f,n){this.t(()=>{if(n)for(const[r,t]of l)h.set(r,t);else{const r=new Set;for(const[t,a]of l)r.add(t),h.get(t)!==a&&this.n(f,t);for(const[t]of h.items)r.has(t)||this.n(f,t)}})}}e.AbstractStorageService=d,d.a=60*1e3;function g(m){return m.isDefault||!!m.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=g;class v extends d{constructor(){super(),this.p=this.B(new P.Storage(new P.InMemoryStorageDatabase)),this.P=this.B(new P.Storage(new P.InMemoryStorageDatabase)),this.Q=this.B(new P.Storage(new P.InMemoryStorageDatabase)),this.B(this.Q.onDidChangeStorage(l=>this.n(1,l))),this.B(this.P.onDidChangeStorage(l=>this.n(0,l))),this.B(this.p.onDidChangeStorage(l=>this.n(-1,l)))}L(l){switch(l){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(l){switch(l){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(l){return!1}}e.InMemoryStorageService=v;async function u(m,l,h,f,n,r){const t=N=>{try{return JSON.parse(N)}catch{return N}},a=new Map,s=new Map;m.forEach((N,j)=>{a.set(j,N),s.set(j,t(N))});const c=new Map,o=new Map;l.forEach((N,j)=>{c.set(j,N),o.set(j,t(N))});const y=new Map,E=new Map;h.forEach((N,j)=>{y.set(j,N),E.set(j,t(N))}),console.group(f!==n?`Storage: Application (path: ${f})`:`Storage: Application & Profile (path: ${f}, default profile)`);const T=[];if(a.forEach((N,j)=>{T.push({key:j,value:N})}),console.table(T),console.groupEnd(),console.log(s),f!==n){console.group(`Storage: Profile (path: ${n}, profile specific)`);const N=[];c.forEach((j,F)=>{N.push({key:F,value:j})}),console.table(N),console.groupEnd(),console.log(o)}console.group(`Storage: Workspace (path: ${r})`);const q=[];y.forEach((N,j)=>{q.push({key:j,value:N})}),console.table(q),console.groupEnd(),console.log(E)}e.logStorage=u}),define(re[116],ae([0,1,3,2,15,29,33,19]),function(_,e,D,i,R,k,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let I=class extends i.Disposable{constructor(C,w){super(),this.a=new D.Emitter,this.onDidChangeEnablement=this.a.event,this.b=this.B(new S(C)),this.B(this.b.onDidChange(p=>this.a.fire({extensions:p,source:"storage"}))),this.B(w.onDidInstallExtensions(p=>p.forEach(({local:d,operation:g})=>{d&&g===4&&this.f(d.identifier)})))}async enableExtension(C,w){return this.f(C)?(this.a.fire({extensions:[C],source:w}),!0):!1}async disableExtension(C,w){return this.c(C)?(this.a.fire({extensions:[C],source:w}),!0):!1}getDisabledExtensions(){return this.h(k.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(C){const w=this.getDisabledExtensions();return w.every(p=>!(0,L.areSameExtensions)(p,C))?(w.push(C),this.g(w),!0):!1}f(C){const w=this.getDisabledExtensions();for(let p=0;p<w.length;p++){const d=w[p];if((0,L.areSameExtensions)(d,C))return w.splice(p,1),this.g(w),!0}return!1}g(C){this.i(k.DISABLED_EXTENSIONS_STORAGE_PATH,C)}h(C){return this.b.get(C,0)}i(C,w){this.b.set(C,w,0)}};I=pe([K(0,P.IStorageService),K(1,k.IExtensionManagementService)],I),e.GlobalExtensionEnablementService=I;class S extends i.Disposable{constructor(C){super(),this.c=C,this.a=Object.create(null),this.b=this.B(new D.Emitter),this.onDidChange=this.b.event,this.B(C.onDidChangeValue(w=>this.f(w)))}get(C,w){let p;return w===0?((0,R.isUndefinedOrNull)(this.a[C])&&(this.a[C]=this.g(C,w)),p=this.a[C]):p=this.g(C,w),JSON.parse(p)}set(C,w,p){const d=JSON.stringify(w.map(({id:v,uuid:u})=>({id:v,uuid:u})));this.g(C,p)!==d&&(p===0&&(w.length?this.a[C]=d:delete this.a[C]),this.h(C,w.length?d:void 0,p))}f(C){if(C.scope===0&&!(0,R.isUndefinedOrNull)(this.a[C.key])&&this.g(C.key,C.scope)!==this.a[C.key]){const p=this.get(C.key,C.scope);delete this.a[C.key];const d=this.get(C.key,C.scope),g=p.filter(u=>!d.some(m=>(0,L.areSameExtensions)(u,m))),v=d.filter(u=>!p.some(m=>(0,L.areSameExtensions)(m,u)));(g.length||v.length)&&this.b.fire([...g,...v])}}g(C,w){return this.c.get(C,w,"[]")}h(C,w,p){w?this.c.store(C,w,p,1):this.c.remove(C,p)}}e.StorageManager=S}),define(re[265],ae([0,1,20,21,9,5,36,15,8,16,13,29,33,70,14,7,23,47,236,19,24]),function(_,e,D,i,R,k,L,P,I,S,b,C,w,p,d,g,v,u,m,l,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const f=k.isWeb?"web":(0,C.getTargetPlatform)(k.platform,L.arch);var n;(function(O){O[O.None=0]="None",O[O.IncludeVersions=1]="IncludeVersions",O[O.IncludeFiles=2]="IncludeFiles",O[O.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",O[O.IncludeSharedAccounts=8]="IncludeSharedAccounts",O[O.IncludeVersionProperties=16]="IncludeVersionProperties",O[O.ExcludeNonValidated=32]="ExcludeNonValidated",O[O.IncludeInstallationTargets=64]="IncludeInstallationTargets",O[O.IncludeAssetUri=128]="IncludeAssetUri",O[O.IncludeStatistics=256]="IncludeStatistics",O[O.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",O[O.Unpublished=4096]="Unpublished",O[O.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function r(...O){return String(O.reduce((M,H)=>M|H,0))}var t;(function(O){O[O.Tag=1]="Tag",O[O.ExtensionId=4]="ExtensionId",O[O.Category=5]="Category",O[O.ExtensionName=7]="ExtensionName",O[O.Target=8]="Target",O[O.Featured=9]="Featured",O[O.SearchText=10]="SearchText",O[O.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},s={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},o={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class y{constructor(M=o){this.d=M}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(M,H=this.d.pageSize){return new y({...this.d,pageNumber:M,pageSize:H})}withFilter(M,...H){const V=[...this.d.criteria,...H.length?H.map(X=>({filterType:M,value:X})):[{filterType:M}]];return new y({...this.d,criteria:V})}withSortBy(M){return new y({...this.d,sortBy:M})}withSortOrder(M){return new y({...this.d,sortOrder:M})}withFlags(...M){return new y({...this.d,flags:M.reduce((H,V)=>H|V,0)})}withAssetTypes(...M){return new y({...this.d,assetTypes:M})}withSource(M){return new y({...this.d,source:M})}get raw(){const{criteria:M,pageNumber:H,pageSize:V,sortBy:X,sortOrder:se,flags:x,assetTypes:ie}=this.d;return{filters:[{criteria:M,pageNumber:H,pageSize:V,sortBy:X,sortOrder:se}],assetTypes:ie,flags:x}}get searchText(){const M=this.d.criteria.filter(H=>H.filterType===t.SearchText)[0];return M&&M.value?M.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(M=>String(M.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function E(O,M){const H=(O||[]).filter(V=>V.statisticName===M)[0];return H?H.value:0}function T(O){const M="Microsoft.VisualStudio.Code.Translation.";return O.files.filter(V=>V.assetType.indexOf(M)===0).reduce((V,X)=>{const se=j(O,X.assetType);return se&&V.push([X.assetType.substring(M.length),se]),V},[])}function q(O){if(O.properties){const M=O.properties.filter(X=>X.key===a.Repository),H=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),V=M.filter(X=>H.test(X.value))[0];return V?{uri:V.value,fallbackUri:V.value}:null}return j(O,a.Repository)}function N(O){return{uri:`${O.fallbackAssetUri}/${a.VSIX}?redirect=true${O.targetPlatform?`&targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${a.VSIX}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}}function j(O,M){return O.files.filter(V=>V.assetType===M)[0]?{uri:`${O.assetUri}/${M}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${M}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}:null}function F(O,M){const H=O.properties?O.properties.filter(X=>X.key===M):[],V=H.length>0&&H[0].value;return V?V.split(",").map(X=>(0,w.adoptToGalleryExtensionId)(X)):[]}function A(O){const M=O.properties?O.properties.filter(H=>H.key===s.Engine):[];return M.length>0&&M[0].value||""}function U(O){const M=O.properties?O.properties.filter(H=>H.key===s.PreRelease):[];return M.length>0&&M[0].value==="true"}function B(O){const M=O.properties?O.properties.filter(V=>V.key===s.LocalizedLanguages):[],H=M.length>0&&M[0].value||"";return H?H.split(","):[]}function G(O){return O.properties?.find(M=>M.key===s.SponsorLink)?.value}function W(O){return O.indexOf("preview")!==-1}function Z(O){return O.targetPlatform?(0,C.toTargetPlatform)(O.targetPlatform):"undefined"}function $(O){const M=(0,D.distinct)(O.versions.map(Z)),H=!!O.tags?.includes(C.WEB_EXTENSION_TAG),V=M.indexOf("web");return H?V===-1&&M.push("web"):V!==-1&&M.splice(V,1),M}function z(O,M){const H=(0,C.getFallbackTargetPlarforms)(M);for(let V=0;V<O.length;V++){const X=O[V];if(X.version===O[V-1]?.version){let se=V;const x=Z(X);if(x===M)for(;se>0&&O[se-1].version===X.version;)se--;else if(H.includes(x))for(;se>0&&O[se-1].version===X.version&&Z(O[se-1])!==M;)se--;se!==V&&(O.splice(V,1),O.splice(se,0,X))}}return O}e.sortExtensionVersions=z;function Y(O,M,H){O.telemetryData={index:M,querySource:H}}function ee(O,M,H){const V=O.versions[0],X={manifest:j(M,a.Manifest),readme:j(M,a.Details),changelog:j(M,a.Changelog),license:j(M,a.License),repository:q(M),download:N(M),icon:j(M,a.Icon),signature:j(M,a.Signature),coreTranslations:T(M)};return{identifier:{id:(0,w.getGalleryExtensionId)(O.publisher.publisherName,O.extensionName),uuid:O.extensionId},name:O.extensionName,version:M.version,displayName:O.displayName,publisherId:O.publisher.publisherId,publisher:O.publisher.publisherName,publisherDisplayName:O.publisher.displayName,publisherDomain:O.publisher.domain?{link:O.publisher.domain,verified:!!O.publisher.isDomainVerified}:void 0,publisherSponsorLink:G(V),description:O.shortDescription||"",installCount:E(O.statistics,"install"),rating:E(O.statistics,"averagerating"),ratingCount:E(O.statistics,"ratingcount"),categories:O.categories||[],tags:O.tags||[],releaseDate:Date.parse(O.releaseDate),lastUpdated:Date.parse(O.lastUpdated),allTargetPlatforms:H,assets:X,properties:{dependencies:F(M,s.Dependency),extensionPack:F(M,s.ExtensionPack),engine:A(M),localizedLanguages:B(M),targetPlatform:Z(M),isPreReleaseVersion:U(M)},hasPreReleaseVersion:U(V),hasReleaseVersion:!0,preview:W(O.flags),isSigned:!!X.signature}}let oe=class{constructor(M,H,V,X,se,x,ie,ne){this.k=H,this.l=V,this.n=X,this.o=se,this.q=x,this.u=ie,this.w=ne;const le=ie.extensionsGallery,ue=le?.servicePPEUrl&&ne.getValue("_extensionsGallery.enablePPE");this.d=ue?le.servicePPEUrl:le?.serviceUrl,this.g=ue?void 0:le?.searchUrl,this.h=le?.controlUrl,this.j=(0,m.resolveMarketplaceHeaders)(ie.version,ie,this.n,this.w,this.q,M,this.o)}x(M=""){return`${this.d}${M}`}isEnabled(){return!!this.d}async getExtensions(M,H,V){const X=i.CancellationToken.isCancellationToken(H)?{}:H,se=i.CancellationToken.isCancellationToken(H)?H:V,x=[],ie=[],ne=[],le=[];let ue=!0;for(const be of M){be.uuid?ie.push(be.uuid):x.push(be.id);const Ee=!!(be.version||be.preRelease);ne.push({id:be.id,uuid:be.uuid,includePreRelease:Ee}),be.version&&le.push({id:be.id,uuid:be.uuid,version:be.version}),ue=ue&&!!be.hasPreRelease&&!Ee}if(!ie.length&&!x.length)return[];let ye=new y().withPage(1,M.length);ie.length&&(ye=ye.withFilter(t.ExtensionId,...ie)),x.length&&(ye=ye.withFilter(t.ExtensionName,...x)),(X.queryAllVersions||ue)&&(ye=ye.withFlags(ye.flags,n.IncludeVersions)),X.source&&(ye=ye.withSource(X.source));const{extensions:Se}=await this.z(ye,{targetPlatform:X.targetPlatform??f,includePreRelease:ne,versions:le,compatible:!!X.compatible},se);return X.source&&Se.forEach((be,Ee)=>Y(be,Ee,X.source)),Se}async getCompatibleExtension(M,H,V){if((0,C.isNotWebExtensionInWebTargetPlatform)(M.allTargetPlatforms,V))return null;if(await this.isExtensionCompatible(M,H,V))return M;const X=new y().withFlags(n.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,M.identifier.uuid),{extensions:se}=await this.z(X,{targetPlatform:V,compatible:!0,includePreRelease:H},i.CancellationToken.None);return se[0]||null}async isExtensionCompatible(M,H,V){if(!(0,C.isTargetPlatformCompatible)(M.properties.targetPlatform,M.allTargetPlatforms,V)||!H&&M.properties.isPreReleaseVersion)return!1;let X=M.properties.engine;if(!X){const se=await this.getManifest(M,i.CancellationToken.None);if(!se)throw new Error("Manifest was not found");X=se.engines.vscode}return(0,p.isEngineValid)(X,this.u.version,this.u.date)}async y(M,H,V,X,se){if(!(0,C.isTargetPlatformCompatible)(Z(M),X,se)||H!=="any"&&U(M)!==(H==="prerelease"))return!1;if(V)try{const x=await this.E(M);if(!(0,p.isEngineValid)(x,this.u.version,this.u.date))return!1}catch(x){return this.l.error(`Error while getting the engine for the version ${M.version}.`,(0,R.getErrorMessage)(x)),!1}return!0}async query(M,H){let V=M.text||"";const X=M.pageSize??50;let se=new y().withPage(1,X);V?(V=V.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,ye,Se)=>(se=se.withFilter(t.Category,Se||ye),"")),V=V.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,ye,Se)=>(se=se.withFilter(t.Tag,Se||ye),"")),V=V.replace(/\bfeatured(\s+|\b|$)/g,()=>(se=se.withFilter(t.Featured),"")),V=V.trim(),V&&(V=V.length<200?V:V.substring(0,200),se=se.withFilter(t.SearchText,V)),se=se.withSortBy(0)):M.ids?se=se.withFilter(t.ExtensionId,...M.ids):M.names?se=se.withFilter(t.ExtensionName,...M.names):se=se.withSortBy(4),typeof M.sortBy=="number"&&(se=se.withSortBy(M.sortBy)),typeof M.sortOrder=="number"&&(se=se.withSortOrder(M.sortOrder)),M.source&&(se=se.withSource(M.source));const x=async(ue,ye)=>{const{extensions:Se,total:be}=await this.z(ue,{targetPlatform:f,compatible:!1,includePreRelease:!!M.includePreRelease},ye);return Se.forEach((Ee,Ne)=>Y(Ee,(ue.pageNumber-1)*ue.pageSize+Ne,M.source)),{extensions:Se,total:be}},{extensions:ie,total:ne}=await x(se,H),le=async(ue,ye)=>{if(ye.isCancellationRequested)throw new R.CancellationError;const{extensions:Se}=await x(se.withPage(ue+1),ye);return Se};return{firstPage:ie,total:ne,pageSize:se.pageSize,getPage:le}}async z(M,H,V){const X=M.flags;!!(M.flags&n.IncludeLatestVersionOnly)&&!!(M.flags&n.IncludeVersions)&&(M=M.withFlags(M.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(M.flags&n.IncludeLatestVersionOnly)&&!(M.flags&n.IncludeVersions)&&(M=M.withFlags(M.flags,n.IncludeLatestVersionOnly)),H.versions?.length&&(M=M.withFlags(M.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),M=M.withFlags(M.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:se,total:x}=await this.B(M,V);if(!(M.flags&n.IncludeLatestVersionOnly)){const ue=[];for(const ye of se){const Se=await this.A(ye,H);Se&&ue.push(Se)}return{extensions:ue,total:x}}const ne=[],le=new Map;for(let ue=0;ue<se.length;ue++){const ye=se[ue],Se={id:(0,w.getGalleryExtensionId)(ye.publisher.publisherName,ye.extensionName),uuid:ye.extensionId},be=(0,P.isBoolean)(H.includePreRelease)?H.includePreRelease:!!H.includePreRelease.find(Ne=>(0,w.areSameExtensions)(Ne,Se))?.includePreRelease;if(H.compatible&&(0,C.isNotWebExtensionInWebTargetPlatform)($(ye),H.targetPlatform))continue;const Ee=await this.A(ye,H);!Ee||Ee.properties.isPreReleaseVersion&&(!be||!Ee.hasReleaseVersion)||!Ee.properties.isPreReleaseVersion&&Ee.properties.targetPlatform!==H.targetPlatform&&Ee.hasPreReleaseVersion?le.set(ye.extensionId,ue):ne.push([ue,Ee])}if(le.size){const ue=new Date().getTime(),ye=new y().withFlags(X&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,le.size).withFilter(t.ExtensionId,...le.keys()),{extensions:Se}=await this.z(ye,H,V);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ue,count:le.size});for(const be of Se){const Ee=le.get(be.identifier.uuid);ne.push([Ee,be])}}return{extensions:ne.sort((ue,ye)=>ue[0]-ye[0]).map(([,ue])=>ue),total:x}}async A(M,H){const V={id:(0,w.getGalleryExtensionId)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},X=H.versions?.find(ne=>(0,w.areSameExtensions)(ne,V))?.version,se=(0,P.isBoolean)(H.includePreRelease)?H.includePreRelease:!!H.includePreRelease.find(ne=>(0,w.areSameExtensions)(ne,V))?.includePreRelease,x=$(M),ie=z(M.versions,H.targetPlatform);if(H.compatible&&(0,C.isNotWebExtensionInWebTargetPlatform)(x,H.targetPlatform))return null;for(let ne=0;ne<ie.length;ne++){const le=ie[ne];if(!(X&&le.version!==X)){if(await this.y(le,se?"any":"release",H.compatible,x,H.targetPlatform))return ee(M,le,x);if(X&&le.version===X)return null}}return X||H.compatible?null:ee(M,M.versions[0],x)}async B(M,H){if(!this.isEnabled())throw new Error("No extension gallery service configured.");M=M.withFlags(M.flags,n.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,r(n.Unpublished));const V=await this.j,X=JSON.stringify(M.raw),se={...V,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(X.length)},x=new Date().getTime();let ie,ne,le=0;try{if(ie=await this.k.request({type:"POST",url:this.g&&M.criteria.some(ye=>ye.filterType===t.SearchText)?this.g:this.x("/extensionquery"),data:X,headers:se},H),ie.res.statusCode&&ie.res.statusCode>=400&&ie.res.statusCode<500)return{galleryExtensions:[],total:le};const ue=await(0,u.asJson)(ie);if(ue){const ye=ue.results[0],Se=ye.extensions,be=ye.resultMetadata&&ye.resultMetadata.filter(Ee=>Ee.metadataType==="ResultCount")[0];return le=be&&be.metadataItems.filter(Ee=>Ee.name==="TotalCount")[0].count||0,{galleryExtensions:Se,total:le}}return{galleryExtensions:[],total:le}}catch(ue){throw ne=ue,ue}finally{this.o.publicLog2("galleryService:query",{...M.telemetryData,requestBodySize:String(X.length),duration:new Date().getTime()-x,success:!!ie&&(0,u.isSuccess)(ie),responseBodySize:ie?.res.headers["Content-Length"],statusCode:ie?String(ie.res.statusCode):void 0,errorCode:ne?(0,R.isCancellationError)(ne)?"canceled":(0,R.getErrorMessage)(ne).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(le)})}}async reportStatistic(M,H,V,X){if(!this.isEnabled())return;const se=k.isWeb?this.x(`/itemName/${M}.${H}/version/${V}/statType/${X==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${M}/extensions/${H}/${V}/stats?statType=${X}`),x=k.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ne={...await this.j,Accept:x};try{await this.k.request({type:"POST",url:se,headers:ne},i.CancellationToken.None)}catch{}}async download(M,H,V){this.l.trace("ExtensionGalleryService#download",M.identifier.id);const X=(0,w.getGalleryExtensionTelemetryData)(M),se=new Date().getTime(),x=ue=>this.o.publicLog("galleryService:downloadVSIX",{...X,duration:ue}),ie=V===2?"install":V===3?"update":"",ne=ie?{uri:`${M.assets.download.uri}${I.URI.parse(M.assets.download.uri).query?"&":"?"}${ie}=true`,fallbackUri:`${M.assets.download.fallbackUri}${I.URI.parse(M.assets.download.fallbackUri).query?"&":"?"}${ie}=true`}:M.assets.download,le=await this.D(ne);await this.q.writeFile(H,le.stream),x(new Date().getTime()-se)}async downloadSignatureArchive(M,H){if(!M.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",M.identifier.id);const V=await this.D(M.assets.signature);await this.q.writeFile(H,V.stream)}async getReadme(M,H){if(M.assets.readme){const V=await this.D(M.assets.readme,{},H);return await(0,u.asTextOrError)(V)||""}return""}async getManifest(M,H){if(M.assets.manifest){const V=await this.D(M.assets.manifest,{},H),X=await(0,u.asTextOrError)(V);return X?JSON.parse(X):null}return null}async C(M,H){const V=j(M,a.Manifest);if(!V)throw new Error("Manifest was not found");const X={"Accept-Encoding":"gzip"},se=await this.D(V,{headers:X});return await(0,u.asJson)(se)}async getCoreTranslation(M,H){const V=M.assets.coreTranslations.filter(X=>X[0]===H.toUpperCase())[0];if(V){const X=await this.D(V[1]),se=await(0,u.asTextOrError)(X);return se?JSON.parse(se):null}return null}async getChangelog(M,H){if(M.assets.changelog){const V=await this.D(M.assets.changelog,{},H);return await(0,u.asTextOrError)(V)||""}return""}async getAllCompatibleVersions(M,H,V){let X=new y().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);M.identifier.uuid?X=X.withFilter(t.ExtensionId,M.identifier.uuid):X=X.withFilter(t.ExtensionName,M.identifier.id);const{galleryExtensions:se}=await this.B(X,i.CancellationToken.None);if(!se.length)return[];const x=$(se[0]);if((0,C.isNotWebExtensionInWebTargetPlatform)(x,V))return[];const ie=[];await Promise.all(se[0].versions.map(async ue=>{try{await this.y(ue,H?"any":"release",!0,x,V)&&ie.push(ue)}catch{}}));const ne=[],le=new Set;for(const ue of z(ie,V))le.has(ue.version)||(le.add(ue.version),ne.push({version:ue.version,date:ue.lastUpdated,isPreReleaseVersion:U(ue)}));return ne}async D(M,H={},V=i.CancellationToken.None){const X=await this.j,se={type:"GET"},x={...X,...H.headers||{}};H={...H,...se,headers:x};const ie=M.uri,ne=M.fallbackUri,le={...H,url:ie};try{const ue=await this.k.request(le,V);if(ue.res.statusCode===200)return ue;const ye=await(0,u.asTextOrError)(ue);throw new Error(`Expected 200, got back ${ue.res.statusCode} instead.

${ye}`)}catch(ue){if((0,R.isCancellationError)(ue))throw ue;const ye=(0,R.getErrorMessage)(ue);this.o.publicLog2("galleryService:cdnFallback",{url:ie,message:ye});const Se={...H,url:ne};return this.k.request(Se,V)}}async E(M){let H=A(M);if(!H){const V=await this.C(M,i.CancellationToken.None);if(!V)throw new Error("Manifest was not found");H=V.engines.vscode}return H}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const M=await this.k.request({type:"GET",url:this.h},i.CancellationToken.None);if(M.res.statusCode!==200)throw new Error("Could not get extensions report.");const H=await(0,u.asJson)(M),V=[],X={};if(H){for(const se of H.malicious)V.push({id:se});if(H.migrateToPreRelease)for(const[se,x]of Object.entries(H.migrateToPreRelease))(!x.engine||(0,p.isEngineValid)(x.engine,this.u.version,this.u.date))&&(X[se.toLowerCase()]={disallowInstall:!0,extension:{id:x.id,displayName:x.displayName,autoMigrate:{storage:!!x.migrateStorage},preRelease:!0}});if(H.deprecated)for(const[se,x]of Object.entries(H.deprecated))x&&(X[se.toLowerCase()]=(0,P.isBoolean)(x)?{}:x)}return{malicious:V,deprecated:X}}};oe=pe([K(1,u.IRequestService),K(2,g.ILogService),K(3,b.IEnvironmentService),K(4,h.ITelemetryService),K(5,d.IFileService),K(6,v.IProductService),K(7,S.IConfigurationService)],oe);let J=class extends oe{constructor(M,H,V,X,se,x,ie,ne){super(M,H,V,X,se,x,ie,ne)}};J=pe([K(0,l.IStorageService),K(1,u.IRequestService),K(2,g.ILogService),K(3,b.IEnvironmentService),K(4,h.ITelemetryService),K(5,d.IFileService),K(6,v.IProductService),K(7,S.IConfigurationService)],J),e.ExtensionGalleryService=J;let Q=class extends oe{constructor(M,H,V,X,se,x,ie){super(void 0,M,H,V,X,se,x,ie)}};Q=pe([K(0,u.IRequestService),K(1,g.ILogService),K(2,b.IEnvironmentService),K(3,h.ITelemetryService),K(4,d.IFileService),K(5,v.IProductService),K(6,S.IConfigurationService)],Q),e.ExtensionGalleryServiceWithNoStorageService=Q}),define(re[80],ae([0,1,4,3,2,19,33,23,20,7,15]),function(_,e,D,i,R,k,L,P,I,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,D.createDecorator)("IExtensionStorageService");const C=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let w=class Ze extends R.Disposable{static b(d){return`extensionKeys/${(0,L.adoptToGalleryExtensionId)(d.id)}@${d.version}`}static c(d){const g=C.exec(d);if(g&&g[1])return{id:g[1],version:g[2]}}static async removeOutdatedExtensionVersions(d,g){const v=await d.getInstalled(),u=[];for(const[m,l]of Ze.f(g)){const h=v.find(f=>(0,L.areSameExtensions)(f.identifier,{id:m}))?.manifest.version;for(const f of l)h!==f&&u.push(Ze.b({id:m,version:f}))}for(const m of u)g.remove(m,0)}static f(d){const g=new Map,v=d.keys(0,1);for(const u of v){const m=Ze.c(u);if(m){let l=g.get(m.id.toLowerCase());l||g.set(m.id.toLowerCase(),l=[]),l.push(m.version)}}return g}constructor(d,g,v){super(),this.i=d,this.j=g,this.k=v,this.g=this.B(new i.Emitter),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=Ze.f(d),this.B(this.i.onDidChangeValue(u=>this.l(u)))}l(d){if(d.scope!==0)return;if(this.h.has(d.key.toLowerCase())){this.g.fire();return}const g=Ze.c(d.key);if(g){if(this.i.get(d.key,0)===void 0)this.h.delete(g.id.toLowerCase());else{let v=this.h.get(g.id.toLowerCase());v||this.h.set(g.id.toLowerCase(),v=[]),v.push(g.version),this.g.fire()}return}}m(d){if((0,b.isString)(d))return d;const g=d.manifest?d.manifest.publisher:d.publisher,v=d.manifest?d.manifest.name:d.name;return(0,L.getExtensionId)(g,v)}getExtensionState(d,g){const v=this.m(d),u=this.getExtensionStateRaw(d,g);if(u)try{return JSON.parse(u)}catch(m){this.k.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${v}, global: ${g}): ${m}`)}}getExtensionStateRaw(d,g){const v=this.m(d),u=this.i.get(v,g?0:1);return u&&u?.length>Ze.a&&this.k.warn(`[mainThreadStorage] large extension state detected (extensionId: ${v}, global: ${g}): ${u.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),u}setExtensionState(d,g,v){const u=this.m(d);g===void 0?this.i.remove(u,v?0:1):this.i.store(u,JSON.stringify(g),v?0:1,1)}setKeysForSync(d,g){this.i.store(Ze.b(d),JSON.stringify(g),0,1)}getKeysForSync(d){const g=this.j.extensionSyncedKeys?.[d.id.toLowerCase()],v=this.i.get(Ze.b(d),0),u=v?JSON.parse(v):void 0;return u&&g?(0,I.distinct)([...u,...g]):u||g}addToMigrationList(d,g){if(d!==g){const v=this.n.filter(u=>!u.includes(d)&&!u.includes(g));v.push([d,g]),this.n=v}}getSourceExtensionToMigrate(d){const g=this.n.find(([,v])=>d===v);return g?g[0]:void 0}get n(){const d=this.i.get("extensionStorage.migrationList",-1,"[]");try{const g=JSON.parse(d);if(Array.isArray(g))return g}catch{}return[]}set n(d){d.length?this.i.store("extensionStorage.migrationList",JSON.stringify(d),-1,1):this.i.remove("extensionStorage.migrationList",-1)}};w.a=512*1024,w=pe([K(0,k.IStorageService),K(1,P.IProductService),K(2,S.ILogService)],w),e.ExtensionStorageService=w}),define(re[266],ae([0,1,20,6,3,12,5,36,8,158,13,29,33,226,98,14,7,58,23,47,19,24]),function(_,e,D,i,R,k,L,P,I,S,b,C,w,p,d,g,v,u,m,l,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const n="extensionTips/promptedExecutableTips",r="extensionTips/lastPromptedMediumImpExeTime";let t=class extends p.ExtensionTipsService{constructor(s,c,o,y,E,T,q,N,j,F){super(q,N,j,F),this.r=s,this.s=c,this.t=o,this.u=y,this.v=E,this.w=T,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Map,this.p=new Map,N.exeBasedExtensionTips&&Object.entries(N.exeBasedExtensionTips).forEach(([A,U])=>{const B=[],G=[],W=[];Object.entries(U.recommendations).forEach(([Z,$])=>{$.important?U.important?B.push({extensionId:Z,extensionName:$.name,isExtensionPack:!!$.isExtensionPack}):G.push({extensionId:Z,extensionName:$.name,isExtensionPack:!!$.isExtensionPack}):W.push({extensionId:Z,extensionName:$.name,isExtensionPack:!!$.isExtensionPack})}),B.length&&this.k.set(A,{exeFriendlyName:U.friendlyName,windowsPath:U.windowsPath,recommendations:B}),G.length&&this.l.set(A,{exeFriendlyName:U.friendlyName,windowsPath:U.windowsPath,recommendations:G}),W.length&&this.m.set(A,{exeFriendlyName:U.friendlyName,windowsPath:U.windowsPath,recommendations:W})}),(0,i.timeout)(3e3).then(async()=>{await this.y(),this.C(),this.D()})}async getImportantExecutableBasedTips(){const s=await this.M(this.k),c=await this.M(this.l);return[...s,...c]}getOtherExecutableBasedTips(){return this.M(this.m)}async y(){const s=await this.M(this.k),c=await this.M(this.l),o=await this.t.getInstalled();this.n=this.z(s,o),this.p=this.z(c,o)}z(s,c){const o=new Map;s.forEach(N=>o.set(N.extensionId.toLowerCase(),N));const{installed:y,uninstalled:E}=this.L([...o.keys()],c);for(const N of y){const j=o.get(N);j&&this.s.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:N,exeName:j.exeName})}for(const N of E){const j=o.get(N);j&&this.s.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:N,exeName:j.exeName})}const T=this.I(),q=new Map;for(const N of E){const j=o.get(N);if(j&&(!T[j.exeName]||!T[j.exeName].includes(j.extensionId))){let F=q.get(j.exeName);F||(F=[],q.set(j.exeName,F)),F.push(j)}}return q}C(){if(this.n.size===0)return;const[s,c]=[...this.n.entries()][0];this.F(c).then(o=>{switch(o){case"reacted":this.J(c[0].exeName,c);break;case"ignored":this.n.delete(s);break;case"incompatibleWindow":{const y=R.Event.once(R.Event.latch(R.Event.any(this.v.onDidOpenWindow,this.v.onDidFocusWindow)));this.B(y(()=>this.C()));break}case"toomany":{const y=this.B((0,i.disposableTimeout)(()=>{y.dispose(),this.C()},36e5));break}}})}D(){if(this.p.size===0)return;const s=this.G(),c=Date.now()-s,o=7*24*60*60*1e3;if(c<o){const T=this.B((0,i.disposableTimeout)(()=>{T.dispose(),this.D()},o-c));return}const[y,E]=[...this.p.entries()][0];this.F(E).then(T=>{switch(T){case"reacted":{this.H(Date.now()),this.p.delete(y),this.J(E[0].exeName,E);const q=this.B((0,i.disposableTimeout)(()=>{q.dispose(),this.D()},o));break}case"ignored":this.p.delete(y),this.D();break;case"incompatibleWindow":{const q=R.Event.once(R.Event.latch(R.Event.any(this.v.onDidOpenWindow,this.v.onDidFocusWindow)));this.B(q(()=>this.D()));break}case"toomany":{const q=this.B((0,i.disposableTimeout)(()=>{q.dispose(),this.D()},36e5));break}}})}async F(s){const c=await this.t.getInstalled(1),o=s.filter(E=>!E.whenNotInstalled||E.whenNotInstalled.every(T=>c.every(q=>!(0,w.areSameExtensions)(q.identifier,{id:T})))).map(({extensionId:E})=>E.toLowerCase()),y=(0,S.localize)(0,null,s[0].exeFriendlyName);return this.w.promptImportantExtensionsInstallNotification(o,y,`@exe:"${s[0].exeName}"`,3)}G(){let s=this.u.getNumber(r,-1);return s||(s=Date.now(),this.H(s)),s}H(s){this.u.store(r,s,-1,1)}I(){return JSON.parse(this.u.get(n,-1,"{}"))}J(s,c){const o=this.I();o[s]=c.map(({extensionId:y})=>y.toLowerCase()),this.u.store(n,JSON.stringify(o),-1,0)}L(s,c){const o=[],y=[],E=c.reduce((T,q)=>(T.add(q.identifier.id.toLowerCase()),T),new Set);return s.forEach(T=>{E.has(T.toLowerCase())?o.push(T):y.push(T)}),{installed:o,uninstalled:y}}async M(s){const c=[],o=new Map;for(const y of s.keys()){const E=s.get(y);if(!E||!(0,D.isNonEmptyArray)(E.recommendations))continue;const T=[];L.isWindows?E.windowsPath&&T.push(E.windowsPath.replace("%USERPROFILE%",P.env.USERPROFILE).replace("%ProgramFiles(x86)%",P.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",P.env.ProgramFiles).replace("%APPDATA%",P.env.APPDATA).replace("%WINDIR%",P.env.WINDIR)):(T.push((0,k.join)("/usr/local/bin",y)),T.push((0,k.join)("/usr/bin",y)),T.push((0,k.join)(this.r.userHome.fsPath,y)));for(const q of T){let N=o.get(q);if(N===void 0&&(N=await this.b.exists(I.URI.file(q)),o.set(q,N)),N)for(const{extensionId:j,extensionName:F,isExtensionPack:A,whenNotInstalled:U}of E.recommendations)c.push({extensionId:j,extensionName:F,isExtensionPack:A,exeName:y,exeFriendlyName:E.exeFriendlyName,windowsPath:E.windowsPath,whenNotInstalled:U})}}return c}};t=pe([K(0,b.INativeEnvironmentService),K(1,f.ITelemetryService),K(2,C.IExtensionManagementService),K(3,h.IStorageService),K(4,u.INativeHostService),K(5,d.IExtensionRecommendationNotificationService),K(6,g.IFileService),K(7,m.IProductService),K(8,l.IRequestService),K(9,v.ILogService)],t),e.ExtensionTipsService=t}),define(re[267],ae([0,1,6,2,22,69,19,76,18]),function(_,e,D,i,R,k,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class S extends L.AbstractStorageService{constructor(C,w,p,d){super(),this.X=C,this.Y=w,this.Z=p,this.ab=d,this.p=this.Y.defaultProfile,this.s=this.bb(),this.P=this.Y.currentProfile,this.Q=this.B(new i.DisposableStore),this.R=this.cb(this.P),this.S=this.X?.id,this.U=this.B(new i.DisposableStore),this.W=this.db(this.X)}bb(){const C=this.B(new P.ApplicationStorageDatabaseClient(this.Z.getChannel("storage"))),w=this.B(new k.Storage(C));return this.B(w.onDidChangeStorage(p=>this.n(-1,p))),w}cb(C){this.Q.clear(),this.P=C;let w;if((0,L.isProfileUsingDefaultStorage)(C))w=this.s;else{const p=this.Q.add(new P.ProfileStorageDatabaseClient(this.Z.getChannel("storage"),C));w=this.Q.add(new k.Storage(p))}return this.Q.add(w.onDidChangeStorage(p=>this.n(0,p))),w}db(C){this.U.clear(),this.S=C?.id;let w;if(C){const p=this.U.add(new P.WorkspaceStorageDatabaseClient(this.Z.getChannel("storage"),C));w=this.U.add(new k.Storage(p)),this.U.add(w.onDidChangeStorage(d=>this.n(1,d)))}return w}async J(){await D.Promises.settled([this.s.init(),this.R.init(),this.W?.init()??Promise.resolve()])}L(C){switch(C){case-1:return this.s;case 0:return this.R;default:return this.W}}M(C){switch(C){case-1:return this.p.globalStorageHome.fsPath;case 0:return this.P?.globalStorageHome.fsPath;default:return this.S?`${(0,R.joinPath)(this.ab.workspaceStorageHome,this.S,"state.vscdb").fsPath}`:void 0}}async close(){this.m(),this.r(L.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.s.close(),this.R.close(),this.W?.close()??Promise.resolve()])}async N(C,w){if(!this.H(this.P,C))return;const p=this.R,d=p.items;p!==this.s&&await p.close(),this.R=this.cb(C),await this.R.init(),this.I(d,this.R,0,w)}async O(C,w){const p=this.W,d=p?.items??new Map;await p?.close(),this.W=this.db(C),await this.W.init(),this.I(d,this.W,1,w)}hasScope(C){return(0,I.isUserDataProfile)(C)?this.P.id===C.id:this.S===C.id}}e.NativeStorageService=S}),define(re[62],ae([0,1,2,69,4,19]),function(_,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUserDataProfileStorageService=e.IUserDataProfileStorageService=void 0,e.IUserDataProfileStorageService=(0,R.createDecorator)("IUserDataProfileStorageService");let L=class extends D.Disposable{constructor(S){super(),this.a=S}async readStorageData(S){return this.withProfileScopedStorageService(S,async b=>this.b(b))}async updateStorageData(S,b,C){return this.withProfileScopedStorageService(S,async w=>this.c(w,b,C))}async withProfileScopedStorageService(S,b){if(this.a.hasScope(S))return b(this.a);const C=await this.createStorageDatabase(S),w=new P(C);try{await w.initialize();const p=await b(w);return await w.flush(),p}finally{w.dispose(),await this.f(C)}}b(S){const b=new Map,C=w=>{for(const p of S.keys(0,w))b.set(p,{value:S.get(p,0),target:w})};return C(0),C(1),b}c(S,b,C){for(const[w,p]of b)S.store(w,p,0,C)}async f(S){try{await S.close()}finally{(0,D.isDisposable)(S)&&S.dispose()}}};L=pe([K(0,k.IStorageService)],L),e.AbstractUserDataProfileStorageService=L;class P extends k.AbstractStorageService{constructor(S){super({flushInterval:100}),this.p=this.B(new i.Storage(S))}J(){return this.p.init()}L(S){return S===0?this.p:void 0}M(){}async N(){}async O(){}hasScope(){return!1}}}),define(re[268],ae([0,1,3,2,22,13,57,18]),function(_,e,D,i,R,k,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesNativeService=void 0;let I=class extends i.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this.b}constructor(b,C,w){super(),this.b=[],this.c=this.B(new D.Emitter),this.onDidChangeProfiles=this.c.event,this.f=!0,this.a=C.getChannel("userDataProfiles"),this.profilesHome=(0,R.joinPath)(w.userRoamingDataHome,"profiles"),this.b=b.map(p=>(0,P.reviveProfile)(p,this.profilesHome.scheme)),this.B(this.a.listen("onDidChangeProfiles")(p=>{const d=p.added.map(u=>(0,P.reviveProfile)(u,this.profilesHome.scheme)),g=p.removed.map(u=>(0,P.reviveProfile)(u,this.profilesHome.scheme)),v=p.updated.map(u=>(0,P.reviveProfile)(u,this.profilesHome.scheme));this.b=p.all.map(u=>(0,P.reviveProfile)(u,this.profilesHome.scheme)),this.c.fire({added:d,removed:g,updated:v,all:this.profiles})})),this.onDidResetWorkspaces=this.a.listen("onDidResetWorkspaces")}setEnablement(b){this.f=b}isEnabled(){return this.f}async createNamedProfile(b,C,w){const p=await this.a.call("createNamedProfile",[b,C,w]);return(0,P.reviveProfile)(p,this.profilesHome.scheme)}async createProfile(b,C,w,p){const d=await this.a.call("createProfile",[b,C,w,p]);return(0,P.reviveProfile)(d,this.profilesHome.scheme)}async createTransientProfile(b){const C=await this.a.call("createTransientProfile",[b]);return(0,P.reviveProfile)(C,this.profilesHome.scheme)}async setProfileForWorkspace(b,C){await this.a.call("setProfileForWorkspace",[b,C])}removeProfile(b){return this.a.call("removeProfile",[b])}async updateProfile(b,C){const w=await this.a.call("updateProfile",[b,C]);return(0,P.reviveProfile)(w,this.profilesHome.scheme)}resetWorkspaces(){return this.a.call("resetWorkspaces")}cleanUp(){return this.a.call("cleanUp")}cleanUpTransientProfiles(){return this.a.call("cleanUpTransientProfiles")}};I=pe([K(1,L.IMainProcessService),K(2,k.IEnvironmentService)],I),e.UserDataProfilesNativeService=I}),define(re[269],ae([0,1,3,2,57,7,62,19,76,18,71]),function(_,e,D,i,R,k,L,P,I,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfileStorageService=void 0;let C=class extends L.AbstractUserDataProfileStorageService{constructor(p,d,g,v){super(g),this.h=p;const u=p.getChannel("profileStorageListener"),m=this.B(new i.MutableDisposable);this.g=this.B(new D.Emitter({onWillAddFirstListener:()=>{m.value=u.listen("onDidChange")(l=>{v.trace("profile storage changes",l),this.g.fire({targetChanges:l.targetChanges.map(h=>(0,S.reviveProfile)(h,d.profilesHome.scheme)),valueChanges:l.valueChanges.map(h=>({...h,profile:(0,S.reviveProfile)(h.profile,d.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>m.value=void 0})),this.onDidChange=this.g.event}async createStorageDatabase(p){const d=this.h.getChannel("storage");return(0,P.isProfileUsingDefaultStorage)(p)?new I.ApplicationStorageDatabaseClient(d):new I.ProfileStorageDatabaseClient(d,p)}};C=pe([K(0,R.IMainProcessService),K(1,S.IUserDataProfilesService),K(2,P.IStorageService),K(3,k.ILogService)],C),e.UserDataProfileStorageService=C,(0,b.registerSingleton)(L.IUserDataProfileStorageService,C,1)}),define(re[41],ae([0,1,20,6,17,21,3,35,2,27,15,174,16,13,14,7,45,19,24,30,26,18]),function(_,e,D,i,R,k,L,P,I,S,b,C,w,p,d,g,v,u,m,l,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.getSyncResourceLogLabel=e.isSyncData=e.isRemoteUserData=void 0;function n(y){return!!(y&&y.ref!==void 0&&typeof y.ref=="string"&&y.ref!==""&&y.syncData!==void 0&&(y.syncData===null||r(y.syncData)))}e.isRemoteUserData=n;function r(y){return!!(y&&y.version!==void 0&&typeof y.version=="number"&&y.content!==void 0&&typeof y.content=="string"&&(Object.keys(y).length===2||Object.keys(y).length===3&&y.machineId!==void 0&&typeof y.machineId=="string"))}e.isSyncData=r;function t(y,E){return`${(0,S.uppercaseFirstLetter)(y)}${E.isDefault?"":` (${E.name})`}`}e.getSyncResourceLogLabel=t;let a=class extends I.Disposable{get status(){return this.k}get conflicts(){return{...this.syncResource,conflicts:this.m}}constructor(E,T,q,N,j,F,A,U,B,G,W,Z){super(),this.syncResource=E,this.collection=T,this.C=q,this.D=N,this.F=j,this.G=F,this.H=A,this.I=U,this.J=B,this.L=G,this.M=W,this.c=null,this.k="idle",this.l=this.B(new L.Emitter),this.onDidChangeStatus=this.l.event,this.m=[],this.n=this.B(new L.Emitter),this.onDidChangeConflicts=this.n.event,this.s=new i.ThrottledDelayer(50),this.t=this.B(new L.Emitter),this.onDidChangeLocal=this.t.event,this.v=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.w=!1,this.z={},this.resource=this.syncResource.syncResource,this.y=t(E.syncResource,E.profile),this.h=Z.extUri,this.f=this.h.joinPath(N.userDataSyncHome,...(0,h.getPathSegments)(E.profile.isDefault?void 0:E.profile.id,E.syncResource)),this.g=this.h.joinPath(this.f,h.PREVIEW_DIR_NAME),this.u=(0,h.getLastSyncResourceUri)(E.profile.isDefault?void 0:E.profile.id,E.syncResource,N,this.h),this.j=(0,v.getServiceMachineId)(N,q,j)}triggerLocalChange(){this.s.trigger(()=>this.N())}async N(){if(this.status==="hasConflicts"){this.L.info(`${this.y}: In conflicts state and local change detected. Syncing again...`);const E=await this.c;this.c=null;const T=await this.S(E.remoteUserData,E.lastSyncUserData,!0,this.lb());this.O(T)}else{this.L.trace(`${this.y}: Checking for local changes...`);const E=await this.getLastSyncUserData();(E?await this.rb(E):!0)&&this.t.fire()}}O(E){this.k!==E&&(this.k=E,this.l.fire(E))}async sync(E,T={}){await this.P(E,!0,this.lb(),T)}async preview(E,T,q={}){return this.P(E,!1,T,q)}async apply(E,T={}){try{this.z={...T};const q=await this.X(E);return this.O(q),this.c}finally{this.z={}}}async P(E,T,q,N){try{if(this.z={...N},this.status==="hasConflicts")return this.L.info(`${this.y}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.L.info(`${this.y}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.L.trace(`${this.y}: Started synchronizing ${this.resource.toLowerCase()}...`),this.O("syncing");let j="idle";try{const F=await this.getLastSyncUserData(),A=await this.R(E,F);return j=await this.S(A,F,T,q),j==="hasConflicts"?this.L.info(`${this.y}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):j==="idle"&&this.L.trace(`${this.y}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.O(j)}}finally{this.z={}}}async replace(E){const T=this.hb(E);if(!T)return!1;await this.stop();try{this.L.trace(`${this.y}: Started resetting ${this.resource.toLowerCase()}...`),this.O("syncing");const q=await this.getLastSyncUserData(),N=await this.R(null,q),j=await this.Q(N),F=await this.nb({ref:N.ref,syncData:T},q,j,this.lb(),k.CancellationToken.None),A=[];for(const U of F){const B=await this.pb(U,U.remoteResource,void 0,k.CancellationToken.None),{remoteChange:G}=await this.pb(U,U.previewResource,U.remoteContent,k.CancellationToken.None);A.push([U,{...B,remoteChange:G!==0?G:2}])}await this.qb(N,q,A,!1),this.L.info(`${this.y}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.O("idle")}return!0}async Q(E){const T=await this.j;return!!E.syncData?.machineId&&E.syncData.machineId===T}async R(E,T){if(T){const q=E?E[this.resource]:void 0;if(T.ref===q||q===void 0&&T.syncData===null)return T}return this.getRemoteUserData(T)}async S(E,T,q,N){if(E.syncData&&E.syncData.version>this.mb)throw this.J.publicLog2("sync/incompatible",{source:this.resource}),new h.UserDataSyncError((0,C.localize)(0,null,this.resource,this.mb,E.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.U(E,T,q,N)}catch(j){if(j instanceof h.UserDataSyncError)switch(j.code){case"LocalPreconditionFailed":return this.L.info(`${this.y}: Failed to synchronize ${this.y} as there is a new local version available. Synchronizing again...`),this.S(E,T,q,N);case"Conflict":case"PreconditionFailed":return this.L.info(`${this.y}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),E=await this.getRemoteUserData(null),T=await this.getLastSyncUserData(),this.S(E,T,q,N)}throw j}}async U(E,T,q,N){try{const j=await this.Q(E),F=!j&&T===null&&this.db()!==void 0,A=q&&!F;this.c||(this.c=(0,i.createCancelablePromise)(B=>this.bb(E,T,j,A,N,B)));let U=await this.c;if(q&&F){this.L.info(`${this.y}: Accepting remote because it was synced before and the last sync data is not available.`);for(const B of U.resourcePreviews)U=await this.accept(B.remoteResource)||U}return this.Z(U.resourcePreviews),U.resourcePreviews.some(({mergeState:B})=>B==="conflict")?"hasConflicts":q?await this.X(!1):"syncing"}catch(j){throw this.c=null,j}}async merge(E){return await this.W(E,async T=>{const q=await this.ob(T,k.CancellationToken.None);await this.C.writeFile(T.previewResource,R.VSBuffer.fromString(q?.content||""));const N=q&&!q.hasConflicts?await this.pb(T,T.previewResource,void 0,k.CancellationToken.None):void 0;return T.acceptResult=N,T.mergeState=q.hasConflicts?"conflict":N?"accepted":"preview",T.localChange=N?N.localChange:q.localChange,T.remoteChange=N?N.remoteChange:q.remoteChange,T}),this.c}async accept(E,T){return await this.W(E,async q=>{const N=await this.pb(q,E,T,k.CancellationToken.None);return q.acceptResult=N,q.mergeState="accepted",q.localChange=N.localChange,q.remoteChange=N.remoteChange,q}),this.c}async discard(E){return await this.W(E,async T=>{const q=await this.ob(T,k.CancellationToken.None);return await this.C.writeFile(T.previewResource,R.VSBuffer.fromString(q.content||"")),T.acceptResult=void 0,T.mergeState="preview",T.localChange=q.localChange,T.remoteChange=q.remoteChange,T}),this.c}async W(E,T){if(!this.c)return;let q=await this.c;const N=q.resourcePreviews.findIndex(({localResource:j,remoteResource:F,previewResource:A})=>this.h.isEqual(j,E)||this.h.isEqual(F,E)||this.h.isEqual(A,E));N!==-1&&(this.c=(0,i.createCancelablePromise)(async j=>{const F=[...q.resourcePreviews];return F[N]=await T(F[N]),{...q,resourcePreviews:F}}),q=await this.c,this.Z(q.resourcePreviews),q.resourcePreviews.some(({mergeState:j})=>j==="conflict")?this.O("hasConflicts"):this.O("syncing"))}async X(E){if(!this.c)return"idle";const T=await this.c;return T.resourcePreviews.some(({mergeState:q})=>q==="conflict")?"hasConflicts":T.resourcePreviews.some(({mergeState:q})=>q!=="accepted")?"syncing":(await this.qb(T.remoteUserData,T.lastSyncUserData,T.resourcePreviews.map(q=>[q,q.acceptResult]),E),this.c=null,await this.Y(),"idle")}async Y(){try{await this.C.del(this.g,{recursive:!0})}catch{}}Z(E){const T=E.filter(({mergeState:q})=>q==="conflict");(0,D.equals)(this.m,T,(q,N)=>this.h.isEqual(q.previewResource,N.previewResource))||(this.m=T,this.n.fire(this.conflicts))}async hasPreviouslySynced(){const E=await this.getLastSyncUserData();return!!E&&E.syncData!==null}async ab(E){const T=this.c?await this.c:null;if(T)for(const q of T.resourcePreviews){if(this.h.isEqual(q.acceptedResource,E))return q.acceptResult?q.acceptResult.content:null;if(this.h.isEqual(q.remoteResource,E))return q.remoteContent;if(this.h.isEqual(q.localResource,E))return q.localContent;if(this.h.isEqual(q.baseResource,E))return q.baseContent}return null}async resetLocal(){this.F.remove(this.v,-1);try{await this.C.del(this.u)}catch(E){this.L.error(E)}}async bb(E,T,q,N,j,F){const A=await this.nb(E,T,q,j,F),U=[];for(const B of A){const G=B.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(B.localChange===0&&B.remoteChange===0)U.push({...B,acceptedResource:G,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const W=N?await this.ob(B,F):void 0;if(F.isCancellationRequested)break;await this.C.writeFile(B.previewResource,R.VSBuffer.fromString(W?.content||""));const Z=W&&!W.hasConflicts?await this.pb(B,B.previewResource,void 0,F):void 0;U.push({...B,acceptResult:Z,mergeState:W?.hasConflicts?"conflict":Z?"accepted":"preview",localChange:Z?Z.localChange:W?W.localChange:B.localChange,remoteChange:Z?Z.remoteChange:W?W.remoteChange:B.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:E,lastSyncUserData:T,resourcePreviews:U,isLastSyncFromCurrentMachine:q}}async getLastSyncUserData(){let E=this.db();if(E||(E=await this.gb()),!E)return this.L.info(`${this.y}: Last sync data state does not exist.`),null;const T=JSON.parse(E),q=this.I.getResourceSyncStateVersion(this.resource);if(this.w=!!T.version&&!!q&&T.version!==q,this.w)return this.L.info(`${this.y}: Reset last sync state because last sync state version ${T.version} is not compatible with current sync state version ${q}.`),await this.resetLocal(),null;let N,j=1;for(;N===void 0&&j++<6;)try{const F=await this.eb();F&&(F.ref===T.ref?N=F.syncData:this.L.info(`${this.y}: Last sync data stored locally is not same as the last sync state.`));break}catch(F){if(F instanceof d.FileOperationError&&F.fileOperationResult===1){this.L.info(`${this.y}: Last sync resource does not exist locally.`);break}else{if(F instanceof h.UserDataSyncError)throw F;this.L.error(F,j)}}if(N===void 0)try{const F=await this.G.resolveResourceContent(this.resource,T.ref,this.collection,this.z);N=F===null?null:this.hb(F),await this.fb({ref:T.ref,syncData:N})}catch(F){if(F instanceof h.UserDataSyncError&&F.code==="NotFound")this.L.info(`${this.y}: Last sync resource does not exist remotely.`);else throw F}return N===void 0?null:{...T,syncData:N}}async cb(E,T={}){if(T.ref||T.version)throw new Error("Cannot have core properties as additional");const q=this.I.getResourceSyncStateVersion(this.resource),N={ref:E.ref,version:q,...T};this.F.store(this.v,JSON.stringify(N),-1,1),await this.fb(E)}db(){return this.F.get(this.v,-1)}async eb(){const E=(await this.C.readFile(this.u)).value.toString();try{const T=E?JSON.parse(E):void 0;if(n(T))return T}catch(T){this.L.error(T)}}async fb(E){await this.C.writeFile(this.u,R.VSBuffer.fromString(JSON.stringify(E)))}async gb(){try{const E=await this.C.readFile(this.u),T=JSON.parse(E.value.toString());await this.C.del(this.u),T.ref&&T.content!==void 0&&(this.F.store(this.v,JSON.stringify({...T,content:void 0}),-1,1),await this.fb({ref:T.ref,syncData:T.content===null?null:JSON.parse(T.content)}))}catch(E){E instanceof d.FileOperationError&&E.fileOperationResult===1?this.L.debug(`${this.y}: Migrating last sync user data. Resource does not exist.`):this.L.error(E)}return this.F.get(this.v,-1)}async getRemoteUserData(E){const{ref:T,content:q}=await this.ib(E);let N=null;return q!==null&&(N=this.hb(q)),{ref:T,syncData:N}}hb(E){try{const T=JSON.parse(E);if(r(T))return T}catch(T){this.L.error(T)}throw new h.UserDataSyncError((0,C.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async ib(E){const T=E?{ref:E.ref,content:E.syncData?JSON.stringify(E.syncData):null}:null;return this.G.readResource(this.resource,T,this.collection,this.z)}async jb(E,T){const q=await this.j,N={version:this.mb,machineId:q,content:E};try{return T=await this.G.writeResource(this.resource,JSON.stringify(N),T,this.collection,this.z),{ref:T,syncData:N}}catch(j){throw j instanceof h.UserDataSyncError&&j.code==="TooLarge"&&(j=new h.UserDataSyncError(j.message,j.code,this.resource)),j}}async kb(E){const T={version:this.mb,content:E};return this.H.backup(this.syncResource.profile,this.resource,JSON.stringify(T))}async stop(){this.status!=="idle"&&(this.L.trace(`${this.y}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.Z([]),await this.Y(),this.O("idle"),this.L.info(`${this.y}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}lb(){return this.M.getValue(h.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};a=pe([K(2,d.IFileService),K(3,p.IEnvironmentService),K(4,u.IStorageService),K(5,h.IUserDataSyncStoreService),K(6,h.IUserDataSyncBackupStoreService),K(7,h.IUserDataSyncEnablementService),K(8,m.ITelemetryService),K(9,h.IUserDataSyncLogService),K(10,w.IConfigurationService),K(11,l.IUriIdentityService)],a),e.AbstractSynchroniser=a;let s=class extends a{constructor(E,T,q,N,j,F,A,U,B,G,W,Z,$){super(T,q,N,j,F,A,U,B,G,W,Z,$),this.i=E,this.B(this.C.watch(this.h.dirname(E))),this.B(this.C.onDidFilesChange(z=>this.tb(z)))}async p(){try{return await this.C.readFile(this.i)}catch{return null}}async r(E,T,q){try{T?await this.C.writeFile(this.i,R.VSBuffer.fromString(E),q?void 0:T):await this.C.createFile(this.i,R.VSBuffer.fromString(E),{overwrite:q})}catch(N){throw N instanceof d.FileOperationError&&N.fileOperationResult===1||N instanceof d.FileOperationError&&N.fileOperationResult===3?new h.UserDataSyncError(N.message,"LocalPreconditionFailed"):N}}async sb(){try{await this.C.del(this.i)}catch(E){if(!(E instanceof d.FileOperationError&&E.fileOperationResult===1))throw E}}tb(E){!E.contains(this.i)||this.triggerLocalChange()}};s=pe([K(3,d.IFileService),K(4,p.IEnvironmentService),K(5,u.IStorageService),K(6,h.IUserDataSyncStoreService),K(7,h.IUserDataSyncBackupStoreService),K(8,h.IUserDataSyncEnablementService),K(9,m.ITelemetryService),K(10,h.IUserDataSyncLogService),K(11,w.IConfigurationService),K(12,l.IUriIdentityService)],s),e.AbstractFileSynchroniser=s;let c=class extends s{constructor(E,T,q,N,j,F,A,U,B,G,W,Z,$,z){super(E,T,q,N,j,F,A,U,B,G,W,$,z),this.ub=Z,this.wb=void 0}vb(E,T){const q=[],N=(0,P.parse)(E,q,{allowEmptyContent:!0,allowTrailingComma:!0});return q.length>0||!(0,b.isUndefined)(N)&&T!==Array.isArray(N)}xb(){return this.wb||(this.wb=this.ub.resolveFormattingOptions(this.i)),this.wb}};c=pe([K(3,d.IFileService),K(4,p.IEnvironmentService),K(5,u.IStorageService),K(6,h.IUserDataSyncStoreService),K(7,h.IUserDataSyncBackupStoreService),K(8,h.IUserDataSyncEnablementService),K(9,m.ITelemetryService),K(10,h.IUserDataSyncLogService),K(11,h.IUserDataSyncUtilService),K(12,w.IConfigurationService),K(13,l.IUriIdentityService)],c),e.AbstractJsonFileSynchroniser=c;let o=class{constructor(E,T,q,N,j,F,A){this.resource=E,this.g=T,this.h=q,this.j=N,this.k=j,this.l=F,this.d=A.extUri,this.f=(0,h.getLastSyncResourceUri)(void 0,this.resource,q,this.d)}async initialize({ref:E,content:T}){if(!T){this.j.info("Remote content does not exist.",this.resource);return}const q=this.m(T);if(!!q)try{await this.doInitialize({ref:E,syncData:q})}catch(N){this.j.error(N)}}m(E){try{const T=JSON.parse(E);if(r(T))return T}catch(T){this.j.error(T)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(E,T={}){if(T.ref||T.version)throw new Error("Cannot have core properties as additional");const q={ref:E.ref,version:void 0,...T};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(q),-1,1),await this.k.writeFile(this.f,R.VSBuffer.fromString(JSON.stringify(E)))}};o=pe([K(1,f.IUserDataProfilesService),K(2,p.IEnvironmentService),K(3,g.ILogService),K(4,d.IFileService),K(5,u.IStorageService),K(6,l.IUriIdentityService)],o),e.AbstractInitializer=o}),define(re[117],ae([0,1,6,21,9,3,43,2,27,16,13,116,29,33,80,14,4,72,7,19,24,30,18,41,252,114,26,62]),function(_,e,D,i,R,k,L,P,I,S,b,C,w,p,d,g,v,u,m,l,h,f,n,r,t,a,s,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.LocalExtensionsProvider=e.ExtensionsSynchroniser=e.stringify=e.parseExtensions=void 0;async function o(j,F){const A=JSON.parse(j.content);if(j.version===1||j.version===2){const U=(await F.getInstalled(0)).filter(B=>B.isBuiltin);for(const B of A)j.version===1&&(B.enabled===!1&&(B.disabled=!0),delete B.enabled),j.version===2&&U.every(G=>!(0,p.areSameExtensions)(G.identifier,B.identifier))&&(B.installed=!0)}return A}function y(j){return JSON.parse(j.content)}e.parseExtensions=y;function E(j,F){return j.sort((A,U)=>!A.identifier.uuid&&U.identifier.uuid?-1:A.identifier.uuid&&!U.identifier.uuid?1:(0,I.compare)(A.identifier.id,U.identifier.id)),F?(0,L.toFormattedString)(j,{}):JSON.stringify(j)}e.stringify=E;let T=class extends r.AbstractSynchroniser{constructor(F,A,U,B,G,W,Z,$,z,Y,ee,oe,J,Q,O,M,H){super({syncResource:"extensions",profile:F},A,B,U,G,W,Z,oe,J,Y,ee,O),this.yb=$,this.zb=z,this.Ab=H,this.mb=5,this.sb=this.h.joinPath(this.g,"extensions.json"),this.tb=this.sb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"base"}),this.ub=this.sb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"local"}),this.vb=this.sb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.wb=this.sb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.xb=this.Ab.createInstance(q),this.B(k.Event.any(k.Event.filter(this.yb.onDidInstallExtensions,V=>V.some(({local:X})=>!!X)),k.Event.filter(this.yb.onDidUninstallExtension,V=>!V.error),k.Event.filter(M.onDidChange,V=>V.valueChanges.some(({profile:X,changes:se})=>this.syncResource.profile.id===X.id&&se.some(x=>x.key===w.DISABLED_EXTENSIONS_STORAGE_PATH))),Q.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async nb(F,A){const U=F.syncData?await o(F.syncData,this.yb):null,B=A?.skippedExtensions||[],G=A?.builtinExtensions||[],W=A?.syncData?await o(A.syncData,this.yb):null,{localExtensions:Z,ignoredExtensions:$}=await this.xb.getLocalExtensions(this.syncResource.profile);U?this.L.trace(`${this.y}: Merging remote extensions with local extensions...`):this.L.trace(`${this.y}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:z,remote:Y}=(0,t.merge)(Z,U,W,B,$,G),ee={local:z,remote:Y,content:this.Db(Z,z.added,z.updated,z.removed),localChange:z.added.length>0||z.removed.length>0||z.updated.length>0?2:0,remoteChange:Y!==null?2:0},oe=this.Jb(Z,!1);return[{skippedExtensions:B,builtinExtensions:G,baseResource:this.tb,baseContent:W?this.Jb(W,!1):oe,localResource:this.ub,localContent:oe,localExtensions:Z,remoteResource:this.vb,remoteExtensions:U,remoteContent:U?this.Jb(U,!1):null,previewResource:this.sb,previewResult:ee,localChange:ee.localChange,remoteChange:ee.remoteChange,acceptedResource:this.wb}]}async rb(F){const A=F.syncData?await o(F.syncData,this.yb):null,{localExtensions:U,ignoredExtensions:B}=await this.xb.getLocalExtensions(this.syncResource.profile),{remote:G}=(0,t.merge)(U,A,A,F.skippedExtensions||[],B,F.builtinExtensions||[]);return G!==null}Db(F,A,U,B){const G=[...A,...U],W=new Set,Z=$=>{W.add($.id.toLowerCase()),$.uuid&&W.add($.uuid)};G.forEach(({identifier:$})=>Z($)),B.forEach(Z);for(const $ of F)W.has($.identifier.id.toLowerCase())||$.identifier.uuid&&W.has($.identifier.uuid)||G.push($);return this.Jb(G,!1)}async ob(F,A){return{...F.previewResult,hasConflicts:!1}}async pb(F,A,U,B){if(this.h.isEqual(A,this.ub))return this.Gb(F);if(this.h.isEqual(A,this.vb))return this.Hb(F);if(this.h.isEqual(A,this.sb))return F.previewResult;throw new Error(`Invalid Resource: ${A.toString()}`)}async Gb(F){const A=await this.yb.getInstalled(void 0,this.syncResource.profile.extensionsResource),U=this.zb.getIgnoredExtensions(A),B=(0,t.merge)(F.localExtensions,null,null,F.skippedExtensions,U,F.builtinExtensions),{local:G,remote:W}=B;return{content:F.localContent,local:G,remote:W,localChange:G.added.length>0||G.removed.length>0||G.updated.length>0?2:0,remoteChange:W!==null?2:0}}async Hb(F){const A=await this.yb.getInstalled(void 0,this.syncResource.profile.extensionsResource),U=this.zb.getIgnoredExtensions(A),B=F.remoteContent?JSON.parse(F.remoteContent):null;if(B!==null){const G=(0,t.merge)(F.localExtensions,B,F.localExtensions,[],U,F.builtinExtensions),{local:W,remote:Z}=G;return{content:F.remoteContent,local:W,remote:Z,localChange:W.added.length>0||W.removed.length>0||W.updated.length>0?2:0,remoteChange:Z!==null?2:0}}else return{content:F.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async qb(F,A,U,B){let{skippedExtensions:G,localExtensions:W}=U[0][0];const{local:Z,remote:$,localChange:z,remoteChange:Y}=U[0][1];if(z===0&&Y===0&&this.L.info(`${this.y}: No changes found during synchronizing extensions.`),z!==0&&(await this.kb(JSON.stringify(W)),G=await this.xb.updateLocalExtensions(Z.added,Z.removed,Z.updated,G,this.syncResource.profile)),$){this.L.trace(`${this.y}: Updating remote extensions...`);const ee=JSON.stringify($.all);F=await this.jb(ee,B?null:F.ref),this.L.info(`${this.y}: Updated remote extensions.${$.added.length?` Added: ${JSON.stringify($.added.map(oe=>oe.identifier.id))}.`:""}${$.updated.length?` Updated: ${JSON.stringify($.updated.map(oe=>oe.identifier.id))}.`:""}${$.removed.length?` Removed: ${JSON.stringify($.removed.map(oe=>oe.identifier.id))}.`:""}`)}if(A?.ref!==F.ref){this.L.trace(`${this.y}: Updating last synchronized extensions...`);const ee=W.filter(oe=>!oe.installed).map(oe=>oe.identifier);await this.cb(F,{skippedExtensions:G,builtinExtensions:ee}),this.L.info(`${this.y}: Updated last synchronized extensions.${G.length?` Skipped: ${JSON.stringify(G.map(oe=>oe.identifier.id))}.`:""}`)}}async resolveContent(F){if(this.h.isEqual(this.vb,F)||this.h.isEqual(this.tb,F)||this.h.isEqual(this.ub,F)||this.h.isEqual(this.wb,F)){const A=await this.ab(F);return A&&this.Jb(JSON.parse(A),!0)}return null}Jb(F,A){return E(F,A)}async hasLocalData(){try{const{localExtensions:F}=await this.xb.getLocalExtensions(this.syncResource.profile);if(F.some(A=>A.installed||A.disabled))return!0}catch{}return!1}};T=pe([K(2,b.IEnvironmentService),K(3,g.IFileService),K(4,l.IStorageService),K(5,s.IUserDataSyncStoreService),K(6,s.IUserDataSyncBackupStoreService),K(7,w.IExtensionManagementService),K(8,a.IIgnoredExtensionsManagementService),K(9,s.IUserDataSyncLogService),K(10,S.IConfigurationService),K(11,s.IUserDataSyncEnablementService),K(12,h.ITelemetryService),K(13,d.IExtensionStorageService),K(14,f.IUriIdentityService),K(15,c.IUserDataProfileStorageService),K(16,v.IInstantiationService)],T),e.ExtensionsSynchroniser=T;let q=class{constructor(F,A,U,B,G,W){this.a=F,this.b=A,this.c=U,this.d=B,this.f=G,this.g=W}async getLocalExtensions(F){const A=await this.a.getInstalled(void 0,F.extensionsResource),U=this.d.getIgnoredExtensions(A);return{localExtensions:await this.j(F,async(G,W)=>{const Z=G.getDisabledExtensions();return A.map($=>{const{identifier:z,isBuiltin:Y,manifest:ee,preRelease:oe}=$,J={identifier:z,preRelease:oe,version:ee.version};Z.some(Q=>(0,p.areSameExtensions)(Q,z))&&(J.disabled=!0),Y||(J.installed=!0);try{const Q=W.getKeysForSync({id:z.id,version:ee.version});if(Q){const O=W.getExtensionState($,!0)||{};J.state=Object.keys(O).reduce((M,H)=>(Q.includes(H)&&(M[H]=O[H]),M),{})}}catch(Q){this.g.info(`${(0,r.getSyncResourceLogLabel)("extensions",F)}: Error while parsing extension state`,(0,R.getErrorMessage)(Q))}return J})}),ignoredExtensions:U}}async updateLocalExtensions(F,A,U,B,G){const W=(0,r.getSyncResourceLogLabel)("extensions",G);return this.j(G,async(Z,$)=>{const z=[],Y=[],ee=await this.a.getInstalled(void 0,G.extensionsResource);if(A.length){const J=ee.filter(({identifier:Q,isBuiltin:O})=>!O&&A.some(M=>(0,p.areSameExtensions)(Q,M)));await D.Promises.settled(J.map(async Q=>{this.g.trace(`${W}: Uninstalling local extension...`,Q.identifier.id),await this.a.uninstall(Q,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:G.extensionsResource}),this.g.info(`${W}: Uninstalled local extension.`,Q.identifier.id),z.push(Q.identifier)}))}(F.length||U.length)&&await D.Promises.settled([...F,...U].map(async J=>{const Q=ee.find(M=>(0,p.areSameExtensions)(M.identifier,J.identifier));if(Q&&Q.isBuiltin){J.state&&Q.manifest.version===J.version&&this.h(J.state,Q,Q.manifest.version,$),Z.getDisabledExtensions().some(H=>(0,p.areSameExtensions)(H,J.identifier))!==!!J.disabled&&(J.disabled?(this.g.trace(`${W}: Disabling extension...`,J.identifier.id),await Z.disableExtension(J.identifier),this.g.info(`${W}: Disabled extension`,J.identifier.id)):(this.g.trace(`${W}: Enabling extension...`,J.identifier.id),await Z.enableExtension(J.identifier),this.g.info(`${W}: Enabled extension`,J.identifier.id))),z.push(J.identifier);return}const O=(await this.c.getExtensions([{...J.identifier,preRelease:J.preRelease}],i.CancellationToken.None))[0];if(J.state&&(Q?Q.manifest.version===J.version:!!O)&&this.h(J.state,Q||O,Q?.manifest.version,$),O)try{Z.getDisabledExtensions().some(H=>(0,p.areSameExtensions)(H,J.identifier))!==!!J.disabled&&(J.disabled?(this.g.trace(`${W}: Disabling extension...`,J.identifier.id,O.version),await Z.disableExtension(O.identifier),this.g.info(`${W}: Disabled extension`,J.identifier.id,O.version)):(this.g.trace(`${W}: Enabling extension...`,J.identifier.id,O.version),await Z.enableExtension(O.identifier),this.g.info(`${W}: Enabled extension`,J.identifier.id,O.version))),(!Q||Q.preRelease!==J.preRelease)&&(await this.a.canInstall(O)?(this.g.trace(`${W}: Installing extension...`,J.identifier.id,O.version),await this.a.installFromGallery(O,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:J.preRelease,profileLocation:G.extensionsResource}),this.g.info(`${W}: Installed extension.`,J.identifier.id,O.version),z.push(O.identifier)):(this.g.info(`${W}: Skipped synchronizing extension because it cannot be installed.`,O.displayName||O.identifier.id),Y.push(J)))}catch(M){Y.push(J),M instanceof w.ExtensionManagementError&&[w.ExtensionManagementErrorCode.Incompatible,w.ExtensionManagementErrorCode.IncompatiblePreRelease,w.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(M.code)?this.g.info(`${W}: Skipped synchronizing extension because the compatible extension is not found.`,O.displayName||O.identifier.id):(this.g.error(M),this.g.info(`${W}: Skipped synchronizing extension`,O.displayName||O.identifier.id))}else Y.push(J),this.g.info(`${W}: Skipped synchronizing extension because the extension is not found.`,J.identifier.id)}));const oe=[];for(const J of B)z.some(Q=>(0,p.areSameExtensions)(Q,J.identifier))||oe.push(J);for(const J of Y)oe.some(Q=>(0,p.areSameExtensions)(Q.identifier,J.identifier))||oe.push(J);return oe})}h(F,A,U,B){const G=B.getExtensionState(A,!0)||{},W=U?B.getKeysForSync({id:A.identifier.id,version:U}):void 0;W?W.forEach(Z=>{G[Z]=F[Z]}):Object.keys(F).forEach(Z=>G[Z]=F[Z]),B.setExtensionState(A,G,!0)}async j(F,A){return this.b.withProfileScopedStorageService(F,async U=>{const B=new P.DisposableStore,G=this.f.createChild(new u.ServiceCollection([l.IStorageService,U])),W=B.add(G.createInstance(C.GlobalExtensionEnablementService)),Z=B.add(G.createInstance(d.ExtensionStorageService));try{return await A(W,Z)}finally{B.dispose()}})}};q=pe([K(0,w.IExtensionManagementService),K(1,c.IUserDataProfileStorageService),K(2,w.IExtensionGalleryService),K(3,a.IIgnoredExtensionsManagementService),K(4,v.IInstantiationService),K(5,s.IUserDataSyncLogService)],q),e.LocalExtensionsProvider=q;let N=class extends r.AbstractInitializer{constructor(F,A,U,B,G,W,Z,$){super("extensions",B,G,W,U,Z,$),this.o=F,this.p=A}async q(F){return F.syncData?await o(F.syncData,this.o):null}t(F,A){const U=[],B=[],G=[];for(const W of F){if(this.p.hasToNeverSyncExtension(W.identifier.id))continue;const Z=A.find($=>(0,p.areSameExtensions)($.identifier,W.identifier));Z?(U.push(Z),W.disabled&&G.push(W.identifier)):W.installed&&(B.push({...W.identifier,preRelease:!!W.preRelease}),W.disabled&&G.push(W.identifier))}return{installedExtensions:U,newExtensions:B,disabledExtensions:G,remoteExtensions:F}}};N=pe([K(0,w.IExtensionManagementService),K(1,a.IIgnoredExtensionsManagementService),K(2,g.IFileService),K(3,n.IUserDataProfilesService),K(4,b.IEnvironmentService),K(5,m.ILogService),K(6,l.IStorageService),K(7,f.IUriIdentityService)],N),e.AbstractExtensionsInitializer=N}),define(re[118],ae([0,1,17,9,3,35,43,5,31,16,13,14,7,45,19,24,30,41,60,256,26,18,62,4]),function(_,e,D,i,R,k,L,P,I,S,b,C,w,p,d,g,v,u,m,l,h,f,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.LocalGlobalStateProvider=e.GlobalStateSynchroniser=e.stringify=void 0;const t="globalState.argv.",a=["locale"];function s(q,N){const j=q.storage?Object.keys(q.storage).sort():[],F={};return j.forEach(A=>F[A]=q.storage[A]),q.storage=F,N?(0,L.toFormattedString)(q,{}):JSON.stringify(q)}e.stringify=s;const c=1;let o=class extends u.AbstractSynchroniser{constructor(N,j,F,A,U,B,G,W,Z,$,z,Y,ee,oe){super({syncResource:"globalState",profile:N},j,A,W,Y,U,B,Z,$,G,z,ee),this.wb=F,this.mb=c,this.p=this.h.joinPath(this.g,"globalState.json"),this.r=this.p.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),this.sb=this.p.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),this.tb=this.p.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.ub=this.p.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.vb=oe.createInstance(y),this.B(A.watch(this.h.dirname(this.D.argvResource))),this.B(R.Event.any(R.Event.filter(A.onDidFilesChange,J=>J.contains(this.D.argvResource)),R.Event.filter(F.onDidChange,J=>!!(J.targetChanges.some(Q=>this.syncResource.profile.id===Q.id)||J.valueChanges.some(({profile:Q,changes:O})=>this.syncResource.profile.id===Q.id&&O.some(M=>M.target===0)))))(()=>this.triggerLocalChange()))}async nb(N,j,F){const A=N.syncData?JSON.parse(N.syncData.content):null;j=j===null&&F?N:j;const U=j&&j.syncData?JSON.parse(j.syncData.content):null,B=await this.vb.getLocalGlobalState(this.syncResource.profile);A?this.L.trace(`${this.y}: Merging remote ui state with local ui state...`):this.L.trace(`${this.y}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const G=await this.Eb(U),{local:W,remote:Z}=(0,l.merge)(B.storage,A?A.storage:null,U?U.storage:null,G,this.L),$={content:null,local:W,remote:Z,localChange:Object.keys(W.added).length>0||Object.keys(W.updated).length>0||W.removed.length>0?2:0,remoteChange:Z.all!==null?2:0},z=s(B,!1);return[{baseResource:this.r,baseContent:U?s(U,!1):z,localResource:this.sb,localContent:z,localUserData:B,remoteResource:this.tb,remoteContent:A?s(A,!1):null,previewResource:this.p,previewResult:$,localChange:$.localChange,remoteChange:$.remoteChange,acceptedResource:this.ub,storageKeys:G}]}async rb(N){const j=N.syncData?JSON.parse(N.syncData.content):null;if(j===null)return!0;const F=await this.vb.getLocalGlobalState(this.syncResource.profile),A=await this.Eb(j),{remote:U}=(0,l.merge)(F.storage,j.storage,j.storage,A,this.L);return U.all!==null}async ob(N,j){return{...N.previewResult,hasConflicts:!1}}async pb(N,j,F,A){if(this.h.isEqual(j,this.sb))return this.Bb(N);if(this.h.isEqual(j,this.tb))return this.Cb(N);if(this.h.isEqual(j,this.p))return N.previewResult;throw new Error(`Invalid Resource: ${j.toString()}`)}async Bb(N){return{content:N.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(N.localUserData.storage),removed:[],updated:[],all:N.localUserData.storage},localChange:0,remoteChange:2}}async Cb(N){if(N.remoteContent!==null){const j=JSON.parse(N.remoteContent),{local:F,remote:A}=(0,l.merge)(N.localUserData.storage,j.storage,null,N.storageKeys,this.L);return{content:N.remoteContent,local:F,remote:A,localChange:Object.keys(F.added).length>0||Object.keys(F.updated).length>0||F.removed.length>0?2:0,remoteChange:A!==null?2:0}}else return{content:N.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async qb(N,j,F,A){const{localUserData:U}=F[0][0],{local:B,remote:G,localChange:W,remoteChange:Z}=F[0][1];if(W===0&&Z===0&&this.L.info(`${this.y}: No changes found during synchronizing ui state.`),W!==0&&(this.L.trace(`${this.y}: Updating local ui state...`),await this.kb(JSON.stringify(U)),await this.vb.writeLocalGlobalState(B,this.syncResource.profile),this.L.info(`${this.y}: Updated local ui state`)),Z!==0){this.L.trace(`${this.y}: Updating remote ui state...`);const $=JSON.stringify({storage:G.all});N=await this.jb($,A?null:N.ref),this.L.info(`${this.y}: Updated remote ui state.${G.added.length?` Added: ${G.added}.`:""}${G.updated.length?` Updated: ${G.updated}.`:""}${G.removed.length?` Removed: ${G.removed}.`:""}`)}j?.ref!==N.ref&&(this.L.trace(`${this.y}: Updating last synchronized ui state...`),await this.cb(N),this.L.info(`${this.y}: Updated last synchronized ui state`))}async resolveContent(N){if(this.h.isEqual(this.tb,N)||this.h.isEqual(this.r,N)||this.h.isEqual(this.sb,N)||this.h.isEqual(this.ub,N)){const j=await this.ab(N);return j&&s(JSON.parse(j),!0)}return null}async hasLocalData(){try{const{storage:N}=await this.vb.getLocalGlobalState(this.syncResource.profile);if(Object.keys(N).length>1||N[`${t}.locale`]?.value!=="en")return!0}catch{}return!1}async Eb(N){const j=await this.wb.readStorageData(this.syncResource.profile),F=[],A=[];for(const[G,W]of j)W.target===0?F.push(G):W.target===1&&A.push(G);const U=[...F,...A],B=N?.storage?Object.keys(N.storage).filter(G=>!G.startsWith(t)&&!U.includes(G)&&j.get(G)!==void 0):[];if(!P.isWeb){const G=[...h.ALL_SYNC_RESOURCES.map(W=>(0,h.getEnablementKey)(W)),h.SYNC_SERVICE_URL_TYPE];B.push(...G),A.push(...G)}return{user:F,machine:A,unregistered:B}}};o=pe([K(2,n.IUserDataProfileStorageService),K(3,C.IFileService),K(4,h.IUserDataSyncStoreService),K(5,h.IUserDataSyncBackupStoreService),K(6,h.IUserDataSyncLogService),K(7,b.IEnvironmentService),K(8,h.IUserDataSyncEnablementService),K(9,g.ITelemetryService),K(10,S.IConfigurationService),K(11,d.IStorageService),K(12,v.IUriIdentityService),K(13,r.IInstantiationService)],o),e.GlobalStateSynchroniser=o;let y=class{constructor(N,j,F,A){this.a=N,this.b=j,this.c=F,this.d=A}async getLocalGlobalState(N){const j={};if(N.isDefault){const A=await this.f(),U=(0,k.parse)(A);for(const B of a)U[B]!==void 0&&(j[`${t}${B}`]={version:1,value:U[B]})}const F=await this.c.readStorageData(N);for(const[A,U]of F)U.value&&U.target===0&&(j[A]={version:1,value:U.value});return{storage:j}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const N=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),N.value.toString()}catch(N){this.d.debug((0,i.getErrorMessage)(N))}return"{}"}async writeLocalGlobalState({added:N,removed:j,updated:F},A){const U=(0,u.getSyncResourceLogLabel)("globalState",A),B={},G=new Map,W=await this.c.readStorageData(A),Z=($,z)=>{for(const Y of $){if(Y.startsWith(t)){B[Y.substring(t.length)]=z?z[Y].value:void 0;continue}if(z){const ee=z[Y];ee.value!==W.get(Y)?.value&&G.set(Y,ee.value)}else W.get(Y)!==void 0&&G.set(Y,void 0)}};if(Z(Object.keys(N),N),Z(Object.keys(F),F),Z(j),Object.keys(B).length){this.d.trace(`${U}: Updating locale...`);const $=await this.f();let z=$;for(const Y of Object.keys(B))z=(0,m.edit)(z,[Y],B[Y],{});$!==z&&(this.d.trace(`${U}: Updating locale...`),await this.a.writeFile(this.b.argvResource,D.VSBuffer.fromString(z)),this.d.info(`${U}: Updated locale.`)),this.d.info(`${U}: Updated locale`)}G.size&&(this.d.trace(`${U}: Updating global state...`),await this.c.updateStorageData(A,G,0),this.d.info(`${U}: Updated global state`,[...G.keys()]))}};y=pe([K(0,C.IFileService),K(1,b.IEnvironmentService),K(2,n.IUserDataProfileStorageService),K(3,h.IUserDataSyncLogService)],y),e.LocalGlobalStateProvider=y;let E=class extends u.AbstractInitializer{constructor(N,j,F,A,U,B){super("globalState",F,A,U,j,N,B)}async doInitialize(N){const j=N.syncData?JSON.parse(N.syncData.content):null;if(!j){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const F={},A={};for(const U of Object.keys(j.storage))U.startsWith(t)?F[U.substring(t.length)]=j.storage[U].value:this.l.get(U,0)===void 0&&(A[U]=j.storage[U].value);if(Object.keys(F).length){let U="{}";try{U=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const B of Object.keys(F))U=(0,m.edit)(U,[B],F[B],{});await this.k.writeFile(this.h.argvResource,D.VSBuffer.fromString(U))}if(Object.keys(A).length)for(const U of Object.keys(A))this.l.store(U,A[U],0,0)}};E=pe([K(0,d.IStorageService),K(1,C.IFileService),K(2,f.IUserDataProfilesService),K(3,b.IEnvironmentService),K(4,h.IUserDataSyncLogService),K(5,v.IUriIdentityService)],E),e.GlobalStateInitializer=E;let T=class{constructor(N,j,F,A,U){this.a=N,this.b=j,this.c=F,this.d=A,this.f=U}getSyncStoreType(N){return this.h(N)?.storage[h.SYNC_SERVICE_URL_TYPE]?.value}async sync(N){const j=(0,h.createSyncHeaders)((0,I.generateUuid)());try{return await this.g(N,j)}catch(F){if(F instanceof h.UserDataSyncError)switch(F.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(N,j)}throw F}}async g(N,j){const F=await this.a.readResource("globalState",null,void 0,j),A=this.h(F)||{storage:{}};A.storage[h.SYNC_SERVICE_URL_TYPE]={value:N,version:c};const U=await(0,p.getServiceMachineId)(this.c,this.d,this.b),B={version:c,machineId:U,content:s(A,!1)};await this.a.writeResource("globalState",JSON.stringify(B),F.ref,void 0,j)}h({content:N}){if(!N)return null;const j=JSON.parse(N);if((0,u.isSyncData)(j))return j?JSON.parse(j.content):null;throw new Error("Invalid remote data")}};T=pe([K(1,d.IStorageService),K(2,b.IEnvironmentService),K(3,C.IFileService),K(4,w.ILogService)],T),e.UserDataSyncStoreTypeSynchronizer=T}),define(re[119],ae([0,1,20,17,3,35,5,15,175,16,13,14,19,24,30,18,41,253,26]),function(_,e,D,i,R,k,L,P,I,S,b,C,w,p,d,g,v,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function l(n,r,t){try{const a=JSON.parse(n);if(!r)return(0,P.isUndefined)(a.all)?null:a.all;switch(L.OS){case 2:return(0,P.isUndefined)(a.mac)?null:a.mac;case 3:return(0,P.isUndefined)(a.linux)?null:a.linux;case 1:return(0,P.isUndefined)(a.windows)?null:a.windows}}catch(a){return t.error(a),null}}e.getKeybindingsContentFromSyncContent=l;let h=class extends v.AbstractJsonFileSynchroniser{constructor(r,t,a,s,c,o,y,E,T,q,N,j,F){super(r.keybindingsResource,{syncResource:"keybindings",profile:r},t,E,T,q,a,s,y,j,c,N,o,F),this.mb=2,this.zb=this.h.joinPath(this.g,"keybindings.json"),this.Ab=this.zb.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),this.Bb=this.zb.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.Cb=this.zb.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.Db=this.zb.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.B(R.Event.filter(o.onDidChangeConfiguration,A=>A.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async nb(r,t,a,s){const c=r.syncData?l(r.syncData.content,s.keybindingsPerPlatform??this.Lb(),this.L):null;t=t===null&&a?r:t;const o=t?this.Jb(t):null,y=await this.p(),E=await this.xb();let T=null,q=!1,N=!1,j=!1;if(c){let U=y?y.value.toString():"[]";if(U=U||"[]",this.vb(U,!0))throw new m.UserDataSyncError((0,I.localize)(0,null),"LocalInvalidContent",this.resource);if(!o||o!==U||o!==c){this.L.trace(`${this.y}: Merging remote keybindings with local keybindings...`);const B=await(0,u.merge)(U,c,o,E,this.ub);B.hasChanges&&(T=B.mergeContent,j=B.hasConflicts,q=j||B.mergeContent!==U,N=j||B.mergeContent!==c)}}else y&&(this.L.trace(`${this.y}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),T=y.value.toString(),N=!0);const F={content:j?o:T,localChange:q?y?2:1:0,remoteChange:N?2:0,hasConflicts:j},A=y?y.value.toString():null;return[{fileContent:y,baseResource:this.Ab,baseContent:o,localResource:this.Bb,localContent:A,localChange:F.localChange,remoteResource:this.Cb,remoteContent:c,remoteChange:F.remoteChange,previewResource:this.zb,previewResult:F,acceptedResource:this.Db}]}async rb(r){const t=this.Jb(r);if(t===null)return!0;const a=await this.p(),s=a?a.value.toString():"",c=await this.xb(),o=await(0,u.merge)(s||"[]",t,t,c,this.ub);return o.hasConflicts||o.mergeContent!==t}async ob(r,t){return r.previewResult}async pb(r,t,a,s){if(this.h.isEqual(t,this.Bb))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(t,this.Cb))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(t,this.zb))return a===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:a,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async qb(r,t,a,s){const{fileContent:c}=a[0][0];let{content:o,localChange:y,remoteChange:E}=a[0][1];if(y===0&&E===0&&this.L.info(`${this.y}: No changes found during synchronizing keybindings.`),o!==null&&(o=o.trim(),o=o||"[]",this.vb(o,!0)))throw new m.UserDataSyncError((0,I.localize)(1,null),"LocalInvalidContent",this.resource);if(y!==0&&(this.L.trace(`${this.y}: Updating local keybindings...`),c&&await this.kb(this.Kb(c.value.toString())),await this.r(o||"[]",c,s),this.L.info(`${this.y}: Updated local keybindings`)),E!==0){this.L.trace(`${this.y}: Updating remote keybindings...`);const T=this.Kb(o||"[]",r.syncData?.content);r=await this.jb(T,s?null:r.ref),this.L.info(`${this.y}: Updated remote keybindings`)}try{await this.C.del(this.zb)}catch{}t?.ref!==r.ref&&(this.L.trace(`${this.y}: Updating last synchronized keybindings...`),await this.cb(r,{platformSpecific:this.Lb()}),this.L.info(`${this.y}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.p();if(r){const t=(0,k.parse)(r.value.toString());if((0,D.isNonEmptyArray)(t))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async resolveContent(r){return this.h.isEqual(this.Cb,r)||this.h.isEqual(this.Ab,r)||this.h.isEqual(this.Bb,r)||this.h.isEqual(this.Db,r)?this.ab(r):null}Jb(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.Lb()?null:l(r.syncData.content,this.Lb(),this.L)}Kb(r,t){let a={};try{a=JSON.parse(t||"{}")}catch(s){this.L.error(s)}switch(this.Lb()?delete a.all:a.all=r,L.OS){case 2:a.mac=r;break;case 3:a.linux=r;break;case 1:a.windows=r;break}return JSON.stringify(a)}Lb(){return!!this.M.getValue(m.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM)}};h=pe([K(2,m.IUserDataSyncStoreService),K(3,m.IUserDataSyncBackupStoreService),K(4,m.IUserDataSyncLogService),K(5,S.IConfigurationService),K(6,m.IUserDataSyncEnablementService),K(7,C.IFileService),K(8,b.IEnvironmentService),K(9,w.IStorageService),K(10,m.IUserDataSyncUtilService),K(11,p.ITelemetryService),K(12,d.IUriIdentityService)],h),e.KeybindingsSynchroniser=h;let f=class extends v.AbstractInitializer{constructor(r,t,a,s,c,o){super("keybindings",t,a,s,r,c,o)}async doInitialize(r){const t=r.syncData?this.i(r.syncData.content):null;if(!t){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.c()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,i.VSBuffer.fromString(t)),await this.n(r)}async c(){try{const r=await this.k.readFile(this.g.defaultProfile.settingsResource),t=(0,k.parse)(r.value.toString());return!(0,D.isNonEmptyArray)(t)}catch(r){return r.fileOperationResult===1}}i(r){try{return l(r,!0,this.j)}catch(t){return this.j.error(t),null}}};f=pe([K(0,C.IFileService),K(1,g.IUserDataProfilesService),K(2,b.IEnvironmentService),K(3,m.IUserDataSyncLogService),K(4,w.IStorageService),K(5,d.IUriIdentityService)],f),e.KeybindingsInitializer=f}),define(re[120],ae([0,1,17,3,176,16,74,13,29,14,19,24,30,18,41,60,257,26]),function(_,e,D,i,R,k,L,P,I,S,b,C,w,p,d,g,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function m(n){return n&&n.settings&&typeof n.settings=="string"&&Object.keys(n).length===1}function l(n){const r=JSON.parse(n);return m(r)?r:{settings:n}}e.parseSettingsSyncContent=l;let h=class extends d.AbstractJsonFileSynchroniser{constructor(r,t,a,s,c,o,y,E,T,q,N,j,F,A){super(r.settingsResource,{syncResource:"settings",profile:r},t,a,s,c,o,y,N,j,E,T,q,A),this.zb=F,this.mb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.Jb=void 0}async getRemoteUserDataSyncConfiguration(r){const t=await this.getLastSyncUserData(),a=await this.R(r,t),s=this.Gb(a),c=new L.ConfigurationModelParser(u.USER_DATA_SYNC_CONFIGURATION_SCOPE);return s?.settings&&c.parse(s.settings),c.configurationModel.getValue(u.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async nb(r,t,a){const s=await this.p(),c=await this.xb(),o=this.Gb(r);t=t===null&&a?r:t;const y=t?this.Gb(t):null,E=await this.Kb();let T=null,q=!1,N=!1,j=!1;if(o){let B=s?s.value.toString().trim():"{}";B=B||"{}",this.Lb(B),this.L.trace(`${this.y}: Merging remote settings with local settings...`);const G=(0,v.merge)(B,o.settings,y?y.settings:null,E,[],c);T=G.localContent||G.remoteContent,q=G.localContent!==null,N=G.remoteContent!==null,j=G.hasConflicts}else s&&(this.L.trace(`${this.y}: Remote settings does not exist. Synchronizing settings for the first time.`),T=s.value.toString().trim()||"{}",this.Lb(T),N=!0);const F=s?s.value.toString():null,A=y?.settings??null,U={content:j?A:T,localChange:q?2:0,remoteChange:N?2:0,hasConflicts:j};return[{fileContent:s,baseResource:this.baseResource,baseContent:A,localResource:this.localResource,localContent:F,localChange:U.localChange,remoteResource:this.remoteResource,remoteContent:o?o.settings:null,remoteChange:U.remoteChange,previewResource:this.previewResource,previewResult:U,acceptedResource:this.acceptedResource}]}async rb(r){const t=this.Gb(r);if(t===null)return!0;const a=await this.p(),s=a?a.value.toString().trim():"",c=await this.Kb(),o=await this.xb();return(0,v.merge)(s||"{}",t.settings,t.settings,c,[],o).remoteContent!==null}async ob(r,t){const a=await this.xb(),s=await this.Kb();return{...r.previewResult,content:r.previewResult.content?(0,v.updateIgnoredSettings)(r.previewResult.content,"{}",s,a):null}}async pb(r,t,a,s){const c=await this.xb(),o=await this.Kb();if(this.h.isEqual(t,this.localResource))return{content:r.fileContent?(0,v.updateIgnoredSettings)(r.fileContent.value.toString(),"{}",o,c):null,localChange:0,remoteChange:2};if(this.h.isEqual(t,this.remoteResource))return{content:r.remoteContent!==null?(0,v.updateIgnoredSettings)(r.remoteContent,r.fileContent?r.fileContent.value.toString():"{}",o,c):null,localChange:2,remoteChange:0};if(this.h.isEqual(t,this.previewResource))return a===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:a!==null?(0,v.updateIgnoredSettings)(a,r.fileContent?r.fileContent.value.toString():"{}",o,c):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async qb(r,t,a,s){const{fileContent:c}=a[0][0];let{content:o,localChange:y,remoteChange:E}=a[0][1];if(y===0&&E===0&&this.L.info(`${this.y}: No changes found during synchronizing settings.`),o=o?o.trim():"{}",o=o||"{}",this.Lb(o),y!==0&&(this.L.trace(`${this.y}: Updating local settings...`),c&&await this.kb(JSON.stringify(this.Ib(c.value.toString()))),await this.r(o,c,s),await this.M.reloadConfiguration(3),this.L.info(`${this.y}: Updated local settings`)),E!==0){const T=await this.xb(),q=this.Gb(r),N=await this.Kb(o);o=(0,v.updateIgnoredSettings)(o,q?q.settings:"{}",N,T),this.L.trace(`${this.y}: Updating remote settings...`),r=await this.jb(JSON.stringify(this.Ib(o)),s?null:r.ref),this.L.info(`${this.y}: Updated remote settings`)}try{await this.C.del(this.previewResource)}catch{}t?.ref!==r.ref&&(this.L.trace(`${this.y}: Updating last synchronized settings...`),await this.cb(r),this.L.info(`${this.y}: Updated last synchronized settings`))}async hasLocalData(){try{const r=await this.p();if(r){const t=await this.xb(),a=(0,g.edit)(r.value.toString(),[u.CONFIGURATION_SYNC_STORE_KEY],void 0,t);return!(0,v.isEmpty)(a)}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async resolveContent(r){return this.h.isEqual(this.remoteResource,r)||this.h.isEqual(this.localResource,r)||this.h.isEqual(this.acceptedResource,r)||this.h.isEqual(this.baseResource,r)?this.ab(r):null}async ab(r){let t=await super.ab(r);if(t){const a=await this.xb(),s=await this.Kb();t=(0,v.updateIgnoredSettings)(t,"{}",s,a)}return t}Gb(r){return r.syncData?this.Hb(r.syncData.content):null}Hb(r){try{return l(r)}catch(t){this.L.error(t)}return null}Ib(r){return{settings:r}}async Kb(r){if(!this.Jb){this.Jb=this.ub.resolveDefaultIgnoredSettings();const a=i.Event.any(i.Event.filter(this.zb.onDidInstallExtensions,s=>s.some(({local:c})=>!!c)),i.Event.filter(this.zb.onDidUninstallExtension,s=>!s.error))(()=>{a.dispose(),this.Jb=void 0})}const t=await this.Jb;return(0,v.getIgnoredSettings)(t,this.M,r)}Lb(r){if(this.vb(r,!1))throw new u.UserDataSyncError((0,R.localize)(0,null),"LocalInvalidContent",this.resource)}};h=pe([K(2,S.IFileService),K(3,P.IEnvironmentService),K(4,b.IStorageService),K(5,u.IUserDataSyncStoreService),K(6,u.IUserDataSyncBackupStoreService),K(7,u.IUserDataSyncLogService),K(8,u.IUserDataSyncUtilService),K(9,k.IConfigurationService),K(10,u.IUserDataSyncEnablementService),K(11,C.ITelemetryService),K(12,I.IExtensionManagementService),K(13,w.IUriIdentityService)],h),e.SettingsSynchroniser=h;let f=class extends d.AbstractInitializer{constructor(r,t,a,s,c,o){super("settings",t,a,s,r,c,o)}async doInitialize(r){const t=r.syncData?this.i(r.syncData.content):null;if(!t){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.c()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,D.VSBuffer.fromString(t.settings)),await this.n(r)}async c(){try{const r=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,v.isEmpty)(r.value.toString().trim())}catch(r){return r.fileOperationResult===1}}i(r){try{return l(r)}catch(t){this.j.error(t)}return null}};f=pe([K(0,S.IFileService),K(1,p.IUserDataProfilesService),K(2,P.IEnvironmentService),K(3,u.IUserDataSyncLogService),K(4,b.IStorageService),K(5,w.IUriIdentityService)],f),e.SettingsInitializer=f}),define(re[121],ae([0,1,17,3,32,16,13,14,19,24,30,18,41,254,26]),function(_,e,D,i,R,k,L,P,I,S,b,C,w,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=e.parseSnippets=void 0;function g(m){return JSON.parse(m.content)}e.parseSnippets=g;let v=class extends w.AbstractSynchroniser{constructor(l,h,f,n,r,t,a,s,c,o,y,E){super({syncResource:"snippets",profile:l},h,n,f,r,t,a,o,y,s,c,E),this.mb=1,this.p=l.snippetsHome,this.B(this.C.watch(f.userRoamingDataHome)),this.B(this.C.watch(this.p)),this.B(i.Event.filter(this.C.onDidFilesChange,T=>T.affects(this.p))(()=>this.triggerLocalChange()))}async nb(l,h,f){const n=await this.Cb(),r=this.Bb(n),t=l.syncData?this.Ab(l.syncData):null;h=h===null&&f?l:h;const a=h&&h.syncData?this.Ab(h.syncData):null;t?this.L.trace(`${this.y}: Merging remote snippets with local snippets...`):this.L.trace(`${this.y}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const s=(0,p.merge)(r,t,a);return this.wb(s,n,t||{},a||{})}async rb(l){const h=l.syncData?this.Ab(l.syncData):null;if(h===null)return!0;const f=await this.Cb(),n=this.Bb(f),r=(0,p.merge)(n,h,h);return Object.keys(r.remote.added).length>0||Object.keys(r.remote.updated).length>0||r.remote.removed.length>0||r.conflicts.length>0}async ob(l,h){return l.previewResult}async pb(l,h,f,n){if(this.h.isEqualOrParent(h,this.g.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:l.fileContent?l.fileContent.value.toString():null,localChange:0,remoteChange:l.fileContent?l.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(h,this.g.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:l.remoteContent,localChange:l.remoteContent!==null?l.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(h,this.g))return f===void 0?{content:l.previewResult.content,localChange:l.previewResult.localChange,remoteChange:l.previewResult.remoteChange}:{content:f,localChange:f===null?l.fileContent!==null?3:0:2,remoteChange:f===null?l.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${h.toString()}`)}async qb(l,h,f,n){const r=f.map(([t,a])=>({...t,acceptResult:a}));r.every(({localChange:t,remoteChange:a})=>t===0&&a===0)&&this.L.info(`${this.y}: No changes found during synchronizing snippets.`),r.some(({localChange:t})=>t!==0)&&(await this.xb(r),await this.yb(r,n)),r.some(({remoteChange:t})=>t!==0)&&(l=await this.zb(r,l,n)),h?.ref!==l.ref&&(this.L.trace(`${this.y}: Updating last synchronized snippets...`),await this.cb(l),this.L.info(`${this.y}: Updated last synchronized snippets`));for(const{previewResource:t}of r)try{await this.C.del(t)}catch{}}wb(l,h,f,n){const r=new Map;for(const t of Object.keys(l.local.added)){const a={content:l.local.added[t],hasConflicts:!1,localChange:1,remoteChange:0};r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[t],previewResource:this.h.joinPath(this.g,t),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(l.local.updated)){const a={content:l.local.updated[t],hasConflicts:!1,localChange:2,remoteChange:0},s=h[t]?h[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:h[t],localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[t],previewResource:this.h.joinPath(this.g,t),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of l.local.removed){const a={content:null,hasConflicts:!1,localChange:3,remoteChange:0},s=h[t]?h[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:h[t],localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,t),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(l.remote.added)){const a={content:l.remote.added[t],hasConflicts:!1,localChange:0,remoteChange:1},s=h[t]?h[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:h[t],localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,t),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(l.remote.updated)){const a={content:l.remote.updated[t],hasConflicts:!1,localChange:0,remoteChange:2},s=h[t]?h[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:h[t],localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[t],previewResource:this.h.joinPath(this.g,t),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of l.remote.removed){const a={content:null,hasConflicts:!1,localChange:0,remoteChange:3};r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[t],previewResource:this.h.joinPath(this.g,t),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of l.conflicts){const a={content:n[t]??null,hasConflicts:!0,localChange:h[t]?2:1,remoteChange:f[t]?2:1},s=h[t]?h[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:h[t]||null,localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[t]||null,previewResource:this.h.joinPath(this.g,t),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(h))if(!r.has(t)){const a={content:h[t]?h[t].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},s=h[t]?h[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:h[t]||null,localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[t]||null,previewResource:this.h.joinPath(this.g,t),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...r.values()]}async resolveContent(l){return this.h.isEqualOrParent(l,this.g.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.h.isEqualOrParent(l,this.g.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.h.isEqualOrParent(l,this.g.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.h.isEqualOrParent(l,this.g.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"}))?this.ab(l):null}async hasLocalData(){try{const l=await this.Cb();if(Object.keys(l).length)return!0}catch{}return!1}async xb(l){const h={};for(const f of l)f.fileContent&&(h[this.h.basename(f.localResource)]=f.fileContent);await this.kb(JSON.stringify(this.Bb(h)))}async yb(l,h){for(const{fileContent:f,acceptResult:n,localResource:r,remoteResource:t,localChange:a}of l)if(a!==0){const s=t?this.h.basename(t):this.h.basename(r),c=this.h.joinPath(this.p,s);a===3?(this.L.trace(`${this.y}: Deleting snippet...`,this.h.basename(c)),await this.C.del(c),this.L.info(`${this.y}: Deleted snippet`,this.h.basename(c))):a===1?(this.L.trace(`${this.y}: Creating snippet...`,this.h.basename(c)),await this.C.createFile(c,D.VSBuffer.fromString(n.content),{overwrite:h}),this.L.info(`${this.y}: Created snippet`,this.h.basename(c))):(this.L.trace(`${this.y}: Updating snippet...`,this.h.basename(c)),await this.C.writeFile(c,D.VSBuffer.fromString(n.content),h?void 0:f),this.L.info(`${this.y}: Updated snippet`,this.h.basename(c)))}}async zb(l,h,f){const n=h.syncData?this.Ab(h.syncData):{},r=(0,R.deepClone)(n);for(const{acceptResult:t,localResource:a,remoteResource:s,remoteChange:c}of l)if(c!==0){const o=a?this.h.basename(a):this.h.basename(s);c===3?delete r[o]:r[o]=t.content}return(0,p.areSame)(n,r)||(this.L.trace(`${this.y}: Updating remote snippets...`),h=await this.jb(JSON.stringify(r),f?null:h.ref),this.L.info(`${this.y}: Updated remote snippets`)),h}Ab(l){return g(l)}Bb(l){const h={};for(const f of Object.keys(l))h[f]=l[f].value.toString();return h}async Cb(){const l={};let h;try{h=await this.C.resolve(this.p)}catch(f){if(f instanceof P.FileOperationError&&f.fileOperationResult===1)return l;throw f}for(const f of h.children||[]){const n=f.resource,r=this.h.extname(n);if(r===".json"||r===".code-snippets"){const t=this.h.relativePath(this.p,n),a=await this.C.readFile(n);l[t]=a}}return l}};v=pe([K(2,L.IEnvironmentService),K(3,P.IFileService),K(4,I.IStorageService),K(5,d.IUserDataSyncStoreService),K(6,d.IUserDataSyncBackupStoreService),K(7,d.IUserDataSyncLogService),K(8,k.IConfigurationService),K(9,d.IUserDataSyncEnablementService),K(10,S.ITelemetryService),K(11,b.IUriIdentityService)],v),e.SnippetsSynchroniser=v;let u=class extends w.AbstractInitializer{constructor(l,h,f,n,r,t){super("snippets",h,f,n,l,r,t)}async doInitialize(l){const h=l.syncData?JSON.parse(l.syncData.content):null;if(!h){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.c()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const n of Object.keys(h)){const r=h[n];if(r){const t=this.d.joinPath(this.g.defaultProfile.snippetsHome,n);await this.k.createFile(t,D.VSBuffer.fromString(r)),this.j.info("Created snippet",this.d.basename(t))}}await this.n(l)}async c(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(l){return l.fileOperationResult===1}}};u=pe([K(0,P.IFileService),K(1,C.IUserDataProfilesService),K(2,L.IEnvironmentService),K(3,d.IUserDataSyncLogService),K(4,I.IStorageService),K(5,b.IUriIdentityService)],u),e.SnippetsInitializer=u}),define(re[122],ae([0,1,17,16,13,14,19,24,30,18,41,26]),function(_,e,D,i,R,k,L,P,I,S,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function w(v,u){try{return JSON.parse(v).tasks??null}catch(m){return u.error(m),null}}e.getTasksContentFromSyncContent=w;let p=class extends b.AbstractFileSynchroniser{constructor(u,m,l,h,f,n,r,t,a,s,c,o){super(u.tasksResource,{syncResource:"tasks",profile:u},m,t,a,s,l,h,r,c,f,n,o),this.mb=1,this.vb=this.h.joinPath(this.g,"tasks.json"),this.wb=this.vb.with({scheme:C.USER_DATA_SYNC_SCHEME,authority:"base"}),this.xb=this.vb.with({scheme:C.USER_DATA_SYNC_SCHEME,authority:"local"}),this.yb=this.vb.with({scheme:C.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.zb=this.vb.with({scheme:C.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async nb(u,m,l,h){const f=u.syncData?w(u.syncData.content,this.L):null;m=m===null&&l?u:m;const n=m?.syncData?w(m.syncData.content,this.L):null,r=await this.p();let t=null,a=!1,s=!1,c=!1;if(u.syncData){const E=r?r.value.toString():null;if(!n||n!==E||n!==f){this.L.trace(`${this.y}: Merging remote tasks with local tasks...`);const T=g(E,f,n);t=T.content,c=T.hasConflicts,a=T.hasLocalChanged,s=T.hasRemoteChanged}}else r&&(this.L.trace(`${this.y}: Remote tasks does not exist. Synchronizing tasks for the first time.`),t=r.value.toString(),s=!0);const o={content:c?n:t,localChange:a?r?2:1:0,remoteChange:s?2:0,hasConflicts:c},y=r?r.value.toString():null;return[{fileContent:r,baseResource:this.wb,baseContent:n,localResource:this.xb,localContent:y,localChange:o.localChange,remoteResource:this.yb,remoteContent:f,remoteChange:o.remoteChange,previewResource:this.vb,previewResult:o,acceptedResource:this.zb}]}async rb(u){const m=u?.syncData?w(u.syncData.content,this.L):null;if(m===null)return!0;const l=await this.p(),h=l?l.value.toString():null,f=g(h,m,m);return f.hasLocalChanged||f.hasRemoteChanged}async ob(u,m){return u.previewResult}async pb(u,m,l,h){if(this.h.isEqual(m,this.xb))return{content:u.fileContent?u.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(m,this.yb))return{content:u.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(m,this.vb))return l===void 0?{content:u.previewResult.content,localChange:u.previewResult.localChange,remoteChange:u.previewResult.remoteChange}:{content:l,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${m.toString()}`)}async qb(u,m,l,h){const{fileContent:f}=l[0][0],{content:n,localChange:r,remoteChange:t}=l[0][1];if(r===0&&t===0&&this.L.info(`${this.y}: No changes found during synchronizing tasks.`),r!==0&&(this.L.trace(`${this.y}: Updating local tasks...`),f&&await this.kb(JSON.stringify(this.Fb(f.value.toString()))),n?await this.r(n,f,h):await this.sb(),this.L.info(`${this.y}: Updated local tasks`)),t!==0){this.L.trace(`${this.y}: Updating remote tasks...`);const a=JSON.stringify(this.Fb(n));u=await this.jb(a,h?null:u.ref),this.L.info(`${this.y}: Updated remote tasks`)}try{await this.C.del(this.vb)}catch{}m?.ref!==u.ref&&(this.L.trace(`${this.y}: Updating last synchronized tasks...`),await this.cb(u),this.L.info(`${this.y}: Updated last synchronized tasks`))}async hasLocalData(){return this.C.exists(this.i)}async resolveContent(u){return this.h.isEqual(this.yb,u)||this.h.isEqual(this.wb,u)||this.h.isEqual(this.xb,u)||this.h.isEqual(this.zb,u)?this.ab(u):null}Fb(u){return u?{tasks:u}:{}}};p=pe([K(2,C.IUserDataSyncStoreService),K(3,C.IUserDataSyncBackupStoreService),K(4,C.IUserDataSyncLogService),K(5,i.IConfigurationService),K(6,C.IUserDataSyncEnablementService),K(7,k.IFileService),K(8,R.IEnvironmentService),K(9,L.IStorageService),K(10,P.ITelemetryService),K(11,I.IUriIdentityService)],p),e.TasksSynchroniser=p;let d=class extends b.AbstractInitializer{constructor(u,m,l,h,f,n){super("tasks",m,l,h,u,f,n),this.c=this.g.defaultProfile.tasksResource}async doInitialize(u){const m=u.syncData?w(u.syncData.content,this.j):null;if(!m){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,D.VSBuffer.fromString(m)),await this.n(u)}async i(){return this.k.exists(this.c)}};d=pe([K(0,k.IFileService),K(1,S.IUserDataProfilesService),K(2,R.IEnvironmentService),K(3,C.IUserDataSyncLogService),K(4,L.IStorageService),K(5,I.IUriIdentityService)],d),e.TasksInitializer=d;function g(v,u,m){if(v===null&&u===null&&m===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(v===u)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const l=m!==v,h=m!==u;return!l&&!h?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:l&&!h?{content:v,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:h&&!l?{content:u,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:v,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(re[123],ae([0,1,43,16,13,14,19,24,30,18,41,255,26]),function(_,e,D,i,R,k,L,P,I,S,b,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseUserDataProfilesManifest=e.stringifyLocalProfiles=e.UserDataProfilesManifestSynchroniser=void 0;let p=class extends b.AbstractSynchroniser{constructor(u,m,l,h,f,n,r,t,a,s,c,o,y){super({syncResource:"profiles",profile:u},m,h,f,n,r,t,c,o,a,s,y),this.r=l,this.mb=1,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async getLastSyncedProfiles(){const u=await this.getLastSyncUserData();return u?.syncData?g(u.syncData):null}async getRemoteSyncedProfiles(u){const m=await this.getLastSyncUserData(),l=await this.R(u,m);return l?.syncData?g(l.syncData):null}async nb(u,m,l){if(!this.r.isEnabled())throw new w.UserDataSyncError("Cannot sync profiles because they are disabled","LocalError");const h=u.syncData?g(u.syncData):null,f=m?.syncData?g(m.syncData):null,n=this.zb(),{local:r,remote:t}=(0,C.merge)(n,h,f,[]),a={local:r,remote:t,content:f?this.Ab(f):null,localChange:r.added.length>0||r.removed.length>0||r.updated.length>0?2:0,remoteChange:t!==null?2:0},s=d(n,!1);return[{baseResource:this.baseResource,baseContent:f?this.Ab(f):null,localResource:this.localResource,localContent:s,remoteResource:this.remoteResource,remoteContent:h?this.Ab(h):null,remoteProfiles:h,previewResource:this.previewResource,previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.acceptedResource}]}async rb(u){const m=u?.syncData?g(u.syncData):null,l=this.zb(),{remote:h}=(0,C.merge)(l,m,m,[]);return!!h?.added.length||!!h?.removed.length||!!h?.updated.length}async ob(u,m){return{...u.previewResult,hasConflicts:!1}}async pb(u,m,l,h){if(this.h.isEqual(m,this.localResource))return this.wb(u);if(this.h.isEqual(m,this.remoteResource))return this.xb(u);if(this.h.isEqual(m,this.previewResource))return u.previewResult;throw new Error(`Invalid Resource: ${m.toString()}`)}async wb(u){const m=this.zb(),l=(0,C.merge)(m,null,null,[]),{local:h,remote:f}=l;return{content:u.localContent,local:h,remote:f,localChange:h.added.length>0||h.removed.length>0||h.updated.length>0?2:0,remoteChange:f!==null?2:0}}async xb(u){const m=u.remoteContent?JSON.parse(u.remoteContent):null,l=[],h=[];for(const f of this.zb()){const n=m?.find(r=>r.id===f.id);n&&(l.push({id:f.id,name:f.name,collection:n.collection}),h.push(f))}if(m!==null){const f=(0,C.merge)(h,m,l,[]),{local:n,remote:r}=f;return{content:u.remoteContent,local:n,remote:r,localChange:n.added.length>0||n.removed.length>0||n.updated.length>0?2:0,remoteChange:r!==null?2:0}}else return{content:u.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async qb(u,m,l,h){const{local:f,remote:n,localChange:r,remoteChange:t}=l[0][1];if(r===0&&t===0&&this.L.info(`${this.y}: No changes found during synchronizing profiles.`),r!==0){await this.kb(d(this.zb(),!1));const a=[];for(const s of f.added)a.push((async()=>{this.L.trace(`${this.y}: Creating '${s.name}' profile...`),await this.r.createProfile(s.id,s.name,{shortName:s.shortName}),this.L.info(`${this.y}: Created profile '${s.name}'.`)})());for(const s of f.removed)a.push((async()=>{this.L.trace(`${this.y}: Removing '${s.name}' profile...`),await this.r.removeProfile(s),this.L.info(`${this.y}: Removed profile '${s.name}'.`)})());for(const s of f.updated){const c=this.r.profiles.find(o=>o.id===s.id);c?a.push((async()=>{this.L.trace(`${this.y}: Updating '${s.name}' profile...`),await this.r.updateProfile(c,{name:s.name,shortName:s.shortName}),this.L.info(`${this.y}: Updated profile '${s.name}'.`)})()):this.L.info(`${this.y}: Could not find profile with id '${s.id}' to update.`)}await Promise.all(a)}if(t!==0){const a=l[0][0].remoteProfiles||[];this.L.trace(`${this.y}: Updating remote profiles...`);for(const s of n?.added||[]){const c=await this.G.createCollection(this.z);a.push({id:s.id,name:s.name,collection:c,shortName:s.shortName})}for(const s of n?.removed||[])a.splice(a.findIndex(({id:c})=>s.id===c),1);for(const s of n?.updated||[]){const c=a.find(({id:o})=>s.id===o);c&&a.splice(a.indexOf(c),1,{id:s.id,name:s.name,collection:c.collection,shortName:s.shortName})}u=await this.jb(this.Ab(a),h?null:u.ref),this.L.info(`${this.y}: Updated remote profiles.${n?.added.length?` Added: ${JSON.stringify(n.added.map(s=>s.name))}.`:""}${n?.updated.length?` Updated: ${JSON.stringify(n.updated.map(s=>s.name))}.`:""}${n?.removed.length?` Removed: ${JSON.stringify(n.removed.map(s=>s.name))}.`:""}`);for(const s of n?.removed||[])await this.G.deleteCollection(s.collection,this.z)}m?.ref!==u.ref&&(this.L.trace(`${this.y}: Updating last synchronized profiles...`),await this.cb(u),this.L.info(`${this.y}: Updated last synchronized profiles.`))}async hasLocalData(){return this.zb().length>0}async resolveContent(u){if(this.h.isEqual(this.remoteResource,u)||this.h.isEqual(this.baseResource,u)||this.h.isEqual(this.localResource,u)||this.h.isEqual(this.acceptedResource,u)){const m=await this.ab(u);return m&&(0,D.toFormattedString)(JSON.parse(m),{})}return null}zb(){return this.r.profiles.filter(u=>!u.isDefault&&!u.isTransient)}Ab(u){return JSON.stringify([...u].sort((m,l)=>m.name.localeCompare(l.name)))}};p=pe([K(2,S.IUserDataProfilesService),K(3,k.IFileService),K(4,R.IEnvironmentService),K(5,L.IStorageService),K(6,w.IUserDataSyncStoreService),K(7,w.IUserDataSyncBackupStoreService),K(8,w.IUserDataSyncLogService),K(9,i.IConfigurationService),K(10,w.IUserDataSyncEnablementService),K(11,P.ITelemetryService),K(12,I.IUriIdentityService)],p),e.UserDataProfilesManifestSynchroniser=p;function d(v,u){const m=[...v].sort((l,h)=>l.name.localeCompare(h.name)).map(l=>({id:l.id,name:l.name}));return u?(0,D.toFormattedString)(m,{}):JSON.stringify(m)}e.stringifyLocalProfiles=d;function g(v){return JSON.parse(v.content)}e.parseUserDataProfilesManifest=g}),define(re[270],ae([0,1,6,17,65,2,22,16,13,14,18,26]),function(_,e,D,i,R,k,L,P,I,S,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let w=class extends k.Disposable{constructor(d,g,v,u,m){super(),this.a=d,this.b=g,this.c=v,this.f=u,this.g=m;for(const l of this.g.profiles)for(const h of C.ALL_SYNC_RESOURCES)this.i(this.h(l,h))}async getAllRefs(d,g){const v=this.h(d,g),u=await this.b.resolve(v);return u.children?u.children.filter(l=>l.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(l.name)).sort().reverse().map(l=>({ref:l.name,created:this.j(l)})):[]}async resolveContent(d,g,v){const u=this.h(d,g),m=(0,L.joinPath)(u,v);try{return(await this.b.readFile(m)).value.toString()}catch(l){return this.f.error(l),null}}async backup(d,g,v){const u=this.h(d,g),m=(0,L.joinPath)(u,`${(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(m,i.VSBuffer.fromString(v))}catch(l){this.f.error(l)}try{this.i(u)}catch{}}h(d,g){return(0,L.joinPath)(this.a.userDataSyncHome,...d.isDefault?[g]:[d.id,g])}async i(d){try{try{if(!await this.b.exists(d))return}catch{return}const g=await this.b.resolve(d);if(g.children){const v=g.children.filter(h=>h.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(h.name)).sort(),u=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let m=v.filter(h=>Date.now()-this.j(h)>u);const l=v.length-m.length;l<10&&(m=m.slice(10-l)),await D.Promises.settled(m.map(async h=>{this.f.info("Deleting from backup",h.resource.path),await this.b.del(h.resource)}))}}catch(g){this.f.error(g)}}j(d){return d.ctime||new Date(parseInt(d.name.substring(0,4)),parseInt(d.name.substring(4,6))-1,parseInt(d.name.substring(6,8)),parseInt(d.name.substring(9,11)),parseInt(d.name.substring(11,13)),parseInt(d.name.substring(13,15))).getTime()}};w=pe([K(0,I.IEnvironmentService),K(1,S.IFileService),K(2,P.IConfigurationService),K(3,C.IUserDataSyncLogService),K(4,b.IUserDataProfilesService)],w),e.UserDataSyncBackupStoreService=w}),define(re[271],ae([0,1,3,2,5,13,19,24,26]),function(_,e,D,i,R,k,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const S="sync.enable";let b=class extends i.Disposable{constructor(w,p,d,g){super(),this.c=w,this.f=p,this.g=d,this.h=g,this.a=new D.Emitter,this.onDidChangeEnablement=this.a.event,this.b=new D.Emitter,this.onDidChangeResourceEnablement=this.b.event,this.B(w.onDidChangeValue(v=>this.j(v)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(S,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(w){w&&!this.canToggleEnablement()||(this.f.publicLog2(S,{enabled:w}),this.c.store(S,w,-1,1))}isResourceEnabled(w){return this.c.getBoolean((0,I.getEnablementKey)(w),-1,!0)}setResourceEnablement(w,p){if(this.isResourceEnabled(w)!==p){const d=(0,I.getEnablementKey)(w);this.i(d,p)}}getResourceSyncStateVersion(w){}i(w,p){this.c.store(w,p,-1,R.isWeb?0:1)}j(w){if(w.scope!==-1)return;if(S===w.key){this.a.fire(this.isEnabled());return}const p=I.ALL_SYNC_RESOURCES.filter(d=>(0,I.getEnablementKey)(d)===w.key)[0];if(p){this.b.fire([p,this.isResourceEnabled(p)]);return}}};b=pe([K(0,L.IStorageService),K(1,P.ITelemetryService),K(2,k.IEnvironmentService),K(3,I.IUserDataSyncStoreManagementService)],b),e.UserDataSyncEnablementService=b}),define(re[81],ae([0,1,3,2,5,27,179,13,14,4,23,45,19,26]),function(_,e,D,i,R,k,L,P,I,S,b,C,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,S.createDecorator)("IUserDataSyncMachinesService");const d="sync.currentMachineName",g="Safari",v="Chrome",u="Edge",m="Firefox",l="Android";function h(r){switch(r){case g:case v:case u:case m:case l:case(0,R.PlatformToString)(0):return!0}return!1}e.isWebPlatform=h;function f(){return R.isSafari?g:R.isChrome?v:R.isEdge?u:R.isFirefox?m:R.isAndroid?l:(0,R.PlatformToString)(R.isWeb?0:R.platform)}let n=class rt extends i.Disposable{constructor(t,a,s,c,o,y){super(),this.h=s,this.i=c,this.j=o,this.k=y,this.c=this.B(new D.Emitter),this.onDidChange=this.c.event,this.g=null,this.f=(0,C.getServiceMachineId)(t,a,s)}async getMachines(t){const a=await this.f;return(await this.m(t)).machines.map(c=>({...c,isCurrent:c.id===a}))}async addCurrentMachine(t){const a=await this.f,s=await this.m(t);s.machines.some(({id:c})=>c===a)||(s.machines.push({id:a,name:this.l(s.machines),platform:f()}),await this.n(s))}async removeCurrentMachine(t){const a=await this.f,s=await this.m(t),c=s.machines.filter(({id:o})=>o!==a);c.length!==s.machines.length&&(s.machines=c,await this.n(s))}async renameMachine(t,a,s){const c=await this.m(s),o=c.machines.find(({id:y})=>y===t);if(o){o.name=a,await this.n(c);const y=await this.f;t===y&&this.h.store(d,a,-1,1)}}async setEnablements(t){const a=await this.m();for(const[s,c]of t){const o=a.machines.find(y=>y.id===s);o&&(o.disabled=c?void 0:!0)}await this.n(a)}l(t){const a=this.h.get(d,-1);if(a)return a;const s=`${this.k.embedderIdentifier?`${this.k.embedderIdentifier} - `:""}${f()} (${this.k.nameShort})`,c=new RegExp(`${(0,k.escapeRegExpCharacters)(s)}\\s#(\\d+)`);let o=0;for(const y of t){const E=c.exec(y.name),T=E?parseInt(E[1]):0;o=T>o?T:o}return`${s} #${o+1}`}async m(t){this.g=await this.p(t);const a=this.r(this.g);if(a.version!==rt.a)throw new Error((0,L.localize)(0,null,this.k.nameLong));return a}async n(t){const a=JSON.stringify(t),s=await this.i.writeResource(rt.b,a,this.g?.ref||null);this.g={ref:s,content:a},this.c.fire()}async p(t){if(this.g){const a=t&&t.latest?t.latest[rt.b]:void 0;if(this.g.ref===a)return this.g;if(a===void 0&&this.g.content===null)return this.g}return this.i.readResource(rt.b,this.g)}r(t){if(t.content!==null)try{return JSON.parse(t.content)}catch(a){this.j.error(a)}return{version:rt.a,machines:[]}}};n.a=1,n.b="machines",n=pe([K(0,P.IEnvironmentService),K(1,I.IFileService),K(2,w.IStorageService),K(3,p.IUserDataSyncStoreService),K(4,p.IUserDataSyncLogService),K(5,b.IProductService)],n),e.UserDataSyncMachinesService=n}),define(re[272],ae([0,1,6,65,38,9,3,2,5,22,8,177,23,19,24,26,78,81]),function(_,e,D,i,R,k,L,P,I,S,b,C,w,p,d,g,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const m="sync.disableMachineEventually",l="sync.sessionId",h="sync.storeUrl",f="sync.productQuality";let n=class extends P.Disposable{get j(){const a=this.z.get(h,-1);return a?b.URI.parse(a):void 0}set j(a){a?this.z.store(h,a.toString(),-1,1):this.z.remove(h,-1)}get l(){return this.z.get(f,-1)}set l(a){a?this.z.store(f,a,-1,1):this.z.remove(f,-1)}constructor(a,s,c,o,y,E,T,q,N,j){super(),this.n=s,this.p=c,this.r=o,this.s=y,this.u=E,this.v=T,this.w=q,this.y=N,this.z=j,this.a=this.B(new P.MutableDisposable),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new L.Emitter),this.onError=this.h.event,this.N=[],this.f=this.B(new D.ThrottledDelayer(this.O())),this.i=this.j,this.j=s.userDataSyncStore?.url,this.k=this.l,this.l=a.quality,this.j&&(this.u.info("Using settings sync service",this.j.toString()),this.B(s.onDidChangeUserDataSyncStore(()=>{(0,S.isEqual)(this.j,s.userDataSyncStore?.url)||(this.i=this.j,this.j=s.userDataSyncStore?.url,this.j&&this.u.info("Using settings sync service",this.j.toString()))})),this.r.isEnabled()?this.u.info("Auto Sync is enabled."):this.u.info("Auto Sync is disabled."),this.C(),this.L()&&this.J(),this.B(T.onDidChangeAccount(()=>this.C())),this.B(c.onDidChangeDonotMakeRequestsUntil(()=>this.C())),this.B(y.onDidChangeLocal(F=>this.triggerSync([F],!1,!1))),this.B(L.Event.filter(this.r.onDidChangeResourceEnablement,([,F])=>F)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.n.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}C(){const{enabled:a,message:s}=this.F();a?this.a.value===void 0&&(this.a.value=new r(this.i,1e3*60*5,this.n,this.p,this.s,this.y,this.u,this.z),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(c=>this.I(c))),this.D()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(s&&this.u.info(s),this.a.clear()):s&&this.r.isEnabled()&&this.u.info(s))}D(){return!0}F(){return this.r.isEnabled()?this.v.account?this.p.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,i.toLocalISOString)(this.p.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.M(),this.i=this.j,this.G(!0)}async turnOff(a,s,c){try{this.v.account&&!c&&await this.y.removeCurrentMachine(),this.G(!1),this.z.remove(l,-1),a?(this.w.publicLog2("sync/turnOffEveryWhere"),await this.s.reset()):await this.s.resetLocal()}catch(o){if(this.u.error(o),s)this.G(!1);else throw o}}G(a){this.r.isEnabled()!==a&&(this.r.setEnablement(a),this.C())}H(){return!!this.k&&!!this.l&&this.k!==this.l}async I(a){if(!a){this.b=0;return}const s=g.UserDataSyncError.toUserDataSyncError(a);s instanceof g.UserDataAutoSyncError&&this.w.publicLog2("autosync/error",{code:s.code,service:this.n.userDataSyncStore.url.toString()}),s.code==="SessionExpired"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because current session is expired")):s.code==="TurnedOff"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):s.code==="LocalTooManyRequests"?(this.g=!0,this.u.info("Auto Sync: Suspended sync because of making too many requests to server"),this.C()):s.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.J(),this.u.info("Auto Sync: Turned off sync because of making too many requests to server")):s.code==="UpgradeRequired"||s.code==="Gone"?(await this.turnOff(!1,!0,!0),this.J(),this.u.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):s.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.u.info(`Auto Sync: Turned off sync because server has ${s.resource} content with newer version than of client. Requires client upgrade.`)):s.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.u.info(`Auto Sync: Turned off sync because server has ${s.resource} content with older version than of client. Requires server reset.`)):s.code==="ServiceChanged"||s.code==="DefaultServiceChanged"?I.isWeb&&s.code==="DefaultServiceChanged"&&!this.H()?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.u.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.u.error(s),this.b++),this.h.fire(s)}async J(){this.z.store(m,!0,-1,1),await(0,D.timeout)(1e3*60*10),this.L()&&(this.M(),!this.r.isEnabled()&&this.v.account&&await this.y.removeCurrentMachine())}L(){return this.z.getBoolean(m,-1,!1)}M(){this.z.remove(m,-1)}async triggerSync(a,s,c){if(this.a.value===void 0)return this.f.cancel();if(s&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.u.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.N.push(...a),this.f.trigger(async()=>{this.u.trace("activity sources",...this.N);const o=this.v.account?.authenticationProviderId||"";this.w.publicLog2("sync/triggered",{sources:this.N,providerId:o}),this.N=[],this.a.value&&await this.a.value.sync("Activity",c)},this.b?this.O()*1*Math.min(Math.pow(2,this.b),60):this.O())}O(){return 2e3}};n=pe([K(0,w.IProductService),K(1,g.IUserDataSyncStoreManagementService),K(2,g.IUserDataSyncStoreService),K(3,g.IUserDataSyncEnablementService),K(4,g.IUserDataSyncService),K(5,g.IUserDataSyncLogService),K(6,v.IUserDataSyncAccountService),K(7,d.ITelemetryService),K(8,u.IUserDataSyncMachinesService),K(9,p.IStorageService)],n),e.UserDataAutoSyncService=n;class r extends P.Disposable{constructor(a,s,c,o,y,E,T,q){super(),this.j=a,this.k=s,this.l=c,this.m=o,this.n=y,this.p=E,this.r=T,this.s=q,this.b=this.B(new P.MutableDisposable),this.c=this.B(new L.Emitter),this.onDidStartSync=this.c.event,this.f=this.B(new L.Emitter),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.u())),this.B((0,P.toDisposable)(()=>{this.i&&(this.i.cancel(),this.r.info("Auto sync: Cancelled sync that is in progress"),this.i=void 0),this.h?.stop(),this.r.info("Auto Sync: Stopped")})),this.sync(r.a,!1)}u(){this.b.value=(0,D.disposableTimeout)(()=>this.sync(r.a,!1),this.k)}sync(a,s){const c=(0,D.createCancelablePromise)(async o=>{if(this.i)try{this.r.debug("Auto Sync: Waiting until sync is finished."),await this.i}catch(y){if((0,k.isCancellationError)(y))return}return this.y(a,s,o)});return this.i=c,this.i.finally(()=>this.i=void 0),this.i}v(){return this.j!==void 0&&!(0,S.isEqual)(this.j,this.l.userDataSyncStore?.url)}async w(){const a=await this.l.getPreviousUserDataSyncStore(),s=this.l.userDataSyncStore;return!!s&&!!a&&(!(0,S.isEqual)(s.defaultUrl,a.defaultUrl)||!(0,S.isEqual)(s.insidersUrl,a.insidersUrl)||!(0,S.isEqual)(s.stableUrl,a.stableUrl))}async y(a,s,c){this.r.info(`Auto Sync: Triggered by ${a}`),this.c.fire();let o;try{if(this.h=await this.n.createSyncTask(this.g,s),c.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.n.hasPreviouslySynced())throw this.v()?await this.w()?new g.UserDataAutoSyncError((0,C.localize)(0,null),"DefaultServiceChanged"):new g.UserDataAutoSyncError((0,C.localize)(1,null),"ServiceChanged"):new g.UserDataAutoSyncError((0,C.localize)(2,null),"TurnedOff");const y=this.s.get(l,-1);if(y&&this.g&&y!==this.g.session)throw this.v()?await this.w()?new g.UserDataAutoSyncError((0,C.localize)(3,null),"DefaultServiceChanged"):new g.UserDataAutoSyncError((0,C.localize)(4,null),"ServiceChanged"):new g.UserDataAutoSyncError((0,C.localize)(5,null),"SessionExpired");const E=await this.p.getMachines(this.g||void 0);if(c.isCancellationRequested)return;const T=E.find(q=>q.isCurrent);if(T?.disabled)throw new g.UserDataAutoSyncError((0,C.localize)(6,null),"TurnedOff");if(await this.h.run(),this.g===null)try{this.g=await this.m.manifest(null)}catch(q){throw new g.UserDataAutoSyncError((0,R.toErrorMessage)(q),q instanceof g.UserDataSyncError?q.code:"Unknown")}if(this.g&&this.g.session!==y&&this.s.store(l,this.g.session,-1,1),c.isCancellationRequested)return;T||await this.p.addCurrentMachine(this.g||void 0)}catch(y){this.r.error(y),o=y}this.f.fire(o)}register(a){return super.B(a)}}r.a="Interval"}),define(re[273],ae([0,1,8,180,13,14,45,19,30,26,18,41,121,120,119,16,122,117,118,4,123,43]),function(_,e,D,i,R,k,L,P,I,S,b,C,w,p,d,g,v,u,m,l,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceProviderService=void 0;let n=class Ve{constructor(t,a,s,c,o,y,E,T,q,N){this.e=t,this.f=a,this.g=s,this.h=o,this.i=y,this.j=E,this.k=T,this.l=q,this.m=N,this.d=c.extUri}async getRemoteSyncedProfiles(){const t=await this.e.readResource("profiles",null,void 0);if(t.content){const a=this.K(t.content,"profiles");return(0,h.parseUserDataProfilesManifest)(a)}return[]}async getRemoteSyncResourceHandles(t,a){return(await this.e.getAllResourceRefs(t,a?.collection)).map(({created:c,ref:o})=>({created:c,uri:this.I({remote:!0,syncResource:t,profile:a?.id??this.k.defaultProfile.id,collection:a?.collection,ref:o,node:void 0})}))}async getLocalSyncResourceHandles(t,a){return(await this.f.getAllRefs(a,t)).map(({created:c,ref:o})=>({created:c,uri:this.I({remote:!1,syncResource:t,profile:a.id,collection:void 0,ref:o,node:void 0})}))}resolveUserDataSyncResource({uri:t}){const a=this.J(t),s=a?this.k.profiles.find(c=>c.id===a.profile):void 0;return a&&s?{profile:s,syncResource:a?.syncResource}:void 0}async getAssociatedResources({uri:t}){const a=this.J(t);if(!a)return[];const s=this.k.profiles.find(c=>c.id===a.profile);switch(a.syncResource){case"settings":return this.r(t,s);case"keybindings":return this.t(t,s);case"tasks":return this.v(t,s);case"snippets":return this.x(t,s);case"globalState":return this.C(t,s);case"extensions":return this.z(t,s);case"profiles":return this.F(t,s)}}async getMachineId({uri:t}){const a=this.J(t);if(!!a){if(a.remote){if(a.ref){const{content:s}=await this.L(a.syncResource,a.ref,a.collection);if(s)return this.K(s,a.syncResource)?.machineId}return}return(0,L.getServiceMachineId)(this.h,this.j,this.i)}}async resolveContent(t){const a=this.J(t);if(!a||a.node===Ve.a)return null;if(a.ref){const s=await this.n(a.remote,a.syncResource,a.profile,a.collection,a.ref);return a.node&&s?this.o(a.syncResource,s,a.node):s}return!a.remote&&!a.node?this.q(a.syncResource,a.profile):null}async n(t,a,s,c,o){if(t){const{content:E}=await this.L(a,o,c);return E}const y=this.k.profiles.find(E=>E.id===s);return y?this.f.resolveContent(y,a,o):null}o(t,a,s){const c=this.K(a,t);switch(t){case"settings":return this.s(c,s);case"keybindings":return this.u(c,s);case"tasks":return this.w(c,s);case"snippets":return this.y(c,s);case"globalState":return this.D(c,s);case"extensions":return this.A(c,s);case"profiles":return this.G(c,s)}}async q(t,a){const s=this.k.profiles.find(c=>c.id===a);if(!s)return null;switch(t){case"globalState":return this.E(s);case"extensions":return this.B(s);case"profiles":return this.H(s);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null}}r(t,a){const s=this.d.joinPath(t,"settings.json"),c=a?a.settingsResource:this.d.joinPath(t,Ve.a);return[{resource:s,comparableResource:c}]}s(t,a){switch(a){case"settings.json":return(0,p.parseSettingsSyncContent)(t.content).settings}return null}t(t,a){const s=this.d.joinPath(t,"keybindings.json"),c=a?a.keybindingsResource:this.d.joinPath(t,Ve.a);return[{resource:s,comparableResource:c}]}u(t,a){switch(a){case"keybindings.json":return(0,d.getKeybindingsContentFromSyncContent)(t.content,!!this.l.getValue(S.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM),this.g)}return null}v(t,a){const s=this.d.joinPath(t,"tasks.json"),c=a?a.tasksResource:this.d.joinPath(t,Ve.a);return[{resource:s,comparableResource:c}]}w(t,a){switch(a){case"tasks.json":return(0,v.getTasksContentFromSyncContent)(t.content,this.g)}return null}async x(t,a){const s=await this.resolveContent(t);if(s){const c=this.K(s,"snippets");if(c){const o=(0,w.parseSnippets)(c),y=[];for(const E of Object.keys(o)){const T=this.d.joinPath(t,E),q=a?this.d.joinPath(a.snippetsHome,E):this.d.joinPath(t,Ve.a);y.push({resource:T,comparableResource:q})}return y}}return[]}y(t,a){return(0,w.parseSnippets)(t)[a]||null}z(t,a){const s=this.d.joinPath(t,"extensions.json"),c=a?this.I({remote:!1,syncResource:"extensions",profile:a.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,Ve.a);return[{resource:s,comparableResource:c}]}A(t,a){switch(a){case"extensions.json":return(0,u.stringify)((0,u.parseExtensions)(t),!0)}return null}async B(t){const{localExtensions:a}=await this.m.createInstance(u.LocalExtensionsProvider).getLocalExtensions(t);return(0,u.stringify)(a,!0)}C(t,a){const s=this.d.joinPath(t,"globalState.json"),c=a?this.I({remote:!1,syncResource:"globalState",profile:a.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,Ve.a);return[{resource:s,comparableResource:c}]}D(t,a){switch(a){case"globalState.json":return(0,m.stringify)(JSON.parse(t.content),!0)}return null}async E(t){const a=await this.m.createInstance(m.LocalGlobalStateProvider).getLocalGlobalState(t);return(0,m.stringify)(a,!0)}F(t,a){const s=this.d.joinPath(t,"profiles.json"),c=this.I({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,collection:void 0,ref:void 0,node:void 0});return[{resource:s,comparableResource:c}]}G(t,a){switch(a){case"profiles.json":return(0,f.toFormattedString)(JSON.parse(t.content),{})}return null}async H(t){return(0,h.stringifyLocalProfiles)(this.k.profiles.filter(a=>!a.isDefault&&!a.isTransient),!0)}I(t){const a=t.remote?Ve.b:Ve.c,s=[t.syncResource,t.profile];return t.collection&&s.push(`collection:${t.collection}`),t.ref&&s.push(`ref:${t.ref}`),t.node&&s.push(t.node),this.d.joinPath(D.URI.from({scheme:S.USER_DATA_SYNC_SCHEME,authority:a,path:"/"}),...s)}J(t){if(t.scheme!==S.USER_DATA_SYNC_SCHEME||t.authority!==Ve.c&&t.authority!==Ve.b)return;const a=[];for(;t.path!=="/";)a.unshift(this.d.basename(t)),t=this.d.dirname(t);if(a.length<2)return;const s=t.authority===Ve.b,c=a.shift(),o=a.shift();let y,E,T;for(;a.length;){const q=a.shift();q.startsWith("collection:")?y=q.substring(11):q.startsWith("ref:")?E=q.substring(4):T=q}return{remote:s,syncResource:c,profile:o,collection:y,ref:E,node:T}}K(t,a){try{const s=JSON.parse(t);if((0,C.isSyncData)(s))return s}catch(s){this.g.error(s)}throw new S.UserDataSyncError((0,i.localize)(0,null),"IncompatibleRemoteContent",a)}async L(t,a,s){const c=await this.e.resolveResourceContent(t,a,s);return{ref:a,content:c}}};n.a="not-existing-resource",n.b="remote-backup",n.c="local-backup",n=pe([K(0,S.IUserDataSyncStoreService),K(1,S.IUserDataSyncBackupStoreService),K(2,S.IUserDataSyncLogService),K(3,I.IUriIdentityService),K(4,R.IEnvironmentService),K(5,P.IStorageService),K(6,k.IFileService),K(7,b.IUserDataProfilesService),K(8,g.IConfigurationService),K(9,l.IInstantiationService)],n),e.UserDataSyncResourceProviderService=n}),define(re[274],ae([0,1,20,6,21,38,3,2,22,15,31,16,13,29,4,23,19,24,18,117,118,119,120,121,122,123,26]),function(_,e,D,i,R,k,L,P,I,S,b,C,w,p,d,g,v,u,m,l,h,f,n,r,t,a,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const c="sync.lastSyncTime";let o=class extends P.Disposable{get status(){return this.c}get conflicts(){return this.h}get lastSyncTime(){return this.l}constructor(N,j,F,A,U,B,G,W,Z,$,z){super(),this.u=N,this.v=j,this.w=F,this.y=A,this.z=U,this.C=B,this.D=G,this.F=W,this.G=Z,this.H=$,this.I=z,this.c="uninitialized",this.f=this.B(new L.Emitter),this.onDidChangeStatus=this.f.event,this.g=this.B(new L.Emitter),this.onDidChangeLocal=this.g.event,this.h=[],this.i=this.B(new L.Emitter),this.onDidChangeConflicts=this.i.event,this.j=[],this.k=this.B(new L.Emitter),this.onSyncErrors=this.k.event,this.l=void 0,this.m=this.B(new L.Emitter),this.onDidChangeLastSyncTime=this.m.event,this.n=this.B(new L.Emitter),this.onDidResetLocal=this.n.event,this.r=this.B(new L.Emitter),this.onDidResetRemote=this.r.event,this.t=new Map,this.c=j.userDataSyncStore?"idle":"uninitialized",this.l=this.C.getNumber(c,-1,void 0),this.B((0,P.toDisposable)(()=>this.X()))}async createSyncTask(N,j){this.Y(),this.y.info("Sync started.");const F=new Date().getTime(),A=(0,b.generateUuid)();try{const W=(0,s.createSyncHeaders)(A);j&&(W["Cache-Control"]="no-cache"),N=await this.u.manifest(N,W)}catch(W){const Z=s.UserDataSyncError.toUserDataSyncError(W);throw T(Z,A,this.v,this.z),Z}const U=!1,B=this;let G;return{manifest:N,async run(){if(U)throw new Error("Can run a task only once");G=(0,i.createCancelablePromise)(W=>B.J(N,!1,A,W)),await G.finally(()=>G=void 0),B.y.info(`Sync done. Took ${new Date().getTime()-F}ms`),B.U()},stop(){return G?.cancel(),B.O()}}}async createManualSyncTask(){if(this.Y(),this.D.isEnabled())throw new s.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");this.y.info("Sync started.");const N=new Date().getTime(),j=(0,b.generateUuid)(),F=(0,s.createSyncHeaders)(j);let A;try{A=await this.u.manifest(null,F)}catch(G){const W=s.UserDataSyncError.toUserDataSyncError(G);throw T(W,j,this.v,this.z),W}await this.resetLocal();const U=this,B=new R.CancellationTokenSource;return{id:j,async merge(){return U.J(A,!0,j,B.token)},async apply(){await U.M(A,j,B.token),U.y.info(`Sync done. Took ${new Date().getTime()-N}ms`),U.U()},async stop(){B.cancel(),await U.O(),await U.resetLocal()}}}async J(N,j,F,A){this.j=[];try{this.status!=="hasConflicts"&&this.R("syncing");const U=this.getOrCreateActiveProfileSynchronizer(this.F.defaultProfile,void 0);this.j.push(...await this.N(U,N,j,F,A));const B=U.enabled.find(G=>G.resource==="profiles");if(B){const G=await B.getLastSyncedProfiles()||[];if(A.isCancellationRequested)return;await this.L(G,N,j,F,A)}}finally{this.k.fire(this.j)}}async L(N,j,F,A,U){for(const B of N){if(U.isCancellationRequested)return;const G=this.F.profiles.find(Z=>Z.id===B.id);if(!G){this.y.error(`Profile with id:${B.id} and name: ${B.name} does not exist locally to sync.`);continue}this.y.info("Syncing profile.",B.name);const W=this.getOrCreateActiveProfileSynchronizer(G,B);this.j.push(...await this.N(W,j,F,A,U))}for(const[B,G]of this.t.entries())this.F.profiles.some(W=>W.id===G[0].profile.id)||(G[1].dispose(),this.t.delete(B))}async M(N,j,F){const A=this.W();for(const Z of A){if(F.isCancellationRequested)return;await Z.apply(j,F)}const U=A.find(Z=>Z.profile.isDefault);if(!U)return;const B=U.enabled.find(Z=>Z.resource==="profiles");if(!B)return;const W=(await B.getRemoteSyncedProfiles(N?.latest??null)||[]).filter(Z=>A.every($=>$.profile.id!==Z.id));W.length&&await this.L(W,N,!1,j,F)}async N(N,j,F,A,U){return(await N.sync(j,F,A,U)).map(([G,W])=>({profile:N.profile,syncResource:G,error:W}))}async O(){this.status!=="idle"&&await Promise.allSettled(this.W().map(N=>N.stop()))}async resolveContent(N){const j=await this.I.resolveContent(N);if(j)return j;for(const F of this.W())for(const A of F.enabled){const U=await A.resolveContent(N);if(U)return U}return null}async replace(N){this.Y();const j=this.I.resolveUserDataSyncResource(N);if(!j)return;const F=await this.resolveContent(N.uri);!F||await this.P(j.profile,async A=>{if(j.syncResource===A.resource)return await A.replace(F),!0})}async accept(N,j,F,A){this.Y(),await this.P(N.profile,async U=>{if(N.syncResource===U.resource)return await U.accept(j,F),A&&await U.apply((0,S.isBoolean)(A)?!1:A.force,(0,s.createSyncHeaders)((0,b.generateUuid)())),!0})}getRemoteProfiles(){return this.I.getRemoteSyncedProfiles()}getRemoteSyncResourceHandles(N,j){return this.I.getRemoteSyncResourceHandles(N,j)}async getLocalSyncResourceHandles(N,j){return this.I.getLocalSyncResourceHandles(N,j??this.F.defaultProfile)}async getAssociatedResources(N){return this.I.getAssociatedResources(N)}async getMachineId(N){return this.I.getMachineId(N)}async hasLocalData(){return!!await this.P(this.F.defaultProfile,async j=>{if(j.resource!=="globalState"&&await j.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.P(this.F.defaultProfile,async j=>{if(await j.hasPreviouslySynced())return!0})}async reset(){this.Y(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.Y();try{await this.u.clear(),this.y.info("Cleared data on server")}catch(N){this.y.error(N)}this.r.fire()}async resetLocal(){this.Y(),this.l=void 0,this.C.remove(c,-1);for(const[N]of this.t.values())try{await N.resetLocal()}catch(j){this.y.error(j)}this.X(),this.n.fire(),this.y.info("Did reset the local sync state.")}async P(N,j){const F=new P.DisposableStore;try{const A=this.t.get(N.id);if(A){const Z=await this.Q(A[0],j,F);return(0,S.isUndefined)(Z)?null:Z}if(N.isDefault){const Z=F.add(this.w.createInstance(y,N,void 0)),$=await this.Q(Z,j,F);return(0,S.isUndefined)($)?null:$}if(this.F.isEnabled()||this.H.isBuilt&&(!this.G.enableSyncingProfiles||(0,I.isEqual)(this.v.userDataSyncStore?.url,this.v.userDataSyncStore?.stableUrl)))return null;const U=F.add(this.w.createInstance(a.UserDataProfilesManifestSynchroniser,N,void 0)),B=await this.u.manifest(null),W=(await U.getRemoteSyncedProfiles(B?.latest??null)||[]).find(Z=>Z.id===N.id);if(W){const Z=F.add(this.w.createInstance(y,N,W.collection)),$=await this.Q(Z,j,F);return(0,S.isUndefined)($)?null:$}return null}finally{F.dispose()}}async Q(N,j,F){const A=[...N.enabled,...N.disabled.map(U=>F.add(N.createSynchronizer(U)))];for(const U of A){const B=await j(U);if(!(0,S.isUndefined)(B))return B}}R(N){const j=this.c;this.c!==N&&(this.c=N,this.f.fire(N),j==="hasConflicts"&&this.U())}S(){const N=this.W().map(j=>j.conflicts).flat();(0,D.equals)(this.h,N,(j,F)=>j.profile.id===F.profile.id&&j.syncResource===F.syncResource&&(0,D.equals)(j.conflicts,F.conflicts,(A,U)=>(0,I.isEqual)(A.previewResource,U.previewResource)))||(this.h=N,this.i.fire(N))}U(){this.status==="idle"&&(this.l=new Date().getTime(),this.C.store(c,this.l,-1,1),this.m.fire(this.l))}getOrCreateActiveProfileSynchronizer(N,j){let F=this.t.get(N.id);if(F&&F[0].collection!==j?.collection&&(this.y.error("Profile synchronizer collection does not match with the remote sync profile collection"),F[1].dispose(),F=void 0,this.t.delete(N.id)),!F){const A=new P.DisposableStore,U=A.add(this.w.createInstance(y,N,j?.collection));A.add(U.onDidChangeStatus(B=>this.R(B))),A.add(U.onDidChangeConflicts(B=>this.S())),A.add(U.onDidChangeLocal(B=>this.g.fire(B))),this.t.set(N.id,F=[U,A])}return F[0]}W(){const N=[];for(const[j]of this.t.values())N.push(j);return N}X(){this.t.forEach(([,N])=>N.dispose()),this.t.clear()}Y(){if(!this.v.userDataSyncStore)throw new Error("Not enabled")}};o=pe([K(0,s.IUserDataSyncStoreService),K(1,s.IUserDataSyncStoreManagementService),K(2,d.IInstantiationService),K(3,s.IUserDataSyncLogService),K(4,u.ITelemetryService),K(5,v.IStorageService),K(6,s.IUserDataSyncEnablementService),K(7,m.IUserDataProfilesService),K(8,g.IProductService),K(9,w.IEnvironmentService),K(10,s.IUserDataSyncResourceProviderService)],o),e.UserDataSyncService=o;let y=class extends P.Disposable{get enabled(){return this.c.sort((N,j)=>N[1]-j[1]).map(([N])=>N)}get disabled(){return s.ALL_SYNC_RESOURCES.filter(N=>!this.k.isResourceEnabled(N))}get status(){return this.f}get conflicts(){return this.i}constructor(N,j,F,A,U,B,G,W,Z,$,z,Y){super(),this.profile=N,this.collection=j,this.k=F,this.l=A,this.m=U,this.n=B,this.r=G,this.t=W,this.u=Z,this.v=$,this.w=z,this.y=Y,this.c=[],this.f="idle",this.g=this.B(new L.Emitter),this.onDidChangeStatus=this.g.event,this.h=this.B(new L.Emitter),this.onDidChangeLocal=this.h.event,this.i=[],this.j=this.B(new L.Emitter),this.onDidChangeConflicts=this.j.event,this.B(F.onDidChangeResourceEnablement(([ee,oe])=>this.z(ee,oe))),this.B((0,P.toDisposable)(()=>this.c.splice(0,this.c.length).forEach(([,,ee])=>ee.dispose())));for(const ee of s.ALL_SYNC_RESOURCES)F.isResourceEnabled(ee)&&this.C(ee)}z(N,j){j?this.C(N):this.D(N)}C(N){if(this.c.some(([U])=>U.resource===N))return;if(N==="extensions"&&!this.m.isEnabled()){this.t.info("Skipping extensions sync because gallery is not configured");return}if(N==="profiles"){if(!this.profile.isDefault||!this.v.isEnabled())return;if(this.y.isBuilt&&(!this.u.enableSyncingProfiles||(0,I.isEqual)(this.n.userDataSyncStore?.url,this.n.userDataSyncStore?.stableUrl))){this.t.debug("Skipping profiles sync");return}}const j=new P.DisposableStore,F=j.add(this.createSynchronizer(N));j.add(F.onDidChangeStatus(()=>this.H())),j.add(F.onDidChangeConflicts(()=>this.I())),j.add(F.onDidChangeLocal(()=>this.h.fire(N)));const A=this.J(N);this.c.push([F,A,j])}D(N){const j=this.c.findIndex(([F])=>F.resource===N);if(j!==-1){const[[F,,A]]=this.c.splice(j,1);A.dispose(),this.H(),Promise.allSettled([F.stop(),F.resetLocal()]).then(null,U=>this.t.error(U))}}createSynchronizer(N){switch(N){case"settings":return this.l.createInstance(n.SettingsSynchroniser,this.profile,this.collection);case"keybindings":return this.l.createInstance(f.KeybindingsSynchroniser,this.profile,this.collection);case"snippets":return this.l.createInstance(r.SnippetsSynchroniser,this.profile,this.collection);case"tasks":return this.l.createInstance(t.TasksSynchroniser,this.profile,this.collection);case"globalState":return this.l.createInstance(h.GlobalStateSynchroniser,this.profile,this.collection);case"extensions":return this.l.createInstance(l.ExtensionsSynchroniser,this.profile,this.collection);case"profiles":return this.l.createInstance(a.UserDataProfilesManifestSynchroniser,this.profile,this.collection)}}async sync(N,j,F,A){if(A.isCancellationRequested)return[];const U=this.enabled;if(!U.length)return[];try{const B=[],G=(0,s.createSyncHeaders)(F),W=(this.collection?N?.collections?.[this.collection]?.latest:N?.latest)??null,Z=j?await this.F(W):{};for(const $ of U){if(A.isCancellationRequested)return[];if(!this.k.isResourceEnabled($.resource))return[];try{if(j){const z=await $.preview(W,Z,G);if(z)for(const Y of z.resourcePreviews)(Y.localChange!==0||Y.remoteChange!==0)&&Y.mergeState==="preview"&&await $.merge(Y.previewResource)}else await $.sync(W,G)}catch(z){const Y=s.UserDataSyncError.toUserDataSyncError(z);if(T(Y,F,this.n,this.r),E(z))throw Y;this.t.error(z),this.t.error(`${$.resource}: ${(0,k.toErrorMessage)(z)}`),B.push([$.resource,Y])}}return B}finally{this.H()}}async apply(N,j){const F=(0,s.createSyncHeaders)(N);for(const A of this.enabled){if(j.isCancellationRequested)return;try{await A.apply(!1,F)}catch(U){const B=s.UserDataSyncError.toUserDataSyncError(U);if(T(B,N,this.n,this.r),E(U))throw B;this.t.error(U),this.t.error(`${A.resource}: ${(0,k.toErrorMessage)(U)}`)}}}async stop(){for(const N of this.enabled)try{N.status!=="idle"&&await N.stop()}catch(j){this.t.error(j)}}async resetLocal(){for(const N of this.enabled)try{await N.resetLocal()}catch(j){this.t.error(`${N.resource}: ${(0,k.toErrorMessage)(j)}`),this.t.error(j)}}async F(N){if(!this.profile.isDefault)return{};const j=this.w.getValue(s.USER_DATA_SYNC_CONFIGURATION_SCOPE),F=this.enabled.find(A=>A instanceof n.SettingsSynchroniser);if(F){const A=await F.getRemoteUserDataSyncConfiguration(N);return{...j,...A}}return j}G(N){this.f!==N&&(this.f=N,this.g.fire(N))}H(){return this.I(),this.enabled.some(N=>N.status==="hasConflicts")?this.G("hasConflicts"):this.enabled.some(N=>N.status==="syncing")?this.G("syncing"):this.G("idle")}I(){const N=this.enabled.filter(j=>j.status==="hasConflicts").filter(j=>j.conflicts.conflicts.length>0).map(j=>j.conflicts);(0,D.equals)(this.i,N,(j,F)=>j.syncResource===F.syncResource&&(0,D.equals)(j.conflicts,F.conflicts,(A,U)=>(0,I.isEqual)(A.previewResource,U.previewResource)))||(this.i=N,this.j.fire(N))}J(N){switch(N){case"profiles":return 0;case"settings":return 1;case"keybindings":return 2;case"snippets":return 3;case"tasks":return 4;case"globalState":return 5;case"extensions":return 6}}};y=pe([K(2,s.IUserDataSyncEnablementService),K(3,d.IInstantiationService),K(4,p.IExtensionGalleryService),K(5,s.IUserDataSyncStoreManagementService),K(6,u.ITelemetryService),K(7,s.IUserDataSyncLogService),K(8,g.IProductService),K(9,m.IUserDataProfilesService),K(10,C.IConfigurationService),K(11,w.IEnvironmentService)],y);function E(q){if(q instanceof s.UserDataSyncError)switch(q.code){case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function T(q,N,j,F){F.publicLog2("sync/error",{code:q.code,serverCode:q instanceof s.UserDataSyncStoreError?String(q.serverCode):void 0,url:q instanceof s.UserDataSyncStoreError?q.url:void 0,resource:q.resource,executionId:N,service:j.userDataSyncStore.url.toString()})}}),define(re[275],ae([0,1,3,2,8,18,26]),function(_,e,D,i,R,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;function P(w,p){return{...w,profile:(0,k.reviveProfile)(w.profile,p.profilesHome.scheme)}}function I(w){return{created:w.created,uri:R.URI.revive(w.uri)}}class S{constructor(p,d,g){this.c=p,this.d=d,this.f=g,this.a=new Map,this.b=new D.Emitter}listen(p,d){switch(d){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`Event not found: ${d}`)}async call(p,d,g){try{return await this.g(p,d,g)}catch(v){throw this.f.error(v),v}}async g(p,d,g){switch(d){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(R.URI.revive(g[0]));case"accept":return this.c.accept(P(g[0],this.d),R.URI.revive(g[1]),g[2],g[3]);case"getRemoteProfiles":return this.c.getRemoteProfiles();case"getLocalSyncResourceHandles":return this.c.getLocalSyncResourceHandles(g[0],(0,k.reviveProfile)(g[1],this.d.profilesHome.scheme));case"getRemoteSyncResourceHandles":return this.c.getRemoteSyncResourceHandles(g[0],g[1]);case"replace":return this.c.replace(I(g[0]));case"getAssociatedResources":return this.c.getAssociatedResources(I(g[0]));case"getMachineId":return this.c.getMachineId(I(g[0]));case"createManualSyncTask":return this.i()}if(d.startsWith("manualSync/")){const v=d.substring(11),u=g[0],m=this.h(u);switch(g=g.slice(1),v){case"merge":return m.merge();case"apply":return m.apply().finally(()=>this.a.delete(this.j(m.id)));case"stop":return m.stop().finally(()=>this.a.delete(this.j(m.id)))}}throw new Error("Invalid call")}h(p){const d=this.a.get(this.j(p));if(!d)throw new Error(`Manual sync taks not found: ${p}`);return d}async i(){const p=await this.c.createManualSyncTask();return this.a.set(this.j(p.id),p),p.id}j(p){return`manualSyncTask-${p}`}}e.UserDataSyncChannel=S;let b=class extends i.Disposable{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(p,d){super(),this.k=d,this.b="uninitialized",this.c=this.B(new D.Emitter),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new D.Emitter),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.i=this.B(new D.Emitter),this.onDidChangeLastSyncTime=this.i.event,this.j=this.B(new D.Emitter),this.onSyncErrors=this.j.event,this.a={call(g,v,u){return p.call(g,v,u).then(null,m=>{throw L.UserDataSyncError.toUserDataSyncError(m)})},listen(g,v){return p.listen(g,v)}},this.a.call("_getInitialData").then(([g,v,u])=>{this.l(g),this.m(v),u&&this.n(u),this.B(this.a.listen("onDidChangeStatus")(m=>this.l(m))),this.B(this.a.listen("onDidChangeLastSyncTime")(m=>this.n(m)))}),this.B(this.a.listen("onDidChangeConflicts")(g=>this.m(g))),this.B(this.a.listen("onSyncErrors")(g=>this.j.fire(g.map(v=>({...v,error:L.UserDataSyncError.toUserDataSyncError(v.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const p=await this.a.call("createManualSyncTask"),d=this;return new C(p,{async call(v,u,m){return d.a.call(`manualSync/${v}`,[p,...Array.isArray(u)?u:[u]],m)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(p,d,g,v){return this.a.call("accept",[p,d,g,v])}resolveContent(p){return this.a.call("resolveContent",[p])}getRemoteProfiles(){return this.a.call("getRemoteProfiles")}async getLocalSyncResourceHandles(p,d){return(await this.a.call("getLocalSyncResourceHandles",[p,d])).map(({created:v,uri:u})=>({created:v,uri:R.URI.revive(u)}))}async getRemoteSyncResourceHandles(p,d){return(await this.a.call("getRemoteSyncResourceHandles",[p,d])).map(({created:v,uri:u})=>({created:v,uri:R.URI.revive(u)}))}async getAssociatedResources(p){return(await this.a.call("getAssociatedResources",[p])).map(({resource:g,comparableResource:v})=>({resource:R.URI.revive(g),comparableResource:R.URI.revive(v)}))}getMachineId(p){return this.a.call("getMachineId",[p])}replace(p){return this.a.call("replace",[p])}async l(p){this.b=p,this.c.fire(p)}async m(p){this.f=p.map(d=>({syncResource:d.syncResource,profile:(0,k.reviveProfile)(d.profile,this.k.profilesHome.scheme),conflicts:d.conflicts.map(g=>({...g,baseResource:R.URI.revive(g.baseResource),localResource:R.URI.revive(g.localResource),remoteResource:R.URI.revive(g.remoteResource),previewResource:R.URI.revive(g.previewResource)}))})),this.g.fire(this.f)}n(p){this.h!==p&&(this.h=p,this.i.fire(p))}};b=pe([K(1,k.IUserDataProfilesService)],b),e.UserDataSyncChannelClient=b;class C extends i.Disposable{constructor(p,d){super(),this.id=p,this.a=d}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose")}}}),define(re[276],ae([0,1,6,21,9,3,2,138,5,22,15,8,31,16,13,14,23,47,45,19,26]),function(_,e,D,i,R,k,L,P,I,S,b,C,w,p,d,g,v,u,m,l,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const f="sync.previous.store",n="sync.donot-make-requests-until",r="sync.user-session-id",t="sync.machine-session-id",a=100,s=1e3*60*5;let c=class extends L.Disposable{get userDataSyncStore(){return this.b}get c(){return this.h.get(h.SYNC_SERVICE_URL_TYPE,-1)}set c(N){this.h.store(h.SYNC_SERVICE_URL_TYPE,N,-1,I.isWeb?0:1)}constructor(N,j,F){super(),this.f=N,this.g=j,this.h=F,this.a=this.B(new k.Emitter),this.onDidChangeUserDataSyncStore=this.a.event,this.i(),this.B(k.Event.filter(F.onDidChangeValue,A=>A.key===h.SYNC_SERVICE_URL_TYPE&&A.scope===-1&&this.c!==this.userDataSyncStore?.type)(()=>this.i()))}i(){this.b=this.j(this.f[h.CONFIGURATION_SYNC_STORE_KEY],this.g.getValue(h.CONFIGURATION_SYNC_STORE_KEY)),this.a.fire()}j(N,j){N=I.isWeb&&N?.web?{...N,...N.web}:N;const F={...N||{},...j||{}};if(F&&(0,b.isString)(F.url)&&(0,b.isObject)(F.authenticationProviders)&&Object.keys(F.authenticationProviders).every(A=>Array.isArray(F.authenticationProviders[A].scopes))){const A=F,U=!!A.canSwitch&&!j?.url,B=A.url===A.insidersUrl?"insiders":"stable",G=(U?this.c:void 0)||B,W=j?.url||(G==="insiders"?A.insidersUrl:G==="stable"?A.stableUrl:A.url);return{url:C.URI.parse(W),type:G,defaultType:B,defaultUrl:C.URI.parse(A.url),stableUrl:C.URI.parse(A.stableUrl),insidersUrl:C.URI.parse(A.insidersUrl),canSwitch:U,authenticationProviders:Object.keys(A.authenticationProviders).reduce((Z,$)=>(Z.push({id:$,scopes:A.authenticationProviders[$].scopes}),Z),[])}}}};c=pe([K(0,v.IProductService),K(1,p.IConfigurationService),K(2,l.IStorageService)],c),e.AbstractUserDataSyncStoreManagementService=c;let o=class extends c{constructor(N,j,F){super(N,j,F);const A=this.h.get(f,-1);A&&(this.k=JSON.parse(A));const U=this.f[h.CONFIGURATION_SYNC_STORE_KEY];U?this.h.store(f,JSON.stringify(U),-1,1):this.h.remove(f,-1)}async switch(N){N!==this.c&&(this.c=N,this.i())}async getPreviousUserDataSyncStore(){return this.j(this.k)}};o=pe([K(0,v.IProductService),K(1,p.IConfigurationService),K(2,l.IStorageService)],o),e.UserDataSyncStoreManagementService=o;let y=class extends L.Disposable{get donotMakeRequestsUntil(){return this.i}constructor(N,j,F,A,U,B,G){super(),this.k=F,this.l=A,this.n=G,this.g=this.B(new k.Emitter),this.onTokenFailed=this.g.event,this.h=this.B(new k.Emitter),this.onTokenSucceed=this.h.event,this.i=void 0,this.j=this.B(new k.Emitter),this.onDidChangeDonotMakeRequestsUntil=this.j.event,this.s=void 0,this.p(N),this.c=(0,m.getServiceMachineId)(U,B,G).then(W=>{const Z={"X-Client-Name":`${j.applicationName}${I.isWeb?"-web":""}`,"X-Client-Version":j.version};return j.commit&&(Z["X-Client-Commit"]=j.commit),Z}),this.f=new T(a,s,this.k,this.l),this.r(),this.B((0,L.toDisposable)(()=>{this.s&&(this.s.cancel(),this.s=void 0)}))}setAuthToken(N,j){this.b={token:N,type:j}}p(N){this.a=N?(0,S.joinPath)(N,"v1"):void 0}r(){const N=this.n.getNumber(n,-1);N&&Date.now()<N&&this.t(new Date(N))}t(N){this.i?.getTime()!==N?.getTime()&&(this.i=N,this.s&&(this.s.cancel(),this.s=void 0),this.i?(this.n.store(n,this.i.getTime(),-1,1),this.s=(0,D.createCancelablePromise)(j=>(0,D.timeout)(this.i.getTime()-Date.now(),j).then(()=>this.t(void 0))),this.s.then(null,j=>null)):this.n.remove(n,-1),this.j.fire())}async getAllCollections(N={}){if(!this.a)throw new Error("No settings sync store url configured.");const j=(0,S.joinPath)(this.a,"collection").toString();N={...N},N["Content-Type"]="application/json";const F=await this.w(j,{type:"GET",headers:N},[],i.CancellationToken.None);return await(0,u.asJson)(F)||[]}async createCollection(N={}){if(!this.a)throw new Error("No settings sync store url configured.");const j=(0,S.joinPath)(this.a,"collection").toString();N={...N},N["Content-Type"]=P.Mimes.text;const F=await this.w(j,{type:"POST",headers:N},[],i.CancellationToken.None),A=await(0,u.asTextOrError)(F);if(!A)throw new h.UserDataSyncStoreError("Server did not return the collection id",j,"NoCollection",F.res.statusCode,F.res.headers[h.HEADER_OPERATION_ID]);return A}async deleteCollection(N,j={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=N?(0,S.joinPath)(this.a,"collection",N).toString():(0,S.joinPath)(this.a,"collection").toString();j={...j},await this.w(F,{type:"DELETE",headers:j},[],i.CancellationToken.None)}async getAllResourceRefs(N,j){if(!this.a)throw new Error("No settings sync store url configured.");const F=this.u(this.a,j,N),A={},U=await this.w(F.toString(),{type:"GET",headers:A},[],i.CancellationToken.None);return(await(0,u.asJson)(U)||[]).map(({url:G,created:W})=>({ref:(0,S.relativePath)(F,F.with({path:G})),created:W*1e3}))}async resolveResourceContent(N,j,F,A={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=(0,S.joinPath)(this.u(this.a,F,N),j).toString();A={...A},A["Cache-Control"]="no-cache";const B=await this.w(U,{type:"GET",headers:A},[],i.CancellationToken.None);return await(0,u.asTextOrError)(B)}async deleteResource(N,j,F){if(!this.a)throw new Error("No settings sync store url configured.");const A=j!==null?(0,S.joinPath)(this.u(this.a,F,N),j).toString():this.u(this.a,F,N).toString(),U={};await this.w(A,{type:"DELETE",headers:U},[],i.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const N=(0,S.joinPath)(this.a,"resource").toString(),j={"Content-Type":P.Mimes.text};await this.w(N,{type:"DELETE",headers:j},[],i.CancellationToken.None)}async readResource(N,j,F,A={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=(0,S.joinPath)(this.u(this.a,F,N),"latest").toString();A={...A},A["Cache-Control"]="no-cache",j&&(A["If-None-Match"]=j.ref);const B=await this.w(U,{type:"GET",headers:A},[304],i.CancellationToken.None);let G=null;if(B.res.statusCode===304&&(G=j),G===null){const W=B.res.headers.etag;if(!W)throw new h.UserDataSyncStoreError("Server did not return the ref",U,"NoRef",B.res.statusCode,B.res.headers[h.HEADER_OPERATION_ID]);const Z=await(0,u.asTextOrError)(B);if(!Z&&B.res.statusCode===304)throw new h.UserDataSyncStoreError("Empty response",U,"EmptyResponse",B.res.statusCode,B.res.headers[h.HEADER_OPERATION_ID]);G={ref:W,content:Z}}return G}async writeResource(N,j,F,A,U={}){if(!this.a)throw new Error("No settings sync store url configured.");const B=this.u(this.a,A,N).toString();U={...U},U["Content-Type"]=P.Mimes.text,F&&(U["If-Match"]=F);const G=await this.w(B,{type:"POST",data:j,headers:U},[],i.CancellationToken.None),W=G.res.headers.etag;if(!W)throw new h.UserDataSyncStoreError("Server did not return the ref",B,"NoRef",G.res.statusCode,G.res.headers[h.HEADER_OPERATION_ID]);return W}async manifest(N,j={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,S.joinPath)(this.a,"manifest").toString();j={...j},j["Content-Type"]="application/json",N&&(j["If-None-Match"]=N.ref);const A=await this.w(F,{type:"GET",headers:j},[304],i.CancellationToken.None);let U=null;if(A.res.statusCode===304&&(U=N),!U){const G=A.res.headers.etag;if(!G)throw new h.UserDataSyncStoreError("Server did not return the ref",F,"NoRef",A.res.statusCode,A.res.headers[h.HEADER_OPERATION_ID]);const W=await(0,u.asTextOrError)(A);if(!W&&A.res.statusCode===304)throw new h.UserDataSyncStoreError("Empty response",F,"EmptyResponse",A.res.statusCode,A.res.headers[h.HEADER_OPERATION_ID]);W&&(U={...JSON.parse(W),ref:G})}const B=this.n.get(r,-1);return B&&U&&B!==U.session&&this.v(),U===null&&B&&this.v(),U&&this.n.store(r,U.session,-1,1),U}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteResources(),await this.deleteCollection(),this.v()}u(N,j,F){return j?(0,S.joinPath)(N,"collection",j,"resource",F):(0,S.joinPath)(N,"resource",F)}v(){this.n.remove(r,-1),this.n.remove(t,-1)}async w(N,j,F,A){if(!this.b)throw new h.UserDataSyncStoreError("No Auth Token Available",N,"Unauthorized",void 0,void 0);if(this.i&&Date.now()<this.i.getTime())throw new h.UserDataSyncStoreError(`${j.type} request '${N}' failed because of too many requests (429).`,N,"TooManyRequestsAndRetryAfter",void 0,void 0);this.t(void 0);const U=await this.c;j.headers={...j.headers||{},...U,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.y(j.headers),this.l.trace("Sending request to server",{url:N,type:j.type,headers:{...j.headers,authorization:void 0}});let B;try{B=await this.f.request(N,j,A)}catch($){if(!($ instanceof h.UserDataSyncStoreError)){let z="RequestFailed";const Y=(0,R.getErrorMessage)($).toLowerCase();Y.includes("xhr timeout")?z="RequestTimeout":Y.includes("protocol")&&Y.includes("not supported")?z="RequestProtocolNotSupported":Y.includes("request path contains unescaped characters")?z="RequestPathNotEscaped":Y.includes("headers must be an object")?z="RequestHeadersNotObject":(0,R.isCancellationError)($)&&(z="RequestCanceled"),$=new h.UserDataSyncStoreError(`Connection refused for the request '${N}'.`,N,z,void 0,void 0)}throw this.l.info("Request failed",N),$}const G=B.res.headers[h.HEADER_OPERATION_ID],W={url:N,status:B.res.statusCode,"execution-id":j.headers[h.HEADER_EXECUTION_ID],"operation-id":G},Z=(0,u.isSuccess)(B)||B.res.statusCode&&F.indexOf(B.res.statusCode)!==-1;if(Z?this.l.trace("Request succeeded",W):this.l.info("Request failed",W),B.res.statusCode===401)throw this.b=void 0,this.g.fire(),new h.UserDataSyncStoreError(`Request '${N}' failed because of Unauthorized (401).`,N,"Unauthorized",B.res.statusCode,G);if(this.h.fire(),B.res.statusCode===404)throw new h.UserDataSyncStoreError(`${j.type} request '${N}' failed because the requested resource is not found (404).`,N,"NotFound",B.res.statusCode,G);if(B.res.statusCode===409)throw new h.UserDataSyncStoreError(`${j.type} request '${N}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,N,"Conflict",B.res.statusCode,G);if(B.res.statusCode===410)throw new h.UserDataSyncStoreError(`${j.type} request '${N}' failed because the requested resource is not longer available (410).`,N,"Gone",B.res.statusCode,G);if(B.res.statusCode===412)throw new h.UserDataSyncStoreError(`${j.type} request '${N}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,N,"PreconditionFailed",B.res.statusCode,G);if(B.res.statusCode===413)throw new h.UserDataSyncStoreError(`${j.type} request '${N}' failed because of too large payload (413).`,N,"TooLarge",B.res.statusCode,G);if(B.res.statusCode===426)throw new h.UserDataSyncStoreError(`${j.type} request '${N}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,N,"UpgradeRequired",B.res.statusCode,G);if(B.res.statusCode===429){const $=B.res.headers["retry-after"];throw $?(this.t(new Date(Date.now()+parseInt($)*1e3)),new h.UserDataSyncStoreError(`${j.type} request '${N}' failed because of too many requests (429).`,N,"TooManyRequestsAndRetryAfter",B.res.statusCode,G)):new h.UserDataSyncStoreError(`${j.type} request '${N}' failed because of too many requests (429).`,N,"RemoteTooManyRequests",B.res.statusCode,G)}if(!Z)throw new h.UserDataSyncStoreError("Server returned "+B.res.statusCode,N,"Unknown",B.res.statusCode,G);return B}y(N){let j=this.n.get(t,-1);j===void 0&&(j=(0,w.generateUuid)(),this.n.store(t,j,-1,1)),N["X-Machine-Session-Id"]=j;const F=this.n.get(r,-1);F!==void 0&&(N["X-User-Session-Id"]=F)}};y=pe([K(1,v.IProductService),K(2,u.IRequestService),K(3,h.IUserDataSyncLogService),K(4,d.IEnvironmentService),K(5,g.IFileService),K(6,l.IStorageService)],y),e.UserDataSyncStoreClient=y;let E=class extends y{constructor(N,j,F,A,U,B,G){super(N.userDataSyncStore?.url,j,F,A,U,B,G),this.B(N.onDidChangeUserDataSyncStore(()=>this.p(N.userDataSyncStore?.url)))}};E=pe([K(0,h.IUserDataSyncStoreManagementService),K(1,v.IProductService),K(2,u.IRequestService),K(3,h.IUserDataSyncLogService),K(4,d.IEnvironmentService),K(5,g.IFileService),K(6,l.IStorageService)],E),e.UserDataSyncStoreService=E;class T{constructor(N,j,F,A){this.c=N,this.d=j,this.f=F,this.g=A,this.a=[],this.b=void 0}request(N,j,F){if(this.h()&&this.i(),j.url=N,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new h.UserDataSyncStoreError(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,N,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(N),this.f.request(j,F)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.RequestsSession=T}),define(re[277],ae([0,1,3,58,23,19,24,272,26,78,81]),function(_,e,D,i,R,k,L,P,I,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let C=class extends P.UserDataAutoSyncService{constructor(p,d,g,v,u,m,l,h,f,n,r){super(p,d,g,v,u,l,h,f,n,r),this.B(D.Event.debounce(D.Event.any(D.Event.map(m.onDidFocusWindow,()=>"windowFocus"),D.Event.map(m.onDidOpenWindow,()=>"windowOpen")),(t,a)=>t?[...t,a]:[a],1e3)(t=>this.triggerSync(t,!0,!1)))}};C=pe([K(0,R.IProductService),K(1,I.IUserDataSyncStoreManagementService),K(2,I.IUserDataSyncStoreService),K(3,I.IUserDataSyncEnablementService),K(4,I.IUserDataSyncService),K(5,i.INativeHostService),K(6,I.IUserDataSyncLogService),K(7,S.IUserDataSyncAccountService),K(8,L.ITelemetryService),K(9,b.IUserDataSyncMachinesService),K(10,k.IStorageService)],C),e.UserDataAutoSyncService=C}),define(re[278],ae([0,1,99,25,5,22]),function(_,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function L(S){function b(){let C=S.scheme===i.Schemas.file?(0,k.originalFSPath)(S):S.toString();return R.isLinux||(C=C.toLowerCase()),(0,D.createHash)("md5").update(C).digest("hex")}return{id:b(),configPath:S}}e.getWorkspaceIdentifier=L;function P(S,b){function C(){if(S.scheme!==i.Schemas.file)return(0,D.createHash)("md5").update(S.toString()).digest("hex");if(!b)return;let p;return R.isLinux?p=b.ino:R.isMacintosh?p=b.birthtime.getTime():R.isWindows&&(typeof b.birthtimeMs=="number"?p=Math.floor(b.birthtimeMs):p=b.birthtime.getTime()),(0,D.createHash)("md5").update(S.fsPath).update(p?String(p):"").digest("hex")}const w=C();if(typeof w=="string")return{id:w,uri:S}}e.getSingleFolderWorkspaceIdentifier=P;function I(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=I}),define(re[279],ae([0,1,6,9,2,12,28,13,57,7,58,76,115,278]),function(_,e,D,i,R,k,L,P,I,S,b,C,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let d=class extends R.Disposable{constructor(v,u,m,l){super(),this.a=v,this.b=u,this.c=m,this.f=l,this.B(new D.RunOnceScheduler(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const v=await L.Promises.readdir(this.a.workspaceStorageHome.fsPath),u=new C.StorageClient(this.f.getChannel("storage"));await Promise.all(v.map(async m=>{const l=(0,k.join)(this.a.workspaceStorageHome.fsPath,m);m.length===p.NON_EMPTY_WORKSPACE_ID_LENGTH||m===w.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.c.getWindows()).some(n=>n.workspace?.id===m)||await u.isUsed(l)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${m} as it seems to be an unused empty workspace.`),await L.Promises.rm(l))}))}catch(v){(0,i.onUnexpectedError)(v)}}};d=pe([K(0,P.INativeEnvironmentService),K(1,S.ILogService),K(2,b.INativeHostService),K(3,I.IMainProcessService)],d),e.UnusedWorkspaceStorageDataCleaner=d}),define(re[124],ae([0,1,53,6,12,15,28,150,288,289]),function(_,e,D,i,R,k,L,P,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class b extends Error{constructor(n,r){let t=r.message;switch(n){case"CorruptZip":t=`Corrupt ZIP: ${t}`;break}super(t),this.type=n,this.cause=r}}e.ExtractError=b;function C(f){const n=f.externalFileAttributes>>16||33188;return[448,56,7].map(r=>n&r).reduce((r,t)=>r+t,n&61440)}function w(f){if(f instanceof b)return f;let n;return/end of central directory record signature not found/.test(f.message)&&(n="CorruptZip"),new b(n,f)}function p(f,n,r,t,a,s){const c=R.dirname(n),o=R.join(t,c);if(!o.startsWith(t))return Promise.reject(new Error(P.localize(0,null,n)));const y=R.join(t,n);let E;return s.onCancellationRequested(()=>{E?.destroy()}),Promise.resolve(L.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((T,q)=>{if(!s.isCancellationRequested)try{E=(0,D.createWriteStream)(y,{mode:r}),E.once("close",()=>T()),E.once("error",q),f.once("error",q),f.pipe(E)}catch(N){q(N)}}))}function d(f,n,r,t){let a=(0,i.createCancelablePromise)(()=>Promise.resolve()),s=0;return t.onCancellationRequested(()=>{a.cancel(),f.close()}),new Promise((c,o)=>{const y=new i.Sequencer,E=T=>{T.isCancellationRequested||(s++,f.readEntry())};f.once("error",o),f.once("close",()=>a.then(()=>{t.isCancellationRequested||f.entryCount===s?c():o(new b("Incomplete",new Error(P.localize(1,null,s,f.entryCount))))},o)),f.readEntry(),f.on("entry",T=>{if(t.isCancellationRequested)return;if(!r.sourcePathRegex.test(T.fileName)){E(t);return}const q=T.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(q)){const F=R.join(n,q);a=(0,i.createCancelablePromise)(A=>L.Promises.mkdir(F,{recursive:!0}).then(()=>E(A)).then(void 0,o));return}const N=v(f,T),j=C(T);a=(0,i.createCancelablePromise)(F=>y.queue(()=>N.then(A=>p(A,q,j,n,r,F).then(()=>E(F)))).then(null,o))})})}function g(f,n=!1){return new Promise((r,t)=>{(0,I.open)(f,n?{lazyEntries:!0}:void 0,(a,s)=>{a?t(w(a)):r((0,k.assertIsDefined)(s))})})}function v(f,n){return new Promise((r,t)=>{f.openReadStream(n,(a,s)=>{a?t(w(a)):r((0,k.assertIsDefined)(s))})})}function u(f,n){return new Promise((r,t)=>{const a=new S.ZipFile;n.forEach(c=>{c.contents?a.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&a.addFile(c.localPath,c.path)}),a.end();const s=(0,D.createWriteStream)(f);a.outputStream.pipe(s),a.outputStream.once("error",t),s.once("error",t),s.once("finish",()=>r(f))})}e.zip=u;function m(f,n,r={},t){const a=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let s=g(f,!0);return r.overwrite&&(s=s.then(c=>L.Promises.rm(n).then(()=>c))),s.then(c=>d(c,n,{sourcePathRegex:a},t))}e.extract=m;function l(f,n){return g(f).then(r=>new Promise((t,a)=>{r.on("entry",s=>{s.fileName===n&&v(r,s).then(c=>t(c),c=>a(c))}),r.once("close",()=>a(new Error(P.localize(2,null,n))))}))}function h(f,n){return l(f,n).then(r=>new Promise((t,a)=>{const s=[];r.once("error",a),r.on("data",c=>s.push(c)),r.on("end",()=>t(Buffer.concat(s)))}))}e.buffer=h}),define(re[280],ae([0,1,124,160]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function R(k){return(0,D.buffer)(k,"extension/package.json").then(L=>{try{return JSON.parse(L.toString("utf8"))}catch{throw new Error((0,i.localize)(0,null))}})}e.getManifest=R}),define(re[125],ae([0,1,6,21,38,9,3,2,37,25,12,5,22,54,15,8,31,28,124,159,96,13,262,29,33,61,79,217,263,280,218,219,42,70,14,4,7,23,24,30,18]),function(_,e,D,i,R,k,L,P,I,S,b,C,w,p,d,g,v,u,m,l,h,f,n,r,t,a,s,c,o,y,E,T,q,N,j,F,A,U,B,G,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,F.refineServiceDecorator)(r.IExtensionManagementService);let Z=class extends n.AbstractExtensionManagementService{constructor(O,M,H,V,X,se,x,ie,ne,le,ue,ye){super(O,M,H,le,ye),this.Y=X,this.Z=se,this.ab=x,this.bb=ne,this.cb=ue,this.X=new Map,this.kb=new I.ResourceSet;const Se=this.B(ie.createInstance(o.ExtensionsLifecycle));this.S=this.B(ie.createInstance($,Ee=>Se.postUninstall(Ee))),this.U=this.B(new E.ExtensionsManifestCache(V,this)),this.W=this.B(ie.createInstance(c.ExtensionsDownloader,this.getTargetPlatform()));const be=this.B(new T.ExtensionsWatcher(this,this.Y,ye,se,ue,ne,H));this.B(be.onDidChangeExtensionsByAnotherSource(Ee=>this.jb(Ee))),this.lb()}getTargetPlatform(){return this.db||(this.db=(0,t.computeTargetPlatform)(this.bb,this.v)),this.db}async zip(O){this.v.trace("ExtensionManagementService#zip",O.identifier.id);const M=await this.ib(O),H=await(0,m.zip)((0,w.joinPath)(this.W.extensionsDownloadDir,(0,v.generateUuid)()).fsPath,M);return g.URI.file(H)}async unzip(O){return this.v.trace("ExtensionManagementService#unzip",O.toString()),(await this.install(O)).identifier}async getManifest(O){const{location:M,cleanup:H}=await this.eb(O),V=b.resolve(M.fsPath);try{return await(0,y.getManifest)(V)}finally{await H()}}getInstalled(O,M){return this.S.scanExtensions(O??null,M)}getAllUserInstalled(){return this.S.scanAllUserExtensions(!1)}async install(O,M={}){this.v.trace("ExtensionManagementService#install",O.toString());const{location:H,cleanup:V}=await this.eb(O);try{const X=await(0,y.getManifest)(b.resolve(H.fsPath));if(X.engines&&X.engines.vscode&&!(0,N.isEngineValid)(X.engines.vscode,this.w.version,this.w.date))throw new Error(l.localize(0,null,(0,t.getGalleryExtensionId)(X.publisher,X.name),this.w.version));return await this.z(X,H,M)}finally{await V()}}async installFromLocation(O,M){this.v.trace("ExtensionManagementService#installFromLocation",O.toString());const H=await this.S.scanUserExtensionAtLocation(O);if(!H)throw new Error(`Cannot find a valid extension from the location ${O.toString()}`);return await this.nb([H],M),this.v.info("Successfully installed extension",H.identifier.id,M.toString()),H}getMetadata(O){return this.Y.scanMetadata(O.location)}async updateMetadata(O,M){this.v.trace("ExtensionManagementService#updateMetadata",O.identifier.id);const H={...M};return M.isPreReleaseVersion&&(H.preRelease=!0),O=await this.S.updateMetadata(O,H),this.U.invalidate(),O}async updateExtensionScope(O,M){return this.v.trace("ExtensionManagementService#updateExtensionScope",O.identifier.id),O=await this.S.updateMetadata(O,{isMachineScoped:M}),this.U.invalidate(),O}async reinstallFromGallery(O){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",O.identifier.id),!this.t.isEnabled())throw new Error(l.localize(1,null));const M=await this.getTargetPlatform(),[H]=await this.t.getExtensions([{...O.identifier,preRelease:O.preRelease}],{targetPlatform:M,compatible:!0},i.CancellationToken.None);if(!H)throw new Error(l.localize(2,null));await this.S.setUninstalled(O);try{await this.S.removeUninstalledExtension(O)}catch(V){throw new Error(l.localize(3,null,(0,R.toErrorMessage)(V)))}await this.installFromGallery(H)}markAsUninstalled(...O){return this.S.setUninstalled(...O)}removeUninstalledExtensions(){return this.S.cleanUp()}async download(O,M){const{location:H}=await this.W.download(O,M);return H}async eb(O){if(O.scheme===S.Schemas.file)return{location:O,async cleanup(){}};this.v.trace("Downloading extension from",O.toString());const M=(0,w.joinPath)(this.W.extensionsDownloadDir,(0,v.generateUuid)());return await this.ab.download(O,M),this.v.info("Downloaded extension to",M.toString()),{location:M,cleanup:async()=>{try{await this.bb.del(M)}catch(V){this.v.error(V)}}}}P(){return this.y.defaultProfile.extensionsResource}Q(O,M,H){let V;if(g.URI.isUri(M))V=new ee(O,M,H,this.t,this.S,this.v);else{const X=t.ExtensionKey.create(M).toString();V=this.X.get(X),V||(this.X.set(X,V=new Y(O,M,H,this.W,this.S,this.v)),V.waitUntilTaskIsFinished().then(()=>this.X.delete(X)))}return new oe(V,H.profileLocation,this.Z)}R(O,M){return new J(O,M.profileLocation,this.Z)}async ib(O){const M=async V=>{let X=await u.Promises.readdir(V);X=X.map(ie=>b.join(V,ie));const se=await Promise.all(X.map(ie=>u.Promises.stat(ie)));let x=Promise.resolve([]);return se.forEach((ie,ne)=>{const le=X[ne];ie.isFile()&&(x=x.then(ue=>[...ue,le])),ie.isDirectory()&&(x=x.then(ue=>M(le).then(ye=>[...ue,...ye])))}),x};return(await M(O.location.fsPath)).map(V=>({path:`extension/${b.relative(O.location.fsPath,V)}`,localPath:V}))}async jb({added:O,removed:M}){if(M)for(const H of M.extensions)this.v.info("Extensions removed from another source",H.id,M.profileLocation.toString()),this.p.fire({identifier:H,profileLocation:M.profileLocation});if(O){const V=(await this.S.scanExtensions(1,O.profileLocation)).filter(X=>O.extensions.some(se=>(0,t.areSameExtensions)(se,X.identifier)));this.m.fire(V.map(X=>(this.v.info("Extensions added from another source",X.identifier.id,O.profileLocation.toString()),{identifier:X.identifier,local:X,profileLocation:O.profileLocation,operation:1})))}}async lb(){this.B(this.S.onExtract(M=>this.kb.add(M)));const O=await this.bb.resolve(this.Y.userExtensionsLocation);for(const M of O.children??[])M.isDirectory&&this.kb.add(M.resource);this.B(this.bb.watch(this.Y.userExtensionsLocation)),this.B(this.bb.onDidFilesChange(M=>this.mb(M)))}async mb(O){const M=[];for(const H of O.rawAdded){if(this.kb.has(H)||!this.cb.extUri.isEqual(this.cb.extUri.dirname(H),this.Y.userExtensionsLocation)||this.cb.extUri.isEqual(H,this.cb.extUri.joinPath(this.Y.userExtensionsLocation,".obsolete"))||this.cb.extUri.basename(H).startsWith(".")||!(await this.bb.stat(H)).isDirectory)continue;const V=await this.S.scanUserExtensionAtLocation(H);V&&V.installedTimestamp===void 0&&(this.kb.add(H),M.push(V))}M.length&&(await this.nb(M,this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",M.map(H=>H.identifier.id)))}async nb(O,M){await this.Z.addExtensionsToProfile(O.map(H=>[H,void 0]),M),this.m.fire(O.map(H=>({local:H,identifier:H.identifier,operation:1,profileLocation:M})))}};Z=pe([K(0,r.IExtensionGalleryService),K(1,B.ITelemetryService),K(2,A.ILogService),K(3,f.INativeEnvironmentService),K(4,s.IExtensionsScannerService),K(5,a.IExtensionsProfileScannerService),K(6,h.IDownloadService),K(7,F.IInstantiationService),K(8,j.IFileService),K(9,U.IProductService),K(10,G.IUriIdentityService),K(11,W.IUserDataProfilesService)],Z),e.ExtensionManagementService=Z;let $=class extends P.Disposable{constructor(O,M,H,V){super(),this.j=O,this.k=M,this.l=H,this.m=V,this.h=this.B(new L.Emitter),this.onExtract=this.h.event,this.c=(0,w.joinPath)(this.l.userExtensionsLocation,".obsolete").fsPath,this.g=new D.Queue}async cleanUp(){await this.v()}async scanExtensions(O,M){await this.l.initializeDefaultProfileExtensions();const H={includeInvalid:!0,profileLocation:M};let V=[];return O===null||O===0?V.push(...await this.l.scanAllExtensions({includeInvalid:!0},H,!1)):O===1&&V.push(...await this.l.scanUserExtensions(H)),V=O!==null?V.filter(X=>X.type===O):V,Promise.all(V.map(X=>this.u(X)))}async scanAllUserExtensions(O){const M=await this.l.scanUserExtensions({includeAllVersions:!O,includeInvalid:!0});return Promise.all(M.map(H=>this.u(H)))}async scanUserExtensionAtLocation(O){try{const M=await this.l.scanExistingExtension(O,1,{includeInvalid:!0});if(M)return await this.u(M)}catch(M){this.m.error(M)}return null}async extractUserExtension(O,M,H,V){await this.l.initializeDefaultProfileExtensions();const X=O.toString(),se=b.join(this.l.userExtensionsLocation.fsPath,`.${(0,v.generateUuid)()}`),x=b.join(this.l.userExtensionsLocation.fsPath,X);try{await u.Promises.rm(x)}catch{throw new r.ExtensionManagementError(l.localize(4,null,x,O.id),r.ExtensionManagementErrorCode.Delete)}await this.p(O,M,se,V),await this.l.updateMetadata(g.URI.file(se),H);try{this.h.fire(g.URI.file(x)),await this.s(O,se,x,Date.now()+2*60*1e3),this.m.info("Renamed to",x)}catch(ie){try{await u.Promises.rm(se)}catch{}if(ie.code==="ENOTEMPTY")this.m.info("Rename failed because extension was installed by another source. So ignoring renaming.",O.id);else throw this.m.info(`Rename failed because of ${(0,k.getErrorMessage)(ie)}. Deleted from extracted location`,se),ie}return this.t(g.URI.file(x),1)}async updateMetadata(O,M){return await this.l.updateMetadata(O.location,M),this.t(O.location,O.type)}getUninstalledExtensions(){return this.n()}async setUninstalled(...O){const M=O.map(H=>t.ExtensionKey.create(H));await this.n(H=>M.forEach(V=>{H[V.toString()]=!0,this.m.info("Marked extension as uninstalled",V.toString())}))}async setInstalled(O){await this.n(V=>delete V[O.toString()]);const H=(await this.scanAllUserExtensions(!0)).find(V=>t.ExtensionKey.create(V).equals(O))||null;return H?this.updateMetadata(H,{installedTimestamp:Date.now()}):null}async removeExtension(O,M){this.m.trace(`Deleting ${M} extension from disk`,O.identifier.id,O.location.fsPath),await u.Promises.rm(O.location.fsPath),this.m.info("Deleted from disk",O.identifier.id,O.location.fsPath)}async removeUninstalledExtension(O){await this.removeExtension(O,"uninstalled"),await this.n(M=>delete M[t.ExtensionKey.create(O).toString()])}async n(O){return this.g.queue(async()=>{let M;try{M=await u.Promises.readFile(this.c,"utf8")}catch(V){if(V.code!=="ENOENT")throw V}let H={};if(M)try{H=JSON.parse(M)}catch{}return O&&(O(H),Object.keys(H).length?await u.Promises.writeFile(this.c,JSON.stringify(H)):await u.Promises.rm(this.c)),H})}async p(O,M,H,V){this.m.trace(`Started extracting the extension from ${M} to ${H}`);try{await u.Promises.rm(H)}catch(X){throw new r.ExtensionManagementError(this.w(X).message,r.ExtensionManagementErrorCode.Delete)}try{await(0,m.extract)(M,H,{sourcePath:"extension",overwrite:!0},V),this.m.info(`Extracted extension to ${H}:`,O.id)}catch(X){try{await u.Promises.rm(H)}catch{}let se=r.ExtensionManagementErrorCode.Extract;throw X instanceof m.ExtractError&&(X.type==="CorruptZip"?se=r.ExtensionManagementErrorCode.CorruptZip:X.type==="Incomplete"&&(se=r.ExtensionManagementErrorCode.IncompleteZip)),new r.ExtensionManagementError(X.message,se)}}async s(O,M,H,V){try{await u.Promises.rename(M,H)}catch(X){if(C.isWindows&&X&&X.code==="EPERM"&&Date.now()<V)return this.m.info(`Failed renaming ${M} to ${H} with 'EPERM' error. Trying again...`,O.id),this.s(O,M,H,V);throw new r.ExtensionManagementError(X.message||l.localize(5,null,M,H),X.code||r.ExtensionManagementErrorCode.Rename)}}async t(O,M){const H=await this.l.scanExistingExtension(O,M,{includeInvalid:!0});if(H)return this.u(H);throw new Error(l.localize(6,null,O.path))}async u(O){const M=await this.k.resolve(O.location);let H,V;return M.children&&(H=M.children.find(({name:X})=>/^readme(\.txt|\.md|)$/i.test(X))?.resource,V=M.children.find(({name:X})=>/^changelog(\.txt|\.md|)$/i.test(X))?.resource),{identifier:O.identifier,type:O.type,isBuiltin:O.isBuiltin||!!O.metadata?.isBuiltin,location:O.location,manifest:O.manifest,targetPlatform:O.targetPlatform,validations:O.validations,isValid:O.isValid,readmeUrl:H,changelogUrl:V,publisherDisplayName:O.metadata?.publisherDisplayName||null,publisherId:O.metadata?.publisherId||null,isApplicationScoped:!!O.metadata?.isApplicationScoped,isMachineScoped:!!O.metadata?.isMachineScoped,isPreReleaseVersion:!!O.metadata?.isPreReleaseVersion,preRelease:!!O.metadata?.preRelease,installedTimestamp:O.metadata?.installedTimestamp,updated:!!O.metadata?.updated}}async v(){const O=await this.getUninstalledExtensions(),M=await this.l.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),H=new Set;for(const se of M)O[t.ExtensionKey.create(se).toString()]||H.add(se.identifier.id.toLowerCase());const V=(0,t.groupByExtension)(M,se=>se.identifier);await D.Promises.settled(V.map(async se=>{const x=se.sort((ie,ne)=>p.rcompare(ie.manifest.version,ne.manifest.version))[0];H.has(x.identifier.id.toLowerCase())||await this.j(await this.u(x))}));const X=M.filter(se=>O[t.ExtensionKey.create(se).toString()]);await D.Promises.settled(X.map(se=>this.removeUninstalledExtension(se)))}w(O){const M=Array.isArray(O)?O:[O];return M.length===1?M[0]instanceof Error?M[0]:new Error(M[0]):M.reduce((H,V)=>new Error(`${H.message}${H.message?",":""}${V instanceof Error?V.message:V}`),new Error(""))}};$=pe([K(1,j.IFileService),K(2,s.IExtensionsScannerService),K(3,A.ILogService)],$),e.ExtensionsScanner=$;class z extends n.AbstractExtensionTask{get operation(){return(0,d.isUndefined)(this.k.operation)?this.j:this.k.operation}constructor(O,M,H,V,X){super(),this.identifier=O,this.source=M,this.k=H,this.l=V,this.m=X,this.wasVerified=!1,this.j=2}async n(O,M){try{const H=await this.o(O.key);if(H)return this.l.updateMetadata(H,O.metadata)}catch{throw C.isMacintosh?new r.ExtensionManagementError(l.localize(7,null),r.ExtensionManagementErrorCode.Internal):new r.ExtensionManagementError(l.localize(8,null),r.ExtensionManagementErrorCode.Internal)}return this.q(O,M)}async o(O){if(!await this.p(O))return null;this.m.trace("Removing the extension from uninstalled list:",O.id);const H=await this.l.setInstalled(O);return this.m.info("Removed the extension from uninstalled list:",O.id),H}async p(O){return!!(await this.l.getUninstalledExtensions())[O.toString()]}async q({zipPath:O,key:M,metadata:H},V){const X=await this.l.extractUserExtension(M,O,H,V);return this.m.info("Extracting completed.",M.id),X}}class Y extends z{constructor(O,M,H,V,X,se){super(M.identifier,M,H,X,se),this.s=O,this.t=M,this.u=V}async h(O){const H=(await this.l.scanExtensions(null,void 0)).find(x=>(0,t.areSameExtensions)(x.identifier,this.t.identifier));H&&(this.j=3);const V={id:this.t.identifier.uuid,publisherId:this.t.publisherId,publisherDisplayName:this.t.publisherDisplayName,targetPlatform:this.t.properties.targetPlatform,isApplicationScoped:(0,q.isApplicationScopedExtension)(this.s),isMachineScoped:this.k.isMachineScoped||H?.isMachineScoped,isBuiltin:this.k.isBuiltin||H?.isBuiltin,isSystem:H?.type===0?!0:void 0,updated:!!H,isPreReleaseVersion:this.t.properties.isPreReleaseVersion,installedTimestamp:Date.now(),preRelease:this.t.properties.isPreReleaseVersion||((0,d.isBoolean)(this.k.installPreReleaseVersion)?this.k.installPreReleaseVersion:H?.preRelease)};if(H?.manifest.version===this.t.version)return{local:await this.l.updateMetadata(H,V),metadata:V};const{location:X,verified:se}=await this.u.download(this.t,this.j);try{return this.wasVerified=!!se,this.w(X.fsPath),{local:await this.n({zipPath:X.fsPath,key:t.ExtensionKey.create(this.t),metadata:V},O),metadata:V}}catch(x){try{await this.u.delete(X)}catch(ie){this.m.warn("Error while deleting the downloaded file",X.toString(),(0,k.getErrorMessage)(ie))}throw x}}async w(O){try{await(0,y.getManifest)(O)}catch(M){throw new r.ExtensionManagementError((0,n.joinErrors)(M).message,r.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=Y;class ee extends z{constructor(O,M,H,V,X,se){super({id:(0,t.getGalleryExtensionId)(O.publisher,O.name)},M,H,X,se),this.s=O,this.t=M,this.u=V}async h(O){const M=new t.ExtensionKey(this.identifier,this.s.version),V=(await this.l.scanExtensions(1,void 0)).find(x=>(0,t.areSameExtensions)(this.identifier,x.identifier)),X=await this.w(this.identifier.id,this.s.version,O);if(X.isApplicationScoped=(0,q.isApplicationScopedExtension)(this.s),X.isMachineScoped=this.k.isMachineScoped||V?.isMachineScoped,X.isBuiltin=this.k.isBuiltin||V?.isBuiltin,X.installedTimestamp=Date.now(),V)if(this.j=3,M.equals(new t.ExtensionKey(V.identifier,V.manifest.version)))try{await this.l.removeExtension(V,"existing")}catch{throw new Error(l.localize(9,null,this.s.displayName||this.s.name))}else!this.k.profileLocation&&p.gt(V.manifest.version,this.s.version)&&await this.l.setUninstalled(V);else{const x=await this.o(M);if(x)try{await this.l.removeExtension(x,"existing")}catch{throw new Error(l.localize(10,null,this.s.displayName||this.s.name))}}return{local:await this.n({zipPath:b.resolve(this.t.fsPath),key:M,metadata:X},O),metadata:X}}async w(O,M,H){try{let[V]=await this.u.getExtensions([{id:O,version:M}],H);if(V||([V]=await this.u.getExtensions([{id:O}],H)),V)return{id:V.identifier.uuid,publisherDisplayName:V.publisherDisplayName,publisherId:V.publisherId,isPreReleaseVersion:V.properties.isPreReleaseVersion,preRelease:V.properties.isPreReleaseVersion||this.k.installPreReleaseVersion}}catch{}return{}}}class oe{constructor(O,M,H){this.d=O,this.g=M,this.h=H,this.identifier=this.d.identifier,this.source=this.d.source,this.operation=this.d.operation,this.c=this.j()}async j(){const O=await this.d.waitUntilTaskIsFinished();return await this.h.addExtensionsToProfile([[O.local,O.metadata]],this.g),O}async run(){return await this.d.run(),this.c}waitUntilTaskIsFinished(){return this.c}cancel(){return this.d.cancel()}}class J extends n.AbstractExtensionTask{constructor(O,M,H){super(),this.extension=O,this.j=M,this.k=H}async h(O){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(re[281],ae([0,1,2,29,80,216,125,7,19]),function(_,e,D,i,R,k,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsContributions=void 0;let S=class extends D.Disposable{constructor(C,w,p,d,g,v){super(),C.removeUninstalledExtensions(),(0,k.migrateUnsupportedExtensions)(C,w,p,d,v),R.ExtensionStorageService.removeOutdatedExtensionVersions(C,g)}};S=pe([K(0,L.INativeServerExtensionManagementService),K(1,i.IExtensionGalleryService),K(2,R.IExtensionStorageService),K(3,i.IGlobalExtensionEnablementService),K(4,I.IStorageService),K(5,P.ILogService)],S),e.ExtensionsContributions=S}),define(re[290],ae([0,1,93,34,38,9,2,25,22,8,39,148,209,210,202,203,279,191,194,16,214,95,234,96,225,13,231,116,265,29,97,193,266,125,98,189,14,205,207,55,4,200,72,201,57,73,220,7,102,58,103,23,47,19,267,108,24,109,110,111,51,239,112,241,247,80,114,26,78,270,258,259,81,271,274,275,276,277,269,62,260,107,233,77,249,222,248,106,230,30,250,5,251,195,212,211,79,264,18,61,208,59,268,228,238,261,235,105,101,273,281]),function(_,e,D,i,R,k,L,P,I,S,b,C,w,p,d,g,v,u,m,l,h,f,n,r,t,a,s,c,o,y,E,T,q,N,j,F,A,U,B,G,W,Z,$,z,Y,ee,oe,J,Q,O,M,H,V,X,se,x,ie,ne,le,ue,ye,Se,be,Ee,Ne,Fe,Ye,Be,ce,de,ge,Ce,Pe,Ae,De,je,Te,Me,ze,ke,Oe,te,he,fe,me,we,Ie,Re,He,$e,Le,qe,Ge,et,at,wt,At,Lt,vt,St,Tt,bt,Ot,Nt,Ut,Mt,Ft,Et,Ct,jt,$t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Bt extends L.Disposable{constructor(ve){super(),this.f=ve,this.a=this.B(new C.Server),this.b=void 0,this.c=void 0,this.g()}g(){const ve=async()=>{this.c&&(await this.c.fireOnWillShutdown(),this.c.dispose(),this.c=void 0),this.dispose()};process.once("exit",ve),D.ipcRenderer.once("vscode:electron-main->shared-process=exit",ve);const Ue="vscode:electron-main->shared-process=disposeWorker",We=(Je,tt)=>{this.h(tt)};D.ipcRenderer.on(Ue,We),this.B((0,L.toDisposable)(()=>D.ipcRenderer.removeListener(Ue,We)))}h(ve){this.b?.disposeWorker(ve)}async open(){const ve=await this.i();(0,Be.registerConfiguration)(),ve.invokeFunction(Ue=>{const We=Ue.get(J.ILogService);We.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(Ue),this.k(We)}),this.B((0,L.combinedDisposable)(ve.createInstance(w.CodeCacheCleaner,this.f.codeCachePath),ve.createInstance(p.LanguagePackCachedDataCleaner),ve.createInstance(v.UnusedWorkspaceStorageDataCleaner),ve.createInstance(g.LogsDataCleaner),ve.createInstance(d.LocalizationsUpdater),ve.createInstance($t.ExtensionsContributions),ve.createInstance(Mt.UserDataProfilesCleaner)))}async i(){const ve=new $.ServiceCollection,Ue={_serviceBrand:void 0,...M.default};ve.set(H.IProductService,Ue);const We=new b.StaticRouter(Qe=>Qe==="main"),Je=new z.MessagePortMainProcessService(this.a,We);ve.set(Y.IMainProcessService,Je);const tt=this.f.policiesData?new Tt.PolicyChannelClient(this.f.policiesData,Je.getChannel("policy")):new bt.NullPolicyService;ve.set(bt.IPolicyService,tt);const Ke=new s.SharedProcessEnvironmentService(this.f.args,Ue);ve.set(a.INativeEnvironmentService,Ke);const lt=new Q.LogLevelChannelClient(this.a.getChannel("logLevel",We)),it=new Q.LoggerChannelClient(this.f.logLevel,lt.onDidChangeLogLevel,Je.getChannel("logger"));ve.set(J.ILoggerService,it);const ht=this.B(new J.MultiplexLogService([this.B(new J.ConsoleLogger(this.f.logLevel)),this.B(it.createLogger((0,I.joinPath)(S.URI.file(Ke.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),xe=this.B(new Q.FollowerLogService(lt,ht));ve.set(J.ILogService,xe),this.c=new Ct.SharedProcessLifecycleService(xe),ve.set(Ct.ISharedProcessLifecycleService,this.c),this.b=new He.SharedProcessWorkerService(xe),ve.set(Re.ISharedProcessWorkerService,this.b);const _e=this.B(new U.FileService(xe));ve.set(A.IFileService,_e);const ft=this.B(new B.DiskFileSystemProvider(xe));_e.registerProvider(P.Schemas.file,ft);const dt=this.B(new Ge.FileUserDataProvider(P.Schemas.file,this.B(new et.DiskFileSystemProviderClient(Je.getChannel(et.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:qe.isLinux})),P.Schemas.vscodeUserData,xe));_e.registerProvider(P.Schemas.vscodeUserData,dt);const nt=this.B(new Ot.UserDataProfilesNativeService(this.f.profiles,Je,Ke));ve.set(vt.IUserDataProfilesService,nt);const Xe=this.B(new h.ConfigurationService(nt.defaultProfile.settingsResource,_e,tt,xe));ve.set(l.IConfigurationService,Xe);const ot=new se.NativeStorageService(void 0,{defaultProfile:nt.defaultProfile,currentProfile:nt.defaultProfile},Je,Ke);ve.set(X.IStorageService,ot),this.B((0,L.toDisposable)(()=>ot.flush())),await Promise.all([Xe.initialize(),ot.initialize()]),ve.set($e.IUriIdentityService,new Le.UriIdentityService(_e)),ve.set(V.IRequestService,new Nt.SharedProcessRequestService(Je,Xe,Ue,xe)),ve.set(u.IChecksumService,new G.SyncDescriptor(m.ChecksumService,void 0,!1)),ve.set(wt.IV8InspectProfilingService,new G.SyncDescriptor(at.InspectProfilingService,void 0,!1));const ut=b.ProxyChannel.toService(Je.getChannel("nativeHost"),{context:this.f.windowId});ve.set(O.INativeHostService,ut),ve.set(r.IDownloadService,new G.SyncDescriptor(t.DownloadService,void 0,!0));const gt=this.B(new Oe.ActiveWindowManager(ut)),mt=new b.StaticRouter(Qe=>gt.getActiveClientId().then(pt=>Qe===pt));ve.set(j.IExtensionRecommendationNotificationService,new F.ExtensionRecommendationNotificationServiceChannelClient(this.a.getChannel("extensionRecommendationNotification",mt)));let st;const ct=[],Pt=(0,ye.isInternalTelemetry)(Ue,Xe);if((0,ye.supportsTelemetry)(Ue,Ke)){const Qe=new le.TelemetryLogAppender(it,Ke);ct.push(Qe);const{installSourcePath:pt}=Ke;if(Ue.aiConfig?.ariaKey){const Dt=new Ut.OneDataSystemAppender(Pt,"monacoworkbench",null,Ue.aiConfig.ariaKey);this.B((0,L.toDisposable)(()=>Dt.flush())),ct.push(Dt)}st=new ue.TelemetryService({appenders:ct,commonProperties:(0,x.resolveCommonProperties)(_e,(0,i.release)(),(0,i.hostname)(),process.arch,Ue.commit,Ue.version,this.f.machineId,Pt,pt),sendErrorTelemetry:!0,piiPaths:(0,ye.getPiiPathsFromEnvironment)(Ke)},Xe,Ue)}else{st=ye.NullTelemetryService;const Qe=ye.NullAppender;ct.push(Qe)}this.a.registerChannel("telemetryAppender",new ne.TelemetryAppenderChannel(ct)),ve.set(ie.ITelemetryService,st);const qt=new Se.CustomEndpointTelemetryService(Xe,st,it,Ke,Ue);ve.set(ie.ICustomEndpointTelemetryService,qt),ve.set(St.IExtensionsProfileScannerService,new G.SyncDescriptor(St.ExtensionsProfileScannerService,void 0,!0)),ve.set(At.IExtensionsScannerService,new G.SyncDescriptor(Lt.ExtensionsScannerService,void 0,!0)),ve.set(E.IExtensionSignatureVerificationService,new G.SyncDescriptor(E.ExtensionSignatureVerificationService,void 0,!0)),ve.set(N.INativeServerExtensionManagementService,new G.SyncDescriptor(N.ExtensionManagementService,void 0,!0)),ve.set(y.IExtensionGalleryService,new G.SyncDescriptor(o.ExtensionGalleryService,void 0,!0)),ve.set(y.IExtensionTipsService,new G.SyncDescriptor(q.ExtensionTipsService,void 0,!1)),ve.set(ee.ILanguagePackService,new G.SyncDescriptor(oe.NativeLanguagePackService,void 0,!1)),ve.set(f.IDiagnosticsService,new G.SyncDescriptor(n.DiagnosticsService,void 0,!1)),ve.set(ce.IUserDataSyncAccountService,new G.SyncDescriptor(ce.UserDataSyncAccountService,void 0,!0)),ve.set(Be.IUserDataSyncLogService,new G.SyncDescriptor(Ce.UserDataSyncLogService,void 0,!0)),ve.set(Be.IUserDataSyncUtilService,new ge.UserDataSyncUtilServiceClient(this.a.getChannel("userDataSyncUtil",Qe=>Qe.ctx!=="main"))),ve.set(y.IGlobalExtensionEnablementService,new G.SyncDescriptor(c.GlobalExtensionEnablementService,void 0,!1)),ve.set(Ye.IIgnoredExtensionsManagementService,new G.SyncDescriptor(Ye.IgnoredExtensionsManagementService,void 0,!0)),ve.set(Fe.IExtensionStorageService,new G.SyncDescriptor(Fe.ExtensionStorageService)),ve.set(Be.IUserDataSyncStoreManagementService,new G.SyncDescriptor(Te.UserDataSyncStoreManagementService,void 0,!0)),ve.set(Be.IUserDataSyncStoreService,new G.SyncDescriptor(Te.UserDataSyncStoreService,void 0,!0)),ve.set(Pe.IUserDataSyncMachinesService,new G.SyncDescriptor(Pe.UserDataSyncMachinesService,void 0,!0)),ve.set(Be.IUserDataSyncBackupStoreService,new G.SyncDescriptor(de.UserDataSyncBackupStoreService,void 0,!1)),ve.set(Be.IUserDataSyncEnablementService,new G.SyncDescriptor(Ae.UserDataSyncEnablementService,void 0,!0)),ve.set(Be.IUserDataSyncService,new G.SyncDescriptor(De.UserDataSyncService,void 0,!1)),ve.set(ke.IUserDataProfileStorageService,new G.SyncDescriptor(ze.UserDataProfileStorageService,void 0,!0)),ve.set(Be.IUserDataSyncResourceProviderService,new G.SyncDescriptor(jt.UserDataSyncResourceProviderService,void 0,!0));const Rt=new Ne.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Xe.getValue("terminal.integrated.persistentSessionScrollback")??100},Xe,Ke,xe);return Rt.initialize(),ve.set(Ee.ILocalPtyService,this.B(Rt)),ve.set(te.ISignService,new G.SyncDescriptor(he.SignService,void 0,!1)),ve.set(fe.ISharedTunnelsService,new G.SyncDescriptor(me.SharedTunnelsService)),ve.set(we.ISharedProcessTunnelService,new G.SyncDescriptor(Ie.SharedProcessTunnelService)),ve.set(Et.IRemoteTunnelService,new G.SyncDescriptor(Ft.RemoteTunnelService)),new Z.InstantiationService(ve)}j(ve){const Ue=new Q.LogLevelChannel(ve.get(J.ILogService),ve.get(J.ILoggerService));this.a.registerChannel("logLevel",Ue);const We=new T.ExtensionManagementChannel(ve.get(y.IExtensionManagementService),()=>null);this.a.registerChannel("extensions",We);const Je=b.ProxyChannel.fromService(ve.get(ee.ILanguagePackService));this.a.registerChannel("languagePacks",Je);const tt=b.ProxyChannel.fromService(ve.get(f.IDiagnosticsService));this.a.registerChannel("diagnostics",tt);const Ke=new T.ExtensionTipsChannel(ve.get(y.IExtensionTipsService));this.a.registerChannel("extensionTipsService",Ke);const lt=b.ProxyChannel.fromService(ve.get(u.IChecksumService));this.a.registerChannel("checksum",lt);const it=b.ProxyChannel.fromService(ve.get(wt.IV8InspectProfilingService));this.a.registerChannel("v8InspectProfiling",it);const ht=new ge.UserDataSyncMachinesServiceChannel(ve.get(Pe.IUserDataSyncMachinesService));this.a.registerChannel("userDataSyncMachines",ht);const xe=b.ProxyChannel.fromService(ve.get(ie.ICustomEndpointTelemetryService));this.a.registerChannel("customEndpointTelemetry",xe);const _e=new ge.UserDataSyncAccountServiceChannel(ve.get(ce.IUserDataSyncAccountService));this.a.registerChannel("userDataSyncAccount",_e);const ft=new ge.UserDataSyncStoreManagementServiceChannel(ve.get(Be.IUserDataSyncStoreManagementService));this.a.registerChannel("userDataSyncStoreManagement",ft);const dt=new je.UserDataSyncChannel(ve.get(Be.IUserDataSyncService),ve.get(vt.IUserDataProfilesService),ve.get(J.ILogService));this.a.registerChannel("userDataSync",dt);const nt=this.B(ve.get(W.IInstantiationService).createInstance(Me.UserDataAutoSyncService)),Xe=new ge.UserDataAutoSyncChannel(nt);this.a.registerChannel("userDataAutoSync",Xe);const ot=ve.get(Ee.ILocalPtyService),ut=b.ProxyChannel.fromService(ot);this.a.registerChannel(be.TerminalIpcChannels.LocalPty,ut);const gt=b.ProxyChannel.fromService(ve.get(we.ISharedProcessTunnelService));this.a.registerChannel(we.ipcSharedProcessTunnelChannelName,gt);const mt=b.ProxyChannel.fromService(ve.get(Re.ISharedProcessWorkerService));this.a.registerChannel(Re.ipcSharedProcessWorkerChannelName,mt);const st=b.ProxyChannel.fromService(ve.get(Et.IRemoteTunnelService));this.a.registerChannel("remoteTunnel",st)}k(ve){window.addEventListener("unhandledrejection",Ue=>{(0,k.onUnexpectedError)(Ue.reason),Ue.preventDefault()}),(0,k.setUnexpectedErrorHandler)(Ue=>{const We=(0,R.toErrorMessage)(Ue,!0);!We||ve.error(`[uncaught exception in sharedProcess]: ${We}`)})}}async function zt(It){const ve=new Bt(It);D.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ve.open(),D.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=zt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/d0e44be43287acadb13f7c2808332e00fe52568d/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
