/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ee=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/errors","vs/base/common/network","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/platform/product/common/productService","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/base/node/pfs","vs/base/common/arrays","os","vs/base/common/strings","vs/platform/environment/electron-main/environmentMainService","vs/platform/workspace/common/workspace","vs/base/common/uuid","vs/base/common/extpath","vs/platform/windows/electron-main/windows","vs/base/common/process","vs/base/common/labels","vs/platform/environment/common/environment","vs/platform/state/electron-main/state","vs/platform/telemetry/common/telemetry","vs/platform/policy/common/policy","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/map","fs","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/json","vs/base/common/objects","vs/base/common/errorMessage","child_process","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/base/common/functional","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/remote/common/remoteHosts","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/theme/electron-main/themeMainService","vs/base/common/iterator","vs/base/common/hash","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/window/common/window","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/normalization","crypto","net","vs/base/common/processes","vs/base/common/stopwatch","vs/base/node/id","vs/base/node/processes","vs/base/parts/ipc/node/ipc.net","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensions/common/extensions","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/update/electron-main/abstractUpdateService","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/common/storage","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/common/linkedList","vs/base/node/ports","vs/base/common/severity","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/common/encryptionService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/shell/node/shellEnv","vs/platform/telemetry/common/telemetryService","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/codicons","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/skipList","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/encryption/node/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/state/electron-main/stateMainService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/launch/electron-main/launchMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","vs/platform/userDataProfile/electron-main/userDataTransientProfilesHandler","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/backup/electron-main/backupMainService","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","vs/platform/policy/node/nativePolicyService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","minimist","assert","graceful-fs","https","string_decoder","vscode-policy-watcher","zlib","vs/code/electron-main/main"],te=function(q){for(var e=[],I=0,t=q.length;I<t;I++)e[I]=ee[q[I]];return e};define(ee[119],te([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.Codicon=e.getCodiconAriaLabel=void 0;function I(M){return M?M.replace(/\$\((.*?)\)/g,(A,k)=>` ${k} `).trim():""}e.getCodiconAriaLabel=I;class t{constructor(A,k,p){this.id=A,this.definition=k,this.description=p,t.a.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t.a}}e.Codicon=t,t.a=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);var C;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const A=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function k(y){if(y instanceof t)return["codicon","codicon-"+y.id];const P=A.exec(y.id);if(!P)return k(t.error);const[,E,h]=P,w=["codicon","codicon-"+E];return h&&w.push("codicon-modifier-"+h.substring(1)),w}M.asClassNameArray=k;function p(y){return k(y).join(" ")}M.asClassName=p;function m(y){return"."+k(y).join(".")}M.asCSSSelector=m})(C=e.CSSIcon||(e.CSSIcon={}))}),define(ee[120],te([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function I(k,p){const m=Math.pow(10,p);return Math.round(k*m)/m}class t{constructor(p,m,y,P=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,p))|0,this.g=Math.min(255,Math.max(0,m))|0,this.b=Math.min(255,Math.max(0,y))|0,this.a=I(Math.max(Math.min(1,P),0),3)}static equals(p,m){return p.r===m.r&&p.g===m.g&&p.b===m.b&&p.a===m.a}}e.RGBA=t;class C{constructor(p,m,y,P){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,p),0)|0,this.s=I(Math.max(Math.min(1,m),0),3),this.l=I(Math.max(Math.min(1,y),0),3),this.a=I(Math.max(Math.min(1,P),0),3)}static equals(p,m){return p.h===m.h&&p.s===m.s&&p.l===m.l&&p.a===m.a}static fromRGBA(p){const m=p.r/255,y=p.g/255,P=p.b/255,E=p.a,h=Math.max(m,y,P),w=Math.min(m,y,P);let d=0,b=0;const u=(w+h)/2,v=h-w;if(v>0){switch(b=Math.min(u<=.5?v/(2*u):v/(2-2*u),1),h){case m:d=(y-P)/v+(y<P?6:0);break;case y:d=(P-m)/v+2;break;case P:d=(m-y)/v+4;break}d*=60,d=Math.round(d)}return new C(d,b,u,E)}static i(p,m,y){return y<0&&(y+=1),y>1&&(y-=1),y<1/6?p+(m-p)*6*y:y<1/2?m:y<2/3?p+(m-p)*(2/3-y)*6:p}static toRGBA(p){const m=p.h/360,{s:y,l:P,a:E}=p;let h,w,d;if(y===0)h=w=d=P;else{const b=P<.5?P*(1+y):P+y-P*y,u=2*P-b;h=C.i(u,b,m+1/3),w=C.i(u,b,m),d=C.i(u,b,m-1/3)}return new t(Math.round(h*255),Math.round(w*255),Math.round(d*255),E)}}e.HSLA=C;class M{constructor(p,m,y,P){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,p),0)|0,this.s=I(Math.max(Math.min(1,m),0),3),this.v=I(Math.max(Math.min(1,y),0),3),this.a=I(Math.max(Math.min(1,P),0),3)}static equals(p,m){return p.h===m.h&&p.s===m.s&&p.v===m.v&&p.a===m.a}static fromRGBA(p){const m=p.r/255,y=p.g/255,P=p.b/255,E=Math.max(m,y,P),h=Math.min(m,y,P),w=E-h,d=E===0?0:w/E;let b;return w===0?b=0:E===m?b=((y-P)/w%6+6)%6:E===y?b=(P-m)/w+2:b=(m-y)/w+4,new M(Math.round(b*60),d,E,p.a)}static toRGBA(p){const{h:m,s:y,v:P,a:E}=p,h=P*y,w=h*(1-Math.abs(m/60%2-1)),d=P-h;let[b,u,v]=[0,0,0];return m<60?(b=h,u=w):m<120?(b=w,u=h):m<180?(u=h,v=w):m<240?(u=w,v=h):m<300?(b=w,v=h):m<=360&&(b=h,v=w),b=Math.round((b+d)*255),u=Math.round((u+d)*255),v=Math.round((v+d)*255),new t(b,u,v,E)}}e.HSVA=M;class A{static fromHex(p){return A.Format.CSS.parseHex(p)||A.red}static equals(p,m){return!p&&!m?!0:!p||!m?!1:p.equals(m)}get hsla(){return this.i?this.i:C.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:M.fromRGBA(this.rgba)}constructor(p){if(p)if(p instanceof t)this.rgba=p;else if(p instanceof C)this.i=p,this.rgba=C.toRGBA(p);else if(p instanceof M)this.j=p,this.rgba=M.toRGBA(p);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(p){return!!p&&t.equals(this.rgba,p.rgba)&&C.equals(this.hsla,p.hsla)&&M.equals(this.hsva,p.hsva)}getRelativeLuminance(){const p=A.k(this.rgba.r),m=A.k(this.rgba.g),y=A.k(this.rgba.b),P=.2126*p+.7152*m+.0722*y;return I(P,4)}static k(p){const m=p/255;return m<=.03928?m/12.92:Math.pow((m+.055)/1.055,2.4)}getContrastRatio(p){const m=this.getRelativeLuminance(),y=p.getRelativeLuminance();return m>y?(m+.05)/(y+.05):(y+.05)/(m+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(p){const m=this.getRelativeLuminance(),y=p.getRelativeLuminance();return m>y}isDarkerThan(p){const m=this.getRelativeLuminance(),y=p.getRelativeLuminance();return m<y}lighten(p){return new A(new C(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*p,this.hsla.a))}darken(p){return new A(new C(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*p,this.hsla.a))}transparent(p){const{r:m,g:y,b:P,a:E}=this.rgba;return new A(new t(m,y,P,E*p))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new A(new t(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(p){const m=p.rgba,y=this.rgba.a,P=m.a,E=y+P*(1-y);if(E<1e-6)return A.transparent;const h=this.rgba.r*y/E+m.r*P*(1-y)/E,w=this.rgba.g*y/E+m.g*P*(1-y)/E,d=this.rgba.b*y/E+m.b*P*(1-y)/E;return new A(new t(h,w,d,E))}makeOpaque(p){if(this.isOpaque()||p.rgba.a!==1)return this;const{r:m,g:y,b:P,a:E}=this.rgba;return new A(new t(p.rgba.r-E*(p.rgba.r-m),p.rgba.g-E*(p.rgba.g-y),p.rgba.b-E*(p.rgba.b-P),1))}flatten(...p){const m=p.reduceRight((y,P)=>A.o(P,y));return A.o(this,m)}static o(p,m){const y=1-p.rgba.a;return new A(new t(y*m.rgba.r+p.rgba.a*p.rgba.r,y*m.rgba.g+p.rgba.a*p.rgba.g,y*m.rgba.b+p.rgba.a*p.rgba.b))}toString(){return this.u||(this.u=A.Format.CSS.format(this)),this.u}static getLighterColor(p,m,y){if(p.isLighterThan(m))return p;y=y||.5;const P=p.getRelativeLuminance(),E=m.getRelativeLuminance();return y=y*(E-P)/E,p.lighten(y)}static getDarkerColor(p,m,y){if(p.isDarkerThan(m))return p;y=y||.5;const P=p.getRelativeLuminance(),E=m.getRelativeLuminance();return y=y*(P-E)/P,p.darken(y)}}e.Color=A,A.white=new A(new t(255,255,255,1)),A.black=new A(new t(0,0,0,1)),A.red=new A(new t(255,0,0,1)),A.blue=new A(new t(0,0,255,1)),A.green=new A(new t(0,255,0,1)),A.cyan=new A(new t(0,255,255,1)),A.lightgrey=new A(new t(211,211,211,1)),A.transparent=new A(new t(0,0,0,0)),function(k){let p;(function(m){let y;(function(P){function E(n){return n.rgba.a===1?`rgb(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b})`:k.Format.CSS.formatRGBA(n)}P.formatRGB=E;function h(n){return`rgba(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b}, ${+n.rgba.a.toFixed(2)})`}P.formatRGBA=h;function w(n){return n.hsla.a===1?`hsl(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%)`:k.Format.CSS.formatHSLA(n)}P.formatHSL=w;function d(n){return`hsla(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%, ${n.hsla.a.toFixed(2)})`}P.formatHSLA=d;function b(n){const r=n.toString(16);return r.length!==2?"0"+r:r}function u(n){return`#${b(n.rgba.r)}${b(n.rgba.g)}${b(n.rgba.b)}`}P.formatHex=u;function v(n,r=!1){return r&&n.rgba.a===1?k.Format.CSS.formatHex(n):`#${b(n.rgba.r)}${b(n.rgba.g)}${b(n.rgba.b)}${b(Math.round(n.rgba.a*255))}`}P.formatHexA=v;function g(n){return n.isOpaque()?k.Format.CSS.formatHex(n):k.Format.CSS.formatRGBA(n)}P.format=g;function f(n){const r=n.length;if(r===0||n.charCodeAt(0)!==35)return null;if(r===7){const i=16*c(n.charCodeAt(1))+c(n.charCodeAt(2)),a=16*c(n.charCodeAt(3))+c(n.charCodeAt(4)),s=16*c(n.charCodeAt(5))+c(n.charCodeAt(6));return new k(new t(i,a,s,1))}if(r===9){const i=16*c(n.charCodeAt(1))+c(n.charCodeAt(2)),a=16*c(n.charCodeAt(3))+c(n.charCodeAt(4)),s=16*c(n.charCodeAt(5))+c(n.charCodeAt(6)),l=16*c(n.charCodeAt(7))+c(n.charCodeAt(8));return new k(new t(i,a,s,l/255))}if(r===4){const i=c(n.charCodeAt(1)),a=c(n.charCodeAt(2)),s=c(n.charCodeAt(3));return new k(new t(16*i+i,16*a+a,16*s+s))}if(r===5){const i=c(n.charCodeAt(1)),a=c(n.charCodeAt(2)),s=c(n.charCodeAt(3)),l=c(n.charCodeAt(4));return new k(new t(16*i+i,16*a+a,16*s+s,(16*l+l)/255))}return null}P.parseHex=f;function c(n){switch(n){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(y=m.CSS||(m.CSS={}))})(p=k.Format||(k.Format={}))}(A=e.Color||(e.Color={}))}),define(ee[53],te([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function I(A){return(k,p,m)=>{let y=null,P=null;if(typeof m.value=="function"?(y="value",P=m.value):typeof m.get=="function"&&(y="get",P=m.get),!P)throw new Error("not supported");m[y]=A(P,p)}}function t(A,k,p){let m=null,y=null;if(typeof p.value=="function"?(m="value",y=p.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(m="get",y=p.get),!y)throw new Error("not supported");const P=`$memoize$${k}`;p[m]=function(...E){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:y.apply(this,E)}),this[P]}}e.memoize=t;function C(A,k,p){return I((m,y)=>{const P=`$debounce$${y}`,E=`$debounce$result$${y}`;return function(...h){this[E]||(this[E]=p?p():void 0),clearTimeout(this[P]),k&&(this[E]=k(this[E],...h),h=[this[E]]),this[P]=setTimeout(()=>{m.apply(this,h),this[E]=p?p():void 0},A)}})}e.debounce=C;function M(A,k,p){return I((m,y)=>{const P=`$throttle$timer$${y}`,E=`$throttle$result$${y}`,h=`$throttle$lastRun$${y}`,w=`$throttle$pending$${y}`;return function(...d){if(this[E]||(this[E]=p?p():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),k&&(this[E]=k(this[E],...d)),this[w])return;const b=this[h]+A;b<=Date.now()?(this[h]=Date.now(),m.apply(this,[this[E]]),this[E]=p?p():void 0):(this[w]=!0,this[P]=setTimeout(()=>{this[w]=!1,this[h]=Date.now(),m.apply(this,[this[E]]),this[E]=p?p():void 0},b-Date.now()))}})}e.throttle=M}),define(ee[14],te([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class I{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?g.isErrorNoTelemetry(n)?new g(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(r=>{r(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}e.ErrorHandler=I,e.errorHandler=new I;function t(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=t;function C(c){p(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=C;function M(c){p(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=M;function A(c){if(c instanceof Error){const{name:n,message:r}=c,i=c.stacktrace||c.stack;return{$isError:!0,name:n,message:r,stack:i,noTelemetry:g.isErrorNoTelemetry(c)}}return c}e.transformErrorForSerialization=A;const k="Canceled";function p(c){return c instanceof m?!0:c instanceof Error&&c.name===k&&c.message===k}e.isCancellationError=p;class m extends Error{constructor(){super(k),this.name=this.message}}e.CancellationError=m;function y(){const c=new Error(k);return c.name=c.message,c}e.canceled=y;function P(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=P;function E(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=E;function h(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=h;function w(c){const n=new Error(`${c} has been disposed`);return n.name="DISPOSED",n}e.disposed=w;function d(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=d;class b extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.NotImplementedError=b;class u extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.NotSupportedError=u;class v extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=v;class g extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof g)return n;const r=new g;return r.message=n.message,r.stack=n.stack,r}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.ErrorNoTelemetry=g;class f extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,f.prototype);debugger}}e.BugIndicatingError=f}),define(ee[24],te([0,1,14]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t($,Z=0){return $[$.length-(1+Z)]}e.tail=t;function C($){if($.length===0)throw new Error("Invalid tail call");return[$.slice(0,$.length-1),$[$.length-1]]}e.tail2=C;function M($,Z,x=(oe,ge)=>oe===ge){if($===Z)return!0;if(!$||!Z||$.length!==Z.length)return!1;for(let oe=0,ge=$.length;oe<ge;oe++)if(!x($[oe],Z[oe]))return!1;return!0}e.equals=M;function A($,Z){const x=$.length-1;Z<x&&($[Z]=$[x]),$.pop()}e.removeFastWithoutKeepingOrder=A;function k($,Z,x){return p($.length,oe=>x($[oe],Z))}e.binarySearch=k;function p($,Z){let x=0,oe=$-1;for(;x<=oe;){const ge=(x+oe)/2|0,De=Z(ge);if(De<0)x=ge+1;else if(De>0)oe=ge-1;else return ge}return-(x+1)}e.binarySearch2=p;function m($,Z){let x=0,oe=$.length;if(oe===0)return 0;for(;x<oe;){const ge=Math.floor((x+oe)/2);Z($[ge])?oe=ge:x=ge+1}return x}e.findFirstInSorted=m;function y($,Z,x){if($=$|0,$>=Z.length)throw new TypeError("invalid index");const oe=Z[Math.floor(Z.length*Math.random())],ge=[],De=[],Oe=[];for(const Ce of Z){const Re=x(Ce,oe);Re<0?ge.push(Ce):Re>0?De.push(Ce):Oe.push(Ce)}return $<ge.length?y($,ge,x):$<ge.length+Oe.length?Oe[0]:y($-(ge.length+Oe.length),De,x)}e.quickSelect=y;function P($,Z){const x=[];let oe;for(const ge of $.slice(0).sort(Z))!oe||Z(oe[0],ge)!==0?(oe=[ge],x.push(oe)):oe.push(ge);return x}e.groupBy=P;function E($,Z,x){const oe=[];function ge(Ce,Re,be){if(Re===0&&be.length===0)return;const we=oe[oe.length-1];we&&we.start+we.deleteCount===Ce?(we.deleteCount+=Re,we.toInsert.push(...be)):oe.push({start:Ce,deleteCount:Re,toInsert:be})}let De=0,Oe=0;for(;;){if(De===$.length){ge(De,0,Z.slice(Oe));break}if(Oe===Z.length){ge(De,$.length-De,[]);break}const Ce=$[De],Re=Z[Oe],be=x(Ce,Re);be===0?(De+=1,Oe+=1):be<0?(ge(De,1,[]),De+=1):be>0&&(ge(De,0,[Re]),Oe+=1)}return oe}e.sortedDiff=E;function h($,Z,x){const oe=E($,Z,x),ge=[],De=[];for(const Oe of oe)ge.push(...$.slice(Oe.start,Oe.start+Oe.deleteCount)),De.push(...Oe.toInsert);return{removed:ge,added:De}}e.delta=h;function w($,Z,x){if(x===0)return[];const oe=$.slice(0,x).sort(Z);return b($,Z,oe,x,$.length),oe}e.top=w;function d($,Z,x,oe,ge){return x===0?Promise.resolve([]):new Promise((De,Oe)=>{(async()=>{const Ce=$.length,Re=$.slice(0,x).sort(Z);for(let be=x,we=Math.min(x+oe,Ce);be<Ce;be=we,we=Math.min(we+oe,Ce)){if(be>x&&await new Promise(ve=>setTimeout(ve)),ge&&ge.isCancellationRequested)throw new I.CancellationError;b($,Z,Re,be,we)}return Re})().then(De,Oe)})}e.topAsync=d;function b($,Z,x,oe,ge){for(const De=x.length;oe<ge;oe++){const Oe=$[oe];if(Z(Oe,x[De-1])<0){x.pop();const Ce=m(x,Re=>Z(Oe,Re)<0);x.splice(Ce,0,Oe)}}}function u($){return $.filter(Z=>!!Z)}e.coalesce=u;function v($){let Z=0;for(let x=0;x<$.length;x++)$[x]&&($[Z]=$[x],Z+=1);$.length=Z}e.coalesceInPlace=v;function g($,Z,x){$.splice(x,0,$.splice(Z,1)[0])}e.move=g;function f($){return!Array.isArray($)||$.length===0}e.isFalsyOrEmpty=f;function c($){return Array.isArray($)&&$.length>0}e.isNonEmptyArray=c;function n($,Z=x=>x){const x=new Set;return $.filter(oe=>{const ge=Z(oe);return x.has(ge)?!1:(x.add(ge),!0)})}e.distinct=n;function r($){const Z=new Set;return x=>{const oe=$(x);return Z.has(oe)?!1:(Z.add(oe),!0)}}e.uniqueFilter=r;function i($,Z){const x=a($,Z);if(x!==-1)return $[x]}e.findLast=i;function a($,Z){for(let x=$.length-1;x>=0;x--){const oe=$[x];if(Z(oe))return x}return-1}e.lastIndex=a;function s($,Z){return $.length>0?$[0]:Z}e.firstOrDefault=s;function l($,Z){return $.length>0?$[$.length-1]:Z}e.lastOrDefault=l;function o($,Z,x=(oe,ge)=>oe===ge){let oe=0;for(let ge=0,De=Math.min($.length,Z.length);ge<De&&x($[ge],Z[ge]);ge++)oe++;return oe}e.commonPrefixLength=o;function S($){return[].concat(...$)}e.flatten=S;function D($,Z){let x=typeof Z=="number"?$:0;typeof Z=="number"?x=$:(x=0,Z=$);const oe=[];if(x<=Z)for(let ge=x;ge<Z;ge++)oe.push(ge);else for(let ge=x;ge>Z;ge--)oe.push(ge);return oe}e.range=D;function L($,Z,x){return $.reduce((oe,ge)=>(oe[Z(ge)]=x?x(ge):ge,oe),Object.create(null))}e.index=L;function j($,Z){return $.push(Z),()=>X($,Z)}e.insert=j;function X($,Z){const x=$.indexOf(Z);if(x>-1)return $.splice(x,1),Z}e.remove=X;function ae($,Z,x){const oe=$.slice(0,Z),ge=$.slice(Z);return oe.concat(x,ge)}e.arrayInsert=ae;function Y($,Z){let x;if(typeof Z=="number"){let oe=Z;x=()=>{const ge=Math.sin(oe++)*179426549;return ge-Math.floor(ge)}}else x=Math.random;for(let oe=$.length-1;oe>0;oe-=1){const ge=Math.floor(x()*(oe+1)),De=$[oe];$[oe]=$[ge],$[ge]=De}}e.shuffle=Y;function J($,Z){const x=$.indexOf(Z);x>-1&&($.splice(x,1),$.unshift(Z))}e.pushToStart=J;function se($,Z){const x=$.indexOf(Z);x>-1&&($.splice(x,1),$.push(Z))}e.pushToEnd=se;function ne($,Z){for(const x of Z)$.push(x)}e.pushMany=ne;function he($,Z){return Array.isArray($)?$.map(Z):Z($)}e.mapArrayOrNot=he;function K($){return Array.isArray($)?$:[$]}e.asArray=K;function le($){return $[Math.floor(Math.random()*$.length)]}e.getRandomElement=le;function W($,Z){for(const x of $){const oe=Z(x);if(oe!==void 0)return oe}}e.mapFind=W;function F($,Z,x){const oe=H($,Z),ge=$.length,De=x.length;$.length=ge+De;for(let Oe=ge-1;Oe>=oe;Oe--)$[Oe+De]=$[Oe];for(let Oe=0;Oe<De;Oe++)$[Oe+oe]=x[Oe]}e.insertInto=F;function N($,Z,x,oe){const ge=H($,Z),De=$.splice(ge,x);return F($,ge,oe),De}e.splice=N;function H($,Z){return Z<0?Math.max(Z+$.length,0):Math.min(Z,$.length)}var re;(function($){function Z(ge){return ge<0}$.isLessThan=Z;function x(ge){return ge>0}$.isGreaterThan=x;function oe(ge){return ge===0}$.isNeitherLessOrGreaterThan=oe,$.greaterThan=1,$.lessThan=-1,$.neitherLessOrGreaterThan=0})(re=e.CompareResult||(e.CompareResult={}));function z($,Z){return(x,oe)=>Z($(x),$(oe))}e.compareBy=z;function T(...$){return(Z,x)=>{for(const oe of $){const ge=oe(Z,x);if(!re.isNeitherLessOrGreaterThan(ge))return ge}return re.neitherLessOrGreaterThan}}e.tieBreakComparators=T;const R=($,Z)=>$-Z;e.numberComparator=R;function O($,Z){if($.length===0)return;let x=$[0];for(let oe=1;oe<$.length;oe++){const ge=$[oe];Z(ge,x)>0&&(x=ge)}return x}e.findMaxBy=O;function U($,Z){if($.length===0)return;let x=$[0];for(let oe=1;oe<$.length;oe++){const ge=$[oe];Z(ge,x)>=0&&(x=ge)}return x}e.findLastMaxBy=U;function B($,Z){return O($,(x,oe)=>-Z(x,oe))}e.findMinBy=B;class V{constructor(Z){this.f=Z,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(Z){let x=this.c;for(;x<this.f.length&&Z(this.f[x]);)x++;const oe=x===this.c?null:this.f.slice(this.c,x);return this.c=x,oe}takeFromEndWhile(Z){let x=this.d;for(;x>=0&&Z(this.f[x]);)x--;const oe=x===this.d?null:this.f.slice(x+1,this.d+1);return this.d=x,oe}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const Z=this.f[this.c];return this.c++,Z}removeLast(){const Z=this.f[this.d];return this.d--,Z}takeCount(Z){const x=this.f.slice(this.c,this.c+Z);return this.c+=Z,x}}e.ArrayQueue=V;class ie{constructor(Z){this.iterate=Z}forEach(Z){this.iterate(x=>(Z(x),!0))}toArray(){const Z=[];return this.iterate(x=>(Z.push(x),!0)),Z}filter(Z){return new ie(x=>this.iterate(oe=>Z(oe)?x(oe):!0))}map(Z){return new ie(x=>this.iterate(oe=>x(Z(oe))))}some(Z){let x=!1;return this.iterate(oe=>(x=Z(oe),!x)),x}findFirst(Z){let x;return this.iterate(oe=>Z(oe)?(x=oe,!1):!0),x}findLast(Z){let x;return this.iterate(oe=>(Z(oe)&&(x=oe),!0)),x}findLastMaxBy(Z){let x,oe=!0;return this.iterate(ge=>((oe||re.isGreaterThan(Z(ge,x)))&&(oe=!1,x=ge),!0)),x}}e.CallbackIterable=ie,ie.empty=new ie($=>{})}),define(ee[121],te([0,1,14]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(p,m){if(!p)throw new Error(m?`Assertion failed (${m})`:"Assertion Failed")}e.ok=t;function C(p,m="Unreachable"){throw new Error(m)}e.assertNever=C;function M(p){if(!p)throw new I.BugIndicatingError("Assertion Failed")}e.assert=M;function A(p){if(!p()){debugger;p(),(0,I.onUnexpectedError)(new I.BugIndicatingError("Assertion Failed"))}}e.assertFn=A;function k(p,m){let y=0;for(;y<p.length-1;){const P=p[y],E=p[y+1];if(!m(P,E))return!1;y++}return!0}e.checkAdjacentItems=k}),define(ee[50],te([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function I(t){const C=this;let M=!1,A;return function(){return M||(M=!0,A=t.apply(C,arguments)),A}}e.once=I}),define(ee[67],te([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var I;(function(t){function C(f){return f&&typeof f=="object"&&typeof f[Symbol.iterator]=="function"}t.is=C;const M=Object.freeze([]);function A(){return M}t.empty=A;function*k(f){yield f}t.single=k;function p(f){return C(f)?f:k(f)}t.wrap=p;function m(f){return f||M}t.from=m;function y(f){return!f||f[Symbol.iterator]().next().done===!0}t.isEmpty=y;function P(f){return f[Symbol.iterator]().next().value}t.first=P;function E(f,c){for(const n of f)if(c(n))return!0;return!1}t.some=E;function h(f,c){for(const n of f)if(c(n))return n}t.find=h;function*w(f,c){for(const n of f)c(n)&&(yield n)}t.filter=w;function*d(f,c){let n=0;for(const r of f)yield c(r,n++)}t.map=d;function*b(...f){for(const c of f)for(const n of c)yield n}t.concat=b;function u(f,c,n){let r=n;for(const i of f)r=c(r,i);return r}t.reduce=u;function*v(f,c,n=f.length){for(c<0&&(c+=f.length),n<0?n+=f.length:n>f.length&&(n=f.length);c<n;c++)yield f[c]}t.slice=v;function g(f,c=Number.POSITIVE_INFINITY){const n=[];if(c===0)return[n,f];const r=f[Symbol.iterator]();for(let i=0;i<c;i++){const a=r.next();if(a.done)return[n,t.empty()];n.push(a.value)}return[n,{[Symbol.iterator](){return r}}]}t.consume=g})(I=e.Iterable||(e.Iterable={}))}),define(ee[43],te([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var I;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(I=e.ScanError||(e.ScanError={}));var t;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var C;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(C=e.ParseErrorCode||(e.ParseErrorCode={}));var M;(function(n){n.DEFAULT={allowTrailingComma:!0}})(M=e.ParseOptions||(e.ParseOptions={}));function A(n,r=!1){let i=0;const a=n.length;let s="",l=0,o=16,S=0;function D(se){let ne=0,he=0;for(;ne<se;){const K=n.charCodeAt(i);if(K>=48&&K<=57)he=he*16+K-48;else if(K>=65&&K<=70)he=he*16+K-65+10;else if(K>=97&&K<=102)he=he*16+K-97+10;else break;i++,ne++}return ne<se&&(he=-1),he}function L(se){i=se,s="",l=0,o=16,S=0}function j(){const se=i;if(n.charCodeAt(i)===48)i++;else for(i++;i<n.length&&m(n.charCodeAt(i));)i++;if(i<n.length&&n.charCodeAt(i)===46)if(i++,i<n.length&&m(n.charCodeAt(i)))for(i++;i<n.length&&m(n.charCodeAt(i));)i++;else return S=3,n.substring(se,i);let ne=i;if(i<n.length&&(n.charCodeAt(i)===69||n.charCodeAt(i)===101))if(i++,(i<n.length&&n.charCodeAt(i)===43||n.charCodeAt(i)===45)&&i++,i<n.length&&m(n.charCodeAt(i))){for(i++;i<n.length&&m(n.charCodeAt(i));)i++;ne=i}else S=3;return n.substring(se,ne)}function X(){let se="",ne=i;for(;;){if(i>=a){se+=n.substring(ne,i),S=2;break}const he=n.charCodeAt(i);if(he===34){se+=n.substring(ne,i),i++;break}if(he===92){if(se+=n.substring(ne,i),i++,i>=a){S=2;break}switch(n.charCodeAt(i++)){case 34:se+='"';break;case 92:se+="\\";break;case 47:se+="/";break;case 98:se+="\b";break;case 102:se+="\f";break;case 110:se+=`
`;break;case 114:se+="\r";break;case 116:se+="	";break;case 117:{const le=D(4);le>=0?se+=String.fromCharCode(le):S=4;break}default:S=5}ne=i;continue}if(he>=0&&he<=31)if(p(he)){se+=n.substring(ne,i),S=2;break}else S=6;i++}return se}function ae(){if(s="",S=0,l=i,i>=a)return l=a,o=17;let se=n.charCodeAt(i);if(k(se)){do i++,s+=String.fromCharCode(se),se=n.charCodeAt(i);while(k(se));return o=15}if(p(se))return i++,s+=String.fromCharCode(se),se===13&&n.charCodeAt(i)===10&&(i++,s+=`
`),o=14;switch(se){case 123:return i++,o=1;case 125:return i++,o=2;case 91:return i++,o=3;case 93:return i++,o=4;case 58:return i++,o=6;case 44:return i++,o=5;case 34:return i++,s=X(),o=10;case 47:{const ne=i-1;if(n.charCodeAt(i+1)===47){for(i+=2;i<a&&!p(n.charCodeAt(i));)i++;return s=n.substring(ne,i),o=12}if(n.charCodeAt(i+1)===42){i+=2;const he=a-1;let K=!1;for(;i<he;){if(n.charCodeAt(i)===42&&n.charCodeAt(i+1)===47){i+=2,K=!0;break}i++}return K||(i++,S=1),s=n.substring(ne,i),o=13}return s+=String.fromCharCode(se),i++,o=16}case 45:if(s+=String.fromCharCode(se),i++,i===a||!m(n.charCodeAt(i)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=j(),o=11;default:for(;i<a&&Y(se);)i++,se=n.charCodeAt(i);if(l!==i){switch(s=n.substring(l,i),s){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return s+=String.fromCharCode(se),i++,o=16}}function Y(se){if(k(se)||p(se))return!1;switch(se){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function J(){let se;do se=ae();while(se>=12&&se<=15);return se}return{setPosition:L,getPosition:()=>i,scan:r?J:ae,getToken:()=>o,getTokenValue:()=>s,getTokenOffset:()=>l,getTokenLength:()=>i-l,getTokenError:()=>S}}e.createScanner=A;function k(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function p(n){return n===10||n===13||n===8232||n===8233}function m(n){return n>=48&&n<=57}var y;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(y||(y={}));function P(n,r){const i=[],a=new Object;let s;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function S(D,L,j,X){l.value=D,l.offset=L,l.length=j,l.type=X,l.colonOffset=void 0,s=l}try{g(n,{onObjectBegin:(D,L)=>{if(r<=D)throw a;s=void 0,o=r>D,i.push("")},onObjectProperty:(D,L,j)=>{if(r<L||(S(D,L,j,"property"),i[i.length-1]=D,r<=L+j))throw a},onObjectEnd:(D,L)=>{if(r<=D)throw a;s=void 0,i.pop()},onArrayBegin:(D,L)=>{if(r<=D)throw a;s=void 0,i.push(0)},onArrayEnd:(D,L)=>{if(r<=D)throw a;s=void 0,i.pop()},onLiteralValue:(D,L,j)=>{if(r<L||(S(D,L,j,c(D)),r<=L+j))throw a},onSeparator:(D,L,j)=>{if(r<=L)throw a;if(D===":"&&s&&s.type==="property")s.colonOffset=L,o=!1,s=void 0;else if(D===","){const X=i[i.length-1];typeof X=="number"?i[i.length-1]=X+1:(o=!0,i[i.length-1]=""),s=void 0}}})}catch(D){if(D!==a)throw D}return{path:i,previousNode:s,isAtPropertyKey:o,matches:D=>{let L=0;for(let j=0;L<D.length&&j<i.length;j++)if(D[L]===i[j]||D[L]==="*")L++;else if(D[L]!=="**")return!1;return L===D.length}}}e.getLocation=P;function E(n,r=[],i=M.DEFAULT){let a=null,s=[];const l=[];function o(D){Array.isArray(s)?s.push(D):a!==null&&(s[a]=D)}return g(n,{onObjectBegin:()=>{const D={};o(D),l.push(s),s=D,a=null},onObjectProperty:D=>{a=D},onObjectEnd:()=>{s=l.pop()},onArrayBegin:()=>{const D=[];o(D),l.push(s),s=D,a=null},onArrayEnd:()=>{s=l.pop()},onLiteralValue:o,onError:(D,L,j)=>{r.push({error:D,offset:L,length:j})}},i),s[0]}e.parse=E;function h(n,r=[],i=M.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(D){a.type==="property"&&(a.length=D-a.offset,a=a.parent)}function l(D){return a.children.push(D),D}g(n,{onObjectBegin:D=>{a=l({type:"object",offset:D,length:-1,parent:a,children:[]})},onObjectProperty:(D,L,j)=>{a=l({type:"property",offset:L,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:D,offset:L,length:j,parent:a})},onObjectEnd:(D,L)=>{a.length=D+L-a.offset,a=a.parent,s(D+L)},onArrayBegin:(D,L)=>{a=l({type:"array",offset:D,length:-1,parent:a,children:[]})},onArrayEnd:(D,L)=>{a.length=D+L-a.offset,a=a.parent,s(D+L)},onLiteralValue:(D,L,j)=>{l({type:c(D),offset:L,length:j,parent:a,value:D}),s(L+j)},onSeparator:(D,L,j)=>{a.type==="property"&&(D===":"?a.colonOffset=L:D===","&&s(L))},onError:(D,L,j)=>{r.push({error:D,offset:L,length:j})}},i);const S=a.children[0];return S&&delete S.parent,S}e.parseTree=h;function w(n,r){if(!n)return;let i=n;for(const a of r)if(typeof a=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let s=!1;for(const l of i.children)if(Array.isArray(l.children)&&l.children[0].value===a){i=l.children[1],s=!0;break}if(!s)return}else{const s=a;if(i.type!=="array"||s<0||!Array.isArray(i.children)||s>=i.children.length)return;i=i.children[s]}return i}e.findNodeAtLocation=w;function d(n){if(!n.parent||!n.parent.children)return[];const r=d(n.parent);if(n.parent.type==="property"){const i=n.parent.children[0].value;r.push(i)}else if(n.parent.type==="array"){const i=n.parent.children.indexOf(n);i!==-1&&r.push(i)}return r}e.getNodePath=d;function b(n){switch(n.type){case"array":return n.children.map(b);case"object":{const r=Object.create(null);for(const i of n.children){const a=i.children[1];a&&(r[i.children[0].value]=b(a))}return r}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=b;function u(n,r,i=!1){return r>=n.offset&&r<n.offset+n.length||i&&r===n.offset+n.length}e.contains=u;function v(n,r,i=!1){if(u(n,r,i)){const a=n.children;if(Array.isArray(a))for(let s=0;s<a.length&&a[s].offset<=r;s++){const l=v(a[s],r,i);if(l)return l}return n}}e.findNodeAtOffset=v;function g(n,r,i=M.DEFAULT){const a=A(n,!1);function s(z){return z?()=>z(a.getTokenOffset(),a.getTokenLength()):()=>!0}function l(z){return z?T=>z(T,a.getTokenOffset(),a.getTokenLength()):()=>!0}const o=s(r.onObjectBegin),S=l(r.onObjectProperty),D=s(r.onObjectEnd),L=s(r.onArrayBegin),j=s(r.onArrayEnd),X=l(r.onLiteralValue),ae=l(r.onSeparator),Y=s(r.onComment),J=l(r.onError),se=i&&i.disallowComments,ne=i&&i.allowTrailingComma;function he(){for(;;){const z=a.scan();switch(a.getTokenError()){case 4:K(14);break;case 5:K(15);break;case 3:K(13);break;case 1:se||K(11);break;case 2:K(12);break;case 6:K(16);break}switch(z){case 12:case 13:se?K(10):Y();break;case 16:K(1);break;case 15:case 14:break;default:return z}}}function K(z,T=[],R=[]){if(J(z),T.length+R.length>0){let O=a.getToken();for(;O!==17;){if(T.indexOf(O)!==-1){he();break}else if(R.indexOf(O)!==-1)break;O=he()}}}function le(z){const T=a.getTokenValue();return z?X(T):S(T),he(),!0}function W(){switch(a.getToken()){case 11:{let z=0;try{z=JSON.parse(a.getTokenValue()),typeof z!="number"&&(K(2),z=0)}catch{K(2)}X(z);break}case 7:X(null);break;case 8:X(!0);break;case 9:X(!1);break;default:return!1}return he(),!0}function F(){return a.getToken()!==10?(K(3,[],[2,5]),!1):(le(!1),a.getToken()===6?(ae(":"),he(),re()||K(4,[],[2,5])):K(5,[],[2,5]),!0)}function N(){o(),he();let z=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(z||K(4,[],[]),ae(","),he(),a.getToken()===2&&ne)break}else z&&K(6,[],[]);F()||K(4,[],[2,5]),z=!0}return D(),a.getToken()!==2?K(7,[2],[]):he(),!0}function H(){L(),he();let z=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(z||K(4,[],[]),ae(","),he(),a.getToken()===4&&ne)break}else z&&K(6,[],[]);re()||K(4,[],[4,5]),z=!0}return j(),a.getToken()!==4?K(8,[4],[]):he(),!0}function re(){switch(a.getToken()){case 3:return H();case 1:return N();case 10:return le(!0);default:return W()}}return he(),a.getToken()===17?i.allowEmptyContent?!0:(K(4,[],[]),!1):re()?(a.getToken()!==17&&K(9,[],[]),!0):(K(4,[],[]),!1)}e.visit=g;function f(n,r){const i=A(n),a=[];let s,l=0,o;do switch(o=i.getPosition(),s=i.scan(),s){case 12:case 13:case 17:l!==o&&a.push(n.substring(l,o)),r!==void 0&&a.push(i.getTokenValue().replace(/[^\r\n]/g,r)),l=i.getPosition();break}while(s!==17);return a.join("")}e.stripComments=f;function c(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(ee[122],te([0,1,43]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(m,y,P){let E,h,w,d,b;if(y){for(d=y.offset,b=d+y.length,w=d;w>0&&!p(m,w-1);)w--;let o=b;for(;o<m.length&&!p(m,o);)o++;h=m.substring(w,o),E=A(h,P)}else h=m,E=0,w=0,d=0,b=m.length;const u=k(P,m);let v=!1,g=0,f;P.insertSpaces?f=M(" ",P.tabSize||4):f="	";const c=(0,I.createScanner)(h,!1);let n=!1;function r(){return u+M(f,E+g)}function i(){let o=c.scan();for(v=!1;o===15||o===14;)v=v||o===14,o=c.scan();return n=o===16||c.getTokenError()!==0,o}const a=[];function s(o,S,D){!n&&S<b&&D>d&&m.substring(S,D)!==o&&a.push({offset:S,length:D-S,content:o})}let l=i();if(l!==17){const o=c.getTokenOffset()+w,S=M(f,E);s(S,w,o)}for(;l!==17;){let o=c.getTokenOffset()+c.getTokenLength()+w,S=i(),D="";for(;!v&&(S===12||S===13);){const j=c.getTokenOffset()+w;s(" ",o,j),o=c.getTokenOffset()+c.getTokenLength()+w,D=S===12?r():"",S=i()}if(S===2)l!==1&&(g--,D=r());else if(S===4)l!==3&&(g--,D=r());else{switch(l){case 3:case 1:g++,D=r();break;case 5:case 12:D=r();break;case 13:v?D=r():D=" ";break;case 6:D=" ";break;case 10:if(S===6){D="";break}case 7:case 8:case 9:case 11:case 2:case 4:S===12||S===13?D=" ":S!==5&&S!==17&&(n=!0);break;case 16:n=!0;break}v&&(S===12||S===13)&&(D=r())}const L=c.getTokenOffset()+w;s(D,o,L),l=S}return a}e.format=t;function C(m,y){const P=JSON.stringify(m,void 0,y.insertSpaces?y.tabSize||4:"	");return y.eol!==void 0?P.replace(/\r\n|\r|\n/g,y.eol):P}e.toFormattedString=C;function M(m,y){let P="";for(let E=0;E<y;E++)P+=m;return P}function A(m,y){let P=0,E=0;const h=y.tabSize||4;for(;P<m.length;){const w=m.charAt(P);if(w===" ")E++;else if(w==="	")E+=h;else break;P++}return Math.floor(E/h)}function k(m,y){for(let P=0;P<y.length;P++){const E=y.charAt(P);if(E==="\r")return P+1<y.length&&y.charAt(P+1)===`
`?`\r
`:"\r";if(E===`
`)return`
`}return m&&m.eol||`
`}e.getEOL=k;function p(m,y){return`\r
`.indexOf(m.charAt(y))!==-1}e.isEOL=p}),define(ee[123],te([0,1,43,122]),function(q,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function C(m,y,P){return M(m,y,void 0,P)}e.removeProperty=C;function M(m,y,P,E,h){const w=y.slice(),d=[],b=(0,I.parseTree)(m,d);let u,v;for(;w.length>0&&(v=w.pop(),u=(0,I.findNodeAtLocation)(b,w),u===void 0&&P!==void 0);)typeof v=="string"?P={[v]:P}:P=[P];if(u)if(u.type==="object"&&typeof v=="string"&&Array.isArray(u.children)){const g=(0,I.findNodeAtLocation)(u,[v]);if(g!==void 0)if(P===void 0){if(!g.parent)throw new Error("Malformed AST");const f=u.children.indexOf(g.parent);let c,n=g.parent.offset+g.parent.length;if(f>0){const r=u.children[f-1];c=r.offset+r.length}else c=u.offset+1,u.children.length>1&&(n=u.children[1].offset);return A(m,{offset:c,length:n-c,content:""},E)}else return A(m,{offset:g.offset,length:g.length,content:JSON.stringify(P)},E);else{if(P===void 0)return[];const f=`${JSON.stringify(v)}: ${JSON.stringify(P)}`,c=h?h(u.children.map(r=>r.children[0].value)):u.children.length;let n;if(c>0){const r=u.children[c-1];n={offset:r.offset+r.length,length:0,content:","+f}}else u.children.length===0?n={offset:u.offset+1,length:0,content:f}:n={offset:u.offset+1,length:0,content:f+","};return A(m,n,E)}}else if(u.type==="array"&&typeof v=="number"&&Array.isArray(u.children))if(P!==void 0){const g=`${JSON.stringify(P)}`;let f;if(u.children.length===0||v===0)f={offset:u.offset+1,length:0,content:u.children.length===0?g:g+","};else{const c=v===-1||v>u.children.length?u.children.length:v,n=u.children[c-1];f={offset:n.offset+n.length,length:0,content:","+g}}return A(m,f,E)}else{const g=v,f=u.children[g];let c;if(u.children.length===1)c={offset:u.offset+1,length:u.length-2,content:""};else if(u.children.length-1===g){const n=u.children[g-1],r=n.offset+n.length,i=u.offset+u.length;c={offset:r,length:i-2-r,content:""}}else c={offset:f.offset,length:u.children[g+1].offset-f.offset,content:""};return A(m,c,E)}else throw new Error(`Can not add ${typeof v!="number"?"index":"property"} to parent of type ${u.type}`);else{if(P===void 0)throw new Error("Can not delete in empty document");return A(m,{offset:b?b.offset:0,length:b?b.length:0,content:JSON.stringify(P)},E)}}e.setProperty=M;function A(m,y,P){let E=k(m,y),h=y.offset,w=y.offset+y.content.length;if(y.length===0||y.content.length===0){for(;h>0&&!(0,t.isEOL)(E,h-1);)h--;for(;w<E.length&&!(0,t.isEOL)(E,w);)w++}const d=(0,t.format)(E,{offset:h,length:w-h},P);for(let u=d.length-1;u>=0;u--){const v=d[u];E=k(E,v),h=Math.min(h,v.offset),w=Math.max(w,v.offset+v.length),w+=v.content.length-v.length}const b=m.length-(E.length-w)-h;return[{offset:h,length:b,content:E.substring(h,w)}]}e.withFormatting=A;function k(m,y){return m.substring(0,y.offset)+y.content+m.substring(y.offset+y.length)}e.applyEdit=k;function p(m,y){const P=y.slice(0).sort((h,w)=>{const d=h.offset-w.offset;return d===0?h.length-w.length:d});let E=m.length;for(let h=P.length-1;h>=0;h--){const w=P[h];if(w.offset+w.length<=E)m=k(m,w);else throw new Error("Overlapping edit");E=w.offset}return m}e.applyEdits=p}),define(ee[124],te([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class I{constructor(C){this.d=C,this.a=!1}hasValue(){return this.a}getValue(){if(!this.a)try{this.b=this.d()}catch(C){this.c=C}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}map(C){return new I(()=>C(this.getValue()))}}e.Lazy=I}),define(ee[2],te([0,1,50,67]),function(q,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const C=!1;let M=null;function A(l){M=l}if(e.setDisposableTracker=A,C){const l="__is_disposable_tracked__";A(new class{trackDisposable(o){const S=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[l]||console.log(S)},3e3)}setParent(o,S){if(o&&o!==v.None)try{o[l]=!0}catch{}}markAsDisposed(o){if(o&&o!==v.None)try{o[l]=!0}catch{}}markAsSingleton(o){}})}function k(l){return M?.trackDisposable(l),l}function p(l){M?.markAsDisposed(l)}function m(l,o){M?.setParent(l,o)}function y(l,o){if(!!M)for(const S of l)M.setParent(S,o)}function P(l){return M?.markAsSingleton(l),l}e.markAsSingleton=P;function E(l){return typeof l.dispose=="function"&&l.dispose.length===0}e.isDisposable=E;function h(l){if(t.Iterable.is(l)){const o=[];for(const S of l)if(S)try{S.dispose()}catch(D){o.push(D)}if(o.length===1)throw o[0];if(o.length>1)throw new AggregateError(o,"Encountered errors while disposing of store");return Array.isArray(l)?[]:l}else if(l)return l.dispose(),l}e.dispose=h;function w(l){for(const o of l)E(o)&&o.dispose();return[]}e.disposeIfDisposable=w;function d(...l){const o=b(()=>h(l));return y(l,o),o}e.combinedDisposable=d;function b(l){const o=k({dispose:(0,I.once)(()=>{p(o),l()})});return o}e.toDisposable=b;class u{constructor(){this.c=new Set,this.f=!1,k(this)}dispose(){this.f||(p(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{h(this.c)}finally{this.c.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return m(o,this),this.f?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(o),o}}e.DisposableStore=u,u.DISABLE_DISPOSED_WARNING=!1;class v{constructor(){this.q=new u,k(this),m(this.q,this)}dispose(){p(this),this.q.dispose()}B(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(o)}}e.Disposable=v,v.None=Object.freeze({dispose(){}});class g{constructor(){this.b=!1,k(this)}get value(){return this.b?void 0:this.a}set value(o){this.b||o===this.a||(this.a?.dispose(),o&&m(o,this),this.a=o)}clear(){this.value=void 0}dispose(){this.b=!0,p(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const o=this.a;return this.a=void 0,o&&m(o,null),o}}e.MutableDisposable=g;class f{constructor(o){this.b=o,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=f;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,k(this)}set(o){let S=o;return this.unset=()=>S=void 0,this.isset=()=>S!==void 0,this.dispose=()=>{S&&(S(),S=void 0,p(this))},this}}e.SafeDisposable=c;class n{constructor(){this.a=new Map}acquire(o,...S){let D=this.a.get(o);D||(D={counter:0,object:this.b(o,...S)},this.a.set(o,D));const{object:L}=D,j=(0,I.once)(()=>{--D.counter===0&&(this.c(o,D.object),this.a.delete(o))});return D.counter++,{object:L,dispose:j}}}e.ReferenceCollection=n;class r{constructor(o){this.a=o}async acquire(o,...S){const D=this.a.acquire(o,...S);try{return{object:await D.object,dispose:()=>D.dispose()}}catch(L){throw D.dispose(),L}}}e.AsyncReferenceCollection=r;class i{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=i;function a(l){const o=new u;try{l(o)}finally{o.dispose()}}e.disposeOnReturn=a;class s{constructor(){this.a=new Map,this.b=!1,k(this)}dispose(){p(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{h(this.a.values())}finally{this.a.clear()}}has(o){return this.a.has(o)}get(o){return this.a.get(o)}set(o,S,D=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),D||this.a.get(o)?.dispose(),this.a.set(o,S)}deleteAndDispose(o){this.a.get(o)?.dispose(),this.a.delete(o)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=s}),define(ee[96],te([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class I{constructor(M){this.element=M,this.next=I.Undefined,this.prev=I.Undefined}}I.Undefined=new I(void 0);class t{constructor(){this.a=I.Undefined,this.b=I.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===I.Undefined}clear(){let M=this.a;for(;M!==I.Undefined;){const A=M.next;M.prev=I.Undefined,M.next=I.Undefined,M=A}this.a=I.Undefined,this.b=I.Undefined,this.c=0}unshift(M){return this.d(M,!1)}push(M){return this.d(M,!0)}d(M,A){const k=new I(M);if(this.a===I.Undefined)this.a=k,this.b=k;else if(A){const m=this.b;this.b=k,k.prev=m,m.next=k}else{const m=this.a;this.a=k,k.next=m,m.prev=k}this.c+=1;let p=!1;return()=>{p||(p=!0,this.e(k))}}shift(){if(this.a!==I.Undefined){const M=this.a.element;return this.e(this.a),M}}pop(){if(this.b!==I.Undefined){const M=this.b.element;return this.e(this.b),M}}e(M){if(M.prev!==I.Undefined&&M.next!==I.Undefined){const A=M.prev;A.next=M.next,M.next.prev=A}else M.prev===I.Undefined&&M.next===I.Undefined?(this.a=I.Undefined,this.b=I.Undefined):M.next===I.Undefined?(this.b=this.b.prev,this.b.next=I.Undefined):M.prev===I.Undefined&&(this.a=this.a.next,this.a.prev=I.Undefined);this.c-=1}*[Symbol.iterator](){let M=this.a;for(;M!==I.Undefined;)yield M.element,M=M.next}}e.LinkedList=t}),define(ee[39],te([0,1]),function(q,e){"use strict";var I,t,C;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function M(w,d,b){let u=w.get(d);return u===void 0&&(u=b,w.set(d,u)),u}e.getOrSet=M;function A(w){const d=[];return w.forEach((b,u)=>{d.push(`${u} => ${b}`)}),`Map(${w.size}) {${d.join(", ")}}`}e.mapToString=A;function k(w){const d=[];return w.forEach(b=>{d.push(b)}),`Set(${w.size}) {${d.join(", ")}}`}e.setToString=k;class p{constructor(d,b){this.uri=d,this.value=b}}class m{constructor(d,b){this[I]="ResourceMap",d instanceof m?(this.b=new Map(d.b),this.c=b??m.a):(this.b=new Map,this.c=d??m.a)}set(d,b){return this.b.set(this.c(d),new p(d,b)),this}get(d){return this.b.get(this.c(d))?.value}has(d){return this.b.has(this.c(d))}get size(){return this.b.size}clear(){this.b.clear()}delete(d){return this.b.delete(this.c(d))}forEach(d,b){typeof b<"u"&&(d=d.bind(b));for(const[u,v]of this.b)d(v.value,v.uri,this)}*values(){for(const d of this.b.values())yield d.value}*keys(){for(const d of this.b.values())yield d.uri}*entries(){for(const d of this.b.values())yield[d.uri,d.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(const[,d]of this.b)yield[d.uri,d.value]}}e.ResourceMap=m,m.a=w=>w.toString();class y{constructor(d,b){this[t]="ResourceSet",!d||typeof d=="function"?this.a=new m(d):(this.a=new m(b),d.forEach(this.add,this))}get size(){return this.a.size}add(d){return this.a.set(d,d),this}clear(){this.a.clear()}delete(d){return this.a.delete(d)}forEach(d,b){this.a.forEach((u,v)=>d.call(b,v,v,this))}has(d){return this.a.has(d)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=y;var P;(function(w){w[w.None=0]="None",w[w.AsOld=1]="AsOld",w[w.AsNew=2]="AsNew"})(P=e.Touch||(e.Touch={}));class E{constructor(){this[C]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(d){return this.a.has(d)}get(d,b=0){const u=this.a.get(d);if(!!u)return b!==0&&this.j(u,b),u.value}set(d,b,u=0){let v=this.a.get(d);if(v)v.value=b,u!==0&&this.j(v,u);else{switch(v={key:d,value:b,next:void 0,previous:void 0},u){case 0:this.h(v);break;case 1:this.g(v);break;case 2:this.h(v);break;default:this.h(v);break}this.a.set(d,v),this.d++}return this}delete(d){return!!this.remove(d)}remove(d){const b=this.a.get(d);if(!!b)return this.a.delete(d),this.i(b),this.d--,b.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const d=this.b;return this.a.delete(d.key),this.i(d),this.d--,d.value}forEach(d,b){const u=this.e;let v=this.b;for(;v;){if(b?d.bind(b)(v.value,v.key,this):d(v.value,v.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");v=v.next}}keys(){const d=this,b=this.e;let u=this.b;const v={[Symbol.iterator](){return v},next(){if(d.e!==b)throw new Error("LinkedMap got modified during iteration.");if(u){const g={value:u.key,done:!1};return u=u.next,g}else return{value:void 0,done:!0}}};return v}values(){const d=this,b=this.e;let u=this.b;const v={[Symbol.iterator](){return v},next(){if(d.e!==b)throw new Error("LinkedMap got modified during iteration.");if(u){const g={value:u.value,done:!1};return u=u.next,g}else return{value:void 0,done:!0}}};return v}entries(){const d=this,b=this.e;let u=this.b;const v={[Symbol.iterator](){return v},next(){if(d.e!==b)throw new Error("LinkedMap got modified during iteration.");if(u){const g={value:[u.key,u.value],done:!1};return u=u.next,g}else return{value:void 0,done:!0}}};return v}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(d){if(d>=this.size)return;if(d===0){this.clear();return}let b=this.b,u=this.size;for(;b&&u>d;)this.a.delete(b.key),b=b.next,u--;this.b=b,this.d=u,b&&(b.previous=void 0),this.e++}g(d){if(!this.b&&!this.c)this.c=d;else if(this.b)d.next=this.b,this.b.previous=d;else throw new Error("Invalid list");this.b=d,this.e++}h(d){if(!this.b&&!this.c)this.b=d;else if(this.c)d.previous=this.c,this.c.next=d;else throw new Error("Invalid list");this.c=d,this.e++}i(d){if(d===this.b&&d===this.c)this.b=void 0,this.c=void 0;else if(d===this.b){if(!d.next)throw new Error("Invalid list");d.next.previous=void 0,this.b=d.next}else if(d===this.c){if(!d.previous)throw new Error("Invalid list");d.previous.next=void 0,this.c=d.previous}else{const b=d.next,u=d.previous;if(!b||!u)throw new Error("Invalid list");b.previous=u,u.next=b}d.next=void 0,d.previous=void 0,this.e++}j(d,b){if(!this.b||!this.c)throw new Error("Invalid list");if(!(b!==1&&b!==2)){if(b===1){if(d===this.b)return;const u=d.next,v=d.previous;d===this.c?(v.next=void 0,this.c=v):(u.previous=v,v.next=u),d.previous=void 0,d.next=this.b,this.b.previous=d,this.b=d,this.e++}else if(b===2){if(d===this.c)return;const u=d.next,v=d.previous;d===this.b?(u.previous=void 0,this.b=u):(u.previous=v,v.next=u),d.next=void 0,d.previous=this.c,this.c.next=d,this.c=d,this.e++}}}toJSON(){const d=[];return this.forEach((b,u)=>{d.push([u,b])}),d}fromJSON(d){this.clear();for(const[b,u]of d)this.set(b,u)}}e.LinkedMap=E;class h extends E{constructor(d,b=1){super(),this.k=d,this.l=Math.min(Math.max(0,b),1)}get limit(){return this.k}set limit(d){this.k=d,this.m()}get ratio(){return this.l}set ratio(d){this.l=Math.min(Math.max(0,d),1),this.m()}get(d,b=2){return super.get(d,b)}peek(d){return super.get(d,0)}set(d,b){return super.set(d,b,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=h}),define(ee[76],te([0,1,39]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new I.LRUCache(1e4);function C(m){return p(m,"NFC",t)}e.normalizeNFC=C;const M=new I.LRUCache(1e4);function A(m){return p(m,"NFD",M)}e.normalizeNFD=A;const k=/[^\u0000-\u0080]/;function p(m,y,P){if(!m)return m;const E=P.get(m);if(E)return E;let h;return k.test(m)?h=m.normalize(y):h=m,P.set(m,h),h}e.removeAccents=function(){const m=/[\u0300-\u036f]/g;return function(y){return A(y).replace(m,"")}}()}),function(){function q(C){const M=[];typeof C=="number"&&M.push("code/timeOrigin",C);function A(p){M.push(p,Date.now())}function k(){const p=[];for(let m=0;m<M.length;m+=2)p.push({name:M[m],startTime:M[m+1]});return p}return{mark:A,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?q():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const A of performance.getEntriesByType("mark"))M.push({name:A.name,startTime:Math.round(C+A.startTime)});return M}};if(typeof process=="object"){const C=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return q(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),q()}function I(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=I(t))}(),function(q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var t in I)(typeof exports=="object"?exports:q)[t]=I[t]}}(typeof self<"u"?self:this,function(){return function(q){var e={};function I(t){if(e[t])return e[t].exports;var C=e[t]={i:t,l:!1,exports:{}};return q[t].call(C.exports,C,C.exports,I),C.l=!0,C.exports}return I.m=q,I.c=e,I.d=function(t,C,M){I.o(t,C)||Object.defineProperty(t,C,{enumerable:!0,get:M})},I.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},I.t=function(t,C){if(1&C&&(t=I(t)),8&C||4&C&&typeof t=="object"&&t&&t.__esModule)return t;var M=Object.create(null);if(I.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:t}),2&C&&typeof t!="string")for(var A in t)I.d(M,A,function(k){return t[k]}.bind(null,A));return M},I.n=function(t){var C=t&&t.__esModule?function(){return t.default}:function(){return t};return I.d(C,"a",C),C},I.o=function(t,C){return Object.prototype.hasOwnProperty.call(t,C)},I.p="",I(I.s=0)}([function(q,e,I){(function(t){var C;e=q.exports=R,C=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var Q=Array.prototype.slice.call(arguments,0);Q.unshift("SEMVER"),console.log.apply(console,Q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,k=e.re=[],p=e.src=[],m=0,y=m++;p[y]="0|[1-9]\\d*";var P=m++;p[P]="[0-9]+";var E=m++;p[E]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var h=m++;p[h]="("+p[y]+")\\.("+p[y]+")\\.("+p[y]+")";var w=m++;p[w]="("+p[P]+")\\.("+p[P]+")\\.("+p[P]+")";var d=m++;p[d]="(?:"+p[y]+"|"+p[E]+")";var b=m++;p[b]="(?:"+p[P]+"|"+p[E]+")";var u=m++;p[u]="(?:-("+p[d]+"(?:\\."+p[d]+")*))";var v=m++;p[v]="(?:-?("+p[b]+"(?:\\."+p[b]+")*))";var g=m++;p[g]="[0-9A-Za-z-]+";var f=m++;p[f]="(?:\\+("+p[g]+"(?:\\."+p[g]+")*))";var c=m++,n="v?"+p[h]+p[u]+"?"+p[f]+"?";p[c]="^"+n+"$";var r="[v=\\s]*"+p[w]+p[v]+"?"+p[f]+"?",i=m++;p[i]="^"+r+"$";var a=m++;p[a]="((?:<|>)?=?)";var s=m++;p[s]=p[P]+"|x|X|\\*";var l=m++;p[l]=p[y]+"|x|X|\\*";var o=m++;p[o]="[v=\\s]*("+p[l]+")(?:\\.("+p[l]+")(?:\\.("+p[l]+")(?:"+p[u]+")?"+p[f]+"?)?)?";var S=m++;p[S]="[v=\\s]*("+p[s]+")(?:\\.("+p[s]+")(?:\\.("+p[s]+")(?:"+p[v]+")?"+p[f]+"?)?)?";var D=m++;p[D]="^"+p[a]+"\\s*"+p[o]+"$";var L=m++;p[L]="^"+p[a]+"\\s*"+p[S]+"$";var j=m++;p[j]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var X=m++;p[X]="(?:~>?)";var ae=m++;p[ae]="(\\s*)"+p[X]+"\\s+",k[ae]=new RegExp(p[ae],"g");var Y=m++;p[Y]="^"+p[X]+p[o]+"$";var J=m++;p[J]="^"+p[X]+p[S]+"$";var se=m++;p[se]="(?:\\^)";var ne=m++;p[ne]="(\\s*)"+p[se]+"\\s+",k[ne]=new RegExp(p[ne],"g");var he=m++;p[he]="^"+p[se]+p[o]+"$";var K=m++;p[K]="^"+p[se]+p[S]+"$";var le=m++;p[le]="^"+p[a]+"\\s*("+r+")$|^$";var W=m++;p[W]="^"+p[a]+"\\s*("+n+")$|^$";var F=m++;p[F]="(\\s*)"+p[a]+"\\s*("+r+"|"+p[o]+")",k[F]=new RegExp(p[F],"g");var N=m++;p[N]="^\\s*("+p[o]+")\\s+-\\s+("+p[o]+")\\s*$";var H=m++;p[H]="^\\s*("+p[S]+")\\s+-\\s+("+p[S]+")\\s*$";var re=m++;p[re]="(<|>)?=?\\s*\\*";for(var z=0;z<35;z++)C(z,p[z]),k[z]||(k[z]=new RegExp(p[z]));function T(Q,fe){if(Q instanceof R)return Q;if(typeof Q!="string"||Q.length>M||!(fe?k[i]:k[c]).test(Q))return null;try{return new R(Q,fe)}catch{return null}}function R(Q,fe){if(Q instanceof R){if(Q.loose===fe)return Q;Q=Q.version}else if(typeof Q!="string")throw new TypeError("Invalid Version: "+Q);if(Q.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof R))return new R(Q,fe);C("SemVer",Q,fe),this.loose=fe;var de=Q.trim().match(fe?k[i]:k[c]);if(!de)throw new TypeError("Invalid Version: "+Q);if(this.raw=Q,this.major=+de[1],this.minor=+de[2],this.patch=+de[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");de[4]?this.prerelease=de[4].split(".").map(function(ye){if(/^[0-9]+$/.test(ye)){var Ie=+ye;if(Ie>=0&&Ie<A)return Ie}return ye}):this.prerelease=[],this.build=de[5]?de[5].split("."):[],this.format()}e.parse=T,e.valid=function(Q,fe){var de=T(Q,fe);return de?de.version:null},e.clean=function(Q,fe){var de=T(Q.trim().replace(/^[=v]+/,""),fe);return de?de.version:null},e.SemVer=R,R.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},R.prototype.toString=function(){return this.version},R.prototype.compare=function(Q){return C("SemVer.compare",this.version,this.loose,Q),Q instanceof R||(Q=new R(Q,this.loose)),this.compareMain(Q)||this.comparePre(Q)},R.prototype.compareMain=function(Q){return Q instanceof R||(Q=new R(Q,this.loose)),U(this.major,Q.major)||U(this.minor,Q.minor)||U(this.patch,Q.patch)},R.prototype.comparePre=function(Q){if(Q instanceof R||(Q=new R(Q,this.loose)),this.prerelease.length&&!Q.prerelease.length)return-1;if(!this.prerelease.length&&Q.prerelease.length)return 1;if(!this.prerelease.length&&!Q.prerelease.length)return 0;var fe=0;do{var de=this.prerelease[fe],ye=Q.prerelease[fe];if(C("prerelease compare",fe,de,ye),de===void 0&&ye===void 0)return 0;if(ye===void 0)return 1;if(de===void 0)return-1;if(de!==ye)return U(de,ye)}while(++fe)},R.prototype.inc=function(Q,fe){switch(Q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var de=this.prerelease.length;--de>=0;)typeof this.prerelease[de]=="number"&&(this.prerelease[de]++,de=-2);de===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+Q)}return this.format(),this.raw=this.version,this},e.inc=function(Q,fe,de,ye){typeof de=="string"&&(ye=de,de=void 0);try{return new R(Q,de).inc(fe,ye).version}catch{return null}},e.diff=function(Q,fe){if($(Q,fe))return null;var de=T(Q),ye=T(fe);if(de.prerelease.length||ye.prerelease.length){for(var Ie in de)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&de[Ie]!==ye[Ie])return"pre"+Ie;return"prerelease"}for(var Ie in de)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&de[Ie]!==ye[Ie])return Ie},e.compareIdentifiers=U;var O=/^[0-9]+$/;function U(Q,fe){var de=O.test(Q),ye=O.test(fe);return de&&ye&&(Q=+Q,fe=+fe),de&&!ye?-1:ye&&!de?1:Q<fe?-1:Q>fe?1:0}function B(Q,fe,de){return new R(Q,de).compare(new R(fe,de))}function V(Q,fe,de){return B(Q,fe,de)>0}function ie(Q,fe,de){return B(Q,fe,de)<0}function $(Q,fe,de){return B(Q,fe,de)===0}function Z(Q,fe,de){return B(Q,fe,de)!==0}function x(Q,fe,de){return B(Q,fe,de)>=0}function oe(Q,fe,de){return B(Q,fe,de)<=0}function ge(Q,fe,de,ye){var Ie;switch(fe){case"===":typeof Q=="object"&&(Q=Q.version),typeof de=="object"&&(de=de.version),Ie=Q===de;break;case"!==":typeof Q=="object"&&(Q=Q.version),typeof de=="object"&&(de=de.version),Ie=Q!==de;break;case"":case"=":case"==":Ie=$(Q,de,ye);break;case"!=":Ie=Z(Q,de,ye);break;case">":Ie=V(Q,de,ye);break;case">=":Ie=x(Q,de,ye);break;case"<":Ie=ie(Q,de,ye);break;case"<=":Ie=oe(Q,de,ye);break;default:throw new TypeError("Invalid operator: "+fe)}return Ie}function De(Q,fe){if(Q instanceof De){if(Q.loose===fe)return Q;Q=Q.value}if(!(this instanceof De))return new De(Q,fe);C("comparator",Q,fe),this.loose=fe,this.parse(Q),this.semver===Oe?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(Q,fe){return U(fe,Q)},e.major=function(Q,fe){return new R(Q,fe).major},e.minor=function(Q,fe){return new R(Q,fe).minor},e.patch=function(Q,fe){return new R(Q,fe).patch},e.compare=B,e.compareLoose=function(Q,fe){return B(Q,fe,!0)},e.rcompare=function(Q,fe,de){return B(fe,Q,de)},e.sort=function(Q,fe){return Q.sort(function(de,ye){return e.compare(de,ye,fe)})},e.rsort=function(Q,fe){return Q.sort(function(de,ye){return e.rcompare(de,ye,fe)})},e.gt=V,e.lt=ie,e.eq=$,e.neq=Z,e.gte=x,e.lte=oe,e.cmp=ge,e.Comparator=De;var Oe={};function Ce(Q,fe){if(Q instanceof Ce)return Q.loose===fe?Q:new Ce(Q.raw,fe);if(Q instanceof De)return new Ce(Q.value,fe);if(!(this instanceof Ce))return new Ce(Q,fe);if(this.loose=fe,this.raw=Q,this.set=Q.split(/\s*\|\|\s*/).map(function(de){return this.parseRange(de.trim())},this).filter(function(de){return de.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Q);this.format()}function Re(Q){return!Q||Q.toLowerCase()==="x"||Q==="*"}function be(Q,fe,de,ye,Ie,Te,Fe,qe,Ue,$e,Je,je,Ke){return((fe=Re(de)?"":Re(ye)?">="+de+".0.0":Re(Ie)?">="+de+"."+ye+".0":">="+fe)+" "+(qe=Re(Ue)?"":Re($e)?"<"+(+Ue+1)+".0.0":Re(Je)?"<"+Ue+"."+(+$e+1)+".0":je?"<="+Ue+"."+$e+"."+Je+"-"+je:"<="+qe)).trim()}function we(Q,fe){for(var de=0;de<Q.length;de++)if(!Q[de].test(fe))return!1;if(fe.prerelease.length){for(de=0;de<Q.length;de++)if(C(Q[de].semver),Q[de].semver!==Oe&&Q[de].semver.prerelease.length>0){var ye=Q[de].semver;if(ye.major===fe.major&&ye.minor===fe.minor&&ye.patch===fe.patch)return!0}return!1}return!0}function ve(Q,fe,de){try{fe=new Ce(fe,de)}catch{return!1}return fe.test(Q)}function Me(Q,fe,de,ye){var Ie,Te,Fe,qe,Ue;switch(Q=new R(Q,ye),fe=new Ce(fe,ye),de){case">":Ie=V,Te=oe,Fe=ie,qe=">",Ue=">=";break;case"<":Ie=ie,Te=x,Fe=V,qe="<",Ue="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ve(Q,fe,ye))return!1;for(var $e=0;$e<fe.set.length;++$e){var Je=fe.set[$e],je=null,Ke=null;if(Je.forEach(function(G){G.semver===Oe&&(G=new De(">=0.0.0")),je=je||G,Ke=Ke||G,Ie(G.semver,je.semver,ye)?je=G:Fe(G.semver,Ke.semver,ye)&&(Ke=G)}),je.operator===qe||je.operator===Ue||(!Ke.operator||Ke.operator===qe)&&Te(Q,Ke.semver)||Ke.operator===Ue&&Fe(Q,Ke.semver))return!1}return!0}De.prototype.parse=function(Q){var fe=this.loose?k[le]:k[W],de=Q.match(fe);if(!de)throw new TypeError("Invalid comparator: "+Q);this.operator=de[1],this.operator==="="&&(this.operator=""),de[2]?this.semver=new R(de[2],this.loose):this.semver=Oe},De.prototype.toString=function(){return this.value},De.prototype.test=function(Q){return C("Comparator.test",Q,this.loose),this.semver===Oe||(typeof Q=="string"&&(Q=new R(Q,this.loose)),ge(Q,this.operator,this.semver,this.loose))},De.prototype.intersects=function(Q,fe){if(!(Q instanceof De))throw new TypeError("a Comparator is required");var de;if(this.operator==="")return de=new Ce(Q.value,fe),ve(this.value,de,fe);if(Q.operator==="")return de=new Ce(this.value,fe),ve(Q.semver,de,fe);var ye=!(this.operator!==">="&&this.operator!==">"||Q.operator!==">="&&Q.operator!==">"),Ie=!(this.operator!=="<="&&this.operator!=="<"||Q.operator!=="<="&&Q.operator!=="<"),Te=this.semver.version===Q.semver.version,Fe=!(this.operator!==">="&&this.operator!=="<="||Q.operator!==">="&&Q.operator!=="<="),qe=ge(this.semver,"<",Q.semver,fe)&&(this.operator===">="||this.operator===">")&&(Q.operator==="<="||Q.operator==="<"),Ue=ge(this.semver,">",Q.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(Q.operator===">="||Q.operator===">");return ye||Ie||Te&&Fe||qe||Ue},e.Range=Ce,Ce.prototype.format=function(){return this.range=this.set.map(function(Q){return Q.join(" ").trim()}).join("||").trim(),this.range},Ce.prototype.toString=function(){return this.range},Ce.prototype.parseRange=function(Q){var fe=this.loose;Q=Q.trim(),C("range",Q,fe);var de=fe?k[H]:k[N];Q=Q.replace(de,be),C("hyphen replace",Q),Q=Q.replace(k[F],"$1$2$3"),C("comparator trim",Q,k[F]),Q=(Q=(Q=Q.replace(k[ae],"$1~")).replace(k[ne],"$1^")).split(/\s+/).join(" ");var ye=fe?k[le]:k[W],Ie=Q.split(" ").map(function(Te){return function(Fe,qe){return C("comp",Fe),Fe=function(Ue,$e){return Ue.trim().split(/\s+/).map(function(Je){return function(je,Ke){C("caret",je,Ke);var G=Ke?k[K]:k[he];return je.replace(G,function(ce,ue,me,Se,Le){var Be;return C("caret",je,ce,ue,me,Se,Le),Re(ue)?Be="":Re(me)?Be=">="+ue+".0.0 <"+(+ue+1)+".0.0":Re(Se)?Be=ue==="0"?">="+ue+"."+me+".0 <"+ue+"."+(+me+1)+".0":">="+ue+"."+me+".0 <"+(+ue+1)+".0.0":Le?(C("replaceCaret pr",Le),Le.charAt(0)!=="-"&&(Le="-"+Le),Be=ue==="0"?me==="0"?">="+ue+"."+me+"."+Se+Le+" <"+ue+"."+me+"."+(+Se+1):">="+ue+"."+me+"."+Se+Le+" <"+ue+"."+(+me+1)+".0":">="+ue+"."+me+"."+Se+Le+" <"+(+ue+1)+".0.0"):(C("no pr"),Be=ue==="0"?me==="0"?">="+ue+"."+me+"."+Se+" <"+ue+"."+me+"."+(+Se+1):">="+ue+"."+me+"."+Se+" <"+ue+"."+(+me+1)+".0":">="+ue+"."+me+"."+Se+" <"+(+ue+1)+".0.0"),C("caret return",Be),Be})}(Je,$e)}).join(" ")}(Fe,qe),C("caret",Fe),Fe=function(Ue,$e){return Ue.trim().split(/\s+/).map(function(Je){return function(je,Ke){var G=Ke?k[J]:k[Y];return je.replace(G,function(ce,ue,me,Se,Le){var Be;return C("tilde",je,ce,ue,me,Se,Le),Re(ue)?Be="":Re(me)?Be=">="+ue+".0.0 <"+(+ue+1)+".0.0":Re(Se)?Be=">="+ue+"."+me+".0 <"+ue+"."+(+me+1)+".0":Le?(C("replaceTilde pr",Le),Le.charAt(0)!=="-"&&(Le="-"+Le),Be=">="+ue+"."+me+"."+Se+Le+" <"+ue+"."+(+me+1)+".0"):Be=">="+ue+"."+me+"."+Se+" <"+ue+"."+(+me+1)+".0",C("tilde return",Be),Be})}(Je,$e)}).join(" ")}(Fe,qe),C("tildes",Fe),Fe=function(Ue,$e){return C("replaceXRanges",Ue,$e),Ue.split(/\s+/).map(function(Je){return function(je,Ke){je=je.trim();var G=Ke?k[L]:k[D];return je.replace(G,function(ce,ue,me,Se,Le,Be){C("xRange",je,ce,ue,me,Se,Le,Be);var it=Re(me),Ze=it||Re(Se),Ve=Ze||Re(Le);return ue==="="&&Ve&&(ue=""),it?ce=ue===">"||ue==="<"?"<0.0.0":"*":ue&&Ve?(Ze&&(Se=0),Ve&&(Le=0),ue===">"?(ue=">=",Ze?(me=+me+1,Se=0,Le=0):Ve&&(Se=+Se+1,Le=0)):ue==="<="&&(ue="<",Ze?me=+me+1:Se=+Se+1),ce=ue+me+"."+Se+"."+Le):Ze?ce=">="+me+".0.0 <"+(+me+1)+".0.0":Ve&&(ce=">="+me+"."+Se+".0 <"+me+"."+(+Se+1)+".0"),C("xRange return",ce),ce})}(Je,$e)}).join(" ")}(Fe,qe),C("xrange",Fe),Fe=function(Ue,$e){return C("replaceStars",Ue,$e),Ue.trim().replace(k[re],"")}(Fe,qe),C("stars",Fe),Fe}(Te,fe)}).join(" ").split(/\s+/);return this.loose&&(Ie=Ie.filter(function(Te){return!!Te.match(ye)})),Ie=Ie.map(function(Te){return new De(Te,fe)})},Ce.prototype.intersects=function(Q,fe){if(!(Q instanceof Ce))throw new TypeError("a Range is required");return this.set.some(function(de){return de.every(function(ye){return Q.set.some(function(Ie){return Ie.every(function(Te){return ye.intersects(Te,fe)})})})})},e.toComparators=function(Q,fe){return new Ce(Q,fe).set.map(function(de){return de.map(function(ye){return ye.value}).join(" ").trim().split(" ")})},Ce.prototype.test=function(Q){if(!Q)return!1;typeof Q=="string"&&(Q=new R(Q,this.loose));for(var fe=0;fe<this.set.length;fe++)if(we(this.set[fe],Q))return!0;return!1},e.satisfies=ve,e.maxSatisfying=function(Q,fe,de){var ye=null,Ie=null;try{var Te=new Ce(fe,de)}catch{return null}return Q.forEach(function(Fe){Te.test(Fe)&&(ye&&Ie.compare(Fe)!==-1||(Ie=new R(ye=Fe,de)))}),ye},e.minSatisfying=function(Q,fe,de){var ye=null,Ie=null;try{var Te=new Ce(fe,de)}catch{return null}return Q.forEach(function(Fe){Te.test(Fe)&&(ye&&Ie.compare(Fe)!==1||(Ie=new R(ye=Fe,de)))}),ye},e.validRange=function(Q,fe){try{return new Ce(Q,fe).range||"*"}catch{return null}},e.ltr=function(Q,fe,de){return Me(Q,fe,"<",de)},e.gtr=function(Q,fe,de){return Me(Q,fe,">",de)},e.outside=Me,e.prerelease=function(Q,fe){var de=T(Q,fe);return de&&de.prerelease.length?de.prerelease:null},e.intersects=function(Q,fe,de){return Q=new Ce(Q,de),fe=new Ce(fe,de),Q.intersects(fe)},e.coerce=function(Q){if(Q instanceof R)return Q;if(typeof Q!="string")return null;var fe=Q.match(k[j]);return fe==null?null:T((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,I(1))},function(q,e){var I,t,C=q.exports={};function M(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function k(b){if(I===setTimeout)return setTimeout(b,0);if((I===M||!I)&&setTimeout)return I=setTimeout,setTimeout(b,0);try{return I(b,0)}catch{try{return I.call(null,b,0)}catch{return I.call(this,b,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:M}catch{I=M}try{t=typeof clearTimeout=="function"?clearTimeout:A}catch{t=A}})();var p,m=[],y=!1,P=-1;function E(){y&&p&&(y=!1,p.length?m=p.concat(m):P=-1,m.length&&h())}function h(){if(!y){var b=k(E);y=!0;for(var u=m.length;u;){for(p=m,m=[];++P<u;)p&&p[P].run();P=-1,u=m.length}p=null,y=!1,function(v){if(t===clearTimeout)return clearTimeout(v);if((t===A||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(v);try{t(v)}catch{try{return t.call(null,v)}catch{return t.call(this,v)}}}(b)}}function w(b,u){this.fun=b,this.array=u}function d(){}C.nextTick=function(b){var u=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)u[v-1]=arguments[v];m.push(new w(b,u)),m.length!==1||y||k(h)},w.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=d,C.addListener=d,C.once=d,C.off=d,C.removeListener=d,C.removeAllListeners=d,C.emit=d,C.prependListener=d,C.prependOnceListener=d,C.listeners=function(b){return[]},C.binding=function(b){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(b){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(ee[125],te([0,1]),function(q,e){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(k,p,m){this.level=k,this.key=p,this.value=m,this.forward=[]}}const C=void 0;class M{constructor(k,p=2**16){this.comparator=k,this[I]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(p)|0),this.e=new t(this.c,C,C)}get size(){return this.f}clear(){this.e=new t(this.c,C,C)}has(k){return Boolean(M.g(this,k,this.comparator))}get(k){return M.g(this,k,this.comparator)?.value}set(k,p){return M.h(this,k,p,this.comparator)&&(this.f+=1),this}delete(k){const p=M.k(this,k,this.comparator);return p&&(this.f-=1),p}forEach(k,p){let m=this.e.forward[0];for(;m;)k.call(p,m.value,m.key,this),m=m.forward[0]}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let k=this.e.forward[0];for(;k;)yield[k.key,k.value],k=k.forward[0]}*keys(){let k=this.e.forward[0];for(;k;)yield k.key,k=k.forward[0]}*values(){let k=this.e.forward[0];for(;k;)yield k.value,k=k.forward[0]}toString(){let k="[SkipList]:",p=this.e.forward[0];for(;p;)k+=`node(${p.key}, ${p.value}, lvl:${p.level})`,p=p.forward[0];return k}static g(k,p,m){let y=k.e;for(let P=k.d-1;P>=0;P--)for(;y.forward[P]&&m(y.forward[P].key,p)<0;)y=y.forward[P];if(y=y.forward[0],y&&m(y.key,p)===0)return y}static h(k,p,m,y){const P=[];let E=k.e;for(let h=k.d-1;h>=0;h--){for(;E.forward[h]&&y(E.forward[h].key,p)<0;)E=E.forward[h];P[h]=E}if(E=E.forward[0],E&&y(E.key,p)===0)return E.value=m,!1;{const h=M.j(k);if(h>k.d){for(let w=k.d;w<h;w++)P[w]=k.e;k.d=h}E=new t(h,p,m);for(let w=0;w<h;w++)E.forward[w]=P[w].forward[w],P[w].forward[w]=E;return!0}}static j(k,p=.5){let m=1;for(;Math.random()<p&&m<k.c;)m+=1;return m}static k(k,p,m){const y=[];let P=k.e;for(let E=k.d-1;E>=0;E--){for(;P.forward[E]&&m(P.forward[E].key,p)<0;)P=P.forward[E];y[E]=P}if(P=P.forward[0],!P||m(P.key,p)!==0)return!1;for(let E=0;E<k.d&&y[E].forward[E]===P;E++)y[E].forward[E]=P.forward[E];for(;k.d>0&&k.e.forward[k.d-1]===C;)k.d-=1;return!0}}e.SkipList=M}),define(ee[59],te([0,1,14,2]),function(q,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function C(f){const c=f;return c?typeof c.read=="function":!1}e.isReadable=C;function M(f){const c=f;return c?[c.on,c.pause,c.resume,c.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=M;function A(f){const c=f;return c?M(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=A;function k(f,c){return new p(f,c)}e.newWriteableStream=k;class p{constructor(c,n){this.e=c,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(c){if(!this.a.destroyed){if(this.a.flowing)this.g(c);else if(this.b.data.push(c),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(c){this.a.destroyed||(this.a.flowing?this.h(c):this.b.error.push(c))}end(c){this.a.destroyed||(typeof c<"u"&&this.write(c),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(c){this.c.data.slice(0).forEach(n=>n(c))}h(c){this.c.error.length===0?(0,I.onUnexpectedError)(c):this.c.error.slice(0).forEach(n=>n(c))}i(){this.c.end.slice(0).forEach(c=>c())}on(c,n){if(!this.a.destroyed)switch(c){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(c,n){if(this.a.destroyed)return;let r;switch(c){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const i=r.indexOf(n);i>=0&&r.splice(i,1)}}j(){if(this.b.data.length>0){const c=this.e(this.b.data);this.g(c),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const c of this.b.error)this.h(c);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function m(f,c){const n=[];let r;for(;(r=f.read())!==null;)n.push(r);return c(n)}e.consumeReadable=m;function y(f,c,n){const r=[];let i;for(;(i=f.read())!==null&&r.length<n;)r.push(i);return i===null&&r.length>0?c(r):{read:()=>{if(r.length>0)return r.shift();if(typeof i<"u"){const a=i;return i=void 0,a}return f.read()}}}e.peekReadable=y;function P(f,c){return new Promise((n,r)=>{const i=[];E(f,{onData:a=>{c&&i.push(a)},onError:a=>{c?r(a):n(void 0)},onEnd:()=>{n(c?c(i):void 0)}})})}e.consumeStream=P;function E(f,c){let n=!1;return f.on("error",r=>{n||c.onError(r)}),f.on("end",()=>{n||c.onEnd()}),f.on("data",r=>{n||c.onData(r)}),(0,t.toDisposable)(()=>n=!0)}e.listenStream=E;function h(f,c){return new Promise((n,r)=>{const i=new t.DisposableStore,a=[],s=S=>{if(a.push(S),a.length>c)return i.dispose(),f.pause(),n({stream:f,buffer:a,ended:!1})},l=S=>r(S),o=()=>n({stream:f,buffer:a,ended:!0});i.add((0,t.toDisposable)(()=>f.removeListener("error",l))),f.on("error",l),i.add((0,t.toDisposable)(()=>f.removeListener("end",o))),f.on("end",o),i.add((0,t.toDisposable)(()=>f.removeListener("data",s))),f.on("data",s)})}e.peekStream=h;function w(f,c){const n=k(c);return n.end(f),n}e.toStream=w;function d(){const f=k(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=d;function b(f){let c=!1;return{read:()=>c?null:(c=!0,f)}}e.toReadable=b;function u(f,c,n){const r=k(n);return E(f,{onData:i=>r.write(c.data(i)),onError:i=>r.error(c.error?c.error(i):i),onEnd:()=>r.end()}),r}e.transform=u;function v(f,c,n){let r=!1;return{read:()=>{const i=c.read();return r?i:(r=!0,i!==null?n([f,i]):f)}}}e.prefixedReadable=v;function g(f,c,n){let r=!1;const i=k(n);return E(c,{onData:a=>r?i.write(a):(r=!0,i.write(n([f,a]))),onError:a=>i.error(a),onEnd:()=>{r||(r=!0,i.write(f)),i.end()}}),i}e.prefixedStream=g}),define(ee[17],te([0,1,59]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let C,M;class A{static alloc(S){return t?new A(Buffer.allocUnsafe(S)):new A(new Uint8Array(S))}static wrap(S){return t&&!Buffer.isBuffer(S)&&(S=Buffer.from(S.buffer,S.byteOffset,S.byteLength)),new A(S)}static fromString(S,D){return!(D?.dontUseNodeBuffer||!1)&&t?new A(Buffer.from(S)):(C||(C=new TextEncoder),new A(C.encode(S)))}static fromByteArray(S){const D=A.alloc(S.length);for(let L=0,j=S.length;L<j;L++)D.buffer[L]=S[L];return D}static concat(S,D){if(typeof D>"u"){D=0;for(let X=0,ae=S.length;X<ae;X++)D+=S[X].byteLength}const L=A.alloc(D);let j=0;for(let X=0,ae=S.length;X<ae;X++){const Y=S[X];L.set(Y,j),j+=Y.byteLength}return L}constructor(S){this.buffer=S,this.byteLength=this.buffer.byteLength}clone(){const S=A.alloc(this.byteLength);return S.set(this),S}toString(){return t?this.buffer.toString():(M||(M=new TextDecoder),M.decode(this.buffer))}slice(S,D){return new A(this.buffer.subarray(S,D))}set(S,D){if(S instanceof A)this.buffer.set(S.buffer,D);else if(S instanceof Uint8Array)this.buffer.set(S,D);else if(S instanceof ArrayBuffer)this.buffer.set(new Uint8Array(S),D);else if(ArrayBuffer.isView(S))this.buffer.set(new Uint8Array(S.buffer,S.byteOffset,S.byteLength),D);else throw new Error("Unknown argument 'array'")}readUInt32BE(S){return m(this.buffer,S)}writeUInt32BE(S,D){y(this.buffer,S,D)}readUInt32LE(S){return P(this.buffer,S)}writeUInt32LE(S,D){E(this.buffer,S,D)}readUInt8(S){return h(this.buffer,S)}writeUInt8(S,D){w(this.buffer,S,D)}}e.VSBuffer=A;function k(o,S){return o[S+0]<<0>>>0|o[S+1]<<8>>>0}e.readUInt16LE=k;function p(o,S,D){o[D+0]=S&255,S=S>>>8,o[D+1]=S&255}e.writeUInt16LE=p;function m(o,S){return o[S]*2**24+o[S+1]*2**16+o[S+2]*2**8+o[S+3]}e.readUInt32BE=m;function y(o,S,D){o[D+3]=S,S=S>>>8,o[D+2]=S,S=S>>>8,o[D+1]=S,S=S>>>8,o[D]=S}e.writeUInt32BE=y;function P(o,S){return o[S+0]<<0>>>0|o[S+1]<<8>>>0|o[S+2]<<16>>>0|o[S+3]<<24>>>0}e.readUInt32LE=P;function E(o,S,D){o[D+0]=S&255,S=S>>>8,o[D+1]=S&255,S=S>>>8,o[D+2]=S&255,S=S>>>8,o[D+3]=S&255}e.writeUInt32LE=E;function h(o,S){return o[S]}e.readUInt8=h;function w(o,S,D){o[D]=S}e.writeUInt8=w;function d(o){return I.consumeReadable(o,S=>A.concat(S))}e.readableToBuffer=d;function b(o){return I.toReadable(o)}e.bufferToReadable=b;function u(o){return I.consumeStream(o,S=>A.concat(S))}e.streamToBuffer=u;async function v(o){return o.ended?A.concat(o.buffer):A.concat([...o.buffer,await u(o.stream)])}e.bufferedStreamToBuffer=v;function g(o){return I.toStream(o,S=>A.concat(S))}e.bufferToStream=g;function f(o){return I.transform(o,{data:S=>typeof S=="string"?A.fromString(S):A.wrap(S)},S=>A.concat(S))}e.streamToBufferReadableStream=f;function c(o){return I.newWriteableStream(S=>A.concat(S),o)}e.newWriteableBufferStream=c;function n(o,S){return I.prefixedReadable(o,S,D=>A.concat(D))}e.prefixedBufferReadable=n;function r(o,S){return I.prefixedStream(o,S,D=>A.concat(D))}e.prefixedBufferStream=r;function i(o){let S=0,D=0,L=0;const j=new Uint8Array(Math.floor(o.length/4*3)),X=Y=>{switch(D){case 3:j[L++]=S|Y,D=0;break;case 2:j[L++]=S|Y>>>2,S=Y<<6,D=3;break;case 1:j[L++]=S|Y>>>4,S=Y<<4,D=2;break;default:S=Y<<2,D=1}};for(let Y=0;Y<o.length;Y++){const J=o.charCodeAt(Y);if(J>=65&&J<=90)X(J-65);else if(J>=97&&J<=122)X(J-97+26);else if(J>=48&&J<=57)X(J-48+52);else if(J===43||J===45)X(62);else if(J===47||J===95)X(63);else{if(J===61)break;throw new SyntaxError(`Unexpected base64 character ${o[Y]}`)}}const ae=L;for(;D>0;)X(0);return A.wrap(j).slice(0,ae)}e.decodeBase64=i;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function l({buffer:o},S=!0,D=!1){const L=D?s:a;let j="";const X=o.byteLength%3;let ae=0;for(;ae<o.byteLength-X;ae+=3){const Y=o[ae+0],J=o[ae+1],se=o[ae+2];j+=L[Y>>>2],j+=L[(Y<<4|J>>>4)&63],j+=L[(J<<2|se>>>6)&63],j+=L[se&63]}if(X===1){const Y=o[ae+0];j+=L[Y>>>2],j+=L[Y<<4&63],S&&(j+="==")}else if(X===2){const Y=o[ae+0],J=o[ae+1];j+=L[Y>>>2],j+=L[(Y<<4|J>>>4)&63],j+=L[J<<2&63],S&&(j+="=")}return j}e.encodeBase64=l}),define(ee[12],te([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function I(r){return typeof r=="string"}e.isString=I;function t(r){return Array.isArray(r)&&r.every(i=>I(i))}e.isStringArray=t;function C(r){return typeof r=="object"&&r!==null&&!Array.isArray(r)&&!(r instanceof RegExp)&&!(r instanceof Date)}e.isObject=C;function M(r){const i=Object.getPrototypeOf(Uint8Array);return typeof r=="object"&&r instanceof i}e.isTypedArray=M;function A(r){return typeof r=="number"&&!isNaN(r)}e.isNumber=A;function k(r){return!!r&&typeof r[Symbol.iterator]=="function"}e.isIterable=k;function p(r){return r===!0||r===!1}e.isBoolean=p;function m(r){return typeof r>"u"}e.isUndefined=m;function y(r){return!P(r)}e.isDefined=y;function P(r){return m(r)||r===null}e.isUndefinedOrNull=P;function E(r,i){if(!r)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.assertType=E;function h(r){if(P(r))throw new Error("Assertion Failed: argument is undefined or null");return r}e.assertIsDefined=h;function w(...r){const i=[];for(let a=0;a<r.length;a++){const s=r[a];if(P(s))throw new Error(`Assertion Failed: argument at index ${a} is undefined or null`);i.push(s)}return i}e.assertAllDefined=w;const d=Object.prototype.hasOwnProperty;function b(r){if(!C(r))return!1;for(const i in r)if(d.call(r,i))return!1;return!0}e.isEmptyObject=b;function u(r){return typeof r=="function"}e.isFunction=u;function v(...r){return r.length>0&&r.every(u)}e.areFunctions=v;function g(r,i){const a=Math.min(r.length,i.length);for(let s=0;s<a;s++)f(r[s],i[s])}e.validateConstraints=g;function f(r,i){if(I(i)){if(typeof r!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(u(i)){try{if(r instanceof i)return}catch{}if(!P(r)&&r.constructor===i||i.length===1&&i.call(void 0,r)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=f;function c(r){return r===null?void 0:r}e.withNullAsUndefined=c;function n(r){return typeof r>"u"?null:r}e.withUndefinedAsNull=n}),define(ee[44],te([0,1,12]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const v=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([g,f])=>{v[g]=f&&typeof f=="object"?t(f):f}),v}e.deepClone=t;function C(u){if(!u||typeof u!="object")return u;const v=[u];for(;v.length>0;){const g=v.shift();Object.freeze(g);for(const f in g)if(M.call(g,f)){const c=g[f];typeof c=="object"&&!Object.isFrozen(c)&&!(0,I.isTypedArray)(c)&&v.push(c)}}return u}e.deepFreeze=C;const M=Object.prototype.hasOwnProperty;function A(u,v){return k(u,v,new Set)}e.cloneAndChange=A;function k(u,v,g){if((0,I.isUndefinedOrNull)(u))return u;const f=v(u);if(typeof f<"u")return f;if(Array.isArray(u)){const c=[];for(const n of u)c.push(k(n,v,g));return c}if((0,I.isObject)(u)){if(g.has(u))throw new Error("Cannot clone recursive data-structure");g.add(u);const c={};for(const n in u)M.call(u,n)&&(c[n]=k(u[n],v,g));return g.delete(u),c}return u}function p(u,v,g=!0){return(0,I.isObject)(u)?((0,I.isObject)(v)&&Object.keys(v).forEach(f=>{f in u?g&&((0,I.isObject)(u[f])&&(0,I.isObject)(v[f])?p(u[f],v[f],g):u[f]=v[f]):u[f]=v[f]}),u):v}e.mixin=p;function m(u,v){if(u===v)return!0;if(u==null||v===null||v===void 0||typeof u!=typeof v||typeof u!="object"||Array.isArray(u)!==Array.isArray(v))return!1;let g,f;if(Array.isArray(u)){if(u.length!==v.length)return!1;for(g=0;g<u.length;g++)if(!m(u[g],v[g]))return!1}else{const c=[];for(f in u)c.push(f);c.sort();const n=[];for(f in v)n.push(f);if(n.sort(),!m(c,n))return!1;for(g=0;g<c.length;g++)if(!m(u[c[g]],v[c[g]]))return!1}return!0}e.equals=m;function y(u){const v=new Set;return JSON.stringify(u,(g,f)=>{if((0,I.isObject)(f)||Array.isArray(f)){if(v.has(f))return"[Circular]";v.add(f)}return f})}e.safeStringify=y;function P(u,v){const g=Object.create(null);return!u||!v||Object.keys(v).forEach(c=>{const n=u[c],r=v[c];m(n,r)||(g[c]=r)}),g}e.distinct=P;function E(u,v){const g=v.toLowerCase(),f=Object.keys(u).find(c=>c.toLowerCase()===g);return f?u[f]:u[v]}e.getCaseInsensitive=E;function h(u,v){const g=Object.create(null);for(const[f,c]of Object.entries(u))v(f,c)&&(g[f]=c);return g}e.filter=h;function w(u){let v=[],g=Object.getPrototypeOf(u);for(;Object.prototype!==g;)v=v.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return v}e.getAllPropertyNames=w;function d(u){const v=[];for(const g of w(u))typeof u[g]=="function"&&v.push(g);return v}e.getAllMethodNames=d;function b(u,v){const g=c=>function(){const n=Array.prototype.slice.call(arguments,0);return v(c,n)},f={};for(const c of u)f[c]=g(c);return f}e.createProxyObject=b}),define(ee[29],te([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(C){return I.test(C)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(k){for(let p=0;p<k.length;p++)k[p]=Math.floor(Math.random()*256);return k};const M=new Uint8Array(16),A=[];for(let k=0;k<256;k++)A.push(k.toString(16).padStart(2,"0"));return function(){C(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let p=0,m="";return m+=A[M[p++]],m+=A[M[p++]],m+=A[M[p++]],m+=A[M[p++]],m+="-",m+=A[M[p++]],m+=A[M[p++]],m+="-",m+=A[M[p++]],m+=A[M[p++]],m+="-",m+=A[M[p++]],m+=A[M[p++]],m+="-",m+=A[M[p++]],m+=A[M[p++]],m+=A[M[p++]],m+=A[M[p++]],m+=A[M[p++]],m+=A[M[p++]],m}}()}),define(ee[126],te([0,1,77,40,50]),function(q,e,I,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function M(A,k){if(await new Promise((y,P)=>{const E=t.createReadStream(A),h=I.createHash("sha1");E.pipe(h);const w=(0,C.once)((d,b)=>{E.removeAllListeners(),h.removeAllListeners(),d?P(d):y(b)});E.once("error",w),E.once("end",w),h.once("error",w),h.once("data",d=>w(void 0,d.toString("hex")))})!==k)throw new Error("Hash mismatch")}e.checksum=M}),define(ee[127],te([0,1,25]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function C(A){const k=A.replace(/\-/g,":").toLowerCase();return!t.has(k)}function M(){const A=(0,I.networkInterfaces)();for(const k in A){const p=A[k];if(p){for(const{mac:m}of p)if(C(m))return m}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=M}),define(ee[97],te([0,1,78]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(k,p,m,y=1){let P=!1;return new Promise(E=>{const h=setTimeout(()=>{if(!P)return P=!0,E(0)},m);C(k,p,y,w=>{if(!P)return P=!0,clearTimeout(h),E(w)})})}e.findFreePort=t;function C(k,p,m,y){if(p===0)return y(0);const P=new I.Socket;P.once("connect",()=>(A(P),C(k+m,p-1,m,y))),P.once("data",()=>{}),P.once("error",E=>(A(P),E.code!=="ECONNREFUSED"?C(k+m,p-1,m,y):y(k))),P.connect(k,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function M(k,p,m,y="127.0.0.1"){let P=!1,E,h=1;const w=I.createServer({pauseOnConnect:!0});function d(b,u){P||(P=!0,w.removeAllListeners(),w.close(),E&&clearTimeout(E),u(b))}return new Promise(b=>{E=setTimeout(()=>{d(0,b)},m),w.on("listening",()=>{d(k,b)}),w.on("error",u=>{u&&(u.code==="EADDRINUSE"||u.code==="EACCES")&&h<p?(k++,h++,w.listen(k,y)):d(0,b)}),w.on("close",()=>{d(0,b)}),w.listen(k,y)})}e.findFreePortFaster=M;function A(k){try{k.removeAllListeners("connect"),k.removeAllListeners("error"),k.end(),k.destroy(),k.unref()}catch(p){console.error(p)}}}),define(ee[128],te([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(ee[129],te([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class I{constructor(C,M){this.a=C,this.onMessage=M}send(C){try{this.a.send("vscode:message",C.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.Protocol=I}),define(ee[41],te([0,1,13,14]),function(q,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class C{constructor(){this.a=new WeakMap}on(A,k){const p=(m,...y)=>{this.b(A,m)&&k(m,...y)};return this.a.set(k,p),I.ipcMain.on(A,p),this}once(A,k){return I.ipcMain.once(A,(p,...m)=>{this.b(A,p)&&k(p,...m)}),this}handle(A,k){return I.ipcMain.handle(A,(p,...m)=>this.b(A,p)?k(p,...m):Promise.reject(`Invalid channel '${A}' or sender for ipcMain.handle() usage.`)),this}removeHandler(A){return I.ipcMain.removeHandler(A),this}removeListener(A,k){const p=this.a.get(k);return p&&(I.ipcMain.removeListener(A,p),this.a.delete(k)),this}b(A,k){if(!A||!A.startsWith("vscode:"))return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${A}' because the channel is unknown.`),!1;const p=k.senderFrame,m=p.url;if(!m)return!0;let y="unknown";try{y=new URL(m).host}catch{return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${A}' because of a malformed URL '${m}'.`),!1}return y!=="vscode-app"?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${A}' because of a bad origin of '${y}'.`),!1):p.parent!==null?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${A}' because sender of origin '${y}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new C}),define(ee[130],te([0,1,13,41,12,128]),function(q,e,I,t,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function A(){t.validatedIpcMain.on(M.CONTEXT_MENU_CHANNEL,(p,m,y,P,E)=>{const h=k(p,P,y);h.popup({window:(0,C.withNullAsUndefined)(I.BrowserWindow.fromWebContents(p.sender)),x:E?E.x:void 0,y:E?E.y:void 0,positioningItem:E?E.positioningItem:void 0,callback:()=>{h&&p.sender.send(M.CONTEXT_MENU_CLOSE_CHANNEL,m)}})})}e.registerContextMenuListener=A;function k(p,m,y){const P=new I.Menu;return y.forEach(E=>{let h;E.type==="separator"?h=new I.MenuItem({type:E.type}):Array.isArray(E.submenu)?h=new I.MenuItem({submenu:k(p,m,E.submenu),label:E.label}):h=new I.MenuItem({label:E.label,type:E.type,accelerator:E.accelerator,checked:E.checked,enabled:E.enabled,visible:E.visible,click:(w,d,b)=>p.sender.send(m,E.id,b)}),P.append(h)}),P}}),define(ee[131],te([11,10]),function(q,e){return q.create("vs/base/common/date",e)}),define(ee[132],te([0,1,131]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,C=t*60,M=C*24,A=M*7,k=M*30,p=M*365;function m(P,E,h){typeof P!="number"&&(P=P.getTime());const w=Math.round((new Date().getTime()-P)/1e3);if(w<-30)return(0,I.localize)(0,null,m(new Date().getTime()+w*1e3,!1));if(w<30)return(0,I.localize)(1,null);let d;return w<t?(d=w,E?d===1?h?(0,I.localize)(2,null,d):(0,I.localize)(3,null,d):h?(0,I.localize)(4,null,d):(0,I.localize)(5,null,d):d===1?h?(0,I.localize)(6,null,d):(0,I.localize)(7,null,d):h?(0,I.localize)(8,null,d):(0,I.localize)(9,null,d)):w<C?(d=Math.floor(w/t),E?d===1?h?(0,I.localize)(10,null,d):(0,I.localize)(11,null,d):h?(0,I.localize)(12,null,d):(0,I.localize)(13,null,d):d===1?h?(0,I.localize)(14,null,d):(0,I.localize)(15,null,d):h?(0,I.localize)(16,null,d):(0,I.localize)(17,null,d)):w<M?(d=Math.floor(w/C),E?d===1?h?(0,I.localize)(18,null,d):(0,I.localize)(19,null,d):h?(0,I.localize)(20,null,d):(0,I.localize)(21,null,d):d===1?h?(0,I.localize)(22,null,d):(0,I.localize)(23,null,d):h?(0,I.localize)(24,null,d):(0,I.localize)(25,null,d)):w<A?(d=Math.floor(w/M),E?d===1?(0,I.localize)(26,null,d):(0,I.localize)(27,null,d):d===1?(0,I.localize)(28,null,d):(0,I.localize)(29,null,d)):w<k?(d=Math.floor(w/A),E?d===1?h?(0,I.localize)(30,null,d):(0,I.localize)(31,null,d):h?(0,I.localize)(32,null,d):(0,I.localize)(33,null,d):d===1?h?(0,I.localize)(34,null,d):(0,I.localize)(35,null,d):h?(0,I.localize)(36,null,d):(0,I.localize)(37,null,d)):w<p?(d=Math.floor(w/k),E?d===1?h?(0,I.localize)(38,null,d):(0,I.localize)(39,null,d):h?(0,I.localize)(40,null,d):(0,I.localize)(41,null,d):d===1?h?(0,I.localize)(42,null,d):(0,I.localize)(43,null,d):h?(0,I.localize)(44,null,d):(0,I.localize)(45,null,d)):(d=Math.floor(w/p),E?d===1?h?(0,I.localize)(46,null,d):(0,I.localize)(47,null,d):h?(0,I.localize)(48,null,d):(0,I.localize)(49,null,d):d===1?h?(0,I.localize)(50,null,d):(0,I.localize)(51,null,d):h?(0,I.localize)(52,null,d):(0,I.localize)(53,null,d))}e.fromNow=m;function y(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=y}),define(ee[133],te([11,10]),function(q,e){return q.create("vs/base/common/errorMessage",e)}),define(ee[45],te([0,1,24,12,133]),function(q,e,I,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function M(P,E){return E&&(P.stack||P.stacktrace)?C.localize(0,null,k(P),A(P.stack)||A(P.stacktrace)):k(P)}function A(P){return Array.isArray(P)?P.join(`
`):P}function k(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?C.localize(1,null,P.message):P.message||C.localize(2,null)}function p(P=null,E=!1){if(!P)return C.localize(3,null);if(Array.isArray(P)){const h=I.coalesce(P),w=p(h[0],E);return h.length>1?C.localize(4,null,w,h.length):w}if(t.isString(P))return P;if(P.detail){const h=P.detail;if(h.error)return M(h.error,E);if(h.exception)return M(h.exception,E)}return P.stack?M(P,E):P.message?P.message:C.localize(5,null)}e.toErrorMessage=p;function m(P){const E=P;return E instanceof Error&&Array.isArray(E.actions)}e.isErrorWithActions=m;function y(P,E){let h;return typeof P=="string"?h=new Error(P):h=P,h.actions=E,h}e.createErrorWithActions=y}),define(ee[134],te([11,10]),function(q,e){return q.create("vs/base/common/jsonErrorMessages",e)}),define(ee[135],te([0,1,134]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function t(C){switch(C){case 1:return(0,I.localize)(0,null);case 2:return(0,I.localize)(1,null);case 3:return(0,I.localize)(2,null);case 4:return(0,I.localize)(3,null);case 5:return(0,I.localize)(4,null);case 6:return(0,I.localize)(5,null);case 7:return(0,I.localize)(6,null);case 8:return(0,I.localize)(7,null);case 9:return(0,I.localize)(8,null);default:return""}}e.getParseErrorMessage=t}),define(ee[136],te([11,10]),function(q,e){return q.create("vs/base/common/platform",e)}),define(ee[4],te([0,1,136]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let t=!1,C=!1,M=!1,A=!1,k=!1,p=!1,m=!1,y=!1,P=!1,E=!1,h,w=e.LANGUAGE_DEFAULT,d,b;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?u=e.globals.vscode.process:typeof process<"u"&&(u=process);const v=typeof u?.versions?.electron=="string",g=v&&u?.type==="renderer";if(typeof navigator=="object"&&!g)b=navigator.userAgent,t=b.indexOf("Windows")>=0,C=b.indexOf("Macintosh")>=0,y=(b.indexOf("Macintosh")>=0||b.indexOf("iPad")>=0||b.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=b.indexOf("Linux")>=0,E=b?.indexOf("Mobi")>=0,p=!0,h=I.getConfiguredDefaultLocale(I.localize(0,null))||e.LANGUAGE_DEFAULT,w=h;else if(typeof u=="object"){t=u.platform==="win32",C=u.platform==="darwin",M=u.platform==="linux",A=M&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,m=v,P=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=e.LANGUAGE_DEFAULT,w=e.LANGUAGE_DEFAULT;const o=u.env.VSCODE_NLS_CONFIG;if(o)try{const S=JSON.parse(o),D=S.availableLanguages["*"];h=S.locale,w=D||e.LANGUAGE_DEFAULT,d=S._translationsConfigFile}catch{}k=!0}else console.error("Unable to resolve platform.");var f;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(f=e.Platform||(e.Platform={}));function c(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=c;let n=0;C?n=1:t?n=3:M&&(n=2),e.isWindows=t,e.isMacintosh=C,e.isLinux=M,e.isLinuxSnap=A,e.isNative=k,e.isElectron=m,e.isWeb=p,e.isWebWorker=p&&typeof e.globals.importScripts=="function",e.isIOS=y,e.isMobile=E,e.isCI=P,e.platform=n,e.userAgent=b,e.language=w;var r;(function(o){function S(){return e.language}o.value=S;function D(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=D;function L(){return e.language==="en"}o.isDefault=L})(r=e.Language||(e.Language={})),e.locale=h,e.translationsConfigFile=d,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const o=[];e.globals.addEventListener("message",D=>{if(D.data&&D.data.vscodeScheduleAsyncWork)for(let L=0,j=o.length;L<j;L++){const X=o[L];if(X.id===D.data.vscodeScheduleAsyncWork){o.splice(L,1),X.callback();return}}});let S=0;return D=>{const L=++S;o.push({id:L,callback:D}),e.globals.postMessage({vscodeScheduleAsyncWork:L},"*")}}return o=>setTimeout(o)})();var i;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(i=e.OperatingSystem||(e.OperatingSystem={})),e.OS=C||y?2:t?1:3;let a=!0,s=!1;function l(){if(!s){s=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,a=new Uint16Array(o.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=l,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ee[32],te([0,1,4]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof I.globals.vscode<"u"&&typeof I.globals.vscode.process<"u"){const C=I.globals.vscode.process;t={get platform(){return C.platform},get arch(){return C.arch},get env(){return C.env},cwd(){return C.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return I.isWindows?"win32":I.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(ee[9],te([0,1,32]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,C=97,M=90,A=122,k=46,p=47,m=92,y=58,P=63;class E extends Error{constructor(f,c,n){let r;typeof c=="string"&&c.indexOf("not ")===0?(r="must not be",c=c.replace(/^not /,"")):r="must be";const i=f.indexOf(".")!==-1?"property":"argument";let a=`The "${f}" ${i} ${r} of type ${c}`;a+=`. Received type ${typeof n}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function h(g,f){if(typeof g!="string")throw new E(f,"string",g)}function w(g){return g===p||g===m}function d(g){return g===p}function b(g){return g>=t&&g<=M||g>=C&&g<=A}function u(g,f,c,n){let r="",i=0,a=-1,s=0,l=0;for(let o=0;o<=g.length;++o){if(o<g.length)l=g.charCodeAt(o);else{if(n(l))break;l=p}if(n(l)){if(!(a===o-1||s===1))if(s===2){if(r.length<2||i!==2||r.charCodeAt(r.length-1)!==k||r.charCodeAt(r.length-2)!==k){if(r.length>2){const S=r.lastIndexOf(c);S===-1?(r="",i=0):(r=r.slice(0,S),i=r.length-1-r.lastIndexOf(c)),a=o,s=0;continue}else if(r.length!==0){r="",i=0,a=o,s=0;continue}}f&&(r+=r.length>0?`${c}..`:"..",i=2)}else r.length>0?r+=`${c}${g.slice(a+1,o)}`:r=g.slice(a+1,o),i=o-a-1;a=o,s=0}else l===k&&s!==-1?++s:s=-1}return r}function v(g,f){if(f===null||typeof f!="object")throw new E("pathObject","Object",f);const c=f.dir||f.root,n=f.base||`${f.name||""}${f.ext||""}`;return c?c===f.root?`${c}${n}`:`${c}${g}${n}`:n}e.win32={resolve(...g){let f="",c="",n=!1;for(let r=g.length-1;r>=-1;r--){let i;if(r>=0){if(i=g[r],h(i,"path"),i.length===0)continue}else f.length===0?i=I.cwd():(i=I.env[`=${f}`]||I.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==f.toLowerCase()&&i.charCodeAt(2)===m)&&(i=`${f}\\`));const a=i.length;let s=0,l="",o=!1;const S=i.charCodeAt(0);if(a===1)w(S)&&(s=1,o=!0);else if(w(S))if(o=!0,w(i.charCodeAt(1))){let D=2,L=D;for(;D<a&&!w(i.charCodeAt(D));)D++;if(D<a&&D!==L){const j=i.slice(L,D);for(L=D;D<a&&w(i.charCodeAt(D));)D++;if(D<a&&D!==L){for(L=D;D<a&&!w(i.charCodeAt(D));)D++;(D===a||D!==L)&&(l=`\\\\${j}\\${i.slice(L,D)}`,s=D)}}}else s=1;else b(S)&&i.charCodeAt(1)===y&&(l=i.slice(0,2),s=2,a>2&&w(i.charCodeAt(2))&&(o=!0,s=3));if(l.length>0)if(f.length>0){if(l.toLowerCase()!==f.toLowerCase())continue}else f=l;if(n){if(f.length>0)break}else if(c=`${i.slice(s)}\\${c}`,n=o,o&&f.length>0)break}return c=u(c,!n,"\\",w),n?`${f}\\${c}`:`${f}${c}`||"."},normalize(g){h(g,"path");const f=g.length;if(f===0)return".";let c=0,n,r=!1;const i=g.charCodeAt(0);if(f===1)return d(i)?"\\":g;if(w(i))if(r=!0,w(g.charCodeAt(1))){let s=2,l=s;for(;s<f&&!w(g.charCodeAt(s));)s++;if(s<f&&s!==l){const o=g.slice(l,s);for(l=s;s<f&&w(g.charCodeAt(s));)s++;if(s<f&&s!==l){for(l=s;s<f&&!w(g.charCodeAt(s));)s++;if(s===f)return`\\\\${o}\\${g.slice(l)}\\`;s!==l&&(n=`\\\\${o}\\${g.slice(l,s)}`,c=s)}}}else c=1;else b(i)&&g.charCodeAt(1)===y&&(n=g.slice(0,2),c=2,f>2&&w(g.charCodeAt(2))&&(r=!0,c=3));let a=c<f?u(g.slice(c),!r,"\\",w):"";return a.length===0&&!r&&(a="."),a.length>0&&w(g.charCodeAt(f-1))&&(a+="\\"),n===void 0?r?`\\${a}`:a:r?`${n}\\${a}`:`${n}${a}`},isAbsolute(g){h(g,"path");const f=g.length;if(f===0)return!1;const c=g.charCodeAt(0);return w(c)||f>2&&b(c)&&g.charCodeAt(1)===y&&w(g.charCodeAt(2))},join(...g){if(g.length===0)return".";let f,c;for(let i=0;i<g.length;++i){const a=g[i];h(a,"path"),a.length>0&&(f===void 0?f=c=a:f+=`\\${a}`)}if(f===void 0)return".";let n=!0,r=0;if(typeof c=="string"&&w(c.charCodeAt(0))){++r;const i=c.length;i>1&&w(c.charCodeAt(1))&&(++r,i>2&&(w(c.charCodeAt(2))?++r:n=!1))}if(n){for(;r<f.length&&w(f.charCodeAt(r));)r++;r>=2&&(f=`\\${f.slice(r)}`)}return e.win32.normalize(f)},relative(g,f){if(h(g,"from"),h(f,"to"),g===f)return"";const c=e.win32.resolve(g),n=e.win32.resolve(f);if(c===n||(g=c.toLowerCase(),f=n.toLowerCase(),g===f))return"";let r=0;for(;r<g.length&&g.charCodeAt(r)===m;)r++;let i=g.length;for(;i-1>r&&g.charCodeAt(i-1)===m;)i--;const a=i-r;let s=0;for(;s<f.length&&f.charCodeAt(s)===m;)s++;let l=f.length;for(;l-1>s&&f.charCodeAt(l-1)===m;)l--;const o=l-s,S=a<o?a:o;let D=-1,L=0;for(;L<S;L++){const X=g.charCodeAt(r+L);if(X!==f.charCodeAt(s+L))break;X===m&&(D=L)}if(L!==S){if(D===-1)return n}else{if(o>S){if(f.charCodeAt(s+L)===m)return n.slice(s+L+1);if(L===2)return n.slice(s+L)}a>S&&(g.charCodeAt(r+L)===m?D=L:L===2&&(D=3)),D===-1&&(D=0)}let j="";for(L=r+D+1;L<=i;++L)(L===i||g.charCodeAt(L)===m)&&(j+=j.length===0?"..":"\\..");return s+=D,j.length>0?`${j}${n.slice(s,l)}`:(n.charCodeAt(s)===m&&++s,n.slice(s,l))},toNamespacedPath(g){if(typeof g!="string")return g;if(g.length===0)return"";const f=e.win32.resolve(g);if(f.length<=2)return g;if(f.charCodeAt(0)===m){if(f.charCodeAt(1)===m){const c=f.charCodeAt(2);if(c!==P&&c!==k)return`\\\\?\\UNC\\${f.slice(2)}`}}else if(b(f.charCodeAt(0))&&f.charCodeAt(1)===y&&f.charCodeAt(2)===m)return`\\\\?\\${f}`;return g},dirname(g){h(g,"path");const f=g.length;if(f===0)return".";let c=-1,n=0;const r=g.charCodeAt(0);if(f===1)return w(r)?g:".";if(w(r)){if(c=n=1,w(g.charCodeAt(1))){let s=2,l=s;for(;s<f&&!w(g.charCodeAt(s));)s++;if(s<f&&s!==l){for(l=s;s<f&&w(g.charCodeAt(s));)s++;if(s<f&&s!==l){for(l=s;s<f&&!w(g.charCodeAt(s));)s++;if(s===f)return g;s!==l&&(c=n=s+1)}}}}else b(r)&&g.charCodeAt(1)===y&&(c=f>2&&w(g.charCodeAt(2))?3:2,n=c);let i=-1,a=!0;for(let s=f-1;s>=n;--s)if(w(g.charCodeAt(s))){if(!a){i=s;break}}else a=!1;if(i===-1){if(c===-1)return".";i=c}return g.slice(0,i)},basename(g,f){f!==void 0&&h(f,"ext"),h(g,"path");let c=0,n=-1,r=!0,i;if(g.length>=2&&b(g.charCodeAt(0))&&g.charCodeAt(1)===y&&(c=2),f!==void 0&&f.length>0&&f.length<=g.length){if(f===g)return"";let a=f.length-1,s=-1;for(i=g.length-1;i>=c;--i){const l=g.charCodeAt(i);if(w(l)){if(!r){c=i+1;break}}else s===-1&&(r=!1,s=i+1),a>=0&&(l===f.charCodeAt(a)?--a===-1&&(n=i):(a=-1,n=s))}return c===n?n=s:n===-1&&(n=g.length),g.slice(c,n)}for(i=g.length-1;i>=c;--i)if(w(g.charCodeAt(i))){if(!r){c=i+1;break}}else n===-1&&(r=!1,n=i+1);return n===-1?"":g.slice(c,n)},extname(g){h(g,"path");let f=0,c=-1,n=0,r=-1,i=!0,a=0;g.length>=2&&g.charCodeAt(1)===y&&b(g.charCodeAt(0))&&(f=n=2);for(let s=g.length-1;s>=f;--s){const l=g.charCodeAt(s);if(w(l)){if(!i){n=s+1;break}continue}r===-1&&(i=!1,r=s+1),l===k?c===-1?c=s:a!==1&&(a=1):c!==-1&&(a=-1)}return c===-1||r===-1||a===0||a===1&&c===r-1&&c===n+1?"":g.slice(c,r)},format:v.bind(null,"\\"),parse(g){h(g,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return f;const c=g.length;let n=0,r=g.charCodeAt(0);if(c===1)return w(r)?(f.root=f.dir=g,f):(f.base=f.name=g,f);if(w(r)){if(n=1,w(g.charCodeAt(1))){let D=2,L=D;for(;D<c&&!w(g.charCodeAt(D));)D++;if(D<c&&D!==L){for(L=D;D<c&&w(g.charCodeAt(D));)D++;if(D<c&&D!==L){for(L=D;D<c&&!w(g.charCodeAt(D));)D++;D===c?n=D:D!==L&&(n=D+1)}}}}else if(b(r)&&g.charCodeAt(1)===y){if(c<=2)return f.root=f.dir=g,f;if(n=2,w(g.charCodeAt(2))){if(c===3)return f.root=f.dir=g,f;n=3}}n>0&&(f.root=g.slice(0,n));let i=-1,a=n,s=-1,l=!0,o=g.length-1,S=0;for(;o>=n;--o){if(r=g.charCodeAt(o),w(r)){if(!l){a=o+1;break}continue}s===-1&&(l=!1,s=o+1),r===k?i===-1?i=o:S!==1&&(S=1):i!==-1&&(S=-1)}return s!==-1&&(i===-1||S===0||S===1&&i===s-1&&i===a+1?f.base=f.name=g.slice(a,s):(f.name=g.slice(a,i),f.base=g.slice(a,s),f.ext=g.slice(i,s))),a>0&&a!==n?f.dir=g.slice(0,a-1):f.dir=f.root,f},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...g){let f="",c=!1;for(let n=g.length-1;n>=-1&&!c;n--){const r=n>=0?g[n]:I.cwd();h(r,"path"),r.length!==0&&(f=`${r}/${f}`,c=r.charCodeAt(0)===p)}return f=u(f,!c,"/",d),c?`/${f}`:f.length>0?f:"."},normalize(g){if(h(g,"path"),g.length===0)return".";const f=g.charCodeAt(0)===p,c=g.charCodeAt(g.length-1)===p;return g=u(g,!f,"/",d),g.length===0?f?"/":c?"./":".":(c&&(g+="/"),f?`/${g}`:g)},isAbsolute(g){return h(g,"path"),g.length>0&&g.charCodeAt(0)===p},join(...g){if(g.length===0)return".";let f;for(let c=0;c<g.length;++c){const n=g[c];h(n,"path"),n.length>0&&(f===void 0?f=n:f+=`/${n}`)}return f===void 0?".":e.posix.normalize(f)},relative(g,f){if(h(g,"from"),h(f,"to"),g===f||(g=e.posix.resolve(g),f=e.posix.resolve(f),g===f))return"";const c=1,n=g.length,r=n-c,i=1,a=f.length-i,s=r<a?r:a;let l=-1,o=0;for(;o<s;o++){const D=g.charCodeAt(c+o);if(D!==f.charCodeAt(i+o))break;D===p&&(l=o)}if(o===s)if(a>s){if(f.charCodeAt(i+o)===p)return f.slice(i+o+1);if(o===0)return f.slice(i+o)}else r>s&&(g.charCodeAt(c+o)===p?l=o:o===0&&(l=0));let S="";for(o=c+l+1;o<=n;++o)(o===n||g.charCodeAt(o)===p)&&(S+=S.length===0?"..":"/..");return`${S}${f.slice(i+l)}`},toNamespacedPath(g){return g},dirname(g){if(h(g,"path"),g.length===0)return".";const f=g.charCodeAt(0)===p;let c=-1,n=!0;for(let r=g.length-1;r>=1;--r)if(g.charCodeAt(r)===p){if(!n){c=r;break}}else n=!1;return c===-1?f?"/":".":f&&c===1?"//":g.slice(0,c)},basename(g,f){f!==void 0&&h(f,"ext"),h(g,"path");let c=0,n=-1,r=!0,i;if(f!==void 0&&f.length>0&&f.length<=g.length){if(f===g)return"";let a=f.length-1,s=-1;for(i=g.length-1;i>=0;--i){const l=g.charCodeAt(i);if(l===p){if(!r){c=i+1;break}}else s===-1&&(r=!1,s=i+1),a>=0&&(l===f.charCodeAt(a)?--a===-1&&(n=i):(a=-1,n=s))}return c===n?n=s:n===-1&&(n=g.length),g.slice(c,n)}for(i=g.length-1;i>=0;--i)if(g.charCodeAt(i)===p){if(!r){c=i+1;break}}else n===-1&&(r=!1,n=i+1);return n===-1?"":g.slice(c,n)},extname(g){h(g,"path");let f=-1,c=0,n=-1,r=!0,i=0;for(let a=g.length-1;a>=0;--a){const s=g.charCodeAt(a);if(s===p){if(!r){c=a+1;break}continue}n===-1&&(r=!1,n=a+1),s===k?f===-1?f=a:i!==1&&(i=1):f!==-1&&(i=-1)}return f===-1||n===-1||i===0||i===1&&f===n-1&&f===c+1?"":g.slice(f,n)},format:v.bind(null,"/"),parse(g){h(g,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return f;const c=g.charCodeAt(0)===p;let n;c?(f.root="/",n=1):n=0;let r=-1,i=0,a=-1,s=!0,l=g.length-1,o=0;for(;l>=n;--l){const S=g.charCodeAt(l);if(S===p){if(!s){i=l+1;break}continue}a===-1&&(s=!1,a=l+1),S===k?r===-1?r=l:o!==1&&(o=1):r!==-1&&(o=-1)}if(a!==-1){const S=i===0&&c?1:i;r===-1||o===0||o===1&&r===a-1&&r===i+1?f.base=f.name=g.slice(S,a):(f.name=g.slice(S,r),f.base=g.slice(S,a),f.ext=g.slice(r,a))}return i>0?f.dir=g.slice(0,i-1):c&&(f.dir="/"),f},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=I.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=I.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=I.platform==="win32"?e.win32.join:e.posix.join,e.resolve=I.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=I.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=I.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=I.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=I.platform==="win32"?e.win32.extname:e.posix.extname,e.format=I.platform==="win32"?e.win32.format:e.posix.format,e.parse=I.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=I.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=I.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=I.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ee[79],te([0,1,4]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var C;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(C=e.TerminateResponseCode||(e.TerminateResponseCode={}));function M(k,...p){const m=p.reduce((E,h)=>(E[h]=!0,E),{}),y=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(E=>!m[E]).forEach(E=>{for(let h=0;h<y.length;h++)if(E.search(y[h])!==-1){delete k[E];break}})}e.sanitizeProcessEnvironment=M;function A(k){!k||(delete k.DEBUG,I.isMacintosh&&delete k.DYLD_LIBRARY_PATH,I.isLinux&&delete k.LD_PRELOAD)}e.removeDangerousEnvVariables=A}),define(ee[80],te([0,1,4]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=I.globals.performance&&typeof I.globals.performance.now=="function";class C{static create(A=!0){return new C(A)}constructor(A){this.a=t&&A,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?I.globals.performance.now():Date.now()}}e.StopWatch=C}),define(ee[3],te([0,1,14,50,2,96,80]),function(q,e,I,t,C,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const k=!1,p=!1;var m;(function(l){l.None=()=>C.Disposable.None;function o(B){if(p){const{onDidAddListener:V}=B,ie=w.create();let $=0;B.onDidAddListener=()=>{++$===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ie.print()),V?.()}}}function S(B,V){return ne(B,()=>{},0,void 0,void 0,V)}l.defer=S;function D(B){return(V,ie=null,$)=>{let Z=!1,x;return x=B(oe=>{if(!Z)return x?x.dispose():Z=!0,V.call(ie,oe)},null,$),Z&&x.dispose(),x}}l.once=D;function L(B,V,ie){return se(($,Z=null,x)=>B(oe=>$.call(Z,V(oe)),null,x),ie)}l.map=L;function j(B,V,ie){return se(($,Z=null,x)=>B(oe=>{V(oe),$.call(Z,oe)},null,x),ie)}l.forEach=j;function X(B,V,ie){return se(($,Z=null,x)=>B(oe=>V(oe)&&$.call(Z,oe),null,x),ie)}l.filter=X;function ae(B){return B}l.signal=ae;function Y(...B){return(V,ie=null,$)=>(0,C.combinedDisposable)(...B.map(Z=>Z(x=>V.call(ie,x),null,$)))}l.any=Y;function J(B,V,ie,$){let Z=ie;return L(B,x=>(Z=V(Z,x),Z),$)}l.reduce=J;function se(B,V){let ie;const $={onWillAddFirstListener(){ie=B(Z.fire,Z)},onDidRemoveLastListener(){ie?.dispose()}};V||o($);const Z=new b($);return V?.add(Z),Z.event}function ne(B,V,ie=100,$=!1,Z,x){let oe,ge,De,Oe=0;const Ce={leakWarningThreshold:Z,onWillAddFirstListener(){oe=B(be=>{Oe++,ge=V(ge,be),$&&!De&&(Re.fire(ge),ge=void 0),clearTimeout(De),De=setTimeout(()=>{const we=ge;ge=void 0,De=void 0,(!$||Oe>1)&&Re.fire(we),Oe=0},ie)})},onDidRemoveLastListener(){oe.dispose()}};x||o(Ce);const Re=new b(Ce);return x?.add(Re),Re.event}l.debounce=ne;function he(B,V=0,ie){return l.debounce(B,($,Z)=>$?($.push(Z),$):[Z],V,void 0,void 0,ie)}l.accumulate=he;function K(B,V=($,Z)=>$===Z,ie){let $=!0,Z;return X(B,x=>{const oe=$||!V(x,Z);return $=!1,Z=x,oe},ie)}l.latch=K;function le(B,V,ie){return[l.filter(B,V,ie),l.filter(B,$=>!V($),ie)]}l.split=le;function W(B,V=!1,ie=[]){let $=ie.slice(),Z=B(ge=>{$?$.push(ge):oe.fire(ge)});const x=()=>{$?.forEach(ge=>oe.fire(ge)),$=null},oe=new b({onWillAddFirstListener(){Z||(Z=B(ge=>oe.fire(ge)))},onDidAddFirstListener(){$&&(V?setTimeout(x):x())},onDidRemoveLastListener(){Z&&Z.dispose(),Z=null}});return oe.event}l.buffer=W;class F{constructor(V){this.event=V,this.c=new C.DisposableStore}map(V){return new F(L(this.event,V,this.c))}forEach(V){return new F(j(this.event,V,this.c))}filter(V){return new F(X(this.event,V,this.c))}reduce(V,ie){return new F(J(this.event,V,ie,this.c))}latch(){return new F(K(this.event,void 0,this.c))}debounce(V,ie=100,$=!1,Z){return new F(ne(this.event,V,ie,$,Z,this.c))}on(V,ie,$){return this.event(V,ie,$)}once(V,ie,$){return D(this.event)(V,ie,$)}dispose(){this.c.dispose()}}function N(B){return new F(B)}l.chain=N;function H(B,V,ie=$=>$){const $=(...ge)=>oe.fire(ie(...ge)),Z=()=>B.on(V,$),x=()=>B.removeListener(V,$),oe=new b({onWillAddFirstListener:Z,onDidRemoveLastListener:x});return oe.event}l.fromNodeEventEmitter=H;function re(B,V,ie=$=>$){const $=(...ge)=>oe.fire(ie(...ge)),Z=()=>B.addEventListener(V,$),x=()=>B.removeEventListener(V,$),oe=new b({onWillAddFirstListener:Z,onDidRemoveLastListener:x});return oe.event}l.fromDOMEventEmitter=re;function z(B){return new Promise(V=>D(B)(V))}l.toPromise=z;function T(B,V){return V(void 0),B(ie=>V(ie))}l.runAndSubscribe=T;function R(B,V){let ie=null;function $(x){ie?.dispose(),ie=new C.DisposableStore,V(x,ie)}$(void 0);const Z=B(x=>$(x));return(0,C.toDisposable)(()=>{Z.dispose(),ie?.dispose()})}l.runAndSubscribeWithStore=R;class O{constructor(V,ie){this.obs=V,this.c=0,this.d=!1;const $={onWillAddFirstListener:()=>{V.addObserver(this)},onDidRemoveLastListener:()=>{V.removeObserver(this)}};ie||o($),this.emitter=new b($),ie&&ie.add(this.emitter)}beginUpdate(V){this.c++}handleChange(V,ie){this.d=!0}endUpdate(V){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function U(B,V){return new O(B,V).emitter.event}l.fromObservable=U})(m=e.Event||(e.Event={}));class y{constructor(o){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${o}_${y.c++}`,y.all.add(this)}start(o){this.d=new A.StopWatch(!0),this.listenerCount=o}stop(){if(this.d){const o=this.d.elapsed();this.durations.push(o),this.elapsedOverall+=o,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=y,y.all=new Set,y.c=0;let P=-1;function E(l){const o=P;return P=l,{dispose(){P=o}}}e.setGlobalLeakWarningThreshold=E;class h{constructor(o,S=Math.random().toString(18).slice(2,5)){this.threshold=o,this.name=S,this.d=0}dispose(){this.c?.clear()}check(o,S){const D=this.threshold;if(D<=0||S<D)return;this.c||(this.c=new Map);const L=this.c.get(o.value)||0;if(this.c.set(o.value,L+1),this.d-=1,this.d<=0){this.d=D*.5;let j,X=0;for(const[ae,Y]of this.c)(!j||X<Y)&&(j=ae,X=Y);console.warn(`[${this.name}] potential listener LEAK detected, having ${S} listeners already. MOST frequent listener (${X}):`),console.warn(j)}return()=>{const j=this.c.get(o.value)||0;this.c.set(o.value,j-1)}}}class w{static create(){return new w(new Error().stack??"")}constructor(o){this.value=o}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class d{constructor(o,S,D){this.callback=o,this.callbackThis=S,this.stack=D,this.subscription=new C.SafeDisposable}invoke(o){this.callback.call(this.callbackThis,o)}}class b{constructor(o){this.j=!1,this.d=o,this.f=P>0||this.d?.leakWarningThreshold?new h(this.d?.leakWarningThreshold??P):void 0,this.g=this.d?._profName?new y(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(k){const o=Array.from(this.q);queueMicrotask(()=>{for(const S of o)S.subscription.isset()&&(S.subscription.unset(),S.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(o,S,D)=>{if(this.q||(this.q=new M.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),C.Disposable.None;const L=this.q.isEmpty();L&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let j,X;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(X=w.create(),j=this.f.check(X,this.q.size+1)),k&&(X=X??w.create());const ae=new d(o,S,X),Y=this.q.push(ae);L&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,o,S);const J=ae.subscription.set(()=>{j?.(),this.j||(Y(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return D instanceof C.DisposableStore?D.add(J):Array.isArray(D)&&D.push(J),J}),this.l}fire(o){if(this.q){this.m||(this.m=new v);for(const S of this.q)this.m.push(this,S,o);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=b;class u{constructor(){this.c=new M.LinkedList}get size(){return this.c.size}push(o,S,D){this.c.push(new g(o,S,D))}clear(o){const S=new M.LinkedList;for(const D of this.c)D.emitter!==o&&S.push(D);this.c=S}deliver(){for(;this.c.size>0;){const o=this.c.shift();try{o.listener.invoke(o.event)}catch(S){(0,I.onUnexpectedError)(S)}}}}e.EventDeliveryQueue=u;class v extends u{clear(o){this.c.clear()}}class g{constructor(o,S,D){this.emitter=o,this.listener=S,this.event=D}}class f extends b{async fireAsync(o,S,D){if(!!this.q){this.c||(this.c=new M.LinkedList);for(const L of this.q)this.c.push([L,o]);for(;this.c.size>0&&!S.isCancellationRequested;){const[L,j]=this.c.shift(),X=[],ae={...j,token:S,waitUntil:Y=>{if(Object.isFrozen(X))throw new Error("waitUntil can NOT be called asynchronous");D&&(Y=D(Y,L.callback)),X.push(Y)}};try{L.invoke(ae)}catch(Y){(0,I.onUnexpectedError)(Y);continue}Object.freeze(X),await Promise.allSettled(X).then(Y=>{for(const J of Y)J.status==="rejected"&&(0,I.onUnexpectedError)(J.reason)})}}}}e.AsyncEmitter=f;class c extends b{constructor(o){super(o),this.h=0,this.s=new M.LinkedList,this.t=o?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const o=Array.from(this.s);this.s.clear(),super.fire(this.t(o))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(o){this.q&&(this.h!==0?this.s.push(o):super.fire(o))}}e.PauseableEmitter=c;class n extends c{constructor(o){super(o),this.c=o.delay??100}fire(o){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(o)}}e.DebounceEmitter=n;class r extends b{constructor(o){super(o),this.c=[],this.h=o?.merge}fire(o){!this.hasListeners()||(this.c.push(o),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(S=>super.fire(S)),this.c=[]}))}}e.MicrotaskEmitter=r;class i{constructor(){this.d=!1,this.f=[],this.c=new b({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(o){const S={event:o,listener:null};this.f.push(S),this.d&&this.j(S);const D=()=>{this.d&&this.k(S);const L=this.f.indexOf(S);this.f.splice(L,1)};return(0,C.toDisposable)((0,t.once)(D))}g(){this.d=!0,this.f.forEach(o=>this.j(o))}h(){this.d=!1,this.f.forEach(o=>this.k(o))}j(o){o.listener=o.event(S=>this.c.fire(S))}k(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=i;class a{constructor(){this.c=[]}wrapEvent(o){return(S,D,L)=>o(j=>{const X=this.c[this.c.length-1];X?X.push(()=>S.call(D,j)):S.call(D,j)},void 0,L)}bufferEvents(o){const S=[];this.c.push(S);const D=o();return this.c.pop(),S.forEach(L=>L()),D}}e.EventBufferer=a;class s{constructor(){this.c=!1,this.d=m.None,this.f=C.Disposable.None,this.g=new b({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(o){this.d=o,this.c&&(this.f.dispose(),this.f=o(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=s}),define(ee[22],te([0,1,3]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(k,p){const m=setTimeout(k.bind(p),0);return{dispose(){clearTimeout(m)}}});var C;(function(k){function p(m){return m===k.None||m===k.Cancelled||m instanceof M?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}k.isCancellationToken=p,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:I.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(C=e.CancellationToken||(e.CancellationToken={}));class M{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?t:(this.b||(this.b=new I.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor(p){this.a=void 0,this.b=void 0,this.b=p&&p.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new M),this.a}cancel(){this.a?this.a instanceof M&&this.a.cancel():this.a=C.Cancelled}dispose(p=!1){p&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof M&&this.a.dispose():this.a=C.None}}e.CancellationTokenSource=A}),define(ee[137],te([0,1,22]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(k){this.b=k,this.a=null}get(){if(this.a)return this.a;const k=new I.CancellationTokenSource,p=this.b(k.token);return this.a={promise:p,dispose:()=>{this.a=null,k.cancel(),k.dispose()}},this.a}}e.Cache=t;class C{constructor(k){this.c=k,this.a=void 0,this.b=void 0}get(k){const p=JSON.stringify(k);return this.b!==p&&(this.b=p,this.a=this.c(k)),this.a}}e.LRUCachedFunction=C;class M{get cachedValues(){return this.a}constructor(k){this.b=k,this.a=new Map}get(k){if(this.a.has(k))return this.a.get(k);const p=this.b(k);return this.a.set(k,p),p}}e.CachedFunction=M}),define(ee[26],te([0,1,137,124]),function(q,e,I,t){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function M(G){return!G||typeof G!="string"?!0:G.trim().length===0}e.isFalsyOrWhitespace=M;const A=/{(\d+)}/g;function k(G,...ce){return ce.length===0?G:G.replace(A,function(ue,me){const Se=parseInt(me,10);return isNaN(Se)||Se<0||Se>=ce.length?ue:ce[Se]})}e.format=k;const p=/{([^}]+)}/g;function m(G,ce){return G.replace(p,(ue,me)=>ce[me]??ue)}e.format2=m;function y(G){return G.replace(/[<>&]/g,function(ce){switch(ce){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ce}})}e.escape=y;function P(G){return G.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=P;function E(G,ce){let ue=0;const me=ce.charCodeAt(0);for(let Se=G.length-1;Se>=0;Se--)G.charCodeAt(Se)===me&&ue++;return ue}e.count=E;function h(G,ce,ue="\u2026"){return G.length<=ce?G:`${G.substr(0,ce)}${ue}`}e.truncate=h;function w(G,ce=" "){const ue=d(G,ce);return b(ue,ce)}e.trim=w;function d(G,ce){if(!G||!ce)return G;const ue=ce.length;if(ue===0||G.length===0)return G;let me=0;for(;G.indexOf(ce,me)===me;)me=me+ue;return G.substring(me)}e.ltrim=d;function b(G,ce){if(!G||!ce)return G;const ue=ce.length,me=G.length;if(ue===0||me===0)return G;let Se=me,Le=-1;for(;Le=G.lastIndexOf(ce,Se-1),!(Le===-1||Le+ue!==Se);){if(Le===0)return"";Se=Le}return G.substring(0,Se)}e.rtrim=b;function u(G){return G.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function v(G){return G.replace(/\*/g,"")}e.stripWildcards=v;function g(G,ce,ue={}){if(!G)throw new Error("Cannot create regex from empty string");ce||(G=P(G)),ue.wholeWord&&(/\B/.test(G.charAt(0))||(G="\\b"+G),/\B/.test(G.charAt(G.length-1))||(G=G+"\\b"));let me="";return ue.global&&(me+="g"),ue.matchCase||(me+="i"),ue.multiline&&(me+="m"),ue.unicode&&(me+="u"),new RegExp(G,me)}e.createRegExp=g;function f(G){return G.source==="^"||G.source==="^$"||G.source==="$"||G.source==="^\\s*$"?!1:!!(G.exec("")&&G.lastIndex===0)}e.regExpLeadsToEndlessLoop=f;function c(G){return!!G.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=c;function n(G){return(G.global?"g":"")+(G.ignoreCase?"i":"")+(G.multiline?"m":"")+(G.unicode?"u":"")}e.regExpFlags=n;function r(G){return G.split(/\r\n|\r|\n/)}e.splitLines=r;function i(G){for(let ce=0,ue=G.length;ce<ue;ce++){const me=G.charCodeAt(ce);if(me!==32&&me!==9)return ce}return-1}e.firstNonWhitespaceIndex=i;function a(G,ce=0,ue=G.length){for(let me=ce;me<ue;me++){const Se=G.charCodeAt(me);if(Se!==32&&Se!==9)return G.substring(ce,me)}return G.substring(ce,ue)}e.getLeadingWhitespace=a;function s(G,ce=G.length-1){for(let ue=ce;ue>=0;ue--){const me=G.charCodeAt(ue);if(me!==32&&me!==9)return ue}return-1}e.lastNonWhitespaceIndex=s;function l(G,ce,ue){const me=[];let Se=0;for(const Le of G.matchAll(ce)){if(me.push(G.slice(Se,Le.index)),Le.index===void 0)throw new Error("match.index should be defined");Se=Le.index+Le[0].length,me.push(ue(Le[0],...Le.slice(1),Le.index,G,Le.groups))}return me.push(G.slice(Se)),Promise.all(me).then(Le=>Le.join(""))}e.replaceAsync=l;function o(G,ce){return G<ce?-1:G>ce?1:0}e.compare=o;function S(G,ce,ue=0,me=G.length,Se=0,Le=ce.length){for(;ue<me&&Se<Le;ue++,Se++){const Ze=G.charCodeAt(ue),Ve=ce.charCodeAt(Se);if(Ze<Ve)return-1;if(Ze>Ve)return 1}const Be=me-ue,it=Le-Se;return Be<it?-1:Be>it?1:0}e.compareSubstring=S;function D(G,ce){return L(G,ce,0,G.length,0,ce.length)}e.compareIgnoreCase=D;function L(G,ce,ue=0,me=G.length,Se=0,Le=ce.length){for(;ue<me&&Se<Le;ue++,Se++){let Ze=G.charCodeAt(ue),Ve=ce.charCodeAt(Se);if(Ze===Ve)continue;if(Ze>=128||Ve>=128)return S(G.toLowerCase(),ce.toLowerCase(),ue,me,Se,Le);X(Ze)&&(Ze-=32),X(Ve)&&(Ve-=32);const et=Ze-Ve;if(et!==0)return et}const Be=me-ue,it=Le-Se;return Be<it?-1:Be>it?1:0}e.compareSubstringIgnoreCase=L;function j(G){return G>=48&&G<=57}e.isAsciiDigit=j;function X(G){return G>=97&&G<=122}e.isLowerAsciiLetter=X;function ae(G){return G>=65&&G<=90}e.isUpperAsciiLetter=ae;function Y(G,ce){return G.length===ce.length&&L(G,ce)===0}e.equalsIgnoreCase=Y;function J(G,ce){const ue=ce.length;return ce.length>G.length?!1:L(G,ce,0,ue)===0}e.startsWithIgnoreCase=J;function se(G,ce){const ue=Math.min(G.length,ce.length);let me;for(me=0;me<ue;me++)if(G.charCodeAt(me)!==ce.charCodeAt(me))return me;return ue}e.commonPrefixLength=se;function ne(G,ce){const ue=Math.min(G.length,ce.length);let me;const Se=G.length-1,Le=ce.length-1;for(me=0;me<ue;me++)if(G.charCodeAt(Se-me)!==ce.charCodeAt(Le-me))return me;return ue}e.commonSuffixLength=ne;function he(G){return 55296<=G&&G<=56319}e.isHighSurrogate=he;function K(G){return 56320<=G&&G<=57343}e.isLowSurrogate=K;function le(G,ce){return(G-55296<<10)+(ce-56320)+65536}e.computeCodePoint=le;function W(G,ce,ue){const me=G.charCodeAt(ue);if(he(me)&&ue+1<ce){const Se=G.charCodeAt(ue+1);if(K(Se))return le(me,Se)}return me}e.getNextCodePoint=W;function F(G,ce){const ue=G.charCodeAt(ce-1);if(K(ue)&&ce>1){const me=G.charCodeAt(ce-2);if(he(me))return le(me,ue)}return ue}class N{get offset(){return this.e}constructor(ce,ue=0){this.c=ce,this.d=ce.length,this.e=ue}setOffset(ce){this.e=ce}prevCodePoint(){const ce=F(this.c,this.e);return this.e-=ce>=65536?2:1,ce}nextCodePoint(){const ce=W(this.c,this.d,this.e);return this.e+=ce>=65536?2:1,ce}eol(){return this.e>=this.d}}e.CodePointIterator=N;class H{get offset(){return this.c.offset}constructor(ce,ue=0){this.c=new N(ce,ue)}nextGraphemeLength(){const ce=Te.getInstance(),ue=this.c,me=ue.offset;let Se=ce.getGraphemeBreakType(ue.nextCodePoint());for(;!ue.eol();){const Le=ue.offset,Be=ce.getGraphemeBreakType(ue.nextCodePoint());if(ye(Se,Be)){ue.setOffset(Le);break}Se=Be}return ue.offset-me}prevGraphemeLength(){const ce=Te.getInstance(),ue=this.c,me=ue.offset;let Se=ce.getGraphemeBreakType(ue.prevCodePoint());for(;ue.offset>0;){const Le=ue.offset,Be=ce.getGraphemeBreakType(ue.prevCodePoint());if(ye(Be,Se)){ue.setOffset(Le);break}Se=Be}return me-ue.offset}eol(){return this.c.eol()}}e.GraphemeIterator=H;function re(G,ce){return new H(G,ce).nextGraphemeLength()}e.nextCharLength=re;function z(G,ce){return new H(G,ce).prevGraphemeLength()}e.prevCharLength=z;function T(G,ce){ce>0&&K(G.charCodeAt(ce))&&ce--;const ue=ce+re(G,ce);return[ue-z(G,ue),ue]}e.getCharContainingOffset=T;function R(G){const ce=new H(G);let ue=0;for(;!ce.eol();)ue++,ce.nextGraphemeLength();return ue}e.charCount=R;let O;function U(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function B(G){return O||(O=U()),O.test(G)}e.containsRTL=B;const V=/^[\t\n\r\x20-\x7E]*$/;function ie(G){return V.test(G)}e.isBasicASCII=ie,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function $(G){return e.UNUSUAL_LINE_TERMINATORS.test(G)}e.containsUnusualLineTerminators=$;function Z(G){return G>=11904&&G<=55215||G>=63744&&G<=64255||G>=65281&&G<=65374}e.isFullWidthCharacter=Z;function x(G){return G>=127462&&G<=127487||G===8986||G===8987||G===9200||G===9203||G>=9728&&G<=10175||G===11088||G===11093||G>=127744&&G<=128591||G>=128640&&G<=128764||G>=128992&&G<=129008||G>=129280&&G<=129535||G>=129648&&G<=129782}e.isEmojiImprecise=x;function oe(G,ce){if(G.length<ce)return G;const ue=/\b/g;let me=0;for(;ue.test(G)&&!(G.length-ue.lastIndex<ce);)me=ue.lastIndex,ue.lastIndex+=1;return G.substring(me).replace(/^\s/,"")}e.lcut=oe;const ge=/\x1B\x5B[12]?K/g,De=/\x1b\[\d+m/g,Oe=/\x1b\[0?m/g;function Ce(G){return G&&(G=G.replace(ge,""),G=G.replace(De,""),G=G.replace(Oe,"")),G}e.removeAnsiEscapeCodes=Ce,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Re(G){return!!(G&&G.length>0&&G.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Re;function be(G){return Re(G)?G.substr(1):G}e.stripUTF8BOM=be;function we(G,ce){if(!G||!ce||G.length<ce.length)return!1;const ue=ce.length,me=G.toLowerCase();let Se=0,Le=-1;for(;Se<ue;){const Be=me.indexOf(ce[Se],Le+1);if(Be<0)return!1;Le=Be,Se++}return!0}e.fuzzyContains=we;function ve(G,ce=!1){return G?(ce&&(G=G.replace(/\\./g,"")),G.toLowerCase()!==G):!1}e.containsUppercaseCharacter=ve;function Me(G){return G.charAt(0).toUpperCase()+G.slice(1)}e.uppercaseFirstLetter=Me;function Q(G,ce=1){if(ce===0)return"";let ue=-1;do ue=G.indexOf(`
`,ue+1),ce--;while(ce>0&&ue>=0);return ue===-1?G:(G[ue-1]==="\r"&&ue--,G.substr(0,ue))}e.getNLines=Q;function fe(G){return G=G%(2*26),G<26?String.fromCharCode(97+G):String.fromCharCode(65+G-26)}e.singleLetterHash=fe;function de(G){return Te.getInstance().getGraphemeBreakType(G)}e.getGraphemeBreakType=de;function ye(G,ce){return G===0?ce!==5&&ce!==7:G===2&&ce===3?!1:G===4||G===2||G===3||ce===4||ce===2||ce===3?!0:!(G===8&&(ce===8||ce===9||ce===11||ce===12)||(G===11||G===9)&&(ce===9||ce===10)||(G===12||G===10)&&ce===10||ce===5||ce===13||ce===7||G===1||G===13&&ce===14||G===6&&ce===6)}var Ie;(function(G){G[G.Other=0]="Other",G[G.Prepend=1]="Prepend",G[G.CR=2]="CR",G[G.LF=3]="LF",G[G.Control=4]="Control",G[G.Extend=5]="Extend",G[G.Regional_Indicator=6]="Regional_Indicator",G[G.SpacingMark=7]="SpacingMark",G[G.L=8]="L",G[G.V=9]="V",G[G.T=10]="T",G[G.LV=11]="LV",G[G.LVT=12]="LVT",G[G.ZWJ=13]="ZWJ",G[G.Extended_Pictographic=14]="Extended_Pictographic"})(Ie=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Te{static getInstance(){return Te.c||(Te.c=new Te),Te.c}constructor(){this.d=Fe()}getGraphemeBreakType(ce){if(ce<32)return ce===10?3:ce===13?2:4;if(ce<127)return 0;const ue=this.d,me=ue.length/3;let Se=1;for(;Se<=me;)if(ce<ue[3*Se])Se=2*Se;else if(ce>ue[3*Se+1])Se=2*Se+1;else return ue[3*Se+2];return 0}}Te.c=null;function Fe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function qe(G,ce){if(G===0)return 0;const ue=Ue(G,ce);if(ue!==void 0)return ue;const me=new N(ce,G);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=qe;function Ue(G,ce){const ue=new N(ce,G);let me=ue.prevCodePoint();for(;$e(me)||me===65039||me===8419;){if(ue.offset===0)return;me=ue.prevCodePoint()}if(!x(me))return;let Se=ue.offset;return Se>0&&ue.prevCodePoint()===8205&&(Se=ue.offset),Se}function $e(G){return 127995<=G&&G<=127999}var Je;(function(G){G[G.zwj=8205]="zwj",G[G.emojiVariantSelector=65039]="emojiVariantSelector",G[G.enclosingKeyCap=8419]="enclosingKeyCap"})(Je||(Je={})),e.noBreakWhitespace="\xA0";class je{static getInstance(ce){return je.d.get(Array.from(ce))}static getLocales(){return je.e.getValue()}constructor(ce){this.f=ce}isAmbiguous(ce){return this.f.has(ce)}getPrimaryConfusable(ce){return this.f.get(ce)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=je,C=je,je.c=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),je.d=new I.LRUCachedFunction(G=>{function ce(Ve){const et=new Map;for(let nt=0;nt<Ve.length;nt+=2)et.set(Ve[nt],Ve[nt+1]);return et}function ue(Ve,et){const nt=new Map(Ve);for(const[ct,mt]of et)nt.set(ct,mt);return nt}function me(Ve,et){if(!Ve)return et;const nt=new Map;for(const[ct,mt]of Ve)et.has(ct)&&nt.set(ct,mt);return nt}const Se=C.c.getValue();let Le=G.filter(Ve=>!Ve.startsWith("_")&&Ve in Se);Le.length===0&&(Le=["_default"]);let Be;for(const Ve of Le){const et=ce(Se[Ve]);Be=me(Be,et)}const it=ce(Se._common),Ze=ue(it,Be);return new je(Ze)}),je.e=new t.Lazy(()=>Object.keys(je.c.getValue()).filter(G=>!G.startsWith("_")));class Ke{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Ke.c())),this.d}static isInvisibleCharacter(ce){return Ke.e().has(ce)}static get codePoints(){return Ke.e()}}e.InvisibleCharacters=Ke,Ke.d=void 0}),define(ee[30],te([0,1,9,4,26,12]),function(q,e,I,t,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(s){return s===47||s===92}e.isPathSeparator=A;function k(s){return s.replace(/[\\/]/g,I.posix.sep)}e.toSlashes=k;function p(s){return s.indexOf("/")===-1&&(s=k(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=p;function m(s,l=I.posix.sep){if(!s)return"";const o=s.length,S=s.charCodeAt(0);if(A(S)){if(A(s.charCodeAt(1))&&!A(s.charCodeAt(2))){let L=3;const j=L;for(;L<o&&!A(s.charCodeAt(L));L++);if(j!==L&&!A(s.charCodeAt(L+1))){for(L+=1;L<o;L++)if(A(s.charCodeAt(L)))return s.slice(0,L+1).replace(/[\\/]/g,l)}}return l}else if(u(S)&&s.charCodeAt(1)===58)return A(s.charCodeAt(2))?s.slice(0,2)+l:s.slice(0,2);let D=s.indexOf("://");if(D!==-1){for(D+=3;D<o;D++)if(A(s.charCodeAt(D)))return s.slice(0,D+1)}return""}e.getRoot=m;function y(s){if(!t.isWindows||!s||s.length<5)return!1;let l=s.charCodeAt(0);if(l!==92||(l=s.charCodeAt(1),l!==92))return!1;let o=2;const S=o;for(;o<s.length&&(l=s.charCodeAt(o),l!==92);o++);return!(S===o||(l=s.charCodeAt(o+1),isNaN(l)||l===92))}e.isUNC=y;const P=/[\\/:\*\?"<>\|]/g,E=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function w(s,l=t.isWindows){const o=l?P:E;return!(!s||s.length===0||/^\s+$/.test(s)||(o.lastIndex=0,o.test(s))||l&&h.test(s)||s==="."||s===".."||l&&s[s.length-1]==="."||l&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=w;function d(s,l,o){const S=s===l;return!o||S?S:!s||!l?!1:(0,C.equalsIgnoreCase)(s,l)}e.isEqual=d;function b(s,l,o,S=I.sep){if(s===l)return!0;if(!s||!l||l.length>s.length)return!1;if(o){if(!(0,C.startsWithIgnoreCase)(s,l))return!1;if(l.length===s.length)return!0;let L=l.length;return l.charAt(l.length-1)===S&&L--,s.charAt(L)===S}return l.charAt(l.length-1)!==S&&(l+=S),s.indexOf(l)===0}e.isEqualOrParent=b;function u(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=u;function v(s,l){return t.isWindows&&s.endsWith(":")&&(s+=I.sep),(0,I.isAbsolute)(s)||(s=(0,I.join)(l,s)),s=(0,I.normalize)(s),t.isWindows?(s=(0,C.rtrim)(s,I.sep),s.endsWith(":")&&(s+=I.sep)):(s=(0,C.rtrim)(s,I.sep),s||(s=I.sep)),s}e.sanitizeFilePath=v;function g(s){const l=(0,I.normalize)(s);return t.isWindows?s.length>3?!1:f(l)&&(s.length===2||l.charCodeAt(2)===92):l===I.posix.sep}e.isRootOrDriveLetter=g;function f(s,l=t.isWindows){return l?u(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=f;function c(s){return f(s)?s[0]:void 0}e.getDriveLetter=c;function n(s,l,o){return l.length>s.length?-1:s===l?0:(o&&(s=s.toLowerCase(),l=l.toLowerCase()),s.indexOf(l))}e.indexOfPath=n;function r(s){const l=s.split(":");let o,S,D;for(const L of l){const j=Number(L);(0,M.isNumber)(j)?S===void 0?S=j:D===void 0&&(D=j):o=o?[o,L].join(":"):L}if(!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:S!==void 0?S:void 0,column:D!==void 0?D:S!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function a(s,l,o=8){let S="";for(let L=0;L<o;L++)S+=i.charAt(Math.floor(Math.random()*i.length));let D;return l?D=`${l}-${S}`:D=S,s?(0,I.join)(s,D):D}e.randomPath=a}),define(ee[68],te([0,1,26]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(u){return C(u,0)}e.hash=t;function C(u,v){switch(typeof u){case"object":return u===null?M(349,v):Array.isArray(u)?p(u,v):m(u,v);case"string":return k(u,v);case"boolean":return A(u,v);case"number":return M(u,v);case"undefined":return M(937,v);default:return M(617,v)}}e.doHash=C;function M(u,v){return(v<<5)-v+u|0}e.numberHash=M;function A(u,v){return M(u?433:863,v)}function k(u,v){v=M(149417,v);for(let g=0,f=u.length;g<f;g++)v=M(u.charCodeAt(g),v);return v}e.stringHash=k;function p(u,v){return v=M(104579,v),u.reduce((g,f)=>C(f,g),v)}function m(u,v){return v=M(181387,v),Object.keys(u).sort().reduce((g,f)=>(g=k(f,g),C(u[f],g)),v)}class y{constructor(){this.g=0}get value(){return this.g}hash(v){return this.g=C(v,this.g),this.g}}e.Hasher=y;var P;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function E(u,v,g=32){const f=g-v,c=~((1<<f)-1);return(u<<v|(c&u)>>>f)>>>0}function h(u,v=0,g=u.byteLength,f=0){for(let c=0;c<g;c++)u[v+c]=f}function w(u,v,g="0"){for(;u.length<v;)u=g+u;return u}function d(u,v=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(g=>g.toString(16).padStart(2,"0")).join(""):w((u>>>0).toString(16),v/4)}e.toHexString=d;class b{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(v){const g=v.length;if(g===0)return;const f=this.p;let c=this.r,n=this.u,r,i;for(n!==0?(r=n,i=-1,n=0):(r=v.charCodeAt(0),i=0);;){let a=r;if(I.isHighSurrogate(r))if(i+1<g){const s=v.charCodeAt(i+1);I.isLowSurrogate(s)?(i++,a=I.computeCodePoint(r,s)):a=65533}else{n=r;break}else I.isLowSurrogate(r)&&(a=65533);if(c=this.w(f,c,a),i++,i<g)r=v.charCodeAt(i);else break}this.r=c,this.u=n}w(v,g,f){return f<128?v[g++]=f:f<2048?(v[g++]=192|(f&1984)>>>6,v[g++]=128|(f&63)>>>0):f<65536?(v[g++]=224|(f&61440)>>>12,v[g++]=128|(f&4032)>>>6,v[g++]=128|(f&63)>>>0):(v[g++]=240|(f&1835008)>>>18,v[g++]=128|(f&258048)>>>12,v[g++]=128|(f&4032)>>>6,v[g++]=128|(f&63)>>>0),g>=64&&(this.y(),g-=64,this.t+=64,v[0]=v[64+0],v[1]=v[64+1],v[2]=v[64+2]),g}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),d(this.h)+d(this.l)+d(this.m)+d(this.n)+d(this.o)}x(){this.p[this.r++]=128,h(this.p,this.r),this.r>56&&(this.y(),h(this.p));const v=8*this.t;this.q.setUint32(56,Math.floor(v/4294967296),!1),this.q.setUint32(60,v%4294967296,!1),this.y()}y(){const v=b.g,g=this.q;for(let o=0;o<64;o+=4)v.setUint32(o,g.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)v.setUint32(o,E(v.getUint32(o-12,!1)^v.getUint32(o-32,!1)^v.getUint32(o-56,!1)^v.getUint32(o-64,!1),1),!1);let f=this.h,c=this.l,n=this.m,r=this.n,i=this.o,a,s,l;for(let o=0;o<80;o++)o<20?(a=c&n|~c&r,s=1518500249):o<40?(a=c^n^r,s=1859775393):o<60?(a=c&n|c&r|n&r,s=2400959708):(a=c^n^r,s=3395469782),l=E(f,5)+a+i+s+v.getUint32(o*4,!1)&4294967295,i=r,r=n,n=E(c,30),c=f,f=l;this.h=this.h+f&4294967295,this.l=this.l+c&4294967295,this.m=this.m+n&4294967295,this.n=this.n+r&4294967295,this.o=this.o+i&4294967295}}e.StringSHA1=b,b.g=new DataView(new ArrayBuffer(320))}),define(ee[98],te([0,1,26]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(t||(t={})),function(C){const M="error",A="warning",k="warn",p="info",m="ignore";function y(E){return E?I.equalsIgnoreCase(M,E)?C.Error:I.equalsIgnoreCase(A,E)||I.equalsIgnoreCase(k,E)?C.Warning:I.equalsIgnoreCase(p,E)?C.Info:C.Ignore:C.Ignore}C.fromValue=y;function P(E){switch(E){case C.Error:return M;case C.Warning:return A;case C.Info:return p;default:return m}}C.toString=P}(t||(t={})),e.default=t}),define(ee[60],te([0,1,24,26]),function(q,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class C{constructor(){this.b="",this.c=0}reset(h){return this.b=h,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(h){const w=h.charCodeAt(0),d=this.b.charCodeAt(this.c);return w-d}value(){return this.b[this.c]}}e.StringIterator=C;class M{constructor(h=!0){this.e=h}reset(h){return this.b=h,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let h=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(h)this.c++;else break;else h=!1;return this}cmp(h){return this.e?(0,t.compareSubstring)(h,this.b,0,h.length,this.c,this.d):(0,t.compareSubstringIgnoreCase)(h,this.b,0,h.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=M;class A{constructor(h=!0,w=!0){this.f=h,this.g=w}reset(h){this.d=0,this.e=0,this.b=h,this.c=h.length;for(let w=h.length-1;w>=0;w--,this.c--){const d=this.b.charCodeAt(w);if(!(d===47||this.f&&d===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let h=!0;for(;this.e<this.c;this.e++){const w=this.b.charCodeAt(this.e);if(w===47||this.f&&w===92)if(h)this.d++;else break;else h=!1}return this}cmp(h){return this.g?(0,t.compareSubstring)(h,this.b,0,h.length,this.d,this.e):(0,t.compareSubstringIgnoreCase)(h,this.b,0,h.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=A;var k;(function(E){E[E.Scheme=1]="Scheme",E[E.Authority=2]="Authority",E[E.Path=3]="Path",E[E.Query=4]="Query",E[E.Fragment=5]="Fragment"})(k||(k={}));class p{constructor(h,w){this.f=h,this.g=w,this.d=[],this.e=0}reset(h){return this.c=h,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(h)),this.b.reset(h.path),this.b.value()&&this.d.push(3)),this.g(h)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(h){if(this.d[this.e]===1)return(0,t.compareIgnoreCase)(h,this.c.scheme);if(this.d[this.e]===2)return(0,t.compareIgnoreCase)(h,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(h);if(this.d[this.e]===4)return(0,t.compare)(h,this.c.query);if(this.d[this.e]===5)return(0,t.compare)(h,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=p;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(E){E[E.Left=-1]="Left",E[E.Mid=0]="Mid",E[E.Right=1]="Right"})(y||(y={}));class P{static forUris(h=()=>!1,w=()=>!1){return new P(new p(h,w))}static forPaths(h=!1){return new P(new A(void 0,!h))}static forStrings(){return new P(new C)}static forConfigKeys(){return new P(new M)}constructor(h){this.b=h}clear(){this.c=void 0}fill(h,w){if(w){const d=w.slice(0);(0,I.shuffle)(d);for(const b of d)this.set(b,h)}else{const d=h.slice(0);(0,I.shuffle)(d);for(const b of d)this.set(b[0],b[1])}}set(h,w){const d=this.b.reset(h);let b;this.c||(this.c=new m,this.c.segment=d.value());const u=[];for(b=this.c;;){const g=d.cmp(b.segment);if(g>0)b.left||(b.left=new m,b.left.segment=d.value()),u.push([-1,b]),b=b.left;else if(g<0)b.right||(b.right=new m,b.right.segment=d.value()),u.push([1,b]),b=b.right;else if(d.hasNext())d.next(),b.mid||(b.mid=new m,b.mid.segment=d.value()),u.push([0,b]),b=b.mid;else break}const v=b.value;b.value=w,b.key=h;for(let g=u.length-1;g>=0;g--){const f=u[g][1];f.updateHeight();const c=f.balanceFactor();if(c<-1||c>1){const n=u[g][0],r=u[g+1][0];if(n===1&&r===1)u[g][1]=f.rotateLeft();else if(n===-1&&r===-1)u[g][1]=f.rotateRight();else if(n===1&&r===-1)f.right=u[g+1][1]=u[g+1][1].rotateRight(),u[g][1]=f.rotateLeft();else if(n===-1&&r===1)f.left=u[g+1][1]=u[g+1][1].rotateLeft(),u[g][1]=f.rotateRight();else throw new Error;if(g>0)switch(u[g-1][0]){case-1:u[g-1][1].left=u[g][1];break;case 1:u[g-1][1].right=u[g][1];break;case 0:u[g-1][1].mid=u[g][1];break}else this.c=u[0][1]}}return v}get(h){return this.d(h)?.value}d(h){const w=this.b.reset(h);let d=this.c;for(;d;){const b=w.cmp(d.segment);if(b>0)d=d.left;else if(b<0)d=d.right;else if(w.hasNext())w.next(),d=d.mid;else break}return d}has(h){const w=this.d(h);return!(w?.value===void 0&&w?.mid===void 0)}delete(h){return this.e(h,!1)}deleteSuperstr(h){return this.e(h,!0)}e(h,w){const d=this.b.reset(h),b=[];let u=this.c;for(;u;){const v=d.cmp(u.segment);if(v>0)b.push([-1,u]),u=u.left;else if(v<0)b.push([1,u]),u=u.right;else if(d.hasNext())d.next(),b.push([0,u]),u=u.mid;else break}if(!!u){if(w?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const v=this.f(u.right);if(v.key){const{key:g,value:f,segment:c}=v;this.e(v.key,!1),u.key=g,u.value=f,u.segment=c}}else{const v=u.left??u.right;if(b.length>0){const[g,f]=b[b.length-1];switch(g){case-1:f.left=v;break;case 0:f.mid=v;break;case 1:f.right=v;break}}else this.c=v}for(let v=b.length-1;v>=0;v--){const g=b[v][1];g.updateHeight();const f=g.balanceFactor();if(f>1?(g.right.balanceFactor()>=0||(g.right=g.right.rotateRight()),b[v][1]=g.rotateLeft()):f<-1&&(g.left.balanceFactor()<=0||(g.left=g.left.rotateLeft()),b[v][1]=g.rotateRight()),v>0)switch(b[v-1][0]){case-1:b[v-1][1].left=b[v][1];break;case 1:b[v-1][1].right=b[v][1];break;case 0:b[v-1][1].mid=b[v][1];break}else this.c=b[0][1]}}}f(h){for(;h.left;)h=h.left;return h}findSubstr(h){const w=this.b.reset(h);let d=this.c,b;for(;d;){const u=w.cmp(d.segment);if(u>0)d=d.left;else if(u<0)d=d.right;else if(w.hasNext())w.next(),b=d.value||b,d=d.mid;else break}return d&&d.value||b}findSuperstr(h){const w=this.b.reset(h);let d=this.c;for(;d;){const b=w.cmp(d.segment);if(b>0)d=d.left;else if(b<0)d=d.right;else if(w.hasNext())w.next(),d=d.mid;else return d.mid?this.g(d.mid):void 0}}forEach(h){for(const[w,d]of this)h(d,w)}*[Symbol.iterator](){yield*this.g(this.c)}g(h){const w=[];return this.h(h,w),w[Symbol.iterator]()}h(h,w){!h||(h.left&&this.h(h.left,w),h.value&&w.push([h.key,h.value]),h.mid&&this.h(h.mid,w),h.right&&this.h(h.right,w))}_isBalanced(){const h=w=>{if(!w)return!0;const d=w.balanceFactor();return d<-1||d>1?!1:h(w.left)&&h(w.right)};return h(this.c)}}e.TernarySearchTree=P}),define(ee[7],te([0,1,9,4]),function(q,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const C=/^\w[\w\d+.-]*$/,M=/^\//,A=/^\/\//;function k(i,a){if(!i.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!C.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!M.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function p(i,a){return!i&&!a?"file":i}function m(i,a){switch(i){case"https":case"http":case"file":a?a[0]!==P&&(a=P+a):a=P;break}return a}const y="",P="/",E=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(a){return a instanceof h?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}constructor(a,s,l,o,S,D=!1){typeof a=="object"?(this.scheme=a.scheme||y,this.authority=a.authority||y,this.path=a.path||y,this.query=a.query||y,this.fragment=a.fragment||y):(this.scheme=p(a,D),this.authority=s||y,this.path=m(this.scheme,l||y),this.query=o||y,this.fragment=S||y,k(this,D))}get fsPath(){return g(this,!1)}with(a){if(!a)return this;let{scheme:s,authority:l,path:o,query:S,fragment:D}=a;return s===void 0?s=this.scheme:s===null&&(s=y),l===void 0?l=this.authority:l===null&&(l=y),o===void 0?o=this.path:o===null&&(o=y),S===void 0?S=this.query:S===null&&(S=y),D===void 0?D=this.fragment:D===null&&(D=y),s===this.scheme&&l===this.authority&&o===this.path&&S===this.query&&D===this.fragment?this:new d(s,l,o,S,D)}static parse(a,s=!1){const l=E.exec(a);return l?new d(l[2]||y,r(l[4]||y),r(l[5]||y),r(l[7]||y),r(l[9]||y),s):new d(y,y,y,y,y)}static file(a){let s=y;if(t.isWindows&&(a=a.replace(/\\/g,P)),a[0]===P&&a[1]===P){const l=a.indexOf(P,2);l===-1?(s=a.substring(2),a=P):(s=a.substring(2,l),a=a.substring(l)||P)}return new d("file",s,a,y,y)}static from(a){const s=new d(a.scheme,a.authority,a.path,a.query,a.fragment);return k(s,!0),s}static joinPath(a,...s){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return t.isWindows&&a.scheme==="file"?l=h.file(I.win32.join(g(a,!0),...s)).path:l=I.posix.join(a.path,...s),a.with({path:l})}toString(a=!1){return f(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof h)return a;{const s=new d(a);return s._formatted=a.external,s._fsPath=a._sep===w?a.fsPath:null,s}}else return a}}e.URI=h;const w=t.isWindows?1:void 0;class d extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(a=!1){return a?f(this,!0):(this._formatted||(this._formatted=f(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=w),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const b={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(i,a){let s,l=-1;for(let o=0;o<i.length;o++){const S=i.charCodeAt(o);if(S>=97&&S<=122||S>=65&&S<=90||S>=48&&S<=57||S===45||S===46||S===95||S===126||a&&S===47)l!==-1&&(s+=encodeURIComponent(i.substring(l,o)),l=-1),s!==void 0&&(s+=i.charAt(o));else{s===void 0&&(s=i.substr(0,o));const D=b[S];D!==void 0?(l!==-1&&(s+=encodeURIComponent(i.substring(l,o)),l=-1),s+=D):l===-1&&(l=o)}}return l!==-1&&(s+=encodeURIComponent(i.substring(l))),s!==void 0?s:i}function v(i){let a;for(let s=0;s<i.length;s++){const l=i.charCodeAt(s);l===35||l===63?(a===void 0&&(a=i.substr(0,s)),a+=b[l]):a!==void 0&&(a+=i[s])}return a!==void 0?a:i}function g(i,a){let s;return i.authority&&i.path.length>1&&i.scheme==="file"?s=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?a?s=i.path.substr(1):s=i.path[1].toLowerCase()+i.path.substr(2):s=i.path,t.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=g;function f(i,a){const s=a?v:u;let l="",{scheme:o,authority:S,path:D,query:L,fragment:j}=i;if(o&&(l+=o,l+=":"),(S||o==="file")&&(l+=P,l+=P),S){let X=S.indexOf("@");if(X!==-1){const ae=S.substr(0,X);S=S.substr(X+1),X=ae.indexOf(":"),X===-1?l+=s(ae,!1):(l+=s(ae.substr(0,X),!1),l+=":",l+=s(ae.substr(X+1),!1)),l+="@"}S=S.toLowerCase(),X=S.indexOf(":"),X===-1?l+=s(S,!1):(l+=s(S.substr(0,X),!1),l+=S.substr(X))}if(D){if(D.length>=3&&D.charCodeAt(0)===47&&D.charCodeAt(2)===58){const X=D.charCodeAt(1);X>=65&&X<=90&&(D=`/${String.fromCharCode(X+32)}:${D.substr(3)}`)}else if(D.length>=2&&D.charCodeAt(1)===58){const X=D.charCodeAt(0);X>=65&&X<=90&&(D=`${String.fromCharCode(X+32)}:${D.substr(2)}`)}l+=s(D,!0)}return L&&(l+="?",l+=s(L,!1)),j&&(l+="#",l+=a?j:u(j,!1)),l}function c(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+c(i.substr(3)):i}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(n)?i.replace(n,a=>c(a)):i}}),define(ee[138],te([0,1,7]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(m){const y=m;return y&&typeof y.type=="string"&&typeof y.severity=="string"}e.isRemoteConsoleLog=t;function C(m){const y=[];let P;try{const E=JSON.parse(m.arguments),h=E[E.length-1];h&&h.__$stack&&(E.pop(),P=h.__$stack),y.push(...E)}catch{y.push("Unable to log remote console arguments",m.arguments)}return{args:y,stack:P}}e.parse=C;function M(m){if(typeof m!="string")return M(C(m).stack);const y=m;if(y){const P=A(y),E=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(P||"");if(E&&E.length===4)return{uri:I.URI.file(E[1]),line:Number(E[2]),column:Number(E[3])}}}e.getFirstFrame=M;function A(m){if(!m)return m;const y=m.indexOf(`
`);return y===-1?m:m.substring(0,y)}function k(m,y){const{args:P,stack:E}=C(m),h=typeof P[0]=="string"&&P.length===1;let w=A(E);w&&(w=`(${w.trim()})`);let d=[];if(typeof P[0]=="string"?w&&h?d=[`%c[${y}] %c${P[0]} %c${w}`,p("blue"),p(""),p("grey")]:d=[`%c[${y}] %c${P[0]}`,p("blue"),p(""),...P.slice(1)]:d=[`%c[${y}]%`,p("blue"),...P],w&&!h&&d.push(w),typeof console[m.severity]!="function")throw new Error("Unknown console method");console[m.severity].apply(console,d)}e.log=k;function p(m){return`color: ${m}`}}),define(ee[69],te([0,1,17,26,7]),function(q,e,I,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function M(m){return JSON.stringify(m,k)}e.stringify=M;function A(m){let y=JSON.parse(m);return y=p(y),y}e.parse=A;function k(m,y){return y instanceof RegExp?{$mid:2,source:y.source,flags:(0,t.regExpFlags)(y)}:y}function p(m,y=0){if(!m||y>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return C.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 16:return new Date(m.source)}if(m instanceof I.VSBuffer||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let P=0;P<m.length;++P)m[P]=p(m[P],y+1);else for(const P in m)Object.hasOwnProperty.call(m,P)&&(m[P]=p(m[P],y+1))}return m}e.revive=p}),define(ee[15],te([0,1,4,7]),function(q,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var C;(function(p){p.inMemory="inmemory",p.vscode="vscode",p.internal="private",p.walkThrough="walkThrough",p.walkThroughSnippet="walkThroughSnippet",p.http="http",p.https="https",p.file="file",p.mailto="mailto",p.untitled="untitled",p.data="data",p.command="command",p.vscodeRemote="vscode-remote",p.vscodeRemoteResource="vscode-remote-resource",p.vscodeUserData="vscode-userdata",p.vscodeCustomEditor="vscode-custom-editor",p.vscodeNotebook="vscode-notebook",p.vscodeNotebookCell="vscode-notebook-cell",p.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",p.vscodeNotebookCellOutput="vscode-notebook-cell-output",p.vscodeInteractive="vscode-interactive",p.vscodeInteractiveInput="vscode-interactive-input",p.vscodeSettings="vscode-settings",p.vscodeWorkspaceTrust="vscode-workspace-trust",p.vscodeTerminal="vscode-terminal",p.webviewPanel="webview-panel",p.vscodeWebview="vscode-webview",p.extension="extension",p.vscodeFileResource="vscode-file",p.tmp="tmp",p.vsls="vsls",p.vscodeSourceControl="vscode-scm"})(C=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class M{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${C.vscodeRemoteResource}`}setPreferredWebSchema(m){this.d=m}setDelegate(m){this.e=m}setServerRootPath(m){this.f=`${m}/${C.vscodeRemoteResource}`}set(m,y,P){this.a[m]=y,this.b[m]=P}setConnectionToken(m,y){this.c[m]=y}getPreferredWebSchema(){return this.d}rewrite(m){if(this.e)return this.e(m);const y=m.authority;let P=this.a[y];P&&P.indexOf(":")!==-1&&P.indexOf("[")===-1&&(P=`[${P}]`);const E=this.b[y],h=this.c[y];let w=`path=${encodeURIComponent(m.path)}`;return typeof h=="string"&&(w+=`&${e.connectionTokenQueryName}=${encodeURIComponent(h)}`),t.URI.from({scheme:I.isWeb?this.d:C.vscodeRemoteResource,authority:`${P}:${E}`,path:this.f,query:w})}}e.RemoteAuthorities=new M,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class A{asBrowserUri(m){const y=this.b(m,q);return this.uriToBrowserUri(y)}uriToBrowserUri(m){return m.scheme===C.vscodeRemote?e.RemoteAuthorities.rewrite(m):m.scheme===C.file&&(I.isNative||I.isWebWorker&&I.globals.origin===`${C.vscodeFileResource}://${A.a}`)?m.with({scheme:C.vscodeFileResource,authority:m.authority||A.a,query:null,fragment:null}):m}asFileUri(m){const y=this.b(m,q);return this.uriToFileUri(y)}uriToFileUri(m){return m.scheme===C.vscodeFileResource?m.with({scheme:C.file,authority:m.authority!==A.a?m.authority:null,query:null,fragment:null}):m}b(m,y){return t.URI.isUri(m)?m:t.URI.parse(y.toUrl(m))}}A.a="vscode-app",e.FileAccess=new A;var k;(function(p){const m=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);p.CoopAndCoep=Object.freeze(m.get("3"));const y="vscode-coi";function P(h){let w;typeof h=="string"?w=new URL(h).searchParams:h instanceof URL?w=h.searchParams:t.URI.isUri(h)&&(w=new URL(h.toString(!0)).searchParams);const d=w?.get(y);if(!!d)return m.get(d)}p.getHeadersFromQuery=P;function E(h,w,d){if(!globalThis.crossOriginIsolated)return;const b=w&&d?"3":d?"2":"1";h instanceof URLSearchParams?h.set(y,b):h[y]=b}p.addSearchParam=E})(k=e.COI||(e.COI={}))}),define(ee[20],te([0,1,30,15,9,4,26,7]),function(q,e,I,t,C,M,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function p(h){return(0,k.uriToFsPath)(h,!0)}e.originalFSPath=p;class m{constructor(w){this.a=w}compare(w,d,b=!1){return w===d?0:(0,A.compare)(this.getComparisonKey(w,b),this.getComparisonKey(d,b))}isEqual(w,d,b=!1){return w===d?!0:!w||!d?!1:this.getComparisonKey(w,b)===this.getComparisonKey(d,b)}getComparisonKey(w,d=!1){return w.with({path:this.a(w)?w.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(w){return this.a(w)}isEqualOrParent(w,d,b=!1){if(w.scheme===d.scheme){if(w.scheme===t.Schemas.file)return I.isEqualOrParent(p(w),p(d),this.a(w))&&w.query===d.query&&(b||w.fragment===d.fragment);if((0,e.isEqualAuthority)(w.authority,d.authority))return I.isEqualOrParent(w.path,d.path,this.a(w),"/")&&w.query===d.query&&(b||w.fragment===d.fragment)}return!1}joinPath(w,...d){return k.URI.joinPath(w,...d)}basenameOrAuthority(w){return(0,e.basename)(w)||w.authority}basename(w){return C.posix.basename(w.path)}extname(w){return C.posix.extname(w.path)}dirname(w){if(w.path.length===0)return w;let d;return w.scheme===t.Schemas.file?d=k.URI.file(C.dirname(p(w))).path:(d=C.posix.dirname(w.path),w.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${w.toString})) resulted in a relative path`),d="/")),w.with({path:d})}normalizePath(w){if(!w.path.length)return w;let d;return w.scheme===t.Schemas.file?d=k.URI.file(C.normalize(p(w))).path:d=C.posix.normalize(w.path),w.with({path:d})}relativePath(w,d){if(w.scheme!==d.scheme||!(0,e.isEqualAuthority)(w.authority,d.authority))return;if(w.scheme===t.Schemas.file){const v=C.relative(p(w),p(d));return M.isWindows?I.toSlashes(v):v}let b=w.path||"/";const u=d.path||"/";if(this.a(w)){let v=0;for(const g=Math.min(b.length,u.length);v<g&&!(b.charCodeAt(v)!==u.charCodeAt(v)&&b.charAt(v).toLowerCase()!==u.charAt(v).toLowerCase());v++);b=u.substr(0,v)+b.substr(v)}return C.posix.relative(b,u)}resolvePath(w,d){if(w.scheme===t.Schemas.file){const b=k.URI.file(C.resolve(p(w),d));return w.with({authority:b.authority,path:b.path})}return d=I.toPosixPath(d),w.with({path:C.posix.resolve(w.path,d)})}isAbsolutePath(w){return!!w.path&&w.path[0]==="/"}isEqualAuthority(w,d){return w===d||w!==void 0&&d!==void 0&&(0,A.equalsIgnoreCase)(w,d)}hasTrailingPathSeparator(w,d=C.sep){if(w.scheme===t.Schemas.file){const b=p(w);return b.length>I.getRoot(b).length&&b[b.length-1]===d}else{const b=w.path;return b.length>1&&b.charCodeAt(b.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(w.fsPath)}}removeTrailingPathSeparator(w,d=C.sep){return(0,e.hasTrailingPathSeparator)(w,d)?w.with({path:w.path.substr(0,w.path.length-1)}):w}addTrailingPathSeparator(w,d=C.sep){let b=!1;if(w.scheme===t.Schemas.file){const u=p(w);b=u!==void 0&&u.length===I.getRoot(u).length&&u[u.length-1]===d}else{d="/";const u=w.path;b=u.length===1&&u.charCodeAt(u.length-1)===47}return!b&&!(0,e.hasTrailingPathSeparator)(w,d)?w.with({path:w.path+"/"}):w}}e.ExtUri=m,e.extUri=new m(()=>!1),e.extUriBiasedIgnorePathCase=new m(h=>h.scheme===t.Schemas.file?!M.isLinux:!0),e.extUriIgnorePathCase=new m(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function y(h,w){const d=[];for(let b=0;b<h.length;b++){const u=w(h[b]);h.some((v,g)=>g===b?!1:(0,e.isEqualOrParent)(u,w(v)))||d.push(h[b])}return d}e.distinctParents=y;var P;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function w(d){const b=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(g=>{const[f,c]=g.split(":");f&&c&&b.set(f,c)});const v=d.path.substring(0,d.path.indexOf(";"));return v&&b.set(h.META_DATA_MIME,v),b}h.parseMetaData=w})(P=e.DataUri||(e.DataUri={}));function E(h,w,d){if(w){let b=h.path;return b&&b[0]!==C.posix.sep&&(b=C.posix.sep+b),h.with({scheme:d,authority:w,path:b})}return h.with({scheme:d})}e.toLocalResource=E}),define(ee[8],te([0,1,22,14,3,2,20,4]),function(q,e,I,t,C,M,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function p(T){return!!T&&typeof T.then=="function"}e.isThenable=p;function m(T){const R=new I.CancellationTokenSource,O=T(R.token),U=new Promise((B,V)=>{const ie=R.token.onCancellationRequested(()=>{ie.dispose(),R.dispose(),V(new t.CancellationError)});Promise.resolve(O).then($=>{ie.dispose(),R.dispose(),B($)},$=>{ie.dispose(),R.dispose(),V($)})});return new class{cancel(){R.cancel()}then(B,V){return U.then(B,V)}catch(B){return this.then(void 0,B)}finally(B){return U.finally(B)}}}e.createCancelablePromise=m;function y(T,R,O){return new Promise((U,B)=>{const V=R.onCancellationRequested(()=>{V.dispose(),U(O)});T.then(U,B).finally(()=>V.dispose())})}e.raceCancellation=y;function P(T,R){return new Promise((O,U)=>{const B=R.onCancellationRequested(()=>{B.dispose(),U(new t.CancellationError)});T.then(O,U).finally(()=>B.dispose())})}e.raceCancellationError=P;async function E(T){let R=-1;const O=T.map((B,V)=>B.then(ie=>(R=V,ie))),U=await Promise.race(O);return T.forEach((B,V)=>{V!==R&&B.cancel()}),U}e.raceCancellablePromises=E;function h(T,R,O){let U;const B=setTimeout(()=>{U?.(void 0),O?.()},R);return Promise.race([T.finally(()=>clearTimeout(B)),new Promise(V=>U=V)])}e.raceTimeout=h;function w(T){return new Promise((R,O)=>{const U=T();p(U)?U.then(R,O):R(U)})}e.asPromise=w;class d{constructor(){this.a=null,this.b=null,this.d=null}queue(R){if(this.a){if(this.d=R,!this.b){const O=()=>{this.b=null;const U=this.queue(this.d);return this.d=null,U};this.b=new Promise(U=>{this.a.then(O,O).then(U)})}return new Promise((O,U)=>{this.b.then(O,U)})}return this.a=R(),new Promise((O,U)=>{this.a.then(B=>{this.a=null,O(B)},B=>{this.a=null,U(B)})})}}e.Throttler=d;class b{constructor(){this.a=Promise.resolve(null)}queue(R){return this.a=this.a.then(()=>R(),()=>R())}}e.Sequencer=b;class u{constructor(){this.a=new Map}queue(R,O){const B=(this.a.get(R)??Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.a.get(R)===B&&this.a.delete(R)});return this.a.set(R,B),B}}e.SequencerByKey=u;const v=(T,R)=>{let O=!0;const U=setTimeout(()=>{O=!1,R()},T);return{isTriggered:()=>O,dispose:()=>{clearTimeout(U),O=!1}}},g=T=>{let R=!0;return queueMicrotask(()=>{R&&(R=!1,T())}),{isTriggered:()=>R,dispose:()=>{R=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class f{constructor(R){this.defaultDelay=R,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(R,O=this.defaultDelay){this.g=R,this.h(),this.b||(this.b=new Promise((B,V)=>{this.d=B,this.f=V}).then(()=>{if(this.b=null,this.d=null,this.g){const B=this.g;return this.g=null,B()}}));const U=()=>{this.a=null,this.d?.(null)};return this.a=O===e.MicrotaskDelay?g(U):v(O,U),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new t.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=f;class c{constructor(R){this.a=new f(R),this.b=new d}trigger(R,O){return this.a.trigger(()=>this.b.queue(R),O)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=c;class n{constructor(){this.a=!1,this.b=new Promise((R,O)=>{this.d=R})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=n;class r extends n{constructor(R){super(),this.f=setTimeout(()=>this.open(),R)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=r;function i(T,R){return R?new Promise((O,U)=>{const B=setTimeout(()=>{V.dispose(),O()},T),V=R.onCancellationRequested(()=>{clearTimeout(B),V.dispose(),U(new t.CancellationError)})}):m(O=>i(T,O))}e.timeout=i;function a(T,R=0){const O=setTimeout(T,R);return(0,M.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=a;function s(T){const R=[];let O=0;const U=T.length;function B(){return O<U?T[O++]():null}function V(ie){ie!=null&&R.push(ie);const $=B();return $?$.then(V):Promise.resolve(R)}return Promise.resolve(null).then(V)}e.sequence=s;function l(T,R=U=>!!U,O=null){let U=0;const B=T.length,V=()=>{if(U>=B)return Promise.resolve(O);const ie=T[U++];return Promise.resolve(ie()).then(Z=>R(Z)?Promise.resolve(Z):V())};return V()}e.first=l;function o(T,R=U=>!!U,O=null){if(T.length===0)return Promise.resolve(O);let U=T.length;const B=()=>{U=-1;for(const V of T)V.cancel?.()};return new Promise((V,ie)=>{for(const $ of T)$.then(Z=>{--U>=0&&R(Z)?(B(),V(Z)):U===0&&V(O)}).catch(Z=>{--U>=0&&(B(),ie(Z))})})}e.firstParallel=o;class S{constructor(R){this.a=0,this.d=R,this.f=[],this.b=0,this.g=new C.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(R){return this.a++,new Promise((O,U)=>{this.f.push({factory:R,c:O,e:U}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const R=this.f.shift();this.b++;const O=R.factory();O.then(R.c,R.e),O.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=S;class D extends S{constructor(){super(1)}}e.Queue=D;class L{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const R=new W;return this.b.add(R),R.p}d(){for(const[,R]of this.a)if(R.size>0)return!1;return!0}queueFor(R,O=A.extUri){const U=O.getComparisonKey(R);let B=this.a.get(U);return B||(B=new D,C.Event.once(B.onDrained)(()=>{B?.dispose(),this.a.delete(U),this.f()}),this.a.set(U,B)),B}f(){!this.d()||this.g()}g(){for(const R of this.b)R.complete();this.b.clear()}dispose(){for(const[,R]of this.a)R.dispose();this.a.clear(),this.g()}}e.ResourceQueue=L;class j{constructor(R,O){this.a=-1,typeof R=="function"&&typeof O=="number"&&this.setIfNotSet(R,O)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(R,O){this.cancel(),this.a=setTimeout(()=>{this.a=-1,R()},O)}setIfNotSet(R,O){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,R()},O))}}e.TimeoutTimer=j;class X{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(R,O){this.cancel(),this.a=setInterval(()=>{R()},O)}}e.IntervalTimer=X;class ae{constructor(R,O){this.b=-1,this.a=R,this.d=O,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(R=this.d){this.cancel(),this.b=setTimeout(this.f,R)}get delay(){return this.d}set delay(R){this.d=R}isScheduled(){return this.b!==-1}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=ae;class Y{constructor(R,O){O%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.a=R,this.b=O,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(R=this.b){R%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${R}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(R/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=Y;class J extends ae{constructor(R,O){super(R,O),this.j=[]}work(R){this.j.push(R),this.isScheduled()||this.schedule()}h(){const R=this.j;this.j=[],this.a?.(R)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=J;class se extends M.Disposable{constructor(R,O){super(),this.g=R,this.h=O,this.a=[],this.b=this.B(new M.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(R){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+R.length>this.g.maxBufferedWork)return!1}else if(this.pending+R.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}return this.a.push(...R),this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ae(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=se,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=T=>{(0,k.setTimeout0)(()=>{if(R)return;const O=Date.now()+15;T(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let R=!1;return{dispose(){R||(R=!0)}}}:e.runWhenIdle=(T,R)=>{const O=requestIdleCallback(T,typeof R=="number"?{timeout:R}:void 0);let U=!1;return{dispose(){U||(U=!0,cancelIdleCallback(O))}}}}();class ne{constructor(R){this.d=!1,this.a=()=>{try{this.f=R()}catch(O){this.g=O}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=ne;async function he(T,R,O){let U;for(let B=0;B<O;B++)try{return await T()}catch(V){U=V,await i(R)}throw U}e.retry=he;class K{hasPending(R){return this.a?typeof R=="number"?this.a.taskId===R:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(R,O,U){return this.a={taskId:R,cancel:()=>U?.(),promise:O},O.then(()=>this.d(R),()=>this.d(R)),O}d(R){this.a&&R===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const R=this.b;this.b=void 0,R.run().then(R.promiseResolve,R.promiseReject)}}setNext(R){if(this.b)this.b.run=R;else{let O,U;const B=new Promise((V,ie)=>{O=V,U=ie});this.b={run:R,promise:B,promiseResolve:O,promiseReject:U}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=K;class le{constructor(R,O=()=>Date.now()){this.d=R,this.f=O,this.a=0,this.b=0}increment(){const R=this.f();return R-this.a>this.d&&(this.a=R,this.b=0),this.b++,this.b}}e.IntervalCounter=le;class W{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((R,O)=>{this.a=R,this.b=O})}complete(R){return new Promise(O=>{this.a(R),this.f=!0,O()})}error(R){return new Promise(O=>{this.b(R),this.d=!0,O()})}cancel(){new Promise(R=>{this.b(new t.CancellationError),this.d=!0,R()})}}e.DeferredPromise=W;var F;(function(T){async function R(U){let B;const V=await Promise.all(U.map(ie=>ie.then($=>$,$=>{B||(B=$)})));if(typeof B<"u")throw B;return V}T.settled=R;function O(U){return new Promise(async(B,V)=>{try{await U(B,V)}catch(ie){V(ie)}})}T.withAsyncBody=O})(F=e.Promises||(e.Promises={}));var N;(function(T){T[T.Initial=0]="Initial",T[T.DoneOK=1]="DoneOK",T[T.DoneError=2]="DoneError"})(N||(N={}));class H{static fromArray(R){return new H(O=>{O.emitMany(R)})}static fromPromise(R){return new H(async O=>{O.emitMany(await R)})}static fromPromises(R){return new H(async O=>{await Promise.all(R.map(async U=>O.emitOne(await U)))})}static merge(R){return new H(async O=>{await Promise.all(R.map(async U=>{for await(const B of U)O.emitOne(B)}))})}constructor(R){this.a=0,this.b=[],this.d=null,this.f=new C.Emitter,queueMicrotask(async()=>{const O={emitOne:U=>this.g(U),emitMany:U=>this.h(U),reject:U=>this.k(U)};try{await Promise.resolve(R(O)),this.j()}catch(U){this.k(U)}finally{O.emitOne=void 0,O.emitMany=void 0,O.reject=void 0}})}[Symbol.asyncIterator](){let R=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(R<this.b.length)return{done:!1,value:this.b[R++]};if(this.a===1)return{done:!0,value:void 0};await C.Event.toPromise(this.f.event)}while(!0)}}}static map(R,O){return new H(async U=>{for await(const B of R)U.emitOne(O(B))})}map(R){return H.map(this,R)}static filter(R,O){return new H(async U=>{for await(const B of R)O(B)&&U.emitOne(B)})}filter(R){return H.filter(this,R)}static coalesce(R){return H.filter(R,O=>!!O)}coalesce(){return H.coalesce(this)}static async toPromise(R){const O=[];for await(const U of R)O.push(U);return O}toPromise(){return H.toPromise(this)}g(R){this.a===0&&(this.b.push(R),this.f.fire())}h(R){this.a===0&&(this.b=this.b.concat(R),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(R){this.a===0&&(this.a=2,this.d=R,this.f.fire())}}e.AsyncIterableObject=H,H.EMPTY=H.fromArray([]);class re extends H{constructor(R,O){super(O),this.l=R}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=re;function z(T){const R=new I.CancellationTokenSource,O=T(R.token);return new re(R,async U=>{const B=R.token.onCancellationRequested(()=>{B.dispose(),R.dispose(),U.reject(new t.CancellationError)});try{for await(const V of O){if(R.token.isCancellationRequested)return;U.emitOne(V)}B.dispose(),R.dispose()}catch(V){B.dispose(),R.dispose(),U.reject(V)}})}e.createCancelableAsyncIterable=z}),define(ee[99],te([0,1,24,8,30,39,9,4,26]),function(q,e,I,t,C,M,A,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function m(){return Object.create(null)}e.getEmptyExpression=m,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const y="[/\\\\]",P="[^/\\\\]",E=/\//g;function h(W,F){switch(W){case 0:return"";case 1:return`${P}*?`;default:return`(?:${y}|${P}+${y}${F?`|${y}${P}+`:""})*?`}}function w(W,F){if(!W)return[];const N=[];let H=!1,re=!1,z="";for(const T of W){switch(T){case F:if(!H&&!re){N.push(z),z="";continue}break;case"{":H=!0;break;case"}":H=!1;break;case"[":re=!0;break;case"]":re=!1;break}z+=T}return z&&N.push(z),N}e.splitGlobAware=w;function d(W){if(!W)return"";let F="";const N=w(W,e.GLOB_SPLIT);if(N.every(H=>H===e.GLOBSTAR))F=".*";else{let H=!1;N.forEach((re,z)=>{if(re===e.GLOBSTAR){if(H)return;F+=h(2,z===N.length-1)}else{let T=!1,R="",O=!1,U="";for(const B of re){if(B!=="}"&&T){R+=B;continue}if(O&&(B!=="]"||!U)){let V;B==="-"?V=B:(B==="^"||B==="!")&&!U?V="^":B===e.GLOB_SPLIT?V="":V=(0,p.escapeRegExpCharacters)(B),U+=V;continue}switch(B){case"{":T=!0;continue;case"[":O=!0;continue;case"}":{F+=`(?:${w(R,",").map($=>d($)).join("|")})`,T=!1,R="";break}case"]":{F+="["+U+"]",O=!1,U="";break}case"?":F+=P;continue;case"*":F+=h(1);continue;default:F+=(0,p.escapeRegExpCharacters)(B)}}z<N.length-1&&(N[z+1]!==e.GLOBSTAR||z+2<N.length)&&(F+=y)}H=re===e.GLOBSTAR})}return F}const b=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,g=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,f=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new M.LRUCache(1e4),r=function(){return!1},i=function(){return null};function a(W,F){if(!W)return i;let N;typeof W!="string"?N=W.pattern:N=W,N=N.trim();const H=`${N}_${!!F.trimForExclusions}`;let re=n.get(H);if(re)return s(re,W);let z;return b.test(N)?re=o(N.substr(4),N):(z=u.exec(l(N,F)))?re=S(z[1],N):(F.trimForExclusions?g:v).test(N)?re=D(N,F):(z=f.exec(l(N,F)))?re=L(z[1].substr(1),N,!0):(z=c.exec(l(N,F)))?re=L(z[1],N,!1):re=j(N),n.set(H,re),s(re,W)}function s(W,F){if(typeof F=="string")return W;const N=function(H,re){return(0,C.isEqualOrParent)(H,F.base,!k.isLinux)?W((0,p.ltrim)(H.substr(F.base.length),A.sep),re):null};return N.allBasenames=W.allBasenames,N.allPaths=W.allPaths,N.basenames=W.basenames,N.patterns=W.patterns,N}function l(W,F){return F.trimForExclusions&&W.endsWith("/**")?W.substr(0,W.length-2):W}function o(W,F){return function(N,H){return typeof N=="string"&&N.endsWith(W)?F:null}}function S(W,F){const N=`/${W}`,H=`\\${W}`,re=function(T,R){return typeof T!="string"?null:R?R===W?F:null:T===W||T.endsWith(N)||T.endsWith(H)?F:null},z=[W];return re.basenames=z,re.patterns=[F],re.allBasenames=z,re}function D(W,F){const N=K(W.slice(1,-1).split(",").map(R=>a(R,F)).filter(R=>R!==i),W),H=N.length;if(!H)return i;if(H===1)return N[0];const re=function(R,O){for(let U=0,B=N.length;U<B;U++)if(N[U](R,O))return W;return null},z=N.find(R=>!!R.allBasenames);z&&(re.allBasenames=z.allBasenames);const T=N.reduce((R,O)=>O.allPaths?R.concat(O.allPaths):R,[]);return T.length&&(re.allPaths=T),re}function L(W,F,N){const H=A.sep===A.posix.sep,re=H?W:W.replace(E,A.sep),z=A.sep+re,T=A.posix.sep+W;let R;return N?R=function(O,U){return typeof O=="string"&&(O===re||O.endsWith(z)||!H&&(O===W||O.endsWith(T)))?F:null}:R=function(O,U){return typeof O=="string"&&(O===re||!H&&O===W)?F:null},R.allPaths=[(N?"*/":"./")+W],R}function j(W){try{const F=new RegExp(`^${d(W)}$`);return function(N){return F.lastIndex=0,typeof N=="string"&&F.test(N)?W:null}}catch{return i}}function X(W,F,N){return!W||typeof F!="string"?!1:ae(W)(F,void 0,N)}e.match=X;function ae(W,F={}){if(!W)return r;if(typeof W=="string"||Y(W)){const N=a(W,F);if(N===i)return r;const H=function(re,z){return!!N(re,z)};return N.allBasenames&&(H.allBasenames=N.allBasenames),N.allPaths&&(H.allPaths=N.allPaths),H}return ne(W,F)}e.parse=ae;function Y(W){const F=W;return F?typeof F.base=="string"&&typeof F.pattern=="string":!1}e.isRelativePattern=Y;function J(W){return W.allBasenames||[]}e.getBasenameTerms=J;function se(W){return W.allPaths||[]}e.getPathTerms=se;function ne(W,F){const N=K(Object.getOwnPropertyNames(W).map(R=>he(R,W[R],F)).filter(R=>R!==i)),H=N.length;if(!H)return i;if(!N.some(R=>!!R.requiresSiblings)){if(H===1)return N[0];const R=function(B,V){let ie;for(let $=0,Z=N.length;$<Z;$++){const x=N[$](B,V);if(typeof x=="string")return x;(0,t.isThenable)(x)&&(ie||(ie=[]),ie.push(x))}return ie?(async()=>{for(const $ of ie){const Z=await $;if(typeof Z=="string")return Z}return null})():null},O=N.find(B=>!!B.allBasenames);O&&(R.allBasenames=O.allBasenames);const U=N.reduce((B,V)=>V.allPaths?B.concat(V.allPaths):B,[]);return U.length&&(R.allPaths=U),R}const re=function(R,O,U){let B,V;for(let ie=0,$=N.length;ie<$;ie++){const Z=N[ie];Z.requiresSiblings&&U&&(O||(O=(0,A.basename)(R)),B||(B=O.substr(0,O.length-(0,A.extname)(R).length)));const x=Z(R,O,B,U);if(typeof x=="string")return x;(0,t.isThenable)(x)&&(V||(V=[]),V.push(x))}return V?(async()=>{for(const ie of V){const $=await ie;if(typeof $=="string")return $}return null})():null},z=N.find(R=>!!R.allBasenames);z&&(re.allBasenames=z.allBasenames);const T=N.reduce((R,O)=>O.allPaths?R.concat(O.allPaths):R,[]);return T.length&&(re.allPaths=T),re}function he(W,F,N){if(F===!1)return i;const H=a(W,N);if(H===i)return i;if(typeof F=="boolean")return H;if(F){const re=F.when;if(typeof re=="string"){const z=(T,R,O,U)=>{if(!U||!H(T,R))return null;const B=re.replace("$(basename)",O),V=U(B);return(0,t.isThenable)(V)?V.then(ie=>ie?W:null):V?W:null};return z.requiresSiblings=!0,z}}return H}function K(W,F){const N=W.filter(R=>!!R.basenames);if(N.length<2)return W;const H=N.reduce((R,O)=>{const U=O.basenames;return U?R.concat(U):R},[]);let re;if(F){re=[];for(let R=0,O=H.length;R<O;R++)re.push(F)}else re=N.reduce((R,O)=>{const U=O.patterns;return U?R.concat(U):R},[]);const z=function(R,O){if(typeof R!="string")return null;if(!O){let B;for(B=R.length;B>0;B--){const V=R.charCodeAt(B-1);if(V===47||V===92)break}O=R.substr(B)}const U=H.indexOf(O);return U!==-1?re[U]:null};z.basenames=H,z.patterns=re,z.allBasenames=H;const T=W.filter(R=>!R.basenames);return T.push(z),T}function le(W,F){return(0,I.equals)(W,F,(N,H)=>typeof N=="string"&&typeof H=="string"?N===H:typeof N!="string"&&typeof H!="string"?N.base===H.base&&N.pattern===H.pattern:!1)}e.patternsEquals=le}),define(ee[33],te([0,1,24,30,9,4,20,26]),function(q,e,I,t,C,M,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function p(i,a){const{os:s,tildify:l,relative:o}=a;if(o){const L=m(i,o,s);if(typeof L=="string")return L}let S=i.fsPath;if(s===1&&!M.isWindows?S=S.replace(/\//g,"\\"):s!==1&&M.isWindows&&(S=S.replace(/\\/g,"/")),s!==1&&l?.userHome){const L=l.userHome.fsPath;let j;i.scheme!==l.userHome.scheme&&i.path.startsWith(C.posix.sep)?j=l.userHome.with({path:i.path}).fsPath:j=i.fsPath,S=E(j,L,s)}return(s===1?C.win32:C.posix).normalize(y(S,s===1))}e.getPathLabel=p;function m(i,a,s){const l=s===1?C.win32:C.posix,o=s===3?A.extUri:A.extUriIgnorePathCase,S=a.getWorkspace(),D=(0,I.firstOrDefault)(S.folders);if(!D)return;i.scheme!==D.uri.scheme&&i.path.startsWith(C.posix.sep)&&(i=D.uri.with({path:i.path}));const L=a.getWorkspaceFolder(i);if(!L)return;let j;if(o.isEqual(L.uri,i)?j="":j=o.relativePath(L.uri,i)??"",j&&(j=l.normalize(j)),S.folders.length>1&&!a.noPrefix){const X=L.name?L.name:o.basenameOrAuthority(L.uri);j=j?`${X} \u2022 ${j}`:X}return j}function y(i,a=M.isWindows){return(0,t.hasDriveLetter)(i,a)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=y;let P=Object.create(null);function E(i,a,s=M.OS){if(s===1||!i||!a)return i;let l=P.original===a?P.normalized:void 0;l||(l=a,M.isWindows&&(l=(0,t.toSlashes)(l)),l=`${(0,k.rtrim)(l,C.posix.sep)}${C.posix.sep}`,P={original:a,normalized:l});let o=i;return M.isWindows&&(o=(0,t.toSlashes)(o)),(s===3?o.startsWith(l):(0,k.startsWithIgnoreCase)(o,l))?`~/${o.substr(l.length)}`:i}e.tildify=E;function h(i,a){return i.replace(/^~($|\/|\\)/,`${a}$1`)}e.untildify=h;const w="\u2026",d="\\\\",b="~";function u(i,a=C.sep){const s=new Array(i.length);let l=!1;for(let o=0;o<i.length;o++){const S=i[o];if(S===""){s[o]=`.${a}`;continue}if(!S){s[o]=S;continue}l=!0;let D="",L=S;L.indexOf(d)===0?(D=L.substr(0,L.indexOf(d)+d.length),L=L.substr(L.indexOf(d)+d.length)):L.indexOf(a)===0?(D=L.substr(0,L.indexOf(a)+a.length),L=L.substr(L.indexOf(a)+a.length)):L.indexOf(b)===0&&(D=L.substr(0,L.indexOf(b)+b.length),L=L.substr(L.indexOf(b)+b.length));const j=L.split(a);for(let X=1;l&&X<=j.length;X++)for(let ae=j.length-X;l&&ae>=0;ae--){l=!1;let Y=j.slice(ae,ae+X).join(a);for(let J=0;!l&&J<i.length;J++)if(J!==o&&i[J]&&i[J].indexOf(Y)>-1){const se=ae+X===j.length,ne=ae>0&&i[J].indexOf(a)>-1?a+Y:Y,he=i[J].endsWith(ne);l=!se||he}if(!l){let J="";(j[0].endsWith(":")||D!=="")&&(ae===1&&(ae=0,X++,Y=j[0]+a+Y),ae>0&&(J=j[0]+a),J=D+J),ae>0&&(J=J+w+a),J=J+Y,ae+X<j.length&&(J=J+a+w),s[o]=J}}l&&(s[o]=S)}return s}e.shorten=u;var v;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(v||(v={}));function g(i,a=Object.create(null)){const s=[];let l=!1,o="";for(const S of i)if(S==="$"||l&&S==="{")o&&s.push({value:o,type:v.TEXT}),o="",l=!0;else if(S==="}"&&l){const D=a[o];if(typeof D=="string")D.length&&s.push({value:D,type:v.VARIABLE});else if(D){const L=s[s.length-1];(!L||L.type!==v.SEPARATOR)&&s.push({value:D.label,type:v.SEPARATOR})}o="",l=!1}else o+=S;return o&&!l&&s.push({value:o,type:v.TEXT}),s.filter((S,D)=>{if(S.type===v.SEPARATOR){const L=s[D-1],j=s[D+1];return[L,j].every(X=>X&&(X.type===v.VARIABLE||X.type===v.TEXT)&&X.value.length>0)}return!0}).map(S=>S.value).join("")}e.template=g;function f(i,a){return M.isMacintosh||a?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):i.replace(/&&|&/g,s=>s==="&"?"&&":"&")}e.mnemonicMenuLabel=f;function c(i,a){return M.isMacintosh||a?i.replace(/\(&&\w\)|&&/g,""):M.isWindows?i.replace(/&&|&/g,s=>s==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=c;function n(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=n;function r(i){const a=i.indexOf("/")!==-1?C.posix:C.win32,s=a.basename(i),l=a.dirname(i);return s.length?{name:s,parentPath:l}:{name:l,parentPath:""}}e.splitName=r}),define(ee[139],te([0,1,7]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(y){return y.toJSON()}class C{constructor(P){this.a=P}transformIncoming(P){const E=this.a.transformIncoming(P);return E===P?P:t(I.URI.from(E))}transformOutgoing(P){const E=this.a.transformOutgoing(P);return E===P?P:t(I.URI.from(E))}transformOutgoingURI(P){const E=this.a.transformOutgoing(P);return E===P?P:I.URI.from(E)}transformOutgoingScheme(P){return this.a.transformOutgoingScheme(P)}}e.URITransformer=C,e.DefaultURITransformer=new class{transformIncoming(y){return y}transformOutgoing(y){return y}transformOutgoingURI(y){return y}transformOutgoingScheme(y){return y}};function M(y,P,E){if(!y||E>200)return null;if(typeof y=="object"){if(y instanceof I.URI)return P.transformOutgoing(y);for(const h in y)if(Object.hasOwnProperty.call(y,h)){const w=M(y[h],P,E+1);w!==null&&(y[h]=w)}}return null}function A(y,P){const E=M(y,P,0);return E===null?y:E}e.transformOutgoingURIs=A;function k(y,P,E,h){if(!y||h>200)return null;if(typeof y=="object"){if(y.$mid===1)return E?I.URI.revive(P.transformIncoming(y)):P.transformIncoming(y);for(const w in y)if(Object.hasOwnProperty.call(y,w)){const d=k(y[w],P,E,h+1);d!==null&&(y[w]=d)}}return null}function p(y,P){const E=k(y,P,!1,0);return E===null?y:E}e.transformIncomingURIs=p;function m(y,P){const E=k(y,P,!0,0);return E===null?y:E}e.transformAndReviveIncomingURIs=m}),define(ee[81],te([0,1,25,14,60,29,127]),function(q,e,I,t,C,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(y){return this.a||(this.a=C.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(y)}value(){if(this.b===void 0){let y=0,P=0;const E=(0,I.networkInterfaces)();for(const h in E){const w=E[h];if(w)for(const{mac:d,internal:b}of w)b||(P+=1,this.c(d.toUpperCase())&&(y+=1))}this.b=P>0?y/P:0}return this.b}};let k;async function p(){return k||(k=(async()=>await m()||M.generateUuid())()),k}e.getMachineId=p;async function m(){try{const y=await new Promise((E,h)=>{q(["crypto"],E,h)}),P=(0,A.getMac)();return y.createHash("sha256").update(P,"utf8").digest("hex")}catch(y){t.onUnexpectedError(y);return}}}),define(ee[23],te([0,1,40,25,140,8,30,76,9,4,20,7]),function(q,e,I,t,C,M,A,k,p,m,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var E;(function(ne){ne[ne.UNLINK=0]="UNLINK",ne[ne.MOVE=1]="MOVE"})(E=e.RimRafMode||(e.RimRafMode={}));async function h(ne,he=E.UNLINK){if((0,A.isRootOrDriveLetter)(ne))throw new Error("rimraf - will refuse to recursively delete root");return he===E.UNLINK?d(ne):w(ne)}async function w(ne){try{const he=(0,A.randomPath)((0,t.tmpdir)());try{await I.promises.rename(ne,he)}catch(K){return K.code==="ENOENT"?void 0:d(ne)}d(he).catch(K=>{})}catch(he){if(he.code!=="ENOENT")throw he}}async function d(ne){return(0,C.promisify)(I.rm)(ne,{recursive:!0,force:!0,maxRetries:3})}function b(ne){if((0,A.isRootOrDriveLetter)(ne))throw new Error("rimraf - will refuse to recursively delete root");I.rmSync(ne,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=b;async function u(ne,he){return f(await(he?v(ne):(0,C.promisify)(I.readdir)(ne)))}async function v(ne){try{return await(0,C.promisify)(I.readdir)(ne,{withFileTypes:!0})}catch(le){console.warn("[node.js fs] readdir with filetypes failed with error: ",le)}const he=[],K=await u(ne);for(const le of K){let W=!1,F=!1,N=!1;try{const H=await e.Promises.lstat((0,p.join)(ne,le));W=H.isFile(),F=H.isDirectory(),N=H.isSymbolicLink()}catch(H){console.warn("[node.js fs] unexpected error from lstat after readdir: ",H)}he.push({name:le,isFile:()=>W,isDirectory:()=>F,isSymbolicLink:()=>N})}return he}function g(ne){return f(I.readdirSync(ne))}e.readdirSync=g;function f(ne){return ne.map(he=>typeof he=="string"?m.isMacintosh?(0,k.normalizeNFC)(he):he:(he.name=m.isMacintosh?(0,k.normalizeNFC)(he.name):he.name,he))}async function c(ne){const he=await u(ne),K=[];for(const le of he)await r.existsDirectory((0,p.join)(ne,le))&&K.push(le);return K}function n(ne,he=1e3){return new Promise(K=>{let le=!1;const W=setInterval(()=>{le||(le=!0,I.access(ne,F=>{le=!1,F&&(clearInterval(W),K(void 0))}))},he)})}e.whenDeleted=n;var r;(function(ne){async function he(W){let F;try{if(F=await e.Promises.lstat(W),!F.isSymbolicLink())return{stat:F}}catch{}try{return{stat:await e.Promises.stat(W),symbolicLink:F?.isSymbolicLink()?{dangling:!1}:void 0}}catch(N){if(N.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};if(m.isWindows&&N.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(W)),symbolicLink:{dangling:!1}}}catch(H){if(H.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};throw H}throw N}}ne.stat=he;async function K(W){try{const{stat:F,symbolicLink:N}=await ne.stat(W);return F.isFile()&&N?.dangling!==!0}catch{}return!1}ne.existsFile=K;async function le(W){try{const{stat:F,symbolicLink:N}=await ne.stat(W);return F.isDirectory()&&N?.dangling!==!0}catch{}return!1}ne.existsDirectory=le})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new M.ResourceQueue;function a(ne,he,K){return i.queueFor(P.URI.file(ne),y.extUriBiasedIgnorePathCase).queue(()=>{const le=D(K);return new Promise((W,F)=>o(ne,he,le,N=>N?F(N):W()))})}let s=!0;function l(ne){s=ne}e.configureFlushOnWrite=l;function o(ne,he,K,le){if(!s)return I.writeFile(ne,he,{mode:K.mode,flag:K.flag},le);I.open(ne,K.flag,K.mode,(W,F)=>{if(W)return le(W);I.writeFile(F,he,N=>{if(N)return I.close(F,()=>le(N));I.fdatasync(F,H=>(H&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",H),l(!1)),I.close(F,re=>le(re))))})})}function S(ne,he,K){const le=D(K);if(!s)return I.writeFileSync(ne,he,{mode:le.mode,flag:le.flag});const W=I.openSync(ne,le.flag,le.mode);try{I.writeFileSync(W,he);try{I.fdatasyncSync(W)}catch(F){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",F),l(!1)}}finally{I.closeSync(W)}}e.writeFileSync=S;function D(ne){return ne?{mode:typeof ne.mode=="number"?ne.mode:438,flag:typeof ne.flag=="string"?ne.flag:"w"}:{mode:438,flag:"w"}}async function L(ne,he){if(ne!==he)try{await e.Promises.rename(ne,he)}catch(K){if(ne.toLowerCase()!==he.toLowerCase()&&K.code==="EXDEV"||ne.endsWith("."))await j(ne,he,{preserveSymlinks:!1}),await h(ne,E.MOVE);else throw K}}async function j(ne,he,K){return ae(ne,he,{root:{source:ne,target:he},options:K,handledSourcePaths:new Set})}const X=511;async function ae(ne,he,K){if(K.handledSourcePaths.has(ne))return;K.handledSourcePaths.add(ne);const{stat:le,symbolicLink:W}=await r.stat(ne);if(W){if(K.options.preserveSymlinks)try{return await se(ne,he,K)}catch(F){console.warn("[node.js fs] copy of symlink failed: ",F)}if(W.dangling)return}return le.isDirectory()?Y(ne,he,le.mode&X,K):J(ne,he,le.mode&X)}async function Y(ne,he,K,le){await e.Promises.mkdir(he,{recursive:!0,mode:K});const W=await u(ne);for(const F of W)await ae((0,p.join)(ne,F),(0,p.join)(he,F),le)}async function J(ne,he,K){await e.Promises.copyFile(ne,he),await e.Promises.chmod(he,K)}async function se(ne,he,K){let le=await e.Promises.readlink(ne);(0,A.isEqualOrParent)(le,K.root.source,!m.isLinux)&&(le=(0,p.join)(K.root.target,le.substr(K.root.source.length+1))),await e.Promises.symlink(le,he)}e.Promises=new class{get access(){return(0,C.promisify)(I.access)}get stat(){return(0,C.promisify)(I.stat)}get lstat(){return(0,C.promisify)(I.lstat)}get utimes(){return(0,C.promisify)(I.utimes)}get read(){return(ne,he,K,le,W)=>new Promise((F,N)=>{I.read(ne,he,K,le,W,(H,re,z)=>H?N(H):F({bytesRead:re,buffer:z}))})}get readFile(){return(0,C.promisify)(I.readFile)}get write(){return(ne,he,K,le,W)=>new Promise((F,N)=>{I.write(ne,he,K,le,W,(H,re,z)=>H?N(H):F({bytesWritten:re,buffer:z}))})}get appendFile(){return(0,C.promisify)(I.appendFile)}get fdatasync(){return(0,C.promisify)(I.fdatasync)}get truncate(){return(0,C.promisify)(I.truncate)}get rename(){return(0,C.promisify)(I.rename)}get copyFile(){return(0,C.promisify)(I.copyFile)}get open(){return(0,C.promisify)(I.open)}get close(){return(0,C.promisify)(I.close)}get symlink(){return(0,C.promisify)(I.symlink)}get readlink(){return(0,C.promisify)(I.readlink)}get chmod(){return(0,C.promisify)(I.chmod)}get mkdir(){return(0,C.promisify)(I.mkdir)}get unlink(){return(0,C.promisify)(I.unlink)}get rmdir(){return(0,C.promisify)(I.rmdir)}get realpath(){return(0,C.promisify)(I.realpath)}async exists(ne){try{return await e.Promises.access(ne),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return c}get writeFile(){return a}get rm(){return h}get move(){return L}get copy(){return j}}}),define(ee[100],te([0,1,40,9,4,26,23]),function(q,e,I,t,C,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function k(E){if(C.isLinux)return E;const h=(0,t.dirname)(E);if(E===h)return E;const w=((0,t.basename)(E)||E).toLowerCase();try{const b=(0,A.readdirSync)(h).filter(u=>u.toLowerCase()===w);if(b.length===1){const u=k(h);if(u)return(0,t.join)(u,b[0])}else if(b.length>1){const u=b.indexOf(w);if(u>=0){const v=k(h);if(v)return(0,t.join)(v,b[u])}}}catch{}return null}e.realcaseSync=k;async function p(E){if(C.isLinux)return E;const h=(0,t.dirname)(E);if(E===h)return E;const w=((0,t.basename)(E)||E).toLowerCase();try{const b=(await A.Promises.readdir(h)).filter(u=>u.toLowerCase()===w);if(b.length===1){const u=await p(h);if(u)return(0,t.join)(u,b[0])}else if(b.length>1){const u=b.indexOf(w);if(u>=0){const v=await p(h);if(v)return(0,t.join)(v,b[u])}}}catch{}return null}e.realcase=p;async function m(E){try{return await A.Promises.realpath(E)}catch{const w=P(E);return await A.Promises.access(w,I.constants.R_OK),w}}e.realpath=m;function y(E){try{return I.realpathSync(E)}catch{const w=P(E);return I.accessSync(w,I.constants.R_OK),w}}e.realpathSync=y;function P(E){return(0,M.rtrim)((0,t.normalize)(E),t.sep)}}),define(ee[141],te([0,1,25,9,23]),function(q,e,I,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const M=/^\d+$/,A=/^Microsoft.PowerShell_.*/,k=/^Microsoft.PowerShellPreview_.*/;var p;(function(f){f[f.x64=0]="x64",f[f.x86=1]="x86",f[f.ARM=2]="ARM"})(p||(p={}));let m;switch(process.arch){case"ia32":case"x32":m=1;break;case"arm":case"arm64":m=2;break;default:m=0;break}let y;process.env.PROCESSOR_ARCHITEW6432?y=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?y=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?y=1:y=0;class P{constructor(c,n,r){this.exePath=c,this.displayName=n,this.a=r}async exists(){return this.a===void 0&&(this.a=await C.SymlinkSupport.existsFile(this.exePath)),this.a}}function E({useAlternateBitness:f=!1}={}){return f?m===0?process.env["ProgramFiles(x86)"]||null:y===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function h({useAlternateBitness:f=!1,findPreview:c=!1}={}){const n=E({useAlternateBitness:f});if(!n)return null;const r=t.join(n,"PowerShell");if(!await C.SymlinkSupport.existsDirectory(r))return null;let i=-1,a=null;for(const o of await C.Promises.readdir(r)){let S=-1;if(c){const L=o.indexOf("-");if(L<0)continue;const j=o.substring(0,L);if(!M.test(j)||o.substring(L+1)!=="preview")continue;S=parseInt(j,10)}else{if(!M.test(o))continue;S=parseInt(o,10)}if(S<=i)continue;const D=t.join(r,o,"pwsh.exe");!await C.SymlinkSupport.existsFile(D)||(a=D,i=S)}if(!a)return null;const s=n.includes("x86")?" (x86)":"",l=c?" Preview":"";return new P(a,`PowerShell${l}${s}`,!0)}async function w({findPreview:f}={}){if(!process.env.LOCALAPPDATA)return null;const c=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await C.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:n,pwshMsixName:r}=f?{pwshMsixDirRegex:k,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const i of await C.Promises.readdir(c))if(n.test(i)){const a=t.join(c,i,"pwsh.exe");return new P(a,r)}return null}function d(){const f=t.join(I.homedir(),".dotnet","tools","pwsh.exe");return new P(f,".NET Core PowerShell Global Tool")}function b(){const f=t.join(process.env.windir,m===1&&y!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new P(f,"Windows PowerShell",!0)}async function*u(){let f=await h();f&&(yield f),f=await h({useAlternateBitness:!0}),f&&(yield f),f=await w(),f&&(yield f),f=d(),f&&(yield f),f=await h({findPreview:!0}),f&&(yield f),f=await w({findPreview:!0}),f&&(yield f),f=await h({useAlternateBitness:!0,findPreview:!0}),f&&(yield f),f=b(),f&&(yield f)}async function*v(){for await(const f of u())await f.exists()&&(yield f)}e.enumeratePowerShellInstallations=v;async function g(){for await(const f of v())return f;return null}e.getFirstAvailablePowerShellInstallation=g}),define(ee[82],te([0,1,9,4,32,79,12,23]),function(q,e,I,t,C,M,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return M.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return M.TerminateResponseCode}});function p(P=C.env){return P.comspec||"cmd.exe"}e.getWindowsShell=p;function m(P){let E=[],h=!1;const w=function(d){if(h){E.push(d);return}(!P.send(d,u=>{if(u&&console.error(u),h=!1,E.length>0){const v=E.slice(0);E=[],v.forEach(g=>w(g))}})||t.isWindows)&&(h=!0)};return{send:w}}e.createQueuedSender=m;var y;(function(P){async function E(h,w,d){if(I.isAbsolute(h))return h;if(w===void 0&&(w=C.cwd()),I.dirname(h)!=="."||(d===void 0&&A.isString(C.env.PATH)&&(d=C.env.PATH.split(I.delimiter)),d===void 0||d.length===0))return I.join(w,h);async function u(v){if(await k.Promises.exists(v)){let g;try{g=await k.Promises.stat(v)}catch(f){f.message.startsWith("EACCES")&&(g=await k.Promises.lstat(v))}return g?!g.isDirectory():!1}return!1}for(const v of d){let g;if(I.isAbsolute(v)?g=I.join(v,h):g=I.join(w,v,h),await u(g))return g;let f=g+".com";if(await u(f)||(f=g+".exe",await u(f)))return f}return I.join(w,h)}P.findExecutable=E})(y=e.win32||(e.win32={}))}),define(ee[101],te([0,1,46,15]),function(q,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function C(A){return new Promise((k,p)=>{let m;const y=new Map;function P(h,w,d,b,u){const v=y.get(w);if(h===A||v){const g={name:E(d),cmd:d,pid:h,ppid:w,load:b,mem:u};y.set(h,g),h===A&&(m=g),v&&(v.children||(v.children=[]),v.children.push(g),v.children.length>1&&(v.children=v.children.sort((f,c)=>f.pid-c.pid)))}}function E(h){const w=/--vscode-window-kind=shared-process/,d=/--vscode-window-kind=issue-reporter/,b=/--vscode-window-kind=process-explorer/,u=/--utility-sub-type=network/,v=/--utility-sub-type=node.mojom.NodeService/,g=/--crashes-directory/,f=/\\pipe\\winpty-control/,c=/conhost\.exe/,n=/--type=([a-zA-Z-]+)/;if(g.exec(h))return"electron-crash-reporter";if(f.exec(h))return"winpty-process";if(c.exec(h))return"console-window-host (Windows internal process)";let r=n.exec(h);if(r&&r.length===2){if(r[1]==="renderer")return w.exec(h)?"shared-process":d.exec(h)?"issue-reporter":b.exec(h)?"process-explorer":"window";if(r[1]==="utility"){if(u.exec(h))return"utility-network-service";if(v.exec(h))return"extension-host"}return r[1]}const i=/[a-zA-Z-]+\.js/g;let a="";do r=i.exec(h),r&&(a+=r+" ");while(r);return a&&h.indexOf("node ")<0&&h.indexOf("node.exe")<0?`electron_node ${a}`:h}if(process.platform==="win32"){const h=w=>w.indexOf("\\\\?\\")===0||w.indexOf("\\??\\")===0?w.substr(4):w.indexOf('"\\\\?\\')===0||w.indexOf('"\\??\\')===0?'"'+w.substr(5):w;new Promise((w,d)=>{q(["windows-process-tree"],w,d)}).then(w=>{w.getProcessList(A,d=>{if(!d){p(new Error(`Root process ${A} not found`));return}w.getProcessCpuUsage(d,b=>{const u=new Map;b.forEach(v=>{const g=h(v.commandLine||"");u.set(v.pid,{name:E(g),cmd:g,pid:v.pid,ppid:v.ppid,load:v.cpu||0,mem:v.memory||0})}),m=u.get(A),m?(u.forEach(v=>{const g=u.get(v.ppid);g&&(g.children||(g.children=[]),g.children.push(v))}),u.forEach(v=>{v.children&&(v.children=v.children.sort((g,f)=>g.pid-f.pid))}),k(m)):p(new Error(`Root process ${A} not found`))})},w.ProcessDataFlag.CommandLine|w.ProcessDataFlag.Memory)})}else{let h=function(){let w=[m];const d=[];for(;w.length;){const u=w.shift();u&&(d.push(u.pid),u.children&&(w=w.concat(u.children)))}let b=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);b+=" "+d.join(" "),(0,I.exec)(b,{},(u,v,g)=>{if(u||g)p(u||new Error(g.toString()));else{const f=v.toString().split(`
`);for(let c=0;c<d.length;c++){const n=y.get(d[c]);n.load=parseFloat(f[c])}if(!m){p(new Error(`Root process ${A} not found`));return}k(m)}})};(0,I.exec)("which ps",{},(w,d,b)=>{if(w||b)if(process.platform!=="linux")p(w||new Error(b.toString()));else{const u=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,I.exec)(u,{},(v,g,f)=>{v||f?p(v||new Error(f.toString())):(M(g,P),h())})}else{const u=d.toString().trim(),v="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,I.exec)(`${u} ${v}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(g,f,c)=>{g||c&&!c.includes("screen size is bogus")?p(g||new Error(c.toString())):(M(f,P),process.platform==="linux"?h():m?k(m):p(new Error(`Root process ${A} not found`)))})}})}})}e.listProcesses=C;function M(A,k){const p=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,m=A.toString().split(`
`);for(const y of m){const P=p.exec(y.trim());P&&P.length===6&&k(parseInt(P[1]),parseInt(P[2]),P[5],parseFloat(P[3]),parseFloat(P[4]))}}}),define(ee[142],te([0,1,25,4,141,82]),function(q,e,I,t,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function A(h,w){return h===1?t.isWindows?P():M.getWindowsShell(w):m(h,w)}e.getSystemShell=A;function k(h,w){return h===1?t.isWindows?E(w):M.getWindowsShell(w):m(h,w)}e.getSystemShellSync=k;let p=null;function m(h,w){if(t.isLinux&&h===2||t.isMacintosh&&h===3)return"/bin/bash";if(!p){let d;if(t.isWindows)d="/bin/bash";else{if(d=w.SHELL,!d)try{d=(0,I.userInfo)().shell}catch{}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}p=d}return p}let y=null;async function P(){return y||(y=(await(0,C.getFirstAvailablePowerShellInstallation)()).exePath),y}function E(h){if(y)return y;const w=t.isWindows&&parseFloat((0,I.release)())>=10,d=h.hasOwnProperty("PROCESSOR_ARCHITEW6432"),b=`${h.windir}\\${d?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return w?b:M.getWindowsShell(h)}});var pe=this&&this.__decorate||function(q,e,I,t){var C=arguments.length,M=C<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,I):t,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(q,e,I,t);else for(var k=q.length-1;k>=0;k--)(A=q[k])&&(M=(C<3?A(M):C>3?A(e,I,M):A(e,I))||M);return C>3&&M&&Object.defineProperty(e,I,M),M};define(ee[47],te([0,1,24,8,17,22,53,14,3,2,69,26,12]),function(q,e,I,t,C,M,A,k,p,m,y,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=void 0;var h;(function(W){W[W.Promise=100]="Promise",W[W.PromiseCancel=101]="PromiseCancel",W[W.EventListen=102]="EventListen",W[W.EventDispose=103]="EventDispose"})(h||(h={}));function w(W){switch(W){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var d;(function(W){W[W.Initialize=200]="Initialize",W[W.PromiseSuccess=201]="PromiseSuccess",W[W.PromiseError=202]="PromiseError",W[W.PromiseErrorObj=203]="PromiseErrorObj",W[W.EventFire=204]="EventFire"})(d||(d={}));function b(W){switch(W){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(W){W[W.Uninitialized=0]="Uninitialized",W[W.Idle=1]="Idle"})(u||(u={}));class v{constructor(F){this.b=F,this.a=0}read(F){const N=this.b.slice(this.a,this.a+F);return this.a+=N.byteLength,N}}class g{constructor(){this.a=[]}get buffer(){return C.VSBuffer.concat(this.a)}write(F){this.a.push(F)}}var f;(function(W){W[W.Undefined=0]="Undefined",W[W.String=1]="String",W[W.Buffer=2]="Buffer",W[W.VSBuffer=3]="VSBuffer",W[W.Array=4]="Array",W[W.Object=5]="Object"})(f||(f={}));function c(W){const F=C.VSBuffer.alloc(4);return F.writeUInt32BE(W,0),F}function n(W){return W.read(4).readUInt32BE(0)}function r(W){const F=C.VSBuffer.alloc(1);return F.writeUInt8(W,0),F}const i={Undefined:r(f.Undefined),String:r(f.String),Buffer:r(f.Buffer),VSBuffer:r(f.VSBuffer),Array:r(f.Array),Object:r(f.Object)},a=typeof Buffer<"u";function s(W,F){if(typeof F>"u")W.write(i.Undefined);else if(typeof F=="string"){const N=C.VSBuffer.fromString(F);W.write(i.String),W.write(c(N.byteLength)),W.write(N)}else if(a&&Buffer.isBuffer(F)){const N=C.VSBuffer.wrap(F);W.write(i.Buffer),W.write(c(N.byteLength)),W.write(N)}else if(F instanceof C.VSBuffer)W.write(i.VSBuffer),W.write(c(F.byteLength)),W.write(F);else if(Array.isArray(F)){W.write(i.Array),W.write(c(F.length));for(const N of F)s(W,N)}else{const N=C.VSBuffer.fromString(JSON.stringify(F));W.write(i.Object),W.write(c(N.byteLength)),W.write(N)}}function l(W){switch(W.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return W.read(n(W)).toString();case f.Buffer:return W.read(n(W)).buffer;case f.VSBuffer:return W.read(n(W));case f.Array:{const N=n(W),H=[];for(let re=0;re<N;re++)H.push(l(W));return H}case f.Object:return JSON.parse(W.read(n(W)).toString())}}class o{constructor(F,N,H=null,re=1e3){this.h=F,this.j=N,this.k=H,this.l=re,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(z=>this.p(z)),this.m({type:200})}registerChannel(F,N){this.b.set(F,N),setTimeout(()=>this.v(F),0)}m(F){switch(F.type){case 200:{const N=this.n([F.type]);this.k?.logOutgoing(N,0,1,b(F.type));return}case 201:case 202:case 204:case 203:{const N=this.n([F.type,F.id],F.data);this.k?.logOutgoing(N,F.id,1,b(F.type),F.data);return}}}n(F,N=void 0){const H=new g;return s(H,F),s(H,N),this.o(H.buffer)}o(F){try{return this.h.send(F),F.byteLength}catch{return 0}}p(F){const N=new v(F),H=l(N),re=l(N),z=H[0];switch(z){case 100:return this.k?.logIncoming(F.byteLength,H[1],1,`${w(z)}: ${H[2]}.${H[3]}`,re),this.q({type:z,id:H[1],channelName:H[2],name:H[3],arg:re});case 102:return this.k?.logIncoming(F.byteLength,H[1],1,`${w(z)}: ${H[2]}.${H[3]}`,re),this.s({type:z,id:H[1],channelName:H[2],name:H[3],arg:re});case 101:return this.k?.logIncoming(F.byteLength,H[1],1,`${w(z)}`),this.t({type:z,id:H[1]});case 103:return this.k?.logIncoming(F.byteLength,H[1],1,`${w(z)}`),this.t({type:z,id:H[1]})}}q(F){const N=this.b.get(F.channelName);if(!N){this.u(F);return}const H=new M.CancellationTokenSource;let re;try{re=N.call(this.j,F.name,F.arg,H.token)}catch(R){re=Promise.reject(R)}const z=F.id;re.then(R=>{this.m({id:z,data:R,type:201}),this.d.delete(F.id)},R=>{R instanceof Error?this.m({id:z,data:{message:R.message,name:R.name,stack:R.stack?R.stack.split?R.stack.split(`
`):R.stack:void 0},type:202}):this.m({id:z,data:R,type:203}),this.d.delete(F.id)});const T=(0,m.toDisposable)(()=>H.cancel());this.d.set(F.id,T)}s(F){const N=this.b.get(F.channelName);if(!N){this.u(F);return}const H=F.id,z=N.listen(this.j,F.name,F.arg)(T=>this.m({id:H,data:T,type:204}));this.d.set(F.id,z)}t(F){const N=this.d.get(F.id);N&&(N.dispose(),this.d.delete(F.id))}u(F){let N=this.g.get(F.channelName);N||(N=[],this.g.set(F.channelName,N));const H=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.m({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);N.push({request:F,timeoutTimer:H})}v(F){const N=this.g.get(F);if(N){for(const H of N)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.q(H.request);break;case 102:this.s(H.request);break}this.g.delete(F)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,m.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=o;var S;(function(W){W[W.LocalSide=0]="LocalSide",W[W.OtherSide=1]="OtherSide"})(S=e.RequestInitiator||(e.RequestInitiator={}));class D{constructor(F,N=null){this.l=F,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new p.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(H=>this.r(H)),this.j=N}getChannel(F){const N=this;return{call(H,re,z){return N.a?Promise.reject(new k.CancellationError):N.m(F,H,re,z)},listen(H,re){return N.a?p.Event.None:N.n(F,H,re)}}}m(F,N,H,re=M.CancellationToken.None){const z=this.g++,R={id:z,type:100,channelName:F,name:N,arg:H};if(re.isCancellationRequested)return Promise.reject(new k.CancellationError);let O;return new Promise((B,V)=>{if(re.isCancellationRequested)return V(new k.CancellationError);const ie=()=>{const oe=ge=>{switch(ge.type){case 201:this.f.delete(z),B(ge.data);break;case 202:{this.f.delete(z);const De=new Error(ge.data.message);De.stack=Array.isArray(ge.data.stack)?ge.data.stack.join(`
`):ge.data.stack,De.name=ge.data.name,V(De);break}case 203:this.f.delete(z),V(ge.data);break}};this.f.set(z,oe),this.o(R)};let $=null;this.b===u.Idle?ie():($=(0,t.createCancelablePromise)(oe=>this.t()),$.then(()=>{$=null,ie()}));const Z=()=>{$?($.cancel(),$=null):this.o({id:z,type:101}),V(new k.CancellationError)},x=re.onCancellationRequested(Z);O=(0,m.combinedDisposable)((0,m.toDisposable)(Z),x),this.d.add(O)}).finally(()=>{this.d.delete(O)})}n(F,N,H){const re=this.g++,T={id:re,type:102,channelName:F,name:N,arg:H};let R=null;const O=new p.Emitter({onWillAddFirstListener:()=>{R=(0,t.createCancelablePromise)(B=>this.t()),R.then(()=>{R=null,this.d.add(O),this.o(T)})},onDidRemoveLastListener:()=>{R?(R.cancel(),R=null):(this.d.delete(O),this.o({id:re,type:103}))}}),U=B=>O.fire(B.data);return this.f.set(re,U),O.event}o(F){switch(F.type){case 100:case 102:{const N=this.p([F.type,F.id,F.channelName,F.name],F.arg);this.j?.logOutgoing(N,F.id,0,`${w(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const N=this.p([F.type,F.id]);this.j?.logOutgoing(N,F.id,0,w(F.type));return}}}p(F,N=void 0){const H=new g;return s(H,F),s(H,N),this.q(H.buffer)}q(F){try{return this.l.send(F),F.byteLength}catch{return 0}}r(F){const N=new v(F),H=l(N),re=l(N),z=H[0];switch(z){case 200:return this.j?.logIncoming(F.byteLength,0,0,b(z)),this.s({type:H[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(F.byteLength,H[1],0,b(z),re),this.s({type:H[0],id:H[1],data:re})}}s(F){if(F.type===200){this.b=u.Idle,this.k.fire();return}this.f.get(F.id)?.(F)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}t(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,m.dispose)(this.d.values()),this.d.clear()}}pe([A.memoize],D.prototype,"onDidInitializePromise",null),e.ChannelClient=D;class L{get connections(){const F=[];return this.f.forEach(N=>F.push(N)),F}constructor(F){this.a=new Map,this.f=new Set,this.g=new p.Emitter,this.onDidAddConnection=this.g.event,this.h=new p.Emitter,this.onDidRemoveConnection=this.h.event,F(({protocol:N,onDidClientDisconnect:H})=>{p.Event.once(N.onMessage)(z=>{const T=new v(z),R=l(T),O=new o(N,R),U=new D(N);this.a.forEach((V,ie)=>O.registerChannel(ie,V));const B={channelServer:O,channelClient:U,ctx:R};this.f.add(B),this.g.fire(B),H(()=>{O.dispose(),U.dispose(),this.f.delete(B),this.h.fire(B)})})})}getChannel(F,N){const H=this;return{call(re,z,T){let R;if((0,E.isFunction)(N)){const U=(0,I.getRandomElement)(H.connections.filter(N));R=U?Promise.resolve(U):p.Event.toPromise(p.Event.filter(H.onDidAddConnection,N))}else R=N.routeCall(H,re,z);const O=R.then(U=>U.channelClient.getChannel(F));return X(O).call(re,z,T)},listen(re,z){if((0,E.isFunction)(N))return H.j(F,N,re,z);const T=N.routeEvent(H,re,z).then(R=>R.channelClient.getChannel(F));return X(T).listen(re,z)}}}j(F,N,H,re){const z=this;let T=new m.DisposableStore;const R=new p.Emitter({onWillAddFirstListener:()=>{T=new m.DisposableStore;const O=new p.EventMultiplexer,U=new Map,B=ie=>{const Z=ie.channelClient.getChannel(F).listen(H,re),x=O.add(Z);U.set(ie,x)},V=ie=>{const $=U.get(ie);!$||($.dispose(),U.delete(ie))};z.connections.filter(N).forEach(B),p.Event.filter(z.onDidAddConnection,N)(B,void 0,T),z.onDidRemoveConnection(V,void 0,T),O.event(R.fire,R,T),T.add(O)},onDidRemoveLastListener:()=>{T.dispose()}});return R.event}registerChannel(F,N){this.a.set(F,N),this.f.forEach(H=>{H.channelServer.registerChannel(F,N)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=L;class j{constructor(F,N,H=null){const re=new g;s(re,N),F.send(re.buffer),this.a=new D(F,H),this.d=new o(F,N,H)}getChannel(F){return this.a.getChannel(F)}registerChannel(F,N){this.d.registerChannel(F,N)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=j;function X(W){return{call(F,N,H){return W.then(re=>re.call(F,N,H))},listen(F,N){const H=new p.Relay;return W.then(re=>H.input=re.listen(F,N)),H.event}}}e.getDelayedChannel=X;function ae(W){let F=!1;return{call(N,H,re){return F?W.call(N,H,re):(0,t.timeout)(0).then(()=>F=!0).then(()=>W.call(N,H,re))},listen(N,H){if(F)return W.listen(N,H);const re=new p.Relay;return(0,t.timeout)(0).then(()=>F=!0).then(()=>re.input=W.listen(N,H)),re.event}}}e.getNextTickChannel=ae;class Y{constructor(F){this.a=F}routeCall(F){return this.b(F)}routeEvent(F){return this.b(F)}async b(F){for(const N of F.connections)if(await Promise.resolve(this.a(N.ctx)))return Promise.resolve(N);return await p.Event.toPromise(F.onDidAddConnection),await this.b(F)}}e.StaticRouter=Y;var J;(function(W){function F(z,T){const R=z,O=T&&T.disableMarshalling,U=new Map;for(const B in R)H(B)&&U.set(B,p.Event.buffer(R[B],!0));return new class{listen(B,V,ie){const $=U.get(V);if($)return $;if(re(V)){const Z=R[V];if(typeof Z=="function")return Z.call(R,ie)}throw new Error(`Event not found: ${V}`)}call(B,V,ie){const $=R[V];if(typeof $=="function"){if(!O&&Array.isArray(ie))for(let Z=0;Z<ie.length;Z++)ie[Z]=(0,y.revive)(ie[Z]);return $.apply(R,ie)}throw new Error(`Method not found: ${V}`)}}}W.fromService=F;function N(z,T){const R=T&&T.disableMarshalling;return new Proxy({},{get(O,U){if(typeof U=="string")return T?.properties?.has(U)?T.properties.get(U):re(U)?function(B){return z.listen(U,B)}:H(U)?z.listen(U):async function(...B){let V;T&&!(0,E.isUndefinedOrNull)(T.context)?V=[T.context,...B]:V=B;const ie=await z.call(U,V);return R?ie:(0,y.revive)(ie)};throw new Error(`Property not found: ${String(U)}`)}})}W.toService=N;function H(z){return z[0]==="o"&&z[1]==="n"&&P.isUpperAsciiLetter(z.charCodeAt(2))}function re(z){return/^onDynamic/.test(z)&&P.isUpperAsciiLetter(z.charCodeAt(9))}})(J=e.ProxyChannel||(e.ProxyChannel={}));const se=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ne(W){if(Array.isArray(W))return W;if(W&&typeof W=="object"&&typeof W.toString=="function"){const F=W.toString();if(F!=="[object Object]")return F}return W}function he(W){return Array.isArray(W)?W.map(ne):ne(W)}function K(W,F,N,H,re,z,T){T=he(T);const R=se[re],O=R[H%R.length];let U=[`%c[${W}]%c[${String(F).padStart(7," ")}]%c[len: ${String(N).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${z}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(z)?(U=U.concat(T),U.push(")")):U.push(T),console.log.apply(console,U)}class le{constructor(F,N){this.d=F,this.f=N,this.a=0,this.b=0}logOutgoing(F,N,H,re,z){this.b+=F,K(this.d,this.b,F,N,H,re,z)}logIncoming(F,N,H,re,z){this.a+=F,K(this.f,this.a,F,N,H,re,z)}}e.IPCLogger=le}),define(ee[143],te([0,1,17,3,47]),function(q,e,I,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class M{constructor(p){this.a=p,this.onMessage=t.Event.fromDOMEventEmitter(this.a,"message",m=>I.VSBuffer.wrap(m.data)),p.start()}send(p){this.a.postMessage(p.buffer)}disconnect(){this.a.close()}}e.Protocol=M;class A extends C.IPCClient{constructor(p,m){const y=new M(p);super(y,m),this.b=y}dispose(){this.b.disconnect()}}e.Client=A}),define(ee[102],te([0,1,17,3,2,47]),function(q,e,I,t,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(a){a.Created="created",a.Read="read",a.Write="write",a.Open="open",a.Error="error",a.Close="close",a.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",a.NodeEndReceived="nodeEndReceived",a.NodeEndSent="nodeEndSent",a.NodeDrainBegin="nodeDrainBegin",a.NodeDrainEnd="nodeDrainEnd",a.zlibInflateError="zlibInflateError",a.zlibInflateData="zlibInflateData",a.zlibInflateInitialWrite="zlibInflateInitialWrite",a.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",a.zlibInflateWrite="zlibInflateWrite",a.zlibInflateFlushFired="zlibInflateFlushFired",a.zlibDeflateError="zlibDeflateError",a.zlibDeflateData="zlibDeflateData",a.zlibDeflateWrite="zlibDeflateWrite",a.zlibDeflateFlushFired="zlibDeflateFlushFired",a.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",a.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",a.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",a.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",a.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",a.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",a.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",a.ProtocolHeaderRead="protocolHeaderRead",a.ProtocolMessageRead="protocolMessageRead",a.ProtocolHeaderWrite="protocolHeaderWrite",a.ProtocolMessageWrite="protocolMessageWrite",a.ProtocolWrite="protocolWrite"})(A=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var k;(function(a){a.enableDiagnostics=!1,a.records=[];const s=new WeakMap;let l=0;function o(D,L){if(!s.has(D)){const j=String(++l);s.set(D,j)}return s.get(D)}function S(D,L,j,X){if(!a.enableDiagnostics)return;const ae=o(D,L);if(X instanceof I.VSBuffer||X instanceof Uint8Array||X instanceof ArrayBuffer||ArrayBuffer.isView(X)){const Y=I.VSBuffer.alloc(X.byteLength);Y.set(X),a.records.push({timestamp:Date.now(),id:ae,label:L,type:j,buff:Y})}else a.records.push({timestamp:Date.now(),id:ae,label:L,type:j,data:X})}a.traceSocketEvent=S})(k=e.SocketDiagnostics||(e.SocketDiagnostics={}));var p;(function(a){a[a.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",a[a.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(p=e.SocketCloseEventType||(e.SocketCloseEventType={}));let m=null;function y(){return m||(m=I.VSBuffer.alloc(0)),m}class P{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(s){this.a.push(s),this.b+=s.byteLength}read(s){return this.c(s,!0)}peek(s){return this.c(s,!1)}c(s,l){if(s===0)return y();if(s>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===s){const L=this.a[0];return l&&(this.a.shift(),this.b-=s),L}if(this.a[0].byteLength>s){const L=this.a[0].slice(0,s);return l&&(this.a[0]=this.a[0].slice(s),this.b-=s),L}const o=I.VSBuffer.alloc(s);let S=0,D=0;for(;s>0;){const L=this.a[D];if(L.byteLength>s){const j=L.slice(0,s);o.set(j,S),S+=s,l&&(this.a[D]=L.slice(s),this.b-=s),s-=s}else o.set(L,S),S+=L.byteLength,l?(this.a.shift(),this.b-=L.byteLength):D++,s-=L.byteLength}return o}}e.ChunkStream=P;var E;(function(a){a[a.None=0]="None",a[a.Regular=1]="Regular",a[a.Control=2]="Control",a[a.Ack=3]="Ack",a[a.Disconnect=5]="Disconnect",a[a.ReplayRequest=6]="ReplayRequest",a[a.Pause=7]="Pause",a[a.Resume=8]="Resume",a[a.KeepAlive=9]="KeepAlive"})(E||(E={}));function h(a){switch(a){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var w;(function(a){a[a.HeaderLength=13]="HeaderLength",a[a.AcknowledgeTime=2e3]="AcknowledgeTime",a[a.TimeoutTime=2e4]="TimeoutTime",a[a.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",a[a.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(w=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(s,l,o,S){this.type=s,this.id=l,this.ack=o,this.data=S,this.writtenTime=0}get size(){return this.data.byteLength}}class b extends C.Disposable{constructor(s){super(),this.f=this.B(new t.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=s,this.b=!1,this.c=new P,this.B(this.a.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(s);this.c.byteLength>=this.g.readLen;){const l=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=l.readUInt32BE(9),this.g.messageType=l.readUInt8(0),this.g.id=l.readUInt32BE(1),this.g.ack=l.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:h(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const o=this.g.messageType,S=this.g.id,D=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",l),this.f.fire(new d(o,S,D,l)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class u{constructor(s){this.k=null,this.a=!1,this.b=!1,this.c=s,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(s){if(this.a)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=I.VSBuffer.alloc(13);l.writeUInt8(s.type,0),l.writeUInt32BE(s.id,1),l.writeUInt32BE(s.ack,5),l.writeUInt32BE(s.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:h(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",s.data),this.j(l,s.data)}g(s,l){const o=this.f===0;return this.d.push(s,l),this.f+=s.byteLength+l.byteLength,o}h(){const s=I.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,s}j(s,l){this.g(s,l)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const s=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this.c.write(s)}}class v extends C.Disposable{constructor(s){super(),this.f=new t.Emitter,this.onMessage=this.f.event,this.g=new t.Emitter,this.onDidDispose=this.g.event,this.a=s,this.b=this.B(new u(this.a)),this.c=this.B(new b(this.a)),this.B(this.c.onMessage(l=>{l.type===1&&this.f.fire(l.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(s){this.b.write(new d(1,0,0,s))}}e.Protocol=v;class g extends M.IPCClient{static fromSocket(s,l){return new g(new v(s),l)}get onDidDispose(){return this.b.onDidDispose}constructor(s,l,o=null){super(s,l,o),this.b=s}dispose(){super.dispose();const s=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),s.end()}}e.Client=g;class f{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new t.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(s){this.b?this.d.length>0?this.d.push(s):this.a.fire(s):this.d.push(s)}flushBuffer(){this.d=[]}}e.BufferedEmitter=f;class c{constructor(s){this.data=s,this.next=null}}class n{constructor(){this.a=null,this.b=null}length(){let s=0,l=this.a;for(;l;)l=l.next,s++;return s}peek(){return this.a?this.a.data:null}toArray(){const s=[];let l=0,o=this.a;for(;o;)s[l++]=o.data,o=o.next;return s}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(s){const l=new c(s);if(!this.a){this.a=l,this.b=l;return}this.b.next=l,this.b=l}}class r{static getInstance(){return r.b||(r.b=new r),r.b}constructor(){this.c=[];const s=Date.now();for(let l=0;l<r.a;l++)this.c[l]=s-1e3*l;setInterval(()=>{for(let l=r.a;l>=1;l--)this.c[l]=this.c[l-1];this.c[0]=Date.now()},1e3)}d(){const s=Date.now(),l=(1+r.a)*1e3;let o=0;for(let S=0;S<r.a;S++)s-this.c[S]<=l&&o++;return 1-o/r.a}hasHighLoad(){return this.d()>=.5}}r.a=10,r.b=null;class i{get unacknowledgedCount(){return this.c-this.d}constructor(s,l=null,o=r.getInstance()){this.t=new f,this.onControlMessage=this.t.event,this.u=new f,this.onMessage=this.u.event,this.v=new f,this.onDidDispose=this.v.event,this.w=new f,this.onSocketClose=this.w.event,this.x=new f,this.onSocketTimeout=this.x.event,this.s=o,this.a=!1,this.b=new n,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=[],this.o=s,this.p=new u(this.o),this.r.push(this.p),this.q=new b(this.o),this.r.push(this.q),this.r.push(this.q.onMessage(S=>this.y(S))),this.r.push(this.o.onClose(S=>this.w.fire(S))),l&&this.q.acceptChunk(l),this.l=setInterval(()=>{this.C()},5e3)}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r=(0,C.dispose)(this.r)}drain(){return this.p.drain()}sendDisconnect(){const s=new d(5,0,0,y());this.p.write(s),this.p.flush()}sendPause(){const s=new d(7,0,0,y());this.p.write(s)}sendResume(){const s=new d(8,0,0,y());this.p.write(s)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(s,l){this.a=!0,this.r=(0,C.dispose)(this.r),this.t.flushBuffer(),this.w.flushBuffer(),this.x.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=s,this.p=new u(this.o),this.r.push(this.p),this.q=new b(this.o),this.r.push(this.q),this.r.push(this.q.onMessage(o=>this.y(o))),this.r.push(this.o.onClose(o=>this.w.fire(o))),this.q.acceptChunk(l)}endAcceptReconnection(){this.a=!1,this.h=this.g;const s=new d(3,0,this.h,y());this.p.write(s);const l=this.b.toArray();for(let o=0,S=l.length;o<S;o++)this.p.write(l[o]);this.A()}acceptDisconnect(){this.v.fire()}y(s){if(s.ack>this.d){this.d=s.ack;do{const l=this.b.peek();if(l&&l.id<=s.ack)this.b.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this.g)if(s.id!==this.g+1){const l=Date.now();l-this.m>1e4&&(this.m=l,this.p.write(new d(6,0,0,y())))}else this.g=s.id,this.j=Date.now(),this.z(),this.u.fire(s.data);break}case 2:{this.t.fire(s.data);break}case 3:break;case 5:{this.v.fire();break}case 6:{const l=this.b.toArray();for(let o=0,S=l.length;o<S;o++)this.p.write(l[o]);this.A();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(s){const l=++this.c;this.h=this.g;const o=new d(1,l,this.h,s);this.b.push(o),this.a||(this.p.write(o),this.A())}sendControl(s){const l=new d(2,0,0,s);this.p.write(l)}z(){if(this.g<=this.h||this.k)return;const s=Date.now()-this.j;if(s>=2e3){this.B();return}this.k=setTimeout(()=>{this.k=null,this.z()},2e3-s+5)}A(){if(this.c<=this.d||this.f||this.a)return;const s=this.b.peek(),l=Date.now()-s.writtenTime,o=Date.now()-this.q.lastReadTime,S=Date.now()-this.n;if(l>=2e4&&o>=2e4&&S>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.x.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:o});return}const D=Math.max(2e4-l,2e4-o,2e4-S,500);this.f=setTimeout(()=>{this.f=null,this.A()},D)}B(){if(this.g<=this.h)return;this.h=this.g;const s=new d(3,0,this.h,y());this.p.write(s)}C(){const s=new d(9,0,0,y());this.p.write(s)}}e.PersistentProtocol=i}),define(ee[144],te([0,1,41,17,3,2,47,129]),function(q,e,I,t,C,M,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function p(y,P){const E=C.Event.fromNodeEventEmitter(I.validatedIpcMain,P,(w,d)=>({event:w,message:d})),h=C.Event.filter(E,({event:w})=>w.sender.id===y);return C.Event.map(h,({message:w})=>w&&t.VSBuffer.wrap(w))}class m extends A.IPCServer{static d(){const P=C.Event.fromNodeEventEmitter(I.validatedIpcMain,"vscode:hello",({sender:E})=>E);return C.Event.map(P,E=>{const h=E.id;m.b.get(h)?.dispose();const d=new C.Emitter;m.b.set(h,(0,M.toDisposable)(()=>d.fire()));const b=p(h,"vscode:message"),u=C.Event.any(C.Event.signal(p(h,"vscode:disconnect")),d.event);return{protocol:new k.Protocol(E,b),onDidClientDisconnect:u}})}constructor(){super(m.d())}}e.Server=m,m.b=new Map}),define(ee[103],te([0,1,41,3,29,143]),function(q,e,I,t,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class A extends M.Client{constructor(m,y){super({addEventListener:(P,E)=>m.addListener(P,E),removeEventListener:(P,E)=>m.removeListener(P,E),postMessage:P=>m.postMessage(P),start:()=>m.start(),close:()=>m.close()},y)}}e.Client=A;async function k(p){if(p.isDestroyed()||p.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const m=(0,C.generateUuid)();p.webContents.send("vscode:createMessageChannel",m);const y=t.Event.fromNodeEventEmitter(I.validatedIpcMain,"vscode:createMessageChannelResult",(E,h)=>({nonce:h,port:E.ports[0]})),{port:P}=await t.Event.toPromise(t.Event.once(t.Event.filter(y,E=>E.nonce===m)));return P}e.connect=k}),define(ee[145],te([0,1,46,8,17,22,138,14,3,2,44,82,79,47]),function(q,e,I,t,C,M,A,k,p,m,y,P,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class w extends h.ChannelServer{constructor(u){super({send:v=>{try{process.send?.(v.buffer.toString("base64"))}catch{}},onMessage:p.Event.fromNodeEventEmitter(process,"message",v=>C.VSBuffer.wrap(Buffer.from(v,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.Server=w;class d{constructor(u,v){this.i=u,this.j=v,this.c=new Set,this.g=new Map,this.h=new p.Emitter,this.onDidProcessExit=this.h.event;const g=v&&v.timeout?v.timeout:6e4;this.b=new t.Delayer(g),this.d=null,this.f=null}getChannel(u){const v=this;return{call(g,f,c){return v.k(u,g,f,c)},listen(g,f){return v.l(u,g,f)}}}k(u,v,g,f=M.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(f.isCancellationRequested)return Promise.reject(k.canceled());this.b.cancel();const c=this.n(u),n=(0,t.createCancelablePromise)(a=>c.call(v,g,a)),r=f.onCancellationRequested(()=>n.cancel()),i=(0,m.toDisposable)(()=>n.cancel());return this.c.add(i),n.finally(()=>{r.dispose(),this.c.delete(i),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),n}l(u,v,g){if(!this.b)return p.Event.None;this.b.cancel();let f;const c=new p.Emitter({onWillAddFirstListener:()=>{f=this.n(u).listen(v,g)(c.fire,c),this.c.add(f)},onDidRemoveLastListener:()=>{this.c.delete(f),f.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return c.event}get m(){if(!this.f){const u=this.j&&this.j.args?this.j.args:[],v=Object.create(null);v.env={...(0,y.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(v.env={...v.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(v.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(v.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(v.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),v.execArgv===void 0&&(v.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s))),(0,E.removeDangerousEnvVariables)(v.env),this.d=(0,I.fork)(this.i,u,v);const g=new p.Emitter;p.Event.fromNodeEventEmitter(this.d,"message",s=>s)(s=>{if((0,A.isRemoteConsoleLog)(s)){(0,A.log)(s,`IPC Library: ${this.j.serverName}`);return}g.fire(C.VSBuffer.wrap(Buffer.from(s,"base64")))});const c=this.j.useQueue?(0,P.createQueuedSender)(this.d):this.d,n=s=>this.d&&this.d.connected&&c.send(s.buffer.toString("base64")),r=g.event,i={send:n,onMessage:r};this.f=new h.ChannelClient(i);const a=()=>this.o();process.once("exit",a),this.d.on("error",s=>console.warn('IPC "'+this.j.serverName+'" errored with '+s)),this.d.on("exit",(s,l)=>{process.removeListener("exit",a),this.c.forEach(o=>(0,m.dispose)(o)),this.c.clear(),s!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+s+" and signal "+l),this.b?.cancel(),this.o(),this.h.fire({code:s,signal:l})})}return this.f}n(u){let v=this.g.get(u);return v||(v=this.m.getChannel(u),this.g.set(u,v)),v}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=d}),define(ee[83],te([0,1,17,14,3,2,9,4,29,47,102]),function(q,e,I,t,C,M,A,k,p,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function P(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class E{traceSocketEvent(o,S){y.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,o,S)}constructor(o,S=""){this.f=!0,this.debugLabel=S,this.socket=o,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=D=>{if(this.traceSocketEvent("error",{code:D?.code,message:D?.message}),D){if(D.code==="EPIPE")return;(0,t.onUnexpectedError)(D)}},this.socket.on("error",this.a),this.b=D=>{this.traceSocketEvent("close",{hadError:D}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(o){const S=D=>{this.traceSocketEvent("read",D),o(I.VSBuffer.wrap(D))};return this.socket.on("data",S),{dispose:()=>this.socket.off("data",S)}}onClose(o){const S=D=>{o({type:0,hadError:D,error:void 0})};return this.socket.on("close",S),{dispose:()=>this.socket.off("close",S)}}onEnd(o){const S=()=>{o()};return this.socket.on("end",S),{dispose:()=>this.socket.off("end",S)}}write(o){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",o),this.socket.write(o.buffer,S=>{if(S){if(S.code==="EPIPE")return;(0,t.onUnexpectedError)(S)}})}catch(S){if(S.code==="EPIPE")return;(0,t.onUnexpectedError)(S)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((o,S)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),o();return}const D=()=>{this.socket.off("close",D),this.socket.off("end",D),this.socket.off("error",D),this.socket.off("timeout",D),this.socket.off("drain",D),this.traceSocketEvent("nodeDrainEnd"),o()};this.socket.on("close",D),this.socket.on("end",D),this.socket.on("error",D),this.socket.on("timeout",D),this.socket.on("drain",D)})}}e.NodeSocket=E;var h;(function(l){l[l.MinHeaderByteSize=2]="MinHeaderByteSize"})(h||(h={}));var w;(function(l){l[l.PeekHeader=1]="PeekHeader",l[l.ReadHeader=2]="ReadHeader",l[l.ReadBody=3]="ReadBody",l[l.Fin=4]="Fin"})(w||(w={}));class d extends M.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(o,S){this.socket.traceSocketEvent(o,S)}constructor(o,S,D,L){super(),this.f=this.B(new C.Emitter),this.g=this.B(new C.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=o,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:S,inflateBytesLength:D?.byteLength||0,recordInflateBytes:L}),this.a=this.B(new b(this,S,D,L,this.f,(j,X)=>this.k(j,X))),this.B(this.a.onError(j=>{console.error(j),(0,t.onUnexpectedError)(j),this.g.fire({type:0,hadError:!0,error:j})})),this.b=new y.ChunkStream,this.B(this.socket.onData(j=>this.l(j))),this.B(this.socket.onClose(j=>this.g.fire(j)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(o){return this.f.event(o)}onClose(o){return this.g.event(o)}onEnd(o){return this.socket.onEnd(o)}write(o){this.a.writeMessage(o)}k(o,S){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",o);let D=2;o.byteLength<126?D+=0:o.byteLength<2**16?D+=2:D+=8;const L=I.VSBuffer.alloc(D);if(S?L.writeUInt8(194,0):L.writeUInt8(130,0),o.byteLength<126)L.writeUInt8(o.byteLength,1);else if(o.byteLength<2**16){L.writeUInt8(126,1);let j=1;L.writeUInt8(o.byteLength>>>8&255,++j),L.writeUInt8(o.byteLength>>>0&255,++j)}else{L.writeUInt8(127,1);let j=1;L.writeUInt8(0,++j),L.writeUInt8(0,++j),L.writeUInt8(0,++j),L.writeUInt8(0,++j),L.writeUInt8(o.byteLength>>>24&255,++j),L.writeUInt8(o.byteLength>>>16&255,++j),L.writeUInt8(o.byteLength>>>8&255,++j),L.writeUInt8(o.byteLength>>>0&255,++j)}this.socket.write(I.VSBuffer.concat([L,o]))}end(){this.h=!0,this.socket.end()}l(o){if(o.byteLength!==0){for(this.b.acceptChunk(o);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const S=this.b.peek(this.j.readLen),D=S.readUInt8(0),L=(D&128)>>>7,j=(D&64)>>>6,X=S.readUInt8(1),ae=(X&128)>>>7,Y=X&127;this.j.state=2,this.j.readLen=2+(ae?4:0)+(Y===126?2:0)+(Y===127?8:0),this.j.fin=L,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(j)),this.j.firstFrameOfMessage=Boolean(L),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const S=this.b.read(this.j.readLen),D=S.readUInt8(1),L=(D&128)>>>7;let j=D&127,X=1;j===126?j=S.readUInt8(++X)*2**8+S.readUInt8(++X):j===127&&(j=S.readUInt8(++X)*0+S.readUInt8(++X)*0+S.readUInt8(++X)*0+S.readUInt8(++X)*0+S.readUInt8(++X)*2**24+S.readUInt8(++X)*2**16+S.readUInt8(++X)*2**8+S.readUInt8(++X));let ae=0;L&&(ae=S.readUInt8(++X)*2**24+S.readUInt8(++X)*2**16+S.readUInt8(++X)*2**8+S.readUInt8(++X)),this.j.state=3,this.j.readLen=j,this.j.mask=ae,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const S=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",S),g(S,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",S),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(S,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await C.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=d;class b extends M.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:I.VSBuffer.alloc(0)}constructor(o,S,D,L,j,X){super(),this.k=o,this.l=j,this.m=X,this.a=this.B(new C.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new C.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,S?(this.b=this.B(new u(this.k,L,D,{windowBits:15})),this.f=this.B(new v(this.k,{windowBits:15})),this.B(this.b.onError(ae=>this.a.fire(ae))),this.B(this.f.onError(ae=>this.a.fire(ae)))):(this.b=null,this.f=null)}writeMessage(o){this.g.push(o),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const o=this.g.shift();if(this.f){const S=await this.r(this.f,o);this.m(S,!0)}else this.m(o,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(o,S){return new Promise((D,L)=>{o.write(S),o.flush(j=>D(j))})}acceptFrame(o,S,D){this.h.push({data:o,isCompressed:S,isLastFrameOfMessage:D}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const o=this.h.shift();if(this.b&&o.isCompressed){const S=await this.u(this.b,o.data,o.isLastFrameOfMessage);this.l.fire(S)}else this.l.fire(o.data)}this.s=!1}}u(o,S,D){return new Promise((L,j)=>{o.write(S),D&&o.write(I.VSBuffer.fromByteArray([0,0,255,255])),o.flush(X=>L(X))})}}class u extends M.Disposable{get recordedInflateBytes(){return this.j?I.VSBuffer.concat(this.f):I.VSBuffer.alloc(0)}constructor(o,S,D,L){super(),this.h=o,this.j=S,this.a=this.B(new C.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=P().zlib.createInflateRaw(L),this.b.on("error",j=>{this.h.traceSocketEvent("zlibInflateError",{message:j?.message,code:j?.code}),this.a.fire(j)}),this.b.on("data",j=>{this.h.traceSocketEvent("zlibInflateData",j),this.g.push(I.VSBuffer.wrap(j))}),D&&(this.h.traceSocketEvent("zlibInflateInitialWrite",D.buffer),this.b.write(D.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(o){this.j&&this.f.push(o.clone()),this.h.traceSocketEvent("zlibInflateWrite",o),this.b.write(o.buffer)}flush(o){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const S=I.VSBuffer.concat(this.g);this.g.length=0,o(S)})}}class v extends M.Disposable{constructor(o,S){super(),this.g=o,this.a=this.B(new C.Emitter),this.onError=this.a.event,this.f=[],this.b=P().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",D=>{this.g.traceSocketEvent("zlibDeflateError",{message:D?.message,code:D?.code}),this.a.fire(D)}),this.b.on("data",D=>{this.g.traceSocketEvent("zlibDeflateData",D),this.f.push(I.VSBuffer.wrap(D))})}write(o){this.g.traceSocketEvent("zlibDeflateWrite",o.buffer),this.b.write(o.buffer)}flush(o){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let S=I.VSBuffer.concat(this.f);this.f.length=0,S=S.slice(0,S.byteLength-4),o(S)})}}function g(l,o){if(o===0)return;const S=l.byteLength>>>2;for(let Y=0;Y<S;Y++){const J=l.readUInt32BE(Y*4);l.writeUInt32BE(J^o,Y*4)}const D=S*4,L=l.byteLength-D,j=o>>>24&255,X=o>>>16&255,ae=o>>>8&255;L>=1&&l.writeUInt8(l.readUInt8(D)^j,D),L>=2&&l.writeUInt8(l.readUInt8(D+1)^X,D+1),L>=3&&l.writeUInt8(l.readUInt8(D+2)^ae,D+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const f={[2]:107,[1]:103};function c(){const l=(0,p.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${l}-sock`;let o;return e.XDG_RUNTIME_DIR?o=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${l}.sock`):o=(0,A.join)(P().os.tmpdir(),`vscode-ipc-${l}.sock`),r(o),o}e.createRandomIPCHandle=c;function n(l,o,S){const D=P().crypto.createHash("md5").update(l).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${D}-${S}-${o}-sock`;let L;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?L=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-${D.substr(0,8)}-${S}-${o}.sock`):L=(0,A.join)(l,`${S}-${o}.sock`),r(L),L}e.createStaticIPCHandle=n;function r(l){const o=f[k.platform];typeof o=="number"&&l.length>=o&&console.warn(`WARNING: IPC handle "${l}" is longer than ${o} chars, try a shorter --user-data-dir`)}class i extends m.IPCServer{static b(o){const S=C.Event.fromNodeEventEmitter(o,"connection");return C.Event.map(S,D=>({protocol:new y.Protocol(new E(D,"ipc-server-connection")),onDidClientDisconnect:C.Event.once(C.Event.fromNodeEventEmitter(D,"close"))}))}constructor(o){super(i.b(o)),this.d=o}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=i;function a(l){return new Promise((o,S)=>{const D=P().net.createServer();D.on("error",S),D.listen(l,()=>{D.removeListener("error",S),o(new i(D))})})}e.serve=a;function s(l,o){return new Promise((S,D)=>{const L=P().net.createConnection(l,()=>{L.removeListener("error",D),S(y.Client.fromSocket(new E(L,`ipc-client${o}`),o))});L.once("error",D)})}e.connect=s}),define(ee[104],te([0,1,8,3,2,12]),function(q,e,I,t,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var A;(function(P){P[P.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(A=e.StorageHint||(e.StorageHint={}));function k(P){const E=P;return E?.changed instanceof Map||E?.deleted instanceof Set}e.isStorageItemsChangeEvent=k;var p;(function(P){P[P.None=0]="None",P[P.Initialized=1]="Initialized",P[P.Closed=2]="Closed"})(p=e.StorageState||(e.StorageState={}));class m extends C.Disposable{constructor(E,h=Object.create(null)){super(),this.m=E,this.n=h,this.b=this.B(new t.Emitter),this.onDidChangeStorage=this.b.event,this.c=p.None,this.f=new Map,this.g=new I.ThrottledDelayer(m.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(E=>this.r(E)))}r(E){E.changed?.forEach((h,w)=>this.s(w,h)),E.deleted?.forEach(h=>this.s(h,void 0))}s(E,h){if(this.c===p.Closed)return;let w=!1;(0,M.isUndefinedOrNull)(h)?w=this.f.delete(E):this.f.get(E)!==h&&(this.f.set(E,h),w=!0),w&&this.b.fire(E)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===p.None&&(this.c=p.Initialized,this.n.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(E,h){const w=this.f.get(E);return(0,M.isUndefinedOrNull)(w)?h:w}getBoolean(E,h){const w=this.get(E);return(0,M.isUndefinedOrNull)(w)?h:w==="true"}getNumber(E,h){const w=this.get(E);return(0,M.isUndefinedOrNull)(w)?h:parseInt(w,10)}async set(E,h){if(this.c===p.Closed)return;if((0,M.isUndefinedOrNull)(h))return this.delete(E);const w=String(h);if(this.f.get(E)!==w)return this.f.set(E,w),this.j.set(E,w),this.h.delete(E),this.b.fire(E),this.w()}async delete(E){if(!(this.c===p.Closed||!this.f.delete(E)))return this.h.has(E)||this.h.add(E),this.j.delete(E),this.b.fire(E),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=p.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const E={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(E).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(E){if(!!this.u)return this.w(E)}async w(E){return this.g.trigger(()=>this.v(),E)}async whenFlushed(){if(!!this.u)return new Promise(E=>this.l.push(E))}dispose(){this.g.dispose(),super.dispose()}}e.Storage=m,m.a=100;class y{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(E){E.insert?.forEach((h,w)=>this.a.set(w,h)),E.delete?.forEach(h=>this.a.delete(h))}async close(){}}e.InMemoryStorageDatabase=y}),define(ee[146],te([0,1,8,3,39,9,23]),function(q,e,I,t,C,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class k{get onDidChangeItemsExternal(){return t.Event.None}constructor(y,P=Object.create(null)){this.g=y,this.h=P,this.c=(0,M.basename)(this.g),this.d=new p(this.h.logging),this.f=this.n(this.g)}async getItems(){const y=await this.f,P=new Map;return(await this.s(y,"SELECT * FROM ItemTable")).forEach(h=>P.set(h.key,h.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${P.size} rows`),P}async updateItems(y){const P=await this.f;return this.j(P,y)}j(y,P){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${P.insert?(0,C.mapToString)(P.insert):"0"}), delete(${P.delete?(0,C.setToString)(P.delete):"0"})`),this.t(y,()=>{const E=P.insert,h=P.delete;if(E&&E.size>0){const w=[];w.push([]);let d=0;E.forEach((b,u)=>{let v=w[d];v.length>k.b&&(d++,v=[],w.push(v)),v.push(u,b)}),w.forEach(b=>{this.u(y,`INSERT INTO ItemTable VALUES ${new Array(b.length/2).fill("(?,?)").join(",")}`,u=>u.run(b),()=>{const u=[];let v=0;return E.forEach((g,f)=>{u.push(f),v+=g.length}),`Keys: ${u.join(", ")} Length: ${v}`})})}if(h&&h.size){const w=[];w.push([]);let d=0;h.forEach(b=>{let u=w[d];u.length>k.b&&(d++,u=[],w.push(u)),u.push(b)}),w.forEach(b=>{this.u(y,`DELETE FROM ItemTable WHERE key IN (${new Array(b.length).fill("?").join(",")})`,u=>u.run(b),()=>{const u=[];return h.forEach(v=>{u.push(v)}),`Keys: ${u.join(", ")}`})})}})}async close(y){this.d.trace(`[storage ${this.c}] close()`);const P=await this.f;return this.k(P,y)}k(y,P){return new Promise((E,h)=>{y.db.close(w=>(w&&this.o(y,`[storage ${this.c}] close(): ${w}`),this.g===k.IN_MEMORY_PATH?E():!y.isErroneous&&!y.isInMemory?this.l().then(E,d=>(this.d.error(`[storage ${this.c}] backup(): ${d}`),E())):typeof P=="function"?A.Promises.unlink(this.g).then(()=>this.p(this.g).then(d=>{const b=()=>this.k(d,void 0);return this.j(d,{insert:P()}).then(()=>b(),u=>(b(),Promise.reject(u)))})).then(E,h):h(w||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const y=this.m(this.g);return A.Promises.copy(this.g,y,{preserveSymlinks:!1})}m(y){return`${y}.backup`}async checkIntegrity(y){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${y})`);const P=await this.f,E=await this.r(P,y?"PRAGMA integrity_check":"PRAGMA quick_check"),h=y?E.integrity_check:E.quick_check;return P.isErroneous?`${h} (last error: ${P.lastError})`:P.isInMemory?`${h} (in-memory!)`:h}async n(y,P=!0){this.d.trace(`[storage ${this.c}] open(${y}, retryOnBusy: ${P})`);try{return await this.p(y)}catch(E){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${E}`),E.code==="SQLITE_BUSY"&&P)return await(0,I.timeout)(k.a),this.n(y,!1);try{await A.Promises.unlink(y);try{await A.Promises.rename(this.m(y),y)}catch{}return await this.p(y)}catch(h){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${h}`),this.p(k.IN_MEMORY_PATH)}}}o(y,P){y.isErroneous=!0,y.lastError=P,this.d.error(P)}p(y){return new Promise((P,E)=>{new Promise((h,w)=>{q(["@vscode/sqlite3"],h,w)}).then(h=>{const w={db:new(this.d.isTracing?h.verbose().Database:h.Database)(y,d=>d?w.db&&d.code!=="SQLITE_CANTOPEN"?w.db.close(()=>E(d)):E(d):this.q(w,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>P(w),b=>w.db.close(()=>E(b)))),isInMemory:y===k.IN_MEMORY_PATH};w.db.on("error",d=>this.o(w,`[storage ${this.c}] Error (event): ${d}`)),this.d.isTracing&&w.db.on("trace",d=>this.d.trace(`[storage ${this.c}] Trace (event): ${d}`))},E)})}q(y,P){return new Promise((E,h)=>{y.db.exec(P,w=>w?(this.o(y,`[storage ${this.c}] exec(): ${w}`),h(w)):E())})}r(y,P){return new Promise((E,h)=>{y.db.get(P,(w,d)=>w?(this.o(y,`[storage ${this.c}] get(): ${w}`),h(w)):E(d))})}s(y,P){return new Promise((E,h)=>{y.db.all(P,(w,d)=>w?(this.o(y,`[storage ${this.c}] all(): ${w}`),h(w)):E(d))})}t(y,P){return new Promise((E,h)=>{y.db.serialize(()=>{y.db.run("BEGIN TRANSACTION"),P(),y.db.run("END TRANSACTION",w=>w?(this.o(y,`[storage ${this.c}] transaction(): ${w}`),h(w)):E())})})}u(y,P,E,h){const w=y.db.prepare(P),d=b=>{this.o(y,`[storage ${this.c}] prepare(): ${b} (${P}). Details: ${h()}`)};w.on("error",d),E(w),w.finalize(b=>{b&&d(b),w.removeListener("error",d)})}}e.SQLiteStorageDatabase=k,k.IN_MEMORY_PATH=":memory:",k.a=2e3,k.b=256;class p{constructor(y){y&&typeof y.logTrace=="function"&&process.env[p.VSCODE_TRACE_STORAGE]&&(this.a=y.logTrace),y&&typeof y.logError=="function"&&(this.b=y.logError)}get isTracing(){return!!this.a}trace(y){this.a?.(y)}error(y){this.b?.(y)}}p.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(ee[147],te([11,10]),function(q,e){return q.create("vs/code/electron-main/app",e)}),define(ee[148],te([11,10]),function(q,e){return q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ee[149],te([11,10]),function(q,e){return q.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(ee[150],te([11,10]),function(q,e){return q.create("vs/platform/environment/node/argv",e)}),define(ee[151],te([11,10]),function(q,e){return q.create("vs/platform/environment/node/argvHelper",e)}),define(ee[152],te([11,10]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ee[153],te([11,10]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ee[154],te([11,10]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ee[155],te([11,10]),function(q,e){return q.create("vs/platform/extensions/common/extensionValidator",e)}),define(ee[156],te([11,10]),function(q,e){return q.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ee[157],te([11,10]),function(q,e){return q.create("vs/platform/files/common/fileService",e)}),define(ee[158],te([11,10]),function(q,e){return q.create("vs/platform/files/common/files",e)}),define(ee[159],te([11,10]),function(q,e){return q.create("vs/platform/files/common/io",e)}),define(ee[160],te([11,10]),function(q,e){return q.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(ee[161],te([11,10]),function(q,e){return q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ee[162],te([11,10]),function(q,e){return q.create("vs/platform/issue/electron-main/issueMainService",e)}),define(ee[163],te([11,10]),function(q,e){return q.create("vs/platform/menubar/electron-main/menubar",e)}),define(ee[164],te([11,10]),function(q,e){return q.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(ee[165],te([11,10]),function(q,e){return q.create("vs/platform/request/common/request",e)}),define(ee[166],te([11,10]),function(q,e){return q.create("vs/platform/shell/node/shellEnv",e)}),define(ee[167],te([11,10]),function(q,e){return q.create("vs/platform/telemetry/common/telemetryService",e)}),define(ee[168],te([11,10]),function(q,e){return q.create("vs/platform/update/common/update.config.contribution",e)}),define(ee[169],te([11,10]),function(q,e){return q.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ee[170],te([11,10]),function(q,e){return q.create("vs/platform/windows/electron-main/windowImpl",e)}),define(ee[171],te([11,10]),function(q,e){return q.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(ee[172],te([11,10]),function(q,e){return q.create("vs/platform/workspace/common/workspace",e)}),define(ee[173],te([11,10]),function(q,e){return q.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(ee[174],te([11,10]),function(q,e){return q.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(ee[175],te([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function I(C){return C&&C.hasOwnProperty("folderUri")}e.isFolderBackupInfo=I;function t(C){return C&&C.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=t}),define(ee[176],te([0,1,7]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function t(A){return typeof A?.backupFolder=="string"}e.isEmptyWindowBackupInfo=t;function C(A){let k=[];try{Array.isArray(A.workspaces)&&(k=A.workspaces.map(p=>({workspace:{id:p.id,configPath:I.URI.parse(p.configURIPath)},remoteAuthority:p.remoteAuthority})))}catch{}return k}e.deserializeWorkspaceInfos=C;function M(A){let k=[];try{Array.isArray(A.folders)&&(k=A.folders.map(p=>({folderUri:I.URI.parse(p.folderUri),remoteAuthority:p.remoteAuthority})))}catch{}return k}e.deserializeFolderInfos=M}),define(ee[177],te([0,1,3,2]),function(q,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class C{constructor(){this.a=new I.Emitter,this.b=new I.Emitter,this.c=new I.Emitter,this.d=new I.Emitter}call(k,p,m){switch(p){case"close":return Promise.resolve(this.a.fire({sessionId:m[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:m[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:m[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:m[0],port:m[1],subId:m[2]}))}throw new Error("Method not implemented.")}listen(k,p,m){switch(p){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=C,C.ChannelName="extensionhostdebugservice";class M extends t.Disposable{constructor(k){super(),this.b=k}reload(k){this.b.call("reload",[k])}get onReload(){return this.b.listen("reload")}close(k){this.b.call("close",[k])}get onClose(){return this.b.listen("close")}attachSession(k,p,m){this.b.call("attach",[k,p,m])}get onAttachSession(){return this.b.listen("attach")}terminateSession(k,p){this.b.call("terminate",[k,p])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(k,p){return this.b.call("openExtensionDevelopmentHostWindow",[k,p])}}e.ExtensionHostDebugChannelClient=M}),define(ee[178],te([0,1,132,53,15,9,32,20,7]),function(q,e,I,t,C,M,A,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class m{get appRoot(){return(0,M.dirname)(C.FileAccess.asFileUri("").fsPath)}get userHome(){return p.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return p.URI.file((0,M.join)(this.userDataPath,"User"))}get tmpDir(){return p.URI.file(this.b.tmpDir)}get cacheHome(){return p.URI.file(this.userDataPath)}get stateResource(){return(0,k.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,k.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const d=(0,I.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,M.join)(this.userDataPath,"logs",d)}return this.args.logsPath}get userDataSyncLogResource(){return p.URI.file((0,M.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return p.URI.file((0,M.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,k.joinPath)(p.URI.file((0,M.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,k.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,k.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,k.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=A.env.VSCODE_PORTABLE;return d?p.URI.file((0,M.join)(d,"argv.json")):(0,k.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return p.URI.file((0,M.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,M.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,M.resolve)(d):(0,M.normalize)((0,M.join)(C.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const d=this.args["extensions-download-dir"];return d?p.URI.file((0,M.resolve)(d)):p.URI.file((0,M.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,M.resolve)(d);const b=A.env.VSCODE_EXTENSIONS;if(b)return b;const u=A.env.VSCODE_PORTABLE;return u?(0,M.join)(u,"extensions"):(0,k.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(b=>/^[^:/?#]+?:\/\//.test(b)?p.URI.parse(b):p.URI.file((0,M.normalize)(b)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?p.URI.parse(d):p.URI.file((0,M.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return y(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(d=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(d))}get extensionLogLevel(){const d=[];for(const b of this.args.log||[]){const u=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(b);u&&u[1]&&u[2]&&d.push([u[1],u[2]])}return d.length?d:void 0}get serviceMachineIdResource(){return(0,k.joinPath)(p.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return p.URI.file((0,M.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const d=A.env.VSCODE_PORTABLE;return d?p.URI.file((0,M.join)(d,"policy.json")):(0,k.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(d){this.args.continueOn=d}get args(){return this.a}constructor(d,b,u){this.a=d,this.b=b,this.c=u,this.editSessionId=this.args.editSessionId}}pe([t.memoize],m.prototype,"appRoot",null),pe([t.memoize],m.prototype,"userHome",null),pe([t.memoize],m.prototype,"userDataPath",null),pe([t.memoize],m.prototype,"appSettingsHome",null),pe([t.memoize],m.prototype,"tmpDir",null),pe([t.memoize],m.prototype,"cacheHome",null),pe([t.memoize],m.prototype,"stateResource",null),pe([t.memoize],m.prototype,"userRoamingDataHome",null),pe([t.memoize],m.prototype,"userDataSyncHome",null),pe([t.memoize],m.prototype,"userDataSyncLogResource",null),pe([t.memoize],m.prototype,"editSessionsLogResource",null),pe([t.memoize],m.prototype,"sync",null),pe([t.memoize],m.prototype,"machineSettingsResource",null),pe([t.memoize],m.prototype,"workspaceStorageHome",null),pe([t.memoize],m.prototype,"localHistoryHome",null),pe([t.memoize],m.prototype,"keyboardLayoutResource",null),pe([t.memoize],m.prototype,"argvResource",null),pe([t.memoize],m.prototype,"isExtensionDevelopment",null),pe([t.memoize],m.prototype,"untitledWorkspacesHome",null),pe([t.memoize],m.prototype,"installSourcePath",null),pe([t.memoize],m.prototype,"builtinExtensionsPath",null),pe([t.memoize],m.prototype,"extensionsPath",null),pe([t.memoize],m.prototype,"extensionDevelopmentLocationURI",null),pe([t.memoize],m.prototype,"extensionDevelopmentKind",null),pe([t.memoize],m.prototype,"extensionTestsLocationURI",null),pe([t.memoize],m.prototype,"debugExtensionHost",null),pe([t.memoize],m.prototype,"logLevel",null),pe([t.memoize],m.prototype,"extensionLogLevel",null),pe([t.memoize],m.prototype,"serviceMachineIdResource",null),pe([t.memoize],m.prototype,"telemetryLogResource",null),pe([t.memoize],m.prototype,"disableWorkspaceTrust",null),pe([t.memoize],m.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=m;function y(w,d){return h(w["inspect-extensions"],w["inspect-brk-extensions"],5870,d,w.debugId,w.extensionEnvironment)}e.parseExtensionHostPort=y;function P(w,d){return h(w["inspect-search"],w["inspect-brk-search"],5876,d,w.extensionEnvironment)}e.parseSearchPort=P;function E(w,d){return h(w["inspect-ptyhost"],w["inspect-brk-ptyhost"],5877,d,w.extensionEnvironment)}e.parsePtyHostPort=E;function h(w,d,b,u,v,g){const c=Number(d||w)||(u?null:b),n=c?Boolean(!!d):!1;let r;if(g)try{r=JSON.parse(g)}catch{}return{port:c,break:n,debugId:v,env:r}}}),define(ee[105],te([0,1,277,4,150]),function(q,e,I,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const M={o:(0,C.localize)(0,null),e:(0,C.localize)(1,null),t:(0,C.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,C.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,C.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,C.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,C.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,C.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,C.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,C.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,C.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,C.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,C.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,C.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,C.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,C.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,C.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,C.localize)(17,null)},category:{type:"string",cat:"e",description:(0,C.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,C.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,C.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,C.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,C.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,C.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,C.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,C.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,C.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,C.localize)(27,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,C.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,C.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,C.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,C.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,C.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,C.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,C.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,C.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const A={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function k(d,b,u=A){const v=d.find(l=>l.length>0&&l[0]!=="-"),g={},f=["_"],c=[],n={};let r;for(const l in b){const o=b[l];o.type==="subcommand"?l===v&&(r=o):(o.alias&&(g[l]=o.alias),o.type==="string"||o.type==="string[]"?(f.push(l),o.deprecates&&f.push(...o.deprecates)):o.type==="boolean"&&(c.push(l),o.deprecates&&c.push(...o.deprecates)),o.global&&(n[l]=o))}if(r&&v){const l=n;for(const L in r.options)l[L]=r.options[L];const o=d.filter(L=>L!==v),S=u.getSubcommandReporter?u.getSubcommandReporter(v):void 0,D=k(o,l,S);return{[v]:D,_:[]}}const i=I(d,{string:f,boolean:c,alias:g}),a={},s=i;a._=i._.map(l=>String(l)).filter(l=>l.length>0),delete s._;for(const l in b){const o=b[l];if(o.type==="subcommand")continue;o.alias&&delete s[o.alias];let S=s[l];if(o.deprecates)for(const D of o.deprecates)s.hasOwnProperty(D)&&(S||(S=s[D],S&&u.onDeprecatedOption(D,o.deprecationMessage||(0,C.localize)(36,null,l))),delete s[D]);if(typeof S<"u"){if(o.type==="string[]"){if(Array.isArray(S)||(S=[S]),!o.allowEmptyValue){const D=S.filter(L=>L.length>0);D.length!==S.length&&(u.onEmptyValue(l),S=D.length>0?D:void 0)}}else o.type==="string"&&(Array.isArray(S)?(S=S.pop(),u.onMultipleValues(l,S)):!S&&!o.allowEmptyValue&&(u.onEmptyValue(l),S=void 0));a[l]=S,o.deprecationMessage&&u.onDeprecatedOption(l,o.deprecationMessage)}delete s[l]}for(const l in s)u.onUnknownOption(l);return a}e.parseArgs=k;function p(d,b){let u="";return b.args&&(Array.isArray(b.args)?u=` <${b.args.join("> <")}>`:u=` <${b.args}>`),b.alias?`-${b.alias} --${d}${u}`:`--${d}${u}`}function m(d,b){const u=[];for(const v in d){const g=d[v],f=p(v,g);u.push([f,g.description])}return y(u,b)}e.formatOptions=m;function y(d,b){const v=d.reduce((c,n)=>Math.max(c,n[0].length),12)+2+1;if(b-v<25)return d.reduce((c,n)=>c.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);const g=b-v-1,f=[];for(const c of d){const n=c[0],r=E(c[1],g),i=P(v-n.length-2);f.push("  "+n+i+r[0]);for(let a=1;a<r.length;a++)f.push(P(v)+r[a])}return f}function P(d){return" ".repeat(d)}function E(d,b){const u=[];for(;d.length;){const v=d.length<b?d.length:d.lastIndexOf(" ",b),g=d.slice(0,v).trim();d=d.slice(v),u.push(g)}return u}function h(d,b,u,v,g){const f=process.stdout.isTTY&&process.stdout.columns||80,c=g?.noInputFiles!==!0?`[${(0,C.localize)(37,null)}...]`:"",n=[`${d} ${u}`];n.push(""),n.push(`${(0,C.localize)(38,null)}: ${b} [${(0,C.localize)(39,null)}]${c}`),n.push(""),g?.noPipe!==!0&&(t.isWindows?n.push((0,C.localize)(40,null,b)):n.push((0,C.localize)(41,null,b)),n.push(""));const r={},i=[];for(const a in v){const s=v[a];if(s.type==="subcommand")s.description&&i.push({command:a,description:s.description});else if(s.description&&s.cat){let l=r[s.cat];l||(r[s.cat]=l={}),l[a]=s}}for(const a in r){const s=a,l=r[s];l&&(n.push(M[s]),n.push(...m(l,f)),n.push(""))}return i.length&&(n.push((0,C.localize)(42,null)),n.push(...y(i.map(a=>[a.command,a.description]),f)),n.push("")),n.join(`
`)}e.buildHelpMessage=h;function w(d,b){return`${d||(0,C.localize)(43,null)}
${b||(0,C.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=w}),define(ee[179],te([0,1,78,177,105]),function(q,e,I,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class M extends t.ExtensionHostDebugBroadcastChannel{constructor(k){super(),this.f=k}call(k,p,m){return p==="openExtensionDevelopmentHostWindow"?this.g(m[0],m[1]):super.call(k,p,m)}async g(k,p){const m=(0,C.parseArgs)(k,C.OPTIONS);m.debugRenderer=p;const y=m.extensionDevelopmentPath;if(!y)return{success:!1};const[P]=await this.f.openExtensionDevelopmentHostWindow(y,{context:5,cli:m,forceProfile:m.profile,forceTempProfile:m["profile-temp"]});if(!p)return{success:!0};const E=P.win;if(!E)return{success:!0};const h=E.webContents.debugger;let w=h.isAttached()?1/0:0;const d=(0,I.createServer)(b=>{w++===0&&h.attach();let u=!1;const v=c=>{u||b.write(JSON.stringify(c)+"\0")},g=(c,n,r,i)=>v({method:n,params:r,sessionId:i});E.on("close",()=>{h.removeListener("message",g),b.end(),u=!0}),h.addListener("message",g);let f=Buffer.alloc(0);b.on("data",c=>{f=Buffer.concat([f,c]);for(let n=f.indexOf(0);n!==-1;n=f.indexOf(0)){let r;try{const i=f.slice(0,n).toString("utf8");f=f.slice(n+1),r=JSON.parse(i)}catch(i){console.error("error reading cdp line",i)}h.sendCommand(r.method,r.params,r.sessionId).then(i=>v({id:r.id,sessionId:r.sessionId,result:i})).catch(i=>v({id:r.id,sessionId:r.sessionId,error:{code:0,message:i.message}}))}}),b.on("error",c=>{console.error("error on cdp pipe:",c)}),b.on("close",()=>{u=!0,--w===0&&h.detach()})});return await new Promise(b=>d.listen(0,b)),E.on("close",()=>d.close()),{rendererDebugPort:d.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=M}),define(ee[61],te([0,1,278,151,105]),function(q,e,I,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const M=2048;function A(E,h){const w=(f,c)=>{console.warn((0,t.localize)(0,null,f,c))},d=f=>{console.warn((0,t.localize)(1,null,f))},b=(f,c)=>{console.warn((0,t.localize)(2,null,f,c))},u=f=>({onUnknownOption:c=>{f!=="tunnel"&&console.warn((0,t.localize)(3,null,c,f))},onMultipleValues:w,onEmptyValue:d,onDeprecatedOption:b,getSubcommandReporter:f!=="tunnel"?u:void 0}),v={onUnknownOption:f=>{console.warn((0,t.localize)(4,null,f))},onMultipleValues:w,onEmptyValue:d,onDeprecatedOption:b,getSubcommandReporter:u},g=(0,C.parseArgs)(E,C.OPTIONS,h?v:void 0);return g.goto&&g._.forEach(f=>I(/^(\w:)?[^:]+(:\d*){0,2}$/.test(f),(0,t.localize)(5,null))),g["max-memory"]&&I(parseInt(g["max-memory"])>=M,`The max-memory argument cannot be specified lower than ${M} MB.`),g}function k(E){const h=E.findIndex(w=>!/^-/.test(w));if(h>-1)return[...E.slice(0,h),...E.slice(h+1)]}function p(E){let[,...h]=E;process.env.VSCODE_DEV&&(h=k(h)||[]);const w=!P(process.env);return A(h,w)}e.parseMainProcessArgv=p;function m(E){let[,,...h]=E;return process.env.VSCODE_DEV&&(h=k(h)||[]),A(h,!0)}e.parseCLIProcessArgv=m;function y(E,...h){const w=E.indexOf("--");return w===-1?E.push(...h):E.splice(w,0,...h),E}e.addArg=y;function P(E){return E.VSCODE_CLI==="1"}e.isLaunchedFromCli=P}),function(){"use strict";function q(e,I,t){function C(A,k){const p=M(A,k),m=[p];return e.isAbsolute(p)||m.unshift(t),e.resolve(...m)}function M(A,k){process.env.VSCODE_DEV&&(k="code-oss-dev");const p=process.env.VSCODE_PORTABLE;if(p)return e.join(p,"user-data");let m=process.env.VSCODE_APPDATA;if(m)return e.join(m,k);const y=A["user-data-dir"];if(y)return y;switch(process.platform){case"win32":if(m=process.env.APPDATA,!m){const P=process.env.USERPROFILE;if(typeof P!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");m=e.join(P,"AppData","Roaming")}break;case"darwin":m=e.join(I.homedir(),"Library","Application Support");break;case"linux":m=process.env.XDG_CONFIG_HOME||e.join(I.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(m,k)}return{getUserDataPath:C}}if(typeof define=="function")define(ee[180],te([181,25,32]),function(e,I,t){return q(e,I,t.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),I=require("os");module.exports=q(e,I,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ee[182],te([0,1,25,178,180]),function(q,e,I,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class M extends t.AbstractNativeEnvironmentService{constructor(k,p){super(k,{homeDir:(0,I.homedir)(),tmpDir:(0,I.tmpdir)(),userDataDir:(0,C.getUserDataPath)(k,p.nameShort)},p)}}e.NativeEnvironmentService=M}),define(ee[183],te([0,1,40,25,30]),function(q,e,I,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=void 0;function M(A){const k=(0,C.randomPath)((0,t.tmpdir)());try{return(0,I.writeFileSync)(k,""),A&&console.log(`Marker file for --wait created: ${k}`),k}catch(p){A&&console.error(`Failed to create marker file for --wait: ${p}`);return}}e.createWaitMarkerFileSync=M}),define(ee[184],te([0,1,12,153]),function(q,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function C(A,k,p){try{M(A,k,p)}catch(m){console.error(m?.message??m)}return A}e.localizeManifest=C;function M(A,k,p){const m=(y,P,E)=>{const h=y[P];if((0,I.isString)(h)){const w=h,d=w.length;if(d>1&&w[0]==="%"&&w[d-1]==="%"){const b=w.substr(1,d-2);let u=k[b];u===void 0&&p&&(u=p[b]);const v=typeof u=="string"?u:u?.message,g=p?.[b],f=typeof g=="string"?g:g?.message;if(!v){f||console.warn(`[${A.name}]: ${(0,t.localize)(0,null,b)}`);return}if(E&&(P==="title"||P==="category")&&f&&f!==v){const c={value:v,original:f};y[P]=c}else y[P]=v}}else if((0,I.isObject)(h))for(const w in h)h.hasOwnProperty(w)&&(w==="commands"?m(h,w,!0):m(h,w,E));else if(Array.isArray(h))for(let w=0;w<h.length;w++)m(h,w,E)};for(const y in A)A.hasOwnProperty(y)&&m(A,y)}}),define(ee[185],te([0,1,14]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class t{constructor(){this.a=new Map}register(M,A){this.a.set(M,A)}updateManifest(M){if(!(!Array.isArray(M.activationEvents)||!M.contributes)&&!(typeof M.main>"u"&&typeof M.browser>"u"))for(const A in M.contributes){const k=this.a.get(A);if(!k)continue;const p=M.contributes[A],m=Array.isArray(p)?p:[p];try{k(m,M.activationEvents)}catch(y){(0,I.onUnexpectedError)(y)}}}}e.ImplicitActivationEventsImpl=t,e.ImplicitActivationEvents=new t}),define(ee[186],te([0,1,20,98,155,187]),function(q,e,I,t,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function p(u){return u=u.trim(),u==="*"||A.test(u)}e.isValidVersionStr=p;function m(u){if(!p(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const v=u.match(A);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=m;function y(u){if(!u)return null;const v=u.majorBase,g=u.majorMustEqual,f=u.minorBase;let c=u.minorMustEqual;const n=u.patchBase;let r=u.patchMustEqual;u.hasCaret&&(v===0||(c=!1),r=!1);let i=0;if(u.preRelease){const a=k.exec(u.preRelease);if(a){const[,s,l,o]=a;i=Date.UTC(Number(s),Number(l)-1,Number(o))}}return{majorBase:v,majorMustEqual:g,minorBase:f,minorMustEqual:c,patchBase:n,patchMustEqual:r,isMinimum:u.hasGreaterEquals,notBefore:i}}e.normalizeVersion=y;function P(u,v,g){let f;typeof u=="string"?f=y(m(u)):f=u;let c;v instanceof Date?c=v.getTime():typeof v=="string"&&(c=new Date(v).getTime());let n;if(typeof g=="string"?n=y(m(g)):n=g,!f||!n)return!1;const r=f.majorBase,i=f.minorBase,a=f.patchBase;let s=n.majorBase,l=n.minorBase,o=n.patchBase;const S=n.notBefore;let D=n.majorMustEqual,L=n.minorMustEqual,j=n.patchMustEqual;return n.isMinimum?r>s?!0:r<s?!1:i>l?!0:i<l||c&&c<S?!1:a>=o:(r===1&&s===0&&(!D||!L||!j)&&(s=1,l=0,o=0,D=!0,L=!1,j=!1),r<s?!1:r>s?!D:i<l?!1:i>l?!L:a<o?!1:a>o?!j:!(c&&c<S))}e.isValidVersion=P;function E(u,v,g,f,c){const n=[];if(typeof f.publisher<"u"&&typeof f.publisher!="string")return n.push([t.default.Error,C.localize(0,null)]),n;if(typeof f.name!="string")return n.push([t.default.Error,C.localize(1,null,"name")]),n;if(typeof f.version!="string")return n.push([t.default.Error,C.localize(2,null,"version")]),n;if(!f.engines)return n.push([t.default.Error,C.localize(3,null,"engines")]),n;if(typeof f.engines.vscode!="string")return n.push([t.default.Error,C.localize(4,null,"engines.vscode")]),n;if(typeof f.extensionDependencies<"u"&&!b(f.extensionDependencies))return n.push([t.default.Error,C.localize(5,null,"extensionDependencies")]),n;if(typeof f.activationEvents<"u"){if(!b(f.activationEvents))return n.push([t.default.Error,C.localize(6,null,"activationEvents")]),n;if(typeof f.main>"u"&&typeof f.browser>"u")return n.push([t.default.Error,C.localize(7,null,"activationEvents","main")]),n}if(typeof f.extensionKind<"u"&&typeof f.main>"u"&&n.push([t.default.Warning,C.localize(8,null,"extensionKind")]),typeof f.main<"u"){if(typeof f.main!="string")return n.push([t.default.Error,C.localize(9,null,"main")]),n;{const a=(0,I.joinPath)(g,f.main);(0,I.isEqualOrParent)(a,g)||n.push([t.default.Warning,C.localize(10,null,a.path,g.path)])}if(typeof f.activationEvents>"u")return n.push([t.default.Error,C.localize(11,null,"activationEvents","main")]),n}if(typeof f.browser<"u"){if(typeof f.browser!="string")return n.push([t.default.Error,C.localize(12,null,"browser")]),n;{const a=(0,I.joinPath)(g,f.browser);(0,I.isEqualOrParent)(a,g)||n.push([t.default.Warning,C.localize(13,null,a.path,g.path)])}if(typeof f.activationEvents>"u")return n.push([t.default.Error,C.localize(14,null,"activationEvents","browser")]),n}if(!M.valid(f.version))return n.push([t.default.Error,C.localize(15,null)]),n;const r=[];if(!h(u,v,f,c,r))for(const a of r)n.push([t.default.Error,a]);return n}e.validateExtensionManifest=E;function h(u,v,g,f,c){return f||typeof g.main>"u"&&typeof g.browser>"u"?!0:d(u,v,g.engines.vscode,c)}e.isValidExtensionVersion=h;function w(u,v,g){return u==="*"||d(v,g,u)}e.isEngineValid=w;function d(u,v,g,f=[]){const c=y(m(g));if(!c)return f.push(C.localize(16,null,g)),!1;if(c.majorBase===0){if(!c.majorMustEqual||!c.minorMustEqual)return f.push(C.localize(17,null,g)),!1}else if(!c.majorMustEqual)return f.push(C.localize(18,null,g)),!1;return P(u,v,c)?!0:(f.push(C.localize(19,null,u,g)),!1)}function b(u){if(!Array.isArray(u))return!1;for(let v=0,g=u.length;v<g;v++)if(typeof u[v]!="string")return!1;return!0}}),define(ee[188],te([0,1,17,29]),function(q,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function C(M,A,k){let p=k&&k.get("storage.serviceMachineId",-1)||null;if(p)return p;try{const y=(await A.readFile(M.serviceMachineIdResource)).value.toString();p=(0,t.isUUID)(y)?y:null}catch{p=null}if(!p){p=(0,t.generateUuid)();try{await A.writeFile(M.serviceMachineIdResource,I.VSBuffer.fromString(p))}catch{}}return k?.store("storage.serviceMachineId",p,-1,1),p}e.getServiceMachineId=C}),define(ee[70],te([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class I{constructor(C,M=[],A=!1){this.ctor=C,this.staticArguments=M,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=I}),define(ee[189],te([0,1,70]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var C;(function(k){k[k.Eager=0]="Eager",k[k.Delayed=1]="Delayed"})(C=e.InstantiationType||(e.InstantiationType={}));function M(k,p,m){p instanceof I.SyncDescriptor||(p=new I.SyncDescriptor(p,[],Boolean(m))),t.push([k,p])}e.registerSingleton=M;function A(){return t}e.getSingletonServiceDescriptors=A}),define(ee[190],te([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class I{constructor(M,A){this.key=M,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.Node=I;class t{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const A of this.a.values())A.outgoing.size===0&&M.push(A);return M}insertEdge(M,A){const k=this.lookupOrInsertNode(M),p=this.lookupOrInsertNode(A);k.outgoing.set(p.key,p),p.incoming.set(k.key,k)}removeNode(M){const A=this.b(M);this.a.delete(A);for(const k of this.a.values())k.outgoing.delete(A),k.incoming.delete(A)}lookupOrInsertNode(M){const A=this.b(M);let k=this.a.get(A);return k||(k=new I(A,M),this.a.set(A,k)),k}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[A,k]of this.a)M.push(`${A}
	(-> incoming)[${[...k.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...k.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,A]of this.a){const k=new Set([M]),p=this.c(A,k);if(p)return p}}c(M,A){for(const[k,p]of M.outgoing){if(A.has(k))return[...A,k].join(" -> ");A.add(k);const m=this.c(p,A);if(m)return m;A.delete(k)}}}e.Graph=t}),define(ee[5],te([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var I;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function k(p){return p[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=k})(I=e._util||(e._util={})),e.IInstantiationService=C("instantiationService");function t(A,k,p){k[I.DI_TARGET]===k?k[I.DI_DEPENDENCIES].push({id:A,index:p}):(k[I.DI_DEPENDENCIES]=[{id:A,index:p}],k[I.DI_TARGET]=k)}function C(A){if(I.serviceIds.has(A))return I.serviceIds.get(A);const k=function(p,m,y){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(k,p,y)};return k.toString=()=>A,I.serviceIds.set(A,k),k}e.createDecorator=C;function M(A){return A}e.refineServiceDecorator=M}),define(ee[62],te([0,1,5]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,I.createDecorator)("backupMainService")}),define(ee[18],te([0,1,12,7,5]),function(q,e,I,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,C.createDecorator)("configurationService");function M(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof t.URI)}e.isConfigurationOverrides=M;function A(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=A;var k;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function p(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=p;function m(u,v){const g=Object.create(null);for(const f in u)y(g,f,u[f],v);return g}e.toValuesTree=m;function y(u,v,g,f){const c=v.split("."),n=c.pop();let r=u;for(let i=0;i<c.length;i++){const a=c[i];let s=r[a];switch(typeof s){case"undefined":s=r[a]=Object.create(null);break;case"object":break;default:f(`Ignoring ${v} as ${c.slice(0,i+1).join(".")} is ${JSON.stringify(s)}`);return}r=s}if(typeof r=="object"&&r!==null)try{r[n]=g}catch{f(`Ignoring ${v} as ${c.join(".")} is ${JSON.stringify(r)}`)}else f(`Ignoring ${v} as ${c.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=y;function P(u,v){const g=v.split(".");E(u,g)}e.removeFromValueTree=P;function E(u,v){const g=v.shift();if(v.length===0){delete u[g];return}if(Object.keys(u).indexOf(g)!==-1){const f=u[g];typeof f=="object"&&!Array.isArray(f)&&(E(f,v),Object.keys(f).length===0&&delete u[g])}}function h(u,v,g){function f(r,i){let a=r;for(const s of i){if(typeof a!="object"||a===null)return;a=a[s]}return a}const c=v.split("."),n=f(u,c);return typeof n>"u"?g:n}e.getConfigurationValue=h;function w(u,v,g){Object.keys(v).forEach(f=>{f!=="__proto__"&&(f in u?I.isObject(u[f])&&I.isObject(v[f])?w(u[f],v[f],g):g&&(u[f]=v[f]):u[f]=v[f])})}e.merge=w;function d(u,v,g){const f=u.inspect(v),c=u.inspect(g);return typeof f.userValue<"u"||typeof f.workspaceValue<"u"||typeof f.workspaceFolderValue<"u"?f.value:typeof c.userValue<"u"||typeof c.workspaceValue<"u"||typeof c.workspaceFolderValue<"u"?c.value:f.defaultValue}e.getMigratedSettingValue=d;function b(u){return u.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=b}),define(ee[71],te([0,1,5]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,I.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,I.createDecorator)("credentialsMainService");class t{constructor(){this.a={}}async getPassword(M,A){return this.a[M]?.[A]??null}async setPassword(M,A,k){this.a[M]=this.a[M]??{},this.a[M][A]=k}async deletePassword(M,A){return this.a[M]?.[A]?(delete this.a[M][A],Object.keys(this.a[M]).length===0&&delete this.a[M],!0):!1}async findPassword(M){return JSON.stringify(this.a[M])??null}async findCredentials(M){const A=[];for(const k of Object.keys(this.a[M]||{}))A.push({account:k,password:this.a[M][k]});return A}async clear(){this.a={}}}e.InMemoryCredentialsProvider=t}),define(ee[84],te([0,1,5]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,I.createDecorator)(e.ID);function t(M){return!!M.hostName&&!!M.errorMessage}e.isRemoteDiagnosticError=t;class C{async getPerformanceInfo(A,k){return{}}async getSystemInfo(A,k){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(A,k){return""}async getWorkspaceFileExtensions(A){return{extensions:[]}}async reportWorkspaceStats(A){}}e.NullDiagnosticsService=C}),define(ee[106],te([0,1,5]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,I.createDecorator)("encryptionMainService")}),define(ee[34],te([0,1,5]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,I.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,I.refineServiceDecorator)(e.IEnvironmentService)}),define(ee[27],te([0,1,53,9,83,34,182,5]),function(q,e,I,t,C,M,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,k.refineServiceDecorator)(M.IEnvironmentService);class p extends A.NativeEnvironmentService{get cachedLanguagesPath(){return(0,t.join)(this.userDataPath,"clp")}get backupHome(){return(0,t.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,C.createStaticIPCHandle)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,t.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}pe([I.memoize],p.prototype,"cachedLanguagesPath",null),pe([I.memoize],p.prototype,"backupHome",null),pe([I.memoize],p.prototype,"mainIPCHandle",null),pe([I.memoize],p.prototype,"mainLockfile",null),pe([I.memoize],p.prototype,"disableUpdates",null),pe([I.memoize],p.prototype,"disableKeytar",null),pe([I.memoize],p.prototype,"crossOriginIsolated",null),pe([I.memoize],p.prototype,"codeCachePath",null),pe([I.memoize],p.prototype,"useCodeCache",null),e.EnvironmentMainService=p}),define(ee[191],te([0,1,152,5]),function(q,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function C(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=C;function M(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=M;function A(u,v){switch(u){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=A;function k(u,v){return v==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=k;function p(u,v,g){return k(v,g)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===g?!0:m(g).includes(u)}e.isTargetPlatformCompatible=p;function m(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=m;function y(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=y;var P;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(P=e.SortBy||(e.SortBy={}));var E;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(E=e.SortOrder||(e.SortOrder={}));var h;(function(u){u.Install="install",u.Uninstall="uninstall"})(h=e.StatisticType||(e.StatisticType={}));var w;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(w=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var d;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal",u.Signature="Signature"})(d=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class b extends Error{constructor(v,g){super(v),this.code=g,this.name=g}}e.ExtensionManagementError=b,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,I.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,I.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(ee[192],te([0,1,5]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,I.createDecorator)("extensionUrlTrustService")}),define(ee[193],te([0,1,5]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,I.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(ee[107],te([0,1,5]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,I.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,I.createDecorator)("externalTerminal")}),define(ee[194],te([0,1,46,15,9,4,79,23,82,156,107]),function(q,e,I,t,C,M,A,k,p,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const P=m.localize(0,null);class E{async getDefaultTerminalForPlatforms(){return{windows:h.getDefaultTerminalWindows(),linux:await d.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class h extends E{openTerminal(f,c){return this.spawnTerminal(I,f,p.getWindowsShell(),c)}spawnTerminal(f,c,n,r){const i=c.windowsExec||h.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const a=C.basename(i).toLowerCase();if(a==="cmder"||a==="cmder.exe")return f.spawn(i,r?[r]:void 0),Promise.resolve(void 0);const s=["/c","start","/wait"];return i.indexOf(" ")>=0&&s.push('""'),s.push(i),(a==="wt"||a==="wt.exe")&&s.push("-d ."),new Promise((l,o)=>{const S=b(process),D=f.spawn(n,s,{cwd:r,env:S});D.on("error",o),D.on("exit",()=>l())})}runInTerminal(f,c,n,r,i){const a="windowsExec"in i&&i.windowsExec?i.windowsExec:h.getDefaultTerminalWindows();return new Promise((s,l)=>{const o=`"${c} - ${P}"`,S=`""${n.join('" "')}" & pause"`,D=["/c","start",o,"/wait",a,"/c",S],L=Object.assign({},b(process),r);Object.keys(L).filter(ae=>L[ae]===null).forEach(ae=>delete L[ae]);const j={cwd:c,env:L,windowsVerbatimArguments:!0};I.spawn(h.b,D,j).on("error",ae=>{l(u(ae))}),s(void 0)})}static getDefaultTerminalWindows(){if(!h.d){const f=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");h.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${f?"Sysnative":"System32"}\\cmd.exe`}return h.d}}e.WindowsExternalTerminalService=h,h.b="cmd.exe";class w extends E{openTerminal(f,c){return this.spawnTerminal(I,f,c)}runInTerminal(f,c,n,r,i){const a=i.osxExec||y.DEFAULT_TERMINAL_OSX;return new Promise((s,l)=>{if(a===y.DEFAULT_TERMINAL_OSX||a==="iTerm.app"){const o=a===y.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",D=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${o}.scpt`).fsPath,"-t",f||P,"-w",c];for(const X of n)D.push("-a"),D.push(X);if(r){const X=Object.assign({},b(process),r);for(const ae in X){const Y=X[ae];Y===null?(D.push("-u"),D.push(ae)):(D.push("-e"),D.push(`${ae}=${Y}`))}}let L="";const j=I.spawn(w.b,D);j.on("error",X=>{l(u(X))}),j.stderr.on("data",X=>{L+=X.toString()}),j.on("exit",X=>{if(X===0)s(void 0);else if(L){const ae=L.split(`
`,1);l(new Error(ae[0]))}else l(new Error(m.localize(1,null,o,X)))})}else l(new Error(m.localize(2,null,a)))})}spawnTerminal(f,c,n){const r=c.osxExec||y.DEFAULT_TERMINAL_OSX;return new Promise((i,a)=>{const s=["-a",r];n&&s.push(n);const l=b(process),o=f.spawn("/usr/bin/open",s,{cwd:n,env:l});o.on("error",a),o.on("exit",()=>i())})}}e.MacExternalTerminalService=w,w.b="/usr/bin/osascript";class d extends E{openTerminal(f,c){return this.spawnTerminal(I,f,c)}runInTerminal(f,c,n,r,i){const a=i.linuxExec?Promise.resolve(i.linuxExec):d.getDefaultTerminalLinuxReady();return new Promise((s,l)=>{const o=[];a.then(S=>{S.indexOf("gnome-terminal")>=0?o.push("-x"):o.push("-e"),o.push("bash"),o.push("-c");const D=`${v(n)}; echo; read -p "${d.b}" -n1;`;o.push(`''${D}''`);const L=Object.assign({},b(process),r);Object.keys(L).filter(Y=>L[Y]===null).forEach(Y=>delete L[Y]);const j={cwd:c,env:L};let X="";const ae=I.spawn(S,o,j);ae.on("error",Y=>{l(u(Y))}),ae.stderr.on("data",Y=>{X+=Y.toString()}),ae.on("exit",Y=>{if(Y===0)s(void 0);else if(X){const J=X.split(`
`,1);l(new Error(J[0]))}else l(new Error(m.localize(4,null,S,Y)))})})})}static async getDefaultTerminalLinuxReady(){if(!d.d)if(!M.isLinux)d.d=Promise.resolve("xterm");else{const f=await k.Promises.exists("/etc/debian_version");d.d=new Promise(c=>{f?c("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?c("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?c("konsole"):process.env.COLORTERM?c(process.env.COLORTERM):process.env.TERM?c(process.env.TERM):c("xterm")})}return d.d}spawnTerminal(f,c,n){const r=c.linuxExec?Promise.resolve(c.linuxExec):d.getDefaultTerminalLinuxReady();return new Promise((i,a)=>{r.then(s=>{const l=b(process),o=f.spawn(s,[],{cwd:n,env:l});o.on("error",a),o.on("exit",()=>i())})})}}e.LinuxExternalTerminalService=d,d.b=m.localize(3,null);function b(g){const f={...g.env};return(0,A.sanitizeProcessEnvironment)(f),f}function u(g){return"errno"in g&&g.errno==="ENOENT"&&"path"in g&&typeof g.path=="string"?new Error(m.localize(5,null,g.path)):g}function v(g){let f="";for(const c of g)c.indexOf(" ")>=0?f+='"'+c+'"':f+=c,f+=" ";return f}}),define(ee[16],te([0,1,60,9,26,12,7,158,5]),function(q,e,I,t,C,M,A,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,p.createDecorator)("fileService");function m(K){return K.create===!0}e.isFileOpenForWriteOptions=m;var y;(function(K){K[K.Unknown=0]="Unknown",K[K.File=1]="File",K[K.Directory=2]="Directory",K[K.SymbolicLink=64]="SymbolicLink"})(y=e.FileType||(e.FileType={}));var P;(function(K){K[K.Readonly=1]="Readonly"})(P=e.FilePermission||(e.FilePermission={}));var E;(function(K){K[K.FileReadWrite=2]="FileReadWrite",K[K.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",K[K.FileReadStream=16]="FileReadStream",K[K.FileFolderCopy=8]="FileFolderCopy",K[K.PathCaseSensitive=1024]="PathCaseSensitive",K[K.Readonly=2048]="Readonly",K[K.Trash=4096]="Trash",K[K.FileWriteUnlock=8192]="FileWriteUnlock",K[K.FileAtomicRead=16384]="FileAtomicRead",K[K.FileClone=32768]="FileClone"})(E=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function h(K){return!!(K.capabilities&2)}e.hasReadWriteCapability=h;function w(K){return!!(K.capabilities&8)}e.hasFileFolderCopyCapability=w;function d(K){return!!(K.capabilities&32768)}e.hasFileCloneCapability=d;function b(K){return!!(K.capabilities&4)}e.hasOpenReadWriteCloseCapability=b;function u(K){return!!(K.capabilities&16)}e.hasFileReadStreamCapability=u;function v(K){return h(K)?!!(K.capabilities&16384):!1}e.hasFileAtomicReadCapability=v;var g;(function(K){K.FileExists="EntryExists",K.FileNotFound="EntryNotFound",K.FileNotADirectory="EntryNotADirectory",K.FileIsADirectory="EntryIsADirectory",K.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",K.FileTooLarge="EntryTooLarge",K.FileWriteLocked="EntryWriteLocked",K.NoPermissions="NoPermissions",K.Unavailable="Unavailable",K.Unknown="Unknown"})(g=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class f extends Error{constructor(le,W){super(le),this.code=W}}e.FileSystemProviderError=f;function c(K,le){const W=new f(K.toString(),le);return r(W,le),W}e.createFileSystemProviderError=c;function n(K){return K||c((0,k.localize)(0,null),g.Unknown)}e.ensureFileSystemProviderError=n;function r(K,le){return K.name=le?`${le} (FileSystemError)`:"FileSystemError",K}e.markAsFileSystemProviderError=r;function i(K){if(!K)return g.Unknown;if(K instanceof f)return K.code;const le=/^(.+) \(FileSystemError\)$/.exec(K.name);if(!le)return g.Unknown;switch(le[1]){case g.FileExists:return g.FileExists;case g.FileIsADirectory:return g.FileIsADirectory;case g.FileNotADirectory:return g.FileNotADirectory;case g.FileNotFound:return g.FileNotFound;case g.FileExceedsMemoryLimit:return g.FileExceedsMemoryLimit;case g.FileTooLarge:return g.FileTooLarge;case g.FileWriteLocked:return g.FileWriteLocked;case g.NoPermissions:return g.NoPermissions;case g.Unavailable:return g.Unavailable}return g.Unknown}e.toFileSystemProviderErrorCode=i;function a(K){if(K instanceof L)return K.fileOperationResult;switch(i(K)){case g.FileNotFound:return 1;case g.FileIsADirectory:return 0;case g.FileNotADirectory:return 10;case g.FileWriteLocked:return 5;case g.NoPermissions:return 6;case g.FileExists:return 4;case g.FileExceedsMemoryLimit:return 9;case g.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=a;var s;(function(K){K[K.CREATE=0]="CREATE",K[K.DELETE=1]="DELETE",K[K.MOVE=2]="MOVE",K[K.COPY=3]="COPY",K[K.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class l{constructor(le,W,F){this.resource=le,this.operation=W,this.target=F}isOperation(le){return this.operation===le}}e.FileOperationEvent=l;var o;(function(K){K[K.UPDATED=0]="UPDATED",K[K.ADDED=1]="ADDED",K[K.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class S{constructor(le,W){this.a=void 0,this.b=void 0,this.c=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=le;const F=new Map;for(const N of le){const H=F.get(N.type);switch(H?H.push([N.resource,N]):F.set(N.type,[[N.resource,N]]),N.type){case 1:this.rawAdded.push(N.resource);break;case 0:this.rawUpdated.push(N.resource);break;case 2:this.rawDeleted.push(N.resource);break}}for(const[N,H]of F)switch(N){case 1:this.a=I.TernarySearchTree.forUris(()=>W),this.a.fill(H);break;case 0:this.b=I.TernarySearchTree.forUris(()=>W),this.b.fill(H);break;case 2:this.c=I.TernarySearchTree.forUris(()=>W),this.c.fill(H);break}}contains(le,...W){return this.d(le,{includeChildren:!1},...W)}affects(le,...W){return this.d(le,{includeChildren:!0},...W)}d(le,W,...F){if(!le)return!1;const N=F.length>0;return!!((!N||F.includes(1))&&(this.a?.get(le)||W.includeChildren&&this.a?.findSuperstr(le))||(!N||F.includes(0))&&(this.b?.get(le)||W.includeChildren&&this.b?.findSuperstr(le))||(!N||F.includes(2))&&(this.c?.findSubstr(le)||W.includeChildren&&this.c?.findSuperstr(le)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=S;function D(K,le,W){return!K||!le||K===le||le.length>K.length?!1:(le.charAt(le.length-1)!==t.sep&&(le+=t.sep),W?(0,C.startsWithIgnoreCase)(K,le):K.indexOf(le)===0)}e.isParent=D;class L extends Error{constructor(le,W,F){super(le),this.fileOperationResult=W,this.options=F}}e.FileOperationError=L;class j extends L{constructor(le,W,F){super(le,2,F),this.stat=W}}e.NotModifiedSinceFileOperationError=j;var X;(function(K){K[K.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",K[K.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",K[K.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",K[K.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",K[K.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",K[K.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",K[K.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",K[K.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",K[K.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",K[K.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",K[K.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",K[K.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(X=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var ae;(function(K){K[K.FILE=0]="FILE",K[K.FOLDER=1]="FOLDER",K[K.ROOT_FOLDER=2]="ROOT_FOLDER"})(ae=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function Y(K){if(!(typeof K.size!="number"||typeof K.mtime!="number"))return K.mtime.toString(29)+K.size.toString(31)}e.etag=Y;async function J(K,le){if(!le.hasProvider(A.URI.from({scheme:K.scheme})))return new Promise(W=>{const F=le.onDidChangeFileSystemProviderRegistrations(N=>{N.scheme===K.scheme&&N.added&&(F.dispose(),W())})})}e.whenProviderRegistered=J,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class se{static formatSize(le){return(0,M.isNumber)(le)||(le=0),le<se.KB?(0,k.localize)(1,null,le.toFixed(0)):le<se.MB?(0,k.localize)(2,null,(le/se.KB).toFixed(2)):le<se.GB?(0,k.localize)(3,null,(le/se.MB).toFixed(2)):le<se.TB?(0,k.localize)(4,null,(le/se.GB).toFixed(2)):(0,k.localize)(5,null,(le/se.TB).toFixed(2))}}e.ByteSize=se,se.KB=1024,se.MB=se.KB*se.KB,se.GB=se.MB*se.KB,se.TB=se.GB*se.KB;var ne;(function(K){K[K.IA32=0]="IA32",K[K.OTHER=1]="OTHER"})(ne=e.Arch||(e.Arch={}));function he(K){return{maxFileSize:K===0?300*se.MB:16*se.GB,maxHeapSize:K===0?700*se.MB:2*700*se.MB}}e.getPlatformLimits=he}),define(ee[195],te([0,1,17,45,14,3,2,59,7,29,16]),function(q,e,I,t,C,M,A,k,p,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class P extends A.Disposable{constructor(h,w){super(),this.a=h,this.b=w,this.onDidChangeCapabilities=M.Event.None,this.f=this.B(new M.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new M.Emitter),this.onDidWatchError=this.g.event,this.h=(0,m.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(h){return this.a.call("stat",[h])}readdir(h){return this.a.call("readdir",[h])}async readFile(h,w){const{buffer:d}=await this.a.call("readFile",[h,w]);return d}readFileStream(h,w,d){const b=(0,k.newWriteableStream)(v=>I.VSBuffer.concat(v.map(g=>I.VSBuffer.wrap(g))).buffer),u=this.a.listen("readFileStream",[h,w])(v=>{if(v instanceof I.VSBuffer)b.write(v.buffer);else{if(v==="end")b.end();else{let g=v;g instanceof Error||(g=(0,y.createFileSystemProviderError)((0,t.toErrorMessage)(g),y.FileSystemProviderErrorCode.Unknown)),b.error(g),b.end()}u.dispose()}});return d.onCancellationRequested(()=>{b.error((0,C.canceled)()),b.end(),u.dispose()}),b}writeFile(h,w,d){return this.a.call("writeFile",[h,I.VSBuffer.wrap(w),d])}open(h,w){return this.a.call("open",[h,w])}close(h){return this.a.call("close",[h])}async read(h,w,d,b,u){const[v,g]=await this.a.call("read",[h,w,u]);return d.set(v.buffer.slice(0,g),b),g}write(h,w,d,b,u){return this.a.call("write",[h,w,I.VSBuffer.wrap(d),b,u])}mkdir(h){return this.a.call("mkdir",[h])}delete(h,w){return this.a.call("delete",[h,w])}rename(h,w,d){return this.a.call("rename",[h,w,d])}copy(h,w,d){return this.a.call("copy",[h,w,d])}cloneFile(h,w){return this.a.call("cloneFile",[h,w])}i(){this.B(this.a.listen("fileChange",[this.h])(h=>{if(Array.isArray(h)){const w=h;this.f.fire(w.map(d=>({resource:p.URI.revive(d.resource),type:d.type})))}else{const w=h;this.g.fire(w)}}))}watch(h,w){const d=(0,m.generateUuid)();return this.a.call("watch",[this.h,d,h,w]),(0,A.toDisposable)(()=>this.a.call("unwatch",[this.h,d]))}}e.DiskFileSystemProviderClient=P}),define(ee[108],te([0,1,17,14,159,16]),function(q,e,I,t,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function A(y,P,E,h,w,d){let b;try{await k(y,P,E,h,w,d)}catch(u){b=u}finally{b&&w.errorTransformer&&(b=w.errorTransformer(b)),typeof b<"u"&&E.error(b),E.end()}}e.readFileIntoStream=A;async function k(y,P,E,h,w,d){p(d);const b=await y.open(P,{create:!1});try{p(d);let u=0,v=0,g=w&&typeof w.length=="number"?w.length:void 0,f=I.VSBuffer.alloc(Math.min(w.bufferSize,typeof g=="number"?g:w.bufferSize)),c=w&&typeof w.position=="number"?w.position:0,n=0;do v=await y.read(b,c,f.buffer,n,f.byteLength-n),c+=v,n+=v,u+=v,typeof g=="number"&&(g-=v),n===f.byteLength&&(await E.write(h(f)),f=I.VSBuffer.alloc(Math.min(w.bufferSize,typeof g=="number"?g:w.bufferSize)),n=0);while(v>0&&(typeof g!="number"||g>0)&&p(d)&&m(u,w));if(n>0){let r=n;typeof g=="number"&&(r=Math.min(n,g)),E.write(h(f.slice(0,r)))}}catch(u){throw(0,M.ensureFileSystemProviderError)(u)}finally{await y.close(b)}}function p(y){if(y.isCancellationRequested)throw(0,t.canceled)();return!0}function m(y,P){if(P?.limits){if(typeof P.limits.memory=="number"&&y>P.limits.memory)throw(0,M.createFileSystemProviderError)((0,C.localize)(0,null),M.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof P.limits.size=="number"&&y>P.limits.size)throw(0,M.createFileSystemProviderError)((0,C.localize)(1,null),M.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ee[72],te([0,1,99,2,9,4,7,16]),function(q,e,I,t,C,M,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function p(u){return u.recursive===!0}e.isRecursiveWatchRequest=p;class m extends t.Disposable{constructor(v,g,f,c){super(),this.h=v,this.i=g,this.j=f,this.k=c,this.c=this.B(new t.MutableDisposable),this.f=void 0,this.g=0}m(){const v=new t.DisposableStore;this.c.value=v,this.b=this.l(v),this.b.setVerboseLogging(this.j),v.add(this.b.onDidChangeFile(g=>this.h(g))),v.add(this.b.onDidLogMessage(g=>this.i(g))),v.add(this.b.onDidError(g=>this.n(g)))}n(v){this.k.restartOnError?this.g<m.a&&this.f?(this.r(`restarting watcher after error: ${v}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${v}`):this.r(v)}p(v){this.g++,this.m(),this.watch(v)}async watch(v){this.f=v,await this.b?.watch(v)}async setVerboseLogging(v){this.j=v,await this.b?.setVerboseLogging(v)}r(v){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${v}`})}dispose(){return this.b=void 0,super.dispose()}}e.AbstractWatcherClient=m,m.a=5;class y extends m{constructor(v,g,f){super(v,g,f,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=y;class P extends m{constructor(v,g,f){super(v,g,f,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=P;function E(u){return u.map(v=>({type:v.type,resource:A.URI.file(v.path)}))}e.toFileChanges=E;function h(u){const v=new b;for(const g of u)v.processEvent(g);return v.coalesce()}e.coalesceEvents=h;function w(u,v){return typeof v=="string"&&!v.startsWith(I.GLOBSTAR)&&!(0,C.isAbsolute)(v)?{base:u,pattern:v}:v}e.normalizeWatcherPattern=w;function d(u,v){const g=[];for(const f of v)g.push((0,I.parse)(w(u,f)));return g}e.parseWatcherPatterns=d;class b{constructor(){this.a=new Set,this.b=new Map}c(v){return M.isLinux?v.path:v.path.toLowerCase()}processEvent(v){const g=this.b.get(this.c(v));let f=!1;if(g){const c=g.type,n=v.type;g.path!==v.path&&(v.type===2||v.type===1)?f=!0:c===1&&n===2?(this.b.delete(this.c(v)),this.a.delete(g)):c===2&&n===1?g.type=0:c===1&&n===0||(g.type=n)}else f=!0;f&&(this.a.add(v),this.b.set(this.c(v),v))}coalesce(){const v=[],g=[];return Array.from(this.a).filter(f=>f.type!==2?(v.push(f),!1):!0).sort((f,c)=>f.path.length-c.path.length).filter(f=>g.some(c=>(0,k.isParent)(f.path,c,!M.isLinux))?!1:(g.push(f.path),!0)).concat(v)}}}),define(ee[196],te([0,1,40,8,22,30,2,76,9,4,100,23,72]),function(q,e,I,t,C,M,A,k,p,m,y,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class h extends A.Disposable{constructor(b,u,v,g){super(),this.k=b,this.l=u,this.m=v,this.n=g,this.c=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},f=>this.l(f)),this.f=this.B(new t.ThrottledDelayer(h.b)),this.g=[],this.h=(0,E.parseWatcherPatterns)(this.k.path,this.k.excludes),this.i=this.k.includes?(0,E.parseWatcherPatterns)(this.k.path,this.k.includes):void 0,this.j=new C.CancellationTokenSource,this.ready=this.r()}async r(){try{const b=await this.s(this.k);if(this.j.token.isCancellationRequested)return;const u=await P.Promises.stat(b);this.B(await this.t(b,u.isDirectory()))}catch(b){b.code!=="ENOENT"?this.w(b):this.z(b)}}async s(b){let u=b.path;try{u=await P.Promises.realpath(b.path),b.path===u&&(u=await(0,y.realcase)(b.path)??b.path),b.path!==u&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${b.path}, real: ${u})`)}catch{}return u}async t(b,u){if(m.isMacintosh&&(0,M.isEqualOrParent)(b,"/Volumes/",!0))return this.w(`Refusing to watch ${b} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.Disposable.None;const v=new C.CancellationTokenSource(this.j.token),g=new A.DisposableStore;try{const f=(0,p.basename)(b),c=(0,I.watch)(b);g.add((0,A.toDisposable)(()=>{c.removeAllListeners(),c.close()})),this.z(`Started watching: '${b}'`);const n=new Set;if(u)try{for(const i of await P.Promises.readdir(b))n.add(i)}catch(i){this.w(i)}const r=new Map;g.add((0,A.toDisposable)(()=>{for(const[,i]of r)i.dispose();r.clear()})),c.on("error",(i,a)=>{this.w(`Failed to watch ${b} for changes using fs.watch() (${i}, ${a})`),this.dispose()}),c.on("change",(i,a)=>{if(v.token.isCancellationRequested)return;this.z(`[raw] ["${i}"] ${a}`);let s="";if(a&&(s=a.toString(),m.isMacintosh&&(s=(0,k.normalizeNFC)(s))),!(!s||i!=="change"&&i!=="rename"))if(u)if(i==="rename"){r.get(s)?.dispose();const l=setTimeout(async()=>{if(r.delete(s),s===f&&!await P.Promises.exists(b)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const o=await this.v((0,p.join)(b,s));if(v.token.isCancellationRequested)return;let S;o?n.has(s)?S=0:(S=1,n.add(s)):(n.delete(s),S=2),this.u({path:(0,p.join)(this.k.path,s),type:S})},h.a);r.set(s,(0,A.toDisposable)(()=>clearTimeout(l)))}else{let l;n.has(s)?l=0:(l=1,n.add(s)),this.u({path:(0,p.join)(this.k.path,s),type:l})}else if(i==="rename"||s!==f){const l=setTimeout(async()=>{const o=await P.Promises.exists(b);v.token.isCancellationRequested||(o?(this.u({path:this.k.path,type:0},!0),g.add(await this.t(b,!1))):(await this.u({path:this.k.path,type:2},!0),this.dispose()))},h.a);g.clear(),g.add((0,A.toDisposable)(()=>clearTimeout(l)))}else this.u({path:this.k.path,type:0},!0)})}catch(f){await P.Promises.exists(b)&&!v.token.isCancellationRequested&&this.w(`Failed to watch ${b} for changes using fs.watch() (${f.toString()})`)}return(0,A.toDisposable)(()=>{v.dispose(!0),g.dispose()})}async u(b,u=!1){if(!this.j.token.isCancellationRequested){this.n&&this.z(`${b.type===1?"[ADDED]":b.type===2?"[DELETED]":"[CHANGED]"} ${b.path}`),!u&&this.h.some(v=>v(b.path))?this.n&&this.z(` >> ignored (excluded) ${b.path}`):!u&&this.i&&this.i.length>0&&!this.i.some(v=>v(b.path))?this.n&&this.z(` >> ignored (not included) ${b.path}`):this.g.push(b);try{await this.f.trigger(async()=>{const v=this.g;this.g=[];const g=(0,E.coalesceEvents)(v);if(g.length>0){if(this.n)for(const c of g)this.z(`>> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`);this.c.work(g)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${g[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${g.length}, most recent change: ${g[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async v(b){if(m.isLinux)return P.Promises.exists(b);try{const u=(0,p.basename)(b);return(await P.Promises.readdir((0,p.dirname)(b))).some(g=>g===u)}catch(u){return this.z(u),!1}}setVerboseLogging(b){this.n=b}w(b){this.j.token.isCancellationRequested||this.m?.({type:"error",message:`[File Watcher (node.js)] ${b}`})}y(b){this.j.token.isCancellationRequested||this.m?.({type:"warn",message:`[File Watcher (node.js)] ${b}`})}z(b){!this.j.token.isCancellationRequested&&this.n&&this.m?.({type:"trace",message:`[File Watcher (node.js)] ${b}`})}dispose(){this.z(`stopping file watcher on ${this.k.path}`),this.j.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=h,h.a=100,h.b=50;async function w(d,b,u,v,g=512){const f=await P.Promises.open(d,"r"),c=Buffer.allocUnsafe(g),n=new C.CancellationTokenSource(v);let r,i=!1;const a={path:d,excludes:[],recursive:!1},s=new h(a,l=>{(async()=>{for(const{type:o}of l)if(o===0){if(i)return;i=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:S}=await P.Promises.read(f,c,0,g,null);if(!S||n.token.isCancellationRequested)break;b(c.slice(0,S))}}catch(S){r=new Error(S),n.dispose(!0)}finally{i=!1}}})()});return await s.ready,u(),new Promise((l,o)=>{n.token.onCancellationRequested(async()=>{s.dispose();try{await P.Promises.close(f)}catch(S){r=new Error(S)}r?o(r):l()})})}e.watchFileContents=w}),define(ee[197],te([0,1,3,99,2,4,196]),function(q,e,I,t,C,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class k extends C.Disposable{constructor(){super(...arguments),this.a=this.B(new I.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new I.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=I.Event.None,this.c=new Map,this.f=!1}async watch(m){const y=this.i(m),P=y.filter(h=>{const w=this.c.get(h.path);return w?!(0,t.patternsEquals)(w.request.excludes,h.excludes)||!(0,t.patternsEquals)(w.request.includes,h.includes):!0}),E=Array.from(this.c.values()).filter(({request:h})=>!y.find(w=>w.path===h.path&&(0,t.patternsEquals)(w.excludes,h.excludes)&&(0,t.patternsEquals)(w.includes,h.includes))).map(({request:h})=>h.path);P.length&&this.j(`Request to start watching: ${P.map(h=>`${h.path} (excludes: ${h.excludes.length>0?h.excludes:"<none>"}, includes: ${h.includes&&h.includes.length>0?JSON.stringify(h.includes):"<all>"})`).join(",")}`),E.length&&this.j(`Request to stop watching: ${E.join(",")}`);for(const h of E)this.h(h);for(const h of P)this.g(h)}g(m){const y=new A.NodeJSFileWatcherLibrary(m,E=>this.a.fire(E),E=>this.b.fire(E),this.f),P={request:m,instance:y};this.c.set(m.path,P)}async stop(){for(const[m]of this.c)this.h(m);this.c.clear()}h(m){const y=this.c.get(m);y&&(this.c.delete(m),y.instance.dispose())}i(m){const y=new Map;for(const P of m){const E=M.isLinux?P.path:P.path.toLowerCase();y.set(E,P)}return Array.from(y.values())}async setVerboseLogging(m){this.f=m;for(const[,y]of this.c)y.instance.setVerboseLogging(m)}j(m){this.f&&this.b.fire({type:"trace",message:this.k(m)})}k(m,y){return y?`[File Watcher (node.js)] ${m} (path: ${y.request.path})`:`[File Watcher (node.js)] ${m}`}}e.NodeJSWatcher=k}),define(ee[198],te([0,1,72,197]),function(q,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class C extends I.AbstractNonRecursiveWatcherClient{constructor(A,k,p){super(A,k,p),this.m()}l(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=C}),define(ee[199],te([0,1,15,47,145,72]),function(q,e,I,t,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class A extends M.AbstractUniversalWatcherClient{constructor(p,m,y){super(p,m,y),this.m()}l(p){const m=p.add(new C.Client(I.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return p.add(m.onDidProcessExit(({code:y,signal:P})=>this.n(`terminated by itself with code ${y}, signal: ${P}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(m.getChannel("watcher")))}}e.UniversalWatcherClient=A}),define(ee[85],te([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class I{constructor(...C){this.a=new Map;for(const[M,A]of C)this.set(M,A)}set(C,M){const A=this.a.get(C);return this.a.set(C,M),A}has(C){return this.a.has(C)}get(C){return this.a.get(C)}}e.ServiceCollection=I}),define(ee[200],te([0,1,8,14,2,70,190,5,85,96]),function(q,e,I,t,C,M,A,k,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const y=!1;class P extends Error{constructor(b){super("cyclic dependency between services"),this.message=b.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${b.toString()}`}}class E{constructor(b=new p.ServiceCollection,u=!1,v,g=y){this.f=b,this.g=u,this.h=v,this.i=g,this.o=new Set,this.f.set(k.IInstantiationService,this),this._globalGraph=g?v?._globalGraph??new A.Graph(f=>f):void 0}createChild(b){return new E(b,this.g,this,this.i)}invokeFunction(b,...u){const v=w.traceInvocation(this.i,b);let g=!1;try{return b({get:c=>{if(g)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const n=this.m(c,v);if(!n)throw new Error(`[invokeFunction] unknown service '${c}'`);return n}},...u)}finally{g=!0,v.stop()}}createInstance(b,...u){let v,g;return b instanceof M.SyncDescriptor?(v=w.traceCreation(this.i,b.ctor),g=this.j(b.ctor,b.staticArguments.concat(u),v)):(v=w.traceCreation(this.i,b),g=this.j(b,u,v)),v.stop(),g}j(b,u=[],v){const g=k._util.getServiceDependencies(b).sort((n,r)=>n.index-r.index),f=[];for(const n of g){const r=this.m(n.id,v);r||this.u(`[createInstance] ${b.name} depends on UNKNOWN service ${n.id}.`,!1),f.push(r)}const c=g.length>0?g[0].index:u.length;if(u.length!==c){console.trace(`[createInstance] First service dependency of ${b.name} at position ${c+1} conflicts with ${u.length} static arguments`);const n=c-u.length;n>0?u=u.concat(new Array(n)):u=u.slice(0,c)}return Reflect.construct(b,u.concat(f))}k(b,u){if(this.f.get(b)instanceof M.SyncDescriptor)this.f.set(b,u);else if(this.h)this.h.k(b,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l(b){const u=this.f.get(b);return!u&&this.h?this.h.l(b):u}m(b,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(b));const v=this.l(b);return v instanceof M.SyncDescriptor?this.q(b,v,u.branch(b,!0)):(u.branch(b,!1),v)}q(b,u,v){if(this.o.has(b))throw new Error(`illegal state - RECURSIVELY instantiating service '${b}'`);this.o.add(b);try{return this.r(b,u,v)}finally{this.o.delete(b)}}r(b,u,v){const g=new A.Graph(n=>n.id.toString());let f=0;const c=[{id:b,desc:u,_trace:v}];for(;c.length;){const n=c.pop();if(g.lookupOrInsertNode(n),f++>1e3)throw new P(g);for(const r of k._util.getServiceDependencies(n.desc.ctor)){const i=this.l(r.id);if(i||this.u(`[createInstance] ${b} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(r.id)),i instanceof M.SyncDescriptor){const a={id:r.id,desc:i,_trace:n._trace.branch(r.id,!0)};g.insertEdge(n,a),c.push(a)}}}for(;;){const n=g.roots();if(n.length===0){if(!g.isEmpty())throw new P(g);break}for(const{data:r}of n){if(this.l(r.id)instanceof M.SyncDescriptor){const a=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,a)}g.removeNode(r)}}return this.l(b)}s(b,u,v=[],g,f){if(this.f.get(b)instanceof M.SyncDescriptor)return this.t(b,u,v,g,f);if(this.h)return this.h.s(b,u,v,g,f);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t(b,u,v=[],g,f){if(g){const c=new E(void 0,this.g,this,this.i);c.c=String(b);const n=new Map,r=new I.IdleValue(()=>{const i=c.j(u,v,f);for(const[a,s]of n){const l=i[a];if(typeof l=="function")for(const o of s)l.apply(i,o)}return n.clear(),i});return new Proxy(Object.create(null),{get(i,a){if(!r.isInitialized&&typeof a=="string"&&(a.startsWith("onDid")||a.startsWith("onWill"))){let o=n.get(a);return o||(o=new m.LinkedList,n.set(a,o)),(D,L,j)=>{const X=o.push([D,L,j]);return(0,C.toDisposable)(X)}}if(a in i)return i[a];const s=r.value;let l=s[a];return typeof l!="function"||(l=l.bind(s),i[a]=l),l},set(i,a,s){return r.value[a]=s,!0}})}else return this.j(u,v,f)}u(b,u){if(u&&console.warn(b),this.g)throw new Error(b)}}e.InstantiationService=E;var h;(function(d){d[d.Creation=0]="Creation",d[d.Invocation=1]="Invocation",d[d.Branch=2]="Branch"})(h||(h={}));class w{static traceInvocation(b,u){return b?new w(1,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):w.c}static traceCreation(b,u){return b?new w(0,u.name):w.c}constructor(b,u){this.type=b,this.name=u,this.g=Date.now(),this.h=[]}branch(b,u){const v=new w(2,b.toString());return this.h.push([b,u,v]),v}stop(){const b=Date.now()-this.g;w.f+=b;let u=!1;function v(f,c){const n=[],r=new Array(f+1).join("	");for(const[i,a,s]of c.h)if(a&&s){u=!0,n.push(`${r}CREATES -> ${i}`);const l=v(f+1,s);l&&n.push(l)}else n.push(`${r}uses -> ${i}`);return n.join(`
`)}const g=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${b.toFixed(2)}ms (grand total ${w.f.toFixed(2)}ms)`];(b>2||u)&&w.all.add(g.join(`
`))}}e.Trace=w,w.all=new Set,w.c=new class extends w{constructor(){super(-1,null)}stop(){}branch(){return this}},w.f=0}),define(ee[6],te([0,1,45,3,2,39,4,7,5]),function(q,e,I,t,C,M,A,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,p.createDecorator)("logService"),e.ILoggerService=(0,p.createDecorator)("loggerService");function m(){return new Date().toISOString()}var y;(function(l){l[l.Off=0]="Off",l[l.Trace=1]="Trace",l[l.Debug=2]="Debug",l[l.Info=3]="Info",l[l.Warning=4]="Warning",l[l.Error=5]="Error"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;function P(l,o,S){switch(o){case y.Trace:l.trace(S);break;case y.Debug:l.debug(S);break;case y.Info:l.info(S);break;case y.Warning:l.warn(S);break;case y.Error:l.error(S);break;case y.Off:break;default:throw new Error(`Invalid log level ${o}`)}}e.log=P;function E(l){let o="";for(let S=0;S<l.length;S++){let D=l[S];if(typeof D=="object")try{D=JSON.stringify(D)}catch{}o+=(S>0?" ":"")+D}return o}e.format=E;class h extends C.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new t.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(o){this.b!==o&&(this.b=o,this.c.fire(this.b))}getLevel(){return this.b}f(o){return this.b!==y.Off&&this.b<=o}}e.AbstractLogger=h;class w extends h{constructor(o){super(),this.h=o}f(o){return this.h||super.f(o)}trace(o,...S){this.f(y.Trace)&&this.g(y.Trace,E([o,...S]))}debug(o,...S){this.f(y.Debug)&&this.g(y.Debug,E([o,...S]))}info(o,...S){this.f(y.Info)&&this.g(y.Info,E([o,...S]))}warn(o,...S){this.f(y.Warning)&&this.g(y.Warning,E([o,...S]))}error(o,...S){if(this.f(y.Error))if(o instanceof Error){const D=Array.prototype.slice.call(arguments);D[0]=o.stack,this.g(y.Error,E(D))}else this.g(y.Error,E([o,...S]))}flush(){}}e.AbstractMessageLogger=w;class d extends h{constructor(o=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(o),this.g=!A.isWindows}trace(o,...S){this.f(y.Trace)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,o,...S):console.log(`[main ${m()}]`,o,...S))}debug(o,...S){this.f(y.Debug)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,o,...S):console.log(`[main ${m()}]`,o,...S))}info(o,...S){this.f(y.Info)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,o,...S):console.log(`[main ${m()}]`,o,...S))}warn(o,...S){this.f(y.Warning)&&(this.g?console.warn(`\x1B[93m[main ${m()}]\x1B[0m`,o,...S):console.warn(`[main ${m()}]`,o,...S))}error(o,...S){this.f(y.Error)&&(this.g?console.error(`\x1B[91m[main ${m()}]\x1B[0m`,o,...S):console.error(`[main ${m()}]`,o,...S))}dispose(){}flush(){}}e.ConsoleMainLogger=d;class b extends h{constructor(o=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(o)}trace(o,...S){this.f(y.Trace)&&console.log("%cTRACE","color: #888",o,...S)}debug(o,...S){this.f(y.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",o,...S)}info(o,...S){this.f(y.Info)&&console.log("%c INFO","color: #33f",o,...S)}warn(o,...S){this.f(y.Warning)&&console.log("%c WARN","color: #993",o,...S)}error(o,...S){this.f(y.Error)&&console.log("%c  ERR","color: #f33",o,...S)}dispose(){}flush(){}}e.ConsoleLogger=b;class u extends h{constructor(o,S=e.DEFAULT_LOG_LEVEL){super(),this.g=o,this.setLevel(S)}trace(o,...S){this.f(y.Trace)&&this.g.log(y.Trace,[this.h(o),...S])}debug(o,...S){this.f(y.Debug)&&this.g.log(y.Debug,[this.h(o),...S])}info(o,...S){this.f(y.Info)&&this.g.log(y.Info,[this.h(o),...S])}warn(o,...S){this.f(y.Warning)&&this.g.log(y.Warning,[this.h(o),...S])}error(o,...S){this.f(y.Error)&&this.g.log(y.Error,[this.h(o),...S])}h(o){return typeof o=="string"?o:(0,I.toErrorMessage)(o,this.f(y.Trace))}dispose(){}flush(){}}e.AdapterLogger=u;class v extends h{constructor(o){super(),this.g=o,o.length&&this.setLevel(o[0].getLevel())}setLevel(o){for(const S of this.g)S.setLevel(o);super.setLevel(o)}trace(o,...S){for(const D of this.g)D.trace(o,...S)}debug(o,...S){for(const D of this.g)D.debug(o,...S)}info(o,...S){for(const D of this.g)D.info(o,...S)}warn(o,...S){for(const D of this.g)D.warn(o,...S)}error(o,...S){for(const D of this.g)D.error(o,...S)}flush(){for(const o of this.g)o.flush()}dispose(){for(const o of this.g)o.dispose()}}e.MultiplexLogService=v;class g extends C.Disposable{constructor(o){super(),this.b=o,this.B(o)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(o){this.b.setLevel(o)}getLevel(){return this.b.getLevel()}trace(o,...S){this.b.trace(o,...S)}debug(o,...S){this.b.debug(o,...S)}info(o,...S){this.b.info(o,...S)}warn(o,...S){this.b.warn(o,...S)}error(o,...S){this.b.error(o,...S)}flush(){this.b.flush()}}e.LogService=g;class f extends C.Disposable{constructor(o,S){super(),this.c=o,this.b=new M.ResourceMap,this.B(S(D=>this.setLevel(D)))}getLoggers(){return[...this.b.values()].map(({logger:o})=>o)}getLogger(o){return this.b.get(o)?.logger}createLogger(o,S,D){let L=this.b.get(o)?.logger;return L||(D=S?.always?y.Trace:D,L=this.f(o,D??this.c,S),this.b.set(o,{logger:L,logLevel:D})),L}setLevel(o,S){const D=k.URI.isUri(o)?o:void 0,L=D?S:o;if(D){const j=this.b.get(D);j&&j.logLevel!==L&&(j.logLevel=L,j.logger.setLevel(L))}else this.c=L,this.b.forEach(({logLevel:j,logger:X})=>{j===void 0&&X.setLevel(this.c)})}getLogLevel(o){return this.b.get(o)?.logLevel}dispose(){this.b.forEach(({logger:o})=>o.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=f;class c{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(o){}getLevel(){return y.Info}trace(o,...S){}debug(o,...S){}info(o,...S){}warn(o,...S){}error(o,...S){}critical(o,...S){}dispose(){}flush(){}}e.NullLogger=c;class n extends c{}e.NullLogService=n;class r extends f{constructor(){super(y.Info,t.Event.None)}f(o,S,D){return new c}}e.NullLoggerService=r;function i(l){if(l.verbose)return y.Trace;if(typeof l.logLevel=="string"){const o=s(l.logLevel.toLowerCase());if(o!==void 0)return o}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=i;function a(l){switch(l){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Off:return"off"}}e.LogLevelToString=a;function s(l){switch(l){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Error;case"off":return y.Off}}e.parseLogLevel=s});var _=this&&this.__param||function(q,e){return function(I,t){e(I,t,q)}};define(ee[201],te([0,1,71,3,2,6,4,8]),function(q,e,I,t,C,M,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let p=class Et extends C.Disposable{constructor(y){super(),this.g=y,this.c=this.B(new t.Emitter),this.onDidChangePassword=this.c.event}async getPassword(y,P){this.g.trace("Getting password from keytar:",y,P);let E;try{E=await this.h()}catch{return null}const h=await(0,k.retry)(()=>E.getPassword(y,P),50,3);if(!h)return this.g.trace("Did not get a password from keytar for account:",P),h;let w,d;try{const b=JSON.parse(h);w=b.content,d=b.hasNextChunk}catch{}if(!w||!d)return this.g.trace("Got password from keytar for account:",P),h;try{let b=1;for(;d;){const u=await(0,k.retry)(()=>E.getPassword(y,`${P}-${b}`),50,3),v=JSON.parse(u);w+=v.content,d=v.hasNextChunk,b++}return this.g.trace(`Got ${b}-chunked password from keytar for account:`,P),w}catch(b){return this.g.error(b),h}}async setPassword(y,P,E){this.g.trace("Setting password using keytar:",y,P);let h;try{h=await this.h()}catch(w){throw this.i?.(w),w}if(A.isWindows&&E.length>Et.a){let w=0,d=0,b=!0;for(;b;){const u=E.substring(w,w+Et.b);w+=Et.b,b=E.length-w>0;const v={content:u,hasNextChunk:b};await(0,k.retry)(()=>h.setPassword(y,d?`${P}-${d}`:P,JSON.stringify(v)),50,3),d++}this.g.trace(`Got${d?` ${d}-chunked`:""} password from keytar for account:`,P)}else await(0,k.retry)(()=>h.setPassword(y,P,E),50,3),this.g.trace("Got password from keytar for account:",P);this.c.fire({service:y,account:P})}async deletePassword(y,P){this.g.trace("Deleting password using keytar:",y,P);let E;try{E=await this.h()}catch(u){throw this.i?.(u),u}const h=await E.getPassword(y,P);if(!h)return this.g.trace("Did not get a password to delete from keytar for account:",P),!1;let w,d;try{const u=JSON.parse(h);w=u.content,d=u.hasNextChunk}catch{}let b=0;if(w&&d)try{for(b++;d;){const u=`${P}-${b}`,v=await E.getPassword(y,u);await E.deletePassword(y,u),d=JSON.parse(v).hasNextChunk,b++}}catch(u){this.g.error(u)}return await E.deletePassword(y,P)?(this.c.fire({service:y,account:P}),this.g.trace(`Deleted${b?` ${b}-chunked`:""} password from keytar for account:`,P),!0):(this.g.trace(`Keytar failed to delete${b?` ${b}-chunked`:""} password for account:`,P),!1)}async findPassword(y){let P;try{P=await this.h()}catch{return null}return await P.findPassword(y)}async findCredentials(y){let P;try{P=await this.h()}catch{return[]}return await P.findCredentials(y)}clear(){return this.f instanceof I.InMemoryCredentialsProvider?this.f.clear():Promise.resolve()}};p.a=2500,p.b=p.a-100,p=pe([_(0,M.ILogService)],p),e.BaseCredentialsMainService=p}),define(ee[202],te([0,1,6]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;let t=class{constructor(M,A){this.a=M,this.b=A}c(){return new Promise((M,A)=>q(["vscode-encrypt"],M,A))}async encrypt(M){let A;try{A=await this.c()}catch{return M}try{return A.encrypt(this.a,M)}catch(k){return this.b.error(k),M}}async decrypt(M){let A;try{A=await this.c()}catch{return M}try{return A.decrypt(this.a,M)}catch(k){return this.b.error(k),M}}};t=pe([_(1,I.ILogService)],t),e.EncryptionMainService=t}),define(ee[203],te([0,1,24,8,14,3,2,9,72,6]),function(q,e,I,t,C,M,A,k,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class y extends A.Disposable{constructor(E,h){super(),this.a=E,this.b=h,this.c=this.B(new M.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new M.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new t.ThrottledDelayer(0)),this.s=[],this.t=this.B(new t.ThrottledDelayer(0))}watch(E,h){return h.recursive||this.b?.watcher?.forceUniversal?this.l(E,h):this.u(E,h)}l(E,h){const w={path:this.C(E),excludes:h.excludes,includes:h.includes,recursive:h.recursive},d=(0,I.insert)(this.j,w);return this.m(),(0,A.toDisposable)(()=>{d(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(E=>(0,C.onUnexpectedError)(E))}n(){this.h||(this.h=this.B(this.p(h=>this.c.fire((0,p.toFileChanges)(h)),h=>this.z(h),this.a.getLevel()===m.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===m.LogLevel.Trace)})));const E=this.b?.watcher?.recursive?.usePolling;if(E===!0)for(const h of this.j)(0,p.isRecursiveWatchRequest)(h)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(E))for(const h of this.j)(0,p.isRecursiveWatchRequest)(h)&&E.includes(h.path)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(E,h){const w={path:this.C(E),excludes:h.excludes,includes:h.includes,recursive:!1},d=(0,I.insert)(this.s,w);return this.v(),(0,A.toDisposable)(()=>{d(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(E=>(0,C.onUnexpectedError)(E))}w(){return this.r||(this.r=this.B(this.y(E=>this.c.fire((0,p.toFileChanges)(E)),E=>this.z(E),this.a.getLevel()===m.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===m.LogLevel.Trace)}))),this.r.watch(this.s)}z(E){E.type==="error"&&this.g.fire(E.message),this.a[E.type](E.message)}C(E){return(0,k.normalize)(E.fsPath)}}e.AbstractDiskFileSystemProvider=y}),define(ee[204],te([0,1,24,8,17,22,3,68,67,2,60,15,73,20,59,157,16,108,6]),function(q,e,I,t,C,M,A,k,p,m,y,P,E,h,w,d,b,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let g=class extends m.Disposable{constructor(c){super(),this.b=c,this.a=256*1024,this.c=this.B(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new A.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new A.Emitter),this.onDidRunOperation=this.m.event,this.Q=this.B(new A.Emitter),this.onDidFilesChange=this.Q.event,this.R=this.B(new A.Emitter),this.onDidWatchError=this.R.event,this.S=new Map,this.W=this.B(new t.ResourceQueue)}registerProvider(c,n){if(this.h.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,E.mark)(`code/registerFilesystem/${c}`);const r=new m.DisposableStore;return this.h.set(c,n),this.c.fire({added:!0,scheme:c,provider:n}),r.add(n.onDidChangeFile(i=>this.Q.fire(new b.FileChangesEvent(i,!this.N(n))))),typeof n.onDidWatchError=="function"&&r.add(n.onDidWatchError(i=>this.R.fire(new Error(i)))),r.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:c}))),(0,m.toDisposable)(()=>{this.c.fire({added:!1,scheme:c,provider:n}),this.h.delete(c),(0,m.dispose)(r)})}getProvider(c){return this.h.get(c)}async activateProvider(c){const n=[];this.f.fire({scheme:c,join(r){n.push(r)}}),!this.h.has(c)&&await t.Promises.settled(n)}async canHandleResource(c){return await this.activateProvider(c.scheme),this.hasProvider(c)}hasProvider(c){return this.h.has(c.scheme)}hasCapability(c,n){const r=this.h.get(c.scheme);return!!(r&&r.capabilities&n)}listCapabilities(){return p.Iterable.map(this.h,([c,n])=>({scheme:c,capabilities:n.capabilities}))}async j(c){if(!(0,h.isAbsolutePath)(c))throw new b.FileOperationError((0,d.localize)(0,null,this.mb(c)),8);await this.activateProvider(c.scheme);const n=this.h.get(c.scheme);if(!n){const r=new Error;throw r.name="ENOPRO",r.message=(0,d.localize)(1,null,c.toString()),r}return n}async k(c){const n=await this.j(c);if((0,b.hasOpenReadWriteCloseCapability)(n)||(0,b.hasReadWriteCapability)(n)||(0,b.hasFileReadStreamCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(c){const n=await this.j(c);if((0,b.hasOpenReadWriteCloseCapability)(n)||(0,b.hasReadWriteCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,n){try{return await this.n(c,n)}catch(r){throw(0,b.toFileSystemProviderErrorCode)(r)===b.FileSystemProviderErrorCode.FileNotFound?new b.FileOperationError((0,d.localize)(2,null,this.mb(c)),1):(0,b.ensureFileSystemProviderError)(r)}}async n(c,n){const r=await this.j(c),i=this.N(r),a=n?.resolveTo,s=n?.resolveSingleChildDescendants,l=n?.resolveMetadata,o=await r.stat(c);let S;return this.p(r,c,o,void 0,!!l,(D,L)=>(S||(S=y.TernarySearchTree.forUris(()=>!i),S.set(c,!0),a&&S.fill(!0,a)),S.get(D.resource)||S.findSuperstr(D.resource.with({query:null,fragment:null}))?!0:D.isDirectory&&s?L===1:!1))}async p(c,n,r,i,a,s){const{providerExtUri:l}=this.M(c),o={resource:n,name:l.basename(n),isFile:(r.type&b.FileType.File)!==0,isDirectory:(r.type&b.FileType.Directory)!==0,isSymbolicLink:(r.type&b.FileType.SymbolicLink)!==0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&b.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,b.etag)({mtime:r.mtime,size:r.size}),children:void 0};if(o.isDirectory&&s(o,i)){try{const S=await c.readdir(n),D=await t.Promises.settled(S.map(async([L,j])=>{try{const X=l.joinPath(n,L),ae=a?await c.stat(X):{type:j};return await this.p(c,X,ae,S.length,a,s)}catch(X){return this.b.trace(X),null}}));o.children=(0,I.coalesce)(D)}catch(S){this.b.trace(S),o.children=[]}return o}return o}async resolveAll(c){return t.Promises.settled(c.map(async n=>{try{return{stat:await this.n(n.resource,n.options),success:!0}}catch(r){return this.b.trace(r),{stat:void 0,success:!1}}}))}async stat(c){const n=await this.j(c),r=await n.stat(c);return this.p(n,c,r,void 0,!0,()=>!1)}async exists(c){const n=await this.j(c);try{return!!await n.stat(c)}catch{return!1}}async canCreateFile(c,n){try{await this.r(c,n)}catch(r){return r}return!0}async r(c,n){if(!n?.overwrite&&await this.exists(c))throw new b.FileOperationError((0,d.localize)(3,null,this.mb(c)),3,n)}async createFile(c,n=C.VSBuffer.fromString(""),r){await this.r(c,r);const i=await this.writeFile(c,n);return this.m.fire(new b.FileOperationEvent(c,0,i)),i}async writeFile(c,n,r){const i=this.kb(await this.l(c),c),{providerExtUri:a}=this.M(i);try{await this.s(i,c,r)||await this.O(i,a.dirname(c));let l;if((0,b.hasReadWriteCapability)(i)&&!(n instanceof C.VSBuffer))if((0,w.isReadableStream)(n)){const o=await(0,w.peekStream)(n,3);o.ended?l=C.VSBuffer.concat(o.buffer):l=o}else l=(0,w.peekReadable)(n,o=>C.VSBuffer.concat(o),3);else l=n;!(0,b.hasOpenReadWriteCloseCapability)(i)||(0,b.hasReadWriteCapability)(i)&&l instanceof C.VSBuffer?await this.bb(i,c,r,l):await this.X(i,c,r,l instanceof C.VSBuffer?(0,C.bufferToReadable)(l):l),this.m.fire(new b.FileOperationEvent(c,4))}catch(s){throw new b.FileOperationError((0,d.localize)(4,null,this.mb(c),(0,b.ensureFileSystemProviderError)(s).toString()),(0,b.toFileOperationResult)(s),r)}return this.resolve(c,{resolveMetadata:!0})}async s(c,n,r){if(!!r?.unlock&&!(c.capabilities&8192))throw new Error((0,d.localize)(5,null,this.mb(n)));let a;try{a=await c.stat(n)}catch{return}if((a.type&b.FileType.Directory)!==0)throw new b.FileOperationError((0,d.localize)(6,null,this.mb(n)),0,r);if(this.lb(n,a),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==b.ETAG_DISABLED&&typeof a.mtime=="number"&&typeof a.size=="number"&&r.mtime<a.mtime&&r.etag!==(0,b.etag)({mtime:r.mtime,size:a.size}))throw new b.FileOperationError((0,d.localize)(7,null),3,r);return a}async readFile(c,n,r){const i=await this.k(c);return n?.atomic?this.t(i,c,n,r):this.u(i,c,n,r)}async t(c,n,r,i){return new Promise((a,s)=>{this.W.queueFor(n,this.M(c).providerExtUri).queue(async()=>{try{const l=await this.u(c,n,r,i);a(l)}catch(l){s(l)}})})}async u(c,n,r,i){const a=await this.v(c,n,{...r,preferUnbuffered:!0},i);return{...a,value:await(0,C.streamToBuffer)(a.value)}}async readFileStream(c,n,r){const i=await this.k(c);return this.v(i,c,n,r)}async v(c,n,r,i){const a=new M.CancellationTokenSource(i),s=this.D(n,r).then(o=>o,o=>{throw a.cancel(),o});let l;try{return typeof r?.etag=="string"&&r.etag!==b.ETAG_DISABLED&&await s,r?.atomic&&(0,b.hasFileAtomicReadCapability)(c)||!((0,b.hasOpenReadWriteCloseCapability)(c)||(0,b.hasFileReadStreamCapability)(c))||(0,b.hasReadWriteCapability)(c)&&r?.preferUnbuffered?l=this.C(c,n,r):(0,b.hasFileReadStreamCapability)(c)?l=this.w(c,n,a.token,r):l=this.z(c,n,a.token,r),{...await s,value:l}}catch(o){l&&await(0,w.consumeStream)(l);const S=(0,d.localize)(8,null,this.mb(n),(0,b.ensureFileSystemProviderError)(o).toString());throw o instanceof b.NotModifiedSinceFileOperationError?new b.NotModifiedSinceFileOperationError(S,o.stat,r):new b.FileOperationError(S,(0,b.toFileOperationResult)(o),r)}}w(c,n,r,i=Object.create(null)){const a=c.readFileStream(n,i,r);return(0,w.transform)(a,{data:s=>s instanceof C.VSBuffer?s:C.VSBuffer.wrap(s),error:s=>new b.FileOperationError((0,d.localize)(9,null,this.mb(n),(0,b.ensureFileSystemProviderError)(s).toString()),(0,b.toFileOperationResult)(s),i)},s=>C.VSBuffer.concat(s))}z(c,n,r,i=Object.create(null)){const a=(0,C.newWriteableBufferStream)();return(0,u.readFileIntoStream)(c,n,a,s=>s,{...i,bufferSize:this.a,errorTransformer:s=>new b.FileOperationError((0,d.localize)(10,null,this.mb(n),(0,b.ensureFileSystemProviderError)(s).toString()),(0,b.toFileOperationResult)(s),i)},r),a}C(c,n,r){const i=(0,w.newWriteableStream)(a=>C.VSBuffer.concat(a));return(async()=>{try{let a;r?.atomic&&(0,b.hasFileAtomicReadCapability)(c)?a=await c.readFile(n,{atomic:!0}):a=await c.readFile(n),typeof r?.position=="number"&&(a=a.slice(r.position)),typeof r?.length=="number"&&(a=a.slice(0,r.length)),this.F(n,a.byteLength,r),i.end(C.VSBuffer.wrap(a))}catch(a){i.error(a),i.end()}})(),i}async D(c,n){const r=await this.resolve(c,{resolveMetadata:!0});if(r.isDirectory)throw new b.FileOperationError((0,d.localize)(11,null,this.mb(c)),0,n);if(typeof n?.etag=="string"&&n.etag!==b.ETAG_DISABLED&&n.etag===r.etag)throw new b.NotModifiedSinceFileOperationError((0,d.localize)(12,null),r,n);return this.F(c,r.size,n),r}F(c,n,r){if(r?.limits){let i;if(typeof r.limits.memory=="number"&&n>r.limits.memory&&(i=9),typeof r.limits.size=="number"&&n>r.limits.size&&(i=7),typeof i=="number")throw new b.FileOperationError((0,d.localize)(13,null,this.mb(c)),i)}}async canMove(c,n,r){return this.G(c,n,"move",r)}async canCopy(c,n,r){return this.G(c,n,"copy",r)}async G(c,n,r,i){if(c.toString()!==n.toString())try{const a=r==="move"?this.kb(await this.l(c),c):await this.k(c),s=this.kb(await this.l(n),n);await this.L(a,c,s,n,r,i)}catch(a){return a}return!0}async move(c,n,r){const i=this.kb(await this.l(c),c),a=this.kb(await this.l(n),n),s=await this.H(i,c,a,n,"move",!!r),l=await this.resolve(n,{resolveMetadata:!0});return this.m.fire(new b.FileOperationEvent(c,s==="move"?2:3,l)),l}async copy(c,n,r){const i=await this.k(c),a=this.kb(await this.l(n),n),s=await this.H(i,c,a,n,"copy",!!r),l=await this.resolve(n,{resolveMetadata:!0});return this.m.fire(new b.FileOperationEvent(c,s==="copy"?3:2,l)),l}async H(c,n,r,i,a,s){if(n.toString()===i.toString())return a;const{exists:l,isSameResourceWithDifferentPathCase:o}=await this.L(c,n,r,i,a,s);if(l&&!o&&s&&await this.del(i,{recursive:!0}),await this.O(r,this.M(r).providerExtUri.dirname(i)),a==="copy"){if(c===r&&(0,b.hasFileFolderCopyCapability)(c))await c.copy(n,i,{overwrite:s});else{const S=await this.resolve(n);S.isDirectory?await this.J(c,S,r,i):await this.I(c,n,r,i)}return a}else return c===r?(await c.rename(n,i,{overwrite:s}),a):(await this.H(c,n,r,i,"copy",s),await this.del(n,{recursive:!0}),"copy")}async I(c,n,r,i){if((0,b.hasOpenReadWriteCloseCapability)(c)&&(0,b.hasOpenReadWriteCloseCapability)(r))return this.db(c,n,r,i);if((0,b.hasOpenReadWriteCloseCapability)(c)&&(0,b.hasReadWriteCapability)(r))return this.jb(c,n,r,i);if((0,b.hasReadWriteCapability)(c)&&(0,b.hasOpenReadWriteCloseCapability)(r))return this.hb(c,n,r,i);if((0,b.hasReadWriteCapability)(c)&&(0,b.hasReadWriteCapability)(r))return this.fb(c,n,r,i)}async J(c,n,r,i){await r.mkdir(i),Array.isArray(n.children)&&await t.Promises.settled(n.children.map(async a=>{const s=this.M(r).providerExtUri.joinPath(i,a.name);return a.isDirectory?this.J(c,await this.resolve(a.resource),r,s):this.I(c,a.resource,r,s)}))}async L(c,n,r,i,a,s){let l=!1;if(c===r){const{providerExtUri:S,isPathCaseSensitive:D}=this.M(c);if(D||(l=S.isEqual(n,i)),l&&a==="copy")throw new Error((0,d.localize)(14,null,this.mb(n),this.mb(i)));if(!l&&S.isEqualOrParent(i,n))throw new Error((0,d.localize)(15,null,this.mb(n),this.mb(i)))}const o=await this.exists(i);if(o&&!l){if(!s)throw new b.FileOperationError((0,d.localize)(16,null,this.mb(n),this.mb(i)),4);if(c===r){const{providerExtUri:S}=this.M(c);if(S.isEqualOrParent(n,i))throw new Error((0,d.localize)(17,null,this.mb(n),this.mb(i)))}}return{exists:o,isSameResourceWithDifferentPathCase:l}}M(c){const n=this.N(c);return{providerExtUri:n?h.extUri:h.extUriIgnorePathCase,isPathCaseSensitive:n}}N(c){return!!(c.capabilities&1024)}async createFolder(c){const n=this.kb(await this.j(c),c);await this.O(n,c);const r=await this.resolve(c,{resolveMetadata:!0});return this.m.fire(new b.FileOperationEvent(c,0,r)),r}async O(c,n){const r=[],{providerExtUri:i}=this.M(c);for(;!i.isEqual(n,i.dirname(n));)try{if(((await c.stat(n)).type&b.FileType.Directory)===0)throw new Error((0,d.localize)(18,null,this.mb(n)));break}catch(a){if((0,b.toFileSystemProviderErrorCode)(a)!==b.FileSystemProviderErrorCode.FileNotFound)throw a;r.push(i.basename(n)),n=i.dirname(n)}for(let a=r.length-1;a>=0;a--){n=i.joinPath(n,r[a]);try{await c.mkdir(n)}catch(s){if((0,b.toFileSystemProviderErrorCode)(s)!==b.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(c,n){try{await this.P(c,n)}catch(r){return r}return!0}async P(c,n){const r=this.kb(await this.j(c),c);if(!!n?.useTrash&&!(r.capabilities&4096))throw new Error((0,d.localize)(19,null,this.mb(c)));let a;try{a=await r.stat(c)}catch{}if(a)this.lb(c,a);else throw new b.FileOperationError((0,d.localize)(20,null,this.mb(c)),1);if(!!!n?.recursive){const l=await this.resolve(c);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,d.localize)(21,null,this.mb(c)))}return r}async del(c,n){const r=await this.P(c,n),i=!!n?.useTrash,a=!!n?.recursive;await r.delete(c,{recursive:a,useTrash:i}),this.m.fire(new b.FileOperationEvent(c,1))}async cloneFile(c,n){const r=await this.j(c),i=this.kb(await this.l(n),n);if(r===i&&this.M(r).providerExtUri.isEqual(c,n))return;if(r===i&&(0,b.hasFileCloneCapability)(r))return r.cloneFile(c,n);await this.O(i,this.M(i).providerExtUri.dirname(n));const a=this.W.queueFor(c,this.M(r).providerExtUri);return r===i&&(0,b.hasFileFolderCopyCapability)(r)?a.queue(()=>r.copy(c,n,{overwrite:!0})):a.queue(()=>this.I(r,c,i,n))}watch(c,n={recursive:!1,excludes:[]}){const r=new m.DisposableStore;let i=!1,a=()=>{i=!0};return r.add((0,m.toDisposable)(()=>a())),(async()=>{try{const s=await this.U(c,n);i?(0,m.dispose)(s):a=()=>(0,m.dispose)(s)}catch(s){this.b.error(s)}})(),r}async U(c,n){const r=await this.j(c),i=(0,k.hash)([this.M(r).providerExtUri.getComparisonKey(c),n]);let a=this.S.get(i);return a||(a={count:0,disposable:r.watch(c,n)},this.S.set(i,a)),a.count+=1,(0,m.toDisposable)(()=>{a&&(a.count--,a.count===0&&((0,m.dispose)(a.disposable),this.S.delete(i)))})}dispose(){super.dispose();for(const[,c]of this.S)(0,m.dispose)(c.disposable);this.S.clear()}async X(c,n,r,i){return this.W.queueFor(n,this.M(c).providerExtUri).queue(async()=>{const a=await c.open(n,{create:!0,unlock:r?.unlock??!1});try{(0,w.isReadableStream)(i)||(0,w.isReadableBufferedStream)(i)?await this.Y(c,a,i):await this.Z(c,a,i)}catch(s){throw(0,b.ensureFileSystemProviderError)(s)}finally{await c.close(a)}})}async Y(c,n,r){let i=0,a;if((0,w.isReadableBufferedStream)(r)){if(r.buffer.length>0){const s=C.VSBuffer.concat(r.buffer);await this.ab(c,n,s,s.byteLength,i,0),i+=s.byteLength}if(r.ended)return;a=r.stream}else a=r;return new Promise((s,l)=>{(0,w.listenStream)(a,{onData:async o=>{a.pause();try{await this.ab(c,n,o,o.byteLength,i,0)}catch(S){return l(S)}i+=o.byteLength,setTimeout(()=>a.resume())},onError:o=>l(o),onEnd:()=>s()})})}async Z(c,n,r){let i=0,a;for(;(a=r.read())!==null;)await this.ab(c,n,a,a.byteLength,i,0),i+=a.byteLength}async ab(c,n,r,i,a,s){let l=0;for(;l<i;)l+=await c.write(n,a+l,r.buffer,s+l,i-l)}async bb(c,n,r,i){return this.W.queueFor(n,this.M(c).providerExtUri).queue(()=>this.cb(c,n,r,i))}async cb(c,n,r,i){let a;i instanceof C.VSBuffer?a=i:(0,w.isReadableStream)(i)?a=await(0,C.streamToBuffer)(i):(0,w.isReadableBufferedStream)(i)?a=await(0,C.bufferedStreamToBuffer)(i):a=(0,C.readableToBuffer)(i),await c.writeFile(n,a.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async db(c,n,r,i){return this.W.queueFor(i,this.M(r).providerExtUri).queue(()=>this.eb(c,n,r,i))}async eb(c,n,r,i){let a,s;try{a=await c.open(n,{create:!1}),s=await r.open(i,{create:!0,unlock:!1});const l=C.VSBuffer.alloc(this.a);let o=0,S=0,D=0;do D=await c.read(a,o,l.buffer,S,l.byteLength-S),await this.ab(r,s,l,D,o,S),o+=D,S+=D,S===l.byteLength&&(S=0);while(D>0)}catch(l){throw(0,b.ensureFileSystemProviderError)(l)}finally{await t.Promises.settled([typeof a=="number"?c.close(a):Promise.resolve(),typeof s=="number"?r.close(s):Promise.resolve()])}}async fb(c,n,r,i){return this.W.queueFor(i,this.M(r).providerExtUri).queue(()=>this.gb(c,n,r,i))}async gb(c,n,r,i){return r.writeFile(i,await c.readFile(n),{create:!0,overwrite:!0,unlock:!1})}async hb(c,n,r,i){return this.W.queueFor(i,this.M(r).providerExtUri).queue(()=>this.ib(c,n,r,i))}async ib(c,n,r,i){const a=await r.open(i,{create:!0,unlock:!1});try{const s=await c.readFile(n);await this.ab(r,a,C.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,b.ensureFileSystemProviderError)(s)}finally{await r.close(a)}}async jb(c,n,r,i){const a=await(0,C.streamToBuffer)(this.z(c,n,M.CancellationToken.None));await this.bb(r,i,void 0,a)}kb(c,n){if(c.capabilities&2048)throw new b.FileOperationError((0,d.localize)(22,null,this.mb(n)),6);return c}lb(c,n){if((n.permissions??0)&b.FilePermission.Readonly)throw new b.FileOperationError((0,d.localize)(23,null,this.mb(c)),6)}mb(c){return c.scheme===P.Schemas.file?c.fsPath:c.toString(!0)}};g=pe([_(0,v.ILogService)],g),e.FileService=g}),define(ee[86],te([0,1,40,279,8,39,17,3,30,2,9,4,20,59,23,161,16,108,203,45,199,198]),function(q,e,I,t,C,M,A,k,p,m,y,P,E,h,w,d,b,u,v,g,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(I)}catch(r){console.error(`Error enabling graceful-fs: ${(0,g.toErrorMessage)(r)}`)}})();class n extends v.AbstractDiskFileSystemProvider{constructor(i,a){super(i,a),this.onDidChangeCapabilities=k.Event.None,this.H=new M.ResourceMap(s=>E.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,P.isLinux&&(this.F|=1024)),this.F}async stat(i){try{const{stat:a,symbolicLink:s}=await w.SymlinkSupport.stat(this.C(i));return{type:this.G(a,s),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.Y(a)}}async readdir(i){try{const a=await w.Promises.readdir(this.C(i),{withFileTypes:!0}),s=[];return await Promise.all(a.map(async l=>{try{let o;l.isSymbolicLink()?o=(await this.stat((0,E.joinPath)(i,l.name))).type:o=this.G(l),s.push([l.name,o])}catch(o){this.a.trace(o)}})),s}catch(a){throw this.Y(a)}}G(i,a){let s;return a?.dangling?s=b.FileType.Unknown:i.isFile()?s=b.FileType.File:i.isDirectory()?s=b.FileType.Directory:s=b.FileType.Unknown,a&&(s|=b.FileType.SymbolicLink),s}async I(i){const a=this.C(i);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${a})`);let s;for(;s=this.H.get(i);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${a})`),await s.wait();const l=new C.Barrier;return this.H.set(i,l),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${a})`),(0,m.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${a})`),this.H.get(i)===l&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${a})`),this.H.delete(i)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${a})`),l.open()})}async readFile(i,a){let s;try{a?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(i)})`),s=await this.I(i));const l=this.C(i);return await w.Promises.readFile(l)}catch(l){throw this.Y(l)}finally{s?.dispose()}}J(i){n.D&&this.a.trace(i)}readFileStream(i,a,s){const l=(0,h.newWriteableStream)(o=>A.VSBuffer.concat(o.map(S=>A.VSBuffer.wrap(S))).buffer);return(0,u.readFileIntoStream)(this,i,l,o=>o.buffer,{...a,bufferSize:256*1024},s),l}async writeFile(i,a,s){let l;try{const o=this.C(i);if(!s.create||!s.overwrite){if(await w.Promises.exists(o)){if(!s.overwrite)throw(0,b.createFileSystemProviderError)((0,d.localize)(0,null),b.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,b.createFileSystemProviderError)((0,d.localize)(1,null),b.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(i,{create:!0,unlock:s.unlock}),await this.write(l,0,a,0,a.byteLength)}catch(o){throw await this.Z(i,o)}finally{typeof l=="number"&&await this.close(l)}}static configureFlushOnWrite(i){n.O=i}async open(i,a){const s=this.C(i);let l;(0,b.isFileOpenForWriteOptions)(a)&&(l=await this.I(i));let o;try{if((0,b.isFileOpenForWriteOptions)(a)&&a.unlock)try{const{stat:D}=await w.SymlinkSupport.stat(s);D.mode&128||await w.Promises.chmod(s,D.mode|128)}catch(D){this.a.trace(D)}let S;if((0,b.isFileOpenForWriteOptions)(a)){if(P.isWindows)try{await w.Promises.truncate(s,0),S="r+"}catch(D){D.code!=="ENOENT"&&this.a.trace(D)}S||(S="w")}else S="r";o=await w.Promises.open(s,S)}catch(S){throw l?.dispose(),(0,b.isFileOpenForWriteOptions)(a)?await this.Z(i,S):this.Y(S)}if(this.L.set(o,0),(0,b.isFileOpenForWriteOptions)(a)&&this.N.set(o,i),l){const S=this.M.get(o);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${o} (${s})`),this.M.set(o,l),S&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${o} (${s})`),S.dispose())}return o}async close(i){const a=this.M.get(i);try{if(this.L.delete(i),this.N.delete(i)&&n.O)try{await w.Promises.fdatasync(i)}catch(s){n.configureFlushOnWrite(!1),this.a.error(s)}return await w.Promises.close(i)}catch(s){throw this.Y(s)}finally{a&&(this.M.get(i)===a&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.M.delete(i)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),a.dispose())}}async read(i,a,s,l,o){const S=this.P(i,a);let D=null;try{D=(await w.Promises.read(i,s,l,o,S)).bytesRead}catch(L){throw this.Y(L)}finally{this.Q(i,S,D)}return D}P(i,a){return a===this.L.get(i)?null:a}Q(i,a,s){const l=this.L.get(i);typeof l=="number"&&(typeof a=="number"||(typeof s=="number"?this.L.set(i,l+s):this.L.delete(i)))}async write(i,a,s,l,o){return(0,C.retry)(()=>this.R(i,a,s,l,o),100,3)}async R(i,a,s,l,o){const S=this.P(i,a);let D=null;try{D=(await w.Promises.write(i,s,l,o,S)).bytesWritten}catch(L){throw await this.Z(this.N.get(i),L)}finally{this.Q(i,S,D)}return D}async mkdir(i){try{await w.Promises.mkdir(this.C(i))}catch(a){throw this.Y(a)}}async delete(i,a){try{const s=this.C(i);a.recursive?await w.Promises.rm(s,w.RimRafMode.MOVE):await w.Promises.unlink(s)}catch(s){throw this.Y(s)}}async rename(i,a,s){const l=this.C(i),o=this.C(a);if(l!==o)try{await this.S(i,a,"move",s.overwrite),await w.Promises.move(l,o)}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,d.localize)(2,null,(0,y.basename)(l),(0,y.basename)((0,y.dirname)(o)),S.toString()))),this.Y(S)}}async copy(i,a,s){const l=this.C(i),o=this.C(a);if(l!==o)try{await this.S(i,a,"copy",s.overwrite),await w.Promises.copy(l,o,{preserveSymlinks:!0})}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,d.localize)(3,null,(0,y.basename)(l),(0,y.basename)((0,y.dirname)(o)),S.toString()))),this.Y(S)}}async S(i,a,s,l){const o=this.C(i),S=this.C(a);let D=!1;if(!!(this.capabilities&1024)||(D=(0,p.isEqual)(o,S,!0)),D&&s==="copy")throw(0,b.createFileSystemProviderError)((0,d.localize)(4,null),b.FileSystemProviderErrorCode.FileExists);if(!D&&await w.Promises.exists(S)){if(!l)throw(0,b.createFileSystemProviderError)((0,d.localize)(5,null),b.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}async cloneFile(i,a){return this.U(i,a,!1)}async U(i,a,s){const l=this.C(i),o=this.C(a),S=!!(this.capabilities&1024);if((0,p.isEqual)(l,o,!S))return;const D=new m.DisposableStore;try{const[L,j]=await Promise.all([this.I(i),this.I(a)]);D.add(L),D.add(j),s&&await w.Promises.mkdir((0,y.dirname)(o),{recursive:!0}),await w.Promises.copyFile(l,o)}catch(L){if(L.code==="ENOENT"&&!s)return this.U(i,a,!0);throw this.Y(L)}finally{D.dispose()}}p(i,a,s){return new f.UniversalWatcherClient(l=>i(l),l=>a(l),s)}y(i,a,s){return new c.NodeJSWatcherClient(l=>i(l),l=>a(l),s)}Y(i){if(i instanceof b.FileSystemProviderError)return i;let a;switch(i.code){case"ENOENT":a=b.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=b.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=b.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=b.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=b.FileSystemProviderErrorCode.NoPermissions;break;default:a=b.FileSystemProviderErrorCode.Unknown}return(0,b.createFileSystemProviderError)(i,a)}async Z(i,a){let s=this.Y(a);if(i&&s.code===b.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await w.SymlinkSupport.stat(this.C(i));l.mode&128||(s=(0,b.createFileSystemProviderError)(a,b.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.a.trace(l)}return s}}e.DiskFileSystemProvider=n,n.D=!1,n.O=!0}),define(ee[205],te([0,1,3,86,2,17,59,22]),function(q,e,I,t,C,M,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class p extends C.Disposable{constructor(P,E){super(),this.a=P,this.b=E,this.w=new Map,this.y=new Map}call(P,E,h){const w=this.c(P);switch(E){case"stat":return this.g(w,h[0]);case"readdir":return this.h(w,h[0]);case"open":return this.l(w,h[0],h[1]);case"close":return this.m(h[0]);case"read":return this.n(h[0],h[1],h[2]);case"readFile":return this.i(w,h[0],h[1]);case"write":return this.p(h[0],h[1],h[2],h[3],h[4]);case"writeFile":return this.k(w,h[0],h[1],h[2]);case"rename":return this.t(w,h[0],h[1],h[2]);case"copy":return this.u(w,h[0],h[1],h[2]);case"cloneFile":return this.v(w,h[0],h[1]);case"mkdir":return this.r(w,h[0]);case"delete":return this.s(w,h[0],h[1]);case"watch":return this.C(w,h[0],h[1],h[2],h[3]);case"unwatch":return this.D(h[0],h[1])}throw new Error(`IPC Command ${E} not found`)}listen(P,E,h){const w=this.c(P);switch(E){case"fileChange":return this.z(w,h[0]);case"readFileStream":return this.j(w,h[0],h[1])}throw new Error(`Unknown event ${E}`)}g(P,E){const h=this.f(P,E,!0);return this.a.stat(h)}h(P,E){const h=this.f(P,E);return this.a.readdir(h)}async i(P,E,h){const w=this.f(P,E,!0),d=await this.a.readFile(w,h);return M.VSBuffer.wrap(d)}j(P,E,h){const w=this.f(P,E,!0),d=new k.CancellationTokenSource,b=new I.Emitter({onDidRemoveLastListener:()=>{d.cancel()}}),u=this.a.readFileStream(w,h,d.token);return(0,A.listenStream)(u,{onData:v=>b.fire(M.VSBuffer.wrap(v)),onError:v=>b.fire(v),onEnd:()=>{b.fire("end"),b.dispose(),d.dispose()}}),b.event}k(P,E,h,w){const d=this.f(P,E);return this.a.writeFile(d,h.buffer,w)}l(P,E,h){const w=this.f(P,E,!0);return this.a.open(w,h)}m(P){return this.a.close(P)}async n(P,E,h){const w=M.VSBuffer.alloc(h),d=0,b=await this.a.read(P,E,w.buffer,d,h);return[w,b]}p(P,E,h,w,d){return this.a.write(P,E,h.buffer,w,d)}r(P,E){const h=this.f(P,E);return this.a.mkdir(h)}s(P,E,h){const w=this.f(P,E);return this.a.delete(w,h)}t(P,E,h,w){const d=this.f(P,E),b=this.f(P,h);return this.a.rename(d,b,w)}u(P,E,h,w){const d=this.f(P,E),b=this.f(P,h);return this.a.copy(d,b,w)}v(P,E,h){const w=this.f(P,E),d=this.f(P,h);return this.a.cloneFile(w,d)}z(P,E){const h=new I.Emitter({onWillAddFirstListener:()=>{this.w.set(E,this.F(P,h))},onDidRemoveLastListener:()=>{(0,C.dispose)(this.w.get(E)),this.w.delete(E)}});return h.event}async C(P,E,h,w,d){const b=this.w.get(E);if(b){const u=this.f(P,w),v=b.watch(h,u,d);this.y.set(E+h,v)}}async D(P,E){const h=P+E,w=this.y.get(h);w&&((0,C.dispose)(w),this.y.delete(h))}dispose(){super.dispose();for(const[,P]of this.y)P.dispose();this.y.clear();for(const[,P]of this.w)P.dispose();this.w.clear()}}e.AbstractDiskFileSystemProviderChannel=p;class m extends C.Disposable{constructor(P,E,h,w){super(),this.c=P,this.f=h,this.g=w,this.a=new Map,this.b=this.B(new t.DiskFileSystemProvider(this.f,{watcher:{recursive:this.i(this.g)}})),this.h(E)}h(P){const E=this.B(new I.Emitter);this.B(E.event(h=>{P.fire(h.map(w=>({resource:this.c.transformOutgoingURI(w.resource),type:w.type})))})),this.B(this.b.onDidChangeFile(h=>E.fire(h))),this.B(this.b.onDidWatchError(h=>P.fire(h)))}i(P){}j(P){}watch(P,E,h){const w=this.j(this.g);return Array.isArray(w)&&(h.excludes=[...h.excludes,...w]),this.a.set(P,this.b.watch(E,h)),(0,C.toDisposable)(()=>{(0,C.dispose)(this.a.get(P)),this.a.delete(P)})}dispose(){super.dispose();for(const[,P]of this.a)P.dispose();this.a.clear()}}e.AbstractSessionFileWatcher=m}),define(ee[206],te([0,1,13,160,4,7,16,9,205,139]),function(q,e,I,t,C,M,A,k,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class y extends p.AbstractDiskFileSystemProviderChannel{constructor(h,w,d){super(h,w),this.G=d}c(h){return m.DefaultURITransformer}f(h,w){return M.URI.revive(w)}async s(h,w,d){if(!d.useTrash)return super.s(h,w,d);const b=this.f(h,w),u=(0,k.normalize)(b.fsPath);try{await I.shell.trashItem(u)}catch{throw(0,A.createFileSystemProviderError)(C.isWindows?(0,t.localize)(0,null,(0,k.basename)(u)):(0,t.localize)(1,null,(0,k.basename)(u)),A.FileSystemProviderErrorCode.Unknown)}}F(h,w){return new P(h,w,this.b,this.G)}}e.DiskFileSystemProviderChannel=y;class P extends p.AbstractSessionFileWatcher{watch(h,w,d){if(d.recursive)throw(0,A.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",A.FileSystemProviderErrorCode.Unavailable);return super.watch(h,w,d)}}}),define(ee[207],te([0,1,6]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;class t extends I.AbstractMessageLogger{constructor(M=I.DEFAULT_LOG_LEVEL){super(),this.k=[],this.l=void 0,this.setLevel(M),this.B(this.onDidChangeLogLevel(A=>{this.l?.setLevel(A)}))}set logger(M){this.l=M;for(const{level:A,message:k}of this.k)(0,I.log)(M,A,k);this.k=[]}g(M,A){this.l?(0,I.log)(this.l,M,A):this.getLevel()<=M&&this.k.push({level:M,message:A})}dispose(){this.l?.dispose()}flush(){this.l?.flush()}}e.BufferLogService=t}),define(ee[208],te([0,1,3,7,6]),function(q,e,I,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class M{constructor(E,h){this.a=E,this.b=h,this.onDidChangeLogLevel=I.Event.buffer(E.onDidChangeLogLevel,!0)}listen(E,h){switch(h){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${h}`)}async call(E,h,w){switch(h){case"setLevel":return w[1]?this.b.setLevel(t.URI.revive(w[1]),w[0]):this.a.setLevel(w[0])}throw new Error(`Call not found: ${h}`)}}e.LogLevelChannel=M;class A{constructor(E){this.a=E}get onDidChangeLogLevel(){return this.a.listen("onDidChangeLogLevel")}setLevel(E,h){A.setLevel(this.a,E,h)}static setLevel(E,h,w){return E.call("setLevel",[h,w])}}e.LogLevelChannelClient=A;class k{constructor(E){this.b=E,this.a=new Map}listen(E,h){throw new Error(`Event not found: ${h}`)}async call(E,h,w){switch(h){case"createLogger":this.c(t.URI.revive(w[0]),w[1]);return;case"log":return this.e(t.URI.revive(w[0]),w[1]);case"consoleLog":return this.d(w[0],w[1])}throw new Error(`Call not found: ${h}`)}c(E,h){this.a.set(E.toString(),this.b.createLogger(E,h))}d(E,h){let w=console.log;switch(E){case C.LogLevel.Error:w=console.error;break;case C.LogLevel.Warning:w=console.warn;break;case C.LogLevel.Info:w=console.info;break}w.call(console,...h)}e(E,h){const w=this.a.get(E.toString());if(!w)throw new Error("Create the logger before logging");for(const[d,b]of h)(0,C.log)(w,d,b)}}e.LoggerChannel=k;class p extends C.AbstractLoggerService{constructor(E,h,w){super(E,h),this.g=w}createConsoleMainLogger(){return new C.AdapterLogger({log:(E,h)=>{this.g.call("consoleLog",[E,h])}})}f(E,h,w){return new m(this.g,E,h,w)}}e.LoggerChannelClient=p;class m extends C.AbstractMessageLogger{constructor(E,h,w,d){super(d?.always),this.m=E,this.n=h,this.k=!1,this.l=[],this.setLevel(w),this.m.call("createLogger",[h,d]).then(()=>{this.r(this.l),this.k=!0})}g(E,h){const w=[[E,h]];this.k?this.r(w):this.l.push(...w)}r(E){this.m.call("log",[this.n,E])}}class y extends C.LogService{constructor(E,h){super(h),this.c=E,this.B(E.onDidChangeLogLevel(w=>h.setLevel(w)))}setLevel(E){super.setLevel(E),this.c.setLevel(E)}}e.FollowerLogService=y}),define(ee[209],te([0,1,16,6]),function(q,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var C;(function(m){m[m.Trace=0]="Trace",m[m.Debug=1]="Debug",m[m.Info=2]="Info",m[m.Warning=3]="Warning",m[m.Error=4]="Error",m[m.Critical=5]="Critical",m[m.Off=6]="Off"})(C||(C={}));async function M(m,y,P,E,h){try{const w=await new Promise((b,u)=>{q(["spdlog"],b,u)});w.setFlushOn(C.Trace);const d=await w.createAsyncRotatingLogger(m,y,P,E);return h?d.clearFormatters():d.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),d}catch(w){console.error(w)}return null}function A(m,y,P){switch(y){case t.LogLevel.Trace:m.trace(P);break;case t.LogLevel.Debug:m.debug(P);break;case t.LogLevel.Info:m.info(P);break;case t.LogLevel.Warning:m.warn(P);break;case t.LogLevel.Error:m.error(P);break;case t.LogLevel.Off:break;default:throw new Error(`Invalid log level ${y}`)}}function k(m,y){switch(y){case t.LogLevel.Trace:m.setLevel(C.Trace);break;case t.LogLevel.Debug:m.setLevel(C.Debug);break;case t.LogLevel.Info:m.setLevel(C.Info);break;case t.LogLevel.Warning:m.setLevel(C.Warning);break;case t.LogLevel.Error:m.setLevel(C.Error);break;case t.LogLevel.Off:m.setLevel(C.Off);break;default:throw new Error(`Invalid log level ${y}`)}}class p extends t.AbstractMessageLogger{constructor(y,P,E,h,w){super(),this.k=[],this.setLevel(w),this.l=this.n(y,P,E,h),this.B(this.onDidChangeLogLevel(d=>{this.m&&k(this.m,d)}))}async n(y,P,E,h){const w=E?6:1,d=30/w*I.ByteSize.MB,b=await M(y,P,d,w,h);if(b){this.m=b,k(this.m,this.getLevel());for(const{level:u,message:v}of this.k)A(this.m,u,v);this.k=[]}}g(y,P){this.m?A(this.m,y,P):this.getLevel()<=y&&this.k.push({level:y,message:P})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=p}),define(ee[210],te([0,1,29,6,209]),function(q,e,I,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let M=class extends t.AbstractLoggerService{constructor(k){super(k.getLevel(),k.onDidChangeLogLevel)}f(k,p,m){return new C.SpdLogLogger(m?.name||(0,I.generateUuid)(),k.fsPath,!m?.donotRotate,!!m?.donotUseFormatters,p)}};M=pe([_(0,t.ILogService)],M),e.LoggerService=M}),define(ee[211],te([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function I(A){return A.submenu!==void 0}e.isMenubarMenuItemSubmenu=I;function t(A){return A.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=t;function C(A){return A.uri!==void 0}e.isMenubarMenuItemRecentAction=C;function M(A){return!I(A)&&!t(A)&&!C(A)}e.isMenubarMenuItemAction=M}),define(ee[37],te([0,1,3,67,2,5]),function(q,e,I,t,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,M.createDecorator)("policy");class A extends C.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new I.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(m){const y=Object.keys(this.f).length;return this.f={...m,...this.f},y!==Object.keys(this.f).length&&await this.i(m),t.Iterable.reduce(this.g.entries(),(P,[E,h])=>({...P,[E]:h}),{})}getPolicyValue(m){return this.g.get(m)}serialize(){return t.Iterable.reduce(Object.entries(this.f),(m,[y,P])=>({...m,[y]:{definition:P,value:this.g.get(y)}}),{})}}e.AbstractPolicyService=A;class k{constructor(){this.onDidChange=I.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=k}),define(ee[212],te([0,1,8,3,67,12,16,6,37]),function(q,e,I,t,C,M,A,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function m(P,E){const h=[];for(const w of C.Iterable.concat(P.keys(),E.keys()))P.get(w)!==E.get(w)&&h.push(w);return h}let y=class extends p.AbstractPolicyService{constructor(E,h,w){super(),this.j=E,this.k=h,this.l=w,this.c=this.B(new I.ThrottledDelayer(500));const d=t.Event.filter(h.onDidFilesChange,b=>b.affects(E));this.B(h.watch(E)),this.B(d(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const E=new Map;try{const h=await this.k.readFile(this.j),w=JSON.parse(h.value.toString());if(!(0,M.isObject)(w))throw new Error("Policy file isn't a JSON object");for(const d of Object.keys(w))this.f[d]&&E.set(d,w[d])}catch(h){h.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",h)}return E}async p(){const E=await this.n(),h=m(this.g,E);this.g=E,h.length>0&&this.h.fire(h)}};y=pe([_(1,A.IFileService),_(2,k.ILogService)],y),e.FilePolicyService=y}),define(ee[213],te([0,1,3,2,37]),function(q,e,I,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class M{constructor(p){this.b=p,this.a=new t.DisposableStore}listen(p,m){switch(m){case"onDidChange":return I.Event.map(this.b.onDidChange,y=>y.reduce((P,E)=>({...P,[E]:this.b.getPolicyValue(E)??null}),{}),this.a)}throw new Error(`Event not found: ${m}`)}call(p,m,y){switch(m){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(y)}throw new Error(`Call not found: ${m}`)}dispose(){this.a.dispose()}}e.PolicyChannel=M;class A extends C.AbstractPolicyService{constructor(p,m){super(),this.a=m;for(const y in p){const{definition:P,value:E}=p[y];this.f[y]=P,E!==void 0&&this.g.set(y,E)}this.a.listen("onDidChange")(y=>{for(const P in y){const E=y[P];E===null?this.g.delete(P):this.g.set(P,E)}this.h.fire(Object.keys(y))})}async i(p){const m=await this.a.call("updatePolicyDefinitions",p);for(const y in m)this.g.set(y,m[y])}}e.PolicyChannelClient=A}),define(ee[63],te([0,1,4,32]),function(q,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let C;if(typeof I.globals.vscode<"u"&&typeof I.globals.vscode.context<"u"){const M=I.globals.vscode.context.configuration();if(M)C=M.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(C=globalThis._VSCODE_PRODUCT_JSON,t.env.VSCODE_DEV&&Object.assign(C,{nameShort:`${C.nameShort} Dev`,nameLong:`${C.nameLong} Dev`,dataFolderName:`${C.dataFolderName}-dev`,serverDataFolderName:C.serverDataFolderName?`${C.serverDataFolderName}-dev`:void 0}),!C.version){const M=globalThis._VSCODE_PACKAGE_JSON;Object.assign(C,{version:M.version})}}else C={},Object.keys(C).length===0&&Object.assign(C,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=C}),define(ee[19],te([0,1,5]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,I.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ee[214],te([0,1,77,6,19]),function(q,e,I,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let M=class{constructor(k,p){this.b=k,this.c=p,this.a=new Map}async isExtensionUrlTrusted(k,p){if(!this.b.trustedExtensionUrlPublicKeys)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const m=/^(.*)#([^#]+)$/.exec(p);if(!m)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",p),!1;const[,y,P]=m;let E=this.a.get(k);if(!E){if(E=this.b.trustedExtensionUrlPublicKeys[k],!E||E.length===0)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",k),!1;this.a.set(k,[...E])}const h=Buffer.from(decodeURIComponent(P),"base64");if(h.length<=6)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",p),!1;const w=h.slice(0,6),d=h.readUIntBE(0,6),b=Date.now()-d;if(b<0||b>36e5)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",p),!1;const u=h.slice(6),v=I.createVerify("SHA256");v.write(w),v.write(Buffer.from(y)),v.end();for(let g=0;g<E.length;g++){let f=E[g];if(f!==null){if(typeof f=="string")try{f=I.createPublicKey({key:Buffer.from(f,"base64"),format:"der",type:"spki"}),E[g]=f}catch(c){this.c.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${g+1} for ${k}:`,c),E[g]=null;continue}if(v.verify(f,u))return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",p),!0}}return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",p),!1}};M=pe([_(0,C.IProductService),_(1,t.ILogService)],M),e.ExtensionUrlTrustService=M}),define(ee[215],te([0,1,8,6]),function(q,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;let C=class{constructor(A,k,p){this.a=A,this.b=k,this.c=p}async inspect(A){await this.d();const k=this.a.webContents.debugger;await k.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,I.timeout)(A);const p=await k.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),p.profile}async d(){const A=this.a.webContents.debugger;A.attach(),await A.sendCommand("Profiler.enable")}async e(){const A=this.a.webContents.debugger;await A.sendCommand("Profiler.disable"),A.detach()}};C=pe([_(2,t.ILogService)],C),e.WindowProfiler=C}),define(ee[64],te([0,1,5]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,I.createDecorator)("protocolMainService")}),define(ee[48],te([0,1,121,12]),function(q,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class C{constructor(){this.a=new Map}add(A,k){I.ok(t.isString(A)),I.ok(t.isObject(k)),I.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,k)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.Registry=new C}),define(ee[216],te([0,1,3,48]),function(q,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function C(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class M{constructor(){this.b=new I.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(p,m){this.a[C(p)]=m,this.b.fire(p)}notifySchemaChanged(p){this.b.fire(p)}getSchemaContributions(){return{schemas:this.a}}}const A=new M;t.Registry.add(e.Extensions.JSONContribution,A)}),define(ee[65],te([0,1,24,3,12,148,18,216,48]),function(q,e,I,t,C,M,A,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var m;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(m=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var y;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(y=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const P=p.Registry.as(k.Extensions.JSONContribution);class E{constructor(){this.h=new Set,this.i=new t.Emitter,this.onDidSchemaChange=this.i.event,this.j=new t.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.r()}registerConfiguration(n,r=!0){this.registerConfigurations([n],r)}registerConfigurations(n,r=!0){const i=this.k(n,r);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(n){const r=this.l(n);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:n,remove:r}){const i=[];i.push(...this.l(r)),i.push(...this.k(n,!1)),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:(0,I.distinct)(i)})}registerDefaultConfigurations(n){const r=[],i=[];for(const{overrides:a,source:s}of n)for(const l in a)if(r.push(l),e.OVERRIDE_PROPERTY_REGEX.test(l)){const o=this.a.get(l),S=o?.valuesSources??new Map;if(s)for(const X of Object.keys(a[l]))S.set(X,s);const D={...o?.value||{},...a[l]};this.a.set(l,{source:s,value:D,valuesSources:S});const L=(0,A.getLanguageTagSettingPlainKey)(l),j={type:"object",default:D,description:M.localize(1,null,L),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:D,source:C.isString(s)?void 0:s,defaultValueSource:s};i.push(...d(l)),this.d[l]=j,this.b.properties[l]=j}else{this.a.set(l,{value:a[l],source:s});const o=this.d[l];o&&(this.s(l,o),this.o(l,o))}this.registerOverrideIdentifiers(i),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(n){const r=[];for(const{overrides:i,source:a}of n)for(const s in i){const l=this.a.get(s),o=C.isString(a)?a:a?.id,S=C.isString(l?.source)?l?.source:l?.source?.id;if(o===S)if(r.push(s),this.a.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.d[s],delete this.b.properties[s];else{const D=this.d[s];D&&(this.s(s,D),this.o(s,D))}}this.q(),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){for(const r of n)this.h.add(r);this.q()}k(n,r){const i=[];return n.forEach(a=>{i.push(...this.m(a,r,a.extensionInfo,a.restrictedProperties)),this.c.push(a),this.n(a)}),i}l(n){const r=[],i=a=>{if(a.properties)for(const s in a.properties){r.push(s);const l=this.d[s];l?.policy?.name&&this.e.delete(l.policy.name),delete this.d[s],this.p(s,a.properties[s])}a.allOf?.forEach(s=>i(s))};for(const a of n){i(a);const s=this.c.indexOf(a);s!==-1&&this.c.splice(s,1)}return r}m(n,r=!0,i,a,s=3){s=C.isUndefinedOrNull(n.scope)?s:n.scope;const l=[],o=n.properties;if(o)for(const D in o){const L=o[D];if(r&&g(D,L)){delete o[D];continue}if(L.source=i,L.defaultDefaultValue=o[D].default,this.s(D,L),e.OVERRIDE_PROPERTY_REGEX.test(D)?L.scope=void 0:(L.scope=C.isUndefinedOrNull(L.scope)?s:L.scope,L.restricted=C.isUndefinedOrNull(L.restricted)?!!a?.includes(D):L.restricted),o[D].hasOwnProperty("included")&&!o[D].included){this.f[D]=o[D],delete o[D];continue}else this.d[D]=o[D],o[D].policy?.name&&this.e.set(o[D].policy.name,D);!o[D].deprecationMessage&&o[D].markdownDeprecationMessage&&(o[D].deprecationMessage=o[D].markdownDeprecationMessage),l.push(D)}const S=n.allOf;if(S)for(const D of S)l.push(...this.m(D,r,i,a,s));return l}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}n(n){const r=i=>{const a=i.properties;if(a)for(const l in a)this.o(l,a[l]);i.allOf?.forEach(r)};r(n)}o(n,r){switch(e.allSettings.properties[n]=r,r.scope){case 1:e.applicationSettings.properties[n]=r;break;case 2:e.machineSettings.properties[n]=r;break;case 6:e.machineOverridableSettings.properties[n]=r;break;case 3:e.windowSettings.properties[n]=r;break;case 4:e.resourceSettings.properties[n]=r;break;case 5:e.resourceSettings.properties[n]=r,this.g.properties[n]=r;break}}p(n,r){switch(delete e.allSettings.properties[n],r.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.g.properties[n];break}}q(){for(const n of this.h.values()){const r=`[${n}]`,i={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.s(r,i),e.allSettings.properties[r]=i,e.applicationSettings.properties[r]=i,e.machineSettings.properties[r]=i,e.machineOverridableSettings.properties[r]=i,e.windowSettings.properties[r]=i,e.resourceSettings.properties[r]=i}this.i.fire()}r(){const n={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this.i.fire()}s(n,r){const i=this.a.get(n);let a=i?.value,s=i?.source;C.isUndefined(a)&&(a=r.defaultDefaultValue,s=void 0),C.isUndefined(a)&&(a=u(r.type)),r.default=a,r.defaultValueSource=s}}const h="\\[([^\\]]+)\\]",w=new RegExp(h,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${h})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function d(c){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(c)){let r=w.exec(c);for(;r?.length;){const i=r[1].trim();i&&n.push(i),r=w.exec(c)}}return(0,I.distinct)(n)}e.overrideIdentifiersFromKey=d;function b(c){return c.reduce((n,r)=>`${n}[${r}]`,"")}e.keyFromOverrideIdentifiers=b;function u(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const v=new E;p.Registry.add(e.Extensions.Configuration,v);function g(c,n){return c.trim()?e.OVERRIDE_PROPERTY_REGEX.test(c)?M.localize(7,null,c):v.getConfigurationProperties()[c]!==void 0?M.localize(8,null,c):n.policy?.name&&v.getPolicyConfigurations().get(n.policy?.name)!==void 0?M.localize(9,null,c,n.policy?.name,v.getPolicyConfigurations().get(n.policy?.name)):null:M.localize(6,null)}e.validateProperty=g;function f(){const c=[],n=v.getConfigurationProperties();for(const r of Object.keys(n))c.push([r,n[r].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.getScopes=f}),define(ee[109],te([0,1,24,3,43,2,39,44,12,7,18,65,48]),function(q,e,I,t,C,M,A,k,p,m,y,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class h{constructor(r={},i=[],a=[],s){this.c=r,this.d=i,this.f=a,this.raw=s,this.a=!1,this.b=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const r=this.raw.map(i=>{if(i instanceof h)return i;const a=new w("");return a.parseRaw(i),a.configurationModel});this.g=r.reduce((i,a)=>a===i?a:i.merge(a),r[0])}else this.g=this;return this.g}get contents(){return this.k(this.c)}get overrides(){return this.k(this.f)}get keys(){return this.k(this.d)}isEmpty(){return this.d.length===0&&Object.keys(this.c).length===0&&this.f.length===0}isFrozen(){return this.a}getValue(r){return r?(0,y.getConfigurationValue)(this.contents,r):this.contents}inspect(r,i){const a=this.rawConfiguration.getValue(r),s=i?this.rawConfiguration.getOverrideValue(r,i):void 0,l=i?this.rawConfiguration.override(i).getValue(r):a;return{value:a,override:s,merged:l}}getOverrideValue(r,i){const a=this.l(i);return a?r?(0,y.getConfigurationValue)(a,r):a:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const a of this.overrides)a.identifiers.includes(r)&&i.push(...a.keys);return I.distinct(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return I.distinct(r)}override(r){let i=this.b.get(r);return i||(i=this.h(r),this.b.set(r,i)),i}merge(...r){const i=k.deepClone(this.contents),a=k.deepClone(this.overrides),s=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const o of r)if(l.push(...o.raw?.length?o.raw:[o]),!o.isEmpty()){this.j(i,o.contents);for(const S of o.overrides){const[D]=a.filter(L=>I.equals(L.identifiers,S.identifiers));D?(this.j(D.contents,S.contents),D.keys.push(...S.keys),D.keys=I.distinct(D.keys)):a.push(k.deepClone(S))}for(const S of o.keys)s.indexOf(S)===-1&&s.push(S)}return new h(i,s,a,l.every(o=>o instanceof h)?void 0:l)}freeze(){return this.a=!0,this}clone(){return new h(k.deepClone(this.contents),[...this.keys],k.deepClone(this.overrides))}h(r){const i=this.l(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const a={};for(const s of I.distinct([...Object.keys(this.contents),...Object.keys(i)])){let l=this.contents[s];const o=i[s];o&&(typeof l=="object"&&typeof o=="object"?(l=k.deepClone(l),this.j(l,o)):l=o),a[s]=l}return new h(a,this.keys,this.overrides)}j(r,i){for(const a of Object.keys(i)){if(a in r&&p.isObject(r[a])&&p.isObject(i[a])){this.j(r[a],i[a]);continue}r[a]=k.deepClone(i[a])}}k(r){return this.a&&!Object.isFrozen(r)?k.deepFreeze(r):r}l(r){let i=null,a=null;const s=l=>{l&&(a?this.j(a,l):a=k.deepClone(l))};for(const l of this.overrides)I.equals(l.identifiers,[r])?i=l.contents:l.identifiers.includes(r)&&s(l.contents);return s(i),a}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,i){this.m(r),(0,y.addToValueTree)(this.contents,r,i,a=>{throw new Error(a)})}removeValue(r){this.n(r)&&(0,y.removeFromValueTree)(this.contents,r)}m(r){let i=this.keys.length;for(let a=0;a<i;a++)r.indexOf(this.keys[a])===0&&(i=a);this.keys.splice(i,1,r)}n(r){const i=this.keys.indexOf(r);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=h;class w{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new h}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,i){if(!p.isUndefinedOrNull(r)){const a=this.g(r);this.parseRaw(a,i)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,i){this.a=r;const{contents:a,keys:s,overrides:l,restricted:o,hasExcludedProperties:S}=this.h(r,i);this.b=new h(a,s,l,S?[r]:void 0),this.c=o||[]}g(r){let i={},a=null,s=[];const l=[],o=[];function S(L){Array.isArray(s)?s.push(L):a!==null&&(s[a]=L)}const D={onObjectBegin:()=>{const L={};S(L),l.push(s),s=L,a=null},onObjectProperty:L=>{a=L},onObjectEnd:()=>{s=l.pop()},onArrayBegin:()=>{const L=[];S(L),l.push(s),s=L,a=null},onArrayEnd:()=>{s=l.pop()},onLiteralValue:S,onError:(L,j,X)=>{o.push({error:L,offset:j,length:X})}};if(r)try{C.visit(r,D),i=s[0]||{}}catch(L){console.error(`Error while parsing settings file ${this.f}: ${L}`),this.d=[L]}return i}h(r,i){const a=E.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),s=this.j(r,a,!0,i);r=s.raw;const l=(0,y.toValuesTree)(r,D=>console.error(`Conflict in settings file ${this.f}: ${D}`)),o=Object.keys(r),S=this.l(r,D=>console.error(`Conflict in settings file ${this.f}: ${D}`));return{contents:l,keys:o,overrides:S,restricted:s.restricted,hasExcludedProperties:s.hasExcludedProperties}}j(r,i,a,s){let l=!1;if(!s?.scopes&&!s?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:l};const o={},S=[];for(const D in r)if(P.OVERRIDE_PROPERTY_REGEX.test(D)&&a){const L=this.j(r[D],i,!1,s);o[D]=L.raw,l=l||L.hasExcludedProperties,S.push(...L.restricted)}else{const L=i[D],j=L?typeof L.scope<"u"?L.scope:3:void 0;L?.restricted&&S.push(D),(j===void 0||s.scopes===void 0||s.scopes.includes(j))&&!(s.skipRestricted&&L?.restricted)?o[D]=r[D]:l=!0}return{raw:o,restricted:S,hasExcludedProperties:l}}l(r,i){const a=[];for(const s of Object.keys(r))if(P.OVERRIDE_PROPERTY_REGEX.test(s)){const l={};for(const o in r[s])l[o]=r[s][o];a.push({identifiers:(0,P.overrideIdentifiersFromKey)(s),keys:Object.keys(l),contents:(0,y.toValuesTree)(l,i)})}return a}}e.ConfigurationModelParser=w;class d extends M.Disposable{constructor(r,i,a,s){super(),this.f=r,this.g=i,this.h=s,this.c=this.B(new t.Emitter),this.onDidChange=this.c.event,this.a=new w(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(a.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(t.Event.any(t.Event.filter(this.h.onDidFilesChange,l=>l.contains(this.f)),t.Event.filter(this.h.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&a.isEqual(l.resource,r)))(()=>this.c.fire()))}async loadConfiguration(){try{const r=await this.h.readFile(this.f);return this.a.parse(r.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new h}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=d;class b{constructor(r,i,a,s,l,o,S,D,L,j,X,ae,Y){this.a=r,this.b=i,this.value=a,this.overrideIdentifiers=s,this.c=l,this.d=o,this.f=S,this.g=D,this.h=L,this.j=j,this.k=X,this.l=ae,this.m=Y}get p(){return this.n||(this.n=this.c.inspect(this.a,this.b.overrideIdentifier)),this.n}get defaultValue(){return this.p.merged}get default(){return this.p.value!==void 0||this.p.override!==void 0?{value:this.p.value,override:this.p.override}:void 0}get r(){return this.q===void 0&&(this.q=this.d?this.d.inspect(this.a):null),this.q}get policyValue(){return this.r?.merged}get policy(){return this.r?.value!==void 0?{value:this.r.value}:void 0}get t(){return this.s===void 0&&(this.s=this.f?this.f.inspect(this.a):null),this.s}get applicationValue(){return this.t?.merged}get application(){return this.t?.value!==void 0||this.t?.override!==void 0?{value:this.t.value,override:this.t.override}:void 0}get v(){return this.u||(this.u=this.g.inspect(this.a,this.b.overrideIdentifier)),this.u}get userValue(){return this.v.merged}get user(){return this.v.value!==void 0||this.v.override!==void 0?{value:this.v.value,override:this.v.override}:void 0}get x(){return this.w||(this.w=this.h.inspect(this.a,this.b.overrideIdentifier)),this.w}get userLocalValue(){return this.x.merged}get userLocal(){return this.x.value!==void 0||this.x.override!==void 0?{value:this.x.value,override:this.x.override}:void 0}get z(){return this.y||(this.y=this.j.inspect(this.a,this.b.overrideIdentifier)),this.y}get userRemoteValue(){return this.z.merged}get userRemote(){return this.z.value!==void 0||this.z.override!==void 0?{value:this.z.value,override:this.z.override}:void 0}get B(){return this.A===void 0&&(this.A=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.A}get workspaceValue(){return this.B?.merged}get workspace(){return this.B?.value!==void 0||this.B?.override!==void 0?{value:this.B.value,override:this.B.override}:void 0}get E(){return this.D===void 0&&(this.D=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.D}get workspaceFolderValue(){return this.E?.merged}get workspaceFolder(){return this.E?.value!==void 0||this.E?.override!==void 0?{value:this.E.value,override:this.E.override}:void 0}get memoryValue(){return this.m.merged}get memory(){return this.m.value!==void 0||this.m.override!==void 0?{value:this.m.value,override:this.m.override}:void 0}}class u{constructor(r,i,a,s,l=new h,o=new h,S=new A.ResourceMap,D=new h,L=new A.ResourceMap,j=!0){this.c=r,this.d=i,this.f=a,this.g=s,this.h=l,this.j=o,this.l=S,this.m=D,this.n=L,this.p=j,this.a=null,this.b=new A.ResourceMap,this.q=null}getValue(r,i,a){return this.s(r,i,a).getValue(r)}updateValue(r,i,a={}){let s;a.resource?(s=this.n.get(a.resource),s||(s=new h,this.n.set(a.resource,s))):s=this.m,i===void 0?s.removeValue(r):s.setValue(r,i),a.resource||(this.a=null)}inspect(r,i,a){const s=this.s(r,i,a),l=I.distinct(s.overrides.map(D=>D.identifiers).flat()).filter(D=>s.getOverrideValue(r,D)!==void 0),o=this.w(i.resource,a),S=i.resource?this.n.get(i.resource)||this.m:this.m;return new b(r,i,s.getValue(r),l.length?l:void 0,this.c,this.d.isEmpty()?void 0:this.d.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),a?this.j.freeze():void 0,o?o.freeze():void 0,S.inspect(r,i.overrideIdentifier))}keys(r){const i=this.w(void 0,r);return{default:this.c.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this.j.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.q=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.q=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.j=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,i){this.l.set(r,i),this.b.delete(r)}deleteFolderConfiguration(r){this.r.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const a=[];if(!i){const{added:s,updated:l,removed:o}=f(this.c,r);i=[...s,...l,...o]}for(const s of i)for(const l of(0,P.overrideIdentifiersFromKey)(s)){const o=this.c.getKeysForOverrideIdentifier(l),S=r.getKeysForOverrideIdentifier(l),D=[...S.filter(L=>o.indexOf(L)===-1),...o.filter(L=>S.indexOf(L)===-1),...o.filter(L=>!k.equals(this.c.override(l).getValue(L),r.override(l).getValue(L)))];a.push([l,D])}return this.updateDefaultConfiguration(r),{keys:i,overrides:a}}compareAndUpdatePolicyConfiguration(r){const{added:i,updated:a,removed:s}=f(this.d,r),l=[...i,...a,...s];return l.length&&this.updatePolicyConfiguration(r),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:i,updated:a,removed:s,overrides:l}=f(this.applicationConfiguration,r),o=[...i,...a,...s];return o.length&&this.updateApplicationConfiguration(r),{keys:o,overrides:l}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:a,removed:s,overrides:l}=f(this.localUserConfiguration,r),o=[...i,...a,...s];return o.length&&this.updateLocalUserConfiguration(r),{keys:o,overrides:l}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:a,removed:s,overrides:l}=f(this.remoteUserConfiguration,r),o=[...i,...a,...s];return o.length&&this.updateRemoteUserConfiguration(r),{keys:o,overrides:l}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:a,removed:s,overrides:l}=f(this.workspaceConfiguration,r),o=[...i,...a,...s];return o.length&&this.updateWorkspaceConfiguration(r),{keys:o,overrides:l}}compareAndUpdateFolderConfiguration(r,i){const a=this.r.get(r),{added:s,updated:l,removed:o,overrides:S}=f(a,i),D=[...s,...l,...o];return(D.length||!a)&&this.updateFolderConfiguration(r,i),{keys:D,overrides:S}}compareAndDeleteFolderConfiguration(r){const i=this.r.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:a,updated:s,removed:l,overrides:o}=f(i,void 0);return{keys:[...a,...s,...l],overrides:o}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.q||(this.q=this.h.isEmpty()?this.g:this.g.merge(this.h),this.p&&this.q.freeze()),this.q}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.j}get r(){return this.l}s(r,i,a){let s=this.t(i,a);return i.overrideIdentifier&&(s=s.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(s=s.merge(this.d)),s}t({resource:r},i){let a=this.u();if(i&&r){const s=i.getFolder(r);s&&(a=this.v(s.uri)||a);const l=this.n.get(r);l&&(a=a.merge(l))}return a}u(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.j,this.m),this.p&&(this.j=this.j.freeze())),this.a}v(r){let i=this.b.get(r);if(!i){const a=this.u(),s=this.l.get(r);s?(i=a.merge(s),this.p&&(i=i.freeze()),this.b.set(r,i)):i=a}return i}w(r,i){if(i&&r){const a=i.getFolder(r);if(a)return this.l.get(a.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},folders:[...this.l.keys()].reduce((r,i)=>{const{contents:a,overrides:s,keys:l}=this.l.get(i);return r.push([i,{contents:a,overrides:s,keys:l}]),r},[])}}allKeys(){const r=new Set;return this.c.freeze().keys.forEach(i=>r.add(i)),this.userConfiguration.freeze().keys.forEach(i=>r.add(i)),this.j.freeze().keys.forEach(i=>r.add(i)),this.l.forEach(i=>i.freeze().keys.forEach(a=>r.add(a))),[...r.values()]}x(){const r=new Set;return this.c.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.j.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.l.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(a=>r.add(a))),[...r.values()]}y(r){const i=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(a=>i.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(a=>i.add(a)),this.j.getKeysForOverrideIdentifier(r).forEach(a=>i.add(a)),this.l.forEach(a=>a.getKeysForOverrideIdentifier(r).forEach(s=>i.add(s))),[...i.values()]}static parse(r){const i=this.z(r.defaults),a=this.z(r.policy),s=this.z(r.application),l=this.z(r.user),o=this.z(r.workspace),S=r.folders.reduce((D,L)=>(D.set(m.URI.revive(L[0]),this.z(L[1])),D),new A.ResourceMap);return new u(i,a,s,l,new h,o,S,new h,new A.ResourceMap,!1)}static z(r){return new h(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=u;function v(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const r=new Set,i=new Map;for(const s of n)s.keys.forEach(l=>r.add(l)),s.overrides.forEach(([l,o])=>{const S=(0,A.getOrSet)(i,l,new Set);o.forEach(D=>S.add(D))});const a=[];return i.forEach((s,l)=>a.push([l,[...s.values()]])),{keys:[...r.values()],overrides:a}}e.mergeChanges=v;class g{constructor(r,i,a,s){this.change=r,this.b=i,this.c=a,this.d=s,this.f=void 0;const l=new Set;r.keys.forEach(S=>l.add(S)),r.overrides.forEach(([,S])=>S.forEach(D=>l.add(D))),this.affectedKeys=[...l.values()];const o=new h;this.affectedKeys.forEach(S=>o.setValue(S,{})),this.a=o.contents}get previousConfiguration(){return!this.f&&this.b&&(this.f=u.parse(this.b.data)),this.f}affectsConfiguration(r,i){if(this.g(this.a,r)){if(i){const a=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.b?.workspace):void 0,s=this.c.getValue(r,i,this.d);return!k.equals(a,s)}return!0}return!1}g(r,i){let a=(0,y.toValuesTree)({[i]:!0},()=>{}),s;for(;typeof a=="object"&&(s=Object.keys(a)[0]);){if(r=r[s],!r)return!1;a=a[s]}return!0}}e.ConfigurationChangeEvent=g;function f(n,r){const{added:i,removed:a,updated:s}=c(r?.rawConfiguration,n?.rawConfiguration),l=[],o=n?.getAllOverrideIdentifiers()||[],S=r?.getAllOverrideIdentifiers()||[];if(r){const D=S.filter(L=>!o.includes(L));for(const L of D)l.push([L,r.getKeysForOverrideIdentifier(L)])}if(n){const D=o.filter(L=>!S.includes(L));for(const L of D)l.push([L,n.getKeysForOverrideIdentifier(L)])}if(r&&n){for(const D of o)if(S.includes(D)){const L=c({contents:n.getOverrideValue(void 0,D)||{},keys:n.getKeysForOverrideIdentifier(D)},{contents:r.getOverrideValue(void 0,D)||{},keys:r.getKeysForOverrideIdentifier(D)});l.push([D,[...L.added,...L.removed,...L.updated]])}}return{added:i,removed:a,updated:s,overrides:l}}function c(n,r){const i=n?r?n.keys.filter(l=>r.keys.indexOf(l)===-1):[...n.keys]:[],a=r?n?r.keys.filter(l=>n.keys.indexOf(l)===-1):[...r.keys]:[],s=[];if(n&&r){for(const l of r.keys)if(n.keys.indexOf(l)!==-1){const o=(0,y.getConfigurationValue)(r.contents,l),S=(0,y.getConfigurationValue)(n.contents,l);k.equals(o,S)||s.push(l)}}return{added:i,removed:a,updated:s}}}),define(ee[217],te([0,1,24,3,2,44,12,18,109,65,6,37,48]),function(q,e,I,t,C,M,A,k,p,m,y,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class h extends C.Disposable{constructor(){super(...arguments),this.a=this.B(new t.Emitter),this.onDidChangeConfiguration=this.a.event}get configurationModel(){return this.b||(this.b=new w(this.f())),this.b}async initialize(){return this.b=void 0,this.B(E.Registry.as(m.Extensions.Configuration).onDidUpdateConfiguration(({properties:v,defaultsOverrides:g})=>this.c(v,g))),this.configurationModel}reload(){return this.b=void 0,this.configurationModel}c(v,g){this.b=void 0,this.a.fire({defaults:this.configurationModel,properties:v})}f(){return{}}}e.DefaultConfiguration=h;class w extends p.ConfigurationModel{constructor(v={}){const g=E.Registry.as(m.Extensions.Configuration).getConfigurationProperties(),f=Object.keys(g),c=Object.create(null),n=[];for(const r in g){const i=v[r],a=i!==void 0?i:g[r].default;(0,k.addToValueTree)(c,r,a,s=>console.error(`Conflict in default settings: ${s}`))}for(const r of Object.keys(c))m.OVERRIDE_PROPERTY_REGEX.test(r)&&n.push({identifiers:(0,m.overrideIdentifiersFromKey)(r),keys:Object.keys(c[r]),contents:(0,k.toValuesTree)(c[r],i=>console.error(`Conflict in default settings file: ${i}`))});super(c,f,n)}}e.DefaultConfigurationModel=w;class d{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new p.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=d;let b=class extends C.Disposable{get configurationModel(){return this.b}constructor(v,g,f){super(),this.c=v,this.f=g,this.g=f,this.a=this.B(new t.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new p.ConfigurationModel}async initialize(){return this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(v=>this.i(v))),this.B(this.c.onDidChangeConfiguration(async({properties:v})=>this.j(await this.h(v),!0))),this.b}async h(v){const g={},f=[],c=E.Registry.as(m.Extensions.Configuration).getConfigurationProperties();for(const n of v){const r=c[n];if(!r){f.push(n);continue}if(r.policy){if(r.type!=="string"&&r.type!=="number"){this.g.warn(`Policy ${r.policy.name} has unsupported type ${r.type}`);continue}f.push(n),g[r.policy.name]={type:r.type}}}return(0,A.isEmptyObject)(g)||await this.f.updatePolicyDefinitions(g),f}i(v){const g=E.Registry.as(m.Extensions.Configuration).getPolicyConfigurations(),f=(0,I.coalesce)(v.map(c=>g.get(c)));this.j(f,!0)}j(v,g){const f=E.Registry.as(m.Extensions.Configuration).getConfigurationProperties(),c=[],n=this.b.isEmpty();for(const r of v){const i=f[r]?.policy?.name;if(i){const a=this.f.getPolicyValue(i);(n?a!==void 0:!(0,M.equals)(this.b.getValue(r),a))&&c.push([r,a])}else this.b.getValue(r)!==void 0&&c.push([r,void 0])}if(c.length){const r=this.b;this.b=new p.ConfigurationModel;for(const i of r.keys)this.b.setValue(i,r.getValue(i));for(const[i,a]of c)a===void 0?this.b.removeValue(i):this.b.setValue(i,a);g&&this.a.fire(this.b)}}};b=pe([_(1,P.IPolicyService),_(2,y.ILogService)],b),e.PolicyConfiguration=b}),define(ee[218],te([0,1,8,3,2,20,18,109,217,37]),function(q,e,I,t,C,M,A,k,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class y extends C.Disposable{constructor(E,h,w,d){super(),this.i=E,this.h=this.B(new t.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new p.DefaultConfiguration),this.c=w instanceof m.NullPolicyService?new p.NullPolicyConfiguration:this.B(new p.PolicyConfiguration(this.b,w,d)),this.f=this.B(new k.UserSettings(this.i,void 0,M.extUriBiasedIgnorePathCase,h)),this.a=new k.Configuration(this.b.configurationModel,this.c.configurationModel,new k.ConfigurationModel,new k.ConfigurationModel),this.g=this.B(new I.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:b,properties:u})=>this.k(b,u))),this.B(this.c.onDidChangeConfiguration(b=>this.l(b))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[E,h,w]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new k.Configuration(E,h,new k.ConfigurationModel,w)}getConfigurationData(){return this.a.toData()}getValue(E,h){const w=typeof E=="string"?E:void 0,d=(0,A.isConfigurationOverrides)(E)?E:(0,A.isConfigurationOverrides)(h)?h:{};return this.a.getValue(w,d,void 0)}updateValue(E,h,w,d){return Promise.reject(new Error("not supported"))}inspect(E){return this.a.inspect(E,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const E=await this.f.loadConfiguration();this.j(E)}j(E){const h=this.a.toData(),w=this.a.compareAndUpdateLocalUserConfiguration(E);this.m(w,h,2)}k(E,h){const w=this.a.toData(),d=this.a.compareAndUpdateDefaultConfiguration(E,h);this.m(d,w,7)}l(E){const h=this.a.toData(),w=this.a.compareAndUpdatePolicyConfiguration(E);this.m(w,h,7)}m(E,h,w){const d=new k.ConfigurationChangeEvent(E,{data:h},this.a);d.source=w,d.sourceConfig=this.n(w),this.h.fire(d)}n(E){switch(E){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=y}),define(ee[219],te([0,1,14,5]),function(q,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var C;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(C=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class M extends I.ErrorNoTelemetry{static isNotAvailable(k){return k instanceof M&&k._code===C.NotAvailable}static isTemporarilyNotAvailable(k){return k instanceof M&&k._code===C.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof M&&k._code===C.NoResolverFound}static isHandled(k){return k instanceof M&&k.isHandled}constructor(k,p=C.Unknown,m){super(k),this._message=k,this._code=p,this._detail=m,this.isHandled=p===C.NotAvailable&&m===!0,Object.setPrototypeOf(this,M.prototype)}}e.RemoteAuthorityResolverError=M}),define(ee[54],te([0,1,15]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(m){return m.scheme===I.Schemas.vscodeRemote?m.authority:void 0}e.getRemoteAuthority=t;function C(m){if(!m)return;const y=m.indexOf("+");return y<0?m:m.substr(0,y)}e.getRemoteName=C;function M(m){return`/${m.quality??"oss"}-${m.commit??"dev"}`}e.getRemoteServerRootPath=M;function A(m){const{host:y,port:P}=p(m);if(typeof P>"u")throw new Error("Remote authority doesn't contain a port!");return{host:y,port:P}}e.parseAuthorityWithPort=A;function k(m,y){let{host:P,port:E}=p(m);return typeof E>"u"&&(E=y),{host:P,port:E}}e.parseAuthorityWithOptionalPort=k;function p(m){const y=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(y)return{host:y[1],port:parseInt(y[2],10)};const P=m.match(/^(\[[0-9a-z:]+\])$/);if(P)return{host:P[1],port:void 0};const E=m.match(/(.*):(\d+)$/);return E?{host:E[1],port:parseInt(E[2],10)}:{host:m,port:void 0}}}),define(ee[87],te([0,1,26,5,54]),function(q,e,I,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function M(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.getWorkspaceSupportTypeMessage=M;function A(w){return w&&typeof w=="object"&&typeof w.id=="string"&&(!w.uuid||typeof w.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));var p;(function(w){w.WIN32_X64="win32-x64",w.WIN32_IA32="win32-ia32",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(p=e.TargetPlatform||(e.TargetPlatform={}));class m{constructor(d){this.value=d,this.c=d.toLowerCase()}static equals(d,b){if(typeof d>"u"||d===null)return typeof b>"u"||b===null;if(typeof b>"u"||b===null)return!1;if(typeof d=="string"||typeof b=="string"){const u=typeof d=="string"?d:d.value,v=typeof b=="string"?b:b.value;return I.equalsIgnoreCase(u,v)}return d.c===b.c}static toKey(d){return typeof d=="string"?d.toLowerCase():d.c}}e.ExtensionIdentifier=m;function y(w){return P(w)}e.isApplicationScopedExtension=y;function P(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.isLanguagePackExtension=P;function E(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=E;function h(w,d){if(d){const b=`onResolveRemoteAuthority:${(0,C.getRemoteName)(d)}`;return w.activationEvents?.indexOf(b)!==-1}return!1}e.isResolverExtension=h,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(ee[110],te([0,1,26,191,87,4,7,14,32]),function(q,e,I,t,C,M,A,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function m(r,i){return r.uuid&&i.uuid?r.uuid===i.uuid:r.id===i.id?!0:(0,I.compareIgnoreCase)(r.id,i.id)===0}e.areSameExtensions=m;const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class P{static create(i){const a=i.manifest?i.manifest.version:i.version,s=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new P(i.identifier,a,s)}static parse(i){const a=y.exec(i);return a&&a[1]&&a[2]?new P({id:a[1]},a[2],a[4]||void 0):null}constructor(i,a,s="undefined"){this.version=a,this.targetPlatform=s,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof P?m(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=P;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function h(r){const i=E.exec(r);return i&&i[1]?[d(i[1]),i[2]]:[d(r),void 0]}e.getIdAndVersion=h;function w(r,i){return`${r}.${i}`}e.getExtensionId=w;function d(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=d;function b(r,i){return d(w(r,i))}e.getGalleryExtensionId=b;function u(r,i){const a=[],s=l=>{for(const o of a)if(o.some(S=>m(i(S),i(l))))return o;return null};for(const l of r){const o=s(l);o?o.push(l):a.push([l])}return a}e.groupByExtension=u;function v(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=v;function g(r){return{id:r.identifier.id,name:r.name,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.getGalleryExtensionTelemetryData=g,e.BetterMergeId=new C.ExtensionIdentifier("pprice.better-merge");function f(r,i){const a=[],s=i.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const l=s.shift();if(l&&a.every(o=>!m(o.identifier,{id:l}))){const o=r.filter(S=>m(S.identifier,{id:l}));o.length===1&&(a.push(o[0]),s.push(...o[0].manifest.extensionDependencies?.slice(0)??[]))}}return a}e.getExtensionDependencies=f;async function c(r,i){if(!M.isLinux)return!1;let a;try{a=(await r.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{a=(await r.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){i.debug("Error while getting the os-release file.",(0,k.getErrorMessage)(l))}}return!!a&&(a.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=c;async function n(r,i){const a=await c(r,i),s=(0,t.getTargetPlatform)(a?"alpine":M.platform,p.arch);return i.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=n}),define(ee[220],te([0,1,8,17,22,14,3,2,29,102,219,54]),function(q,e,I,t,C,M,A,k,p,m,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const E=30*1e3;var h;(function(z){z[z.Management=1]="Management",z[z.ExtensionHost=2]="ExtensionHost",z[z.Tunnel=3]="Tunnel"})(h=e.ConnectionType||(e.ConnectionType={}));function w(z){switch(z){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function d(z){const T=new C.CancellationTokenSource;return setTimeout(()=>T.cancel(),z),T.token}function b(z,T){if(z.isCancellationRequested||T.isCancellationRequested)return C.CancellationToken.Cancelled;const R=new C.CancellationTokenSource;return z.onCancellationRequested(()=>R.cancel()),T.onCancellationRequested(()=>R.cancel()),R.token}class u{get didTimeout(){return this.c==="timedout"}constructor(T){this.c="pending",this.d=new k.DisposableStore,this.promise=new Promise((R,O)=>{this.f=R,this.g=O}),T.isCancellationRequested?this.h():this.d.add(T.onCancellationRequested(()=>this.h()))}registerDisposable(T){this.c==="pending"?this.d.add(T):T.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const T=new Error("Time limit reached");return T.code="ETIMEDOUT",T.syscall="connect",T}resolve(T){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(T))}reject(T){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(T))}}function v(z,T){const R=new u(T);return R.registerDisposable(z.onControlMessage(O=>{const U=JSON.parse(O.toString()),B=W(U);B?R.reject(B):R.resolve(U)})),R.promise}function g(z,T,R,O,U,B,V,ie){const $=new u(ie);return T.connect(R,O,U,B,V,(Z,x)=>{$.didTimeout?(Z&&z.error(Z),x?.dispose()):Z||!x?$.reject(Z):$.resolve(x)}),$.promise}function f(z,T){const R=new u(T);return z.then(O=>{R.didTimeout||R.resolve(O)},O=>{R.didTimeout||R.reject(O)}),R.promise}async function c(z,T,R,O){const U=H(z,T);z.logService.trace(`${U} 1/6. invoking socketFactory.connect().`);let B;try{B=await g(z.logService,z.socketFactory,z.host,z.port,(0,P.getRemoteServerRootPath)(z),`reconnectionToken=${z.reconnectionToken}&reconnection=${z.reconnectionProtocol?"true":"false"}`,`renderer-${w(T)}-${z.reconnectionToken}`,O)}catch(x){throw z.logService.error(`${U} socketFactory.connect() failed or timed out. Error:`),z.logService.error(x),x}z.logService.trace(`${U} 2/6. socketFactory.connect() was successful.`);let V,ie;z.reconnectionProtocol?(z.reconnectionProtocol.beginAcceptReconnection(B,null),V=z.reconnectionProtocol,ie=!1):(V=new m.PersistentProtocol(B,null),ie=!0),z.logService.trace(`${U} 3/6. sending AuthRequest control message.`);const $=await f(z.signService.createNewMessage((0,p.generateUuid)()),O),Z={type:"auth",auth:z.connectionToken||"00000000000000000000",data:$.data};V.sendControl(t.VSBuffer.fromString(JSON.stringify(Z)));try{const x=await v(V,b(O,d(1e4)));if(x.type!=="sign"||typeof x.data!="string"){const Oe=new Error("Unexpected handshake message");throw Oe.code="VSCODE_CONNECTION_ERROR",Oe}if(z.logService.trace(`${U} 4/6. received SignRequest control message.`),!await f(z.signService.validate($,x.signedData),O)){const Oe=new Error("Refused to connect to unsupported server");throw Oe.code="VSCODE_CONNECTION_ERROR",Oe}const ge=await f(z.signService.sign(x.data),O),De={type:"connectionType",commit:z.commit,signedData:ge,desiredConnectionType:T};return R&&(De.args=R),z.logService.trace(`${U} 5/6. sending ConnectionTypeRequest control message.`),V.sendControl(t.VSBuffer.fromString(JSON.stringify(De))),{protocol:V,ownsProtocol:ie}}catch(x){throw x&&x.code==="ETIMEDOUT"&&(z.logService.error(`${U} the handshake timed out. Error:`),z.logService.error(x)),x&&x.code==="VSCODE_CONNECTION_ERROR"&&(z.logService.error(`${U} received error control message when negotiating connection. Error:`),z.logService.error(x)),ie&&le(V),x}}async function n(z,T,R,O){const U=Date.now(),B=H(z,T),{protocol:V,ownsProtocol:ie}=await c(z,T,R,O),$=new u(O);return $.registerDisposable(V.onControlMessage(Z=>{const x=JSON.parse(Z.toString()),oe=W(x);oe?(z.logService.error(`${B} received error control message when negotiating connection. Error:`),z.logService.error(oe),ie&&le(V),$.reject(oe)):(z.reconnectionProtocol?.endAcceptReconnection(),z.logService.trace(`${B} 6/6. handshake finished, connection is up and running after ${re(U)}!`),$.resolve({protocol:V,firstMessage:x}))})),$.promise}async function r(z,T){const{protocol:R}=await n(z,1,void 0,T);return{protocol:R}}async function i(z,T,R){const{protocol:O,firstMessage:U}=await n(z,2,T,R),B=U&&U.debugPort;return{protocol:O,debugPort:B}}async function a(z,T,R){const O=Date.now(),U=H(z,3),{protocol:B}=await c(z,3,T,R);return z.logService.trace(`${U} 6/6. handshake finished, connection is up and running after ${re(O)}!`),B}async function s(z,T,R){const{host:O,port:U,connectionToken:B}=await z.addressProvider.getAddress();return{commit:z.commit,quality:z.quality,host:O,port:U,connectionToken:B,reconnectionToken:T,reconnectionProtocol:R,socketFactory:z.socketFactory,signService:z.signService,logService:z.logService}}async function l(z,T,R){return S(z,async O=>{const{protocol:U}=await r(O,C.CancellationToken.None);return new he(z,T,R,O.reconnectionToken,U)})}e.connectRemoteAgentManagement=l;async function o(z,T){return S(z,async R=>{const{protocol:O,debugPort:U}=await i(R,T,C.CancellationToken.None);return new K(z,T,R.reconnectionToken,O,U)})}e.connectRemoteAgentExtensionHost=o;async function S(z,T){for(let O=1;;O++)try{const U=(0,p.generateUuid)(),B=await s(z,U,null);return await T(B)}catch(U){if(O<5)z.logService.error(`[remote-connection][attempt ${O}] An error occurred in initial connection! Will retry... Error:`),z.logService.error(U);else throw z.logService.error(`[remote-connection][attempt ${O}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),z.logService.error(U),ne.triggerPermanentFailure(0,0,y.RemoteAuthorityResolverError.isHandled(U)),U}}async function D(z,T,R){const O=await s(z,(0,p.generateUuid)(),null);return await a(O,{host:T,port:R},C.CancellationToken.None)}e.connectRemoteAgentTunnel=D;function L(z){return(0,I.createCancelablePromise)(T=>new Promise((R,O)=>{const U=setTimeout(R,z*1e3);T.onCancellationRequested(()=>{clearTimeout(U),R()})}))}var j;(function(z){z[z.ConnectionLost=0]="ConnectionLost",z[z.ReconnectionWait=1]="ReconnectionWait",z[z.ReconnectionRunning=2]="ReconnectionRunning",z[z.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",z[z.ConnectionGain=4]="ConnectionGain"})(j=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class X{constructor(T,R){this.reconnectionToken=T,this.millisSinceLastIncomingData=R,this.type=0}}e.ConnectionLostEvent=X;class ae{constructor(T,R,O,U){this.reconnectionToken=T,this.millisSinceLastIncomingData=R,this.durationSeconds=O,this.c=U,this.type=1}skipWait(){this.c.cancel()}}e.ReconnectionWaitEvent=ae;class Y{constructor(T,R,O){this.reconnectionToken=T,this.millisSinceLastIncomingData=R,this.attempt=O,this.type=2}}e.ReconnectionRunningEvent=Y;class J{constructor(T,R,O){this.reconnectionToken=T,this.millisSinceLastIncomingData=R,this.attempt=O,this.type=4}}e.ConnectionGainEvent=J;class se{constructor(T,R,O,U){this.reconnectionToken=T,this.millisSinceLastIncomingData=R,this.attempt=O,this.handled=U,this.type=3}}e.ReconnectionPermanentFailureEvent=se;class ne extends k.Disposable{static triggerPermanentFailure(T,R,O){this._permanentFailure=!0,this.f=T,this.g=R,this.h=O,this.i.forEach(U=>U.u(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(T=>T.r())}static debugPauseSocketWriting(){this.i.forEach(T=>T.v())}get k(){return this.c||ne._permanentFailure}constructor(T,R,O,U,B){super(),this.m=T,this.n=R,this.reconnectionToken=O,this.protocol=U,this.p=B,this.j=this.B(new A.Emitter),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.j.fire(new J(this.reconnectionToken,0,0)),this.B(U.onSocketClose(V=>{const ie=N(this.m,this.reconnectionToken,!0);V?V.type===0?(this.n.logService.info(`${ie} received socket close event (hadError: ${V.hadError}).`),V.error&&this.n.logService.error(V.error)):(this.n.logService.info(`${ie} received socket close event (wasClean: ${V.wasClean}, code: ${V.code}, reason: ${V.reason}).`),V.event&&this.n.logService.error(V.event)):this.n.logService.info(`${ie} received socket close event.`),this.r()})),this.B(U.onSocketTimeout(V=>{const ie=N(this.m,this.reconnectionToken,!0);this.n.logService.info(`${ie} received socket timeout event (unacknowledgedMsgCount: ${V.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${V.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${V.timeSinceLastReceivedSomeData}).`),this.r()})),ne.i.push(this),this.B((0,k.toDisposable)(()=>{const V=ne.i.indexOf(this);V>=0&&ne.i.splice(V,1)})),this.k&&this.u(ne.f,ne.g,ne.h)}async r(){if(!this.l)try{this.l=!0,await this.s()}finally{this.l=!1}}async s(){if(this.k)return;const T=N(this.m,this.reconnectionToken,!0);this.n.logService.info(`${T} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new X(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const R=[0,5,5,10,10,10,10,10,30];let O=-1;do{O++;const U=O<R.length?R[O]:R[R.length-1];try{if(U>0){const V=L(U);this.j.fire(new ae(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),U,V)),this.n.logService.info(`${T} waiting for ${U} seconds before reconnecting...`);try{await V}catch{}}if(this.k){this.n.logService.error(`${T} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new Y(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1)),this.n.logService.info(`${T} resolving connection...`);const B=await s(this.n,this.reconnectionToken,this.protocol);this.n.logService.info(`${T} connecting to ${B.host}:${B.port}...`),await this.w(B,d(E)),this.n.logService.info(`${T} reconnected!`),this.j.fire(new J(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1));break}catch(B){if(B.code==="VSCODE_CONNECTION_ERROR"){this.n.logService.error(`${T} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.n.logService.error(B),this.t(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(O>360){this.n.logService.error(`${T} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.n.logService.error(B),this.t(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(y.RemoteAuthorityResolverError.isTemporarilyNotAvailable(B)){this.n.logService.info(`${T} A temporarily not available error occurred while trying to reconnect, will try again...`),this.n.logService.trace(B);continue}if((B.code==="ETIMEDOUT"||B.code==="ENETUNREACH"||B.code==="ECONNREFUSED"||B.code==="ECONNRESET")&&B.syscall==="connect"){this.n.logService.info(`${T} A network error occurred while trying to reconnect, will try again...`),this.n.logService.trace(B);continue}if((0,M.isCancellationError)(B)){this.n.logService.info(`${T} A promise cancelation error occurred while trying to reconnect, will try again...`),this.n.logService.trace(B);continue}if(B instanceof y.RemoteAuthorityResolverError){this.n.logService.error(`${T} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.n.logService.error(B),this.t(this.protocol.getMillisSinceLastIncomingData(),O+1,y.RemoteAuthorityResolverError.isHandled(B));break}this.n.logService.error(`${T} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.n.logService.error(B),this.t(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}}while(!this.k)}t(T,R,O){this.p?ne.triggerPermanentFailure(T,R,O):this.u(T,R,O)}u(T,R,O){this.j.fire(new se(this.reconnectionToken,T,R,O)),le(this.protocol)}v(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=ne,ne._permanentFailure=!1,ne.f=0,ne.g=0,ne.h=!1,ne.i=[];class he extends ne{constructor(T,R,O,U,B){super(1,T,U,B,!0),this.client=this.B(new m.Client(B,{remoteAuthority:R,clientId:O},T.ipcLogger))}async w(T,R){await r(T,R)}}e.ManagementPersistentConnection=he;class K extends ne{constructor(T,R,O,U,B){super(2,T,O,U,!1),this.y=R,this.debugPort=B}async w(T,R){await i(T,this.y,R)}}e.ExtensionHostPersistentConnection=K;function le(z){try{z.acceptDisconnect();const T=z.getSocket();z.dispose(),T.dispose()}catch(T){(0,M.onUnexpectedError)(T)}}function W(z){if(z&&z.type==="error"){const T=new Error(`Connection error: ${z.reason}`);return T.code="VSCODE_CONNECTION_ERROR",T}return null}function F(z,T){for(;z.length<T;)z+=" ";return z}function N(z,T,R){return`[remote-connection][${F(w(z),13)}][${T.substr(0,5)}\u2026][${R?"reconnect":"initial"}]`}function H(z,T){return`${N(T,z.reconnectionToken,!!z.reconnectionProtocol)}[${z.host}:${z.port}]`}function re(z){return`${Date.now()-z} ms`}}),define(ee[221],te([0,1,78,83]),function(q,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(C,M,A,k,p,m){const y=E=>m(E,void 0),P=I.createConnection({host:C,port:M},()=>{P.removeListener("error",y);const E=Buffer.alloc(16);for(let b=0;b<16;b++)E[b]=Math.round(Math.random()*256);const h=E.toString("base64"),w=[`GET ws://${/:/.test(C)?`[${C}]`:C}:${M}${A}?${k}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${h}`];P.write(w.join(`\r
`)+`\r
\r
`);const d=b=>{b.toString().indexOf(`\r
\r
`)>=0&&(P.off("data",d),m(void 0,new t.NodeSocket(P,p)))};P.on("data",d)});P.setNoDelay(!0),P.once("error",y)}}}),define(ee[222],te([0,1,25,46,40,181]),function(q,e,I,t,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=void 0;let A;async function k(h=!1){return(A===void 0||h)&&(A=p()),A}e.hasWSLFeatureInstalled=k;async function p(){const h=m();if(h===void 0)return!1;if(h>=22e3){const w=P();if(w)return new Promise(d=>{t.execFile(w,["--status"],b=>d(!b))})}else{const w=E();if(w)try{if((await C.promises.stat(w)).isFile())return!0}catch{}}return!1}function m(){const h=/(\d+)\.(\d+)\.(\d+)/g.exec(I.release());if(h)return parseInt(h[3])}function y(h){const w=process.env.SystemRoot;if(w){const d=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return M.join(w,d?"Sysnative":"System32",h)}}function P(){return y("wsl.exe")}function E(){return y("lxss\\LxssManager.dll")}}),define(ee[55],te([0,1,17,165,65,5,48]),function(q,e,I,t,C,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,M.createDecorator)("requestService");function k(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}e.isSuccess=k;function p(d){return d.res.statusCode===204}async function m(d){return p(d)?null:(await(0,I.streamToBuffer)(d.stream)).toString()}e.asText=m;async function y(d){if(!k(d))throw new Error("Server returned "+d.res.statusCode);return m(d)}e.asTextOrError=y;async function P(d){if(!k(d))throw new Error("Server returned "+d.res.statusCode);if(p(d))return null;const u=(await(0,I.streamToBuffer)(d.stream)).toString();try{return JSON.parse(u)}catch(v){throw v.message+=`:
`+u,v}}e.asJson=P;function E(d){w(d)}e.updateProxyConfigurationsScope=E;let h;function w(d){const b=A.Registry.as(C.Extensions.Configuration),u=h;h={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:d,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},b.updateConfigurations({add:[h],remove:u?[u]:[]})}w(2)}),define(ee[223],te([0,1,17,22]),function(q,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class C{constructor(k){this.a=k}listen(k,p){throw new Error("Invalid listen")}call(k,p,m,y=t.CancellationToken.None){switch(p){case"request":return this.a.request(m[0],y).then(async({res:P,stream:E})=>{const h=await(0,I.streamToBuffer)(E);return[{statusCode:P.statusCode,headers:P.headers},h]});case"resolveProxy":return this.a.resolveProxy(m[0])}throw new Error("Invalid call")}}e.RequestChannel=C;class M{constructor(k){this.a=k}async request(k,p){const[m,y]=await this.a.call("request",[k],p);return{res:m,stream:(0,I.bufferToStream)(y)}}async resolveProxy(k){return this.a.call("resolveProxy",[k])}}e.RequestChannelClient=M}),define(ee[224],te([0,1,225,12]),function(q,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function C(A,k){return A.protocol==="http:"?k.HTTP_PROXY||k.http_proxy||null:A.protocol==="https:"&&(k.HTTPS_PROXY||k.https_proxy||k.HTTP_PROXY||k.http_proxy)||null}async function M(A,k,p={}){const m=(0,I.parse)(A),y=p.proxyUrl||C(m,k);if(!y)return null;const P=(0,I.parse)(y);if(!/^https?:$/.test(P.protocol||""))return null;const E={host:P.hostname||"",port:P.port||(P.protocol==="https"?"443":"80"),auth:P.auth,rejectUnauthorized:(0,t.isBoolean)(p.strictSSL)?p.strictSSL:!0};return m.protocol==="http:"?new(await new Promise((h,w)=>{q(["http-proxy-agent"],h,w)}))(E):new(await new Promise((h,w)=>{q(["https-proxy-agent"],h,w)}))(E)}e.getProxyAgent=M}),define(ee[111],te([0,1,46,9,166,22,45,14,4,29,142,61,8]),function(q,e,I,t,C,M,A,k,p,m,y,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const h=1e4;let w;async function d(u,v,g){return v["force-disable-user-env"]?(u.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):p.isWindows?(u.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,P.isLaunchedFromCli)(g)&&!v["force-user-env"]?(u.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,P.isLaunchedFromCli)(g)?u.trace("resolveShellEnv(): running (--force-user-env)"):u.trace("resolveShellEnv(): running (macOS/Linux)"),w||(w=E.Promises.withAsyncBody(async(f,c)=>{const n=new M.CancellationTokenSource,r=setTimeout(()=>{n.dispose(!0),c(new Error((0,C.localize)(0,null)))},h);try{f(await b(u,n.token))}catch(i){!(0,k.isCancellationError)(i)&&!n.token.isCancellationRequested?c(new Error((0,C.localize)(1,null,(0,A.toErrorMessage)(i)))):f({})}finally{clearTimeout(r),n.dispose()}})),w)}e.getResolvedShellEnv=d;async function b(u,v){const g=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",g);const f=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",f);const c=(0,m.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(c+"(.*)"+c),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};u.trace("getUnixShellEnvironment#env",r);const i=await(0,y.getSystemShell)(p.OS,r);return u.trace("getUnixShellEnvironment#shell",i),new Promise((a,s)=>{if(v.isCancellationRequested)return s((0,k.canceled)());const l=(0,t.basename)(i);let o,S;const D=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(l)?(o=`& '${process.execPath}' ${D} -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,S=["-Login","-Command"]):(o=`'${process.execPath}' ${D} -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,l==="tcsh"?S=["-ic"]:S=["-ilc"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(S),o);const L=(0,I.spawn)(i,[...S,o],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});v.onCancellationRequested(()=>(L.kill(),s((0,k.canceled)()))),L.on("error",ae=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,A.toErrorMessage)(ae)),s(ae)});const j=[];L.stdout.on("data",ae=>j.push(ae));const X=[];L.stderr.on("data",ae=>X.push(ae)),L.on("close",(ae,Y)=>{const J=Buffer.concat(j).toString("utf8");u.trace("getUnixShellEnvironment#raw",J);const se=Buffer.concat(X).toString("utf8");if(se.trim()&&u.trace("getUnixShellEnvironment#stderr",se),ae||Y)return s(new Error((0,C.localize)(2,null,ae,Y)));const ne=n.exec(J),he=ne?ne[1]:"{}";try{const K=JSON.parse(he);g?K.ELECTRON_RUN_AS_NODE=g:delete K.ELECTRON_RUN_AS_NODE,f?K.ELECTRON_NO_ATTACH_CONSOLE=f:delete K.ELECTRON_NO_ATTACH_CONSOLE,delete K.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",K),a(K)}catch(K){u.error("getUnixShellEnvironment#errorCaught",(0,A.toErrorMessage)(K)),s(K)}})})}}),define(ee[88],te([0,1,5]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,I.createDecorator)(e.SIGN_SERVICE_ID)}),define(ee[226],te([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class I{constructor(){this.b=new Map}c(){return new Promise((C,M)=>q(["vsda"],C,M))}async createNewMessage(C){try{const M=await this.c(),A=new M.validator;if(A){const k=String(I.a++);return this.b.set(k,A),{id:k,data:A.createNewMessage(C)}}}catch{}return{id:"",data:C}}async validate(C,M){if(!C.id)return!0;const A=this.b.get(C.id);if(!A)return!1;this.b.delete(C.id);try{return A.validate(M)==="ok"}catch{return!1}}async sign(C){try{const M=await this.c(),A=new M.signer;if(A)return A.sign(C)}catch{}return C}}e.SignService=I,I.a=1}),define(ee[35],te([0,1,5]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,I.createDecorator)("stateMainService")}),define(ee[21],te([0,1,13,41,8,3,2,4,32,12,5,6,35,27]),function(q,e,I,t,C,M,A,k,p,m,y,P,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,y.createDecorator)("lifecycleMainService");var w;(function(u){u[u.QUIT=1]="QUIT",u[u.KILL=2]="KILL"})(w=e.ShutdownReason||(e.ShutdownReason={}));var d;(function(u){u[u.Starting=1]="Starting",u[u.Ready=2]="Ready",u[u.AfterWindowOpen=3]="AfterWindowOpen",u[u.Eventually=4]="Eventually"})(d=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let b=class It extends A.Disposable{get quitRequested(){return this.i}get wasRestarted(){return this.j}get phase(){return this.k}constructor(v,g,f){super(),this.v=v,this.w=g,this.y=f,this.c=this.B(new M.Emitter),this.onBeforeShutdown=this.c.event,this.f=this.B(new M.Emitter),this.onWillShutdown=this.f.event,this.g=this.B(new M.Emitter),this.onWillLoadWindow=this.g.event,this.h=this.B(new M.Emitter),this.onBeforeCloseWindow=this.h.event,this.i=!1,this.j=!1,this.k=1,this.l=new Set,this.m=0,this.n=0,this.p=void 0,this.r=void 0,this.s=void 0,this.t=new Map,this.u=new Map,this.z(),this.when(2).then(()=>this.C())}z(){this.j=!!this.w.getItem(It.b),this.j&&this.w.removeItem(It.b)}C(){const v=()=>{this.i||(this.L("Lifecycle#app.on(before-quit)"),this.i=!0,this.L("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),k.isMacintosh&&this.n===0&&this.D(1))};I.app.addListener("before-quit",v);const g=()=>{this.L("Lifecycle#app.on(window-all-closed)"),(this.i||!k.isMacintosh)&&I.app.quit()};I.app.addListener("window-all-closed",g),I.app.once("will-quit",f=>{this.L("Lifecycle#app.on(will-quit)"),f.preventDefault(),this.D(1).finally(()=>{this.H(!1),I.app.removeListener("before-quit",v),I.app.removeListener("window-all-closed",g),I.app.quit()})})}D(v){if(this.s)return this.s;this.L("Lifecycle#onWillShutdown.fire()");const g=[];return this.f.fire({reason:v,join(f){g.push(f)}}),this.s=(async()=>{try{await C.Promises.settled(g)}catch(f){this.v.error(f)}try{await this.w.close()}catch(f){this.v.error(f)}})(),this.s}set phase(v){if(v<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.k===v)return;this.L(`lifecycle (main): phase changed (value: ${v})`),this.k=v;const g=this.u.get(this.k);g&&(g.open(),this.u.delete(this.k))}async when(v){if(v<=this.k)return;let g=this.u.get(v);g||(g=new C.Barrier,this.u.set(v,g)),await g.wait()}registerWindow(v){const g=new A.DisposableStore;this.n++,g.add(v.onWillLoad(c=>this.g.fire({window:v,workspace:c.workspace,reason:c.reason})));const f=(0,m.assertIsDefined)(v.win);f.on("close",c=>{const n=v.id;if(this.l.has(n)){this.l.delete(n);return}this.L(`Lifecycle#window.on('close') - window ID ${v.id}`),c.preventDefault(),this.unload(v,1).then(r=>{if(r){this.l.delete(n);return}this.l.add(n),this.L(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${n}`),this.h.fire(v),v.close()})}),f.on("closed",()=>{this.L(`Lifecycle#window.on('closed') - window ID ${v.id}`),this.n--,g.dispose(),this.n===0&&(!k.isMacintosh||this.i)&&this.D(1)})}async reload(v,g){await this.unload(v,3)||v.reload(g)}unload(v,g){const f=this.t.get(v.id);if(f)return f;const c=this.F(v,g).finally(()=>{this.t.delete(v.id)});return this.t.set(v.id,c),c}async F(v,g){if(!v.isReady)return!1;this.L(`Lifecycle#unload() - window ID ${v.id}`);const f=this.i?2:g,c=await this.I(v,f);return c?(this.L(`Lifecycle#unload() - veto in renderer (window ID ${v.id})`),this.G(c)):(await this.J(v,f),!1)}G(v){return v?(this.H(!0),this.i=!1,!0):!1}H(v){this.r&&(this.r(v),this.r=void 0,this.p=void 0)}I(v,g){return new Promise(f=>{const c=this.m++,n=`vscode:ok${c}`,r=`vscode:cancel${c}`;t.validatedIpcMain.once(n,()=>{f(!1)}),t.validatedIpcMain.once(r,()=>{f(!0)}),v.send("vscode:onBeforeUnload",{okChannel:n,cancelChannel:r,reason:g})})}J(v,g){return new Promise(f=>{const n=`vscode:reply${this.m++}`;t.validatedIpcMain.once(n,()=>f()),v.send("vscode:onWillUnload",{replyChannel:n,reason:g})})}quit(v){return this.L(`Lifecycle#quit() - begin (willRestart: ${v})`),this.p?(this.L("Lifecycle#quit() - returning pending quit promise"),this.p):(v&&this.w.setItem(It.b,!0),this.p=new Promise(g=>{this.r=g,this.L("Lifecycle#quit() - calling app.quit()"),I.app.quit()}),this.p)}L(v){this.y.args["enable-smoke-test-driver"]?this.v.info(v):this.v.trace(v)}async relaunch(v){this.L("Lifecycle#relaunch()");const g=process.argv.slice(1);if(v?.addArgs&&g.push(...v.addArgs),v?.removeArgs)for(const n of v.removeArgs){const r=g.indexOf(n);r>=0&&g.splice(r,1)}const f=()=>{try{if(k.isWindows){const n=(0,p.cwd)();n!==process.cwd()&&process.chdir(n)}}catch(n){this.v.error(n)}this.L("Lifecycle#relaunch() - calling app.relaunch()"),I.app.relaunch({args:g})};I.app.once("quit",f),await this.quit(!0)&&I.app.removeListener("quit",f)}async kill(v){this.L("Lifecycle#kill()"),await this.D(2),await Promise.race([(0,C.timeout)(1e3),(async()=>{for(const g of I.BrowserWindow.getAllWindows())if(g&&!g.isDestroyed()){let f;g.webContents&&!g.webContents.isDestroyed()?f=new Promise(c=>g.once("closed",c)):f=Promise.resolve(),g.destroy(),await f}})()]),I.app.exit(v)}};b.b="lifecycle.quitAndRestart",b=pe([_(0,P.ILogService),_(1,E.IStateMainService),_(2,h.IEnvironmentMainService)],b),e.LifecycleMainService=b}),define(ee[227],te([0,1,4,3,2,5,21]),function(q,e,I,t,C,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,M.createDecorator)("keyboardLayoutMainService");let k=class extends C.Disposable{constructor(y){super(),this.a=this.B(new t.Emitter),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,y.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const y=await new Promise((P,E)=>{q(["native-keymap"],P,E)});this.c=p(y),I.isCI||y.onDidChangeKeyboardLayout(()=>{this.c=p(y),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};k=pe([_(0,A.ILifecycleMainService)],k),e.KeyboardLayoutMainService=k;function p(m){const y=m.getKeyMap(),P=m.getCurrentKeyboardLayout();return{keyboardMapping:y,keyboardLayoutInfo:P}}}),define(ee[228],te([0,1,5]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,I.createDecorator)("stateService")}),define(ee[229],te([0,1,8,17,12,34,16,6]),function(q,e,I,t,C,M,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class p{constructor(P,E,h){this.f=P,this.g=E,this.h=h,this.a=Object.create(null),this.b="",this.c=new I.ThrottledDelayer(100),this.d=void 0,this.e=void 0}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(P){P.fileOperationResult!==1&&this.g.error(P)}}getItem(P,E){const h=this.a[P];return(0,C.isUndefinedOrNull)(h)?E:h}setItem(P,E){this.setItems([{key:P,data:E}])}setItems(P){let E=!1;for(const{key:h,data:w}of P)this.a[h]!==w&&((0,C.isUndefinedOrNull)(w)?(0,C.isUndefined)(this.a[h])||(this.a[h]=void 0,E=!0):(this.a[h]=w,E=!0));E&&this.j()}removeItem(P){(0,C.isUndefined)(this.a[P])||(this.a[P]=void 0,this.j())}async j(){if(!this.e)return this.c.trigger(()=>this.k())}async k(){if(!this.d)return;await this.d;const P=JSON.stringify(this.a,null,4);if(P!==this.b)try{await this.h.writeFile(this.f,t.VSBuffer.fromString(P)),this.b=P}catch(E){this.g.error(E)}}async close(){return this.e||(this.e=this.c.trigger(()=>this.k(),0)),this.e}}e.FileStorage=p;let m=class{constructor(P,E,h){this.a=new p(P.stateResource,E,h)}async init(){await this.a.init()}getItem(P,E){return this.a.getItem(P,E)}};m=pe([_(0,M.IEnvironmentService),_(1,k.ILogService),_(2,A.IFileService)],m),e.StateService=m}),define(ee[230],te([0,1,229]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=void 0;class t extends I.StateService{setItem(M,A){this.a.setItem(M,A)}setItems(M){this.a.setItems(M)}removeItem(M){this.a.removeItem(M)}close(){return this.a.close()}}e.StateMainService=t}),define(ee[89],te([0,1,4,32,7,29]),function(q,e,I,t,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(m){if(I.platform===2&&/^penguin(\.|$)/i.test(m))return"chromebook"}async function k(m,y,P,E,h,w,d,b,u,v){const g=Object.create(null);g["common.machineId"]=d,g.sessionID=(0,M.generateUuid)()+Date.now(),g.commitHash=h,g.version=w,g["common.platformVersion"]=(y||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,I.PlatformToString)(I.platform),g["common.nodePlatform"]=t.platform,g["common.nodeArch"]=E,g["common.product"]=v||"desktop",b&&(g["common.msftInternal"]=b);let f=0;const c=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),I.isLinuxSnap&&(g["common.snap"]="true");const n=A(P);n&&(g["common.platformDetail"]=n);try{const r=await m.readFile(C.URI.file(u));g["common.source"]=r.value.toString().slice(0,30)}catch{}return g}e.resolveCommonProperties=k;function p(m){const y=t.env.USERDNSDOMAIN;if(!y)return!1;const P=y.toLowerCase();return m.some(E=>P===E)}e.verifyMicrosoftInternalDomain=p}),define(ee[36],te([0,1,5]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,I.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,I.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var C;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(C=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ee[231],te([0,1,25,8,43,15,9,4,7,81,23,101,84,16,19,36]),function(q,e,I,t,C,M,A,k,p,m,y,P,E,h,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const b=new Map;async function u(n,r){const i=`${n}::${r.join(":")}`,a=b.get(i);if(a)return a;const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],l=new Map,o=new Map,S=2e4;function D(j,X,ae,Y){const J=X.substring(j.length+1);return t.Promises.withAsyncBody(async se=>{let ne;try{ne=await y.Promises.readdir(X,{withFileTypes:!0})}catch{se();return}if(Y.count>=S){Y.count+=ne.length,Y.maxReached=!0,se();return}let he=ne.length;if(he===0){se();return}let K=ne;Y.count+ne.length>S&&(Y.maxReached=!0,he=S-Y.count,K=ne.slice(0,he)),Y.count+=ne.length;for(const le of K)if(le.isDirectory()){if(ae.includes(le.name)||await D(j,(0,A.join)(X,le.name),ae,Y),--he===0){se();return}}else{const W=le.name.lastIndexOf(".");if(W>=0){const F=le.name.substring(W+1);F&&l.set(F,(l.get(F)??0)+1)}for(const F of s)F.relativePathPattern?.test(J)!==!1&&F.filePattern.test(le.name)&&o.set(F.tag,(o.get(F.tag)??0)+1);if(--he===0){se();return}}})}const L=t.Promises.withAsyncBody(async j=>{const X={count:0,maxReached:!1};await D(n,n,r,X);const ae=await f(n);j({configFiles:v(o),fileTypes:v(l),fileCount:X.count,maxFilesReached:X.maxReached,launchConfigFiles:ae})});return b.set(i,L),L}e.collectWorkspaceStats=u;function v(n){return Array.from(n.entries(),([r,i])=>({name:r,count:i})).sort((r,i)=>i.count-r.count)}function g(){const n={os:`${I.type()} ${I.arch()} ${I.release()}`,memory:`${(I.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(I.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(m.virtualMachineHint.value()*100)}%`},r=I.cpus();return r&&r.length>0&&(n.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),n}e.getMachineInfo=g;async function f(n){try{const r=new Map,i=(0,A.join)(n,".vscode","launch.json"),a=await y.Promises.readFile(i),s=[],l=(0,C.parse)(a.toString(),s);if(s.length)return console.log(`Unable to parse ${i}`),[];if((0,C.getNodeType)(l)==="object"&&l.configurations)for(const o of l.configurations){const S=o.type;S&&(r.has(S)?r.set(S,r.get(S)+1):r.set(S,1))}return v(r)}catch{return[]}}e.collectLaunchConfigs=f;let c=class{constructor(r,i){this.c=r,this.d=i}f(r){const i=[];return i.push(`OS Version:       ${r.os}`),i.push(`CPUs:             ${r.cpus}`),i.push(`Memory (System):  ${r.memory}`),i.push(`VM:               ${r.vmHint}`),i.join(`
`)}g(r){const i=[];i.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),i.push(`OS Version:       ${I.type()} ${I.arch()} ${I.release()}`);const a=I.cpus();return a&&a.length>0&&i.push(`CPUs:             ${a[0].model} (${a.length} x ${a[0].speed})`),i.push(`Memory (System):  ${(I.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(I.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),k.isWindows||i.push(`Load (avg):       ${I.loadavg().map(s=>Math.round(s)).join(", ")}`),i.push(`VM:               ${Math.round(m.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${r.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.j(r.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(r,i){return Promise.all([(0,P.listProcesses)(r.mainPID),this.k(r)]).then(async a=>{let[s,l]=a,o=this.m(r,s);return i.forEach(S=>{if((0,E.isRemoteDiagnosticError)(S))o+=`
${S.errorMessage}`,l+=`
${S.errorMessage}`;else if(o+=`

Remote: ${S.hostName}`,S.processes&&(o+=`
${this.m(r,S.processes)}`),S.workspaceMetadata){l+=`
|  Remote: ${S.hostName}`;for(const D of Object.keys(S.workspaceMetadata)){const L=S.workspaceMetadata[D];let j=`${L.fileCount} files`;L.maxFilesReached&&(j=`more than ${j}`),l+=`|    Folder (${D}): ${j}`,l+=this.h(L)}}}),{processInfo:o,workspaceInfo:l}})}async getSystemInfo(r,i){const{memory:a,vmHint:s,os:l,cpus:o}=g(),S={os:l,memory:a,cpus:o,vmHint:s,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:i};return k.isWindows||(S.load=`${I.loadavg().map(D=>Math.round(D)).join(", ")}`),k.isLinux&&(S.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(S)}async getDiagnostics(r,i){const a=[];return(0,P.listProcesses)(r.mainPID).then(async s=>(a.push(""),a.push(this.g(r)),a.push(""),a.push(this.m(r,s)),r.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(a.push(""),a.push("Workspace Stats: "),a.push(await this.k(r))),i.forEach(l=>{if((0,E.isRemoteDiagnosticError)(l))a.push(`
${l.errorMessage}`);else if(a.push(`

`),a.push(`Remote:           ${l.hostName}`),a.push(this.f(l.machineInfo)),l.processes&&a.push(this.m(r,l.processes)),l.workspaceMetadata)for(const o of Object.keys(l.workspaceMetadata)){const S=l.workspaceMetadata[o];let D=`${S.fileCount} files`;S.maxFilesReached&&(D=`more than ${D}`),a.push(`Folder (${o}): ${D}`),a.push(this.h(S))}}),a.push(""),a.push(""),a.join(`
`)))}h(r){const i=[];let s=0;const l=(L,j)=>{const X=` ${L}(${j})`;s+X.length>60?(i.push(o),o="|                 ",s=o.length):s+=X.length,o+=X};let o="|      File types:";const S=10,D=r.fileTypes.length>S?S:r.fileTypes.length;for(let L=0;L<D;L++){const j=r.fileTypes[L];l(j.name,j.count)}if(i.push(o),r.configFiles.length>=0&&(o="|      Conf files:",s=0,r.configFiles.forEach(L=>{l(L.name,L.count)}),i.push(o)),r.launchConfigFiles.length>0){let L="|      Launch Configs:";r.launchConfigFiles.forEach(j=>{L+=j.count>1?` ${j.name}(${j.count})`:` ${j.name}`}),i.push(L)}return i.join(`
`)}j(r){const i=Math.max(...Object.keys(r).map(a=>a.length));return Object.keys(r).map(a=>`${a}:  ${" ".repeat(i-a.length)}  ${r[a]}`).join(`
                  `)}k(r){const i=[],a=[];return r.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(i.push(`|  Window (${s.title})`),s.folderURIs.forEach(l=>{const o=p.URI.revive(l);if(o.scheme===M.Schemas.file){const S=o.fsPath;a.push(u(S,["node_modules",".git"]).then(D=>{let L=`${D.fileCount} files`;D.maxFilesReached&&(L=`more than ${L}`),i.push(`|    Folder (${(0,A.basename)(S)}): ${L}`),i.push(this.h(D))}).catch(D=>{i.push(`|      Error: Unable to collect workspace stats for folder ${S} (${D.toString()})`)}))}else i.push(`|    Folder (${o.toString()}): Workspace stats not available.`)}))}),Promise.all(a).then(s=>i.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}m(r,i){const a=new Map;r.windows.forEach(l=>a.set(l.pid,l.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),i&&this.n(r.mainPID,a,s,i,0),s.join(`
`)}n(r,i,a,s,l){const o=l===0;let S;o?S=s.pid===r?`${this.d.applicationName} main`:"remote agent":(S=`${"  ".repeat(l)} ${s.name}`,s.name==="window"&&(S=`${S} (${i.get(s.pid)})`));const D=process.platform==="win32"?s.mem:I.totalmem()*(s.mem/100);a.push(`${s.load.toFixed(0).padStart(5," ")}	${(D/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${S}`),Array.isArray(s.children)&&s.children.forEach(L=>this.n(r,i,a,L,l+1))}async getWorkspaceFileExtensions(r){const i=new Set;for(const{uri:a}of r.folders){const s=p.URI.revive(a);if(s.scheme!==M.Schemas.file)continue;const l=s.fsPath;try{(await u(l,["node_modules",".git"])).fileTypes.forEach(S=>i.add(S.name))}catch{}}return{extensions:[...i]}}async reportWorkspaceStats(r){for(const{uri:i}of r.folders){const a=p.URI.revive(i);if(a.scheme!==M.Schemas.file)continue;const s=a.fsPath;try{const l=await u(s,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),l.fileTypes.forEach(o=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:o.name,count:o.count})}),l.launchConfigFiles.forEach(o=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:o.name,count:o.count})}),l.configFiles.forEach(o=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:o.name,count:o.count})})}catch{}}}};c=pe([_(0,d.ITelemetryService),_(1,w.IProductService)],c),e.DiagnosticsService=c}),define(ee[232],te([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class I{constructor(M){this.b=M}listen(M,A){throw new Error(`Event not found: ${A}`)}call(M,A,{eventName:k,data:p}){return this.b.forEach(m=>m.log(k,p)),Promise.resolve(null)}}e.TelemetryAppenderChannel=I;class t{constructor(M){this.b=M}log(M,A){return this.b.call("log",{eventName:M,data:A}).then(void 0,k=>`Failed to log telemetry: ${console.warn(k)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=t}),define(ee[56],te([0,1,44,12,18,54,89,36]),function(q,e,I,t,C,M,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TrustedTelemetryValue=void 0;class p{constructor(l){this.value=l}}e.TrustedTelemetryValue=p;class m{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(l,o){return Promise.resolve(void 0)}publicLog2(l,o){return this.publicLog(l,o)}publicLogError(l,o){return Promise.resolve(void 0)}publicLogError2(l,o){return this.publicLogError(l,o)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=m,e.NullTelemetryService=new m;class y{async publicLog(l,o,S){}async publicLogError(l,o,S){}}e.NullEndpointTelemetryService=y,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function P(s,l){return l.onDidChangeConfiguration(o=>{o.source!==7&&s.publicLog2("updateConfiguration",{configurationSource:(0,C.ConfigurationTargetToString)(o.source),configurationKeys:g(o.sourceConfig)})})}e.configurationTelemetry=P;function E(s,l){return!l.isBuilt&&!l.disableTelemetry?!0:!(l.disableTelemetry||!s.enableTelemetry||l.extensionTestsLocationURI)}e.supportsTelemetry=E;function h(s,l){return!(l.isBuilt||l.disableTelemetry||s.enableTelemetry&&s.aiConfig?.ariaKey)}e.isLoggingOnly=h;function w(s){const l=s.getValue(k.TELEMETRY_SETTING_ID),o=s.getValue("telemetry.enableCrashReporter");if(s.getValue(k.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return 0;switch(l??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=w;function d(s){const l={},o={},S={};v(s,S);for(let D in S){D=D.length>150?D.substr(D.length-149):D;const L=S[D];typeof L=="number"?o[D]=L:typeof L=="boolean"?o[D]=L?1:0:typeof L=="string"?(L.length>8192&&console.warn(`Telemetry property: ${D} has been trimmed to 8192, the original length is ${L.length}`),l[D]=L.substring(0,8191)):typeof L<"u"&&L!==null&&(l[D]=L)}return{properties:l,measurements:o}}e.validateTelemetryData=d;const b=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function u(s){if(!s)return"none";const l=(0,M.getRemoteName)(s);return b.has(l)?l:"other"}e.cleanRemoteAuthority=u;function v(s,l,o=0,S){if(!!s)for(const D of Object.getOwnPropertyNames(s)){const L=s[D],j=S?S+D:D;Array.isArray(L)?l[j]=(0,I.safeStringify)(L):L instanceof Date?l[j]=L.toISOString():(0,t.isObject)(L)?o<2?v(L,l,o+1,j+"."):l[j]=(0,I.safeStringify)(L):l[j]=L}}function g(s){if(!s)return[];const l=[];return f(l,"",s),l}function f(s,l,o){o&&typeof o=="object"&&!Array.isArray(o)?Object.keys(o).forEach(S=>f(s,l?`${l}.${S}`:S,o[S])):s.push(l)}function c(s,l){const o=s.msftInternalDomains||[],S=l.getValue("telemetry.internalTesting");return(0,A.verifyMicrosoftInternalDomain)(o)||S}e.isInternalTelemetry=c;function n(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}e.getPiiPathsFromEnvironment=n;function r(s,l){if(!s||!s.includes("/")&&!s.includes("\\"))return s;let o=s;const S=[];for(const X of l)for(;;){const ae=X.exec(s);if(!ae)break;S.push([ae.index,X.lastIndex])}const D=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,L=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let j=0;for(o="";;){const X=L.exec(s);if(!X)break;const ae=S.some(([Y,J])=>X.index<J&&Y<L.lastIndex);!D.test(X[0])&&!ae&&(o+=s.substring(j,X.index)+"<REDACTED: user-file-path>",j=L.lastIndex)}return j<s.length&&(o+=s.substr(j)),o}function i(s){if(!s)return s;const l=s.toLowerCase(),o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const S of o)if(S.regex.test(l))return`<REDACTED: ${S.label}>`;return s}function a(s,l){return(0,I.cloneAndChange)(s,o=>{if(o instanceof p)return o.value;if(typeof o=="string"){let S=o.replaceAll("%20"," ");S=r(S,l);for(const D of l)S=S.replace(D,"");return S=i(S),S}})}e.cleanData=a}),define(ee[233],te([0,1,188,56]),function(q,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function C(M,A,k,p,m,y,P){const E={"X-Market-Client-Id":`VSCode ${M}`,"User-Agent":`VSCode ${M} (${A.nameShort})`};if((0,t.supportsTelemetry)(A,k)&&(0,t.getTelemetryLevel)(p)===3){const h=await(0,I.getServiceMachineId)(k,m,y),{machineId:w}=await P.getTelemetryInfo();E["X-Market-User-Id"]=h,E["VSCode-SessionId"]=w||h}return E}e.resolveMarketplaceHeaders=C}),define(ee[234],te([0,1,14,44,56]),function(q,e,I,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const M="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function A(p,m,y){const P=await new Promise((b,u)=>{q(["@microsoft/1ds-core-js"],b,u)}),E=await new Promise((b,u)=>{q(["@microsoft/1ds-post-js"],b,u)}),h=new P.AppInsightsCore,w=new E.PostChannel,d={instrumentationKey:p,endpointUrl:M,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[w]]};if(y){d.extensionConfig={};const b={alwaysUseXhrOverride:!0,httpXHROverride:y};d.extensionConfig[w.identifier]=b}return h.initialize(d,[]),h.addTelemetryInitializer(b=>{m&&(b.ext=b.ext??{},b.ext.utc=b.ext.utc??{},b.ext.utc.flags=8462029)}),h}class k{constructor(m,y,P,E,h){this.d=m,this.e=y,this.f=P,this.g=h,this.c=M,this.f||(this.f={}),typeof E=="function"?this.a=E():this.a=E,this.b=null}h(m){if(!!this.a){if(typeof this.a!="string"){m(this.a);return}this.b||(this.b=A(this.a,this.d,this.g)),this.b.then(y=>{m(y)},y=>{(0,I.onUnexpectedError)(y),console.error(y)})}}log(m,y){if(!this.a)return;y=(0,t.mixin)(y,this.f),y=(0,C.validateTelemetryData)(y);const P=this.e+"/"+m;try{this.h(E=>{E.pluginVersionString=y?.properties.version??"Unknown",E.track({name:P,baseData:{name:P,properties:y?.properties,measurements:y?.measurements}})})}catch{}}flush(){return this.a?new Promise(m=>{this.h(y=>{y.unload(!0,()=>{this.a=void 0,m(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=k}),define(ee[112],te([0,1,2,44,4,26,167,18,65,63,19,48,36,56]),function(q,e,I,t,C,M,A,k,p,m,y,P,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let w=class{constructor(u,v,g){this.k=v,this.l=g,this.d={},this.i=new I.DisposableStore,this.j=[],this.b=u.appenders,this.c=u.commonProperties||Promise.resolve({}),this.f=u.piiPaths||[],this.g=3,this.h=!!u.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const f of this.f)this.j.push(new RegExp((0,M.escapeRegExpCharacters)(f),"gi")),f.indexOf("\\")>=0&&this.j.push(new RegExp((0,M.escapeRegExpCharacters)(f.replace(/\\/g,"/")),"gi"));this.m(),this.k.onDidChangeConfiguration(this.m,this,this.i)}setExperimentProperty(u,v){this.d[u]=v}m(){let u=(0,h.getTelemetryLevel)(this.k);const v=this.l.enabledTelemetryLevels;if(v){this.h=this.sendErrorTelemetry?v.error:!1;const g=v.usage?3:v.error?2:0;u=Math.min(u,g)}this.g=u}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const u=await this.c,v=u.sessionID,g=u["common.machineId"],f=u["common.firstSessionDate"],c=u["common.msftInternal"];return{sessionId:v,machineId:g,firstSessionDate:f,msftInternal:c}}dispose(){this.i.dispose()}n(u,v,g){return this.g<v?Promise.resolve(void 0):this.c.then(f=>{g=(0,t.mixin)(g,this.d),g=(0,h.cleanData)(g,this.j),g=(0,t.mixin)(g,f),this.b.forEach(c=>c.log(u,g))},f=>{console.error(f)})}publicLog(u,v){return this.n(u,3,v)}publicLog2(u,v){return this.publicLog(u,v)}publicLogError(u,v){return this.h?this.n(u,2,v):Promise.resolve(void 0)}publicLogError2(u,v){return this.publicLogError(u,v)}};w.IDLE_START_EVENT_NAME="UserIdleStart",w.IDLE_STOP_EVENT_NAME="UserIdleStop",w=pe([_(1,k.IConfigurationService),_(2,y.IProductService)],w),e.TelemetryService=w;function d(){const b=(0,A.localize)(0,null,m.default.nameLong),u=m.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",m.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),v=C.isWeb?"":(0,A.localize)(3,null),g=(0,A.localize)(4,null),f=(0,A.localize)(5,null),c=(0,A.localize)(6,null),n=(0,A.localize)(7,null),r=`
|       | ${g} | ${f} | ${c} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,A.localize)(8,null);return`
${b} ${u} ${v}

&nbsp;

${n}
${r}

&nbsp;

${i}
`}P.Registry.as(p.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,A.localize)(9,null),properties:{[E.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:d(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),P.Registry.as(p.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[E.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:m.default.privacyStatementUrl?(0,A.localize)(16,null,m.default.nameLong,m.default.privacyStatementUrl):(0,A.localize)(15,null,m.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${E.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ee[235],te([0,1,280,234]),function(q,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class C extends t.AbstractOneDataSystemAppender{constructor(A,k,p,m){const y={sendPOST:(P,E)=>{const h={method:"POST",headers:{...P.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(P.data)}};try{const w=I.request(P.urlString,h,d=>{d.on("data",function(b){E(d.statusCode??200,d.headers,b.toString())}),d.on("error",function(b){E(0,{})})});w.write(P.data),w.end()}catch{E(0,{})}}};super(A,k,p,m,y)}}e.OneDataSystemAppender=C}),define(ee[236],te([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var I;(function(M){M.DARK="dark",M.LIGHT="light",M.HIGH_CONTRAST_DARK="hcDark",M.HIGH_CONTRAST_LIGHT="hcLight"})(I=e.ColorScheme||(e.ColorScheme={}));function t(M){return M===I.HIGH_CONTRAST_DARK||M===I.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function C(M){return M===I.DARK||M===I.HIGH_CONTRAST_DARK}e.isDark=C}),define(ee[237],te([0,1,119,3,2,5,48,236]),function(q,e,I,t,C,M,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,M.createDecorator)("themeService");var p;(function(b){function u(v){return v&&typeof v=="object"&&typeof v.id=="string"}b.isThemeColor=u})(p=e.ThemeColor||(e.ThemeColor={}));function m(b){return{id:b}}e.themeColorFromId=m;var y;(function(b){function u(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color>"u"||p.isThemeColor(a.color))}b.isThemeIcon=u;const v=new RegExp(`^\\$\\((${I.CSSIcon.iconNameExpression}(?:${I.CSSIcon.iconModifierExpression})?)\\)$`);function g(a){const s=v.exec(a);if(!s)return;const[,l]=s;return{id:l}}b.fromString=g;function f(a){return{id:a}}b.fromId=f;function c(a,s){let l=a.id;const o=l.lastIndexOf("~");return o!==-1&&(l=l.substring(0,o)),s&&(l=`${l}~${s}`),{id:l}}b.modify=c;function n(a){const s=a.id.lastIndexOf("~");if(s!==-1)return a.id.substring(s+1)}b.getModifier=n;function r(a,s){return a.id===s.id&&a.color?.id===s.color?.id}b.isEqual=r;function i(a,s){return{id:a.id,color:s?m(s):void 0}}b.asThemeIcon=i,b.asClassNameArray=I.CSSIcon.asClassNameArray,b.asClassName=I.CSSIcon.asClassName,b.asCSSSelector=I.CSSIcon.asCSSSelector})(y=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=I.Codicon.file,e.FolderThemeIcon=I.Codicon.folder;function P(b){switch(b){case k.ColorScheme.DARK:return"vs-dark";case k.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case k.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=P,e.Extensions={ThemingContribution:"base.contributions.theming"};class E{constructor(){this.a=[],this.a=[],this.b=new t.Emitter}onColorThemeChange(u){return this.a.push(u),this.b.fire(u),(0,C.toDisposable)(()=>{const v=this.a.indexOf(u);this.a.splice(v,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const h=new E;A.Registry.add(e.Extensions.ThemingContribution,h);function w(b){return h.onColorThemeChange(b)}e.registerThemingParticipant=w;class d extends C.Disposable{constructor(u){super(),this.k=u,this.h=u.getColorTheme(),this.B(this.k.onDidColorThemeChange(v=>this.n(v)))}n(u){this.h=u,this.updateStyles()}updateStyles(){}w(u,v){let g=this.h.getColor(u);return g&&v&&(g=v(g,this.h)),g?g.toString():null}}e.Themable=d}),define(ee[66],te([0,1,13,3,2,4,18,5,35]),function(q,e,I,t,C,M,A,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const m="#FFFFFF",y="#1E1E1E",P="#000000",E="#FFFFFF",h="theme",w="themeBackground",d="windowSplash";e.IThemeMainService=(0,k.createDecorator)("themeMainService");let b=class extends C.Disposable{constructor(v,g){super(),this.b=v,this.c=g,this.a=this.B(new t.Emitter),this.onDidChangeColorScheme=this.a.event,I.nativeTheme.on("updated",()=>{this.a.fire(this.getColorScheme())})}getColorScheme(){if(M.isWindows){if(I.nativeTheme.shouldUseHighContrastColors)return{dark:I.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(M.isMacintosh){if(I.nativeTheme.shouldUseInvertedColorScheme||I.nativeTheme.shouldUseHighContrastColors)return{dark:I.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(M.isLinux&&I.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:I.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const v=this.getColorScheme();if(v.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return v.dark?P:E;let g=this.b.getItem(w,null);if(!g)switch(this.b.getItem(h,"vs-dark").split(" ")[0]){case"vs":g=m;break;case"hc-black":g=P;break;case"hc-light":g=E;break;default:g=y}return M.isMacintosh&&g.toUpperCase()===y&&(g="#171717"),g}saveWindowSplash(v,g){this.b.setItems([{key:h,data:g.baseTheme},{key:w,data:g.colorInfo.background},{key:d,data:g}]),typeof v=="number"&&this.f(v,g)}f(v,g){for(const f of I.BrowserWindow.getAllWindows())if(f.id===v){f.setBackgroundColor(g.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(d)}};b=pe([_(0,p.IStateMainService),_(1,A.IConfigurationService)],b),e.ThemeMainService=b}),define(ee[113],te([0,1,3,18,5,6]),function(q,e,I,t,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,C.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,C.createDecorator)("sharedTunnelsService");var A;(function(d){d.Http="http",d.Https="https"})(A=e.TunnelProtocol||(e.TunnelProtocol={}));var k;(function(d){d.ConstantPrivate="constantPrivate",d.Private="private",d.Public="public"})(k=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var p;(function(d){d[d.Notify=1]="Notify",d[d.OpenBrowser=2]="OpenBrowser",d[d.OpenPreview=3]="OpenPreview",d[d.Silent=4]="Silent",d[d.Ignore=5]="Ignore",d[d.OpenBrowserOnce=6]="OpenBrowserOnce"})(p=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function m(d){if(d.scheme!=="http"&&d.scheme!=="https")return;const b=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(d.authority);if(!!b)return{address:b[1],port:+b[2]}}e.extractLocalHostUriMetaDataForPortMapping=m,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function y(d){return e.LOCALHOST_ADDRESSES.indexOf(d)>=0}e.isLocalhost=y,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function P(d){return e.ALL_INTERFACES_ADDRESSES.indexOf(d)>=0}e.isAllInterfaces=P;function E(d,b,u,v){if(u===1)return!1;if(u===2&&P(b)){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(v);if(g?.length===4&&parseInt(g[1])>=18)return!1}return d<1024}e.isPortPrivileged=E;class h{constructor(b,u,v){this.remoteAddress=b,this.localAddress=u,this.b=v,this.a=new I.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=h;let w=class{constructor(b,u){this.i=b,this.j=u,this.a=new I.Emitter,this.onTunnelOpened=this.a.event,this.b=new I.Emitter,this.onTunnelClosed=this.b.event,this.c=new I.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const b=this.j.getValue("remote.localPortHost");return!b||b==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(b){return this.e=b,b?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(b){this.f=b.elevation,this.g=b.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const b=[],u=Array.from(this.d.values());for(const v of u){const g=Array.from(v.values());for(const f of g){const c=await f.value;c&&b.push(c)}}return b}async dispose(){for(const b of this.d.values()){for(const{value:u}of b.values())await u.then(v=>v?.dispose());b.clear()}this.d.clear()}setEnvironmentTunnel(b,u,v,g,f){this.o(b,u,Promise.resolve({tunnelRemoteHost:b,tunnelRemotePort:u,localAddress:v,privacy:g,protocol:f,dispose:()=>Promise.resolve()}))}async getExistingTunnel(b,u){(P(b)||y(b))&&(b=e.LOCALHOST_ADDRESSES[0]);const v=this.q(b,u);if(v)return++v.refcount,v.value}openTunnel(b,u,v,g,f=!1,c,n){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${v} on local port ${g}.`),!b)return;if(u||(u="localhost"),this.e&&this.h.has(v)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.r(b,u,v,g,f,c,n);return r?r.then(i=>{if(!i){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(u,v);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.m(i);return(i.tunnelRemoteHost!==u||i.tunnelRemotePort!==v)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(a),a}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}m(b){return{tunnelRemotePort:b.tunnelRemotePort,tunnelRemoteHost:b.tunnelRemoteHost,tunnelLocalPort:b.tunnelLocalPort,localAddress:b.localAddress,privacy:b.privacy,protocol:b.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${b.tunnelRemoteHost}:${b.tunnelRemotePort} `);const u=this.d.get(b.tunnelRemoteHost);if(u){const v=u.get(b.tunnelRemotePort);v&&(v.refcount--,await this.n(b.tunnelRemoteHost,b.tunnelRemotePort,v))}}}}async n(b,u,v){if(v.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${b}:${u}.`);const g=v.value.then(async f=>{f&&(await f.dispose(!0),this.b.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this.d.has(b)&&this.d.get(b).delete(u),g}}async closeTunnel(b,u){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${b}:${u} `);const v=this.d.get(b);if(v&&v.has(u)){const g=v.get(u);g.refcount=0,await this.n(b,u,g)}}o(b,u,v){this.d.has(b)||this.d.set(b,new Map),this.d.get(b).set(u,{refcount:1,value:v})}async p(b,u){const v=this.d.get(b);v&&(await v.get(u)||v.delete(u),v.size===0&&this.d.delete(b))}q(b,u){const v=[b];y(b)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):P(b)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const g=v.map(f=>this.d.get(f));for(const f of g){const c=f?.get(u);if(c)return c}}canTunnel(b){return!!m(b)}s(b,u,v,g,f,c,n){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${v} on local port ${g}.`);const r=v;this.h.add(r);const i=g===void 0?v:g,a={elevationRequired:f?this.isPortPrivileged(i):!1},s={remoteAddress:{host:u,port:v},localAddressPort:g,privacy:c,public:c?c!==k.Private:void 0,protocol:n},l=b.forwardPort(s,a);return l?(this.o(u,v,l),l.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(r)})):this.h.delete(r),l}};w=pe([_(0,M.ILogService),_(1,t.IConfigurationService)],w),e.AbstractTunnelService=w}),define(ee[238],te([0,1,78,25,97,221,8,2,18,6,19,220,113,88,4]),function(q,e,I,t,C,M,A,k,p,m,y,P,E,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function d(f,c,n,r,i){let a;for(let s=3;s&&(a?.dispose(),a=await new b(f,c,n,r,i).waitForReady(),!(i&&C.BROWSER_RESTRICTED_PORTS[i]||!C.BROWSER_RESTRICTED_PORTS[a.tunnelLocalPort]));s--);return a}class b extends k.Disposable{constructor(c,n,r,i,a){super(),this.j=n,this.k=a,this.privacy=E.TunnelPrivacyId.Private,this.i=new Map,this.a=c,this.b=I.createServer(),this.c=new A.Barrier,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=s=>this.l(s),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=i,this.tunnelRemoteHost=r}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(n=>{n()})}async waitForReady(){const c=this.k??this.tunnelRemotePort,n=(0,E.isAllInterfaces)(this.j)?"0.0.0.0":"127.0.0.1";let r=await(0,C.findFreePortFaster)(c,2,1e3,n),i=null;return this.b.listen(r,this.j),await this.c.wait(),i=this.b.address(),i||(r=0,this.b.listen(r,this.j),await this.c.wait(),i=this.b.address()),this.tunnelLocalPort=i.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${i.port}`,this}async l(c){c.pause();const n=(0,E.isLocalhost)(this.tunnelRemoteHost)||(0,E.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,r=await(0,P.connectRemoteAgentTunnel)(this.a,n,this.tunnelRemotePort),i=r.getSocket().socket,a=r.readEntireBuffer();r.dispose(),a.byteLength>0&&c.write(a.buffer),c.on("end",()=>{c.localAddress&&this.i.delete(c.localAddress),i.end()}),c.on("close",()=>i.end()),c.on("error",()=>{c.localAddress&&this.i.delete(c.localAddress),i.destroy()}),i.on("end",()=>c.end()),i.on("close",()=>c.end()),i.on("error",()=>{c.destroy()}),c.pipe(i),i.pipe(c),c.localAddress&&this.i.set(c.localAddress,()=>{c.end(),i.end()})}}let u=class extends E.AbstractTunnelService{constructor(c,n,r,i,a){super(n,a),this.t=c,this.u=r,this.v=i}isPortPrivileged(c){return(0,E.isPortPrivileged)(c,this.k,w.OS,t.release())}r(c,n,r,i,a,s,l){const o=this.q(n,r);if(o)return++o.refcount,o.value;if(this.e)return this.s(this.e,n,r,i,a,s,l);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${r} on local port ${i}.`);const S={commit:this.v.commit,quality:this.v.quality,socketFactory:this.t,addressProvider:c,signService:this.u,logService:this.i,ipcLogger:null},D=d(S,this.k,n,r,i);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(n,r,D),D}}};u=pe([_(1,m.ILogService),_(2,h.ISignService),_(3,y.IProductService),_(4,p.IConfigurationService)],u),e.BaseTunnelService=u;let v=class extends u{constructor(c,n,r,i){super(M.nodeSocketFactory,c,n,r,i)}};v=pe([_(0,m.ILogService),_(1,h.ISignService),_(2,y.IProductService),_(3,p.IConfigurationService)],v),e.TunnelService=v;let g=class extends k.Disposable{constructor(c,n,r,i){super(),this.b=c,this.c=n,this.f=r,this.g=i,this.a=new Map}async openTunnel(c,n,r,i,a,s,l,o){if(this.b.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${r}:${i} on local port ${a}.`),!this.a.has(c)){const S=new v(this.b,this.f,this.c,this.g);this.B(S),this.a.set(c,S),S.onTunnelClosed(async()=>{(await S.tunnels).length===0&&(S.dispose(),this.a.delete(c))})}return this.a.get(c).openTunnel(n,r,i,a,s,l,o)}};g=pe([_(0,m.ILogService),_(1,y.IProductService),_(2,h.ISignService),_(3,p.IConfigurationService)],g),e.SharedTunnelsService=g}),define(ee[49],te([0,1,5]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var t;(function(M){M.Uninitialized="uninitialized",M.Idle="idle",M.CheckingForUpdates="checking for updates",M.AvailableForDownload="available for download",M.Downloading="downloading",M.Downloaded="downloaded",M.Updating="updating",M.Ready="ready"})(t=e.StateType||(e.StateType={}));var C;(function(M){M[M.Setup=0]="Setup",M[M.Archive=1]="Archive",M[M.Snap=2]="Snap"})(C=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(M,A)=>({type:"idle",updateType:M,error:A}),CheckingForUpdates:M=>({type:"checking for updates",explicit:M}),AvailableForDownload:M=>({type:"available for download",update:M}),Downloading:M=>({type:"downloading",update:M}),Downloaded:M=>({type:"downloaded",update:M}),Updating:M=>({type:"updating",update:M}),Ready:M=>({type:"ready",update:M})},e.IUpdateService=(0,I.createDecorator)("updateService")}),define(ee[239],te([0,1,4,168,65,48]),function(q,e,I,t,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),M.Registry.as(C.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,t.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,t.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,t.localize)(2,null),(0,t.localize)(3,null),(0,t.localize)(4,null),(0,t.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,t.localize)(6,null),deprecationMessage:(0,t.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,t.localize)(8,null),description:(0,t.localize)(9,null),included:I.isWindows&&!I.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,t.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(ee[240],te([0,1,3,49]),function(q,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class C{constructor(k){this.a=k}listen(k,p){switch(p){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${p}`)}call(k,p,m){switch(p){case"checkForUpdates":return this.a.checkForUpdates(m);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(m)}throw new Error(`Call not found: ${p}`)}}e.UpdateChannel=C;class M{get state(){return this.b}set state(k){this.b=k,this.a.fire(k)}constructor(k){this.c=k,this.a=new I.Emitter,this.onStateChange=this.a.event,this.b=t.State.Uninitialized,this.c.listen("onStateChange")(p=>this.state=p),this.c.call("_getInitialState").then(p=>this.state=p)}checkForUpdates(k){return this.c.call("checkForUpdates",k)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(k){return this.c.call("_applySpecificUpdate",k)}}e.UpdateChannelClient=M}),define(ee[90],te([0,1,8,22,3,18,27,21,6,19,55,49]),function(q,e,I,t,C,M,A,k,p,m,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function E(w,d,b){return`${b.updateUrl}/api/update/${w}/${d}/${b.commit}`}e.createUpdateURL=E;let h=class{get state(){return this.b}d(d){this.j.info("update#setState",d.type),this.b=d,this.c.fire(d)}constructor(d,b,u,v,g,f){this.f=d,this.g=b,this.h=u,this.i=v,this.j=g,this.k=f,this.b=P.State.Uninitialized,this.c=new C.Emitter,this.onStateChange=this.c.event}async initialize(){if(!this.h.isBuilt)return;if(this.h.disableUpdates){this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.j.info("update#ctor - updates are disabled as there is no update URL");return}const d=this.l(),b=this.m(d);if(!b){this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(b),!this.a){this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.d(P.State.Idle(this.q())),d==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}d==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,u=>this.j.error(u))}l(){return(0,M.getMigratedSettingValue)(this.g,"update.mode","update.channel")}m(d){return d==="none"?void 0:this.k.quality}n(d=60*60*1e3){return(0,I.timeout)(d).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(d){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(d)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(d){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(d=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${d}`),!d&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){return this.a?await this.l()==="none"?!1:(await this.i.request({url:this.a},t.CancellationToken.None)).res.statusCode===204:void 0}async _applySpecificUpdate(d){}q(){return 1}r(){}};h=pe([_(0,k.ILifecycleMainService),_(1,M.IConfigurationService),_(2,A.IEnvironmentMainService),_(3,y.IRequestService),_(4,p.ILogService),_(5,m.IProductService)],h),e.AbstractUpdateService=h}),define(ee[241],te([0,1,13,53,3,2,18,27,21,6,19,55,36,49,90]),function(q,e,I,t,C,M,A,k,p,m,y,P,E,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let d=class extends w.AbstractUpdateService{get v(){return C.Event.fromNodeEventEmitter(I.autoUpdater,"error",(u,v)=>v)}get w(){return C.Event.fromNodeEventEmitter(I.autoUpdater,"update-not-available")}get x(){return C.Event.fromNodeEventEmitter(I.autoUpdater,"update-available",(u,v,g)=>({url:v,version:g,productVersion:g}))}get y(){return C.Event.fromNodeEventEmitter(I.autoUpdater,"update-downloaded",(u,v,g,f)=>({releaseNotes:v,version:g,productVersion:g,date:f}))}constructor(u,v,g,f,c,n,r){super(u,v,f,c,n,r),this.z=g,this.u=new M.DisposableStore}async initialize(){await super.initialize(),this.v(this.A,this,this.u),this.x(this.D,this,this.u),this.y(this.E,this,this.u),this.w(this.F,this,this.u)}A(u){this.j.error("UpdateService error:",u);const g=(this.state.type==="checking for updates"?this.state.explicit:!0)?u:void 0;this.d(h.State.Idle(1,g))}s(u){let v;this.k.darwinUniversalAssetId?v=this.k.darwinUniversalAssetId:v=process.arch==="x64"?"darwin":"darwin-arm64";const g=(0,w.createUpdateURL)(v,u,this.k);try{I.autoUpdater.setFeedURL({url:g})}catch(f){this.j.error("Failed to set update feed URL",f);return}return g}t(u){this.d(h.State.CheckingForUpdates(u)),I.autoUpdater.checkForUpdates()}D(u){this.state.type==="checking for updates"&&this.d(h.State.Downloading(u))}E(u){this.state.type==="downloading"&&(this.z.publicLog2("update:downloaded",{version:u.version}),this.d(h.State.Ready(u)))}F(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(h.State.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),I.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};pe([t.memoize],d.prototype,"v",null),pe([t.memoize],d.prototype,"w",null),pe([t.memoize],d.prototype,"x",null),pe([t.memoize],d.prototype,"y",null),d=pe([_(0,p.ILifecycleMainService),_(1,A.IConfigurationService),_(2,E.ITelemetryService),_(3,k.IEnvironmentMainService),_(4,P.IRequestService),_(5,m.ILogService),_(6,y.IProductService)],d),e.DarwinUpdateService=d}),define(ee[242],te([0,1,46,40,8,3,9,27,21,6,36,49]),function(q,e,I,t,C,M,A,k,p,m,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let E=class{get state(){return this.a}d(d){this.g.info("update#setState",d.type),this.a=d,this.b.fire(d)}constructor(d,b,u){if(this.f=d,this.g=u,this.a=P.State.Uninitialized,this.b=new M.Emitter,this.onStateChange=this.b.event,b.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(P.State.Idle(this.k())),this.h(30*1e3).then(void 0,v=>this.g.error(v))}h(d=60*60*1e3){return(0,C.timeout)(d).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(d){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(d)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(d){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(d=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${d}`),!d&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(d){}};E=pe([_(0,p.ILifecycleMainService),_(1,k.IEnvironmentMainService),_(2,m.ILogService)],E);let h=class extends E{constructor(d,b,u,v,g,f){super(u,v,g),this.o=d,this.p=b,this.q=f;const c=(0,t.watch)(A.dirname(this.o)),n=M.Event.fromNodeEventEmitter(c,"change",(s,l)=>l),r=M.Event.filter(n,s=>s==="current"),a=M.Event.debounce(r,(s,l)=>l,2e3)(()=>this.checkForUpdates(!1));u.onWillShutdown(()=>{a.dispose(),c.close()})}m(){this.d(P.State.CheckingForUpdates(!1)),this.u().then(d=>{d?this.d(P.State.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(P.State.Idle(2)))},d=>{this.g.error(d),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(P.State.Idle(2,d.message||d))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,I.spawn)("sleep 3 && "+A.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const d=await new Promise((u,v)=>(0,t.realpath)(`${A.dirname(this.o)}/current`,(g,f)=>g?v(g):u(f))),b=A.basename(d);return this.p!==b}isLatestVersion(){return this.u().then(void 0,d=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};h=pe([_(2,p.ILifecycleMainService),_(3,k.IEnvironmentMainService),_(4,m.ILogService),_(5,y.ITelemetryService)],h),e.SnapUpdateService=h}),define(ee[42],te([0,1,5]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,I.createDecorator)("IUriIdentityService")}),define(ee[243],te([0,1,42,189,16,20,125,3,2]),function(q,e,I,t,C,M,A,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class m{constructor(E){this.uri=E,this.time=m._clock++}touch(){return this.time=m._clock++,this}}m._clock=0;let y=class{constructor(E){this.g=E,this.c=new p.DisposableStore,this.f=2**16;const h=new Map,w=d=>{let b=h.get(d.scheme);return b===void 0&&(b=E.hasProvider(d)&&!this.g.hasCapability(d,1024),h.set(d.scheme,b)),b};this.c.add(k.Event.any(E.onDidChangeFileSystemProviderRegistrations,E.onDidChangeFileSystemProviderCapabilities)(d=>{h.delete(d.scheme)})),this.extUri=new M.ExtUri(w),this.d=new A.SkipList((d,b)=>this.extUri.compare(d,b,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(E){this.g.hasProvider(E)&&(E=(0,M.normalizePath)(E));const h=this.d.get(E);return h?h.touch().uri.with({fragment:E.fragment}):(this.d.set(E,new m(E)),this.h(),E)}h(){if(this.d.size<this.f)return;const E=[...this.d.entries()].sort((w,d)=>w[1].touch<d[1].touch?1:w[1].touch>d[1].touch?-1:0);m._clock=0,this.d.clear();const h=this.f*.5;for(let w=0;w<h;w++)this.d.set(E[w][0],E[w][1].touch())}};y=pe([_(0,C.IFileService)],y),e.UriIdentityService=y,(0,t.registerSingleton)(I.IUriIdentityService,y,1)}),define(ee[114],te([0,1,5]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,I.createDecorator)("urlService")}),define(ee[244],te([0,1,7]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class t{constructor(k){this.a=k}listen(k,p){throw new Error(`Event not found: ${p}`)}call(k,p,m){switch(p){case"handleURL":return this.a.handleURL(I.URI.revive(m[0]),m[1])}throw new Error(`Call not found: ${p}`)}}e.URLHandlerChannel=t;class C{constructor(k){this.a=k}handleURL(k,p){return this.a.call("handleURL",[k.toJSON(),p])}}e.URLHandlerChannelClient=C;class M{constructor(k){this.a=k}async routeCall(k,p,m,y){if(p!=="handleURL")throw new Error(`Call not found: ${p}`);if(m){const P=I.URI.revive(m);if(P&&P.query){const E=/\bwindowId=(\d+)/.exec(P.query);if(E){const h=E[1],w=new RegExp(`window:${h}`),d=k.connections.find(b=>w.test(b.ctx));if(d)return d}}}return this.a.routeCall(k,p,m,y)}routeEvent(k,p){throw new Error(`Event not found: ${p}`)}}e.URLHandlerRouter=M}),define(ee[245],te([0,1,8,2,7,19]),function(q,e,I,t,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class A extends t.Disposable{constructor(){super(...arguments),this.a=new Set}open(m,y){const P=[...this.a.values()];return(0,I.first)(P.map(E=>()=>E.handleURL(m,y)),void 0,!1).then(E=>E||!1)}registerHandler(m){return this.a.add(m),(0,t.toDisposable)(()=>this.a.delete(m))}}e.AbstractURLService=A;let k=class extends A{constructor(m){super(),this.b=m}create(m){let{authority:y,path:P,query:E,fragment:h}=m||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return y&&P&&P.indexOf("/")!==0&&(P=`/${P}`),C.URI.from({scheme:this.b.urlProtocol,authority:y,path:P,query:E,fragment:h})}};k=pe([_(0,M.IProductService)],k),e.NativeURLService=k}),define(ee[246],te([0,1,13,8,3,2,4,7]),function(q,e,I,t,C,M,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function p(y){try{return k.URI.parse(y)}catch{return null}}class m{constructor(P,E,h,w,d){if(this.f=E,this.a=[],this.b=0,this.c=M.Disposable.None,this.d=new M.DisposableStore,this.a=P,A.isWindows){const v=w.isBuilt?[]:[`"${w.appRoot}"`];v.push("--open-url","--"),I.app.setAsDefaultProtocolClient(d.urlProtocol,process.execPath,v)}const b=C.Event.map(C.Event.fromNodeEventEmitter(I.app,"open-url",(v,g)=>({event:v,url:g})),({event:v,url:g})=>(v.preventDefault(),g));this.d.add(b(v=>{const g=p(v);!g||this.f.open(g,{originalUrl:v})})),h.getWindows().filter(v=>v.isReady).length>0?this.g():C.Event.once(h.onDidSignalReadyWindow)(this.g,this,this.d)}async g(){if(this.b++>10)return;const P=[];for(const E of this.a)await this.f.open(E.uri,{originalUrl:E.url})||P.push(E);P.length!==0&&(this.a=P,this.c=(0,t.disposableTimeout)(()=>this.g(),500))}dispose(){this.d.dispose(),this.c.dispose()}}e.ElectronURLListener=m}),define(ee[247],te([0,1,5]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,I.createDecorator)("webviewManagerService")}),define(ee[248],te([0,1,13,2,15,7]),function(q,e,I,t,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class A extends t.Disposable{constructor(){super();const p=this.b.bind(this);I.protocol.registerFileProtocol(C.Schemas.vscodeWebview,p)}b(p,m){try{const y=M.URI.parse(p.url),P=A.a.get(y.path);if(typeof P=="string"){const E=`vs/workbench/contrib/webview/browser/pre/${P}`,h=C.FileAccess.asFileUri(E);return m({path:decodeURIComponent(h.fsPath),headers:{...C.COI.getHeadersFromQuery(p.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return m({error:-10})}catch{}return m({error:-2})}}e.WebviewProtocolProvider=A,A.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}),define(ee[74],te([0,1,4]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function t(y){return!!y.workspaceUri}e.isWorkspaceToOpen=t;function C(y){return!!y.folderUri}e.isFolderToOpen=C;function M(y){return!!y.fileUri}e.isFileToOpen=M;function A(y){const P=k(y),E=y.getValue("window.menuBarVisibility");return E==="default"||P==="native"&&E==="compact"||I.isMacintosh&&I.isNative?"classic":E}e.getMenuBarVisibility=A;function k(y){if(I.isWeb)return"custom";const P=y.getValue("window");if(P){if(I.isMacintosh&&P.nativeTabs===!0||I.isMacintosh&&P.nativeFullScreen===!1)return"native";const w=P.titleBarStyle;if(w==="native"||w==="custom")return w}return I.isLinux?"native":"custom"}e.getTitleBarStyle=k;function p(y){if(!I.isWindows||I.isWeb||k(y)==="native")return!1;const P=y.getValue("window.experimental.windowControlsOverlay.enabled");return typeof P=="boolean"?P:!0}e.useWindowControlsOverlay=p;function m(y=0){return Math.pow(1.2,y)}e.zoomLevelToZoomFactor=m}),define(ee[115],te([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var I;(function(k){k[k.INITIAL=1]="INITIAL",k[k.LOAD=2]="LOAD",k[k.RELOAD=3]="RELOAD"})(I=e.LoadReason||(e.LoadReason={}));var t;(function(k){k[k.CLOSE=1]="CLOSE",k[k.QUIT=2]="QUIT",k[k.RELOAD=3]="RELOAD",k[k.LOAD=4]="LOAD"})(t=e.UnloadReason||(e.UnloadReason={}));const C=function(k=1){return{width:1024,height:768,mode:k}};e.defaultWindowState=C;var M;(function(k){k[k.Maximized=0]="Maximized",k[k.Normal=1]="Normal",k[k.Minimized=2]="Minimized",k[k.Fullscreen=3]="Fullscreen"})(M=e.WindowMode||(e.WindowMode={}));var A;(function(k){k[k.UNRESPONSIVE=1]="UNRESPONSIVE",k[k.PROCESS_GONE=2]="PROCESS_GONE",k[k.LOAD=3]="LOAD"})(A=e.WindowError||(e.WindowError={}))}),define(ee[31],te([0,1,5]),function(q,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,I.createDecorator)("windowsMainService");var t;(function(C){C[C.CLI=0]="CLI",C[C.DOCK=1]="DOCK",C[C.MENU=2]="MENU",C[C.DIALOG=3]="DIALOG",C[C.DESKTOP=4]="DESKTOP",C[C.API=5]="API"})(t=e.OpenContext||(e.OpenContext={}))}),define(ee[249],te([0,1,13,22,3,68,2,29,71,106,6,19,31]),function(q,e,I,t,C,M,A,k,p,m,y,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var h;(function(d){d[d.Initial=1]="Initial",d[d.StoredCredentialsUsed=2]="StoredCredentialsUsed",d[d.LoginDialogShown=3]="LoginDialogShown"})(h||(h={}));let w=class extends A.Disposable{constructor(b,u,v,g,f){super(),this.g=b,this.h=u,this.i=v,this.j=g,this.k=f,this.a=`${this.k.urlProtocol}.proxy-credentials`,this.b=void 0,this.c=h.Initial,this.f=void 0,this.l()}l(){const b=C.Event.fromNodeEventEmitter(I.app,"login",(u,v,g,f,c)=>({event:u,webContents:v,req:g,authInfo:f,callback:c}));this.B(b(this.m,this))}async m({event:b,authInfo:u,req:v,callback:g}){if(!u.isProxy)return;if(!this.b&&this.c===h.LoginDialogShown&&v.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}b.preventDefault();let f;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),f=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.n(u);try{f=await this.b}finally{this.b=void 0}}g(f?.username,f?.password)}async n(b){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const u=await this.p(b);if(u)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),u;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async p(b){this.g.trace("auth#doResolveProxyCredentials - enter",b);const u=String((0,M.hash)({scheme:b.scheme,host:b.host,port:b.port}));let v,g;try{const r=await this.i.getPassword(this.a,u);if(r){const i=JSON.parse(await this.j.decrypt(r));v=i.username,g=i.password}}catch(r){this.g.error(r)}if(this.c!==h.StoredCredentialsUsed&&typeof v=="string"&&typeof g=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=h.StoredCredentialsUsed,{username:v,password:g};const f=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!f){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${f.id} to handle proxy login`);const c={authInfo:b,username:this.f?.username??v,password:this.f?.password??g,replyChannel:`vscode:proxyAuthResponse:${(0,k.generateUuid)()}`};f.sendWhenReady("vscode:openProxyAuthenticationDialog",t.CancellationToken.None,c),this.c=h.LoginDialogShown;const n=await new Promise(r=>{const i=async(a,s,l)=>{if(s===c.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${f.id}`),f.win?.webContents.off("ipc-message",i),l){const o={username:l.username,password:l.password};try{if(l.remember){const S=await this.j.encrypt(JSON.stringify(o));await this.i.setPassword(this.a,u,S)}else await this.i.deletePassword(this.a,u)}catch(S){this.g.error(S)}r({username:o.username,password:o.password})}else r(void 0)};f.win?.webContents.on("ipc-message",i)});return this.f=n,n}};w=pe([_(0,y.ILogService),_(1,E.IWindowsMainService),_(2,p.ICredentialsMainService),_(3,m.IEncryptionMainService),_(4,P.IProductService)],w),e.ProxyAuthHandler=w}),define(ee[250],te([0,1,71,6,34,19,31,201]),function(q,e,I,t,C,M,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let p=class extends k.BaseCredentialsMainService{constructor(y,P,E,h){super(y),this.j=P,this.k=E,this.l=h,this.i=w=>{this.l.sendToFocused("vscode:showCredentialsError",w.message??w)}}async getSecretStoragePrefix(){return Promise.resolve(this.k.urlProtocol)}async h(){if(this.f)return this.f;if(this.j.disableKeytar)return this.g.info("Keytar is disabled. Using in-memory credential store instead."),this.f=new I.InMemoryCredentialsProvider,this.f;const y=await new Promise((P,E)=>{q(["keytar"],P,E)});return await y.findCredentials("test-keytar-loads"),this.f=y,this.f}};p=pe([_(0,t.ILogService),_(1,C.INativeEnvironmentService),_(2,M.IProductService),_(3,A.IWindowsMainService)],p),e.CredentialsNativeMainService=p}),define(ee[251],te([0,1,14,2,3,6,21,80,46,281,8,15,44,4,32,13,31]),function(q,e,I,t,C,M,A,k,p,m,y,P,E,h,w,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;const u=d.utilityProcess,v=typeof u<"u";let g=class Bt{constructor(r,i,a){this.d=r,this.f=a,this.c=!1,this.b=new Map,i.onWillShutdown(s=>{this.c=!0,s.join(this._waitForAllExit(6e3))})}dispose(){}g(r){const i=this.b.get(r);if(!i)throw new Error("Unknown extension host!");return i}onDynamicStdout(r){return this.g(r).onStdout}onDynamicStderr(r){return this.g(r).onStderr}onDynamicMessage(r){return this.g(r).onMessage}onDynamicError(r){return this.g(r).onError}onDynamicExit(r){return this.g(r).onExit}async canUseUtilityProcess(){return v}async createExtensionHost(r){if(this.c)throw(0,I.canceled)();const i=String(++Bt.a);let a;if(r){if(!v)throw new Error("Cannot use UtilityProcess!");a=new c(i,this.d,this.f)}else a=new f(i,this.d);return this.b.set(i,a),a.onExit(({pid:s,code:l,signal:o})=>{this.d.info(`Extension host with pid ${s} exited with code: ${l}, signal: ${o}.`),setTimeout(()=>{a.dispose(),this.b.delete(i)})}),{id:i}}async start(r,i){if(this.c)throw(0,I.canceled)();return this.g(r).start(i)}async enableInspectPort(r){if(this.c)throw(0,I.canceled)();const i=this.b.get(r);return i?i.enableInspectPort():!1}async kill(r){if(this.c)throw(0,I.canceled)();const i=this.b.get(r);!i||i.kill()}async _killAllNow(){for(const[,r]of this.b)r.kill()}async _waitForAllExit(r){const i=[];for(const[,a]of this.b)i.push(a.waitForExit(r));return y.Promises.settled(i).then(()=>{})}};g.a=0,g=pe([_(0,M.ILogService),_(1,A.ILifecycleMainService),_(2,b.IWindowsMainService)],g),e.ExtensionHostStarter=g;let f=class extends t.Disposable{constructor(r,i){super(),this.id=r,this.c=i,this._onStdout=this.B(new C.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this.B(new C.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this.B(new C.Emitter),this.onMessage=this._onMessage.event,this._onError=this.B(new C.Emitter),this.onError=this._onError.event,this._onExit=this.B(new C.Emitter),this.onExit=this._onExit.event,this.a=null,this.b=!1}start(r){h.isCI&&this.c.info("Calling fork to start extension host...");const i=k.StopWatch.create(!1);this.a=(0,p.fork)(P.FileAccess.asFileUri("bootstrap-fork").fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,E.mixin)({cwd:(0,w.cwd)()},r));const a=i.elapsed(),s=this.a.pid;this.c.info(`Starting extension host with pid ${s} (fork() took ${a} ms).`);const l=new m.StringDecoder("utf-8");this.a.stdout?.on("data",S=>{const D=typeof S=="string"?S:l.write(S);this._onStdout.fire(D)});const o=new m.StringDecoder("utf-8");this.a.stderr?.on("data",S=>{const D=typeof S=="string"?S:o.write(S);this._onStderr.fire(D)}),this.a.on("message",S=>{this._onMessage.fire(S)}),this.a.on("error",S=>{this._onError.fire({error:(0,I.transformErrorForSerialization)(S)})}),this.a.on("exit",(S,D)=>{this.b=!0,this._onExit.fire({pid:s,code:S,signal:D})})}enableInspectPort(){return this.a?(this.c.info(`Enabling inspect port on extension host with pid ${this.a.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this.a.pid),!0):h.isWindows?!1:(this.a.kill("SIGUSR1"),!0)):!1}kill(){!this.a||(this.c.info(`Killing extension host with pid ${this.a.pid}.`),this.a.kill())}async waitForExit(r){if(!this.a)return;const i=this.a.pid;this.c.info(`Waiting for extension host with pid ${i} to exit.`),await Promise.race([C.Event.toPromise(this.onExit),(0,y.timeout)(r)]),this.b||(this.c.info(`Extension host with pid ${i} did not exit within ${r}ms.`),this.a.kill())}};f=pe([_(1,M.ILogService)],f);let c=class extends t.Disposable{constructor(r,i,a){super(),this.id=r,this.c=i,this.f=a,this.onError=C.Event.None,this._onStdout=this.B(new C.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this.B(new C.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this.B(new C.Emitter),this.onMessage=this._onMessage.event,this._onExit=this.B(new C.Emitter),this.onExit=this._onExit.event,this.a=null,this.b=!1}start(r){const i=this.f.getWindowById(r.responseWindowId);if(!i){this.c.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const a=i.win;if(!a||a.isDestroyed()||a.webContents.isDestroyed()){this.c.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const s=`extensionHost${this.id}`,l=P.FileAccess.asFileUri("bootstrap-fork.js").fsPath,o=["--type=extensionHost","--skipWorkspaceStorageLock"],S=r.execArgv||[],D={...r.env},L=!0,j="pipe";for(const ne of Object.keys(D))D[ne]=String(D[ne]);this.c.info(`UtilityProcess<${this.id}>: Creating new...`),this.a=u.fork(l,o,{serviceName:s,env:D,execArgv:S,allowLoadingUnsignedLibraries:L,stdio:j});const X=new m.StringDecoder("utf-8");this.a.stdout?.on("data",ne=>{const he=typeof ne=="string"?ne:X.write(ne);this._onStdout.fire(he)});const ae=new m.StringDecoder("utf-8");this.a.stderr?.on("data",ne=>{const he=typeof ne=="string"?ne:ae.write(ne);this._onStderr.fire(he)}),this.a.on("message",ne=>{this._onMessage.fire(ne)}),this.B(C.Event.fromNodeEventEmitter(this.a,"spawn")(()=>{this.c.info(`UtilityProcess<${this.id}>: received spawn event.`)}));const Y=C.Event.fromNodeEventEmitter(this.a,"exit",ne=>ne);this.B(Y(ne=>{this.c.info(`UtilityProcess<${this.id}>: received exit event with code ${ne}.`),this.b=!0,this._onExit.fire({pid:this.a.pid,code:ne,signal:""})}));const{port1:J,port2:se}=new d.MessageChannelMain;this.a.postMessage("null",[se]),a.webContents.postMessage(r.responseChannel,r.responseNonce,[J])}enableInspectPort(){return this.a?(this.c.info(`UtilityProcess<${this.id}>: Enabling inspect port on extension host with pid ${this.a.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this.a.pid),!0):!1):!1}kill(){!this.a||(this.c.info(`UtilityProcess<${this.id}>: Killing extension host with pid ${this.a.pid}.`),this.a.kill())}async waitForExit(r){if(!this.a)return;const i=this.a.pid;this.c.info(`UtilityProcess<${this.id}>: Waiting for extension host with pid ${i} to exit.`),await Promise.race([C.Event.toPromise(this.onExit),(0,y.timeout)(r)]),this.b||(this.c.info(`UtilityProcess<${this.id}>: Extension host with pid ${i} did not exit within ${r}ms, will kill it now.`),this.a.kill())}};c=pe([_(1,M.ILogService),_(2,b.IWindowsMainService)],c)}),define(ee[252],te([0,1,13,24,4,7,23,18,61,5,6,114,31]),function(q,e,I,t,C,M,A,k,p,m,y,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,m.createDecorator)(e.ID);let h=class{constructor(d,b,u,v){this.a=d,this.b=b,this.c=u,this.d=v}async start(d,b){this.a.trace("Received data from other instance: ",d,b),C.isMacintosh&&I.app.focus({steal:!0});const u=this.e(d);if(u.length){let v=Promise.resolve();if(this.b.getWindowCount()===0){const g=(0,t.firstOrDefault)(await this.b.openEmptyWindow({context:4}));g&&(v=g.ready())}v.then(()=>{for(const{uri:g,url:f}of u)this.c.open(g,{originalUrl:f})})}else return this.f(d,b)}e(d){return d["open-url"]&&d._urls&&d._urls.length>0?(0,t.coalesce)(d._urls.map(b=>{try{return{uri:M.URI.parse(b),url:b}}catch{return null}})):[]}async f(d,b){const u=(0,p.isLaunchedFromCli)(b)?0:4;let v=[];const g=d.wait&&d.waitMarkerFilePath?M.URI.file(d.waitMarkerFilePath):void 0,f=d.remote||void 0,c={context:u,cli:d,userEnv:b,waitMarkerFileURI:g,remoteAuthority:f,forceProfile:d.profile,forceTempProfile:d["profile-temp"]};if(d.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(d.extensionDevelopmentPath,c);else if(!d._.length&&!d["folder-uri"]&&!d["file-uri"]){let n=!1;if(d["new-window"]||d["unity-launch"]||c.forceProfile||c.forceTempProfile)n=!0;else if(d["reuse-window"])n=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":n=!0;break;case"off":n=!1;break;default:n=!C.isMacintosh}if(n)v=await this.b.open({...c,forceNewWindow:!0,forceEmpty:!0});else{const r=this.b.getLastActiveWindow();r?(this.b.openExistingWindow(r,c),v=[r]):v=await this.b.open({...c,forceEmpty:!0})}}else v=await this.b.open({...c,forceNewWindow:d["new-window"],preferNewWindow:!d["reuse-window"]&&!d.wait,forceReuseWindow:d["reuse-window"],diffMode:d.diff,mergeMode:d.merge,addMode:d.add,noRecentEntry:!!d["skip-add-to-recently-opened"],gotoLineMode:d.goto});if(g&&v.length===1&&v[0])return Promise.race([v[0].whenClosedOrLoaded,(0,A.whenDeleted)(g.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};h=pe([_(0,y.ILogService),_(1,E.IWindowsMainService),_(2,P.IURLService),_(3,k.IConfigurationService)],h),e.LaunchMainService=h}),define(ee[253],te([0,1,13,3,2,248,31]),function(q,e,I,t,C,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let k=class extends C.Disposable{constructor(m){super(),this.b=m,this.a=this.B(new t.Emitter),this.onFoundInFrame=this.a.event,this.B(new M.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(m,y){let P;if(typeof m.windowId=="number"){const{windowId:E}=m,h=this.b.getWindowById(E);if(!h?.win)throw new Error(`Invalid windowId: ${E}`);P=h.win.webContents}else{const{webContentsId:E}=m;if(P=I.webContents.fromId(E),!P)throw new Error(`Invalid webContentsId: ${E}`)}P.isDestroyed()||P.setIgnoreMenuShortcuts(y)}async findInFrame(m,y,P,E){const w=this.c(m,y);if(typeof w.findInFrame=="function"){w.findInFrame(P,{findNext:E.findNext,forward:E.forward});const d=(b,u)=>{u.finalUpdate&&(this.a.fire(u),w.removeListener("found-in-frame",d))};w.on("found-in-frame",d)}}async stopFindInFrame(m,y,P){const h=this.c(m,y);typeof h.stopFindInFrame=="function"&&h.stopFindInFrame(P.keepSelection?"keepSelection":"clearSelection")}c(m,y){const P=this.b.getWindowById(m.windowId);if(!P?.win)throw new Error(`Invalid windowId: ${m}`);const E=P.win.webContents.mainFrame.framesInSubtree.find(h=>h.name===y);if(!E)throw new Error(`Unknown frame: ${y}`);return E}};k=pe([_(0,A.IWindowsMainService)],k),e.WebviewMainService=k}),define(ee[254],te([0,1,8,3,2]),function(q,e,I,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class M extends C.Disposable{constructor({onDidOpenWindow:k,onDidFocusWindow:p,getActiveWindowId:m}){super(),this.a=this.B(new C.DisposableStore),t.Event.latch(t.Event.any(k,p))(this.f,this,this.a),this.b=(0,I.createCancelablePromise)(()=>m()),(async()=>{try{const P=await this.b;this.c=typeof this.c=="number"?this.c:P}catch{}finally{this.b=void 0}})()}f(k){this.b&&(this.b.cancel(),this.b=void 0),this.c=k}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.ActiveWindowManager=M}),define(ee[28],te([0,1,172,9,60,20,7,5,15]),function(q,e,I,t,C,M,A,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,k.createDecorator)("contextService");function m(r){const i=r;return typeof i?.id=="string"&&A.URI.isUri(i.uri)}e.isSingleFolderWorkspaceIdentifier=m,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function y(r,i){if(typeof r=="string"||typeof r>"u")return typeof r=="string"?{id:(0,t.basename)(r)}:i?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const a=r;if(a.configuration)return{id:a.id,configPath:a.configuration};if(a.folders.length===1)return{id:a.id,uri:a.folders[0].uri}}e.toWorkspaceIdentifier=y;function P(r){const i=r;return typeof i?.id=="string"&&A.URI.isUri(i.configPath)}e.isWorkspaceIdentifier=P;function E(r){const i=r;if(i?.uri)return{id:i.id,uri:A.URI.revive(i.uri)};const a=r;if(a?.configPath)return{id:a.id,configPath:A.URI.revive(a.configPath)};if(r?.id)return{id:r.id}}e.reviveIdentifier=E;var h;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(h=e.WorkbenchState||(e.WorkbenchState={}));function w(r){const i=r;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.isWorkspace=w;function d(r){const i=r;return!!(i&&typeof i=="object"&&A.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.isWorkspaceFolder=d;class b{constructor(i,a,s,l,o){this.h=i,this.j=s,this.k=l,this.l=o,this.c=C.TernarySearchTree.forUris(this.l,()=>!0),this.folders=a}update(i){this.h=i.id,this.k=i.configuration,this.j=i.transient,this.l=i.l,this.folders=i.folders}get folders(){return this.g}set folders(i){this.g=i,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(i){this.k=i}getFolder(i){return i&&this.c.findSubstr(i)||null}n(){this.c=C.TernarySearchTree.forUris(this.l,()=>!0);for(const i of this.folders)this.c.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=b;class u{constructor(i,a){this.raw=a,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,M.joinPath)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=u;function v(r){return new u({uri:r,index:0,name:(0,M.basenameOrAuthority)(r)},{uri:r.toString()})}e.toWorkspaceFolder=v,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function g(r,i){return M.extUriBiasedIgnorePathCase.isEqualOrParent(r,i.untitledWorkspacesHome)}e.isUntitledWorkspace=g;function f(r){let i;return A.URI.isUri(r)?i=r:i=r.configuration,i?.scheme===p.Schemas.tmp}e.isTemporaryWorkspace=f;function c(r,i){return!g(r,i)&&!f(r)}e.isSavedWorkspace=c;function n(r){return(typeof r=="string"?(0,t.extname)(r):(0,M.extname)(r))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=n}),define(ee[57],te([0,1,13,8,68,33,2,76,4,12,23,149,5,6,28]),function(q,e,I,t,C,M,A,k,p,m,y,P,E,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,E.createDecorator)("dialogMainService");let d=class{constructor(u){this.d=u,this.a=new Map,this.b=new Map,this.c=new t.Queue}pickFileFolder(u,v){return this.e({...u,pickFolders:!0,pickFiles:!0,title:(0,P.localize)(0,null)},v)}pickFolder(u,v){return this.e({...u,pickFolders:!0,title:(0,P.localize)(1,null)},v)}pickFile(u,v){return this.e({...u,pickFiles:!0,title:(0,P.localize)(2,null)},v)}pickWorkspace(u,v){const g=(0,P.localize)(3,null),f=(0,M.mnemonicButtonLabel)((0,P.localize)(4,null)),c=w.WORKSPACE_FILTER;return this.e({...u,pickFiles:!0,title:g,filters:c,buttonLabel:f},v)}async e(u,v){const g={title:u.title,buttonLabel:u.buttonLabel,filters:u.filters,defaultPath:u.defaultPath};(typeof u.pickFiles=="boolean"||typeof u.pickFolders=="boolean")&&(g.properties=void 0,u.pickFiles&&u.pickFolders&&(g.properties=["multiSelections","openDirectory","openFile","createDirectory"])),g.properties||(g.properties=["multiSelections",u.pickFolders?"openDirectory":"openFile","createDirectory"]),p.isMacintosh&&g.properties.push("treatPackageAsDirectory");const f=await this.showOpenDialog(g,(0,m.withNullAsUndefined)(v||I.BrowserWindow.getFocusedWindow()));if(f&&f.filePaths&&f.filePaths.length>0)return f.filePaths}f(u){if(u){let v=this.b.get(u.id);return v||(v=new t.Queue,this.b.set(u.id,v)),v}else return this.c}showMessageBox(u,v){return this.f(v).queue(async()=>v?I.dialog.showMessageBox(v,u):I.dialog.showMessageBox(u))}async showSaveDialog(u,v){const g=this.i(u,v);if(!g)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.f(v).queue(async()=>{let f;return v?f=await I.dialog.showSaveDialog(v,u):f=await I.dialog.showSaveDialog(u),f.filePath=this.g(f.filePath),f})}finally{(0,A.dispose)(g)}}g(u){return u&&p.isMacintosh&&(u=(0,k.normalizeNFC)(u)),u}h(u){return u.map(v=>this.g(v))}async showOpenDialog(u,v){u.defaultPath&&(await y.Promises.exists(u.defaultPath)||(u.defaultPath=void 0));const g=this.i(u,v);if(!g)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.f(v).queue(async()=>{let f;return v?f=await I.dialog.showOpenDialog(v,u):f=await I.dialog.showOpenDialog(u),f.filePaths=this.h(f.filePaths),f})}finally{(0,A.dispose)(g)}}i(u,v){if(!v)return A.Disposable.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",u);let g=this.a.get(v.id);g||(g=new Set,this.a.set(v.id,g));const f=(0,C.hash)(u);if(!g.has(f))return this.d.trace("[DialogMainService]: new file dialog lock created",u),g.add(f),(0,A.toDisposable)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",u),g?.delete(f),g?.size===0&&this.a.delete(v.id)})}};d=pe([_(0,h.ILogService)],d),e.DialogMainService=d}),define(ee[255],te([0,1,3,2,69,28]),function(q,e,I,t,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class A extends t.Disposable{constructor(p,m){super(),this.f=p,this.g=m,this.b=this.B(new I.Emitter),this.c=new Map,this.h(m.applicationStorage,this.b)}h(p,m){this.B(I.Event.debounce(p.onDidChangeStorage,(y,P)=>(y?y.push(P):y=[P],y),A.a)(y=>{y.length&&m.fire(this.i(y,p))}))}i(p,m){const y=new Map,P=new Set;return p.forEach(E=>{const h=m.get(E.key);typeof h=="string"?y.set(E.key,h):P.add(E.key)}),{changed:Array.from(y.entries()),deleted:Array.from(P.values())}}listen(p,m,y){switch(m){case"onDidChangeStorage":{const P=y.profile?(0,C.revive)(y.profile):void 0;if(!P)return this.b.event;let E=this.c.get(P.id);return E||(E=this.B(new I.Emitter),this.h(this.g.profileStorage(P),E),this.c.set(P.id,E)),E.event}}throw new Error(`Event not found: ${m}`)}async call(p,m,y){const P=y.profile?(0,C.revive)(y.profile):void 0,E=(0,M.reviveIdentifier)(y.workspace),h=await this.j(P,E);switch(m){case"getItems":return Array.from(h.items.entries());case"updateItems":{const w=y;if(w.insert)for(const[d,b]of w.insert)h.set(d,b);w.delete?.forEach(d=>h.delete(d));break}case"isUsed":{const w=y.payload;if(typeof w=="string")return this.g.isUsed(w)}default:throw new Error(`Call not found: ${m}`)}}async j(p,m){let y;m?y=this.g.workspaceStorage(m):p?y=this.g.profileStorage(p):y=this.g.applicationStorage;try{await y.init()}catch(P){this.f.error(`StorageIPC#init: Unable to init ${m?"workspace":p?"profile":"application"} storage due to ${P}`)}return y}}e.StorageDatabaseChannel=A,A.a=100}),define(ee[38],te([0,1,68,3,2,20,7,169,34,16,5,6,28,39,42,8,29,26]),function(q,e,I,t,C,M,A,k,p,m,y,P,E,h,w,d,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function v(r){const i=r;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&A.URI.isUri(i.location)&&A.URI.isUri(i.globalStorageHome)&&A.URI.isUri(i.settingsResource)&&A.URI.isUri(i.keybindingsResource)&&A.URI.isUri(i.tasksResource)&&A.URI.isUri(i.snippetsHome)&&A.URI.isUri(i.extensionsResource))}e.isUserDataProfile=v,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,y.createDecorator)("IUserDataProfilesService");function g(r,i){return{id:r.id,isDefault:r.isDefault,name:r.name,shortName:r.shortName,location:A.URI.revive(r.location).with({scheme:i}),globalStorageHome:A.URI.revive(r.globalStorageHome).with({scheme:i}),settingsResource:A.URI.revive(r.settingsResource).with({scheme:i}),keybindingsResource:A.URI.revive(r.keybindingsResource).with({scheme:i}),tasksResource:A.URI.revive(r.tasksResource).with({scheme:i}),snippetsHome:A.URI.revive(r.snippetsHome).with({scheme:i}),extensionsResource:A.URI.revive(r.extensionsResource)?.with({scheme:i}),useDefaultFlags:r.useDefaultFlags,isTransient:r.isTransient}}e.reviveProfile=g;function f(r,i,a,s){return{id:r,name:i,location:a,isDefault:!1,shortName:s?.shortName,globalStorageHome:(0,M.joinPath)(a,"globalStorage"),settingsResource:(0,M.joinPath)(a,"settings.json"),keybindingsResource:(0,M.joinPath)(a,"keybindings.json"),tasksResource:(0,M.joinPath)(a,"tasks.json"),snippetsHome:(0,M.joinPath)(a,"snippets"),extensionsResource:(0,M.joinPath)(a,"extensions.json"),useDefaultFlags:s?.useDefaultFlags,isTransient:s?.transient}}e.toUserDataProfile=f;let c=class extends C.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(i,a,s,l){super(),this.m=i,this.n=a,this.r=s,this.s=l,this.f=!1,this.g=this.B(new t.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new t.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new t.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new t.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new h.ResourceMap},this.profilesHome=(0,M.joinPath)(this.m.userRoamingDataHome,"profiles")}setEnablement(i){this.f!==i&&(this.t=void 0,this.f=i)}isEnabled(){return this.f}get u(){if(!this.t){const i=this.f?this.H().map(o=>f((0,M.basename)(o.location),o.name,o.location,{shortName:o.shortName,useDefaultFlags:o.useDefaultFlags})):[];let a;const s=new h.ResourceMap,l=f((0,I.hash)(this.m.userRoamingDataHome.path).toString(16),(0,k.localize)(0,null),this.m.userRoamingDataHome);if(i.unshift({...l,extensionsResource:this.M()??l.extensionsResource,isDefault:!0}),i.length){const o=this.J();if(o.workspaces)for(const[S,D]of Object.entries(o.workspaces)){const L=A.URI.parse(S),j=A.URI.parse(D),X=i.find(ae=>this.r.extUri.isEqual(ae.location,j));X&&s.set(L,X)}if(o.emptyWindow){const S=A.URI.parse(o.emptyWindow);a=i.find(D=>this.r.extUri.isEqual(D.location,S))}}this.t={profiles:i,workspaces:s,emptyWindow:a}}return this.t}async createTransientProfile(i){const a="Temp",s=new RegExp(`${(0,u.escapeRegExpCharacters)(a)}\\s(\\d+)`);let l=0;for(const S of this.profiles){const D=s.exec(S.name),L=D?parseInt(D[1]):0;l=L>l?L:l}const o=`${a} ${l+1}`;return this.createProfile((0,I.hash)((0,b.generateUuid)()).toString(16),o,{transient:!0},i)}async createNamedProfile(i,a,s){return this.createProfile((0,I.hash)((0,b.generateUuid)()).toString(16),i,a,s)}async createProfile(i,a,s,l){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const o=await this.v(i,a,s);return l&&await this.setProfileForWorkspace(l,o),o}async v(i,a,s){let l=this.k.get(a);return l||(l=(async()=>{try{const o=this.profiles.find(L=>L.name===a||L.id===i);if(o)return o;const S=f(i,a,(0,M.joinPath)(this.profilesHome,i),s);await this.n.createFolder(S.location);const D=[];return this.h.fire({profile:S,join(L){D.push(L)}}),await d.Promises.settled(D),this.C([S],[],[]),S}finally{this.k.delete(a)}})(),this.k.set(a,l)),l}async updateProfile(i,a){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let s=this.profiles.find(l=>l.id===i.id);if(!s)throw new Error(`Profile '${i.name}' does not exist`);return s=f(s.id,a.name??s.name,s.location,{shortName:a.shortName??s.shortName,transient:a.transient??s.isTransient,useDefaultFlags:a.useDefaultFlags??s.useDefaultFlags}),this.C([],[],[s]),s}async removeProfile(i){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(i.isDefault)throw new Error("Cannot remove default profile");const a=this.profiles.find(l=>l.id===i.id);if(!a)throw new Error(`Profile '${i.name}' does not exist`);const s=[];this.i.fire({profile:a,join(l){s.push(l)}});try{await Promise.allSettled(s)}catch(l){this.s.error(l)}a.id===this.u.emptyWindow?.id&&(this.u.emptyWindow=void 0);for(const l of[...this.u.workspaces.keys()])a.id===this.u.workspaces.get(l)?.id&&this.u.workspaces.delete(l);this.G(),this.C([],[a],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(a.location,{recursive:!0})}catch(l){this.s.error(l)}}getOrSetProfileForWorkspace(i,a=this.defaultProfile){if(!this.f)return this.defaultProfile;let s=this.w(i);return s||(s=a,this.profiles.length>1&&this.setProfileForWorkspaceSync(i,s)),s}async setProfileForWorkspace(i,a){this.setProfileForWorkspaceSync(i,a)}setProfileForWorkspaceSync(i,a){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const s=this.profiles.find(l=>l.id===a.id);if(!s)throw new Error(`Profile '${a.name}' does not exist`);this.F(i,s)}unsetWorkspace(i,a){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.F(i,void 0,a)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindow=void 0,this.u.workspaces.clear(),this.u.emptyWindow=void 0,this.G(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const i=await this.n.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(a=>a.isDirectory&&this.profiles.every(s=>!this.r.extUri.isEqual(s.location,a.resource))).map(a=>this.n.del(a.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const i=this.l.profiles.filter(a=>!this.z(a));await Promise.allSettled(i.map(a=>this.removeProfile(a)))}w(i){const a=this.y(i);return A.URI.isUri(a)?this.l.workspaces.get(a)??this.u.workspaces.get(a):this.l.emptyWindow??this.u.emptyWindow}y(i){return(0,E.isSingleFolderWorkspaceIdentifier)(i)?i.uri:(0,E.isWorkspaceIdentifier)(i)?i.configPath:"empty-window"}z(i){return!!(this.r.extUri.isEqual(this.l.emptyWindow?.location,i.location)||[...this.l.workspaces.values()].some(a=>this.r.extUri.isEqual(a.location,i.location))||this.r.extUri.isEqual(this.u.emptyWindow?.location,i.location)||[...this.u.workspaces.values()].some(a=>this.r.extUri.isEqual(a.location,i.location)))}C(i,a,s){const l=[...this.profiles,...i],o=[];this.l.profiles=[];for(let S of l)S.isDefault||a.some(D=>S.id===D.id)||(S=s.find(D=>S.id===D.id)??S,S.isTransient?this.l.profiles.push(S):o.push({location:S.location,name:S.name,shortName:S.shortName,useDefaultFlags:S.useDefaultFlags}));this.I(o),this.t=void 0,this.D(i,a,s)}D(i,a,s){this.g.fire({added:i,removed:a,updated:s,all:this.profiles})}F(i,a,s){s=a?.isTransient?!0:s,s||this.F(i,void 0,!0);const l=this.y(i),o=s?this.l:this.u;A.URI.isUri(l)?(o.workspaces.delete(l),a&&o.workspaces.set(l,a)):o.emptyWindow=a,s||this.G()}G(){const i={};for(const[s,l]of this.u.workspaces.entries())i[s.toString()]=l.location.toString();const a=this.u.emptyWindow?.location.toString();this.L({workspaces:i,emptyWindow:a}),this.t=void 0}H(){return[]}I(i){throw new Error("not implemented")}J(){return{}}L(i){throw new Error("not implemented")}M(){}};c.b="userDataProfiles",c.c="profileAssociations",c=pe([_(0,p.IEnvironmentService),_(1,m.IFileService),_(2,w.IUriIdentityService),_(3,P.ILogService)],c),e.UserDataProfilesService=c;class n extends c{constructor(){super(...arguments),this.a=[],this.P={}}H(){return this.a}I(i){this.a=i}J(){return this.P}L(i){this.P=i}}e.InMemoryUserDataProfilesService=n}),define(ee[91],te([0,1,8,17,2,3,39,7,110,87,16,5,6,38,42]),function(q,e,I,t,C,M,A,k,p,m,y,P,E,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,P.createDecorator)("IExtensionsProfileScannerService");let d=class extends C.Disposable{constructor(v,g,f,c){super(),this.h=v,this.i=g,this.j=f,this.k=c,this.a=this.B(new M.Emitter),this.onAddExtensions=this.a.event,this.b=this.B(new M.Emitter),this.onDidAddExtensions=this.b.event,this.c=this.B(new M.Emitter),this.onRemoveExtensions=this.c.event,this.f=this.B(new M.Emitter),this.onDidRemoveExtensions=this.f.event,this.g=new A.ResourceMap}scanProfileExtensions(v){return this.l(v)}async addExtensionsToProfile(v,g){const f=[],c=[];try{return await this.l(g,n=>{const r=[];for(const i of n)v.some(([a])=>(0,p.areSameExtensions)(a.identifier,i.identifier)&&a.manifest.version!==i.version)?f.push(i):r.push(i);for(const[i,a]of v)if(!r.some(s=>(0,p.areSameExtensions)(s.identifier,i.identifier)&&s.version===i.manifest.version)){const s={identifier:i.identifier,version:i.manifest.version,location:i.location,metadata:a};c.push(s),r.push(s)}return c.length&&this.a.fire({extensions:c,profileLocation:g}),f.length&&this.c.fire({extensions:f,profileLocation:g}),r}),c.length&&this.b.fire({extensions:c,profileLocation:g}),f.length&&this.f.fire({extensions:f,profileLocation:g}),c}catch(n){throw c.length&&this.b.fire({extensions:c,error:n,profileLocation:g}),f.length&&this.f.fire({extensions:f,error:n,profileLocation:g}),n}}async removeExtensionFromProfile(v,g){const f=[];this.c.fire({extensions:f,profileLocation:g});try{await this.l(g,c=>{const n=[];for(const r of c)(0,p.areSameExtensions)(r.identifier,v.identifier)?f.push(r):n.push(r);return f.length&&this.c.fire({extensions:f,profileLocation:g}),n}),f.length&&this.f.fire({extensions:f,profileLocation:g})}catch(c){throw f.length&&this.f.fire({extensions:f,error:c,profileLocation:g}),c}}async l(v,g){return this.p(v).queue(async()=>{let f=[],c;try{const n=await this.h.readFile(v);c=JSON.parse(n.value.toString())}catch(n){if((0,y.toFileOperationResult)(n)!==1)throw n;this.j.extUri.isEqual(v,this.i.defaultProfile.extensionsResource)&&(c=await this.n())}if(c)for(const n of c){if(!n.identifier){this.k.info("Ignoring invalid extension while scanning. Identifier does not exist.",n);continue}if(!n.location){this.k.info("Ignoring invalid extension while scanning. Location does not exist.",n);continue}if(!n.version){this.k.info("Ignoring invalid extension while scanning. Version does not exist.",n);continue}f.push({identifier:n.identifier,location:k.URI.revive(n.location),version:n.version,metadata:n.metadata})}if(g){f=g(f);const n=f.map(r=>({identifier:r.identifier,version:r.version,location:r.location.toJSON(),metadata:r.metadata}));await this.h.writeFile(v,t.VSBuffer.fromString(JSON.stringify(n)))}return f})}async n(){return this.m||(this.m=(async()=>{const v=this.j.extUri.joinPath(this.i.defaultProfile.location,"extensions.json");let g;try{g=(await this.h.readFile(v)).value.toString()}catch(c){if((0,y.toFileOperationResult)(c)===1)return;throw c}this.k.info("Migrating extensions from old default profile location",v.toString());let f;try{const c=JSON.parse(g);Array.isArray(c)&&c.every(n=>!!(n&&typeof n=="object"&&(0,m.isIExtensionIdentifier)(n.identifier)&&b(n.location)&&n.version&&typeof n.version=="string"))?f=c:this.k.warn("Skipping migrating from old default profile locaiton: Found invalid data",c)}catch(c){this.k.error(c)}if(f)try{await this.h.createFile(this.i.defaultProfile.extensionsResource,t.VSBuffer.fromString(JSON.stringify(f)),{overwrite:!1}),this.k.info("Migrated extensions from old default profile location to new location",v.toString(),this.i.defaultProfile.extensionsResource.toString())}catch(c){if((0,y.toFileOperationResult)(c)===3)this.k.info("Migration from old default profile location to new location is done by another window",v.toString(),this.i.defaultProfile.extensionsResource.toString());else throw c}try{await this.h.del(v)}catch(c){(0,y.toFileOperationResult)(c)!==1&&this.k.error(c)}return f})()),this.m}p(v){let g=this.g.get(v);return g||(g=new I.Queue,this.g.set(v,g)),g}};d=pe([_(0,y.IFileService),_(1,h.IUserDataProfilesService),_(2,w.IUriIdentityService),_(3,E.ILogService)],d),e.ExtensionsProfileScannerService=d;function b(u){return u?typeof u.path=="string"&&typeof u.scheme=="string":!1}}),define(ee[116],te([0,1,24,8,44,17,14,43,135,2,15,9,4,20,187,98,12,7,154,34,110,87,186,16,5,6,19,3,69,91,38,42,184,185]),function(q,e,I,t,C,M,A,k,p,m,y,P,E,h,w,d,b,u,v,g,f,c,n,r,i,a,s,l,o,S,D,L,j,X){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var ae;(function(le){function W(F,N){if(F===N)return!0;const H=Object.keys(F),re=new Set;for(const z of Object.keys(N))re.add(z);if(H.length!==re.size)return!1;for(const z of H){if(F[z]!==N[z])return!1;re.delete(z)}return re.size===0}le.equals=W})(ae=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let Y=class extends m.Disposable{constructor(W,F,N,H,re,z,T,R,O,U,B,V){super(),this.systemExtensionsLocation=W,this.userExtensionsLocation=F,this.l=N,this.m=H,this.n=re,this.p=z,this.r=T,this.s=R,this.t=O,this.u=U,this.v=B,this.w=V,this.g=this.B(new l.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,h.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(ne,(0,h.joinPath)(this.m,c.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(ne,(0,h.joinPath)(this.m,c.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(se,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,f.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(W,F,N){const[H,re]=await Promise.all([this.scanSystemExtensions(W),this.scanUserExtensions(F)]),z=N?await this.scanExtensionsUnderDevelopment(W,[...H,...re]):[];return this.D(H,re,z,await this.getTargetPlatform(),!0)}async scanSystemExtensions(W){const F=[];F.push(this.F(!!W.useCache,W.language)),F.push(this.G(W.language,!!W.checkControlFile));const[N,H]=await Promise.all(F);return this.C([...N,...H],0,W,!1)}async scanUserExtensions(W){const F=W.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",F);const N=await this.I(F,!!W.profileLocation,1,!W.includeUninstalled,W.language);let re=await(W.useCache&&!N.devMode&&N.excludeObsolete?this.j:this.k).scanExtensions(N);return re=await this.C(re,1,W,!0),this.s.trace("Scanned user extensions:",re.length),re}async scanExtensionsUnderDevelopment(W,F){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const N=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(H=>H.scheme===y.Schemas.file).map(async H=>{const re=await this.I(H,!1,1,!0,W.language,!1);return(await this.k.scanOneOrMultipleExtensions(re)).map(T=>(T.type=F.find(R=>(0,f.areSameExtensions)(R.identifier,T.identifier))?.type??T.type,this.k.validate(T,re)))}))).flat();return this.C(N,"development",W,!0)}return[]}async scanExistingExtension(W,F,N){const H=await this.I(W,!1,F,!0,N.language),re=await this.k.scanExtension(H);return!re||!N.includeInvalid&&!re.isValid?null:re}async scanOneOrMultipleExtensions(W,F,N){const H=await this.I(W,!1,F,!0,N.language),re=await this.k.scanOneOrMultipleExtensions(H);return this.C(re,F,N,!0)}async scanMetadata(W){const F=(0,h.joinPath)(W,"package.json"),N=(await this.r.readFile(F)).value.toString();return JSON.parse(N).__metadata}async updateMetadata(W,F){const N=(0,h.joinPath)(W,"package.json"),H=(await this.r.readFile(N)).value.toString(),re=JSON.parse(H);F.isMachineScoped=F.isMachineScoped||void 0,F.isBuiltin=F.isBuiltin||void 0,F.installedTimestamp=F.installedTimestamp||void 0,re.__metadata={...re.__metadata,...F},await this.r.writeFile((0,h.joinPath)(W,"package.json"),M.VSBuffer.fromString(JSON.stringify(re,null,"	")))}initializeDefaultProfileExtensions(){return this.z||(this.z=(async()=>{try{const W=this.v.extUri.joinPath(this.userExtensionsLocation,".init-default-profile-extensions");if(await this.r.exists(W))return;if(!await this.r.exists(this.n.defaultProfile.extensionsResource)&&!await this.r.exists(this.v.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"))){this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const F=await this.scanUserExtensions({includeInvalid:!0});await this.p.addExtensionsToProfile(F.map(N=>[N,N.metadata]),this.n.defaultProfile.extensionsResource),this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}try{await this.r.createFile(W,M.VSBuffer.fromString(""))}catch(F){(0,r.toFileOperationResult)(F)!==1&&this.s.warn("Failed to create default profile extensions initialize marker in extensions installation folder.",this.userExtensionsLocation.toString(),(0,A.getErrorMessage)(F))}}catch(W){throw this.s.error(W),W}})()),this.z}async C(W,F,N,H){return N.includeAllVersions||(W=this.D(F===0?W:void 0,F===1?W:void 0,F==="development"?W:void 0,await this.getTargetPlatform(),H)),N.includeInvalid||(W=W.filter(re=>re.isValid)),W.sort((re,z)=>{const T=P.basename(re.location.fsPath),R=P.basename(z.location.fsPath);return T<R?-1:T>R?1:0})}D(W,F,N,H,re){const z=(R,O,U)=>{if(R.isValid&&!O.isValid)return!1;if(R.isValid===O.isValid){if(re&&w.gt(R.manifest.version,O.manifest.version))return this.s.debug(`Skipping extension ${O.location.path} with lower version ${O.manifest.version} in favour of ${R.location.path} with version ${R.manifest.version}`),!1;if(w.eq(R.manifest.version,O.manifest.version)){if(R.type===0)return this.s.debug(`Skipping extension ${O.location.path} in favour of system extension ${R.location.path} with same version`),!1;if(R.targetPlatform===H)return this.s.debug(`Skipping extension ${O.location.path} from different target platform ${O.targetPlatform}`),!1}}return U?this.s.warn(`Overwriting user extension ${R.location.path} with ${O.location.path}.`):this.s.debug(`Overwriting user extension ${R.location.path} with ${O.location.path}.`),!0},T=new Map;return W?.forEach(R=>{const O=c.ExtensionIdentifier.toKey(R.identifier.id),U=T.get(O);(!U||z(U,R,!1))&&T.set(O,R)}),F?.forEach(R=>{const O=c.ExtensionIdentifier.toKey(R.identifier.id),U=T.get(O);if(!U&&W&&R.type===0){this.s.debug(`Skipping obsolete system extension ${R.location.path}.`);return}(!U||z(U,R,!1))&&T.set(O,R)}),N?.forEach(R=>{const O=c.ExtensionIdentifier.toKey(R.identifier.id),U=T.get(O);(!U||z(U,R,!0))&&T.set(O,R),T.set(O,R)}),[...T.values()]}async F(W,F){this.s.trace("Started scanning system extensions");const N=await this.I(this.systemExtensionsLocation,!1,0,!0,F),re=await(W&&!N.devMode?this.i:this.k).scanExtensions(N);return this.s.trace("Scanned system extensions:",re.length),re}async G(W,F){const N=this.t.isBuilt?[]:this.u.builtInExtensions;if(!N?.length)return[];this.s.trace("Started scanning dev system extensions");const H=F?await this.H():{},re=[],z=u.URI.file(P.normalize(P.join(y.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const R of N){const O=H[R.name]||"marketplace";switch(O){case"disabled":break;case"marketplace":re.push((0,h.joinPath)(z,R.name));break;default:re.push(u.URI.file(O));break}}const T=await Promise.all(re.map(async R=>this.k.scanExtension(await this.I(R,!1,0,!0,W))));return this.s.trace("Scanned dev system extensions:",T.length),(0,I.coalesce)(T)}async H(){try{const W=await this.r.readFile(this.l);return JSON.parse(W.value.toString())}catch{return{}}}async I(W,F,N,H,re,z=!0){const T=await this.f(re??E.language),R=await this.J(W),O=F&&!this.v.extUri.isEqual(W,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,U=O?await this.J(O):void 0;return new J(W,R,O,U,F,N,H,z,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,re,T)}async J(W){try{const F=await this.r.stat(W);if(typeof F.mtime=="number")return F.mtime}catch{}}};Y=pe([_(4,D.IUserDataProfilesService),_(5,S.IExtensionsProfileScannerService),_(6,r.IFileService),_(7,a.ILogService),_(8,g.IEnvironmentService),_(9,s.IProductService),_(10,L.IUriIdentityService),_(11,i.IInstantiationService)],Y),e.AbstractExtensionsScannerService=Y;class J{constructor(W,F,N,H,re,z,T,R,O,U,B,V,ie,$){this.location=W,this.mtime=F,this.applicationExtensionslocation=N,this.applicationExtensionslocationMtime=H,this.profile=re,this.type=z,this.excludeObsolete=T,this.validate=R,this.productVersion=O,this.productDate=U,this.productCommit=B,this.devMode=V,this.language=ie,this.translations=$}static createNlsConfiguration(W){return{language:W.language,pseudo:W.language==="pseudo",devMode:W.devMode,translations:W.translations}}static equals(W,F){return(0,h.isEqual)(W.location,F.location)&&W.mtime===F.mtime&&(0,h.isEqual)(W.applicationExtensionslocation,F.applicationExtensionslocation)&&W.applicationExtensionslocationMtime===F.applicationExtensionslocationMtime&&W.profile===F.profile&&W.type===F.type&&W.excludeObsolete===F.excludeObsolete&&W.validate===F.validate&&W.productVersion===F.productVersion&&W.productDate===F.productDate&&W.productCommit===F.productCommit&&W.devMode===F.devMode&&W.language===F.language&&ae.equals(W.translations,F.translations)}}let se=class extends m.Disposable{constructor(W,F,N,H,re){super(),this.f=W,this.g=F,this.h=N,this.i=H,this.j=re}async scanExtensions(W){const F=W.profile?await this.l(W):await this.k(W);let N={};if(W.excludeObsolete&&W.type===1)try{const H=(await this.i.readFile(this.f)).value.toString();N=JSON.parse(H)}catch{}return(0,b.isEmptyObject)(N)?F:F.filter(H=>!N[f.ExtensionKey.create(H).toString()])}async k(W){const F=await this.i.resolve(W.location);if(!F.children?.length)return[];const N=await Promise.all(F.children.map(async H=>{if(!H.isDirectory||W.type===1&&(0,h.basename)(H.resource).indexOf(".")===0)return null;const re=new J(H.resource,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension(re)}));return(0,I.coalesce)(N).sort((H,re)=>H.location.path<re.location.path?-1:1)}async l(W){let F=await this.m(W.location,()=>!0,W);if(W.applicationExtensionslocation&&!this.h.extUri.isEqual(W.location,W.applicationExtensionslocation)){F=F.filter(H=>!H.metadata?.isApplicationScoped);const N=await this.m(W.applicationExtensionslocation,H=>!!H.metadata?.isApplicationScoped,W);F.push(...N)}return F}async m(W,F,N){const H=await this.g.scanProfileExtensions(W);if(!H.length)return[];const re=await Promise.all(H.map(async z=>{if(F(z)){const T=new J(z.location,N.mtime,N.applicationExtensionslocation,N.applicationExtensionslocationMtime,N.profile,N.type,N.excludeObsolete,N.validate,N.productVersion,N.productDate,N.productCommit,N.devMode,N.language,N.translations);return this.scanExtension(T,z.metadata)}return null}));return(0,I.coalesce)(re)}async scanOneOrMultipleExtensions(W){try{if(await this.i.exists((0,h.joinPath)(W.location,"package.json"))){const F=await this.scanExtension(W);return F?[F]:[]}else return await this.scanExtensions(W)}catch(F){return this.j.error(`Error scanning extensions at ${W.location.path}:`,(0,A.getErrorMessage)(F)),[]}}async scanExtension(W,F){try{let N=await this.scanExtensionManifest(W.location);if(N){N.publisher||(N.publisher=c.UNDEFINED_PUBLISHER),F=F??N.__metadata,delete N.__metadata;const H=(0,f.getGalleryExtensionId)(N.publisher,N.name),re=F?.id?{id:H,uuid:F.id}:{id:H},z=F?.isSystem?0:W.type,T=z===0||!!F?.isBuiltin;X.ImplicitActivationEvents.updateManifest(N),N=await this.n(W.location,N,J.createNlsConfiguration(W));const R={type:z,identifier:re,manifest:N,location:W.location,isBuiltin:T,targetPlatform:F?.targetPlatform??"undefined",metadata:F,isValid:!0,validations:[]};return W.validate?this.validate(R,W):R}}catch(N){W.type!==0&&this.j.error(N)}return null}validate(W,F){let N=!0;const H=(0,n.validateExtensionManifest)(F.productVersion,F.productDate,F.location,W.manifest,W.isBuiltin);for(const[re,z]of H)re===d.default.Error&&(N=!1,this.j.error(this.t(F.location,z)));return W.isValid=N,W.validations=H,W}async scanExtensionManifest(W){const F=(0,h.joinPath)(W,"package.json");let N;try{N=(await this.i.readFile(F)).value.toString()}catch(re){return(0,r.toFileOperationResult)(re)!==1&&this.j.error(this.t(W,(0,v.localize)(0,null,F.path,re.message))),null}let H;try{H=JSON.parse(N)}catch{const z=[];(0,k.parse)(N,z);for(const T of z)this.j.error(this.t(W,(0,v.localize)(1,null,F.path,T.offset,T.length,(0,p.getParseErrorMessage)(T.error))));return null}return(0,k.getNodeType)(H)!=="object"?(this.j.error(this.t(W,(0,v.localize)(2,null,F.path))),null):H}async n(W,F,N){const H=await this.p(W,F,N);if(H)try{const re=[],z=await this.r(H.default,re);if(re.length>0)return re.forEach(R=>{this.j.error(this.t(W,(0,v.localize)(3,null,H.default?.path,(0,p.getParseErrorMessage)(R.error))))}),F;if((0,k.getNodeType)(H)!=="object")return this.j.error(this.t(W,(0,v.localize)(4,null,H.default?.path))),F;const T=H.values||Object.create(null);return(0,j.localizeManifest)(F,T,z)}catch{}return F}async p(W,F,N){const H=(0,h.joinPath)(W,"package.nls.json"),re=(O,U)=>{U.forEach(B=>{this.j.error(this.t(W,(0,v.localize)(5,null,O?.path,(0,p.getParseErrorMessage)(B.error))))})},z=O=>{this.j.error(this.t(W,(0,v.localize)(6,null,O?.path)))},T=`${F.publisher}.${F.name}`,R=N.translations[T];if(R)try{const O=u.URI.file(R),U=(await this.i.readFile(O)).value.toString(),B=[],V=(0,k.parse)(U,B);return B.length>0?(re(O,B),{values:void 0,default:H}):(0,k.getNodeType)(V)!=="object"?(z(O),{values:void 0,default:H}):{values:V.contents?V.contents.package:void 0,default:H}}catch{return{values:void 0,default:H}}else{if(!await this.i.exists(H))return;let U;try{U=await this.s(W,N)}catch{return}if(!U.localized)return{values:void 0,default:U.original};try{const B=(await this.i.readFile(U.localized)).value.toString(),V=[],ie=(0,k.parse)(B,V);return V.length>0?(re(U.localized,V),{values:void 0,default:U.original}):(0,k.getNodeType)(ie)!=="object"?(z(U.localized),{values:void 0,default:U.original}):{values:ie,default:U.original}}catch{return{values:void 0,default:U.original}}}}async r(W,F){if(W)try{const N=(await this.i.readFile(W)).value.toString();return(0,k.parse)(N,F)}catch{}}s(W,F){return new Promise((N,H)=>{const re=z=>{const T=(0,h.joinPath)(W,`package.nls.${z}.json`);this.i.exists(T).then(R=>{R&&N({localized:T,original:(0,h.joinPath)(W,"package.nls.json")});const O=z.lastIndexOf("-");O===-1?N({localized:(0,h.joinPath)(W,"package.nls.json"),original:null}):(z=z.substring(0,O),re(z))})};if(F.devMode||F.pseudo||!F.language)return N({localized:(0,h.joinPath)(W,"package.nls.json"),original:null});re(F.language)})}t(W,F){return`[${W.path}]: ${F}`}};se=pe([_(1,S.IExtensionsProfileScannerService),_(2,L.IUriIdentityService),_(3,r.IFileService),_(4,a.ILogService)],se);let ne=class extends se{constructor(W,F,N,H,re,z){super(F,N,H,re,z),this.y=W,this.v=this.B(new t.ThrottledDelayer(3e3)),this.w=this.B(new l.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(W){const F=await this.z();if(this.u=W,F&&F.input&&J.equals(F.input,this.u))return this.v.trigger(()=>this.D()),F.result.map(H=>(H.location=u.URI.revive(H.location),H));const N=await super.scanExtensions(W);return await this.C({input:W,result:N}),N}async z(){try{const W=await this.i.readFile(this.y),F=JSON.parse(W.value.toString());return{result:F.result,input:(0,o.revive)(F.input)}}catch(W){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,A.getErrorMessage)(W))}return null}async C(W){try{await this.i.writeFile(this.y,M.VSBuffer.fromString(JSON.stringify(W)))}catch(F){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,A.getErrorMessage)(F))}}async D(){if(!this.u)return;const W=await this.z();if(!W)return;const F=W.result,N=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!C.equals(N,F))try{await this.i.del(this.y),this.w.fire()}catch(H){this.j.error(H)}}};ne=pe([_(2,S.IExtensionsProfileScannerService),_(3,L.IUriIdentityService),_(4,r.IFileService),_(5,a.ILogService)],ne);function he(le,W){const F=(0,f.getExtensionId)(le.manifest.publisher,le.manifest.name);return{id:F,identifier:new c.ExtensionIdentifier(F),isBuiltin:le.type===0,isUserBuiltin:le.type===1&&le.isBuiltin,isUnderDevelopment:W,extensionLocation:le.location,uuid:le.identifier.uuid,targetPlatform:le.targetPlatform,...le.manifest}}e.toExtensionDescription=he;class K extends Y{constructor(W,F,N,H,re,z,T,R,O,U,B,V){super(W,F,(0,h.joinPath)(N,".vscode-oss-dev","extensions","control.json"),(0,h.joinPath)(H,c.MANIFEST_CACHE_FOLDER),re,z,T,R,O,U,B,V),this.L=(async()=>{if(E.translationsConfigFile)try{const ie=await this.r.readFile(u.URI.file(E.translationsConfigFile));return JSON.parse(ie.value.toString())}catch{}return Object.create(null)})()}f(W){return this.L}}e.NativeExtensionsScannerService=K}),define(ee[256],te([0,1,7,34,91,116,16,5,6,19,42,38]),function(q,e,I,t,C,M,A,k,p,m,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let E=class extends M.NativeExtensionsScannerService{constructor(w,d,b,u,v,g,f,c){super(I.URI.file(v.builtinExtensionsPath),I.URI.file(v.extensionsPath),v.userHome,I.URI.file(v.userDataPath),w,d,b,u,v,g,f,c)}};E=pe([_(0,P.IUserDataProfilesService),_(1,C.IExtensionsProfileScannerService),_(2,A.IFileService),_(3,p.ILogService),_(4,t.INativeEnvironmentService),_(5,m.IProductService),_(6,y.IUriIdentityService),_(7,k.IInstantiationService)],E),e.ExtensionsScannerService=E}),define(ee[257],te([0,1,13,2,15,9,4,60,7,29,41,34,6,38]),function(q,e,I,t,C,M,A,k,p,m,y,P,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let w=class extends t.Disposable{constructor(b,u,v){super(),this.c=b,this.f=v,this.a=k.TernarySearchTree.forPaths(!A.isLinux),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(b.appRoot),this.addValidFileRoot(b.extensionsPath),this.addValidFileRoot(u.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(b.workspaceStorageHome.fsPath),this.g()}g(){const{defaultSession:b}=I.session;b.protocol.registerFileProtocol(C.Schemas.vscodeFileResource,(u,v)=>this.i(u,v)),b.protocol.interceptFileProtocol(C.Schemas.file,(u,v)=>this.h(u,v)),this.B((0,t.toDisposable)(()=>{b.protocol.unregisterProtocol(C.Schemas.vscodeFileResource),b.protocol.uninterceptProtocol(C.Schemas.file)}))}addValidFileRoot(b){const u=(0,M.normalize)(b);return this.a.get(u)?t.Disposable.None:(this.a.set(u,!0),(0,t.toDisposable)(()=>this.a.delete(u)))}h(b,u){const v=p.URI.parse(b.url);return this.f.error(`Refused to load resource ${v.fsPath} from ${C.Schemas.file}: protocol (original URL: ${b.url})`),u({error:-3})}i(b,u){const v=this.j(b);let g;return this.c.crossOriginIsolated&&((0,M.basename)(v)==="workbench.html"||(0,M.basename)(v)==="workbench-dev.html"?g=C.COI.CoopAndCoep:g=C.COI.getHeadersFromQuery(b.url)),this.a.findSubstr(v)?u({path:v,headers:g}):this.b.has((0,M.extname)(v).toLowerCase())?u({path:v}):(this.f.error(`${C.Schemas.vscodeFileResource}: Refused to load resource ${v} from ${C.Schemas.vscodeFileResource}: protocol (original URL: ${b.url})`),u({error:-3}))}j(b){const u=p.URI.parse(b.url),v=C.FileAccess.uriToFileUri(u);return(0,M.normalize)(v.fsPath)}createIPCObjectUrl(){let b;const u=p.URI.from({scheme:"vscode",path:(0,m.generateUuid)()}),v=u.toString(),g=async()=>b;return y.validatedIpcMain.handle(v,g),this.f.trace(`IPC Object URL: Registered new channel ${v}.`),{resource:u,update:f=>b=f,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${v}.`),y.validatedIpcMain.removeHandler(v)}}}};w=pe([_(0,P.INativeEnvironmentService),_(1,h.IUserDataProfilesService),_(2,E.ILogService)],w),e.ProtocolMainService=w}),define(ee[258],te([0,1,13,41,8,3,2,15,12,103,27,21,6,63,64,66,45,38,37]),function(q,e,I,t,C,M,A,k,p,m,y,P,E,h,w,d,b,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let g=class extends A.Disposable{constructor(c,n,r,i,a,s,l,o,S){super(),this.g=c,this.h=n,this.i=r,this.j=i,this.k=a,this.l=s,this.m=l,this.n=o,this.p=S,this.a=new C.Barrier,this.b=void 0,this.c=void 0,this.f=this.B(new M.Emitter),this.onDidError=M.Event.buffer(this.f.event),this.w=void 0,this.y=void 0,this.r()}r(){t.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(c,n)=>this.s(c,n)),t.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(c,n)=>this.t(c,n)),this.B(this.k.onWillShutdown(()=>this.u()))}async s(c,n){this.l.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.a.isOpen()||this.a.open(),await this.whenReady();const r=await this.connect();if(c.sender.isDestroyed())return r.close();c.sender.postMessage("vscode:createSharedProcessMessageChannelResult",n,[r])}t(c,n){this.l.trace("SharedProcess: onWorkerConnection",n);const r=new A.DisposableStore,i=s=>{!this.F()||(this.l.trace(`SharedProcess: disposing worker (reason: '${s}')`,n),r.dispose(),this.v("vscode:electron-main->shared-process=disposeWorker",n))},a=I.BrowserWindow.fromId(n.reply.windowId);if(!a||a.isDestroyed()||a.webContents.isDestroyed()||!n.reply.channel){i("unavailable");return}r.add(M.Event.filter(this.k.onWillLoadWindow,s=>s.window.win===a)(()=>i("load"))),r.add(M.Event.fromNodeEventEmitter(a,"closed")(()=>i("closed"))),a.webContents.postMessage(n.reply.channel,n.reply.nonce,c.ports)}u(){const c=this.b;!c||(this.v("vscode:electron-main->shared-process=exit"),this.c&&(c.removeListener("close",this.c),this.c=void 0),setTimeout(()=>{try{c.close()}catch{}this.b=void 0},0))}v(c,...n){if(!this.F()){this.l.warn(`Sending IPC message to channel '${c}' for shared process window that is destroyed`);return}try{this.b?.webContents.send(c,...n)}catch(r){this.l.warn(`Error sending IPC message to channel '${c}' of shared process: ${(0,b.toErrorMessage)(r)}`)}}whenReady(){return this.w||(this.w=new Promise(c=>t.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.l.trace("SharedProcess: Overall ready"),c()}))),this.w}get z(){return this.y||(this.y=(async()=>{await this.a.wait(),this.C(),this.D(),await new Promise(c=>t.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.l.trace("SharedProcess: IPC ready"),c()}))})()),this.y}C(){const c=this.B(this.p.createIPCObjectUrl());this.b=new I.BrowserWindow({show:!1,backgroundColor:this.n.getBackgroundColor(),webPreferences:{preload:k.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${c.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.i.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,images:!1,webgl:!1}}),c.update({machineId:this.g,windowId:this.b.id,appRoot:this.i.appRoot,codeCachePath:this.i.codeCachePath,profiles:this.j.profiles,userEnv:this.h,args:this.i.args,logLevel:this.l.getLevel(),product:h.default,policiesData:this.m.serialize()}),this.b.loadURL(k.FileAccess.asBrowserUri(`vs/code/electron-browser/sharedProcess/sharedProcess${this.i.isBuilt?"":"-dev"}.html`).toString(!0))}D(){!this.b||(this.c=c=>{this.l.trace("SharedProcess#close prevented"),c.preventDefault(),this.b?.isVisible()&&this.b.hide()},this.b.on("close",this.c),this.b.webContents.on("render-process-gone",(c,n)=>this.f.fire({type:2,details:n})),this.b.on("unresponsive",()=>this.f.fire({type:1})),this.b.webContents.on("did-fail-load",(c,n,r)=>this.f.fire({type:3,details:{reason:r,exitCode:n}})))}async connect(){await this.z;const c=(0,p.assertIsDefined)(this.b);return(0,m.connect)(c)}async toggle(){await this.z,this.b&&(this.b.isVisible()?(this.b.webContents.closeDevTools(),this.b.hide()):(this.b.show(),this.b.webContents.openDevTools()))}isVisible(){return this.b?.isVisible()??!1}F(){const c=this.b;return c?!c.isDestroyed()&&!c.webContents.isDestroyed():!1}};g=pe([_(2,y.IEnvironmentMainService),_(3,u.IUserDataProfilesService),_(4,P.ILifecycleMainService),_(5,E.ILogService),_(6,v.IPolicyService),_(7,d.IThemeMainService),_(8,w.IProtocolMainService)],g),e.SharedProcess=g}),define(ee[92],te([0,1,8,3,2,73,12,104,5,38]),function(q,e,I,t,C,M,A,k,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,p.createDecorator)("storageService");var y;(function(v){v[v.NONE=0]="NONE",v[v.SHUTDOWN=1]="SHUTDOWN"})(y=e.WillSaveStateReason||(e.WillSaveStateReason={}));var P;(function(v){v[v.APPLICATION=-1]="APPLICATION",v[v.PROFILE=0]="PROFILE",v[v.WORKSPACE=1]="WORKSPACE"})(P=e.StorageScope||(e.StorageScope={}));var E;(function(v){v[v.USER=0]="USER",v[v.MACHINE=1]="MACHINE"})(E=e.StorageTarget||(e.StorageTarget={}));function h(v){const g=v.get(e.TARGET_KEY);if(g)try{return JSON.parse(g)}catch{}return Object.create(null)}e.loadKeyTargets=h;class w extends C.Disposable{constructor(g={flushInterval:w.a}){super(),this.j=g,this.b=this.B(new t.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new t.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new t.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new I.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new C.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,I.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,C.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,M.mark)("code/willInitStorage");try{await this.J()}finally{(0,M.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(g,f){if(f===e.TARGET_KEY){switch(g){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:g})}else this.b.fire({scope:g,key:f,target:this.F(g)[f]})}r(g){this.f.fire({reason:g})}get(g,f,c){return this.L(f)?.get(g,c)}getBoolean(g,f,c){return this.L(f)?.getBoolean(g,c)}getNumber(g,f,c){return this.L(f)?.getNumber(g,c)}store(g,f,c,n){if((0,A.isUndefinedOrNull)(f)){this.remove(g,c);return}this.t(()=>{this.u(g,c,n),this.L(c)?.set(g,f)})}remove(g,f){this.t(()=>{this.u(g,f,void 0),this.L(f)?.delete(g)})}t(g){this.b.pause(),this.c.pause();try{g()}finally{this.b.resume(),this.c.resume()}}keys(g,f){const c=[],n=this.F(g);for(const r of Object.keys(n))n[r]===f&&c.push(r);return c}u(g,f,c){const n=this.F(f);typeof c=="number"?n[g]!==c&&(n[g]=c,this.L(f)?.set(e.TARGET_KEY,JSON.stringify(n))):typeof n[g]=="number"&&(delete n[g],this.L(f)?.set(e.TARGET_KEY,JSON.stringify(n)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(g){switch(g){case-1:return this.D;case 0:return this.z;default:return this.w}}G(g){const f=this.L(g);return f?h(f):Object.create(null)}isNew(g){return this.getBoolean(e.IS_NEW_KEY,g)===!0}async flush(g=y.NONE){this.f.fire({reason:g});const f=this.L(-1),c=this.L(0),n=this.L(1);switch(g){case y.NONE:await I.Promises.settled([f?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve()]);break;case y.SHUTDOWN:await I.Promises.settled([f?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve()]);break}}async log(){const g=this.L(-1)?.items??new Map,f=this.L(0)?.items??new Map,c=this.L(1)?.items??new Map;return u(g,f,c,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(g,f){return this.r(y.NONE),(0,m.isUserDataProfile)(g)?this.N(g,f):this.O(g,f)}H(g,f){return!(g.id===f.id||d(f)&&d(g))}I(g,f,c,n){this.t(()=>{if(n)for(const[r,i]of g)f.set(r,i);else{const r=new Set;for(const[i,a]of g)r.add(i),f.get(i)!==a&&this.n(c,i);for(const[i]of f.items)r.has(i)||this.n(c,i)}})}}e.AbstractStorageService=w,w.a=60*1e3;function d(v){return v.isDefault||!!v.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=d;class b extends w{constructor(){super(),this.p=this.B(new k.Storage(new k.InMemoryStorageDatabase)),this.P=this.B(new k.Storage(new k.InMemoryStorageDatabase)),this.Q=this.B(new k.Storage(new k.InMemoryStorageDatabase)),this.B(this.Q.onDidChangeStorage(g=>this.n(1,g))),this.B(this.P.onDidChangeStorage(g=>this.n(0,g))),this.B(this.p.onDidChangeStorage(g=>this.n(-1,g)))}L(g){switch(g){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(g){switch(g){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(g){return!1}}e.InMemoryStorageService=b;async function u(v,g,f,c,n,r){const i=X=>{try{return JSON.parse(X)}catch{return X}},a=new Map,s=new Map;v.forEach((X,ae)=>{a.set(ae,X),s.set(ae,i(X))});const l=new Map,o=new Map;g.forEach((X,ae)=>{l.set(ae,X),o.set(ae,i(X))});const S=new Map,D=new Map;f.forEach((X,ae)=>{S.set(ae,X),D.set(ae,i(X))}),console.group(c!==n?`Storage: Application (path: ${c})`:`Storage: Application & Profile (path: ${c}, default profile)`);const L=[];if(a.forEach((X,ae)=>{L.push({key:ae,value:X})}),console.table(L),console.groupEnd(),console.log(s),c!==n){console.group(`Storage: Profile (path: ${n}, profile specific)`);const X=[];l.forEach((ae,Y)=>{X.push({key:Y,value:ae})}),console.table(X),console.groupEnd(),console.log(o)}console.group(`Storage: Workspace (path: ${r})`);const j=[];S.forEach((X,ae)=>{j.push({key:ae,value:X})}),console.table(j),console.groupEnd(),console.log(D)}e.logStorage=u}),define(ee[259],te([0,1,24,8,3,2,9,80,7,23,104,146,6,92,36,28]),function(q,e,I,t,C,M,A,k,p,m,y,P,E,h,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class b extends M.Disposable{get storage(){return this.f}constructor(r,i){super(),this.j=r,this.k=i,this.b=this.B(new C.Emitter),this.onDidChangeStorage=this.b.event,this.c=this.B(new C.Emitter),this.onDidCloseStorage=this.c.event,this.f=new y.Storage(new y.InMemoryStorageDatabase),this.g=void 0,this.h=new t.DeferredPromise,this.whenInit=this.h.p,this.i=y.StorageState.None}init(){return this.g||(this.g=(async()=>{if(this.i===y.StorageState.None)try{const r=await this.n();this.f.dispose(),this.f=r,this.B(r.onDidChangeStorage(a=>this.b.fire({key:a}))),await this.m(r);const i=r.getBoolean(h.IS_NEW_KEY);i===void 0?r.set(h.IS_NEW_KEY,!0):i&&r.set(h.IS_NEW_KEY,!1)}catch(r){this.j.error(`[storage main] initialize(): Unable to init storage due to ${r}`)}finally{this.i=y.StorageState.Initialized,this.h.complete()}})()),this.g}l(){return{logTrace:this.j.getLevel()===E.LogLevel.Trace?r=>this.j.trace(r):void 0,logError:r=>this.j.error(r)}}m(r){return r.init()}get items(){return this.f.items}get(r,i){return this.f.get(r,i)}set(r,i){return this.f.set(r,i)}delete(r){return this.f.delete(r)}async close(){const r=new k.StopWatch(!1);await this.s(),r.stop(),r.elapsed()>b.a&&await this.r(r),this.c.fire()}async r(r){if(!!this.path)try{const i=(0,I.top)(Array.from(this.f.items.entries()).map(([s,l])=>({key:s,length:l.length})),(s,l)=>l.length-s.length,5).map(s=>`${s.key}:${s.length}`).join(", "),a=(await this.k.stat(p.URI.file(this.path))).size;this.j.warn(`[storage main] detected slow close() operation: Time: ${r.elapsed()}ms, DB size: ${a}b, Large Keys: ${i}`)}catch(i){this.j.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async s(){this.g&&await this.g,this.i=y.StorageState.Closed,await this.f.close()}}b.a=2e3;class u extends b{get path(){if(!this.v.useInMemoryStorage)return(0,A.join)(this.u.globalStorageHome.fsPath,u.t)}constructor(r,i,a,s){super(a,s),this.u=r,this.v=i}async n(){return new y.Storage(new P.SQLiteStorageDatabase(this.path??P.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.l()}))}}u.t="state.vscdb";class v extends u{constructor(r,i,a,s){super(r,i,a,s)}}e.ProfileStorageMain=v;class g extends u{constructor(r,i,a,s){super(i.defaultProfile,r,a,s)}async m(r){await super.m(r),this.z(r)}z(r){r.get(w.firstSessionDateStorageKey,void 0)===void 0&&r.set(w.firstSessionDateStorageKey,new Date().toUTCString());const a=r.get(w.currentSessionDateStorageKey,void 0),s=new Date().toUTCString();r.set(w.lastSessionDateStorageKey,typeof a>"u"?null:a),r.set(w.currentSessionDateStorageKey,s)}}e.ApplicationStorageMain=g;class f extends b{get path(){if(!this.w.useInMemoryStorage)return(0,A.join)(this.y.workspaceStorageHome.fsPath,this.v.id,f.t)}constructor(r,i,a,s,l){super(a,l),this.v=r,this.w=i,this.y=s}async n(){const{storageFilePath:r,wasCreated:i}=await this.C();return new y.Storage(new P.SQLiteStorageDatabase(r,{logging:this.l()}),{hint:i?y.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async C(){if(this.w.useInMemoryStorage)return{storageFilePath:P.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const r=(0,A.join)(this.y.workspaceStorageHome.fsPath,this.v.id),i=(0,A.join)(r,f.t);return await m.Promises.exists(r)?{storageFilePath:i,wasCreated:!1}:(await m.Promises.mkdir(r,{recursive:!0}),this.D(r),{storageFilePath:i,wasCreated:!0})}async D(r){let i;if((0,d.isSingleFolderWorkspaceIdentifier)(this.v)?i={folder:this.v.uri.toString()}:(0,d.isWorkspaceIdentifier)(this.v)&&(i={workspace:this.v.configPath.toString()}),i)try{const a=(0,A.join)(r,f.u);await m.Promises.exists(a)||await m.Promises.writeFile(a,JSON.stringify(i,void 0,2))}catch(a){this.j.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${a}`)}}}e.WorkspaceStorageMain=f,f.t="state.vscdb",f.u="workspace.json";class c extends b{get path(){}async n(){return new y.Storage(new y.InMemoryStorageDatabase)}}e.InMemoryStorageMain=c}),define(ee[260],te([0,1,3,2,92]),function(q,e,I,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class M extends t.Disposable{constructor(k,p,m){super(),this.b=k,this.c=p,this.f=m;const y=this.B(new t.MutableDisposable);this.a=this.B(new I.Emitter({onWillAddFirstListener:()=>y.value=this.g(),onDidRemoveLastListener:()=>y.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const k=new t.DisposableStore;return k.add(I.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(p,m)=>(p?p.push(m.key):p=[m.key],p),100)(p=>this.h(p))),k.add(I.Event.debounce(this.b.onDidChangeProfileStorage,(p,m)=>{p||(p=new Map);let y=p.get(m.profile.id);return y||p.set(m.profile.id,y={profile:m.profile,keys:[],storage:m.storage}),y.keys.push(m.key),p},100)(p=>this.i(p))),k}h(k){const p=k.includes(C.TARGET_KEY)?[this.c.defaultProfile]:[],m=[];if(k=k.filter(y=>y!==C.TARGET_KEY),k.length){const y=(0,C.loadKeyTargets)(this.b.applicationStorage.storage);m.push({profile:this.c.defaultProfile,changes:k.map(P=>({key:P,scope:0,target:y[P]}))})}this.j(p,m)}i(k){const p=[],m=new Map;for(const[y,P]of k.entries()){P.keys.includes(C.TARGET_KEY)&&p.push(P.profile);const E=P.keys.filter(h=>h!==C.TARGET_KEY);if(E.length){const h=(0,C.loadKeyTargets)(P.storage.storage);m.set(y,{profile:P.profile,changes:E.map(w=>({key:w,scope:0,target:h[w]}))})}}this.j(p,[...m.values()])}j(k,p){(k.length||p.length)&&this.a.fire({valueChanges:p,targetChanges:k})}listen(k,p,m){switch(p){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${p}`)}async call(k,p){throw new Error(`Call not found: ${p}`)}}e.ProfileStorageChangesListenerChannel=M}),define(ee[261],te([0,1,69,7,34,16,6,228,42,38]),function(q,e,I,t,C,M,A,k,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=void 0;let y=class Ot extends m.UserDataProfilesService{constructor(E,h,w,d,b){super(w,d,h,b),this.a=E,this.N=w}H(){return(0,I.revive)(this.a.getItem(Ot.b,[]))}J(){return(0,I.revive)(this.a.getItem(Ot.c,{}))}M(){return this.r.extUri.joinPath(t.URI.file(this.N.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};y=pe([_(0,k.IStateService),_(1,p.IUriIdentityService),_(2,C.INativeEnvironmentService),_(3,M.IFileService),_(4,A.ILogService)],y),e.UserDataProfilesService=y}),define(ee[51],te([0,1,7,34,16,5,6,35,42,38,261]),function(q,e,I,t,C,M,A,k,p,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,M.refineServiceDecorator)(m.IUserDataProfilesService);let P=class ft extends y.UserDataProfilesService{constructor(h,w,d,b,u){super(h,w,d,b,u),this.R=h}setEnablement(h){super.setEnablement(h),this.f||(this.I([]),this.L({}))}I(h){h.length?this.R.setItem(ft.b,h):this.R.removeItem(ft.b)}L(h){h.emptyWindow||h.workspaces?this.R.setItem(ft.c,h):this.R.removeItem(ft.c)}J(){const h="workspaceAndProfileInfo",w=this.R.getItem(h,void 0);if(w){this.R.removeItem(h);const d=w.reduce((b,{workspace:u,profile:v})=>(b[I.URI.revive(u).toString()]=I.URI.revive(v).toString(),b),{});this.R.setItem(ft.c,{workspaces:d})}return super.J()}};P=pe([_(0,k.IStateMainService),_(1,p.IUriIdentityService),_(2,t.INativeEnvironmentService),_(3,C.IFileService),_(4,A.ILogService)],P),e.UserDataProfilesMainService=P}),define(ee[93],te([0,1,7,50,3,2,34,16,5,21,6,92,259,38,51,42]),function(q,e,I,t,C,M,A,k,p,m,y,P,E,h,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,p.createDecorator)("storageMainService");let b=class extends M.Disposable{constructor(g,f,c,n,r,i){super(),this.c=g,this.f=f,this.g=c,this.h=n,this.i=r,this.j=i,this.a=void 0,this.b=this.B(new C.Emitter),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.m(),this.n=new Map,this.r=new Map,this.l()}k(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}l(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(g=>{g.window.profile&&this.profileStorage(g.window.profile).init(),g.workspace&&this.workspaceStorage(g.workspace).init()})),this.B(this.h.onWillShutdown(g=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=g.reason,g.join(this.applicationStorage.close());for(const[,f]of this.n)g.join(f.close());for(const[,f]of this.r)g.join(f.close())})),this.B(this.g.onWillCreateProfile(g=>{g.join((async()=>{await this.i.exists(g.profile.globalStorageHome)||await this.i.createFolder(g.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(g=>{const f=this.n.get(g.profile.id);f&&g.join(f.close())}))}m(){this.c.trace("StorageMainService: creating application storage");const g=new E.ApplicationStorageMain(this.k(),this.g,this.c,this.i);return(0,t.once)(g.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")}),g}profileStorage(g){if((0,P.isProfileUsingDefaultStorage)(g))return this.applicationStorage;let f=this.n.get(g.id);if(!f){this.c.trace(`StorageMainService: creating profile storage (${g.name})`),f=this.p(g),this.n.set(g.id,f);const c=this.B(f.onDidChangeStorage(n=>this.b.fire({...n,storage:f,profile:g})));(0,t.once)(f.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${g.name})`),this.n.delete(g.id),c.dispose()})}return f}p(g){return this.a===2?new E.InMemoryStorageMain(this.c,this.i):new E.ProfileStorageMain(g,this.k(),this.c,this.i)}workspaceStorage(g){let f=this.r.get(g.id);return f||(this.c.trace(`StorageMainService: creating workspace storage (${g.id})`),f=this.s(g),this.r.set(g.id,f),(0,t.once)(f.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${g.id})`),this.r.delete(g.id)})),f}s(g){return this.a===2?new E.InMemoryStorageMain(this.c,this.i):new E.WorkspaceStorageMain(g,this.k(),this.c,this.f,this.i)}isUsed(g){const f=I.URI.file(g);for(const c of[this.applicationStorage,...this.n.values(),...this.r.values()])if(!!c.path&&this.j.extUri.isEqualOrParent(I.URI.file(c.path),f))return!0;return!1}};b=pe([_(0,y.ILogService),_(1,A.IEnvironmentService),_(2,w.IUserDataProfilesMainService),_(3,m.ILifecycleMainService),_(4,k.IFileService),_(5,d.IUriIdentityService)],b),e.StorageMainService=b,e.IApplicationStorageMainService=(0,p.createDecorator)("applicationStorageMainService");let u=class extends P.AbstractStorageService{constructor(g,f){super(),this.p=g,this.s=f,this.whenReady=this.s.applicationStorage.whenInit}J(){return this.s.applicationStorage.whenInit}L(g){if(g===-1)return this.s.applicationStorage.storage}M(g){if(g===-1)return this.p.defaultProfile.globalStorageHome.fsPath}l(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}N(){throw new Error("Switching storage profile is unsupported from main process")}O(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};u=pe([_(0,h.IUserDataProfilesService),_(1,e.IStorageMainService)],u),e.ApplicationStorageMainService=u}),define(ee[262],te([0,1,2,21,51]),function(q,e,I,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataTransientProfilesHandler=void 0;let M=class extends I.Disposable{constructor(k,p){super(),this.a=p,this.B(k.onWillLoadWindow(m=>{m.reason===2&&this.b(m.window.openedWorkspace??"empty-window")})),this.B(k.onBeforeCloseWindow(m=>this.b(m.openedWorkspace??"empty-window")))}async b(k){this.a.getOrSetProfileForWorkspace(k).isTransient&&(this.a.unsetWorkspace(k,!0),await this.a.cleanUpTransientProfiles())}};M=pe([_(0,t.ILifecycleMainService),_(1,C.IUserDataProfilesMainService)],M),e.UserDataTransientProfilesHandler=M}),define(ee[117],te([0,1,20,7,28]),function(q,e,I,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;async function M(p,m,y){for(const E of p){const h=E.openedWorkspace;if((0,C.isWorkspaceIdentifier)(h)){const w=await y(h);if(w){if(w.folders.some(d=>I.extUriBiasedIgnorePathCase.isEqualOrParent(m,d.uri)))return E}else if(I.extUriBiasedIgnorePathCase.isEqualOrParent(m,h.configPath))return E}}const P=p.filter(E=>(0,C.isSingleFolderWorkspaceIdentifier)(E.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqualOrParent(m,E.openedWorkspace.uri));if(P.length)return P.sort((E,h)=>-(E.openedWorkspace.uri.path.length-h.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=M;function A(p,m){for(const y of p)if((0,C.isWorkspaceIdentifier)(y.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqual(y.openedWorkspace.configPath,m)||(0,C.isSingleFolderWorkspaceIdentifier)(y.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqual(y.openedWorkspace.uri,m))return y}e.findWindowOnWorkspaceOrFolder=A;function k(p,m){const y=P=>m.some(E=>I.extUriBiasedIgnorePathCase.isEqual(t.URI.file(E),t.URI.file(P)));for(const P of p)if(P.config?.extensionDevelopmentPath?.some(E=>y(E)))return P}e.findWindowOnExtensionDevelopmentPath=k}),define(ee[263],te([0,1,13,2,4,20,7,18,21,6,35,31,115,28]),function(q,e,I,t,C,M,A,k,p,m,y,P,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let w=class Tt extends t.Disposable{get state(){return this.b}constructor(f,c,n,r,i){super(),this.g=f,this.h=c,this.i=n,this.j=r,this.k=i,this.b=d(this.h.getItem(Tt.a)),this.c=void 0,this.f=!1,this.l()}l(){I.app.on("browser-window-blur",()=>{this.f||this.n()}),this.i.onBeforeCloseWindow(f=>this.p(f)),this.i.onBeforeShutdown(()=>this.m()),this.g.onDidChangeWindowsCount(f=>{f.newCount-f.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(f=>this.p(f))}m(){this.f=!0,this.n()}n(){const f=new Set,c={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!c.lastActiveWindow){let i=this.g.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.g.getWindows().find(a=>!a.isExtensionDevelopmentHost)),i&&(c.lastActiveWindow=this.r(i),c.lastActiveWindow.uiState.mode===3&&f.add(c.lastActiveWindow.uiState.display))}const n=this.g.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);n&&(c.lastPluginDevelopmentHostWindow=this.r(n),c.lastPluginDevelopmentHostWindow.uiState.mode===3&&(f.has(c.lastPluginDevelopmentHostWindow.uiState.display)?C.isMacintosh&&!n.win?.isSimpleFullScreen()&&(c.lastPluginDevelopmentHostWindow.uiState.mode=1):f.add(c.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(c.openedWindows=this.g.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const a=this.r(i);return a.uiState.mode===3&&(f.has(a.uiState.display)?C.isMacintosh&&a.windowId!==c.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(a.uiState.mode=1):f.add(a.uiState.display)),a}));const r=u(c);this.h.setItem(Tt.a,r),this.f&&this.j.trace("[WindowsStateHandler] onBeforeShutdown",r)}p(f){if(this.i.quitRequested)return;const c=this.r(f);f.isExtensionDevelopmentHost&&!f.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=c:!f.isExtensionDevelopmentHost&&f.openedWorkspace&&this.b.openedWindows.forEach(n=>{const r=(0,h.isWorkspaceIdentifier)(f.openedWorkspace)&&n.workspace?.id===f.openedWorkspace.id,i=(0,h.isSingleFolderWorkspaceIdentifier)(f.openedWorkspace)&&n.folderUri&&M.extUriBiasedIgnorePathCase.isEqual(n.folderUri,f.openedWorkspace.uri);(r||i)&&(n.uiState=c.uiState)}),this.g.getWindowCount()===1&&(this.c=c)}r(f){return{windowId:f.id,workspace:(0,h.isWorkspaceIdentifier)(f.openedWorkspace)?f.openedWorkspace:void 0,folderUri:(0,h.isSingleFolderWorkspaceIdentifier)(f.openedWorkspace)?f.openedWorkspace.uri:void 0,backupPath:f.backupPath,remoteAuthority:f.remoteAuthority,uiState:f.serializeWindowState()}}getNewWindowState(f){const c=this.s(f),n=this.k.getValue("window");if(c.mode===3){let r;c.hasDefaultState?r=!!(n?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(n.newWindowDimensions)>=0):r=!!(this.i.wasRestarted||n?.restoreFullscreen),r||(c.mode=1)}return c}s(f){const c=this.g.getLastActiveWindow();if(!f.extensionTestsPath){if(!!f.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const l=f.workspace;if((0,h.isWorkspaceIdentifier)(l)){const S=this.state.openedWindows.filter(D=>D.workspace&&D.workspace.id===l.id).map(D=>D.uiState);if(S.length)return S[0]}if((0,h.isSingleFolderWorkspaceIdentifier)(l)){const S=this.state.openedWindows.filter(D=>D.folderUri&&M.extUriBiasedIgnorePathCase.isEqual(D.folderUri,l.uri)).map(D=>D.uiState);if(S.length)return S[0]}else if(f.backupPath){const S=this.state.openedWindows.filter(D=>D.backupPath===f.backupPath).map(D=>D.uiState);if(S.length)return S[0]}const o=this.c||this.state.lastActiveWindow;if(!c&&o)return o.uiState}let n;const r=I.screen.getAllDisplays();if(r.length===1)n=r[0];else{if(C.isMacintosh){const l=I.screen.getCursorScreenPoint();n=I.screen.getDisplayNearestPoint(l)}!n&&c&&(n=I.screen.getDisplayMatching(c.getBounds())),n||(n=I.screen.getPrimaryDisplay()||r[0])}let i=(0,E.defaultWindowState)();i.x=Math.round(n.bounds.x+n.bounds.width/2-i.width/2),i.y=Math.round(n.bounds.y+n.bounds.height/2-i.height/2);const a=this.k.getValue("window");let s=!0;if(a?.newWindowDimensions){if(a.newWindowDimensions==="maximized")i.mode=0,s=!1;else if(a.newWindowDimensions==="fullscreen")i.mode=3,s=!1;else if((a.newWindowDimensions==="inherit"||a.newWindowDimensions==="offset")&&c){const l=c.serializeWindowState();l.mode===3?i.mode=3:i=l,s=i.mode!==3&&a.newWindowDimensions==="offset"}}return s&&(i=this.t(i)),i.hasDefaultState=!0,i}t(f){if(this.g.getWindows().length===0)return f;f.x=typeof f.x=="number"?f.x:0,f.y=typeof f.y=="number"?f.y:0;const c=this.g.getWindows().map(n=>n.getBounds());for(;c.some(n=>n.x===f.x||n.y===f.y);)f.x+=30,f.y+=30;return f}};w.a="windowsState",w=pe([_(0,P.IWindowsMainService),_(1,y.IStateMainService),_(2,p.ILifecycleMainService),_(3,m.ILogService),_(4,k.IConfigurationService)],w),e.WindowsStateHandler=w;function d(g){const f={openedWindows:[]},c=g||{openedWindows:[]};return c.lastActiveWindow&&(f.lastActiveWindow=b(c.lastActiveWindow)),c.lastPluginDevelopmentHostWindow&&(f.lastPluginDevelopmentHostWindow=b(c.lastPluginDevelopmentHostWindow)),Array.isArray(c.openedWindows)&&(f.openedWindows=c.openedWindows.map(n=>b(n))),f}e.restoreWindowsState=d;function b(g){const f={uiState:g.uiState};return g.backupPath&&(f.backupPath=g.backupPath),g.remoteAuthority&&(f.remoteAuthority=g.remoteAuthority),g.folder&&(f.folderUri=A.URI.parse(g.folder)),g.workspaceIdentifier&&(f.workspace={id:g.workspaceIdentifier.id,configPath:A.URI.parse(g.workspaceIdentifier.configURIPath)}),f}function u(g){return{lastActiveWindow:g.lastActiveWindow&&v(g.lastActiveWindow),lastPluginDevelopmentHostWindow:g.lastPluginDevelopmentHostWindow&&v(g.lastPluginDevelopmentHostWindow),openedWindows:g.openedWindows.map(f=>v(f))}}e.getWindowsStateStoreData=u;function v(g){return{workspaceIdentifier:g.workspace&&{id:g.workspace.id,configURIPath:g.workspace.configPath.toString()},folder:g.folderUri&&g.folderUri.toString(),backupPath:g.backupPath,remoteAuthority:g.remoteAuthority,uiState:g.uiState}}}),define(ee[94],te([0,1,30,43,123,33,15,9,4,20,7,5,54,28]),function(q,e,I,t,C,M,A,k,p,m,y,P,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,P.createDecorator)("workspacesService");function w(D){return D.hasOwnProperty("workspace")}e.isRecentWorkspace=w;function d(D){return D.hasOwnProperty("folderUri")}e.isRecentFolder=d;function b(D){return D.hasOwnProperty("fileUri")}e.isRecentFile=b;function u(D){return v(D)||g(D)}e.isStoredWorkspaceFolder=u;function v(D){const L=D;return typeof L?.path=="string"&&(!L.name||typeof L.name=="string")}function g(D){const L=D;return typeof L?.uri=="string"&&(!L.name||typeof L.name=="string")}function f(D,L,j,X,ae){if(D.scheme!==X.scheme)return{name:j,uri:D.toString(!0)};let Y=L?void 0:ae.relativePath(X,D);if(Y!==void 0)Y.length===0?Y=".":p.isWindows&&(Y=c(Y));else if(D.scheme===A.Schemas.file)Y=D.fsPath,p.isWindows&&(Y=c(Y));else if(ae.isEqualAuthority(D.authority,X.authority))Y=D.path;else return{name:j,uri:D.toString(!0)};return{name:j,path:Y}}e.getStoredWorkspaceFolder=f;function c(D){return D=(0,M.normalizeDriveLetter)(D),(0,I.isUNC)(D)||(D=(0,I.toSlashes)(D)),D}function n(D,L,j){const X=[],ae=new Set,Y=j.dirname(L);for(const J of D){let se;if(v(J))J.path&&(se=j.resolvePath(Y,J.path));else if(g(J))try{se=y.URI.parse(J.uri),se.path[0]!==k.posix.sep&&(se=se.with({path:k.posix.sep+se.path}))}catch(ne){console.warn(ne)}if(se){const ne=j.getComparisonKey(se);if(!ae.has(ne)){ae.add(ne);const he=J.name||j.basenameOrAuthority(se);X.push(new h.WorkspaceFolder({uri:se,name:he,index:X.length},J))}}}return X}e.toWorkspaceFolders=n;function r(D,L,j,X,ae){const Y=i(L,D),J=ae.dirname(L),se=ae.dirname(X),ne=[];for(const W of Y.folders){const F=v(W)?ae.resolvePath(J,W.path):y.URI.parse(W.uri);let N;j?N=!1:N=!v(W)||(0,k.isAbsolute)(W.path),ne.push(f(F,N,W.name,se,ae))}const he={insertSpaces:!1,tabSize:4,eol:p.isLinux||p.isMacintosh?`
`:`\r
`},K=C.setProperty(D,["folders"],ne,he);let le=C.applyEdits(D,K);return(0,m.isEqualAuthority)(Y.remoteAuthority,(0,E.getRemoteAuthority)(X))&&(le=C.applyEdits(le,C.removeProperty(le,["remoteAuthority"],he))),le}e.rewriteWorkspaceFileForNewLocation=r;function i(D,L){const j=t.parse(L);if(j&&Array.isArray(j.folders))j.folders=j.folders.filter(X=>u(X));else throw new Error(`${D} looks like an invalid workspace file.`);return j}function a(D){return D.workspace&&typeof D.workspace=="object"&&typeof D.workspace.id=="string"&&typeof D.workspace.configPath=="string"}function s(D){return typeof D.folderUri=="string"}function l(D){return typeof D.fileUri=="string"}function o(D,L){const j={workspaces:[],files:[]};if(D){const X=function(Y,J){for(let se=0;se<Y.length;se++)try{J(Y[se],se)}catch(ne){L.warn(`Error restoring recent entry ${JSON.stringify(Y[se])}: ${ne.toString()}. Skip entry.`)}},ae=D;Array.isArray(ae.entries)&&X(ae.entries,Y=>{const J=Y.label,se=Y.remoteAuthority;a(Y)?j.workspaces.push({label:J,remoteAuthority:se,workspace:{id:Y.workspace.id,configPath:y.URI.parse(Y.workspace.configPath)}}):s(Y)?j.workspaces.push({label:J,remoteAuthority:se,folderUri:y.URI.parse(Y.folderUri)}):l(Y)&&j.files.push({label:J,remoteAuthority:se,fileUri:y.URI.parse(Y.fileUri)})})}return j}e.restoreRecentlyOpened=o;function S(D){const L={entries:[]};for(const j of D.workspaces)d(j)?L.entries.push({folderUri:j.folderUri.toString(),label:j.label,remoteAuthority:j.remoteAuthority}):L.entries.push({workspace:{id:j.workspace.id,configPath:j.workspace.configPath.toString()},label:j.label,remoteAuthority:j.remoteAuthority});for(const j of D.files)L.entries.push({fileUri:j.fileUri.toString(),label:j.label,remoteAuthority:j.remoteAuthority});return L}e.toStoreData=S}),define(ee[95],te([0,1,77,15,4,20]),function(q,e,I,t,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function A(m){function y(){let P=m.scheme===t.Schemas.file?(0,M.originalFSPath)(m):m.toString();return C.isLinux||(P=P.toLowerCase()),(0,I.createHash)("md5").update(P).digest("hex")}return{id:y(),configPath:m}}e.getWorkspaceIdentifier=A;function k(m,y){function P(){if(m.scheme!==t.Schemas.file)return(0,I.createHash)("md5").update(m.toString()).digest("hex");if(!y)return;let h;return C.isLinux?h=y.ino:C.isMacintosh?h=y.birthtime.getTime():C.isWindows&&(typeof y.birthtimeMs=="number"?h=Math.floor(y.birthtimeMs):h=y.birthtime.getTime()),(0,I.createHash)("md5").update(m.fsPath).update(h?String(h):"").digest("hex")}const E=P();if(typeof E=="string")return{id:E,uri:m}}e.getSingleFolderWorkspaceIdentifier=k;function p(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=p}),define(ee[264],te([0,1,77,30,15,9,4,20,23,176,18,27,35,16,6,175,28,95]),function(q,e,I,t,C,M,A,k,p,m,y,P,E,h,w,d,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let v=class Ft{constructor(f,c,n,r){this.j=f,this.k=c,this.l=n,this.m=r,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=k.extUriBiasedIgnorePathCase,this.i={isEqual:(i,a)=>(0,t.isEqual)(i,a,!A.isLinux)}}async initialize(){const f=await this.n();this.g=await this.x(f.emptyWindows),this.d=await this.v((0,m.deserializeWorkspaceInfos)(f)),this.e=await this.w((0,m.deserializeFolderInfos)(f)),this.D()}async n(){let f=this.m.getItem(Ft.a);if(!f)try{const c=(0,M.join)(this.c,"workspaces.json"),n=await p.Promises.readFile(c,"utf8");try{await p.Promises.unlink(c)}catch{}const r=JSON.parse(n);f={workspaces:Array.isArray(r.rootURIWorkspaces)?r.rootURIWorkspaces:[],folders:Array.isArray(r.folderWorkspaceInfos)?r.folderWorkspaceInfos:[],emptyWindows:Array.isArray(r.emptyWorkspaceInfos)?r.emptyWorkspaceInfos:[]}}catch(c){c.code!=="ENOENT"&&this.l.error(`Backup: Could not migrate legacy backup workspaces metadata: ${c.toString()}`)}return f??{workspaces:[],folders:[],emptyWindows:[]}}o(){return this.s()?[]:this.d.slice(0)}q(){return this.s()?[]:this.e.slice(0)}isHotExitEnabled(){return this.t()!==h.HotExitConfiguration.OFF}s(){return this.t()===h.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}t(){return this.k.getValue()?.files?.hotExit||h.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(f,c){this.d.some(r=>f.workspace.id===r.workspace.id)||(this.d.push(f),this.D());const n=(0,M.join)(this.c,f.workspace.id);return c?this.u(n,c).then(()=>n):n}async u(f,c){if(await p.Promises.exists(f)&&await this.A(f),await p.Promises.exists(c))try{await p.Promises.rename(c,f)}catch(n){this.l.error(`Backup: Could not move backup folder to new location: ${n.toString()}`)}}registerFolderBackup(f){return this.e.some(c=>this.h.isEqual(f.folderUri,c.folderUri))||(this.e.push(f),this.D()),(0,M.join)(this.c,this.E(f))}registerEmptyWindowBackup(f){return this.g.some(c=>!!c.backupFolder&&this.i.isEqual(c.backupFolder,f.backupFolder))||(this.g.push(f),this.D()),(0,M.join)(this.c,f.backupFolder)}async v(f){if(!Array.isArray(f))return[];const c=new Set,n=[];for(const r of f){const i=r.workspace;if(!(0,b.isWorkspaceIdentifier)(i))return[];if(!c.has(i.id)){c.add(i.id);const a=(0,M.join)(this.c,i.id);await this.C(a)?i.configPath.scheme!==C.Schemas.file||await p.Promises.exists(i.configPath.fsPath)?n.push(r):await this.A(a):await this.y(a)}}return n}async w(f){if(!Array.isArray(f))return[];const c=[],n=new Set;for(const r of f){const i=r.folderUri,a=this.h.getComparisonKey(i);if(!n.has(a)){n.add(a);const s=(0,M.join)(this.c,this.E(r));await this.C(s)?i.scheme!==C.Schemas.file||await p.Promises.exists(i.fsPath)?c.push(r):await this.A(s):await this.y(s)}}return c}async x(f){if(!Array.isArray(f))return[];const c=[],n=new Set;for(const r of f){const i=r.backupFolder;if(typeof i!="string")return[];if(!n.has(i)){n.add(i);const a=(0,M.join)(this.c,i);await this.C(a)?c.push(r):await this.y(a)}}return c}async y(f){try{await p.Promises.rm(f,p.RimRafMode.MOVE)}catch(c){this.l.error(`Backup: Could not delete stale backup: ${c.toString()}`)}}z(){let f=(0,u.createEmptyWorkspaceIdentifier)();for(;this.g.some(c=>!!c.backupFolder&&this.i.isEqual(c.backupFolder,f.id));)f=(0,u.createEmptyWorkspaceIdentifier)();return{backupFolder:f.id}}async A(f){const c=this.z(),n=(0,M.join)(this.c,c.backupFolder);try{await p.Promises.rename(f,n)}catch(r){return this.l.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.g.push(c),!0}async getDirtyWorkspaces(){const f=[];for(const c of this.d)await this.B(c)&&f.push(c);for(const c of this.e)await this.B(c)&&f.push(c);return f}B(f){let c;return(0,m.isEmptyWindowBackupInfo)(f)?c=(0,M.join)(this.c,f.backupFolder):(0,d.isFolderBackupInfo)(f)?c=(0,M.join)(this.c,this.E(f)):c=(0,M.join)(this.c,f.workspace.id),this.C(c)}async C(f){try{const c=await p.Promises.readdir(f);for(const n of c)try{if((await p.Promises.readdir((0,M.join)(f,n))).length>0)return!0}catch{}}catch{}return!1}D(){const f={workspaces:this.d.map(({workspace:c,remoteAuthority:n})=>{const r={id:c.id,configURIPath:c.configPath.toString()};return n&&(r.remoteAuthority=n),r}),folders:this.e.map(({folderUri:c,remoteAuthority:n})=>{const r={folderUri:c.toString()};return n&&(r.remoteAuthority=n),r}),emptyWindows:this.g.map(({backupFolder:c,remoteAuthority:n})=>{const r={backupFolder:c};return n&&(r.remoteAuthority=n),r})};this.m.setItem(Ft.a,f)}E(f){const c=f.folderUri;let n;return c.scheme===C.Schemas.file?n=A.isLinux?c.fsPath:c.fsPath.toLowerCase():n=c.toString().toLowerCase(),(0,I.createHash)("md5").update(n).digest("hex")}};v.a="backupWorkspaces",v=pe([_(0,P.IEnvironmentMainService),_(1,y.IConfigurationService),_(2,w.ILogService),_(3,E.IStateMainService)],v),e.BackupMainService=v}),define(ee[52],te([0,1,13,3,43,33,2,15,9,20,12,23,174,62,57,27,5,6,19,51,117,28,94,95]),function(q,e,I,t,C,M,A,k,p,m,y,P,E,h,w,d,b,u,v,g,f,c,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,b.createDecorator)("workspacesManagementMainService");let i=class extends A.Disposable{constructor(s,l,o,S,D,L){super(),this.g=s,this.h=l,this.i=o,this.j=S,this.k=D,this.l=L,this.a=this.B(new t.Emitter),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new t.Emitter),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const s=(await P.Promises.readdir(this.c.fsPath)).map(l=>(0,m.joinPath)(this.c,l,c.UNTITLED_WORKSPACE_NAME));for(const l of s){const o=(0,r.getWorkspaceIdentifier)(l),S=await this.resolveLocalWorkspace(l);S?this.f.push({workspace:o,remoteAuthority:S.remoteAuthority}):await this.deleteUntitledWorkspace(o)}}catch(s){s.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${s}).`)}}resolveLocalWorkspace(s){return this.m(s,l=>P.Promises.readFile(l,"utf8"))}m(s,l){if(!!this.n(s)&&s.scheme===k.Schemas.file)try{const o=l(s.fsPath);return o instanceof Promise?o.then(S=>this.p(s,S),S=>{}):this.p(s,o)}catch{return}}n(s){return(0,c.isUntitledWorkspace)(s,this.g)||(0,c.hasWorkspaceFileExtension)(s)}p(s,l){try{const o=this.r(s,l),S=(0,r.getWorkspaceIdentifier)(s);return{id:S.id,configPath:S.configPath,folders:(0,n.toWorkspaceFolders)(o.folders,S.configPath,m.extUriBiasedIgnorePathCase),remoteAuthority:o.remoteAuthority,transient:o.transient}}catch(o){this.h.warn(o.toString())}}r(s,l){const o=(0,C.parse)(l);if(o&&Array.isArray(o.folders))o.folders=o.folders.filter(S=>(0,n.isStoredWorkspaceFolder)(S));else throw new Error(`${s.toString(!0)} looks like an invalid workspace file.`);return o}async createUntitledWorkspace(s,l){const{workspace:o,storedWorkspace:S}=this.s(s,l),D=o.configPath.fsPath;return await P.Promises.mkdir((0,p.dirname)(D),{recursive:!0}),await P.Promises.writeFile(D,JSON.stringify(S,null,"	")),this.f.push({workspace:o,remoteAuthority:l}),o}s(s=[],l){const o=(Date.now()+Math.round(Math.random()*1e3)).toString(),S=(0,m.joinPath)(this.c,o),D=(0,m.joinPath)(S,c.UNTITLED_WORKSPACE_NAME),L=[];for(const j of s)L.push((0,n.getStoredWorkspaceFolder)(j.uri,!0,j.name,S,m.extUriBiasedIgnorePathCase));return{workspace:(0,r.getWorkspaceIdentifier)(D),storedWorkspace:{folders:L,remoteAuthority:l}}}async getWorkspaceIdentifier(s){return(0,r.getWorkspaceIdentifier)(s)}isUntitledWorkspace(s){return(0,c.isUntitledWorkspace)(s.configPath,this.g)}async deleteUntitledWorkspace(s){!this.isUntitledWorkspace(s)||(await this.t(s),this.i.isEnabled()&&this.i.unsetWorkspace(s),this.a.fire(s))}async t(s){const l=(0,m.originalFSPath)(s.configPath);try{await P.Promises.rm((0,p.dirname)(l));const o=(0,p.join)(this.g.workspaceStorageHome.fsPath,s.id);await P.Promises.exists(o)&&await P.Promises.writeFile((0,p.join)(o,"obsolete"),""),this.f=this.f.filter(S=>S.workspace.id!==s.id)}catch(o){this.h.warn(`Unable to delete untitled workspace ${l} (${o}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(s,l,o){if(!s||!s.win||!s.isReady||!await this.u(s,l,o))return;const D=await this.v(s,(0,r.getWorkspaceIdentifier)(o));if(!!D)return this.b.fire({window:s,workspace:D.workspace}),D}async u(s,l,o){if(!o)return!0;if((0,c.isWorkspaceIdentifier)(s.openedWorkspace)&&m.extUriBiasedIgnorePathCase.isEqual(s.openedWorkspace.configPath,o))return!1;if((0,f.findWindowOnWorkspaceOrFolder)(l,o)){const S={title:this.l.nameLong,type:"info",buttons:[(0,M.mnemonicButtonLabel)((0,E.localize)(0,null))],message:(0,E.localize)(1,null,(0,m.basename)(o)),detail:(0,E.localize)(2,null),noLink:!0,defaultId:0};return await this.k.showMessageBox(S,(0,y.withNullAsUndefined)(I.BrowserWindow.getFocusedWindow())),!1}return!0}async v(s,l){if(!s.config)return;s.focus();let o;return s.config.extensionDevelopmentPath||(s.config.backupPath?o=await this.j.registerWorkspaceBackup({workspace:l,remoteAuthority:s.remoteAuthority},s.config.backupPath):o=this.j.registerWorkspaceBackup({workspace:l,remoteAuthority:s.remoteAuthority})),(0,c.isWorkspaceIdentifier)(s.openedWorkspace)&&this.isUntitledWorkspace(s.openedWorkspace)&&await this.deleteUntitledWorkspace(s.openedWorkspace),s.config.workspace=l,s.config.backupPath=o,{workspace:l,backupPath:o}}};i=pe([_(0,d.IEnvironmentMainService),_(1,u.ILogService),_(2,g.IUserDataProfilesMainService),_(3,h.IBackupMainService),_(4,w.IDialogMainService),_(5,v.IProductService)],i),e.WorkspacesManagementMainService=i}),define(ee[118],te([0,1,13,41,22,5,31,28,52,12,6]),function(q,e,I,t,C,M,A,k,p,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,M.createDecorator)(e.ID);let P=class{constructor(h,w,d){this.a=h,this.b=w,this.c=d}async getRemoteDiagnostics(h){const w=this.a.getWindows();return(await Promise.all(w.map(async b=>{const u=b.remoteAuthority;if(!u)return;const v=`vscode:getDiagnosticInfoResponse${b.id}`,g={includeProcesses:h.includeProcesses,folders:h.includeWorkspaceMetadata?await this.f(b):void 0};return new Promise(f=>{b.sendWhenReady("vscode:getDiagnosticInfo",C.CancellationToken.None,{replyChannel:v,args:g}),t.validatedIpcMain.once(v,(c,n)=>{n||f({hostName:u,errorMessage:`Unable to resolve connection to '${u}'.`}),f(n)}),setTimeout(()=>{f({hostName:u,errorMessage:`Connection to '${u}' could not be established`})},5e3)})}))).filter(b=>!!b)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const h=[];for(const w of I.BrowserWindow.getAllWindows()){const d=this.a.getWindowById(w.id);d?h.push(await this.d(d)):h.push(this.e(w))}return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:h,screenReader:!!I.app.accessibilitySupportEnabled,gpuFeatureStatus:I.app.getGPUFeatureStatus()}}async d(h){const w=await this.f(h),d=(0,m.assertIsDefined)(h.win);return this.e(d,w,h.remoteAuthority)}e(h,w=[],d){return{pid:h.webContents.getOSProcessId(),title:h.getTitle(),folderURIs:w,remoteAuthority:d}}async f(h){const w=[],d=h.openedWorkspace;if((0,k.isSingleFolderWorkspaceIdentifier)(d))w.push(d.uri);else if((0,k.isWorkspaceIdentifier)(d)){const b=await this.b.resolveLocalWorkspace(d.configPath);b&&b.folders.forEach(v=>{w.push(v.uri)})}return w}};P=pe([_(0,A.IWindowsMainService),_(1,p.IWorkspacesManagementMainService),_(2,y.ILogService)],P),e.DiagnosticsMainService=P}),define(ee[58],te([0,1,46,13,25,140,53,3,33,2,15,9,4,7,100,81,23,97,164,57,27,5,21,6,19,66,31,28,52,17,222,215,35]),function(q,e,I,t,C,M,A,k,p,m,y,P,E,h,w,d,b,u,v,g,f,c,n,r,i,a,s,l,o,S,D,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,c.createDecorator)("nativeHostMainService");let X=class extends m.Disposable{constructor(Y,J,se,ne,he,K,le,W,F,N){super(),this.a=Y,this.b=J,this.c=se,this.f=ne,this.g=he,this.h=K,this.i=le,this.j=W,this.k=F,this.l=N,this.onDidOpenWindow=k.Event.map(this.b.onDidOpenWindow,H=>H.id),this.onDidTriggerSystemContextMenu=k.Event.filter(k.Event.map(this.b.onDidTriggerSystemContextMenu,({window:H,x:re,y:z})=>({windowId:H.id,x:re,y:z})),({windowId:H})=>!!this.b.getWindowById(H)),this.onDidMaximizeWindow=k.Event.filter(k.Event.fromNodeEventEmitter(t.app,"browser-window-maximize",(H,re)=>re.id),H=>!!this.b.getWindowById(H)),this.onDidUnmaximizeWindow=k.Event.filter(k.Event.fromNodeEventEmitter(t.app,"browser-window-unmaximize",(H,re)=>re.id),H=>!!this.b.getWindowById(H)),this.onDidBlurWindow=k.Event.filter(k.Event.fromNodeEventEmitter(t.app,"browser-window-blur",(H,re)=>re.id),H=>!!this.b.getWindowById(H)),this.onDidFocusWindow=k.Event.any(k.Event.map(k.Event.filter(k.Event.map(this.b.onDidChangeWindowsCount,()=>this.b.getLastActiveWindow()),H=>!!H),H=>H.id),k.Event.filter(k.Event.fromNodeEventEmitter(t.app,"browser-window-focus",(H,re)=>re.id),H=>!!this.b.getWindowById(H))),this.onDidResumeOS=k.Event.fromNodeEventEmitter(t.powerMonitor,"resume"),this.onDidChangeColorScheme=this.j.onDidChangeColorScheme,this.m=this.B(new k.Emitter),this.onDidChangePassword=this.m.event,this.onDidChangeDisplay=k.Event.debounce(k.Event.any(k.Event.filter(k.Event.fromNodeEventEmitter(t.screen,"display-metrics-changed",(H,re,z)=>z),H=>!(Array.isArray(H)&&H.length===1&&H[0]==="workArea")),k.Event.fromNodeEventEmitter(t.screen,"display-added"),k.Event.fromNodeEventEmitter(t.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.b.getWindows().map(J=>({id:J.id,workspace:J.openedWorkspace??(0,l.toWorkspaceIdentifier)(J.backupPath,J.isExtensionDevelopmentHost),title:J.win?.getTitle()??"",filename:J.getRepresentedFilename(),dirty:J.isDocumentEdited()}))}async getWindowCount(Y){return this.b.getWindowCount()}async getActiveWindowId(Y){const J=t.BrowserWindow.getFocusedWindow()||this.b.getLastActiveWindow();if(J)return J.id}openWindow(Y,J,se){return Array.isArray(J)?this.n(Y,J,se):this.p(Y,J)}async n(Y,J,se=Object.create(null)){J.length>0&&await this.b.open({context:5,contextWindowId:Y,urisToOpen:J,cli:this.g.args,forceNewWindow:se.forceNewWindow,forceReuseWindow:se.forceReuseWindow,preferNewWindow:se.preferNewWindow,diffMode:se.diffMode,mergeMode:se.mergeMode,addMode:se.addMode,gotoLineMode:se.gotoLineMode,noRecentEntry:se.noRecentEntry,waitMarkerFileURI:se.waitMarkerFileURI,remoteAuthority:se.remoteAuthority||void 0})}async p(Y,J){await this.b.openEmptyWindow({context:5,contextWindowId:Y},J)}async toggleFullScreen(Y){this.w(Y)?.toggleFullScreen()}async handleTitleDoubleClick(Y){this.w(Y)?.handleTitleDoubleClick()}async isMaximized(Y){const J=this.w(Y);return J?.win?J.win.isMaximized():!1}async maximizeWindow(Y){const J=this.w(Y);J?.win&&J.win.maximize()}async unmaximizeWindow(Y){const J=this.w(Y);J?.win&&J.win.unmaximize()}async minimizeWindow(Y){const J=this.w(Y);J?.win&&J.win.minimize()}async updateWindowControls(Y,J){const se=this.w(Y);se&&se.updateWindowControls(J)}async focusWindow(Y,J){J&&typeof J.windowId=="number"&&(Y=J.windowId),this.w(Y)?.focus({force:J?.force??!1})}async setMinimumSize(Y,J,se){const ne=this.w(Y);if(ne?.win){const[he,K]=ne.win.getSize(),[le,W]=ne.win.getMinimumSize(),[F,N]=[J??le,se??W],[H,re]=[Math.max(he,F),Math.max(K,N)];(le!==F||W!==N)&&ne.win.setMinimumSize(F,N),(he!==H||K!==re)&&ne.win.setSize(H,re)}}async saveWindowSplash(Y,J){this.j.saveWindowSplash(Y,J)}async installShellCommand(Y){const{source:J,target:se}=await this.r();try{const{symbolicLink:ne}=await b.SymlinkSupport.stat(J);if(ne&&!ne.dangling){const he=await(0,w.realpath)(J);if(se===he)return}await b.Promises.unlink(J)}catch(ne){if(ne.code!=="ENOENT")throw ne}try{await b.Promises.symlink(se,J)}catch(ne){if(ne.code!=="EACCES"&&ne.code!=="ENOENT")throw ne;const{response:he}=await this.showMessageBox(Y,{title:this.i.nameLong,type:"info",message:(0,v.localize)(0,null,this.i.nameShort),buttons:[(0,p.mnemonicButtonLabel)((0,v.localize)(1,null)),(0,p.mnemonicButtonLabel)((0,v.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(he===0)try{const K=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${se}' '${J}'\\" with administrator privileges"`;await(0,M.promisify)(I.exec)(K)}catch{throw new Error((0,v.localize)(3,null,J))}}}async uninstallShellCommand(Y){const{source:J}=await this.r();try{await b.Promises.unlink(J)}catch(se){switch(se.code){case"EACCES":{const{response:ne}=await this.showMessageBox(Y,{title:this.i.nameLong,type:"info",message:(0,v.localize)(4,null,this.i.nameShort),buttons:[(0,p.mnemonicButtonLabel)((0,v.localize)(5,null)),(0,p.mnemonicButtonLabel)((0,v.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(ne===0)try{const he=`osascript -e "do shell script \\"rm '${J}'\\" with administrator privileges"`;await(0,M.promisify)(I.exec)(he)}catch{throw new Error((0,v.localize)(7,null,J))}break}case"ENOENT":break;default:throw se}}}async r(){const Y=(0,P.resolve)(this.g.appRoot,"bin","code"),J=`/usr/local/bin/${this.i.applicationName}`;if(!await b.Promises.exists(Y))throw new Error((0,v.localize)(8,null,Y));return{source:J,target:Y}}async showMessageBox(Y,J){return this.c.showMessageBox(J,this.s(Y))}async showSaveDialog(Y,J){return this.c.showSaveDialog(J,this.s(Y))}async showOpenDialog(Y,J){return this.c.showOpenDialog(J,this.s(Y))}s(Y){const J=this.w(Y);if(J?.win)return J.win}async pickFileFolderAndOpen(Y,J){const se=await this.c.pickFileFolder(J);se&&await this.t(await Promise.all(se.map(async ne=>await b.SymlinkSupport.existsDirectory(ne)?{folderUri:h.URI.file(ne)}:{fileUri:h.URI.file(ne)})),J,Y)}async pickFolderAndOpen(Y,J){const se=await this.c.pickFolder(J);se&&await this.t(se.map(ne=>({folderUri:h.URI.file(ne)})),J,Y)}async pickFileAndOpen(Y,J){const se=await this.c.pickFile(J);se&&await this.t(se.map(ne=>({fileUri:h.URI.file(ne)})),J,Y)}async pickWorkspaceAndOpen(Y,J){const se=await this.c.pickWorkspace(J);se&&await this.t(se.map(ne=>({workspaceUri:h.URI.file(ne)})),J,Y)}async t(Y,J,se){await this.b.open({context:3,contextWindowId:se,cli:this.g.args,urisToOpen:Y,forceNewWindow:J.forceNewWindow})}async showItemInFolder(Y,J){t.shell.showItemInFolder(J)}async setRepresentedFilename(Y,J){this.w(Y)?.setRepresentedFilename(J)}async setDocumentEdited(Y,J){this.w(Y)?.setDocumentEdited(J)}async openExternal(Y,J){return E.isLinuxSnap?this.u(J):t.shell.openExternal(J),!0}u(Y){const J=process.env.GDK_PIXBUF_MODULE_FILE,se=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,t.shell.openExternal(Y),process.env.GDK_PIXBUF_MODULE_FILE=J,process.env.GDK_PIXBUF_MODULEDIR=se}moveItemToTrash(Y,J){return t.shell.trashItem(J)}async isAdmin(){let Y;return E.isWindows?Y=(await new Promise((J,se)=>{q(["native-is-elevated"],J,se)}))():Y=process.getuid()===0,Y}async writeElevated(Y,J,se,ne){const he=await new Promise((K,le)=>{q(["@vscode/sudo-prompt"],K,le)});return new Promise((K,le)=>{const W=[`"${this.v}"`];ne?.unlock&&W.push("--file-chmod"),W.push("--file-write",`"${J.fsPath}"`,`"${se.fsPath}"`);const F={name:this.i.nameLong.replace("-",""),icns:E.isMacintosh&&this.g.isBuilt?(0,P.join)((0,P.dirname)(this.g.appRoot),`${this.i.nameShort}.icns`):void 0};he.exec(W.join(" "),F,(N,H,re)=>{H&&this.h.trace(`[sudo-prompt] received stdout: ${H}`),re&&this.h.trace(`[sudo-prompt] received stderr: ${re}`),N?le(N):K(void 0)})})}get v(){return E.isWindows?this.g.isBuilt?(0,P.join)((0,P.dirname)(process.execPath),"bin",`${this.i.applicationName}.cmd`):(0,P.join)(this.g.appRoot,"scripts","code-cli.bat"):E.isLinux?this.g.isBuilt?(0,P.join)((0,P.dirname)(process.execPath),"bin",`${this.i.applicationName}`):(0,P.join)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,P.join)(this.g.appRoot,"bin","code"):(0,P.join)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,C.totalmem)(),freemem:(0,C.freemem)(),loadavg:(0,C.loadavg)()}}async getOSProperties(){return{arch:(0,C.arch)(),platform:(0,C.platform)(),release:(0,C.release)(),type:(0,C.type)(),cpus:(0,C.cpus)()}}async getOSVirtualMachineHint(){return d.virtualMachineHint.value()}async getOSColorScheme(){return this.j.getColorScheme()}async hasWSLFeatureInstalled(){return E.isWindows&&(0,D.hasWSLFeatureInstalled)()}async killProcess(Y,J,se){process.kill(J,se)}async readClipboardText(Y,J){return t.clipboard.readText(J)}async writeClipboardText(Y,J,se){return t.clipboard.writeText(J,se)}async readClipboardFindText(Y){return t.clipboard.readFindText()}async writeClipboardFindText(Y,J){return t.clipboard.writeFindText(J)}async writeClipboardBuffer(Y,J,se,ne){return t.clipboard.writeBuffer(J,Buffer.from(se.buffer),ne)}async readClipboardBuffer(Y,J){return S.VSBuffer.wrap(t.clipboard.readBuffer(J))}async hasClipboard(Y,J,se){return t.clipboard.has(J,se)}async newWindowTab(){await this.b.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){t.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){t.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){t.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){t.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){t.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(Y,J){this.w(Y)?.updateTouchBar(J)}async notifyReady(Y){this.w(Y)?.setReady()}async relaunch(Y,J){return this.f.relaunch(J)}async reload(Y,J){const se=this.w(Y);if(se){if((0,l.isWorkspaceIdentifier)(se.openedWorkspace)){const ne=se.openedWorkspace.configPath;if(ne.scheme===y.Schemas.file&&(await this.l.resolveLocalWorkspace(ne))?.transient)return this.openWindow(se.id,{forceReuseWindow:!0})}return this.f.reload(se,J?.disableExtensions!==void 0?{_:[],"disable-extensions":J.disableExtensions}:void 0)}}async closeWindow(Y){this.closeWindowById(Y,Y)}async closeWindowById(Y,J){const se=this.w(J);if(se?.win)return se.win.close()}async quit(Y){const J=this.b.getLastActiveWindow();J?.isExtensionDevelopmentHost&&this.b.getWindowCount()>1&&J.win?J.win.close():this.f.quit()}async exit(Y,J){await this.f.kill(J)}async resolveProxy(Y,J){const ne=this.w(Y)?.win?.webContents?.session;if(ne)return ne.resolveProxy(J)}findFreePort(Y,J,se,ne,he=1){return(0,u.findFreePort)(J,se,ne,he)}async openDevTools(Y,J){const se=this.w(Y);se?.win&&se.win.webContents.openDevTools(J)}async toggleDevTools(Y){const J=this.w(Y);J?.win&&J.win.webContents.toggleDevTools()}async sendInputEvent(Y,J){const se=this.w(Y);se?.win&&(J.type==="mouseDown"||J.type==="mouseUp")&&se.win.webContents.sendInputEvent(J)}async enableSandbox(Y,J){J?this.k.setItem("window.experimental.useSandbox",!0):this.k.removeItem("window.experimental.useSandbox")}async toggleSharedProcessWindow(){return this.a.toggle()}async profileRenderer(Y,J,se){const ne=this.w(Y);if(!ne||!ne.win)throw new Error;return await new L.WindowProfiler(ne.win,J,this.h).inspect(se)}async windowsGetStringRegKey(Y,J,se,ne){if(!E.isWindows)return;const he=await new Promise((K,le)=>{q(["@vscode/windows-registry"],K,le)});try{return he.GetStringRegKey(J,se,ne)}catch{return}}w(Y){if(typeof Y=="number")return this.b.getWindowById(Y)}};pe([A.memoize],X.prototype,"v",null),X=pe([_(1,s.IWindowsMainService),_(2,g.IDialogMainService),_(3,n.ILifecycleMainService),_(4,f.IEnvironmentMainService),_(5,r.ILogService),_(6,i.IProductService),_(7,a.IThemeMainService),_(8,j.IStateMainService),_(9,o.IWorkspacesManagementMainService)],X),e.NativeHostMainService=X}),define(ee[265],te([0,1,13,41,25,33,2,15,4,101,162,84,118,57,27,5,6,58,63,19,64,74,30,12]),function(q,e,I,t,C,M,A,k,p,m,y,P,E,h,w,d,b,u,v,g,f,c,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,d.createDecorator)("issueMainService");let i=class jt{constructor(s,l,o,S,D,L,j,X,ae){this.g=s,this.h=l,this.i=o,this.j=S,this.k=D,this.l=L,this.m=j,this.n=X,this.o=ae,this.b=null,this.c=null,this.d=null,this.f=null,this.p()}p(){t.validatedIpcMain.on("vscode:issueSystemInfoRequest",async s=>{const[l,o]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),S=await this.j.getSystemInfo(l,o);this.q(s,"vscode:issueSystemInfoResponse",S)}),t.validatedIpcMain.on("vscode:listProcesses",async s=>{const l=[];try{l.push({name:(0,y.localize)(0,null),rootProcess:await(0,m.listProcesses)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(S=>{(0,P.isRemoteDiagnosticError)(S)?l.push({name:S.hostName,rootProcess:S}):S.processes&&l.push({name:S.hostName,rootProcess:S.processes})})}catch(o){this.i.error(`Listing processes failed: ${o}`)}this.q(s,"vscode:listProcessesResponse",l)}),t.validatedIpcMain.on("vscode:issueReporterClipboard",async s=>{const l={title:this.o.nameLong,message:(0,y.localize)(1,null),type:"warning",buttons:[(0,M.mnemonicButtonLabel)((0,y.localize)(2,null)),(0,M.mnemonicButtonLabel)((0,y.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.b){const o=await this.l.showMessageBox(l,this.b);this.q(s,"vscode:issueReporterClipboardResponse",o.response===0)}}),t.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async s=>{const l=await this.u();this.q(s,"vscode:issuePerformanceInfoResponse",l)}),t.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{const s={title:this.o.nameLong,message:(0,y.localize)(4,null),type:"warning",buttons:[(0,M.mnemonicButtonLabel)((0,y.localize)(5,null)),(0,M.mnemonicButtonLabel)((0,y.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.b&&(await this.l.showMessageBox(s,this.b)).response===0&&this.b&&(this.b.destroy(),this.b=null)}),t.validatedIpcMain.on("vscode:workbenchCommand",(s,l)=>{const{id:o,from:S,args:D}=l;let L;switch(S){case"issueReporter":L=this.c;break;case"processExplorer":L=this.f;break;default:throw new Error(`Unexpected command source: ${S}`)}L?.webContents.send("vscode:runAction",{id:o,from:S,args:D})}),t.validatedIpcMain.on("vscode:openExternal",(s,l)=>{this.m.openExternal(void 0,l)}),t.validatedIpcMain.on("vscode:closeIssueReporter",s=>{this.b?.close()}),t.validatedIpcMain.on("vscode:closeProcessExplorer",s=>{this.d?.close()}),t.validatedIpcMain.on("vscode:windowsInfoRequest",async s=>{const l=await this.k.getMainDiagnostics();this.q(s,"vscode:windowsInfoResponse",l.windows)})}q(s,l,...o){s.sender.isDestroyed()||s.sender.send(l,...o)}async openReporter(s){if(!this.b&&(this.c=I.BrowserWindow.getFocusedWindow(),this.c)){const l=new A.DisposableStore,o=l.add(this.n.createIPCObjectUrl()),S=this.t(this.c,700,800);this.b=this.s(S,o,{backgroundColor:s.styles.backgroundColor,title:(0,y.localize)(7,null),zoomLevel:s.zoomLevel,alwaysOnTop:!1},"issue-reporter"),o.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:s,disableExtensions:!!this.h.disableExtensions,os:{type:(0,C.type)(),arch:(0,C.arch)(),release:(0,C.release)()},product:v.default}),this.b.loadURL(k.FileAccess.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,l.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,l.dispose())})}this.b&&this.r(this.b)}async openProcessExplorer(s){if(!this.d&&(this.f=I.BrowserWindow.getFocusedWindow(),this.f)){const l=new A.DisposableStore,o=l.add(this.n.createIPCObjectUrl()),S=this.t(this.f,800,500);this.d=this.s(S,o,{backgroundColor:s.styles.backgroundColor,title:(0,y.localize)(8,null),zoomLevel:s.zoomLevel,alwaysOnTop:!0},"process-explorer"),o.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:s,product:v.default}),this.d.loadURL(k.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,l.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,l.dispose())})}this.d&&this.r(this.d)}r(s){s.isMinimized()&&s.restore(),s.focus()}s(s,l,o,S){const D=new I.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:s.width,height:s.height,minWidth:300,minHeight:200,x:s.x,y:s.y,title:o.title,backgroundColor:o.backgroundColor||jt.a,webPreferences:{preload:k.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${l.resource.toString()}`,`--vscode-window-kind=${S}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,c.zoomLevelToZoomFactor)(o.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:o.alwaysOnTop,experimentalDarkMode:!0});return D.setMenuBarVisibility(!1),D}async getSystemStatus(){const[s,l]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(s,l)}t(s,l,o){let S;const D=I.screen.getAllDisplays();if(D.length===1)S=D[0];else{if(p.isMacintosh){const X=I.screen.getCursorScreenPoint();S=I.screen.getDisplayNearestPoint(X)}!S&&s&&(S=I.screen.getDisplayMatching(s.getBounds())),S||(S=I.screen.getPrimaryDisplay()||D[0])}const L={width:l,height:o},j=S.bounds;return L.x=j.x+j.width/2-L.width/2,L.y=j.y+j.height/2-L.height/2,j.width>0&&j.height>0&&(L.x<j.x&&(L.x=j.x),L.y<j.y&&(L.y=j.y),L.x>j.x+j.width&&(L.x=j.x),L.y>j.y+j.height&&(L.y=j.y),L.width>j.width&&(L.width=j.width),L.height>j.height&&(L.height=j.height)),L}async u(){try{const[s,l]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(s,l)}catch(s){throw this.i.warn("issueService#getPerformanceInfo ",s.message),s}}async stopTracing(){if(!this.h.args.trace)return;const s=await I.contentTracing.stopRecording(`${(0,n.randomPath)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({title:this.o.nameLong,type:"info",message:(0,y.localize)(9,null),detail:(0,y.localize)(10,null,s),buttons:[(0,M.mnemonicButtonLabel)((0,y.localize)(11,null))],defaultId:0,noLink:!0},(0,r.withNullAsUndefined)(I.BrowserWindow.getFocusedWindow())),this.m.showItemInFolder(void 0,s)}};i.a="#1E1E1E",i=pe([_(1,w.IEnvironmentMainService),_(2,b.ILogService),_(3,P.IDiagnosticsService),_(4,E.IDiagnosticsMainService),_(5,h.IDialogMainService),_(6,u.INativeHostMainService),_(7,f.IProtocolMainService),_(8,g.IProductService)],i),e.IssueMainService=i}),define(ee[266],te([0,1,22,18,27,21,6,58,19,55,36,49,90]),function(q,e,I,t,C,M,A,k,p,m,y,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let h=class extends E.AbstractUpdateService{constructor(d,b,u,v,g,f,c,n){super(d,b,v,g,f,n),this.e=u,this.u=c}s(d){return(0,E.createUpdateURL)(`linux-${process.arch}`,d,this.k)}t(d){!this.a||(this.d(P.State.CheckingForUpdates(d)),this.i.request({url:this.a},I.CancellationToken.None).then(m.asJson).then(b=>{!b||!b.url||!b.version||!b.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!d}),this.d(P.State.Idle(1))):this.d(P.State.AvailableForDownload(b))}).then(void 0,b=>{this.j.error(b),this.e.publicLog2("update:notAvailable",{explicit:!!d});const u=d?b.message||b:void 0;this.d(P.State.Idle(1,u))}))}async o(d){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):d.update.url&&this.u.openExternal(void 0,d.update.url),this.d(P.State.Idle(1))}};h=pe([_(0,M.ILifecycleMainService),_(1,t.IConfigurationService),_(2,y.ITelemetryService),_(3,C.IEnvironmentMainService),_(4,m.IRequestService),_(5,A.ILogService),_(6,k.INativeHostMainService),_(7,p.IProductService)],h),e.LinuxUpdateService=h}),define(ee[267],te([0,1,46,40,25,8,22,53,9,7,126,23,18,27,16,21,6,58,19,55,36,49,90]),function(q,e,I,t,C,M,A,k,p,m,y,P,E,h,w,d,b,u,v,g,f,c,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function r(l,o=1e3){for(;!l();)await(0,M.timeout)(o)}let i;function a(){return typeof i>"u"&&(i=t.existsSync(p.join(p.dirname(process.execPath),"unins000.exe"))?0:1),i}let s=class extends n.AbstractUpdateService{get cachePath(){const o=p.join((0,C.tmpdir)(),`vscode-update-${this.k.target}-${process.arch}`);return P.Promises.mkdir(o,{recursive:!0}).then(()=>o)}constructor(o,S,D,L,j,X,ae,Y,J){super(o,S,L,j,X,J),this.u=D,this.v=ae,this.w=Y}async initialize(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}super.initialize()}s(o){let S="win32";return process.arch!=="ia32"&&(S+=`-${process.arch}`),a()===1?S+="-archive":this.k.target==="user"&&(S+="-user"),(0,n.createUpdateURL)(S,o,this.k)}t(o){!this.a||(this.d(c.State.CheckingForUpdates(o)),this.i.request({url:this.a},A.CancellationToken.None).then(g.asJson).then(S=>{const D=a();return!S||!S.url||!S.version||!S.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!o}),this.d(c.State.Idle(D)),Promise.resolve(null)):D===1?(this.d(c.State.AvailableForDownload(S)),Promise.resolve(null)):(this.d(c.State.Downloading(S)),this.B(S.version).then(()=>this.A(S.version).then(L=>P.Promises.exists(L).then(j=>{if(j)return Promise.resolve(L);const X=S.url,ae=S.hash,Y=`${L}.tmp`;return this.i.request({url:X},A.CancellationToken.None).then(J=>this.v.writeFile(m.URI.file(Y),J.stream)).then(ae?()=>(0,y.checksum)(Y,S.hash):()=>{}).then(()=>P.Promises.rename(Y,L)).then(()=>L)})).then(L=>{const j=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:L},j&&S.supportsFastUpdate?this.k.target==="user"?this.p():this.d(c.State.Downloaded(S)):this.d(c.State.Ready(S))})))}).then(void 0,S=>{this.j.error(S),this.u.publicLog2("update:notAvailable",{explicit:!!o});const D=o?S.message||S:void 0;this.d(c.State.Idle(a(),D))}))}async o(o){o.update.url&&this.w.openExternal(void 0,o.update.url),this.d(c.State.Idle(a()))}async A(o){const S=await this.cachePath;return p.join(S,`CodeSetup-${this.k.quality}-${o}.exe`)}async B(o=null){const S=o?X=>!new RegExp(`${this.k.quality}-${o}\\.exe$`).test(X):()=>!0,D=await this.cachePath,j=(await P.Promises.readdir(D)).filter(S).map(async X=>{try{await P.Promises.unlink(p.join(D,X))}catch{}});await Promise.all(j)}async p(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const o=this.state.update;this.d(c.State.Updating(o));const S=await this.cachePath;this.e.updateFilePath=p.join(S,`CodeSetup-${this.k.quality}-${o.version}.flag`),await P.Promises.writeFile(this.e.updateFilePath,"flag"),(0,I.spawn)(this.e.packagePath,["/verysilent",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(c.State.Idle(a()))});const L=`${this.k.win32MutexName}-ready`,j=await new Promise((X,ae)=>{q(["windows-mutex"],X,ae)});r(()=>j.isActive(L)).then(()=>this.d(c.State.Ready(o)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.e.updateFilePath?t.unlinkSync(this.e.updateFilePath):(0,I.spawn)(this.e.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return a()}async _applySpecificUpdate(o){if(this.state.type!=="idle")return;const S=this.g.getValue("update.enableWindowsBackgroundUpdates"),D={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!S};this.d(c.State.Downloading(D)),this.e={packagePath:o},S?this.k.target==="user"?this.p():this.d(c.State.Downloaded(D)):this.d(c.State.Ready(D))}};pe([k.memoize],s.prototype,"cachePath",null),s=pe([_(0,d.ILifecycleMainService),_(1,E.IConfigurationService),_(2,f.ITelemetryService),_(3,h.IEnvironmentMainService),_(4,g.IRequestService),_(5,b.ILogService),_(6,w.IFileService),_(7,u.INativeHostMainService),_(8,v.IProductService)],s),e.Win32UpdateService=s}),define(ee[268],te([0,1,13,8,22,45,3,33,2,15,9,73,4,7,170,62,18,57,27,61,16,21,6,19,64,233,93,36,237,66,74,31,28,52,115,120,37,35,51,58,235,112,56,89,25]),function(q,e,I,t,C,M,A,k,p,m,y,P,E,h,w,d,b,u,v,g,f,c,n,r,i,a,s,l,o,S,D,L,j,X,ae,Y,J,se,ne,he,K,le,W,F,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var H;(function(z){z[z.NONE=0]="NONE",z[z.NAVIGATING=1]="NAVIGATING",z[z.READY=2]="READY"})(H||(H={}));let re=class dt extends p.Disposable{get id(){return this.k}get win(){return this.l}get lastFocusTime(){return this.m}get backupPath(){return this.n?.backupPath}get openedWorkspace(){return this.n?.workspace}get profile(){return this.config?this.O.profiles.find(T=>T.id===this.config?.profiles.profile.id)??this.O.getOrSetProfileForWorkspace(this.config.workspace??"empty-window",this.O.defaultProfile):void 0}get remoteAuthority(){return this.n?.remoteAuthority}get config(){return this.n}get isExtensionDevelopmentHost(){return!!this.n?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.n?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.n?.debugId}constructor(T,R,O,U,B,V,ie,$,Z,x,oe,ge,De,Oe,Ce,Re,be,we,ve,Me){super(),this.L=R,this.M=O,this.N=U,this.O=B,this.P=V,this.Q=ie,this.R=$,this.S=Z,this.U=x,this.W=oe,this.X=ge,this.Y=De,this.Z=Oe,this.ab=Ce,this.bb=Re,this.db=be,this.eb=we,this.fb=ve,this.gb=Me,this.c=this.B(new A.Emitter),this.onWillLoad=this.c.event,this.f=this.B(new A.Emitter),this.onDidSignalReady=this.f.event,this.g=this.B(new A.Emitter),this.onDidTriggerSystemContextMenu=this.g.event,this.h=this.B(new A.Emitter),this.onDidClose=this.h.event,this.j=this.B(new A.Emitter),this.onDidDestroy=this.j.event,this.m=-1,this.t=void 0,this.u=void 0,this.z=!1,this.C=[],this.D=[],this.F=void 0,this.G=void 0,this.H=this.B(this.db.createIPCObjectUrl()),this.J=!1,this.hb=0;{const[Q,fe]=this.sb(T.state);this.r=Q,this.L.trace("window#ctor: using window state",Q);const de=this.r.mode===0||this.r.mode===3;typeof dt.b>"u"&&(dt.b=this.fb.getItem("window.experimental.useSandbox",!1));const ye=this.S.getValue("window");let Ie=!1;typeof ye?.experimental?.useSandbox=="boolean"?Ie=ye.experimental.useSandbox:this.bb.quality==="stable"&&dt.b?Ie=!0:Ie=typeof this.bb.quality=="string"&&this.bb.quality!=="stable";const Te={width:this.r.width,height:this.r.height,x:this.r.x,y:this.r.y,backgroundColor:this.U.getBackgroundColor(),minWidth:D.WindowMinimumSize.WIDTH,minHeight:D.WindowMinimumSize.HEIGHT,show:!de,title:this.bb.nameLong,webPreferences:{preload:m.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.H.resource.toString()}`],v8CacheOptions:this.M.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,D.zoomLevelToZoomFactor)(ye?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...Ie?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};E.isLinux?Te.icon=(0,y.join)(this.M.appRoot,"resources/linux/code.png"):E.isWindows&&!this.M.isBuilt&&(Te.icon=(0,y.join)(this.M.appRoot,"resources/win32/code_150x150.png")),E.isMacintosh&&!this.zb()&&(Te.fullscreenable=!1),E.isMacintosh&&(Te.acceptFirstMouse=!0,ye?.clickThroughInactive===!1&&(Te.acceptFirstMouse=!1));const Fe=E.isMacintosh&&ye?.nativeTabs===!0;Fe&&(Te.tabbingIdentifier=this.bb.nameShort);const qe=(0,D.getTitleBarStyle)(this.S)==="custom";if(qe&&(Te.titleBarStyle="hidden",E.isMacintosh||(Te.frame=!1),(0,D.useWindowControlsOverlay)(this.S))){const Ue=this.U.getWindowSplash()?.colorInfo.titleBarBackground??this.U.getBackgroundColor(),$e=Y.Color.fromHex(Ue).isDarker()?"#FFFFFF":"#000000";Te.titleBarOverlay={height:29,color:Ue,symbolColor:$e},this.z=!0}if((0,P.mark)("code/willCreateCodeBrowserWindow"),this.l=new I.BrowserWindow(Te),(0,P.mark)("code/didCreateCodeBrowserWindow"),this.k=this.l.id,E.isMacintosh&&qe&&this.l.setSheetOffset(22),qe&&(E.isWindows&&(0,D.useWindowControlsOverlay)(this.S)||E.isMacintosh)){const Ue=this.fb.getItem(dt.a);Ue&&this.updateWindowControls({height:Ue})}E.isWindows&&qe&&this.l.hookWindowMessage(278,()=>{const[$e,Je]=this.l.getPosition(),je=I.screen.getCursorScreenPoint(),Ke=je.x-$e,G=je.y-Je;return(()=>!(Ke>30&&G>=0&&G<=Math.max(this.l.getBounds().height*.15,35)))()||(this.l.setEnabled(!1),this.l.setEnabled(!0),this.g.fire({x:Ke,y:G})),0}),(E.isMacintosh||E.isWindows)&&fe&&(!Fe||I.BrowserWindow.getAllWindows().length===1)&&[this.r.width,this.r.height,this.r.x,this.r.y].every(Ue=>typeof Ue=="number")&&this.l.setBounds({width:this.r.width,height:this.r.height,x:this.r.x,y:this.r.y}),de&&((0,P.mark)("code/willMaximizeCodeWindow"),this.l.maximize(),this.r.mode===3&&this.vb(!0),this.l.show(),(0,P.mark)("code/didMaximizeCodeWindow")),this.m=Date.now()}this.M.args["open-devtools"]===!0&&this.l.webContents.openDevTools(),this.pb(),this.Db(),this.ib()}setRepresentedFilename(T){E.isMacintosh?this.l.setRepresentedFilename(T):this.v=T}getRepresentedFilename(){return E.isMacintosh?this.l.getRepresentedFilename():this.v}setDocumentEdited(T){E.isMacintosh&&this.l.setDocumentEdited(T),this.w=T}isDocumentEdited(){return E.isMacintosh?this.l.isDocumentEdited():!!this.w}focus(T){E.isMacintosh&&T?.force&&I.app.focus({steal:!0}),this.l&&(this.l.isMinimized()&&this.l.restore(),this.l.focus())}setReady(){for(this.L.trace(`window#load: window reported ready (id: ${this.k})`),this.hb=2;this.C.length;)this.C.pop()(this);this.f.fire()}ready(){return new Promise(T=>{if(this.isReady)return T(this);this.C.push(T)})}get isReady(){return this.hb===2}get whenClosedOrLoaded(){return new Promise(T=>{function R(){O.dispose(),U.dispose(),T()}const O=this.onDidClose(()=>R()),U=this.onWillLoad(()=>R())})}ib(){this.l.on("unresponsive",()=>this.lb(1)),this.l.webContents.on("render-process-gone",(R,O)=>this.lb(2,O)),this.l.webContents.on("did-fail-load",(R,O,U)=>this.lb(3,{reason:U,exitCode:O})),this.l.webContents.on("will-prevent-unload",R=>{R.preventDefault()}),this.l.on("closed",()=>{this.h.fire(),this.dispose()}),this.l.webContents.on("did-finish-load",()=>{this.I&&(this.n=this.I,this.I=void 0)}),this.l.on("focus",()=>{this.m=Date.now()}),this.l.on("maximize",R=>{this.n&&(this.n.maximized=!0),I.app.emit("browser-window-maximize",R,this.l)}),this.l.on("unmaximize",R=>{this.n&&(this.n.maximized=!1),I.app.emit("browser-window-unmaximize",R,this.l)}),this.l.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",C.CancellationToken.None),this.u?.complete(),this.u=void 0}),this.l.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",C.CancellationToken.None),this.u?.complete(),this.u=void 0}),this.B(this.S.onDidChangeConfiguration(R=>this.pb(R))),this.B(this.W.onDidDeleteUntitledWorkspace(R=>this.ob(R)));const T=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.l.webContents.session.webRequest.onBeforeSendHeaders({urls:T},async(R,O)=>{const U=await this.kb();O({cancel:!1,requestHeaders:Object.assign(R.requestHeaders,U)})})}kb(){return this.jb||(this.jb=(0,a.resolveMarketplaceHeaders)(this.bb.version,this.bb,this.M,this.S,this.P,this.Q,this.Y)),this.jb}async lb(T,R){switch(T){case 2:this.L.error(`CodeWindow: renderer process gone (reason: ${R?.reason||"<unknown>"}, code: ${R?.exitCode||"<unknown>"})`);break;case 1:this.L.error("CodeWindow: detected unresponsive");break;case 3:this.L.error(`CodeWindow: failed to load (reason: ${R?.reason||"<unknown>"}, code: ${R?.exitCode||"<unknown>"})`);break}switch(this.Y.publicLog2("windowerror",{type:T,reason:R?.reason,code:R?.exitCode}),T){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.ab.kill(1);return}if(this.M.args["enable-smoke-test-driver"]){await this.nb(!1,!1),this.ab.quit();return}if(T===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.l&&this.l.webContents&&this.l.webContents.isDevToolsOpened())return;const O=await this.Z.showMessageBox({title:this.bb.nameLong,type:"warning",buttons:[(0,k.mnemonicButtonLabel)((0,w.localize)(0,null)),(0,k.mnemonicButtonLabel)((0,w.localize)(1,null)),(0,k.mnemonicButtonLabel)((0,w.localize)(2,null))],message:(0,w.localize)(3,null),detail:(0,w.localize)(4,null),noLink:!0,defaultId:0,cancelId:1,checkboxLabel:this.n?.workspace?(0,w.localize)(5,null):void 0},this.l);if(O.response!==1){const U=O.response===0;await this.nb(U,O.checkboxChecked)}}else if(T===2)if(E.isWindows&&R?.reason==="launch-failed"&&R.exitCode===18&&await this.gb.isAdmin(void 0))await this.mb(R);else{let O;R?O=(0,w.localize)(7,null,R.reason,R.exitCode??"<unknown>"):O=(0,w.localize)(6,null);const U=await this.Z.showMessageBox({title:this.bb.nameLong,type:"warning",buttons:[(0,k.mnemonicButtonLabel)((0,w.localize)(8,null)),(0,k.mnemonicButtonLabel)((0,w.localize)(9,null))],message:O,detail:(0,w.localize)(10,null),noLink:!0,defaultId:0,checkboxLabel:this.n?.workspace?(0,w.localize)(11,null):void 0},this.l),B=U.response===0;await this.nb(B,U.checkboxChecked)}break}}async mb(T){const R=[],O=(0,W.isInternalTelemetry)(this.bb,this.S);if((0,W.supportsTelemetry)(this.bb,this.M)){this.bb.aiConfig&&this.bb.aiConfig.ariaKey&&R.push(new K.OneDataSystemAppender(O,"monacoworkbench",null,this.bb.aiConfig.ariaKey));const{installSourcePath:U}=this.M,B={appenders:R,sendErrorTelemetry:!1,commonProperties:(0,F.resolveCommonProperties)(this.P,(0,N.release)(),(0,N.hostname)(),process.arch,this.bb.commit,this.bb.version,this.fb.getItem(l.machineIdKey),O,U),piiPaths:(0,W.getPiiPathsFromEnvironment)(this.M)};await new le.TelemetryService(B,this.S,this.bb).publicLog2("windowadminerror",{reason:T.reason,code:T.exitCode})}await this.Z.showMessageBox({title:this.bb.nameLong,type:"error",buttons:[(0,k.mnemonicButtonLabel)((0,w.localize)(12,null))],message:(0,w.localize)(13,null),detail:(0,w.localize)(14,null,this.bb.nameLong),noLink:!0,defaultId:0},this.l),await Promise.all(R.map(U=>U.flush())),await this.nb(!1,!1)}async nb(T,R){const O=this.n?.workspace;if(R&&O)try{const U=this.R.workspaceStorage(O);await U.init(),U.delete("memento/workbench.parts.editor"),await U.close()}catch(U){this.L.error(U)}if(this.j.fire(),this.l?.destroy(),T&&this.n){let U,B;(0,j.isSingleFolderWorkspaceIdentifier)(O)?U={folderUri:O.uri}:(0,j.isWorkspaceIdentifier)(O)?U={workspaceUri:O.configPath}:B=!0;const[V]=await this.eb.open({context:5,userEnv:this.n.userEnv,cli:{...this.M.args,_:[]},urisToOpen:U?[U]:void 0,forceEmpty:B,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});V.focus()}}ob(T){this.n?.workspace?.id===T.id&&(this.n.workspace=void 0)}pb(T){const R=this.Ab();R!==this.s&&(this.s=R,this.Bb(R));let O=(this.S.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;O?.endsWith("/")&&(O=O.substr(0,O.length-1));const U=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((O||"").indexOf("@")===-1&&(O!==this.F||U!==this.G)){this.F=O,this.G=U;const B=O||"",V=U?`${U},<local>`:"<local>";this.L.trace(`Setting proxy to '${B}', bypassing '${V}'`),this.l.webContents.session.setProxy({proxyRules:B,proxyBypassRules:V,pacScript:""})}}addTabbedWindow(T){E.isMacintosh&&T.win&&this.l.addTabbedWindow(T.win)}load(T,R=Object.create(null)){this.L.trace(`window#load: attempt to load window (id: ${this.k})`),this.isDocumentEdited()&&(!R.isReload||!this.X.isHotExitEnabled())&&this.setDocumentEdited(!1),R.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.l.setTitle(this.bb.nameLong)),this.qb(T,R),this.hb===0?this.n=T:this.I=T,this.hb=1,this.l.loadURL(m.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.M.isBuilt?"":"-dev"}.html`).toString(!0));const O=this.J;this.J=!0,!this.M.isBuilt&&!this.M.extensionTestsLocationURI&&this.B(new t.RunOnceScheduler(()=>{this.l&&!this.l.isVisible()&&!this.l.isMinimized()&&(this.l.show(),this.focus({force:!0}),this.l.webContents.openDevTools())},1e4)).schedule(),this.c.fire({workspace:T.workspace,reason:R.isReload?3:O?2:1})}qb(T,R){const O=(this.n??this.I)?.userEnv;if(O){const U=(0,g.isLaunchedFromCli)(O)&&!(0,g.isLaunchedFromCli)(T.userEnv),B=this.isExtensionDevelopmentHost;(U||B)&&(T.userEnv={...O,...T.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(T.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),R.disableExtensions!==void 0&&(T["disable-extensions"]=R.disableExtensions),T.fullscreen=this.isFullScreen,T.maximized=this.l.isMaximized(),T.partsSplash=this.U.getWindowSplash(),(0,P.mark)("code/willOpenNewWindow"),T.perfMarks=(0,P.getMarks)(),this.H.update(T)}async reload(T){const R=Object.assign({},this.n);R.workspace=await this.rb(R),delete R.filesToOpenOrCreate,delete R.filesToDiff,delete R.filesToMerge,delete R.filesToWait,this.isExtensionDevelopmentHost&&T&&(R.verbose=T.verbose,R.debugId=T.debugId,R.extensionEnvironment=T.extensionEnvironment,R["inspect-extensions"]=T["inspect-extensions"],R["inspect-brk-extensions"]=T["inspect-brk-extensions"],R["extensions-dir"]=T["extensions-dir"]),R.isInitialStartup=!1,R.policiesData=this.N.serialize(),R.continueOn=this.M.continueOn,R.profiles={all:this.O.profiles,profile:this.profile||this.O.defaultProfile},R.logLevel=this.L.getLevel(),this.load(R,{isReload:!0,disableExtensions:T?.["disable-extensions"]})}async rb(T){if((0,j.isWorkspaceIdentifier)(T.workspace)){const R=T.workspace.configPath;if(R.scheme===m.Schemas.file&&!await this.P.exists(R))return}else if((0,j.isSingleFolderWorkspaceIdentifier)(T.workspace)){const R=T.workspace.uri;if(R.scheme===m.Schemas.file&&!await this.P.exists(R))return}return T.workspace}serializeWindowState(){if(!this.l)return(0,ae.defaultWindowState)();if(this.isFullScreen){let O;try{O=I.screen.getDisplayMatching(this.getBounds())}catch{}const U=(0,ae.defaultWindowState)();return{mode:3,display:O?O.id:void 0,width:this.r.width||U.width,height:this.r.height||U.height,x:this.r.x||0,y:this.r.y||0}}const T=Object.create(null);let R;if(!E.isMacintosh&&this.l.isMaximized()?R=0:R=1,R===0?T.mode=0:T.mode=1,R===1||R===0){let O;R===1?O=this.getBounds():O=this.l.getNormalBounds(),T.x=O.x,T.y=O.y,T.width=O.width,T.height=O.height}return T}updateWindowControls(T){if(T.height&&this.fb.setItem(dt.a,T.height),E.isWindows&&this.z)this.l.setTitleBarOverlay({color:T.backgroundColor?.trim()===""?void 0:T.backgroundColor,symbolColor:T.foregroundColor?.trim()===""?void 0:T.foregroundColor,height:T.height?T.height-1:void 0});else if(E.isMacintosh&&T.height!==void 0){const R=(T.height-15)/2;this.l.setTrafficLightPosition({x:R,y:R})}}sb(T){(0,P.mark)("code/willRestoreCodeWindowState");let R=!1;if(T)try{const O=I.screen.getAllDisplays();R=O.length>1,T=this.tb(T,O)}catch(O){this.L.warn(`Unexpected error validating window state: ${O}
${O.stack}`)}return(0,P.mark)("code/didRestoreCodeWindowState"),[T||(0,ae.defaultWindowState)(),R]}tb(T,R){if(this.L.trace(`window#validateWindowState: validating window state on ${R.length} display(s)`,T),typeof T.x!="number"||typeof T.y!="number"||typeof T.width!="number"||typeof T.height!="number"){this.L.trace("window#validateWindowState: unexpected type of state values");return}if(T.width<=0||T.height<=0){this.L.trace("window#validateWindowState: unexpected negative values");return}if(R.length===1){const B=this.ub(R[0]);if(B){let V=function(){!T||typeof T.x!="number"||typeof T.y!="number"||!B||(T.x<B.x&&(T.x=B.x),T.y<B.y&&(T.y=B.y))};this.L.trace("window#validateWindowState: 1 monitor working area",B),V(),T.width>B.width&&(T.width=B.width),T.height>B.height&&(T.height=B.height),T.x>B.x+B.width-128&&(T.x=B.x+B.width-T.width),T.y>B.y+B.height-128&&(T.y=B.y+B.height-T.height),V()}return T}if(T.display&&T.mode===3){const B=R.find(V=>V.id===T.display);if(B&&typeof B.bounds?.x=="number"&&typeof B.bounds?.y=="number"){this.L.trace("window#validateWindowState: restoring fullscreen to previous display");const V=(0,ae.defaultWindowState)(3);return V.x=B.bounds.x,V.y=B.bounds.y,V}}let O,U;try{O=I.screen.getDisplayMatching({x:T.x,y:T.y,width:T.width,height:T.height}),U=this.ub(O)}catch{}if(O&&U&&T.x+T.width>U.x&&T.y+T.height>U.y&&T.x<U.x+U.width&&T.y<U.y+U.height)return this.L.trace("window#validateWindowState: multi-monitor working area",U),T}ub(T){if(T.workArea.width>0&&T.workArea.height>0)return T.workArea;if(T.bounds.width>0&&T.bounds.height>0)return T.bounds}getBounds(){const[T,R]=this.l.getPosition(),[O,U]=this.l.getSize();return{x:T,y:R,width:O,height:U}}toggleFullScreen(){this.vb(!this.isFullScreen)}vb(T){this.zb()?this.wb(T):this.yb(T),this.sendWhenReady(T?"vscode:enterFullScreen":"vscode:leaveFullScreen",C.CancellationToken.None),this.s&&this.Bb(this.s,!1)}get isFullScreen(){return E.isMacintosh&&typeof this.t=="boolean"?this.t:this.l.isFullScreen()||this.l.isSimpleFullScreen()}wb(T){this.l.isSimpleFullScreen()&&this.l.setSimpleFullScreen(!1),this.xb(T)}xb(T){E.isMacintosh&&(this.t=T,this.u=new t.DeferredPromise,Promise.race([this.u.p,(0,t.timeout)(1e3)]).finally(()=>this.t=void 0)),this.l.setFullScreen(T)}yb(T){this.l.isFullScreen()&&this.xb(!1),this.l.setSimpleFullScreen(T),this.l.webContents.focus()}zb(){const T=this.S.getValue("window");return!T||typeof T.nativeFullScreen!="boolean"||T.nativeTabs?!0:T.nativeFullScreen!==!1}isMinimized(){return this.l.isMinimized()}Ab(){let T=(0,D.getMenuBarVisibility)(this.S);return["visible","toggle","hidden"].indexOf(T)<0&&(T="classic"),T}Bb(T,R=!0){E.isMacintosh||(T==="toggle"&&R&&this.send("vscode:showInfoMessage",(0,w.localize)(15,null)),T==="hidden"?setTimeout(()=>{this.Cb(T)}):this.Cb(T))}Cb(T){const R=this.isFullScreen;switch(T){case"classic":this.l.setMenuBarVisibility(!R),this.l.autoHideMenuBar=R;break;case"visible":this.l.setMenuBarVisibility(!0),this.l.autoHideMenuBar=!1;break;case"toggle":this.l.setMenuBarVisibility(!1),this.l.autoHideMenuBar=!0;break;case"hidden":this.l.setMenuBarVisibility(!1),this.l.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(E.isMacintosh)switch(I.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this.l.minimize();break;case"None":break;case"Maximize":default:this.l.isMaximized()?this.l.unmaximize():this.l.maximize()}else this.l.isMaximized()?this.l.unmaximize():this.l.maximize()}close(){this.l?.close()}sendWhenReady(T,R,...O){this.isReady?this.send(T,...O):this.ready().then(()=>{R.isCancellationRequested||this.send(T,...O)})}send(T,...R){if(this.l){if(this.l.isDestroyed()||this.l.webContents.isDestroyed()){this.L.warn(`Sending IPC message to channel '${T}' for window that is destroyed`);return}try{this.l.webContents.send(T,...R)}catch(O){this.L.warn(`Error sending IPC message to channel '${T}' of window ${this.k}: ${(0,M.toErrorMessage)(O)}`)}}}updateTouchBar(T){!E.isMacintosh||this.D.forEach((R,O)=>{const U=T[O];R.segments=this.Fb(U)})}Db(){if(!!E.isMacintosh){for(let T=0;T<10;T++){const R=this.Eb();this.D.push(R)}this.l.setTouchBar(new I.TouchBar({items:this.D}))}}Eb(T=[]){const R=this.Fb(T),O=new I.TouchBar.TouchBarSegmentedControl({segments:R,mode:"buttons",segmentStyle:"automatic",change:U=>{this.sendWhenReady("vscode:runAction",C.CancellationToken.None,{id:O.segments[U].id,from:"touchbar"})}});return O}Fb(T=[]){return T.map(O=>{let U;O.icon&&!o.ThemeIcon.isThemeIcon(O.icon)&&O.icon?.dark?.scheme===m.Schemas.file&&(U=I.nativeImage.createFromPath(h.URI.revive(O.icon.dark).fsPath),U.isEmpty()&&(U=void 0));let B;return typeof O.title=="string"?B=O.title:B=O.title.value,{id:O.id,label:U?void 0:B,icon:U}})}dispose(){super.dispose(),this.l=null}};re.a="windowControlHeight",re.b=void 0,re=pe([_(1,n.ILogService),_(2,v.IEnvironmentMainService),_(3,J.IPolicyService),_(4,ne.IUserDataProfilesMainService),_(5,f.IFileService),_(6,s.IApplicationStorageMainService),_(7,s.IStorageMainService),_(8,b.IConfigurationService),_(9,S.IThemeMainService),_(10,X.IWorkspacesManagementMainService),_(11,d.IBackupMainService),_(12,l.ITelemetryService),_(13,u.IDialogMainService),_(14,c.ILifecycleMainService),_(15,r.IProductService),_(16,i.IProtocolMainService),_(17,L.IWindowsMainService),_(18,se.IStateMainService),_(19,he.INativeHostMainService)],re),e.CodeWindow=re}),define(ee[75],te([0,1,13,24,8,3,33,2,15,4,20,7,23,173,5,21,6,93,94,28,52,39]),function(q,e,I,t,C,M,A,k,p,m,y,P,E,h,w,d,b,u,v,g,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,w.createDecorator)("workspacesHistoryMainService");let n=class rt extends k.Disposable{constructor(i,a,s,l){super(),this.f=i,this.g=a,this.h=s,this.j=l,this.c=this.B(new M.Emitter),this.onDidChangeRecentlyOpened=this.c.event,this.z=this.B(new C.ThrottledDelayer(800)),this.k()}k(){this.h.when(4).then(()=>this.C()),this.B(this.g.onDidEnterWorkspace(i=>this.addRecentlyOpened([{workspace:i.workspace,remoteAuthority:i.window.remoteAuthority}])))}async addRecentlyOpened(i){let a=[],s=[];for(const o of i)if((0,v.isRecentWorkspace)(o))!this.g.isUntitledWorkspace(o.workspace)&&!this.r(a,o.workspace)&&a.push(o);else if((0,v.isRecentFolder)(o))this.s(a,o.folderUri)||a.push(o);else{const S=this.t(s,o.fileUri),D=o.fileUri.scheme===p.Schemas.file&&rt.y.indexOf((0,y.basename)(o.fileUri))>=0;!S&&!D&&(s.push(o),m.isWindows&&o.fileUri.scheme===p.Schemas.file&&I.app.addRecentDocument(o.fileUri.fsPath))}const l=await this.l({workspaces:a,files:s});a=l.workspaces,s=l.files,a.length>rt.a&&(a.length=rt.a),s.length>rt.a&&(s.length=rt.a),await this.n({workspaces:a,files:s}),this.c.fire(),m.isMacintosh&&this.z.trigger(()=>this.H())}async removeRecentlyOpened(i){const a=S=>{const D=this.p(S);for(const L of i)if(y.extUriBiasedIgnorePathCase.isEqual(L,D))return!1;return!0},s=await this.getRecentlyOpened(),l=s.workspaces.filter(a),o=s.files.filter(a);(l.length!==s.workspaces.length||o.length!==s.files.length)&&(await this.n({files:o,workspaces:l}),this.c.fire(),m.isMacintosh&&this.z.trigger(()=>this.H()))}async clearRecentlyOpened(){await this.n({workspaces:[],files:[]}),I.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.l()}async l(i){const a=new c.ResourceMap(o=>y.extUriBiasedIgnorePathCase.getComparisonKey(o));if(i?.workspaces)for(const o of i.workspaces)a.set(this.p(o),o);const s=new c.ResourceMap(o=>y.extUriBiasedIgnorePathCase.getComparisonKey(o));if(i?.files)for(const o of i.files)s.set(this.p(o),o);const l=await this.m();for(const o of l.workspaces){const S=a.get(this.p(o));S?S.label=S.label??o.label:a.set(this.p(o),o)}for(const o of l.files){const S=s.get(this.p(o));S?S.label=S.label??o.label:s.set(this.p(o),o)}return{workspaces:[...a.values()],files:[...s.values()]}}async m(){await this.j.whenReady;let i;const a=this.j.get(rt.b,-1);if(typeof a=="string")try{i=JSON.parse(a)}catch(s){this.f.error("Unexpected error parsing opened paths list",s)}return(0,v.restoreRecentlyOpened)(i,this.f)}async n(i){await this.j.whenReady,this.j.store(rt.b,JSON.stringify((0,v.toStoreData)(i)),-1,1)}p(i){return(0,v.isRecentFolder)(i)?i.folderUri:(0,v.isRecentFile)(i)?i.fileUri:i.workspace.configPath}r(i,a){return!!i.find(s=>(0,v.isRecentWorkspace)(s)&&s.workspace.id===a.id)}s(i,a){return!!i.find(s=>(0,v.isRecentFolder)(s)&&y.extUriBiasedIgnorePathCase.isEqual(s.folderUri,a))}t(i,a){return!!i.find(s=>y.extUriBiasedIgnorePathCase.isEqual(s.fileUri,a))}async C(){!m.isWindows||(await this.D(),this.B(this.onDidChangeRecentlyOpened(()=>this.D())))}async D(){if(!m.isWindows)return;const i=[];if(i.push({type:"tasks",items:[{type:"task",title:(0,h.localize)(0,null),description:(0,h.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const a=[];for(const o of I.app.getJumpListSettings().removedItems){const S=o.args;if(S){const D=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(S);D&&a.push(P.URI.parse(D[2]))}}await this.removeRecentlyOpened(a);let s=!1;const l=(0,t.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,rt.w).map(o=>{const S=(0,v.isRecentWorkspace)(o)?o.workspace:o.folderUri,{title:D,description:L}=this.F(S,o.label);let j;return P.URI.isUri(S)?j=`--folder-uri "${S.toString()}"`:(s=!0,j=`--file-uri "${S.configPath.toString()}"`),{type:"task",title:D.substr(0,255),description:L.substr(0,255),program:process.execPath,args:j,iconPath:"explorer.exe",iconIndex:0}}));l.length>0&&i.push({type:"custom",name:s?(0,h.localize)(2,null):(0,h.localize)(3,null),items:l})}i.push({type:"recent"});try{const a=I.app.setJumpList(i);a&&a!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${a}`)}catch(a){this.f.warn("updateWindowsJumpList#setJumpList",a)}}F(i,a){if(a)return{title:(0,A.splitName)(a).name,description:a};if(P.URI.isUri(i))return{title:(0,y.basename)(i),description:this.G(i)};if(this.g.isUntitledWorkspace(i))return{title:(0,h.localize)(4,null),description:""};let s=(0,y.basename)(i.configPath);return s.endsWith(g.WORKSPACE_EXTENSION)&&(s=s.substr(0,s.length-g.WORKSPACE_EXTENSION.length-1)),{title:(0,h.localize)(5,null,s),description:this.G(i.configPath)}}G(i){return i.scheme==="file"?(0,A.normalizeDriveLetter)(i.fsPath):i.toString()}async H(){if(!m.isMacintosh)return;I.app.clearRecentDocuments();const i=await this.getRecentlyOpened(),a=[];let s=0;for(let o=0;o<i.workspaces.length&&s<rt.u;o++){const S=this.p(i.workspaces[o]);if(S.scheme===p.Schemas.file){const D=(0,y.originalFSPath)(S);await E.Promises.exists(D)&&(a.push(D),s++)}}const l=[];for(let o=0;o<i.files.length&&s<rt.v;o++){const S=this.p(i.files[o]);if(S.scheme===p.Schemas.file){const D=(0,y.originalFSPath)(S);if(rt.y.includes((0,y.basename)(S))||a.includes(D))continue;await E.Promises.exists(D)&&(l.push(D),s++)}}l.reverse().forEach(o=>I.app.addRecentDocument(o)),a.reverse().forEach(o=>I.app.addRecentDocument(o))}};n.a=500,n.b="history.recentlyOpenedPathsList",n.u=7,n.v=10,n.w=7,n.y=["COMMIT_EDITMSG","MERGE_MSG"],n=pe([_(0,b.ILogService),_(1,f.IWorkspacesManagementMainService),_(2,d.ILifecycleMainService),_(3,u.IApplicationStorageMainService)],n),e.WorkspacesHistoryMainService=n}),define(ee[269],te([0,1,13,8,22,33,4,7,163,18,27,21,6,211,58,19,35,36,49,74,31,75]),function(q,e,I,t,C,M,A,k,p,m,y,P,E,h,w,d,b,u,v,g,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const n="menu";let r=class Wt{constructor(s,l,o,S,D,L,j,X,ae,Y,J){this.n=s,this.o=l,this.p=o,this.q=S,this.r=D,this.s=L,this.t=j,this.u=X,this.v=ae,this.w=Y,this.x=J,this.m=Object.create(null),this.g=new t.RunOnceScheduler(()=>this.E(),0),this.h=new t.RunOnceScheduler(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(A.isMacintosh||(0,g.getTitleBarStyle)(this.o)==="native")&&this.y(),this.z(),this.d=!1,this.f=!1,this.j=[],this.H(),this.A()}y(){const s=this.t.getItem(Wt.a);s&&(s.menus&&(this.k=s.menus),s.keybindings&&(this.l=s.keybindings))}z(){this.m["workbench.action.files.newUntitledFile"]=(L,j,X)=>this.p.openEmptyWindow({context:2,contextWindowId:j?.id}),this.m["workbench.action.newWindow"]=(L,j,X)=>this.p.openEmptyWindow({context:2,contextWindowId:j?.id}),this.m["workbench.action.files.openFileFolder"]=(L,j,X)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.P(X),telemetryExtraData:{from:n}}),this.m["workbench.action.files.openFolder"]=(L,j,X)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.P(X),telemetryExtraData:{from:n}}),this.m["workbench.action.openWorkspace"]=(L,j,X)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.P(X),telemetryExtraData:{from:n}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened();const s=this.x.twitterUrl;s&&(this.m["workbench.action.openTwitterUrl"]=()=>this.Z(s,"openTwitterUrl"));const l=this.x.requestFeatureUrl;l&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.Z(l,"openUserVoiceUrl"));const o=this.x.reportIssueUrl;o&&(this.m["workbench.action.openIssueReporter"]=()=>this.Z(o,"openReportIssues"));const S=this.x.licenseUrl;S&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(A.language){const L=S.indexOf("?")>0?"&":"?";this.Z(`${S}${L}lang=${A.language}`,"openLicenseUrl")}else this.Z(S,"openLicenseUrl")});const D=this.x.privacyStatementUrl;D&&S&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.Z(D,"openPrivacyStatement")})}A(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(s=>this.F(s)),this.w.onDidBlurWindow(()=>this.G()),this.w.onDidFocusWindow(()=>this.G())}get B(){const s=this.o.getValue("window.enableMenuBarMnemonics");return typeof s!="boolean"?!0:s}get C(){if(!A.isMacintosh)return!1;const s=this.o.getValue("window.nativeTabs");return typeof s!="boolean"?!1:s}updateMenu(s,l){this.k=s.menus,this.l=s.keybindings,this.t.setItem(Wt.a,s),this.D()}D(){this.g.schedule()}E(){this.b||setTimeout(()=>{this.b||this.H()},10)}F(s){!A.isMacintosh||(s.oldCount===0&&s.newCount>0||s.oldCount>0&&s.newCount===0)&&(this.d=s.newCount===0,this.D())}G(){!A.isMacintosh||(this.f=!I.BrowserWindow.getFocusedWindow(),this.D())}H(){const s=I.Menu.getApplicationMenu();if(s&&this.j.push(s),Object.keys(this.k).length===0){I.Menu.setApplicationMenu(A.isMacintosh?new I.Menu:null);return}const l=new I.Menu;let o;if(A.isMacintosh){const D=new I.Menu;o=new I.MenuItem({label:this.x.nameShort,submenu:D}),this.I(D),l.append(o)}if(A.isMacintosh&&!this.c){this.c=!0;const D=new I.Menu;D.append(new I.MenuItem({label:this.bb(p.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),I.app.dock.setMenu(D)}if(this.K("File")){const D=new I.Menu,L=new I.MenuItem({label:this.bb(p.localize(1,null)),submenu:D});this.M(D,"File"),l.append(L)}if(this.K("Edit")){const D=new I.Menu,L=new I.MenuItem({label:this.bb(p.localize(2,null)),submenu:D});this.M(D,"Edit"),l.append(L)}if(this.K("Selection")){const D=new I.Menu,L=new I.MenuItem({label:this.bb(p.localize(3,null)),submenu:D});this.M(D,"Selection"),l.append(L)}if(this.K("View")){const D=new I.Menu,L=new I.MenuItem({label:this.bb(p.localize(4,null)),submenu:D});this.M(D,"View"),l.append(L)}if(this.K("Go")){const D=new I.Menu,L=new I.MenuItem({label:this.bb(p.localize(5,null)),submenu:D});this.M(D,"Go"),l.append(L)}if(this.K("Run")){const D=new I.Menu,L=new I.MenuItem({label:this.bb(p.localize(6,null)),submenu:D});this.M(D,"Run"),l.append(L)}if(this.K("Terminal")){const D=new I.Menu,L=new I.MenuItem({label:this.bb(p.localize(7,null)),submenu:D});this.M(D,"Terminal"),l.append(L)}let S;if(this.K("Window")){const D=new I.Menu;S=new I.MenuItem({label:this.bb(p.localize(8,null)),submenu:D,role:"window"}),this.S(D)}if(S&&l.append(S),this.K("Help")){const D=new I.Menu,L=new I.MenuItem({label:this.bb(p.localize(9,null)),submenu:D,role:"help"});this.M(D,"Help"),l.append(L)}l.items&&l.items.length>0?I.Menu.setApplicationMenu(l):I.Menu.setApplicationMenu(null),this.h.schedule()}I(s){const l=this.U(p.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),o=this.T();let S;if(this.K("Preferences")){const se=new I.Menu;this.M(se,"Preferences"),S=new I.MenuItem({label:this.bb(p.localize(11,null)),submenu:se})}const D=new I.Menu,L=new I.MenuItem({label:p.localize(12,null),role:"services",submenu:D}),j=new I.MenuItem({label:p.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),X=new I.MenuItem({label:p.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),ae=new I.MenuItem({label:p.localize(15,null),role:"unhide"}),Y=new I.MenuItem(this.Y("workbench.action.quit",{label:p.localize(16,null,this.x.nameLong),click:async(se,ne,he)=>{const K=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||!!I.BrowserWindow.getFocusedWindow()||K?.isMinimized())&&await this.J(he)&&this.w.quit(void 0)}})),J=[l];J.push(...o),S&&J.push(i(),S),J.push(i(),L,i(),j,X,ae,i(),Y),J.forEach(se=>s.append(se))}async J(s){if(this.p.getWindowCount()===0)return!0;const l=this.o.getValue("window.confirmBeforeClose");if(l==="always"||l==="keyboardOnly"&&this.Q(s)){const o={title:this.x.nameLong,type:"question",buttons:[(0,M.mnemonicButtonLabel)(p.localize(17,null)),(0,M.mnemonicButtonLabel)(p.localize(18,null))],message:p.localize(19,null),noLink:!0,defaultId:0,cancelId:1},{response:S}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,o);return S===0}return!0}K(s){if(!A.isMacintosh&&(0,g.getTitleBarStyle)(this.o)==="custom")return!1;switch(s){case"File":case"Help":if(A.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[s];case"Window":if(A.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[s]}}L(s,l){l.forEach(o=>{if((0,h.isMenubarMenuItemSeparator)(o))s.append(i());else if((0,h.isMenubarMenuItemSubmenu)(o)){const S=new I.Menu,D=new I.MenuItem({label:this.bb(o.label),submenu:S});this.L(S,o.submenu.items),s.append(D)}else(0,h.isMenubarMenuItemRecentAction)(o)?s.append(this.O(o)):(0,h.isMenubarMenuItemAction)(o)&&(o.id==="workbench.action.showAboutDialog"&&this.N(s),A.isMacintosh?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[o.id]?s.append(new I.MenuItem(this.Y(o.id,{label:this.bb(o.label),click:this.m[o.id]}))):s.append(this.U(o.label,o.id,!1,o.checked)):s.append(this.U(o.label,o.id,o.enabled!==!1,!!o.checked)):s.append(this.U(o.label,o.id,o.enabled!==!1,!!o.checked)))})}M(s,l){this.k&&this.k[l]&&this.L(s,this.k[l].items)}N(s){const l=this.T();l.length&&(l.forEach(o=>s.append(o)),s.append(i()))}O(s){const l=k.URI.revive(s.uri),o=s.id,S=o==="openRecentFile"?{fileUri:l}:o==="openRecentWorkspace"?{workspaceUri:l}:{folderUri:l};return new I.MenuItem(this.Y(o,{label:s.label,click:async(D,L,j)=>{const X=this.P(j);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[S],forceNewWindow:X,gotoLineMode:!1,remoteAuthority:s.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([l])}},!1))}P(s){return!!(s&&(!A.isMacintosh&&(s.ctrlKey||s.shiftKey)||A.isMacintosh&&(s.metaKey||s.altKey)))}Q(s){return!!(s.triggeredByAccelerator||s.altKey||s.ctrlKey||s.metaKey||s.shiftKey)}R(s,l,o){const S={label:this.bb(s),role:o,enabled:!0};return new I.MenuItem(this.X(l,S))}S(s){const l=new I.MenuItem({label:p.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),o=new I.MenuItem({label:p.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),S=new I.MenuItem({label:p.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),D=this.U(p.localize(23,null),"workbench.action.switchWindow"),L=[];this.C&&(L.push(i()),L.push(this.U(p.localize(24,null),"workbench.action.newWindowTab")),L.push(this.R(p.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),L.push(this.R(p.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),L.push(this.R(p.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),L.push(this.R(p.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[l,o,i(),D,...L,i(),S].forEach(j=>s.append(j))}T(){switch(this.n.state.type){case"uninitialized":return[];case"idle":return[new I.MenuItem({label:this.bb(p.localize(29,null)),click:()=>setTimeout(()=>{this.ab("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new I.MenuItem({label:p.localize(30,null),enabled:!1})];case"available for download":return[new I.MenuItem({label:this.bb(p.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new I.MenuItem({label:p.localize(32,null),enabled:!1})];case"downloaded":return[new I.MenuItem({label:this.bb(p.localize(33,null)),click:()=>{this.ab("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new I.MenuItem({label:p.localize(34,null),enabled:!1})];case"ready":return[new I.MenuItem({label:this.bb(p.localize(35,null)),click:()=>{this.ab("RestartToUpdate"),this.n.quitAndInstall()}})]}}U(s,l,o,S){const D=this.bb(s),L=typeof l=="function"?l:(J,se,ne)=>{const he=J?J.userSettingsLabel:null;let K=l;Array.isArray(l)&&(K=this.P(ne)?l[1]:l[0]),he&&ne.triggeredByAccelerator?this.W({type:"keybinding",userSettingsLabel:he}):this.W({type:"commandId",commandId:K})},j=typeof o=="boolean"?o:this.p.getWindowCount()>0,X=typeof S=="boolean"?S:!1,ae={label:D,click:L,enabled:j};X&&(ae.type="checkbox",ae.checked=X);let Y;return typeof l=="string"?Y=l:Array.isArray(l)&&(Y=l[0]),A.isMacintosh&&(Y==="editor.action.clipboardCutAction"?ae.role="cut":Y==="editor.action.clipboardCopyAction"?ae.role="copy":Y==="editor.action.clipboardPasteAction"&&(ae.role="paste"),Y==="undo"?ae.click=this.V(L,{inDevTools:J=>J.undo(),inNoWindow:()=>I.Menu.sendActionToFirstResponder("undo:")}):Y==="redo"?ae.click=this.V(L,{inDevTools:J=>J.redo(),inNoWindow:()=>I.Menu.sendActionToFirstResponder("redo:")}):Y==="editor.action.selectAll"&&(ae.click=this.V(L,{inDevTools:J=>J.selectAll(),inNoWindow:()=>I.Menu.sendActionToFirstResponder("selectAll:")}))),new I.MenuItem(this.X(Y,ae))}V(s,l){return(o,S,D)=>{const L=I.BrowserWindow.getFocusedWindow();if(!L)return l.inNoWindow();if(L.webContents.isDevToolsFocused()&&L.webContents.devToolsWebContents)return l.inDevTools(L.webContents.devToolsWebContents);s(o,S||L,D)}}W(s){let l=I.BrowserWindow.getFocusedWindow();if(!l){const S=this.p.getLastActiveWindow();S?.isMinimized()&&(l=S.win)}const o=l?this.p.getWindowById(l.id):void 0;if(o){if(this.v.trace("menubar#runActionInRenderer",s),A.isMacintosh&&!this.q.isBuilt&&!o.isReady&&(s.type==="commandId"&&s.commandId==="workbench.action.toggleDevTools"||s.type!=="commandId"&&s.userSettingsLabel==="alt+cmd+i"))return;if(s.type==="commandId"){const S={id:s.commandId,from:"menu"};o.sendWhenReady("vscode:runAction",C.CancellationToken.None,S)}else{const S={userSettingsLabel:s.userSettingsLabel};o.sendWhenReady("vscode:runKeybinding",C.CancellationToken.None,S)}}else this.v.trace("menubar#runActionInRenderer: no active window found",s)}X(s,l){const o=typeof s=="string"?this.l[s]:void 0;if(o?.label){if(o.isNative!==!1)l.accelerator=o.label,l.userSettingsLabel=o.userSettingsLabel;else if(typeof l.label=="string"){const S=l.label.indexOf("[");S>=0?l.label=`${l.label.substr(0,S)} [${o.label}]`:l.label=`${l.label} [${o.label}]`}}else l.accelerator=void 0;return l}Y(s,l,o=!l.accelerator){o&&(l=this.X(s,l));const S=l.click;return l.click=(D,L,j)=>{this.ab(s),S?.(D,L,j)},l}Z(s,l){this.w.openExternal(void 0,s),this.ab(l)}ab(s){this.r.publicLog2("workbenchActionExecuted",{id:s,from:n})}bb(s){return(0,M.mnemonicMenuLabel)(s,!this.B)}};r.a="lastKnownMenubarData",r=pe([_(0,v.IUpdateService),_(1,m.IConfigurationService),_(2,f.IWindowsMainService),_(3,y.IEnvironmentMainService),_(4,u.ITelemetryService),_(5,c.IWorkspacesHistoryMainService),_(6,b.IStateMainService),_(7,P.ILifecycleMainService),_(8,E.ILogService),_(9,w.INativeHostMainService),_(10,d.IProductService)],r),e.Menubar=r;function i(){return new I.MenuItem({type:"separator"})}}),define(ee[270],te([0,1,5,21,6,269]),function(q,e,I,t,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,I.createDecorator)("menubarMainService");let A=class{constructor(p,m,y){this.b=p,this.c=m,this.d=y,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(M.Menubar)}async updateMenubar(p,m){this.d.trace("menubarService#updateMenubar",p),(await this.a).updateMenu(m,p)}};A=pe([_(0,I.IInstantiationService),_(1,t.ILifecycleMainService),_(2,C.ILogService)],A),e.MenubarMainService=A}),define(ee[271],te([0,1,13,23,25,24,22,3,30,50,33,2,15,9,73,4,32,20,12,7,171,62,18,57,27,16,5,21,6,63,19,64,54,35,74,268,117,263,28,95,75,52,66,37,51]),function(q,e,I,t,C,M,A,k,p,m,y,P,E,h,w,d,b,u,v,g,f,c,n,r,i,a,s,l,o,S,D,L,j,X,ae,Y,J,se,ne,he,K,le,W,F,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function H(T){return(0,ne.isWorkspaceIdentifier)(T?.workspace)}function re(T){return(0,ne.isSingleFolderWorkspaceIdentifier)(T?.workspace)}let z=class gt extends P.Disposable{constructor(R,O,U,B,V,ie,$,Z,x,oe,ge,De,Oe,Ce,Re,be,we,ve){super(),this.k=R,this.l=O,this.m=U,this.n=B,this.r=V,this.s=ie,this.t=$,this.u=Z,this.v=x,this.w=oe,this.z=ge,this.C=De,this.D=Oe,this.F=Ce,this.G=Re,this.H=be,this.I=we,this.J=ve,this.b=this.B(new k.Emitter),this.onDidOpenWindow=this.b.event,this.c=this.B(new k.Emitter),this.onDidSignalReadyWindow=this.c.event,this.f=this.B(new k.Emitter),this.onDidDestroyWindow=this.f.event,this.g=this.B(new k.Emitter),this.onDidChangeWindowsCount=this.g.event,this.h=this.B(new k.Emitter),this.onDidTriggerSystemContextMenu=this.h.event,this.j=this.B(new se.WindowsStateHandler(this,this.n,this.u,this.m,this.w)),this.L()}L(){this.B(this.C.onDidEnterWorkspace(R=>this.c.fire(R.window))),this.B(this.onDidSignalReadyWindow(R=>{if(R.config?.extensionDevelopmentPath||R.config?.extensionTestsPath){const O=new P.DisposableStore;if(O.add(k.Event.any(R.onDidClose,R.onDidDestroy)(()=>O.dispose())),R.config.extensionDevelopmentPath)for(const U of R.config.extensionDevelopmentPath)O.add(this.I.addValidFileRoot(U));R.config.extensionTestsPath&&O.add(this.I.addValidFileRoot(R.config.extensionTestsPath))}}))}openEmptyWindow(R,O){const U=this.s.args,B=O?.remoteAuthority||void 0,V=!0,ie=O?.forceReuseWindow,$=!ie;return this.open({...R,cli:U,forceEmpty:V,forceNewWindow:$,forceReuseWindow:ie,remoteAuthority:B})}openExistingWindow(R,O){R.focus(),this.M(O,[R])}async open(R){this.m.trace("windowsManager#open"),R.addMode&&(R.initialStartup||!this.getLastActiveWindow())&&(R.addMode=!1);const O=[],U=[],B=[],V=[],ie=[];let $,Z=0;const x=await this.S(R);this.m.trace("windowsManager#open pathsToOpen",x);for(const Ce of x)re(Ce)?R.addMode?O.push(Ce):U.push(Ce):H(Ce)?B.push(Ce):Ce.fileUri?($||($={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Ce.remoteAuthority}),$.filesToOpenOrCreate.push(Ce)):Ce.backupPath?ie.push({backupFolder:(0,h.basename)(Ce.backupPath),remoteAuthority:Ce.remoteAuthority}):Z++;R.diffMode&&$&&$.filesToOpenOrCreate.length>=2&&($.filesToDiff=$.filesToOpenOrCreate.slice(0,2),$.filesToOpenOrCreate=[]),R.mergeMode&&$&&$.filesToOpenOrCreate.length===4&&($.filesToMerge=$.filesToOpenOrCreate.slice(0,4),$.filesToOpenOrCreate=[],$.filesToDiff=[]),$&&R.waitMarkerFileURI&&($.filesToWait={paths:(0,M.coalesce)([...$.filesToDiff,$.filesToMerge[3],...$.filesToOpenOrCreate]),waitMarkerFileUri:R.waitMarkerFileURI}),R.initialStartup?(V.push(...this.C.getUntitledWorkspaces()),B.push(...V),ie.push(...this.v.getEmptyWindowBackups())):ie.length=0;const{windows:oe,filesOpenedInWindow:ge}=await this.N(R,B,U,ie,Z,$,O);if(this.m.trace(`windowsManager#open used window count ${oe.length} (workspacesToOpen: ${B.length}, foldersToOpen: ${U.length}, emptyToRestore: ${ie.length}, emptyToOpen: ${Z})`),oe.length>1)if(ge)ge.focus();else{const Ce=this.j.state.lastActiveWindow&&!R.forceEmpty&&!R.cli._.length&&!R.cli["file-uri"]&&!R.cli["folder-uri"]&&!(R.urisToOpen&&R.urisToOpen.length);let Re=!0,be=!0;if(Ce){const we=oe.filter(ve=>this.j.state.lastActiveWindow&&ve.backupPath===this.j.state.lastActiveWindow.backupPath);we.length&&(we[0].focus(),Re=!1,be=!1)}if(Re)for(let we=oe.length-1;we>=0;we--){const ve=oe[we];if(!(ve.openedWorkspace&&V.some(Me=>ve.openedWorkspace&&Me.workspace.id===ve.openedWorkspace.id)||ve.backupPath&&ie.some(Me=>ve.backupPath&&Me.backupFolder===(0,h.basename)(ve.backupPath)))){ve.focus(),be=!1;break}}be&&oe[oe.length-1].focus()}const De=$&&$.filesToDiff.length>0,Oe=$&&$.filesToMerge.length>0;if(!oe.some(Ce=>Ce.isExtensionDevelopmentHost)&&!De&&!Oe&&!R.noRecentEntry){const Ce=[];for(const Re of x)H(Re)&&!Re.transient?Ce.push({label:Re.label,workspace:Re.workspace,remoteAuthority:Re.remoteAuthority}):re(Re)?Ce.push({label:Re.label,folderUri:Re.workspace.uri,remoteAuthority:Re.remoteAuthority}):Re.fileUri&&Ce.push({label:Re.label,fileUri:Re.fileUri,remoteAuthority:Re.remoteAuthority});this.z.addRecentlyOpened(Ce)}return this.M(R,oe),oe}M(R,O){const U=R.waitMarkerFileURI;R.context===0&&U&&O.length===1&&O[0]&&(async()=>{await O[0].whenClosedOrLoaded;try{await this.G.del(U)}catch{}})()}async N(R,O,U,B,V,ie,$){const Z=[];let x;function oe(we,ve){Z.push(we),ve&&(x=we,ie=void 0)}let{openFolderInNewWindow:ge,openFilesInNewWindow:De}=this.fb(R);if(!R.initialStartup&&$.length>0){const we=$[0].remoteAuthority,ve=this.kb(we);ve&&oe(this.P(ve,$.map(Me=>Me.workspace.uri)))}const Oe=U.length+O.length+B.length;if(ie&&Oe===0){const we=ie.filesToOpenOrCreate[0]||ie.filesToDiff[0]||ie.filesToMerge[3],ve=this.getWindows().filter(Q=>ie&&(0,u.isEqualAuthority)(Q.remoteAuthority,ie.remoteAuthority));let Me;we?.fileUri&&!De&&((R.context===4||R.context===0||R.context===1)&&(Me=await(0,J.findWindowOnFile)(ve,we.fileUri,async Q=>Q.configPath.scheme===E.Schemas.file?this.C.resolveLocalWorkspace(Q.configPath):void 0)),Me||(Me=this.lb(ve))),Me?(0,ne.isWorkspaceIdentifier)(Me.openedWorkspace)?O.push({workspace:Me.openedWorkspace,remoteAuthority:Me.remoteAuthority}):(0,ne.isSingleFolderWorkspaceIdentifier)(Me.openedWorkspace)?U.push({workspace:Me.openedWorkspace,remoteAuthority:Me.remoteAuthority}):oe(this.O(R,Me,ie),!0):oe(await this.gb({userEnv:R.userEnv,cli:R.cli,initialStartup:R.initialStartup,filesToOpen:ie,forceNewWindow:!0,remoteAuthority:ie.remoteAuthority,forceNewTabbedWindow:R.forceNewTabbedWindow,forceProfile:R.forceProfile,forceTempProfile:R.forceTempProfile}),!0)}const Ce=(0,M.distinct)(O,we=>we.workspace.id);if(Ce.length>0){const we=(0,M.coalesce)(Ce.map(ve=>(0,J.findWindowOnWorkspaceOrFolder)(this.getWindows(),ve.workspace.configPath)));if(we.length>0){const ve=we[0],Me=(0,u.isEqualAuthority)(ie?.remoteAuthority,ve.remoteAuthority)?ie:void 0;oe(this.O(R,ve,Me),!!Me),ge=!0}for(const ve of Ce){if(we.some(fe=>fe.openedWorkspace&&fe.openedWorkspace.id===ve.workspace.id))continue;const Me=ve.remoteAuthority,Q=(0,u.isEqualAuthority)(ie?.remoteAuthority,Me)?ie:void 0;oe(await this.R(R,ve,ge,Q),!!Q),ge=!0}}const Re=(0,M.distinct)(U,we=>u.extUriBiasedIgnorePathCase.getComparisonKey(we.workspace.uri));if(Re.length>0){const we=(0,M.coalesce)(Re.map(ve=>(0,J.findWindowOnWorkspaceOrFolder)(this.getWindows(),ve.workspace.uri)));if(we.length>0){const ve=we[0],Me=(0,u.isEqualAuthority)(ie?.remoteAuthority,ve.remoteAuthority)?ie:void 0;oe(this.O(R,ve,Me),!!Me),ge=!0}for(const ve of Re){if(we.some(fe=>(0,ne.isSingleFolderWorkspaceIdentifier)(fe.openedWorkspace)&&u.extUriBiasedIgnorePathCase.isEqual(fe.openedWorkspace.uri,ve.workspace.uri)))continue;const Me=ve.remoteAuthority,Q=(0,u.isEqualAuthority)(ie?.remoteAuthority,Me)?ie:void 0;oe(await this.R(R,ve,ge,Q),!!Q),ge=!0}}const be=(0,M.distinct)(B,we=>we.backupFolder);if(be.length>0)for(const we of be){const ve=we.remoteAuthority,Me=(0,u.isEqualAuthority)(ie?.remoteAuthority,ve)?ie:void 0;oe(await this.Q(R,!0,ve,Me,we),!!Me),ge=!0}if(Z.length===0||ie){ie&&!V&&V++;const we=ie?ie.remoteAuthority:R.remoteAuthority;for(let ve=0;ve<V;ve++)oe(await this.Q(R,ge,we,ie),!!ie),ge=!0}return{windows:(0,M.distinct)(Z),filesOpenedInWindow:x}}O(R,O,U){this.m.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:U}),O.focus();const B={filesToOpenOrCreate:U?.filesToOpenOrCreate,filesToDiff:U?.filesToDiff,filesToMerge:U?.filesToMerge,filesToWait:U?.filesToWait,termProgram:R?.userEnv?.TERM_PROGRAM};return O.sendWhenReady("vscode:openFiles",A.CancellationToken.None,B),O}P(R,O){this.m.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:O}),R.focus();const U={foldersToAdd:O};return R.sendWhenReady("vscode:addFolders",A.CancellationToken.None,U),R}Q(R,O,U,B,V){this.m.trace("windowsManager#doOpenEmpty",{restore:!!V,remoteAuthority:U,filesToOpen:B,forceNewWindow:O});let ie;return!O&&typeof R.contextWindowId=="number"&&(ie=this.getWindowById(R.contextWindowId)),this.gb({userEnv:R.userEnv,cli:R.cli,initialStartup:R.initialStartup,remoteAuthority:U,forceNewWindow:O,forceNewTabbedWindow:R.forceNewTabbedWindow,filesToOpen:B,windowToUse:ie,emptyWindowBackupInfo:V,forceProfile:R.forceProfile,forceTempProfile:R.forceTempProfile})}R(R,O,U,B,V){return this.m.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:O,filesToOpen:B}),!U&&!V&&typeof R.contextWindowId=="number"&&(V=this.getWindowById(R.contextWindowId)),this.gb({workspace:O.workspace,userEnv:R.userEnv,cli:R.cli,initialStartup:R.initialStartup,remoteAuthority:O.remoteAuthority,forceNewWindow:U,forceNewTabbedWindow:R.forceNewTabbedWindow,filesToOpen:B,windowToUse:V,forceProfile:R.forceProfile,forceTempProfile:R.forceTempProfile})}async S(R){let O,U=!1,B=!1;if(R.urisToOpen&&R.urisToOpen.length>0?(O=await this.U(R),U=!0):R.forceEmpty?O=[Object.create(null)]:R.cli._.length||R.cli["folder-uri"]||R.cli["file-uri"]?(O=await this.W(R.cli),O.length===0&&O.push(Object.create(null)),U=!0):(O=await this.Y(),O.length===0&&O.push(Object.create(null)),B=!0),!R.addMode&&U){const V=O.filter(ie=>re(ie));if(V.length>1){const ie=V[0].remoteAuthority;if(V.every($=>(0,u.isEqualAuthority)($.remoteAuthority,ie))){const $=await this.C.createUntitledWorkspace(V.map(Z=>({uri:Z.workspace.uri})));O.push({workspace:$,remoteAuthority:ie}),O=O.filter(Z=>!re(Z))}}}if(R.initialStartup&&!B&&this.w.getValue("window")?.restoreWindows==="preserve"){const V=await this.Y();O.unshift(...V.filter(ie=>H(ie)||re(ie)||ie.backupPath))}return O}async U(R){const O={gotoLineMode:R.gotoLineMode,remoteAuthority:R.remoteAuthority},U=await Promise.all((0,M.coalesce)(R.urisToOpen||[]).map(async B=>{const V=await this.ab(B,O);if(V)return V.label=B.label,V;const ie=this.cb(B),$={title:this.H.nameLong,type:"info",buttons:[(0,y.mnemonicButtonLabel)((0,f.localize)(0,null))],defaultId:0,message:ie.scheme===E.Schemas.file?(0,f.localize)(1,null):(0,f.localize)(2,null),detail:ie.scheme===E.Schemas.file?(0,f.localize)(3,null,(0,y.getPathLabel)(ie,{os:d.OS,tildify:this.s})):(0,f.localize)(4,null,ie.toString(!0)),noLink:!0};this.F.showMessageBox($,(0,v.withNullAsUndefined)(I.BrowserWindow.getFocusedWindow()))}));return(0,M.coalesce)(U)}async W(R){const O=[],U={ignoreFileNotFound:!0,gotoLineMode:R.goto,remoteAuthority:R.remote||void 0,forceOpenWorkspaceAsFile:R.diff&&R._.length===2||R.merge&&R._.length===4},B=R["folder-uri"];if(B){const $=await Promise.all(B.map(Z=>{const x=this.X(Z);if(!!x)return this.ab({folderUri:x},U)}));O.push(...(0,M.coalesce)($))}const V=R["file-uri"];if(V){const $=await Promise.all(V.map(Z=>{const x=this.X(Z);if(!!x)return this.ab((0,ne.hasWorkspaceFileExtension)(Z)?{workspaceUri:x}:{fileUri:x},U)}));O.push(...(0,M.coalesce)($))}const ie=await Promise.all(R._.map($=>U.remoteAuthority?this.eb($,U):this.db($,U)));return O.push(...(0,M.coalesce)(ie)),O}X(R){try{const O=g.URI.parse(R);if(!O.scheme){this.m.error(`Invalid URI input string, scheme missing: ${R}`);return}return O}catch(O){this.m.error(`Invalid URI input string: ${R}, ${O.message}`)}}async Y(){const R=this.Z();switch(R){case"none":return[];case"one":case"all":case"preserve":case"folders":{const O=[];R!=="one"&&O.push(...this.j.state.openedWindows),this.j.state.lastActiveWindow&&O.push(this.j.state.lastActiveWindow);const U=await Promise.all(O.map(async B=>{if(B.workspace){const V=await this.ab({workspaceUri:B.workspace.configPath},{remoteAuthority:B.remoteAuthority,rejectTransientWorkspaces:!0});if(H(V))return V}else if(B.folderUri){const V=await this.ab({folderUri:B.folderUri},{remoteAuthority:B.remoteAuthority});if(re(V))return V}else if(R!=="folders"&&B.backupPath)return{backupPath:B.backupPath,remoteAuthority:B.remoteAuthority}}));return(0,M.coalesce)(U)}}}Z(){let R;return this.u.wasRestarted?R="all":(R=this.w.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(R)||(R="all")),R}async ab(R,O=Object.create(null)){const U=this.cb(R);return U.scheme===E.Schemas.file?((0,ae.isFileToOpen)(R)&&(O={...O,forceOpenWorkspaceAsFile:!0}),this.db(U.fsPath,O)):this.bb(R,O)}bb(R,O){let U=this.cb(R);const B=(0,j.getRemoteAuthority)(U)||O.remoteAuthority;if(U=(0,u.removeTrailingPathSeparator)((0,u.normalizePath)(U)),(0,ae.isFileToOpen)(R)){if(O.gotoLineMode){const{path:V,line:ie,column:$}=(0,p.parseLineAndColumnAware)(U.path);return{fileUri:U.with({path:V}),options:{selection:ie?{startLineNumber:ie,startColumn:$||1}:void 0},remoteAuthority:B}}return{fileUri:U,remoteAuthority:B}}else if((0,ae.isWorkspaceToOpen)(R))return{workspace:(0,he.getWorkspaceIdentifier)(U),remoteAuthority:B};return{workspace:(0,he.getSingleFolderWorkspaceIdentifier)(U),remoteAuthority:B}}cb(R){return(0,ae.isWorkspaceToOpen)(R)?R.workspaceUri:(0,ae.isFolderToOpen)(R)?R.folderUri:R.fileUri}async db(R,O){let U,B;O.gotoLineMode&&({path:R,line:U,column:B}=(0,p.parseLineAndColumnAware)(R)),R=(0,p.sanitizeFilePath)((0,h.normalize)(R),(0,b.cwd)());try{const V=await t.Promises.stat(R);if(V.isFile()){if(!O.forceOpenWorkspaceAsFile){const ie=await this.C.resolveLocalWorkspace(g.URI.file(R));if(ie)return ie.transient&&O.rejectTransientWorkspaces?void 0:{workspace:{id:ie.id,configPath:ie.configPath},type:a.FileType.File,exists:!0,remoteAuthority:ie.remoteAuthority,transient:ie.transient}}return{fileUri:g.URI.file(R),type:a.FileType.File,exists:!0,options:{selection:U?{startLineNumber:U,startColumn:B||1}:void 0}}}else{if(V.isDirectory())return{workspace:(0,he.getSingleFolderWorkspaceIdentifier)(g.URI.file(R),V),type:a.FileType.Directory,exists:!0};if(!d.isWindows&&R==="/dev/null")return{fileUri:g.URI.file(R),type:a.FileType.File,exists:!0}}}catch{const ie=g.URI.file(R);if(this.z.removeRecentlyOpened([ie]),O.ignoreFileNotFound)return{fileUri:ie,type:a.FileType.File,exists:!1}}}eb(R,O){const U=R.charCodeAt(0),B=O.remoteAuthority;let V,ie;O.gotoLineMode&&({path:R,line:V,column:ie}=(0,p.parseLineAndColumnAware)(R)),U!==47&&((0,p.isWindowsDriveLetter)(U)&&R.charCodeAt(R.charCodeAt(1))===58&&(R=(0,p.toSlashes)(R)),R=`/${R}`);const $=g.URI.from({scheme:E.Schemas.vscodeRemote,authority:B,path:R});if(R.charCodeAt(R.length-1)!==47){if((0,ne.hasWorkspaceFileExtension)(R))return O.forceOpenWorkspaceAsFile?{fileUri:$,options:{selection:V?{startLineNumber:V,startColumn:ie||1}:void 0},remoteAuthority:O.remoteAuthority}:{workspace:(0,he.getWorkspaceIdentifier)($),remoteAuthority:B};if(O.gotoLineMode||h.posix.basename(R).indexOf(".")!==-1)return{fileUri:$,options:{selection:V?{startLineNumber:V,startColumn:ie||1}:void 0},remoteAuthority:B}}return{workspace:(0,he.getSingleFolderWorkspaceIdentifier)($),remoteAuthority:B}}fb(R){const O=this.w.getValue("window"),U=O?.openFoldersInNewWindow||"default",B=O?.openFilesInNewWindow||"off";let V=(R.preferNewWindow||R.forceNewWindow)&&!R.forceReuseWindow;!R.forceNewWindow&&!R.forceReuseWindow&&(U==="on"||U==="off")&&(V=U==="on");let ie=!1;return R.forceNewWindow||R.forceReuseWindow?ie=!!R.forceNewWindow&&!R.forceReuseWindow:(d.isMacintosh?R.context===1&&(ie=!0):R.context!==3&&R.context!==2&&!(R.userEnv&&R.userEnv.TERM_PROGRAM==="vscode")&&(ie=!0),!R.cli.extensionDevelopmentPath&&(B==="on"||B==="off")&&(ie=B==="on")),{openFolderInNewWindow:!!V,openFilesInNewWindow:ie}}async openExtensionDevelopmentHostWindow(R,O){const U=(0,J.findWindowOnExtensionDevelopmentPath)(this.getWindows(),R);if(U)return this.u.reload(U,O.cli),U.focus(),[U];let B=O.cli["folder-uri"]||[],V=O.cli["file-uri"]||[],ie=O.cli._;if(!ie.length&&!B.length&&!V.length&&!O.cli.extensionTestsPath){const x=this.j.state.lastPluginDevelopmentHostWindow,oe=x?.workspace??x?.folderUri;oe&&(g.URI.isUri(oe)?oe.scheme===E.Schemas.file?ie=[oe.fsPath]:B=[oe.toString()]:oe.configPath.scheme===E.Schemas.file?ie=[(0,u.originalFSPath)(oe.configPath)]:V=[oe.configPath.toString()])}let $=O.remoteAuthority;for(const x of R)if(x.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const oe=g.URI.parse(x),ge=(0,j.getRemoteAuthority)(oe);ge&&($?(0,u.isEqualAuthority)(ge,$)||this.m.error("more than one extension development path authority"):$=ge)}ie=ie.filter(x=>{const oe=g.URI.file(x);return(0,J.findWindowOnWorkspaceOrFolder)(this.getWindows(),oe)?!1:(0,u.isEqualAuthority)((0,j.getRemoteAuthority)(oe),$)}),B=B.filter(x=>{const oe=this.X(x);return oe&&!!(0,J.findWindowOnWorkspaceOrFolder)(this.getWindows(),oe)?!1:oe?(0,u.isEqualAuthority)((0,j.getRemoteAuthority)(oe),$):!1}),V=V.filter(x=>{const oe=this.X(x);return oe&&!!(0,J.findWindowOnWorkspaceOrFolder)(this.getWindows(),oe)?!1:oe?(0,u.isEqualAuthority)((0,j.getRemoteAuthority)(oe),$):!1}),O.cli._=ie,O.cli["folder-uri"]=B,O.cli["file-uri"]=V;const Z={context:O.context,cli:O.cli,forceNewWindow:!0,forceEmpty:!ie.length&&!B.length&&!V.length,userEnv:O.userEnv,noRecentEntry:!0,waitMarkerFileURI:O.waitMarkerFileURI,remoteAuthority:$,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile};return this.open(Z)}async gb(R){const O=this.w.getValue("window");let U;!R.forceNewWindow&&!R.forceNewTabbedWindow&&(U=R.windowToUse||this.getLastActiveWindow(),U&&U.focus());const B={...this.s.args,...R.cli,machineId:this.k,windowId:-1,mainPid:process.pid,appRoot:this.s.appRoot,execPath:process.execPath,codeCachePath:this.s.codeCachePath,backupPath:R.emptyWindowBackupInfo?(0,h.join)(this.s.backupHome,R.emptyWindowBackupInfo.backupFolder):void 0,profiles:{all:this.t.profiles,profile:U?.isExtensionDevelopmentHost&&U?.profile?U.profile:await this.ib(R)},homeDir:this.s.userHome.fsPath,tmpDir:this.s.tmpDir.fsPath,userDataDir:this.s.userDataPath,remoteAuthority:R.remoteAuthority,workspace:R.workspace,userEnv:{...this.l,...R.userEnv},filesToOpenOrCreate:R.filesToOpen?.filesToOpenOrCreate,filesToDiff:R.filesToOpen?.filesToDiff,filesToMerge:R.filesToOpen?.filesToMerge,filesToWait:R.filesToOpen?.filesToWait,logLevel:this.m.getLevel(),logsPath:this.s.logsPath,product:S.default,isInitialStartup:R.initialStartup,perfMarks:(0,w.getMarks)(),os:{release:(0,C.release)(),hostname:(0,C.hostname)()},zoomLevel:typeof O?.zoomLevel=="number"?O.zoomLevel:void 0,autoDetectHighContrast:O?.autoDetectHighContrast??!0,autoDetectColorScheme:O?.autoDetectColorScheme??!1,accessibilitySupport:I.app.accessibilitySupportEnabled,colorScheme:this.J.getColorScheme(),policiesData:this.r.serialize(),continueOn:this.s.continueOn};if(U){const V=U.config;!B.extensionDevelopmentPath&&V?.extensionDevelopmentPath&&(B.extensionDevelopmentPath=V.extensionDevelopmentPath,B.extensionDevelopmentKind=V.extensionDevelopmentKind,B["enable-proposed-api"]=V["enable-proposed-api"],B.verbose=V.verbose,B["inspect-extensions"]=V["inspect-extensions"],B["inspect-brk-extensions"]=V["inspect-brk-extensions"],B.debugId=V.debugId,B.extensionEnvironment=V.extensionEnvironment,B["extensions-dir"]=V["extensions-dir"],B["disable-extensions"]=V["disable-extensions"])}else{const V=this.j.getNewWindowState(B);(0,w.mark)("code/willCreateCodeWindow");const ie=U=this.D.createInstance(Y.CodeWindow,{state:V,extensionDevelopmentPath:B.extensionDevelopmentPath,isExtensionTestHost:!!B.extensionTestsPath});(0,w.mark)("code/didCreateCodeWindow"),R.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(ie),gt.a.push(ie),this.b.fire(ie),this.g.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,m.once)(ie.onDidSignalReady)(()=>this.c.fire(ie)),(0,m.once)(ie.onDidClose)(()=>this.jb(ie)),(0,m.once)(ie.onDidDestroy)(()=>this.f.fire(ie)),ie.onDidTriggerSystemContextMenu(({x:Z,y:x})=>this.h.fire({window:ie,x:Z,y:x}));const $=(0,v.assertIsDefined)(ie.win?.webContents);$.removeAllListeners("devtools-reload-page"),$.on("devtools-reload-page",()=>this.u.reload(ie)),this.u.registerWindow(ie)}return B.windowId=U.id,U.isReady?this.u.unload(U,4).then(V=>{V||this.hb(U,B,R)}):this.hb(U,B,R),U}hb(R,O,U){O.extensionDevelopmentPath||((0,ne.isWorkspaceIdentifier)(O.workspace)?O.backupPath=this.v.registerWorkspaceBackup({workspace:O.workspace,remoteAuthority:O.remoteAuthority}):(0,ne.isSingleFolderWorkspaceIdentifier)(O.workspace)?O.backupPath=this.v.registerFolderBackup({folderUri:O.workspace.uri,remoteAuthority:O.remoteAuthority}):O.backupPath=this.v.registerEmptyWindowBackup({backupFolder:U.emptyWindowBackupInfo?.backupFolder??(0,he.createEmptyWorkspaceIdentifier)().id,remoteAuthority:O.remoteAuthority})),R.load(O)}async ib(R){let O;return this.t.isEnabled()&&(R.forceProfile?O=this.t.profiles.find(U=>U.name===R.forceProfile)??await this.t.createNamedProfile(R.forceProfile):R.forceTempProfile&&(O=await this.t.createTransientProfile())),O?R.cli?.extensionDevelopmentPath||this.t.setProfileForWorkspaceSync(R.workspace??"empty-window",O):O=this.t.getOrSetProfileForWorkspace(R.workspace??"empty-window",(R.windowToUse??this.getLastActiveWindow())?.profile??this.t.defaultProfile),O}jb(R){const O=gt.a.indexOf(R);gt.a.splice(O,1),this.g.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const R=I.BrowserWindow.getFocusedWindow();if(R)return this.getWindowById(R.id)}getLastActiveWindow(){return this.lb(this.getWindows())}kb(R){return this.lb(this.getWindows().filter(O=>(0,u.isEqualAuthority)(O.remoteAuthority,R)))}lb(R){const O=Math.max.apply(Math,R.map(U=>U.lastFocusTime));return R.find(U=>U.lastFocusTime===O)}sendToFocused(R,...O){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(R,A.CancellationToken.None,...O)}sendToAll(R,O,U){for(const B of this.getWindows())U&&U.indexOf(B.id)>=0||B.sendWhenReady(R,A.CancellationToken.None,O)}getWindows(){return gt.a}getWindowCount(){return gt.a.length}getWindowById(R){const O=this.getWindows().filter(U=>U.id===R);return(0,M.firstOrDefault)(O)}getWindowByWebContents(R){const O=I.BrowserWindow.fromWebContents(R);if(!!O)return this.getWindowById(O.id)}};z.a=[],z=pe([_(2,o.ILogService),_(3,X.IStateMainService),_(4,F.IPolicyService),_(5,i.IEnvironmentMainService),_(6,N.IUserDataProfilesMainService),_(7,l.ILifecycleMainService),_(8,c.IBackupMainService),_(9,n.IConfigurationService),_(10,K.IWorkspacesHistoryMainService),_(11,le.IWorkspacesManagementMainService),_(12,s.IInstantiationService),_(13,r.IDialogMainService),_(14,a.IFileService),_(15,D.IProductService),_(16,L.IProtocolMainService),_(17,W.IThemeMainService)],z),e.WindowsMainService=z}),define(ee[272],te([0,1,62,31,75,52]),function(q,e,I,t,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let A=class{constructor(p,m,y,P){this.a=p,this.b=m,this.c=y,this.d=P,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(p,m){const y=this.b.getWindowById(p);if(y)return this.a.enterWorkspace(y,this.b.getWindows(),m)}createUntitledWorkspace(p,m,y){return this.a.createUntitledWorkspace(m,y)}deleteUntitledWorkspace(p,m){return this.a.deleteUntitledWorkspace(m)}getWorkspaceIdentifier(p,m){return this.a.getWorkspaceIdentifier(m)}getRecentlyOpened(p){return this.c.getRecentlyOpened()}addRecentlyOpened(p,m){return this.c.addRecentlyOpened(m)}removeRecentlyOpened(p,m){return this.c.removeRecentlyOpened(m)}clearRecentlyOpened(p){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};A=pe([_(0,M.IWorkspacesManagementMainService),_(1,t.IWindowsMainService),_(2,C.IWorkspacesHistoryMainService),_(3,I.IBackupMainService)],A),e.WorkspacesMainService=A}),define(ee[273],te([0,1,13,41,25,17,45,14,30,50,43,33,2,15,9,4,12,7,29,81,130,47,144,103,249,147,62,264,18,71,179,84,118,57,106,202,27,61,111,192,214,193,251,107,194,195,16,206,86,70,5,85,265,227,252,21,6,208,270,58,19,54,258,88,35,255,93,89,36,232,112,56,49,240,241,266,242,267,114,244,245,246,247,253,31,271,254,28,94,75,272,52,250,37,213,51,223,55,91,116,256,262,260,8]),function(q,e,I,t,C,M,A,k,p,m,y,P,E,h,w,d,b,u,v,g,f,c,n,r,i,a,s,l,o,S,D,L,j,X,ae,Y,J,se,ne,he,K,le,W,F,N,H,re,z,T,R,O,U,B,V,ie,$,Z,x,oe,ge,De,Oe,Ce,Re,be,we,ve,Me,Q,fe,de,ye,Ie,Te,Fe,qe,Ue,$e,Je,je,Ke,G,ce,ue,me,Se,Le,Be,it,Ze,Ve,et,nt,ct,mt,Pt,$t,zt,Ut,qt,Ht,Vt,Gt,kt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Ct=class extends E.Disposable{constructor(Ee,ke,Ae,Pe,We,ze,_e,tt,Ne,Ge,Xe){super(),this.c=Ee,this.f=ke,this.g=Ae,this.h=Pe,this.i=We,this.j=ze,this.k=_e,this.l=tt,this.m=Ne,this.n=Ge,this.p=Xe,this.r(),this.s()}r(){const Ee=Ne=>Ne?.startsWith(`${h.Schemas.vscodeWebview}://`),ke=new Set(["clipboard-read","clipboard-sanitized-write"]);I.session.defaultSession.setPermissionRequestHandler((Ne,Ge,Xe,xe)=>Ee(xe.requestingUrl)?Xe(ke.has(Ge)):Xe(!1)),I.session.defaultSession.setPermissionCheckHandler((Ne,Ge,Xe,xe)=>Ee(xe.requestingUrl)?ke.has(Ge):!1);const Ae=new Set([h.Schemas.file,h.Schemas.vscodeFileResource,h.Schemas.vscodeRemoteResource,"devtools"]),Pe=Ne=>{for(let Ge=Ne;Ge;Ge=Ge.parent)if(Ge.url.startsWith(`${h.Schemas.vscodeWebview}://`))return!0;return!1},We=Ne=>Ne.resourceType==="xhr"||Pe(Ne.frame),ze=Ne=>{const Ge=Ne.frame;if(!Ge||!this.a)return!1;const Xe=I.BrowserWindow.getAllWindows();for(const xe of Xe)if(Ge.processId===xe.webContents.mainFrame.processId)return!0;return!1},_e=(Ne,Ge)=>{if(Ne.path!=="/index.html")return!0;const Xe=Ge.frame;if(!Xe||!this.a)return!1;for(const xe of this.a.getWindows())if(xe.win&&Xe.processId===xe.win.webContents.mainFrame.processId)return!0;return!1};I.session.defaultSession.webRequest.onBeforeRequest((Ne,Ge)=>{const Xe=u.URI.parse(Ne.url);return Xe.scheme===h.Schemas.vscodeWebview&&!_e(Xe,Ne)?(this.h.error("Blocked vscode-webview request",Ne.url),Ge({cancel:!0})):Xe.scheme===h.Schemas.vscodeFileResource&&!ze(Ne)?(this.h.error("Blocked vscode-file request",Ne.url),Ge({cancel:!0})):Xe.path.endsWith(".svg")&&!Ae.has(Xe.scheme)?Ge({cancel:!We(Ne)}):Ge({cancel:!1})}),I.session.defaultSession.webRequest.onHeadersReceived((Ne,Ge)=>{const Xe=Ne.responseHeaders,xe=Xe["content-type"]||Xe["Content-Type"];if(xe&&Array.isArray(xe)){const st=u.URI.parse(Ne.url);if(st.path.endsWith(".svg")&&Ae.has(st.scheme))return Xe["Content-Type"]=["image/svg+xml"],Ge({cancel:!1,responseHeaders:Xe});if(!st.path.endsWith(h.Schemas.vscodeRemoteResource)&&xe.some(at=>at.toLowerCase().includes("image/svg")))return Ge({cancel:!We(Ne)})}return Ge({cancel:!1})});const tt=I.session.defaultSession;typeof tt.setCodeCachePath=="function"&&this.i.codeCachePath&&tt.setCodeCachePath((0,w.join)(this.i.codeCachePath,"chrome"))}s(){(0,k.setUnexpectedErrorHandler)(Ae=>this.u(Ae)),process.on("uncaughtException",Ae=>(0,k.onUnexpectedError)(Ae)),process.on("unhandledRejection",Ae=>(0,k.onUnexpectedError)(Ae)),this.j.onWillShutdown(()=>this.dispose()),(0,f.registerContextMenuListener)(),I.app.on("accessibility-support-changed",(Ae,Pe)=>{this.a?.sendToAll("vscode:accessibilitySupportChanged",Pe)}),I.app.on("activate",async(Ae,Pe)=>{this.h.trace("app#activate"),Pe||await this.a?.openEmptyWindow({context:1})}),I.app.on("web-contents-created",(Ae,Pe)=>{Pe.on("will-navigate",We=>{this.h.error("webContents#will-navigate: Prevented webcontent navigation"),We.preventDefault()}),Pe.setWindowOpenHandler(({url:We})=>(this.b?.openExternal(void 0,We),{action:"deny"}))});let Ee=[],ke;I.app.on("open-file",(Ae,Pe)=>{this.h.trace("app#open-file: ",Pe),Ae.preventDefault(),Ee.push((0,Be.hasWorkspaceFileExtension)(Pe)?{workspaceUri:u.URI.file(Pe)}:{fileUri:u.URI.file(Pe)}),ke!==void 0&&(clearTimeout(ke),ke=void 0),ke=setTimeout(async()=>{await this.a?.open({context:1,cli:this.i.args,urisToOpen:Ee,gotoLineMode:!1,preferNewWindow:!0}),Ee=[],ke=void 0},100)}),I.app.on("new-window-for-tab",async()=>{await this.a?.openEmptyWindow({context:4})}),t.validatedIpcMain.handle("vscode:fetchShellEnv",Ae=>{const Pe=this.a?.getWindowByWebContents(Ae.sender);let We,ze;return Pe?.config?(We=Pe.config,ze={...process.env,...Pe.config.userEnv}):(We=this.i.args,ze=process.env),this.L(We,ze,!1)}),t.validatedIpcMain.handle("vscode:writeNlsFile",(Ae,Pe,We)=>{const ze=this.t([Pe]);if(!ze||typeof We!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.m.writeFile(ze,M.VSBuffer.fromString(We))}),t.validatedIpcMain.handle("vscode:readNlsFile",async(Ae,...Pe)=>{const We=this.t(Pe);if(!We)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.m.readFile(We)).value.toString()}),t.validatedIpcMain.on("vscode:toggleDevTools",Ae=>Ae.sender.toggleDevTools()),t.validatedIpcMain.on("vscode:openDevTools",Ae=>Ae.sender.openDevTools()),t.validatedIpcMain.on("vscode:reloadWindow",Ae=>Ae.sender.reload())}t(Ee){let ke;for(const Ae of Ee)typeof Ae=="string"&&(typeof ke!="string"?ke=Ae:ke=(0,w.join)(ke,Ae));if(!(typeof ke!="string"||!(0,w.isAbsolute)(ke)||!(0,p.isEqualOrParent)(ke,this.i.cachedLanguagesPath,!d.isLinux)))return u.URI.file(ke)}u(Ee){if(Ee){const ke={message:`[uncaught exception in main]: ${Ee.message}`,stack:Ee.stack};this.a?.sendToFocused("vscode:reportError",JSON.stringify(ke))}this.h.error(`[uncaught exception in main]: ${Ee}`),Ee.stack&&this.h.error(Ee.stack)}async startup(){this.h.debug("Starting VS Code"),this.h.debug(`from: ${this.i.appRoot}`),this.h.debug("args:",this.i.args);const Ee=this.n.win32AppUserModelId;d.isWindows&&Ee&&I.app.setAppUserModelId(Ee);try{d.isMacintosh&&this.k.getValue("window.nativeTabs")===!0&&!I.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&I.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ne){this.h.error(Ne)}const ke=new n.Server;this.j.onWillShutdown(Ne=>{Ne.reason===2&&ke.dispose()}),this.h.trace("Resolving machine identifier...");const Ae=await this.w();this.h.trace(`Resolved machine identifier: ${Ae}`);const{sharedProcess:Pe,sharedProcessReady:We,sharedProcessClient:ze}=this.y(Ae),_e=await this.z(Ae,Pe,We);this.v(_e),_e.invokeFunction(Ne=>this.C(Ne,ke,ze)),await _e.invokeFunction(Ne=>this.D(Ne,ke)),_e.invokeFunction(Ne=>this.H(Ne,Pe)),this.B(new kt.RunOnceScheduler(()=>{this.B((0,kt.runWhenIdle)(()=>this.j.phase=4,2500))},2500)).schedule()}v(Ee){this.B(Ee.createInstance(i.ProxyAuthHandler)),this.B(Ee.createInstance(Vt.UserDataTransientProfilesHandler))}async w(){let Ee=this.l.getItem(Q.machineIdKey);return(!Ee||d.isMacintosh&&Ee==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(Ee=await(0,g.getMachineId)(),this.l.setItem(Q.machineIdKey,Ee)),Ee}y(Ee){const ke=this.B(this.g.createInstance(Ce.SharedProcess,Ee,this.f)),Ae=(async()=>{this.h.trace("Main->SharedProcess#connect");const We=await ke.connect();return this.h.trace("Main->SharedProcess#connect: connection established"),new r.Client(We,"main")})(),Pe=(async()=>(await ke.whenReady(),Ae))();return{sharedProcess:ke,sharedProcessReady:Pe,sharedProcessClient:Ae}}async z(Ee,ke,Ae){const Pe=new U.ServiceCollection;switch(process.platform){case"win32":Pe.set(Ie.IUpdateService,new R.SyncDescriptor($e.Win32UpdateService));break;case"linux":d.isLinuxSnap?Pe.set(Ie.IUpdateService,new R.SyncDescriptor(Ue.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Pe.set(Ie.IUpdateService,new R.SyncDescriptor(qe.LinuxUpdateService));break;case"darwin":Pe.set(Ie.IUpdateService,new R.SyncDescriptor(Fe.DarwinUpdateService));break}Pe.set(me.IWindowsMainService,new R.SyncDescriptor(Se.WindowsMainService,[Ee,this.f],!1));const We=new X.DialogMainService(this.h);Pe.set(X.IDialogMainService,We),Pe.set(ie.ILaunchMainService,new R.SyncDescriptor(ie.LaunchMainService,void 0,!1)),Pe.set(j.IDiagnosticsMainService,new R.SyncDescriptor(j.DiagnosticsMainService,void 0,!1)),Pe.set(L.IDiagnosticsService,c.ProxyChannel.toService((0,c.getDelayedChannel)(Ae.then(tt=>tt.getChannel("diagnostics"))))),Pe.set(B.IIssueMainService,new R.SyncDescriptor(B.IssueMainService,[this.f])),Pe.set(ae.IEncryptionMainService,new R.SyncDescriptor(Y.EncryptionMainService,[Ee])),Pe.set(V.IKeyboardLayoutMainService,new R.SyncDescriptor(V.KeyboardLayoutMainService)),Pe.set(ge.INativeHostMainService,new R.SyncDescriptor(ge.NativeHostMainService,[ke],!1)),Pe.set(S.ICredentialsMainService,new R.SyncDescriptor(nt.CredentialsNativeMainService)),Pe.set(ce.IWebviewManagerService,new R.SyncDescriptor(ue.WebviewMainService)),Pe.set(oe.IMenubarMainService,new R.SyncDescriptor(oe.MenubarMainService)),Pe.set(he.IExtensionUrlTrustService,new R.SyncDescriptor(K.ExtensionUrlTrustService)),Pe.set(le.IExtensionHostStarter,new R.SyncDescriptor(W.ExtensionHostStarter)),Pe.set(ve.IStorageMainService,new R.SyncDescriptor(ve.StorageMainService)),Pe.set(ve.IApplicationStorageMainService,new R.SyncDescriptor(ve.ApplicationStorageMainService)),d.isWindows?Pe.set(F.IExternalTerminalMainService,new R.SyncDescriptor(N.WindowsExternalTerminalService)):d.isMacintosh?Pe.set(F.IExternalTerminalMainService,new R.SyncDescriptor(N.MacExternalTerminalService)):d.isLinux&&Pe.set(F.IExternalTerminalMainService,new R.SyncDescriptor(N.LinuxExternalTerminalService));const ze=new l.BackupMainService(this.i,this.k,this.h,this.l);Pe.set(s.IBackupMainService,ze);const _e=new et.WorkspacesManagementMainService(this.i,this.h,this.p,ze,We,this.n);if(Pe.set(et.IWorkspacesManagementMainService,_e),Pe.set(it.IWorkspacesService,new R.SyncDescriptor(Ve.WorkspacesMainService,void 0,!1)),Pe.set(Ze.IWorkspacesHistoryMainService,new R.SyncDescriptor(Ze.WorkspacesHistoryMainService,void 0,!1)),Pe.set(Je.IURLService,new R.SyncDescriptor(Ke.NativeURLService,void 0,!1)),(0,ye.supportsTelemetry)(this.n,this.i)){const tt=(0,ye.isInternalTelemetry)(this.n,this.k),Ne=(0,c.getDelayedChannel)(Ae.then(at=>at.getChannel("telemetryAppender"))),Ge=new fe.TelemetryAppenderClient(Ne),Xe=(0,Me.resolveCommonProperties)(this.m,(0,C.release)(),(0,C.hostname)(),process.arch,this.n.commit,this.n.version,Ee,tt,this.i.installSourcePath),xe=(0,ye.getPiiPathsFromEnvironment)(this.i),st={appenders:[Ge],commonProperties:Xe,piiPaths:xe,sendErrorTelemetry:!0};Pe.set(Q.ITelemetryService,new R.SyncDescriptor(de.TelemetryService,[st],!1))}else Pe.set(Q.ITelemetryService,ye.NullTelemetryService);return Pe.set(Ut.IExtensionsProfileScannerService,new R.SyncDescriptor(Ut.ExtensionsProfileScannerService,void 0,!0)),Pe.set(qt.IExtensionsScannerService,new R.SyncDescriptor(Ht.ExtensionsScannerService,void 0,!0)),await kt.Promises.settled([ze.initialize(),_e.initialize()]),this.g.createChild(Pe)}C(Ee,ke,Ae){const Pe=c.ProxyChannel.fromService(Ee.get(ie.ILaunchMainService),{disableMarshalling:!0});this.c.registerChannel("launch",Pe);const We=c.ProxyChannel.fromService(Ee.get(j.IDiagnosticsMainService),{disableMarshalling:!0});this.c.registerChannel("diagnostics",We);const ze=new mt.PolicyChannel(Ee.get(ct.IPolicyService));ke.registerChannel("policy",ze),Ae.then(Ye=>Ye.registerChannel("policy",ze));const _e=this.m.getProvider(h.Schemas.file);(0,b.assertType)(_e instanceof T.DiskFileSystemProvider);const tt=new z.DiskFileSystemProviderChannel(_e,this.h,this.i);ke.registerChannel(H.LOCAL_FILE_SYSTEM_CHANNEL_NAME,tt),Ae.then(Ye=>Ye.registerChannel(H.LOCAL_FILE_SYSTEM_CHANNEL_NAME,tt));const Ne=c.ProxyChannel.fromService(Ee.get(Pt.IUserDataProfilesMainService));ke.registerChannel("userDataProfiles",Ne),Ae.then(Ye=>Ye.registerChannel("userDataProfiles",Ne));const Ge=new $t.RequestChannel(Ee.get(zt.IRequestService));Ae.then(Ye=>Ye.registerChannel("request",Ge));const Xe=new Te.UpdateChannel(Ee.get(Ie.IUpdateService));ke.registerChannel("update",Xe);const xe=c.ProxyChannel.fromService(Ee.get(B.IIssueMainService));ke.registerChannel("issue",xe);const st=c.ProxyChannel.fromService(Ee.get(ae.IEncryptionMainService));ke.registerChannel("encryption",st);const at=c.ProxyChannel.fromService(Ee.get(S.ICredentialsMainService));ke.registerChannel("credentials",at);const Dt=c.ProxyChannel.fromService(Ee.get(Re.ISignService));ke.registerChannel("sign",Dt);const Qe=c.ProxyChannel.fromService(Ee.get(V.IKeyboardLayoutMainService));ke.registerChannel("keyboardLayout",Qe),this.b=Ee.get(ge.INativeHostMainService);const wt=c.ProxyChannel.fromService(this.b);ke.registerChannel("nativeHost",wt),Ae.then(Ye=>Ye.registerChannel("nativeHost",wt));const pt=c.ProxyChannel.fromService(Ee.get(it.IWorkspacesService));ke.registerChannel("workspaces",pt);const yt=c.ProxyChannel.fromService(Ee.get(oe.IMenubarMainService));ke.registerChannel("menubar",yt);const Mt=c.ProxyChannel.fromService(Ee.get(Je.IURLService));ke.registerChannel("url",Mt);const At=c.ProxyChannel.fromService(Ee.get(he.IExtensionUrlTrustService));ke.registerChannel("extensionUrlTrust",At);const bt=c.ProxyChannel.fromService(Ee.get(ce.IWebviewManagerService));ke.registerChannel("webview",bt);const lt=this.B(new we.StorageDatabaseChannel(this.h,Ee.get(ve.IStorageMainService)));ke.registerChannel("storage",lt),Ae.then(Ye=>Ye.registerChannel("storage",lt));const St=this.B(new Gt.ProfileStorageChangesListenerChannel(Ee.get(ve.IStorageMainService),Ee.get(Pt.IUserDataProfilesMainService),this.h));Ae.then(Ye=>Ye.registerChannel("profileStorageListener",St));const vt=c.ProxyChannel.fromService(Ee.get(F.IExternalTerminalMainService));ke.registerChannel("externalTerminal",vt);const ut=new x.LogLevelChannel(Ee.get(Z.ILogService),Ee.get(Z.ILoggerService));ke.registerChannel("logLevel",ut),Ae.then(Ye=>Ye.registerChannel("logLevel",ut));const He=new x.LoggerChannel(Ee.get(Z.ILoggerService));ke.registerChannel("logger",He),Ae.then(Ye=>Ye.registerChannel("logger",He));const ot=new D.ElectronExtensionHostDebugBroadcastChannel(Ee.get(me.IWindowsMainService));ke.registerChannel("extensionhostdebugservice",ot);const ht=c.ProxyChannel.fromService(Ee.get(le.IExtensionHostStarter));ke.registerChannel(le.ipcExtensionHostStarterChannelName,ht)}async D(Ee,ke){const Ae=this.a=Ee.get(me.IWindowsMainService),Pe=Ee.get(Je.IURLService),We=Ee.get(ge.INativeHostMainService);this.j.phase=2;const ze=[],_e=[...this.i.args["open-url"]?this.i.args._urls||[]:[],...global.getOpenUrls()||[]].map(He=>{try{return{uri:u.URI.parse(He),url:He}}catch{return}}).filter(He=>{if(!He||this.F(He.uri))return!1;const ot=this.G(He.uri);return ot?(ze.push(ot),!1):!0}),tt=this,Ne=this.i,Ge=this.n,Xe=this.h;Pe.registerHandler({async handleURL(He,ot){if(Xe.trace("app#handleURL: ",He.toString(!0),ot),He.scheme===Ge.urlProtocol&&He.path==="workspace"&&(He=He.with({authority:"file",path:u.URI.parse(He.query).path,query:""})),tt.F(He))return!0;let ht=!1;const Ye=new URLSearchParams(He.query);Ye.get("windowId")==="_blank"&&(Ye.delete("windowId"),He=He.with({query:Ye.toString()}),ht=!0),ht||=d.isMacintosh&&Ae.getWindowCount()===0;const Nt=Ye.get("continueOn");Nt!==null&&(Ne.continueOn=Nt??void 0,Ye.delete("continueOn"),He=He.with({query:Ye.toString()}));const Rt=tt.G(He);if(Xe.trace("app#handleURL: windowOpenableFromProtocolLink = ",Rt),Rt){const[Lt]=await Ae.open({context:5,cli:{...Ne.args},urisToOpen:[Rt],forceNewWindow:ht,gotoLineMode:!0});return Lt.focus(),!0}if(ht){const[Lt]=await Ae.open({context:5,cli:{...Ne.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,Oe.getRemoteAuthority)(He)});return await Lt.ready(),Pe.open(He,ot)}return!1}});const xe=this.B(new Le.ActiveWindowManager({onDidOpenWindow:We.onDidOpenWindow,onDidFocusWindow:We.onDidFocusWindow,getActiveWindowId:()=>We.getActiveWindowId(-1)})),st=new c.StaticRouter(He=>xe.getActiveClientId().then(ot=>He===ot)),at=new je.URLHandlerRouter(st),Dt=ke.getChannel("urlHandler",at);Pe.registerHandler(new je.URLHandlerChannelClient(Dt)),this.B(new G.ElectronURLListener(_e,Pe,Ae,this.i,this.n));const Qe=this.i.args,wt=global.macOpenFiles,pt=(0,se.isLaunchedFromCli)(process.env)?0:4,yt=Qe._.length,Mt=!!Qe["folder-uri"],At=!!Qe["file-uri"],bt=Qe["skip-add-to-recently-opened"]===!0,lt=Qe.wait&&Qe.waitMarkerFilePath?u.URI.file(Qe.waitMarkerFilePath):void 0,St=Qe.remote||void 0,vt=Qe.profile,ut=Qe["profile-temp"];if(ze.length>0)return Ae.open({context:pt,cli:Qe,urisToOpen:ze,gotoLineMode:!0,initialStartup:!0});if(!yt&&!Mt&&!At){if(Qe["new-window"]||vt||ut)return Ae.open({context:pt,cli:Qe,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:bt,waitMarkerFileURI:lt,initialStartup:!0,remoteAuthority:St,forceProfile:vt,forceTempProfile:ut});if(wt.length)return Ae.open({context:1,cli:Qe,urisToOpen:wt.map(He=>(0,Be.hasWorkspaceFileExtension)(He)?{workspaceUri:u.URI.file(He)}:{fileUri:u.URI.file(He)}),noRecentEntry:bt,waitMarkerFileURI:lt,initialStartup:!0})}return Ae.open({context:pt,cli:Qe,forceNewWindow:Qe["new-window"]||!yt&&Qe["unity-launch"],diffMode:Qe.diff,mergeMode:Qe.merge,noRecentEntry:bt,waitMarkerFileURI:lt,gotoLineMode:Qe.goto,initialStartup:!0,remoteAuthority:St,forceProfile:vt,forceTempProfile:ut})}F(Ee){return!!(Ee.authority===h.Schemas.file&&d.isWindows&&I.dialog.showMessageBoxSync({title:this.n.nameLong,type:"question",buttons:[(0,P.mnemonicButtonLabel)((0,a.localize)(0,null)),(0,P.mnemonicButtonLabel)((0,a.localize)(1,null))],defaultId:0,cancelId:1,message:(0,a.localize)(2,null,(0,P.getPathLabel)(Ee,{os:d.OS,tildify:this.i}),this.n.nameShort),detail:(0,a.localize)(3,null),noLink:!0})===1)}G(Ee){if(!!Ee.path){if(Ee.authority===h.Schemas.file){const ke=u.URI.file(Ee.fsPath);return(0,Be.hasWorkspaceFileExtension)(ke)?{workspaceUri:ke}:{fileUri:ke}}else if(Ee.authority===h.Schemas.vscodeRemote){const ke=Ee.path.indexOf(w.posix.sep,1);if(ke!==-1){const Ae=Ee.path.substring(1,ke),Pe=Ee.path.substring(ke),We=u.URI.from({scheme:h.Schemas.vscodeRemote,authority:Ae,path:Pe,query:Ee.query,fragment:Ee.fragment});return(0,Be.hasWorkspaceFileExtension)(Pe)?{workspaceUri:We}:/:[\d]+$/.test(Pe)?{fileUri:We}:{folderUri:We}}}}}H(Ee,ke){const Ae=Ee.get(Q.ITelemetryService),Pe=Ee.get(Ie.IUpdateService);this.j.phase=3,this.J(Ae,ke),this.I(),I.protocol.registerHttpProtocol(h.Schemas.vscodeRemoteResource,(We,ze)=>{ze({url:We.url.replace(/^vscode-remote-resource:/,"http:"),method:We.method})}),(Pe instanceof $e.Win32UpdateService||Pe instanceof qe.LinuxUpdateService||Pe instanceof Fe.DarwinUpdateService)&&Pe.initialize(),this.L(this.i.args,process.env,!0),this.M()}async I(){const Ee=this.n.win32MutexName;if(d.isWindows&&Ee)try{const ke=await new Promise((Pe,We)=>{q(["windows-mutex"],Pe,We)}),Ae=new ke.Mutex(Ee);(0,m.once)(this.j.onWillShutdown)(()=>Ae.release())}catch(ke){this.h.error(ke)}}J(Ee,ke){let Ae=!1;(0,m.once)(this.j.onWillShutdown)(()=>Ae=!0),this.B(ke.onDidError(({type:Pe,details:We})=>{let ze;switch(Pe){case 1:ze="SharedProcess: detected unresponsive window";break;case 2:ze=`SharedProcess: renderer process gone (detail: ${We?.reason??"<unknown>"}, code: ${We?.exitCode??"<unknown>"})`;break;case 3:ze=`SharedProcess: failed to load (detail: ${We?.reason??"<unknown>"}, code: ${We?.exitCode??"<unknown>"})`;break}(0,k.onUnexpectedError)(new Error(ze)),Ee.publicLog2("sharedprocesserror",{type:Pe,reason:We?.reason,code:We?.exitCode,visible:ke.isVisible(),shuttingdown:Ae})}))}async L(Ee,ke,Ae){try{return await(0,ne.getResolvedShellEnv)(this.h,Ee,ke)}catch(Pe){const We=(0,A.toErrorMessage)(Pe);Ae?this.a?.sendToFocused("vscode:showResolveShellEnvError",We):this.h.error(We)}return{}}async M(){try{const ke=(await this.m.readFile(this.i.argvResource)).value.toString(),Ae=JSON.parse((0,y.stripComments)(ke)),We=(0,ye.getTelemetryLevel)(this.k)>=1;if(Ae["enable-crash-reporter"]===void 0){const ze=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${We},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,v.generateUuid)()}"`,"}"],_e=ke.substring(0,ke.length-2).concat(`,
`,ze.join(`
`));await this.m.writeFile(this.i.argvResource,M.VSBuffer.fromString(_e))}else{const ze=ke.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${We},`);ze!==ke&&await this.m.writeFile(this.i.argvResource,M.VSBuffer.fromString(ze))}}catch(Ee){this.h.error(Ee)}}};Ct=pe([_(2,O.IInstantiationService),_(3,Z.ILogService),_(4,J.IEnvironmentMainService),_(5,$.ILifecycleMainService),_(6,o.IConfigurationService),_(7,be.IStateMainService),_(8,re.IFileService),_(9,De.IProductService),_(10,Pt.IUserDataProfilesMainService)],Ct),e.CodeApplication=Ct}),define(ee[274],te([0,1,37,8,282,2,6]),function(q,e,I,t,C,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let k=class extends I.AbstractPolicyService{constructor(m,y){super(),this.j=m,this.k=y,this.a=new t.Throttler,this.b=this.B(new M.MutableDisposable)}async i(m){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(m).length} policy definitions`),await this.a.queue(()=>new Promise((y,P)=>{try{this.b.value=(0,C.createWatcher)(this.k,m,E=>{this.m(E),y()})}catch(E){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",E),P(E)}}))}m(m){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(m)}`);for(const y in m){const P=m[y];P===void 0?this.g.delete(y):this.g.set(y,P)}this.h.fire(Object.keys(m))}};k=pe([_(0,A.ILogService)],k),e.NativePolicyService=k}),define(ee[275],te([0,1,225,8,17,14,2,12,18,34,111,6,224,283]),function(q,e,I,t,C,M,A,k,p,m,y,P,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let w=class extends A.Disposable{constructor(b,u,v){super(),this.h=u,this.i=v,this.j(b.getValue()),this.B(b.onDidChangeConfiguration(()=>this.j(b.getValue()),this))}j(b){this.a=b.http&&b.http.proxy,this.b=!!(b.http&&b.http.proxyStrictSSL),this.f=b.http&&b.http.proxyAuthorization}async request(b,u){this.i.trace("RequestService#request (node) - begin",b.url);const{a:v,b:g}=this;let f;try{f=await(0,y.getResolvedShellEnv)(this.i,this.h.args,process.env)}catch(r){this.g||(this.g=!0,this.i.error("RequestService#request (node) resolving shell environment failed",r))}const c={...process.env,...f},n=b.agent?b.agent:await(0,E.getProxyAgent)(b.url||"",c,{proxyUrl:v,strictSSL:g});b.agent=n,b.strictSSL=g,this.f&&(b.headers={...b.headers||{},"Proxy-Authorization":this.f});try{const r=await this.l(b,u);return this.i.trace("RequestService#request (node) - success",b.url),r}catch(r){throw this.i.trace("RequestService#request (node) - error",b.url,r),r}}async k(b){return((0,I.parse)(b.url).protocol==="https:"?await new Promise((g,f)=>{q(["https"],g,f)}):await new Promise((g,f)=>{q(["http"],g,f)})).request}l(b,u){return t.Promises.withAsyncBody(async(v,g)=>{const f=(0,I.parse)(b.url),c=b.getRawRequest?b.getRawRequest(b):await this.k(b),n={hostname:f.hostname,port:f.port?parseInt(f.port):f.protocol==="https:"?443:80,protocol:f.protocol,path:f.path,method:b.type||"GET",headers:b.headers,agent:b.agent,rejectUnauthorized:(0,k.isBoolean)(b.strictSSL)?b.strictSSL:!0};b.user&&b.password&&(n.auth=b.user+":"+b.password);const r=c(n,i=>{const a=(0,k.isNumber)(b.followRedirects)?b.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&a>0&&i.headers.location)this.l({...b,url:i.headers.location,followRedirects:a-1},u).then(v,g);else{let s=i;!b.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(s=i.pipe((0,h.createGunzip)())),v({res:i,stream:(0,C.streamToBufferReadableStream)(s)})}});r.on("error",g),b.timeout&&r.setTimeout(b.timeout),b.isChromiumNetwork&&r.removeHeader("Content-Length"),b.data&&typeof b.data=="string"&&r.write(b.data),r.end(),u.onCancellationRequested(()=>{r.abort(),g(new M.CancellationError)})})}async resolveProxy(b){}};w=pe([_(0,p.IConfigurationService),_(1,m.INativeEnvironmentService),_(2,P.ILogService)],w),e.RequestService=w}),define(ee[276],te([0,1,13,275]),function(q,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function C(A){return I.net.request}class M extends t.RequestService{request(k,p){return super.request({...k||{},getRawRequest:C,isChromiumNetwork:!0},p)}}e.RequestMainService=M}),define(ee[284],te([0,1,13,40,7,24,8,45,14,30,50,33,15,9,73,4,32,26,23,47,83,273,10,18,218,231,27,61,183,16,204,86,70,200,85,21,207,6,210,63,19,64,257,113,238,55,276,88,226,35,230,56,66,51,37,274,212,2,42,243,38,239]),function(q,e,I,t,C,M,A,k,p,m,y,P,E,h,w,d,b,u,v,g,f,c,n,r,i,a,s,l,o,S,D,L,j,X,ae,Y,J,se,ne,he,K,le,W,F,N,H,re,z,T,R,O,U,B,V,ie,$,Z,x,oe,ge,De){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Oe{main(){try{this.a()}catch(be){console.error(be.message),I.app.exit(1)}}async a(){(0,p.setUnexpectedErrorHandler)(Ie=>console.error(Ie));const[be,we,ve,Me,Q,fe,de,ye]=this.b();try{try{await this.d(ve,ye,Me,Q,de)}catch(Ie){throw this.f(ve,de.nameLong,Ie),Ie}await be.invokeFunction(async Ie=>{const Te=Ie.get(se.ILogService),Fe=Ie.get(Y.ILifecycleMainService),qe=Ie.get(S.IFileService),Ue=Ie.get(se.ILoggerService),$e=await this.e(Te,ve,Fe,be,de,!0);return v.Promises.writeFile(ve.mainLockfile,String(process.pid)).catch(Je=>{Te.warn(`Error writing main lockfile: ${Je.stack}`)}),fe.logger=Ue.createLogger(C.URI.file((0,h.join)(ve.logsPath,"main.log")),{name:"main"}),(0,y.once)(Fe.onWillShutdown)(Je=>{qe.dispose(),Me.dispose(),Je.join(v.Promises.unlink(ve.mainLockfile).catch(()=>{}))}),be.createInstance(c.CodeApplication,$e,we).startup()})}catch(Ie){be.invokeFunction(this.i,Ie)}}b(){const be=new ae.ServiceCollection,we=new x.DisposableStore;process.once("exit",()=>we.dispose());const ve={_serviceBrand:void 0,...he.default};be.set(K.IProductService,ve);const Me=new s.EnvironmentMainService(this.j(),ve),Q=this.c(Me);be.set(s.IEnvironmentMainService,Me);const fe=new J.BufferLogService,de=we.add(new se.MultiplexLogService([new se.ConsoleMainLogger((0,se.getLogLevel)(Me)),fe]));be.set(se.ILogService,de);const ye=new D.FileService(de);be.set(S.IFileService,ye);const Ie=new L.DiskFileSystemProvider(de);ye.registerProvider(E.Schemas.file,Ie);const Te=new ge.UriIdentityService(ye);be.set(oe.IUriIdentityService,Te),be.set(se.ILoggerService,new ne.LoggerService(de));const Fe=new O.StateMainService(Me,de,ye);be.set(R.IStateMainService,Fe);const qe=new V.UserDataProfilesMainService(Fe,Te,Me,ye,de);be.set(V.IUserDataProfilesMainService,qe);const Ue=d.isWindows&&ve.win32RegValueName?we.add(new $.NativePolicyService(de,ve.win32RegValueName)):Me.policyFile?we.add(new Z.FilePolicyService(Me.policyFile,ye,de)):new ie.NullPolicyService;be.set(ie.IPolicyService,Ue);const $e=new i.ConfigurationService(qe.defaultProfile.settingsResource,ye,Ue,de);return be.set(r.IConfigurationService,$e),be.set(Y.ILifecycleMainService,new j.SyncDescriptor(Y.LifecycleMainService,void 0,!1)),be.set(H.IRequestService,new j.SyncDescriptor(re.RequestMainService,void 0,!0)),be.set(B.IThemeMainService,new j.SyncDescriptor(B.ThemeMainService)),be.set(z.ISignService,new j.SyncDescriptor(T.SignService,void 0,!1)),be.set(F.ITunnelService,new j.SyncDescriptor(N.TunnelService)),be.set(le.IProtocolMainService,new W.ProtocolMainService(Me,qe,de)),[new X.InstantiationService(be,!0),Q,Me,$e,Fe,fe,ve,qe]}c(be){const we={VSCODE_IPC_HOOK:be.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ve=>{const Me=process.env[ve];typeof Me=="string"&&(we[ve]=Me)}),Object.assign(process.env,we),we}async d(be,we,ve,Me,Q){await A.Promises.settled([Promise.all([be.extensionsPath,be.codeCachePath,be.logsPath,we.defaultProfile.globalStorageHome.fsPath,be.workspaceStorageHome.fsPath,be.localHistoryHome.fsPath,be.backupHome].map(fe=>fe?v.Promises.mkdir(fe,{recursive:!0}):void 0)),Me.init(),ve.initialize()]),we.setEnablement(Q.quality!=="stable"||ve.getValue(De.PROFILES_ENABLEMENT_CONFIG))}async e(be,we,ve,Me,Q,fe){let de;try{(0,w.mark)("code/willStartMainServer"),de=await(0,f.serve)(we.mainIPCHandle),(0,w.mark)("code/didStartMainServer"),(0,y.once)(ve.onWillShutdown)(()=>de.dispose())}catch(ye){if(ye.code!=="EADDRINUSE")throw this.f(we,Q.nameLong,ye),ye;let Ie;try{Ie=await(0,f.connect)(we.mainIPCHandle,"main")}catch(Ue){if(!fe||d.isWindows||Ue.code!=="ECONNREFUSED")throw Ue.code==="EPERM"&&this.g((0,n.localize)(0,null,Q.nameShort),(0,n.localize)(1,null),Q.nameLong),Ue;try{(0,t.unlinkSync)(we.mainIPCHandle)}catch($e){throw be.warn("Could not delete obsolete instance handle",$e),$e}return this.e(be,we,ve,Me,Q,!1)}if(we.extensionTestsLocationURI&&!we.debugExtensionHost.break){const Ue=`Running extension tests from the command line is currently only supported if no other instance of ${Q.nameShort} is running.`;throw be.error(Ue),Ie.dispose(),new Error(Ue)}let Te;!we.args.wait&&!we.args.status&&(Te=setTimeout(()=>{this.g((0,n.localize)(2,null,Q.nameShort),(0,n.localize)(3,null),Q.nameLong)},1e4));const Fe=g.ProxyChannel.toService(Ie.getChannel("launch"),{disableMarshalling:!0}),qe=g.ProxyChannel.toService(Ie.getChannel("diagnostics"),{disableMarshalling:!0});if(we.args.status)return Me.invokeFunction(async()=>{const Ue=new a.DiagnosticsService(U.NullTelemetryService,Q),$e=await qe.getMainDiagnostics(),Je=await qe.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),je=await Ue.getDiagnostics($e,Je);throw console.log(je),new p.ExpectedError});throw d.isWindows&&await this.h(Fe,be),be.trace("Sending env to running instance..."),await Fe.start(we.args,process.env),Ie.dispose(),Te&&clearTimeout(Te),new p.ExpectedError("Sent env to running instance. Terminating...")}if(we.args.status)throw be.warn(`Warning: The --status argument can only be used if ${Q.nameShort} is already running. Please run it again after {0} has started.`),new p.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),de}f(be,we,ve){if(ve.code==="EACCES"||ve.code==="EPERM"){const Me=(0,M.coalesce)([be.userDataPath,be.extensionsPath,f.XDG_RUNTIME_DIR]).map(Q=>(0,P.getPathLabel)(C.URI.file(Q),{os:d.OS,tildify:be}));this.g((0,n.localize)(4,null),(0,n.localize)(5,null,(0,k.toErrorMessage)(ve),Me.join(`
`)),we)}}g(be,we,ve){I.dialog.showMessageBoxSync({title:ve,type:"warning",buttons:[(0,P.mnemonicButtonLabel)((0,n.localize)(6,null))],message:be,detail:we,defaultId:0,noLink:!0})}async h(be,we){if(d.isWindows){const ve=await be.getMainProcessId();we.trace("Sending some foreground love to the running instance:",ve);try{(await new Promise((Me,Q)=>{q(["windows-foreground-love"],Me,Q)})).allowSetForegroundWindow(ve)}catch(Me){we.error(Me)}}}i(be,we){const ve=be.get(se.ILogService),Me=be.get(Y.ILifecycleMainService);let Q=0;we&&(we.isExpected?we.message&&ve.trace(we.message):(Q=1,we.stack?ve.error(we.stack):ve.error(`Startup error: ${we.toString()}`))),Me.kill(Q)}j(){const be=this.k((0,l.parseMainProcessArgv)(process.argv));if(be.wait&&!be.waitMarkerFilePath){const we=(0,o.createWaitMarkerFileSync)(be.verbose);we&&((0,l.addArg)(process.argv,"--waitMarkerFilePath",we),be.waitMarkerFilePath=we)}return be}k(be){if(be["open-url"]&&(be._urls=be._,be._=[]),!be.remote){const we=this.l(be._,be.goto);be._=we}return be}l(be,we){const ve=(0,b.cwd)(),Me=be.map(de=>{let ye=String(de),Ie;we&&(Ie=(0,m.parseLineAndColumnAware)(ye),ye=Ie.path),ye&&(ye=this.m(ve,ye));const Te=(0,m.sanitizeFilePath)(ye,ve),Fe=(0,h.basename)(Te);return Fe&&!(0,m.isValidBasename)(Fe)?null:we&&Ie?(Ie.path=Te,this.n(Ie)):Te}),Q=d.isWindows||d.isMacintosh,fe=(0,M.distinct)(Me,de=>de&&Q?de.toLowerCase():de||"");return(0,M.coalesce)(fe)}m(be,we){return d.isWindows&&(we=(0,u.rtrim)(we,'"')),we=(0,u.trim)((0,u.trim)(we," "),"	"),d.isWindows&&(we=(0,h.resolve)(be,we),we=(0,u.rtrim)(we,".")),we}n(be){const we=[be.path];return typeof be.line=="number"&&we.push(String(be.line)),typeof be.column=="number"&&we.push(String(be.column)),we.join(":")}}new Oe().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/d0e44be43287acadb13f7c2808332e00fe52568d/core/vs/code/electron-main/main.js.map
